// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'exports.enums.swagger.dart' as enums;
export 'exports.enums.swagger.dart';

part 'exports.swagger.chopper.dart';
part 'exports.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class Exports extends ChopperService {
  static Exports create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$Exports(client);
    }

    final newClient = ChopperClient(
        services: [_$Exports()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$Exports(newClient);
  }

  ///
  Future<
          chopper.Response<
              WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponse>>
      apiV1InvoicebatchexportExportPost({
    String? cacheControl,
    required WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportRequest?
        body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponse,
        () => WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponse
            .fromJsonFactory);

    return _apiV1InvoicebatchexportExportPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/invoicebatchexport/export')
  Future<
          chopper.Response<
              WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponse>>
      _apiV1InvoicebatchexportExportPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportRequest?
            body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1InvoicebatchexportEmptyobjectGet({String? cacheControl}) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1InvoicebatchexportEmptyobjectGet(cacheControl: cacheControl);
  }

  ///
  @Get(path: '/api/v1/invoicebatchexport/emptyobject')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1InvoicebatchexportEmptyobjectGet(
          {@Header('Cache-Control') String? cacheControl});

  ///
  Future<
          chopper.Response<
              WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponse>>
      apiV1ReceiptbatchexportExportPost({
    String? cacheControl,
    required WebApiModulesExportsReceiptBatchExportReceiptBatchExportRequest?
        body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponse,
        () => WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponse
            .fromJsonFactory);

    return _apiV1ReceiptbatchexportExportPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/receiptbatchexport/export')
  Future<
          chopper.Response<
              WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponse>>
      _apiV1ReceiptbatchexportExportPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesExportsReceiptBatchExportReceiptBatchExportRequest?
            body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1ReceiptbatchexportEmptyobjectGet({String? cacheControl}) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1ReceiptbatchexportEmptyobjectGet(cacheControl: cacheControl);
  }

  ///
  @Get(path: '/api/v1/receiptbatchexport/emptyobject')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1ReceiptbatchexportEmptyobjectGet(
          {@Header('Cache-Control') String? cacheControl});

  ///
  Future<
          chopper.Response<
              WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponse>>
      apiV1VendorinvoicebatchexportExportPost({
    String? cacheControl,
    required WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportRequest?
        body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponse,
        () =>
            WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponse
                .fromJsonFactory);

    return _apiV1VendorinvoicebatchexportExportPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/vendorinvoicebatchexport/export')
  Future<
          chopper.Response<
              WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponse>>
      _apiV1VendorinvoicebatchexportExportPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportRequest?
            body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1VendorinvoicebatchexportEmptyobjectGet({String? cacheControl}) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1VendorinvoicebatchexportEmptyobjectGet(
        cacheControl: cacheControl);
  }

  ///
  @Get(path: '/api/v1/vendorinvoicebatchexport/emptyobject')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1VendorinvoicebatchexportEmptyobjectGet(
          {@Header('Cache-Control') String? cacheControl});
}

@JsonSerializable(explicitToJson: true)
class FwCoreApiSwashbuckleBadRequestResponse {
  FwCoreApiSwashbuckleBadRequestResponse();

  factory FwCoreApiSwashbuckleBadRequestResponse.fromJson(
          Map<String, dynamic> json) =>
      _$FwCoreApiSwashbuckleBadRequestResponseFromJson(json);

  static const fromJsonFactory =
      _$FwCoreApiSwashbuckleBadRequestResponseFromJson;
  static const toJsonFactory = _$FwCoreApiSwashbuckleBadRequestResponseToJson;
  Map<String, dynamic> toJson() =>
      _$FwCoreApiSwashbuckleBadRequestResponseToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode => runtimeType.hashCode;
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwApiException {
  FwStandardModelsFwApiException({
    this.statusCode,
    this.message,
    this.stackTrace,
  });

  factory FwStandardModelsFwApiException.fromJson(Map<String, dynamic> json) =>
      _$FwStandardModelsFwApiExceptionFromJson(json);

  @JsonKey(name: 'StatusCode', includeIfNull: false)
  final int? statusCode;
  @JsonKey(name: 'Message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'StackTrace', includeIfNull: false, defaultValue: '')
  final String? stackTrace;
  static const fromJsonFactory = _$FwStandardModelsFwApiExceptionFromJson;
  static const toJsonFactory = _$FwStandardModelsFwApiExceptionToJson;
  Map<String, dynamic> toJson() => _$FwStandardModelsFwApiExceptionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwApiException &&
            (identical(other.statusCode, statusCode) ||
                const DeepCollectionEquality()
                    .equals(other.statusCode, statusCode)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.stackTrace, stackTrace) ||
                const DeepCollectionEquality()
                    .equals(other.stackTrace, stackTrace)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(statusCode) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(stackTrace) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwApiExceptionExtension
    on FwStandardModelsFwApiException {
  FwStandardModelsFwApiException copyWith(
      {int? statusCode, String? message, String? stackTrace}) {
    return FwStandardModelsFwApiException(
        statusCode: statusCode ?? this.statusCode,
        message: message ?? this.message,
        stackTrace: stackTrace ?? this.stackTrace);
  }

  FwStandardModelsFwApiException copyWithWrapped(
      {Wrapped<int?>? statusCode,
      Wrapped<String?>? message,
      Wrapped<String?>? stackTrace}) {
    return FwStandardModelsFwApiException(
        statusCode: (statusCode != null ? statusCode.value : this.statusCode),
        message: (message != null ? message.value : this.message),
        stackTrace: (stackTrace != null ? stackTrace.value : this.stackTrace));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardSqlServerFwJsonDataTable {
  FwStandardSqlServerFwJsonDataTable({
    this.columnIndex,
    this.totals,
    this.columns,
    this.rows,
    this.pageNo,
    this.pageSize,
    this.totalPages,
    this.totalRows,
    this.dateFields,
    this.columnNameByIndex,
  });

  factory FwStandardSqlServerFwJsonDataTable.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardSqlServerFwJsonDataTableFromJson(json);

  @JsonKey(name: 'ColumnIndex', includeIfNull: false)
  final Map<String, dynamic>? columnIndex;
  @JsonKey(name: 'Totals', includeIfNull: false)
  final Map<String, dynamic>? totals;
  @JsonKey(
      name: 'Columns',
      includeIfNull: false,
      defaultValue: <FwStandardSqlServerFwJsonDataTableColumn>[])
  final List<FwStandardSqlServerFwJsonDataTableColumn>? columns;
  @JsonKey(name: 'Rows', includeIfNull: false, defaultValue: <List<Object>>[])
  final List<List<Object>>? rows;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalPages', includeIfNull: false)
  final int? totalPages;
  @JsonKey(name: 'TotalRows', includeIfNull: false)
  final int? totalRows;
  @JsonKey(name: 'DateFields', includeIfNull: false, defaultValue: <String>[])
  final List<String>? dateFields;
  @JsonKey(name: 'ColumnNameByIndex', includeIfNull: false)
  final Map<String, dynamic>? columnNameByIndex;
  static const fromJsonFactory = _$FwStandardSqlServerFwJsonDataTableFromJson;
  static const toJsonFactory = _$FwStandardSqlServerFwJsonDataTableToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardSqlServerFwJsonDataTableToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardSqlServerFwJsonDataTable &&
            (identical(other.columnIndex, columnIndex) ||
                const DeepCollectionEquality()
                    .equals(other.columnIndex, columnIndex)) &&
            (identical(other.totals, totals) ||
                const DeepCollectionEquality().equals(other.totals, totals)) &&
            (identical(other.columns, columns) ||
                const DeepCollectionEquality()
                    .equals(other.columns, columns)) &&
            (identical(other.rows, rows) ||
                const DeepCollectionEquality().equals(other.rows, rows)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalPages, totalPages) ||
                const DeepCollectionEquality()
                    .equals(other.totalPages, totalPages)) &&
            (identical(other.totalRows, totalRows) ||
                const DeepCollectionEquality()
                    .equals(other.totalRows, totalRows)) &&
            (identical(other.dateFields, dateFields) ||
                const DeepCollectionEquality()
                    .equals(other.dateFields, dateFields)) &&
            (identical(other.columnNameByIndex, columnNameByIndex) ||
                const DeepCollectionEquality()
                    .equals(other.columnNameByIndex, columnNameByIndex)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(columnIndex) ^
      const DeepCollectionEquality().hash(totals) ^
      const DeepCollectionEquality().hash(columns) ^
      const DeepCollectionEquality().hash(rows) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalPages) ^
      const DeepCollectionEquality().hash(totalRows) ^
      const DeepCollectionEquality().hash(dateFields) ^
      const DeepCollectionEquality().hash(columnNameByIndex) ^
      runtimeType.hashCode;
}

extension $FwStandardSqlServerFwJsonDataTableExtension
    on FwStandardSqlServerFwJsonDataTable {
  FwStandardSqlServerFwJsonDataTable copyWith(
      {Map<String, dynamic>? columnIndex,
      Map<String, dynamic>? totals,
      List<FwStandardSqlServerFwJsonDataTableColumn>? columns,
      List<List<Object>>? rows,
      int? pageNo,
      int? pageSize,
      int? totalPages,
      int? totalRows,
      List<String>? dateFields,
      Map<String, dynamic>? columnNameByIndex}) {
    return FwStandardSqlServerFwJsonDataTable(
        columnIndex: columnIndex ?? this.columnIndex,
        totals: totals ?? this.totals,
        columns: columns ?? this.columns,
        rows: rows ?? this.rows,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalPages: totalPages ?? this.totalPages,
        totalRows: totalRows ?? this.totalRows,
        dateFields: dateFields ?? this.dateFields,
        columnNameByIndex: columnNameByIndex ?? this.columnNameByIndex);
  }

  FwStandardSqlServerFwJsonDataTable copyWithWrapped(
      {Wrapped<Map<String, dynamic>?>? columnIndex,
      Wrapped<Map<String, dynamic>?>? totals,
      Wrapped<List<FwStandardSqlServerFwJsonDataTableColumn>?>? columns,
      Wrapped<List<List<Object>>?>? rows,
      Wrapped<int?>? pageNo,
      Wrapped<int?>? pageSize,
      Wrapped<int?>? totalPages,
      Wrapped<int?>? totalRows,
      Wrapped<List<String>?>? dateFields,
      Wrapped<Map<String, dynamic>?>? columnNameByIndex}) {
    return FwStandardSqlServerFwJsonDataTable(
        columnIndex:
            (columnIndex != null ? columnIndex.value : this.columnIndex),
        totals: (totals != null ? totals.value : this.totals),
        columns: (columns != null ? columns.value : this.columns),
        rows: (rows != null ? rows.value : this.rows),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalPages: (totalPages != null ? totalPages.value : this.totalPages),
        totalRows: (totalRows != null ? totalRows.value : this.totalRows),
        dateFields: (dateFields != null ? dateFields.value : this.dateFields),
        columnNameByIndex: (columnNameByIndex != null
            ? columnNameByIndex.value
            : this.columnNameByIndex));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardSqlServerFwJsonDataTableColumn {
  FwStandardSqlServerFwJsonDataTableColumn({
    this.name,
    this.dataField,
    this.dataType,
    this.isUniqueId,
    this.isVisible,
  });

  factory FwStandardSqlServerFwJsonDataTableColumn.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardSqlServerFwJsonDataTableColumnFromJson(json);

  @JsonKey(name: 'Name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'DataField', includeIfNull: false, defaultValue: '')
  final String? dataField;
  @JsonKey(
    name: 'DataType',
    includeIfNull: false,
    toJson: fwStandardSqlServerFwDataTypesToJson,
    fromJson: fwStandardSqlServerFwDataTypesFromJson,
  )
  final enums.FwStandardSqlServerFwDataTypes? dataType;
  @JsonKey(name: 'IsUniqueId', includeIfNull: false)
  final bool? isUniqueId;
  @JsonKey(name: 'IsVisible', includeIfNull: false)
  final bool? isVisible;
  static const fromJsonFactory =
      _$FwStandardSqlServerFwJsonDataTableColumnFromJson;
  static const toJsonFactory = _$FwStandardSqlServerFwJsonDataTableColumnToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardSqlServerFwJsonDataTableColumnToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardSqlServerFwJsonDataTableColumn &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.dataField, dataField) ||
                const DeepCollectionEquality()
                    .equals(other.dataField, dataField)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.isUniqueId, isUniqueId) ||
                const DeepCollectionEquality()
                    .equals(other.isUniqueId, isUniqueId)) &&
            (identical(other.isVisible, isVisible) ||
                const DeepCollectionEquality()
                    .equals(other.isVisible, isVisible)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(dataField) ^
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(isUniqueId) ^
      const DeepCollectionEquality().hash(isVisible) ^
      runtimeType.hashCode;
}

extension $FwStandardSqlServerFwJsonDataTableColumnExtension
    on FwStandardSqlServerFwJsonDataTableColumn {
  FwStandardSqlServerFwJsonDataTableColumn copyWith(
      {String? name,
      String? dataField,
      enums.FwStandardSqlServerFwDataTypes? dataType,
      bool? isUniqueId,
      bool? isVisible}) {
    return FwStandardSqlServerFwJsonDataTableColumn(
        name: name ?? this.name,
        dataField: dataField ?? this.dataField,
        dataType: dataType ?? this.dataType,
        isUniqueId: isUniqueId ?? this.isUniqueId,
        isVisible: isVisible ?? this.isVisible);
  }

  FwStandardSqlServerFwJsonDataTableColumn copyWithWrapped(
      {Wrapped<String?>? name,
      Wrapped<String?>? dataField,
      Wrapped<enums.FwStandardSqlServerFwDataTypes?>? dataType,
      Wrapped<bool?>? isUniqueId,
      Wrapped<bool?>? isVisible}) {
    return FwStandardSqlServerFwJsonDataTableColumn(
        name: (name != null ? name.value : this.name),
        dataField: (dataField != null ? dataField.value : this.dataField),
        dataType: (dataType != null ? dataType.value : this.dataType),
        isUniqueId: (isUniqueId != null ? isUniqueId.value : this.isUniqueId),
        isVisible: (isVisible != null ? isVisible.value : this.isVisible));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportRequest {
  WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportRequest({
    this.batchId,
    this.dataExportFormatId,
  });

  factory WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportRequestFromJson(
          json);

  @JsonKey(name: 'BatchId', includeIfNull: false, defaultValue: '')
  final String? batchId;
  @JsonKey(name: 'DataExportFormatId', includeIfNull: false, defaultValue: '')
  final String? dataExportFormatId;
  static const fromJsonFactory =
      _$WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportRequest &&
            (identical(other.batchId, batchId) ||
                const DeepCollectionEquality()
                    .equals(other.batchId, batchId)) &&
            (identical(other.dataExportFormatId, dataExportFormatId) ||
                const DeepCollectionEquality()
                    .equals(other.dataExportFormatId, dataExportFormatId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(batchId) ^
      const DeepCollectionEquality().hash(dataExportFormatId) ^
      runtimeType.hashCode;
}

extension $WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportRequestExtension
    on WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportRequest {
  WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportRequest copyWith(
      {String? batchId, String? dataExportFormatId}) {
    return WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportRequest(
        batchId: batchId ?? this.batchId,
        dataExportFormatId: dataExportFormatId ?? this.dataExportFormatId);
  }

  WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportRequest
      copyWithWrapped(
          {Wrapped<String?>? batchId, Wrapped<String?>? dataExportFormatId}) {
    return WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportRequest(
        batchId: (batchId != null ? batchId.value : this.batchId),
        dataExportFormatId: (dataExportFormatId != null
            ? dataExportFormatId.value
            : this.dataExportFormatId));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponse {
  WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponse({
    this.batchId,
    this.batchNumber,
    this.downloadUrl,
  });

  factory WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponseFromJson(
          json);

  @JsonKey(name: 'BatchId', includeIfNull: false, defaultValue: '')
  final String? batchId;
  @JsonKey(name: 'BatchNumber', includeIfNull: false, defaultValue: '')
  final String? batchNumber;
  @JsonKey(name: 'downloadUrl', includeIfNull: false, defaultValue: '')
  final String? downloadUrl;
  static const fromJsonFactory =
      _$WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponse &&
            (identical(other.batchId, batchId) ||
                const DeepCollectionEquality()
                    .equals(other.batchId, batchId)) &&
            (identical(other.batchNumber, batchNumber) ||
                const DeepCollectionEquality()
                    .equals(other.batchNumber, batchNumber)) &&
            (identical(other.downloadUrl, downloadUrl) ||
                const DeepCollectionEquality()
                    .equals(other.downloadUrl, downloadUrl)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(batchId) ^
      const DeepCollectionEquality().hash(batchNumber) ^
      const DeepCollectionEquality().hash(downloadUrl) ^
      runtimeType.hashCode;
}

extension $WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponseExtension
    on WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponse {
  WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponse copyWith(
      {String? batchId, String? batchNumber, String? downloadUrl}) {
    return WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponse(
        batchId: batchId ?? this.batchId,
        batchNumber: batchNumber ?? this.batchNumber,
        downloadUrl: downloadUrl ?? this.downloadUrl);
  }

  WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponse
      copyWithWrapped(
          {Wrapped<String?>? batchId,
          Wrapped<String?>? batchNumber,
          Wrapped<String?>? downloadUrl}) {
    return WebApiModulesExportsInvoiceBatchExportInvoiceBatchExportResponse(
        batchId: (batchId != null ? batchId.value : this.batchId),
        batchNumber:
            (batchNumber != null ? batchNumber.value : this.batchNumber),
        downloadUrl:
            (downloadUrl != null ? downloadUrl.value : this.downloadUrl));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesExportsReceiptBatchExportReceiptBatchExportRequest {
  WebApiModulesExportsReceiptBatchExportReceiptBatchExportRequest({
    this.batchId,
    this.dataExportFormatId,
  });

  factory WebApiModulesExportsReceiptBatchExportReceiptBatchExportRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesExportsReceiptBatchExportReceiptBatchExportRequestFromJson(
          json);

  @JsonKey(name: 'BatchId', includeIfNull: false, defaultValue: '')
  final String? batchId;
  @JsonKey(name: 'DataExportFormatId', includeIfNull: false, defaultValue: '')
  final String? dataExportFormatId;
  static const fromJsonFactory =
      _$WebApiModulesExportsReceiptBatchExportReceiptBatchExportRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesExportsReceiptBatchExportReceiptBatchExportRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesExportsReceiptBatchExportReceiptBatchExportRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesExportsReceiptBatchExportReceiptBatchExportRequest &&
            (identical(other.batchId, batchId) ||
                const DeepCollectionEquality()
                    .equals(other.batchId, batchId)) &&
            (identical(other.dataExportFormatId, dataExportFormatId) ||
                const DeepCollectionEquality()
                    .equals(other.dataExportFormatId, dataExportFormatId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(batchId) ^
      const DeepCollectionEquality().hash(dataExportFormatId) ^
      runtimeType.hashCode;
}

extension $WebApiModulesExportsReceiptBatchExportReceiptBatchExportRequestExtension
    on WebApiModulesExportsReceiptBatchExportReceiptBatchExportRequest {
  WebApiModulesExportsReceiptBatchExportReceiptBatchExportRequest copyWith(
      {String? batchId, String? dataExportFormatId}) {
    return WebApiModulesExportsReceiptBatchExportReceiptBatchExportRequest(
        batchId: batchId ?? this.batchId,
        dataExportFormatId: dataExportFormatId ?? this.dataExportFormatId);
  }

  WebApiModulesExportsReceiptBatchExportReceiptBatchExportRequest
      copyWithWrapped(
          {Wrapped<String?>? batchId, Wrapped<String?>? dataExportFormatId}) {
    return WebApiModulesExportsReceiptBatchExportReceiptBatchExportRequest(
        batchId: (batchId != null ? batchId.value : this.batchId),
        dataExportFormatId: (dataExportFormatId != null
            ? dataExportFormatId.value
            : this.dataExportFormatId));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponse {
  WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponse({
    this.batchId,
    this.batchNumber,
    this.downloadUrl,
  });

  factory WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponseFromJson(
          json);

  @JsonKey(name: 'BatchId', includeIfNull: false, defaultValue: '')
  final String? batchId;
  @JsonKey(name: 'BatchNumber', includeIfNull: false, defaultValue: '')
  final String? batchNumber;
  @JsonKey(name: 'downloadUrl', includeIfNull: false, defaultValue: '')
  final String? downloadUrl;
  static const fromJsonFactory =
      _$WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponse &&
            (identical(other.batchId, batchId) ||
                const DeepCollectionEquality()
                    .equals(other.batchId, batchId)) &&
            (identical(other.batchNumber, batchNumber) ||
                const DeepCollectionEquality()
                    .equals(other.batchNumber, batchNumber)) &&
            (identical(other.downloadUrl, downloadUrl) ||
                const DeepCollectionEquality()
                    .equals(other.downloadUrl, downloadUrl)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(batchId) ^
      const DeepCollectionEquality().hash(batchNumber) ^
      const DeepCollectionEquality().hash(downloadUrl) ^
      runtimeType.hashCode;
}

extension $WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponseExtension
    on WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponse {
  WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponse copyWith(
      {String? batchId, String? batchNumber, String? downloadUrl}) {
    return WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponse(
        batchId: batchId ?? this.batchId,
        batchNumber: batchNumber ?? this.batchNumber,
        downloadUrl: downloadUrl ?? this.downloadUrl);
  }

  WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponse
      copyWithWrapped(
          {Wrapped<String?>? batchId,
          Wrapped<String?>? batchNumber,
          Wrapped<String?>? downloadUrl}) {
    return WebApiModulesExportsReceiptBatchExportReceiptBatchExportResponse(
        batchId: (batchId != null ? batchId.value : this.batchId),
        batchNumber:
            (batchNumber != null ? batchNumber.value : this.batchNumber),
        downloadUrl:
            (downloadUrl != null ? downloadUrl.value : this.downloadUrl));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportRequest {
  WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportRequest({
    this.batchId,
    this.dataExportFormatId,
  });

  factory WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportRequestFromJson(
          json);

  @JsonKey(name: 'BatchId', includeIfNull: false, defaultValue: '')
  final String? batchId;
  @JsonKey(name: 'DataExportFormatId', includeIfNull: false, defaultValue: '')
  final String? dataExportFormatId;
  static const fromJsonFactory =
      _$WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportRequest &&
            (identical(other.batchId, batchId) ||
                const DeepCollectionEquality()
                    .equals(other.batchId, batchId)) &&
            (identical(other.dataExportFormatId, dataExportFormatId) ||
                const DeepCollectionEquality()
                    .equals(other.dataExportFormatId, dataExportFormatId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(batchId) ^
      const DeepCollectionEquality().hash(dataExportFormatId) ^
      runtimeType.hashCode;
}

extension $WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportRequestExtension
    on WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportRequest {
  WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportRequest
      copyWith({String? batchId, String? dataExportFormatId}) {
    return WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportRequest(
        batchId: batchId ?? this.batchId,
        dataExportFormatId: dataExportFormatId ?? this.dataExportFormatId);
  }

  WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportRequest
      copyWithWrapped(
          {Wrapped<String?>? batchId, Wrapped<String?>? dataExportFormatId}) {
    return WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportRequest(
        batchId: (batchId != null ? batchId.value : this.batchId),
        dataExportFormatId: (dataExportFormatId != null
            ? dataExportFormatId.value
            : this.dataExportFormatId));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponse {
  WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponse({
    this.batchId,
    this.batchNumber,
    this.downloadUrl,
  });

  factory WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponseFromJson(
          json);

  @JsonKey(name: 'BatchId', includeIfNull: false, defaultValue: '')
  final String? batchId;
  @JsonKey(name: 'BatchNumber', includeIfNull: false, defaultValue: '')
  final String? batchNumber;
  @JsonKey(name: 'downloadUrl', includeIfNull: false, defaultValue: '')
  final String? downloadUrl;
  static const fromJsonFactory =
      _$WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponse &&
            (identical(other.batchId, batchId) ||
                const DeepCollectionEquality()
                    .equals(other.batchId, batchId)) &&
            (identical(other.batchNumber, batchNumber) ||
                const DeepCollectionEquality()
                    .equals(other.batchNumber, batchNumber)) &&
            (identical(other.downloadUrl, downloadUrl) ||
                const DeepCollectionEquality()
                    .equals(other.downloadUrl, downloadUrl)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(batchId) ^
      const DeepCollectionEquality().hash(batchNumber) ^
      const DeepCollectionEquality().hash(downloadUrl) ^
      runtimeType.hashCode;
}

extension $WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponseExtension
    on WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponse {
  WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponse
      copyWith({String? batchId, String? batchNumber, String? downloadUrl}) {
    return WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponse(
        batchId: batchId ?? this.batchId,
        batchNumber: batchNumber ?? this.batchNumber,
        downloadUrl: downloadUrl ?? this.downloadUrl);
  }

  WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponse
      copyWithWrapped(
          {Wrapped<String?>? batchId,
          Wrapped<String?>? batchNumber,
          Wrapped<String?>? downloadUrl}) {
    return WebApiModulesExportsVendorInvoiceBatchExportVendorInvoiceBatchExportResponse(
        batchId: (batchId != null ? batchId.value : this.batchId),
        batchNumber:
            (batchNumber != null ? batchNumber.value : this.batchNumber),
        downloadUrl:
            (downloadUrl != null ? downloadUrl.value : this.downloadUrl));
  }
}

String? fwStandardSqlServerFwDataTypesToJson(
    enums.FwStandardSqlServerFwDataTypes? fwStandardSqlServerFwDataTypes) {
  return enums
      .$FwStandardSqlServerFwDataTypesMap[fwStandardSqlServerFwDataTypes];
}

enums.FwStandardSqlServerFwDataTypes fwStandardSqlServerFwDataTypesFromJson(
  Object? fwStandardSqlServerFwDataTypes, [
  enums.FwStandardSqlServerFwDataTypes? defaultValue,
]) {
  if (fwStandardSqlServerFwDataTypes is String) {
    return enums.$FwStandardSqlServerFwDataTypesMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                fwStandardSqlServerFwDataTypes.toLowerCase(),
            orElse: () => const MapEntry(
                enums.FwStandardSqlServerFwDataTypes.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$FwStandardSqlServerFwDataTypesMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.FwStandardSqlServerFwDataTypes.swaggerGeneratedUnknown;
}

List<String> fwStandardSqlServerFwDataTypesListToJson(
    List<enums.FwStandardSqlServerFwDataTypes>?
        fwStandardSqlServerFwDataTypes) {
  if (fwStandardSqlServerFwDataTypes == null) {
    return [];
  }

  return fwStandardSqlServerFwDataTypes
      .map((e) => enums.$FwStandardSqlServerFwDataTypesMap[e]!)
      .toList();
}

List<enums.FwStandardSqlServerFwDataTypes>
    fwStandardSqlServerFwDataTypesListFromJson(
  List? fwStandardSqlServerFwDataTypes, [
  List<enums.FwStandardSqlServerFwDataTypes>? defaultValue,
]) {
  if (fwStandardSqlServerFwDataTypes == null) {
    return defaultValue ?? [];
  }

  return fwStandardSqlServerFwDataTypes
      .map((e) => fwStandardSqlServerFwDataTypesFromJson(e.toString()))
      .toList();
}

List<enums.FwStandardSqlServerFwDataTypes>?
    fwStandardSqlServerFwDataTypesNullableListFromJson(
  List? fwStandardSqlServerFwDataTypes, [
  List<enums.FwStandardSqlServerFwDataTypes>? defaultValue,
]) {
  if (fwStandardSqlServerFwDataTypes == null) {
    return defaultValue;
  }

  return fwStandardSqlServerFwDataTypes
      .map((e) => fwStandardSqlServerFwDataTypesFromJson(e.toString()))
      .toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
