// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'free_product_remote_data_source.enums.swagger.dart' as enums;
export 'free_product_remote_data_source.enums.swagger.dart';

part 'free_product_remote_data_source.swagger.chopper.dart';
part 'free_product_remote_data_source.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class FreeProductRemoteDataSource extends ChopperService {
  static FreeProductRemoteDataSource create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$FreeProductRemoteDataSource(client);
    }

    final newClient = ChopperClient(
        services: [_$FreeProductRemoteDataSource()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$FreeProductRemoteDataSource(newClient);
  }

  ///
  Future<chopper.Response<ErrorJson>> errorDelete({String? cacheControl}) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorDelete(cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/error')
  Future<chopper.Response<ErrorJson>> _errorDelete(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<ErrorJson>> errorGet({String? cacheControl}) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorGet(cacheControl: cacheControl);
  }

  ///
  @Get(path: '/error')
  Future<chopper.Response<ErrorJson>> _errorGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<ErrorJson>> errorHead({String? cacheControl}) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorHead(cacheControl: cacheControl);
  }

  ///
  @Head(path: '/error')
  Future<chopper.Response<ErrorJson>> _errorHead(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<ErrorJson>> errorPatch({String? cacheControl}) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorPatch(cacheControl: cacheControl);
  }

  ///
  @Patch(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<ErrorJson>> _errorPatch(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<ErrorJson>> errorPost({String? cacheControl}) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorPost(cacheControl: cacheControl);
  }

  ///
  @Post(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<ErrorJson>> _errorPost(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<ErrorJson>> errorPut({String? cacheControl}) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorPut(cacheControl: cacheControl);
  }

  ///
  @Put(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<ErrorJson>> _errorPut(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FreeProductResponse>> v1FreeProductsGet(
      {String? cacheControl}) {
    generatedMapping.putIfAbsent(
        FreeProductResponse, () => FreeProductResponse.fromJsonFactory);

    return _v1FreeProductsGet(cacheControl: cacheControl);
  }

  ///
  @Get(path: '/v1/free-products')
  Future<chopper.Response<FreeProductResponse>> _v1FreeProductsGet(
      {@Header('Cache-Control') String? cacheControl});
}

@JsonSerializable(explicitToJson: true)
class ErrorJson {
  ErrorJson({
    this.error,
    this.message,
    this.status,
  });

  factory ErrorJson.fromJson(Map<String, dynamic> json) =>
      _$ErrorJsonFromJson(json);

  @JsonKey(name: 'error', includeIfNull: false, defaultValue: '')
  final String? error;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'status', includeIfNull: false)
  final int? status;
  static const fromJsonFactory = _$ErrorJsonFromJson;
  static const toJsonFactory = _$ErrorJsonToJson;
  Map<String, dynamic> toJson() => _$ErrorJsonToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ErrorJson &&
            (identical(other.error, error) ||
                const DeepCollectionEquality().equals(other.error, error)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(error) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(status) ^
      runtimeType.hashCode;
}

extension $ErrorJsonExtension on ErrorJson {
  ErrorJson copyWith({String? error, String? message, int? status}) {
    return ErrorJson(
        error: error ?? this.error,
        message: message ?? this.message,
        status: status ?? this.status);
  }

  ErrorJson copyWithWrapped(
      {Wrapped<String?>? error,
      Wrapped<String?>? message,
      Wrapped<int?>? status}) {
    return ErrorJson(
        error: (error != null ? error.value : this.error),
        message: (message != null ? message.value : this.message),
        status: (status != null ? status.value : this.status));
  }
}

@JsonSerializable(explicitToJson: true)
class FreeProduct {
  FreeProduct({
    required this.code,
    required this.products,
    required this.statuses,
  });

  factory FreeProduct.fromJson(Map<String, dynamic> json) =>
      _$FreeProductFromJson(json);

  @JsonKey(name: 'code', includeIfNull: false, defaultValue: '')
  final String code;
  @JsonKey(
      name: 'products', includeIfNull: false, defaultValue: <ProductCard>[])
  final List<ProductCard> products;
  @JsonKey(name: 'statuses', includeIfNull: false, defaultValue: <Status>[])
  final List<Status> statuses;
  static const fromJsonFactory = _$FreeProductFromJson;
  static const toJsonFactory = _$FreeProductToJson;
  Map<String, dynamic> toJson() => _$FreeProductToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FreeProduct &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.products, products) ||
                const DeepCollectionEquality()
                    .equals(other.products, products)) &&
            (identical(other.statuses, statuses) ||
                const DeepCollectionEquality()
                    .equals(other.statuses, statuses)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(code) ^
      const DeepCollectionEquality().hash(products) ^
      const DeepCollectionEquality().hash(statuses) ^
      runtimeType.hashCode;
}

extension $FreeProductExtension on FreeProduct {
  FreeProduct copyWith(
      {String? code, List<ProductCard>? products, List<Status>? statuses}) {
    return FreeProduct(
        code: code ?? this.code,
        products: products ?? this.products,
        statuses: statuses ?? this.statuses);
  }

  FreeProduct copyWithWrapped(
      {Wrapped<String>? code,
      Wrapped<List<ProductCard>>? products,
      Wrapped<List<Status>>? statuses}) {
    return FreeProduct(
        code: (code != null ? code.value : this.code),
        products: (products != null ? products.value : this.products),
        statuses: (statuses != null ? statuses.value : this.statuses));
  }
}

@JsonSerializable(explicitToJson: true)
class FreeProductResponse {
  FreeProductResponse({
    required this.freeProducts,
  });

  factory FreeProductResponse.fromJson(Map<String, dynamic> json) =>
      _$FreeProductResponseFromJson(json);

  @JsonKey(
      name: 'freeProducts', includeIfNull: false, defaultValue: <FreeProduct>[])
  final List<FreeProduct> freeProducts;
  static const fromJsonFactory = _$FreeProductResponseFromJson;
  static const toJsonFactory = _$FreeProductResponseToJson;
  Map<String, dynamic> toJson() => _$FreeProductResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FreeProductResponse &&
            (identical(other.freeProducts, freeProducts) ||
                const DeepCollectionEquality()
                    .equals(other.freeProducts, freeProducts)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(freeProducts) ^ runtimeType.hashCode;
}

extension $FreeProductResponseExtension on FreeProductResponse {
  FreeProductResponse copyWith({List<FreeProduct>? freeProducts}) {
    return FreeProductResponse(freeProducts: freeProducts ?? this.freeProducts);
  }

  FreeProductResponse copyWithWrapped(
      {Wrapped<List<FreeProduct>>? freeProducts}) {
    return FreeProductResponse(
        freeProducts:
            (freeProducts != null ? freeProducts.value : this.freeProducts));
  }
}

@JsonSerializable(explicitToJson: true)
class Image {
  Image({
    required this.height,
    required this.url,
    required this.width,
  });

  factory Image.fromJson(Map<String, dynamic> json) => _$ImageFromJson(json);

  @JsonKey(name: 'height', includeIfNull: false)
  final int height;
  @JsonKey(name: 'url', includeIfNull: false, defaultValue: '')
  final String url;
  @JsonKey(name: 'width', includeIfNull: false)
  final int width;
  static const fromJsonFactory = _$ImageFromJson;
  static const toJsonFactory = _$ImageToJson;
  Map<String, dynamic> toJson() => _$ImageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Image &&
            (identical(other.height, height) ||
                const DeepCollectionEquality().equals(other.height, height)) &&
            (identical(other.url, url) ||
                const DeepCollectionEquality().equals(other.url, url)) &&
            (identical(other.width, width) ||
                const DeepCollectionEquality().equals(other.width, width)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(height) ^
      const DeepCollectionEquality().hash(url) ^
      const DeepCollectionEquality().hash(width) ^
      runtimeType.hashCode;
}

extension $ImageExtension on Image {
  Image copyWith({int? height, String? url, int? width}) {
    return Image(
        height: height ?? this.height,
        url: url ?? this.url,
        width: width ?? this.width);
  }

  Image copyWithWrapped(
      {Wrapped<int>? height, Wrapped<String>? url, Wrapped<int>? width}) {
    return Image(
        height: (height != null ? height.value : this.height),
        url: (url != null ? url.value : this.url),
        width: (width != null ? width.value : this.width));
  }
}

@JsonSerializable(explicitToJson: true)
class ProductCard {
  ProductCard({
    this.availableOnline,
    this.bonusEndDate,
    this.bonusMechanism,
    this.bonusPeriodDescription,
    this.bonusSegmentDescription,
    this.bonusSegmentId,
    this.bonusStartDate,
    this.brand,
    this.currentPrice,
    this.descriptionFull,
    this.descriptionHighlights,
    this.discountType,
    this.extraDescriptions,
    required this.hqId,
    this.images,
    this.isBonus,
    this.isBonusPrice,
    required this.isInfiniteBonus,
    required this.isOrderable,
    this.isPreviouslyBought,
    required this.isSample,
    this.isStapelBonus,
    this.mainCategory,
    this.nix18,
    this.orderAvailabilityDescription,
    this.orderAvailabilityStatus,
    this.priceBeforeBonus,
    this.promotionType,
    this.properties,
    this.propertyIcons,
    this.salesUnitSize,
    this.segmentType,
    this.shopType,
    this.subCategory,
    this.subCategoryId,
    required this.title,
    this.unitPriceDescription,
    required this.webshopId,
  });

  factory ProductCard.fromJson(Map<String, dynamic> json) =>
      _$ProductCardFromJson(json);

  @JsonKey(name: 'availableOnline', includeIfNull: false)
  final bool? availableOnline;
  @JsonKey(name: 'bonusEndDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? bonusEndDate;
  @JsonKey(name: 'bonusMechanism', includeIfNull: false, defaultValue: '')
  final String? bonusMechanism;
  @JsonKey(
      name: 'bonusPeriodDescription', includeIfNull: false, defaultValue: '')
  final String? bonusPeriodDescription;
  @JsonKey(
      name: 'bonusSegmentDescription', includeIfNull: false, defaultValue: '')
  final String? bonusSegmentDescription;
  @JsonKey(name: 'bonusSegmentId', includeIfNull: false)
  final num? bonusSegmentId;
  @JsonKey(name: 'bonusStartDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? bonusStartDate;
  @JsonKey(name: 'brand', includeIfNull: false, defaultValue: '')
  final String? brand;
  @JsonKey(name: 'currentPrice', includeIfNull: false)
  final double? currentPrice;
  @JsonKey(name: 'descriptionFull', includeIfNull: false, defaultValue: '')
  final String? descriptionFull;
  @JsonKey(
      name: 'descriptionHighlights', includeIfNull: false, defaultValue: '')
  final String? descriptionHighlights;
  @JsonKey(name: 'discountType', includeIfNull: false, defaultValue: '')
  final String? discountType;
  @JsonKey(
      name: 'extraDescriptions', includeIfNull: false, defaultValue: <String>[])
  final List<String>? extraDescriptions;
  @JsonKey(name: 'hqId', includeIfNull: false)
  final num hqId;
  @JsonKey(name: 'images', includeIfNull: false, defaultValue: <Image>[])
  final List<Image>? images;
  @JsonKey(name: 'isBonus', includeIfNull: false)
  final bool? isBonus;
  @JsonKey(name: 'isBonusPrice', includeIfNull: false)
  final bool? isBonusPrice;
  @JsonKey(name: 'isInfiniteBonus', includeIfNull: false)
  final bool isInfiniteBonus;
  @JsonKey(name: 'isOrderable', includeIfNull: false)
  final bool isOrderable;
  @JsonKey(name: 'isPreviouslyBought', includeIfNull: false)
  final bool? isPreviouslyBought;
  @JsonKey(name: 'isSample', includeIfNull: false)
  final bool isSample;
  @JsonKey(name: 'isStapelBonus', includeIfNull: false)
  final bool? isStapelBonus;
  @JsonKey(name: 'mainCategory', includeIfNull: false, defaultValue: '')
  final String? mainCategory;
  @JsonKey(name: 'nix18', includeIfNull: false)
  final bool? nix18;
  @JsonKey(
      name: 'orderAvailabilityDescription',
      includeIfNull: false,
      defaultValue: '')
  final String? orderAvailabilityDescription;
  @JsonKey(
      name: 'orderAvailabilityStatus', includeIfNull: false, defaultValue: '')
  final String? orderAvailabilityStatus;
  @JsonKey(name: 'priceBeforeBonus', includeIfNull: false)
  final double? priceBeforeBonus;
  @JsonKey(name: 'promotionType', includeIfNull: false, defaultValue: '')
  final String? promotionType;
  @JsonKey(name: 'properties', includeIfNull: false)
  final Map<String, dynamic>? properties;
  @JsonKey(
      name: 'propertyIcons', includeIfNull: false, defaultValue: <String>[])
  final List<String>? propertyIcons;
  @JsonKey(name: 'salesUnitSize', includeIfNull: false, defaultValue: '')
  final String? salesUnitSize;
  @JsonKey(name: 'segmentType', includeIfNull: false, defaultValue: '')
  final String? segmentType;
  @JsonKey(name: 'shopType', includeIfNull: false, defaultValue: '')
  final String? shopType;
  @JsonKey(name: 'subCategory', includeIfNull: false, defaultValue: '')
  final String? subCategory;
  @JsonKey(name: 'subCategoryId', includeIfNull: false)
  final num? subCategoryId;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  @JsonKey(name: 'unitPriceDescription', includeIfNull: false, defaultValue: '')
  final String? unitPriceDescription;
  @JsonKey(name: 'webshopId', includeIfNull: false)
  final num webshopId;
  static const fromJsonFactory = _$ProductCardFromJson;
  static const toJsonFactory = _$ProductCardToJson;
  Map<String, dynamic> toJson() => _$ProductCardToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProductCard &&
            (identical(other.availableOnline, availableOnline) ||
                const DeepCollectionEquality()
                    .equals(other.availableOnline, availableOnline)) &&
            (identical(other.bonusEndDate, bonusEndDate) ||
                const DeepCollectionEquality()
                    .equals(other.bonusEndDate, bonusEndDate)) &&
            (identical(other.bonusMechanism, bonusMechanism) ||
                const DeepCollectionEquality()
                    .equals(other.bonusMechanism, bonusMechanism)) &&
            (identical(other.bonusPeriodDescription, bonusPeriodDescription) ||
                const DeepCollectionEquality().equals(
                    other.bonusPeriodDescription, bonusPeriodDescription)) &&
            (identical(other.bonusSegmentDescription, bonusSegmentDescription) ||
                const DeepCollectionEquality().equals(
                    other.bonusSegmentDescription, bonusSegmentDescription)) &&
            (identical(other.bonusSegmentId, bonusSegmentId) ||
                const DeepCollectionEquality()
                    .equals(other.bonusSegmentId, bonusSegmentId)) &&
            (identical(other.bonusStartDate, bonusStartDate) ||
                const DeepCollectionEquality()
                    .equals(other.bonusStartDate, bonusStartDate)) &&
            (identical(other.brand, brand) ||
                const DeepCollectionEquality().equals(other.brand, brand)) &&
            (identical(other.currentPrice, currentPrice) ||
                const DeepCollectionEquality()
                    .equals(other.currentPrice, currentPrice)) &&
            (identical(other.descriptionFull, descriptionFull) ||
                const DeepCollectionEquality()
                    .equals(other.descriptionFull, descriptionFull)) &&
            (identical(other.descriptionHighlights, descriptionHighlights) ||
                const DeepCollectionEquality().equals(
                    other.descriptionHighlights, descriptionHighlights)) &&
            (identical(other.discountType, discountType) ||
                const DeepCollectionEquality()
                    .equals(other.discountType, discountType)) &&
            (identical(other.extraDescriptions, extraDescriptions) ||
                const DeepCollectionEquality()
                    .equals(other.extraDescriptions, extraDescriptions)) &&
            (identical(other.hqId, hqId) ||
                const DeepCollectionEquality().equals(other.hqId, hqId)) &&
            (identical(other.images, images) ||
                const DeepCollectionEquality().equals(other.images, images)) &&
            (identical(other.isBonus, isBonus) ||
                const DeepCollectionEquality()
                    .equals(other.isBonus, isBonus)) &&
            (identical(other.isBonusPrice, isBonusPrice) ||
                const DeepCollectionEquality()
                    .equals(other.isBonusPrice, isBonusPrice)) &&
            (identical(other.isInfiniteBonus, isInfiniteBonus) ||
                const DeepCollectionEquality()
                    .equals(other.isInfiniteBonus, isInfiniteBonus)) &&
            (identical(other.isOrderable, isOrderable) || const DeepCollectionEquality().equals(other.isOrderable, isOrderable)) &&
            (identical(other.isPreviouslyBought, isPreviouslyBought) || const DeepCollectionEquality().equals(other.isPreviouslyBought, isPreviouslyBought)) &&
            (identical(other.isSample, isSample) || const DeepCollectionEquality().equals(other.isSample, isSample)) &&
            (identical(other.isStapelBonus, isStapelBonus) || const DeepCollectionEquality().equals(other.isStapelBonus, isStapelBonus)) &&
            (identical(other.mainCategory, mainCategory) || const DeepCollectionEquality().equals(other.mainCategory, mainCategory)) &&
            (identical(other.nix18, nix18) || const DeepCollectionEquality().equals(other.nix18, nix18)) &&
            (identical(other.orderAvailabilityDescription, orderAvailabilityDescription) || const DeepCollectionEquality().equals(other.orderAvailabilityDescription, orderAvailabilityDescription)) &&
            (identical(other.orderAvailabilityStatus, orderAvailabilityStatus) || const DeepCollectionEquality().equals(other.orderAvailabilityStatus, orderAvailabilityStatus)) &&
            (identical(other.priceBeforeBonus, priceBeforeBonus) || const DeepCollectionEquality().equals(other.priceBeforeBonus, priceBeforeBonus)) &&
            (identical(other.promotionType, promotionType) || const DeepCollectionEquality().equals(other.promotionType, promotionType)) &&
            (identical(other.properties, properties) || const DeepCollectionEquality().equals(other.properties, properties)) &&
            (identical(other.propertyIcons, propertyIcons) || const DeepCollectionEquality().equals(other.propertyIcons, propertyIcons)) &&
            (identical(other.salesUnitSize, salesUnitSize) || const DeepCollectionEquality().equals(other.salesUnitSize, salesUnitSize)) &&
            (identical(other.segmentType, segmentType) || const DeepCollectionEquality().equals(other.segmentType, segmentType)) &&
            (identical(other.shopType, shopType) || const DeepCollectionEquality().equals(other.shopType, shopType)) &&
            (identical(other.subCategory, subCategory) || const DeepCollectionEquality().equals(other.subCategory, subCategory)) &&
            (identical(other.subCategoryId, subCategoryId) || const DeepCollectionEquality().equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.title, title) || const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.unitPriceDescription, unitPriceDescription) || const DeepCollectionEquality().equals(other.unitPriceDescription, unitPriceDescription)) &&
            (identical(other.webshopId, webshopId) || const DeepCollectionEquality().equals(other.webshopId, webshopId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(availableOnline) ^
      const DeepCollectionEquality().hash(bonusEndDate) ^
      const DeepCollectionEquality().hash(bonusMechanism) ^
      const DeepCollectionEquality().hash(bonusPeriodDescription) ^
      const DeepCollectionEquality().hash(bonusSegmentDescription) ^
      const DeepCollectionEquality().hash(bonusSegmentId) ^
      const DeepCollectionEquality().hash(bonusStartDate) ^
      const DeepCollectionEquality().hash(brand) ^
      const DeepCollectionEquality().hash(currentPrice) ^
      const DeepCollectionEquality().hash(descriptionFull) ^
      const DeepCollectionEquality().hash(descriptionHighlights) ^
      const DeepCollectionEquality().hash(discountType) ^
      const DeepCollectionEquality().hash(extraDescriptions) ^
      const DeepCollectionEquality().hash(hqId) ^
      const DeepCollectionEquality().hash(images) ^
      const DeepCollectionEquality().hash(isBonus) ^
      const DeepCollectionEquality().hash(isBonusPrice) ^
      const DeepCollectionEquality().hash(isInfiniteBonus) ^
      const DeepCollectionEquality().hash(isOrderable) ^
      const DeepCollectionEquality().hash(isPreviouslyBought) ^
      const DeepCollectionEquality().hash(isSample) ^
      const DeepCollectionEquality().hash(isStapelBonus) ^
      const DeepCollectionEquality().hash(mainCategory) ^
      const DeepCollectionEquality().hash(nix18) ^
      const DeepCollectionEquality().hash(orderAvailabilityDescription) ^
      const DeepCollectionEquality().hash(orderAvailabilityStatus) ^
      const DeepCollectionEquality().hash(priceBeforeBonus) ^
      const DeepCollectionEquality().hash(promotionType) ^
      const DeepCollectionEquality().hash(properties) ^
      const DeepCollectionEquality().hash(propertyIcons) ^
      const DeepCollectionEquality().hash(salesUnitSize) ^
      const DeepCollectionEquality().hash(segmentType) ^
      const DeepCollectionEquality().hash(shopType) ^
      const DeepCollectionEquality().hash(subCategory) ^
      const DeepCollectionEquality().hash(subCategoryId) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(unitPriceDescription) ^
      const DeepCollectionEquality().hash(webshopId) ^
      runtimeType.hashCode;
}

extension $ProductCardExtension on ProductCard {
  ProductCard copyWith(
      {bool? availableOnline,
      DateTime? bonusEndDate,
      String? bonusMechanism,
      String? bonusPeriodDescription,
      String? bonusSegmentDescription,
      num? bonusSegmentId,
      DateTime? bonusStartDate,
      String? brand,
      double? currentPrice,
      String? descriptionFull,
      String? descriptionHighlights,
      String? discountType,
      List<String>? extraDescriptions,
      num? hqId,
      List<Image>? images,
      bool? isBonus,
      bool? isBonusPrice,
      bool? isInfiniteBonus,
      bool? isOrderable,
      bool? isPreviouslyBought,
      bool? isSample,
      bool? isStapelBonus,
      String? mainCategory,
      bool? nix18,
      String? orderAvailabilityDescription,
      String? orderAvailabilityStatus,
      double? priceBeforeBonus,
      String? promotionType,
      Map<String, dynamic>? properties,
      List<String>? propertyIcons,
      String? salesUnitSize,
      String? segmentType,
      String? shopType,
      String? subCategory,
      num? subCategoryId,
      String? title,
      String? unitPriceDescription,
      num? webshopId}) {
    return ProductCard(
        availableOnline: availableOnline ?? this.availableOnline,
        bonusEndDate: bonusEndDate ?? this.bonusEndDate,
        bonusMechanism: bonusMechanism ?? this.bonusMechanism,
        bonusPeriodDescription:
            bonusPeriodDescription ?? this.bonusPeriodDescription,
        bonusSegmentDescription:
            bonusSegmentDescription ?? this.bonusSegmentDescription,
        bonusSegmentId: bonusSegmentId ?? this.bonusSegmentId,
        bonusStartDate: bonusStartDate ?? this.bonusStartDate,
        brand: brand ?? this.brand,
        currentPrice: currentPrice ?? this.currentPrice,
        descriptionFull: descriptionFull ?? this.descriptionFull,
        descriptionHighlights:
            descriptionHighlights ?? this.descriptionHighlights,
        discountType: discountType ?? this.discountType,
        extraDescriptions: extraDescriptions ?? this.extraDescriptions,
        hqId: hqId ?? this.hqId,
        images: images ?? this.images,
        isBonus: isBonus ?? this.isBonus,
        isBonusPrice: isBonusPrice ?? this.isBonusPrice,
        isInfiniteBonus: isInfiniteBonus ?? this.isInfiniteBonus,
        isOrderable: isOrderable ?? this.isOrderable,
        isPreviouslyBought: isPreviouslyBought ?? this.isPreviouslyBought,
        isSample: isSample ?? this.isSample,
        isStapelBonus: isStapelBonus ?? this.isStapelBonus,
        mainCategory: mainCategory ?? this.mainCategory,
        nix18: nix18 ?? this.nix18,
        orderAvailabilityDescription:
            orderAvailabilityDescription ?? this.orderAvailabilityDescription,
        orderAvailabilityStatus:
            orderAvailabilityStatus ?? this.orderAvailabilityStatus,
        priceBeforeBonus: priceBeforeBonus ?? this.priceBeforeBonus,
        promotionType: promotionType ?? this.promotionType,
        properties: properties ?? this.properties,
        propertyIcons: propertyIcons ?? this.propertyIcons,
        salesUnitSize: salesUnitSize ?? this.salesUnitSize,
        segmentType: segmentType ?? this.segmentType,
        shopType: shopType ?? this.shopType,
        subCategory: subCategory ?? this.subCategory,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        title: title ?? this.title,
        unitPriceDescription: unitPriceDescription ?? this.unitPriceDescription,
        webshopId: webshopId ?? this.webshopId);
  }

  ProductCard copyWithWrapped(
      {Wrapped<bool?>? availableOnline,
      Wrapped<DateTime?>? bonusEndDate,
      Wrapped<String?>? bonusMechanism,
      Wrapped<String?>? bonusPeriodDescription,
      Wrapped<String?>? bonusSegmentDescription,
      Wrapped<num?>? bonusSegmentId,
      Wrapped<DateTime?>? bonusStartDate,
      Wrapped<String?>? brand,
      Wrapped<double?>? currentPrice,
      Wrapped<String?>? descriptionFull,
      Wrapped<String?>? descriptionHighlights,
      Wrapped<String?>? discountType,
      Wrapped<List<String>?>? extraDescriptions,
      Wrapped<num>? hqId,
      Wrapped<List<Image>?>? images,
      Wrapped<bool?>? isBonus,
      Wrapped<bool?>? isBonusPrice,
      Wrapped<bool>? isInfiniteBonus,
      Wrapped<bool>? isOrderable,
      Wrapped<bool?>? isPreviouslyBought,
      Wrapped<bool>? isSample,
      Wrapped<bool?>? isStapelBonus,
      Wrapped<String?>? mainCategory,
      Wrapped<bool?>? nix18,
      Wrapped<String?>? orderAvailabilityDescription,
      Wrapped<String?>? orderAvailabilityStatus,
      Wrapped<double?>? priceBeforeBonus,
      Wrapped<String?>? promotionType,
      Wrapped<Map<String, dynamic>?>? properties,
      Wrapped<List<String>?>? propertyIcons,
      Wrapped<String?>? salesUnitSize,
      Wrapped<String?>? segmentType,
      Wrapped<String?>? shopType,
      Wrapped<String?>? subCategory,
      Wrapped<num?>? subCategoryId,
      Wrapped<String>? title,
      Wrapped<String?>? unitPriceDescription,
      Wrapped<num>? webshopId}) {
    return ProductCard(
        availableOnline: (availableOnline != null
            ? availableOnline.value
            : this.availableOnline),
        bonusEndDate:
            (bonusEndDate != null ? bonusEndDate.value : this.bonusEndDate),
        bonusMechanism: (bonusMechanism != null
            ? bonusMechanism.value
            : this.bonusMechanism),
        bonusPeriodDescription: (bonusPeriodDescription != null
            ? bonusPeriodDescription.value
            : this.bonusPeriodDescription),
        bonusSegmentDescription: (bonusSegmentDescription != null
            ? bonusSegmentDescription.value
            : this.bonusSegmentDescription),
        bonusSegmentId: (bonusSegmentId != null
            ? bonusSegmentId.value
            : this.bonusSegmentId),
        bonusStartDate: (bonusStartDate != null
            ? bonusStartDate.value
            : this.bonusStartDate),
        brand: (brand != null ? brand.value : this.brand),
        currentPrice:
            (currentPrice != null ? currentPrice.value : this.currentPrice),
        descriptionFull: (descriptionFull != null
            ? descriptionFull.value
            : this.descriptionFull),
        descriptionHighlights: (descriptionHighlights != null
            ? descriptionHighlights.value
            : this.descriptionHighlights),
        discountType:
            (discountType != null ? discountType.value : this.discountType),
        extraDescriptions: (extraDescriptions != null
            ? extraDescriptions.value
            : this.extraDescriptions),
        hqId: (hqId != null ? hqId.value : this.hqId),
        images: (images != null ? images.value : this.images),
        isBonus: (isBonus != null ? isBonus.value : this.isBonus),
        isBonusPrice:
            (isBonusPrice != null ? isBonusPrice.value : this.isBonusPrice),
        isInfiniteBonus: (isInfiniteBonus != null
            ? isInfiniteBonus.value
            : this.isInfiniteBonus),
        isOrderable:
            (isOrderable != null ? isOrderable.value : this.isOrderable),
        isPreviouslyBought: (isPreviouslyBought != null
            ? isPreviouslyBought.value
            : this.isPreviouslyBought),
        isSample: (isSample != null ? isSample.value : this.isSample),
        isStapelBonus:
            (isStapelBonus != null ? isStapelBonus.value : this.isStapelBonus),
        mainCategory:
            (mainCategory != null ? mainCategory.value : this.mainCategory),
        nix18: (nix18 != null ? nix18.value : this.nix18),
        orderAvailabilityDescription: (orderAvailabilityDescription != null
            ? orderAvailabilityDescription.value
            : this.orderAvailabilityDescription),
        orderAvailabilityStatus: (orderAvailabilityStatus != null
            ? orderAvailabilityStatus.value
            : this.orderAvailabilityStatus),
        priceBeforeBonus: (priceBeforeBonus != null
            ? priceBeforeBonus.value
            : this.priceBeforeBonus),
        promotionType:
            (promotionType != null ? promotionType.value : this.promotionType),
        properties: (properties != null ? properties.value : this.properties),
        propertyIcons:
            (propertyIcons != null ? propertyIcons.value : this.propertyIcons),
        salesUnitSize:
            (salesUnitSize != null ? salesUnitSize.value : this.salesUnitSize),
        segmentType:
            (segmentType != null ? segmentType.value : this.segmentType),
        shopType: (shopType != null ? shopType.value : this.shopType),
        subCategory:
            (subCategory != null ? subCategory.value : this.subCategory),
        subCategoryId:
            (subCategoryId != null ? subCategoryId.value : this.subCategoryId),
        title: (title != null ? title.value : this.title),
        unitPriceDescription: (unitPriceDescription != null
            ? unitPriceDescription.value
            : this.unitPriceDescription),
        webshopId: (webshopId != null ? webshopId.value : this.webshopId));
  }
}

@JsonSerializable(explicitToJson: true)
class Status {
  Status({
    required this.amount,
    required this.status,
  });

  factory Status.fromJson(Map<String, dynamic> json) => _$StatusFromJson(json);

  @JsonKey(name: 'amount', includeIfNull: false)
  final int amount;
  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: statusStatusToJson,
    fromJson: statusStatusFromJson,
  )
  final enums.StatusStatus status;
  static const fromJsonFactory = _$StatusFromJson;
  static const toJsonFactory = _$StatusToJson;
  Map<String, dynamic> toJson() => _$StatusToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Status &&
            (identical(other.amount, amount) ||
                const DeepCollectionEquality().equals(other.amount, amount)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(amount) ^
      const DeepCollectionEquality().hash(status) ^
      runtimeType.hashCode;
}

extension $StatusExtension on Status {
  Status copyWith({int? amount, enums.StatusStatus? status}) {
    return Status(amount: amount ?? this.amount, status: status ?? this.status);
  }

  Status copyWithWrapped(
      {Wrapped<int>? amount, Wrapped<enums.StatusStatus>? status}) {
    return Status(
        amount: (amount != null ? amount.value : this.amount),
        status: (status != null ? status.value : this.status));
  }
}

String? statusStatusToJson(enums.StatusStatus? statusStatus) {
  return enums.$StatusStatusMap[statusStatus];
}

enums.StatusStatus statusStatusFromJson(
  Object? statusStatus, [
  enums.StatusStatus? defaultValue,
]) {
  if (statusStatus is String) {
    return enums.$StatusStatusMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == statusStatus.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.StatusStatus.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$StatusStatusMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.StatusStatus.swaggerGeneratedUnknown;
}

List<String> statusStatusListToJson(List<enums.StatusStatus>? statusStatus) {
  if (statusStatus == null) {
    return [];
  }

  return statusStatus.map((e) => enums.$StatusStatusMap[e]!).toList();
}

List<enums.StatusStatus> statusStatusListFromJson(
  List? statusStatus, [
  List<enums.StatusStatus>? defaultValue,
]) {
  if (statusStatus == null) {
    return defaultValue ?? [];
  }

  return statusStatus.map((e) => statusStatusFromJson(e.toString())).toList();
}

List<enums.StatusStatus>? statusStatusNullableListFromJson(
  List? statusStatus, [
  List<enums.StatusStatus>? defaultValue,
]) {
  if (statusStatus == null) {
    return defaultValue;
  }

  return statusStatus.map((e) => statusStatusFromJson(e.toString())).toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
