// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'go_screen_service.enums.swagger.dart' as enums;
export 'go_screen_service.enums.swagger.dart';

part 'go_screen_service.swagger.chopper.dart';
part 'go_screen_service.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class GoScreenService extends ChopperService {
  static GoScreenService create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$GoScreenService(client);
    }

    final newClient = ChopperClient(
        services: [_$GoScreenService()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$GoScreenService(newClient);
  }

  ///Returns the most preferred instance and/or provider based on entitlements, bookmarks and provided parameters.
  ///@param titleCrid The title Crid for which the most preferred instance is requested.
  ///@param brandingProviderId
  ///@param cityId City Identifier of the user.
  ///@param profileId The end user profile Id. Used to call the bookmark service.
  ///@param x-entitlements-token The entitlements token as obtained from the Purchase Service. Used to get the entitlements and validate the customerId
  ///@param x-cus The customer Id. Used to validate the entitlement token.
  ///@param x-dev The device Id. Used to validate the entitlement token.
  ///@param x-claims-set The claims set generated by the gateway from the claims token as obtained from personalization service. Used to validate that the profileId given, belongs to the customer making the request.
  Future<chopper.Response<TitlePreferredInstance>>
      v1TitlePreferredInstanceTitleCridGet({
    required String? titleCrid,
    String? brandingProviderId,
    int? cityId,
    String? profileId,
    String? xEntitlementsToken = 'X-Entitlements-Token',
    String? xCus = 'X-Cus',
    String? xDev,
    String? xClaimsSet,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        TitlePreferredInstance, () => TitlePreferredInstance.fromJsonFactory);

    return _v1TitlePreferredInstanceTitleCridGet(
        titleCrid: titleCrid,
        brandingProviderId: brandingProviderId,
        cityId: cityId,
        profileId: profileId,
        xEntitlementsToken: xEntitlementsToken,
        xCus: xCus,
        xDev: xDev,
        xClaimsSet: xClaimsSet,
        cacheControl: cacheControl);
  }

  ///Returns the most preferred instance and/or provider based on entitlements, bookmarks and provided parameters.
  ///@param titleCrid The title Crid for which the most preferred instance is requested.
  ///@param brandingProviderId
  ///@param cityId City Identifier of the user.
  ///@param profileId The end user profile Id. Used to call the bookmark service.
  ///@param x-entitlements-token The entitlements token as obtained from the Purchase Service. Used to get the entitlements and validate the customerId
  ///@param x-cus The customer Id. Used to validate the entitlement token.
  ///@param x-dev The device Id. Used to validate the entitlement token.
  ///@param x-claims-set The claims set generated by the gateway from the claims token as obtained from personalization service. Used to validate that the profileId given, belongs to the customer making the request.
  @Get(path: '/v1/titlePreferredInstance/{titleCrid}')
  Future<chopper.Response<TitlePreferredInstance>>
      _v1TitlePreferredInstanceTitleCridGet({
    @Path('titleCrid') required String? titleCrid,
    @Query('brandingProviderId') String? brandingProviderId,
    @Query('cityId') int? cityId,
    @Query('profileId') String? profileId,
    @Header('x-entitlements-token')
        String? xEntitlementsToken = 'X-Entitlements-Token',
    @Header('x-cus') String? xCus = 'X-Cus',
    @Header('x-dev') String? xDev,
    @Header('x-claims-set') String? xClaimsSet,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Returns the title Details page for a title, for the most preferred OR indicated provider
  ///@param titleCrid The title Crid for which the details is requested.
  ///@param language two character language code
  ///@param brandingProviderId
  ///@param cityId City Identifier of the user.
  ///@param x-entitlements-token The entitlements token as obtained from the Purchase Service. Used to get the entitlements and validate the customerId
  ///@param x-cus The customer Id. Used to validate the entitlement token.
  ///@param x-dev The device Id. Used to validate the entitlement token.
  ///@param profileId The end user profile Id. Used to call the bookmark service.
  ///@param x-claims-set The claims set generated by the gateway from the claims token as obtained from personalization service. Used to validate that the profileId given, belongs to the customer making the request.
  Future<chopper.Response<ProgramDetails>> v1TitleDetailsTitleCridGet({
    required String? titleCrid,
    required String? language,
    String? brandingProviderId,
    int? cityId,
    String? xEntitlementsToken = 'X-Entitlements-Token',
    String? xCus = 'X-Cus',
    String? xDev,
    String? profileId,
    String? xClaimsSet,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ProgramDetails, () => ProgramDetails.fromJsonFactory);

    return _v1TitleDetailsTitleCridGet(
        titleCrid: titleCrid,
        language: language,
        brandingProviderId: brandingProviderId,
        cityId: cityId,
        xEntitlementsToken: xEntitlementsToken,
        xCus: xCus,
        xDev: xDev,
        profileId: profileId,
        xClaimsSet: xClaimsSet,
        cacheControl: cacheControl);
  }

  ///Returns the title Details page for a title, for the most preferred OR indicated provider
  ///@param titleCrid The title Crid for which the details is requested.
  ///@param language two character language code
  ///@param brandingProviderId
  ///@param cityId City Identifier of the user.
  ///@param x-entitlements-token The entitlements token as obtained from the Purchase Service. Used to get the entitlements and validate the customerId
  ///@param x-cus The customer Id. Used to validate the entitlement token.
  ///@param x-dev The device Id. Used to validate the entitlement token.
  ///@param profileId The end user profile Id. Used to call the bookmark service.
  ///@param x-claims-set The claims set generated by the gateway from the claims token as obtained from personalization service. Used to validate that the profileId given, belongs to the customer making the request.
  @Get(path: '/v1/titleDetails/{titleCrid}')
  Future<chopper.Response<ProgramDetails>> _v1TitleDetailsTitleCridGet({
    @Path('titleCrid') required String? titleCrid,
    @Query('language') required String? language,
    @Query('brandingProviderId') String? brandingProviderId,
    @Query('cityId') int? cityId,
    @Header('x-entitlements-token')
        String? xEntitlementsToken = 'X-Entitlements-Token',
    @Header('x-cus') String? xCus = 'X-Cus',
    @Header('x-dev') String? xDev,
    @Query('profileId') String? profileId,
    @Header('x-claims-set') String? xClaimsSet,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Returns the rented items for the customer
  ///@param adult Whether to return adult or non adult rentals
  ///@param language two character language code
  ///@param x-entitlements-token The entitlements token as obtained from the Purchase Service. Used to get the entitlements and validate the customerId
  ///@param x-cus The customer Id. Used to validate the entitlement token.
  ///@param x-dev The device Id. Used to validate the entitlement token.
  ///@param profileId The end user profile Id. Used to determine viewProgress and watchlist status.
  ///@param x-claims-set The claims set generated by the gateway from the claims token as obtained from personalization service. Used to validate that the profileId given, belongs to the customer making the request.
  Future<chopper.Response<ProgramFeed>> v1FeedsRentalsGet({
    bool? adult,
    required String? language,
    String? xEntitlementsToken = 'X-Entitlements-Token',
    String? xCus = 'X-Cus',
    String? xDev,
    String? profileId,
    String? xClaimsSet,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ProgramFeed, () => ProgramFeed.fromJsonFactory);

    return _v1FeedsRentalsGet(
        adult: adult,
        language: language,
        xEntitlementsToken: xEntitlementsToken,
        xCus: xCus,
        xDev: xDev,
        profileId: profileId,
        xClaimsSet: xClaimsSet,
        cacheControl: cacheControl);
  }

  ///Returns the rented items for the customer
  ///@param adult Whether to return adult or non adult rentals
  ///@param language two character language code
  ///@param x-entitlements-token The entitlements token as obtained from the Purchase Service. Used to get the entitlements and validate the customerId
  ///@param x-cus The customer Id. Used to validate the entitlement token.
  ///@param x-dev The device Id. Used to validate the entitlement token.
  ///@param profileId The end user profile Id. Used to determine viewProgress and watchlist status.
  ///@param x-claims-set The claims set generated by the gateway from the claims token as obtained from personalization service. Used to validate that the profileId given, belongs to the customer making the request.
  @Get(path: '/v1/feeds/rentals')
  Future<chopper.Response<ProgramFeed>> _v1FeedsRentalsGet({
    @Query('adult') bool? adult,
    @Query('language') required String? language,
    @Header('x-entitlements-token')
        String? xEntitlementsToken = 'X-Entitlements-Token',
    @Header('x-cus') String? xCus = 'X-Cus',
    @Header('x-dev') String? xDev,
    @Query('profileId') String? profileId,
    @Header('x-claims-set') String? xClaimsSet,
    @Header('Cache-Control') String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class TitlePreferredInstance {
  TitlePreferredInstance({
    required this.titleId,
    this.brandingProviderId,
    this.contentId,
    required this.isGoPlayable,
    this.viewProgress,
  });

  factory TitlePreferredInstance.fromJson(Map<String, dynamic> json) =>
      _$TitlePreferredInstanceFromJson(json);

  @JsonKey(name: 'titleId', includeIfNull: false, defaultValue: '')
  final String titleId;
  @JsonKey(name: 'brandingProviderId', includeIfNull: false, defaultValue: '')
  final String? brandingProviderId;
  @JsonKey(name: 'contentId', includeIfNull: false, defaultValue: '')
  final String? contentId;
  @JsonKey(name: 'isGoPlayable', includeIfNull: false)
  final bool isGoPlayable;
  @JsonKey(name: 'viewProgress', includeIfNull: false)
  final ViewProgress? viewProgress;
  static const fromJsonFactory = _$TitlePreferredInstanceFromJson;
  static const toJsonFactory = _$TitlePreferredInstanceToJson;
  Map<String, dynamic> toJson() => _$TitlePreferredInstanceToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TitlePreferredInstance &&
            (identical(other.titleId, titleId) ||
                const DeepCollectionEquality()
                    .equals(other.titleId, titleId)) &&
            (identical(other.brandingProviderId, brandingProviderId) ||
                const DeepCollectionEquality()
                    .equals(other.brandingProviderId, brandingProviderId)) &&
            (identical(other.contentId, contentId) ||
                const DeepCollectionEquality()
                    .equals(other.contentId, contentId)) &&
            (identical(other.isGoPlayable, isGoPlayable) ||
                const DeepCollectionEquality()
                    .equals(other.isGoPlayable, isGoPlayable)) &&
            (identical(other.viewProgress, viewProgress) ||
                const DeepCollectionEquality()
                    .equals(other.viewProgress, viewProgress)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(titleId) ^
      const DeepCollectionEquality().hash(brandingProviderId) ^
      const DeepCollectionEquality().hash(contentId) ^
      const DeepCollectionEquality().hash(isGoPlayable) ^
      const DeepCollectionEquality().hash(viewProgress) ^
      runtimeType.hashCode;
}

extension $TitlePreferredInstanceExtension on TitlePreferredInstance {
  TitlePreferredInstance copyWith(
      {String? titleId,
      String? brandingProviderId,
      String? contentId,
      bool? isGoPlayable,
      ViewProgress? viewProgress}) {
    return TitlePreferredInstance(
        titleId: titleId ?? this.titleId,
        brandingProviderId: brandingProviderId ?? this.brandingProviderId,
        contentId: contentId ?? this.contentId,
        isGoPlayable: isGoPlayable ?? this.isGoPlayable,
        viewProgress: viewProgress ?? this.viewProgress);
  }

  TitlePreferredInstance copyWithWrapped(
      {Wrapped<String>? titleId,
      Wrapped<String?>? brandingProviderId,
      Wrapped<String?>? contentId,
      Wrapped<bool>? isGoPlayable,
      Wrapped<ViewProgress?>? viewProgress}) {
    return TitlePreferredInstance(
        titleId: (titleId != null ? titleId.value : this.titleId),
        brandingProviderId: (brandingProviderId != null
            ? brandingProviderId.value
            : this.brandingProviderId),
        contentId: (contentId != null ? contentId.value : this.contentId),
        isGoPlayable:
            (isGoPlayable != null ? isGoPlayable.value : this.isGoPlayable),
        viewProgress:
            (viewProgress != null ? viewProgress.value : this.viewProgress));
  }
}

@JsonSerializable(explicitToJson: true)
class ProgramDetails {
  ProgramDetails();

  factory ProgramDetails.fromJson(Map<String, dynamic> json) =>
      _$ProgramDetailsFromJson(json);

  static const fromJsonFactory = _$ProgramDetailsFromJson;
  static const toJsonFactory = _$ProgramDetailsToJson;
  Map<String, dynamic> toJson() => _$ProgramDetailsToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode => runtimeType.hashCode;
}

@JsonSerializable(explicitToJson: true)
class SharedProgramDetails {
  SharedProgramDetails({
    required this.info,
    required this.metadata,
    required this.trailers,
    this.profileData,
    required this.sources,
  });

  factory SharedProgramDetails.fromJson(Map<String, dynamic> json) =>
      _$SharedProgramDetailsFromJson(json);

  @JsonKey(name: 'info', includeIfNull: false)
  final InfoData info;
  @JsonKey(name: 'metadata', includeIfNull: false)
  final TitleMetadata metadata;
  @JsonKey(name: 'trailers', includeIfNull: false, defaultValue: <SourceVod>[])
  final List<SourceVod> trailers;
  @JsonKey(name: 'profileData', includeIfNull: false)
  final ProfileData? profileData;
  @JsonKey(name: 'sources', includeIfNull: false, defaultValue: <SourceExt>[])
  final List<SourceExt> sources;
  static const fromJsonFactory = _$SharedProgramDetailsFromJson;
  static const toJsonFactory = _$SharedProgramDetailsToJson;
  Map<String, dynamic> toJson() => _$SharedProgramDetailsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SharedProgramDetails &&
            (identical(other.info, info) ||
                const DeepCollectionEquality().equals(other.info, info)) &&
            (identical(other.metadata, metadata) ||
                const DeepCollectionEquality()
                    .equals(other.metadata, metadata)) &&
            (identical(other.trailers, trailers) ||
                const DeepCollectionEquality()
                    .equals(other.trailers, trailers)) &&
            (identical(other.profileData, profileData) ||
                const DeepCollectionEquality()
                    .equals(other.profileData, profileData)) &&
            (identical(other.sources, sources) ||
                const DeepCollectionEquality().equals(other.sources, sources)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(info) ^
      const DeepCollectionEquality().hash(metadata) ^
      const DeepCollectionEquality().hash(trailers) ^
      const DeepCollectionEquality().hash(profileData) ^
      const DeepCollectionEquality().hash(sources) ^
      runtimeType.hashCode;
}

extension $SharedProgramDetailsExtension on SharedProgramDetails {
  SharedProgramDetails copyWith(
      {InfoData? info,
      TitleMetadata? metadata,
      List<SourceVod>? trailers,
      ProfileData? profileData,
      List<SourceExt>? sources}) {
    return SharedProgramDetails(
        info: info ?? this.info,
        metadata: metadata ?? this.metadata,
        trailers: trailers ?? this.trailers,
        profileData: profileData ?? this.profileData,
        sources: sources ?? this.sources);
  }

  SharedProgramDetails copyWithWrapped(
      {Wrapped<InfoData>? info,
      Wrapped<TitleMetadata>? metadata,
      Wrapped<List<SourceVod>>? trailers,
      Wrapped<ProfileData?>? profileData,
      Wrapped<List<SourceExt>>? sources}) {
    return SharedProgramDetails(
        info: (info != null ? info.value : this.info),
        metadata: (metadata != null ? metadata.value : this.metadata),
        trailers: (trailers != null ? trailers.value : this.trailers),
        profileData:
            (profileData != null ? profileData.value : this.profileData),
        sources: (sources != null ? sources.value : this.sources));
  }
}

@JsonSerializable(explicitToJson: true)
class ProfileData {
  ProfileData({
    this.viewProgress,
    this.onWatchlist,
  });

  factory ProfileData.fromJson(Map<String, dynamic> json) =>
      _$ProfileDataFromJson(json);

  @JsonKey(name: 'viewProgress', includeIfNull: false)
  final ViewProgress? viewProgress;
  @JsonKey(name: 'onWatchlist', includeIfNull: false)
  final bool? onWatchlist;
  static const fromJsonFactory = _$ProfileDataFromJson;
  static const toJsonFactory = _$ProfileDataToJson;
  Map<String, dynamic> toJson() => _$ProfileDataToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProfileData &&
            (identical(other.viewProgress, viewProgress) ||
                const DeepCollectionEquality()
                    .equals(other.viewProgress, viewProgress)) &&
            (identical(other.onWatchlist, onWatchlist) ||
                const DeepCollectionEquality()
                    .equals(other.onWatchlist, onWatchlist)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(viewProgress) ^
      const DeepCollectionEquality().hash(onWatchlist) ^
      runtimeType.hashCode;
}

extension $ProfileDataExtension on ProfileData {
  ProfileData copyWith({ViewProgress? viewProgress, bool? onWatchlist}) {
    return ProfileData(
        viewProgress: viewProgress ?? this.viewProgress,
        onWatchlist: onWatchlist ?? this.onWatchlist);
  }

  ProfileData copyWithWrapped(
      {Wrapped<ViewProgress?>? viewProgress, Wrapped<bool?>? onWatchlist}) {
    return ProfileData(
        viewProgress:
            (viewProgress != null ? viewProgress.value : this.viewProgress),
        onWatchlist:
            (onWatchlist != null ? onWatchlist.value : this.onWatchlist));
  }
}

@JsonSerializable(explicitToJson: true)
class TitleProgramDetails {
  TitleProgramDetails({
    required this.title,
    this.programType,
    this.info,
    this.metadata,
    this.trailers,
    this.profileData,
    this.sources,
  });

  factory TitleProgramDetails.fromJson(Map<String, dynamic> json) =>
      _$TitleProgramDetailsFromJson(json);

  @JsonKey(name: 'title', includeIfNull: false)
  final TitleData title;
  @JsonKey(
    name: 'programType',
    includeIfNull: false,
    toJson: titleProgramDetailsProgramTypeToJson,
    fromJson: titleProgramDetailsProgramTypeFromJson,
  )
  final enums.TitleProgramDetailsProgramType? programType;
  @JsonKey(name: 'info', includeIfNull: false)
  final InfoData? info;
  @JsonKey(name: 'metadata', includeIfNull: false)
  final TitleMetadata? metadata;
  @JsonKey(name: 'trailers', includeIfNull: false, defaultValue: <SourceVod>[])
  final List<SourceVod>? trailers;
  @JsonKey(name: 'profileData', includeIfNull: false)
  final ProfileData? profileData;
  @JsonKey(name: 'sources', includeIfNull: false, defaultValue: <SourceExt>[])
  final List<SourceExt>? sources;
  static const fromJsonFactory = _$TitleProgramDetailsFromJson;
  static const toJsonFactory = _$TitleProgramDetailsToJson;
  Map<String, dynamic> toJson() => _$TitleProgramDetailsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TitleProgramDetails &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.programType, programType) ||
                const DeepCollectionEquality()
                    .equals(other.programType, programType)) &&
            (identical(other.info, info) ||
                const DeepCollectionEquality().equals(other.info, info)) &&
            (identical(other.metadata, metadata) ||
                const DeepCollectionEquality()
                    .equals(other.metadata, metadata)) &&
            (identical(other.trailers, trailers) ||
                const DeepCollectionEquality()
                    .equals(other.trailers, trailers)) &&
            (identical(other.profileData, profileData) ||
                const DeepCollectionEquality()
                    .equals(other.profileData, profileData)) &&
            (identical(other.sources, sources) ||
                const DeepCollectionEquality().equals(other.sources, sources)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(programType) ^
      const DeepCollectionEquality().hash(info) ^
      const DeepCollectionEquality().hash(metadata) ^
      const DeepCollectionEquality().hash(trailers) ^
      const DeepCollectionEquality().hash(profileData) ^
      const DeepCollectionEquality().hash(sources) ^
      runtimeType.hashCode;
}

extension $TitleProgramDetailsExtension on TitleProgramDetails {
  TitleProgramDetails copyWith(
      {TitleData? title,
      enums.TitleProgramDetailsProgramType? programType,
      InfoData? info,
      TitleMetadata? metadata,
      List<SourceVod>? trailers,
      ProfileData? profileData,
      List<SourceExt>? sources}) {
    return TitleProgramDetails(
        title: title ?? this.title,
        programType: programType ?? this.programType,
        info: info ?? this.info,
        metadata: metadata ?? this.metadata,
        trailers: trailers ?? this.trailers,
        profileData: profileData ?? this.profileData,
        sources: sources ?? this.sources);
  }

  TitleProgramDetails copyWithWrapped(
      {Wrapped<TitleData>? title,
      Wrapped<enums.TitleProgramDetailsProgramType?>? programType,
      Wrapped<InfoData?>? info,
      Wrapped<TitleMetadata?>? metadata,
      Wrapped<List<SourceVod>?>? trailers,
      Wrapped<ProfileData?>? profileData,
      Wrapped<List<SourceExt>?>? sources}) {
    return TitleProgramDetails(
        title: (title != null ? title.value : this.title),
        programType:
            (programType != null ? programType.value : this.programType),
        info: (info != null ? info.value : this.info),
        metadata: (metadata != null ? metadata.value : this.metadata),
        trailers: (trailers != null ? trailers.value : this.trailers),
        profileData:
            (profileData != null ? profileData.value : this.profileData),
        sources: (sources != null ? sources.value : this.sources));
  }
}

@JsonSerializable(explicitToJson: true)
class EpisodeProgramDetails {
  EpisodeProgramDetails({
    required this.episode,
    required this.season,
    required this.show,
    this.programType,
    this.info,
    this.metadata,
    this.trailers,
    this.profileData,
    this.sources,
  });

  factory EpisodeProgramDetails.fromJson(Map<String, dynamic> json) =>
      _$EpisodeProgramDetailsFromJson(json);

  @JsonKey(name: 'episode', includeIfNull: false)
  final EpisodeData episode;
  @JsonKey(name: 'season', includeIfNull: false)
  final SeasonData season;
  @JsonKey(name: 'show', includeIfNull: false)
  final ShowData show;
  @JsonKey(
    name: 'programType',
    includeIfNull: false,
    toJson: episodeProgramDetailsProgramTypeToJson,
    fromJson: episodeProgramDetailsProgramTypeFromJson,
  )
  final enums.EpisodeProgramDetailsProgramType? programType;
  @JsonKey(name: 'info', includeIfNull: false)
  final InfoData? info;
  @JsonKey(name: 'metadata', includeIfNull: false)
  final TitleMetadata? metadata;
  @JsonKey(name: 'trailers', includeIfNull: false, defaultValue: <SourceVod>[])
  final List<SourceVod>? trailers;
  @JsonKey(name: 'profileData', includeIfNull: false)
  final ProfileData? profileData;
  @JsonKey(name: 'sources', includeIfNull: false, defaultValue: <SourceExt>[])
  final List<SourceExt>? sources;
  static const fromJsonFactory = _$EpisodeProgramDetailsFromJson;
  static const toJsonFactory = _$EpisodeProgramDetailsToJson;
  Map<String, dynamic> toJson() => _$EpisodeProgramDetailsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EpisodeProgramDetails &&
            (identical(other.episode, episode) ||
                const DeepCollectionEquality()
                    .equals(other.episode, episode)) &&
            (identical(other.season, season) ||
                const DeepCollectionEquality().equals(other.season, season)) &&
            (identical(other.show, show) ||
                const DeepCollectionEquality().equals(other.show, show)) &&
            (identical(other.programType, programType) ||
                const DeepCollectionEquality()
                    .equals(other.programType, programType)) &&
            (identical(other.info, info) ||
                const DeepCollectionEquality().equals(other.info, info)) &&
            (identical(other.metadata, metadata) ||
                const DeepCollectionEquality()
                    .equals(other.metadata, metadata)) &&
            (identical(other.trailers, trailers) ||
                const DeepCollectionEquality()
                    .equals(other.trailers, trailers)) &&
            (identical(other.profileData, profileData) ||
                const DeepCollectionEquality()
                    .equals(other.profileData, profileData)) &&
            (identical(other.sources, sources) ||
                const DeepCollectionEquality().equals(other.sources, sources)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(episode) ^
      const DeepCollectionEquality().hash(season) ^
      const DeepCollectionEquality().hash(show) ^
      const DeepCollectionEquality().hash(programType) ^
      const DeepCollectionEquality().hash(info) ^
      const DeepCollectionEquality().hash(metadata) ^
      const DeepCollectionEquality().hash(trailers) ^
      const DeepCollectionEquality().hash(profileData) ^
      const DeepCollectionEquality().hash(sources) ^
      runtimeType.hashCode;
}

extension $EpisodeProgramDetailsExtension on EpisodeProgramDetails {
  EpisodeProgramDetails copyWith(
      {EpisodeData? episode,
      SeasonData? season,
      ShowData? show,
      enums.EpisodeProgramDetailsProgramType? programType,
      InfoData? info,
      TitleMetadata? metadata,
      List<SourceVod>? trailers,
      ProfileData? profileData,
      List<SourceExt>? sources}) {
    return EpisodeProgramDetails(
        episode: episode ?? this.episode,
        season: season ?? this.season,
        show: show ?? this.show,
        programType: programType ?? this.programType,
        info: info ?? this.info,
        metadata: metadata ?? this.metadata,
        trailers: trailers ?? this.trailers,
        profileData: profileData ?? this.profileData,
        sources: sources ?? this.sources);
  }

  EpisodeProgramDetails copyWithWrapped(
      {Wrapped<EpisodeData>? episode,
      Wrapped<SeasonData>? season,
      Wrapped<ShowData>? show,
      Wrapped<enums.EpisodeProgramDetailsProgramType?>? programType,
      Wrapped<InfoData?>? info,
      Wrapped<TitleMetadata?>? metadata,
      Wrapped<List<SourceVod>?>? trailers,
      Wrapped<ProfileData?>? profileData,
      Wrapped<List<SourceExt>?>? sources}) {
    return EpisodeProgramDetails(
        episode: (episode != null ? episode.value : this.episode),
        season: (season != null ? season.value : this.season),
        show: (show != null ? show.value : this.show),
        programType:
            (programType != null ? programType.value : this.programType),
        info: (info != null ? info.value : this.info),
        metadata: (metadata != null ? metadata.value : this.metadata),
        trailers: (trailers != null ? trailers.value : this.trailers),
        profileData:
            (profileData != null ? profileData.value : this.profileData),
        sources: (sources != null ? sources.value : this.sources));
  }
}

@JsonSerializable(explicitToJson: true)
class ProgramTypeTitle {
  ProgramTypeTitle({
    required this.programType,
  });

  factory ProgramTypeTitle.fromJson(Map<String, dynamic> json) =>
      _$ProgramTypeTitleFromJson(json);

  @JsonKey(
    name: 'programType',
    includeIfNull: false,
    toJson: programTypeTitleProgramTypeToJson,
    fromJson: programTypeTitleProgramTypeFromJson,
  )
  final enums.ProgramTypeTitleProgramType programType;
  static const fromJsonFactory = _$ProgramTypeTitleFromJson;
  static const toJsonFactory = _$ProgramTypeTitleToJson;
  Map<String, dynamic> toJson() => _$ProgramTypeTitleToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProgramTypeTitle &&
            (identical(other.programType, programType) ||
                const DeepCollectionEquality()
                    .equals(other.programType, programType)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(programType) ^ runtimeType.hashCode;
}

extension $ProgramTypeTitleExtension on ProgramTypeTitle {
  ProgramTypeTitle copyWith({enums.ProgramTypeTitleProgramType? programType}) {
    return ProgramTypeTitle(programType: programType ?? this.programType);
  }

  ProgramTypeTitle copyWithWrapped(
      {Wrapped<enums.ProgramTypeTitleProgramType>? programType}) {
    return ProgramTypeTitle(
        programType:
            (programType != null ? programType.value : this.programType));
  }
}

@JsonSerializable(explicitToJson: true)
class ProgramTypeEpisode {
  ProgramTypeEpisode({
    required this.programType,
  });

  factory ProgramTypeEpisode.fromJson(Map<String, dynamic> json) =>
      _$ProgramTypeEpisodeFromJson(json);

  @JsonKey(
    name: 'programType',
    includeIfNull: false,
    toJson: programTypeEpisodeProgramTypeToJson,
    fromJson: programTypeEpisodeProgramTypeFromJson,
  )
  final enums.ProgramTypeEpisodeProgramType programType;
  static const fromJsonFactory = _$ProgramTypeEpisodeFromJson;
  static const toJsonFactory = _$ProgramTypeEpisodeToJson;
  Map<String, dynamic> toJson() => _$ProgramTypeEpisodeToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProgramTypeEpisode &&
            (identical(other.programType, programType) ||
                const DeepCollectionEquality()
                    .equals(other.programType, programType)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(programType) ^ runtimeType.hashCode;
}

extension $ProgramTypeEpisodeExtension on ProgramTypeEpisode {
  ProgramTypeEpisode copyWith(
      {enums.ProgramTypeEpisodeProgramType? programType}) {
    return ProgramTypeEpisode(programType: programType ?? this.programType);
  }

  ProgramTypeEpisode copyWithWrapped(
      {Wrapped<enums.ProgramTypeEpisodeProgramType>? programType}) {
    return ProgramTypeEpisode(
        programType:
            (programType != null ? programType.value : this.programType));
  }
}

@JsonSerializable(explicitToJson: true)
class ViewProgress {
  ViewProgress({
    required this.viewState,
    required this.position,
    required this.duration,
  });

  factory ViewProgress.fromJson(Map<String, dynamic> json) =>
      _$ViewProgressFromJson(json);

  @JsonKey(
    name: 'viewState',
    includeIfNull: false,
    toJson: viewStateToJson,
    fromJson: viewStateFromJson,
  )
  final enums.ViewState viewState;
  @JsonKey(name: 'position', includeIfNull: false)
  final double position;
  @JsonKey(name: 'duration', includeIfNull: false)
  final double duration;
  static const fromJsonFactory = _$ViewProgressFromJson;
  static const toJsonFactory = _$ViewProgressToJson;
  Map<String, dynamic> toJson() => _$ViewProgressToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ViewProgress &&
            (identical(other.viewState, viewState) ||
                const DeepCollectionEquality()
                    .equals(other.viewState, viewState)) &&
            (identical(other.position, position) ||
                const DeepCollectionEquality()
                    .equals(other.position, position)) &&
            (identical(other.duration, duration) ||
                const DeepCollectionEquality()
                    .equals(other.duration, duration)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(viewState) ^
      const DeepCollectionEquality().hash(position) ^
      const DeepCollectionEquality().hash(duration) ^
      runtimeType.hashCode;
}

extension $ViewProgressExtension on ViewProgress {
  ViewProgress copyWith(
      {enums.ViewState? viewState, double? position, double? duration}) {
    return ViewProgress(
        viewState: viewState ?? this.viewState,
        position: position ?? this.position,
        duration: duration ?? this.duration);
  }

  ViewProgress copyWithWrapped(
      {Wrapped<enums.ViewState>? viewState,
      Wrapped<double>? position,
      Wrapped<double>? duration}) {
    return ViewProgress(
        viewState: (viewState != null ? viewState.value : this.viewState),
        position: (position != null ? position.value : this.position),
        duration: (duration != null ? duration.value : this.duration));
  }
}

@JsonSerializable(explicitToJson: true)
class Program {
  Program();

  factory Program.fromJson(Map<String, dynamic> json) =>
      _$ProgramFromJson(json);

  static const fromJsonFactory = _$ProgramFromJson;
  static const toJsonFactory = _$ProgramToJson;
  Map<String, dynamic> toJson() => _$ProgramToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode => runtimeType.hashCode;
}

@JsonSerializable(explicitToJson: true)
class ProgramInfo {
  ProgramInfo({
    this.info,
  });

  factory ProgramInfo.fromJson(Map<String, dynamic> json) =>
      _$ProgramInfoFromJson(json);

  @JsonKey(name: 'info', includeIfNull: false)
  final InfoData? info;
  static const fromJsonFactory = _$ProgramInfoFromJson;
  static const toJsonFactory = _$ProgramInfoToJson;
  Map<String, dynamic> toJson() => _$ProgramInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProgramInfo &&
            (identical(other.info, info) ||
                const DeepCollectionEquality().equals(other.info, info)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(info) ^ runtimeType.hashCode;
}

extension $ProgramInfoExtension on ProgramInfo {
  ProgramInfo copyWith({InfoData? info}) {
    return ProgramInfo(info: info ?? this.info);
  }

  ProgramInfo copyWithWrapped({Wrapped<InfoData?>? info}) {
    return ProgramInfo(info: (info != null ? info.value : this.info));
  }
}

@JsonSerializable(explicitToJson: true)
class ProgramCustomerData {
  ProgramCustomerData({
    this.customerData,
  });

  factory ProgramCustomerData.fromJson(Map<String, dynamic> json) =>
      _$ProgramCustomerDataFromJson(json);

  @JsonKey(name: 'customerData', includeIfNull: false)
  final Entitlement? customerData;
  static const fromJsonFactory = _$ProgramCustomerDataFromJson;
  static const toJsonFactory = _$ProgramCustomerDataToJson;
  Map<String, dynamic> toJson() => _$ProgramCustomerDataToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProgramCustomerData &&
            (identical(other.customerData, customerData) ||
                const DeepCollectionEquality()
                    .equals(other.customerData, customerData)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(customerData) ^ runtimeType.hashCode;
}

extension $ProgramCustomerDataExtension on ProgramCustomerData {
  ProgramCustomerData copyWith({Entitlement? customerData}) {
    return ProgramCustomerData(customerData: customerData ?? this.customerData);
  }

  ProgramCustomerData copyWithWrapped({Wrapped<Entitlement?>? customerData}) {
    return ProgramCustomerData(
        customerData:
            (customerData != null ? customerData.value : this.customerData));
  }
}

@JsonSerializable(explicitToJson: true)
class TitleProgram {
  TitleProgram({
    required this.title,
    this.profileData,
    this.programType,
    this.info,
    this.customerData,
  });

  factory TitleProgram.fromJson(Map<String, dynamic> json) =>
      _$TitleProgramFromJson(json);

  @JsonKey(name: 'title', includeIfNull: false)
  final TitleData title;
  @JsonKey(name: 'profileData', includeIfNull: false)
  final ProfileData? profileData;
  @JsonKey(
    name: 'programType',
    includeIfNull: false,
    toJson: titleProgramProgramTypeToJson,
    fromJson: titleProgramProgramTypeFromJson,
  )
  final enums.TitleProgramProgramType? programType;
  @JsonKey(name: 'info', includeIfNull: false)
  final InfoData? info;
  @JsonKey(name: 'customerData', includeIfNull: false)
  final Entitlement? customerData;
  static const fromJsonFactory = _$TitleProgramFromJson;
  static const toJsonFactory = _$TitleProgramToJson;
  Map<String, dynamic> toJson() => _$TitleProgramToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TitleProgram &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.profileData, profileData) ||
                const DeepCollectionEquality()
                    .equals(other.profileData, profileData)) &&
            (identical(other.programType, programType) ||
                const DeepCollectionEquality()
                    .equals(other.programType, programType)) &&
            (identical(other.info, info) ||
                const DeepCollectionEquality().equals(other.info, info)) &&
            (identical(other.customerData, customerData) ||
                const DeepCollectionEquality()
                    .equals(other.customerData, customerData)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(profileData) ^
      const DeepCollectionEquality().hash(programType) ^
      const DeepCollectionEquality().hash(info) ^
      const DeepCollectionEquality().hash(customerData) ^
      runtimeType.hashCode;
}

extension $TitleProgramExtension on TitleProgram {
  TitleProgram copyWith(
      {TitleData? title,
      ProfileData? profileData,
      enums.TitleProgramProgramType? programType,
      InfoData? info,
      Entitlement? customerData}) {
    return TitleProgram(
        title: title ?? this.title,
        profileData: profileData ?? this.profileData,
        programType: programType ?? this.programType,
        info: info ?? this.info,
        customerData: customerData ?? this.customerData);
  }

  TitleProgram copyWithWrapped(
      {Wrapped<TitleData>? title,
      Wrapped<ProfileData?>? profileData,
      Wrapped<enums.TitleProgramProgramType?>? programType,
      Wrapped<InfoData?>? info,
      Wrapped<Entitlement?>? customerData}) {
    return TitleProgram(
        title: (title != null ? title.value : this.title),
        profileData:
            (profileData != null ? profileData.value : this.profileData),
        programType:
            (programType != null ? programType.value : this.programType),
        info: (info != null ? info.value : this.info),
        customerData:
            (customerData != null ? customerData.value : this.customerData));
  }
}

@JsonSerializable(explicitToJson: true)
class EpisodeProgram {
  EpisodeProgram({
    required this.episode,
    required this.season,
    required this.show,
    this.profileData,
    this.programType,
    this.info,
    this.customerData,
  });

  factory EpisodeProgram.fromJson(Map<String, dynamic> json) =>
      _$EpisodeProgramFromJson(json);

  @JsonKey(name: 'episode', includeIfNull: false)
  final EpisodeData episode;
  @JsonKey(name: 'season', includeIfNull: false)
  final SeasonData season;
  @JsonKey(name: 'show', includeIfNull: false)
  final ShowData show;
  @JsonKey(name: 'profileData', includeIfNull: false)
  final ProfileData? profileData;
  @JsonKey(
    name: 'programType',
    includeIfNull: false,
    toJson: episodeProgramProgramTypeToJson,
    fromJson: episodeProgramProgramTypeFromJson,
  )
  final enums.EpisodeProgramProgramType? programType;
  @JsonKey(name: 'info', includeIfNull: false)
  final InfoData? info;
  @JsonKey(name: 'customerData', includeIfNull: false)
  final Entitlement? customerData;
  static const fromJsonFactory = _$EpisodeProgramFromJson;
  static const toJsonFactory = _$EpisodeProgramToJson;
  Map<String, dynamic> toJson() => _$EpisodeProgramToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EpisodeProgram &&
            (identical(other.episode, episode) ||
                const DeepCollectionEquality()
                    .equals(other.episode, episode)) &&
            (identical(other.season, season) ||
                const DeepCollectionEquality().equals(other.season, season)) &&
            (identical(other.show, show) ||
                const DeepCollectionEquality().equals(other.show, show)) &&
            (identical(other.profileData, profileData) ||
                const DeepCollectionEquality()
                    .equals(other.profileData, profileData)) &&
            (identical(other.programType, programType) ||
                const DeepCollectionEquality()
                    .equals(other.programType, programType)) &&
            (identical(other.info, info) ||
                const DeepCollectionEquality().equals(other.info, info)) &&
            (identical(other.customerData, customerData) ||
                const DeepCollectionEquality()
                    .equals(other.customerData, customerData)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(episode) ^
      const DeepCollectionEquality().hash(season) ^
      const DeepCollectionEquality().hash(show) ^
      const DeepCollectionEquality().hash(profileData) ^
      const DeepCollectionEquality().hash(programType) ^
      const DeepCollectionEquality().hash(info) ^
      const DeepCollectionEquality().hash(customerData) ^
      runtimeType.hashCode;
}

extension $EpisodeProgramExtension on EpisodeProgram {
  EpisodeProgram copyWith(
      {EpisodeData? episode,
      SeasonData? season,
      ShowData? show,
      ProfileData? profileData,
      enums.EpisodeProgramProgramType? programType,
      InfoData? info,
      Entitlement? customerData}) {
    return EpisodeProgram(
        episode: episode ?? this.episode,
        season: season ?? this.season,
        show: show ?? this.show,
        profileData: profileData ?? this.profileData,
        programType: programType ?? this.programType,
        info: info ?? this.info,
        customerData: customerData ?? this.customerData);
  }

  EpisodeProgram copyWithWrapped(
      {Wrapped<EpisodeData>? episode,
      Wrapped<SeasonData>? season,
      Wrapped<ShowData>? show,
      Wrapped<ProfileData?>? profileData,
      Wrapped<enums.EpisodeProgramProgramType?>? programType,
      Wrapped<InfoData?>? info,
      Wrapped<Entitlement?>? customerData}) {
    return EpisodeProgram(
        episode: (episode != null ? episode.value : this.episode),
        season: (season != null ? season.value : this.season),
        show: (show != null ? show.value : this.show),
        profileData:
            (profileData != null ? profileData.value : this.profileData),
        programType:
            (programType != null ? programType.value : this.programType),
        info: (info != null ? info.value : this.info),
        customerData:
            (customerData != null ? customerData.value : this.customerData));
  }
}

@JsonSerializable(explicitToJson: true)
class SeasonProgram {
  SeasonProgram({
    required this.season,
    required this.show,
    this.programType,
    this.info,
    this.customerData,
  });

  factory SeasonProgram.fromJson(Map<String, dynamic> json) =>
      _$SeasonProgramFromJson(json);

  @JsonKey(name: 'season', includeIfNull: false)
  final SeasonData season;
  @JsonKey(name: 'show', includeIfNull: false)
  final ShowData show;
  @JsonKey(
    name: 'programType',
    includeIfNull: false,
    toJson: seasonProgramProgramTypeToJson,
    fromJson: seasonProgramProgramTypeFromJson,
  )
  final enums.SeasonProgramProgramType? programType;
  @JsonKey(name: 'info', includeIfNull: false)
  final InfoData? info;
  @JsonKey(name: 'customerData', includeIfNull: false)
  final Entitlement? customerData;
  static const fromJsonFactory = _$SeasonProgramFromJson;
  static const toJsonFactory = _$SeasonProgramToJson;
  Map<String, dynamic> toJson() => _$SeasonProgramToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SeasonProgram &&
            (identical(other.season, season) ||
                const DeepCollectionEquality().equals(other.season, season)) &&
            (identical(other.show, show) ||
                const DeepCollectionEquality().equals(other.show, show)) &&
            (identical(other.programType, programType) ||
                const DeepCollectionEquality()
                    .equals(other.programType, programType)) &&
            (identical(other.info, info) ||
                const DeepCollectionEquality().equals(other.info, info)) &&
            (identical(other.customerData, customerData) ||
                const DeepCollectionEquality()
                    .equals(other.customerData, customerData)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(season) ^
      const DeepCollectionEquality().hash(show) ^
      const DeepCollectionEquality().hash(programType) ^
      const DeepCollectionEquality().hash(info) ^
      const DeepCollectionEquality().hash(customerData) ^
      runtimeType.hashCode;
}

extension $SeasonProgramExtension on SeasonProgram {
  SeasonProgram copyWith(
      {SeasonData? season,
      ShowData? show,
      enums.SeasonProgramProgramType? programType,
      InfoData? info,
      Entitlement? customerData}) {
    return SeasonProgram(
        season: season ?? this.season,
        show: show ?? this.show,
        programType: programType ?? this.programType,
        info: info ?? this.info,
        customerData: customerData ?? this.customerData);
  }

  SeasonProgram copyWithWrapped(
      {Wrapped<SeasonData>? season,
      Wrapped<ShowData>? show,
      Wrapped<enums.SeasonProgramProgramType?>? programType,
      Wrapped<InfoData?>? info,
      Wrapped<Entitlement?>? customerData}) {
    return SeasonProgram(
        season: (season != null ? season.value : this.season),
        show: (show != null ? show.value : this.show),
        programType:
            (programType != null ? programType.value : this.programType),
        info: (info != null ? info.value : this.info),
        customerData:
            (customerData != null ? customerData.value : this.customerData));
  }
}

@JsonSerializable(explicitToJson: true)
class ShowProgram {
  ShowProgram({
    required this.show,
    this.programType,
    this.info,
    this.customerData,
  });

  factory ShowProgram.fromJson(Map<String, dynamic> json) =>
      _$ShowProgramFromJson(json);

  @JsonKey(name: 'show', includeIfNull: false)
  final ShowData show;
  @JsonKey(
    name: 'programType',
    includeIfNull: false,
    toJson: showProgramProgramTypeToJson,
    fromJson: showProgramProgramTypeFromJson,
  )
  final enums.ShowProgramProgramType? programType;
  @JsonKey(name: 'info', includeIfNull: false)
  final InfoData? info;
  @JsonKey(name: 'customerData', includeIfNull: false)
  final Entitlement? customerData;
  static const fromJsonFactory = _$ShowProgramFromJson;
  static const toJsonFactory = _$ShowProgramToJson;
  Map<String, dynamic> toJson() => _$ShowProgramToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ShowProgram &&
            (identical(other.show, show) ||
                const DeepCollectionEquality().equals(other.show, show)) &&
            (identical(other.programType, programType) ||
                const DeepCollectionEquality()
                    .equals(other.programType, programType)) &&
            (identical(other.info, info) ||
                const DeepCollectionEquality().equals(other.info, info)) &&
            (identical(other.customerData, customerData) ||
                const DeepCollectionEquality()
                    .equals(other.customerData, customerData)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(show) ^
      const DeepCollectionEquality().hash(programType) ^
      const DeepCollectionEquality().hash(info) ^
      const DeepCollectionEquality().hash(customerData) ^
      runtimeType.hashCode;
}

extension $ShowProgramExtension on ShowProgram {
  ShowProgram copyWith(
      {ShowData? show,
      enums.ShowProgramProgramType? programType,
      InfoData? info,
      Entitlement? customerData}) {
    return ShowProgram(
        show: show ?? this.show,
        programType: programType ?? this.programType,
        info: info ?? this.info,
        customerData: customerData ?? this.customerData);
  }

  ShowProgram copyWithWrapped(
      {Wrapped<ShowData>? show,
      Wrapped<enums.ShowProgramProgramType?>? programType,
      Wrapped<InfoData?>? info,
      Wrapped<Entitlement?>? customerData}) {
    return ShowProgram(
        show: (show != null ? show.value : this.show),
        programType:
            (programType != null ? programType.value : this.programType),
        info: (info != null ? info.value : this.info),
        customerData:
            (customerData != null ? customerData.value : this.customerData));
  }
}

@JsonSerializable(explicitToJson: true)
class ProgramTypeSeason {
  ProgramTypeSeason({
    required this.programType,
  });

  factory ProgramTypeSeason.fromJson(Map<String, dynamic> json) =>
      _$ProgramTypeSeasonFromJson(json);

  @JsonKey(
    name: 'programType',
    includeIfNull: false,
    toJson: programTypeSeasonProgramTypeToJson,
    fromJson: programTypeSeasonProgramTypeFromJson,
  )
  final enums.ProgramTypeSeasonProgramType programType;
  static const fromJsonFactory = _$ProgramTypeSeasonFromJson;
  static const toJsonFactory = _$ProgramTypeSeasonToJson;
  Map<String, dynamic> toJson() => _$ProgramTypeSeasonToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProgramTypeSeason &&
            (identical(other.programType, programType) ||
                const DeepCollectionEquality()
                    .equals(other.programType, programType)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(programType) ^ runtimeType.hashCode;
}

extension $ProgramTypeSeasonExtension on ProgramTypeSeason {
  ProgramTypeSeason copyWith(
      {enums.ProgramTypeSeasonProgramType? programType}) {
    return ProgramTypeSeason(programType: programType ?? this.programType);
  }

  ProgramTypeSeason copyWithWrapped(
      {Wrapped<enums.ProgramTypeSeasonProgramType>? programType}) {
    return ProgramTypeSeason(
        programType:
            (programType != null ? programType.value : this.programType));
  }
}

@JsonSerializable(explicitToJson: true)
class ProgramTypeShow {
  ProgramTypeShow({
    required this.programType,
  });

  factory ProgramTypeShow.fromJson(Map<String, dynamic> json) =>
      _$ProgramTypeShowFromJson(json);

  @JsonKey(
    name: 'programType',
    includeIfNull: false,
    toJson: programTypeShowProgramTypeToJson,
    fromJson: programTypeShowProgramTypeFromJson,
  )
  final enums.ProgramTypeShowProgramType programType;
  static const fromJsonFactory = _$ProgramTypeShowFromJson;
  static const toJsonFactory = _$ProgramTypeShowToJson;
  Map<String, dynamic> toJson() => _$ProgramTypeShowToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProgramTypeShow &&
            (identical(other.programType, programType) ||
                const DeepCollectionEquality()
                    .equals(other.programType, programType)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(programType) ^ runtimeType.hashCode;
}

extension $ProgramTypeShowExtension on ProgramTypeShow {
  ProgramTypeShow copyWith({enums.ProgramTypeShowProgramType? programType}) {
    return ProgramTypeShow(programType: programType ?? this.programType);
  }

  ProgramTypeShow copyWithWrapped(
      {Wrapped<enums.ProgramTypeShowProgramType>? programType}) {
    return ProgramTypeShow(
        programType:
            (programType != null ? programType.value : this.programType));
  }
}

@JsonSerializable(explicitToJson: true)
class TitleMetadata {
  TitleMetadata({
    this.parentalGuidanceText,
    required this.description,
    required this.longDescription,
    required this.genres,
    this.productionYear,
    required this.productionCountries,
    required this.cast,
    required this.crew,
  });

  factory TitleMetadata.fromJson(Map<String, dynamic> json) =>
      _$TitleMetadataFromJson(json);

  @JsonKey(name: 'parentalGuidanceText', includeIfNull: false, defaultValue: '')
  final String? parentalGuidanceText;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String description;
  @JsonKey(name: 'longDescription', includeIfNull: false, defaultValue: '')
  final String longDescription;
  @JsonKey(name: 'genres', includeIfNull: false, defaultValue: <String>[])
  final List<String> genres;
  @JsonKey(name: 'productionYear', includeIfNull: false)
  final int? productionYear;
  @JsonKey(
      name: 'productionCountries',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String> productionCountries;
  @JsonKey(name: 'cast', includeIfNull: false, defaultValue: <Person>[])
  final List<Person> cast;
  @JsonKey(name: 'crew', includeIfNull: false, defaultValue: <Person>[])
  final List<Person> crew;
  static const fromJsonFactory = _$TitleMetadataFromJson;
  static const toJsonFactory = _$TitleMetadataToJson;
  Map<String, dynamic> toJson() => _$TitleMetadataToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TitleMetadata &&
            (identical(other.parentalGuidanceText, parentalGuidanceText) ||
                const DeepCollectionEquality().equals(
                    other.parentalGuidanceText, parentalGuidanceText)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.longDescription, longDescription) ||
                const DeepCollectionEquality()
                    .equals(other.longDescription, longDescription)) &&
            (identical(other.genres, genres) ||
                const DeepCollectionEquality().equals(other.genres, genres)) &&
            (identical(other.productionYear, productionYear) ||
                const DeepCollectionEquality()
                    .equals(other.productionYear, productionYear)) &&
            (identical(other.productionCountries, productionCountries) ||
                const DeepCollectionEquality()
                    .equals(other.productionCountries, productionCountries)) &&
            (identical(other.cast, cast) ||
                const DeepCollectionEquality().equals(other.cast, cast)) &&
            (identical(other.crew, crew) ||
                const DeepCollectionEquality().equals(other.crew, crew)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(parentalGuidanceText) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(longDescription) ^
      const DeepCollectionEquality().hash(genres) ^
      const DeepCollectionEquality().hash(productionYear) ^
      const DeepCollectionEquality().hash(productionCountries) ^
      const DeepCollectionEquality().hash(cast) ^
      const DeepCollectionEquality().hash(crew) ^
      runtimeType.hashCode;
}

extension $TitleMetadataExtension on TitleMetadata {
  TitleMetadata copyWith(
      {String? parentalGuidanceText,
      String? description,
      String? longDescription,
      List<String>? genres,
      int? productionYear,
      List<String>? productionCountries,
      List<Person>? cast,
      List<Person>? crew}) {
    return TitleMetadata(
        parentalGuidanceText: parentalGuidanceText ?? this.parentalGuidanceText,
        description: description ?? this.description,
        longDescription: longDescription ?? this.longDescription,
        genres: genres ?? this.genres,
        productionYear: productionYear ?? this.productionYear,
        productionCountries: productionCountries ?? this.productionCountries,
        cast: cast ?? this.cast,
        crew: crew ?? this.crew);
  }

  TitleMetadata copyWithWrapped(
      {Wrapped<String?>? parentalGuidanceText,
      Wrapped<String>? description,
      Wrapped<String>? longDescription,
      Wrapped<List<String>>? genres,
      Wrapped<int?>? productionYear,
      Wrapped<List<String>>? productionCountries,
      Wrapped<List<Person>>? cast,
      Wrapped<List<Person>>? crew}) {
    return TitleMetadata(
        parentalGuidanceText: (parentalGuidanceText != null
            ? parentalGuidanceText.value
            : this.parentalGuidanceText),
        description:
            (description != null ? description.value : this.description),
        longDescription: (longDescription != null
            ? longDescription.value
            : this.longDescription),
        genres: (genres != null ? genres.value : this.genres),
        productionYear: (productionYear != null
            ? productionYear.value
            : this.productionYear),
        productionCountries: (productionCountries != null
            ? productionCountries.value
            : this.productionCountries),
        cast: (cast != null ? cast.value : this.cast),
        crew: (crew != null ? crew.value : this.crew));
  }
}

typedef LanguageCodes = List<String>;

@JsonSerializable(explicitToJson: true)
class TechnicalData {
  TechnicalData({
    required this.duration,
    this.endCreditsTimestamp,
    this.startIntroTime,
    this.endIntroTime,
    required this.resolution,
    required this.languages,
  });

  factory TechnicalData.fromJson(Map<String, dynamic> json) =>
      _$TechnicalDataFromJson(json);

  @JsonKey(name: 'duration', includeIfNull: false)
  final double duration;
  @JsonKey(name: 'endCreditsTimestamp', includeIfNull: false)
  final double? endCreditsTimestamp;
  @JsonKey(name: 'startIntroTime', includeIfNull: false)
  final double? startIntroTime;
  @JsonKey(name: 'endIntroTime', includeIfNull: false)
  final double? endIntroTime;
  @JsonKey(name: 'resolution', includeIfNull: false, defaultValue: '')
  final String resolution;
  @JsonKey(name: 'languages', includeIfNull: false)
  final StreamLanguages languages;
  static const fromJsonFactory = _$TechnicalDataFromJson;
  static const toJsonFactory = _$TechnicalDataToJson;
  Map<String, dynamic> toJson() => _$TechnicalDataToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TechnicalData &&
            (identical(other.duration, duration) ||
                const DeepCollectionEquality()
                    .equals(other.duration, duration)) &&
            (identical(other.endCreditsTimestamp, endCreditsTimestamp) ||
                const DeepCollectionEquality()
                    .equals(other.endCreditsTimestamp, endCreditsTimestamp)) &&
            (identical(other.startIntroTime, startIntroTime) ||
                const DeepCollectionEquality()
                    .equals(other.startIntroTime, startIntroTime)) &&
            (identical(other.endIntroTime, endIntroTime) ||
                const DeepCollectionEquality()
                    .equals(other.endIntroTime, endIntroTime)) &&
            (identical(other.resolution, resolution) ||
                const DeepCollectionEquality()
                    .equals(other.resolution, resolution)) &&
            (identical(other.languages, languages) ||
                const DeepCollectionEquality()
                    .equals(other.languages, languages)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(duration) ^
      const DeepCollectionEquality().hash(endCreditsTimestamp) ^
      const DeepCollectionEquality().hash(startIntroTime) ^
      const DeepCollectionEquality().hash(endIntroTime) ^
      const DeepCollectionEquality().hash(resolution) ^
      const DeepCollectionEquality().hash(languages) ^
      runtimeType.hashCode;
}

extension $TechnicalDataExtension on TechnicalData {
  TechnicalData copyWith(
      {double? duration,
      double? endCreditsTimestamp,
      double? startIntroTime,
      double? endIntroTime,
      String? resolution,
      StreamLanguages? languages}) {
    return TechnicalData(
        duration: duration ?? this.duration,
        endCreditsTimestamp: endCreditsTimestamp ?? this.endCreditsTimestamp,
        startIntroTime: startIntroTime ?? this.startIntroTime,
        endIntroTime: endIntroTime ?? this.endIntroTime,
        resolution: resolution ?? this.resolution,
        languages: languages ?? this.languages);
  }

  TechnicalData copyWithWrapped(
      {Wrapped<double>? duration,
      Wrapped<double?>? endCreditsTimestamp,
      Wrapped<double?>? startIntroTime,
      Wrapped<double?>? endIntroTime,
      Wrapped<String>? resolution,
      Wrapped<StreamLanguages>? languages}) {
    return TechnicalData(
        duration: (duration != null ? duration.value : this.duration),
        endCreditsTimestamp: (endCreditsTimestamp != null
            ? endCreditsTimestamp.value
            : this.endCreditsTimestamp),
        startIntroTime: (startIntroTime != null
            ? startIntroTime.value
            : this.startIntroTime),
        endIntroTime:
            (endIntroTime != null ? endIntroTime.value : this.endIntroTime),
        resolution: (resolution != null ? resolution.value : this.resolution),
        languages: (languages != null ? languages.value : this.languages));
  }
}

@JsonSerializable(explicitToJson: true)
class Person {
  Person({
    required this.id,
    required this.name,
  });

  factory Person.fromJson(Map<String, dynamic> json) => _$PersonFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  static const fromJsonFactory = _$PersonFromJson;
  static const toJsonFactory = _$PersonToJson;
  Map<String, dynamic> toJson() => _$PersonToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Person &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(name) ^
      runtimeType.hashCode;
}

extension $PersonExtension on Person {
  Person copyWith({String? id, String? name}) {
    return Person(id: id ?? this.id, name: name ?? this.name);
  }

  Person copyWithWrapped({Wrapped<String>? id, Wrapped<String>? name}) {
    return Person(
        id: (id != null ? id.value : this.id),
        name: (name != null ? name.value : this.name));
  }
}

@JsonSerializable(explicitToJson: true)
class Catchup {
  Catchup({
    required this.broadcastDate,
    required this.channelName,
    required this.channelId,
  });

  factory Catchup.fromJson(Map<String, dynamic> json) =>
      _$CatchupFromJson(json);

  @JsonKey(name: 'broadcastDate', includeIfNull: false)
  final DateTime broadcastDate;
  @JsonKey(name: 'channelName', includeIfNull: false, defaultValue: '')
  final String channelName;
  @JsonKey(name: 'channelId', includeIfNull: false, defaultValue: '')
  final String channelId;
  static const fromJsonFactory = _$CatchupFromJson;
  static const toJsonFactory = _$CatchupToJson;
  Map<String, dynamic> toJson() => _$CatchupToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Catchup &&
            (identical(other.broadcastDate, broadcastDate) ||
                const DeepCollectionEquality()
                    .equals(other.broadcastDate, broadcastDate)) &&
            (identical(other.channelName, channelName) ||
                const DeepCollectionEquality()
                    .equals(other.channelName, channelName)) &&
            (identical(other.channelId, channelId) ||
                const DeepCollectionEquality()
                    .equals(other.channelId, channelId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(broadcastDate) ^
      const DeepCollectionEquality().hash(channelName) ^
      const DeepCollectionEquality().hash(channelId) ^
      runtimeType.hashCode;
}

extension $CatchupExtension on Catchup {
  Catchup copyWith(
      {DateTime? broadcastDate, String? channelName, String? channelId}) {
    return Catchup(
        broadcastDate: broadcastDate ?? this.broadcastDate,
        channelName: channelName ?? this.channelName,
        channelId: channelId ?? this.channelId);
  }

  Catchup copyWithWrapped(
      {Wrapped<DateTime>? broadcastDate,
      Wrapped<String>? channelName,
      Wrapped<String>? channelId}) {
    return Catchup(
        broadcastDate:
            (broadcastDate != null ? broadcastDate.value : this.broadcastDate),
        channelName:
            (channelName != null ? channelName.value : this.channelName),
        channelId: (channelId != null ? channelId.value : this.channelId));
  }
}

@JsonSerializable(explicitToJson: true)
class Offer {
  Offer();

  factory Offer.fromJson(Map<String, dynamic> json) => _$OfferFromJson(json);

  static const fromJsonFactory = _$OfferFromJson;
  static const toJsonFactory = _$OfferToJson;
  Map<String, dynamic> toJson() => _$OfferToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode => runtimeType.hashCode;
}

@JsonSerializable(explicitToJson: true)
class TvodOffer {
  TvodOffer({
    required this.type,
    required this.crid,
    required this.offerId,
    required this.name,
    required this.price,
    required this.displayPrice,
    required this.currency,
    required this.rentalPeriod,
    this.customerData,
  });

  factory TvodOffer.fromJson(Map<String, dynamic> json) =>
      _$TvodOfferFromJson(json);

  @JsonKey(
    name: 'type',
    includeIfNull: false,
    toJson: tvodOfferTypeToJson,
    fromJson: tvodOfferTypeFromJson,
  )
  final enums.TvodOfferType type;
  @JsonKey(name: 'crid', includeIfNull: false, defaultValue: '')
  final String crid;
  @JsonKey(name: 'offerId', includeIfNull: false, defaultValue: '')
  final String offerId;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'price', includeIfNull: false)
  final double price;
  @JsonKey(name: 'displayPrice', includeIfNull: false, defaultValue: '')
  final String displayPrice;
  @JsonKey(name: 'currency', includeIfNull: false, defaultValue: '')
  final String currency;
  @JsonKey(name: 'rentalPeriod', includeIfNull: false)
  final double rentalPeriod;
  @JsonKey(name: 'customerData', includeIfNull: false)
  final Entitlement? customerData;
  static const fromJsonFactory = _$TvodOfferFromJson;
  static const toJsonFactory = _$TvodOfferToJson;
  Map<String, dynamic> toJson() => _$TvodOfferToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TvodOffer &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.crid, crid) ||
                const DeepCollectionEquality().equals(other.crid, crid)) &&
            (identical(other.offerId, offerId) ||
                const DeepCollectionEquality()
                    .equals(other.offerId, offerId)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.price, price) ||
                const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.displayPrice, displayPrice) ||
                const DeepCollectionEquality()
                    .equals(other.displayPrice, displayPrice)) &&
            (identical(other.currency, currency) ||
                const DeepCollectionEquality()
                    .equals(other.currency, currency)) &&
            (identical(other.rentalPeriod, rentalPeriod) ||
                const DeepCollectionEquality()
                    .equals(other.rentalPeriod, rentalPeriod)) &&
            (identical(other.customerData, customerData) ||
                const DeepCollectionEquality()
                    .equals(other.customerData, customerData)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(crid) ^
      const DeepCollectionEquality().hash(offerId) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(price) ^
      const DeepCollectionEquality().hash(displayPrice) ^
      const DeepCollectionEquality().hash(currency) ^
      const DeepCollectionEquality().hash(rentalPeriod) ^
      const DeepCollectionEquality().hash(customerData) ^
      runtimeType.hashCode;
}

extension $TvodOfferExtension on TvodOffer {
  TvodOffer copyWith(
      {enums.TvodOfferType? type,
      String? crid,
      String? offerId,
      String? name,
      double? price,
      String? displayPrice,
      String? currency,
      double? rentalPeriod,
      Entitlement? customerData}) {
    return TvodOffer(
        type: type ?? this.type,
        crid: crid ?? this.crid,
        offerId: offerId ?? this.offerId,
        name: name ?? this.name,
        price: price ?? this.price,
        displayPrice: displayPrice ?? this.displayPrice,
        currency: currency ?? this.currency,
        rentalPeriod: rentalPeriod ?? this.rentalPeriod,
        customerData: customerData ?? this.customerData);
  }

  TvodOffer copyWithWrapped(
      {Wrapped<enums.TvodOfferType>? type,
      Wrapped<String>? crid,
      Wrapped<String>? offerId,
      Wrapped<String>? name,
      Wrapped<double>? price,
      Wrapped<String>? displayPrice,
      Wrapped<String>? currency,
      Wrapped<double>? rentalPeriod,
      Wrapped<Entitlement?>? customerData}) {
    return TvodOffer(
        type: (type != null ? type.value : this.type),
        crid: (crid != null ? crid.value : this.crid),
        offerId: (offerId != null ? offerId.value : this.offerId),
        name: (name != null ? name.value : this.name),
        price: (price != null ? price.value : this.price),
        displayPrice:
            (displayPrice != null ? displayPrice.value : this.displayPrice),
        currency: (currency != null ? currency.value : this.currency),
        rentalPeriod:
            (rentalPeriod != null ? rentalPeriod.value : this.rentalPeriod),
        customerData:
            (customerData != null ? customerData.value : this.customerData));
  }
}

@JsonSerializable(explicitToJson: true)
class Entitlement {
  Entitlement({
    required this.entitled,
    this.entitlementEnd,
  });

  factory Entitlement.fromJson(Map<String, dynamic> json) =>
      _$EntitlementFromJson(json);

  @JsonKey(name: 'entitled', includeIfNull: false)
  final bool entitled;
  @JsonKey(name: 'entitlementEnd', includeIfNull: false)
  final DateTime? entitlementEnd;
  static const fromJsonFactory = _$EntitlementFromJson;
  static const toJsonFactory = _$EntitlementToJson;
  Map<String, dynamic> toJson() => _$EntitlementToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Entitlement &&
            (identical(other.entitled, entitled) ||
                const DeepCollectionEquality()
                    .equals(other.entitled, entitled)) &&
            (identical(other.entitlementEnd, entitlementEnd) ||
                const DeepCollectionEquality()
                    .equals(other.entitlementEnd, entitlementEnd)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(entitled) ^
      const DeepCollectionEquality().hash(entitlementEnd) ^
      runtimeType.hashCode;
}

extension $EntitlementExtension on Entitlement {
  Entitlement copyWith({bool? entitled, DateTime? entitlementEnd}) {
    return Entitlement(
        entitled: entitled ?? this.entitled,
        entitlementEnd: entitlementEnd ?? this.entitlementEnd);
  }

  Entitlement copyWithWrapped(
      {Wrapped<bool>? entitled, Wrapped<DateTime?>? entitlementEnd}) {
    return Entitlement(
        entitled: (entitled != null ? entitled.value : this.entitled),
        entitlementEnd: (entitlementEnd != null
            ? entitlementEnd.value
            : this.entitlementEnd));
  }
}

@JsonSerializable(explicitToJson: true)
class SvodOffer {
  SvodOffer({
    required this.type,
    this.edsProductId,
    required this.name,
    this.displayPrice,
    this.currency,
    this.imageUrl,
    this.customerData,
  });

  factory SvodOffer.fromJson(Map<String, dynamic> json) =>
      _$SvodOfferFromJson(json);

  @JsonKey(
    name: 'type',
    includeIfNull: false,
    toJson: svodOfferTypeToJson,
    fromJson: svodOfferTypeFromJson,
  )
  final enums.SvodOfferType type;
  @JsonKey(name: 'edsProductId', includeIfNull: false, defaultValue: '')
  final String? edsProductId;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'displayPrice', includeIfNull: false, defaultValue: '')
  final String? displayPrice;
  @JsonKey(name: 'currency', includeIfNull: false, defaultValue: '')
  final String? currency;
  @JsonKey(name: 'imageUrl', includeIfNull: false, defaultValue: '')
  final String? imageUrl;
  @JsonKey(name: 'customerData', includeIfNull: false)
  final Entitlement? customerData;
  static const fromJsonFactory = _$SvodOfferFromJson;
  static const toJsonFactory = _$SvodOfferToJson;
  Map<String, dynamic> toJson() => _$SvodOfferToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SvodOffer &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.edsProductId, edsProductId) ||
                const DeepCollectionEquality()
                    .equals(other.edsProductId, edsProductId)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.displayPrice, displayPrice) ||
                const DeepCollectionEquality()
                    .equals(other.displayPrice, displayPrice)) &&
            (identical(other.currency, currency) ||
                const DeepCollectionEquality()
                    .equals(other.currency, currency)) &&
            (identical(other.imageUrl, imageUrl) ||
                const DeepCollectionEquality()
                    .equals(other.imageUrl, imageUrl)) &&
            (identical(other.customerData, customerData) ||
                const DeepCollectionEquality()
                    .equals(other.customerData, customerData)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(edsProductId) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(displayPrice) ^
      const DeepCollectionEquality().hash(currency) ^
      const DeepCollectionEquality().hash(imageUrl) ^
      const DeepCollectionEquality().hash(customerData) ^
      runtimeType.hashCode;
}

extension $SvodOfferExtension on SvodOffer {
  SvodOffer copyWith(
      {enums.SvodOfferType? type,
      String? edsProductId,
      String? name,
      String? displayPrice,
      String? currency,
      String? imageUrl,
      Entitlement? customerData}) {
    return SvodOffer(
        type: type ?? this.type,
        edsProductId: edsProductId ?? this.edsProductId,
        name: name ?? this.name,
        displayPrice: displayPrice ?? this.displayPrice,
        currency: currency ?? this.currency,
        imageUrl: imageUrl ?? this.imageUrl,
        customerData: customerData ?? this.customerData);
  }

  SvodOffer copyWithWrapped(
      {Wrapped<enums.SvodOfferType>? type,
      Wrapped<String?>? edsProductId,
      Wrapped<String>? name,
      Wrapped<String?>? displayPrice,
      Wrapped<String?>? currency,
      Wrapped<String?>? imageUrl,
      Wrapped<Entitlement?>? customerData}) {
    return SvodOffer(
        type: (type != null ? type.value : this.type),
        edsProductId:
            (edsProductId != null ? edsProductId.value : this.edsProductId),
        name: (name != null ? name.value : this.name),
        displayPrice:
            (displayPrice != null ? displayPrice.value : this.displayPrice),
        currency: (currency != null ? currency.value : this.currency),
        imageUrl: (imageUrl != null ? imageUrl.value : this.imageUrl),
        customerData:
            (customerData != null ? customerData.value : this.customerData));
  }
}

@JsonSerializable(explicitToJson: true)
class Source {
  Source();

  factory Source.fromJson(Map<String, dynamic> json) => _$SourceFromJson(json);

  static const fromJsonFactory = _$SourceFromJson;
  static const toJsonFactory = _$SourceToJson;
  Map<String, dynamic> toJson() => _$SourceToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode => runtimeType.hashCode;
}

@JsonSerializable(explicitToJson: true)
class SourceExt {
  SourceExt();

  factory SourceExt.fromJson(Map<String, dynamic> json) =>
      _$SourceExtFromJson(json);

  static const fromJsonFactory = _$SourceExtFromJson;
  static const toJsonFactory = _$SourceExtToJson;
  Map<String, dynamic> toJson() => _$SourceExtToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode => runtimeType.hashCode;
}

@JsonSerializable(explicitToJson: true)
class SourceVod {
  SourceVod({
    required this.sourceType,
    required this.source,
  });

  factory SourceVod.fromJson(Map<String, dynamic> json) =>
      _$SourceVodFromJson(json);

  @JsonKey(
    name: 'sourceType',
    includeIfNull: false,
    toJson: sourceVodSourceTypeToJson,
    fromJson: sourceVodSourceTypeFromJson,
  )
  final enums.SourceVodSourceType sourceType;
  @JsonKey(name: 'source', includeIfNull: false)
  final VodSource source;
  static const fromJsonFactory = _$SourceVodFromJson;
  static const toJsonFactory = _$SourceVodToJson;
  Map<String, dynamic> toJson() => _$SourceVodToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SourceVod &&
            (identical(other.sourceType, sourceType) ||
                const DeepCollectionEquality()
                    .equals(other.sourceType, sourceType)) &&
            (identical(other.source, source) ||
                const DeepCollectionEquality().equals(other.source, source)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(sourceType) ^
      const DeepCollectionEquality().hash(source) ^
      runtimeType.hashCode;
}

extension $SourceVodExtension on SourceVod {
  SourceVod copyWith(
      {enums.SourceVodSourceType? sourceType, VodSource? source}) {
    return SourceVod(
        sourceType: sourceType ?? this.sourceType,
        source: source ?? this.source);
  }

  SourceVod copyWithWrapped(
      {Wrapped<enums.SourceVodSourceType>? sourceType,
      Wrapped<VodSource>? source}) {
    return SourceVod(
        sourceType: (sourceType != null ? sourceType.value : this.sourceType),
        source: (source != null ? source.value : this.source));
  }
}

@JsonSerializable(explicitToJson: true)
class SourceVodExt {
  SourceVodExt({
    required this.sourceType,
    required this.source,
  });

  factory SourceVodExt.fromJson(Map<String, dynamic> json) =>
      _$SourceVodExtFromJson(json);

  @JsonKey(
    name: 'sourceType',
    includeIfNull: false,
    toJson: sourceVodExtSourceTypeToJson,
    fromJson: sourceVodExtSourceTypeFromJson,
  )
  final enums.SourceVodExtSourceType sourceType;
  @JsonKey(name: 'source', includeIfNull: false)
  final VodSourceExt source;
  static const fromJsonFactory = _$SourceVodExtFromJson;
  static const toJsonFactory = _$SourceVodExtToJson;
  Map<String, dynamic> toJson() => _$SourceVodExtToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SourceVodExt &&
            (identical(other.sourceType, sourceType) ||
                const DeepCollectionEquality()
                    .equals(other.sourceType, sourceType)) &&
            (identical(other.source, source) ||
                const DeepCollectionEquality().equals(other.source, source)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(sourceType) ^
      const DeepCollectionEquality().hash(source) ^
      runtimeType.hashCode;
}

extension $SourceVodExtExtension on SourceVodExt {
  SourceVodExt copyWith(
      {enums.SourceVodExtSourceType? sourceType, VodSourceExt? source}) {
    return SourceVodExt(
        sourceType: sourceType ?? this.sourceType,
        source: source ?? this.source);
  }

  SourceVodExt copyWithWrapped(
      {Wrapped<enums.SourceVodExtSourceType>? sourceType,
      Wrapped<VodSourceExt>? source}) {
    return SourceVodExt(
        sourceType: (sourceType != null ? sourceType.value : this.sourceType),
        source: (source != null ? source.value : this.source));
  }
}

@JsonSerializable(explicitToJson: true)
class SourceOtt {
  SourceOtt({
    required this.sourceType,
    required this.source,
  });

  factory SourceOtt.fromJson(Map<String, dynamic> json) =>
      _$SourceOttFromJson(json);

  @JsonKey(
    name: 'sourceType',
    includeIfNull: false,
    toJson: sourceOttSourceTypeToJson,
    fromJson: sourceOttSourceTypeFromJson,
  )
  final enums.SourceOttSourceType sourceType;
  @JsonKey(name: 'source', includeIfNull: false)
  final OttSource source;
  static const fromJsonFactory = _$SourceOttFromJson;
  static const toJsonFactory = _$SourceOttToJson;
  Map<String, dynamic> toJson() => _$SourceOttToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SourceOtt &&
            (identical(other.sourceType, sourceType) ||
                const DeepCollectionEquality()
                    .equals(other.sourceType, sourceType)) &&
            (identical(other.source, source) ||
                const DeepCollectionEquality().equals(other.source, source)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(sourceType) ^
      const DeepCollectionEquality().hash(source) ^
      runtimeType.hashCode;
}

extension $SourceOttExtension on SourceOtt {
  SourceOtt copyWith(
      {enums.SourceOttSourceType? sourceType, OttSource? source}) {
    return SourceOtt(
        sourceType: sourceType ?? this.sourceType,
        source: source ?? this.source);
  }

  SourceOtt copyWithWrapped(
      {Wrapped<enums.SourceOttSourceType>? sourceType,
      Wrapped<OttSource>? source}) {
    return SourceOtt(
        sourceType: (sourceType != null ? sourceType.value : this.sourceType),
        source: (source != null ? source.value : this.source));
  }
}

@JsonSerializable(explicitToJson: true)
class VodSource {
  VodSource({
    required this.titleId,
    this.contentId,
    required this.brandingProviderId,
    required this.isGoPlayable,
  });

  factory VodSource.fromJson(Map<String, dynamic> json) =>
      _$VodSourceFromJson(json);

  @JsonKey(name: 'titleId', includeIfNull: false, defaultValue: '')
  final String titleId;
  @JsonKey(name: 'contentId', includeIfNull: false, defaultValue: '')
  final String? contentId;
  @JsonKey(name: 'brandingProviderId', includeIfNull: false, defaultValue: '')
  final String brandingProviderId;
  @JsonKey(name: 'isGoPlayable', includeIfNull: false)
  final bool isGoPlayable;
  static const fromJsonFactory = _$VodSourceFromJson;
  static const toJsonFactory = _$VodSourceToJson;
  Map<String, dynamic> toJson() => _$VodSourceToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is VodSource &&
            (identical(other.titleId, titleId) ||
                const DeepCollectionEquality()
                    .equals(other.titleId, titleId)) &&
            (identical(other.contentId, contentId) ||
                const DeepCollectionEquality()
                    .equals(other.contentId, contentId)) &&
            (identical(other.brandingProviderId, brandingProviderId) ||
                const DeepCollectionEquality()
                    .equals(other.brandingProviderId, brandingProviderId)) &&
            (identical(other.isGoPlayable, isGoPlayable) ||
                const DeepCollectionEquality()
                    .equals(other.isGoPlayable, isGoPlayable)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(titleId) ^
      const DeepCollectionEquality().hash(contentId) ^
      const DeepCollectionEquality().hash(brandingProviderId) ^
      const DeepCollectionEquality().hash(isGoPlayable) ^
      runtimeType.hashCode;
}

extension $VodSourceExtension on VodSource {
  VodSource copyWith(
      {String? titleId,
      String? contentId,
      String? brandingProviderId,
      bool? isGoPlayable}) {
    return VodSource(
        titleId: titleId ?? this.titleId,
        contentId: contentId ?? this.contentId,
        brandingProviderId: brandingProviderId ?? this.brandingProviderId,
        isGoPlayable: isGoPlayable ?? this.isGoPlayable);
  }

  VodSource copyWithWrapped(
      {Wrapped<String>? titleId,
      Wrapped<String?>? contentId,
      Wrapped<String>? brandingProviderId,
      Wrapped<bool>? isGoPlayable}) {
    return VodSource(
        titleId: (titleId != null ? titleId.value : this.titleId),
        contentId: (contentId != null ? contentId.value : this.contentId),
        brandingProviderId: (brandingProviderId != null
            ? brandingProviderId.value
            : this.brandingProviderId),
        isGoPlayable:
            (isGoPlayable != null ? isGoPlayable.value : this.isGoPlayable));
  }
}

@JsonSerializable(explicitToJson: true)
class VodSourceExt {
  VodSourceExt({
    required this.technicalData,
    this.catchup,
    this.offers,
    this.titleId,
    this.contentId,
    this.brandingProviderId,
    this.isGoPlayable,
  });

  factory VodSourceExt.fromJson(Map<String, dynamic> json) =>
      _$VodSourceExtFromJson(json);

  @JsonKey(name: 'technicalData', includeIfNull: false)
  final TechnicalData technicalData;
  @JsonKey(name: 'catchup', includeIfNull: false)
  final Catchup? catchup;
  @JsonKey(name: 'offers', includeIfNull: false, defaultValue: <Offer>[])
  final List<Offer>? offers;
  @JsonKey(name: 'titleId', includeIfNull: false, defaultValue: '')
  final String? titleId;
  @JsonKey(name: 'contentId', includeIfNull: false, defaultValue: '')
  final String? contentId;
  @JsonKey(name: 'brandingProviderId', includeIfNull: false, defaultValue: '')
  final String? brandingProviderId;
  @JsonKey(name: 'isGoPlayable', includeIfNull: false)
  final bool? isGoPlayable;
  static const fromJsonFactory = _$VodSourceExtFromJson;
  static const toJsonFactory = _$VodSourceExtToJson;
  Map<String, dynamic> toJson() => _$VodSourceExtToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is VodSourceExt &&
            (identical(other.technicalData, technicalData) ||
                const DeepCollectionEquality()
                    .equals(other.technicalData, technicalData)) &&
            (identical(other.catchup, catchup) ||
                const DeepCollectionEquality()
                    .equals(other.catchup, catchup)) &&
            (identical(other.offers, offers) ||
                const DeepCollectionEquality().equals(other.offers, offers)) &&
            (identical(other.titleId, titleId) ||
                const DeepCollectionEquality()
                    .equals(other.titleId, titleId)) &&
            (identical(other.contentId, contentId) ||
                const DeepCollectionEquality()
                    .equals(other.contentId, contentId)) &&
            (identical(other.brandingProviderId, brandingProviderId) ||
                const DeepCollectionEquality()
                    .equals(other.brandingProviderId, brandingProviderId)) &&
            (identical(other.isGoPlayable, isGoPlayable) ||
                const DeepCollectionEquality()
                    .equals(other.isGoPlayable, isGoPlayable)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(technicalData) ^
      const DeepCollectionEquality().hash(catchup) ^
      const DeepCollectionEquality().hash(offers) ^
      const DeepCollectionEquality().hash(titleId) ^
      const DeepCollectionEquality().hash(contentId) ^
      const DeepCollectionEquality().hash(brandingProviderId) ^
      const DeepCollectionEquality().hash(isGoPlayable) ^
      runtimeType.hashCode;
}

extension $VodSourceExtExtension on VodSourceExt {
  VodSourceExt copyWith(
      {TechnicalData? technicalData,
      Catchup? catchup,
      List<Offer>? offers,
      String? titleId,
      String? contentId,
      String? brandingProviderId,
      bool? isGoPlayable}) {
    return VodSourceExt(
        technicalData: technicalData ?? this.technicalData,
        catchup: catchup ?? this.catchup,
        offers: offers ?? this.offers,
        titleId: titleId ?? this.titleId,
        contentId: contentId ?? this.contentId,
        brandingProviderId: brandingProviderId ?? this.brandingProviderId,
        isGoPlayable: isGoPlayable ?? this.isGoPlayable);
  }

  VodSourceExt copyWithWrapped(
      {Wrapped<TechnicalData>? technicalData,
      Wrapped<Catchup?>? catchup,
      Wrapped<List<Offer>?>? offers,
      Wrapped<String?>? titleId,
      Wrapped<String?>? contentId,
      Wrapped<String?>? brandingProviderId,
      Wrapped<bool?>? isGoPlayable}) {
    return VodSourceExt(
        technicalData:
            (technicalData != null ? technicalData.value : this.technicalData),
        catchup: (catchup != null ? catchup.value : this.catchup),
        offers: (offers != null ? offers.value : this.offers),
        titleId: (titleId != null ? titleId.value : this.titleId),
        contentId: (contentId != null ? contentId.value : this.contentId),
        brandingProviderId: (brandingProviderId != null
            ? brandingProviderId.value
            : this.brandingProviderId),
        isGoPlayable:
            (isGoPlayable != null ? isGoPlayable.value : this.isGoPlayable));
  }
}

@JsonSerializable(explicitToJson: true)
class OttSource {
  OttSource({
    required this.titleId,
    this.displayMinPrice,
    this.currency,
    required this.videoHost,
    required this.videoUrl,
    required this.isEST,
    required this.brandingProviderId,
    required this.isGoPlayable,
  });

  factory OttSource.fromJson(Map<String, dynamic> json) =>
      _$OttSourceFromJson(json);

  @JsonKey(name: 'titleId', includeIfNull: false, defaultValue: '')
  final String titleId;
  @JsonKey(name: 'displayMinPrice', includeIfNull: false, defaultValue: '')
  final String? displayMinPrice;
  @JsonKey(name: 'currency', includeIfNull: false, defaultValue: '')
  final String? currency;
  @JsonKey(name: 'videoHost', includeIfNull: false, defaultValue: '')
  final String videoHost;
  @JsonKey(name: 'videoUrl', includeIfNull: false, defaultValue: '')
  final String videoUrl;
  @JsonKey(name: 'isEST', includeIfNull: false)
  final bool isEST;
  @JsonKey(name: 'brandingProviderId', includeIfNull: false, defaultValue: '')
  final String brandingProviderId;
  @JsonKey(name: 'isGoPlayable', includeIfNull: false)
  final bool isGoPlayable;
  static const fromJsonFactory = _$OttSourceFromJson;
  static const toJsonFactory = _$OttSourceToJson;
  Map<String, dynamic> toJson() => _$OttSourceToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OttSource &&
            (identical(other.titleId, titleId) ||
                const DeepCollectionEquality()
                    .equals(other.titleId, titleId)) &&
            (identical(other.displayMinPrice, displayMinPrice) ||
                const DeepCollectionEquality()
                    .equals(other.displayMinPrice, displayMinPrice)) &&
            (identical(other.currency, currency) ||
                const DeepCollectionEquality()
                    .equals(other.currency, currency)) &&
            (identical(other.videoHost, videoHost) ||
                const DeepCollectionEquality()
                    .equals(other.videoHost, videoHost)) &&
            (identical(other.videoUrl, videoUrl) ||
                const DeepCollectionEquality()
                    .equals(other.videoUrl, videoUrl)) &&
            (identical(other.isEST, isEST) ||
                const DeepCollectionEquality().equals(other.isEST, isEST)) &&
            (identical(other.brandingProviderId, brandingProviderId) ||
                const DeepCollectionEquality()
                    .equals(other.brandingProviderId, brandingProviderId)) &&
            (identical(other.isGoPlayable, isGoPlayable) ||
                const DeepCollectionEquality()
                    .equals(other.isGoPlayable, isGoPlayable)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(titleId) ^
      const DeepCollectionEquality().hash(displayMinPrice) ^
      const DeepCollectionEquality().hash(currency) ^
      const DeepCollectionEquality().hash(videoHost) ^
      const DeepCollectionEquality().hash(videoUrl) ^
      const DeepCollectionEquality().hash(isEST) ^
      const DeepCollectionEquality().hash(brandingProviderId) ^
      const DeepCollectionEquality().hash(isGoPlayable) ^
      runtimeType.hashCode;
}

extension $OttSourceExtension on OttSource {
  OttSource copyWith(
      {String? titleId,
      String? displayMinPrice,
      String? currency,
      String? videoHost,
      String? videoUrl,
      bool? isEST,
      String? brandingProviderId,
      bool? isGoPlayable}) {
    return OttSource(
        titleId: titleId ?? this.titleId,
        displayMinPrice: displayMinPrice ?? this.displayMinPrice,
        currency: currency ?? this.currency,
        videoHost: videoHost ?? this.videoHost,
        videoUrl: videoUrl ?? this.videoUrl,
        isEST: isEST ?? this.isEST,
        brandingProviderId: brandingProviderId ?? this.brandingProviderId,
        isGoPlayable: isGoPlayable ?? this.isGoPlayable);
  }

  OttSource copyWithWrapped(
      {Wrapped<String>? titleId,
      Wrapped<String?>? displayMinPrice,
      Wrapped<String?>? currency,
      Wrapped<String>? videoHost,
      Wrapped<String>? videoUrl,
      Wrapped<bool>? isEST,
      Wrapped<String>? brandingProviderId,
      Wrapped<bool>? isGoPlayable}) {
    return OttSource(
        titleId: (titleId != null ? titleId.value : this.titleId),
        displayMinPrice: (displayMinPrice != null
            ? displayMinPrice.value
            : this.displayMinPrice),
        currency: (currency != null ? currency.value : this.currency),
        videoHost: (videoHost != null ? videoHost.value : this.videoHost),
        videoUrl: (videoUrl != null ? videoUrl.value : this.videoUrl),
        isEST: (isEST != null ? isEST.value : this.isEST),
        brandingProviderId: (brandingProviderId != null
            ? brandingProviderId.value
            : this.brandingProviderId),
        isGoPlayable:
            (isGoPlayable != null ? isGoPlayable.value : this.isGoPlayable));
  }
}

@JsonSerializable(explicitToJson: true)
class InfoData {
  InfoData({
    required this.isAdult,
    required this.isGoPlayable,
    this.ageRating,
    required this.brandingProviderId,
  });

  factory InfoData.fromJson(Map<String, dynamic> json) =>
      _$InfoDataFromJson(json);

  @JsonKey(name: 'isAdult', includeIfNull: false)
  final bool isAdult;
  @JsonKey(name: 'isGoPlayable', includeIfNull: false)
  final bool isGoPlayable;
  @JsonKey(name: 'ageRating', includeIfNull: false)
  final double? ageRating;
  @JsonKey(name: 'brandingProviderId', includeIfNull: false, defaultValue: '')
  final String brandingProviderId;
  static const fromJsonFactory = _$InfoDataFromJson;
  static const toJsonFactory = _$InfoDataToJson;
  Map<String, dynamic> toJson() => _$InfoDataToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is InfoData &&
            (identical(other.isAdult, isAdult) ||
                const DeepCollectionEquality()
                    .equals(other.isAdult, isAdult)) &&
            (identical(other.isGoPlayable, isGoPlayable) ||
                const DeepCollectionEquality()
                    .equals(other.isGoPlayable, isGoPlayable)) &&
            (identical(other.ageRating, ageRating) ||
                const DeepCollectionEquality()
                    .equals(other.ageRating, ageRating)) &&
            (identical(other.brandingProviderId, brandingProviderId) ||
                const DeepCollectionEquality()
                    .equals(other.brandingProviderId, brandingProviderId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(isAdult) ^
      const DeepCollectionEquality().hash(isGoPlayable) ^
      const DeepCollectionEquality().hash(ageRating) ^
      const DeepCollectionEquality().hash(brandingProviderId) ^
      runtimeType.hashCode;
}

extension $InfoDataExtension on InfoData {
  InfoData copyWith(
      {bool? isAdult,
      bool? isGoPlayable,
      double? ageRating,
      String? brandingProviderId}) {
    return InfoData(
        isAdult: isAdult ?? this.isAdult,
        isGoPlayable: isGoPlayable ?? this.isGoPlayable,
        ageRating: ageRating ?? this.ageRating,
        brandingProviderId: brandingProviderId ?? this.brandingProviderId);
  }

  InfoData copyWithWrapped(
      {Wrapped<bool>? isAdult,
      Wrapped<bool>? isGoPlayable,
      Wrapped<double?>? ageRating,
      Wrapped<String>? brandingProviderId}) {
    return InfoData(
        isAdult: (isAdult != null ? isAdult.value : this.isAdult),
        isGoPlayable:
            (isGoPlayable != null ? isGoPlayable.value : this.isGoPlayable),
        ageRating: (ageRating != null ? ageRating.value : this.ageRating),
        brandingProviderId: (brandingProviderId != null
            ? brandingProviderId.value
            : this.brandingProviderId));
  }
}

@JsonSerializable(explicitToJson: true)
class TitleData {
  TitleData({
    required this.id,
    required this.name,
  });

  factory TitleData.fromJson(Map<String, dynamic> json) =>
      _$TitleDataFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  static const fromJsonFactory = _$TitleDataFromJson;
  static const toJsonFactory = _$TitleDataToJson;
  Map<String, dynamic> toJson() => _$TitleDataToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TitleData &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(name) ^
      runtimeType.hashCode;
}

extension $TitleDataExtension on TitleData {
  TitleData copyWith({String? id, String? name}) {
    return TitleData(id: id ?? this.id, name: name ?? this.name);
  }

  TitleData copyWithWrapped({Wrapped<String>? id, Wrapped<String>? name}) {
    return TitleData(
        id: (id != null ? id.value : this.id),
        name: (name != null ? name.value : this.name));
  }
}

@JsonSerializable(explicitToJson: true)
class EpisodeData {
  EpisodeData({
    required this.id,
    this.name,
    required this.number,
  });

  factory EpisodeData.fromJson(Map<String, dynamic> json) =>
      _$EpisodeDataFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'number', includeIfNull: false)
  final double number;
  static const fromJsonFactory = _$EpisodeDataFromJson;
  static const toJsonFactory = _$EpisodeDataToJson;
  Map<String, dynamic> toJson() => _$EpisodeDataToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EpisodeData &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.number, number) ||
                const DeepCollectionEquality().equals(other.number, number)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(number) ^
      runtimeType.hashCode;
}

extension $EpisodeDataExtension on EpisodeData {
  EpisodeData copyWith({String? id, String? name, double? number}) {
    return EpisodeData(
        id: id ?? this.id,
        name: name ?? this.name,
        number: number ?? this.number);
  }

  EpisodeData copyWithWrapped(
      {Wrapped<String>? id, Wrapped<String?>? name, Wrapped<double>? number}) {
    return EpisodeData(
        id: (id != null ? id.value : this.id),
        name: (name != null ? name.value : this.name),
        number: (number != null ? number.value : this.number));
  }
}

@JsonSerializable(explicitToJson: true)
class SeasonData {
  SeasonData({
    required this.id,
    required this.number,
  });

  factory SeasonData.fromJson(Map<String, dynamic> json) =>
      _$SeasonDataFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'number', includeIfNull: false)
  final double number;
  static const fromJsonFactory = _$SeasonDataFromJson;
  static const toJsonFactory = _$SeasonDataToJson;
  Map<String, dynamic> toJson() => _$SeasonDataToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SeasonData &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.number, number) ||
                const DeepCollectionEquality().equals(other.number, number)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(number) ^
      runtimeType.hashCode;
}

extension $SeasonDataExtension on SeasonData {
  SeasonData copyWith({String? id, double? number}) {
    return SeasonData(id: id ?? this.id, number: number ?? this.number);
  }

  SeasonData copyWithWrapped({Wrapped<String>? id, Wrapped<double>? number}) {
    return SeasonData(
        id: (id != null ? id.value : this.id),
        number: (number != null ? number.value : this.number));
  }
}

@JsonSerializable(explicitToJson: true)
class ShowData {
  ShowData({
    required this.isBoxset,
    required this.id,
    required this.name,
  });

  factory ShowData.fromJson(Map<String, dynamic> json) =>
      _$ShowDataFromJson(json);

  @JsonKey(name: 'isBoxset', includeIfNull: false)
  final bool isBoxset;
  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  static const fromJsonFactory = _$ShowDataFromJson;
  static const toJsonFactory = _$ShowDataToJson;
  Map<String, dynamic> toJson() => _$ShowDataToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ShowData &&
            (identical(other.isBoxset, isBoxset) ||
                const DeepCollectionEquality()
                    .equals(other.isBoxset, isBoxset)) &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(isBoxset) ^
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(name) ^
      runtimeType.hashCode;
}

extension $ShowDataExtension on ShowData {
  ShowData copyWith({bool? isBoxset, String? id, String? name}) {
    return ShowData(
        isBoxset: isBoxset ?? this.isBoxset,
        id: id ?? this.id,
        name: name ?? this.name);
  }

  ShowData copyWithWrapped(
      {Wrapped<bool>? isBoxset, Wrapped<String>? id, Wrapped<String>? name}) {
    return ShowData(
        isBoxset: (isBoxset != null ? isBoxset.value : this.isBoxset),
        id: (id != null ? id.value : this.id),
        name: (name != null ? name.value : this.name));
  }
}

@JsonSerializable(explicitToJson: true)
class Error {
  Error({
    this.error,
  });

  factory Error.fromJson(Map<String, dynamic> json) => _$ErrorFromJson(json);

  @JsonKey(name: 'error', includeIfNull: false)
  final Error$Error? error;
  static const fromJsonFactory = _$ErrorFromJson;
  static const toJsonFactory = _$ErrorToJson;
  Map<String, dynamic> toJson() => _$ErrorToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Error &&
            (identical(other.error, error) ||
                const DeepCollectionEquality().equals(other.error, error)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(error) ^ runtimeType.hashCode;
}

extension $ErrorExtension on Error {
  Error copyWith({Error$Error? error}) {
    return Error(error: error ?? this.error);
  }

  Error copyWithWrapped({Wrapped<Error$Error?>? error}) {
    return Error(error: (error != null ? error.value : this.error));
  }
}

@JsonSerializable(explicitToJson: true)
class NoContent {
  NoContent({
    this.error,
  });

  factory NoContent.fromJson(Map<String, dynamic> json) =>
      _$NoContentFromJson(json);

  @JsonKey(name: 'error', includeIfNull: false)
  final NoContent$Error? error;
  static const fromJsonFactory = _$NoContentFromJson;
  static const toJsonFactory = _$NoContentToJson;
  Map<String, dynamic> toJson() => _$NoContentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NoContent &&
            (identical(other.error, error) ||
                const DeepCollectionEquality().equals(other.error, error)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(error) ^ runtimeType.hashCode;
}

extension $NoContentExtension on NoContent {
  NoContent copyWith({NoContent$Error? error}) {
    return NoContent(error: error ?? this.error);
  }

  NoContent copyWithWrapped({Wrapped<NoContent$Error?>? error}) {
    return NoContent(error: (error != null ? error.value : this.error));
  }
}

@JsonSerializable(explicitToJson: true)
class NotFound {
  NotFound({
    this.error,
  });

  factory NotFound.fromJson(Map<String, dynamic> json) =>
      _$NotFoundFromJson(json);

  @JsonKey(name: 'error', includeIfNull: false)
  final NotFound$Error? error;
  static const fromJsonFactory = _$NotFoundFromJson;
  static const toJsonFactory = _$NotFoundToJson;
  Map<String, dynamic> toJson() => _$NotFoundToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NotFound &&
            (identical(other.error, error) ||
                const DeepCollectionEquality().equals(other.error, error)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(error) ^ runtimeType.hashCode;
}

extension $NotFoundExtension on NotFound {
  NotFound copyWith({NotFound$Error? error}) {
    return NotFound(error: error ?? this.error);
  }

  NotFound copyWithWrapped({Wrapped<NotFound$Error?>? error}) {
    return NotFound(error: (error != null ? error.value : this.error));
  }
}

@JsonSerializable(explicitToJson: true)
class GatewayError {
  GatewayError({
    this.error,
  });

  factory GatewayError.fromJson(Map<String, dynamic> json) =>
      _$GatewayErrorFromJson(json);

  @JsonKey(name: 'error', includeIfNull: false)
  final GatewayError$Error? error;
  static const fromJsonFactory = _$GatewayErrorFromJson;
  static const toJsonFactory = _$GatewayErrorToJson;
  Map<String, dynamic> toJson() => _$GatewayErrorToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is GatewayError &&
            (identical(other.error, error) ||
                const DeepCollectionEquality().equals(other.error, error)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(error) ^ runtimeType.hashCode;
}

extension $GatewayErrorExtension on GatewayError {
  GatewayError copyWith({GatewayError$Error? error}) {
    return GatewayError(error: error ?? this.error);
  }

  GatewayError copyWithWrapped({Wrapped<GatewayError$Error?>? error}) {
    return GatewayError(error: (error != null ? error.value : this.error));
  }
}

@JsonSerializable(explicitToJson: true)
class StreamLanguages {
  StreamLanguages({
    required this.audio,
    required this.audioDescription,
    required this.subtitle,
    required this.sign,
  });

  factory StreamLanguages.fromJson(Map<String, dynamic> json) =>
      _$StreamLanguagesFromJson(json);

  @JsonKey(name: 'audio', includeIfNull: false)
  final List<String> audio;
  @JsonKey(name: 'audioDescription', includeIfNull: false)
  final List<String> audioDescription;
  @JsonKey(name: 'subtitle', includeIfNull: false)
  final List<String> subtitle;
  @JsonKey(name: 'sign', includeIfNull: false)
  final List<String> sign;
  static const fromJsonFactory = _$StreamLanguagesFromJson;
  static const toJsonFactory = _$StreamLanguagesToJson;
  Map<String, dynamic> toJson() => _$StreamLanguagesToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StreamLanguages &&
            (identical(other.audio, audio) ||
                const DeepCollectionEquality().equals(other.audio, audio)) &&
            (identical(other.audioDescription, audioDescription) ||
                const DeepCollectionEquality()
                    .equals(other.audioDescription, audioDescription)) &&
            (identical(other.subtitle, subtitle) ||
                const DeepCollectionEquality()
                    .equals(other.subtitle, subtitle)) &&
            (identical(other.sign, sign) ||
                const DeepCollectionEquality().equals(other.sign, sign)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(audio) ^
      const DeepCollectionEquality().hash(audioDescription) ^
      const DeepCollectionEquality().hash(subtitle) ^
      const DeepCollectionEquality().hash(sign) ^
      runtimeType.hashCode;
}

extension $StreamLanguagesExtension on StreamLanguages {
  StreamLanguages copyWith(
      {List<String>? audio,
      List<String>? audioDescription,
      List<String>? subtitle,
      List<String>? sign}) {
    return StreamLanguages(
        audio: audio ?? this.audio,
        audioDescription: audioDescription ?? this.audioDescription,
        subtitle: subtitle ?? this.subtitle,
        sign: sign ?? this.sign);
  }

  StreamLanguages copyWithWrapped(
      {Wrapped<List<String>>? audio,
      Wrapped<List<String>>? audioDescription,
      Wrapped<List<String>>? subtitle,
      Wrapped<List<String>>? sign}) {
    return StreamLanguages(
        audio: (audio != null ? audio.value : this.audio),
        audioDescription: (audioDescription != null
            ? audioDescription.value
            : this.audioDescription),
        subtitle: (subtitle != null ? subtitle.value : this.subtitle),
        sign: (sign != null ? sign.value : this.sign));
  }
}

@JsonSerializable(explicitToJson: true)
class Warnings {
  Warnings({
    this.retryRequired,
    this.reason,
  });

  factory Warnings.fromJson(Map<String, dynamic> json) =>
      _$WarningsFromJson(json);

  @JsonKey(name: 'retryRequired', includeIfNull: false)
  final bool? retryRequired;
  @JsonKey(name: 'reason', includeIfNull: false, defaultValue: <Reason>[])
  final List<Reason>? reason;
  static const fromJsonFactory = _$WarningsFromJson;
  static const toJsonFactory = _$WarningsToJson;
  Map<String, dynamic> toJson() => _$WarningsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Warnings &&
            (identical(other.retryRequired, retryRequired) ||
                const DeepCollectionEquality()
                    .equals(other.retryRequired, retryRequired)) &&
            (identical(other.reason, reason) ||
                const DeepCollectionEquality().equals(other.reason, reason)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(retryRequired) ^
      const DeepCollectionEquality().hash(reason) ^
      runtimeType.hashCode;
}

extension $WarningsExtension on Warnings {
  Warnings copyWith({bool? retryRequired, List<Reason>? reason}) {
    return Warnings(
        retryRequired: retryRequired ?? this.retryRequired,
        reason: reason ?? this.reason);
  }

  Warnings copyWithWrapped(
      {Wrapped<bool?>? retryRequired, Wrapped<List<Reason>?>? reason}) {
    return Warnings(
        retryRequired:
            (retryRequired != null ? retryRequired.value : this.retryRequired),
        reason: (reason != null ? reason.value : this.reason));
  }
}

@JsonSerializable(explicitToJson: true)
class Reason {
  Reason({
    this.type,
    required this.message,
  });

  factory Reason.fromJson(Map<String, dynamic> json) => _$ReasonFromJson(json);

  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String message;
  static const fromJsonFactory = _$ReasonFromJson;
  static const toJsonFactory = _$ReasonToJson;
  Map<String, dynamic> toJson() => _$ReasonToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Reason &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality().equals(other.message, message)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(message) ^
      runtimeType.hashCode;
}

extension $ReasonExtension on Reason {
  Reason copyWith({String? type, String? message}) {
    return Reason(type: type ?? this.type, message: message ?? this.message);
  }

  Reason copyWithWrapped({Wrapped<String?>? type, Wrapped<String>? message}) {
    return Reason(
        type: (type != null ? type.value : this.type),
        message: (message != null ? message.value : this.message));
  }
}

@JsonSerializable(explicitToJson: true)
class Error$Error {
  Error$Error({
    this.httpStatusCode,
    this.statusCode,
    this.message,
    this.correlationId,
  });

  factory Error$Error.fromJson(Map<String, dynamic> json) =>
      _$Error$ErrorFromJson(json);

  @JsonKey(name: 'httpStatusCode', includeIfNull: false)
  final int? httpStatusCode;
  @JsonKey(name: 'statusCode', includeIfNull: false)
  final int? statusCode;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'correlationId', includeIfNull: false, defaultValue: '')
  final String? correlationId;
  static const fromJsonFactory = _$Error$ErrorFromJson;
  static const toJsonFactory = _$Error$ErrorToJson;
  Map<String, dynamic> toJson() => _$Error$ErrorToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Error$Error &&
            (identical(other.httpStatusCode, httpStatusCode) ||
                const DeepCollectionEquality()
                    .equals(other.httpStatusCode, httpStatusCode)) &&
            (identical(other.statusCode, statusCode) ||
                const DeepCollectionEquality()
                    .equals(other.statusCode, statusCode)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.correlationId, correlationId) ||
                const DeepCollectionEquality()
                    .equals(other.correlationId, correlationId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(httpStatusCode) ^
      const DeepCollectionEquality().hash(statusCode) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(correlationId) ^
      runtimeType.hashCode;
}

extension $Error$ErrorExtension on Error$Error {
  Error$Error copyWith(
      {int? httpStatusCode,
      int? statusCode,
      String? message,
      String? correlationId}) {
    return Error$Error(
        httpStatusCode: httpStatusCode ?? this.httpStatusCode,
        statusCode: statusCode ?? this.statusCode,
        message: message ?? this.message,
        correlationId: correlationId ?? this.correlationId);
  }

  Error$Error copyWithWrapped(
      {Wrapped<int?>? httpStatusCode,
      Wrapped<int?>? statusCode,
      Wrapped<String?>? message,
      Wrapped<String?>? correlationId}) {
    return Error$Error(
        httpStatusCode: (httpStatusCode != null
            ? httpStatusCode.value
            : this.httpStatusCode),
        statusCode: (statusCode != null ? statusCode.value : this.statusCode),
        message: (message != null ? message.value : this.message),
        correlationId:
            (correlationId != null ? correlationId.value : this.correlationId));
  }
}

@JsonSerializable(explicitToJson: true)
class NoContent$Error {
  NoContent$Error({
    this.httpStatusCode,
    this.statusCode,
    this.message,
    this.correlationId,
  });

  factory NoContent$Error.fromJson(Map<String, dynamic> json) =>
      _$NoContent$ErrorFromJson(json);

  @JsonKey(name: 'httpStatusCode', includeIfNull: false)
  final int? httpStatusCode;
  @JsonKey(name: 'statusCode', includeIfNull: false)
  final int? statusCode;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'correlationId', includeIfNull: false, defaultValue: '')
  final String? correlationId;
  static const fromJsonFactory = _$NoContent$ErrorFromJson;
  static const toJsonFactory = _$NoContent$ErrorToJson;
  Map<String, dynamic> toJson() => _$NoContent$ErrorToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NoContent$Error &&
            (identical(other.httpStatusCode, httpStatusCode) ||
                const DeepCollectionEquality()
                    .equals(other.httpStatusCode, httpStatusCode)) &&
            (identical(other.statusCode, statusCode) ||
                const DeepCollectionEquality()
                    .equals(other.statusCode, statusCode)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.correlationId, correlationId) ||
                const DeepCollectionEquality()
                    .equals(other.correlationId, correlationId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(httpStatusCode) ^
      const DeepCollectionEquality().hash(statusCode) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(correlationId) ^
      runtimeType.hashCode;
}

extension $NoContent$ErrorExtension on NoContent$Error {
  NoContent$Error copyWith(
      {int? httpStatusCode,
      int? statusCode,
      String? message,
      String? correlationId}) {
    return NoContent$Error(
        httpStatusCode: httpStatusCode ?? this.httpStatusCode,
        statusCode: statusCode ?? this.statusCode,
        message: message ?? this.message,
        correlationId: correlationId ?? this.correlationId);
  }

  NoContent$Error copyWithWrapped(
      {Wrapped<int?>? httpStatusCode,
      Wrapped<int?>? statusCode,
      Wrapped<String?>? message,
      Wrapped<String?>? correlationId}) {
    return NoContent$Error(
        httpStatusCode: (httpStatusCode != null
            ? httpStatusCode.value
            : this.httpStatusCode),
        statusCode: (statusCode != null ? statusCode.value : this.statusCode),
        message: (message != null ? message.value : this.message),
        correlationId:
            (correlationId != null ? correlationId.value : this.correlationId));
  }
}

@JsonSerializable(explicitToJson: true)
class NotFound$Error {
  NotFound$Error({
    this.httpStatusCode,
    this.statusCode,
    this.message,
    this.correlationId,
  });

  factory NotFound$Error.fromJson(Map<String, dynamic> json) =>
      _$NotFound$ErrorFromJson(json);

  @JsonKey(name: 'httpStatusCode', includeIfNull: false)
  final int? httpStatusCode;
  @JsonKey(name: 'statusCode', includeIfNull: false)
  final int? statusCode;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'correlationId', includeIfNull: false, defaultValue: '')
  final String? correlationId;
  static const fromJsonFactory = _$NotFound$ErrorFromJson;
  static const toJsonFactory = _$NotFound$ErrorToJson;
  Map<String, dynamic> toJson() => _$NotFound$ErrorToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NotFound$Error &&
            (identical(other.httpStatusCode, httpStatusCode) ||
                const DeepCollectionEquality()
                    .equals(other.httpStatusCode, httpStatusCode)) &&
            (identical(other.statusCode, statusCode) ||
                const DeepCollectionEquality()
                    .equals(other.statusCode, statusCode)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.correlationId, correlationId) ||
                const DeepCollectionEquality()
                    .equals(other.correlationId, correlationId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(httpStatusCode) ^
      const DeepCollectionEquality().hash(statusCode) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(correlationId) ^
      runtimeType.hashCode;
}

extension $NotFound$ErrorExtension on NotFound$Error {
  NotFound$Error copyWith(
      {int? httpStatusCode,
      int? statusCode,
      String? message,
      String? correlationId}) {
    return NotFound$Error(
        httpStatusCode: httpStatusCode ?? this.httpStatusCode,
        statusCode: statusCode ?? this.statusCode,
        message: message ?? this.message,
        correlationId: correlationId ?? this.correlationId);
  }

  NotFound$Error copyWithWrapped(
      {Wrapped<int?>? httpStatusCode,
      Wrapped<int?>? statusCode,
      Wrapped<String?>? message,
      Wrapped<String?>? correlationId}) {
    return NotFound$Error(
        httpStatusCode: (httpStatusCode != null
            ? httpStatusCode.value
            : this.httpStatusCode),
        statusCode: (statusCode != null ? statusCode.value : this.statusCode),
        message: (message != null ? message.value : this.message),
        correlationId:
            (correlationId != null ? correlationId.value : this.correlationId));
  }
}

@JsonSerializable(explicitToJson: true)
class GatewayError$Error {
  GatewayError$Error({
    this.httpStatusCode,
    this.statusCode,
    this.message,
    this.correlationId,
  });

  factory GatewayError$Error.fromJson(Map<String, dynamic> json) =>
      _$GatewayError$ErrorFromJson(json);

  @JsonKey(name: 'httpStatusCode', includeIfNull: false)
  final int? httpStatusCode;
  @JsonKey(name: 'statusCode', includeIfNull: false)
  final int? statusCode;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'correlationId', includeIfNull: false, defaultValue: '')
  final String? correlationId;
  static const fromJsonFactory = _$GatewayError$ErrorFromJson;
  static const toJsonFactory = _$GatewayError$ErrorToJson;
  Map<String, dynamic> toJson() => _$GatewayError$ErrorToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is GatewayError$Error &&
            (identical(other.httpStatusCode, httpStatusCode) ||
                const DeepCollectionEquality()
                    .equals(other.httpStatusCode, httpStatusCode)) &&
            (identical(other.statusCode, statusCode) ||
                const DeepCollectionEquality()
                    .equals(other.statusCode, statusCode)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.correlationId, correlationId) ||
                const DeepCollectionEquality()
                    .equals(other.correlationId, correlationId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(httpStatusCode) ^
      const DeepCollectionEquality().hash(statusCode) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(correlationId) ^
      runtimeType.hashCode;
}

extension $GatewayError$ErrorExtension on GatewayError$Error {
  GatewayError$Error copyWith(
      {int? httpStatusCode,
      int? statusCode,
      String? message,
      String? correlationId}) {
    return GatewayError$Error(
        httpStatusCode: httpStatusCode ?? this.httpStatusCode,
        statusCode: statusCode ?? this.statusCode,
        message: message ?? this.message,
        correlationId: correlationId ?? this.correlationId);
  }

  GatewayError$Error copyWithWrapped(
      {Wrapped<int?>? httpStatusCode,
      Wrapped<int?>? statusCode,
      Wrapped<String?>? message,
      Wrapped<String?>? correlationId}) {
    return GatewayError$Error(
        httpStatusCode: (httpStatusCode != null
            ? httpStatusCode.value
            : this.httpStatusCode),
        statusCode: (statusCode != null ? statusCode.value : this.statusCode),
        message: (message != null ? message.value : this.message),
        correlationId:
            (correlationId != null ? correlationId.value : this.correlationId));
  }
}

String? titleProgramDetailsProgramTypeToJson(
    enums.TitleProgramDetailsProgramType? titleProgramDetailsProgramType) {
  return enums
      .$TitleProgramDetailsProgramTypeMap[titleProgramDetailsProgramType];
}

enums.TitleProgramDetailsProgramType titleProgramDetailsProgramTypeFromJson(
  Object? titleProgramDetailsProgramType, [
  enums.TitleProgramDetailsProgramType? defaultValue,
]) {
  if (titleProgramDetailsProgramType is String) {
    return enums.$TitleProgramDetailsProgramTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                titleProgramDetailsProgramType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.TitleProgramDetailsProgramType.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$TitleProgramDetailsProgramTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.TitleProgramDetailsProgramType.swaggerGeneratedUnknown;
}

List<String> titleProgramDetailsProgramTypeListToJson(
    List<enums.TitleProgramDetailsProgramType>?
        titleProgramDetailsProgramType) {
  if (titleProgramDetailsProgramType == null) {
    return [];
  }

  return titleProgramDetailsProgramType
      .map((e) => enums.$TitleProgramDetailsProgramTypeMap[e]!)
      .toList();
}

List<enums.TitleProgramDetailsProgramType>
    titleProgramDetailsProgramTypeListFromJson(
  List? titleProgramDetailsProgramType, [
  List<enums.TitleProgramDetailsProgramType>? defaultValue,
]) {
  if (titleProgramDetailsProgramType == null) {
    return defaultValue ?? [];
  }

  return titleProgramDetailsProgramType
      .map((e) => titleProgramDetailsProgramTypeFromJson(e.toString()))
      .toList();
}

List<enums.TitleProgramDetailsProgramType>?
    titleProgramDetailsProgramTypeNullableListFromJson(
  List? titleProgramDetailsProgramType, [
  List<enums.TitleProgramDetailsProgramType>? defaultValue,
]) {
  if (titleProgramDetailsProgramType == null) {
    return defaultValue;
  }

  return titleProgramDetailsProgramType
      .map((e) => titleProgramDetailsProgramTypeFromJson(e.toString()))
      .toList();
}

String? episodeProgramDetailsProgramTypeToJson(
    enums.EpisodeProgramDetailsProgramType? episodeProgramDetailsProgramType) {
  return enums
      .$EpisodeProgramDetailsProgramTypeMap[episodeProgramDetailsProgramType];
}

enums.EpisodeProgramDetailsProgramType episodeProgramDetailsProgramTypeFromJson(
  Object? episodeProgramDetailsProgramType, [
  enums.EpisodeProgramDetailsProgramType? defaultValue,
]) {
  if (episodeProgramDetailsProgramType is String) {
    return enums.$EpisodeProgramDetailsProgramTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                episodeProgramDetailsProgramType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.EpisodeProgramDetailsProgramType.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$EpisodeProgramDetailsProgramTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.EpisodeProgramDetailsProgramType.swaggerGeneratedUnknown;
}

List<String> episodeProgramDetailsProgramTypeListToJson(
    List<enums.EpisodeProgramDetailsProgramType>?
        episodeProgramDetailsProgramType) {
  if (episodeProgramDetailsProgramType == null) {
    return [];
  }

  return episodeProgramDetailsProgramType
      .map((e) => enums.$EpisodeProgramDetailsProgramTypeMap[e]!)
      .toList();
}

List<enums.EpisodeProgramDetailsProgramType>
    episodeProgramDetailsProgramTypeListFromJson(
  List? episodeProgramDetailsProgramType, [
  List<enums.EpisodeProgramDetailsProgramType>? defaultValue,
]) {
  if (episodeProgramDetailsProgramType == null) {
    return defaultValue ?? [];
  }

  return episodeProgramDetailsProgramType
      .map((e) => episodeProgramDetailsProgramTypeFromJson(e.toString()))
      .toList();
}

List<enums.EpisodeProgramDetailsProgramType>?
    episodeProgramDetailsProgramTypeNullableListFromJson(
  List? episodeProgramDetailsProgramType, [
  List<enums.EpisodeProgramDetailsProgramType>? defaultValue,
]) {
  if (episodeProgramDetailsProgramType == null) {
    return defaultValue;
  }

  return episodeProgramDetailsProgramType
      .map((e) => episodeProgramDetailsProgramTypeFromJson(e.toString()))
      .toList();
}

String? programTypeTitleProgramTypeToJson(
    enums.ProgramTypeTitleProgramType? programTypeTitleProgramType) {
  return enums.$ProgramTypeTitleProgramTypeMap[programTypeTitleProgramType];
}

enums.ProgramTypeTitleProgramType programTypeTitleProgramTypeFromJson(
  Object? programTypeTitleProgramType, [
  enums.ProgramTypeTitleProgramType? defaultValue,
]) {
  if (programTypeTitleProgramType is String) {
    return enums.$ProgramTypeTitleProgramTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                programTypeTitleProgramType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ProgramTypeTitleProgramType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ProgramTypeTitleProgramTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ProgramTypeTitleProgramType.swaggerGeneratedUnknown;
}

List<String> programTypeTitleProgramTypeListToJson(
    List<enums.ProgramTypeTitleProgramType>? programTypeTitleProgramType) {
  if (programTypeTitleProgramType == null) {
    return [];
  }

  return programTypeTitleProgramType
      .map((e) => enums.$ProgramTypeTitleProgramTypeMap[e]!)
      .toList();
}

List<enums.ProgramTypeTitleProgramType> programTypeTitleProgramTypeListFromJson(
  List? programTypeTitleProgramType, [
  List<enums.ProgramTypeTitleProgramType>? defaultValue,
]) {
  if (programTypeTitleProgramType == null) {
    return defaultValue ?? [];
  }

  return programTypeTitleProgramType
      .map((e) => programTypeTitleProgramTypeFromJson(e.toString()))
      .toList();
}

List<enums.ProgramTypeTitleProgramType>?
    programTypeTitleProgramTypeNullableListFromJson(
  List? programTypeTitleProgramType, [
  List<enums.ProgramTypeTitleProgramType>? defaultValue,
]) {
  if (programTypeTitleProgramType == null) {
    return defaultValue;
  }

  return programTypeTitleProgramType
      .map((e) => programTypeTitleProgramTypeFromJson(e.toString()))
      .toList();
}

String? programTypeEpisodeProgramTypeToJson(
    enums.ProgramTypeEpisodeProgramType? programTypeEpisodeProgramType) {
  return enums.$ProgramTypeEpisodeProgramTypeMap[programTypeEpisodeProgramType];
}

enums.ProgramTypeEpisodeProgramType programTypeEpisodeProgramTypeFromJson(
  Object? programTypeEpisodeProgramType, [
  enums.ProgramTypeEpisodeProgramType? defaultValue,
]) {
  if (programTypeEpisodeProgramType is String) {
    return enums.$ProgramTypeEpisodeProgramTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                programTypeEpisodeProgramType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ProgramTypeEpisodeProgramType.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ProgramTypeEpisodeProgramTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ProgramTypeEpisodeProgramType.swaggerGeneratedUnknown;
}

List<String> programTypeEpisodeProgramTypeListToJson(
    List<enums.ProgramTypeEpisodeProgramType>? programTypeEpisodeProgramType) {
  if (programTypeEpisodeProgramType == null) {
    return [];
  }

  return programTypeEpisodeProgramType
      .map((e) => enums.$ProgramTypeEpisodeProgramTypeMap[e]!)
      .toList();
}

List<enums.ProgramTypeEpisodeProgramType>
    programTypeEpisodeProgramTypeListFromJson(
  List? programTypeEpisodeProgramType, [
  List<enums.ProgramTypeEpisodeProgramType>? defaultValue,
]) {
  if (programTypeEpisodeProgramType == null) {
    return defaultValue ?? [];
  }

  return programTypeEpisodeProgramType
      .map((e) => programTypeEpisodeProgramTypeFromJson(e.toString()))
      .toList();
}

List<enums.ProgramTypeEpisodeProgramType>?
    programTypeEpisodeProgramTypeNullableListFromJson(
  List? programTypeEpisodeProgramType, [
  List<enums.ProgramTypeEpisodeProgramType>? defaultValue,
]) {
  if (programTypeEpisodeProgramType == null) {
    return defaultValue;
  }

  return programTypeEpisodeProgramType
      .map((e) => programTypeEpisodeProgramTypeFromJson(e.toString()))
      .toList();
}

String? viewStateToJson(enums.ViewState? viewState) {
  return enums.$ViewStateMap[viewState];
}

enums.ViewState viewStateFromJson(
  Object? viewState, [
  enums.ViewState? defaultValue,
]) {
  if (viewState is String) {
    return enums.$ViewStateMap.entries
        .firstWhere(
            (element) => element.value.toLowerCase() == viewState.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.ViewState.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ViewStateMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ViewState.swaggerGeneratedUnknown;
}

List<String> viewStateListToJson(List<enums.ViewState>? viewState) {
  if (viewState == null) {
    return [];
  }

  return viewState.map((e) => enums.$ViewStateMap[e]!).toList();
}

List<enums.ViewState> viewStateListFromJson(
  List? viewState, [
  List<enums.ViewState>? defaultValue,
]) {
  if (viewState == null) {
    return defaultValue ?? [];
  }

  return viewState.map((e) => viewStateFromJson(e.toString())).toList();
}

List<enums.ViewState>? viewStateNullableListFromJson(
  List? viewState, [
  List<enums.ViewState>? defaultValue,
]) {
  if (viewState == null) {
    return defaultValue;
  }

  return viewState.map((e) => viewStateFromJson(e.toString())).toList();
}

String? titleProgramProgramTypeToJson(
    enums.TitleProgramProgramType? titleProgramProgramType) {
  return enums.$TitleProgramProgramTypeMap[titleProgramProgramType];
}

enums.TitleProgramProgramType titleProgramProgramTypeFromJson(
  Object? titleProgramProgramType, [
  enums.TitleProgramProgramType? defaultValue,
]) {
  if (titleProgramProgramType is String) {
    return enums.$TitleProgramProgramTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                titleProgramProgramType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.TitleProgramProgramType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$TitleProgramProgramTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.TitleProgramProgramType.swaggerGeneratedUnknown;
}

List<String> titleProgramProgramTypeListToJson(
    List<enums.TitleProgramProgramType>? titleProgramProgramType) {
  if (titleProgramProgramType == null) {
    return [];
  }

  return titleProgramProgramType
      .map((e) => enums.$TitleProgramProgramTypeMap[e]!)
      .toList();
}

List<enums.TitleProgramProgramType> titleProgramProgramTypeListFromJson(
  List? titleProgramProgramType, [
  List<enums.TitleProgramProgramType>? defaultValue,
]) {
  if (titleProgramProgramType == null) {
    return defaultValue ?? [];
  }

  return titleProgramProgramType
      .map((e) => titleProgramProgramTypeFromJson(e.toString()))
      .toList();
}

List<enums.TitleProgramProgramType>?
    titleProgramProgramTypeNullableListFromJson(
  List? titleProgramProgramType, [
  List<enums.TitleProgramProgramType>? defaultValue,
]) {
  if (titleProgramProgramType == null) {
    return defaultValue;
  }

  return titleProgramProgramType
      .map((e) => titleProgramProgramTypeFromJson(e.toString()))
      .toList();
}

String? episodeProgramProgramTypeToJson(
    enums.EpisodeProgramProgramType? episodeProgramProgramType) {
  return enums.$EpisodeProgramProgramTypeMap[episodeProgramProgramType];
}

enums.EpisodeProgramProgramType episodeProgramProgramTypeFromJson(
  Object? episodeProgramProgramType, [
  enums.EpisodeProgramProgramType? defaultValue,
]) {
  if (episodeProgramProgramType is String) {
    return enums.$EpisodeProgramProgramTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                episodeProgramProgramType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.EpisodeProgramProgramType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$EpisodeProgramProgramTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.EpisodeProgramProgramType.swaggerGeneratedUnknown;
}

List<String> episodeProgramProgramTypeListToJson(
    List<enums.EpisodeProgramProgramType>? episodeProgramProgramType) {
  if (episodeProgramProgramType == null) {
    return [];
  }

  return episodeProgramProgramType
      .map((e) => enums.$EpisodeProgramProgramTypeMap[e]!)
      .toList();
}

List<enums.EpisodeProgramProgramType> episodeProgramProgramTypeListFromJson(
  List? episodeProgramProgramType, [
  List<enums.EpisodeProgramProgramType>? defaultValue,
]) {
  if (episodeProgramProgramType == null) {
    return defaultValue ?? [];
  }

  return episodeProgramProgramType
      .map((e) => episodeProgramProgramTypeFromJson(e.toString()))
      .toList();
}

List<enums.EpisodeProgramProgramType>?
    episodeProgramProgramTypeNullableListFromJson(
  List? episodeProgramProgramType, [
  List<enums.EpisodeProgramProgramType>? defaultValue,
]) {
  if (episodeProgramProgramType == null) {
    return defaultValue;
  }

  return episodeProgramProgramType
      .map((e) => episodeProgramProgramTypeFromJson(e.toString()))
      .toList();
}

String? seasonProgramProgramTypeToJson(
    enums.SeasonProgramProgramType? seasonProgramProgramType) {
  return enums.$SeasonProgramProgramTypeMap[seasonProgramProgramType];
}

enums.SeasonProgramProgramType seasonProgramProgramTypeFromJson(
  Object? seasonProgramProgramType, [
  enums.SeasonProgramProgramType? defaultValue,
]) {
  if (seasonProgramProgramType is String) {
    return enums.$SeasonProgramProgramTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                seasonProgramProgramType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.SeasonProgramProgramType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SeasonProgramProgramTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SeasonProgramProgramType.swaggerGeneratedUnknown;
}

List<String> seasonProgramProgramTypeListToJson(
    List<enums.SeasonProgramProgramType>? seasonProgramProgramType) {
  if (seasonProgramProgramType == null) {
    return [];
  }

  return seasonProgramProgramType
      .map((e) => enums.$SeasonProgramProgramTypeMap[e]!)
      .toList();
}

List<enums.SeasonProgramProgramType> seasonProgramProgramTypeListFromJson(
  List? seasonProgramProgramType, [
  List<enums.SeasonProgramProgramType>? defaultValue,
]) {
  if (seasonProgramProgramType == null) {
    return defaultValue ?? [];
  }

  return seasonProgramProgramType
      .map((e) => seasonProgramProgramTypeFromJson(e.toString()))
      .toList();
}

List<enums.SeasonProgramProgramType>?
    seasonProgramProgramTypeNullableListFromJson(
  List? seasonProgramProgramType, [
  List<enums.SeasonProgramProgramType>? defaultValue,
]) {
  if (seasonProgramProgramType == null) {
    return defaultValue;
  }

  return seasonProgramProgramType
      .map((e) => seasonProgramProgramTypeFromJson(e.toString()))
      .toList();
}

String? showProgramProgramTypeToJson(
    enums.ShowProgramProgramType? showProgramProgramType) {
  return enums.$ShowProgramProgramTypeMap[showProgramProgramType];
}

enums.ShowProgramProgramType showProgramProgramTypeFromJson(
  Object? showProgramProgramType, [
  enums.ShowProgramProgramType? defaultValue,
]) {
  if (showProgramProgramType is String) {
    return enums.$ShowProgramProgramTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                showProgramProgramType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ShowProgramProgramType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ShowProgramProgramTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ShowProgramProgramType.swaggerGeneratedUnknown;
}

List<String> showProgramProgramTypeListToJson(
    List<enums.ShowProgramProgramType>? showProgramProgramType) {
  if (showProgramProgramType == null) {
    return [];
  }

  return showProgramProgramType
      .map((e) => enums.$ShowProgramProgramTypeMap[e]!)
      .toList();
}

List<enums.ShowProgramProgramType> showProgramProgramTypeListFromJson(
  List? showProgramProgramType, [
  List<enums.ShowProgramProgramType>? defaultValue,
]) {
  if (showProgramProgramType == null) {
    return defaultValue ?? [];
  }

  return showProgramProgramType
      .map((e) => showProgramProgramTypeFromJson(e.toString()))
      .toList();
}

List<enums.ShowProgramProgramType>? showProgramProgramTypeNullableListFromJson(
  List? showProgramProgramType, [
  List<enums.ShowProgramProgramType>? defaultValue,
]) {
  if (showProgramProgramType == null) {
    return defaultValue;
  }

  return showProgramProgramType
      .map((e) => showProgramProgramTypeFromJson(e.toString()))
      .toList();
}

String? programTypeSeasonProgramTypeToJson(
    enums.ProgramTypeSeasonProgramType? programTypeSeasonProgramType) {
  return enums.$ProgramTypeSeasonProgramTypeMap[programTypeSeasonProgramType];
}

enums.ProgramTypeSeasonProgramType programTypeSeasonProgramTypeFromJson(
  Object? programTypeSeasonProgramType, [
  enums.ProgramTypeSeasonProgramType? defaultValue,
]) {
  if (programTypeSeasonProgramType is String) {
    return enums.$ProgramTypeSeasonProgramTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                programTypeSeasonProgramType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ProgramTypeSeasonProgramType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ProgramTypeSeasonProgramTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ProgramTypeSeasonProgramType.swaggerGeneratedUnknown;
}

List<String> programTypeSeasonProgramTypeListToJson(
    List<enums.ProgramTypeSeasonProgramType>? programTypeSeasonProgramType) {
  if (programTypeSeasonProgramType == null) {
    return [];
  }

  return programTypeSeasonProgramType
      .map((e) => enums.$ProgramTypeSeasonProgramTypeMap[e]!)
      .toList();
}

List<enums.ProgramTypeSeasonProgramType>
    programTypeSeasonProgramTypeListFromJson(
  List? programTypeSeasonProgramType, [
  List<enums.ProgramTypeSeasonProgramType>? defaultValue,
]) {
  if (programTypeSeasonProgramType == null) {
    return defaultValue ?? [];
  }

  return programTypeSeasonProgramType
      .map((e) => programTypeSeasonProgramTypeFromJson(e.toString()))
      .toList();
}

List<enums.ProgramTypeSeasonProgramType>?
    programTypeSeasonProgramTypeNullableListFromJson(
  List? programTypeSeasonProgramType, [
  List<enums.ProgramTypeSeasonProgramType>? defaultValue,
]) {
  if (programTypeSeasonProgramType == null) {
    return defaultValue;
  }

  return programTypeSeasonProgramType
      .map((e) => programTypeSeasonProgramTypeFromJson(e.toString()))
      .toList();
}

String? programTypeShowProgramTypeToJson(
    enums.ProgramTypeShowProgramType? programTypeShowProgramType) {
  return enums.$ProgramTypeShowProgramTypeMap[programTypeShowProgramType];
}

enums.ProgramTypeShowProgramType programTypeShowProgramTypeFromJson(
  Object? programTypeShowProgramType, [
  enums.ProgramTypeShowProgramType? defaultValue,
]) {
  if (programTypeShowProgramType is String) {
    return enums.$ProgramTypeShowProgramTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                programTypeShowProgramType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ProgramTypeShowProgramType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ProgramTypeShowProgramTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ProgramTypeShowProgramType.swaggerGeneratedUnknown;
}

List<String> programTypeShowProgramTypeListToJson(
    List<enums.ProgramTypeShowProgramType>? programTypeShowProgramType) {
  if (programTypeShowProgramType == null) {
    return [];
  }

  return programTypeShowProgramType
      .map((e) => enums.$ProgramTypeShowProgramTypeMap[e]!)
      .toList();
}

List<enums.ProgramTypeShowProgramType> programTypeShowProgramTypeListFromJson(
  List? programTypeShowProgramType, [
  List<enums.ProgramTypeShowProgramType>? defaultValue,
]) {
  if (programTypeShowProgramType == null) {
    return defaultValue ?? [];
  }

  return programTypeShowProgramType
      .map((e) => programTypeShowProgramTypeFromJson(e.toString()))
      .toList();
}

List<enums.ProgramTypeShowProgramType>?
    programTypeShowProgramTypeNullableListFromJson(
  List? programTypeShowProgramType, [
  List<enums.ProgramTypeShowProgramType>? defaultValue,
]) {
  if (programTypeShowProgramType == null) {
    return defaultValue;
  }

  return programTypeShowProgramType
      .map((e) => programTypeShowProgramTypeFromJson(e.toString()))
      .toList();
}

String? tvodOfferTypeToJson(enums.TvodOfferType? tvodOfferType) {
  return enums.$TvodOfferTypeMap[tvodOfferType];
}

enums.TvodOfferType tvodOfferTypeFromJson(
  Object? tvodOfferType, [
  enums.TvodOfferType? defaultValue,
]) {
  if (tvodOfferType is String) {
    return enums.$TvodOfferTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == tvodOfferType.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.TvodOfferType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$TvodOfferTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.TvodOfferType.swaggerGeneratedUnknown;
}

List<String> tvodOfferTypeListToJson(List<enums.TvodOfferType>? tvodOfferType) {
  if (tvodOfferType == null) {
    return [];
  }

  return tvodOfferType.map((e) => enums.$TvodOfferTypeMap[e]!).toList();
}

List<enums.TvodOfferType> tvodOfferTypeListFromJson(
  List? tvodOfferType, [
  List<enums.TvodOfferType>? defaultValue,
]) {
  if (tvodOfferType == null) {
    return defaultValue ?? [];
  }

  return tvodOfferType.map((e) => tvodOfferTypeFromJson(e.toString())).toList();
}

List<enums.TvodOfferType>? tvodOfferTypeNullableListFromJson(
  List? tvodOfferType, [
  List<enums.TvodOfferType>? defaultValue,
]) {
  if (tvodOfferType == null) {
    return defaultValue;
  }

  return tvodOfferType.map((e) => tvodOfferTypeFromJson(e.toString())).toList();
}

String? svodOfferTypeToJson(enums.SvodOfferType? svodOfferType) {
  return enums.$SvodOfferTypeMap[svodOfferType];
}

enums.SvodOfferType svodOfferTypeFromJson(
  Object? svodOfferType, [
  enums.SvodOfferType? defaultValue,
]) {
  if (svodOfferType is String) {
    return enums.$SvodOfferTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == svodOfferType.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.SvodOfferType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SvodOfferTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SvodOfferType.swaggerGeneratedUnknown;
}

List<String> svodOfferTypeListToJson(List<enums.SvodOfferType>? svodOfferType) {
  if (svodOfferType == null) {
    return [];
  }

  return svodOfferType.map((e) => enums.$SvodOfferTypeMap[e]!).toList();
}

List<enums.SvodOfferType> svodOfferTypeListFromJson(
  List? svodOfferType, [
  List<enums.SvodOfferType>? defaultValue,
]) {
  if (svodOfferType == null) {
    return defaultValue ?? [];
  }

  return svodOfferType.map((e) => svodOfferTypeFromJson(e.toString())).toList();
}

List<enums.SvodOfferType>? svodOfferTypeNullableListFromJson(
  List? svodOfferType, [
  List<enums.SvodOfferType>? defaultValue,
]) {
  if (svodOfferType == null) {
    return defaultValue;
  }

  return svodOfferType.map((e) => svodOfferTypeFromJson(e.toString())).toList();
}

String? sourceVodSourceTypeToJson(
    enums.SourceVodSourceType? sourceVodSourceType) {
  return enums.$SourceVodSourceTypeMap[sourceVodSourceType];
}

enums.SourceVodSourceType sourceVodSourceTypeFromJson(
  Object? sourceVodSourceType, [
  enums.SourceVodSourceType? defaultValue,
]) {
  if (sourceVodSourceType is String) {
    return enums.$SourceVodSourceTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                sourceVodSourceType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.SourceVodSourceType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SourceVodSourceTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SourceVodSourceType.swaggerGeneratedUnknown;
}

List<String> sourceVodSourceTypeListToJson(
    List<enums.SourceVodSourceType>? sourceVodSourceType) {
  if (sourceVodSourceType == null) {
    return [];
  }

  return sourceVodSourceType
      .map((e) => enums.$SourceVodSourceTypeMap[e]!)
      .toList();
}

List<enums.SourceVodSourceType> sourceVodSourceTypeListFromJson(
  List? sourceVodSourceType, [
  List<enums.SourceVodSourceType>? defaultValue,
]) {
  if (sourceVodSourceType == null) {
    return defaultValue ?? [];
  }

  return sourceVodSourceType
      .map((e) => sourceVodSourceTypeFromJson(e.toString()))
      .toList();
}

List<enums.SourceVodSourceType>? sourceVodSourceTypeNullableListFromJson(
  List? sourceVodSourceType, [
  List<enums.SourceVodSourceType>? defaultValue,
]) {
  if (sourceVodSourceType == null) {
    return defaultValue;
  }

  return sourceVodSourceType
      .map((e) => sourceVodSourceTypeFromJson(e.toString()))
      .toList();
}

String? sourceVodExtSourceTypeToJson(
    enums.SourceVodExtSourceType? sourceVodExtSourceType) {
  return enums.$SourceVodExtSourceTypeMap[sourceVodExtSourceType];
}

enums.SourceVodExtSourceType sourceVodExtSourceTypeFromJson(
  Object? sourceVodExtSourceType, [
  enums.SourceVodExtSourceType? defaultValue,
]) {
  if (sourceVodExtSourceType is String) {
    return enums.$SourceVodExtSourceTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                sourceVodExtSourceType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.SourceVodExtSourceType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SourceVodExtSourceTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SourceVodExtSourceType.swaggerGeneratedUnknown;
}

List<String> sourceVodExtSourceTypeListToJson(
    List<enums.SourceVodExtSourceType>? sourceVodExtSourceType) {
  if (sourceVodExtSourceType == null) {
    return [];
  }

  return sourceVodExtSourceType
      .map((e) => enums.$SourceVodExtSourceTypeMap[e]!)
      .toList();
}

List<enums.SourceVodExtSourceType> sourceVodExtSourceTypeListFromJson(
  List? sourceVodExtSourceType, [
  List<enums.SourceVodExtSourceType>? defaultValue,
]) {
  if (sourceVodExtSourceType == null) {
    return defaultValue ?? [];
  }

  return sourceVodExtSourceType
      .map((e) => sourceVodExtSourceTypeFromJson(e.toString()))
      .toList();
}

List<enums.SourceVodExtSourceType>? sourceVodExtSourceTypeNullableListFromJson(
  List? sourceVodExtSourceType, [
  List<enums.SourceVodExtSourceType>? defaultValue,
]) {
  if (sourceVodExtSourceType == null) {
    return defaultValue;
  }

  return sourceVodExtSourceType
      .map((e) => sourceVodExtSourceTypeFromJson(e.toString()))
      .toList();
}

String? sourceOttSourceTypeToJson(
    enums.SourceOttSourceType? sourceOttSourceType) {
  return enums.$SourceOttSourceTypeMap[sourceOttSourceType];
}

enums.SourceOttSourceType sourceOttSourceTypeFromJson(
  Object? sourceOttSourceType, [
  enums.SourceOttSourceType? defaultValue,
]) {
  if (sourceOttSourceType is String) {
    return enums.$SourceOttSourceTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                sourceOttSourceType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.SourceOttSourceType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SourceOttSourceTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SourceOttSourceType.swaggerGeneratedUnknown;
}

List<String> sourceOttSourceTypeListToJson(
    List<enums.SourceOttSourceType>? sourceOttSourceType) {
  if (sourceOttSourceType == null) {
    return [];
  }

  return sourceOttSourceType
      .map((e) => enums.$SourceOttSourceTypeMap[e]!)
      .toList();
}

List<enums.SourceOttSourceType> sourceOttSourceTypeListFromJson(
  List? sourceOttSourceType, [
  List<enums.SourceOttSourceType>? defaultValue,
]) {
  if (sourceOttSourceType == null) {
    return defaultValue ?? [];
  }

  return sourceOttSourceType
      .map((e) => sourceOttSourceTypeFromJson(e.toString()))
      .toList();
}

List<enums.SourceOttSourceType>? sourceOttSourceTypeNullableListFromJson(
  List? sourceOttSourceType, [
  List<enums.SourceOttSourceType>? defaultValue,
]) {
  if (sourceOttSourceType == null) {
    return defaultValue;
  }

  return sourceOttSourceType
      .map((e) => sourceOttSourceTypeFromJson(e.toString()))
      .toList();
}

@JsonSerializable(explicitToJson: true)
class ProgramFeed {
  ProgramFeed({
    required this.programs,
    this.warnings,
  });

  factory ProgramFeed.fromJson(Map<String, dynamic> json) =>
      _$ProgramFeedFromJson(json);

  @JsonKey(name: 'programs', includeIfNull: false, defaultValue: <Program>[])
  final List<Program> programs;
  @JsonKey(name: 'warnings', includeIfNull: false)
  final Warnings? warnings;
  static const fromJsonFactory = _$ProgramFeedFromJson;
  static const toJsonFactory = _$ProgramFeedToJson;
  Map<String, dynamic> toJson() => _$ProgramFeedToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProgramFeed &&
            (identical(other.programs, programs) ||
                const DeepCollectionEquality()
                    .equals(other.programs, programs)) &&
            (identical(other.warnings, warnings) ||
                const DeepCollectionEquality()
                    .equals(other.warnings, warnings)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(programs) ^
      const DeepCollectionEquality().hash(warnings) ^
      runtimeType.hashCode;
}

extension $ProgramFeedExtension on ProgramFeed {
  ProgramFeed copyWith({List<Program>? programs, Warnings? warnings}) {
    return ProgramFeed(
        programs: programs ?? this.programs,
        warnings: warnings ?? this.warnings);
  }

  ProgramFeed copyWithWrapped(
      {Wrapped<List<Program>>? programs, Wrapped<Warnings?>? warnings}) {
    return ProgramFeed(
        programs: (programs != null ? programs.value : this.programs),
        warnings: (warnings != null ? warnings.value : this.warnings));
  }
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
