// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'issue_285.enums.swagger.dart' as enums;
export 'issue_285.enums.swagger.dart';

part 'issue_285.swagger.chopper.dart';
part 'issue_285.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class Issue285 extends ChopperService {
  static Issue285 create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$Issue285(client);
    }

    final newClient = ChopperClient(
        services: [_$Issue285()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$Issue285(newClient);
  }

  ///
  ///@param frmNo
  ///@param ordNo
  ///@param noteNm
  ///@param hash
  Future<chopper.Response<StringResult>> fileIOFirmsFrmNoOrdersOrdNoNoteGet({
    required int? frmNo,
    required int? ordNo,
    String? noteNm,
    num? hash,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StringResult, () => StringResult.fromJsonFactory);

    return _fileIOFirmsFrmNoOrdersOrdNoNoteGet(
        frmNo: frmNo,
        ordNo: ordNo,
        noteNm: noteNm,
        hash: hash,
        cacheControl: cacheControl);
  }

  ///
  ///@param frmNo
  ///@param ordNo
  ///@param noteNm
  ///@param hash
  @Get(path: '/FileIO/firms/{frmNo}/orders/{ordNo}/note')
  Future<chopper.Response<StringResult>> _fileIOFirmsFrmNoOrdersOrdNoNoteGet({
    @Path('frmNo') required int? frmNo,
    @Path('ordNo') required int? ordNo,
    @Query('noteNm') String? noteNm,
    @Query('hash') num? hash,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param frmNo
  ///@param ordNo
  ///@param lnNo
  ///@param noteNm
  ///@param hash
  Future<chopper.Response<StringResult>>
      fileIOFirmsFrmNoOrdersOrdNoOrderlinesLnNoNoteGet({
    required int? frmNo,
    required int? ordNo,
    required int? lnNo,
    String? noteNm,
    num? hash,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StringResult, () => StringResult.fromJsonFactory);

    return _fileIOFirmsFrmNoOrdersOrdNoOrderlinesLnNoNoteGet(
        frmNo: frmNo,
        ordNo: ordNo,
        lnNo: lnNo,
        noteNm: noteNm,
        hash: hash,
        cacheControl: cacheControl);
  }

  ///
  ///@param frmNo
  ///@param ordNo
  ///@param lnNo
  ///@param noteNm
  ///@param hash
  @Get(path: '/FileIO/firms/{frmNo}/orders/{ordNo}/orderlines/{lnNo}/note')
  Future<chopper.Response<StringResult>>
      _fileIOFirmsFrmNoOrdersOrdNoOrderlinesLnNoNoteGet({
    @Path('frmNo') required int? frmNo,
    @Path('ordNo') required int? ordNo,
    @Path('lnNo') required int? lnNo,
    @Query('noteNm') String? noteNm,
    @Query('hash') num? hash,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<StringInt32IDictionaryResult>> orderTextTypesGet(
      {String? cacheControl}) {
    generatedMapping.putIfAbsent(StringInt32IDictionaryResult,
        () => StringInt32IDictionaryResult.fromJsonFactory);

    return _orderTextTypesGet(cacheControl: cacheControl);
  }

  ///
  @Get(path: '/Order/textTypes')
  Future<chopper.Response<StringInt32IDictionaryResult>> _orderTextTypesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<Int32IEnumerableResult>> orderFirmCountriesGet(
      {String? cacheControl}) {
    generatedMapping.putIfAbsent(
        Int32IEnumerableResult, () => Int32IEnumerableResult.fromJsonFactory);

    return _orderFirmCountriesGet(cacheControl: cacheControl);
  }

  ///
  @Get(path: '/Order/firmCountries')
  Future<chopper.Response<Int32IEnumerableResult>> _orderFirmCountriesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  ///@param ctry
  Future<chopper.Response<FrmIEnumerableResult>> orderFirmsGet({
    int? ctry,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FrmIEnumerableResult, () => FrmIEnumerableResult.fromJsonFactory);

    return _orderFirmsGet(ctry: ctry, cacheControl: cacheControl);
  }

  ///
  ///@param ctry
  @Get(path: '/Order/firms')
  Future<chopper.Response<FrmIEnumerableResult>> _orderFirmsGet({
    @Query('ctry') int? ctry,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param frmNo
  ///@param txtTp
  ///@param lang
  Future<chopper.Response<TxtIEnumerableResult>> orderFirmsFrmNoTextsGet({
    required int? frmNo,
    enums.TextTp? txtTp,
    int? lang,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        TxtIEnumerableResult, () => TxtIEnumerableResult.fromJsonFactory);

    return _orderFirmsFrmNoTextsGet(
        frmNo: frmNo,
        txtTp: enums.$TextTpMap[txtTp]?.toString(),
        lang: lang,
        cacheControl: cacheControl);
  }

  ///
  ///@param frmNo
  ///@param txtTp
  ///@param lang
  @Get(path: '/Order/firms/{frmNo}/texts')
  Future<chopper.Response<TxtIEnumerableResult>> _orderFirmsFrmNoTextsGet({
    @Path('frmNo') required int? frmNo,
    @Query('txtTp') String? txtTp,
    @Query('lang') int? lang,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param frmNo
  Future<chopper.Response<UnitIEnumerableResult>> orderFirmsFrmNoUnitsGet({
    required int? frmNo,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UnitIEnumerableResult, () => UnitIEnumerableResult.fromJsonFactory);

    return _orderFirmsFrmNoUnitsGet(frmNo: frmNo, cacheControl: cacheControl);
  }

  ///
  ///@param frmNo
  @Get(path: '/Order/firms/{frmNo}/units')
  Future<chopper.Response<UnitIEnumerableResult>> _orderFirmsFrmNoUnitsGet({
    @Path('frmNo') required int? frmNo,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param frmNo
  Future<chopper.Response<ProdIEnumerableResult>> orderFirmsFrmNoProductsGet({
    required int? frmNo,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ProdIEnumerableResult, () => ProdIEnumerableResult.fromJsonFactory);

    return _orderFirmsFrmNoProductsGet(
        frmNo: frmNo, cacheControl: cacheControl);
  }

  ///
  ///@param frmNo
  @Get(path: '/Order/firms/{frmNo}/products')
  Future<chopper.Response<ProdIEnumerableResult>> _orderFirmsFrmNoProductsGet({
    @Path('frmNo') required int? frmNo,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param frmNo
  ///@param prodNo
  Future<chopper.Response<ProdResult>> orderFirmsFrmNoProductsProdNoGet({
    required int? frmNo,
    required String? prodNo,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ProdResult, () => ProdResult.fromJsonFactory);

    return _orderFirmsFrmNoProductsProdNoGet(
        frmNo: frmNo, prodNo: prodNo, cacheControl: cacheControl);
  }

  ///
  ///@param frmNo
  ///@param prodNo
  @Get(path: '/Order/firms/{frmNo}/products/{prodNo}')
  Future<chopper.Response<ProdResult>> _orderFirmsFrmNoProductsProdNoGet({
    @Path('frmNo') required int? frmNo,
    @Path('prodNo') required String? prodNo,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param frmNo
  Future<chopper.Response<R10IEnumerableResult>> orderFirmsFrmNoOfficesGet({
    required int? frmNo,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        R10IEnumerableResult, () => R10IEnumerableResult.fromJsonFactory);

    return _orderFirmsFrmNoOfficesGet(frmNo: frmNo, cacheControl: cacheControl);
  }

  ///
  ///@param frmNo
  @Get(path: '/Order/firms/{frmNo}/offices')
  Future<chopper.Response<R10IEnumerableResult>> _orderFirmsFrmNoOfficesGet({
    @Path('frmNo') required int? frmNo,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param frmNo
  ///@param rNo
  Future<chopper.Response<R10IEnumerableResult>> orderFirmsFrmNoOfficesRNoGet({
    required int? frmNo,
    required String? rNo,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        R10IEnumerableResult, () => R10IEnumerableResult.fromJsonFactory);

    return _orderFirmsFrmNoOfficesRNoGet(
        frmNo: frmNo, rNo: rNo, cacheControl: cacheControl);
  }

  ///
  ///@param frmNo
  ///@param rNo
  @Get(path: '/Order/firms/{frmNo}/offices/{rNo}')
  Future<chopper.Response<R10IEnumerableResult>> _orderFirmsFrmNoOfficesRNoGet({
    @Path('frmNo') required int? frmNo,
    @Path('rNo') required String? rNo,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param frmNo
  ///@param r10
  Future<chopper.Response<R1IEnumerableResult>> orderFirmsFrmNoSectionsGet({
    required int? frmNo,
    String? r10,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        R1IEnumerableResult, () => R1IEnumerableResult.fromJsonFactory);

    return _orderFirmsFrmNoSectionsGet(
        frmNo: frmNo, r10: r10, cacheControl: cacheControl);
  }

  ///
  ///@param frmNo
  ///@param r10
  @Get(path: '/Order/firms/{frmNo}/sections')
  Future<chopper.Response<R1IEnumerableResult>> _orderFirmsFrmNoSectionsGet({
    @Path('frmNo') required int? frmNo,
    @Query('r10') String? r10,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param frmNo
  ///@param rNo
  Future<chopper.Response<R1Result>> orderFirmsFrmNoSectionsRNoGet({
    required int? frmNo,
    required int? rNo,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(R1Result, () => R1Result.fromJsonFactory);

    return _orderFirmsFrmNoSectionsRNoGet(
        frmNo: frmNo, rNo: rNo, cacheControl: cacheControl);
  }

  ///
  ///@param frmNo
  ///@param rNo
  @Get(path: '/Order/firms/{frmNo}/sections/{rNo}')
  Future<chopper.Response<R1Result>> _orderFirmsFrmNoSectionsRNoGet({
    @Path('frmNo') required int? frmNo,
    @Path('rNo') required int? rNo,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param frmNo
  ///@param custNo
  Future<chopper.Response<ActorCustomerResult>>
      orderFirmsFrmNoCustomersCustNoGet({
    required int? frmNo,
    required int? custNo,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ActorCustomerResult, () => ActorCustomerResult.fromJsonFactory);

    return _orderFirmsFrmNoCustomersCustNoGet(
        frmNo: frmNo, custNo: custNo, cacheControl: cacheControl);
  }

  ///
  ///@param frmNo
  ///@param custNo
  @Get(path: '/Order/firms/{frmNo}/customers/{custNo}')
  Future<chopper.Response<ActorCustomerResult>>
      _orderFirmsFrmNoCustomersCustNoGet({
    @Path('frmNo') required int? frmNo,
    @Path('custNo') required int? custNo,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param frmNo
  ///@param actNo
  Future<chopper.Response<ActorDeliveryAddressIEnumerableResult>>
      orderFirmsFrmNoActorsActNoDeliveryAddressesGet({
    required int? frmNo,
    required int? actNo,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ActorDeliveryAddressIEnumerableResult,
        () => ActorDeliveryAddressIEnumerableResult.fromJsonFactory);

    return _orderFirmsFrmNoActorsActNoDeliveryAddressesGet(
        frmNo: frmNo, actNo: actNo, cacheControl: cacheControl);
  }

  ///
  ///@param frmNo
  ///@param actNo
  @Get(path: '/Order/firms/{frmNo}/actors/{actNo}/deliveryAddresses')
  Future<chopper.Response<ActorDeliveryAddressIEnumerableResult>>
      _orderFirmsFrmNoActorsActNoDeliveryAddressesGet({
    @Path('frmNo') required int? frmNo,
    @Path('actNo') required int? actNo,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param frmNo
  ///@param actNo
  Future<chopper.Response<ActorContactPersonIEnumerableResult>>
      orderFirmsFrmNoActorsActNoContactPersonsGet({
    required int? frmNo,
    required int? actNo,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ActorContactPersonIEnumerableResult,
        () => ActorContactPersonIEnumerableResult.fromJsonFactory);

    return _orderFirmsFrmNoActorsActNoContactPersonsGet(
        frmNo: frmNo, actNo: actNo, cacheControl: cacheControl);
  }

  ///
  ///@param frmNo
  ///@param actNo
  @Get(path: '/Order/firms/{frmNo}/actors/{actNo}/contactPersons')
  Future<chopper.Response<ActorContactPersonIEnumerableResult>>
      _orderFirmsFrmNoActorsActNoContactPersonsGet({
    @Path('frmNo') required int? frmNo,
    @Path('actNo') required int? actNo,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param frmNo
  ///@param r10
  Future<chopper.Response<WorkResult>> orderFirmsFrmNoOfficesR10WorkGet({
    required int? frmNo,
    required String? r10,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(WorkResult, () => WorkResult.fromJsonFactory);

    return _orderFirmsFrmNoOfficesR10WorkGet(
        frmNo: frmNo, r10: r10, cacheControl: cacheControl);
  }

  ///
  ///@param frmNo
  ///@param r10
  @Get(path: '/Order/firms/{frmNo}/offices/{r10}/work')
  Future<chopper.Response<WorkResult>> _orderFirmsFrmNoOfficesR10WorkGet({
    @Path('frmNo') required int? frmNo,
    @Path('r10') required String? r10,
    @Header('Cache-Control') String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class ActorContactPerson {
  ActorContactPerson({
    this.frmNo,
    this.actNo,
    this.nm,
    this.ad1,
    this.ad2,
    this.pNo,
    this.ad4,
    this.pArea,
    this.mobPh,
    this.phone,
    this.mailAd,
    this.ctry,
    this.noteNm,
    this.noteHash,
  });

  factory ActorContactPerson.fromJson(Map<String, dynamic> json) =>
      _$ActorContactPersonFromJson(json);

  @JsonKey(name: 'frmNo', includeIfNull: false)
  final int? frmNo;
  @JsonKey(name: 'actNo', includeIfNull: false)
  final int? actNo;
  @JsonKey(name: 'nm', includeIfNull: false, defaultValue: '')
  final String? nm;
  @JsonKey(name: 'ad1', includeIfNull: false, defaultValue: '')
  final String? ad1;
  @JsonKey(name: 'ad2', includeIfNull: false, defaultValue: '')
  final String? ad2;
  @JsonKey(name: 'pNo', includeIfNull: false, defaultValue: '')
  final String? pNo;
  @JsonKey(name: 'ad4', includeIfNull: false, defaultValue: '')
  final String? ad4;
  @JsonKey(name: 'pArea', includeIfNull: false, defaultValue: '')
  final String? pArea;
  @JsonKey(name: 'mobPh', includeIfNull: false, defaultValue: '')
  final String? mobPh;
  @JsonKey(name: 'phone', includeIfNull: false, defaultValue: '')
  final String? phone;
  @JsonKey(name: 'mailAd', includeIfNull: false, defaultValue: '')
  final String? mailAd;
  @JsonKey(name: 'ctry', includeIfNull: false)
  final int? ctry;
  @JsonKey(name: 'noteNm', includeIfNull: false, defaultValue: '')
  final String? noteNm;
  @JsonKey(name: 'noteHash', includeIfNull: false)
  final num? noteHash;
  static const fromJsonFactory = _$ActorContactPersonFromJson;
  static const toJsonFactory = _$ActorContactPersonToJson;
  Map<String, dynamic> toJson() => _$ActorContactPersonToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ActorContactPerson &&
            (identical(other.frmNo, frmNo) ||
                const DeepCollectionEquality().equals(other.frmNo, frmNo)) &&
            (identical(other.actNo, actNo) ||
                const DeepCollectionEquality().equals(other.actNo, actNo)) &&
            (identical(other.nm, nm) ||
                const DeepCollectionEquality().equals(other.nm, nm)) &&
            (identical(other.ad1, ad1) ||
                const DeepCollectionEquality().equals(other.ad1, ad1)) &&
            (identical(other.ad2, ad2) ||
                const DeepCollectionEquality().equals(other.ad2, ad2)) &&
            (identical(other.pNo, pNo) ||
                const DeepCollectionEquality().equals(other.pNo, pNo)) &&
            (identical(other.ad4, ad4) ||
                const DeepCollectionEquality().equals(other.ad4, ad4)) &&
            (identical(other.pArea, pArea) ||
                const DeepCollectionEquality().equals(other.pArea, pArea)) &&
            (identical(other.mobPh, mobPh) ||
                const DeepCollectionEquality().equals(other.mobPh, mobPh)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.mailAd, mailAd) ||
                const DeepCollectionEquality().equals(other.mailAd, mailAd)) &&
            (identical(other.ctry, ctry) ||
                const DeepCollectionEquality().equals(other.ctry, ctry)) &&
            (identical(other.noteNm, noteNm) ||
                const DeepCollectionEquality().equals(other.noteNm, noteNm)) &&
            (identical(other.noteHash, noteHash) ||
                const DeepCollectionEquality()
                    .equals(other.noteHash, noteHash)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(frmNo) ^
      const DeepCollectionEquality().hash(actNo) ^
      const DeepCollectionEquality().hash(nm) ^
      const DeepCollectionEquality().hash(ad1) ^
      const DeepCollectionEquality().hash(ad2) ^
      const DeepCollectionEquality().hash(pNo) ^
      const DeepCollectionEquality().hash(ad4) ^
      const DeepCollectionEquality().hash(pArea) ^
      const DeepCollectionEquality().hash(mobPh) ^
      const DeepCollectionEquality().hash(phone) ^
      const DeepCollectionEquality().hash(mailAd) ^
      const DeepCollectionEquality().hash(ctry) ^
      const DeepCollectionEquality().hash(noteNm) ^
      const DeepCollectionEquality().hash(noteHash) ^
      runtimeType.hashCode;
}

extension $ActorContactPersonExtension on ActorContactPerson {
  ActorContactPerson copyWith(
      {int? frmNo,
      int? actNo,
      String? nm,
      String? ad1,
      String? ad2,
      String? pNo,
      String? ad4,
      String? pArea,
      String? mobPh,
      String? phone,
      String? mailAd,
      int? ctry,
      String? noteNm,
      num? noteHash}) {
    return ActorContactPerson(
        frmNo: frmNo ?? this.frmNo,
        actNo: actNo ?? this.actNo,
        nm: nm ?? this.nm,
        ad1: ad1 ?? this.ad1,
        ad2: ad2 ?? this.ad2,
        pNo: pNo ?? this.pNo,
        ad4: ad4 ?? this.ad4,
        pArea: pArea ?? this.pArea,
        mobPh: mobPh ?? this.mobPh,
        phone: phone ?? this.phone,
        mailAd: mailAd ?? this.mailAd,
        ctry: ctry ?? this.ctry,
        noteNm: noteNm ?? this.noteNm,
        noteHash: noteHash ?? this.noteHash);
  }

  ActorContactPerson copyWithWrapped(
      {Wrapped<int?>? frmNo,
      Wrapped<int?>? actNo,
      Wrapped<String?>? nm,
      Wrapped<String?>? ad1,
      Wrapped<String?>? ad2,
      Wrapped<String?>? pNo,
      Wrapped<String?>? ad4,
      Wrapped<String?>? pArea,
      Wrapped<String?>? mobPh,
      Wrapped<String?>? phone,
      Wrapped<String?>? mailAd,
      Wrapped<int?>? ctry,
      Wrapped<String?>? noteNm,
      Wrapped<num?>? noteHash}) {
    return ActorContactPerson(
        frmNo: (frmNo != null ? frmNo.value : this.frmNo),
        actNo: (actNo != null ? actNo.value : this.actNo),
        nm: (nm != null ? nm.value : this.nm),
        ad1: (ad1 != null ? ad1.value : this.ad1),
        ad2: (ad2 != null ? ad2.value : this.ad2),
        pNo: (pNo != null ? pNo.value : this.pNo),
        ad4: (ad4 != null ? ad4.value : this.ad4),
        pArea: (pArea != null ? pArea.value : this.pArea),
        mobPh: (mobPh != null ? mobPh.value : this.mobPh),
        phone: (phone != null ? phone.value : this.phone),
        mailAd: (mailAd != null ? mailAd.value : this.mailAd),
        ctry: (ctry != null ? ctry.value : this.ctry),
        noteNm: (noteNm != null ? noteNm.value : this.noteNm),
        noteHash: (noteHash != null ? noteHash.value : this.noteHash));
  }
}

@JsonSerializable(explicitToJson: true)
class ActorContactPersonIEnumerableResult {
  ActorContactPersonIEnumerableResult({
    this.success,
    this.message,
    this.data,
  });

  factory ActorContactPersonIEnumerableResult.fromJson(
          Map<String, dynamic> json) =>
      _$ActorContactPersonIEnumerableResultFromJson(json);

  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(
      name: 'data', includeIfNull: false, defaultValue: <ActorContactPerson>[])
  final List<ActorContactPerson>? data;
  static const fromJsonFactory = _$ActorContactPersonIEnumerableResultFromJson;
  static const toJsonFactory = _$ActorContactPersonIEnumerableResultToJson;
  Map<String, dynamic> toJson() =>
      _$ActorContactPersonIEnumerableResultToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ActorContactPersonIEnumerableResult &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(data) ^
      runtimeType.hashCode;
}

extension $ActorContactPersonIEnumerableResultExtension
    on ActorContactPersonIEnumerableResult {
  ActorContactPersonIEnumerableResult copyWith(
      {bool? success, String? message, List<ActorContactPerson>? data}) {
    return ActorContactPersonIEnumerableResult(
        success: success ?? this.success,
        message: message ?? this.message,
        data: data ?? this.data);
  }

  ActorContactPersonIEnumerableResult copyWithWrapped(
      {Wrapped<bool?>? success,
      Wrapped<String?>? message,
      Wrapped<List<ActorContactPerson>?>? data}) {
    return ActorContactPersonIEnumerableResult(
        success: (success != null ? success.value : this.success),
        message: (message != null ? message.value : this.message),
        data: (data != null ? data.value : this.data));
  }
}

@JsonSerializable(explicitToJson: true)
class ActorCustomer {
  ActorCustomer({
    this.frmNo,
    this.actNo,
    this.nm,
    this.ad1,
    this.ad2,
    this.ad4,
    this.pNo,
    this.pArea,
    this.mobPh,
    this.phone,
    this.mailAd,
    this.ctry,
    this.noteNm,
    this.noteHash,
    this.custNo,
    this.crSusp,
  });

  factory ActorCustomer.fromJson(Map<String, dynamic> json) =>
      _$ActorCustomerFromJson(json);

  @JsonKey(name: 'frmNo', includeIfNull: false)
  final int? frmNo;
  @JsonKey(name: 'actNo', includeIfNull: false)
  final int? actNo;
  @JsonKey(name: 'nm', includeIfNull: false, defaultValue: '')
  final String? nm;
  @JsonKey(name: 'ad1', includeIfNull: false, defaultValue: '')
  final String? ad1;
  @JsonKey(name: 'ad2', includeIfNull: false, defaultValue: '')
  final String? ad2;
  @JsonKey(name: 'ad4', includeIfNull: false, defaultValue: '')
  final String? ad4;
  @JsonKey(name: 'pNo', includeIfNull: false, defaultValue: '')
  final String? pNo;
  @JsonKey(name: 'pArea', includeIfNull: false, defaultValue: '')
  final String? pArea;
  @JsonKey(name: 'mobPh', includeIfNull: false, defaultValue: '')
  final String? mobPh;
  @JsonKey(name: 'phone', includeIfNull: false, defaultValue: '')
  final String? phone;
  @JsonKey(name: 'mailAd', includeIfNull: false, defaultValue: '')
  final String? mailAd;
  @JsonKey(name: 'ctry', includeIfNull: false)
  final int? ctry;
  @JsonKey(name: 'noteNm', includeIfNull: false, defaultValue: '')
  final String? noteNm;
  @JsonKey(name: 'noteHash', includeIfNull: false)
  final num? noteHash;
  @JsonKey(name: 'custNo', includeIfNull: false)
  final int? custNo;
  @JsonKey(name: 'crSusp', includeIfNull: false)
  final int? crSusp;
  static const fromJsonFactory = _$ActorCustomerFromJson;
  static const toJsonFactory = _$ActorCustomerToJson;
  Map<String, dynamic> toJson() => _$ActorCustomerToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ActorCustomer &&
            (identical(other.frmNo, frmNo) ||
                const DeepCollectionEquality().equals(other.frmNo, frmNo)) &&
            (identical(other.actNo, actNo) ||
                const DeepCollectionEquality().equals(other.actNo, actNo)) &&
            (identical(other.nm, nm) ||
                const DeepCollectionEquality().equals(other.nm, nm)) &&
            (identical(other.ad1, ad1) ||
                const DeepCollectionEquality().equals(other.ad1, ad1)) &&
            (identical(other.ad2, ad2) ||
                const DeepCollectionEquality().equals(other.ad2, ad2)) &&
            (identical(other.ad4, ad4) ||
                const DeepCollectionEquality().equals(other.ad4, ad4)) &&
            (identical(other.pNo, pNo) ||
                const DeepCollectionEquality().equals(other.pNo, pNo)) &&
            (identical(other.pArea, pArea) ||
                const DeepCollectionEquality().equals(other.pArea, pArea)) &&
            (identical(other.mobPh, mobPh) ||
                const DeepCollectionEquality().equals(other.mobPh, mobPh)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.mailAd, mailAd) ||
                const DeepCollectionEquality().equals(other.mailAd, mailAd)) &&
            (identical(other.ctry, ctry) ||
                const DeepCollectionEquality().equals(other.ctry, ctry)) &&
            (identical(other.noteNm, noteNm) ||
                const DeepCollectionEquality().equals(other.noteNm, noteNm)) &&
            (identical(other.noteHash, noteHash) ||
                const DeepCollectionEquality()
                    .equals(other.noteHash, noteHash)) &&
            (identical(other.custNo, custNo) ||
                const DeepCollectionEquality().equals(other.custNo, custNo)) &&
            (identical(other.crSusp, crSusp) ||
                const DeepCollectionEquality().equals(other.crSusp, crSusp)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(frmNo) ^
      const DeepCollectionEquality().hash(actNo) ^
      const DeepCollectionEquality().hash(nm) ^
      const DeepCollectionEquality().hash(ad1) ^
      const DeepCollectionEquality().hash(ad2) ^
      const DeepCollectionEquality().hash(ad4) ^
      const DeepCollectionEquality().hash(pNo) ^
      const DeepCollectionEquality().hash(pArea) ^
      const DeepCollectionEquality().hash(mobPh) ^
      const DeepCollectionEquality().hash(phone) ^
      const DeepCollectionEquality().hash(mailAd) ^
      const DeepCollectionEquality().hash(ctry) ^
      const DeepCollectionEquality().hash(noteNm) ^
      const DeepCollectionEquality().hash(noteHash) ^
      const DeepCollectionEquality().hash(custNo) ^
      const DeepCollectionEquality().hash(crSusp) ^
      runtimeType.hashCode;
}

extension $ActorCustomerExtension on ActorCustomer {
  ActorCustomer copyWith(
      {int? frmNo,
      int? actNo,
      String? nm,
      String? ad1,
      String? ad2,
      String? ad4,
      String? pNo,
      String? pArea,
      String? mobPh,
      String? phone,
      String? mailAd,
      int? ctry,
      String? noteNm,
      num? noteHash,
      int? custNo,
      int? crSusp}) {
    return ActorCustomer(
        frmNo: frmNo ?? this.frmNo,
        actNo: actNo ?? this.actNo,
        nm: nm ?? this.nm,
        ad1: ad1 ?? this.ad1,
        ad2: ad2 ?? this.ad2,
        ad4: ad4 ?? this.ad4,
        pNo: pNo ?? this.pNo,
        pArea: pArea ?? this.pArea,
        mobPh: mobPh ?? this.mobPh,
        phone: phone ?? this.phone,
        mailAd: mailAd ?? this.mailAd,
        ctry: ctry ?? this.ctry,
        noteNm: noteNm ?? this.noteNm,
        noteHash: noteHash ?? this.noteHash,
        custNo: custNo ?? this.custNo,
        crSusp: crSusp ?? this.crSusp);
  }

  ActorCustomer copyWithWrapped(
      {Wrapped<int?>? frmNo,
      Wrapped<int?>? actNo,
      Wrapped<String?>? nm,
      Wrapped<String?>? ad1,
      Wrapped<String?>? ad2,
      Wrapped<String?>? ad4,
      Wrapped<String?>? pNo,
      Wrapped<String?>? pArea,
      Wrapped<String?>? mobPh,
      Wrapped<String?>? phone,
      Wrapped<String?>? mailAd,
      Wrapped<int?>? ctry,
      Wrapped<String?>? noteNm,
      Wrapped<num?>? noteHash,
      Wrapped<int?>? custNo,
      Wrapped<int?>? crSusp}) {
    return ActorCustomer(
        frmNo: (frmNo != null ? frmNo.value : this.frmNo),
        actNo: (actNo != null ? actNo.value : this.actNo),
        nm: (nm != null ? nm.value : this.nm),
        ad1: (ad1 != null ? ad1.value : this.ad1),
        ad2: (ad2 != null ? ad2.value : this.ad2),
        ad4: (ad4 != null ? ad4.value : this.ad4),
        pNo: (pNo != null ? pNo.value : this.pNo),
        pArea: (pArea != null ? pArea.value : this.pArea),
        mobPh: (mobPh != null ? mobPh.value : this.mobPh),
        phone: (phone != null ? phone.value : this.phone),
        mailAd: (mailAd != null ? mailAd.value : this.mailAd),
        ctry: (ctry != null ? ctry.value : this.ctry),
        noteNm: (noteNm != null ? noteNm.value : this.noteNm),
        noteHash: (noteHash != null ? noteHash.value : this.noteHash),
        custNo: (custNo != null ? custNo.value : this.custNo),
        crSusp: (crSusp != null ? crSusp.value : this.crSusp));
  }
}

@JsonSerializable(explicitToJson: true)
class ActorCustomerResult {
  ActorCustomerResult({
    this.success,
    this.message,
    this.data,
  });

  factory ActorCustomerResult.fromJson(Map<String, dynamic> json) =>
      _$ActorCustomerResultFromJson(json);

  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'data', includeIfNull: false)
  final ActorCustomer? data;
  static const fromJsonFactory = _$ActorCustomerResultFromJson;
  static const toJsonFactory = _$ActorCustomerResultToJson;
  Map<String, dynamic> toJson() => _$ActorCustomerResultToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ActorCustomerResult &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(data) ^
      runtimeType.hashCode;
}

extension $ActorCustomerResultExtension on ActorCustomerResult {
  ActorCustomerResult copyWith(
      {bool? success, String? message, ActorCustomer? data}) {
    return ActorCustomerResult(
        success: success ?? this.success,
        message: message ?? this.message,
        data: data ?? this.data);
  }

  ActorCustomerResult copyWithWrapped(
      {Wrapped<bool?>? success,
      Wrapped<String?>? message,
      Wrapped<ActorCustomer?>? data}) {
    return ActorCustomerResult(
        success: (success != null ? success.value : this.success),
        message: (message != null ? message.value : this.message),
        data: (data != null ? data.value : this.data));
  }
}

@JsonSerializable(explicitToJson: true)
class ActorDeliveryAddress {
  ActorDeliveryAddress({
    this.frmNo,
    this.actNo,
    this.nm,
    this.ad1,
    this.ad2,
    this.ad4,
    this.pNo,
    this.pArea,
    this.mobPh,
    this.phone,
    this.mailAd,
    this.ctry,
    this.noteNm,
    this.noteHash,
  });

  factory ActorDeliveryAddress.fromJson(Map<String, dynamic> json) =>
      _$ActorDeliveryAddressFromJson(json);

  @JsonKey(name: 'frmNo', includeIfNull: false)
  final int? frmNo;
  @JsonKey(name: 'actNo', includeIfNull: false)
  final int? actNo;
  @JsonKey(name: 'nm', includeIfNull: false, defaultValue: '')
  final String? nm;
  @JsonKey(name: 'ad1', includeIfNull: false, defaultValue: '')
  final String? ad1;
  @JsonKey(name: 'ad2', includeIfNull: false, defaultValue: '')
  final String? ad2;
  @JsonKey(name: 'ad4', includeIfNull: false, defaultValue: '')
  final String? ad4;
  @JsonKey(name: 'pNo', includeIfNull: false, defaultValue: '')
  final String? pNo;
  @JsonKey(name: 'pArea', includeIfNull: false, defaultValue: '')
  final String? pArea;
  @JsonKey(name: 'mobPh', includeIfNull: false, defaultValue: '')
  final String? mobPh;
  @JsonKey(name: 'phone', includeIfNull: false, defaultValue: '')
  final String? phone;
  @JsonKey(name: 'mailAd', includeIfNull: false, defaultValue: '')
  final String? mailAd;
  @JsonKey(name: 'ctry', includeIfNull: false)
  final int? ctry;
  @JsonKey(name: 'noteNm', includeIfNull: false, defaultValue: '')
  final String? noteNm;
  @JsonKey(name: 'noteHash', includeIfNull: false)
  final num? noteHash;
  static const fromJsonFactory = _$ActorDeliveryAddressFromJson;
  static const toJsonFactory = _$ActorDeliveryAddressToJson;
  Map<String, dynamic> toJson() => _$ActorDeliveryAddressToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ActorDeliveryAddress &&
            (identical(other.frmNo, frmNo) ||
                const DeepCollectionEquality().equals(other.frmNo, frmNo)) &&
            (identical(other.actNo, actNo) ||
                const DeepCollectionEquality().equals(other.actNo, actNo)) &&
            (identical(other.nm, nm) ||
                const DeepCollectionEquality().equals(other.nm, nm)) &&
            (identical(other.ad1, ad1) ||
                const DeepCollectionEquality().equals(other.ad1, ad1)) &&
            (identical(other.ad2, ad2) ||
                const DeepCollectionEquality().equals(other.ad2, ad2)) &&
            (identical(other.ad4, ad4) ||
                const DeepCollectionEquality().equals(other.ad4, ad4)) &&
            (identical(other.pNo, pNo) ||
                const DeepCollectionEquality().equals(other.pNo, pNo)) &&
            (identical(other.pArea, pArea) ||
                const DeepCollectionEquality().equals(other.pArea, pArea)) &&
            (identical(other.mobPh, mobPh) ||
                const DeepCollectionEquality().equals(other.mobPh, mobPh)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.mailAd, mailAd) ||
                const DeepCollectionEquality().equals(other.mailAd, mailAd)) &&
            (identical(other.ctry, ctry) ||
                const DeepCollectionEquality().equals(other.ctry, ctry)) &&
            (identical(other.noteNm, noteNm) ||
                const DeepCollectionEquality().equals(other.noteNm, noteNm)) &&
            (identical(other.noteHash, noteHash) ||
                const DeepCollectionEquality()
                    .equals(other.noteHash, noteHash)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(frmNo) ^
      const DeepCollectionEquality().hash(actNo) ^
      const DeepCollectionEquality().hash(nm) ^
      const DeepCollectionEquality().hash(ad1) ^
      const DeepCollectionEquality().hash(ad2) ^
      const DeepCollectionEquality().hash(ad4) ^
      const DeepCollectionEquality().hash(pNo) ^
      const DeepCollectionEquality().hash(pArea) ^
      const DeepCollectionEquality().hash(mobPh) ^
      const DeepCollectionEquality().hash(phone) ^
      const DeepCollectionEquality().hash(mailAd) ^
      const DeepCollectionEquality().hash(ctry) ^
      const DeepCollectionEquality().hash(noteNm) ^
      const DeepCollectionEquality().hash(noteHash) ^
      runtimeType.hashCode;
}

extension $ActorDeliveryAddressExtension on ActorDeliveryAddress {
  ActorDeliveryAddress copyWith(
      {int? frmNo,
      int? actNo,
      String? nm,
      String? ad1,
      String? ad2,
      String? ad4,
      String? pNo,
      String? pArea,
      String? mobPh,
      String? phone,
      String? mailAd,
      int? ctry,
      String? noteNm,
      num? noteHash}) {
    return ActorDeliveryAddress(
        frmNo: frmNo ?? this.frmNo,
        actNo: actNo ?? this.actNo,
        nm: nm ?? this.nm,
        ad1: ad1 ?? this.ad1,
        ad2: ad2 ?? this.ad2,
        ad4: ad4 ?? this.ad4,
        pNo: pNo ?? this.pNo,
        pArea: pArea ?? this.pArea,
        mobPh: mobPh ?? this.mobPh,
        phone: phone ?? this.phone,
        mailAd: mailAd ?? this.mailAd,
        ctry: ctry ?? this.ctry,
        noteNm: noteNm ?? this.noteNm,
        noteHash: noteHash ?? this.noteHash);
  }

  ActorDeliveryAddress copyWithWrapped(
      {Wrapped<int?>? frmNo,
      Wrapped<int?>? actNo,
      Wrapped<String?>? nm,
      Wrapped<String?>? ad1,
      Wrapped<String?>? ad2,
      Wrapped<String?>? ad4,
      Wrapped<String?>? pNo,
      Wrapped<String?>? pArea,
      Wrapped<String?>? mobPh,
      Wrapped<String?>? phone,
      Wrapped<String?>? mailAd,
      Wrapped<int?>? ctry,
      Wrapped<String?>? noteNm,
      Wrapped<num?>? noteHash}) {
    return ActorDeliveryAddress(
        frmNo: (frmNo != null ? frmNo.value : this.frmNo),
        actNo: (actNo != null ? actNo.value : this.actNo),
        nm: (nm != null ? nm.value : this.nm),
        ad1: (ad1 != null ? ad1.value : this.ad1),
        ad2: (ad2 != null ? ad2.value : this.ad2),
        ad4: (ad4 != null ? ad4.value : this.ad4),
        pNo: (pNo != null ? pNo.value : this.pNo),
        pArea: (pArea != null ? pArea.value : this.pArea),
        mobPh: (mobPh != null ? mobPh.value : this.mobPh),
        phone: (phone != null ? phone.value : this.phone),
        mailAd: (mailAd != null ? mailAd.value : this.mailAd),
        ctry: (ctry != null ? ctry.value : this.ctry),
        noteNm: (noteNm != null ? noteNm.value : this.noteNm),
        noteHash: (noteHash != null ? noteHash.value : this.noteHash));
  }
}

@JsonSerializable(explicitToJson: true)
class ActorDeliveryAddressIEnumerableResult {
  ActorDeliveryAddressIEnumerableResult({
    this.success,
    this.message,
    this.data,
  });

  factory ActorDeliveryAddressIEnumerableResult.fromJson(
          Map<String, dynamic> json) =>
      _$ActorDeliveryAddressIEnumerableResultFromJson(json);

  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(
      name: 'data',
      includeIfNull: false,
      defaultValue: <ActorDeliveryAddress>[])
  final List<ActorDeliveryAddress>? data;
  static const fromJsonFactory =
      _$ActorDeliveryAddressIEnumerableResultFromJson;
  static const toJsonFactory = _$ActorDeliveryAddressIEnumerableResultToJson;
  Map<String, dynamic> toJson() =>
      _$ActorDeliveryAddressIEnumerableResultToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ActorDeliveryAddressIEnumerableResult &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(data) ^
      runtimeType.hashCode;
}

extension $ActorDeliveryAddressIEnumerableResultExtension
    on ActorDeliveryAddressIEnumerableResult {
  ActorDeliveryAddressIEnumerableResult copyWith(
      {bool? success, String? message, List<ActorDeliveryAddress>? data}) {
    return ActorDeliveryAddressIEnumerableResult(
        success: success ?? this.success,
        message: message ?? this.message,
        data: data ?? this.data);
  }

  ActorDeliveryAddressIEnumerableResult copyWithWrapped(
      {Wrapped<bool?>? success,
      Wrapped<String?>? message,
      Wrapped<List<ActorDeliveryAddress>?>? data}) {
    return ActorDeliveryAddressIEnumerableResult(
        success: (success != null ? success.value : this.success),
        message: (message != null ? message.value : this.message),
        data: (data != null ? data.value : this.data));
  }
}

@JsonSerializable(explicitToJson: true)
class Frm {
  Frm({
    this.frmNo,
    this.nm,
  });

  factory Frm.fromJson(Map<String, dynamic> json) => _$FrmFromJson(json);

  @JsonKey(name: 'frmNo', includeIfNull: false)
  final int? frmNo;
  @JsonKey(name: 'nm', includeIfNull: false, defaultValue: '')
  final String? nm;
  static const fromJsonFactory = _$FrmFromJson;
  static const toJsonFactory = _$FrmToJson;
  Map<String, dynamic> toJson() => _$FrmToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Frm &&
            (identical(other.frmNo, frmNo) ||
                const DeepCollectionEquality().equals(other.frmNo, frmNo)) &&
            (identical(other.nm, nm) ||
                const DeepCollectionEquality().equals(other.nm, nm)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(frmNo) ^
      const DeepCollectionEquality().hash(nm) ^
      runtimeType.hashCode;
}

extension $FrmExtension on Frm {
  Frm copyWith({int? frmNo, String? nm}) {
    return Frm(frmNo: frmNo ?? this.frmNo, nm: nm ?? this.nm);
  }

  Frm copyWithWrapped({Wrapped<int?>? frmNo, Wrapped<String?>? nm}) {
    return Frm(
        frmNo: (frmNo != null ? frmNo.value : this.frmNo),
        nm: (nm != null ? nm.value : this.nm));
  }
}

@JsonSerializable(explicitToJson: true)
class FrmIEnumerableResult {
  FrmIEnumerableResult({
    this.success,
    this.message,
    this.data,
  });

  factory FrmIEnumerableResult.fromJson(Map<String, dynamic> json) =>
      _$FrmIEnumerableResultFromJson(json);

  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'data', includeIfNull: false, defaultValue: <Frm>[])
  final List<Frm>? data;
  static const fromJsonFactory = _$FrmIEnumerableResultFromJson;
  static const toJsonFactory = _$FrmIEnumerableResultToJson;
  Map<String, dynamic> toJson() => _$FrmIEnumerableResultToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FrmIEnumerableResult &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(data) ^
      runtimeType.hashCode;
}

extension $FrmIEnumerableResultExtension on FrmIEnumerableResult {
  FrmIEnumerableResult copyWith(
      {bool? success, String? message, List<Frm>? data}) {
    return FrmIEnumerableResult(
        success: success ?? this.success,
        message: message ?? this.message,
        data: data ?? this.data);
  }

  FrmIEnumerableResult copyWithWrapped(
      {Wrapped<bool?>? success,
      Wrapped<String?>? message,
      Wrapped<List<Frm>?>? data}) {
    return FrmIEnumerableResult(
        success: (success != null ? success.value : this.success),
        message: (message != null ? message.value : this.message),
        data: (data != null ? data.value : this.data));
  }
}

@JsonSerializable(explicitToJson: true)
class Int32IEnumerableResult {
  Int32IEnumerableResult({
    this.success,
    this.message,
    this.data,
  });

  factory Int32IEnumerableResult.fromJson(Map<String, dynamic> json) =>
      _$Int32IEnumerableResultFromJson(json);

  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'data', includeIfNull: false, defaultValue: <int>[])
  final List<int>? data;
  static const fromJsonFactory = _$Int32IEnumerableResultFromJson;
  static const toJsonFactory = _$Int32IEnumerableResultToJson;
  Map<String, dynamic> toJson() => _$Int32IEnumerableResultToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Int32IEnumerableResult &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(data) ^
      runtimeType.hashCode;
}

extension $Int32IEnumerableResultExtension on Int32IEnumerableResult {
  Int32IEnumerableResult copyWith(
      {bool? success, String? message, List<int>? data}) {
    return Int32IEnumerableResult(
        success: success ?? this.success,
        message: message ?? this.message,
        data: data ?? this.data);
  }

  Int32IEnumerableResult copyWithWrapped(
      {Wrapped<bool?>? success,
      Wrapped<String?>? message,
      Wrapped<List<int>?>? data}) {
    return Int32IEnumerableResult(
        success: (success != null ? success.value : this.success),
        message: (message != null ? message.value : this.message),
        data: (data != null ? data.value : this.data));
  }
}

@JsonSerializable(explicitToJson: true)
class Ord {
  Ord({
    this.frmNo,
    this.ordNo,
    this.r1,
    this.r2,
    this.r10,
    this.r11,
    this.empNo,
    this.rsp,
    this.custNo,
    this.nm,
    this.ctry,
    this.delAd1,
    this.delAd2,
    this.delAd4,
    this.delPArea,
    this.cfDelDt,
    this.gr,
    this.gr2,
    this.gr6,
    this.ourRef,
    this.yrRef,
    this.csOrdNo,
    this.label,
    this.inf,
    this.inf2,
    this.inf3,
    this.inf4,
    this.inf5,
    this.inf6,
    this.noteNm,
  });

  factory Ord.fromJson(Map<String, dynamic> json) => _$OrdFromJson(json);

  @JsonKey(name: 'frmNo', includeIfNull: false)
  final int? frmNo;
  @JsonKey(name: 'ordNo', includeIfNull: false)
  final int? ordNo;
  @JsonKey(name: 'r1', includeIfNull: false, defaultValue: '')
  final String? r1;
  @JsonKey(name: 'r2', includeIfNull: false, defaultValue: '')
  final String? r2;
  @JsonKey(name: 'r10', includeIfNull: false, defaultValue: '')
  final String? r10;
  @JsonKey(name: 'r11', includeIfNull: false, defaultValue: '')
  final String? r11;
  @JsonKey(name: 'empNo', includeIfNull: false)
  final int? empNo;
  @JsonKey(name: 'rsp', includeIfNull: false)
  final int? rsp;
  @JsonKey(name: 'custNo', includeIfNull: false)
  final int? custNo;
  @JsonKey(name: 'nm', includeIfNull: false, defaultValue: '')
  final String? nm;
  @JsonKey(name: 'ctry', includeIfNull: false)
  final int? ctry;
  @JsonKey(name: 'delAd1', includeIfNull: false, defaultValue: '')
  final String? delAd1;
  @JsonKey(name: 'delAd2', includeIfNull: false, defaultValue: '')
  final String? delAd2;
  @JsonKey(name: 'delAd4', includeIfNull: false, defaultValue: '')
  final String? delAd4;
  @JsonKey(name: 'delPArea', includeIfNull: false, defaultValue: '')
  final String? delPArea;
  @JsonKey(name: 'cfDelDt', includeIfNull: false)
  final int? cfDelDt;
  @JsonKey(name: 'gr', includeIfNull: false)
  final int? gr;
  @JsonKey(name: 'gr2', includeIfNull: false)
  final int? gr2;
  @JsonKey(name: 'gr6', includeIfNull: false)
  final int? gr6;
  @JsonKey(name: 'ourRef', includeIfNull: false, defaultValue: '')
  final String? ourRef;
  @JsonKey(name: 'yrRef', includeIfNull: false, defaultValue: '')
  final String? yrRef;
  @JsonKey(name: 'csOrdNo', includeIfNull: false, defaultValue: '')
  final String? csOrdNo;
  @JsonKey(name: 'label', includeIfNull: false, defaultValue: '')
  final String? label;
  @JsonKey(name: 'inf', includeIfNull: false, defaultValue: '')
  final String? inf;
  @JsonKey(name: 'inf2', includeIfNull: false, defaultValue: '')
  final String? inf2;
  @JsonKey(name: 'inf3', includeIfNull: false, defaultValue: '')
  final String? inf3;
  @JsonKey(name: 'inf4', includeIfNull: false, defaultValue: '')
  final String? inf4;
  @JsonKey(name: 'inf5', includeIfNull: false, defaultValue: '')
  final String? inf5;
  @JsonKey(name: 'inf6', includeIfNull: false, defaultValue: '')
  final String? inf6;
  @JsonKey(name: 'noteNm', includeIfNull: false, defaultValue: '')
  final String? noteNm;
  static const fromJsonFactory = _$OrdFromJson;
  static const toJsonFactory = _$OrdToJson;
  Map<String, dynamic> toJson() => _$OrdToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Ord &&
            (identical(other.frmNo, frmNo) ||
                const DeepCollectionEquality().equals(other.frmNo, frmNo)) &&
            (identical(other.ordNo, ordNo) ||
                const DeepCollectionEquality().equals(other.ordNo, ordNo)) &&
            (identical(other.r1, r1) ||
                const DeepCollectionEquality().equals(other.r1, r1)) &&
            (identical(other.r2, r2) ||
                const DeepCollectionEquality().equals(other.r2, r2)) &&
            (identical(other.r10, r10) ||
                const DeepCollectionEquality().equals(other.r10, r10)) &&
            (identical(other.r11, r11) ||
                const DeepCollectionEquality().equals(other.r11, r11)) &&
            (identical(other.empNo, empNo) ||
                const DeepCollectionEquality().equals(other.empNo, empNo)) &&
            (identical(other.rsp, rsp) ||
                const DeepCollectionEquality().equals(other.rsp, rsp)) &&
            (identical(other.custNo, custNo) ||
                const DeepCollectionEquality().equals(other.custNo, custNo)) &&
            (identical(other.nm, nm) ||
                const DeepCollectionEquality().equals(other.nm, nm)) &&
            (identical(other.ctry, ctry) ||
                const DeepCollectionEquality().equals(other.ctry, ctry)) &&
            (identical(other.delAd1, delAd1) ||
                const DeepCollectionEquality().equals(other.delAd1, delAd1)) &&
            (identical(other.delAd2, delAd2) ||
                const DeepCollectionEquality().equals(other.delAd2, delAd2)) &&
            (identical(other.delAd4, delAd4) ||
                const DeepCollectionEquality().equals(other.delAd4, delAd4)) &&
            (identical(other.delPArea, delPArea) ||
                const DeepCollectionEquality()
                    .equals(other.delPArea, delPArea)) &&
            (identical(other.cfDelDt, cfDelDt) ||
                const DeepCollectionEquality()
                    .equals(other.cfDelDt, cfDelDt)) &&
            (identical(other.gr, gr) ||
                const DeepCollectionEquality().equals(other.gr, gr)) &&
            (identical(other.gr2, gr2) ||
                const DeepCollectionEquality().equals(other.gr2, gr2)) &&
            (identical(other.gr6, gr6) ||
                const DeepCollectionEquality().equals(other.gr6, gr6)) &&
            (identical(other.ourRef, ourRef) ||
                const DeepCollectionEquality().equals(other.ourRef, ourRef)) &&
            (identical(other.yrRef, yrRef) ||
                const DeepCollectionEquality().equals(other.yrRef, yrRef)) &&
            (identical(other.csOrdNo, csOrdNo) ||
                const DeepCollectionEquality()
                    .equals(other.csOrdNo, csOrdNo)) &&
            (identical(other.label, label) ||
                const DeepCollectionEquality().equals(other.label, label)) &&
            (identical(other.inf, inf) ||
                const DeepCollectionEquality().equals(other.inf, inf)) &&
            (identical(other.inf2, inf2) ||
                const DeepCollectionEquality().equals(other.inf2, inf2)) &&
            (identical(other.inf3, inf3) ||
                const DeepCollectionEquality().equals(other.inf3, inf3)) &&
            (identical(other.inf4, inf4) ||
                const DeepCollectionEquality().equals(other.inf4, inf4)) &&
            (identical(other.inf5, inf5) ||
                const DeepCollectionEquality().equals(other.inf5, inf5)) &&
            (identical(other.inf6, inf6) ||
                const DeepCollectionEquality().equals(other.inf6, inf6)) &&
            (identical(other.noteNm, noteNm) ||
                const DeepCollectionEquality().equals(other.noteNm, noteNm)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(frmNo) ^
      const DeepCollectionEquality().hash(ordNo) ^
      const DeepCollectionEquality().hash(r1) ^
      const DeepCollectionEquality().hash(r2) ^
      const DeepCollectionEquality().hash(r10) ^
      const DeepCollectionEquality().hash(r11) ^
      const DeepCollectionEquality().hash(empNo) ^
      const DeepCollectionEquality().hash(rsp) ^
      const DeepCollectionEquality().hash(custNo) ^
      const DeepCollectionEquality().hash(nm) ^
      const DeepCollectionEquality().hash(ctry) ^
      const DeepCollectionEquality().hash(delAd1) ^
      const DeepCollectionEquality().hash(delAd2) ^
      const DeepCollectionEquality().hash(delAd4) ^
      const DeepCollectionEquality().hash(delPArea) ^
      const DeepCollectionEquality().hash(cfDelDt) ^
      const DeepCollectionEquality().hash(gr) ^
      const DeepCollectionEquality().hash(gr2) ^
      const DeepCollectionEquality().hash(gr6) ^
      const DeepCollectionEquality().hash(ourRef) ^
      const DeepCollectionEquality().hash(yrRef) ^
      const DeepCollectionEquality().hash(csOrdNo) ^
      const DeepCollectionEquality().hash(label) ^
      const DeepCollectionEquality().hash(inf) ^
      const DeepCollectionEquality().hash(inf2) ^
      const DeepCollectionEquality().hash(inf3) ^
      const DeepCollectionEquality().hash(inf4) ^
      const DeepCollectionEquality().hash(inf5) ^
      const DeepCollectionEquality().hash(inf6) ^
      const DeepCollectionEquality().hash(noteNm) ^
      runtimeType.hashCode;
}

extension $OrdExtension on Ord {
  Ord copyWith(
      {int? frmNo,
      int? ordNo,
      String? r1,
      String? r2,
      String? r10,
      String? r11,
      int? empNo,
      int? rsp,
      int? custNo,
      String? nm,
      int? ctry,
      String? delAd1,
      String? delAd2,
      String? delAd4,
      String? delPArea,
      int? cfDelDt,
      int? gr,
      int? gr2,
      int? gr6,
      String? ourRef,
      String? yrRef,
      String? csOrdNo,
      String? label,
      String? inf,
      String? inf2,
      String? inf3,
      String? inf4,
      String? inf5,
      String? inf6,
      String? noteNm}) {
    return Ord(
        frmNo: frmNo ?? this.frmNo,
        ordNo: ordNo ?? this.ordNo,
        r1: r1 ?? this.r1,
        r2: r2 ?? this.r2,
        r10: r10 ?? this.r10,
        r11: r11 ?? this.r11,
        empNo: empNo ?? this.empNo,
        rsp: rsp ?? this.rsp,
        custNo: custNo ?? this.custNo,
        nm: nm ?? this.nm,
        ctry: ctry ?? this.ctry,
        delAd1: delAd1 ?? this.delAd1,
        delAd2: delAd2 ?? this.delAd2,
        delAd4: delAd4 ?? this.delAd4,
        delPArea: delPArea ?? this.delPArea,
        cfDelDt: cfDelDt ?? this.cfDelDt,
        gr: gr ?? this.gr,
        gr2: gr2 ?? this.gr2,
        gr6: gr6 ?? this.gr6,
        ourRef: ourRef ?? this.ourRef,
        yrRef: yrRef ?? this.yrRef,
        csOrdNo: csOrdNo ?? this.csOrdNo,
        label: label ?? this.label,
        inf: inf ?? this.inf,
        inf2: inf2 ?? this.inf2,
        inf3: inf3 ?? this.inf3,
        inf4: inf4 ?? this.inf4,
        inf5: inf5 ?? this.inf5,
        inf6: inf6 ?? this.inf6,
        noteNm: noteNm ?? this.noteNm);
  }

  Ord copyWithWrapped(
      {Wrapped<int?>? frmNo,
      Wrapped<int?>? ordNo,
      Wrapped<String?>? r1,
      Wrapped<String?>? r2,
      Wrapped<String?>? r10,
      Wrapped<String?>? r11,
      Wrapped<int?>? empNo,
      Wrapped<int?>? rsp,
      Wrapped<int?>? custNo,
      Wrapped<String?>? nm,
      Wrapped<int?>? ctry,
      Wrapped<String?>? delAd1,
      Wrapped<String?>? delAd2,
      Wrapped<String?>? delAd4,
      Wrapped<String?>? delPArea,
      Wrapped<int?>? cfDelDt,
      Wrapped<int?>? gr,
      Wrapped<int?>? gr2,
      Wrapped<int?>? gr6,
      Wrapped<String?>? ourRef,
      Wrapped<String?>? yrRef,
      Wrapped<String?>? csOrdNo,
      Wrapped<String?>? label,
      Wrapped<String?>? inf,
      Wrapped<String?>? inf2,
      Wrapped<String?>? inf3,
      Wrapped<String?>? inf4,
      Wrapped<String?>? inf5,
      Wrapped<String?>? inf6,
      Wrapped<String?>? noteNm}) {
    return Ord(
        frmNo: (frmNo != null ? frmNo.value : this.frmNo),
        ordNo: (ordNo != null ? ordNo.value : this.ordNo),
        r1: (r1 != null ? r1.value : this.r1),
        r2: (r2 != null ? r2.value : this.r2),
        r10: (r10 != null ? r10.value : this.r10),
        r11: (r11 != null ? r11.value : this.r11),
        empNo: (empNo != null ? empNo.value : this.empNo),
        rsp: (rsp != null ? rsp.value : this.rsp),
        custNo: (custNo != null ? custNo.value : this.custNo),
        nm: (nm != null ? nm.value : this.nm),
        ctry: (ctry != null ? ctry.value : this.ctry),
        delAd1: (delAd1 != null ? delAd1.value : this.delAd1),
        delAd2: (delAd2 != null ? delAd2.value : this.delAd2),
        delAd4: (delAd4 != null ? delAd4.value : this.delAd4),
        delPArea: (delPArea != null ? delPArea.value : this.delPArea),
        cfDelDt: (cfDelDt != null ? cfDelDt.value : this.cfDelDt),
        gr: (gr != null ? gr.value : this.gr),
        gr2: (gr2 != null ? gr2.value : this.gr2),
        gr6: (gr6 != null ? gr6.value : this.gr6),
        ourRef: (ourRef != null ? ourRef.value : this.ourRef),
        yrRef: (yrRef != null ? yrRef.value : this.yrRef),
        csOrdNo: (csOrdNo != null ? csOrdNo.value : this.csOrdNo),
        label: (label != null ? label.value : this.label),
        inf: (inf != null ? inf.value : this.inf),
        inf2: (inf2 != null ? inf2.value : this.inf2),
        inf3: (inf3 != null ? inf3.value : this.inf3),
        inf4: (inf4 != null ? inf4.value : this.inf4),
        inf5: (inf5 != null ? inf5.value : this.inf5),
        inf6: (inf6 != null ? inf6.value : this.inf6),
        noteNm: (noteNm != null ? noteNm.value : this.noteNm));
  }
}

@JsonSerializable(explicitToJson: true)
class OrdLn {
  OrdLn({
    this.frmNo,
    this.ordNo,
    this.lnNo,
    this.prodNo,
    this.descr,
    this.r1,
    this.cfDelDt,
    this.durDt,
    this.noteNm,
    this.noteHash,
  });

  factory OrdLn.fromJson(Map<String, dynamic> json) => _$OrdLnFromJson(json);

  @JsonKey(name: 'frmNo', includeIfNull: false)
  final int? frmNo;
  @JsonKey(name: 'ordNo', includeIfNull: false)
  final int? ordNo;
  @JsonKey(name: 'lnNo', includeIfNull: false)
  final int? lnNo;
  @JsonKey(name: 'prodNo', includeIfNull: false, defaultValue: '')
  final String? prodNo;
  @JsonKey(name: 'descr', includeIfNull: false, defaultValue: '')
  final String? descr;
  @JsonKey(name: 'r1', includeIfNull: false)
  final int? r1;
  @JsonKey(name: 'cfDelDt', includeIfNull: false)
  final int? cfDelDt;
  @JsonKey(name: 'durDt', includeIfNull: false)
  final int? durDt;
  @JsonKey(name: 'noteNm', includeIfNull: false, defaultValue: '')
  final String? noteNm;
  @JsonKey(name: 'noteHash', includeIfNull: false)
  final num? noteHash;
  static const fromJsonFactory = _$OrdLnFromJson;
  static const toJsonFactory = _$OrdLnToJson;
  Map<String, dynamic> toJson() => _$OrdLnToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OrdLn &&
            (identical(other.frmNo, frmNo) ||
                const DeepCollectionEquality().equals(other.frmNo, frmNo)) &&
            (identical(other.ordNo, ordNo) ||
                const DeepCollectionEquality().equals(other.ordNo, ordNo)) &&
            (identical(other.lnNo, lnNo) ||
                const DeepCollectionEquality().equals(other.lnNo, lnNo)) &&
            (identical(other.prodNo, prodNo) ||
                const DeepCollectionEquality().equals(other.prodNo, prodNo)) &&
            (identical(other.descr, descr) ||
                const DeepCollectionEquality().equals(other.descr, descr)) &&
            (identical(other.r1, r1) ||
                const DeepCollectionEquality().equals(other.r1, r1)) &&
            (identical(other.cfDelDt, cfDelDt) ||
                const DeepCollectionEquality()
                    .equals(other.cfDelDt, cfDelDt)) &&
            (identical(other.durDt, durDt) ||
                const DeepCollectionEquality().equals(other.durDt, durDt)) &&
            (identical(other.noteNm, noteNm) ||
                const DeepCollectionEquality().equals(other.noteNm, noteNm)) &&
            (identical(other.noteHash, noteHash) ||
                const DeepCollectionEquality()
                    .equals(other.noteHash, noteHash)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(frmNo) ^
      const DeepCollectionEquality().hash(ordNo) ^
      const DeepCollectionEquality().hash(lnNo) ^
      const DeepCollectionEquality().hash(prodNo) ^
      const DeepCollectionEquality().hash(descr) ^
      const DeepCollectionEquality().hash(r1) ^
      const DeepCollectionEquality().hash(cfDelDt) ^
      const DeepCollectionEquality().hash(durDt) ^
      const DeepCollectionEquality().hash(noteNm) ^
      const DeepCollectionEquality().hash(noteHash) ^
      runtimeType.hashCode;
}

extension $OrdLnExtension on OrdLn {
  OrdLn copyWith(
      {int? frmNo,
      int? ordNo,
      int? lnNo,
      String? prodNo,
      String? descr,
      int? r1,
      int? cfDelDt,
      int? durDt,
      String? noteNm,
      num? noteHash}) {
    return OrdLn(
        frmNo: frmNo ?? this.frmNo,
        ordNo: ordNo ?? this.ordNo,
        lnNo: lnNo ?? this.lnNo,
        prodNo: prodNo ?? this.prodNo,
        descr: descr ?? this.descr,
        r1: r1 ?? this.r1,
        cfDelDt: cfDelDt ?? this.cfDelDt,
        durDt: durDt ?? this.durDt,
        noteNm: noteNm ?? this.noteNm,
        noteHash: noteHash ?? this.noteHash);
  }

  OrdLn copyWithWrapped(
      {Wrapped<int?>? frmNo,
      Wrapped<int?>? ordNo,
      Wrapped<int?>? lnNo,
      Wrapped<String?>? prodNo,
      Wrapped<String?>? descr,
      Wrapped<int?>? r1,
      Wrapped<int?>? cfDelDt,
      Wrapped<int?>? durDt,
      Wrapped<String?>? noteNm,
      Wrapped<num?>? noteHash}) {
    return OrdLn(
        frmNo: (frmNo != null ? frmNo.value : this.frmNo),
        ordNo: (ordNo != null ? ordNo.value : this.ordNo),
        lnNo: (lnNo != null ? lnNo.value : this.lnNo),
        prodNo: (prodNo != null ? prodNo.value : this.prodNo),
        descr: (descr != null ? descr.value : this.descr),
        r1: (r1 != null ? r1.value : this.r1),
        cfDelDt: (cfDelDt != null ? cfDelDt.value : this.cfDelDt),
        durDt: (durDt != null ? durDt.value : this.durDt),
        noteNm: (noteNm != null ? noteNm.value : this.noteNm),
        noteHash: (noteHash != null ? noteHash.value : this.noteHash));
  }
}

@JsonSerializable(explicitToJson: true)
class Prod {
  Prod({
    this.prodNo,
    this.descr,
    this.prodTp3,
    this.prodGr,
    this.prodPrG2,
    this.stSaleUn,
    this.webPg2,
    this.r3,
    this.r4,
    this.procMt,
    this.excPrint,
    this.editPref,
    this.edFmt,
    this.specFunc,
  });

  factory Prod.fromJson(Map<String, dynamic> json) => _$ProdFromJson(json);

  @JsonKey(name: 'prodNo', includeIfNull: false, defaultValue: '')
  final String? prodNo;
  @JsonKey(name: 'descr', includeIfNull: false, defaultValue: '')
  final String? descr;
  @JsonKey(name: 'prodTp3', includeIfNull: false)
  final int? prodTp3;
  @JsonKey(name: 'prodGr', includeIfNull: false)
  final int? prodGr;
  @JsonKey(name: 'prodPrG2', includeIfNull: false)
  final int? prodPrG2;
  @JsonKey(name: 'stSaleUn', includeIfNull: false)
  final int? stSaleUn;
  @JsonKey(name: 'webPg2', includeIfNull: false, defaultValue: '')
  final String? webPg2;
  @JsonKey(name: 'r3', includeIfNull: false)
  final int? r3;
  @JsonKey(name: 'r4', includeIfNull: false)
  final int? r4;
  @JsonKey(name: 'procMt', includeIfNull: false)
  final int? procMt;
  @JsonKey(name: 'excPrint', includeIfNull: false)
  final int? excPrint;
  @JsonKey(name: 'editPref', includeIfNull: false)
  final int? editPref;
  @JsonKey(name: 'edFmt', includeIfNull: false)
  final int? edFmt;
  @JsonKey(name: 'specFunc', includeIfNull: false)
  final int? specFunc;
  static const fromJsonFactory = _$ProdFromJson;
  static const toJsonFactory = _$ProdToJson;
  Map<String, dynamic> toJson() => _$ProdToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Prod &&
            (identical(other.prodNo, prodNo) ||
                const DeepCollectionEquality().equals(other.prodNo, prodNo)) &&
            (identical(other.descr, descr) ||
                const DeepCollectionEquality().equals(other.descr, descr)) &&
            (identical(other.prodTp3, prodTp3) ||
                const DeepCollectionEquality()
                    .equals(other.prodTp3, prodTp3)) &&
            (identical(other.prodGr, prodGr) ||
                const DeepCollectionEquality().equals(other.prodGr, prodGr)) &&
            (identical(other.prodPrG2, prodPrG2) ||
                const DeepCollectionEquality()
                    .equals(other.prodPrG2, prodPrG2)) &&
            (identical(other.stSaleUn, stSaleUn) ||
                const DeepCollectionEquality()
                    .equals(other.stSaleUn, stSaleUn)) &&
            (identical(other.webPg2, webPg2) ||
                const DeepCollectionEquality().equals(other.webPg2, webPg2)) &&
            (identical(other.r3, r3) ||
                const DeepCollectionEquality().equals(other.r3, r3)) &&
            (identical(other.r4, r4) ||
                const DeepCollectionEquality().equals(other.r4, r4)) &&
            (identical(other.procMt, procMt) ||
                const DeepCollectionEquality().equals(other.procMt, procMt)) &&
            (identical(other.excPrint, excPrint) ||
                const DeepCollectionEquality()
                    .equals(other.excPrint, excPrint)) &&
            (identical(other.editPref, editPref) ||
                const DeepCollectionEquality()
                    .equals(other.editPref, editPref)) &&
            (identical(other.edFmt, edFmt) ||
                const DeepCollectionEquality().equals(other.edFmt, edFmt)) &&
            (identical(other.specFunc, specFunc) ||
                const DeepCollectionEquality()
                    .equals(other.specFunc, specFunc)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(prodNo) ^
      const DeepCollectionEquality().hash(descr) ^
      const DeepCollectionEquality().hash(prodTp3) ^
      const DeepCollectionEquality().hash(prodGr) ^
      const DeepCollectionEquality().hash(prodPrG2) ^
      const DeepCollectionEquality().hash(stSaleUn) ^
      const DeepCollectionEquality().hash(webPg2) ^
      const DeepCollectionEquality().hash(r3) ^
      const DeepCollectionEquality().hash(r4) ^
      const DeepCollectionEquality().hash(procMt) ^
      const DeepCollectionEquality().hash(excPrint) ^
      const DeepCollectionEquality().hash(editPref) ^
      const DeepCollectionEquality().hash(edFmt) ^
      const DeepCollectionEquality().hash(specFunc) ^
      runtimeType.hashCode;
}

extension $ProdExtension on Prod {
  Prod copyWith(
      {String? prodNo,
      String? descr,
      int? prodTp3,
      int? prodGr,
      int? prodPrG2,
      int? stSaleUn,
      String? webPg2,
      int? r3,
      int? r4,
      int? procMt,
      int? excPrint,
      int? editPref,
      int? edFmt,
      int? specFunc}) {
    return Prod(
        prodNo: prodNo ?? this.prodNo,
        descr: descr ?? this.descr,
        prodTp3: prodTp3 ?? this.prodTp3,
        prodGr: prodGr ?? this.prodGr,
        prodPrG2: prodPrG2 ?? this.prodPrG2,
        stSaleUn: stSaleUn ?? this.stSaleUn,
        webPg2: webPg2 ?? this.webPg2,
        r3: r3 ?? this.r3,
        r4: r4 ?? this.r4,
        procMt: procMt ?? this.procMt,
        excPrint: excPrint ?? this.excPrint,
        editPref: editPref ?? this.editPref,
        edFmt: edFmt ?? this.edFmt,
        specFunc: specFunc ?? this.specFunc);
  }

  Prod copyWithWrapped(
      {Wrapped<String?>? prodNo,
      Wrapped<String?>? descr,
      Wrapped<int?>? prodTp3,
      Wrapped<int?>? prodGr,
      Wrapped<int?>? prodPrG2,
      Wrapped<int?>? stSaleUn,
      Wrapped<String?>? webPg2,
      Wrapped<int?>? r3,
      Wrapped<int?>? r4,
      Wrapped<int?>? procMt,
      Wrapped<int?>? excPrint,
      Wrapped<int?>? editPref,
      Wrapped<int?>? edFmt,
      Wrapped<int?>? specFunc}) {
    return Prod(
        prodNo: (prodNo != null ? prodNo.value : this.prodNo),
        descr: (descr != null ? descr.value : this.descr),
        prodTp3: (prodTp3 != null ? prodTp3.value : this.prodTp3),
        prodGr: (prodGr != null ? prodGr.value : this.prodGr),
        prodPrG2: (prodPrG2 != null ? prodPrG2.value : this.prodPrG2),
        stSaleUn: (stSaleUn != null ? stSaleUn.value : this.stSaleUn),
        webPg2: (webPg2 != null ? webPg2.value : this.webPg2),
        r3: (r3 != null ? r3.value : this.r3),
        r4: (r4 != null ? r4.value : this.r4),
        procMt: (procMt != null ? procMt.value : this.procMt),
        excPrint: (excPrint != null ? excPrint.value : this.excPrint),
        editPref: (editPref != null ? editPref.value : this.editPref),
        edFmt: (edFmt != null ? edFmt.value : this.edFmt),
        specFunc: (specFunc != null ? specFunc.value : this.specFunc));
  }
}

@JsonSerializable(explicitToJson: true)
class ProdIEnumerableResult {
  ProdIEnumerableResult({
    this.success,
    this.message,
    this.data,
  });

  factory ProdIEnumerableResult.fromJson(Map<String, dynamic> json) =>
      _$ProdIEnumerableResultFromJson(json);

  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'data', includeIfNull: false, defaultValue: <Prod>[])
  final List<Prod>? data;
  static const fromJsonFactory = _$ProdIEnumerableResultFromJson;
  static const toJsonFactory = _$ProdIEnumerableResultToJson;
  Map<String, dynamic> toJson() => _$ProdIEnumerableResultToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProdIEnumerableResult &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(data) ^
      runtimeType.hashCode;
}

extension $ProdIEnumerableResultExtension on ProdIEnumerableResult {
  ProdIEnumerableResult copyWith(
      {bool? success, String? message, List<Prod>? data}) {
    return ProdIEnumerableResult(
        success: success ?? this.success,
        message: message ?? this.message,
        data: data ?? this.data);
  }

  ProdIEnumerableResult copyWithWrapped(
      {Wrapped<bool?>? success,
      Wrapped<String?>? message,
      Wrapped<List<Prod>?>? data}) {
    return ProdIEnumerableResult(
        success: (success != null ? success.value : this.success),
        message: (message != null ? message.value : this.message),
        data: (data != null ? data.value : this.data));
  }
}

@JsonSerializable(explicitToJson: true)
class ProdResult {
  ProdResult({
    this.success,
    this.message,
    this.data,
  });

  factory ProdResult.fromJson(Map<String, dynamic> json) =>
      _$ProdResultFromJson(json);

  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'data', includeIfNull: false)
  final Prod? data;
  static const fromJsonFactory = _$ProdResultFromJson;
  static const toJsonFactory = _$ProdResultToJson;
  Map<String, dynamic> toJson() => _$ProdResultToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProdResult &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(data) ^
      runtimeType.hashCode;
}

extension $ProdResultExtension on ProdResult {
  ProdResult copyWith({bool? success, String? message, Prod? data}) {
    return ProdResult(
        success: success ?? this.success,
        message: message ?? this.message,
        data: data ?? this.data);
  }

  ProdResult copyWithWrapped(
      {Wrapped<bool?>? success,
      Wrapped<String?>? message,
      Wrapped<Prod?>? data}) {
    return ProdResult(
        success: (success != null ? success.value : this.success),
        message: (message != null ? message.value : this.message),
        data: (data != null ? data.value : this.data));
  }
}

@JsonSerializable(explicitToJson: true)
class R1 {
  R1({
    this.rNo,
    this.r10,
    this.nm,
    this.mailAd,
  });

  factory R1.fromJson(Map<String, dynamic> json) => _$R1FromJson(json);

  @JsonKey(name: 'rNo', includeIfNull: false)
  final int? rNo;
  @JsonKey(name: 'r10', includeIfNull: false, defaultValue: '')
  final String? r10;
  @JsonKey(name: 'nm', includeIfNull: false, defaultValue: '')
  final String? nm;
  @JsonKey(name: 'mailAd', includeIfNull: false, defaultValue: '')
  final String? mailAd;
  static const fromJsonFactory = _$R1FromJson;
  static const toJsonFactory = _$R1ToJson;
  Map<String, dynamic> toJson() => _$R1ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is R1 &&
            (identical(other.rNo, rNo) ||
                const DeepCollectionEquality().equals(other.rNo, rNo)) &&
            (identical(other.r10, r10) ||
                const DeepCollectionEquality().equals(other.r10, r10)) &&
            (identical(other.nm, nm) ||
                const DeepCollectionEquality().equals(other.nm, nm)) &&
            (identical(other.mailAd, mailAd) ||
                const DeepCollectionEquality().equals(other.mailAd, mailAd)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(rNo) ^
      const DeepCollectionEquality().hash(r10) ^
      const DeepCollectionEquality().hash(nm) ^
      const DeepCollectionEquality().hash(mailAd) ^
      runtimeType.hashCode;
}

extension $R1Extension on R1 {
  R1 copyWith({int? rNo, String? r10, String? nm, String? mailAd}) {
    return R1(
        rNo: rNo ?? this.rNo,
        r10: r10 ?? this.r10,
        nm: nm ?? this.nm,
        mailAd: mailAd ?? this.mailAd);
  }

  R1 copyWithWrapped(
      {Wrapped<int?>? rNo,
      Wrapped<String?>? r10,
      Wrapped<String?>? nm,
      Wrapped<String?>? mailAd}) {
    return R1(
        rNo: (rNo != null ? rNo.value : this.rNo),
        r10: (r10 != null ? r10.value : this.r10),
        nm: (nm != null ? nm.value : this.nm),
        mailAd: (mailAd != null ? mailAd.value : this.mailAd));
  }
}

@JsonSerializable(explicitToJson: true)
class R10 {
  R10({
    this.rNo,
    this.nm,
    this.mailAd,
  });

  factory R10.fromJson(Map<String, dynamic> json) => _$R10FromJson(json);

  @JsonKey(name: 'rNo', includeIfNull: false, defaultValue: '')
  final String? rNo;
  @JsonKey(name: 'nm', includeIfNull: false, defaultValue: '')
  final String? nm;
  @JsonKey(name: 'mailAd', includeIfNull: false, defaultValue: '')
  final String? mailAd;
  static const fromJsonFactory = _$R10FromJson;
  static const toJsonFactory = _$R10ToJson;
  Map<String, dynamic> toJson() => _$R10ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is R10 &&
            (identical(other.rNo, rNo) ||
                const DeepCollectionEquality().equals(other.rNo, rNo)) &&
            (identical(other.nm, nm) ||
                const DeepCollectionEquality().equals(other.nm, nm)) &&
            (identical(other.mailAd, mailAd) ||
                const DeepCollectionEquality().equals(other.mailAd, mailAd)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(rNo) ^
      const DeepCollectionEquality().hash(nm) ^
      const DeepCollectionEquality().hash(mailAd) ^
      runtimeType.hashCode;
}

extension $R10Extension on R10 {
  R10 copyWith({String? rNo, String? nm, String? mailAd}) {
    return R10(
        rNo: rNo ?? this.rNo, nm: nm ?? this.nm, mailAd: mailAd ?? this.mailAd);
  }

  R10 copyWithWrapped(
      {Wrapped<String?>? rNo, Wrapped<String?>? nm, Wrapped<String?>? mailAd}) {
    return R10(
        rNo: (rNo != null ? rNo.value : this.rNo),
        nm: (nm != null ? nm.value : this.nm),
        mailAd: (mailAd != null ? mailAd.value : this.mailAd));
  }
}

@JsonSerializable(explicitToJson: true)
class R10IEnumerableResult {
  R10IEnumerableResult({
    this.success,
    this.message,
    this.data,
  });

  factory R10IEnumerableResult.fromJson(Map<String, dynamic> json) =>
      _$R10IEnumerableResultFromJson(json);

  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'data', includeIfNull: false, defaultValue: <R10>[])
  final List<R10>? data;
  static const fromJsonFactory = _$R10IEnumerableResultFromJson;
  static const toJsonFactory = _$R10IEnumerableResultToJson;
  Map<String, dynamic> toJson() => _$R10IEnumerableResultToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is R10IEnumerableResult &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(data) ^
      runtimeType.hashCode;
}

extension $R10IEnumerableResultExtension on R10IEnumerableResult {
  R10IEnumerableResult copyWith(
      {bool? success, String? message, List<R10>? data}) {
    return R10IEnumerableResult(
        success: success ?? this.success,
        message: message ?? this.message,
        data: data ?? this.data);
  }

  R10IEnumerableResult copyWithWrapped(
      {Wrapped<bool?>? success,
      Wrapped<String?>? message,
      Wrapped<List<R10>?>? data}) {
    return R10IEnumerableResult(
        success: (success != null ? success.value : this.success),
        message: (message != null ? message.value : this.message),
        data: (data != null ? data.value : this.data));
  }
}

@JsonSerializable(explicitToJson: true)
class R1IEnumerableResult {
  R1IEnumerableResult({
    this.success,
    this.message,
    this.data,
  });

  factory R1IEnumerableResult.fromJson(Map<String, dynamic> json) =>
      _$R1IEnumerableResultFromJson(json);

  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'data', includeIfNull: false, defaultValue: <R1>[])
  final List<R1>? data;
  static const fromJsonFactory = _$R1IEnumerableResultFromJson;
  static const toJsonFactory = _$R1IEnumerableResultToJson;
  Map<String, dynamic> toJson() => _$R1IEnumerableResultToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is R1IEnumerableResult &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(data) ^
      runtimeType.hashCode;
}

extension $R1IEnumerableResultExtension on R1IEnumerableResult {
  R1IEnumerableResult copyWith(
      {bool? success, String? message, List<R1>? data}) {
    return R1IEnumerableResult(
        success: success ?? this.success,
        message: message ?? this.message,
        data: data ?? this.data);
  }

  R1IEnumerableResult copyWithWrapped(
      {Wrapped<bool?>? success,
      Wrapped<String?>? message,
      Wrapped<List<R1>?>? data}) {
    return R1IEnumerableResult(
        success: (success != null ? success.value : this.success),
        message: (message != null ? message.value : this.message),
        data: (data != null ? data.value : this.data));
  }
}

@JsonSerializable(explicitToJson: true)
class R1Result {
  R1Result({
    this.success,
    this.message,
    this.data,
  });

  factory R1Result.fromJson(Map<String, dynamic> json) =>
      _$R1ResultFromJson(json);

  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'data', includeIfNull: false)
  final R1? data;
  static const fromJsonFactory = _$R1ResultFromJson;
  static const toJsonFactory = _$R1ResultToJson;
  Map<String, dynamic> toJson() => _$R1ResultToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is R1Result &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(data) ^
      runtimeType.hashCode;
}

extension $R1ResultExtension on R1Result {
  R1Result copyWith({bool? success, String? message, R1? data}) {
    return R1Result(
        success: success ?? this.success,
        message: message ?? this.message,
        data: data ?? this.data);
  }

  R1Result copyWithWrapped(
      {Wrapped<bool?>? success,
      Wrapped<String?>? message,
      Wrapped<R1?>? data}) {
    return R1Result(
        success: (success != null ? success.value : this.success),
        message: (message != null ? message.value : this.message),
        data: (data != null ? data.value : this.data));
  }
}

@JsonSerializable(explicitToJson: true)
class StringInt32IDictionaryResult {
  StringInt32IDictionaryResult({
    this.success,
    this.message,
    this.data,
  });

  factory StringInt32IDictionaryResult.fromJson(Map<String, dynamic> json) =>
      _$StringInt32IDictionaryResultFromJson(json);

  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'data', includeIfNull: false)
  final Map<String, dynamic>? data;
  static const fromJsonFactory = _$StringInt32IDictionaryResultFromJson;
  static const toJsonFactory = _$StringInt32IDictionaryResultToJson;
  Map<String, dynamic> toJson() => _$StringInt32IDictionaryResultToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StringInt32IDictionaryResult &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(data) ^
      runtimeType.hashCode;
}

extension $StringInt32IDictionaryResultExtension
    on StringInt32IDictionaryResult {
  StringInt32IDictionaryResult copyWith(
      {bool? success, String? message, Map<String, dynamic>? data}) {
    return StringInt32IDictionaryResult(
        success: success ?? this.success,
        message: message ?? this.message,
        data: data ?? this.data);
  }

  StringInt32IDictionaryResult copyWithWrapped(
      {Wrapped<bool?>? success,
      Wrapped<String?>? message,
      Wrapped<Map<String, dynamic>?>? data}) {
    return StringInt32IDictionaryResult(
        success: (success != null ? success.value : this.success),
        message: (message != null ? message.value : this.message),
        data: (data != null ? data.value : this.data));
  }
}

@JsonSerializable(explicitToJson: true)
class StringResult {
  StringResult({
    this.success,
    this.message,
    this.data,
  });

  factory StringResult.fromJson(Map<String, dynamic> json) =>
      _$StringResultFromJson(json);

  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'data', includeIfNull: false, defaultValue: '')
  final String? data;
  static const fromJsonFactory = _$StringResultFromJson;
  static const toJsonFactory = _$StringResultToJson;
  Map<String, dynamic> toJson() => _$StringResultToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StringResult &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(data) ^
      runtimeType.hashCode;
}

extension $StringResultExtension on StringResult {
  StringResult copyWith({bool? success, String? message, String? data}) {
    return StringResult(
        success: success ?? this.success,
        message: message ?? this.message,
        data: data ?? this.data);
  }

  StringResult copyWithWrapped(
      {Wrapped<bool?>? success,
      Wrapped<String?>? message,
      Wrapped<String?>? data}) {
    return StringResult(
        success: (success != null ? success.value : this.success),
        message: (message != null ? message.value : this.message),
        data: (data != null ? data.value : this.data));
  }
}

@JsonSerializable(explicitToJson: true)
class Txt {
  Txt({
    this.txtNo,
    this.txt,
  });

  factory Txt.fromJson(Map<String, dynamic> json) => _$TxtFromJson(json);

  @JsonKey(name: 'txtNo', includeIfNull: false)
  final int? txtNo;
  @JsonKey(name: 'txt', includeIfNull: false, defaultValue: '')
  final String? txt;
  static const fromJsonFactory = _$TxtFromJson;
  static const toJsonFactory = _$TxtToJson;
  Map<String, dynamic> toJson() => _$TxtToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Txt &&
            (identical(other.txtNo, txtNo) ||
                const DeepCollectionEquality().equals(other.txtNo, txtNo)) &&
            (identical(other.txt, txt) ||
                const DeepCollectionEquality().equals(other.txt, txt)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(txtNo) ^
      const DeepCollectionEquality().hash(txt) ^
      runtimeType.hashCode;
}

extension $TxtExtension on Txt {
  Txt copyWith({int? txtNo, String? txt}) {
    return Txt(txtNo: txtNo ?? this.txtNo, txt: txt ?? this.txt);
  }

  Txt copyWithWrapped({Wrapped<int?>? txtNo, Wrapped<String?>? txt}) {
    return Txt(
        txtNo: (txtNo != null ? txtNo.value : this.txtNo),
        txt: (txt != null ? txt.value : this.txt));
  }
}

@JsonSerializable(explicitToJson: true)
class TxtIEnumerableResult {
  TxtIEnumerableResult({
    this.success,
    this.message,
    this.data,
  });

  factory TxtIEnumerableResult.fromJson(Map<String, dynamic> json) =>
      _$TxtIEnumerableResultFromJson(json);

  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'data', includeIfNull: false, defaultValue: <Txt>[])
  final List<Txt>? data;
  static const fromJsonFactory = _$TxtIEnumerableResultFromJson;
  static const toJsonFactory = _$TxtIEnumerableResultToJson;
  Map<String, dynamic> toJson() => _$TxtIEnumerableResultToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TxtIEnumerableResult &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(data) ^
      runtimeType.hashCode;
}

extension $TxtIEnumerableResultExtension on TxtIEnumerableResult {
  TxtIEnumerableResult copyWith(
      {bool? success, String? message, List<Txt>? data}) {
    return TxtIEnumerableResult(
        success: success ?? this.success,
        message: message ?? this.message,
        data: data ?? this.data);
  }

  TxtIEnumerableResult copyWithWrapped(
      {Wrapped<bool?>? success,
      Wrapped<String?>? message,
      Wrapped<List<Txt>?>? data}) {
    return TxtIEnumerableResult(
        success: (success != null ? success.value : this.success),
        message: (message != null ? message.value : this.message),
        data: (data != null ? data.value : this.data));
  }
}

@JsonSerializable(explicitToJson: true)
class Unit {
  Unit({
    this.un,
    this.descr,
  });

  factory Unit.fromJson(Map<String, dynamic> json) => _$UnitFromJson(json);

  @JsonKey(name: 'un', includeIfNull: false)
  final int? un;
  @JsonKey(name: 'descr', includeIfNull: false, defaultValue: '')
  final String? descr;
  static const fromJsonFactory = _$UnitFromJson;
  static const toJsonFactory = _$UnitToJson;
  Map<String, dynamic> toJson() => _$UnitToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Unit &&
            (identical(other.un, un) ||
                const DeepCollectionEquality().equals(other.un, un)) &&
            (identical(other.descr, descr) ||
                const DeepCollectionEquality().equals(other.descr, descr)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(un) ^
      const DeepCollectionEquality().hash(descr) ^
      runtimeType.hashCode;
}

extension $UnitExtension on Unit {
  Unit copyWith({int? un, String? descr}) {
    return Unit(un: un ?? this.un, descr: descr ?? this.descr);
  }

  Unit copyWithWrapped({Wrapped<int?>? un, Wrapped<String?>? descr}) {
    return Unit(
        un: (un != null ? un.value : this.un),
        descr: (descr != null ? descr.value : this.descr));
  }
}

@JsonSerializable(explicitToJson: true)
class UnitIEnumerableResult {
  UnitIEnumerableResult({
    this.success,
    this.message,
    this.data,
  });

  factory UnitIEnumerableResult.fromJson(Map<String, dynamic> json) =>
      _$UnitIEnumerableResultFromJson(json);

  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'data', includeIfNull: false, defaultValue: <Unit>[])
  final List<Unit>? data;
  static const fromJsonFactory = _$UnitIEnumerableResultFromJson;
  static const toJsonFactory = _$UnitIEnumerableResultToJson;
  Map<String, dynamic> toJson() => _$UnitIEnumerableResultToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UnitIEnumerableResult &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(data) ^
      runtimeType.hashCode;
}

extension $UnitIEnumerableResultExtension on UnitIEnumerableResult {
  UnitIEnumerableResult copyWith(
      {bool? success, String? message, List<Unit>? data}) {
    return UnitIEnumerableResult(
        success: success ?? this.success,
        message: message ?? this.message,
        data: data ?? this.data);
  }

  UnitIEnumerableResult copyWithWrapped(
      {Wrapped<bool?>? success,
      Wrapped<String?>? message,
      Wrapped<List<Unit>?>? data}) {
    return UnitIEnumerableResult(
        success: (success != null ? success.value : this.success),
        message: (message != null ? message.value : this.message),
        data: (data != null ? data.value : this.data));
  }
}

@JsonSerializable(explicitToJson: true)
class Work {
  Work({
    this.ords,
    this.ordLns,
  });

  factory Work.fromJson(Map<String, dynamic> json) => _$WorkFromJson(json);

  @JsonKey(name: 'ords', includeIfNull: false, defaultValue: <Ord>[])
  final List<Ord>? ords;
  @JsonKey(name: 'ordLns', includeIfNull: false, defaultValue: <OrdLn>[])
  final List<OrdLn>? ordLns;
  static const fromJsonFactory = _$WorkFromJson;
  static const toJsonFactory = _$WorkToJson;
  Map<String, dynamic> toJson() => _$WorkToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Work &&
            (identical(other.ords, ords) ||
                const DeepCollectionEquality().equals(other.ords, ords)) &&
            (identical(other.ordLns, ordLns) ||
                const DeepCollectionEquality().equals(other.ordLns, ordLns)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(ords) ^
      const DeepCollectionEquality().hash(ordLns) ^
      runtimeType.hashCode;
}

extension $WorkExtension on Work {
  Work copyWith({List<Ord>? ords, List<OrdLn>? ordLns}) {
    return Work(ords: ords ?? this.ords, ordLns: ordLns ?? this.ordLns);
  }

  Work copyWithWrapped(
      {Wrapped<List<Ord>?>? ords, Wrapped<List<OrdLn>?>? ordLns}) {
    return Work(
        ords: (ords != null ? ords.value : this.ords),
        ordLns: (ordLns != null ? ordLns.value : this.ordLns));
  }
}

@JsonSerializable(explicitToJson: true)
class WorkResult {
  WorkResult({
    this.success,
    this.message,
    this.data,
  });

  factory WorkResult.fromJson(Map<String, dynamic> json) =>
      _$WorkResultFromJson(json);

  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'data', includeIfNull: false)
  final Work? data;
  static const fromJsonFactory = _$WorkResultFromJson;
  static const toJsonFactory = _$WorkResultToJson;
  Map<String, dynamic> toJson() => _$WorkResultToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WorkResult &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(data) ^
      runtimeType.hashCode;
}

extension $WorkResultExtension on WorkResult {
  WorkResult copyWith({bool? success, String? message, Work? data}) {
    return WorkResult(
        success: success ?? this.success,
        message: message ?? this.message,
        data: data ?? this.data);
  }

  WorkResult copyWithWrapped(
      {Wrapped<bool?>? success,
      Wrapped<String?>? message,
      Wrapped<Work?>? data}) {
    return WorkResult(
        success: (success != null ? success.value : this.success),
        message: (message != null ? message.value : this.message),
        data: (data != null ? data.value : this.data));
  }
}

int? textTpToJson(enums.TextTp? textTp) {
  return enums.$TextTpMap[textTp];
}

enums.TextTp textTpFromJson(
  Object? textTp, [
  enums.TextTp? defaultValue,
]) {
  if (textTp is int) {
    return enums.$TextTpMap.entries
        .firstWhere((element) => element.value == textTp,
            orElse: () =>
                const MapEntry(enums.TextTp.swaggerGeneratedUnknown, 0))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$TextTpMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ?? defaultValue ?? enums.TextTp.swaggerGeneratedUnknown;
}

List<int> textTpListToJson(List<enums.TextTp>? textTp) {
  if (textTp == null) {
    return [];
  }

  return textTp.map((e) => enums.$TextTpMap[e]!).toList();
}

List<enums.TextTp> textTpListFromJson(
  List? textTp, [
  List<enums.TextTp>? defaultValue,
]) {
  if (textTp == null) {
    return defaultValue ?? [];
  }

  return textTp.map((e) => textTpFromJson(e.toString())).toList();
}

List<enums.TextTp>? textTpNullableListFromJson(
  List? textTp, [
  List<enums.TextTp>? defaultValue,
]) {
  if (textTp == null) {
    return defaultValue;
  }

  return textTp.map((e) => textTpFromJson(e.toString())).toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
