// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;

part 'issue_328.swagger.chopper.dart';
part 'issue_328.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class Issue328 extends ChopperService {
  static Issue328 create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$Issue328(client);
    }

    final newClient = ChopperClient(
        services: [_$Issue328()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http:///');
    return _$Issue328(newClient);
  }

  ///
  ///@param payload
  Future<chopper.Response> natolyCollectionsPost({
    required Collection? payload,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Collection, () => Collection.fromJsonFactory);

    return _natolyCollectionsPost(payload: payload, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Post(path: '/natoly/collections/')
  Future<chopper.Response> _natolyCollectionsPost({
    @Body() required Collection? payload,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param payload
  Future<chopper.Response> natolyCollectionsGet({
    required Collection? payload,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Collection, () => Collection.fromJsonFactory);

    return _natolyCollectionsGet(payload: payload, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Get(path: '/natoly/collections/')
  Future<chopper.Response> _natolyCollectionsGet({
    @Body() required Collection? payload,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param payload
  Future<chopper.Response> natolyCollectionsAddGet({
    required Collection? payload,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Collection, () => Collection.fromJsonFactory);

    return _natolyCollectionsAddGet(
        payload: payload, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Get(path: '/natoly/collections/add')
  Future<chopper.Response> _natolyCollectionsAddGet({
    @Body() required Collection? payload,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param payload
  Future<chopper.Response> natolyCollectionsAddPost({
    required Collection? payload,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Collection, () => Collection.fromJsonFactory);

    return _natolyCollectionsAddPost(
        payload: payload, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Post(path: '/natoly/collections/add')
  Future<chopper.Response> _natolyCollectionsAddPost({
    @Body() required Collection? payload,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param payload
  Future<chopper.Response> natolyCollectionsAddDelete({
    required Collection? payload,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Collection, () => Collection.fromJsonFactory);

    return _natolyCollectionsAddDelete(
        payload: payload, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Delete(path: '/natoly/collections/add')
  Future<chopper.Response> _natolyCollectionsAddDelete({
    @Body() required Collection? payload,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param payload
  Future<chopper.Response> natolyCollectionsUIdGet({
    required Collection? payload,
    String? id,
    required int? uId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Collection, () => Collection.fromJsonFactory);

    return _natolyCollectionsUIdGet(
        payload: payload, id: id, uId: uId, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Get(path: '/natoly/collections/{u_id}')
  Future<chopper.Response> _natolyCollectionsUIdGet({
    @Body() required Collection? payload,
    @Query('id') String? id,
    @Path('u_id') required int? uId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param payload
  Future<chopper.Response> natolyCollectionsUIdDelete({
    required Collection? payload,
    String? id,
    required int? uId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Collection, () => Collection.fromJsonFactory);

    return _natolyCollectionsUIdDelete(
        payload: payload, id: id, uId: uId, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Delete(path: '/natoly/collections/{u_id}')
  Future<chopper.Response> _natolyCollectionsUIdDelete({
    @Body() required Collection? payload,
    @Query('id') String? id,
    @Path('u_id') required int? uId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param payload
  Future<chopper.Response> natolyDashboardsPost({
    required Dashboard? payload,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Dashboard, () => Dashboard.fromJsonFactory);

    return _natolyDashboardsPost(payload: payload, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Post(path: '/natoly/dashboards/')
  Future<chopper.Response> _natolyDashboardsPost({
    @Body() required Dashboard? payload,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param payload
  Future<chopper.Response> natolyDashboardsAddGet({
    required Dashboard? payload,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Dashboard, () => Dashboard.fromJsonFactory);

    return _natolyDashboardsAddGet(
        payload: payload, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Get(path: '/natoly/dashboards/add')
  Future<chopper.Response> _natolyDashboardsAddGet({
    @Body() required Dashboard? payload,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param payload
  Future<chopper.Response> natolyDashboardsAddPost({
    required Dashboard? payload,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Dashboard, () => Dashboard.fromJsonFactory);

    return _natolyDashboardsAddPost(
        payload: payload, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Post(path: '/natoly/dashboards/add')
  Future<chopper.Response> _natolyDashboardsAddPost({
    @Body() required Dashboard? payload,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param payload
  Future<chopper.Response> natolyDashboardsAddDelete({
    required Dashboard? payload,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Dashboard, () => Dashboard.fromJsonFactory);

    return _natolyDashboardsAddDelete(
        payload: payload, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Delete(path: '/natoly/dashboards/add')
  Future<chopper.Response> _natolyDashboardsAddDelete({
    @Body() required Dashboard? payload,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param payload
  Future<chopper.Response> natolyDashboardsDbIdGet({
    required Dashboard? payload,
    String? id,
    required int? dbId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Dashboard, () => Dashboard.fromJsonFactory);

    return _natolyDashboardsDbIdGet(
        payload: payload, id: id, dbId: dbId, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Get(path: '/natoly/dashboards/{db_id}')
  Future<chopper.Response> _natolyDashboardsDbIdGet({
    @Body() required Dashboard? payload,
    @Query('id') String? id,
    @Path('db_id') required int? dbId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param payload
  Future<chopper.Response> natolyDashboardsDbIdPut({
    required Dashboard? payload,
    String? id,
    required int? dbId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Dashboard, () => Dashboard.fromJsonFactory);

    return _natolyDashboardsDbIdPut(
        payload: payload, id: id, dbId: dbId, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Put(path: '/natoly/dashboards/{db_id}')
  Future<chopper.Response> _natolyDashboardsDbIdPut({
    @Body() required Dashboard? payload,
    @Query('id') String? id,
    @Path('db_id') required int? dbId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param payload
  Future<chopper.Response> natolyDashboardsDbIdDelete({
    required Dashboard? payload,
    String? id,
    required int? dbId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Dashboard, () => Dashboard.fromJsonFactory);

    return _natolyDashboardsDbIdDelete(
        payload: payload, id: id, dbId: dbId, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Delete(path: '/natoly/dashboards/{db_id}')
  Future<chopper.Response> _natolyDashboardsDbIdDelete({
    @Body() required Dashboard? payload,
    @Query('id') String? id,
    @Path('db_id') required int? dbId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> natolyDomodulesPut({String? cacheControl}) {
    return _natolyDomodulesPut(cacheControl: cacheControl);
  }

  ///
  @Put(
    path: '/natoly/domodules/',
    optionalBody: true,
  )
  Future<chopper.Response> _natolyDomodulesPut(
      {@Header('Cache-Control') String? cacheControl});

  ///
  ///@param payload
  Future<chopper.Response> natolyDomodulesPost({
    required Domodule? payload,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Domodule, () => Domodule.fromJsonFactory);

    return _natolyDomodulesPost(payload: payload, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Post(path: '/natoly/domodules/')
  Future<chopper.Response> _natolyDomodulesPost({
    @Body() required Domodule? payload,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param payload
  Future<chopper.Response> natolyDomodulesUIdGet({
    required Domodule? payload,
    required int? uId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Domodule, () => Domodule.fromJsonFactory);

    return _natolyDomodulesUIdGet(
        payload: payload, uId: uId, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Get(path: '/natoly/domodules/{u_id}')
  Future<chopper.Response> _natolyDomodulesUIdGet({
    @Body() required Domodule? payload,
    @Path('u_id') required int? uId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> natolyDomodulesUIdDelete({
    required int? uId,
    String? cacheControl,
  }) {
    return _natolyDomodulesUIdDelete(uId: uId, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/natoly/domodules/{u_id}')
  Future<chopper.Response> _natolyDomodulesUIdDelete({
    @Path('u_id') required int? uId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param payload
  Future<chopper.Response> natolyDomodulesUIdDIdGet({
    required Domodule? payload,
    required int? dId,
    required int? uId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Domodule, () => Domodule.fromJsonFactory);

    return _natolyDomodulesUIdDIdGet(
        payload: payload, dId: dId, uId: uId, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Get(path: '/natoly/domodules/{u_id}/{d_id}')
  Future<chopper.Response> _natolyDomodulesUIdDIdGet({
    @Body() required Domodule? payload,
    @Path('d_id') required int? dId,
    @Path('u_id') required int? uId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param payload
  Future<chopper.Response> natolyUsersPost({
    required User? payload,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(User, () => User.fromJsonFactory);

    return _natolyUsersPost(payload: payload, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Post(path: '/natoly/users/')
  Future<chopper.Response> _natolyUsersPost({
    @Body() required User? payload,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param payload
  Future<chopper.Response> natolyUsersGet({
    required User? payload,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(User, () => User.fromJsonFactory);

    return _natolyUsersGet(payload: payload, cacheControl: cacheControl);
  }

  ///
  ///@param payload
  @Get(path: '/natoly/users/')
  Future<chopper.Response> _natolyUsersGet({
    @Body() required User? payload,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<List<User>>> natolyUsersUIdGet({
    String? id,
    required int? uId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(User, () => User.fromJsonFactory);

    return _natolyUsersUIdGet(id: id, uId: uId, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/natoly/users/{u_id}')
  Future<chopper.Response<List<User>>> _natolyUsersUIdGet({
    @Query('id') String? id,
    @Path('u_id') required int? uId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<List<User>>> natolyUsersUIdPut({
    String? id,
    required int? uId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(User, () => User.fromJsonFactory);

    return _natolyUsersUIdPut(id: id, uId: uId, cacheControl: cacheControl);
  }

  ///
  @Put(
    path: '/natoly/users/{u_id}',
    optionalBody: true,
  )
  Future<chopper.Response<List<User>>> _natolyUsersUIdPut({
    @Query('id') String? id,
    @Path('u_id') required int? uId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<List<User>>> natolyUsersUIdDelete({
    String? id,
    required int? uId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(User, () => User.fromJsonFactory);

    return _natolyUsersUIdDelete(id: id, uId: uId, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/natoly/users/{u_id}')
  Future<chopper.Response<List<User>>> _natolyUsersUIdDelete({
    @Query('id') String? id,
    @Path('u_id') required int? uId,
    @Header('Cache-Control') String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class User {
  User({
    this.name,
    this.uId,
    this.username,
    this.password,
    this.admin,
    this.dashboards,
    this.domodules,
  });

  factory User.fromJson(Map<String, dynamic> json) => _$UserFromJson(json);

  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'u_id', includeIfNull: false)
  final int? uId;
  @JsonKey(name: 'username', includeIfNull: false, defaultValue: '')
  final String? username;
  @JsonKey(name: 'password', includeIfNull: false, defaultValue: '')
  final String? password;
  @JsonKey(name: 'admin', includeIfNull: false)
  final bool? admin;
  @JsonKey(
      name: 'dashboards', includeIfNull: false, defaultValue: <Dashboard>[])
  final List<Dashboard>? dashboards;
  @JsonKey(name: 'domodules', includeIfNull: false, defaultValue: <Domodule>[])
  final List<Domodule>? domodules;
  static const fromJsonFactory = _$UserFromJson;
  static const toJsonFactory = _$UserToJson;
  Map<String, dynamic> toJson() => _$UserToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is User &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.uId, uId) ||
                const DeepCollectionEquality().equals(other.uId, uId)) &&
            (identical(other.username, username) ||
                const DeepCollectionEquality()
                    .equals(other.username, username)) &&
            (identical(other.password, password) ||
                const DeepCollectionEquality()
                    .equals(other.password, password)) &&
            (identical(other.admin, admin) ||
                const DeepCollectionEquality().equals(other.admin, admin)) &&
            (identical(other.dashboards, dashboards) ||
                const DeepCollectionEquality()
                    .equals(other.dashboards, dashboards)) &&
            (identical(other.domodules, domodules) ||
                const DeepCollectionEquality()
                    .equals(other.domodules, domodules)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(uId) ^
      const DeepCollectionEquality().hash(username) ^
      const DeepCollectionEquality().hash(password) ^
      const DeepCollectionEquality().hash(admin) ^
      const DeepCollectionEquality().hash(dashboards) ^
      const DeepCollectionEquality().hash(domodules) ^
      runtimeType.hashCode;
}

extension $UserExtension on User {
  User copyWith(
      {String? name,
      int? uId,
      String? username,
      String? password,
      bool? admin,
      List<Dashboard>? dashboards,
      List<Domodule>? domodules}) {
    return User(
        name: name ?? this.name,
        uId: uId ?? this.uId,
        username: username ?? this.username,
        password: password ?? this.password,
        admin: admin ?? this.admin,
        dashboards: dashboards ?? this.dashboards,
        domodules: domodules ?? this.domodules);
  }

  User copyWithWrapped(
      {Wrapped<String?>? name,
      Wrapped<int?>? uId,
      Wrapped<String?>? username,
      Wrapped<String?>? password,
      Wrapped<bool?>? admin,
      Wrapped<List<Dashboard>?>? dashboards,
      Wrapped<List<Domodule>?>? domodules}) {
    return User(
        name: (name != null ? name.value : this.name),
        uId: (uId != null ? uId.value : this.uId),
        username: (username != null ? username.value : this.username),
        password: (password != null ? password.value : this.password),
        admin: (admin != null ? admin.value : this.admin),
        dashboards: (dashboards != null ? dashboards.value : this.dashboards),
        domodules: (domodules != null ? domodules.value : this.domodules));
  }
}

@JsonSerializable(explicitToJson: true)
class Dashboard {
  Dashboard({
    this.dbId,
    this.name,
    this.uId,
    this.collections,
    this.domodules,
  });

  factory Dashboard.fromJson(Map<String, dynamic> json) =>
      _$DashboardFromJson(json);

  @JsonKey(name: 'db_id', includeIfNull: false, defaultValue: '')
  final String? dbId;
  @JsonKey(name: 'name', includeIfNull: false)
  final int? name;
  @JsonKey(name: 'u_id', includeIfNull: false, defaultValue: '')
  final String? uId;
  @JsonKey(
      name: 'collections', includeIfNull: false, defaultValue: <Collection>[])
  final List<Collection>? collections;
  @JsonKey(name: 'domodules', includeIfNull: false, defaultValue: <Domodule>[])
  final List<Domodule>? domodules;
  static const fromJsonFactory = _$DashboardFromJson;
  static const toJsonFactory = _$DashboardToJson;
  Map<String, dynamic> toJson() => _$DashboardToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Dashboard &&
            (identical(other.dbId, dbId) ||
                const DeepCollectionEquality().equals(other.dbId, dbId)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.uId, uId) ||
                const DeepCollectionEquality().equals(other.uId, uId)) &&
            (identical(other.collections, collections) ||
                const DeepCollectionEquality()
                    .equals(other.collections, collections)) &&
            (identical(other.domodules, domodules) ||
                const DeepCollectionEquality()
                    .equals(other.domodules, domodules)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(dbId) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(uId) ^
      const DeepCollectionEquality().hash(collections) ^
      const DeepCollectionEquality().hash(domodules) ^
      runtimeType.hashCode;
}

extension $DashboardExtension on Dashboard {
  Dashboard copyWith(
      {String? dbId,
      int? name,
      String? uId,
      List<Collection>? collections,
      List<Domodule>? domodules}) {
    return Dashboard(
        dbId: dbId ?? this.dbId,
        name: name ?? this.name,
        uId: uId ?? this.uId,
        collections: collections ?? this.collections,
        domodules: domodules ?? this.domodules);
  }

  Dashboard copyWithWrapped(
      {Wrapped<String?>? dbId,
      Wrapped<int?>? name,
      Wrapped<String?>? uId,
      Wrapped<List<Collection>?>? collections,
      Wrapped<List<Domodule>?>? domodules}) {
    return Dashboard(
        dbId: (dbId != null ? dbId.value : this.dbId),
        name: (name != null ? name.value : this.name),
        uId: (uId != null ? uId.value : this.uId),
        collections:
            (collections != null ? collections.value : this.collections),
        domodules: (domodules != null ? domodules.value : this.domodules));
  }
}

@JsonSerializable(explicitToJson: true)
class Collection {
  Collection({
    this.cId,
    this.uId,
    this.name,
    this.collections,
    this.domodules,
  });

  factory Collection.fromJson(Map<String, dynamic> json) =>
      _$CollectionFromJson(json);

  @JsonKey(name: 'c_id', includeIfNull: false)
  final int? cId;
  @JsonKey(name: 'u_id', includeIfNull: false)
  final int? uId;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(
      name: 'collections', includeIfNull: false, defaultValue: <Collection>[])
  final List<Collection>? collections;
  @JsonKey(name: 'domodules', includeIfNull: false, defaultValue: <Domodule>[])
  final List<Domodule>? domodules;
  static const fromJsonFactory = _$CollectionFromJson;
  static const toJsonFactory = _$CollectionToJson;
  Map<String, dynamic> toJson() => _$CollectionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Collection &&
            (identical(other.cId, cId) ||
                const DeepCollectionEquality().equals(other.cId, cId)) &&
            (identical(other.uId, uId) ||
                const DeepCollectionEquality().equals(other.uId, uId)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.collections, collections) ||
                const DeepCollectionEquality()
                    .equals(other.collections, collections)) &&
            (identical(other.domodules, domodules) ||
                const DeepCollectionEquality()
                    .equals(other.domodules, domodules)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(cId) ^
      const DeepCollectionEquality().hash(uId) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(collections) ^
      const DeepCollectionEquality().hash(domodules) ^
      runtimeType.hashCode;
}

extension $CollectionExtension on Collection {
  Collection copyWith(
      {int? cId,
      int? uId,
      String? name,
      List<Collection>? collections,
      List<Domodule>? domodules}) {
    return Collection(
        cId: cId ?? this.cId,
        uId: uId ?? this.uId,
        name: name ?? this.name,
        collections: collections ?? this.collections,
        domodules: domodules ?? this.domodules);
  }

  Collection copyWithWrapped(
      {Wrapped<int?>? cId,
      Wrapped<int?>? uId,
      Wrapped<String?>? name,
      Wrapped<List<Collection>?>? collections,
      Wrapped<List<Domodule>?>? domodules}) {
    return Collection(
        cId: (cId != null ? cId.value : this.cId),
        uId: (uId != null ? uId.value : this.uId),
        name: (name != null ? name.value : this.name),
        collections:
            (collections != null ? collections.value : this.collections),
        domodules: (domodules != null ? domodules.value : this.domodules));
  }
}

@JsonSerializable(explicitToJson: true)
class Domodule {
  Domodule({
    this.dId,
    this.type,
    this.address,
    this.icon,
    this.parameters,
    this.users,
  });

  factory Domodule.fromJson(Map<String, dynamic> json) =>
      _$DomoduleFromJson(json);

  @JsonKey(name: 'd_id', includeIfNull: false)
  final int? dId;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: <Type$>[])
  final List<Type$>? type;
  @JsonKey(name: 'address', includeIfNull: false, defaultValue: '')
  final String? address;
  @JsonKey(name: 'icon', includeIfNull: false)
  final int? icon;
  @JsonKey(
      name: 'parameters',
      includeIfNull: false,
      defaultValue: <ParameterDomodule>[])
  final List<ParameterDomodule>? parameters;
  @JsonKey(name: 'users', includeIfNull: false, defaultValue: <UserDomodule>[])
  final List<UserDomodule>? users;
  static const fromJsonFactory = _$DomoduleFromJson;
  static const toJsonFactory = _$DomoduleToJson;
  Map<String, dynamic> toJson() => _$DomoduleToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Domodule &&
            (identical(other.dId, dId) ||
                const DeepCollectionEquality().equals(other.dId, dId)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.address, address) ||
                const DeepCollectionEquality()
                    .equals(other.address, address)) &&
            (identical(other.icon, icon) ||
                const DeepCollectionEquality().equals(other.icon, icon)) &&
            (identical(other.parameters, parameters) ||
                const DeepCollectionEquality()
                    .equals(other.parameters, parameters)) &&
            (identical(other.users, users) ||
                const DeepCollectionEquality().equals(other.users, users)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(dId) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(address) ^
      const DeepCollectionEquality().hash(icon) ^
      const DeepCollectionEquality().hash(parameters) ^
      const DeepCollectionEquality().hash(users) ^
      runtimeType.hashCode;
}

extension $DomoduleExtension on Domodule {
  Domodule copyWith(
      {int? dId,
      List<Type$>? type,
      String? address,
      int? icon,
      List<ParameterDomodule>? parameters,
      List<UserDomodule>? users}) {
    return Domodule(
        dId: dId ?? this.dId,
        type: type ?? this.type,
        address: address ?? this.address,
        icon: icon ?? this.icon,
        parameters: parameters ?? this.parameters,
        users: users ?? this.users);
  }

  Domodule copyWithWrapped(
      {Wrapped<int?>? dId,
      Wrapped<List<Type$>?>? type,
      Wrapped<String?>? address,
      Wrapped<int?>? icon,
      Wrapped<List<ParameterDomodule>?>? parameters,
      Wrapped<List<UserDomodule>?>? users}) {
    return Domodule(
        dId: (dId != null ? dId.value : this.dId),
        type: (type != null ? type.value : this.type),
        address: (address != null ? address.value : this.address),
        icon: (icon != null ? icon.value : this.icon),
        parameters: (parameters != null ? parameters.value : this.parameters),
        users: (users != null ? users.value : this.users));
  }
}

@JsonSerializable(explicitToJson: true)
class Type$ {
  Type$({
    this.tId,
    this.typeName,
    this.parameters,
  });

  factory Type$.fromJson(Map<String, dynamic> json) => _$Type$FromJson(json);

  @JsonKey(name: 't_id', includeIfNull: false)
  final int? tId;
  @JsonKey(name: 'type_name', includeIfNull: false, defaultValue: '')
  final String? typeName;
  @JsonKey(
      name: 'parameters', includeIfNull: false, defaultValue: <Parameter>[])
  final List<Parameter>? parameters;
  static const fromJsonFactory = _$Type$FromJson;
  static const toJsonFactory = _$Type$ToJson;
  Map<String, dynamic> toJson() => _$Type$ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Type$ &&
            (identical(other.tId, tId) ||
                const DeepCollectionEquality().equals(other.tId, tId)) &&
            (identical(other.typeName, typeName) ||
                const DeepCollectionEquality()
                    .equals(other.typeName, typeName)) &&
            (identical(other.parameters, parameters) ||
                const DeepCollectionEquality()
                    .equals(other.parameters, parameters)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(tId) ^
      const DeepCollectionEquality().hash(typeName) ^
      const DeepCollectionEquality().hash(parameters) ^
      runtimeType.hashCode;
}

extension $Type$Extension on Type$ {
  Type$ copyWith({int? tId, String? typeName, List<Parameter>? parameters}) {
    return Type$(
        tId: tId ?? this.tId,
        typeName: typeName ?? this.typeName,
        parameters: parameters ?? this.parameters);
  }

  Type$ copyWithWrapped(
      {Wrapped<int?>? tId,
      Wrapped<String?>? typeName,
      Wrapped<List<Parameter>?>? parameters}) {
    return Type$(
        tId: (tId != null ? tId.value : this.tId),
        typeName: (typeName != null ? typeName.value : this.typeName),
        parameters: (parameters != null ? parameters.value : this.parameters));
  }
}

@JsonSerializable(explicitToJson: true)
class Parameter {
  Parameter({
    this.pId,
    this.parameterType,
    this.name,
    this.widget,
    this.admin,
    this.editable,
  });

  factory Parameter.fromJson(Map<String, dynamic> json) =>
      _$ParameterFromJson(json);

  @JsonKey(name: 'p_id', includeIfNull: false)
  final int? pId;
  @JsonKey(name: 'parameter_type', includeIfNull: false, defaultValue: '')
  final String? parameterType;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'widget', includeIfNull: false)
  final int? widget;
  @JsonKey(name: 'admin', includeIfNull: false)
  final int? admin;
  @JsonKey(name: 'editable', includeIfNull: false)
  final int? editable;
  static const fromJsonFactory = _$ParameterFromJson;
  static const toJsonFactory = _$ParameterToJson;
  Map<String, dynamic> toJson() => _$ParameterToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Parameter &&
            (identical(other.pId, pId) ||
                const DeepCollectionEquality().equals(other.pId, pId)) &&
            (identical(other.parameterType, parameterType) ||
                const DeepCollectionEquality()
                    .equals(other.parameterType, parameterType)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.widget, widget) ||
                const DeepCollectionEquality().equals(other.widget, widget)) &&
            (identical(other.admin, admin) ||
                const DeepCollectionEquality().equals(other.admin, admin)) &&
            (identical(other.editable, editable) ||
                const DeepCollectionEquality()
                    .equals(other.editable, editable)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(pId) ^
      const DeepCollectionEquality().hash(parameterType) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(widget) ^
      const DeepCollectionEquality().hash(admin) ^
      const DeepCollectionEquality().hash(editable) ^
      runtimeType.hashCode;
}

extension $ParameterExtension on Parameter {
  Parameter copyWith(
      {int? pId,
      String? parameterType,
      String? name,
      int? widget,
      int? admin,
      int? editable}) {
    return Parameter(
        pId: pId ?? this.pId,
        parameterType: parameterType ?? this.parameterType,
        name: name ?? this.name,
        widget: widget ?? this.widget,
        admin: admin ?? this.admin,
        editable: editable ?? this.editable);
  }

  Parameter copyWithWrapped(
      {Wrapped<int?>? pId,
      Wrapped<String?>? parameterType,
      Wrapped<String?>? name,
      Wrapped<int?>? widget,
      Wrapped<int?>? admin,
      Wrapped<int?>? editable}) {
    return Parameter(
        pId: (pId != null ? pId.value : this.pId),
        parameterType:
            (parameterType != null ? parameterType.value : this.parameterType),
        name: (name != null ? name.value : this.name),
        widget: (widget != null ? widget.value : this.widget),
        admin: (admin != null ? admin.value : this.admin),
        editable: (editable != null ? editable.value : this.editable));
  }
}

@JsonSerializable(explicitToJson: true)
class ParameterDomodule {
  ParameterDomodule({
    this.pdId,
    this.pId,
    this.dId,
    this.value,
    this.properties,
  });

  factory ParameterDomodule.fromJson(Map<String, dynamic> json) =>
      _$ParameterDomoduleFromJson(json);

  @JsonKey(name: 'pd_id', includeIfNull: false)
  final int? pdId;
  @JsonKey(name: 'p_id', includeIfNull: false)
  final int? pId;
  @JsonKey(name: 'd_id', includeIfNull: false)
  final int? dId;
  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String? value;
  @JsonKey(
      name: 'properties', includeIfNull: false, defaultValue: <Parameter>[])
  final List<Parameter>? properties;
  static const fromJsonFactory = _$ParameterDomoduleFromJson;
  static const toJsonFactory = _$ParameterDomoduleToJson;
  Map<String, dynamic> toJson() => _$ParameterDomoduleToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ParameterDomodule &&
            (identical(other.pdId, pdId) ||
                const DeepCollectionEquality().equals(other.pdId, pdId)) &&
            (identical(other.pId, pId) ||
                const DeepCollectionEquality().equals(other.pId, pId)) &&
            (identical(other.dId, dId) ||
                const DeepCollectionEquality().equals(other.dId, dId)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)) &&
            (identical(other.properties, properties) ||
                const DeepCollectionEquality()
                    .equals(other.properties, properties)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(pdId) ^
      const DeepCollectionEquality().hash(pId) ^
      const DeepCollectionEquality().hash(dId) ^
      const DeepCollectionEquality().hash(value) ^
      const DeepCollectionEquality().hash(properties) ^
      runtimeType.hashCode;
}

extension $ParameterDomoduleExtension on ParameterDomodule {
  ParameterDomodule copyWith(
      {int? pdId,
      int? pId,
      int? dId,
      String? value,
      List<Parameter>? properties}) {
    return ParameterDomodule(
        pdId: pdId ?? this.pdId,
        pId: pId ?? this.pId,
        dId: dId ?? this.dId,
        value: value ?? this.value,
        properties: properties ?? this.properties);
  }

  ParameterDomodule copyWithWrapped(
      {Wrapped<int?>? pdId,
      Wrapped<int?>? pId,
      Wrapped<int?>? dId,
      Wrapped<String?>? value,
      Wrapped<List<Parameter>?>? properties}) {
    return ParameterDomodule(
        pdId: (pdId != null ? pdId.value : this.pdId),
        pId: (pId != null ? pId.value : this.pId),
        dId: (dId != null ? dId.value : this.dId),
        value: (value != null ? value.value : this.value),
        properties: (properties != null ? properties.value : this.properties));
  }
}

@JsonSerializable(explicitToJson: true)
class UserDomodule {
  UserDomodule({
    this.udId,
    this.uId,
    this.dId,
    this.name,
  });

  factory UserDomodule.fromJson(Map<String, dynamic> json) =>
      _$UserDomoduleFromJson(json);

  @JsonKey(name: 'ud_id', includeIfNull: false)
  final int? udId;
  @JsonKey(name: 'u_id', includeIfNull: false)
  final int? uId;
  @JsonKey(name: 'd_id', includeIfNull: false)
  final int? dId;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  static const fromJsonFactory = _$UserDomoduleFromJson;
  static const toJsonFactory = _$UserDomoduleToJson;
  Map<String, dynamic> toJson() => _$UserDomoduleToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserDomodule &&
            (identical(other.udId, udId) ||
                const DeepCollectionEquality().equals(other.udId, udId)) &&
            (identical(other.uId, uId) ||
                const DeepCollectionEquality().equals(other.uId, uId)) &&
            (identical(other.dId, dId) ||
                const DeepCollectionEquality().equals(other.dId, dId)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(udId) ^
      const DeepCollectionEquality().hash(uId) ^
      const DeepCollectionEquality().hash(dId) ^
      const DeepCollectionEquality().hash(name) ^
      runtimeType.hashCode;
}

extension $UserDomoduleExtension on UserDomodule {
  UserDomodule copyWith({int? udId, int? uId, int? dId, String? name}) {
    return UserDomodule(
        udId: udId ?? this.udId,
        uId: uId ?? this.uId,
        dId: dId ?? this.dId,
        name: name ?? this.name);
  }

  UserDomodule copyWithWrapped(
      {Wrapped<int?>? udId,
      Wrapped<int?>? uId,
      Wrapped<int?>? dId,
      Wrapped<String?>? name}) {
    return UserDomodule(
        udId: (udId != null ? udId.value : this.udId),
        uId: (uId != null ? uId.value : this.uId),
        dId: (dId != null ? dId.value : this.dId),
        name: (name != null ? name.value : this.name));
  }
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
