// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;

part 'liberty_connectivity_gateway_service.swagger.chopper.dart';
part 'liberty_connectivity_gateway_service.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class LibertyConnectivityGatewayService extends ChopperService {
  static LibertyConnectivityGatewayService create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$LibertyConnectivityGatewayService(client);
    }

    final newClient = ChopperClient(
        services: [_$LibertyConnectivityGatewayService()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$LibertyConnectivityGatewayService(newClient);
  }

  ///
  ///@param Authorization
  ///@param X-API-key
  Future<chopper.Response> $Post({
    String? authorization,
    String? xAPIKey,
    String? cacheControl,
    required WakeUpDeviceRequest? body,
  }) {
    return _$Post(
        authorization: authorization,
        xAPIKey: xAPIKey,
        cacheControl: cacheControl,
        body: body);
  }

  ///
  ///@param Authorization
  ///@param X-API-key
  @Post(path: '/')
  Future<chopper.Response> _$Post({
    @Header('Authorization') String? authorization,
    @Header('X-API-key') String? xAPIKey,
    @Header('Cache-Control') String? cacheControl,
    @Body() required WakeUpDeviceRequest? body,
  });
}

@JsonSerializable(explicitToJson: true)
class WakeUpDeviceRequest {
  WakeUpDeviceRequest({
    required this.customerId,
    required this.macAddressWiFi,
    required this.macAddressEthernet,
  });

  factory WakeUpDeviceRequest.fromJson(Map<String, dynamic> json) =>
      _$WakeUpDeviceRequestFromJson(json);

  @JsonKey(name: 'customerId', includeIfNull: false, defaultValue: '')
  final String customerId;
  @JsonKey(name: 'macAddressWiFi', includeIfNull: false, defaultValue: '')
  final String macAddressWiFi;
  @JsonKey(name: 'macAddressEthernet', includeIfNull: false, defaultValue: '')
  final String macAddressEthernet;
  static const fromJsonFactory = _$WakeUpDeviceRequestFromJson;
  static const toJsonFactory = _$WakeUpDeviceRequestToJson;
  Map<String, dynamic> toJson() => _$WakeUpDeviceRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WakeUpDeviceRequest &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.macAddressWiFi, macAddressWiFi) ||
                const DeepCollectionEquality()
                    .equals(other.macAddressWiFi, macAddressWiFi)) &&
            (identical(other.macAddressEthernet, macAddressEthernet) ||
                const DeepCollectionEquality()
                    .equals(other.macAddressEthernet, macAddressEthernet)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(customerId) ^
      const DeepCollectionEquality().hash(macAddressWiFi) ^
      const DeepCollectionEquality().hash(macAddressEthernet) ^
      runtimeType.hashCode;
}

extension $WakeUpDeviceRequestExtension on WakeUpDeviceRequest {
  WakeUpDeviceRequest copyWith(
      {String? customerId,
      String? macAddressWiFi,
      String? macAddressEthernet}) {
    return WakeUpDeviceRequest(
        customerId: customerId ?? this.customerId,
        macAddressWiFi: macAddressWiFi ?? this.macAddressWiFi,
        macAddressEthernet: macAddressEthernet ?? this.macAddressEthernet);
  }

  WakeUpDeviceRequest copyWithWrapped(
      {Wrapped<String>? customerId,
      Wrapped<String>? macAddressWiFi,
      Wrapped<String>? macAddressEthernet}) {
    return WakeUpDeviceRequest(
        customerId: (customerId != null ? customerId.value : this.customerId),
        macAddressWiFi: (macAddressWiFi != null
            ? macAddressWiFi.value
            : this.macAddressWiFi),
        macAddressEthernet: (macAddressEthernet != null
            ? macAddressEthernet.value
            : this.macAddressEthernet));
  }
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
