// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;

part 'liberty_download_policy_service.swagger.chopper.dart';
part 'liberty_download_policy_service.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class LibertyDownloadPolicyService extends ChopperService {
  static LibertyDownloadPolicyService create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$LibertyDownloadPolicyService(client);
    }

    final newClient = ChopperClient(
        services: [_$LibertyDownloadPolicyService()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$LibertyDownloadPolicyService(newClient);
  }

  ///Download Permission check API
  ///@param body
  Future<chopper.Response<CheckDownloadPermissionResponse>>
      checkDownloadPermissionPost({
    CheckDownloadPermission? body,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CheckDownloadPermission, () => CheckDownloadPermission.fromJsonFactory);
    generatedMapping.putIfAbsent(CheckDownloadPermissionResponse,
        () => CheckDownloadPermissionResponse.fromJsonFactory);

    return _checkDownloadPermissionPost(body: body, cacheControl: cacheControl);
  }

  ///Download Permission check API
  ///@param body
  @Post(path: '/checkDownloadPermission')
  Future<chopper.Response<CheckDownloadPermissionResponse>>
      _checkDownloadPermissionPost({
    @Body() CheckDownloadPermission? body,
    @Header('Cache-Control') String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class CheckDownloadPermissionResponse {
  CheckDownloadPermissionResponse({
    this.code,
    this.message,
  });

  factory CheckDownloadPermissionResponse.fromJson(Map<String, dynamic> json) =>
      _$CheckDownloadPermissionResponseFromJson(json);

  @JsonKey(name: 'code', includeIfNull: false)
  final int? code;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  static const fromJsonFactory = _$CheckDownloadPermissionResponseFromJson;
  static const toJsonFactory = _$CheckDownloadPermissionResponseToJson;
  Map<String, dynamic> toJson() =>
      _$CheckDownloadPermissionResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CheckDownloadPermissionResponse &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality().equals(other.message, message)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(code) ^
      const DeepCollectionEquality().hash(message) ^
      runtimeType.hashCode;
}

extension $CheckDownloadPermissionResponseExtension
    on CheckDownloadPermissionResponse {
  CheckDownloadPermissionResponse copyWith({int? code, String? message}) {
    return CheckDownloadPermissionResponse(
        code: code ?? this.code, message: message ?? this.message);
  }

  CheckDownloadPermissionResponse copyWithWrapped(
      {Wrapped<int?>? code, Wrapped<String?>? message}) {
    return CheckDownloadPermissionResponse(
        code: (code != null ? code.value : this.code),
        message: (message != null ? message.value : this.message));
  }
}

@JsonSerializable(explicitToJson: true)
class KrakenError {
  KrakenError({
    required this.httpStatusCode,
    this.statusCode,
    required this.message,
    this.details,
    this.allErrors,
    this.correlationId,
  });

  factory KrakenError.fromJson(Map<String, dynamic> json) =>
      _$KrakenErrorFromJson(json);

  @JsonKey(name: 'httpStatusCode', includeIfNull: false)
  final int httpStatusCode;
  @JsonKey(name: 'statusCode', includeIfNull: false)
  final int? statusCode;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String message;
  @JsonKey(name: 'details', includeIfNull: false, defaultValue: '')
  final String? details;
  @JsonKey(name: 'allErrors', includeIfNull: false, defaultValue: <String>[])
  final List<String>? allErrors;
  @JsonKey(name: 'correlationId', includeIfNull: false, defaultValue: '')
  final String? correlationId;
  static const fromJsonFactory = _$KrakenErrorFromJson;
  static const toJsonFactory = _$KrakenErrorToJson;
  Map<String, dynamic> toJson() => _$KrakenErrorToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is KrakenError &&
            (identical(other.httpStatusCode, httpStatusCode) ||
                const DeepCollectionEquality()
                    .equals(other.httpStatusCode, httpStatusCode)) &&
            (identical(other.statusCode, statusCode) ||
                const DeepCollectionEquality()
                    .equals(other.statusCode, statusCode)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.details, details) ||
                const DeepCollectionEquality()
                    .equals(other.details, details)) &&
            (identical(other.allErrors, allErrors) ||
                const DeepCollectionEquality()
                    .equals(other.allErrors, allErrors)) &&
            (identical(other.correlationId, correlationId) ||
                const DeepCollectionEquality()
                    .equals(other.correlationId, correlationId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(httpStatusCode) ^
      const DeepCollectionEquality().hash(statusCode) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(details) ^
      const DeepCollectionEquality().hash(allErrors) ^
      const DeepCollectionEquality().hash(correlationId) ^
      runtimeType.hashCode;
}

extension $KrakenErrorExtension on KrakenError {
  KrakenError copyWith(
      {int? httpStatusCode,
      int? statusCode,
      String? message,
      String? details,
      List<String>? allErrors,
      String? correlationId}) {
    return KrakenError(
        httpStatusCode: httpStatusCode ?? this.httpStatusCode,
        statusCode: statusCode ?? this.statusCode,
        message: message ?? this.message,
        details: details ?? this.details,
        allErrors: allErrors ?? this.allErrors,
        correlationId: correlationId ?? this.correlationId);
  }

  KrakenError copyWithWrapped(
      {Wrapped<int>? httpStatusCode,
      Wrapped<int?>? statusCode,
      Wrapped<String>? message,
      Wrapped<String?>? details,
      Wrapped<List<String>?>? allErrors,
      Wrapped<String?>? correlationId}) {
    return KrakenError(
        httpStatusCode: (httpStatusCode != null
            ? httpStatusCode.value
            : this.httpStatusCode),
        statusCode: (statusCode != null ? statusCode.value : this.statusCode),
        message: (message != null ? message.value : this.message),
        details: (details != null ? details.value : this.details),
        allErrors: (allErrors != null ? allErrors.value : this.allErrors),
        correlationId:
            (correlationId != null ? correlationId.value : this.correlationId));
  }
}

@JsonSerializable(explicitToJson: true)
class AssetDownloadElement {
  AssetDownloadElement({
    required this.assetId,
    this.totalViewCount,
    this.totalDownloadCount,
    this.downloads,
    this.activeDownloadCount,
  });

  factory AssetDownloadElement.fromJson(Map<String, dynamic> json) =>
      _$AssetDownloadElementFromJson(json);

  @JsonKey(name: 'assetId', includeIfNull: false, defaultValue: '')
  final String assetId;
  @JsonKey(name: 'totalViewCount', includeIfNull: false)
  final int? totalViewCount;
  @JsonKey(name: 'totalDownloadCount', includeIfNull: false)
  final int? totalDownloadCount;
  @JsonKey(
      name: 'downloads',
      includeIfNull: false,
      defaultValue: <DownloadElement>[])
  final List<DownloadElement>? downloads;
  @JsonKey(name: 'activeDownloadCount', includeIfNull: false)
  final int? activeDownloadCount;
  static const fromJsonFactory = _$AssetDownloadElementFromJson;
  static const toJsonFactory = _$AssetDownloadElementToJson;
  Map<String, dynamic> toJson() => _$AssetDownloadElementToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AssetDownloadElement &&
            (identical(other.assetId, assetId) ||
                const DeepCollectionEquality()
                    .equals(other.assetId, assetId)) &&
            (identical(other.totalViewCount, totalViewCount) ||
                const DeepCollectionEquality()
                    .equals(other.totalViewCount, totalViewCount)) &&
            (identical(other.totalDownloadCount, totalDownloadCount) ||
                const DeepCollectionEquality()
                    .equals(other.totalDownloadCount, totalDownloadCount)) &&
            (identical(other.downloads, downloads) ||
                const DeepCollectionEquality()
                    .equals(other.downloads, downloads)) &&
            (identical(other.activeDownloadCount, activeDownloadCount) ||
                const DeepCollectionEquality()
                    .equals(other.activeDownloadCount, activeDownloadCount)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(assetId) ^
      const DeepCollectionEquality().hash(totalViewCount) ^
      const DeepCollectionEquality().hash(totalDownloadCount) ^
      const DeepCollectionEquality().hash(downloads) ^
      const DeepCollectionEquality().hash(activeDownloadCount) ^
      runtimeType.hashCode;
}

extension $AssetDownloadElementExtension on AssetDownloadElement {
  AssetDownloadElement copyWith(
      {String? assetId,
      int? totalViewCount,
      int? totalDownloadCount,
      List<DownloadElement>? downloads,
      int? activeDownloadCount}) {
    return AssetDownloadElement(
        assetId: assetId ?? this.assetId,
        totalViewCount: totalViewCount ?? this.totalViewCount,
        totalDownloadCount: totalDownloadCount ?? this.totalDownloadCount,
        downloads: downloads ?? this.downloads,
        activeDownloadCount: activeDownloadCount ?? this.activeDownloadCount);
  }

  AssetDownloadElement copyWithWrapped(
      {Wrapped<String>? assetId,
      Wrapped<int?>? totalViewCount,
      Wrapped<int?>? totalDownloadCount,
      Wrapped<List<DownloadElement>?>? downloads,
      Wrapped<int?>? activeDownloadCount}) {
    return AssetDownloadElement(
        assetId: (assetId != null ? assetId.value : this.assetId),
        totalViewCount: (totalViewCount != null
            ? totalViewCount.value
            : this.totalViewCount),
        totalDownloadCount: (totalDownloadCount != null
            ? totalDownloadCount.value
            : this.totalDownloadCount),
        downloads: (downloads != null ? downloads.value : this.downloads),
        activeDownloadCount: (activeDownloadCount != null
            ? activeDownloadCount.value
            : this.activeDownloadCount));
  }
}

@JsonSerializable(explicitToJson: true)
class CheckDownloadPermission {
  CheckDownloadPermission({
    required this.assetId,
    this.assetDownloads,
  });

  factory CheckDownloadPermission.fromJson(Map<String, dynamic> json) =>
      _$CheckDownloadPermissionFromJson(json);

  @JsonKey(name: 'assetId', includeIfNull: false, defaultValue: '')
  final String assetId;
  @JsonKey(
      name: 'assetDownloads',
      includeIfNull: false,
      defaultValue: <AssetDownloadElement>[])
  final List<AssetDownloadElement>? assetDownloads;
  static const fromJsonFactory = _$CheckDownloadPermissionFromJson;
  static const toJsonFactory = _$CheckDownloadPermissionToJson;
  Map<String, dynamic> toJson() => _$CheckDownloadPermissionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CheckDownloadPermission &&
            (identical(other.assetId, assetId) ||
                const DeepCollectionEquality()
                    .equals(other.assetId, assetId)) &&
            (identical(other.assetDownloads, assetDownloads) ||
                const DeepCollectionEquality()
                    .equals(other.assetDownloads, assetDownloads)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(assetId) ^
      const DeepCollectionEquality().hash(assetDownloads) ^
      runtimeType.hashCode;
}

extension $CheckDownloadPermissionExtension on CheckDownloadPermission {
  CheckDownloadPermission copyWith(
      {String? assetId, List<AssetDownloadElement>? assetDownloads}) {
    return CheckDownloadPermission(
        assetId: assetId ?? this.assetId,
        assetDownloads: assetDownloads ?? this.assetDownloads);
  }

  CheckDownloadPermission copyWithWrapped(
      {Wrapped<String>? assetId,
      Wrapped<List<AssetDownloadElement>?>? assetDownloads}) {
    return CheckDownloadPermission(
        assetId: (assetId != null ? assetId.value : this.assetId),
        assetDownloads: (assetDownloads != null
            ? assetDownloads.value
            : this.assetDownloads));
  }
}

@JsonSerializable(explicitToJson: true)
class DownloadElement {
  DownloadElement({
    this.deviceId,
    this.totalViewCount,
    this.totalDownloadCount,
    this.current,
    this.pending,
  });

  factory DownloadElement.fromJson(Map<String, dynamic> json) =>
      _$DownloadElementFromJson(json);

  @JsonKey(name: 'deviceId', includeIfNull: false, defaultValue: '')
  final String? deviceId;
  @JsonKey(name: 'totalViewCount', includeIfNull: false)
  final int? totalViewCount;
  @JsonKey(name: 'totalDownloadCount', includeIfNull: false)
  final int? totalDownloadCount;
  @JsonKey(
      name: 'current',
      includeIfNull: false,
      defaultValue: <DownloadStatusElement>[])
  final List<DownloadStatusElement>? current;
  @JsonKey(
      name: 'pending',
      includeIfNull: false,
      defaultValue: <DownloadStatusElement>[])
  final List<DownloadStatusElement>? pending;
  static const fromJsonFactory = _$DownloadElementFromJson;
  static const toJsonFactory = _$DownloadElementToJson;
  Map<String, dynamic> toJson() => _$DownloadElementToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DownloadElement &&
            (identical(other.deviceId, deviceId) ||
                const DeepCollectionEquality()
                    .equals(other.deviceId, deviceId)) &&
            (identical(other.totalViewCount, totalViewCount) ||
                const DeepCollectionEquality()
                    .equals(other.totalViewCount, totalViewCount)) &&
            (identical(other.totalDownloadCount, totalDownloadCount) ||
                const DeepCollectionEquality()
                    .equals(other.totalDownloadCount, totalDownloadCount)) &&
            (identical(other.current, current) ||
                const DeepCollectionEquality()
                    .equals(other.current, current)) &&
            (identical(other.pending, pending) ||
                const DeepCollectionEquality().equals(other.pending, pending)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(deviceId) ^
      const DeepCollectionEquality().hash(totalViewCount) ^
      const DeepCollectionEquality().hash(totalDownloadCount) ^
      const DeepCollectionEquality().hash(current) ^
      const DeepCollectionEquality().hash(pending) ^
      runtimeType.hashCode;
}

extension $DownloadElementExtension on DownloadElement {
  DownloadElement copyWith(
      {String? deviceId,
      int? totalViewCount,
      int? totalDownloadCount,
      List<DownloadStatusElement>? current,
      List<DownloadStatusElement>? pending}) {
    return DownloadElement(
        deviceId: deviceId ?? this.deviceId,
        totalViewCount: totalViewCount ?? this.totalViewCount,
        totalDownloadCount: totalDownloadCount ?? this.totalDownloadCount,
        current: current ?? this.current,
        pending: pending ?? this.pending);
  }

  DownloadElement copyWithWrapped(
      {Wrapped<String?>? deviceId,
      Wrapped<int?>? totalViewCount,
      Wrapped<int?>? totalDownloadCount,
      Wrapped<List<DownloadStatusElement>?>? current,
      Wrapped<List<DownloadStatusElement>?>? pending}) {
    return DownloadElement(
        deviceId: (deviceId != null ? deviceId.value : this.deviceId),
        totalViewCount: (totalViewCount != null
            ? totalViewCount.value
            : this.totalViewCount),
        totalDownloadCount: (totalDownloadCount != null
            ? totalDownloadCount.value
            : this.totalDownloadCount),
        current: (current != null ? current.value : this.current),
        pending: (pending != null ? pending.value : this.pending));
  }
}

@JsonSerializable(explicitToJson: true)
class DownloadStatusElement {
  DownloadStatusElement({
    this.requestedAt,
    this.viewCount,
  });

  factory DownloadStatusElement.fromJson(Map<String, dynamic> json) =>
      _$DownloadStatusElementFromJson(json);

  @JsonKey(name: 'requestedAt', includeIfNull: false)
  final num? requestedAt;
  @JsonKey(name: 'viewCount', includeIfNull: false)
  final int? viewCount;
  static const fromJsonFactory = _$DownloadStatusElementFromJson;
  static const toJsonFactory = _$DownloadStatusElementToJson;
  Map<String, dynamic> toJson() => _$DownloadStatusElementToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DownloadStatusElement &&
            (identical(other.requestedAt, requestedAt) ||
                const DeepCollectionEquality()
                    .equals(other.requestedAt, requestedAt)) &&
            (identical(other.viewCount, viewCount) ||
                const DeepCollectionEquality()
                    .equals(other.viewCount, viewCount)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(requestedAt) ^
      const DeepCollectionEquality().hash(viewCount) ^
      runtimeType.hashCode;
}

extension $DownloadStatusElementExtension on DownloadStatusElement {
  DownloadStatusElement copyWith({num? requestedAt, int? viewCount}) {
    return DownloadStatusElement(
        requestedAt: requestedAt ?? this.requestedAt,
        viewCount: viewCount ?? this.viewCount);
  }

  DownloadStatusElement copyWithWrapped(
      {Wrapped<num?>? requestedAt, Wrapped<int?>? viewCount}) {
    return DownloadStatusElement(
        requestedAt:
            (requestedAt != null ? requestedAt.value : this.requestedAt),
        viewCount: (viewCount != null ? viewCount.value : this.viewCount));
  }
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
