// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'liberty_go_screen_service.enums.swagger.dart' as enums;
export 'liberty_go_screen_service.enums.swagger.dart';

part 'liberty_go_screen_service.swagger.chopper.dart';
part 'liberty_go_screen_service.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class LibertyGoScreenService extends ChopperService {
  static LibertyGoScreenService create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$LibertyGoScreenService(client);
    }

    final newClient = ChopperClient(
        services: [_$LibertyGoScreenService()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$LibertyGoScreenService(newClient);
  }

  ///Returns the most preferred instance and/or provider based on entitlements, bookmarks and provided parameters.
  ///@param titleCrid The title Crid for which the most preferred instance is requested.
  ///@param brandingProviderId
  ///@param cityId City Identifier of the user.
  ///@param profileId The end user profile Id. Used to call the bookmark service.
  ///@param x-Entitlement-Token The entitlement token as obtained from the Purchase Service.  Used to get the entitlements and validate the customerId
  ///@param x-cus The customer Id. Used to validate the entitlement token.
  ///@param x-dev The device Id. Used to validate the entitlement token.
  ///@param x-claims-set The claims set generated by the gateway from the claims token as obtained from personalization service.  Used to validate that the profileId given, belongs to the customer making the request.
  Future<chopper.Response<TitlePreferredInstance>>
      v1TitlePreferredInstanceTitleCridGet({
    required String? titleCrid,
    String? brandingProviderId,
    String? cityId,
    String? profileId,
    String? xEntitlementToken,
    String? xCus = 'X-Cus',
    String? xDev,
    String? xClaimsSet,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        TitlePreferredInstance, () => TitlePreferredInstance.fromJsonFactory);

    return _v1TitlePreferredInstanceTitleCridGet(
        titleCrid: titleCrid,
        brandingProviderId: brandingProviderId,
        cityId: cityId,
        profileId: profileId,
        xEntitlementToken: xEntitlementToken,
        xCus: xCus,
        xDev: xDev,
        xClaimsSet: xClaimsSet,
        cacheControl: cacheControl);
  }

  ///Returns the most preferred instance and/or provider based on entitlements, bookmarks and provided parameters.
  ///@param titleCrid The title Crid for which the most preferred instance is requested.
  ///@param brandingProviderId
  ///@param cityId City Identifier of the user.
  ///@param profileId The end user profile Id. Used to call the bookmark service.
  ///@param x-Entitlement-Token The entitlement token as obtained from the Purchase Service.  Used to get the entitlements and validate the customerId
  ///@param x-cus The customer Id. Used to validate the entitlement token.
  ///@param x-dev The device Id. Used to validate the entitlement token.
  ///@param x-claims-set The claims set generated by the gateway from the claims token as obtained from personalization service.  Used to validate that the profileId given, belongs to the customer making the request.
  @Get(path: '/v1/titlePreferredInstance/{titleCrid}')
  Future<chopper.Response<TitlePreferredInstance>>
      _v1TitlePreferredInstanceTitleCridGet({
    @Path('titleCrid') required String? titleCrid,
    @Query('brandingProviderId') String? brandingProviderId,
    @Query('cityId') String? cityId,
    @Query('profileId') String? profileId,
    @Header('x-Entitlement-Token') String? xEntitlementToken,
    @Header('x-cus') String? xCus = 'X-Cus',
    @Header('x-dev') String? xDev,
    @Header('x-claims-set') String? xClaimsSet,
    @Header('Cache-Control') String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class TitlePreferredInstance {
  TitlePreferredInstance({
    required this.titleId,
    this.brandingProviderId,
    this.contentId,
    required this.isGoPlayable,
    this.viewProgress,
  });

  factory TitlePreferredInstance.fromJson(Map<String, dynamic> json) =>
      _$TitlePreferredInstanceFromJson(json);

  @JsonKey(name: 'titleId', includeIfNull: false, defaultValue: '')
  final String titleId;
  @JsonKey(name: 'brandingProviderId', includeIfNull: false, defaultValue: '')
  final String? brandingProviderId;
  @JsonKey(name: 'contentId', includeIfNull: false, defaultValue: '')
  final String? contentId;
  @JsonKey(name: 'isGoPlayable', includeIfNull: false)
  final bool isGoPlayable;
  @JsonKey(name: 'viewProgress', includeIfNull: false)
  final ViewProgress? viewProgress;
  static const fromJsonFactory = _$TitlePreferredInstanceFromJson;
  static const toJsonFactory = _$TitlePreferredInstanceToJson;
  Map<String, dynamic> toJson() => _$TitlePreferredInstanceToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TitlePreferredInstance &&
            (identical(other.titleId, titleId) ||
                const DeepCollectionEquality()
                    .equals(other.titleId, titleId)) &&
            (identical(other.brandingProviderId, brandingProviderId) ||
                const DeepCollectionEquality()
                    .equals(other.brandingProviderId, brandingProviderId)) &&
            (identical(other.contentId, contentId) ||
                const DeepCollectionEquality()
                    .equals(other.contentId, contentId)) &&
            (identical(other.isGoPlayable, isGoPlayable) ||
                const DeepCollectionEquality()
                    .equals(other.isGoPlayable, isGoPlayable)) &&
            (identical(other.viewProgress, viewProgress) ||
                const DeepCollectionEquality()
                    .equals(other.viewProgress, viewProgress)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(titleId) ^
      const DeepCollectionEquality().hash(brandingProviderId) ^
      const DeepCollectionEquality().hash(contentId) ^
      const DeepCollectionEquality().hash(isGoPlayable) ^
      const DeepCollectionEquality().hash(viewProgress) ^
      runtimeType.hashCode;
}

extension $TitlePreferredInstanceExtension on TitlePreferredInstance {
  TitlePreferredInstance copyWith(
      {String? titleId,
      String? brandingProviderId,
      String? contentId,
      bool? isGoPlayable,
      ViewProgress? viewProgress}) {
    return TitlePreferredInstance(
        titleId: titleId ?? this.titleId,
        brandingProviderId: brandingProviderId ?? this.brandingProviderId,
        contentId: contentId ?? this.contentId,
        isGoPlayable: isGoPlayable ?? this.isGoPlayable,
        viewProgress: viewProgress ?? this.viewProgress);
  }

  TitlePreferredInstance copyWithWrapped(
      {Wrapped<String>? titleId,
      Wrapped<String?>? brandingProviderId,
      Wrapped<String?>? contentId,
      Wrapped<bool>? isGoPlayable,
      Wrapped<ViewProgress?>? viewProgress}) {
    return TitlePreferredInstance(
        titleId: (titleId != null ? titleId.value : this.titleId),
        brandingProviderId: (brandingProviderId != null
            ? brandingProviderId.value
            : this.brandingProviderId),
        contentId: (contentId != null ? contentId.value : this.contentId),
        isGoPlayable:
            (isGoPlayable != null ? isGoPlayable.value : this.isGoPlayable),
        viewProgress:
            (viewProgress != null ? viewProgress.value : this.viewProgress));
  }
}

@JsonSerializable(explicitToJson: true)
class ViewProgress {
  ViewProgress({
    required this.viewState,
    required this.position,
    required this.duration,
  });

  factory ViewProgress.fromJson(Map<String, dynamic> json) =>
      _$ViewProgressFromJson(json);

  @JsonKey(
    name: 'viewState',
    includeIfNull: false,
    toJson: viewStateToJson,
    fromJson: viewStateFromJson,
  )
  final enums.ViewState viewState;
  @JsonKey(name: 'position', includeIfNull: false)
  final double position;
  @JsonKey(name: 'duration', includeIfNull: false)
  final double duration;
  static const fromJsonFactory = _$ViewProgressFromJson;
  static const toJsonFactory = _$ViewProgressToJson;
  Map<String, dynamic> toJson() => _$ViewProgressToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ViewProgress &&
            (identical(other.viewState, viewState) ||
                const DeepCollectionEquality()
                    .equals(other.viewState, viewState)) &&
            (identical(other.position, position) ||
                const DeepCollectionEquality()
                    .equals(other.position, position)) &&
            (identical(other.duration, duration) ||
                const DeepCollectionEquality()
                    .equals(other.duration, duration)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(viewState) ^
      const DeepCollectionEquality().hash(position) ^
      const DeepCollectionEquality().hash(duration) ^
      runtimeType.hashCode;
}

extension $ViewProgressExtension on ViewProgress {
  ViewProgress copyWith(
      {enums.ViewState? viewState, double? position, double? duration}) {
    return ViewProgress(
        viewState: viewState ?? this.viewState,
        position: position ?? this.position,
        duration: duration ?? this.duration);
  }

  ViewProgress copyWithWrapped(
      {Wrapped<enums.ViewState>? viewState,
      Wrapped<double>? position,
      Wrapped<double>? duration}) {
    return ViewProgress(
        viewState: (viewState != null ? viewState.value : this.viewState),
        position: (position != null ? position.value : this.position),
        duration: (duration != null ? duration.value : this.duration));
  }
}

@JsonSerializable(explicitToJson: true)
class Error {
  Error({
    this.error,
  });

  factory Error.fromJson(Map<String, dynamic> json) => _$ErrorFromJson(json);

  @JsonKey(name: 'error', includeIfNull: false)
  final Error$Error? error;
  static const fromJsonFactory = _$ErrorFromJson;
  static const toJsonFactory = _$ErrorToJson;
  Map<String, dynamic> toJson() => _$ErrorToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Error &&
            (identical(other.error, error) ||
                const DeepCollectionEquality().equals(other.error, error)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(error) ^ runtimeType.hashCode;
}

extension $ErrorExtension on Error {
  Error copyWith({Error$Error? error}) {
    return Error(error: error ?? this.error);
  }

  Error copyWithWrapped({Wrapped<Error$Error?>? error}) {
    return Error(error: (error != null ? error.value : this.error));
  }
}

@JsonSerializable(explicitToJson: true)
class Error$Error {
  Error$Error({
    this.httpStatusCode,
    this.statusCode,
    this.message,
    this.correlationId,
  });

  factory Error$Error.fromJson(Map<String, dynamic> json) =>
      _$Error$ErrorFromJson(json);

  @JsonKey(name: 'httpStatusCode', includeIfNull: false)
  final int? httpStatusCode;
  @JsonKey(name: 'statusCode', includeIfNull: false)
  final int? statusCode;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'correlationId', includeIfNull: false, defaultValue: '')
  final String? correlationId;
  static const fromJsonFactory = _$Error$ErrorFromJson;
  static const toJsonFactory = _$Error$ErrorToJson;
  Map<String, dynamic> toJson() => _$Error$ErrorToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Error$Error &&
            (identical(other.httpStatusCode, httpStatusCode) ||
                const DeepCollectionEquality()
                    .equals(other.httpStatusCode, httpStatusCode)) &&
            (identical(other.statusCode, statusCode) ||
                const DeepCollectionEquality()
                    .equals(other.statusCode, statusCode)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.correlationId, correlationId) ||
                const DeepCollectionEquality()
                    .equals(other.correlationId, correlationId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(httpStatusCode) ^
      const DeepCollectionEquality().hash(statusCode) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(correlationId) ^
      runtimeType.hashCode;
}

extension $Error$ErrorExtension on Error$Error {
  Error$Error copyWith(
      {int? httpStatusCode,
      int? statusCode,
      String? message,
      String? correlationId}) {
    return Error$Error(
        httpStatusCode: httpStatusCode ?? this.httpStatusCode,
        statusCode: statusCode ?? this.statusCode,
        message: message ?? this.message,
        correlationId: correlationId ?? this.correlationId);
  }

  Error$Error copyWithWrapped(
      {Wrapped<int?>? httpStatusCode,
      Wrapped<int?>? statusCode,
      Wrapped<String?>? message,
      Wrapped<String?>? correlationId}) {
    return Error$Error(
        httpStatusCode: (httpStatusCode != null
            ? httpStatusCode.value
            : this.httpStatusCode),
        statusCode: (statusCode != null ? statusCode.value : this.statusCode),
        message: (message != null ? message.value : this.message),
        correlationId:
            (correlationId != null ? correlationId.value : this.correlationId));
  }
}

String? viewStateToJson(enums.ViewState? viewState) {
  return enums.$ViewStateMap[viewState];
}

enums.ViewState viewStateFromJson(
  Object? viewState, [
  enums.ViewState? defaultValue,
]) {
  if (viewState is String) {
    return enums.$ViewStateMap.entries
        .firstWhere(
            (element) => element.value.toLowerCase() == viewState.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.ViewState.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ViewStateMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ViewState.swaggerGeneratedUnknown;
}

List<String> viewStateListToJson(List<enums.ViewState>? viewState) {
  if (viewState == null) {
    return [];
  }

  return viewState.map((e) => enums.$ViewStateMap[e]!).toList();
}

List<enums.ViewState> viewStateListFromJson(
  List? viewState, [
  List<enums.ViewState>? defaultValue,
]) {
  if (viewState == null) {
    return defaultValue ?? [];
  }

  return viewState.map((e) => viewStateFromJson(e.toString())).toList();
}

List<enums.ViewState>? viewStateNullableListFromJson(
  List? viewState, [
  List<enums.ViewState>? defaultValue,
]) {
  if (viewState == null) {
    return defaultValue;
  }

  return viewState.map((e) => viewStateFromJson(e.toString())).toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
