import 'package:json_annotation/json_annotation.dart';

enum ContentRequestType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('CHANNEL')
  channel,
  @JsonValue('PROVIDER')
  provider
}

const $ContentRequestTypeMap = {
  ContentRequestType.channel: 'CHANNEL',
  ContentRequestType.provider: 'PROVIDER'
};

enum IntentResourceIdImageTypeGetMode {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('stretch')
  stretch,
  @JsonValue('box')
  box,
  @JsonValue('crop')
  crop,
  @JsonValue('fill')
  fill,
  @JsonValue('fill-NorthWest')
  fillNorthwest,
  @JsonValue('fill-North')
  fillNorth,
  @JsonValue('fill-NorthEast')
  fillNortheast,
  @JsonValue('fill-West')
  fillWest,
  @JsonValue('fill-Center')
  fillCenter,
  @JsonValue('fill-East')
  fillEast,
  @JsonValue('fill-SouthWest')
  fillSouthwest,
  @JsonValue('fill-South')
  fillSouth,
  @JsonValue('fill-SouthEast')
  fillSoutheast
}

const $IntentResourceIdImageTypeGetModeMap = {
  IntentResourceIdImageTypeGetMode.stretch: 'stretch',
  IntentResourceIdImageTypeGetMode.box: 'box',
  IntentResourceIdImageTypeGetMode.crop: 'crop',
  IntentResourceIdImageTypeGetMode.fill: 'fill',
  IntentResourceIdImageTypeGetMode.fillNorthwest: 'fill-NorthWest',
  IntentResourceIdImageTypeGetMode.fillNorth: 'fill-North',
  IntentResourceIdImageTypeGetMode.fillNortheast: 'fill-NorthEast',
  IntentResourceIdImageTypeGetMode.fillWest: 'fill-West',
  IntentResourceIdImageTypeGetMode.fillCenter: 'fill-Center',
  IntentResourceIdImageTypeGetMode.fillEast: 'fill-East',
  IntentResourceIdImageTypeGetMode.fillSouthwest: 'fill-SouthWest',
  IntentResourceIdImageTypeGetMode.fillSouth: 'fill-South',
  IntentResourceIdImageTypeGetMode.fillSoutheast: 'fill-SouthEast'
};

enum IntentResourceIdImageTypeGetFormat {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('jpg')
  jpg,
  @JsonValue('jpeg')
  jpeg,
  @JsonValue('png')
  png,
  @JsonValue('webp')
  webp,
  @JsonValue('jp2')
  jp2,
  @JsonValue('jxr')
  jxr
}

const $IntentResourceIdImageTypeGetFormatMap = {
  IntentResourceIdImageTypeGetFormat.jpg: 'jpg',
  IntentResourceIdImageTypeGetFormat.jpeg: 'jpeg',
  IntentResourceIdImageTypeGetFormat.png: 'png',
  IntentResourceIdImageTypeGetFormat.webp: 'webp',
  IntentResourceIdImageTypeGetFormat.jp2: 'jp2',
  IntentResourceIdImageTypeGetFormat.jxr: 'jxr'
};

enum IntentResourceIdImageTypeGetChannel {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('Red')
  red,
  @JsonValue('Green')
  green,
  @JsonValue('Blue')
  blue,
  @JsonValue('Opacity')
  opacity,
  @JsonValue('Gray')
  gray
}

const $IntentResourceIdImageTypeGetChannelMap = {
  IntentResourceIdImageTypeGetChannel.red: 'Red',
  IntentResourceIdImageTypeGetChannel.green: 'Green',
  IntentResourceIdImageTypeGetChannel.blue: 'Blue',
  IntentResourceIdImageTypeGetChannel.opacity: 'Opacity',
  IntentResourceIdImageTypeGetChannel.gray: 'Gray'
};

enum IntentResourceIdImageTypeGetColorSpace {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('CMY')
  cmy,
  @JsonValue('CMYK')
  cmyk,
  @JsonValue('Gray')
  gray,
  @JsonValue('HCL')
  hcl,
  @JsonValue('HCLp')
  hclp,
  @JsonValue('HSB')
  hsb,
  @JsonValue('HSI')
  hsi,
  @JsonValue('HSL')
  hsl,
  @JsonValue('HSV')
  hsv,
  @JsonValue('HWB')
  hwb,
  @JsonValue('Lab')
  lab,
  @JsonValue('LCHab')
  lchab,
  @JsonValue('LCHuv')
  lchuv,
  @JsonValue('LMS')
  lms,
  @JsonValue('Log')
  log,
  @JsonValue('Luv')
  luv,
  @JsonValue('OHTA')
  ohta,
  @JsonValue('Rec601YCbCr')
  rec601ycbcr,
  @JsonValue('Rec709YCbCr')
  rec709ycbcr,
  @JsonValue('RGB')
  rgb,
  @JsonValue('scRGB')
  scrgb,
  @JsonValue('sRGB')
  srgb,
  @JsonValue('Transparent')
  transparent,
  @JsonValue('xyY')
  xyy,
  @JsonValue('XYZ')
  xyz,
  @JsonValue('YCbCr')
  ycbcr,
  @JsonValue('YCC')
  ycc,
  @JsonValue('YDbDr')
  ydbdr,
  @JsonValue('YIQ')
  yiq,
  @JsonValue('YPbPr')
  ypbpr,
  @JsonValue('YUV')
  yuv
}

const $IntentResourceIdImageTypeGetColorSpaceMap = {
  IntentResourceIdImageTypeGetColorSpace.cmy: 'CMY',
  IntentResourceIdImageTypeGetColorSpace.cmyk: 'CMYK',
  IntentResourceIdImageTypeGetColorSpace.gray: 'Gray',
  IntentResourceIdImageTypeGetColorSpace.hcl: 'HCL',
  IntentResourceIdImageTypeGetColorSpace.hclp: 'HCLp',
  IntentResourceIdImageTypeGetColorSpace.hsb: 'HSB',
  IntentResourceIdImageTypeGetColorSpace.hsi: 'HSI',
  IntentResourceIdImageTypeGetColorSpace.hsl: 'HSL',
  IntentResourceIdImageTypeGetColorSpace.hsv: 'HSV',
  IntentResourceIdImageTypeGetColorSpace.hwb: 'HWB',
  IntentResourceIdImageTypeGetColorSpace.lab: 'Lab',
  IntentResourceIdImageTypeGetColorSpace.lchab: 'LCHab',
  IntentResourceIdImageTypeGetColorSpace.lchuv: 'LCHuv',
  IntentResourceIdImageTypeGetColorSpace.lms: 'LMS',
  IntentResourceIdImageTypeGetColorSpace.log: 'Log',
  IntentResourceIdImageTypeGetColorSpace.luv: 'Luv',
  IntentResourceIdImageTypeGetColorSpace.ohta: 'OHTA',
  IntentResourceIdImageTypeGetColorSpace.rec601ycbcr: 'Rec601YCbCr',
  IntentResourceIdImageTypeGetColorSpace.rec709ycbcr: 'Rec709YCbCr',
  IntentResourceIdImageTypeGetColorSpace.rgb: 'RGB',
  IntentResourceIdImageTypeGetColorSpace.scrgb: 'scRGB',
  IntentResourceIdImageTypeGetColorSpace.srgb: 'sRGB',
  IntentResourceIdImageTypeGetColorSpace.transparent: 'Transparent',
  IntentResourceIdImageTypeGetColorSpace.xyy: 'xyY',
  IntentResourceIdImageTypeGetColorSpace.xyz: 'XYZ',
  IntentResourceIdImageTypeGetColorSpace.ycbcr: 'YCbCr',
  IntentResourceIdImageTypeGetColorSpace.ycc: 'YCC',
  IntentResourceIdImageTypeGetColorSpace.ydbdr: 'YDbDr',
  IntentResourceIdImageTypeGetColorSpace.yiq: 'YIQ',
  IntentResourceIdImageTypeGetColorSpace.ypbpr: 'YPbPr',
  IntentResourceIdImageTypeGetColorSpace.yuv: 'YUV'
};

enum IntentResourceIdImageTypeGetType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('CHANNEL')
  channel,
  @JsonValue('PROVIDER')
  provider
}

const $IntentResourceIdImageTypeGetTypeMap = {
  IntentResourceIdImageTypeGetType.channel: 'CHANNEL',
  IntentResourceIdImageTypeGetType.provider: 'PROVIDER'
};

enum MetadataPathGetMode {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('stretch')
  stretch,
  @JsonValue('box')
  box,
  @JsonValue('crop')
  crop,
  @JsonValue('fill')
  fill,
  @JsonValue('fill-NorthWest')
  fillNorthwest,
  @JsonValue('fill-North')
  fillNorth,
  @JsonValue('fill-NorthEast')
  fillNortheast,
  @JsonValue('fill-West')
  fillWest,
  @JsonValue('fill-Center')
  fillCenter,
  @JsonValue('fill-East')
  fillEast,
  @JsonValue('fill-SouthWest')
  fillSouthwest,
  @JsonValue('fill-South')
  fillSouth,
  @JsonValue('fill-SouthEast')
  fillSoutheast
}

const $MetadataPathGetModeMap = {
  MetadataPathGetMode.stretch: 'stretch',
  MetadataPathGetMode.box: 'box',
  MetadataPathGetMode.crop: 'crop',
  MetadataPathGetMode.fill: 'fill',
  MetadataPathGetMode.fillNorthwest: 'fill-NorthWest',
  MetadataPathGetMode.fillNorth: 'fill-North',
  MetadataPathGetMode.fillNortheast: 'fill-NorthEast',
  MetadataPathGetMode.fillWest: 'fill-West',
  MetadataPathGetMode.fillCenter: 'fill-Center',
  MetadataPathGetMode.fillEast: 'fill-East',
  MetadataPathGetMode.fillSouthwest: 'fill-SouthWest',
  MetadataPathGetMode.fillSouth: 'fill-South',
  MetadataPathGetMode.fillSoutheast: 'fill-SouthEast'
};

enum MetadataPathGetFormat {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('jpg')
  jpg,
  @JsonValue('jpeg')
  jpeg,
  @JsonValue('png')
  png,
  @JsonValue('webp')
  webp,
  @JsonValue('jp2')
  jp2,
  @JsonValue('jxr')
  jxr
}

const $MetadataPathGetFormatMap = {
  MetadataPathGetFormat.jpg: 'jpg',
  MetadataPathGetFormat.jpeg: 'jpeg',
  MetadataPathGetFormat.png: 'png',
  MetadataPathGetFormat.webp: 'webp',
  MetadataPathGetFormat.jp2: 'jp2',
  MetadataPathGetFormat.jxr: 'jxr'
};

enum MetadataPathGetChannel {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('Red')
  red,
  @JsonValue('Green')
  green,
  @JsonValue('Blue')
  blue,
  @JsonValue('Opacity')
  opacity,
  @JsonValue('Gray')
  gray
}

const $MetadataPathGetChannelMap = {
  MetadataPathGetChannel.red: 'Red',
  MetadataPathGetChannel.green: 'Green',
  MetadataPathGetChannel.blue: 'Blue',
  MetadataPathGetChannel.opacity: 'Opacity',
  MetadataPathGetChannel.gray: 'Gray'
};

enum MetadataPathGetColorspace {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('CMY')
  cmy,
  @JsonValue('CMYK')
  cmyk,
  @JsonValue('Gray')
  gray,
  @JsonValue('HCL')
  hcl,
  @JsonValue('HCLp')
  hclp,
  @JsonValue('HSB')
  hsb,
  @JsonValue('HSI')
  hsi,
  @JsonValue('HSL')
  hsl,
  @JsonValue('HSV')
  hsv,
  @JsonValue('HWB')
  hwb,
  @JsonValue('Lab')
  lab,
  @JsonValue('LCHab')
  lchab,
  @JsonValue('LCHuv')
  lchuv,
  @JsonValue('LMS')
  lms,
  @JsonValue('Log')
  log,
  @JsonValue('Luv')
  luv,
  @JsonValue('OHTA')
  ohta,
  @JsonValue('Rec601YCbCr')
  rec601ycbcr,
  @JsonValue('Rec709YCbCr')
  rec709ycbcr,
  @JsonValue('RGB')
  rgb,
  @JsonValue('scRGB')
  scrgb,
  @JsonValue('sRGB')
  srgb,
  @JsonValue('Transparent')
  transparent,
  @JsonValue('xyY')
  xyy,
  @JsonValue('XYZ')
  xyz,
  @JsonValue('YCbCr')
  ycbcr,
  @JsonValue('YCC')
  ycc,
  @JsonValue('YDbDr')
  ydbdr,
  @JsonValue('YIQ')
  yiq,
  @JsonValue('YPbPr')
  ypbpr,
  @JsonValue('YUV')
  yuv
}

const $MetadataPathGetColorspaceMap = {
  MetadataPathGetColorspace.cmy: 'CMY',
  MetadataPathGetColorspace.cmyk: 'CMYK',
  MetadataPathGetColorspace.gray: 'Gray',
  MetadataPathGetColorspace.hcl: 'HCL',
  MetadataPathGetColorspace.hclp: 'HCLp',
  MetadataPathGetColorspace.hsb: 'HSB',
  MetadataPathGetColorspace.hsi: 'HSI',
  MetadataPathGetColorspace.hsl: 'HSL',
  MetadataPathGetColorspace.hsv: 'HSV',
  MetadataPathGetColorspace.hwb: 'HWB',
  MetadataPathGetColorspace.lab: 'Lab',
  MetadataPathGetColorspace.lchab: 'LCHab',
  MetadataPathGetColorspace.lchuv: 'LCHuv',
  MetadataPathGetColorspace.lms: 'LMS',
  MetadataPathGetColorspace.log: 'Log',
  MetadataPathGetColorspace.luv: 'Luv',
  MetadataPathGetColorspace.ohta: 'OHTA',
  MetadataPathGetColorspace.rec601ycbcr: 'Rec601YCbCr',
  MetadataPathGetColorspace.rec709ycbcr: 'Rec709YCbCr',
  MetadataPathGetColorspace.rgb: 'RGB',
  MetadataPathGetColorspace.scrgb: 'scRGB',
  MetadataPathGetColorspace.srgb: 'sRGB',
  MetadataPathGetColorspace.transparent: 'Transparent',
  MetadataPathGetColorspace.xyy: 'xyY',
  MetadataPathGetColorspace.xyz: 'XYZ',
  MetadataPathGetColorspace.ycbcr: 'YCbCr',
  MetadataPathGetColorspace.ycc: 'YCC',
  MetadataPathGetColorspace.ydbdr: 'YDbDr',
  MetadataPathGetColorspace.yiq: 'YIQ',
  MetadataPathGetColorspace.ypbpr: 'YPbPr',
  MetadataPathGetColorspace.yuv: 'YUV'
};

enum PathGetMode {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('stretch')
  stretch,
  @JsonValue('box')
  box,
  @JsonValue('crop')
  crop,
  @JsonValue('fill')
  fill,
  @JsonValue('fill-NorthWest')
  fillNorthwest,
  @JsonValue('fill-North')
  fillNorth,
  @JsonValue('fill-NorthEast')
  fillNortheast,
  @JsonValue('fill-West')
  fillWest,
  @JsonValue('fill-Center')
  fillCenter,
  @JsonValue('fill-East')
  fillEast,
  @JsonValue('fill-SouthWest')
  fillSouthwest,
  @JsonValue('fill-South')
  fillSouth,
  @JsonValue('fill-SouthEast')
  fillSoutheast
}

const $PathGetModeMap = {
  PathGetMode.stretch: 'stretch',
  PathGetMode.box: 'box',
  PathGetMode.crop: 'crop',
  PathGetMode.fill: 'fill',
  PathGetMode.fillNorthwest: 'fill-NorthWest',
  PathGetMode.fillNorth: 'fill-North',
  PathGetMode.fillNortheast: 'fill-NorthEast',
  PathGetMode.fillWest: 'fill-West',
  PathGetMode.fillCenter: 'fill-Center',
  PathGetMode.fillEast: 'fill-East',
  PathGetMode.fillSouthwest: 'fill-SouthWest',
  PathGetMode.fillSouth: 'fill-South',
  PathGetMode.fillSoutheast: 'fill-SouthEast'
};

enum PathGetFormat {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('jpg')
  jpg,
  @JsonValue('jpeg')
  jpeg,
  @JsonValue('png')
  png,
  @JsonValue('webp')
  webp,
  @JsonValue('jp2')
  jp2,
  @JsonValue('jxr')
  jxr
}

const $PathGetFormatMap = {
  PathGetFormat.jpg: 'jpg',
  PathGetFormat.jpeg: 'jpeg',
  PathGetFormat.png: 'png',
  PathGetFormat.webp: 'webp',
  PathGetFormat.jp2: 'jp2',
  PathGetFormat.jxr: 'jxr'
};

enum PathGetChannel {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('Red')
  red,
  @JsonValue('Green')
  green,
  @JsonValue('Blue')
  blue,
  @JsonValue('Opacity')
  opacity,
  @JsonValue('Gray')
  gray
}

const $PathGetChannelMap = {
  PathGetChannel.red: 'Red',
  PathGetChannel.green: 'Green',
  PathGetChannel.blue: 'Blue',
  PathGetChannel.opacity: 'Opacity',
  PathGetChannel.gray: 'Gray'
};

enum PathGetColorspace {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('CMY')
  cmy,
  @JsonValue('CMYK')
  cmyk,
  @JsonValue('Gray')
  gray,
  @JsonValue('HCL')
  hcl,
  @JsonValue('HCLp')
  hclp,
  @JsonValue('HSB')
  hsb,
  @JsonValue('HSI')
  hsi,
  @JsonValue('HSL')
  hsl,
  @JsonValue('HSV')
  hsv,
  @JsonValue('HWB')
  hwb,
  @JsonValue('Lab')
  lab,
  @JsonValue('LCHab')
  lchab,
  @JsonValue('LCHuv')
  lchuv,
  @JsonValue('LMS')
  lms,
  @JsonValue('Log')
  log,
  @JsonValue('Luv')
  luv,
  @JsonValue('OHTA')
  ohta,
  @JsonValue('Rec601YCbCr')
  rec601ycbcr,
  @JsonValue('Rec709YCbCr')
  rec709ycbcr,
  @JsonValue('RGB')
  rgb,
  @JsonValue('scRGB')
  scrgb,
  @JsonValue('sRGB')
  srgb,
  @JsonValue('Transparent')
  transparent,
  @JsonValue('xyY')
  xyy,
  @JsonValue('XYZ')
  xyz,
  @JsonValue('YCbCr')
  ycbcr,
  @JsonValue('YCC')
  ycc,
  @JsonValue('YDbDr')
  ydbdr,
  @JsonValue('YIQ')
  yiq,
  @JsonValue('YPbPr')
  ypbpr,
  @JsonValue('YUV')
  yuv
}

const $PathGetColorspaceMap = {
  PathGetColorspace.cmy: 'CMY',
  PathGetColorspace.cmyk: 'CMYK',
  PathGetColorspace.gray: 'Gray',
  PathGetColorspace.hcl: 'HCL',
  PathGetColorspace.hclp: 'HCLp',
  PathGetColorspace.hsb: 'HSB',
  PathGetColorspace.hsi: 'HSI',
  PathGetColorspace.hsl: 'HSL',
  PathGetColorspace.hsv: 'HSV',
  PathGetColorspace.hwb: 'HWB',
  PathGetColorspace.lab: 'Lab',
  PathGetColorspace.lchab: 'LCHab',
  PathGetColorspace.lchuv: 'LCHuv',
  PathGetColorspace.lms: 'LMS',
  PathGetColorspace.log: 'Log',
  PathGetColorspace.luv: 'Luv',
  PathGetColorspace.ohta: 'OHTA',
  PathGetColorspace.rec601ycbcr: 'Rec601YCbCr',
  PathGetColorspace.rec709ycbcr: 'Rec709YCbCr',
  PathGetColorspace.rgb: 'RGB',
  PathGetColorspace.scrgb: 'scRGB',
  PathGetColorspace.srgb: 'sRGB',
  PathGetColorspace.transparent: 'Transparent',
  PathGetColorspace.xyy: 'xyY',
  PathGetColorspace.xyz: 'XYZ',
  PathGetColorspace.ycbcr: 'YCbCr',
  PathGetColorspace.ycc: 'YCC',
  PathGetColorspace.ydbdr: 'YDbDr',
  PathGetColorspace.yiq: 'YIQ',
  PathGetColorspace.ypbpr: 'YPbPr',
  PathGetColorspace.yuv: 'YUV'
};
