// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'liberty_jikg_service.enums.swagger.dart' as enums;
export 'liberty_jikg_service.enums.swagger.dart';

part 'liberty_jikg_service.swagger.chopper.dart';
part 'liberty_jikg_service.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class LibertyJikgService extends ChopperService {
  static LibertyJikgService create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$LibertyJikgService(client);
    }

    final newClient = ChopperClient(
        services: [_$LibertyJikgService()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$LibertyJikgService(newClient);
  }

  ///Request Field Keys
  ///@param LgiId LGI Standard SN format
  ///@param body method input
  Future<chopper.Response<GetKeysOutput>> getFieldKeysLgiIdPost({
    required String? lgiId,
    required GetKeysInput? body,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        GetKeysInput, () => GetKeysInput.fromJsonFactory);
    generatedMapping.putIfAbsent(
        GetKeysOutput$Item, () => GetKeysOutput$Item.fromJsonFactory);

    return _getFieldKeysLgiIdPost(
        lgiId: lgiId, body: body, cacheControl: cacheControl);
  }

  ///Request Field Keys
  ///@param LgiId LGI Standard SN format
  ///@param body method input
  @Post(path: '/GetFieldKeys/{LgiId}')
  Future<chopper.Response<GetKeysOutput>> _getFieldKeysLgiIdPost({
    @Path('LgiId') required String? lgiId,
    @Body() required GetKeysInput? body,
    @Header('Cache-Control') String? cacheControl,
  });
}

typedef GetKeysOutput = List<GetKeysOutput$Item>;

@JsonSerializable(explicitToJson: true)
class GetKeysOutput$Item {
  GetKeysOutput$Item({
    this.name,
    this.version,
    this.type,
    this.serialNumber,
    this.key,
  });

  factory GetKeysOutput$Item.fromJson(Map<String, dynamic> json) =>
      _$GetKeysOutput$ItemFromJson(json);

  @JsonKey(name: 'Name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'Version', includeIfNull: false)
  final int? version;
  @JsonKey(name: 'Type', includeIfNull: false, defaultValue: '')
  final String? type;
  @JsonKey(name: 'SerialNumber', includeIfNull: false, defaultValue: '')
  final String? serialNumber;
  @JsonKey(name: 'Key', includeIfNull: false, defaultValue: '')
  final String? key;
  static const fromJsonFactory = _$GetKeysOutput$ItemFromJson;
  static const toJsonFactory = _$GetKeysOutput$ItemToJson;
  Map<String, dynamic> toJson() => _$GetKeysOutput$ItemToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is GetKeysOutput$Item &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.serialNumber, serialNumber) ||
                const DeepCollectionEquality()
                    .equals(other.serialNumber, serialNumber)) &&
            (identical(other.key, key) ||
                const DeepCollectionEquality().equals(other.key, key)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(serialNumber) ^
      const DeepCollectionEquality().hash(key) ^
      runtimeType.hashCode;
}

extension $GetKeysOutput$ItemExtension on GetKeysOutput$Item {
  GetKeysOutput$Item copyWith(
      {String? name,
      int? version,
      String? type,
      String? serialNumber,
      String? key}) {
    return GetKeysOutput$Item(
        name: name ?? this.name,
        version: version ?? this.version,
        type: type ?? this.type,
        serialNumber: serialNumber ?? this.serialNumber,
        key: key ?? this.key);
  }

  GetKeysOutput$Item copyWithWrapped(
      {Wrapped<String?>? name,
      Wrapped<int?>? version,
      Wrapped<String?>? type,
      Wrapped<String?>? serialNumber,
      Wrapped<String?>? key}) {
    return GetKeysOutput$Item(
        name: (name != null ? name.value : this.name),
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type),
        serialNumber:
            (serialNumber != null ? serialNumber.value : this.serialNumber),
        key: (key != null ? key.value : this.key));
  }
}

@JsonSerializable(explicitToJson: true)
class GetKeysInput {
  GetKeysInput({
    required this.lgiId,
    required this.socId,
    required this.swModel,
    required this.country,
    required this.keyTypes,
  });

  factory GetKeysInput.fromJson(Map<String, dynamic> json) =>
      _$GetKeysInputFromJson(json);

  @JsonKey(name: 'LgiId', includeIfNull: false, defaultValue: '')
  final String lgiId;
  @JsonKey(name: 'SocId', includeIfNull: false, defaultValue: '')
  final String socId;
  @JsonKey(name: 'SwModel', includeIfNull: false, defaultValue: '')
  final String swModel;
  @JsonKey(name: 'Country', includeIfNull: false, defaultValue: '')
  final String country;
  @JsonKey(
    name: 'KeyTypes',
    includeIfNull: false,
    toJson: getKeysInputKeyTypesListToJson,
    fromJson: getKeysInputKeyTypesListFromJson,
  )
  final List<enums.GetKeysInputKeyTypes> keyTypes;
  static const fromJsonFactory = _$GetKeysInputFromJson;
  static const toJsonFactory = _$GetKeysInputToJson;
  Map<String, dynamic> toJson() => _$GetKeysInputToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is GetKeysInput &&
            (identical(other.lgiId, lgiId) ||
                const DeepCollectionEquality().equals(other.lgiId, lgiId)) &&
            (identical(other.socId, socId) ||
                const DeepCollectionEquality().equals(other.socId, socId)) &&
            (identical(other.swModel, swModel) ||
                const DeepCollectionEquality()
                    .equals(other.swModel, swModel)) &&
            (identical(other.country, country) ||
                const DeepCollectionEquality()
                    .equals(other.country, country)) &&
            (identical(other.keyTypes, keyTypes) ||
                const DeepCollectionEquality()
                    .equals(other.keyTypes, keyTypes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(lgiId) ^
      const DeepCollectionEquality().hash(socId) ^
      const DeepCollectionEquality().hash(swModel) ^
      const DeepCollectionEquality().hash(country) ^
      const DeepCollectionEquality().hash(keyTypes) ^
      runtimeType.hashCode;
}

extension $GetKeysInputExtension on GetKeysInput {
  GetKeysInput copyWith(
      {String? lgiId,
      String? socId,
      String? swModel,
      String? country,
      List<enums.GetKeysInputKeyTypes>? keyTypes}) {
    return GetKeysInput(
        lgiId: lgiId ?? this.lgiId,
        socId: socId ?? this.socId,
        swModel: swModel ?? this.swModel,
        country: country ?? this.country,
        keyTypes: keyTypes ?? this.keyTypes);
  }

  GetKeysInput copyWithWrapped(
      {Wrapped<String>? lgiId,
      Wrapped<String>? socId,
      Wrapped<String>? swModel,
      Wrapped<String>? country,
      Wrapped<List<enums.GetKeysInputKeyTypes>>? keyTypes}) {
    return GetKeysInput(
        lgiId: (lgiId != null ? lgiId.value : this.lgiId),
        socId: (socId != null ? socId.value : this.socId),
        swModel: (swModel != null ? swModel.value : this.swModel),
        country: (country != null ? country.value : this.country),
        keyTypes: (keyTypes != null ? keyTypes.value : this.keyTypes));
  }
}

@JsonSerializable(explicitToJson: true)
class ErrorOutput {
  ErrorOutput({
    this.error,
  });

  factory ErrorOutput.fromJson(Map<String, dynamic> json) =>
      _$ErrorOutputFromJson(json);

  @JsonKey(name: 'error', includeIfNull: false, defaultValue: '')
  final String? error;
  static const fromJsonFactory = _$ErrorOutputFromJson;
  static const toJsonFactory = _$ErrorOutputToJson;
  Map<String, dynamic> toJson() => _$ErrorOutputToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ErrorOutput &&
            (identical(other.error, error) ||
                const DeepCollectionEquality().equals(other.error, error)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(error) ^ runtimeType.hashCode;
}

extension $ErrorOutputExtension on ErrorOutput {
  ErrorOutput copyWith({String? error}) {
    return ErrorOutput(error: error ?? this.error);
  }

  ErrorOutput copyWithWrapped({Wrapped<String?>? error}) {
    return ErrorOutput(error: (error != null ? error.value : this.error));
  }
}

String? getKeysInputKeyTypesToJson(
    enums.GetKeysInputKeyTypes? getKeysInputKeyTypes) {
  return enums.$GetKeysInputKeyTypesMap[getKeysInputKeyTypes];
}

enums.GetKeysInputKeyTypes getKeysInputKeyTypesFromJson(
  Object? getKeysInputKeyTypes, [
  enums.GetKeysInputKeyTypes? defaultValue,
]) {
  if (getKeysInputKeyTypes is String) {
    return enums.$GetKeysInputKeyTypesMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                getKeysInputKeyTypes.toLowerCase(),
            orElse: () => const MapEntry(
                enums.GetKeysInputKeyTypes.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$GetKeysInputKeyTypesMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.GetKeysInputKeyTypes.swaggerGeneratedUnknown;
}

List<String> getKeysInputKeyTypesListToJson(
    List<enums.GetKeysInputKeyTypes>? getKeysInputKeyTypes) {
  if (getKeysInputKeyTypes == null) {
    return [];
  }

  return getKeysInputKeyTypes
      .map((e) => enums.$GetKeysInputKeyTypesMap[e]!)
      .toList();
}

List<enums.GetKeysInputKeyTypes> getKeysInputKeyTypesListFromJson(
  List? getKeysInputKeyTypes, [
  List<enums.GetKeysInputKeyTypes>? defaultValue,
]) {
  if (getKeysInputKeyTypes == null) {
    return defaultValue ?? [];
  }

  return getKeysInputKeyTypes
      .map((e) => getKeysInputKeyTypesFromJson(e.toString()))
      .toList();
}

List<enums.GetKeysInputKeyTypes>? getKeysInputKeyTypesNullableListFromJson(
  List? getKeysInputKeyTypes, [
  List<enums.GetKeysInputKeyTypes>? defaultValue,
]) {
  if (getKeysInputKeyTypes == null) {
    return defaultValue;
  }

  return getKeysInputKeyTypes
      .map((e) => getKeysInputKeyTypesFromJson(e.toString()))
      .toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
