// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'liberty_picker_service.enums.swagger.dart' as enums;
export 'liberty_picker_service.enums.swagger.dart';

part 'liberty_picker_service.swagger.chopper.dart';
part 'liberty_picker_service.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class LibertyPickerService extends ChopperService {
  static LibertyPickerService create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$LibertyPickerService(client);
    }

    final newClient = ChopperClient(
        services: [_$LibertyPickerService()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http:///');
    return _$LibertyPickerService(newClient);
  }

  ///Retrieve series details
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param seasonCrid Series crid to retrieve episodes. Season's crid or show's (in case if show doesn't have seasons)
  ///@param showCrid Show's crid. Should be used only, when ''seriesCrid'' is a season's crid.
  ///@param selectedEventId The ''CRID'' and ''IMI'' of the selected event.
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<SeriesDetailResponse>> v1SeriesDetailSeasonCridGet({
    String? xDev,
    String? xCus = 'X-Cus',
    String? xSessionId,
    String? xEntitlementsToken = 'X-Entitlements-Token',
    required String? profileId,
    required String? customerId,
    required String? language,
    required String? country,
    required String? seasonCrid,
    String? showCrid,
    String? selectedEventId,
    String? maxRes,
    int? replayOptedInTime,
    String? cityId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SeriesDetailResponse, () => SeriesDetailResponse.fromJsonFactory);

    return _v1SeriesDetailSeasonCridGet(
        xDev: xDev,
        xCus: xCus,
        xSessionId: xSessionId,
        xEntitlementsToken: xEntitlementsToken,
        profileId: profileId,
        customerId: customerId,
        language: language,
        country: country,
        seasonCrid: seasonCrid,
        showCrid: showCrid,
        selectedEventId: selectedEventId,
        maxRes: maxRes,
        replayOptedInTime: replayOptedInTime,
        cityId: cityId,
        cacheControl: cacheControl);
  }

  ///Retrieve series details
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param seasonCrid Series crid to retrieve episodes. Season's crid or show's (in case if show doesn't have seasons)
  ///@param showCrid Show's crid. Should be used only, when ''seriesCrid'' is a season's crid.
  ///@param selectedEventId The ''CRID'' and ''IMI'' of the selected event.
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/seriesDetail/{seasonCrid}')
  Future<chopper.Response<SeriesDetailResponse>> _v1SeriesDetailSeasonCridGet({
    @Header('X-Dev') String? xDev,
    @Header('X-Cus') String? xCus = 'X-Cus',
    @Header('X-Session-Id') String? xSessionId,
    @Header('x-entitlements-token')
        String? xEntitlementsToken = 'X-Entitlements-Token',
    @Query('profileId') required String? profileId,
    @Query('customerId') required String? customerId,
    @Query('language') required String? language,
    @Query('country') required String? country,
    @Path('seasonCrid') required String? seasonCrid,
    @Query('showCrid') String? showCrid,
    @Query('selectedEventId') String? selectedEventId,
    @Query('maxRes') String? maxRes,
    @Query('replayOptedInTime') int? replayOptedInTime,
    @Query('cityId') String? cityId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Retrieve event details
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param seriesId Series Content Reference Identifier(eg: 'crid://bds.tv/162392685').
  ///@param titleCrid Title Content Reference Identifier(eg: 'crid://bds.tv/162392685').
  ///@param eventId Event Instance Metadata Identifier (eg: 'imi:51a4f05fc8421e6346e80099d6173921').
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<EventDetailResponse>> v1EventDetailGet({
    String? xDev,
    String? xCus = 'X-Cus',
    String? xSessionId,
    String? xEntitlementsToken = 'X-Entitlements-Token',
    required String? profileId,
    required String? customerId,
    required String? language,
    required String? country,
    String? seriesId,
    String? titleCrid,
    String? eventId,
    String? maxRes,
    int? replayOptedInTime,
    String? cityId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        EventDetailResponse, () => EventDetailResponse.fromJsonFactory);

    return _v1EventDetailGet(
        xDev: xDev,
        xCus: xCus,
        xSessionId: xSessionId,
        xEntitlementsToken: xEntitlementsToken,
        profileId: profileId,
        customerId: customerId,
        language: language,
        country: country,
        seriesId: seriesId,
        titleCrid: titleCrid,
        eventId: eventId,
        maxRes: maxRes,
        replayOptedInTime: replayOptedInTime,
        cityId: cityId,
        cacheControl: cacheControl);
  }

  ///Retrieve event details
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param seriesId Series Content Reference Identifier(eg: 'crid://bds.tv/162392685').
  ///@param titleCrid Title Content Reference Identifier(eg: 'crid://bds.tv/162392685').
  ///@param eventId Event Instance Metadata Identifier (eg: 'imi:51a4f05fc8421e6346e80099d6173921').
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/eventDetail')
  Future<chopper.Response<EventDetailResponse>> _v1EventDetailGet({
    @Header('X-Dev') String? xDev,
    @Header('X-Cus') String? xCus = 'X-Cus',
    @Header('X-Session-Id') String? xSessionId,
    @Header('x-entitlements-token')
        String? xEntitlementsToken = 'X-Entitlements-Token',
    @Query('profileId') required String? profileId,
    @Query('customerId') required String? customerId,
    @Query('language') required String? language,
    @Query('country') required String? country,
    @Query('seriesId') String? seriesId,
    @Query('titleCrid') String? titleCrid,
    @Query('eventId') String? eventId,
    @Query('maxRes') String? maxRes,
    @Query('replayOptedInTime') int? replayOptedInTime,
    @Query('cityId') String? cityId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Retrieve episode, season, special counts and corresponding channels for a list of series.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param body Customer ID and list of series and multisources to calculate episodes and find corresponding channels. ProfileId is deprecated and ignored by the service, only present for backwards compatibility, to be removed soon. CustomerId is optional. When absent, request is considered anonymous, returning less enriched results.
  Future<chopper.Response<SearchDetailsResponse>> v1SearchDetailsPost({
    String? xDev,
    String? xCus = 'X-Cus',
    String? xSessionId,
    String? xEntitlementsToken = 'X-Entitlements-Token',
    required SearchDetails? body,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SearchDetails, () => SearchDetails.fromJsonFactory);
    generatedMapping.putIfAbsent(
        SearchDetailsResponse, () => SearchDetailsResponse.fromJsonFactory);

    return _v1SearchDetailsPost(
        xDev: xDev,
        xCus: xCus,
        xSessionId: xSessionId,
        xEntitlementsToken: xEntitlementsToken,
        body: body,
        cacheControl: cacheControl);
  }

  ///Retrieve episode, season, special counts and corresponding channels for a list of series.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param body Customer ID and list of series and multisources to calculate episodes and find corresponding channels. ProfileId is deprecated and ignored by the service, only present for backwards compatibility, to be removed soon. CustomerId is optional. When absent, request is considered anonymous, returning less enriched results.
  @Post(path: '/v1/searchDetails')
  Future<chopper.Response<SearchDetailsResponse>> _v1SearchDetailsPost({
    @Header('X-Dev') String? xDev,
    @Header('X-Cus') String? xCus = 'X-Cus',
    @Header('X-Session-Id') String? xSessionId,
    @Header('x-entitlements-token')
        String? xEntitlementsToken = 'X-Entitlements-Token',
    @Body() required SearchDetails? body,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Return most relevant source for given title
  ///@param
  ///@param
  ///@param
  ///@param profileId Profile ID
  ///@param
  ///@param
  ///@param titleId Crid of a title
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<MostRelevantSourceResponse>> v1MostRelevantSourceGet({
    String? xDev,
    String? xCus = 'X-Cus',
    String? xEntitlementsToken = 'X-Entitlements-Token',
    String? profileId,
    required String? language,
    required String? country,
    required String? titleId,
    String? cityId,
    int? replayOptedInTime,
    String? maxRes,
    String? brandingProviderId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(MostRelevantSourceResponse,
        () => MostRelevantSourceResponse.fromJsonFactory);

    return _v1MostRelevantSourceGet(
        xDev: xDev,
        xCus: xCus,
        xEntitlementsToken: xEntitlementsToken,
        profileId: profileId,
        language: language,
        country: country,
        titleId: titleId,
        cityId: cityId,
        replayOptedInTime: replayOptedInTime,
        maxRes: maxRes,
        brandingProviderId: brandingProviderId,
        cacheControl: cacheControl);
  }

  ///Return most relevant source for given title
  ///@param
  ///@param
  ///@param
  ///@param profileId Profile ID
  ///@param
  ///@param
  ///@param titleId Crid of a title
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/mostRelevantSource')
  Future<chopper.Response<MostRelevantSourceResponse>>
      _v1MostRelevantSourceGet({
    @Header('X-Dev') String? xDev,
    @Header('X-Cus') String? xCus = 'X-Cus',
    @Header('x-entitlements-token')
        String? xEntitlementsToken = 'X-Entitlements-Token',
    @Query('profileId') String? profileId,
    @Query('language') required String? language,
    @Query('country') required String? country,
    @Query('titleId') required String? titleId,
    @Query('cityId') String? cityId,
    @Query('replayOptedInTime') int? replayOptedInTime,
    @Query('maxRes') String? maxRes,
    @Query('brandingProviderId') String? brandingProviderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Returns a title crid of the most relevant episode of a series
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param seriesId Crid of a show
  ///@param
  ///@param
  ///@param noSource Boolean to signal to not get the most relevant source or not for the most relevant episode. (mainly used for testing and debugging)
  ///@param
  ///@param brandingProviderId Get vod results only from given branding provider id
  Future<chopper.Response<MostRelevantEpisodeResponse>>
      v1MostRelevantEpisodeGet({
    String? xDev,
    String? xCus = 'X-Cus',
    String? xEntitlementsToken = 'X-Entitlements-Token',
    String? profileId,
    required String? language,
    required String? country,
    required String? seriesId,
    String? cityId,
    int? replayOptedInTime,
    String? noSource,
    String? maxRes,
    String? brandingProviderId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(MostRelevantEpisodeResponse,
        () => MostRelevantEpisodeResponse.fromJsonFactory);

    return _v1MostRelevantEpisodeGet(
        xDev: xDev,
        xCus: xCus,
        xEntitlementsToken: xEntitlementsToken,
        profileId: profileId,
        language: language,
        country: country,
        seriesId: seriesId,
        cityId: cityId,
        replayOptedInTime: replayOptedInTime,
        noSource: noSource,
        maxRes: maxRes,
        brandingProviderId: brandingProviderId,
        cacheControl: cacheControl);
  }

  ///Returns a title crid of the most relevant episode of a series
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param seriesId Crid of a show
  ///@param
  ///@param
  ///@param noSource Boolean to signal to not get the most relevant source or not for the most relevant episode. (mainly used for testing and debugging)
  ///@param
  ///@param brandingProviderId Get vod results only from given branding provider id
  @Get(path: '/v1/mostRelevantEpisode')
  Future<chopper.Response<MostRelevantEpisodeResponse>>
      _v1MostRelevantEpisodeGet({
    @Header('X-Dev') String? xDev,
    @Header('X-Cus') String? xCus = 'X-Cus',
    @Header('x-entitlements-token')
        String? xEntitlementsToken = 'X-Entitlements-Token',
    @Query('profileId') String? profileId,
    @Query('language') required String? language,
    @Query('country') required String? country,
    @Query('seriesId') required String? seriesId,
    @Query('cityId') String? cityId,
    @Query('replayOptedInTime') int? replayOptedInTime,
    @Query('noSource') String? noSource,
    @Query('maxRes') String? maxRes,
    @Query('brandingProviderId') String? brandingProviderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Shows the other sources where the content is available
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param titleId Title's crid.
  ///@param
  ///@param
  ///@param
  ///@param excludedBrandingProviderId Exclude VOD contents for specified branding provider. Either excludedBrandingProviderId or excludedChannelId can be used.
  ///@param excludedChannelId Exclude events and recordings played on specified channel id. Either excludedBrandingProviderId or excludedChannelId can be used.
  Future<chopper.Response> v1TitleAlsoAvailableOnGet({
    String? xDev,
    String? xCus = 'X-Cus',
    String? xEntitlementsToken = 'X-Entitlements-Token',
    String? profileId,
    required String? language,
    required String? country,
    required String? titleId,
    String? maxRes,
    String? cityId,
    int? replayOptedInTime,
    String? excludedBrandingProviderId,
    String? excludedChannelId,
    String? cacheControl,
  }) {
    return _v1TitleAlsoAvailableOnGet(
        xDev: xDev,
        xCus: xCus,
        xEntitlementsToken: xEntitlementsToken,
        profileId: profileId,
        language: language,
        country: country,
        titleId: titleId,
        maxRes: maxRes,
        cityId: cityId,
        replayOptedInTime: replayOptedInTime,
        excludedBrandingProviderId: excludedBrandingProviderId,
        excludedChannelId: excludedChannelId,
        cacheControl: cacheControl);
  }

  ///Shows the other sources where the content is available
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param titleId Title's crid.
  ///@param
  ///@param
  ///@param
  ///@param excludedBrandingProviderId Exclude VOD contents for specified branding provider. Either excludedBrandingProviderId or excludedChannelId can be used.
  ///@param excludedChannelId Exclude events and recordings played on specified channel id. Either excludedBrandingProviderId or excludedChannelId can be used.
  @Get(path: '/v1/titleAlsoAvailableOn')
  Future<chopper.Response> _v1TitleAlsoAvailableOnGet({
    @Header('X-Dev') String? xDev,
    @Header('X-Cus') String? xCus = 'X-Cus',
    @Header('x-entitlements-token')
        String? xEntitlementsToken = 'X-Entitlements-Token',
    @Query('profileId') String? profileId,
    @Query('language') required String? language,
    @Query('country') required String? country,
    @Query('titleId') required String? titleId,
    @Query('maxRes') String? maxRes,
    @Query('cityId') String? cityId,
    @Query('replayOptedInTime') int? replayOptedInTime,
    @Query('excludedBrandingProviderId') String? excludedBrandingProviderId,
    @Query('excludedChannelId') String? excludedChannelId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Provides details of the show.
  ///@param showCrid Show's crid.
  ///@param language Language in ISO639
  Future<chopper.Response<ShowPageResponse>> v1ShowPageShowCridLanguageGet({
    required String? showCrid,
    required String? language,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ShowPageResponse, () => ShowPageResponse.fromJsonFactory);

    return _v1ShowPageShowCridLanguageGet(
        showCrid: showCrid, language: language, cacheControl: cacheControl);
  }

  ///Provides details of the show.
  ///@param showCrid Show's crid.
  ///@param language Language in ISO639
  @Get(path: '/v1/showPage/{showCrid}/{language}')
  Future<chopper.Response<ShowPageResponse>> _v1ShowPageShowCridLanguageGet({
    @Path('showCrid') required String? showCrid,
    @Path('language') required String? language,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Responds with the Show information and a list of all the seasons
  ///@param
  ///@param seriesCrid Crid of a show.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param brandingProviderId Return only contents for specified branding provider. Either brandingProviderId or channelId can be used.
  ///@param channelId Return only events and recordings played on specified channel id. Either brandingProviderId or channelId can be used.
  Future<chopper.Response<EpisodePickerResponse>> v1EpisodePickerGet({
    String? profileId,
    required String? seriesCrid,
    required String? country,
    required String? language,
    String? selectedAssetId,
    String? maxRes,
    String? cityId,
    int? replayOptedInTime,
    String? xDev,
    String? xCus = 'X-Cus',
    String? xEntitlementsToken = 'X-Entitlements-Token',
    String? brandingProviderId,
    String? channelId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        EpisodePickerResponse, () => EpisodePickerResponse.fromJsonFactory);

    return _v1EpisodePickerGet(
        profileId: profileId,
        seriesCrid: seriesCrid,
        country: country,
        language: language,
        selectedAssetId: selectedAssetId,
        maxRes: maxRes,
        cityId: cityId,
        replayOptedInTime: replayOptedInTime,
        xDev: xDev,
        xCus: xCus,
        xEntitlementsToken: xEntitlementsToken,
        brandingProviderId: brandingProviderId,
        channelId: channelId,
        cacheControl: cacheControl);
  }

  ///Responds with the Show information and a list of all the seasons
  ///@param
  ///@param seriesCrid Crid of a show.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param brandingProviderId Return only contents for specified branding provider. Either brandingProviderId or channelId can be used.
  ///@param channelId Return only events and recordings played on specified channel id. Either brandingProviderId or channelId can be used.
  @Get(path: '/v1/episodePicker')
  Future<chopper.Response<EpisodePickerResponse>> _v1EpisodePickerGet({
    @Query('profileId') String? profileId,
    @Query('seriesCrid') required String? seriesCrid,
    @Query('country') required String? country,
    @Query('language') required String? language,
    @Query('selectedAssetId') String? selectedAssetId,
    @Query('maxRes') String? maxRes,
    @Query('cityId') String? cityId,
    @Query('replayOptedInTime') int? replayOptedInTime,
    @Header('X-Dev') String? xDev,
    @Header('X-Cus') String? xCus = 'X-Cus',
    @Header('x-entitlements-token')
        String? xEntitlementsToken = 'X-Entitlements-Token',
    @Query('brandingProviderId') String? brandingProviderId,
    @Query('channelId') String? channelId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Allows for resolving which seasons are available per source
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param showCrid Show's crid.
  ///@param selectedResource Crid and imi of the selected item.
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<SaaoResponse>> v1ShowAlsoAvailableOnGet({
    String? xDev,
    String? xCus = 'X-Cus',
    String? xEntitlementsToken = 'X-Entitlements-Token',
    required String? language,
    required String? country,
    required String? showCrid,
    String? selectedResource,
    String? maxRes,
    String? cityId,
    int? replayOptedInTime,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SaaoResponse, () => SaaoResponse.fromJsonFactory);

    return _v1ShowAlsoAvailableOnGet(
        xDev: xDev,
        xCus: xCus,
        xEntitlementsToken: xEntitlementsToken,
        language: language,
        country: country,
        showCrid: showCrid,
        selectedResource: selectedResource,
        maxRes: maxRes,
        cityId: cityId,
        replayOptedInTime: replayOptedInTime,
        cacheControl: cacheControl);
  }

  ///Allows for resolving which seasons are available per source
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param showCrid Show's crid.
  ///@param selectedResource Crid and imi of the selected item.
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/showAlsoAvailableOn')
  Future<chopper.Response<SaaoResponse>> _v1ShowAlsoAvailableOnGet({
    @Header('X-Dev') String? xDev,
    @Header('X-Cus') String? xCus = 'X-Cus',
    @Header('x-entitlements-token')
        String? xEntitlementsToken = 'X-Entitlements-Token',
    @Query('language') required String? language,
    @Query('country') required String? country,
    @Query('showCrid') required String? showCrid,
    @Query('selectedResource') String? selectedResource,
    @Query('maxRes') String? maxRes,
    @Query('cityId') String? cityId,
    @Query('replayOptedInTime') int? replayOptedInTime,
    @Header('Cache-Control') String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class ErrorWrapper {
  ErrorWrapper({
    required this.error,
  });

  factory ErrorWrapper.fromJson(Map<String, dynamic> json) =>
      _$ErrorWrapperFromJson(json);

  @JsonKey(name: 'error', includeIfNull: false)
  final KrakenError error;
  static const fromJsonFactory = _$ErrorWrapperFromJson;
  static const toJsonFactory = _$ErrorWrapperToJson;
  Map<String, dynamic> toJson() => _$ErrorWrapperToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ErrorWrapper &&
            (identical(other.error, error) ||
                const DeepCollectionEquality().equals(other.error, error)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(error) ^ runtimeType.hashCode;
}

extension $ErrorWrapperExtension on ErrorWrapper {
  ErrorWrapper copyWith({KrakenError? error}) {
    return ErrorWrapper(error: error ?? this.error);
  }

  ErrorWrapper copyWithWrapped({Wrapped<KrakenError>? error}) {
    return ErrorWrapper(error: (error != null ? error.value : this.error));
  }
}

@JsonSerializable(explicitToJson: true)
class KrakenError {
  KrakenError({
    required this.httpStatusCode,
    this.statusCode,
    required this.message,
    this.details,
    this.allErrors,
    this.correlationId,
  });

  factory KrakenError.fromJson(Map<String, dynamic> json) =>
      _$KrakenErrorFromJson(json);

  @JsonKey(name: 'httpStatusCode', includeIfNull: false)
  final int httpStatusCode;
  @JsonKey(name: 'statusCode', includeIfNull: false)
  final int? statusCode;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String message;
  @JsonKey(name: 'details', includeIfNull: false, defaultValue: '')
  final String? details;
  @JsonKey(name: 'allErrors', includeIfNull: false, defaultValue: <String>[])
  final List<String>? allErrors;
  @JsonKey(name: 'correlationId', includeIfNull: false, defaultValue: '')
  final String? correlationId;
  static const fromJsonFactory = _$KrakenErrorFromJson;
  static const toJsonFactory = _$KrakenErrorToJson;
  Map<String, dynamic> toJson() => _$KrakenErrorToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is KrakenError &&
            (identical(other.httpStatusCode, httpStatusCode) ||
                const DeepCollectionEquality()
                    .equals(other.httpStatusCode, httpStatusCode)) &&
            (identical(other.statusCode, statusCode) ||
                const DeepCollectionEquality()
                    .equals(other.statusCode, statusCode)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.details, details) ||
                const DeepCollectionEquality()
                    .equals(other.details, details)) &&
            (identical(other.allErrors, allErrors) ||
                const DeepCollectionEquality()
                    .equals(other.allErrors, allErrors)) &&
            (identical(other.correlationId, correlationId) ||
                const DeepCollectionEquality()
                    .equals(other.correlationId, correlationId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(httpStatusCode) ^
      const DeepCollectionEquality().hash(statusCode) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(details) ^
      const DeepCollectionEquality().hash(allErrors) ^
      const DeepCollectionEquality().hash(correlationId) ^
      runtimeType.hashCode;
}

extension $KrakenErrorExtension on KrakenError {
  KrakenError copyWith(
      {int? httpStatusCode,
      int? statusCode,
      String? message,
      String? details,
      List<String>? allErrors,
      String? correlationId}) {
    return KrakenError(
        httpStatusCode: httpStatusCode ?? this.httpStatusCode,
        statusCode: statusCode ?? this.statusCode,
        message: message ?? this.message,
        details: details ?? this.details,
        allErrors: allErrors ?? this.allErrors,
        correlationId: correlationId ?? this.correlationId);
  }

  KrakenError copyWithWrapped(
      {Wrapped<int>? httpStatusCode,
      Wrapped<int?>? statusCode,
      Wrapped<String>? message,
      Wrapped<String?>? details,
      Wrapped<List<String>?>? allErrors,
      Wrapped<String?>? correlationId}) {
    return KrakenError(
        httpStatusCode: (httpStatusCode != null
            ? httpStatusCode.value
            : this.httpStatusCode),
        statusCode: (statusCode != null ? statusCode.value : this.statusCode),
        message: (message != null ? message.value : this.message),
        details: (details != null ? details.value : this.details),
        allErrors: (allErrors != null ? allErrors.value : this.allErrors),
        correlationId:
            (correlationId != null ? correlationId.value : this.correlationId));
  }
}

@JsonSerializable(explicitToJson: true)
class SeriesDetailResponse {
  SeriesDetailResponse({
    this.id,
    this.title,
    this.genres,
    this.ageRating,
    this.isAdult,
    this.synopsis,
    this.image,
    this.startYear,
    this.endYear,
    this.seasons,
    this.episodes,
  });

  factory SeriesDetailResponse.fromJson(Map<String, dynamic> json) =>
      _$SeriesDetailResponseFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'genres', includeIfNull: false, defaultValue: '')
  final String? genres;
  @JsonKey(name: 'ageRating', includeIfNull: false, defaultValue: '')
  final String? ageRating;
  @JsonKey(name: 'isAdult', includeIfNull: false)
  final bool? isAdult;
  @JsonKey(name: 'synopsis', includeIfNull: false, defaultValue: '')
  final String? synopsis;
  @JsonKey(name: 'image', includeIfNull: false, defaultValue: '')
  final String? image;
  @JsonKey(name: 'startYear', includeIfNull: false, defaultValue: '')
  final String? startYear;
  @JsonKey(name: 'endYear', includeIfNull: false, defaultValue: '')
  final String? endYear;
  @JsonKey(name: 'seasons', includeIfNull: false)
  final SeasonResponse? seasons;
  @JsonKey(name: 'episodes', includeIfNull: false)
  final EpisodeResponse? episodes;
  static const fromJsonFactory = _$SeriesDetailResponseFromJson;
  static const toJsonFactory = _$SeriesDetailResponseToJson;
  Map<String, dynamic> toJson() => _$SeriesDetailResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SeriesDetailResponse &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.genres, genres) ||
                const DeepCollectionEquality().equals(other.genres, genres)) &&
            (identical(other.ageRating, ageRating) ||
                const DeepCollectionEquality()
                    .equals(other.ageRating, ageRating)) &&
            (identical(other.isAdult, isAdult) ||
                const DeepCollectionEquality()
                    .equals(other.isAdult, isAdult)) &&
            (identical(other.synopsis, synopsis) ||
                const DeepCollectionEquality()
                    .equals(other.synopsis, synopsis)) &&
            (identical(other.image, image) ||
                const DeepCollectionEquality().equals(other.image, image)) &&
            (identical(other.startYear, startYear) ||
                const DeepCollectionEquality()
                    .equals(other.startYear, startYear)) &&
            (identical(other.endYear, endYear) ||
                const DeepCollectionEquality()
                    .equals(other.endYear, endYear)) &&
            (identical(other.seasons, seasons) ||
                const DeepCollectionEquality()
                    .equals(other.seasons, seasons)) &&
            (identical(other.episodes, episodes) ||
                const DeepCollectionEquality()
                    .equals(other.episodes, episodes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(genres) ^
      const DeepCollectionEquality().hash(ageRating) ^
      const DeepCollectionEquality().hash(isAdult) ^
      const DeepCollectionEquality().hash(synopsis) ^
      const DeepCollectionEquality().hash(image) ^
      const DeepCollectionEquality().hash(startYear) ^
      const DeepCollectionEquality().hash(endYear) ^
      const DeepCollectionEquality().hash(seasons) ^
      const DeepCollectionEquality().hash(episodes) ^
      runtimeType.hashCode;
}

extension $SeriesDetailResponseExtension on SeriesDetailResponse {
  SeriesDetailResponse copyWith(
      {String? id,
      String? title,
      String? genres,
      String? ageRating,
      bool? isAdult,
      String? synopsis,
      String? image,
      String? startYear,
      String? endYear,
      SeasonResponse? seasons,
      EpisodeResponse? episodes}) {
    return SeriesDetailResponse(
        id: id ?? this.id,
        title: title ?? this.title,
        genres: genres ?? this.genres,
        ageRating: ageRating ?? this.ageRating,
        isAdult: isAdult ?? this.isAdult,
        synopsis: synopsis ?? this.synopsis,
        image: image ?? this.image,
        startYear: startYear ?? this.startYear,
        endYear: endYear ?? this.endYear,
        seasons: seasons ?? this.seasons,
        episodes: episodes ?? this.episodes);
  }

  SeriesDetailResponse copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? title,
      Wrapped<String?>? genres,
      Wrapped<String?>? ageRating,
      Wrapped<bool?>? isAdult,
      Wrapped<String?>? synopsis,
      Wrapped<String?>? image,
      Wrapped<String?>? startYear,
      Wrapped<String?>? endYear,
      Wrapped<SeasonResponse?>? seasons,
      Wrapped<EpisodeResponse?>? episodes}) {
    return SeriesDetailResponse(
        id: (id != null ? id.value : this.id),
        title: (title != null ? title.value : this.title),
        genres: (genres != null ? genres.value : this.genres),
        ageRating: (ageRating != null ? ageRating.value : this.ageRating),
        isAdult: (isAdult != null ? isAdult.value : this.isAdult),
        synopsis: (synopsis != null ? synopsis.value : this.synopsis),
        image: (image != null ? image.value : this.image),
        startYear: (startYear != null ? startYear.value : this.startYear),
        endYear: (endYear != null ? endYear.value : this.endYear),
        seasons: (seasons != null ? seasons.value : this.seasons),
        episodes: (episodes != null ? episodes.value : this.episodes));
  }
}

@JsonSerializable(explicitToJson: true)
class SeasonResponse {
  SeasonResponse({
    this.id,
    this.title,
    this.season,
    this.synopsis,
    this.image,
    this.landscape,
    this.landscapeTile,
    this.totalEpisodes,
    this.type,
    this.genres,
    this.episodes,
  });

  factory SeasonResponse.fromJson(Map<String, dynamic> json) =>
      _$SeasonResponseFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'season', includeIfNull: false, defaultValue: '')
  final String? season;
  @JsonKey(name: 'synopsis', includeIfNull: false, defaultValue: '')
  final String? synopsis;
  @JsonKey(name: 'image', includeIfNull: false, defaultValue: '')
  final String? image;
  @JsonKey(name: 'landscape', includeIfNull: false, defaultValue: '')
  final String? landscape;
  @JsonKey(name: 'landscapeTile', includeIfNull: false, defaultValue: '')
  final String? landscapeTile;
  @JsonKey(name: 'totalEpisodes', includeIfNull: false)
  final int? totalEpisodes;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  @JsonKey(name: 'genres', includeIfNull: false, defaultValue: <String>[])
  final List<String>? genres;
  @JsonKey(name: 'episodes', includeIfNull: false)
  final EpisodeResponse? episodes;
  static const fromJsonFactory = _$SeasonResponseFromJson;
  static const toJsonFactory = _$SeasonResponseToJson;
  Map<String, dynamic> toJson() => _$SeasonResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SeasonResponse &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.season, season) ||
                const DeepCollectionEquality().equals(other.season, season)) &&
            (identical(other.synopsis, synopsis) ||
                const DeepCollectionEquality()
                    .equals(other.synopsis, synopsis)) &&
            (identical(other.image, image) ||
                const DeepCollectionEquality().equals(other.image, image)) &&
            (identical(other.landscape, landscape) ||
                const DeepCollectionEquality()
                    .equals(other.landscape, landscape)) &&
            (identical(other.landscapeTile, landscapeTile) ||
                const DeepCollectionEquality()
                    .equals(other.landscapeTile, landscapeTile)) &&
            (identical(other.totalEpisodes, totalEpisodes) ||
                const DeepCollectionEquality()
                    .equals(other.totalEpisodes, totalEpisodes)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.genres, genres) ||
                const DeepCollectionEquality().equals(other.genres, genres)) &&
            (identical(other.episodes, episodes) ||
                const DeepCollectionEquality()
                    .equals(other.episodes, episodes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(season) ^
      const DeepCollectionEquality().hash(synopsis) ^
      const DeepCollectionEquality().hash(image) ^
      const DeepCollectionEquality().hash(landscape) ^
      const DeepCollectionEquality().hash(landscapeTile) ^
      const DeepCollectionEquality().hash(totalEpisodes) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(genres) ^
      const DeepCollectionEquality().hash(episodes) ^
      runtimeType.hashCode;
}

extension $SeasonResponseExtension on SeasonResponse {
  SeasonResponse copyWith(
      {String? id,
      String? title,
      String? season,
      String? synopsis,
      String? image,
      String? landscape,
      String? landscapeTile,
      int? totalEpisodes,
      String? type,
      List<String>? genres,
      EpisodeResponse? episodes}) {
    return SeasonResponse(
        id: id ?? this.id,
        title: title ?? this.title,
        season: season ?? this.season,
        synopsis: synopsis ?? this.synopsis,
        image: image ?? this.image,
        landscape: landscape ?? this.landscape,
        landscapeTile: landscapeTile ?? this.landscapeTile,
        totalEpisodes: totalEpisodes ?? this.totalEpisodes,
        type: type ?? this.type,
        genres: genres ?? this.genres,
        episodes: episodes ?? this.episodes);
  }

  SeasonResponse copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? title,
      Wrapped<String?>? season,
      Wrapped<String?>? synopsis,
      Wrapped<String?>? image,
      Wrapped<String?>? landscape,
      Wrapped<String?>? landscapeTile,
      Wrapped<int?>? totalEpisodes,
      Wrapped<String?>? type,
      Wrapped<List<String>?>? genres,
      Wrapped<EpisodeResponse?>? episodes}) {
    return SeasonResponse(
        id: (id != null ? id.value : this.id),
        title: (title != null ? title.value : this.title),
        season: (season != null ? season.value : this.season),
        synopsis: (synopsis != null ? synopsis.value : this.synopsis),
        image: (image != null ? image.value : this.image),
        landscape: (landscape != null ? landscape.value : this.landscape),
        landscapeTile:
            (landscapeTile != null ? landscapeTile.value : this.landscapeTile),
        totalEpisodes:
            (totalEpisodes != null ? totalEpisodes.value : this.totalEpisodes),
        type: (type != null ? type.value : this.type),
        genres: (genres != null ? genres.value : this.genres),
        episodes: (episodes != null ? episodes.value : this.episodes));
  }
}

@JsonSerializable(explicitToJson: true)
class EpisodeResponse {
  EpisodeResponse({
    this.id,
    this.episode,
    this.title,
    this.image,
    this.landscape,
    this.landscapeTile,
    this.ageRating,
    this.synopsis,
    this.isAdult,
    this.isWatchedCompletely,
    this.replayContainsAdult,
    this.replayMinAge,
    this.bookmark,
    this.duration,
    this.broadcastDate,
    this.type,
    this.isReplay,
    this.isRecording,
    this.eventId,
    this.channelId,
    this.est,
    this.replayAvailable,
    this.vod,
  });

  factory EpisodeResponse.fromJson(Map<String, dynamic> json) =>
      _$EpisodeResponseFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'episode', includeIfNull: false, defaultValue: '')
  final String? episode;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'image', includeIfNull: false, defaultValue: '')
  final String? image;
  @JsonKey(name: 'landscape', includeIfNull: false, defaultValue: '')
  final String? landscape;
  @JsonKey(name: 'landscapeTile', includeIfNull: false, defaultValue: '')
  final String? landscapeTile;
  @JsonKey(name: 'ageRating', includeIfNull: false, defaultValue: '')
  final String? ageRating;
  @JsonKey(name: 'synopsis', includeIfNull: false, defaultValue: '')
  final String? synopsis;
  @JsonKey(name: 'isAdult', includeIfNull: false)
  final bool? isAdult;
  @JsonKey(name: 'isWatchedCompletely', includeIfNull: false)
  final bool? isWatchedCompletely;
  @JsonKey(name: 'replayContainsAdult', includeIfNull: false)
  final bool? replayContainsAdult;
  @JsonKey(name: 'replayMinAge', includeIfNull: false)
  final int? replayMinAge;
  @JsonKey(name: 'bookmark', includeIfNull: false)
  final int? bookmark;
  @JsonKey(name: 'duration', includeIfNull: false)
  final int? duration;
  @JsonKey(name: 'broadcastDate', includeIfNull: false, defaultValue: '')
  final String? broadcastDate;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  @JsonKey(name: 'isReplay', includeIfNull: false)
  final bool? isReplay;
  @JsonKey(name: 'isRecording', includeIfNull: false)
  final bool? isRecording;
  @JsonKey(name: 'eventId', includeIfNull: false, defaultValue: '')
  final String? eventId;
  @JsonKey(name: 'channelId', includeIfNull: false, defaultValue: '')
  final String? channelId;
  @JsonKey(name: 'est', includeIfNull: false, defaultValue: <EstResponse>[])
  final List<EstResponse>? est;
  @JsonKey(name: 'replayAvailable', includeIfNull: false)
  final bool? replayAvailable;
  @JsonKey(name: 'vod', includeIfNull: false)
  final VodResponse? vod;
  static const fromJsonFactory = _$EpisodeResponseFromJson;
  static const toJsonFactory = _$EpisodeResponseToJson;
  Map<String, dynamic> toJson() => _$EpisodeResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EpisodeResponse &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.episode, episode) ||
                const DeepCollectionEquality()
                    .equals(other.episode, episode)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.image, image) ||
                const DeepCollectionEquality().equals(other.image, image)) &&
            (identical(other.landscape, landscape) ||
                const DeepCollectionEquality()
                    .equals(other.landscape, landscape)) &&
            (identical(other.landscapeTile, landscapeTile) ||
                const DeepCollectionEquality()
                    .equals(other.landscapeTile, landscapeTile)) &&
            (identical(other.ageRating, ageRating) ||
                const DeepCollectionEquality()
                    .equals(other.ageRating, ageRating)) &&
            (identical(other.synopsis, synopsis) ||
                const DeepCollectionEquality()
                    .equals(other.synopsis, synopsis)) &&
            (identical(other.isAdult, isAdult) ||
                const DeepCollectionEquality()
                    .equals(other.isAdult, isAdult)) &&
            (identical(other.isWatchedCompletely, isWatchedCompletely) ||
                const DeepCollectionEquality()
                    .equals(other.isWatchedCompletely, isWatchedCompletely)) &&
            (identical(other.replayContainsAdult, replayContainsAdult) ||
                const DeepCollectionEquality()
                    .equals(other.replayContainsAdult, replayContainsAdult)) &&
            (identical(other.replayMinAge, replayMinAge) ||
                const DeepCollectionEquality()
                    .equals(other.replayMinAge, replayMinAge)) &&
            (identical(other.bookmark, bookmark) ||
                const DeepCollectionEquality()
                    .equals(other.bookmark, bookmark)) &&
            (identical(other.duration, duration) ||
                const DeepCollectionEquality()
                    .equals(other.duration, duration)) &&
            (identical(other.broadcastDate, broadcastDate) ||
                const DeepCollectionEquality()
                    .equals(other.broadcastDate, broadcastDate)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.isReplay, isReplay) ||
                const DeepCollectionEquality()
                    .equals(other.isReplay, isReplay)) &&
            (identical(other.isRecording, isRecording) ||
                const DeepCollectionEquality()
                    .equals(other.isRecording, isRecording)) &&
            (identical(other.eventId, eventId) ||
                const DeepCollectionEquality()
                    .equals(other.eventId, eventId)) &&
            (identical(other.channelId, channelId) ||
                const DeepCollectionEquality()
                    .equals(other.channelId, channelId)) &&
            (identical(other.est, est) ||
                const DeepCollectionEquality().equals(other.est, est)) &&
            (identical(other.replayAvailable, replayAvailable) ||
                const DeepCollectionEquality()
                    .equals(other.replayAvailable, replayAvailable)) &&
            (identical(other.vod, vod) ||
                const DeepCollectionEquality().equals(other.vod, vod)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(episode) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(image) ^
      const DeepCollectionEquality().hash(landscape) ^
      const DeepCollectionEquality().hash(landscapeTile) ^
      const DeepCollectionEquality().hash(ageRating) ^
      const DeepCollectionEquality().hash(synopsis) ^
      const DeepCollectionEquality().hash(isAdult) ^
      const DeepCollectionEquality().hash(isWatchedCompletely) ^
      const DeepCollectionEquality().hash(replayContainsAdult) ^
      const DeepCollectionEquality().hash(replayMinAge) ^
      const DeepCollectionEquality().hash(bookmark) ^
      const DeepCollectionEquality().hash(duration) ^
      const DeepCollectionEquality().hash(broadcastDate) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(isReplay) ^
      const DeepCollectionEquality().hash(isRecording) ^
      const DeepCollectionEquality().hash(eventId) ^
      const DeepCollectionEquality().hash(channelId) ^
      const DeepCollectionEquality().hash(est) ^
      const DeepCollectionEquality().hash(replayAvailable) ^
      const DeepCollectionEquality().hash(vod) ^
      runtimeType.hashCode;
}

extension $EpisodeResponseExtension on EpisodeResponse {
  EpisodeResponse copyWith(
      {String? id,
      String? episode,
      String? title,
      String? image,
      String? landscape,
      String? landscapeTile,
      String? ageRating,
      String? synopsis,
      bool? isAdult,
      bool? isWatchedCompletely,
      bool? replayContainsAdult,
      int? replayMinAge,
      int? bookmark,
      int? duration,
      String? broadcastDate,
      String? type,
      bool? isReplay,
      bool? isRecording,
      String? eventId,
      String? channelId,
      List<EstResponse>? est,
      bool? replayAvailable,
      VodResponse? vod}) {
    return EpisodeResponse(
        id: id ?? this.id,
        episode: episode ?? this.episode,
        title: title ?? this.title,
        image: image ?? this.image,
        landscape: landscape ?? this.landscape,
        landscapeTile: landscapeTile ?? this.landscapeTile,
        ageRating: ageRating ?? this.ageRating,
        synopsis: synopsis ?? this.synopsis,
        isAdult: isAdult ?? this.isAdult,
        isWatchedCompletely: isWatchedCompletely ?? this.isWatchedCompletely,
        replayContainsAdult: replayContainsAdult ?? this.replayContainsAdult,
        replayMinAge: replayMinAge ?? this.replayMinAge,
        bookmark: bookmark ?? this.bookmark,
        duration: duration ?? this.duration,
        broadcastDate: broadcastDate ?? this.broadcastDate,
        type: type ?? this.type,
        isReplay: isReplay ?? this.isReplay,
        isRecording: isRecording ?? this.isRecording,
        eventId: eventId ?? this.eventId,
        channelId: channelId ?? this.channelId,
        est: est ?? this.est,
        replayAvailable: replayAvailable ?? this.replayAvailable,
        vod: vod ?? this.vod);
  }

  EpisodeResponse copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? episode,
      Wrapped<String?>? title,
      Wrapped<String?>? image,
      Wrapped<String?>? landscape,
      Wrapped<String?>? landscapeTile,
      Wrapped<String?>? ageRating,
      Wrapped<String?>? synopsis,
      Wrapped<bool?>? isAdult,
      Wrapped<bool?>? isWatchedCompletely,
      Wrapped<bool?>? replayContainsAdult,
      Wrapped<int?>? replayMinAge,
      Wrapped<int?>? bookmark,
      Wrapped<int?>? duration,
      Wrapped<String?>? broadcastDate,
      Wrapped<String?>? type,
      Wrapped<bool?>? isReplay,
      Wrapped<bool?>? isRecording,
      Wrapped<String?>? eventId,
      Wrapped<String?>? channelId,
      Wrapped<List<EstResponse>?>? est,
      Wrapped<bool?>? replayAvailable,
      Wrapped<VodResponse?>? vod}) {
    return EpisodeResponse(
        id: (id != null ? id.value : this.id),
        episode: (episode != null ? episode.value : this.episode),
        title: (title != null ? title.value : this.title),
        image: (image != null ? image.value : this.image),
        landscape: (landscape != null ? landscape.value : this.landscape),
        landscapeTile:
            (landscapeTile != null ? landscapeTile.value : this.landscapeTile),
        ageRating: (ageRating != null ? ageRating.value : this.ageRating),
        synopsis: (synopsis != null ? synopsis.value : this.synopsis),
        isAdult: (isAdult != null ? isAdult.value : this.isAdult),
        isWatchedCompletely: (isWatchedCompletely != null
            ? isWatchedCompletely.value
            : this.isWatchedCompletely),
        replayContainsAdult: (replayContainsAdult != null
            ? replayContainsAdult.value
            : this.replayContainsAdult),
        replayMinAge:
            (replayMinAge != null ? replayMinAge.value : this.replayMinAge),
        bookmark: (bookmark != null ? bookmark.value : this.bookmark),
        duration: (duration != null ? duration.value : this.duration),
        broadcastDate:
            (broadcastDate != null ? broadcastDate.value : this.broadcastDate),
        type: (type != null ? type.value : this.type),
        isReplay: (isReplay != null ? isReplay.value : this.isReplay),
        isRecording:
            (isRecording != null ? isRecording.value : this.isRecording),
        eventId: (eventId != null ? eventId.value : this.eventId),
        channelId: (channelId != null ? channelId.value : this.channelId),
        est: (est != null ? est.value : this.est),
        replayAvailable: (replayAvailable != null
            ? replayAvailable.value
            : this.replayAvailable),
        vod: (vod != null ? vod.value : this.vod));
  }
}

@JsonSerializable(explicitToJson: true)
class VodResponse {
  VodResponse({
    this.type,
    this.entitlemendEnd,
    this.entitlementState,
  });

  factory VodResponse.fromJson(Map<String, dynamic> json) =>
      _$VodResponseFromJson(json);

  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  @JsonKey(name: 'entitlemendEnd', includeIfNull: false, defaultValue: '')
  final String? entitlemendEnd;
  @JsonKey(name: 'entitlementState', includeIfNull: false, defaultValue: '')
  final String? entitlementState;
  static const fromJsonFactory = _$VodResponseFromJson;
  static const toJsonFactory = _$VodResponseToJson;
  Map<String, dynamic> toJson() => _$VodResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is VodResponse &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.entitlemendEnd, entitlemendEnd) ||
                const DeepCollectionEquality()
                    .equals(other.entitlemendEnd, entitlemendEnd)) &&
            (identical(other.entitlementState, entitlementState) ||
                const DeepCollectionEquality()
                    .equals(other.entitlementState, entitlementState)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(entitlemendEnd) ^
      const DeepCollectionEquality().hash(entitlementState) ^
      runtimeType.hashCode;
}

extension $VodResponseExtension on VodResponse {
  VodResponse copyWith(
      {String? type, String? entitlemendEnd, String? entitlementState}) {
    return VodResponse(
        type: type ?? this.type,
        entitlemendEnd: entitlemendEnd ?? this.entitlemendEnd,
        entitlementState: entitlementState ?? this.entitlementState);
  }

  VodResponse copyWithWrapped(
      {Wrapped<String?>? type,
      Wrapped<String?>? entitlemendEnd,
      Wrapped<String?>? entitlementState}) {
    return VodResponse(
        type: (type != null ? type.value : this.type),
        entitlemendEnd: (entitlemendEnd != null
            ? entitlemendEnd.value
            : this.entitlemendEnd),
        entitlementState: (entitlementState != null
            ? entitlementState.value
            : this.entitlementState));
  }
}

@JsonSerializable(explicitToJson: true)
class EventDetailResponse {
  EventDetailResponse({
    this.titleCrid,
    this.eventId,
    this.contentType,
    this.channelId,
    this.broadcastDate,
    this.broadcastEndDate,
    this.bookmark,
    this.channel,
    this.replayAvailable,
  });

  factory EventDetailResponse.fromJson(Map<String, dynamic> json) =>
      _$EventDetailResponseFromJson(json);

  @JsonKey(name: 'titleCrid', includeIfNull: false, defaultValue: '')
  final String? titleCrid;
  @JsonKey(name: 'eventId', includeIfNull: false, defaultValue: '')
  final String? eventId;
  @JsonKey(name: 'contentType', includeIfNull: false, defaultValue: '')
  final String? contentType;
  @JsonKey(name: 'channelId', includeIfNull: false, defaultValue: '')
  final String? channelId;
  @JsonKey(name: 'broadcastDate', includeIfNull: false, defaultValue: '')
  final String? broadcastDate;
  @JsonKey(name: 'broadcastEndDate', includeIfNull: false, defaultValue: '')
  final String? broadcastEndDate;
  @JsonKey(name: 'bookmark', includeIfNull: false)
  final int? bookmark;
  @JsonKey(
      name: 'channel',
      includeIfNull: false,
      defaultValue: <ChannelEventDetailResponse>[])
  final List<ChannelEventDetailResponse>? channel;
  @JsonKey(name: 'replayAvailable', includeIfNull: false)
  final bool? replayAvailable;
  static const fromJsonFactory = _$EventDetailResponseFromJson;
  static const toJsonFactory = _$EventDetailResponseToJson;
  Map<String, dynamic> toJson() => _$EventDetailResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EventDetailResponse &&
            (identical(other.titleCrid, titleCrid) ||
                const DeepCollectionEquality()
                    .equals(other.titleCrid, titleCrid)) &&
            (identical(other.eventId, eventId) ||
                const DeepCollectionEquality()
                    .equals(other.eventId, eventId)) &&
            (identical(other.contentType, contentType) ||
                const DeepCollectionEquality()
                    .equals(other.contentType, contentType)) &&
            (identical(other.channelId, channelId) ||
                const DeepCollectionEquality()
                    .equals(other.channelId, channelId)) &&
            (identical(other.broadcastDate, broadcastDate) ||
                const DeepCollectionEquality()
                    .equals(other.broadcastDate, broadcastDate)) &&
            (identical(other.broadcastEndDate, broadcastEndDate) ||
                const DeepCollectionEquality()
                    .equals(other.broadcastEndDate, broadcastEndDate)) &&
            (identical(other.bookmark, bookmark) ||
                const DeepCollectionEquality()
                    .equals(other.bookmark, bookmark)) &&
            (identical(other.channel, channel) ||
                const DeepCollectionEquality()
                    .equals(other.channel, channel)) &&
            (identical(other.replayAvailable, replayAvailable) ||
                const DeepCollectionEquality()
                    .equals(other.replayAvailable, replayAvailable)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(titleCrid) ^
      const DeepCollectionEquality().hash(eventId) ^
      const DeepCollectionEquality().hash(contentType) ^
      const DeepCollectionEquality().hash(channelId) ^
      const DeepCollectionEquality().hash(broadcastDate) ^
      const DeepCollectionEquality().hash(broadcastEndDate) ^
      const DeepCollectionEquality().hash(bookmark) ^
      const DeepCollectionEquality().hash(channel) ^
      const DeepCollectionEquality().hash(replayAvailable) ^
      runtimeType.hashCode;
}

extension $EventDetailResponseExtension on EventDetailResponse {
  EventDetailResponse copyWith(
      {String? titleCrid,
      String? eventId,
      String? contentType,
      String? channelId,
      String? broadcastDate,
      String? broadcastEndDate,
      int? bookmark,
      List<ChannelEventDetailResponse>? channel,
      bool? replayAvailable}) {
    return EventDetailResponse(
        titleCrid: titleCrid ?? this.titleCrid,
        eventId: eventId ?? this.eventId,
        contentType: contentType ?? this.contentType,
        channelId: channelId ?? this.channelId,
        broadcastDate: broadcastDate ?? this.broadcastDate,
        broadcastEndDate: broadcastEndDate ?? this.broadcastEndDate,
        bookmark: bookmark ?? this.bookmark,
        channel: channel ?? this.channel,
        replayAvailable: replayAvailable ?? this.replayAvailable);
  }

  EventDetailResponse copyWithWrapped(
      {Wrapped<String?>? titleCrid,
      Wrapped<String?>? eventId,
      Wrapped<String?>? contentType,
      Wrapped<String?>? channelId,
      Wrapped<String?>? broadcastDate,
      Wrapped<String?>? broadcastEndDate,
      Wrapped<int?>? bookmark,
      Wrapped<List<ChannelEventDetailResponse>?>? channel,
      Wrapped<bool?>? replayAvailable}) {
    return EventDetailResponse(
        titleCrid: (titleCrid != null ? titleCrid.value : this.titleCrid),
        eventId: (eventId != null ? eventId.value : this.eventId),
        contentType:
            (contentType != null ? contentType.value : this.contentType),
        channelId: (channelId != null ? channelId.value : this.channelId),
        broadcastDate:
            (broadcastDate != null ? broadcastDate.value : this.broadcastDate),
        broadcastEndDate: (broadcastEndDate != null
            ? broadcastEndDate.value
            : this.broadcastEndDate),
        bookmark: (bookmark != null ? bookmark.value : this.bookmark),
        channel: (channel != null ? channel.value : this.channel),
        replayAvailable: (replayAvailable != null
            ? replayAvailable.value
            : this.replayAvailable));
  }
}

@JsonSerializable(explicitToJson: true)
class ChannelEventDetailResponse {
  ChannelEventDetailResponse({
    this.channelId,
    this.eventId,
    this.contentType,
    this.broadcastDate,
    this.broadcastEndDate,
    this.isRecording,
    this.isReplay,
  });

  factory ChannelEventDetailResponse.fromJson(Map<String, dynamic> json) =>
      _$ChannelEventDetailResponseFromJson(json);

  @JsonKey(name: 'channelId', includeIfNull: false, defaultValue: '')
  final String? channelId;
  @JsonKey(name: 'eventId', includeIfNull: false, defaultValue: '')
  final String? eventId;
  @JsonKey(name: 'contentType', includeIfNull: false, defaultValue: '')
  final String? contentType;
  @JsonKey(name: 'broadcastDate', includeIfNull: false, defaultValue: '')
  final String? broadcastDate;
  @JsonKey(name: 'broadcastEndDate', includeIfNull: false, defaultValue: '')
  final String? broadcastEndDate;
  @JsonKey(name: 'isRecording', includeIfNull: false, defaultValue: '')
  final String? isRecording;
  @JsonKey(name: 'isReplay', includeIfNull: false, defaultValue: '')
  final String? isReplay;
  static const fromJsonFactory = _$ChannelEventDetailResponseFromJson;
  static const toJsonFactory = _$ChannelEventDetailResponseToJson;
  Map<String, dynamic> toJson() => _$ChannelEventDetailResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ChannelEventDetailResponse &&
            (identical(other.channelId, channelId) ||
                const DeepCollectionEquality()
                    .equals(other.channelId, channelId)) &&
            (identical(other.eventId, eventId) ||
                const DeepCollectionEquality()
                    .equals(other.eventId, eventId)) &&
            (identical(other.contentType, contentType) ||
                const DeepCollectionEquality()
                    .equals(other.contentType, contentType)) &&
            (identical(other.broadcastDate, broadcastDate) ||
                const DeepCollectionEquality()
                    .equals(other.broadcastDate, broadcastDate)) &&
            (identical(other.broadcastEndDate, broadcastEndDate) ||
                const DeepCollectionEquality()
                    .equals(other.broadcastEndDate, broadcastEndDate)) &&
            (identical(other.isRecording, isRecording) ||
                const DeepCollectionEquality()
                    .equals(other.isRecording, isRecording)) &&
            (identical(other.isReplay, isReplay) ||
                const DeepCollectionEquality()
                    .equals(other.isReplay, isReplay)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(channelId) ^
      const DeepCollectionEquality().hash(eventId) ^
      const DeepCollectionEquality().hash(contentType) ^
      const DeepCollectionEquality().hash(broadcastDate) ^
      const DeepCollectionEquality().hash(broadcastEndDate) ^
      const DeepCollectionEquality().hash(isRecording) ^
      const DeepCollectionEquality().hash(isReplay) ^
      runtimeType.hashCode;
}

extension $ChannelEventDetailResponseExtension on ChannelEventDetailResponse {
  ChannelEventDetailResponse copyWith(
      {String? channelId,
      String? eventId,
      String? contentType,
      String? broadcastDate,
      String? broadcastEndDate,
      String? isRecording,
      String? isReplay}) {
    return ChannelEventDetailResponse(
        channelId: channelId ?? this.channelId,
        eventId: eventId ?? this.eventId,
        contentType: contentType ?? this.contentType,
        broadcastDate: broadcastDate ?? this.broadcastDate,
        broadcastEndDate: broadcastEndDate ?? this.broadcastEndDate,
        isRecording: isRecording ?? this.isRecording,
        isReplay: isReplay ?? this.isReplay);
  }

  ChannelEventDetailResponse copyWithWrapped(
      {Wrapped<String?>? channelId,
      Wrapped<String?>? eventId,
      Wrapped<String?>? contentType,
      Wrapped<String?>? broadcastDate,
      Wrapped<String?>? broadcastEndDate,
      Wrapped<String?>? isRecording,
      Wrapped<String?>? isReplay}) {
    return ChannelEventDetailResponse(
        channelId: (channelId != null ? channelId.value : this.channelId),
        eventId: (eventId != null ? eventId.value : this.eventId),
        contentType:
            (contentType != null ? contentType.value : this.contentType),
        broadcastDate:
            (broadcastDate != null ? broadcastDate.value : this.broadcastDate),
        broadcastEndDate: (broadcastEndDate != null
            ? broadcastEndDate.value
            : this.broadcastEndDate),
        isRecording:
            (isRecording != null ? isRecording.value : this.isRecording),
        isReplay: (isReplay != null ? isReplay.value : this.isReplay));
  }
}

@JsonSerializable(explicitToJson: true)
class SimpleChannelResponse {
  SimpleChannelResponse({
    this.id,
    this.name,
  });

  factory SimpleChannelResponse.fromJson(Map<String, dynamic> json) =>
      _$SimpleChannelResponseFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  static const fromJsonFactory = _$SimpleChannelResponseFromJson;
  static const toJsonFactory = _$SimpleChannelResponseToJson;
  Map<String, dynamic> toJson() => _$SimpleChannelResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SimpleChannelResponse &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(name) ^
      runtimeType.hashCode;
}

extension $SimpleChannelResponseExtension on SimpleChannelResponse {
  SimpleChannelResponse copyWith({String? id, String? name}) {
    return SimpleChannelResponse(id: id ?? this.id, name: name ?? this.name);
  }

  SimpleChannelResponse copyWithWrapped(
      {Wrapped<String?>? id, Wrapped<String?>? name}) {
    return SimpleChannelResponse(
        id: (id != null ? id.value : this.id),
        name: (name != null ? name.value : this.name));
  }
}

@JsonSerializable(explicitToJson: true)
class SearchDetails {
  SearchDetails({
    this.profileId,
    this.seriesIds,
    this.multisourceIds,
    this.replayOptedInTime,
    this.cityId,
  });

  factory SearchDetails.fromJson(Map<String, dynamic> json) =>
      _$SearchDetailsFromJson(json);

  @JsonKey(name: 'profileId', includeIfNull: false, defaultValue: '')
  final String? profileId;
  @JsonKey(name: 'seriesIds', includeIfNull: false, defaultValue: <String>[])
  final List<String>? seriesIds;
  @JsonKey(
      name: 'multisourceIds', includeIfNull: false, defaultValue: <String>[])
  final List<String>? multisourceIds;
  @JsonKey(name: 'replayOptedInTime', includeIfNull: false)
  final int? replayOptedInTime;
  @JsonKey(name: 'cityId', includeIfNull: false)
  final int? cityId;
  static const fromJsonFactory = _$SearchDetailsFromJson;
  static const toJsonFactory = _$SearchDetailsToJson;
  Map<String, dynamic> toJson() => _$SearchDetailsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SearchDetails &&
            (identical(other.profileId, profileId) ||
                const DeepCollectionEquality()
                    .equals(other.profileId, profileId)) &&
            (identical(other.seriesIds, seriesIds) ||
                const DeepCollectionEquality()
                    .equals(other.seriesIds, seriesIds)) &&
            (identical(other.multisourceIds, multisourceIds) ||
                const DeepCollectionEquality()
                    .equals(other.multisourceIds, multisourceIds)) &&
            (identical(other.replayOptedInTime, replayOptedInTime) ||
                const DeepCollectionEquality()
                    .equals(other.replayOptedInTime, replayOptedInTime)) &&
            (identical(other.cityId, cityId) ||
                const DeepCollectionEquality().equals(other.cityId, cityId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(profileId) ^
      const DeepCollectionEquality().hash(seriesIds) ^
      const DeepCollectionEquality().hash(multisourceIds) ^
      const DeepCollectionEquality().hash(replayOptedInTime) ^
      const DeepCollectionEquality().hash(cityId) ^
      runtimeType.hashCode;
}

extension $SearchDetailsExtension on SearchDetails {
  SearchDetails copyWith(
      {String? profileId,
      List<String>? seriesIds,
      List<String>? multisourceIds,
      int? replayOptedInTime,
      int? cityId}) {
    return SearchDetails(
        profileId: profileId ?? this.profileId,
        seriesIds: seriesIds ?? this.seriesIds,
        multisourceIds: multisourceIds ?? this.multisourceIds,
        replayOptedInTime: replayOptedInTime ?? this.replayOptedInTime,
        cityId: cityId ?? this.cityId);
  }

  SearchDetails copyWithWrapped(
      {Wrapped<String?>? profileId,
      Wrapped<List<String>?>? seriesIds,
      Wrapped<List<String>?>? multisourceIds,
      Wrapped<int?>? replayOptedInTime,
      Wrapped<int?>? cityId}) {
    return SearchDetails(
        profileId: (profileId != null ? profileId.value : this.profileId),
        seriesIds: (seriesIds != null ? seriesIds.value : this.seriesIds),
        multisourceIds: (multisourceIds != null
            ? multisourceIds.value
            : this.multisourceIds),
        replayOptedInTime: (replayOptedInTime != null
            ? replayOptedInTime.value
            : this.replayOptedInTime),
        cityId: (cityId != null ? cityId.value : this.cityId));
  }
}

@JsonSerializable(explicitToJson: true)
class SearchDetailsResponse {
  SearchDetailsResponse({
    this.series,
    this.multisource,
  });

  factory SearchDetailsResponse.fromJson(Map<String, dynamic> json) =>
      _$SearchDetailsResponseFromJson(json);

  @JsonKey(
      name: 'series',
      includeIfNull: false,
      defaultValue: <SearchDetailsResponse$Series>[])
  final List<SearchDetailsResponse$Series>? series;
  @JsonKey(
      name: 'multisource',
      includeIfNull: false,
      defaultValue: <SearchDetailsResponse$Multisource>[])
  final List<SearchDetailsResponse$Multisource>? multisource;
  static const fromJsonFactory = _$SearchDetailsResponseFromJson;
  static const toJsonFactory = _$SearchDetailsResponseToJson;
  Map<String, dynamic> toJson() => _$SearchDetailsResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SearchDetailsResponse &&
            (identical(other.series, series) ||
                const DeepCollectionEquality().equals(other.series, series)) &&
            (identical(other.multisource, multisource) ||
                const DeepCollectionEquality()
                    .equals(other.multisource, multisource)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(series) ^
      const DeepCollectionEquality().hash(multisource) ^
      runtimeType.hashCode;
}

extension $SearchDetailsResponseExtension on SearchDetailsResponse {
  SearchDetailsResponse copyWith(
      {List<SearchDetailsResponse$Series>? series,
      List<SearchDetailsResponse$Multisource>? multisource}) {
    return SearchDetailsResponse(
        series: series ?? this.series,
        multisource: multisource ?? this.multisource);
  }

  SearchDetailsResponse copyWithWrapped(
      {Wrapped<List<SearchDetailsResponse$Series>?>? series,
      Wrapped<List<SearchDetailsResponse$Multisource>?>? multisource}) {
    return SearchDetailsResponse(
        series: (series != null ? series.value : this.series),
        multisource:
            (multisource != null ? multisource.value : this.multisource));
  }
}

@JsonSerializable(explicitToJson: true)
class MostRelevantSourceResponse {
  MostRelevantSourceResponse({
    this.titleId,
    this.seriesId,
    this.seasonId,
    this.episodeNumber,
    this.seasonNumber,
    this.instanceId,
    this.recordingId,
    this.contentType,
    this.providerId,
    this.channelId,
  });

  factory MostRelevantSourceResponse.fromJson(Map<String, dynamic> json) =>
      _$MostRelevantSourceResponseFromJson(json);

  @JsonKey(name: 'titleId', includeIfNull: false, defaultValue: '')
  final String? titleId;
  @JsonKey(name: 'seriesId', includeIfNull: false, defaultValue: '')
  final String? seriesId;
  @JsonKey(name: 'seasonId', includeIfNull: false, defaultValue: '')
  final String? seasonId;
  @JsonKey(name: 'episodeNumber', includeIfNull: false)
  final int? episodeNumber;
  @JsonKey(name: 'seasonNumber', includeIfNull: false)
  final int? seasonNumber;
  @JsonKey(name: 'instanceId', includeIfNull: false, defaultValue: '')
  final String? instanceId;
  @JsonKey(name: 'recordingId', includeIfNull: false, defaultValue: '')
  final String? recordingId;
  @JsonKey(name: 'contentType', includeIfNull: false, defaultValue: '')
  final String? contentType;
  @JsonKey(name: 'providerId', includeIfNull: false, defaultValue: '')
  final String? providerId;
  @JsonKey(name: 'channelId', includeIfNull: false, defaultValue: '')
  final String? channelId;
  static const fromJsonFactory = _$MostRelevantSourceResponseFromJson;
  static const toJsonFactory = _$MostRelevantSourceResponseToJson;
  Map<String, dynamic> toJson() => _$MostRelevantSourceResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MostRelevantSourceResponse &&
            (identical(other.titleId, titleId) ||
                const DeepCollectionEquality()
                    .equals(other.titleId, titleId)) &&
            (identical(other.seriesId, seriesId) ||
                const DeepCollectionEquality()
                    .equals(other.seriesId, seriesId)) &&
            (identical(other.seasonId, seasonId) ||
                const DeepCollectionEquality()
                    .equals(other.seasonId, seasonId)) &&
            (identical(other.episodeNumber, episodeNumber) ||
                const DeepCollectionEquality()
                    .equals(other.episodeNumber, episodeNumber)) &&
            (identical(other.seasonNumber, seasonNumber) ||
                const DeepCollectionEquality()
                    .equals(other.seasonNumber, seasonNumber)) &&
            (identical(other.instanceId, instanceId) ||
                const DeepCollectionEquality()
                    .equals(other.instanceId, instanceId)) &&
            (identical(other.recordingId, recordingId) ||
                const DeepCollectionEquality()
                    .equals(other.recordingId, recordingId)) &&
            (identical(other.contentType, contentType) ||
                const DeepCollectionEquality()
                    .equals(other.contentType, contentType)) &&
            (identical(other.providerId, providerId) ||
                const DeepCollectionEquality()
                    .equals(other.providerId, providerId)) &&
            (identical(other.channelId, channelId) ||
                const DeepCollectionEquality()
                    .equals(other.channelId, channelId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(titleId) ^
      const DeepCollectionEquality().hash(seriesId) ^
      const DeepCollectionEquality().hash(seasonId) ^
      const DeepCollectionEquality().hash(episodeNumber) ^
      const DeepCollectionEquality().hash(seasonNumber) ^
      const DeepCollectionEquality().hash(instanceId) ^
      const DeepCollectionEquality().hash(recordingId) ^
      const DeepCollectionEquality().hash(contentType) ^
      const DeepCollectionEquality().hash(providerId) ^
      const DeepCollectionEquality().hash(channelId) ^
      runtimeType.hashCode;
}

extension $MostRelevantSourceResponseExtension on MostRelevantSourceResponse {
  MostRelevantSourceResponse copyWith(
      {String? titleId,
      String? seriesId,
      String? seasonId,
      int? episodeNumber,
      int? seasonNumber,
      String? instanceId,
      String? recordingId,
      String? contentType,
      String? providerId,
      String? channelId}) {
    return MostRelevantSourceResponse(
        titleId: titleId ?? this.titleId,
        seriesId: seriesId ?? this.seriesId,
        seasonId: seasonId ?? this.seasonId,
        episodeNumber: episodeNumber ?? this.episodeNumber,
        seasonNumber: seasonNumber ?? this.seasonNumber,
        instanceId: instanceId ?? this.instanceId,
        recordingId: recordingId ?? this.recordingId,
        contentType: contentType ?? this.contentType,
        providerId: providerId ?? this.providerId,
        channelId: channelId ?? this.channelId);
  }

  MostRelevantSourceResponse copyWithWrapped(
      {Wrapped<String?>? titleId,
      Wrapped<String?>? seriesId,
      Wrapped<String?>? seasonId,
      Wrapped<int?>? episodeNumber,
      Wrapped<int?>? seasonNumber,
      Wrapped<String?>? instanceId,
      Wrapped<String?>? recordingId,
      Wrapped<String?>? contentType,
      Wrapped<String?>? providerId,
      Wrapped<String?>? channelId}) {
    return MostRelevantSourceResponse(
        titleId: (titleId != null ? titleId.value : this.titleId),
        seriesId: (seriesId != null ? seriesId.value : this.seriesId),
        seasonId: (seasonId != null ? seasonId.value : this.seasonId),
        episodeNumber:
            (episodeNumber != null ? episodeNumber.value : this.episodeNumber),
        seasonNumber:
            (seasonNumber != null ? seasonNumber.value : this.seasonNumber),
        instanceId: (instanceId != null ? instanceId.value : this.instanceId),
        recordingId:
            (recordingId != null ? recordingId.value : this.recordingId),
        contentType:
            (contentType != null ? contentType.value : this.contentType),
        providerId: (providerId != null ? providerId.value : this.providerId),
        channelId: (channelId != null ? channelId.value : this.channelId));
  }
}

@JsonSerializable(explicitToJson: true)
class MostRelevantEpisodeResponse {
  MostRelevantEpisodeResponse({
    required this.titleId,
    required this.seriesId,
    this.seasonId,
    required this.episodeNumber,
    this.seasonNumber,
    this.instanceId,
    this.contentType,
    this.contentSource,
    this.includesVOD,
    this.hasInteracted,
    this.recordingId,
    this.viewProgress,
    this.isGoPlayable,
    this.brandingProviderId,
    this.channelId,
  });

  factory MostRelevantEpisodeResponse.fromJson(Map<String, dynamic> json) =>
      _$MostRelevantEpisodeResponseFromJson(json);

  @JsonKey(name: 'titleId', includeIfNull: false, defaultValue: '')
  final String titleId;
  @JsonKey(name: 'seriesId', includeIfNull: false, defaultValue: '')
  final String seriesId;
  @JsonKey(name: 'seasonId', includeIfNull: false, defaultValue: '')
  final String? seasonId;
  @JsonKey(name: 'episodeNumber', includeIfNull: false)
  final int episodeNumber;
  @JsonKey(name: 'seasonNumber', includeIfNull: false)
  final int? seasonNumber;
  @JsonKey(name: 'instanceId', includeIfNull: false, defaultValue: '')
  final String? instanceId;
  @JsonKey(
    name: 'contentType',
    includeIfNull: false,
    toJson: mostRelevantEpisodeResponseContentTypeToJson,
    fromJson: mostRelevantEpisodeResponseContentTypeFromJson,
  )
  final enums.MostRelevantEpisodeResponseContentType? contentType;
  @JsonKey(name: 'contentSource', includeIfNull: false)
  final int? contentSource;
  @JsonKey(name: 'includesVOD', includeIfNull: false)
  final bool? includesVOD;
  @JsonKey(name: 'hasInteracted', includeIfNull: false)
  final bool? hasInteracted;
  @JsonKey(name: 'recordingId', includeIfNull: false, defaultValue: '')
  final String? recordingId;
  @JsonKey(name: 'viewProgress', includeIfNull: false)
  final ViewProgressResponse? viewProgress;
  @JsonKey(name: 'isGoPlayable', includeIfNull: false)
  final bool? isGoPlayable;
  @JsonKey(name: 'brandingProviderId', includeIfNull: false, defaultValue: '')
  final String? brandingProviderId;
  @JsonKey(name: 'channelId', includeIfNull: false, defaultValue: '')
  final String? channelId;
  static const fromJsonFactory = _$MostRelevantEpisodeResponseFromJson;
  static const toJsonFactory = _$MostRelevantEpisodeResponseToJson;
  Map<String, dynamic> toJson() => _$MostRelevantEpisodeResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MostRelevantEpisodeResponse &&
            (identical(other.titleId, titleId) ||
                const DeepCollectionEquality()
                    .equals(other.titleId, titleId)) &&
            (identical(other.seriesId, seriesId) ||
                const DeepCollectionEquality()
                    .equals(other.seriesId, seriesId)) &&
            (identical(other.seasonId, seasonId) ||
                const DeepCollectionEquality()
                    .equals(other.seasonId, seasonId)) &&
            (identical(other.episodeNumber, episodeNumber) ||
                const DeepCollectionEquality()
                    .equals(other.episodeNumber, episodeNumber)) &&
            (identical(other.seasonNumber, seasonNumber) ||
                const DeepCollectionEquality()
                    .equals(other.seasonNumber, seasonNumber)) &&
            (identical(other.instanceId, instanceId) ||
                const DeepCollectionEquality()
                    .equals(other.instanceId, instanceId)) &&
            (identical(other.contentType, contentType) ||
                const DeepCollectionEquality()
                    .equals(other.contentType, contentType)) &&
            (identical(other.contentSource, contentSource) ||
                const DeepCollectionEquality()
                    .equals(other.contentSource, contentSource)) &&
            (identical(other.includesVOD, includesVOD) ||
                const DeepCollectionEquality()
                    .equals(other.includesVOD, includesVOD)) &&
            (identical(other.hasInteracted, hasInteracted) ||
                const DeepCollectionEquality()
                    .equals(other.hasInteracted, hasInteracted)) &&
            (identical(other.recordingId, recordingId) ||
                const DeepCollectionEquality()
                    .equals(other.recordingId, recordingId)) &&
            (identical(other.viewProgress, viewProgress) ||
                const DeepCollectionEquality()
                    .equals(other.viewProgress, viewProgress)) &&
            (identical(other.isGoPlayable, isGoPlayable) ||
                const DeepCollectionEquality()
                    .equals(other.isGoPlayable, isGoPlayable)) &&
            (identical(other.brandingProviderId, brandingProviderId) ||
                const DeepCollectionEquality()
                    .equals(other.brandingProviderId, brandingProviderId)) &&
            (identical(other.channelId, channelId) ||
                const DeepCollectionEquality()
                    .equals(other.channelId, channelId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(titleId) ^
      const DeepCollectionEquality().hash(seriesId) ^
      const DeepCollectionEquality().hash(seasonId) ^
      const DeepCollectionEquality().hash(episodeNumber) ^
      const DeepCollectionEquality().hash(seasonNumber) ^
      const DeepCollectionEquality().hash(instanceId) ^
      const DeepCollectionEquality().hash(contentType) ^
      const DeepCollectionEquality().hash(contentSource) ^
      const DeepCollectionEquality().hash(includesVOD) ^
      const DeepCollectionEquality().hash(hasInteracted) ^
      const DeepCollectionEquality().hash(recordingId) ^
      const DeepCollectionEquality().hash(viewProgress) ^
      const DeepCollectionEquality().hash(isGoPlayable) ^
      const DeepCollectionEquality().hash(brandingProviderId) ^
      const DeepCollectionEquality().hash(channelId) ^
      runtimeType.hashCode;
}

extension $MostRelevantEpisodeResponseExtension on MostRelevantEpisodeResponse {
  MostRelevantEpisodeResponse copyWith(
      {String? titleId,
      String? seriesId,
      String? seasonId,
      int? episodeNumber,
      int? seasonNumber,
      String? instanceId,
      enums.MostRelevantEpisodeResponseContentType? contentType,
      int? contentSource,
      bool? includesVOD,
      bool? hasInteracted,
      String? recordingId,
      ViewProgressResponse? viewProgress,
      bool? isGoPlayable,
      String? brandingProviderId,
      String? channelId}) {
    return MostRelevantEpisodeResponse(
        titleId: titleId ?? this.titleId,
        seriesId: seriesId ?? this.seriesId,
        seasonId: seasonId ?? this.seasonId,
        episodeNumber: episodeNumber ?? this.episodeNumber,
        seasonNumber: seasonNumber ?? this.seasonNumber,
        instanceId: instanceId ?? this.instanceId,
        contentType: contentType ?? this.contentType,
        contentSource: contentSource ?? this.contentSource,
        includesVOD: includesVOD ?? this.includesVOD,
        hasInteracted: hasInteracted ?? this.hasInteracted,
        recordingId: recordingId ?? this.recordingId,
        viewProgress: viewProgress ?? this.viewProgress,
        isGoPlayable: isGoPlayable ?? this.isGoPlayable,
        brandingProviderId: brandingProviderId ?? this.brandingProviderId,
        channelId: channelId ?? this.channelId);
  }

  MostRelevantEpisodeResponse copyWithWrapped(
      {Wrapped<String>? titleId,
      Wrapped<String>? seriesId,
      Wrapped<String?>? seasonId,
      Wrapped<int>? episodeNumber,
      Wrapped<int?>? seasonNumber,
      Wrapped<String?>? instanceId,
      Wrapped<enums.MostRelevantEpisodeResponseContentType?>? contentType,
      Wrapped<int?>? contentSource,
      Wrapped<bool?>? includesVOD,
      Wrapped<bool?>? hasInteracted,
      Wrapped<String?>? recordingId,
      Wrapped<ViewProgressResponse?>? viewProgress,
      Wrapped<bool?>? isGoPlayable,
      Wrapped<String?>? brandingProviderId,
      Wrapped<String?>? channelId}) {
    return MostRelevantEpisodeResponse(
        titleId: (titleId != null ? titleId.value : this.titleId),
        seriesId: (seriesId != null ? seriesId.value : this.seriesId),
        seasonId: (seasonId != null ? seasonId.value : this.seasonId),
        episodeNumber:
            (episodeNumber != null ? episodeNumber.value : this.episodeNumber),
        seasonNumber:
            (seasonNumber != null ? seasonNumber.value : this.seasonNumber),
        instanceId: (instanceId != null ? instanceId.value : this.instanceId),
        contentType:
            (contentType != null ? contentType.value : this.contentType),
        contentSource:
            (contentSource != null ? contentSource.value : this.contentSource),
        includesVOD:
            (includesVOD != null ? includesVOD.value : this.includesVOD),
        hasInteracted:
            (hasInteracted != null ? hasInteracted.value : this.hasInteracted),
        recordingId:
            (recordingId != null ? recordingId.value : this.recordingId),
        viewProgress:
            (viewProgress != null ? viewProgress.value : this.viewProgress),
        isGoPlayable:
            (isGoPlayable != null ? isGoPlayable.value : this.isGoPlayable),
        brandingProviderId: (brandingProviderId != null
            ? brandingProviderId.value
            : this.brandingProviderId),
        channelId: (channelId != null ? channelId.value : this.channelId));
  }
}

@JsonSerializable(explicitToJson: true)
class EstResponse {
  EstResponse({
    required this.minPrice,
    required this.minPriceDisplay,
    required this.currency,
    required this.videoHost,
    required this.videoUrl,
  });

  factory EstResponse.fromJson(Map<String, dynamic> json) =>
      _$EstResponseFromJson(json);

  @JsonKey(name: 'minPrice', includeIfNull: false, defaultValue: '')
  final String minPrice;
  @JsonKey(name: 'minPriceDisplay', includeIfNull: false, defaultValue: '')
  final String minPriceDisplay;
  @JsonKey(name: 'currency', includeIfNull: false, defaultValue: '')
  final String currency;
  @JsonKey(name: 'videoHost', includeIfNull: false, defaultValue: '')
  final String videoHost;
  @JsonKey(name: 'videoUrl', includeIfNull: false, defaultValue: '')
  final String videoUrl;
  static const fromJsonFactory = _$EstResponseFromJson;
  static const toJsonFactory = _$EstResponseToJson;
  Map<String, dynamic> toJson() => _$EstResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EstResponse &&
            (identical(other.minPrice, minPrice) ||
                const DeepCollectionEquality()
                    .equals(other.minPrice, minPrice)) &&
            (identical(other.minPriceDisplay, minPriceDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.minPriceDisplay, minPriceDisplay)) &&
            (identical(other.currency, currency) ||
                const DeepCollectionEquality()
                    .equals(other.currency, currency)) &&
            (identical(other.videoHost, videoHost) ||
                const DeepCollectionEquality()
                    .equals(other.videoHost, videoHost)) &&
            (identical(other.videoUrl, videoUrl) ||
                const DeepCollectionEquality()
                    .equals(other.videoUrl, videoUrl)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(minPrice) ^
      const DeepCollectionEquality().hash(minPriceDisplay) ^
      const DeepCollectionEquality().hash(currency) ^
      const DeepCollectionEquality().hash(videoHost) ^
      const DeepCollectionEquality().hash(videoUrl) ^
      runtimeType.hashCode;
}

extension $EstResponseExtension on EstResponse {
  EstResponse copyWith(
      {String? minPrice,
      String? minPriceDisplay,
      String? currency,
      String? videoHost,
      String? videoUrl}) {
    return EstResponse(
        minPrice: minPrice ?? this.minPrice,
        minPriceDisplay: minPriceDisplay ?? this.minPriceDisplay,
        currency: currency ?? this.currency,
        videoHost: videoHost ?? this.videoHost,
        videoUrl: videoUrl ?? this.videoUrl);
  }

  EstResponse copyWithWrapped(
      {Wrapped<String>? minPrice,
      Wrapped<String>? minPriceDisplay,
      Wrapped<String>? currency,
      Wrapped<String>? videoHost,
      Wrapped<String>? videoUrl}) {
    return EstResponse(
        minPrice: (minPrice != null ? minPrice.value : this.minPrice),
        minPriceDisplay: (minPriceDisplay != null
            ? minPriceDisplay.value
            : this.minPriceDisplay),
        currency: (currency != null ? currency.value : this.currency),
        videoHost: (videoHost != null ? videoHost.value : this.videoHost),
        videoUrl: (videoUrl != null ? videoUrl.value : this.videoUrl));
  }
}

@JsonSerializable(explicitToJson: true)
class TaaoLinearResponse {
  TaaoLinearResponse({
    this.viewProgress,
    this.sourceType,
    this.source,
  });

  factory TaaoLinearResponse.fromJson(Map<String, dynamic> json) =>
      _$TaaoLinearResponseFromJson(json);

  @JsonKey(name: 'viewProgress', includeIfNull: false)
  final ViewProgressResponse? viewProgress;
  @JsonKey(name: 'sourceType', includeIfNull: false)
  final SourceTypeResponse? sourceType;
  @JsonKey(name: 'source', includeIfNull: false)
  final LinearSourceResponse? source;
  static const fromJsonFactory = _$TaaoLinearResponseFromJson;
  static const toJsonFactory = _$TaaoLinearResponseToJson;
  Map<String, dynamic> toJson() => _$TaaoLinearResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TaaoLinearResponse &&
            (identical(other.viewProgress, viewProgress) ||
                const DeepCollectionEquality()
                    .equals(other.viewProgress, viewProgress)) &&
            (identical(other.sourceType, sourceType) ||
                const DeepCollectionEquality()
                    .equals(other.sourceType, sourceType)) &&
            (identical(other.source, source) ||
                const DeepCollectionEquality().equals(other.source, source)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(viewProgress) ^
      const DeepCollectionEquality().hash(sourceType) ^
      const DeepCollectionEquality().hash(source) ^
      runtimeType.hashCode;
}

extension $TaaoLinearResponseExtension on TaaoLinearResponse {
  TaaoLinearResponse copyWith(
      {ViewProgressResponse? viewProgress,
      SourceTypeResponse? sourceType,
      LinearSourceResponse? source}) {
    return TaaoLinearResponse(
        viewProgress: viewProgress ?? this.viewProgress,
        sourceType: sourceType ?? this.sourceType,
        source: source ?? this.source);
  }

  TaaoLinearResponse copyWithWrapped(
      {Wrapped<ViewProgressResponse?>? viewProgress,
      Wrapped<SourceTypeResponse?>? sourceType,
      Wrapped<LinearSourceResponse?>? source}) {
    return TaaoLinearResponse(
        viewProgress:
            (viewProgress != null ? viewProgress.value : this.viewProgress),
        sourceType: (sourceType != null ? sourceType.value : this.sourceType),
        source: (source != null ? source.value : this.source));
  }
}

@JsonSerializable(explicitToJson: true)
class TaaoRecordingResponse {
  TaaoRecordingResponse({
    this.viewProgress,
    this.sourceType,
    this.source,
  });

  factory TaaoRecordingResponse.fromJson(Map<String, dynamic> json) =>
      _$TaaoRecordingResponseFromJson(json);

  @JsonKey(name: 'viewProgress', includeIfNull: false)
  final ViewProgressResponse? viewProgress;
  @JsonKey(name: 'sourceType', includeIfNull: false)
  final SourceTypeResponse? sourceType;
  @JsonKey(name: 'source', includeIfNull: false)
  final RecordingSourceResponse? source;
  static const fromJsonFactory = _$TaaoRecordingResponseFromJson;
  static const toJsonFactory = _$TaaoRecordingResponseToJson;
  Map<String, dynamic> toJson() => _$TaaoRecordingResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TaaoRecordingResponse &&
            (identical(other.viewProgress, viewProgress) ||
                const DeepCollectionEquality()
                    .equals(other.viewProgress, viewProgress)) &&
            (identical(other.sourceType, sourceType) ||
                const DeepCollectionEquality()
                    .equals(other.sourceType, sourceType)) &&
            (identical(other.source, source) ||
                const DeepCollectionEquality().equals(other.source, source)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(viewProgress) ^
      const DeepCollectionEquality().hash(sourceType) ^
      const DeepCollectionEquality().hash(source) ^
      runtimeType.hashCode;
}

extension $TaaoRecordingResponseExtension on TaaoRecordingResponse {
  TaaoRecordingResponse copyWith(
      {ViewProgressResponse? viewProgress,
      SourceTypeResponse? sourceType,
      RecordingSourceResponse? source}) {
    return TaaoRecordingResponse(
        viewProgress: viewProgress ?? this.viewProgress,
        sourceType: sourceType ?? this.sourceType,
        source: source ?? this.source);
  }

  TaaoRecordingResponse copyWithWrapped(
      {Wrapped<ViewProgressResponse?>? viewProgress,
      Wrapped<SourceTypeResponse?>? sourceType,
      Wrapped<RecordingSourceResponse?>? source}) {
    return TaaoRecordingResponse(
        viewProgress:
            (viewProgress != null ? viewProgress.value : this.viewProgress),
        sourceType: (sourceType != null ? sourceType.value : this.sourceType),
        source: (source != null ? source.value : this.source));
  }
}

@JsonSerializable(explicitToJson: true)
class TaaoVodResponse {
  TaaoVodResponse({
    this.viewProgress,
    this.sourceType,
    this.source,
  });

  factory TaaoVodResponse.fromJson(Map<String, dynamic> json) =>
      _$TaaoVodResponseFromJson(json);

  @JsonKey(name: 'viewProgress', includeIfNull: false)
  final ViewProgressResponse? viewProgress;
  @JsonKey(name: 'sourceType', includeIfNull: false)
  final SourceTypeResponse? sourceType;
  @JsonKey(name: 'source', includeIfNull: false)
  final VodSourceResponse? source;
  static const fromJsonFactory = _$TaaoVodResponseFromJson;
  static const toJsonFactory = _$TaaoVodResponseToJson;
  Map<String, dynamic> toJson() => _$TaaoVodResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TaaoVodResponse &&
            (identical(other.viewProgress, viewProgress) ||
                const DeepCollectionEquality()
                    .equals(other.viewProgress, viewProgress)) &&
            (identical(other.sourceType, sourceType) ||
                const DeepCollectionEquality()
                    .equals(other.sourceType, sourceType)) &&
            (identical(other.source, source) ||
                const DeepCollectionEquality().equals(other.source, source)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(viewProgress) ^
      const DeepCollectionEquality().hash(sourceType) ^
      const DeepCollectionEquality().hash(source) ^
      runtimeType.hashCode;
}

extension $TaaoVodResponseExtension on TaaoVodResponse {
  TaaoVodResponse copyWith(
      {ViewProgressResponse? viewProgress,
      SourceTypeResponse? sourceType,
      VodSourceResponse? source}) {
    return TaaoVodResponse(
        viewProgress: viewProgress ?? this.viewProgress,
        sourceType: sourceType ?? this.sourceType,
        source: source ?? this.source);
  }

  TaaoVodResponse copyWithWrapped(
      {Wrapped<ViewProgressResponse?>? viewProgress,
      Wrapped<SourceTypeResponse?>? sourceType,
      Wrapped<VodSourceResponse?>? source}) {
    return TaaoVodResponse(
        viewProgress:
            (viewProgress != null ? viewProgress.value : this.viewProgress),
        sourceType: (sourceType != null ? sourceType.value : this.sourceType),
        source: (source != null ? source.value : this.source));
  }
}

@JsonSerializable(explicitToJson: true)
class TaaoOttResponse {
  TaaoOttResponse({
    this.viewProgress,
    this.sourceType,
    this.source,
  });

  factory TaaoOttResponse.fromJson(Map<String, dynamic> json) =>
      _$TaaoOttResponseFromJson(json);

  @JsonKey(name: 'viewProgress', includeIfNull: false)
  final ViewProgressResponse? viewProgress;
  @JsonKey(name: 'sourceType', includeIfNull: false)
  final SourceTypeResponse? sourceType;
  @JsonKey(name: 'source', includeIfNull: false)
  final OttSourceResponse? source;
  static const fromJsonFactory = _$TaaoOttResponseFromJson;
  static const toJsonFactory = _$TaaoOttResponseToJson;
  Map<String, dynamic> toJson() => _$TaaoOttResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TaaoOttResponse &&
            (identical(other.viewProgress, viewProgress) ||
                const DeepCollectionEquality()
                    .equals(other.viewProgress, viewProgress)) &&
            (identical(other.sourceType, sourceType) ||
                const DeepCollectionEquality()
                    .equals(other.sourceType, sourceType)) &&
            (identical(other.source, source) ||
                const DeepCollectionEquality().equals(other.source, source)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(viewProgress) ^
      const DeepCollectionEquality().hash(sourceType) ^
      const DeepCollectionEquality().hash(source) ^
      runtimeType.hashCode;
}

extension $TaaoOttResponseExtension on TaaoOttResponse {
  TaaoOttResponse copyWith(
      {ViewProgressResponse? viewProgress,
      SourceTypeResponse? sourceType,
      OttSourceResponse? source}) {
    return TaaoOttResponse(
        viewProgress: viewProgress ?? this.viewProgress,
        sourceType: sourceType ?? this.sourceType,
        source: source ?? this.source);
  }

  TaaoOttResponse copyWithWrapped(
      {Wrapped<ViewProgressResponse?>? viewProgress,
      Wrapped<SourceTypeResponse?>? sourceType,
      Wrapped<OttSourceResponse?>? source}) {
    return TaaoOttResponse(
        viewProgress:
            (viewProgress != null ? viewProgress.value : this.viewProgress),
        sourceType: (sourceType != null ? sourceType.value : this.sourceType),
        source: (source != null ? source.value : this.source));
  }
}

@JsonSerializable(explicitToJson: true)
class ViewProgressResponse {
  ViewProgressResponse({
    this.viewState,
    this.position,
    this.duration,
  });

  factory ViewProgressResponse.fromJson(Map<String, dynamic> json) =>
      _$ViewProgressResponseFromJson(json);

  @JsonKey(
    name: 'viewState',
    includeIfNull: false,
    toJson: viewProgressResponseViewStateToJson,
    fromJson: viewProgressResponseViewStateFromJson,
  )
  final enums.ViewProgressResponseViewState? viewState;
  @JsonKey(name: 'position', includeIfNull: false)
  final int? position;
  @JsonKey(name: 'duration', includeIfNull: false)
  final int? duration;
  static const fromJsonFactory = _$ViewProgressResponseFromJson;
  static const toJsonFactory = _$ViewProgressResponseToJson;
  Map<String, dynamic> toJson() => _$ViewProgressResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ViewProgressResponse &&
            (identical(other.viewState, viewState) ||
                const DeepCollectionEquality()
                    .equals(other.viewState, viewState)) &&
            (identical(other.position, position) ||
                const DeepCollectionEquality()
                    .equals(other.position, position)) &&
            (identical(other.duration, duration) ||
                const DeepCollectionEquality()
                    .equals(other.duration, duration)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(viewState) ^
      const DeepCollectionEquality().hash(position) ^
      const DeepCollectionEquality().hash(duration) ^
      runtimeType.hashCode;
}

extension $ViewProgressResponseExtension on ViewProgressResponse {
  ViewProgressResponse copyWith(
      {enums.ViewProgressResponseViewState? viewState,
      int? position,
      int? duration}) {
    return ViewProgressResponse(
        viewState: viewState ?? this.viewState,
        position: position ?? this.position,
        duration: duration ?? this.duration);
  }

  ViewProgressResponse copyWithWrapped(
      {Wrapped<enums.ViewProgressResponseViewState?>? viewState,
      Wrapped<int?>? position,
      Wrapped<int?>? duration}) {
    return ViewProgressResponse(
        viewState: (viewState != null ? viewState.value : this.viewState),
        position: (position != null ? position.value : this.position),
        duration: (duration != null ? duration.value : this.duration));
  }
}

@JsonSerializable(explicitToJson: true)
class SourceTypeResponse {
  SourceTypeResponse({
    this.sourceType,
  });

  factory SourceTypeResponse.fromJson(Map<String, dynamic> json) =>
      _$SourceTypeResponseFromJson(json);

  @JsonKey(
    name: 'sourceType',
    includeIfNull: false,
    toJson: sourceTypeResponseSourceTypeToJson,
    fromJson: sourceTypeResponseSourceTypeFromJson,
  )
  final enums.SourceTypeResponseSourceType? sourceType;
  static const fromJsonFactory = _$SourceTypeResponseFromJson;
  static const toJsonFactory = _$SourceTypeResponseToJson;
  Map<String, dynamic> toJson() => _$SourceTypeResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SourceTypeResponse &&
            (identical(other.sourceType, sourceType) ||
                const DeepCollectionEquality()
                    .equals(other.sourceType, sourceType)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(sourceType) ^ runtimeType.hashCode;
}

extension $SourceTypeResponseExtension on SourceTypeResponse {
  SourceTypeResponse copyWith(
      {enums.SourceTypeResponseSourceType? sourceType}) {
    return SourceTypeResponse(sourceType: sourceType ?? this.sourceType);
  }

  SourceTypeResponse copyWithWrapped(
      {Wrapped<enums.SourceTypeResponseSourceType?>? sourceType}) {
    return SourceTypeResponse(
        sourceType: (sourceType != null ? sourceType.value : this.sourceType));
  }
}

@JsonSerializable(explicitToJson: true)
class LinearSourceResponse {
  LinearSourceResponse({
    this.titleId,
    this.eventId,
    this.channel,
    this.broadcastDate,
    this.duration,
    this.eventReplay,
  });

  factory LinearSourceResponse.fromJson(Map<String, dynamic> json) =>
      _$LinearSourceResponseFromJson(json);

  @JsonKey(name: 'titleId', includeIfNull: false, defaultValue: '')
  final String? titleId;
  @JsonKey(name: 'eventId', includeIfNull: false, defaultValue: '')
  final String? eventId;
  @JsonKey(name: 'channel', includeIfNull: false)
  final ChannelResponse? channel;
  @JsonKey(name: 'broadcastDate', includeIfNull: false, defaultValue: '')
  final String? broadcastDate;
  @JsonKey(name: 'duration', includeIfNull: false, defaultValue: '')
  final String? duration;
  @JsonKey(name: 'eventReplay', includeIfNull: false)
  final EventReplayResponse? eventReplay;
  static const fromJsonFactory = _$LinearSourceResponseFromJson;
  static const toJsonFactory = _$LinearSourceResponseToJson;
  Map<String, dynamic> toJson() => _$LinearSourceResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is LinearSourceResponse &&
            (identical(other.titleId, titleId) ||
                const DeepCollectionEquality()
                    .equals(other.titleId, titleId)) &&
            (identical(other.eventId, eventId) ||
                const DeepCollectionEquality()
                    .equals(other.eventId, eventId)) &&
            (identical(other.channel, channel) ||
                const DeepCollectionEquality()
                    .equals(other.channel, channel)) &&
            (identical(other.broadcastDate, broadcastDate) ||
                const DeepCollectionEquality()
                    .equals(other.broadcastDate, broadcastDate)) &&
            (identical(other.duration, duration) ||
                const DeepCollectionEquality()
                    .equals(other.duration, duration)) &&
            (identical(other.eventReplay, eventReplay) ||
                const DeepCollectionEquality()
                    .equals(other.eventReplay, eventReplay)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(titleId) ^
      const DeepCollectionEquality().hash(eventId) ^
      const DeepCollectionEquality().hash(channel) ^
      const DeepCollectionEquality().hash(broadcastDate) ^
      const DeepCollectionEquality().hash(duration) ^
      const DeepCollectionEquality().hash(eventReplay) ^
      runtimeType.hashCode;
}

extension $LinearSourceResponseExtension on LinearSourceResponse {
  LinearSourceResponse copyWith(
      {String? titleId,
      String? eventId,
      ChannelResponse? channel,
      String? broadcastDate,
      String? duration,
      EventReplayResponse? eventReplay}) {
    return LinearSourceResponse(
        titleId: titleId ?? this.titleId,
        eventId: eventId ?? this.eventId,
        channel: channel ?? this.channel,
        broadcastDate: broadcastDate ?? this.broadcastDate,
        duration: duration ?? this.duration,
        eventReplay: eventReplay ?? this.eventReplay);
  }

  LinearSourceResponse copyWithWrapped(
      {Wrapped<String?>? titleId,
      Wrapped<String?>? eventId,
      Wrapped<ChannelResponse?>? channel,
      Wrapped<String?>? broadcastDate,
      Wrapped<String?>? duration,
      Wrapped<EventReplayResponse?>? eventReplay}) {
    return LinearSourceResponse(
        titleId: (titleId != null ? titleId.value : this.titleId),
        eventId: (eventId != null ? eventId.value : this.eventId),
        channel: (channel != null ? channel.value : this.channel),
        broadcastDate:
            (broadcastDate != null ? broadcastDate.value : this.broadcastDate),
        duration: (duration != null ? duration.value : this.duration),
        eventReplay:
            (eventReplay != null ? eventReplay.value : this.eventReplay));
  }
}

@JsonSerializable(explicitToJson: true)
class RecordingSourceResponse {
  RecordingSourceResponse({
    this.titleId,
    this.recordingId,
    this.cpeId,
    this.broadcastDate,
    this.duration,
    this.technicalDuration,
    this.channel,
  });

  factory RecordingSourceResponse.fromJson(Map<String, dynamic> json) =>
      _$RecordingSourceResponseFromJson(json);

  @JsonKey(name: 'titleId', includeIfNull: false, defaultValue: '')
  final String? titleId;
  @JsonKey(name: 'recordingId', includeIfNull: false, defaultValue: '')
  final String? recordingId;
  @JsonKey(name: 'cpeId', includeIfNull: false, defaultValue: '')
  final String? cpeId;
  @JsonKey(name: 'broadcastDate', includeIfNull: false, defaultValue: '')
  final String? broadcastDate;
  @JsonKey(name: 'duration', includeIfNull: false)
  final int? duration;
  @JsonKey(name: 'technicalDuration', includeIfNull: false, defaultValue: '')
  final String? technicalDuration;
  @JsonKey(name: 'channel', includeIfNull: false)
  final ChannelResponse? channel;
  static const fromJsonFactory = _$RecordingSourceResponseFromJson;
  static const toJsonFactory = _$RecordingSourceResponseToJson;
  Map<String, dynamic> toJson() => _$RecordingSourceResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is RecordingSourceResponse &&
            (identical(other.titleId, titleId) ||
                const DeepCollectionEquality()
                    .equals(other.titleId, titleId)) &&
            (identical(other.recordingId, recordingId) ||
                const DeepCollectionEquality()
                    .equals(other.recordingId, recordingId)) &&
            (identical(other.cpeId, cpeId) ||
                const DeepCollectionEquality().equals(other.cpeId, cpeId)) &&
            (identical(other.broadcastDate, broadcastDate) ||
                const DeepCollectionEquality()
                    .equals(other.broadcastDate, broadcastDate)) &&
            (identical(other.duration, duration) ||
                const DeepCollectionEquality()
                    .equals(other.duration, duration)) &&
            (identical(other.technicalDuration, technicalDuration) ||
                const DeepCollectionEquality()
                    .equals(other.technicalDuration, technicalDuration)) &&
            (identical(other.channel, channel) ||
                const DeepCollectionEquality().equals(other.channel, channel)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(titleId) ^
      const DeepCollectionEquality().hash(recordingId) ^
      const DeepCollectionEquality().hash(cpeId) ^
      const DeepCollectionEquality().hash(broadcastDate) ^
      const DeepCollectionEquality().hash(duration) ^
      const DeepCollectionEquality().hash(technicalDuration) ^
      const DeepCollectionEquality().hash(channel) ^
      runtimeType.hashCode;
}

extension $RecordingSourceResponseExtension on RecordingSourceResponse {
  RecordingSourceResponse copyWith(
      {String? titleId,
      String? recordingId,
      String? cpeId,
      String? broadcastDate,
      int? duration,
      String? technicalDuration,
      ChannelResponse? channel}) {
    return RecordingSourceResponse(
        titleId: titleId ?? this.titleId,
        recordingId: recordingId ?? this.recordingId,
        cpeId: cpeId ?? this.cpeId,
        broadcastDate: broadcastDate ?? this.broadcastDate,
        duration: duration ?? this.duration,
        technicalDuration: technicalDuration ?? this.technicalDuration,
        channel: channel ?? this.channel);
  }

  RecordingSourceResponse copyWithWrapped(
      {Wrapped<String?>? titleId,
      Wrapped<String?>? recordingId,
      Wrapped<String?>? cpeId,
      Wrapped<String?>? broadcastDate,
      Wrapped<int?>? duration,
      Wrapped<String?>? technicalDuration,
      Wrapped<ChannelResponse?>? channel}) {
    return RecordingSourceResponse(
        titleId: (titleId != null ? titleId.value : this.titleId),
        recordingId:
            (recordingId != null ? recordingId.value : this.recordingId),
        cpeId: (cpeId != null ? cpeId.value : this.cpeId),
        broadcastDate:
            (broadcastDate != null ? broadcastDate.value : this.broadcastDate),
        duration: (duration != null ? duration.value : this.duration),
        technicalDuration: (technicalDuration != null
            ? technicalDuration.value
            : this.technicalDuration),
        channel: (channel != null ? channel.value : this.channel));
  }
}

@JsonSerializable(explicitToJson: true)
class VodSourceResponse {
  VodSourceResponse({
    required this.titleId,
    required this.type,
    this.entitlementEnd,
    required this.entitlementState,
    required this.brandingProviderId,
    this.priceDisplay,
    this.minPriceDisplay,
    this.currency,
  });

  factory VodSourceResponse.fromJson(Map<String, dynamic> json) =>
      _$VodSourceResponseFromJson(json);

  @JsonKey(name: 'titleId', includeIfNull: false, defaultValue: '')
  final String titleId;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String type;
  @JsonKey(name: 'entitlementEnd', includeIfNull: false)
  final int? entitlementEnd;
  @JsonKey(name: 'entitlementState', includeIfNull: false, defaultValue: '')
  final String entitlementState;
  @JsonKey(name: 'brandingProviderId', includeIfNull: false, defaultValue: '')
  final String brandingProviderId;
  @JsonKey(name: 'priceDisplay', includeIfNull: false, defaultValue: '')
  final String? priceDisplay;
  @JsonKey(name: 'minPriceDisplay', includeIfNull: false, defaultValue: '')
  final String? minPriceDisplay;
  @JsonKey(name: 'currency', includeIfNull: false, defaultValue: '')
  final String? currency;
  static const fromJsonFactory = _$VodSourceResponseFromJson;
  static const toJsonFactory = _$VodSourceResponseToJson;
  Map<String, dynamic> toJson() => _$VodSourceResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is VodSourceResponse &&
            (identical(other.titleId, titleId) ||
                const DeepCollectionEquality()
                    .equals(other.titleId, titleId)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.entitlementEnd, entitlementEnd) ||
                const DeepCollectionEquality()
                    .equals(other.entitlementEnd, entitlementEnd)) &&
            (identical(other.entitlementState, entitlementState) ||
                const DeepCollectionEquality()
                    .equals(other.entitlementState, entitlementState)) &&
            (identical(other.brandingProviderId, brandingProviderId) ||
                const DeepCollectionEquality()
                    .equals(other.brandingProviderId, brandingProviderId)) &&
            (identical(other.priceDisplay, priceDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.priceDisplay, priceDisplay)) &&
            (identical(other.minPriceDisplay, minPriceDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.minPriceDisplay, minPriceDisplay)) &&
            (identical(other.currency, currency) ||
                const DeepCollectionEquality()
                    .equals(other.currency, currency)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(titleId) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(entitlementEnd) ^
      const DeepCollectionEquality().hash(entitlementState) ^
      const DeepCollectionEquality().hash(brandingProviderId) ^
      const DeepCollectionEquality().hash(priceDisplay) ^
      const DeepCollectionEquality().hash(minPriceDisplay) ^
      const DeepCollectionEquality().hash(currency) ^
      runtimeType.hashCode;
}

extension $VodSourceResponseExtension on VodSourceResponse {
  VodSourceResponse copyWith(
      {String? titleId,
      String? type,
      int? entitlementEnd,
      String? entitlementState,
      String? brandingProviderId,
      String? priceDisplay,
      String? minPriceDisplay,
      String? currency}) {
    return VodSourceResponse(
        titleId: titleId ?? this.titleId,
        type: type ?? this.type,
        entitlementEnd: entitlementEnd ?? this.entitlementEnd,
        entitlementState: entitlementState ?? this.entitlementState,
        brandingProviderId: brandingProviderId ?? this.brandingProviderId,
        priceDisplay: priceDisplay ?? this.priceDisplay,
        minPriceDisplay: minPriceDisplay ?? this.minPriceDisplay,
        currency: currency ?? this.currency);
  }

  VodSourceResponse copyWithWrapped(
      {Wrapped<String>? titleId,
      Wrapped<String>? type,
      Wrapped<int?>? entitlementEnd,
      Wrapped<String>? entitlementState,
      Wrapped<String>? brandingProviderId,
      Wrapped<String?>? priceDisplay,
      Wrapped<String?>? minPriceDisplay,
      Wrapped<String?>? currency}) {
    return VodSourceResponse(
        titleId: (titleId != null ? titleId.value : this.titleId),
        type: (type != null ? type.value : this.type),
        entitlementEnd: (entitlementEnd != null
            ? entitlementEnd.value
            : this.entitlementEnd),
        entitlementState: (entitlementState != null
            ? entitlementState.value
            : this.entitlementState),
        brandingProviderId: (brandingProviderId != null
            ? brandingProviderId.value
            : this.brandingProviderId),
        priceDisplay:
            (priceDisplay != null ? priceDisplay.value : this.priceDisplay),
        minPriceDisplay: (minPriceDisplay != null
            ? minPriceDisplay.value
            : this.minPriceDisplay),
        currency: (currency != null ? currency.value : this.currency));
  }
}

@JsonSerializable(explicitToJson: true)
class OttSourceResponse {
  OttSourceResponse({
    required this.titleId,
    required this.minPriceDisplay,
    required this.currency,
    required this.videoHost,
    required this.videoUrl,
    required this.isEst,
    required this.brandingProviderId,
  });

  factory OttSourceResponse.fromJson(Map<String, dynamic> json) =>
      _$OttSourceResponseFromJson(json);

  @JsonKey(name: 'titleId', includeIfNull: false, defaultValue: '')
  final String titleId;
  @JsonKey(name: 'minPriceDisplay', includeIfNull: false, defaultValue: '')
  final String minPriceDisplay;
  @JsonKey(name: 'currency', includeIfNull: false, defaultValue: '')
  final String currency;
  @JsonKey(name: 'videoHost', includeIfNull: false, defaultValue: '')
  final String videoHost;
  @JsonKey(name: 'videoUrl', includeIfNull: false, defaultValue: '')
  final String videoUrl;
  @JsonKey(name: 'isEst', includeIfNull: false)
  final bool isEst;
  @JsonKey(name: 'brandingProviderId', includeIfNull: false, defaultValue: '')
  final String brandingProviderId;
  static const fromJsonFactory = _$OttSourceResponseFromJson;
  static const toJsonFactory = _$OttSourceResponseToJson;
  Map<String, dynamic> toJson() => _$OttSourceResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OttSourceResponse &&
            (identical(other.titleId, titleId) ||
                const DeepCollectionEquality()
                    .equals(other.titleId, titleId)) &&
            (identical(other.minPriceDisplay, minPriceDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.minPriceDisplay, minPriceDisplay)) &&
            (identical(other.currency, currency) ||
                const DeepCollectionEquality()
                    .equals(other.currency, currency)) &&
            (identical(other.videoHost, videoHost) ||
                const DeepCollectionEquality()
                    .equals(other.videoHost, videoHost)) &&
            (identical(other.videoUrl, videoUrl) ||
                const DeepCollectionEquality()
                    .equals(other.videoUrl, videoUrl)) &&
            (identical(other.isEst, isEst) ||
                const DeepCollectionEquality().equals(other.isEst, isEst)) &&
            (identical(other.brandingProviderId, brandingProviderId) ||
                const DeepCollectionEquality()
                    .equals(other.brandingProviderId, brandingProviderId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(titleId) ^
      const DeepCollectionEquality().hash(minPriceDisplay) ^
      const DeepCollectionEquality().hash(currency) ^
      const DeepCollectionEquality().hash(videoHost) ^
      const DeepCollectionEquality().hash(videoUrl) ^
      const DeepCollectionEquality().hash(isEst) ^
      const DeepCollectionEquality().hash(brandingProviderId) ^
      runtimeType.hashCode;
}

extension $OttSourceResponseExtension on OttSourceResponse {
  OttSourceResponse copyWith(
      {String? titleId,
      String? minPriceDisplay,
      String? currency,
      String? videoHost,
      String? videoUrl,
      bool? isEst,
      String? brandingProviderId}) {
    return OttSourceResponse(
        titleId: titleId ?? this.titleId,
        minPriceDisplay: minPriceDisplay ?? this.minPriceDisplay,
        currency: currency ?? this.currency,
        videoHost: videoHost ?? this.videoHost,
        videoUrl: videoUrl ?? this.videoUrl,
        isEst: isEst ?? this.isEst,
        brandingProviderId: brandingProviderId ?? this.brandingProviderId);
  }

  OttSourceResponse copyWithWrapped(
      {Wrapped<String>? titleId,
      Wrapped<String>? minPriceDisplay,
      Wrapped<String>? currency,
      Wrapped<String>? videoHost,
      Wrapped<String>? videoUrl,
      Wrapped<bool>? isEst,
      Wrapped<String>? brandingProviderId}) {
    return OttSourceResponse(
        titleId: (titleId != null ? titleId.value : this.titleId),
        minPriceDisplay: (minPriceDisplay != null
            ? minPriceDisplay.value
            : this.minPriceDisplay),
        currency: (currency != null ? currency.value : this.currency),
        videoHost: (videoHost != null ? videoHost.value : this.videoHost),
        videoUrl: (videoUrl != null ? videoUrl.value : this.videoUrl),
        isEst: (isEst != null ? isEst.value : this.isEst),
        brandingProviderId: (brandingProviderId != null
            ? brandingProviderId.value
            : this.brandingProviderId));
  }
}

@JsonSerializable(explicitToJson: true)
class ChannelResponse {
  ChannelResponse({
    this.channelId,
    this.channelName,
  });

  factory ChannelResponse.fromJson(Map<String, dynamic> json) =>
      _$ChannelResponseFromJson(json);

  @JsonKey(name: 'channelId', includeIfNull: false, defaultValue: '')
  final String? channelId;
  @JsonKey(name: 'channelName', includeIfNull: false, defaultValue: '')
  final String? channelName;
  static const fromJsonFactory = _$ChannelResponseFromJson;
  static const toJsonFactory = _$ChannelResponseToJson;
  Map<String, dynamic> toJson() => _$ChannelResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ChannelResponse &&
            (identical(other.channelId, channelId) ||
                const DeepCollectionEquality()
                    .equals(other.channelId, channelId)) &&
            (identical(other.channelName, channelName) ||
                const DeepCollectionEquality()
                    .equals(other.channelName, channelName)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(channelId) ^
      const DeepCollectionEquality().hash(channelName) ^
      runtimeType.hashCode;
}

extension $ChannelResponseExtension on ChannelResponse {
  ChannelResponse copyWith({String? channelId, String? channelName}) {
    return ChannelResponse(
        channelId: channelId ?? this.channelId,
        channelName: channelName ?? this.channelName);
  }

  ChannelResponse copyWithWrapped(
      {Wrapped<String?>? channelId, Wrapped<String?>? channelName}) {
    return ChannelResponse(
        channelId: (channelId != null ? channelId.value : this.channelId),
        channelName:
            (channelName != null ? channelName.value : this.channelName));
  }
}

@JsonSerializable(explicitToJson: true)
class EventReplayResponse {
  EventReplayResponse({
    this.replayAvailabilityStart,
    this.replayAvailabilityEnd,
    this.replayContainsAdult,
    this.replayMinAge,
    this.isGoPlayable,
  });

  factory EventReplayResponse.fromJson(Map<String, dynamic> json) =>
      _$EventReplayResponseFromJson(json);

  @JsonKey(name: 'replayAvailabilityStart', includeIfNull: false)
  final DateTime? replayAvailabilityStart;
  @JsonKey(name: 'replayAvailabilityEnd', includeIfNull: false)
  final DateTime? replayAvailabilityEnd;
  @JsonKey(name: 'replayContainsAdult', includeIfNull: false)
  final bool? replayContainsAdult;
  @JsonKey(name: 'replayMinAge', includeIfNull: false)
  final int? replayMinAge;
  @JsonKey(name: 'isGoPlayable', includeIfNull: false)
  final bool? isGoPlayable;
  static const fromJsonFactory = _$EventReplayResponseFromJson;
  static const toJsonFactory = _$EventReplayResponseToJson;
  Map<String, dynamic> toJson() => _$EventReplayResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EventReplayResponse &&
            (identical(
                    other.replayAvailabilityStart, replayAvailabilityStart) ||
                const DeepCollectionEquality().equals(
                    other.replayAvailabilityStart, replayAvailabilityStart)) &&
            (identical(other.replayAvailabilityEnd, replayAvailabilityEnd) ||
                const DeepCollectionEquality().equals(
                    other.replayAvailabilityEnd, replayAvailabilityEnd)) &&
            (identical(other.replayContainsAdult, replayContainsAdult) ||
                const DeepCollectionEquality()
                    .equals(other.replayContainsAdult, replayContainsAdult)) &&
            (identical(other.replayMinAge, replayMinAge) ||
                const DeepCollectionEquality()
                    .equals(other.replayMinAge, replayMinAge)) &&
            (identical(other.isGoPlayable, isGoPlayable) ||
                const DeepCollectionEquality()
                    .equals(other.isGoPlayable, isGoPlayable)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(replayAvailabilityStart) ^
      const DeepCollectionEquality().hash(replayAvailabilityEnd) ^
      const DeepCollectionEquality().hash(replayContainsAdult) ^
      const DeepCollectionEquality().hash(replayMinAge) ^
      const DeepCollectionEquality().hash(isGoPlayable) ^
      runtimeType.hashCode;
}

extension $EventReplayResponseExtension on EventReplayResponse {
  EventReplayResponse copyWith(
      {DateTime? replayAvailabilityStart,
      DateTime? replayAvailabilityEnd,
      bool? replayContainsAdult,
      int? replayMinAge,
      bool? isGoPlayable}) {
    return EventReplayResponse(
        replayAvailabilityStart:
            replayAvailabilityStart ?? this.replayAvailabilityStart,
        replayAvailabilityEnd:
            replayAvailabilityEnd ?? this.replayAvailabilityEnd,
        replayContainsAdult: replayContainsAdult ?? this.replayContainsAdult,
        replayMinAge: replayMinAge ?? this.replayMinAge,
        isGoPlayable: isGoPlayable ?? this.isGoPlayable);
  }

  EventReplayResponse copyWithWrapped(
      {Wrapped<DateTime?>? replayAvailabilityStart,
      Wrapped<DateTime?>? replayAvailabilityEnd,
      Wrapped<bool?>? replayContainsAdult,
      Wrapped<int?>? replayMinAge,
      Wrapped<bool?>? isGoPlayable}) {
    return EventReplayResponse(
        replayAvailabilityStart: (replayAvailabilityStart != null
            ? replayAvailabilityStart.value
            : this.replayAvailabilityStart),
        replayAvailabilityEnd: (replayAvailabilityEnd != null
            ? replayAvailabilityEnd.value
            : this.replayAvailabilityEnd),
        replayContainsAdult: (replayContainsAdult != null
            ? replayContainsAdult.value
            : this.replayContainsAdult),
        replayMinAge:
            (replayMinAge != null ? replayMinAge.value : this.replayMinAge),
        isGoPlayable:
            (isGoPlayable != null ? isGoPlayable.value : this.isGoPlayable));
  }
}

@JsonSerializable(explicitToJson: true)
class ShowPageResponse {
  ShowPageResponse({
    this.id,
    this.title,
    this.genres,
    this.ageRating,
    this.isAdult,
    this.synopsis,
    this.startYear,
    this.endYear,
    this.previews,
  });

  factory ShowPageResponse.fromJson(Map<String, dynamic> json) =>
      _$ShowPageResponseFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'genres', includeIfNull: false, defaultValue: <String>[])
  final List<String>? genres;
  @JsonKey(name: 'ageRating', includeIfNull: false, defaultValue: '')
  final String? ageRating;
  @JsonKey(name: 'isAdult', includeIfNull: false)
  final bool? isAdult;
  @JsonKey(name: 'synopsis', includeIfNull: false, defaultValue: '')
  final String? synopsis;
  @JsonKey(name: 'startYear', includeIfNull: false, defaultValue: '')
  final String? startYear;
  @JsonKey(name: 'endYear', includeIfNull: false, defaultValue: '')
  final String? endYear;
  @JsonKey(name: 'previews', includeIfNull: false, defaultValue: <String>[])
  final List<String>? previews;
  static const fromJsonFactory = _$ShowPageResponseFromJson;
  static const toJsonFactory = _$ShowPageResponseToJson;
  Map<String, dynamic> toJson() => _$ShowPageResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ShowPageResponse &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.genres, genres) ||
                const DeepCollectionEquality().equals(other.genres, genres)) &&
            (identical(other.ageRating, ageRating) ||
                const DeepCollectionEquality()
                    .equals(other.ageRating, ageRating)) &&
            (identical(other.isAdult, isAdult) ||
                const DeepCollectionEquality()
                    .equals(other.isAdult, isAdult)) &&
            (identical(other.synopsis, synopsis) ||
                const DeepCollectionEquality()
                    .equals(other.synopsis, synopsis)) &&
            (identical(other.startYear, startYear) ||
                const DeepCollectionEquality()
                    .equals(other.startYear, startYear)) &&
            (identical(other.endYear, endYear) ||
                const DeepCollectionEquality()
                    .equals(other.endYear, endYear)) &&
            (identical(other.previews, previews) ||
                const DeepCollectionEquality()
                    .equals(other.previews, previews)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(genres) ^
      const DeepCollectionEquality().hash(ageRating) ^
      const DeepCollectionEquality().hash(isAdult) ^
      const DeepCollectionEquality().hash(synopsis) ^
      const DeepCollectionEquality().hash(startYear) ^
      const DeepCollectionEquality().hash(endYear) ^
      const DeepCollectionEquality().hash(previews) ^
      runtimeType.hashCode;
}

extension $ShowPageResponseExtension on ShowPageResponse {
  ShowPageResponse copyWith(
      {String? id,
      String? title,
      List<String>? genres,
      String? ageRating,
      bool? isAdult,
      String? synopsis,
      String? startYear,
      String? endYear,
      List<String>? previews}) {
    return ShowPageResponse(
        id: id ?? this.id,
        title: title ?? this.title,
        genres: genres ?? this.genres,
        ageRating: ageRating ?? this.ageRating,
        isAdult: isAdult ?? this.isAdult,
        synopsis: synopsis ?? this.synopsis,
        startYear: startYear ?? this.startYear,
        endYear: endYear ?? this.endYear,
        previews: previews ?? this.previews);
  }

  ShowPageResponse copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? title,
      Wrapped<List<String>?>? genres,
      Wrapped<String?>? ageRating,
      Wrapped<bool?>? isAdult,
      Wrapped<String?>? synopsis,
      Wrapped<String?>? startYear,
      Wrapped<String?>? endYear,
      Wrapped<List<String>?>? previews}) {
    return ShowPageResponse(
        id: (id != null ? id.value : this.id),
        title: (title != null ? title.value : this.title),
        genres: (genres != null ? genres.value : this.genres),
        ageRating: (ageRating != null ? ageRating.value : this.ageRating),
        isAdult: (isAdult != null ? isAdult.value : this.isAdult),
        synopsis: (synopsis != null ? synopsis.value : this.synopsis),
        startYear: (startYear != null ? startYear.value : this.startYear),
        endYear: (endYear != null ? endYear.value : this.endYear),
        previews: (previews != null ? previews.value : this.previews));
  }
}

@JsonSerializable(explicitToJson: true)
class EpisodePickerResponse {
  EpisodePickerResponse({
    required this.id,
    required this.title,
    this.startYear,
    this.endYear,
    this.genres,
    this.ageRating,
    required this.isAdult,
    this.synopsis,
    this.seasons,
    this.episodes,
    this.specials,
    this.selectedEpisode,
  });

  factory EpisodePickerResponse.fromJson(Map<String, dynamic> json) =>
      _$EpisodePickerResponseFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  @JsonKey(name: 'startYear', includeIfNull: false)
  final int? startYear;
  @JsonKey(name: 'endYear', includeIfNull: false)
  final int? endYear;
  @JsonKey(name: 'genres', includeIfNull: false, defaultValue: <String>[])
  final List<String>? genres;
  @JsonKey(name: 'ageRating', includeIfNull: false, defaultValue: '')
  final String? ageRating;
  @JsonKey(name: 'isAdult', includeIfNull: false)
  final bool isAdult;
  @JsonKey(name: 'synopsis', includeIfNull: false, defaultValue: '')
  final String? synopsis;
  @JsonKey(
      name: 'seasons',
      includeIfNull: false,
      defaultValue: <EpisodePickerSeasonResponse>[])
  final List<EpisodePickerSeasonResponse>? seasons;
  @JsonKey(
      name: 'episodes',
      includeIfNull: false,
      defaultValue: <EpisodePickerEpisodeResponse>[])
  final List<EpisodePickerEpisodeResponse>? episodes;
  @JsonKey(
      name: 'specials',
      includeIfNull: false,
      defaultValue: <EpisodePickerEpisodeResponse>[])
  final List<EpisodePickerEpisodeResponse>? specials;
  @JsonKey(name: 'selectedEpisode', includeIfNull: false, defaultValue: '')
  final String? selectedEpisode;
  static const fromJsonFactory = _$EpisodePickerResponseFromJson;
  static const toJsonFactory = _$EpisodePickerResponseToJson;
  Map<String, dynamic> toJson() => _$EpisodePickerResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EpisodePickerResponse &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.startYear, startYear) ||
                const DeepCollectionEquality()
                    .equals(other.startYear, startYear)) &&
            (identical(other.endYear, endYear) ||
                const DeepCollectionEquality()
                    .equals(other.endYear, endYear)) &&
            (identical(other.genres, genres) ||
                const DeepCollectionEquality().equals(other.genres, genres)) &&
            (identical(other.ageRating, ageRating) ||
                const DeepCollectionEquality()
                    .equals(other.ageRating, ageRating)) &&
            (identical(other.isAdult, isAdult) ||
                const DeepCollectionEquality()
                    .equals(other.isAdult, isAdult)) &&
            (identical(other.synopsis, synopsis) ||
                const DeepCollectionEquality()
                    .equals(other.synopsis, synopsis)) &&
            (identical(other.seasons, seasons) ||
                const DeepCollectionEquality()
                    .equals(other.seasons, seasons)) &&
            (identical(other.episodes, episodes) ||
                const DeepCollectionEquality()
                    .equals(other.episodes, episodes)) &&
            (identical(other.specials, specials) ||
                const DeepCollectionEquality()
                    .equals(other.specials, specials)) &&
            (identical(other.selectedEpisode, selectedEpisode) ||
                const DeepCollectionEquality()
                    .equals(other.selectedEpisode, selectedEpisode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(startYear) ^
      const DeepCollectionEquality().hash(endYear) ^
      const DeepCollectionEquality().hash(genres) ^
      const DeepCollectionEquality().hash(ageRating) ^
      const DeepCollectionEquality().hash(isAdult) ^
      const DeepCollectionEquality().hash(synopsis) ^
      const DeepCollectionEquality().hash(seasons) ^
      const DeepCollectionEquality().hash(episodes) ^
      const DeepCollectionEquality().hash(specials) ^
      const DeepCollectionEquality().hash(selectedEpisode) ^
      runtimeType.hashCode;
}

extension $EpisodePickerResponseExtension on EpisodePickerResponse {
  EpisodePickerResponse copyWith(
      {String? id,
      String? title,
      int? startYear,
      int? endYear,
      List<String>? genres,
      String? ageRating,
      bool? isAdult,
      String? synopsis,
      List<EpisodePickerSeasonResponse>? seasons,
      List<EpisodePickerEpisodeResponse>? episodes,
      List<EpisodePickerEpisodeResponse>? specials,
      String? selectedEpisode}) {
    return EpisodePickerResponse(
        id: id ?? this.id,
        title: title ?? this.title,
        startYear: startYear ?? this.startYear,
        endYear: endYear ?? this.endYear,
        genres: genres ?? this.genres,
        ageRating: ageRating ?? this.ageRating,
        isAdult: isAdult ?? this.isAdult,
        synopsis: synopsis ?? this.synopsis,
        seasons: seasons ?? this.seasons,
        episodes: episodes ?? this.episodes,
        specials: specials ?? this.specials,
        selectedEpisode: selectedEpisode ?? this.selectedEpisode);
  }

  EpisodePickerResponse copyWithWrapped(
      {Wrapped<String>? id,
      Wrapped<String>? title,
      Wrapped<int?>? startYear,
      Wrapped<int?>? endYear,
      Wrapped<List<String>?>? genres,
      Wrapped<String?>? ageRating,
      Wrapped<bool>? isAdult,
      Wrapped<String?>? synopsis,
      Wrapped<List<EpisodePickerSeasonResponse>?>? seasons,
      Wrapped<List<EpisodePickerEpisodeResponse>?>? episodes,
      Wrapped<List<EpisodePickerEpisodeResponse>?>? specials,
      Wrapped<String?>? selectedEpisode}) {
    return EpisodePickerResponse(
        id: (id != null ? id.value : this.id),
        title: (title != null ? title.value : this.title),
        startYear: (startYear != null ? startYear.value : this.startYear),
        endYear: (endYear != null ? endYear.value : this.endYear),
        genres: (genres != null ? genres.value : this.genres),
        ageRating: (ageRating != null ? ageRating.value : this.ageRating),
        isAdult: (isAdult != null ? isAdult.value : this.isAdult),
        synopsis: (synopsis != null ? synopsis.value : this.synopsis),
        seasons: (seasons != null ? seasons.value : this.seasons),
        episodes: (episodes != null ? episodes.value : this.episodes),
        specials: (specials != null ? specials.value : this.specials),
        selectedEpisode: (selectedEpisode != null
            ? selectedEpisode.value
            : this.selectedEpisode));
  }
}

@JsonSerializable(explicitToJson: true)
class EpisodePickerSeasonResponse {
  EpisodePickerSeasonResponse({
    this.episodes,
    required this.season,
    this.synopsis,
    required this.title,
    required this.totalEpisodes,
  });

  factory EpisodePickerSeasonResponse.fromJson(Map<String, dynamic> json) =>
      _$EpisodePickerSeasonResponseFromJson(json);

  @JsonKey(
      name: 'episodes',
      includeIfNull: false,
      defaultValue: <EpisodePickerEpisodeResponse>[])
  final List<EpisodePickerEpisodeResponse>? episodes;
  @JsonKey(name: 'season', includeIfNull: false)
  final int season;
  @JsonKey(name: 'synopsis', includeIfNull: false, defaultValue: '')
  final String? synopsis;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  @JsonKey(name: 'totalEpisodes', includeIfNull: false, defaultValue: '')
  final String totalEpisodes;
  static const fromJsonFactory = _$EpisodePickerSeasonResponseFromJson;
  static const toJsonFactory = _$EpisodePickerSeasonResponseToJson;
  Map<String, dynamic> toJson() => _$EpisodePickerSeasonResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EpisodePickerSeasonResponse &&
            (identical(other.episodes, episodes) ||
                const DeepCollectionEquality()
                    .equals(other.episodes, episodes)) &&
            (identical(other.season, season) ||
                const DeepCollectionEquality().equals(other.season, season)) &&
            (identical(other.synopsis, synopsis) ||
                const DeepCollectionEquality()
                    .equals(other.synopsis, synopsis)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.totalEpisodes, totalEpisodes) ||
                const DeepCollectionEquality()
                    .equals(other.totalEpisodes, totalEpisodes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(episodes) ^
      const DeepCollectionEquality().hash(season) ^
      const DeepCollectionEquality().hash(synopsis) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(totalEpisodes) ^
      runtimeType.hashCode;
}

extension $EpisodePickerSeasonResponseExtension on EpisodePickerSeasonResponse {
  EpisodePickerSeasonResponse copyWith(
      {List<EpisodePickerEpisodeResponse>? episodes,
      int? season,
      String? synopsis,
      String? title,
      String? totalEpisodes}) {
    return EpisodePickerSeasonResponse(
        episodes: episodes ?? this.episodes,
        season: season ?? this.season,
        synopsis: synopsis ?? this.synopsis,
        title: title ?? this.title,
        totalEpisodes: totalEpisodes ?? this.totalEpisodes);
  }

  EpisodePickerSeasonResponse copyWithWrapped(
      {Wrapped<List<EpisodePickerEpisodeResponse>?>? episodes,
      Wrapped<int>? season,
      Wrapped<String?>? synopsis,
      Wrapped<String>? title,
      Wrapped<String>? totalEpisodes}) {
    return EpisodePickerSeasonResponse(
        episodes: (episodes != null ? episodes.value : this.episodes),
        season: (season != null ? season.value : this.season),
        synopsis: (synopsis != null ? synopsis.value : this.synopsis),
        title: (title != null ? title.value : this.title),
        totalEpisodes:
            (totalEpisodes != null ? totalEpisodes.value : this.totalEpisodes));
  }
}

@JsonSerializable(explicitToJson: true)
class EpisodePickerEpisodeResponse {
  EpisodePickerEpisodeResponse({
    required this.id,
    this.episode,
    this.title,
    this.ageRating,
    this.synopsis,
    required this.isAdult,
    this.viewProgress,
    required this.type,
    required this.sourceType,
    required this.source,
  });

  factory EpisodePickerEpisodeResponse.fromJson(Map<String, dynamic> json) =>
      _$EpisodePickerEpisodeResponseFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'episode', includeIfNull: false)
  final int? episode;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'ageRating', includeIfNull: false, defaultValue: '')
  final String? ageRating;
  @JsonKey(name: 'synopsis', includeIfNull: false, defaultValue: '')
  final String? synopsis;
  @JsonKey(name: 'isAdult', includeIfNull: false)
  final bool isAdult;
  @JsonKey(name: 'viewProgress', includeIfNull: false)
  final ViewProgressResponse? viewProgress;
  @JsonKey(
    name: 'type',
    includeIfNull: false,
    toJson: episodePickerEpisodeResponseTypeToJson,
    fromJson: episodePickerEpisodeResponseTypeFromJson,
  )
  final enums.EpisodePickerEpisodeResponseType type;
  @JsonKey(name: 'sourceType', includeIfNull: false)
  final SourceTypeResponse sourceType;
  @JsonKey(name: 'source', includeIfNull: false)
  final LinearSourceResponse source;
  static const fromJsonFactory = _$EpisodePickerEpisodeResponseFromJson;
  static const toJsonFactory = _$EpisodePickerEpisodeResponseToJson;
  Map<String, dynamic> toJson() => _$EpisodePickerEpisodeResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EpisodePickerEpisodeResponse &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.episode, episode) ||
                const DeepCollectionEquality()
                    .equals(other.episode, episode)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.ageRating, ageRating) ||
                const DeepCollectionEquality()
                    .equals(other.ageRating, ageRating)) &&
            (identical(other.synopsis, synopsis) ||
                const DeepCollectionEquality()
                    .equals(other.synopsis, synopsis)) &&
            (identical(other.isAdult, isAdult) ||
                const DeepCollectionEquality()
                    .equals(other.isAdult, isAdult)) &&
            (identical(other.viewProgress, viewProgress) ||
                const DeepCollectionEquality()
                    .equals(other.viewProgress, viewProgress)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.sourceType, sourceType) ||
                const DeepCollectionEquality()
                    .equals(other.sourceType, sourceType)) &&
            (identical(other.source, source) ||
                const DeepCollectionEquality().equals(other.source, source)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(episode) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(ageRating) ^
      const DeepCollectionEquality().hash(synopsis) ^
      const DeepCollectionEquality().hash(isAdult) ^
      const DeepCollectionEquality().hash(viewProgress) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(sourceType) ^
      const DeepCollectionEquality().hash(source) ^
      runtimeType.hashCode;
}

extension $EpisodePickerEpisodeResponseExtension
    on EpisodePickerEpisodeResponse {
  EpisodePickerEpisodeResponse copyWith(
      {String? id,
      int? episode,
      String? title,
      String? ageRating,
      String? synopsis,
      bool? isAdult,
      ViewProgressResponse? viewProgress,
      enums.EpisodePickerEpisodeResponseType? type,
      SourceTypeResponse? sourceType,
      LinearSourceResponse? source}) {
    return EpisodePickerEpisodeResponse(
        id: id ?? this.id,
        episode: episode ?? this.episode,
        title: title ?? this.title,
        ageRating: ageRating ?? this.ageRating,
        synopsis: synopsis ?? this.synopsis,
        isAdult: isAdult ?? this.isAdult,
        viewProgress: viewProgress ?? this.viewProgress,
        type: type ?? this.type,
        sourceType: sourceType ?? this.sourceType,
        source: source ?? this.source);
  }

  EpisodePickerEpisodeResponse copyWithWrapped(
      {Wrapped<String>? id,
      Wrapped<int?>? episode,
      Wrapped<String?>? title,
      Wrapped<String?>? ageRating,
      Wrapped<String?>? synopsis,
      Wrapped<bool>? isAdult,
      Wrapped<ViewProgressResponse?>? viewProgress,
      Wrapped<enums.EpisodePickerEpisodeResponseType>? type,
      Wrapped<SourceTypeResponse>? sourceType,
      Wrapped<LinearSourceResponse>? source}) {
    return EpisodePickerEpisodeResponse(
        id: (id != null ? id.value : this.id),
        episode: (episode != null ? episode.value : this.episode),
        title: (title != null ? title.value : this.title),
        ageRating: (ageRating != null ? ageRating.value : this.ageRating),
        synopsis: (synopsis != null ? synopsis.value : this.synopsis),
        isAdult: (isAdult != null ? isAdult.value : this.isAdult),
        viewProgress:
            (viewProgress != null ? viewProgress.value : this.viewProgress),
        type: (type != null ? type.value : this.type),
        sourceType: (sourceType != null ? sourceType.value : this.sourceType),
        source: (source != null ? source.value : this.source));
  }
}

@JsonSerializable(explicitToJson: true)
class SaaoResponse {
  SaaoResponse({
    this.selectedSources,
    this.sources,
  });

  factory SaaoResponse.fromJson(Map<String, dynamic> json) =>
      _$SaaoResponseFromJson(json);

  @JsonKey(name: 'selectedSources', includeIfNull: false)
  final SaaoSourceResponse? selectedSources;
  @JsonKey(
      name: 'sources',
      includeIfNull: false,
      defaultValue: <SaaoSourceResponse>[])
  final List<SaaoSourceResponse>? sources;
  static const fromJsonFactory = _$SaaoResponseFromJson;
  static const toJsonFactory = _$SaaoResponseToJson;
  Map<String, dynamic> toJson() => _$SaaoResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SaaoResponse &&
            (identical(other.selectedSources, selectedSources) ||
                const DeepCollectionEquality()
                    .equals(other.selectedSources, selectedSources)) &&
            (identical(other.sources, sources) ||
                const DeepCollectionEquality().equals(other.sources, sources)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(selectedSources) ^
      const DeepCollectionEquality().hash(sources) ^
      runtimeType.hashCode;
}

extension $SaaoResponseExtension on SaaoResponse {
  SaaoResponse copyWith(
      {SaaoSourceResponse? selectedSources,
      List<SaaoSourceResponse>? sources}) {
    return SaaoResponse(
        selectedSources: selectedSources ?? this.selectedSources,
        sources: sources ?? this.sources);
  }

  SaaoResponse copyWithWrapped(
      {Wrapped<SaaoSourceResponse?>? selectedSources,
      Wrapped<List<SaaoSourceResponse>?>? sources}) {
    return SaaoResponse(
        selectedSources: (selectedSources != null
            ? selectedSources.value
            : this.selectedSources),
        sources: (sources != null ? sources.value : this.sources));
  }
}

@JsonSerializable(explicitToJson: true)
class SaaoSourceResponse {
  SaaoSourceResponse({
    this.showId,
    this.contentType,
    this.brandingProviderId,
    this.channelId,
    this.seasonList,
    this.episodeCount,
    this.specialsCount,
  });

  factory SaaoSourceResponse.fromJson(Map<String, dynamic> json) =>
      _$SaaoSourceResponseFromJson(json);

  @JsonKey(name: 'showId', includeIfNull: false, defaultValue: '')
  final String? showId;
  @JsonKey(
    name: 'contentType',
    includeIfNull: false,
    toJson: saaoSourceResponseContentTypeToJson,
    fromJson: saaoSourceResponseContentTypeFromJson,
  )
  final enums.SaaoSourceResponseContentType? contentType;
  @JsonKey(name: 'brandingProviderId', includeIfNull: false, defaultValue: '')
  final String? brandingProviderId;
  @JsonKey(name: 'channelId', includeIfNull: false, defaultValue: '')
  final String? channelId;
  @JsonKey(name: 'seasonList', includeIfNull: false, defaultValue: <String>[])
  final List<String>? seasonList;
  @JsonKey(name: 'episodeCount', includeIfNull: false)
  final double? episodeCount;
  @JsonKey(name: 'specialsCount', includeIfNull: false)
  final double? specialsCount;
  static const fromJsonFactory = _$SaaoSourceResponseFromJson;
  static const toJsonFactory = _$SaaoSourceResponseToJson;
  Map<String, dynamic> toJson() => _$SaaoSourceResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SaaoSourceResponse &&
            (identical(other.showId, showId) ||
                const DeepCollectionEquality().equals(other.showId, showId)) &&
            (identical(other.contentType, contentType) ||
                const DeepCollectionEquality()
                    .equals(other.contentType, contentType)) &&
            (identical(other.brandingProviderId, brandingProviderId) ||
                const DeepCollectionEquality()
                    .equals(other.brandingProviderId, brandingProviderId)) &&
            (identical(other.channelId, channelId) ||
                const DeepCollectionEquality()
                    .equals(other.channelId, channelId)) &&
            (identical(other.seasonList, seasonList) ||
                const DeepCollectionEquality()
                    .equals(other.seasonList, seasonList)) &&
            (identical(other.episodeCount, episodeCount) ||
                const DeepCollectionEquality()
                    .equals(other.episodeCount, episodeCount)) &&
            (identical(other.specialsCount, specialsCount) ||
                const DeepCollectionEquality()
                    .equals(other.specialsCount, specialsCount)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(showId) ^
      const DeepCollectionEquality().hash(contentType) ^
      const DeepCollectionEquality().hash(brandingProviderId) ^
      const DeepCollectionEquality().hash(channelId) ^
      const DeepCollectionEquality().hash(seasonList) ^
      const DeepCollectionEquality().hash(episodeCount) ^
      const DeepCollectionEquality().hash(specialsCount) ^
      runtimeType.hashCode;
}

extension $SaaoSourceResponseExtension on SaaoSourceResponse {
  SaaoSourceResponse copyWith(
      {String? showId,
      enums.SaaoSourceResponseContentType? contentType,
      String? brandingProviderId,
      String? channelId,
      List<String>? seasonList,
      double? episodeCount,
      double? specialsCount}) {
    return SaaoSourceResponse(
        showId: showId ?? this.showId,
        contentType: contentType ?? this.contentType,
        brandingProviderId: brandingProviderId ?? this.brandingProviderId,
        channelId: channelId ?? this.channelId,
        seasonList: seasonList ?? this.seasonList,
        episodeCount: episodeCount ?? this.episodeCount,
        specialsCount: specialsCount ?? this.specialsCount);
  }

  SaaoSourceResponse copyWithWrapped(
      {Wrapped<String?>? showId,
      Wrapped<enums.SaaoSourceResponseContentType?>? contentType,
      Wrapped<String?>? brandingProviderId,
      Wrapped<String?>? channelId,
      Wrapped<List<String>?>? seasonList,
      Wrapped<double?>? episodeCount,
      Wrapped<double?>? specialsCount}) {
    return SaaoSourceResponse(
        showId: (showId != null ? showId.value : this.showId),
        contentType:
            (contentType != null ? contentType.value : this.contentType),
        brandingProviderId: (brandingProviderId != null
            ? brandingProviderId.value
            : this.brandingProviderId),
        channelId: (channelId != null ? channelId.value : this.channelId),
        seasonList: (seasonList != null ? seasonList.value : this.seasonList),
        episodeCount:
            (episodeCount != null ? episodeCount.value : this.episodeCount),
        specialsCount:
            (specialsCount != null ? specialsCount.value : this.specialsCount));
  }
}

typedef SearchDetailsResponse$Series = List<SearchDetailsResponse$Series$Item>;

@JsonSerializable(explicitToJson: true)
class SearchDetailsResponse$Series$Item {
  SearchDetailsResponse$Series$Item({
    required this.seriesId,
    required this.episodeCount,
    required this.seasonCount,
    required this.specialsCount,
    required this.channels,
  });

  factory SearchDetailsResponse$Series$Item.fromJson(
          Map<String, dynamic> json) =>
      _$SearchDetailsResponse$Series$ItemFromJson(json);

  @JsonKey(name: 'seriesId', includeIfNull: false, defaultValue: '')
  final String seriesId;
  @JsonKey(name: 'episodeCount', includeIfNull: false)
  final int episodeCount;
  @JsonKey(name: 'seasonCount', includeIfNull: false)
  final int seasonCount;
  @JsonKey(name: 'specialsCount', includeIfNull: false)
  final int specialsCount;
  @JsonKey(name: 'channels', includeIfNull: false, defaultValue: <Object>[])
  final List<Object> channels;
  static const fromJsonFactory = _$SearchDetailsResponse$Series$ItemFromJson;
  static const toJsonFactory = _$SearchDetailsResponse$Series$ItemToJson;
  Map<String, dynamic> toJson() =>
      _$SearchDetailsResponse$Series$ItemToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SearchDetailsResponse$Series$Item &&
            (identical(other.seriesId, seriesId) ||
                const DeepCollectionEquality()
                    .equals(other.seriesId, seriesId)) &&
            (identical(other.episodeCount, episodeCount) ||
                const DeepCollectionEquality()
                    .equals(other.episodeCount, episodeCount)) &&
            (identical(other.seasonCount, seasonCount) ||
                const DeepCollectionEquality()
                    .equals(other.seasonCount, seasonCount)) &&
            (identical(other.specialsCount, specialsCount) ||
                const DeepCollectionEquality()
                    .equals(other.specialsCount, specialsCount)) &&
            (identical(other.channels, channels) ||
                const DeepCollectionEquality()
                    .equals(other.channels, channels)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(seriesId) ^
      const DeepCollectionEquality().hash(episodeCount) ^
      const DeepCollectionEquality().hash(seasonCount) ^
      const DeepCollectionEquality().hash(specialsCount) ^
      const DeepCollectionEquality().hash(channels) ^
      runtimeType.hashCode;
}

extension $SearchDetailsResponse$Series$ItemExtension
    on SearchDetailsResponse$Series$Item {
  SearchDetailsResponse$Series$Item copyWith(
      {String? seriesId,
      int? episodeCount,
      int? seasonCount,
      int? specialsCount,
      List<Object>? channels}) {
    return SearchDetailsResponse$Series$Item(
        seriesId: seriesId ?? this.seriesId,
        episodeCount: episodeCount ?? this.episodeCount,
        seasonCount: seasonCount ?? this.seasonCount,
        specialsCount: specialsCount ?? this.specialsCount,
        channels: channels ?? this.channels);
  }

  SearchDetailsResponse$Series$Item copyWithWrapped(
      {Wrapped<String>? seriesId,
      Wrapped<int>? episodeCount,
      Wrapped<int>? seasonCount,
      Wrapped<int>? specialsCount,
      Wrapped<List<Object>>? channels}) {
    return SearchDetailsResponse$Series$Item(
        seriesId: (seriesId != null ? seriesId.value : this.seriesId),
        episodeCount:
            (episodeCount != null ? episodeCount.value : this.episodeCount),
        seasonCount:
            (seasonCount != null ? seasonCount.value : this.seasonCount),
        specialsCount:
            (specialsCount != null ? specialsCount.value : this.specialsCount),
        channels: (channels != null ? channels.value : this.channels));
  }
}

typedef SearchDetailsResponse$Multisource
    = List<SearchDetailsResponse$Multisource$Item>;

@JsonSerializable(explicitToJson: true)
class SearchDetailsResponse$Multisource$Item {
  SearchDetailsResponse$Multisource$Item({
    required this.id,
    required this.channels,
  });

  factory SearchDetailsResponse$Multisource$Item.fromJson(
          Map<String, dynamic> json) =>
      _$SearchDetailsResponse$Multisource$ItemFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'channels', includeIfNull: false, defaultValue: <Object>[])
  final List<Object> channels;
  static const fromJsonFactory =
      _$SearchDetailsResponse$Multisource$ItemFromJson;
  static const toJsonFactory = _$SearchDetailsResponse$Multisource$ItemToJson;
  Map<String, dynamic> toJson() =>
      _$SearchDetailsResponse$Multisource$ItemToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SearchDetailsResponse$Multisource$Item &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.channels, channels) ||
                const DeepCollectionEquality()
                    .equals(other.channels, channels)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(channels) ^
      runtimeType.hashCode;
}

extension $SearchDetailsResponse$Multisource$ItemExtension
    on SearchDetailsResponse$Multisource$Item {
  SearchDetailsResponse$Multisource$Item copyWith(
      {String? id, List<Object>? channels}) {
    return SearchDetailsResponse$Multisource$Item(
        id: id ?? this.id, channels: channels ?? this.channels);
  }

  SearchDetailsResponse$Multisource$Item copyWithWrapped(
      {Wrapped<String>? id, Wrapped<List<Object>>? channels}) {
    return SearchDetailsResponse$Multisource$Item(
        id: (id != null ? id.value : this.id),
        channels: (channels != null ? channels.value : this.channels));
  }
}

String? mostRelevantEpisodeResponseContentTypeToJson(
    enums.MostRelevantEpisodeResponseContentType?
        mostRelevantEpisodeResponseContentType) {
  return enums.$MostRelevantEpisodeResponseContentTypeMap[
      mostRelevantEpisodeResponseContentType];
}

enums.MostRelevantEpisodeResponseContentType
    mostRelevantEpisodeResponseContentTypeFromJson(
  Object? mostRelevantEpisodeResponseContentType, [
  enums.MostRelevantEpisodeResponseContentType? defaultValue,
]) {
  if (mostRelevantEpisodeResponseContentType is String) {
    return enums.$MostRelevantEpisodeResponseContentTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                mostRelevantEpisodeResponseContentType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.MostRelevantEpisodeResponseContentType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$MostRelevantEpisodeResponseContentTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.MostRelevantEpisodeResponseContentType.swaggerGeneratedUnknown;
}

List<String> mostRelevantEpisodeResponseContentTypeListToJson(
    List<enums.MostRelevantEpisodeResponseContentType>?
        mostRelevantEpisodeResponseContentType) {
  if (mostRelevantEpisodeResponseContentType == null) {
    return [];
  }

  return mostRelevantEpisodeResponseContentType
      .map((e) => enums.$MostRelevantEpisodeResponseContentTypeMap[e]!)
      .toList();
}

List<enums.MostRelevantEpisodeResponseContentType>
    mostRelevantEpisodeResponseContentTypeListFromJson(
  List? mostRelevantEpisodeResponseContentType, [
  List<enums.MostRelevantEpisodeResponseContentType>? defaultValue,
]) {
  if (mostRelevantEpisodeResponseContentType == null) {
    return defaultValue ?? [];
  }

  return mostRelevantEpisodeResponseContentType
      .map((e) => mostRelevantEpisodeResponseContentTypeFromJson(e.toString()))
      .toList();
}

List<enums.MostRelevantEpisodeResponseContentType>?
    mostRelevantEpisodeResponseContentTypeNullableListFromJson(
  List? mostRelevantEpisodeResponseContentType, [
  List<enums.MostRelevantEpisodeResponseContentType>? defaultValue,
]) {
  if (mostRelevantEpisodeResponseContentType == null) {
    return defaultValue;
  }

  return mostRelevantEpisodeResponseContentType
      .map((e) => mostRelevantEpisodeResponseContentTypeFromJson(e.toString()))
      .toList();
}

String? viewProgressResponseViewStateToJson(
    enums.ViewProgressResponseViewState? viewProgressResponseViewState) {
  return enums.$ViewProgressResponseViewStateMap[viewProgressResponseViewState];
}

enums.ViewProgressResponseViewState viewProgressResponseViewStateFromJson(
  Object? viewProgressResponseViewState, [
  enums.ViewProgressResponseViewState? defaultValue,
]) {
  if (viewProgressResponseViewState is String) {
    return enums.$ViewProgressResponseViewStateMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                viewProgressResponseViewState.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ViewProgressResponseViewState.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ViewProgressResponseViewStateMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ViewProgressResponseViewState.swaggerGeneratedUnknown;
}

List<String> viewProgressResponseViewStateListToJson(
    List<enums.ViewProgressResponseViewState>? viewProgressResponseViewState) {
  if (viewProgressResponseViewState == null) {
    return [];
  }

  return viewProgressResponseViewState
      .map((e) => enums.$ViewProgressResponseViewStateMap[e]!)
      .toList();
}

List<enums.ViewProgressResponseViewState>
    viewProgressResponseViewStateListFromJson(
  List? viewProgressResponseViewState, [
  List<enums.ViewProgressResponseViewState>? defaultValue,
]) {
  if (viewProgressResponseViewState == null) {
    return defaultValue ?? [];
  }

  return viewProgressResponseViewState
      .map((e) => viewProgressResponseViewStateFromJson(e.toString()))
      .toList();
}

List<enums.ViewProgressResponseViewState>?
    viewProgressResponseViewStateNullableListFromJson(
  List? viewProgressResponseViewState, [
  List<enums.ViewProgressResponseViewState>? defaultValue,
]) {
  if (viewProgressResponseViewState == null) {
    return defaultValue;
  }

  return viewProgressResponseViewState
      .map((e) => viewProgressResponseViewStateFromJson(e.toString()))
      .toList();
}

String? sourceTypeResponseSourceTypeToJson(
    enums.SourceTypeResponseSourceType? sourceTypeResponseSourceType) {
  return enums.$SourceTypeResponseSourceTypeMap[sourceTypeResponseSourceType];
}

enums.SourceTypeResponseSourceType sourceTypeResponseSourceTypeFromJson(
  Object? sourceTypeResponseSourceType, [
  enums.SourceTypeResponseSourceType? defaultValue,
]) {
  if (sourceTypeResponseSourceType is String) {
    return enums.$SourceTypeResponseSourceTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                sourceTypeResponseSourceType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.SourceTypeResponseSourceType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SourceTypeResponseSourceTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SourceTypeResponseSourceType.swaggerGeneratedUnknown;
}

List<String> sourceTypeResponseSourceTypeListToJson(
    List<enums.SourceTypeResponseSourceType>? sourceTypeResponseSourceType) {
  if (sourceTypeResponseSourceType == null) {
    return [];
  }

  return sourceTypeResponseSourceType
      .map((e) => enums.$SourceTypeResponseSourceTypeMap[e]!)
      .toList();
}

List<enums.SourceTypeResponseSourceType>
    sourceTypeResponseSourceTypeListFromJson(
  List? sourceTypeResponseSourceType, [
  List<enums.SourceTypeResponseSourceType>? defaultValue,
]) {
  if (sourceTypeResponseSourceType == null) {
    return defaultValue ?? [];
  }

  return sourceTypeResponseSourceType
      .map((e) => sourceTypeResponseSourceTypeFromJson(e.toString()))
      .toList();
}

List<enums.SourceTypeResponseSourceType>?
    sourceTypeResponseSourceTypeNullableListFromJson(
  List? sourceTypeResponseSourceType, [
  List<enums.SourceTypeResponseSourceType>? defaultValue,
]) {
  if (sourceTypeResponseSourceType == null) {
    return defaultValue;
  }

  return sourceTypeResponseSourceType
      .map((e) => sourceTypeResponseSourceTypeFromJson(e.toString()))
      .toList();
}

String? episodePickerEpisodeResponseTypeToJson(
    enums.EpisodePickerEpisodeResponseType? episodePickerEpisodeResponseType) {
  return enums
      .$EpisodePickerEpisodeResponseTypeMap[episodePickerEpisodeResponseType];
}

enums.EpisodePickerEpisodeResponseType episodePickerEpisodeResponseTypeFromJson(
  Object? episodePickerEpisodeResponseType, [
  enums.EpisodePickerEpisodeResponseType? defaultValue,
]) {
  if (episodePickerEpisodeResponseType is String) {
    return enums.$EpisodePickerEpisodeResponseTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                episodePickerEpisodeResponseType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.EpisodePickerEpisodeResponseType.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$EpisodePickerEpisodeResponseTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.EpisodePickerEpisodeResponseType.swaggerGeneratedUnknown;
}

List<String> episodePickerEpisodeResponseTypeListToJson(
    List<enums.EpisodePickerEpisodeResponseType>?
        episodePickerEpisodeResponseType) {
  if (episodePickerEpisodeResponseType == null) {
    return [];
  }

  return episodePickerEpisodeResponseType
      .map((e) => enums.$EpisodePickerEpisodeResponseTypeMap[e]!)
      .toList();
}

List<enums.EpisodePickerEpisodeResponseType>
    episodePickerEpisodeResponseTypeListFromJson(
  List? episodePickerEpisodeResponseType, [
  List<enums.EpisodePickerEpisodeResponseType>? defaultValue,
]) {
  if (episodePickerEpisodeResponseType == null) {
    return defaultValue ?? [];
  }

  return episodePickerEpisodeResponseType
      .map((e) => episodePickerEpisodeResponseTypeFromJson(e.toString()))
      .toList();
}

List<enums.EpisodePickerEpisodeResponseType>?
    episodePickerEpisodeResponseTypeNullableListFromJson(
  List? episodePickerEpisodeResponseType, [
  List<enums.EpisodePickerEpisodeResponseType>? defaultValue,
]) {
  if (episodePickerEpisodeResponseType == null) {
    return defaultValue;
  }

  return episodePickerEpisodeResponseType
      .map((e) => episodePickerEpisodeResponseTypeFromJson(e.toString()))
      .toList();
}

String? saaoSourceResponseContentTypeToJson(
    enums.SaaoSourceResponseContentType? saaoSourceResponseContentType) {
  return enums.$SaaoSourceResponseContentTypeMap[saaoSourceResponseContentType];
}

enums.SaaoSourceResponseContentType saaoSourceResponseContentTypeFromJson(
  Object? saaoSourceResponseContentType, [
  enums.SaaoSourceResponseContentType? defaultValue,
]) {
  if (saaoSourceResponseContentType is String) {
    return enums.$SaaoSourceResponseContentTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                saaoSourceResponseContentType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.SaaoSourceResponseContentType.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SaaoSourceResponseContentTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SaaoSourceResponseContentType.swaggerGeneratedUnknown;
}

List<String> saaoSourceResponseContentTypeListToJson(
    List<enums.SaaoSourceResponseContentType>? saaoSourceResponseContentType) {
  if (saaoSourceResponseContentType == null) {
    return [];
  }

  return saaoSourceResponseContentType
      .map((e) => enums.$SaaoSourceResponseContentTypeMap[e]!)
      .toList();
}

List<enums.SaaoSourceResponseContentType>
    saaoSourceResponseContentTypeListFromJson(
  List? saaoSourceResponseContentType, [
  List<enums.SaaoSourceResponseContentType>? defaultValue,
]) {
  if (saaoSourceResponseContentType == null) {
    return defaultValue ?? [];
  }

  return saaoSourceResponseContentType
      .map((e) => saaoSourceResponseContentTypeFromJson(e.toString()))
      .toList();
}

List<enums.SaaoSourceResponseContentType>?
    saaoSourceResponseContentTypeNullableListFromJson(
  List? saaoSourceResponseContentType, [
  List<enums.SaaoSourceResponseContentType>? defaultValue,
]) {
  if (saaoSourceResponseContentType == null) {
    return defaultValue;
  }

  return saaoSourceResponseContentType
      .map((e) => saaoSourceResponseContentTypeFromJson(e.toString()))
      .toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
