import 'package:json_annotation/json_annotation.dart';

enum SourceType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('single')
  single,
  @JsonValue('show')
  show
}

const $SourceTypeMap = {SourceType.single: 'single', SourceType.show: 'show'};

enum ItemType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('single')
  single,
  @JsonValue('season')
  season,
  @JsonValue('show')
  show
}

const $ItemTypeMap = {
  ItemType.single: 'single',
  ItemType.season: 'season',
  ItemType.show: 'show'
};

enum RecordingState {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('planned')
  planned,
  @JsonValue('ongoing')
  ongoing,
  @JsonValue('recorded')
  recorded,
  @JsonValue('failed')
  failed,
  @JsonValue('blackout')
  blackout,
  @JsonValue('partiallyRecorded')
  partiallyrecorded,
  @JsonValue('quotaExceeded')
  quotaexceeded,
  @JsonValue('replaced')
  replaced,
  @JsonValue('cancelled')
  cancelled
}

const $RecordingStateMap = {
  RecordingState.planned: 'planned',
  RecordingState.ongoing: 'ongoing',
  RecordingState.recorded: 'recorded',
  RecordingState.failed: 'failed',
  RecordingState.blackout: 'blackout',
  RecordingState.partiallyrecorded: 'partiallyRecorded',
  RecordingState.quotaexceeded: 'quotaExceeded',
  RecordingState.replaced: 'replaced',
  RecordingState.cancelled: 'cancelled'
};

enum RecordingStatePending {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('planned')
  planned,
  @JsonValue('ongoing')
  ongoing,
  @JsonValue('recorded')
  recorded,
  @JsonValue('failed')
  failed,
  @JsonValue('blackout')
  blackout,
  @JsonValue('partiallyRecorded')
  partiallyrecorded,
  @JsonValue('quotaExceeded')
  quotaexceeded,
  @JsonValue('replaced')
  replaced,
  @JsonValue('bookingPending')
  bookingpending
}

const $RecordingStatePendingMap = {
  RecordingStatePending.planned: 'planned',
  RecordingStatePending.ongoing: 'ongoing',
  RecordingStatePending.recorded: 'recorded',
  RecordingStatePending.failed: 'failed',
  RecordingStatePending.blackout: 'blackout',
  RecordingStatePending.partiallyrecorded: 'partiallyRecorded',
  RecordingStatePending.quotaexceeded: 'quotaExceeded',
  RecordingStatePending.replaced: 'replaced',
  RecordingStatePending.bookingpending: 'bookingPending'
};

enum ViewState {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('notWatched')
  notwatched,
  @JsonValue('partiallyWatched')
  partiallywatched,
  @JsonValue('alreadyWatched')
  alreadywatched
}

const $ViewStateMap = {
  ViewState.notwatched: 'notWatched',
  ViewState.partiallywatched: 'partiallyWatched',
  ViewState.alreadywatched: 'alreadyWatched'
};

enum ImageType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('HighResLandscape')
  highreslandscape,
  @JsonValue('HighResPortrait')
  highresportrait,
  @JsonValue('BoxCover')
  boxcover,
  @JsonValue('TitleTreatment')
  titletreatment,
  @JsonValue('HighResLandscapeProductionStill')
  highreslandscapeproductionstill
}

const $ImageTypeMap = {
  ImageType.highreslandscape: 'HighResLandscape',
  ImageType.highresportrait: 'HighResPortrait',
  ImageType.boxcover: 'BoxCover',
  ImageType.titletreatment: 'TitleTreatment',
  ImageType.highreslandscapeproductionstill: 'HighResLandscapeProductionStill'
};

enum EpisodeImageType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('seasonPoster')
  seasonposter,
  @JsonValue('showPoster')
  showposter,
  @JsonValue('episodePoster')
  episodeposter,
  @JsonValue('eosShowPoster')
  eosshowposter,
  @JsonValue('titleTreatment')
  titletreatment
}

const $EpisodeImageTypeMap = {
  EpisodeImageType.seasonposter: 'seasonPoster',
  EpisodeImageType.showposter: 'showPoster',
  EpisodeImageType.episodeposter: 'episodePoster',
  EpisodeImageType.eosshowposter: 'eosShowPoster',
  EpisodeImageType.titletreatment: 'titleTreatment'
};

enum TileBookingRecordingState {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('planned')
  planned,
  @JsonValue('ongoing')
  ongoing,
  @JsonValue('recorded')
  recorded,
  @JsonValue('failed')
  failed,
  @JsonValue('blackout')
  blackout,
  @JsonValue('partiallyRecorded')
  partiallyrecorded,
  @JsonValue('quotaExceeded')
  quotaexceeded,
  @JsonValue('replaced')
  replaced,
  @JsonValue('cancelled')
  cancelled
}

const $TileBookingRecordingStateMap = {
  TileBookingRecordingState.planned: 'planned',
  TileBookingRecordingState.ongoing: 'ongoing',
  TileBookingRecordingState.recorded: 'recorded',
  TileBookingRecordingState.failed: 'failed',
  TileBookingRecordingState.blackout: 'blackout',
  TileBookingRecordingState.partiallyrecorded: 'partiallyRecorded',
  TileBookingRecordingState.quotaexceeded: 'quotaExceeded',
  TileBookingRecordingState.replaced: 'replaced',
  TileBookingRecordingState.cancelled: 'cancelled'
};

enum TileBookingType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('single')
  single,
  @JsonValue('show')
  show,
  @JsonValue('season')
  season
}

const $TileBookingTypeMap = {
  TileBookingType.single: 'single',
  TileBookingType.show: 'show',
  TileBookingType.season: 'season'
};

enum ContextualRecordingRecordingState {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('planned')
  planned,
  @JsonValue('ongoing')
  ongoing,
  @JsonValue('recorded')
  recorded,
  @JsonValue('failed')
  failed,
  @JsonValue('blackout')
  blackout,
  @JsonValue('partiallyRecorded')
  partiallyrecorded,
  @JsonValue('quotaExceeded')
  quotaexceeded,
  @JsonValue('replaced')
  replaced,
  @JsonValue('cancelled')
  cancelled
}

const $ContextualRecordingRecordingStateMap = {
  ContextualRecordingRecordingState.planned: 'planned',
  ContextualRecordingRecordingState.ongoing: 'ongoing',
  ContextualRecordingRecordingState.recorded: 'recorded',
  ContextualRecordingRecordingState.failed: 'failed',
  ContextualRecordingRecordingState.blackout: 'blackout',
  ContextualRecordingRecordingState.partiallyrecorded: 'partiallyRecorded',
  ContextualRecordingRecordingState.quotaexceeded: 'quotaExceeded',
  ContextualRecordingRecordingState.replaced: 'replaced',
  ContextualRecordingRecordingState.cancelled: 'cancelled'
};

enum ContextualRecordingType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('single')
  single,
  @JsonValue('season')
  season,
  @JsonValue('show')
  show
}

const $ContextualRecordingTypeMap = {
  ContextualRecordingType.single: 'single',
  ContextualRecordingType.season: 'season',
  ContextualRecordingType.show: 'show'
};

enum TileRecordingRecordingState {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('planned')
  planned,
  @JsonValue('ongoing')
  ongoing,
  @JsonValue('recorded')
  recorded,
  @JsonValue('failed')
  failed,
  @JsonValue('blackout')
  blackout,
  @JsonValue('partiallyRecorded')
  partiallyrecorded,
  @JsonValue('quotaExceeded')
  quotaexceeded,
  @JsonValue('replaced')
  replaced,
  @JsonValue('cancelled')
  cancelled
}

const $TileRecordingRecordingStateMap = {
  TileRecordingRecordingState.planned: 'planned',
  TileRecordingRecordingState.ongoing: 'ongoing',
  TileRecordingRecordingState.recorded: 'recorded',
  TileRecordingRecordingState.failed: 'failed',
  TileRecordingRecordingState.blackout: 'blackout',
  TileRecordingRecordingState.partiallyrecorded: 'partiallyRecorded',
  TileRecordingRecordingState.quotaexceeded: 'quotaExceeded',
  TileRecordingRecordingState.replaced: 'replaced',
  TileRecordingRecordingState.cancelled: 'cancelled'
};

enum TileRecordingType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('single')
  single,
  @JsonValue('season')
  season,
  @JsonValue('show')
  show
}

const $TileRecordingTypeMap = {
  TileRecordingType.single: 'single',
  TileRecordingType.season: 'season',
  TileRecordingType.show: 'show'
};

enum RecordingType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('nDVR')
  ndvr,
  @JsonValue('LDVR')
  ldvr
}

const $RecordingTypeMap = {
  RecordingType.ndvr: 'nDVR',
  RecordingType.ldvr: 'LDVR'
};

enum ExpansionType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('fromThisSeason')
  fromthisseason,
  @JsonValue('fromThisEpisode')
  fromthisepisode,
  @JsonValue('wholeShow')
  wholeshow,
  @JsonValue('onlyThisSeason')
  onlythisseason
}

const $ExpansionTypeMap = {
  ExpansionType.fromthisseason: 'fromThisSeason',
  ExpansionType.fromthisepisode: 'fromThisEpisode',
  ExpansionType.wholeshow: 'wholeShow',
  ExpansionType.onlythisseason: 'onlyThisSeason'
};

enum FailureReason {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('USER_ACTION')
  userAction,
  @JsonValue('NOT_IN_REVIEW_BUFFER')
  notInReviewBuffer,
  @JsonValue('DISK_FULL')
  diskFull,
  @JsonValue('NO_ENTITLEMENT')
  noEntitlement,
  @JsonValue('POWER_CUT')
  powerCut,
  @JsonValue('MANUAL_CONFLICT_RESOLUTION')
  manualConflictResolution,
  @JsonValue('AUTO_CONFLICT_RESOLUTION')
  autoConflictResolution,
  @JsonValue('SIGNAL_LOSS')
  signalLoss,
  @JsonValue('EPG_UPDATE')
  epgUpdate,
  @JsonValue('CHANNEL_LINEUP_CHANGE')
  channelLineupChange,
  @JsonValue('INTERNAL_ERROR')
  internalError,
  @JsonValue('CHANNEL_OFF_AIR')
  channelOffAir,
  @JsonValue('QUOTA_EXCEEDED')
  quotaExceeded
}

const $FailureReasonMap = {
  FailureReason.userAction: 'USER_ACTION',
  FailureReason.notInReviewBuffer: 'NOT_IN_REVIEW_BUFFER',
  FailureReason.diskFull: 'DISK_FULL',
  FailureReason.noEntitlement: 'NO_ENTITLEMENT',
  FailureReason.powerCut: 'POWER_CUT',
  FailureReason.manualConflictResolution: 'MANUAL_CONFLICT_RESOLUTION',
  FailureReason.autoConflictResolution: 'AUTO_CONFLICT_RESOLUTION',
  FailureReason.signalLoss: 'SIGNAL_LOSS',
  FailureReason.epgUpdate: 'EPG_UPDATE',
  FailureReason.channelLineupChange: 'CHANNEL_LINEUP_CHANGE',
  FailureReason.internalError: 'INTERNAL_ERROR',
  FailureReason.channelOffAir: 'CHANNEL_OFF_AIR',
  FailureReason.quotaExceeded: 'QUOTA_EXCEEDED'
};
