import 'package:json_annotation/json_annotation.dart';

enum ReplayEventResolution {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('SD')
  sd,
  @JsonValue('HD')
  hd,
  @JsonValue('4K')
  value_4k,
  @JsonValue('5K')
  value_5k,
  @JsonValue('8K')
  value_8k
}

const $ReplayEventResolutionMap = {
  ReplayEventResolution.sd: 'SD',
  ReplayEventResolution.hd: 'HD',
  ReplayEventResolution.value_4k: '4K',
  ReplayEventResolution.value_5k: '5K',
  ReplayEventResolution.value_8k: '8K'
};

enum ReplayEventV2Resolution {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('SD')
  sd,
  @JsonValue('HD')
  hd,
  @JsonValue('4K')
  value_4k,
  @JsonValue('5K')
  value_5k,
  @JsonValue('8K')
  value_8k
}

const $ReplayEventV2ResolutionMap = {
  ReplayEventV2Resolution.sd: 'SD',
  ReplayEventV2Resolution.hd: 'HD',
  ReplayEventV2Resolution.value_4k: '4K',
  ReplayEventV2Resolution.value_5k: '5K',
  ReplayEventV2Resolution.value_8k: '8K'
};

enum LanguagePurpose {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue(1)
  value_1,
  @JsonValue(2)
  value_2,
  @JsonValue(3)
  value_3,
  @JsonValue(4)
  value_4
}

const $LanguagePurposeMap = {
  LanguagePurpose.value_1: 1,
  LanguagePurpose.value_2: 2,
  LanguagePurpose.value_3: 3,
  LanguagePurpose.value_4: 4
};

enum ErrorCode {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('NotFound')
  notfound,
  @JsonValue('InternalServerError')
  internalservererror
}

const $ErrorCodeMap = {
  ErrorCode.notfound: 'NotFound',
  ErrorCode.internalservererror: 'InternalServerError'
};

enum ChannelV1ReplaySources {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('vod')
  vod,
  @JsonValue('app')
  app,
  @JsonValue('cloud')
  cloud
}

const $ChannelV1ReplaySourcesMap = {
  ChannelV1ReplaySources.vod: 'vod',
  ChannelV1ReplaySources.app: 'app',
  ChannelV1ReplaySources.cloud: 'cloud'
};

enum ChannelReplaySources {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('vod')
  vod,
  @JsonValue('app')
  app,
  @JsonValue('cloud')
  cloud
}

const $ChannelReplaySourcesMap = {
  ChannelReplaySources.vod: 'vod',
  ChannelReplaySources.app: 'app',
  ChannelReplaySources.cloud: 'cloud'
};

enum ReplayProductReplayMode {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('EXACT')
  exact,
  @JsonValue('VOSDAL')
  vosdal
}

const $ReplayProductReplayModeMap = {
  ReplayProductReplayMode.exact: 'EXACT',
  ReplayProductReplayMode.vosdal: 'VOSDAL'
};
