import 'package:json_annotation/json_annotation.dart';

enum MemberMemberType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('B2B')
  b2b,
  @JsonValue('B2C')
  b2c
}

const $MemberMemberTypeMap = {
  MemberMemberType.b2b: 'B2B',
  MemberMemberType.b2c: 'B2C'
};

enum MemberSubscriptions {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('WW_SRV_TEL')
  wwSrvTel,
  @JsonValue('WW_SRV_EMA')
  wwSrvEma,
  @JsonValue('WW_SRV_MAI')
  wwSrvMai,
  @JsonValue('IPH_NEWS')
  iphNews,
  @JsonValue('AH_NEWSLET')
  ahNewslet,
  @JsonValue('POST_OPT')
  postOpt,
  @JsonValue('WW_RET2015')
  wwRet2015,
  @JsonValue('AIRM_OPT')
  airmOpt,
  @JsonValue('BOL_OPT')
  bolOpt,
  @JsonValue('GALL_OPT')
  gallOpt,
  @JsonValue('LOYA_OPT')
  loyaOpt,
  @JsonValue('PREDMYLST')
  predmylst,
  @JsonValue('WW_TTR_SMS')
  wwTtrSms,
  @JsonValue('AHBOXEMAIL')
  ahboxemail,
  @JsonValue('WEEKLY')
  weekly,
  @JsonValue('THEME')
  theme,
  @JsonValue('HEALTHYRC')
  healthyrc,
  @JsonValue('PROD_PITCH')
  prodPitch,
  @JsonValue('BABY')
  baby,
  @JsonValue('BEAUTY')
  beauty,
  @JsonValue('HEALTH')
  health,
  @JsonValue('AT_GENERAL')
  atGeneral,
  @JsonValue('ETOS_OPT')
  etosOpt,
  @JsonValue('BEZORGBUNDEL')
  bezorgbundel,
  @JsonValue('NUTRIRECOM')
  nutrirecom,
  @JsonValue('PUSH_BONUS')
  pushBonus,
  @JsonValue('PUSH_IMPORTANT')
  pushImportant,
  @JsonValue('DIGITAL_SAVINGS')
  digitalSavings,
  @JsonValue('PUSH_ORDER_UPDATE')
  pushOrderUpdate,
  @JsonValue('PUSH_ORDER_UPDATE_ESSENTIALS')
  pushOrderUpdateEssentials,
  @JsonValue('PUSH_FAVORITE_SHOP')
  pushFavoriteShop,
  @JsonValue('PUSH_DIGITAL_SAVINGS')
  pushDigitalSavings,
  @JsonValue('PUSH_NEW_FEATURES_FOR_YOU')
  pushNewFeaturesForYou,
  @JsonValue('PUSH_NEW_CHAT_CUSTOMER_SERVICE')
  pushNewChatCustomerService,
  @JsonValue('PUSH_OFFERS')
  pushOffers,
  @JsonValue('PUSH_INSPIRATION')
  pushInspiration,
  @JsonValue('DIGITAL_NON_FOOD')
  digitalNonFood
}

const $MemberSubscriptionsMap = {
  MemberSubscriptions.wwSrvTel: 'WW_SRV_TEL',
  MemberSubscriptions.wwSrvEma: 'WW_SRV_EMA',
  MemberSubscriptions.wwSrvMai: 'WW_SRV_MAI',
  MemberSubscriptions.iphNews: 'IPH_NEWS',
  MemberSubscriptions.ahNewslet: 'AH_NEWSLET',
  MemberSubscriptions.postOpt: 'POST_OPT',
  MemberSubscriptions.wwRet2015: 'WW_RET2015',
  MemberSubscriptions.airmOpt: 'AIRM_OPT',
  MemberSubscriptions.bolOpt: 'BOL_OPT',
  MemberSubscriptions.gallOpt: 'GALL_OPT',
  MemberSubscriptions.loyaOpt: 'LOYA_OPT',
  MemberSubscriptions.predmylst: 'PREDMYLST',
  MemberSubscriptions.wwTtrSms: 'WW_TTR_SMS',
  MemberSubscriptions.ahboxemail: 'AHBOXEMAIL',
  MemberSubscriptions.weekly: 'WEEKLY',
  MemberSubscriptions.theme: 'THEME',
  MemberSubscriptions.healthyrc: 'HEALTHYRC',
  MemberSubscriptions.prodPitch: 'PROD_PITCH',
  MemberSubscriptions.baby: 'BABY',
  MemberSubscriptions.beauty: 'BEAUTY',
  MemberSubscriptions.health: 'HEALTH',
  MemberSubscriptions.atGeneral: 'AT_GENERAL',
  MemberSubscriptions.etosOpt: 'ETOS_OPT',
  MemberSubscriptions.bezorgbundel: 'BEZORGBUNDEL',
  MemberSubscriptions.nutrirecom: 'NUTRIRECOM',
  MemberSubscriptions.pushBonus: 'PUSH_BONUS',
  MemberSubscriptions.pushImportant: 'PUSH_IMPORTANT',
  MemberSubscriptions.digitalSavings: 'DIGITAL_SAVINGS',
  MemberSubscriptions.pushOrderUpdate: 'PUSH_ORDER_UPDATE',
  MemberSubscriptions.pushOrderUpdateEssentials: 'PUSH_ORDER_UPDATE_ESSENTIALS',
  MemberSubscriptions.pushFavoriteShop: 'PUSH_FAVORITE_SHOP',
  MemberSubscriptions.pushDigitalSavings: 'PUSH_DIGITAL_SAVINGS',
  MemberSubscriptions.pushNewFeaturesForYou: 'PUSH_NEW_FEATURES_FOR_YOU',
  MemberSubscriptions.pushNewChatCustomerService:
      'PUSH_NEW_CHAT_CUSTOMER_SERVICE',
  MemberSubscriptions.pushOffers: 'PUSH_OFFERS',
  MemberSubscriptions.pushInspiration: 'PUSH_INSPIRATION',
  MemberSubscriptions.digitalNonFood: 'DIGITAL_NON_FOOD'
};

enum MemberCommandMemberType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('B2B')
  b2b,
  @JsonValue('B2C')
  b2c
}

const $MemberCommandMemberTypeMap = {
  MemberCommandMemberType.b2b: 'B2B',
  MemberCommandMemberType.b2c: 'B2C'
};

enum MembershipBodyMembership {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('MEMBER')
  member,
  @JsonValue('SHOPPINGLIST')
  shoppinglist,
  @JsonValue('FAVOURITE_STORE')
  favouriteStore,
  @JsonValue('COOKBOOK')
  cookbook,
  @JsonValue('SHORTLIST_COLLECTED_RECIPES')
  shortlistCollectedRecipes,
  @JsonValue('WEBSHOP')
  webshop,
  @JsonValue('WEBSHOP_PROSPECT')
  webshopProspect,
  @JsonValue('CHRISTMAS_PACKAGE')
  christmasPackage,
  @JsonValue('HOUSEHOLD_TIPS')
  householdTips,
  @JsonValue('WINE_ONLINE')
  wineOnline,
  @JsonValue('IPHONE')
  iphone,
  @JsonValue('ANDROID')
  android,
  @JsonValue('LOYALTY')
  loyalty,
  @JsonValue('PERSONAL_OFFERS')
  personalOffers,
  @JsonValue('PRIVILEGES')
  privileges,
  @JsonValue('AIRMILES_EXTRA')
  airmilesExtra,
  @JsonValue('VOETBALPLAATJES')
  voetbalplaatjes,
  @JsonValue('CONTEST')
  contest,
  @JsonValue('KEY_SERVICE')
  keyService,
  @JsonValue('SELF_SCAN')
  selfScan,
  @JsonValue('PURCHASES')
  purchases,
  @JsonValue('PREDICT_MY_LIST')
  predictMyList,
  @JsonValue('HEALTHY_RECOMMENDATION')
  healthyRecommendation,
  @JsonValue('INTERESTS')
  interests,
  @JsonValue('HIKU')
  hiku,
  @JsonValue('NUTRIENT_RECOMMENDATIONS')
  nutrientRecommendations,
  @JsonValue('PREF_ETOS')
  prefEtos,
  @JsonValue('BDAYOFF_ETOS')
  bdayoffEtos,
  @JsonValue('CHILD_ETOS')
  childEtos,
  @JsonValue('PREGN_ETOS')
  pregnEtos,
  @JsonValue('POST_ETOS')
  postEtos,
  @JsonValue('BIERSHOP')
  biershop,
  @JsonValue('DIGITAL_SAVINGS')
  digitalSavings,
  @JsonValue('BEZORGBUNDEL')
  bezorgbundel,
  @JsonValue('PURCHASE_STAMPS_OPT')
  purchaseStampsOpt,
  @JsonValue('PURCHASE_STAMPS_ON')
  purchaseStampsOn,
  @JsonValue('SHOPPINGLIST_BE')
  shoppinglistBe
}

const $MembershipBodyMembershipMap = {
  MembershipBodyMembership.member: 'MEMBER',
  MembershipBodyMembership.shoppinglist: 'SHOPPINGLIST',
  MembershipBodyMembership.favouriteStore: 'FAVOURITE_STORE',
  MembershipBodyMembership.cookbook: 'COOKBOOK',
  MembershipBodyMembership.shortlistCollectedRecipes:
      'SHORTLIST_COLLECTED_RECIPES',
  MembershipBodyMembership.webshop: 'WEBSHOP',
  MembershipBodyMembership.webshopProspect: 'WEBSHOP_PROSPECT',
  MembershipBodyMembership.christmasPackage: 'CHRISTMAS_PACKAGE',
  MembershipBodyMembership.householdTips: 'HOUSEHOLD_TIPS',
  MembershipBodyMembership.wineOnline: 'WINE_ONLINE',
  MembershipBodyMembership.iphone: 'IPHONE',
  MembershipBodyMembership.android: 'ANDROID',
  MembershipBodyMembership.loyalty: 'LOYALTY',
  MembershipBodyMembership.personalOffers: 'PERSONAL_OFFERS',
  MembershipBodyMembership.privileges: 'PRIVILEGES',
  MembershipBodyMembership.airmilesExtra: 'AIRMILES_EXTRA',
  MembershipBodyMembership.voetbalplaatjes: 'VOETBALPLAATJES',
  MembershipBodyMembership.contest: 'CONTEST',
  MembershipBodyMembership.keyService: 'KEY_SERVICE',
  MembershipBodyMembership.selfScan: 'SELF_SCAN',
  MembershipBodyMembership.purchases: 'PURCHASES',
  MembershipBodyMembership.predictMyList: 'PREDICT_MY_LIST',
  MembershipBodyMembership.healthyRecommendation: 'HEALTHY_RECOMMENDATION',
  MembershipBodyMembership.interests: 'INTERESTS',
  MembershipBodyMembership.hiku: 'HIKU',
  MembershipBodyMembership.nutrientRecommendations: 'NUTRIENT_RECOMMENDATIONS',
  MembershipBodyMembership.prefEtos: 'PREF_ETOS',
  MembershipBodyMembership.bdayoffEtos: 'BDAYOFF_ETOS',
  MembershipBodyMembership.childEtos: 'CHILD_ETOS',
  MembershipBodyMembership.pregnEtos: 'PREGN_ETOS',
  MembershipBodyMembership.postEtos: 'POST_ETOS',
  MembershipBodyMembership.biershop: 'BIERSHOP',
  MembershipBodyMembership.digitalSavings: 'DIGITAL_SAVINGS',
  MembershipBodyMembership.bezorgbundel: 'BEZORGBUNDEL',
  MembershipBodyMembership.purchaseStampsOpt: 'PURCHASE_STAMPS_OPT',
  MembershipBodyMembership.purchaseStampsOn: 'PURCHASE_STAMPS_ON',
  MembershipBodyMembership.shoppinglistBe: 'SHOPPINGLIST_BE'
};

enum MembershipCommandType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('MEMBER')
  member,
  @JsonValue('SHOPPINGLIST')
  shoppinglist,
  @JsonValue('FAVOURITE_STORE')
  favouriteStore,
  @JsonValue('COOKBOOK')
  cookbook,
  @JsonValue('SHORTLIST_COLLECTED_RECIPES')
  shortlistCollectedRecipes,
  @JsonValue('WEBSHOP')
  webshop,
  @JsonValue('WEBSHOP_PROSPECT')
  webshopProspect,
  @JsonValue('CHRISTMAS_PACKAGE')
  christmasPackage,
  @JsonValue('HOUSEHOLD_TIPS')
  householdTips,
  @JsonValue('WINE_ONLINE')
  wineOnline,
  @JsonValue('IPHONE')
  iphone,
  @JsonValue('ANDROID')
  android,
  @JsonValue('LOYALTY')
  loyalty,
  @JsonValue('PERSONAL_OFFERS')
  personalOffers,
  @JsonValue('PRIVILEGES')
  privileges,
  @JsonValue('AIRMILES_EXTRA')
  airmilesExtra,
  @JsonValue('VOETBALPLAATJES')
  voetbalplaatjes,
  @JsonValue('CONTEST')
  contest,
  @JsonValue('KEY_SERVICE')
  keyService,
  @JsonValue('SELF_SCAN')
  selfScan,
  @JsonValue('PURCHASES')
  purchases,
  @JsonValue('PREDICT_MY_LIST')
  predictMyList,
  @JsonValue('HEALTHY_RECOMMENDATION')
  healthyRecommendation,
  @JsonValue('INTERESTS')
  interests,
  @JsonValue('HIKU')
  hiku,
  @JsonValue('NUTRIENT_RECOMMENDATIONS')
  nutrientRecommendations,
  @JsonValue('PREF_ETOS')
  prefEtos,
  @JsonValue('BDAYOFF_ETOS')
  bdayoffEtos,
  @JsonValue('CHILD_ETOS')
  childEtos,
  @JsonValue('PREGN_ETOS')
  pregnEtos,
  @JsonValue('POST_ETOS')
  postEtos,
  @JsonValue('BIERSHOP')
  biershop,
  @JsonValue('DIGITAL_SAVINGS')
  digitalSavings,
  @JsonValue('BEZORGBUNDEL')
  bezorgbundel,
  @JsonValue('PURCHASE_STAMPS_OPT')
  purchaseStampsOpt,
  @JsonValue('PURCHASE_STAMPS_ON')
  purchaseStampsOn,
  @JsonValue('SHOPPINGLIST_BE')
  shoppinglistBe
}

const $MembershipCommandTypeMap = {
  MembershipCommandType.member: 'MEMBER',
  MembershipCommandType.shoppinglist: 'SHOPPINGLIST',
  MembershipCommandType.favouriteStore: 'FAVOURITE_STORE',
  MembershipCommandType.cookbook: 'COOKBOOK',
  MembershipCommandType.shortlistCollectedRecipes:
      'SHORTLIST_COLLECTED_RECIPES',
  MembershipCommandType.webshop: 'WEBSHOP',
  MembershipCommandType.webshopProspect: 'WEBSHOP_PROSPECT',
  MembershipCommandType.christmasPackage: 'CHRISTMAS_PACKAGE',
  MembershipCommandType.householdTips: 'HOUSEHOLD_TIPS',
  MembershipCommandType.wineOnline: 'WINE_ONLINE',
  MembershipCommandType.iphone: 'IPHONE',
  MembershipCommandType.android: 'ANDROID',
  MembershipCommandType.loyalty: 'LOYALTY',
  MembershipCommandType.personalOffers: 'PERSONAL_OFFERS',
  MembershipCommandType.privileges: 'PRIVILEGES',
  MembershipCommandType.airmilesExtra: 'AIRMILES_EXTRA',
  MembershipCommandType.voetbalplaatjes: 'VOETBALPLAATJES',
  MembershipCommandType.contest: 'CONTEST',
  MembershipCommandType.keyService: 'KEY_SERVICE',
  MembershipCommandType.selfScan: 'SELF_SCAN',
  MembershipCommandType.purchases: 'PURCHASES',
  MembershipCommandType.predictMyList: 'PREDICT_MY_LIST',
  MembershipCommandType.healthyRecommendation: 'HEALTHY_RECOMMENDATION',
  MembershipCommandType.interests: 'INTERESTS',
  MembershipCommandType.hiku: 'HIKU',
  MembershipCommandType.nutrientRecommendations: 'NUTRIENT_RECOMMENDATIONS',
  MembershipCommandType.prefEtos: 'PREF_ETOS',
  MembershipCommandType.bdayoffEtos: 'BDAYOFF_ETOS',
  MembershipCommandType.childEtos: 'CHILD_ETOS',
  MembershipCommandType.pregnEtos: 'PREGN_ETOS',
  MembershipCommandType.postEtos: 'POST_ETOS',
  MembershipCommandType.biershop: 'BIERSHOP',
  MembershipCommandType.digitalSavings: 'DIGITAL_SAVINGS',
  MembershipCommandType.bezorgbundel: 'BEZORGBUNDEL',
  MembershipCommandType.purchaseStampsOpt: 'PURCHASE_STAMPS_OPT',
  MembershipCommandType.purchaseStampsOn: 'PURCHASE_STAMPS_ON',
  MembershipCommandType.shoppinglistBe: 'SHOPPINGLIST_BE'
};

enum ModelAndViewStatus {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('100 CONTINUE')
  value_100Continue,
  @JsonValue('101 SWITCHING_PROTOCOLS')
  value_101SwitchingProtocols,
  @JsonValue('102 PROCESSING')
  value_102Processing,
  @JsonValue('103 CHECKPOINT')
  value_103Checkpoint,
  @JsonValue('200 OK')
  value_200Ok,
  @JsonValue('201 CREATED')
  value_201Created,
  @JsonValue('202 ACCEPTED')
  value_202Accepted,
  @JsonValue('203 NON_AUTHORITATIVE_INFORMATION')
  value_203NonAuthoritativeInformation,
  @JsonValue('204 NO_CONTENT')
  value_204NoContent,
  @JsonValue('205 RESET_CONTENT')
  value_205ResetContent,
  @JsonValue('206 PARTIAL_CONTENT')
  value_206PartialContent,
  @JsonValue('207 MULTI_STATUS')
  value_207MultiStatus,
  @JsonValue('208 ALREADY_REPORTED')
  value_208AlreadyReported,
  @JsonValue('226 IM_USED')
  value_226ImUsed,
  @JsonValue('300 MULTIPLE_CHOICES')
  value_300MultipleChoices,
  @JsonValue('301 MOVED_PERMANENTLY')
  value_301MovedPermanently,
  @JsonValue('302 FOUND')
  value_302Found,
  @JsonValue('302 MOVED_TEMPORARILY')
  value_302MovedTemporarily,
  @JsonValue('303 SEE_OTHER')
  value_303SeeOther,
  @JsonValue('304 NOT_MODIFIED')
  value_304NotModified,
  @JsonValue('305 USE_PROXY')
  value_305UseProxy,
  @JsonValue('307 TEMPORARY_REDIRECT')
  value_307TemporaryRedirect,
  @JsonValue('308 PERMANENT_REDIRECT')
  value_308PermanentRedirect,
  @JsonValue('400 BAD_REQUEST')
  value_400BadRequest,
  @JsonValue('401 UNAUTHORIZED')
  value_401Unauthorized,
  @JsonValue('402 PAYMENT_REQUIRED')
  value_402PaymentRequired,
  @JsonValue('403 FORBIDDEN')
  value_403Forbidden,
  @JsonValue('404 NOT_FOUND')
  value_404NotFound,
  @JsonValue('405 METHOD_NOT_ALLOWED')
  value_405MethodNotAllowed,
  @JsonValue('406 NOT_ACCEPTABLE')
  value_406NotAcceptable,
  @JsonValue('407 PROXY_AUTHENTICATION_REQUIRED')
  value_407ProxyAuthenticationRequired,
  @JsonValue('408 REQUEST_TIMEOUT')
  value_408RequestTimeout,
  @JsonValue('409 CONFLICT')
  value_409Conflict,
  @JsonValue('410 GONE')
  value_410Gone,
  @JsonValue('411 LENGTH_REQUIRED')
  value_411LengthRequired,
  @JsonValue('412 PRECONDITION_FAILED')
  value_412PreconditionFailed,
  @JsonValue('413 PAYLOAD_TOO_LARGE')
  value_413PayloadTooLarge,
  @JsonValue('413 REQUEST_ENTITY_TOO_LARGE')
  value_413RequestEntityTooLarge,
  @JsonValue('414 URI_TOO_LONG')
  value_414UriTooLong,
  @JsonValue('414 REQUEST_URI_TOO_LONG')
  value_414RequestUriTooLong,
  @JsonValue('415 UNSUPPORTED_MEDIA_TYPE')
  value_415UnsupportedMediaType,
  @JsonValue('416 REQUESTED_RANGE_NOT_SATISFIABLE')
  value_416RequestedRangeNotSatisfiable,
  @JsonValue('417 EXPECTATION_FAILED')
  value_417ExpectationFailed,
  @JsonValue('418 I_AM_A_TEAPOT')
  value_418IAmATeapot,
  @JsonValue('419 INSUFFICIENT_SPACE_ON_RESOURCE')
  value_419InsufficientSpaceOnResource,
  @JsonValue('420 METHOD_FAILURE')
  value_420MethodFailure,
  @JsonValue('421 DESTINATION_LOCKED')
  value_421DestinationLocked,
  @JsonValue('422 UNPROCESSABLE_ENTITY')
  value_422UnprocessableEntity,
  @JsonValue('423 LOCKED')
  value_423Locked,
  @JsonValue('424 FAILED_DEPENDENCY')
  value_424FailedDependency,
  @JsonValue('426 UPGRADE_REQUIRED')
  value_426UpgradeRequired,
  @JsonValue('428 PRECONDITION_REQUIRED')
  value_428PreconditionRequired,
  @JsonValue('429 TOO_MANY_REQUESTS')
  value_429TooManyRequests,
  @JsonValue('431 REQUEST_HEADER_FIELDS_TOO_LARGE')
  value_431RequestHeaderFieldsTooLarge,
  @JsonValue('451 UNAVAILABLE_FOR_LEGAL_REASONS')
  value_451UnavailableForLegalReasons,
  @JsonValue('500 INTERNAL_SERVER_ERROR')
  value_500InternalServerError,
  @JsonValue('501 NOT_IMPLEMENTED')
  value_501NotImplemented,
  @JsonValue('502 BAD_GATEWAY')
  value_502BadGateway,
  @JsonValue('503 SERVICE_UNAVAILABLE')
  value_503ServiceUnavailable,
  @JsonValue('504 GATEWAY_TIMEOUT')
  value_504GatewayTimeout,
  @JsonValue('505 HTTP_VERSION_NOT_SUPPORTED')
  value_505HttpVersionNotSupported,
  @JsonValue('506 VARIANT_ALSO_NEGOTIATES')
  value_506VariantAlsoNegotiates,
  @JsonValue('507 INSUFFICIENT_STORAGE')
  value_507InsufficientStorage,
  @JsonValue('508 LOOP_DETECTED')
  value_508LoopDetected,
  @JsonValue('509 BANDWIDTH_LIMIT_EXCEEDED')
  value_509BandwidthLimitExceeded,
  @JsonValue('510 NOT_EXTENDED')
  value_510NotExtended,
  @JsonValue('511 NETWORK_AUTHENTICATION_REQUIRED')
  value_511NetworkAuthenticationRequired
}

const $ModelAndViewStatusMap = {
  ModelAndViewStatus.value_100Continue: '100 CONTINUE',
  ModelAndViewStatus.value_101SwitchingProtocols: '101 SWITCHING_PROTOCOLS',
  ModelAndViewStatus.value_102Processing: '102 PROCESSING',
  ModelAndViewStatus.value_103Checkpoint: '103 CHECKPOINT',
  ModelAndViewStatus.value_200Ok: '200 OK',
  ModelAndViewStatus.value_201Created: '201 CREATED',
  ModelAndViewStatus.value_202Accepted: '202 ACCEPTED',
  ModelAndViewStatus.value_203NonAuthoritativeInformation:
      '203 NON_AUTHORITATIVE_INFORMATION',
  ModelAndViewStatus.value_204NoContent: '204 NO_CONTENT',
  ModelAndViewStatus.value_205ResetContent: '205 RESET_CONTENT',
  ModelAndViewStatus.value_206PartialContent: '206 PARTIAL_CONTENT',
  ModelAndViewStatus.value_207MultiStatus: '207 MULTI_STATUS',
  ModelAndViewStatus.value_208AlreadyReported: '208 ALREADY_REPORTED',
  ModelAndViewStatus.value_226ImUsed: '226 IM_USED',
  ModelAndViewStatus.value_300MultipleChoices: '300 MULTIPLE_CHOICES',
  ModelAndViewStatus.value_301MovedPermanently: '301 MOVED_PERMANENTLY',
  ModelAndViewStatus.value_302Found: '302 FOUND',
  ModelAndViewStatus.value_302MovedTemporarily: '302 MOVED_TEMPORARILY',
  ModelAndViewStatus.value_303SeeOther: '303 SEE_OTHER',
  ModelAndViewStatus.value_304NotModified: '304 NOT_MODIFIED',
  ModelAndViewStatus.value_305UseProxy: '305 USE_PROXY',
  ModelAndViewStatus.value_307TemporaryRedirect: '307 TEMPORARY_REDIRECT',
  ModelAndViewStatus.value_308PermanentRedirect: '308 PERMANENT_REDIRECT',
  ModelAndViewStatus.value_400BadRequest: '400 BAD_REQUEST',
  ModelAndViewStatus.value_401Unauthorized: '401 UNAUTHORIZED',
  ModelAndViewStatus.value_402PaymentRequired: '402 PAYMENT_REQUIRED',
  ModelAndViewStatus.value_403Forbidden: '403 FORBIDDEN',
  ModelAndViewStatus.value_404NotFound: '404 NOT_FOUND',
  ModelAndViewStatus.value_405MethodNotAllowed: '405 METHOD_NOT_ALLOWED',
  ModelAndViewStatus.value_406NotAcceptable: '406 NOT_ACCEPTABLE',
  ModelAndViewStatus.value_407ProxyAuthenticationRequired:
      '407 PROXY_AUTHENTICATION_REQUIRED',
  ModelAndViewStatus.value_408RequestTimeout: '408 REQUEST_TIMEOUT',
  ModelAndViewStatus.value_409Conflict: '409 CONFLICT',
  ModelAndViewStatus.value_410Gone: '410 GONE',
  ModelAndViewStatus.value_411LengthRequired: '411 LENGTH_REQUIRED',
  ModelAndViewStatus.value_412PreconditionFailed: '412 PRECONDITION_FAILED',
  ModelAndViewStatus.value_413PayloadTooLarge: '413 PAYLOAD_TOO_LARGE',
  ModelAndViewStatus.value_413RequestEntityTooLarge:
      '413 REQUEST_ENTITY_TOO_LARGE',
  ModelAndViewStatus.value_414UriTooLong: '414 URI_TOO_LONG',
  ModelAndViewStatus.value_414RequestUriTooLong: '414 REQUEST_URI_TOO_LONG',
  ModelAndViewStatus.value_415UnsupportedMediaType:
      '415 UNSUPPORTED_MEDIA_TYPE',
  ModelAndViewStatus.value_416RequestedRangeNotSatisfiable:
      '416 REQUESTED_RANGE_NOT_SATISFIABLE',
  ModelAndViewStatus.value_417ExpectationFailed: '417 EXPECTATION_FAILED',
  ModelAndViewStatus.value_418IAmATeapot: '418 I_AM_A_TEAPOT',
  ModelAndViewStatus.value_419InsufficientSpaceOnResource:
      '419 INSUFFICIENT_SPACE_ON_RESOURCE',
  ModelAndViewStatus.value_420MethodFailure: '420 METHOD_FAILURE',
  ModelAndViewStatus.value_421DestinationLocked: '421 DESTINATION_LOCKED',
  ModelAndViewStatus.value_422UnprocessableEntity: '422 UNPROCESSABLE_ENTITY',
  ModelAndViewStatus.value_423Locked: '423 LOCKED',
  ModelAndViewStatus.value_424FailedDependency: '424 FAILED_DEPENDENCY',
  ModelAndViewStatus.value_426UpgradeRequired: '426 UPGRADE_REQUIRED',
  ModelAndViewStatus.value_428PreconditionRequired: '428 PRECONDITION_REQUIRED',
  ModelAndViewStatus.value_429TooManyRequests: '429 TOO_MANY_REQUESTS',
  ModelAndViewStatus.value_431RequestHeaderFieldsTooLarge:
      '431 REQUEST_HEADER_FIELDS_TOO_LARGE',
  ModelAndViewStatus.value_451UnavailableForLegalReasons:
      '451 UNAVAILABLE_FOR_LEGAL_REASONS',
  ModelAndViewStatus.value_500InternalServerError: '500 INTERNAL_SERVER_ERROR',
  ModelAndViewStatus.value_501NotImplemented: '501 NOT_IMPLEMENTED',
  ModelAndViewStatus.value_502BadGateway: '502 BAD_GATEWAY',
  ModelAndViewStatus.value_503ServiceUnavailable: '503 SERVICE_UNAVAILABLE',
  ModelAndViewStatus.value_504GatewayTimeout: '504 GATEWAY_TIMEOUT',
  ModelAndViewStatus.value_505HttpVersionNotSupported:
      '505 HTTP_VERSION_NOT_SUPPORTED',
  ModelAndViewStatus.value_506VariantAlsoNegotiates:
      '506 VARIANT_ALSO_NEGOTIATES',
  ModelAndViewStatus.value_507InsufficientStorage: '507 INSUFFICIENT_STORAGE',
  ModelAndViewStatus.value_508LoopDetected: '508 LOOP_DETECTED',
  ModelAndViewStatus.value_509BandwidthLimitExceeded:
      '509 BANDWIDTH_LIMIT_EXCEEDED',
  ModelAndViewStatus.value_510NotExtended: '510 NOT_EXTENDED',
  ModelAndViewStatus.value_511NetworkAuthenticationRequired:
      '511 NETWORK_AUTHENTICATION_REQUIRED'
};
