// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'member_remote_data_source.enums.swagger.dart' as enums;
export 'member_remote_data_source.enums.swagger.dart';

part 'member_remote_data_source.swagger.chopper.dart';
part 'member_remote_data_source.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class MemberRemoteDataSource extends ChopperService {
  static MemberRemoteDataSource create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$MemberRemoteDataSource(client);
    }

    final newClient = ChopperClient(
        services: [_$MemberRemoteDataSource()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl:
            baseUrl ?? 'http://appie-member-bff.ah-tst.k8s.digitaldev.nl/');
    return _$MemberRemoteDataSource(newClient);
  }

  ///errorHtml
  Future<chopper.Response<ModelAndView>> errorGet({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ModelAndView, () => ModelAndView.fromJsonFactory);

    return _errorGet(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///errorHtml
  @Get(path: '/error')
  Future<chopper.Response<ModelAndView>> _errorGet({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///errorHtml
  Future<chopper.Response<ModelAndView>> errorHead({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ModelAndView, () => ModelAndView.fromJsonFactory);

    return _errorHead(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///errorHtml
  @Head(path: '/error')
  Future<chopper.Response<ModelAndView>> _errorHead({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///errorHtml
  Future<chopper.Response<ModelAndView>> errorPost({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ModelAndView, () => ModelAndView.fromJsonFactory);

    return _errorPost(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///errorHtml
  @Post(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<ModelAndView>> _errorPost({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///errorHtml
  Future<chopper.Response<ModelAndView>> errorPut({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ModelAndView, () => ModelAndView.fromJsonFactory);

    return _errorPut(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///errorHtml
  @Put(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<ModelAndView>> _errorPut({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///errorHtml
  Future<chopper.Response<ModelAndView>> errorDelete({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ModelAndView, () => ModelAndView.fromJsonFactory);

    return _errorDelete(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///errorHtml
  @Delete(path: '/error')
  Future<chopper.Response<ModelAndView>> _errorDelete({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///errorHtml
  Future<chopper.Response<ModelAndView>> errorPatch({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ModelAndView, () => ModelAndView.fromJsonFactory);

    return _errorPatch(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///errorHtml
  @Patch(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<ModelAndView>> _errorPatch({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Member
  Future<chopper.Response<MemberCommand>> memberV1MemberGet({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        MemberCommand, () => MemberCommand.fromJsonFactory);

    return _memberV1MemberGet(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///Member
  @Get(path: '/member/v1/member')
  Future<chopper.Response<MemberCommand>> _memberV1MemberGet({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Member
  ///@param member member
  Future<chopper.Response<MemberCommand>> memberV1MemberPost({
    MemberCommand? member,
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        MemberCommand, () => MemberCommand.fromJsonFactory);

    return _memberV1MemberPost(
        member: member,
        xAuthorization: xAuthorization,
        cacheControl: cacheControl);
  }

  ///Member
  ///@param member member
  @Post(path: '/member/v1/member')
  Future<chopper.Response<MemberCommand>> _memberV1MemberPost({
    @Body() MemberCommand? member,
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///membershipType
  ///@param membershipBody only valid membership are 'NUTRIENT_RECOMMENDATIONS', 'DIGITALSAV'
  Future<chopper.Response<String>> memberV1MemberAddMembershipPost({
    MembershipBody? membershipBody,
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        MembershipBody, () => MembershipBody.fromJsonFactory);

    return _memberV1MemberAddMembershipPost(
        membershipBody: membershipBody,
        xAuthorization: xAuthorization,
        cacheControl: cacheControl);
  }

  ///membershipType
  ///@param membershipBody only valid membership are 'NUTRIENT_RECOMMENDATIONS', 'DIGITALSAV'
  @Post(path: '/member/v1/member/add-membership')
  Future<chopper.Response<String>> _memberV1MemberAddMembershipPost({
    @Body() MembershipBody? membershipBody,
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///membershipType
  ///@param membership only valid membership are 'NUTRIENT_RECOMMENDATIONS', 'DIGITAL_SAVINGS'
  Future<chopper.Response<String>>
      memberV1MemberDeleteMembershipMembershipDelete({
    String? membership,
    String? xAuthorization,
    String? cacheControl,
  }) {
    return _memberV1MemberDeleteMembershipMembershipDelete(
        membership: membership,
        xAuthorization: xAuthorization,
        cacheControl: cacheControl);
  }

  ///membershipType
  ///@param membership only valid membership are 'NUTRIENT_RECOMMENDATIONS', 'DIGITAL_SAVINGS'
  @Delete(path: '/member/v1/member/delete-membership/{membership}')
  Future<chopper.Response<String>>
      _memberV1MemberDeleteMembershipMembershipDelete({
    @Path('membership') String? membership,
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Member
  ///@param member member
  Future<chopper.Response<MemberCommand>> memberV2MemberPost({
    MemberCommand? member,
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        MemberCommand, () => MemberCommand.fromJsonFactory);

    return _memberV2MemberPost(
        member: member,
        xAuthorization: xAuthorization,
        cacheControl: cacheControl);
  }

  ///Member
  ///@param member member
  @Post(path: '/member/v2/member')
  Future<chopper.Response<MemberCommand>> _memberV2MemberPost({
    @Body() MemberCommand? member,
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Member
  Future<chopper.Response<Member>> memberV3MemberGet({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Member, () => Member.fromJsonFactory);

    return _memberV3MemberGet(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///Member
  @Get(path: '/member/v3/member')
  Future<chopper.Response<Member>> _memberV3MemberGet({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Member
  ///@param cardInfo cardInfo
  Future<chopper.Response<MemberWithIdOnly>> memberV3MembersPost({
    MemberByBonusCardRequest? cardInfo,
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(MemberByBonusCardRequest,
        () => MemberByBonusCardRequest.fromJsonFactory);
    generatedMapping.putIfAbsent(
        MemberWithIdOnly, () => MemberWithIdOnly.fromJsonFactory);

    return _memberV3MembersPost(
        cardInfo: cardInfo,
        xAuthorization: xAuthorization,
        cacheControl: cacheControl);
  }

  ///Member
  ///@param cardInfo cardInfo
  @Post(path: '/member/v3/members')
  Future<chopper.Response<MemberWithIdOnly>> _memberV3MembersPost({
    @Body() MemberByBonusCardRequest? cardInfo,
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///membershipCode
  ///@param membership membership
  Future<chopper.Response<String>> memberV3MembershipPost({
    required String? membership,
    String? xAuthorization,
    String? cacheControl,
  }) {
    return _memberV3MembershipPost(
        membership: membership,
        xAuthorization: xAuthorization,
        cacheControl: cacheControl);
  }

  ///membershipCode
  ///@param membership membership
  @Post(
    path: '/member/v3/membership',
    optionalBody: true,
  )
  Future<chopper.Response<String>> _memberV3MembershipPost({
    @Query('membership') required String? membership,
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///membershipCode
  ///@param membership membership
  Future<chopper.Response<String>> memberV3MembershipDelete({
    required String? membership,
    String? xAuthorization,
    String? cacheControl,
  }) {
    return _memberV3MembershipDelete(
        membership: membership,
        xAuthorization: xAuthorization,
        cacheControl: cacheControl);
  }

  ///membershipCode
  ///@param membership membership
  @Delete(path: '/member/v3/membership')
  Future<chopper.Response<String>> _memberV3MembershipDelete({
    @Query('membership') required String? membership,
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///subscriptionCode
  ///@param subscriptionType valid subscriptions are 'DIGITAL_SAVINGS', 'LOYA_OPT', 'WW_TTR_SMS', 'AHBOXEMAIL', 'AH_NEWSLET', 'PUSH_BONUS', 'PUSH_IMPORTANT', 'PUSH_ORDER_UPDATE', 'PUSH_ORDER_UPDATE_ESSENTIALS', 'PUSH_FAVORITE_SHOP', 'PUSH_NEW_FEATURES_FOR_YOU', 'PUSH_NEW_CHAT_CUSTOMER_SERVICE', 'PUSH_OFFERS', 'PUSH_INSPIRATION', 'WW_RET2015'
  Future<chopper.Response<String>> memberV3SubscriptionPost({
    String? subscriptionType,
    String? xAuthorization,
    String? cacheControl,
  }) {
    return _memberV3SubscriptionPost(
        subscriptionType: subscriptionType,
        xAuthorization: xAuthorization,
        cacheControl: cacheControl);
  }

  ///subscriptionCode
  ///@param subscriptionType valid subscriptions are 'DIGITAL_SAVINGS', 'LOYA_OPT', 'WW_TTR_SMS', 'AHBOXEMAIL', 'AH_NEWSLET', 'PUSH_BONUS', 'PUSH_IMPORTANT', 'PUSH_ORDER_UPDATE', 'PUSH_ORDER_UPDATE_ESSENTIALS', 'PUSH_FAVORITE_SHOP', 'PUSH_NEW_FEATURES_FOR_YOU', 'PUSH_NEW_CHAT_CUSTOMER_SERVICE', 'PUSH_OFFERS', 'PUSH_INSPIRATION', 'WW_RET2015'
  @Post(
    path: '/member/v3/subscription',
    optionalBody: true,
  )
  Future<chopper.Response<String>> _memberV3SubscriptionPost({
    @Query('subscriptionType') String? subscriptionType,
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///subscriptionCode
  ///@param subscriptionType valid subscriptions are 'DIGITAL_SAVINGS', 'LOYA_OPT', 'WW_TTR_SMS', 'AHBOXEMAIL', 'AH_NEWSLET', 'PUSH_BONUS', 'PUSH_IMPORTANT', 'PUSH_ORDER_UPDATE', 'PUSH_ORDER_UPDATE_ESSENTIALS', 'PUSH_FAVORITE_SHOP', 'PUSH_NEW_FEATURES_FOR_YOU', 'PUSH_NEW_CHAT_CUSTOMER_SERVICE', 'PUSH_OFFERS', 'PUSH_INSPIRATION', 'WW_RET2015'
  Future<chopper.Response<String>> memberV3SubscriptionDelete({
    String? subscriptionType,
    String? xAuthorization,
    String? cacheControl,
  }) {
    return _memberV3SubscriptionDelete(
        subscriptionType: subscriptionType,
        xAuthorization: xAuthorization,
        cacheControl: cacheControl);
  }

  ///subscriptionCode
  ///@param subscriptionType valid subscriptions are 'DIGITAL_SAVINGS', 'LOYA_OPT', 'WW_TTR_SMS', 'AHBOXEMAIL', 'AH_NEWSLET', 'PUSH_BONUS', 'PUSH_IMPORTANT', 'PUSH_ORDER_UPDATE', 'PUSH_ORDER_UPDATE_ESSENTIALS', 'PUSH_FAVORITE_SHOP', 'PUSH_NEW_FEATURES_FOR_YOU', 'PUSH_NEW_CHAT_CUSTOMER_SERVICE', 'PUSH_OFFERS', 'PUSH_INSPIRATION', 'WW_RET2015'
  @Delete(path: '/member/v3/subscription')
  Future<chopper.Response<String>> _memberV3SubscriptionDelete({
    @Query('subscriptionType') String? subscriptionType,
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class Address {
  Address({
    this.city,
    this.country,
    this.houseNumber,
    this.houseNumberExtra,
    this.street,
    this.zipCode,
  });

  factory Address.fromJson(Map<String, dynamic> json) =>
      _$AddressFromJson(json);

  @JsonKey(name: 'city', includeIfNull: false, defaultValue: '')
  final String? city;
  @JsonKey(name: 'country', includeIfNull: false, defaultValue: '')
  final String? country;
  @JsonKey(name: 'houseNumber', includeIfNull: false, defaultValue: '')
  final String? houseNumber;
  @JsonKey(name: 'houseNumberExtra', includeIfNull: false, defaultValue: '')
  final String? houseNumberExtra;
  @JsonKey(name: 'street', includeIfNull: false, defaultValue: '')
  final String? street;
  @JsonKey(name: 'zipCode', includeIfNull: false, defaultValue: '')
  final String? zipCode;
  static const fromJsonFactory = _$AddressFromJson;
  static const toJsonFactory = _$AddressToJson;
  Map<String, dynamic> toJson() => _$AddressToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Address &&
            (identical(other.city, city) ||
                const DeepCollectionEquality().equals(other.city, city)) &&
            (identical(other.country, country) ||
                const DeepCollectionEquality()
                    .equals(other.country, country)) &&
            (identical(other.houseNumber, houseNumber) ||
                const DeepCollectionEquality()
                    .equals(other.houseNumber, houseNumber)) &&
            (identical(other.houseNumberExtra, houseNumberExtra) ||
                const DeepCollectionEquality()
                    .equals(other.houseNumberExtra, houseNumberExtra)) &&
            (identical(other.street, street) ||
                const DeepCollectionEquality().equals(other.street, street)) &&
            (identical(other.zipCode, zipCode) ||
                const DeepCollectionEquality().equals(other.zipCode, zipCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(city) ^
      const DeepCollectionEquality().hash(country) ^
      const DeepCollectionEquality().hash(houseNumber) ^
      const DeepCollectionEquality().hash(houseNumberExtra) ^
      const DeepCollectionEquality().hash(street) ^
      const DeepCollectionEquality().hash(zipCode) ^
      runtimeType.hashCode;
}

extension $AddressExtension on Address {
  Address copyWith(
      {String? city,
      String? country,
      String? houseNumber,
      String? houseNumberExtra,
      String? street,
      String? zipCode}) {
    return Address(
        city: city ?? this.city,
        country: country ?? this.country,
        houseNumber: houseNumber ?? this.houseNumber,
        houseNumberExtra: houseNumberExtra ?? this.houseNumberExtra,
        street: street ?? this.street,
        zipCode: zipCode ?? this.zipCode);
  }

  Address copyWithWrapped(
      {Wrapped<String?>? city,
      Wrapped<String?>? country,
      Wrapped<String?>? houseNumber,
      Wrapped<String?>? houseNumberExtra,
      Wrapped<String?>? street,
      Wrapped<String?>? zipCode}) {
    return Address(
        city: (city != null ? city.value : this.city),
        country: (country != null ? country.value : this.country),
        houseNumber:
            (houseNumber != null ? houseNumber.value : this.houseNumber),
        houseNumberExtra: (houseNumberExtra != null
            ? houseNumberExtra.value
            : this.houseNumberExtra),
        street: (street != null ? street.value : this.street),
        zipCode: (zipCode != null ? zipCode.value : this.zipCode));
  }
}

@JsonSerializable(explicitToJson: true)
class AddressCommand {
  AddressCommand({
    this.street,
    this.houseNumber,
    this.zipCode,
    this.city,
    this.country,
  });

  factory AddressCommand.fromJson(Map<String, dynamic> json) =>
      _$AddressCommandFromJson(json);

  @JsonKey(name: 'street', includeIfNull: false, defaultValue: '')
  final String? street;
  @JsonKey(name: 'houseNumber', includeIfNull: false, defaultValue: '')
  final String? houseNumber;
  @JsonKey(name: 'zipCode', includeIfNull: false, defaultValue: '')
  final String? zipCode;
  @JsonKey(name: 'city', includeIfNull: false, defaultValue: '')
  final String? city;
  @JsonKey(name: 'country', includeIfNull: false, defaultValue: '')
  final String? country;
  static const fromJsonFactory = _$AddressCommandFromJson;
  static const toJsonFactory = _$AddressCommandToJson;
  Map<String, dynamic> toJson() => _$AddressCommandToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AddressCommand &&
            (identical(other.street, street) ||
                const DeepCollectionEquality().equals(other.street, street)) &&
            (identical(other.houseNumber, houseNumber) ||
                const DeepCollectionEquality()
                    .equals(other.houseNumber, houseNumber)) &&
            (identical(other.zipCode, zipCode) ||
                const DeepCollectionEquality()
                    .equals(other.zipCode, zipCode)) &&
            (identical(other.city, city) ||
                const DeepCollectionEquality().equals(other.city, city)) &&
            (identical(other.country, country) ||
                const DeepCollectionEquality().equals(other.country, country)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(street) ^
      const DeepCollectionEquality().hash(houseNumber) ^
      const DeepCollectionEquality().hash(zipCode) ^
      const DeepCollectionEquality().hash(city) ^
      const DeepCollectionEquality().hash(country) ^
      runtimeType.hashCode;
}

extension $AddressCommandExtension on AddressCommand {
  AddressCommand copyWith(
      {String? street,
      String? houseNumber,
      String? zipCode,
      String? city,
      String? country}) {
    return AddressCommand(
        street: street ?? this.street,
        houseNumber: houseNumber ?? this.houseNumber,
        zipCode: zipCode ?? this.zipCode,
        city: city ?? this.city,
        country: country ?? this.country);
  }

  AddressCommand copyWithWrapped(
      {Wrapped<String?>? street,
      Wrapped<String?>? houseNumber,
      Wrapped<String?>? zipCode,
      Wrapped<String?>? city,
      Wrapped<String?>? country}) {
    return AddressCommand(
        street: (street != null ? street.value : this.street),
        houseNumber:
            (houseNumber != null ? houseNumber.value : this.houseNumber),
        zipCode: (zipCode != null ? zipCode.value : this.zipCode),
        city: (city != null ? city.value : this.city),
        country: (country != null ? country.value : this.country));
  }
}

@JsonSerializable(explicitToJson: true)
class IndustrySector {
  IndustrySector({
    this.code,
    this.description,
  });

  factory IndustrySector.fromJson(Map<String, dynamic> json) =>
      _$IndustrySectorFromJson(json);

  @JsonKey(name: 'code', includeIfNull: false, defaultValue: '')
  final String? code;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  static const fromJsonFactory = _$IndustrySectorFromJson;
  static const toJsonFactory = _$IndustrySectorToJson;
  Map<String, dynamic> toJson() => _$IndustrySectorToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is IndustrySector &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(code) ^
      const DeepCollectionEquality().hash(description) ^
      runtimeType.hashCode;
}

extension $IndustrySectorExtension on IndustrySector {
  IndustrySector copyWith({String? code, String? description}) {
    return IndustrySector(
        code: code ?? this.code, description: description ?? this.description);
  }

  IndustrySector copyWithWrapped(
      {Wrapped<String?>? code, Wrapped<String?>? description}) {
    return IndustrySector(
        code: (code != null ? code.value : this.code),
        description:
            (description != null ? description.value : this.description));
  }
}

@JsonSerializable(explicitToJson: true)
class LoyaltyCard {
  LoyaltyCard({
    required this.id,
    required this.type,
  });

  factory LoyaltyCard.fromJson(Map<String, dynamic> json) =>
      _$LoyaltyCardFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String type;
  static const fromJsonFactory = _$LoyaltyCardFromJson;
  static const toJsonFactory = _$LoyaltyCardToJson;
  Map<String, dynamic> toJson() => _$LoyaltyCardToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is LoyaltyCard &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $LoyaltyCardExtension on LoyaltyCard {
  LoyaltyCard copyWith({String? id, String? type}) {
    return LoyaltyCard(id: id ?? this.id, type: type ?? this.type);
  }

  LoyaltyCard copyWithWrapped({Wrapped<String>? id, Wrapped<String>? type}) {
    return LoyaltyCard(
        id: (id != null ? id.value : this.id),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class LoyaltyCardCommand {
  LoyaltyCardCommand({
    required this.id,
    required this.type,
  });

  factory LoyaltyCardCommand.fromJson(Map<String, dynamic> json) =>
      _$LoyaltyCardCommandFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String type;
  static const fromJsonFactory = _$LoyaltyCardCommandFromJson;
  static const toJsonFactory = _$LoyaltyCardCommandToJson;
  Map<String, dynamic> toJson() => _$LoyaltyCardCommandToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is LoyaltyCardCommand &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $LoyaltyCardCommandExtension on LoyaltyCardCommand {
  LoyaltyCardCommand copyWith({String? id, String? type}) {
    return LoyaltyCardCommand(id: id ?? this.id, type: type ?? this.type);
  }

  LoyaltyCardCommand copyWithWrapped(
      {Wrapped<String>? id, Wrapped<String>? type}) {
    return LoyaltyCardCommand(
        id: (id != null ? id.value : this.id),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Member {
  Member({
    this.address,
    required this.bonusServicesEnabled,
    this.email,
    this.industrySector,
    this.knownUser,
    this.loyaltyCards,
    this.memberId,
    this.memberType,
    this.memberships,
    this.name,
    this.password,
    this.phoneNumber,
    this.presumedMemberCookieValue,
    this.subscriptions,
    this.token,
    required this.webshopDiscountEnabled,
  });

  factory Member.fromJson(Map<String, dynamic> json) => _$MemberFromJson(json);

  @JsonKey(name: 'address', includeIfNull: false)
  final Address? address;
  @JsonKey(name: 'bonusServicesEnabled', includeIfNull: false)
  final bool bonusServicesEnabled;
  @JsonKey(name: 'email', includeIfNull: false, defaultValue: '')
  final String? email;
  @JsonKey(name: 'industrySector', includeIfNull: false)
  final IndustrySector? industrySector;
  @JsonKey(name: 'knownUser', includeIfNull: false)
  final bool? knownUser;
  @JsonKey(
      name: 'loyaltyCards', includeIfNull: false, defaultValue: <LoyaltyCard>[])
  final List<LoyaltyCard>? loyaltyCards;
  @JsonKey(name: 'memberId', includeIfNull: false)
  final num? memberId;
  @JsonKey(
    name: 'memberType',
    includeIfNull: false,
    toJson: memberMemberTypeToJson,
    fromJson: memberMemberTypeFromJson,
  )
  final enums.MemberMemberType? memberType;
  @JsonKey(name: 'memberships', includeIfNull: false, defaultValue: <String>[])
  final List<String>? memberships;
  @JsonKey(name: 'name', includeIfNull: false)
  final Name? name;
  @JsonKey(name: 'password', includeIfNull: false, defaultValue: '')
  final String? password;
  @JsonKey(name: 'phoneNumber', includeIfNull: false, defaultValue: '')
  final String? phoneNumber;
  @JsonKey(
      name: 'presumedMemberCookieValue', includeIfNull: false, defaultValue: '')
  final String? presumedMemberCookieValue;
  @JsonKey(
    name: 'subscriptions',
    includeIfNull: false,
    toJson: memberSubscriptionsListToJson,
    fromJson: memberSubscriptionsListFromJson,
  )
  final List<enums.MemberSubscriptions>? subscriptions;
  @JsonKey(name: 'token', includeIfNull: false, defaultValue: '')
  final String? token;
  @JsonKey(name: 'webshopDiscountEnabled', includeIfNull: false)
  final bool webshopDiscountEnabled;
  static const fromJsonFactory = _$MemberFromJson;
  static const toJsonFactory = _$MemberToJson;
  Map<String, dynamic> toJson() => _$MemberToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Member &&
            (identical(other.address, address) ||
                const DeepCollectionEquality()
                    .equals(other.address, address)) &&
            (identical(other.bonusServicesEnabled, bonusServicesEnabled) ||
                const DeepCollectionEquality().equals(
                    other.bonusServicesEnabled, bonusServicesEnabled)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.industrySector, industrySector) ||
                const DeepCollectionEquality()
                    .equals(other.industrySector, industrySector)) &&
            (identical(other.knownUser, knownUser) ||
                const DeepCollectionEquality()
                    .equals(other.knownUser, knownUser)) &&
            (identical(other.loyaltyCards, loyaltyCards) ||
                const DeepCollectionEquality()
                    .equals(other.loyaltyCards, loyaltyCards)) &&
            (identical(other.memberId, memberId) ||
                const DeepCollectionEquality()
                    .equals(other.memberId, memberId)) &&
            (identical(other.memberType, memberType) ||
                const DeepCollectionEquality()
                    .equals(other.memberType, memberType)) &&
            (identical(other.memberships, memberships) ||
                const DeepCollectionEquality()
                    .equals(other.memberships, memberships)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.password, password) ||
                const DeepCollectionEquality()
                    .equals(other.password, password)) &&
            (identical(other.phoneNumber, phoneNumber) ||
                const DeepCollectionEquality()
                    .equals(other.phoneNumber, phoneNumber)) &&
            (identical(other.presumedMemberCookieValue,
                    presumedMemberCookieValue) ||
                const DeepCollectionEquality().equals(
                    other.presumedMemberCookieValue,
                    presumedMemberCookieValue)) &&
            (identical(other.subscriptions, subscriptions) ||
                const DeepCollectionEquality()
                    .equals(other.subscriptions, subscriptions)) &&
            (identical(other.token, token) ||
                const DeepCollectionEquality().equals(other.token, token)) &&
            (identical(other.webshopDiscountEnabled, webshopDiscountEnabled) ||
                const DeepCollectionEquality().equals(
                    other.webshopDiscountEnabled, webshopDiscountEnabled)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(address) ^
      const DeepCollectionEquality().hash(bonusServicesEnabled) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(industrySector) ^
      const DeepCollectionEquality().hash(knownUser) ^
      const DeepCollectionEquality().hash(loyaltyCards) ^
      const DeepCollectionEquality().hash(memberId) ^
      const DeepCollectionEquality().hash(memberType) ^
      const DeepCollectionEquality().hash(memberships) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(password) ^
      const DeepCollectionEquality().hash(phoneNumber) ^
      const DeepCollectionEquality().hash(presumedMemberCookieValue) ^
      const DeepCollectionEquality().hash(subscriptions) ^
      const DeepCollectionEquality().hash(token) ^
      const DeepCollectionEquality().hash(webshopDiscountEnabled) ^
      runtimeType.hashCode;
}

extension $MemberExtension on Member {
  Member copyWith(
      {Address? address,
      bool? bonusServicesEnabled,
      String? email,
      IndustrySector? industrySector,
      bool? knownUser,
      List<LoyaltyCard>? loyaltyCards,
      num? memberId,
      enums.MemberMemberType? memberType,
      List<String>? memberships,
      Name? name,
      String? password,
      String? phoneNumber,
      String? presumedMemberCookieValue,
      List<enums.MemberSubscriptions>? subscriptions,
      String? token,
      bool? webshopDiscountEnabled}) {
    return Member(
        address: address ?? this.address,
        bonusServicesEnabled: bonusServicesEnabled ?? this.bonusServicesEnabled,
        email: email ?? this.email,
        industrySector: industrySector ?? this.industrySector,
        knownUser: knownUser ?? this.knownUser,
        loyaltyCards: loyaltyCards ?? this.loyaltyCards,
        memberId: memberId ?? this.memberId,
        memberType: memberType ?? this.memberType,
        memberships: memberships ?? this.memberships,
        name: name ?? this.name,
        password: password ?? this.password,
        phoneNumber: phoneNumber ?? this.phoneNumber,
        presumedMemberCookieValue:
            presumedMemberCookieValue ?? this.presumedMemberCookieValue,
        subscriptions: subscriptions ?? this.subscriptions,
        token: token ?? this.token,
        webshopDiscountEnabled:
            webshopDiscountEnabled ?? this.webshopDiscountEnabled);
  }

  Member copyWithWrapped(
      {Wrapped<Address?>? address,
      Wrapped<bool>? bonusServicesEnabled,
      Wrapped<String?>? email,
      Wrapped<IndustrySector?>? industrySector,
      Wrapped<bool?>? knownUser,
      Wrapped<List<LoyaltyCard>?>? loyaltyCards,
      Wrapped<num?>? memberId,
      Wrapped<enums.MemberMemberType?>? memberType,
      Wrapped<List<String>?>? memberships,
      Wrapped<Name?>? name,
      Wrapped<String?>? password,
      Wrapped<String?>? phoneNumber,
      Wrapped<String?>? presumedMemberCookieValue,
      Wrapped<List<enums.MemberSubscriptions>?>? subscriptions,
      Wrapped<String?>? token,
      Wrapped<bool>? webshopDiscountEnabled}) {
    return Member(
        address: (address != null ? address.value : this.address),
        bonusServicesEnabled: (bonusServicesEnabled != null
            ? bonusServicesEnabled.value
            : this.bonusServicesEnabled),
        email: (email != null ? email.value : this.email),
        industrySector: (industrySector != null
            ? industrySector.value
            : this.industrySector),
        knownUser: (knownUser != null ? knownUser.value : this.knownUser),
        loyaltyCards:
            (loyaltyCards != null ? loyaltyCards.value : this.loyaltyCards),
        memberId: (memberId != null ? memberId.value : this.memberId),
        memberType: (memberType != null ? memberType.value : this.memberType),
        memberships:
            (memberships != null ? memberships.value : this.memberships),
        name: (name != null ? name.value : this.name),
        password: (password != null ? password.value : this.password),
        phoneNumber:
            (phoneNumber != null ? phoneNumber.value : this.phoneNumber),
        presumedMemberCookieValue: (presumedMemberCookieValue != null
            ? presumedMemberCookieValue.value
            : this.presumedMemberCookieValue),
        subscriptions:
            (subscriptions != null ? subscriptions.value : this.subscriptions),
        token: (token != null ? token.value : this.token),
        webshopDiscountEnabled: (webshopDiscountEnabled != null
            ? webshopDiscountEnabled.value
            : this.webshopDiscountEnabled));
  }
}

@JsonSerializable(explicitToJson: true)
class MemberByBonusCardRequest {
  MemberByBonusCardRequest({
    required this.code,
    required this.cardType,
  });

  factory MemberByBonusCardRequest.fromJson(Map<String, dynamic> json) =>
      _$MemberByBonusCardRequestFromJson(json);

  @JsonKey(name: 'code', includeIfNull: false, defaultValue: '')
  final String code;
  @JsonKey(name: 'cardType', includeIfNull: false, defaultValue: '')
  final String cardType;
  static const fromJsonFactory = _$MemberByBonusCardRequestFromJson;
  static const toJsonFactory = _$MemberByBonusCardRequestToJson;
  Map<String, dynamic> toJson() => _$MemberByBonusCardRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MemberByBonusCardRequest &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.cardType, cardType) ||
                const DeepCollectionEquality()
                    .equals(other.cardType, cardType)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(code) ^
      const DeepCollectionEquality().hash(cardType) ^
      runtimeType.hashCode;
}

extension $MemberByBonusCardRequestExtension on MemberByBonusCardRequest {
  MemberByBonusCardRequest copyWith({String? code, String? cardType}) {
    return MemberByBonusCardRequest(
        code: code ?? this.code, cardType: cardType ?? this.cardType);
  }

  MemberByBonusCardRequest copyWithWrapped(
      {Wrapped<String>? code, Wrapped<String>? cardType}) {
    return MemberByBonusCardRequest(
        code: (code != null ? code.value : this.code),
        cardType: (cardType != null ? cardType.value : this.cardType));
  }
}

@JsonSerializable(explicitToJson: true)
class MemberCommand {
  MemberCommand({
    this.memberId,
    this.password,
    this.email,
    this.token,
    this.knownUser,
    this.presumedMemberCookieValue,
    this.webshopDiscountEnabled,
    this.bonusServicesEnabled,
    this.loyaltyCardCommands,
    this.memberShipCommands,
    this.address,
    this.name,
    this.memberType,
  });

  factory MemberCommand.fromJson(Map<String, dynamic> json) =>
      _$MemberCommandFromJson(json);

  @JsonKey(name: 'memberId', includeIfNull: false)
  final num? memberId;
  @JsonKey(name: 'password', includeIfNull: false, defaultValue: '')
  final String? password;
  @JsonKey(name: 'email', includeIfNull: false, defaultValue: '')
  final String? email;
  @JsonKey(name: 'token', includeIfNull: false, defaultValue: '')
  final String? token;
  @JsonKey(name: 'knownUser', includeIfNull: false)
  final bool? knownUser;
  @JsonKey(
      name: 'presumedMemberCookieValue', includeIfNull: false, defaultValue: '')
  final String? presumedMemberCookieValue;
  @JsonKey(name: 'webshopDiscountEnabled', includeIfNull: false)
  final bool? webshopDiscountEnabled;
  @JsonKey(name: 'bonusServicesEnabled', includeIfNull: false)
  final bool? bonusServicesEnabled;
  @JsonKey(
      name: 'loyaltyCardCommands',
      includeIfNull: false,
      defaultValue: <LoyaltyCardCommand>[])
  final List<LoyaltyCardCommand>? loyaltyCardCommands;
  @JsonKey(
      name: 'memberShipCommands',
      includeIfNull: false,
      defaultValue: <MembershipCommand>[])
  final List<MembershipCommand>? memberShipCommands;
  @JsonKey(name: 'address', includeIfNull: false)
  final AddressCommand? address;
  @JsonKey(name: 'name', includeIfNull: false)
  final NameCommand? name;
  @JsonKey(
    name: 'memberType',
    includeIfNull: false,
    toJson: memberCommandMemberTypeToJson,
    fromJson: memberCommandMemberTypeFromJson,
  )
  final enums.MemberCommandMemberType? memberType;
  static const fromJsonFactory = _$MemberCommandFromJson;
  static const toJsonFactory = _$MemberCommandToJson;
  Map<String, dynamic> toJson() => _$MemberCommandToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MemberCommand &&
            (identical(other.memberId, memberId) ||
                const DeepCollectionEquality()
                    .equals(other.memberId, memberId)) &&
            (identical(other.password, password) ||
                const DeepCollectionEquality()
                    .equals(other.password, password)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.token, token) ||
                const DeepCollectionEquality().equals(other.token, token)) &&
            (identical(other.knownUser, knownUser) ||
                const DeepCollectionEquality()
                    .equals(other.knownUser, knownUser)) &&
            (identical(other.presumedMemberCookieValue,
                    presumedMemberCookieValue) ||
                const DeepCollectionEquality().equals(
                    other.presumedMemberCookieValue,
                    presumedMemberCookieValue)) &&
            (identical(other.webshopDiscountEnabled, webshopDiscountEnabled) ||
                const DeepCollectionEquality().equals(
                    other.webshopDiscountEnabled, webshopDiscountEnabled)) &&
            (identical(other.bonusServicesEnabled, bonusServicesEnabled) ||
                const DeepCollectionEquality().equals(
                    other.bonusServicesEnabled, bonusServicesEnabled)) &&
            (identical(other.loyaltyCardCommands, loyaltyCardCommands) ||
                const DeepCollectionEquality()
                    .equals(other.loyaltyCardCommands, loyaltyCardCommands)) &&
            (identical(other.memberShipCommands, memberShipCommands) ||
                const DeepCollectionEquality()
                    .equals(other.memberShipCommands, memberShipCommands)) &&
            (identical(other.address, address) ||
                const DeepCollectionEquality()
                    .equals(other.address, address)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.memberType, memberType) ||
                const DeepCollectionEquality()
                    .equals(other.memberType, memberType)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(memberId) ^
      const DeepCollectionEquality().hash(password) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(token) ^
      const DeepCollectionEquality().hash(knownUser) ^
      const DeepCollectionEquality().hash(presumedMemberCookieValue) ^
      const DeepCollectionEquality().hash(webshopDiscountEnabled) ^
      const DeepCollectionEquality().hash(bonusServicesEnabled) ^
      const DeepCollectionEquality().hash(loyaltyCardCommands) ^
      const DeepCollectionEquality().hash(memberShipCommands) ^
      const DeepCollectionEquality().hash(address) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(memberType) ^
      runtimeType.hashCode;
}

extension $MemberCommandExtension on MemberCommand {
  MemberCommand copyWith(
      {num? memberId,
      String? password,
      String? email,
      String? token,
      bool? knownUser,
      String? presumedMemberCookieValue,
      bool? webshopDiscountEnabled,
      bool? bonusServicesEnabled,
      List<LoyaltyCardCommand>? loyaltyCardCommands,
      List<MembershipCommand>? memberShipCommands,
      AddressCommand? address,
      NameCommand? name,
      enums.MemberCommandMemberType? memberType}) {
    return MemberCommand(
        memberId: memberId ?? this.memberId,
        password: password ?? this.password,
        email: email ?? this.email,
        token: token ?? this.token,
        knownUser: knownUser ?? this.knownUser,
        presumedMemberCookieValue:
            presumedMemberCookieValue ?? this.presumedMemberCookieValue,
        webshopDiscountEnabled:
            webshopDiscountEnabled ?? this.webshopDiscountEnabled,
        bonusServicesEnabled: bonusServicesEnabled ?? this.bonusServicesEnabled,
        loyaltyCardCommands: loyaltyCardCommands ?? this.loyaltyCardCommands,
        memberShipCommands: memberShipCommands ?? this.memberShipCommands,
        address: address ?? this.address,
        name: name ?? this.name,
        memberType: memberType ?? this.memberType);
  }

  MemberCommand copyWithWrapped(
      {Wrapped<num?>? memberId,
      Wrapped<String?>? password,
      Wrapped<String?>? email,
      Wrapped<String?>? token,
      Wrapped<bool?>? knownUser,
      Wrapped<String?>? presumedMemberCookieValue,
      Wrapped<bool?>? webshopDiscountEnabled,
      Wrapped<bool?>? bonusServicesEnabled,
      Wrapped<List<LoyaltyCardCommand>?>? loyaltyCardCommands,
      Wrapped<List<MembershipCommand>?>? memberShipCommands,
      Wrapped<AddressCommand?>? address,
      Wrapped<NameCommand?>? name,
      Wrapped<enums.MemberCommandMemberType?>? memberType}) {
    return MemberCommand(
        memberId: (memberId != null ? memberId.value : this.memberId),
        password: (password != null ? password.value : this.password),
        email: (email != null ? email.value : this.email),
        token: (token != null ? token.value : this.token),
        knownUser: (knownUser != null ? knownUser.value : this.knownUser),
        presumedMemberCookieValue: (presumedMemberCookieValue != null
            ? presumedMemberCookieValue.value
            : this.presumedMemberCookieValue),
        webshopDiscountEnabled: (webshopDiscountEnabled != null
            ? webshopDiscountEnabled.value
            : this.webshopDiscountEnabled),
        bonusServicesEnabled: (bonusServicesEnabled != null
            ? bonusServicesEnabled.value
            : this.bonusServicesEnabled),
        loyaltyCardCommands: (loyaltyCardCommands != null
            ? loyaltyCardCommands.value
            : this.loyaltyCardCommands),
        memberShipCommands: (memberShipCommands != null
            ? memberShipCommands.value
            : this.memberShipCommands),
        address: (address != null ? address.value : this.address),
        name: (name != null ? name.value : this.name),
        memberType: (memberType != null ? memberType.value : this.memberType));
  }
}

@JsonSerializable(explicitToJson: true)
class MemberWithIdOnly {
  MemberWithIdOnly({
    required this.memberId,
  });

  factory MemberWithIdOnly.fromJson(Map<String, dynamic> json) =>
      _$MemberWithIdOnlyFromJson(json);

  @JsonKey(name: 'memberId', includeIfNull: false)
  final num memberId;
  static const fromJsonFactory = _$MemberWithIdOnlyFromJson;
  static const toJsonFactory = _$MemberWithIdOnlyToJson;
  Map<String, dynamic> toJson() => _$MemberWithIdOnlyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MemberWithIdOnly &&
            (identical(other.memberId, memberId) ||
                const DeepCollectionEquality()
                    .equals(other.memberId, memberId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(memberId) ^ runtimeType.hashCode;
}

extension $MemberWithIdOnlyExtension on MemberWithIdOnly {
  MemberWithIdOnly copyWith({num? memberId}) {
    return MemberWithIdOnly(memberId: memberId ?? this.memberId);
  }

  MemberWithIdOnly copyWithWrapped({Wrapped<num>? memberId}) {
    return MemberWithIdOnly(
        memberId: (memberId != null ? memberId.value : this.memberId));
  }
}

@JsonSerializable(explicitToJson: true)
class MembershipBody {
  MembershipBody({
    required this.membership,
  });

  factory MembershipBody.fromJson(Map<String, dynamic> json) =>
      _$MembershipBodyFromJson(json);

  @JsonKey(
    name: 'membership',
    includeIfNull: false,
    toJson: membershipBodyMembershipToJson,
    fromJson: membershipBodyMembershipFromJson,
  )
  final enums.MembershipBodyMembership membership;
  static const fromJsonFactory = _$MembershipBodyFromJson;
  static const toJsonFactory = _$MembershipBodyToJson;
  Map<String, dynamic> toJson() => _$MembershipBodyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MembershipBody &&
            (identical(other.membership, membership) ||
                const DeepCollectionEquality()
                    .equals(other.membership, membership)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(membership) ^ runtimeType.hashCode;
}

extension $MembershipBodyExtension on MembershipBody {
  MembershipBody copyWith({enums.MembershipBodyMembership? membership}) {
    return MembershipBody(membership: membership ?? this.membership);
  }

  MembershipBody copyWithWrapped(
      {Wrapped<enums.MembershipBodyMembership>? membership}) {
    return MembershipBody(
        membership: (membership != null ? membership.value : this.membership));
  }
}

@JsonSerializable(explicitToJson: true)
class MembershipCommand {
  MembershipCommand({
    required this.type,
  });

  factory MembershipCommand.fromJson(Map<String, dynamic> json) =>
      _$MembershipCommandFromJson(json);

  @JsonKey(
    name: 'type',
    includeIfNull: false,
    toJson: membershipCommandTypeToJson,
    fromJson: membershipCommandTypeFromJson,
  )
  final enums.MembershipCommandType type;
  static const fromJsonFactory = _$MembershipCommandFromJson;
  static const toJsonFactory = _$MembershipCommandToJson;
  Map<String, dynamic> toJson() => _$MembershipCommandToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MembershipCommand &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(type) ^ runtimeType.hashCode;
}

extension $MembershipCommandExtension on MembershipCommand {
  MembershipCommand copyWith({enums.MembershipCommandType? type}) {
    return MembershipCommand(type: type ?? this.type);
  }

  MembershipCommand copyWithWrapped(
      {Wrapped<enums.MembershipCommandType>? type}) {
    return MembershipCommand(type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ModelAndView {
  ModelAndView({
    this.empty,
    this.model,
    this.modelMap,
    this.reference,
    this.status,
    this.view,
    this.viewName,
  });

  factory ModelAndView.fromJson(Map<String, dynamic> json) =>
      _$ModelAndViewFromJson(json);

  @JsonKey(name: 'empty', includeIfNull: false)
  final bool? empty;
  @JsonKey(name: 'model', includeIfNull: false)
  final Object? model;
  @JsonKey(name: 'modelMap', includeIfNull: false)
  final Map<String, dynamic>? modelMap;
  @JsonKey(name: 'reference', includeIfNull: false)
  final bool? reference;
  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: modelAndViewStatusToJson,
    fromJson: modelAndViewStatusFromJson,
  )
  final enums.ModelAndViewStatus? status;
  @JsonKey(name: 'view', includeIfNull: false)
  final View? view;
  @JsonKey(name: 'viewName', includeIfNull: false, defaultValue: '')
  final String? viewName;
  static const fromJsonFactory = _$ModelAndViewFromJson;
  static const toJsonFactory = _$ModelAndViewToJson;
  Map<String, dynamic> toJson() => _$ModelAndViewToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ModelAndView &&
            (identical(other.empty, empty) ||
                const DeepCollectionEquality().equals(other.empty, empty)) &&
            (identical(other.model, model) ||
                const DeepCollectionEquality().equals(other.model, model)) &&
            (identical(other.modelMap, modelMap) ||
                const DeepCollectionEquality()
                    .equals(other.modelMap, modelMap)) &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.view, view) ||
                const DeepCollectionEquality().equals(other.view, view)) &&
            (identical(other.viewName, viewName) ||
                const DeepCollectionEquality()
                    .equals(other.viewName, viewName)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(empty) ^
      const DeepCollectionEquality().hash(model) ^
      const DeepCollectionEquality().hash(modelMap) ^
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(view) ^
      const DeepCollectionEquality().hash(viewName) ^
      runtimeType.hashCode;
}

extension $ModelAndViewExtension on ModelAndView {
  ModelAndView copyWith(
      {bool? empty,
      Object? model,
      Map<String, dynamic>? modelMap,
      bool? reference,
      enums.ModelAndViewStatus? status,
      View? view,
      String? viewName}) {
    return ModelAndView(
        empty: empty ?? this.empty,
        model: model ?? this.model,
        modelMap: modelMap ?? this.modelMap,
        reference: reference ?? this.reference,
        status: status ?? this.status,
        view: view ?? this.view,
        viewName: viewName ?? this.viewName);
  }

  ModelAndView copyWithWrapped(
      {Wrapped<bool?>? empty,
      Wrapped<Object?>? model,
      Wrapped<Map<String, dynamic>?>? modelMap,
      Wrapped<bool?>? reference,
      Wrapped<enums.ModelAndViewStatus?>? status,
      Wrapped<View?>? view,
      Wrapped<String?>? viewName}) {
    return ModelAndView(
        empty: (empty != null ? empty.value : this.empty),
        model: (model != null ? model.value : this.model),
        modelMap: (modelMap != null ? modelMap.value : this.modelMap),
        reference: (reference != null ? reference.value : this.reference),
        status: (status != null ? status.value : this.status),
        view: (view != null ? view.value : this.view),
        viewName: (viewName != null ? viewName.value : this.viewName));
  }
}

@JsonSerializable(explicitToJson: true)
class Name {
  Name({
    this.firstName,
    this.initials,
    this.middleName,
    this.surname,
    this.title,
  });

  factory Name.fromJson(Map<String, dynamic> json) => _$NameFromJson(json);

  @JsonKey(name: 'firstName', includeIfNull: false, defaultValue: '')
  final String? firstName;
  @JsonKey(name: 'initials', includeIfNull: false, defaultValue: '')
  final String? initials;
  @JsonKey(name: 'middleName', includeIfNull: false, defaultValue: '')
  final String? middleName;
  @JsonKey(name: 'surname', includeIfNull: false, defaultValue: '')
  final String? surname;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  static const fromJsonFactory = _$NameFromJson;
  static const toJsonFactory = _$NameToJson;
  Map<String, dynamic> toJson() => _$NameToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Name &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.initials, initials) ||
                const DeepCollectionEquality()
                    .equals(other.initials, initials)) &&
            (identical(other.middleName, middleName) ||
                const DeepCollectionEquality()
                    .equals(other.middleName, middleName)) &&
            (identical(other.surname, surname) ||
                const DeepCollectionEquality()
                    .equals(other.surname, surname)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(firstName) ^
      const DeepCollectionEquality().hash(initials) ^
      const DeepCollectionEquality().hash(middleName) ^
      const DeepCollectionEquality().hash(surname) ^
      const DeepCollectionEquality().hash(title) ^
      runtimeType.hashCode;
}

extension $NameExtension on Name {
  Name copyWith(
      {String? firstName,
      String? initials,
      String? middleName,
      String? surname,
      String? title}) {
    return Name(
        firstName: firstName ?? this.firstName,
        initials: initials ?? this.initials,
        middleName: middleName ?? this.middleName,
        surname: surname ?? this.surname,
        title: title ?? this.title);
  }

  Name copyWithWrapped(
      {Wrapped<String?>? firstName,
      Wrapped<String?>? initials,
      Wrapped<String?>? middleName,
      Wrapped<String?>? surname,
      Wrapped<String?>? title}) {
    return Name(
        firstName: (firstName != null ? firstName.value : this.firstName),
        initials: (initials != null ? initials.value : this.initials),
        middleName: (middleName != null ? middleName.value : this.middleName),
        surname: (surname != null ? surname.value : this.surname),
        title: (title != null ? title.value : this.title));
  }
}

@JsonSerializable(explicitToJson: true)
class NameCommand {
  NameCommand({
    this.title,
    this.firstName,
    this.initials,
    this.middleName,
    this.surname,
  });

  factory NameCommand.fromJson(Map<String, dynamic> json) =>
      _$NameCommandFromJson(json);

  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'firstName', includeIfNull: false, defaultValue: '')
  final String? firstName;
  @JsonKey(name: 'initials', includeIfNull: false, defaultValue: '')
  final String? initials;
  @JsonKey(name: 'middleName', includeIfNull: false, defaultValue: '')
  final String? middleName;
  @JsonKey(name: 'surname', includeIfNull: false, defaultValue: '')
  final String? surname;
  static const fromJsonFactory = _$NameCommandFromJson;
  static const toJsonFactory = _$NameCommandToJson;
  Map<String, dynamic> toJson() => _$NameCommandToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NameCommand &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.initials, initials) ||
                const DeepCollectionEquality()
                    .equals(other.initials, initials)) &&
            (identical(other.middleName, middleName) ||
                const DeepCollectionEquality()
                    .equals(other.middleName, middleName)) &&
            (identical(other.surname, surname) ||
                const DeepCollectionEquality().equals(other.surname, surname)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(firstName) ^
      const DeepCollectionEquality().hash(initials) ^
      const DeepCollectionEquality().hash(middleName) ^
      const DeepCollectionEquality().hash(surname) ^
      runtimeType.hashCode;
}

extension $NameCommandExtension on NameCommand {
  NameCommand copyWith(
      {String? title,
      String? firstName,
      String? initials,
      String? middleName,
      String? surname}) {
    return NameCommand(
        title: title ?? this.title,
        firstName: firstName ?? this.firstName,
        initials: initials ?? this.initials,
        middleName: middleName ?? this.middleName,
        surname: surname ?? this.surname);
  }

  NameCommand copyWithWrapped(
      {Wrapped<String?>? title,
      Wrapped<String?>? firstName,
      Wrapped<String?>? initials,
      Wrapped<String?>? middleName,
      Wrapped<String?>? surname}) {
    return NameCommand(
        title: (title != null ? title.value : this.title),
        firstName: (firstName != null ? firstName.value : this.firstName),
        initials: (initials != null ? initials.value : this.initials),
        middleName: (middleName != null ? middleName.value : this.middleName),
        surname: (surname != null ? surname.value : this.surname));
  }
}

@JsonSerializable(explicitToJson: true)
class View {
  View({
    this.contentType,
  });

  factory View.fromJson(Map<String, dynamic> json) => _$ViewFromJson(json);

  @JsonKey(name: 'contentType', includeIfNull: false, defaultValue: '')
  final String? contentType;
  static const fromJsonFactory = _$ViewFromJson;
  static const toJsonFactory = _$ViewToJson;
  Map<String, dynamic> toJson() => _$ViewToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is View &&
            (identical(other.contentType, contentType) ||
                const DeepCollectionEquality()
                    .equals(other.contentType, contentType)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(contentType) ^ runtimeType.hashCode;
}

extension $ViewExtension on View {
  View copyWith({String? contentType}) {
    return View(contentType: contentType ?? this.contentType);
  }

  View copyWithWrapped({Wrapped<String?>? contentType}) {
    return View(
        contentType:
            (contentType != null ? contentType.value : this.contentType));
  }
}

String? memberMemberTypeToJson(enums.MemberMemberType? memberMemberType) {
  return enums.$MemberMemberTypeMap[memberMemberType];
}

enums.MemberMemberType memberMemberTypeFromJson(
  Object? memberMemberType, [
  enums.MemberMemberType? defaultValue,
]) {
  if (memberMemberType is String) {
    return enums.$MemberMemberTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == memberMemberType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.MemberMemberType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$MemberMemberTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.MemberMemberType.swaggerGeneratedUnknown;
}

List<String> memberMemberTypeListToJson(
    List<enums.MemberMemberType>? memberMemberType) {
  if (memberMemberType == null) {
    return [];
  }

  return memberMemberType.map((e) => enums.$MemberMemberTypeMap[e]!).toList();
}

List<enums.MemberMemberType> memberMemberTypeListFromJson(
  List? memberMemberType, [
  List<enums.MemberMemberType>? defaultValue,
]) {
  if (memberMemberType == null) {
    return defaultValue ?? [];
  }

  return memberMemberType
      .map((e) => memberMemberTypeFromJson(e.toString()))
      .toList();
}

List<enums.MemberMemberType>? memberMemberTypeNullableListFromJson(
  List? memberMemberType, [
  List<enums.MemberMemberType>? defaultValue,
]) {
  if (memberMemberType == null) {
    return defaultValue;
  }

  return memberMemberType
      .map((e) => memberMemberTypeFromJson(e.toString()))
      .toList();
}

String? memberSubscriptionsToJson(
    enums.MemberSubscriptions? memberSubscriptions) {
  return enums.$MemberSubscriptionsMap[memberSubscriptions];
}

enums.MemberSubscriptions memberSubscriptionsFromJson(
  Object? memberSubscriptions, [
  enums.MemberSubscriptions? defaultValue,
]) {
  if (memberSubscriptions is String) {
    return enums.$MemberSubscriptionsMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                memberSubscriptions.toLowerCase(),
            orElse: () => const MapEntry(
                enums.MemberSubscriptions.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$MemberSubscriptionsMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.MemberSubscriptions.swaggerGeneratedUnknown;
}

List<String> memberSubscriptionsListToJson(
    List<enums.MemberSubscriptions>? memberSubscriptions) {
  if (memberSubscriptions == null) {
    return [];
  }

  return memberSubscriptions
      .map((e) => enums.$MemberSubscriptionsMap[e]!)
      .toList();
}

List<enums.MemberSubscriptions> memberSubscriptionsListFromJson(
  List? memberSubscriptions, [
  List<enums.MemberSubscriptions>? defaultValue,
]) {
  if (memberSubscriptions == null) {
    return defaultValue ?? [];
  }

  return memberSubscriptions
      .map((e) => memberSubscriptionsFromJson(e.toString()))
      .toList();
}

List<enums.MemberSubscriptions>? memberSubscriptionsNullableListFromJson(
  List? memberSubscriptions, [
  List<enums.MemberSubscriptions>? defaultValue,
]) {
  if (memberSubscriptions == null) {
    return defaultValue;
  }

  return memberSubscriptions
      .map((e) => memberSubscriptionsFromJson(e.toString()))
      .toList();
}

String? memberCommandMemberTypeToJson(
    enums.MemberCommandMemberType? memberCommandMemberType) {
  return enums.$MemberCommandMemberTypeMap[memberCommandMemberType];
}

enums.MemberCommandMemberType memberCommandMemberTypeFromJson(
  Object? memberCommandMemberType, [
  enums.MemberCommandMemberType? defaultValue,
]) {
  if (memberCommandMemberType is String) {
    return enums.$MemberCommandMemberTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                memberCommandMemberType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.MemberCommandMemberType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$MemberCommandMemberTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.MemberCommandMemberType.swaggerGeneratedUnknown;
}

List<String> memberCommandMemberTypeListToJson(
    List<enums.MemberCommandMemberType>? memberCommandMemberType) {
  if (memberCommandMemberType == null) {
    return [];
  }

  return memberCommandMemberType
      .map((e) => enums.$MemberCommandMemberTypeMap[e]!)
      .toList();
}

List<enums.MemberCommandMemberType> memberCommandMemberTypeListFromJson(
  List? memberCommandMemberType, [
  List<enums.MemberCommandMemberType>? defaultValue,
]) {
  if (memberCommandMemberType == null) {
    return defaultValue ?? [];
  }

  return memberCommandMemberType
      .map((e) => memberCommandMemberTypeFromJson(e.toString()))
      .toList();
}

List<enums.MemberCommandMemberType>?
    memberCommandMemberTypeNullableListFromJson(
  List? memberCommandMemberType, [
  List<enums.MemberCommandMemberType>? defaultValue,
]) {
  if (memberCommandMemberType == null) {
    return defaultValue;
  }

  return memberCommandMemberType
      .map((e) => memberCommandMemberTypeFromJson(e.toString()))
      .toList();
}

String? membershipBodyMembershipToJson(
    enums.MembershipBodyMembership? membershipBodyMembership) {
  return enums.$MembershipBodyMembershipMap[membershipBodyMembership];
}

enums.MembershipBodyMembership membershipBodyMembershipFromJson(
  Object? membershipBodyMembership, [
  enums.MembershipBodyMembership? defaultValue,
]) {
  if (membershipBodyMembership is String) {
    return enums.$MembershipBodyMembershipMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                membershipBodyMembership.toLowerCase(),
            orElse: () => const MapEntry(
                enums.MembershipBodyMembership.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$MembershipBodyMembershipMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.MembershipBodyMembership.swaggerGeneratedUnknown;
}

List<String> membershipBodyMembershipListToJson(
    List<enums.MembershipBodyMembership>? membershipBodyMembership) {
  if (membershipBodyMembership == null) {
    return [];
  }

  return membershipBodyMembership
      .map((e) => enums.$MembershipBodyMembershipMap[e]!)
      .toList();
}

List<enums.MembershipBodyMembership> membershipBodyMembershipListFromJson(
  List? membershipBodyMembership, [
  List<enums.MembershipBodyMembership>? defaultValue,
]) {
  if (membershipBodyMembership == null) {
    return defaultValue ?? [];
  }

  return membershipBodyMembership
      .map((e) => membershipBodyMembershipFromJson(e.toString()))
      .toList();
}

List<enums.MembershipBodyMembership>?
    membershipBodyMembershipNullableListFromJson(
  List? membershipBodyMembership, [
  List<enums.MembershipBodyMembership>? defaultValue,
]) {
  if (membershipBodyMembership == null) {
    return defaultValue;
  }

  return membershipBodyMembership
      .map((e) => membershipBodyMembershipFromJson(e.toString()))
      .toList();
}

String? membershipCommandTypeToJson(
    enums.MembershipCommandType? membershipCommandType) {
  return enums.$MembershipCommandTypeMap[membershipCommandType];
}

enums.MembershipCommandType membershipCommandTypeFromJson(
  Object? membershipCommandType, [
  enums.MembershipCommandType? defaultValue,
]) {
  if (membershipCommandType is String) {
    return enums.$MembershipCommandTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                membershipCommandType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.MembershipCommandType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$MembershipCommandTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.MembershipCommandType.swaggerGeneratedUnknown;
}

List<String> membershipCommandTypeListToJson(
    List<enums.MembershipCommandType>? membershipCommandType) {
  if (membershipCommandType == null) {
    return [];
  }

  return membershipCommandType
      .map((e) => enums.$MembershipCommandTypeMap[e]!)
      .toList();
}

List<enums.MembershipCommandType> membershipCommandTypeListFromJson(
  List? membershipCommandType, [
  List<enums.MembershipCommandType>? defaultValue,
]) {
  if (membershipCommandType == null) {
    return defaultValue ?? [];
  }

  return membershipCommandType
      .map((e) => membershipCommandTypeFromJson(e.toString()))
      .toList();
}

List<enums.MembershipCommandType>? membershipCommandTypeNullableListFromJson(
  List? membershipCommandType, [
  List<enums.MembershipCommandType>? defaultValue,
]) {
  if (membershipCommandType == null) {
    return defaultValue;
  }

  return membershipCommandType
      .map((e) => membershipCommandTypeFromJson(e.toString()))
      .toList();
}

String? modelAndViewStatusToJson(enums.ModelAndViewStatus? modelAndViewStatus) {
  return enums.$ModelAndViewStatusMap[modelAndViewStatus];
}

enums.ModelAndViewStatus modelAndViewStatusFromJson(
  Object? modelAndViewStatus, [
  enums.ModelAndViewStatus? defaultValue,
]) {
  if (modelAndViewStatus is String) {
    return enums.$ModelAndViewStatusMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == modelAndViewStatus.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ModelAndViewStatus.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ModelAndViewStatusMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ModelAndViewStatus.swaggerGeneratedUnknown;
}

List<String> modelAndViewStatusListToJson(
    List<enums.ModelAndViewStatus>? modelAndViewStatus) {
  if (modelAndViewStatus == null) {
    return [];
  }

  return modelAndViewStatus
      .map((e) => enums.$ModelAndViewStatusMap[e]!)
      .toList();
}

List<enums.ModelAndViewStatus> modelAndViewStatusListFromJson(
  List? modelAndViewStatus, [
  List<enums.ModelAndViewStatus>? defaultValue,
]) {
  if (modelAndViewStatus == null) {
    return defaultValue ?? [];
  }

  return modelAndViewStatus
      .map((e) => modelAndViewStatusFromJson(e.toString()))
      .toList();
}

List<enums.ModelAndViewStatus>? modelAndViewStatusNullableListFromJson(
  List? modelAndViewStatus, [
  List<enums.ModelAndViewStatus>? defaultValue,
]) {
  if (modelAndViewStatus == null) {
    return defaultValue;
  }

  return modelAndViewStatus
      .map((e) => modelAndViewStatusFromJson(e.toString()))
      .toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
