// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;

part 'no_put_if_absent.swagger.chopper.dart';
part 'no_put_if_absent.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class NoPutIfAbsent extends ChopperService {
  static NoPutIfAbsent create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$NoPutIfAbsent(client);
    }

    final newClient = ChopperClient(
        services: [_$NoPutIfAbsent()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://10.1.0.6:8091/ad_v1');
    return _$NoPutIfAbsent(newClient);
  }

  ///
  ///@param param
  Future<chopper.Response<UserInfo>> userPost({
    required Object? param,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(UserInfo, () => UserInfo.fromJsonFactory);

    return _userPost(param: param, cacheControl: cacheControl);
  }

  ///
  ///@param param
  @Post(path: '/user')
  Future<chopper.Response<UserInfo>> _userPost({
    @Body() required Object? param,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param param
  Future<chopper.Response<Config>> configPidPost({
    required Object? param,
    required int? pid,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Config, () => Config.fromJsonFactory);

    return _configPidPost(param: param, pid: pid, cacheControl: cacheControl);
  }

  ///
  ///@param param
  @Post(path: '/config/{pid}')
  Future<chopper.Response<Config>> _configPidPost({
    @Body() required Object? param,
    @Path('pid') required int? pid,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param page
  ///@param size
  ///@param session
  Future<chopper.Response<ConfigsPage>> configPidGet({
    int? page,
    int? size,
    required String? session,
    required int? pid,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ConfigsPage, () => ConfigsPage.fromJsonFactory);

    return _configPidGet(
        page: page,
        size: size,
        session: session,
        pid: pid,
        cacheControl: cacheControl);
  }

  ///
  ///@param page
  ///@param size
  ///@param session
  @Get(path: '/config/{pid}')
  Future<chopper.Response<ConfigsPage>> _configPidGet({
    @Query('page') int? page,
    @Query('size') int? size,
    @Query('session') required String? session,
    @Path('pid') required int? pid,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param param
  Future<chopper.Response> configPidDelete({
    required Object? param,
    required int? pid,
    String? cacheControl,
  }) {
    return _configPidDelete(param: param, pid: pid, cacheControl: cacheControl);
  }

  ///
  ///@param param
  @Delete(path: '/config/{pid}')
  Future<chopper.Response> _configPidDelete({
    @Body() required Object? param,
    @Path('pid') required int? pid,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param param
  Future<chopper.Response<Config>> configPidPut({
    required Object? param,
    required int? pid,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Config, () => Config.fromJsonFactory);

    return _configPidPut(param: param, pid: pid, cacheControl: cacheControl);
  }

  ///
  ///@param param
  @Put(path: '/config/{pid}')
  Future<chopper.Response<Config>> _configPidPut({
    @Body() required Object? param,
    @Path('pid') required int? pid,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param page
  ///@param size
  ///@param session
  Future<chopper.Response<ProductsPage>> productGet({
    int? page,
    int? size,
    required String? session,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ProductsPage, () => ProductsPage.fromJsonFactory);

    return _productGet(
        page: page, size: size, session: session, cacheControl: cacheControl);
  }

  ///
  ///@param page
  ///@param size
  ///@param session
  @Get(path: '/product')
  Future<chopper.Response<ProductsPage>> _productGet({
    @Query('page') int? page,
    @Query('size') int? size,
    @Query('session') required String? session,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param param
  Future<chopper.Response> adPublishSaveCachePidPost({
    required Object? param,
    required int? pid,
    String? cacheControl,
  }) {
    return _adPublishSaveCachePidPost(
        param: param, pid: pid, cacheControl: cacheControl);
  }

  ///
  ///@param param
  @Post(path: '/ad_publish/save_cache/{pid}')
  Future<chopper.Response> _adPublishSaveCachePidPost({
    @Body() required Object? param,
    @Path('pid') required int? pid,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param session
  Future<chopper.Response<ApiUsage>> fbApiUsagePidGet({
    required String? session,
    required int? pid,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ApiUsage, () => ApiUsage.fromJsonFactory);

    return _fbApiUsagePidGet(
        session: session, pid: pid, cacheControl: cacheControl);
  }

  ///
  ///@param session
  @Get(path: '/fb_api_usage/{pid}')
  Future<chopper.Response<ApiUsage>> _fbApiUsagePidGet({
    @Query('session') required String? session,
    @Path('pid') required int? pid,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param page
  ///@param size
  ///@param session
  ///@param projId
  Future<chopper.Response<AdCampaignGet$Response>> adCampaignGet({
    int? page,
    int? size,
    required String? session,
    required String? projId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AdCampaignGet$Response, () => AdCampaignGet$Response.fromJsonFactory);

    return _adCampaignGet(
        page: page,
        size: size,
        session: session,
        projId: projId,
        cacheControl: cacheControl);
  }

  ///
  ///@param page
  ///@param size
  ///@param session
  ///@param projId
  @Get(path: '/ad_campaign')
  Future<chopper.Response<AdCampaignGet$Response>> _adCampaignGet({
    @Query('page') int? page,
    @Query('size') int? size,
    @Query('session') required String? session,
    @Query('projId') required String? projId,
    @Header('Cache-Control') String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class Error {
  Error({
    this.code,
    this.message,
  });

  factory Error.fromJson(Map<String, dynamic> json) => _$ErrorFromJson(json);

  @JsonKey(name: 'code', includeIfNull: false)
  final int? code;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  static const fromJsonFactory = _$ErrorFromJson;
  static const toJsonFactory = _$ErrorToJson;
  Map<String, dynamic> toJson() => _$ErrorToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Error &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality().equals(other.message, message)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(code) ^
      const DeepCollectionEquality().hash(message) ^
      runtimeType.hashCode;
}

extension $ErrorExtension on Error {
  Error copyWith({int? code, String? message}) {
    return Error(code: code ?? this.code, message: message ?? this.message);
  }

  Error copyWithWrapped({Wrapped<int?>? code, Wrapped<String?>? message}) {
    return Error(
        code: (code != null ? code.value : this.code),
        message: (message != null ? message.value : this.message));
  }
}

@JsonSerializable(explicitToJson: true)
class Pagination {
  Pagination({
    this.count,
    this.perPage,
    this.curPage,
    this.totalPages,
  });

  factory Pagination.fromJson(Map<String, dynamic> json) =>
      _$PaginationFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int? count;
  @JsonKey(name: 'perPage', includeIfNull: false)
  final int? perPage;
  @JsonKey(name: 'curPage', includeIfNull: false)
  final int? curPage;
  @JsonKey(name: 'totalPages', includeIfNull: false)
  final int? totalPages;
  static const fromJsonFactory = _$PaginationFromJson;
  static const toJsonFactory = _$PaginationToJson;
  Map<String, dynamic> toJson() => _$PaginationToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Pagination &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.perPage, perPage) ||
                const DeepCollectionEquality()
                    .equals(other.perPage, perPage)) &&
            (identical(other.curPage, curPage) ||
                const DeepCollectionEquality()
                    .equals(other.curPage, curPage)) &&
            (identical(other.totalPages, totalPages) ||
                const DeepCollectionEquality()
                    .equals(other.totalPages, totalPages)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(perPage) ^
      const DeepCollectionEquality().hash(curPage) ^
      const DeepCollectionEquality().hash(totalPages) ^
      runtimeType.hashCode;
}

extension $PaginationExtension on Pagination {
  Pagination copyWith(
      {int? count, int? perPage, int? curPage, int? totalPages}) {
    return Pagination(
        count: count ?? this.count,
        perPage: perPage ?? this.perPage,
        curPage: curPage ?? this.curPage,
        totalPages: totalPages ?? this.totalPages);
  }

  Pagination copyWithWrapped(
      {Wrapped<int?>? count,
      Wrapped<int?>? perPage,
      Wrapped<int?>? curPage,
      Wrapped<int?>? totalPages}) {
    return Pagination(
        count: (count != null ? count.value : this.count),
        perPage: (perPage != null ? perPage.value : this.perPage),
        curPage: (curPage != null ? curPage.value : this.curPage),
        totalPages: (totalPages != null ? totalPages.value : this.totalPages));
  }
}

@JsonSerializable(explicitToJson: true)
class UserInfo {
  UserInfo({
    this.userId,
    this.userName,
    this.password,
    this.nickName,
    this.level,
    this.desc,
  });

  factory UserInfo.fromJson(Map<String, dynamic> json) =>
      _$UserInfoFromJson(json);

  @JsonKey(name: 'userId', includeIfNull: false)
  final int? userId;
  @JsonKey(name: 'userName', includeIfNull: false, defaultValue: '')
  final String? userName;
  @JsonKey(name: 'password', includeIfNull: false, defaultValue: '')
  final String? password;
  @JsonKey(name: 'nickName', includeIfNull: false, defaultValue: '')
  final String? nickName;
  @JsonKey(name: 'level', includeIfNull: false)
  final int? level;
  @JsonKey(name: 'desc', includeIfNull: false, defaultValue: '')
  final String? desc;
  static const fromJsonFactory = _$UserInfoFromJson;
  static const toJsonFactory = _$UserInfoToJson;
  Map<String, dynamic> toJson() => _$UserInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserInfo &&
            (identical(other.userId, userId) ||
                const DeepCollectionEquality().equals(other.userId, userId)) &&
            (identical(other.userName, userName) ||
                const DeepCollectionEquality()
                    .equals(other.userName, userName)) &&
            (identical(other.password, password) ||
                const DeepCollectionEquality()
                    .equals(other.password, password)) &&
            (identical(other.nickName, nickName) ||
                const DeepCollectionEquality()
                    .equals(other.nickName, nickName)) &&
            (identical(other.level, level) ||
                const DeepCollectionEquality().equals(other.level, level)) &&
            (identical(other.desc, desc) ||
                const DeepCollectionEquality().equals(other.desc, desc)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(userId) ^
      const DeepCollectionEquality().hash(userName) ^
      const DeepCollectionEquality().hash(password) ^
      const DeepCollectionEquality().hash(nickName) ^
      const DeepCollectionEquality().hash(level) ^
      const DeepCollectionEquality().hash(desc) ^
      runtimeType.hashCode;
}

extension $UserInfoExtension on UserInfo {
  UserInfo copyWith(
      {int? userId,
      String? userName,
      String? password,
      String? nickName,
      int? level,
      String? desc}) {
    return UserInfo(
        userId: userId ?? this.userId,
        userName: userName ?? this.userName,
        password: password ?? this.password,
        nickName: nickName ?? this.nickName,
        level: level ?? this.level,
        desc: desc ?? this.desc);
  }

  UserInfo copyWithWrapped(
      {Wrapped<int?>? userId,
      Wrapped<String?>? userName,
      Wrapped<String?>? password,
      Wrapped<String?>? nickName,
      Wrapped<int?>? level,
      Wrapped<String?>? desc}) {
    return UserInfo(
        userId: (userId != null ? userId.value : this.userId),
        userName: (userName != null ? userName.value : this.userName),
        password: (password != null ? password.value : this.password),
        nickName: (nickName != null ? nickName.value : this.nickName),
        level: (level != null ? level.value : this.level),
        desc: (desc != null ? desc.value : this.desc));
  }
}

@JsonSerializable(explicitToJson: true)
class Session {
  Session({
    required this.session,
  });

  factory Session.fromJson(Map<String, dynamic> json) =>
      _$SessionFromJson(json);

  @JsonKey(name: 'session', includeIfNull: false, defaultValue: '')
  final String session;
  static const fromJsonFactory = _$SessionFromJson;
  static const toJsonFactory = _$SessionToJson;
  Map<String, dynamic> toJson() => _$SessionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Session &&
            (identical(other.session, session) ||
                const DeepCollectionEquality().equals(other.session, session)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(session) ^ runtimeType.hashCode;
}

extension $SessionExtension on Session {
  Session copyWith({String? session}) {
    return Session(session: session ?? this.session);
  }

  Session copyWithWrapped({Wrapped<String>? session}) {
    return Session(session: (session != null ? session.value : this.session));
  }
}

@JsonSerializable(explicitToJson: true)
class Config {
  Config({
    this.id,
    this.product,
    required this.key,
    required this.value,
    this.updated,
    this.desc,
    this.sort,
  });

  factory Config.fromJson(Map<String, dynamic> json) => _$ConfigFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'product', includeIfNull: false)
  final int? product;
  @JsonKey(name: 'key', includeIfNull: false, defaultValue: '')
  final String key;
  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String value;
  @JsonKey(name: 'updated', includeIfNull: false)
  final int? updated;
  @JsonKey(name: 'desc', includeIfNull: false, defaultValue: '')
  final String? desc;
  @JsonKey(name: 'sort', includeIfNull: false)
  final int? sort;
  static const fromJsonFactory = _$ConfigFromJson;
  static const toJsonFactory = _$ConfigToJson;
  Map<String, dynamic> toJson() => _$ConfigToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Config &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.product, product) ||
                const DeepCollectionEquality()
                    .equals(other.product, product)) &&
            (identical(other.key, key) ||
                const DeepCollectionEquality().equals(other.key, key)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)) &&
            (identical(other.updated, updated) ||
                const DeepCollectionEquality()
                    .equals(other.updated, updated)) &&
            (identical(other.desc, desc) ||
                const DeepCollectionEquality().equals(other.desc, desc)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(product) ^
      const DeepCollectionEquality().hash(key) ^
      const DeepCollectionEquality().hash(value) ^
      const DeepCollectionEquality().hash(updated) ^
      const DeepCollectionEquality().hash(desc) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $ConfigExtension on Config {
  Config copyWith(
      {int? id,
      int? product,
      String? key,
      String? value,
      int? updated,
      String? desc,
      int? sort}) {
    return Config(
        id: id ?? this.id,
        product: product ?? this.product,
        key: key ?? this.key,
        value: value ?? this.value,
        updated: updated ?? this.updated,
        desc: desc ?? this.desc,
        sort: sort ?? this.sort);
  }

  Config copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<int?>? product,
      Wrapped<String>? key,
      Wrapped<String>? value,
      Wrapped<int?>? updated,
      Wrapped<String?>? desc,
      Wrapped<int?>? sort}) {
    return Config(
        id: (id != null ? id.value : this.id),
        product: (product != null ? product.value : this.product),
        key: (key != null ? key.value : this.key),
        value: (value != null ? value.value : this.value),
        updated: (updated != null ? updated.value : this.updated),
        desc: (desc != null ? desc.value : this.desc),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class ConfigsPage {
  ConfigsPage({
    required this.data,
    this.pagination,
  });

  factory ConfigsPage.fromJson(Map<String, dynamic> json) =>
      _$ConfigsPageFromJson(json);

  @JsonKey(name: 'data', includeIfNull: false, defaultValue: <Config>[])
  final List<Config> data;
  @JsonKey(name: 'pagination', includeIfNull: false)
  final Pagination? pagination;
  static const fromJsonFactory = _$ConfigsPageFromJson;
  static const toJsonFactory = _$ConfigsPageToJson;
  Map<String, dynamic> toJson() => _$ConfigsPageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ConfigsPage &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)) &&
            (identical(other.pagination, pagination) ||
                const DeepCollectionEquality()
                    .equals(other.pagination, pagination)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(data) ^
      const DeepCollectionEquality().hash(pagination) ^
      runtimeType.hashCode;
}

extension $ConfigsPageExtension on ConfigsPage {
  ConfigsPage copyWith({List<Config>? data, Pagination? pagination}) {
    return ConfigsPage(
        data: data ?? this.data, pagination: pagination ?? this.pagination);
  }

  ConfigsPage copyWithWrapped(
      {Wrapped<List<Config>>? data, Wrapped<Pagination?>? pagination}) {
    return ConfigsPage(
        data: (data != null ? data.value : this.data),
        pagination: (pagination != null ? pagination.value : this.pagination));
  }
}

@JsonSerializable(explicitToJson: true)
class Product {
  Product({
    this.id,
    required this.name,
    this.projId,
    required this.type,
    this.icon,
    this.fbLocalConfigPath,
    this.fbLocalResPath,
    this.fbAdAcctId,
    this.shortName,
    this.fbAppId,
    this.fbPageId,
    this.fbInsId,
    this.fbExcludeAudience,
    this.fbStoreURLAndroid,
    this.fbStoreURLIos,
    this.fbAccessToken,
    this.translation,
    this.cpaMax,
  });

  factory Product.fromJson(Map<String, dynamic> json) =>
      _$ProductFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'projId', includeIfNull: false, defaultValue: '')
  final String? projId;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String type;
  @JsonKey(name: 'icon', includeIfNull: false, defaultValue: '')
  final String? icon;
  @JsonKey(name: 'fbLocalConfigPath', includeIfNull: false, defaultValue: '')
  final String? fbLocalConfigPath;
  @JsonKey(name: 'fbLocalResPath', includeIfNull: false, defaultValue: '')
  final String? fbLocalResPath;
  @JsonKey(name: 'fbAdAcctId', includeIfNull: false, defaultValue: '')
  final String? fbAdAcctId;
  @JsonKey(name: 'shortName', includeIfNull: false, defaultValue: '')
  final String? shortName;
  @JsonKey(name: 'fbAppId', includeIfNull: false, defaultValue: '')
  final String? fbAppId;
  @JsonKey(name: 'fbPageId', includeIfNull: false, defaultValue: '')
  final String? fbPageId;
  @JsonKey(name: 'fbInsId', includeIfNull: false, defaultValue: '')
  final String? fbInsId;
  @JsonKey(name: 'fbExcludeAudience', includeIfNull: false, defaultValue: '')
  final String? fbExcludeAudience;
  @JsonKey(name: 'fbStoreURLAndroid', includeIfNull: false, defaultValue: '')
  final String? fbStoreURLAndroid;
  @JsonKey(name: 'fbStoreURLIos', includeIfNull: false, defaultValue: '')
  final String? fbStoreURLIos;
  @JsonKey(name: 'fbAccessToken', includeIfNull: false, defaultValue: '')
  final String? fbAccessToken;
  @JsonKey(name: 'translation', includeIfNull: false, defaultValue: '')
  final String? translation;
  @JsonKey(name: 'cpaMax', includeIfNull: false, defaultValue: '')
  final String? cpaMax;
  static const fromJsonFactory = _$ProductFromJson;
  static const toJsonFactory = _$ProductToJson;
  Map<String, dynamic> toJson() => _$ProductToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Product &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.projId, projId) ||
                const DeepCollectionEquality().equals(other.projId, projId)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.icon, icon) ||
                const DeepCollectionEquality().equals(other.icon, icon)) &&
            (identical(other.fbLocalConfigPath, fbLocalConfigPath) ||
                const DeepCollectionEquality()
                    .equals(other.fbLocalConfigPath, fbLocalConfigPath)) &&
            (identical(other.fbLocalResPath, fbLocalResPath) ||
                const DeepCollectionEquality()
                    .equals(other.fbLocalResPath, fbLocalResPath)) &&
            (identical(other.fbAdAcctId, fbAdAcctId) ||
                const DeepCollectionEquality()
                    .equals(other.fbAdAcctId, fbAdAcctId)) &&
            (identical(other.shortName, shortName) ||
                const DeepCollectionEquality()
                    .equals(other.shortName, shortName)) &&
            (identical(other.fbAppId, fbAppId) ||
                const DeepCollectionEquality()
                    .equals(other.fbAppId, fbAppId)) &&
            (identical(other.fbPageId, fbPageId) ||
                const DeepCollectionEquality()
                    .equals(other.fbPageId, fbPageId)) &&
            (identical(other.fbInsId, fbInsId) ||
                const DeepCollectionEquality()
                    .equals(other.fbInsId, fbInsId)) &&
            (identical(other.fbExcludeAudience, fbExcludeAudience) ||
                const DeepCollectionEquality()
                    .equals(other.fbExcludeAudience, fbExcludeAudience)) &&
            (identical(other.fbStoreURLAndroid, fbStoreURLAndroid) ||
                const DeepCollectionEquality()
                    .equals(other.fbStoreURLAndroid, fbStoreURLAndroid)) &&
            (identical(other.fbStoreURLIos, fbStoreURLIos) ||
                const DeepCollectionEquality()
                    .equals(other.fbStoreURLIos, fbStoreURLIos)) &&
            (identical(other.fbAccessToken, fbAccessToken) ||
                const DeepCollectionEquality()
                    .equals(other.fbAccessToken, fbAccessToken)) &&
            (identical(other.translation, translation) ||
                const DeepCollectionEquality()
                    .equals(other.translation, translation)) &&
            (identical(other.cpaMax, cpaMax) ||
                const DeepCollectionEquality().equals(other.cpaMax, cpaMax)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(projId) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(icon) ^
      const DeepCollectionEquality().hash(fbLocalConfigPath) ^
      const DeepCollectionEquality().hash(fbLocalResPath) ^
      const DeepCollectionEquality().hash(fbAdAcctId) ^
      const DeepCollectionEquality().hash(shortName) ^
      const DeepCollectionEquality().hash(fbAppId) ^
      const DeepCollectionEquality().hash(fbPageId) ^
      const DeepCollectionEquality().hash(fbInsId) ^
      const DeepCollectionEquality().hash(fbExcludeAudience) ^
      const DeepCollectionEquality().hash(fbStoreURLAndroid) ^
      const DeepCollectionEquality().hash(fbStoreURLIos) ^
      const DeepCollectionEquality().hash(fbAccessToken) ^
      const DeepCollectionEquality().hash(translation) ^
      const DeepCollectionEquality().hash(cpaMax) ^
      runtimeType.hashCode;
}

extension $ProductExtension on Product {
  Product copyWith(
      {int? id,
      String? name,
      String? projId,
      String? type,
      String? icon,
      String? fbLocalConfigPath,
      String? fbLocalResPath,
      String? fbAdAcctId,
      String? shortName,
      String? fbAppId,
      String? fbPageId,
      String? fbInsId,
      String? fbExcludeAudience,
      String? fbStoreURLAndroid,
      String? fbStoreURLIos,
      String? fbAccessToken,
      String? translation,
      String? cpaMax}) {
    return Product(
        id: id ?? this.id,
        name: name ?? this.name,
        projId: projId ?? this.projId,
        type: type ?? this.type,
        icon: icon ?? this.icon,
        fbLocalConfigPath: fbLocalConfigPath ?? this.fbLocalConfigPath,
        fbLocalResPath: fbLocalResPath ?? this.fbLocalResPath,
        fbAdAcctId: fbAdAcctId ?? this.fbAdAcctId,
        shortName: shortName ?? this.shortName,
        fbAppId: fbAppId ?? this.fbAppId,
        fbPageId: fbPageId ?? this.fbPageId,
        fbInsId: fbInsId ?? this.fbInsId,
        fbExcludeAudience: fbExcludeAudience ?? this.fbExcludeAudience,
        fbStoreURLAndroid: fbStoreURLAndroid ?? this.fbStoreURLAndroid,
        fbStoreURLIos: fbStoreURLIos ?? this.fbStoreURLIos,
        fbAccessToken: fbAccessToken ?? this.fbAccessToken,
        translation: translation ?? this.translation,
        cpaMax: cpaMax ?? this.cpaMax);
  }

  Product copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<String>? name,
      Wrapped<String?>? projId,
      Wrapped<String>? type,
      Wrapped<String?>? icon,
      Wrapped<String?>? fbLocalConfigPath,
      Wrapped<String?>? fbLocalResPath,
      Wrapped<String?>? fbAdAcctId,
      Wrapped<String?>? shortName,
      Wrapped<String?>? fbAppId,
      Wrapped<String?>? fbPageId,
      Wrapped<String?>? fbInsId,
      Wrapped<String?>? fbExcludeAudience,
      Wrapped<String?>? fbStoreURLAndroid,
      Wrapped<String?>? fbStoreURLIos,
      Wrapped<String?>? fbAccessToken,
      Wrapped<String?>? translation,
      Wrapped<String?>? cpaMax}) {
    return Product(
        id: (id != null ? id.value : this.id),
        name: (name != null ? name.value : this.name),
        projId: (projId != null ? projId.value : this.projId),
        type: (type != null ? type.value : this.type),
        icon: (icon != null ? icon.value : this.icon),
        fbLocalConfigPath: (fbLocalConfigPath != null
            ? fbLocalConfigPath.value
            : this.fbLocalConfigPath),
        fbLocalResPath: (fbLocalResPath != null
            ? fbLocalResPath.value
            : this.fbLocalResPath),
        fbAdAcctId: (fbAdAcctId != null ? fbAdAcctId.value : this.fbAdAcctId),
        shortName: (shortName != null ? shortName.value : this.shortName),
        fbAppId: (fbAppId != null ? fbAppId.value : this.fbAppId),
        fbPageId: (fbPageId != null ? fbPageId.value : this.fbPageId),
        fbInsId: (fbInsId != null ? fbInsId.value : this.fbInsId),
        fbExcludeAudience: (fbExcludeAudience != null
            ? fbExcludeAudience.value
            : this.fbExcludeAudience),
        fbStoreURLAndroid: (fbStoreURLAndroid != null
            ? fbStoreURLAndroid.value
            : this.fbStoreURLAndroid),
        fbStoreURLIos:
            (fbStoreURLIos != null ? fbStoreURLIos.value : this.fbStoreURLIos),
        fbAccessToken:
            (fbAccessToken != null ? fbAccessToken.value : this.fbAccessToken),
        translation:
            (translation != null ? translation.value : this.translation),
        cpaMax: (cpaMax != null ? cpaMax.value : this.cpaMax));
  }
}

@JsonSerializable(explicitToJson: true)
class ProductsPage {
  ProductsPage({
    required this.data,
    this.pagination,
  });

  factory ProductsPage.fromJson(Map<String, dynamic> json) =>
      _$ProductsPageFromJson(json);

  @JsonKey(name: 'data', includeIfNull: false, defaultValue: <Product>[])
  final List<Product> data;
  @JsonKey(name: 'pagination', includeIfNull: false)
  final Pagination? pagination;
  static const fromJsonFactory = _$ProductsPageFromJson;
  static const toJsonFactory = _$ProductsPageToJson;
  Map<String, dynamic> toJson() => _$ProductsPageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProductsPage &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)) &&
            (identical(other.pagination, pagination) ||
                const DeepCollectionEquality()
                    .equals(other.pagination, pagination)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(data) ^
      const DeepCollectionEquality().hash(pagination) ^
      runtimeType.hashCode;
}

extension $ProductsPageExtension on ProductsPage {
  ProductsPage copyWith({List<Product>? data, Pagination? pagination}) {
    return ProductsPage(
        data: data ?? this.data, pagination: pagination ?? this.pagination);
  }

  ProductsPage copyWithWrapped(
      {Wrapped<List<Product>>? data, Wrapped<Pagination?>? pagination}) {
    return ProductsPage(
        data: (data != null ? data.value : this.data),
        pagination: (pagination != null ? pagination.value : this.pagination));
  }
}

@JsonSerializable(explicitToJson: true)
class DailyData {
  DailyData({
    this.date,
    this.spend,
    this.$client,
    this.conversion,
    this.day,
    this.userCnt,
    this.adIncome,
    this.amount,
    this.cpa,
    this.roas,
  });

  factory DailyData.fromJson(Map<String, dynamic> json) =>
      _$DailyDataFromJson(json);

  @JsonKey(name: 'date', includeIfNull: false, defaultValue: '')
  final String? date;
  @JsonKey(name: 'spend', includeIfNull: false)
  final double? spend;
  @JsonKey(name: 'client', includeIfNull: false)
  final num? $client;
  @JsonKey(name: 'conversion', includeIfNull: false)
  final double? conversion;
  @JsonKey(name: 'day', includeIfNull: false)
  final num? day;
  @JsonKey(name: 'userCnt', includeIfNull: false)
  final num? userCnt;
  @JsonKey(name: 'adIncome', includeIfNull: false)
  final double? adIncome;
  @JsonKey(name: 'amount', includeIfNull: false)
  final double? amount;
  @JsonKey(name: 'cpa', includeIfNull: false)
  final double? cpa;
  @JsonKey(name: 'roas', includeIfNull: false)
  final double? roas;
  static const fromJsonFactory = _$DailyDataFromJson;
  static const toJsonFactory = _$DailyDataToJson;
  Map<String, dynamic> toJson() => _$DailyDataToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DailyData &&
            (identical(other.date, date) ||
                const DeepCollectionEquality().equals(other.date, date)) &&
            (identical(other.spend, spend) ||
                const DeepCollectionEquality().equals(other.spend, spend)) &&
            (identical(other.$client, $client) ||
                const DeepCollectionEquality()
                    .equals(other.$client, $client)) &&
            (identical(other.conversion, conversion) ||
                const DeepCollectionEquality()
                    .equals(other.conversion, conversion)) &&
            (identical(other.day, day) ||
                const DeepCollectionEquality().equals(other.day, day)) &&
            (identical(other.userCnt, userCnt) ||
                const DeepCollectionEquality()
                    .equals(other.userCnt, userCnt)) &&
            (identical(other.adIncome, adIncome) ||
                const DeepCollectionEquality()
                    .equals(other.adIncome, adIncome)) &&
            (identical(other.amount, amount) ||
                const DeepCollectionEquality().equals(other.amount, amount)) &&
            (identical(other.cpa, cpa) ||
                const DeepCollectionEquality().equals(other.cpa, cpa)) &&
            (identical(other.roas, roas) ||
                const DeepCollectionEquality().equals(other.roas, roas)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(date) ^
      const DeepCollectionEquality().hash(spend) ^
      const DeepCollectionEquality().hash($client) ^
      const DeepCollectionEquality().hash(conversion) ^
      const DeepCollectionEquality().hash(day) ^
      const DeepCollectionEquality().hash(userCnt) ^
      const DeepCollectionEquality().hash(adIncome) ^
      const DeepCollectionEquality().hash(amount) ^
      const DeepCollectionEquality().hash(cpa) ^
      const DeepCollectionEquality().hash(roas) ^
      runtimeType.hashCode;
}

extension $DailyDataExtension on DailyData {
  DailyData copyWith(
      {String? date,
      double? spend,
      num? $client,
      double? conversion,
      num? day,
      num? userCnt,
      double? adIncome,
      double? amount,
      double? cpa,
      double? roas}) {
    return DailyData(
        date: date ?? this.date,
        spend: spend ?? this.spend,
        $client: $client ?? this.$client,
        conversion: conversion ?? this.conversion,
        day: day ?? this.day,
        userCnt: userCnt ?? this.userCnt,
        adIncome: adIncome ?? this.adIncome,
        amount: amount ?? this.amount,
        cpa: cpa ?? this.cpa,
        roas: roas ?? this.roas);
  }

  DailyData copyWithWrapped(
      {Wrapped<String?>? date,
      Wrapped<double?>? spend,
      Wrapped<num?>? $client,
      Wrapped<double?>? conversion,
      Wrapped<num?>? day,
      Wrapped<num?>? userCnt,
      Wrapped<double?>? adIncome,
      Wrapped<double?>? amount,
      Wrapped<double?>? cpa,
      Wrapped<double?>? roas}) {
    return DailyData(
        date: (date != null ? date.value : this.date),
        spend: (spend != null ? spend.value : this.spend),
        $client: ($client != null ? $client.value : this.$client),
        conversion: (conversion != null ? conversion.value : this.conversion),
        day: (day != null ? day.value : this.day),
        userCnt: (userCnt != null ? userCnt.value : this.userCnt),
        adIncome: (adIncome != null ? adIncome.value : this.adIncome),
        amount: (amount != null ? amount.value : this.amount),
        cpa: (cpa != null ? cpa.value : this.cpa),
        roas: (roas != null ? roas.value : this.roas));
  }
}

@JsonSerializable(explicitToJson: true)
class AdCampaign {
  AdCampaign({
    this.platform,
    this.src,
    required this.campaignID,
    this.campaign,
    this.country,
    this.code,
    this.dailyData,
  });

  factory AdCampaign.fromJson(Map<String, dynamic> json) =>
      _$AdCampaignFromJson(json);

  @JsonKey(name: 'platform', includeIfNull: false, defaultValue: '')
  final String? platform;
  @JsonKey(name: 'src', includeIfNull: false, defaultValue: '')
  final String? src;
  @JsonKey(name: 'campaignID', includeIfNull: false, defaultValue: '')
  final String campaignID;
  @JsonKey(name: 'campaign', includeIfNull: false, defaultValue: '')
  final String? campaign;
  @JsonKey(name: 'country', includeIfNull: false, defaultValue: '')
  final String? country;
  @JsonKey(name: 'code', includeIfNull: false, defaultValue: '')
  final String? code;
  @JsonKey(name: 'dailyData', includeIfNull: false, defaultValue: <DailyData>[])
  final List<DailyData>? dailyData;
  static const fromJsonFactory = _$AdCampaignFromJson;
  static const toJsonFactory = _$AdCampaignToJson;
  Map<String, dynamic> toJson() => _$AdCampaignToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AdCampaign &&
            (identical(other.platform, platform) ||
                const DeepCollectionEquality()
                    .equals(other.platform, platform)) &&
            (identical(other.src, src) ||
                const DeepCollectionEquality().equals(other.src, src)) &&
            (identical(other.campaignID, campaignID) ||
                const DeepCollectionEquality()
                    .equals(other.campaignID, campaignID)) &&
            (identical(other.campaign, campaign) ||
                const DeepCollectionEquality()
                    .equals(other.campaign, campaign)) &&
            (identical(other.country, country) ||
                const DeepCollectionEquality()
                    .equals(other.country, country)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.dailyData, dailyData) ||
                const DeepCollectionEquality()
                    .equals(other.dailyData, dailyData)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(platform) ^
      const DeepCollectionEquality().hash(src) ^
      const DeepCollectionEquality().hash(campaignID) ^
      const DeepCollectionEquality().hash(campaign) ^
      const DeepCollectionEquality().hash(country) ^
      const DeepCollectionEquality().hash(code) ^
      const DeepCollectionEquality().hash(dailyData) ^
      runtimeType.hashCode;
}

extension $AdCampaignExtension on AdCampaign {
  AdCampaign copyWith(
      {String? platform,
      String? src,
      String? campaignID,
      String? campaign,
      String? country,
      String? code,
      List<DailyData>? dailyData}) {
    return AdCampaign(
        platform: platform ?? this.platform,
        src: src ?? this.src,
        campaignID: campaignID ?? this.campaignID,
        campaign: campaign ?? this.campaign,
        country: country ?? this.country,
        code: code ?? this.code,
        dailyData: dailyData ?? this.dailyData);
  }

  AdCampaign copyWithWrapped(
      {Wrapped<String?>? platform,
      Wrapped<String?>? src,
      Wrapped<String>? campaignID,
      Wrapped<String?>? campaign,
      Wrapped<String?>? country,
      Wrapped<String?>? code,
      Wrapped<List<DailyData>?>? dailyData}) {
    return AdCampaign(
        platform: (platform != null ? platform.value : this.platform),
        src: (src != null ? src.value : this.src),
        campaignID: (campaignID != null ? campaignID.value : this.campaignID),
        campaign: (campaign != null ? campaign.value : this.campaign),
        country: (country != null ? country.value : this.country),
        code: (code != null ? code.value : this.code),
        dailyData: (dailyData != null ? dailyData.value : this.dailyData));
  }
}

@JsonSerializable(explicitToJson: true)
class ApiUsage {
  ApiUsage({
    this.regainTime,
  });

  factory ApiUsage.fromJson(Map<String, dynamic> json) =>
      _$ApiUsageFromJson(json);

  @JsonKey(name: 'regainTime', includeIfNull: false)
  final int? regainTime;
  static const fromJsonFactory = _$ApiUsageFromJson;
  static const toJsonFactory = _$ApiUsageToJson;
  Map<String, dynamic> toJson() => _$ApiUsageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ApiUsage &&
            (identical(other.regainTime, regainTime) ||
                const DeepCollectionEquality()
                    .equals(other.regainTime, regainTime)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(regainTime) ^ runtimeType.hashCode;
}

extension $ApiUsageExtension on ApiUsage {
  ApiUsage copyWith({int? regainTime}) {
    return ApiUsage(regainTime: regainTime ?? this.regainTime);
  }

  ApiUsage copyWithWrapped({Wrapped<int?>? regainTime}) {
    return ApiUsage(
        regainTime: (regainTime != null ? regainTime.value : this.regainTime));
  }
}

@JsonSerializable(explicitToJson: true)
class UnpublishCountryInfo {
  UnpublishCountryInfo({
    this.countryCode,
    this.countryName,
    this.languageCode,
    this.languageName,
    this.pf,
    this.isPublish,
    this.spend,
    this.cpa,
    this.adContents,
    this.adTitles,
  });

  factory UnpublishCountryInfo.fromJson(Map<String, dynamic> json) =>
      _$UnpublishCountryInfoFromJson(json);

  @JsonKey(name: 'countryCode', includeIfNull: false, defaultValue: '')
  final String? countryCode;
  @JsonKey(name: 'countryName', includeIfNull: false, defaultValue: '')
  final String? countryName;
  @JsonKey(name: 'languageCode', includeIfNull: false, defaultValue: '')
  final String? languageCode;
  @JsonKey(name: 'languageName', includeIfNull: false, defaultValue: '')
  final String? languageName;
  @JsonKey(name: 'pf', includeIfNull: false, defaultValue: '')
  final String? pf;
  @JsonKey(name: 'isPublish', includeIfNull: false)
  final bool? isPublish;
  @JsonKey(name: 'spend', includeIfNull: false)
  final int? spend;
  @JsonKey(name: 'cpa', includeIfNull: false, defaultValue: '')
  final String? cpa;
  @JsonKey(name: 'adContents', includeIfNull: false, defaultValue: <String>[])
  final List<String>? adContents;
  @JsonKey(name: 'adTitles', includeIfNull: false, defaultValue: <String>[])
  final List<String>? adTitles;
  static const fromJsonFactory = _$UnpublishCountryInfoFromJson;
  static const toJsonFactory = _$UnpublishCountryInfoToJson;
  Map<String, dynamic> toJson() => _$UnpublishCountryInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UnpublishCountryInfo &&
            (identical(other.countryCode, countryCode) ||
                const DeepCollectionEquality()
                    .equals(other.countryCode, countryCode)) &&
            (identical(other.countryName, countryName) ||
                const DeepCollectionEquality()
                    .equals(other.countryName, countryName)) &&
            (identical(other.languageCode, languageCode) ||
                const DeepCollectionEquality()
                    .equals(other.languageCode, languageCode)) &&
            (identical(other.languageName, languageName) ||
                const DeepCollectionEquality()
                    .equals(other.languageName, languageName)) &&
            (identical(other.pf, pf) ||
                const DeepCollectionEquality().equals(other.pf, pf)) &&
            (identical(other.isPublish, isPublish) ||
                const DeepCollectionEquality()
                    .equals(other.isPublish, isPublish)) &&
            (identical(other.spend, spend) ||
                const DeepCollectionEquality().equals(other.spend, spend)) &&
            (identical(other.cpa, cpa) ||
                const DeepCollectionEquality().equals(other.cpa, cpa)) &&
            (identical(other.adContents, adContents) ||
                const DeepCollectionEquality()
                    .equals(other.adContents, adContents)) &&
            (identical(other.adTitles, adTitles) ||
                const DeepCollectionEquality()
                    .equals(other.adTitles, adTitles)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(countryCode) ^
      const DeepCollectionEquality().hash(countryName) ^
      const DeepCollectionEquality().hash(languageCode) ^
      const DeepCollectionEquality().hash(languageName) ^
      const DeepCollectionEquality().hash(pf) ^
      const DeepCollectionEquality().hash(isPublish) ^
      const DeepCollectionEquality().hash(spend) ^
      const DeepCollectionEquality().hash(cpa) ^
      const DeepCollectionEquality().hash(adContents) ^
      const DeepCollectionEquality().hash(adTitles) ^
      runtimeType.hashCode;
}

extension $UnpublishCountryInfoExtension on UnpublishCountryInfo {
  UnpublishCountryInfo copyWith(
      {String? countryCode,
      String? countryName,
      String? languageCode,
      String? languageName,
      String? pf,
      bool? isPublish,
      int? spend,
      String? cpa,
      List<String>? adContents,
      List<String>? adTitles}) {
    return UnpublishCountryInfo(
        countryCode: countryCode ?? this.countryCode,
        countryName: countryName ?? this.countryName,
        languageCode: languageCode ?? this.languageCode,
        languageName: languageName ?? this.languageName,
        pf: pf ?? this.pf,
        isPublish: isPublish ?? this.isPublish,
        spend: spend ?? this.spend,
        cpa: cpa ?? this.cpa,
        adContents: adContents ?? this.adContents,
        adTitles: adTitles ?? this.adTitles);
  }

  UnpublishCountryInfo copyWithWrapped(
      {Wrapped<String?>? countryCode,
      Wrapped<String?>? countryName,
      Wrapped<String?>? languageCode,
      Wrapped<String?>? languageName,
      Wrapped<String?>? pf,
      Wrapped<bool?>? isPublish,
      Wrapped<int?>? spend,
      Wrapped<String?>? cpa,
      Wrapped<List<String>?>? adContents,
      Wrapped<List<String>?>? adTitles}) {
    return UnpublishCountryInfo(
        countryCode:
            (countryCode != null ? countryCode.value : this.countryCode),
        countryName:
            (countryName != null ? countryName.value : this.countryName),
        languageCode:
            (languageCode != null ? languageCode.value : this.languageCode),
        languageName:
            (languageName != null ? languageName.value : this.languageName),
        pf: (pf != null ? pf.value : this.pf),
        isPublish: (isPublish != null ? isPublish.value : this.isPublish),
        spend: (spend != null ? spend.value : this.spend),
        cpa: (cpa != null ? cpa.value : this.cpa),
        adContents: (adContents != null ? adContents.value : this.adContents),
        adTitles: (adTitles != null ? adTitles.value : this.adTitles));
  }
}

@JsonSerializable(explicitToJson: true)
class AdCampaignGet$Response {
  AdCampaignGet$Response({
    this.isFull,
    required this.data,
    this.pagination,
  });

  factory AdCampaignGet$Response.fromJson(Map<String, dynamic> json) =>
      _$AdCampaignGet$ResponseFromJson(json);

  @JsonKey(name: 'isFull', includeIfNull: false)
  final bool? isFull;
  @JsonKey(name: 'data', includeIfNull: false, defaultValue: <AdCampaign>[])
  final List<AdCampaign> data;
  @JsonKey(name: 'pagination', includeIfNull: false)
  final Pagination? pagination;
  static const fromJsonFactory = _$AdCampaignGet$ResponseFromJson;
  static const toJsonFactory = _$AdCampaignGet$ResponseToJson;
  Map<String, dynamic> toJson() => _$AdCampaignGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AdCampaignGet$Response &&
            (identical(other.isFull, isFull) ||
                const DeepCollectionEquality().equals(other.isFull, isFull)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)) &&
            (identical(other.pagination, pagination) ||
                const DeepCollectionEquality()
                    .equals(other.pagination, pagination)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(isFull) ^
      const DeepCollectionEquality().hash(data) ^
      const DeepCollectionEquality().hash(pagination) ^
      runtimeType.hashCode;
}

extension $AdCampaignGet$ResponseExtension on AdCampaignGet$Response {
  AdCampaignGet$Response copyWith(
      {bool? isFull, List<AdCampaign>? data, Pagination? pagination}) {
    return AdCampaignGet$Response(
        isFull: isFull ?? this.isFull,
        data: data ?? this.data,
        pagination: pagination ?? this.pagination);
  }

  AdCampaignGet$Response copyWithWrapped(
      {Wrapped<bool?>? isFull,
      Wrapped<List<AdCampaign>>? data,
      Wrapped<Pagination?>? pagination}) {
    return AdCampaignGet$Response(
        isFull: (isFull != null ? isFull.value : this.isFull),
        data: (data != null ? data.value : this.data),
        pagination: (pagination != null ? pagination.value : this.pagination));
  }
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
