// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;

part 'openapi_request_bodies.swagger.chopper.dart';
part 'openapi_request_bodies.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class OpenapiRequestBodies extends ChopperService {
  static OpenapiRequestBodies create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$OpenapiRequestBodies(client);
    }

    final newClient = ChopperClient(
        services: [_$OpenapiRequestBodies()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$OpenapiRequestBodies(newClient);
  }

  ///List Compartments
  ///@param page what page to render
  ///@param itemsPerPage item count to render per page
  Future<chopper.Response<List<Compartment1151786357View>>> compartmentsGet({
    int? page,
    int? itemsPerPage,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Compartment1151786357View,
        () => Compartment1151786357View.fromJsonFactory);

    return _compartmentsGet(
        page: page, itemsPerPage: itemsPerPage, cacheControl: cacheControl);
  }

  ///List Compartments
  ///@param page what page to render
  ///@param itemsPerPage item count to render per page
  @Get(path: '/compartments')
  Future<chopper.Response<List<Compartment1151786357View>>> _compartmentsGet({
    @Query('page') int? page,
    @Query('itemsPerPage') int? itemsPerPage,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new Compartment
  Future<chopper.Response<Compartment1151786357View>> compartmentsPost({
    String? cacheControl,
    required CompartmentsPost$RequestBody? body,
  }) {
    generatedMapping.putIfAbsent(Compartment1151786357View,
        () => Compartment1151786357View.fromJsonFactory);

    return _compartmentsPost(cacheControl: cacheControl, body: body);
  }

  ///Create a new Compartment
  @Post(path: '/compartments')
  Future<chopper.Response<Compartment1151786357View>> _compartmentsPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required CompartmentsPost$RequestBody? body,
  });

  ///Find a Compartment by ID
  ///@param id ID of the Compartment
  Future<chopper.Response<Compartment1151786357View>> compartmentsIdGet({
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Compartment1151786357View,
        () => Compartment1151786357View.fromJsonFactory);

    return _compartmentsIdGet(id: id, cacheControl: cacheControl);
  }

  ///Find a Compartment by ID
  ///@param id ID of the Compartment
  @Get(path: '/compartments/{id}')
  Future<chopper.Response<Compartment1151786357View>> _compartmentsIdGet({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Deletes a Compartment by ID
  ///@param id ID of the Compartment to delete
  Future<chopper.Response> compartmentsIdDelete({
    required int? id,
    String? cacheControl,
  }) {
    return _compartmentsIdDelete(id: id, cacheControl: cacheControl);
  }

  ///Deletes a Compartment by ID
  ///@param id ID of the Compartment to delete
  @Delete(path: '/compartments/{id}')
  Future<chopper.Response> _compartmentsIdDelete({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Updates a Compartment
  ///@param id ID of the Compartment to update
  Future<chopper.Response<Compartment1151786357View>> compartmentsIdPatch({
    required int? id,
    String? cacheControl,
    required CompartmentsIdPatch$RequestBody? body,
  }) {
    generatedMapping.putIfAbsent(Compartment1151786357View,
        () => Compartment1151786357View.fromJsonFactory);

    return _compartmentsIdPatch(id: id, cacheControl: cacheControl, body: body);
  }

  ///Updates a Compartment
  ///@param id ID of the Compartment to update
  @Patch(path: '/compartments/{id}')
  Future<chopper.Response<Compartment1151786357View>> _compartmentsIdPatch({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
    @Body() required CompartmentsIdPatch$RequestBody? body,
  });

  ///Find the attached Items
  ///@param page ID of the Compartment
  ///@param itemsPerPage item count to render per page
  ///@param id ID of the Compartment
  Future<chopper.Response<List<Item1509516544View>>> compartmentsIdContentsGet({
    int? page,
    int? itemsPerPage,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Item1509516544View, () => Item1509516544View.fromJsonFactory);

    return _compartmentsIdContentsGet(
        page: page,
        itemsPerPage: itemsPerPage,
        id: id,
        cacheControl: cacheControl);
  }

  ///Find the attached Items
  ///@param page ID of the Compartment
  ///@param itemsPerPage item count to render per page
  ///@param id ID of the Compartment
  @Get(path: '/compartments/{id}/contents')
  Future<chopper.Response<List<Item1509516544View>>>
      _compartmentsIdContentsGet({
    @Query('page') int? page,
    @Query('itemsPerPage') int? itemsPerPage,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Find the attached Fridge
  ///@param id ID of the Compartment
  Future<chopper.Response<Fridge2716213877View>> compartmentsIdFridgeGet({
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Fridge2716213877View, () => Fridge2716213877View.fromJsonFactory);

    return _compartmentsIdFridgeGet(id: id, cacheControl: cacheControl);
  }

  ///Find the attached Fridge
  ///@param id ID of the Compartment
  @Get(path: '/compartments/{id}/fridge')
  Future<chopper.Response<Fridge2716213877View>> _compartmentsIdFridgeGet({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///List Fridges
  ///@param page what page to render
  ///@param itemsPerPage item count to render per page
  Future<chopper.Response<List<Fridge2716213877View>>> fridgesGet({
    int? page,
    int? itemsPerPage,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Fridge2716213877View, () => Fridge2716213877View.fromJsonFactory);

    return _fridgesGet(
        page: page, itemsPerPage: itemsPerPage, cacheControl: cacheControl);
  }

  ///List Fridges
  ///@param page what page to render
  ///@param itemsPerPage item count to render per page
  @Get(path: '/fridges')
  Future<chopper.Response<List<Fridge2716213877View>>> _fridgesGet({
    @Query('page') int? page,
    @Query('itemsPerPage') int? itemsPerPage,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new Fridge
  Future<chopper.Response<Fridge2716213877View>> fridgesPost({
    String? cacheControl,
    required FridgesPost$RequestBody? body,
  }) {
    generatedMapping.putIfAbsent(
        Fridge2716213877View, () => Fridge2716213877View.fromJsonFactory);

    return _fridgesPost(cacheControl: cacheControl, body: body);
  }

  ///Create a new Fridge
  @Post(path: '/fridges')
  Future<chopper.Response<Fridge2716213877View>> _fridgesPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FridgesPost$RequestBody? body,
  });

  ///Find a Fridge by ID
  ///@param id ID of the Fridge
  Future<chopper.Response<Fridge2716213877View>> fridgesIdGet({
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Fridge2716213877View, () => Fridge2716213877View.fromJsonFactory);

    return _fridgesIdGet(id: id, cacheControl: cacheControl);
  }

  ///Find a Fridge by ID
  ///@param id ID of the Fridge
  @Get(path: '/fridges/{id}')
  Future<chopper.Response<Fridge2716213877View>> _fridgesIdGet({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Updates a Fridge
  ///@param id ID of the Fridge to update
  Future<chopper.Response<Fridge2716213877View>> fridgesIdPatch({
    required int? id,
    String? cacheControl,
    required FridgesIdPatch$RequestBody? body,
  }) {
    generatedMapping.putIfAbsent(
        Fridge2716213877View, () => Fridge2716213877View.fromJsonFactory);

    return _fridgesIdPatch(id: id, cacheControl: cacheControl, body: body);
  }

  ///Updates a Fridge
  ///@param id ID of the Fridge to update
  @Patch(path: '/fridges/{id}')
  Future<chopper.Response<Fridge2716213877View>> _fridgesIdPatch({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
    @Body() required FridgesIdPatch$RequestBody? body,
  });

  ///Find the attached Compartments
  ///@param page ID of the Fridge
  ///@param itemsPerPage item count to render per page
  ///@param id ID of the Fridge
  Future<chopper.Response<List<Compartment1151786357View>>>
      fridgesIdCompartmentsGet({
    int? page,
    int? itemsPerPage,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Compartment1151786357View,
        () => Compartment1151786357View.fromJsonFactory);

    return _fridgesIdCompartmentsGet(
        page: page,
        itemsPerPage: itemsPerPage,
        id: id,
        cacheControl: cacheControl);
  }

  ///Find the attached Compartments
  ///@param page ID of the Fridge
  ///@param itemsPerPage item count to render per page
  ///@param id ID of the Fridge
  @Get(path: '/fridges/{id}/compartments')
  Future<chopper.Response<List<Compartment1151786357View>>>
      _fridgesIdCompartmentsGet({
    @Query('page') int? page,
    @Query('itemsPerPage') int? itemsPerPage,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Return everything stored in this fridge
  Future<chopper.Response<Object>> fridgesIdContentsGet({
    required int? id,
    String? cacheControl,
  }) {
    return _fridgesIdContentsGet(id: id, cacheControl: cacheControl);
  }

  ///Return everything stored in this fridge
  @Get(path: '/fridges/{id}/contents')
  Future<chopper.Response<Object>> _fridgesIdContentsGet({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///List Items
  ///@param page what page to render
  ///@param itemsPerPage item count to render per page
  Future<chopper.Response<List<Item1509516544View>>> itemsGet({
    int? page,
    int? itemsPerPage,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Item1509516544View, () => Item1509516544View.fromJsonFactory);

    return _itemsGet(
        page: page, itemsPerPage: itemsPerPage, cacheControl: cacheControl);
  }

  ///List Items
  ///@param page what page to render
  ///@param itemsPerPage item count to render per page
  @Get(path: '/items')
  Future<chopper.Response<List<Item1509516544View>>> _itemsGet({
    @Query('page') int? page,
    @Query('itemsPerPage') int? itemsPerPage,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new Item
  Future<chopper.Response<Item1509516544View>> itemsPost({
    String? cacheControl,
    required ItemsPost$RequestBody? body,
  }) {
    generatedMapping.putIfAbsent(
        Item1509516544View, () => Item1509516544View.fromJsonFactory);

    return _itemsPost(cacheControl: cacheControl, body: body);
  }

  ///Create a new Item
  @Post(path: '/items')
  Future<chopper.Response<Item1509516544View>> _itemsPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required ItemsPost$RequestBody? body,
  });
}

@JsonSerializable(explicitToJson: true)
class Compartment1151786357View {
  Compartment1151786357View({
    required this.id,
    required this.name,
  });

  factory Compartment1151786357View.fromJson(Map<String, dynamic> json) =>
      _$Compartment1151786357ViewFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int id;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  static const fromJsonFactory = _$Compartment1151786357ViewFromJson;
  static const toJsonFactory = _$Compartment1151786357ViewToJson;
  Map<String, dynamic> toJson() => _$Compartment1151786357ViewToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Compartment1151786357View &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(name) ^
      runtimeType.hashCode;
}

extension $Compartment1151786357ViewExtension on Compartment1151786357View {
  Compartment1151786357View copyWith({int? id, String? name}) {
    return Compartment1151786357View(
        id: id ?? this.id, name: name ?? this.name);
  }

  Compartment1151786357View copyWithWrapped(
      {Wrapped<int>? id, Wrapped<String>? name}) {
    return Compartment1151786357View(
        id: (id != null ? id.value : this.id),
        name: (name != null ? name.value : this.name));
  }
}

@JsonSerializable(explicitToJson: true)
class Fridge2716213877View {
  Fridge2716213877View({
    required this.id,
    required this.title,
  });

  factory Fridge2716213877View.fromJson(Map<String, dynamic> json) =>
      _$Fridge2716213877ViewFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int id;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  static const fromJsonFactory = _$Fridge2716213877ViewFromJson;
  static const toJsonFactory = _$Fridge2716213877ViewToJson;
  Map<String, dynamic> toJson() => _$Fridge2716213877ViewToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Fridge2716213877View &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(title) ^
      runtimeType.hashCode;
}

extension $Fridge2716213877ViewExtension on Fridge2716213877View {
  Fridge2716213877View copyWith({int? id, String? title}) {
    return Fridge2716213877View(id: id ?? this.id, title: title ?? this.title);
  }

  Fridge2716213877View copyWithWrapped(
      {Wrapped<int>? id, Wrapped<String>? title}) {
    return Fridge2716213877View(
        id: (id != null ? id.value : this.id),
        title: (title != null ? title.value : this.title));
  }
}

@JsonSerializable(explicitToJson: true)
class Item1509516544View {
  Item1509516544View({
    required this.id,
    required this.name,
  });

  factory Item1509516544View.fromJson(Map<String, dynamic> json) =>
      _$Item1509516544ViewFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int id;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  static const fromJsonFactory = _$Item1509516544ViewFromJson;
  static const toJsonFactory = _$Item1509516544ViewToJson;
  Map<String, dynamic> toJson() => _$Item1509516544ViewToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Item1509516544View &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(name) ^
      runtimeType.hashCode;
}

extension $Item1509516544ViewExtension on Item1509516544View {
  Item1509516544View copyWith({int? id, String? name}) {
    return Item1509516544View(id: id ?? this.id, name: name ?? this.name);
  }

  Item1509516544View copyWithWrapped(
      {Wrapped<int>? id, Wrapped<String>? name}) {
    return Item1509516544View(
        id: (id != null ? id.value : this.id),
        name: (name != null ? name.value : this.name));
  }
}

@JsonSerializable(explicitToJson: true)
class $400 {
  $400({
    this.code,
    this.errors,
    this.status,
  });

  factory $400.fromJson(Map<String, dynamic> json) => _$$400FromJson(json);

  @JsonKey(name: 'code', includeIfNull: false)
  final int? code;
  @JsonKey(name: 'errors', includeIfNull: false)
  final Object? errors;
  @JsonKey(name: 'status', includeIfNull: false, defaultValue: '')
  final String? status;
  static const fromJsonFactory = _$$400FromJson;
  static const toJsonFactory = _$$400ToJson;
  Map<String, dynamic> toJson() => _$$400ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is $400 &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.errors, errors) ||
                const DeepCollectionEquality().equals(other.errors, errors)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(code) ^
      const DeepCollectionEquality().hash(errors) ^
      const DeepCollectionEquality().hash(status) ^
      runtimeType.hashCode;
}

extension $$400Extension on $400 {
  $400 copyWith({int? code, Object? errors, String? status}) {
    return $400(
        code: code ?? this.code,
        errors: errors ?? this.errors,
        status: status ?? this.status);
  }

  $400 copyWithWrapped(
      {Wrapped<int?>? code,
      Wrapped<Object?>? errors,
      Wrapped<String?>? status}) {
    return $400(
        code: (code != null ? code.value : this.code),
        errors: (errors != null ? errors.value : this.errors),
        status: (status != null ? status.value : this.status));
  }
}

@JsonSerializable(explicitToJson: true)
class $403 {
  $403({
    this.code,
    this.errors,
    this.status,
  });

  factory $403.fromJson(Map<String, dynamic> json) => _$$403FromJson(json);

  @JsonKey(name: 'code', includeIfNull: false)
  final int? code;
  @JsonKey(name: 'errors', includeIfNull: false)
  final Object? errors;
  @JsonKey(name: 'status', includeIfNull: false, defaultValue: '')
  final String? status;
  static const fromJsonFactory = _$$403FromJson;
  static const toJsonFactory = _$$403ToJson;
  Map<String, dynamic> toJson() => _$$403ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is $403 &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.errors, errors) ||
                const DeepCollectionEquality().equals(other.errors, errors)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(code) ^
      const DeepCollectionEquality().hash(errors) ^
      const DeepCollectionEquality().hash(status) ^
      runtimeType.hashCode;
}

extension $$403Extension on $403 {
  $403 copyWith({int? code, Object? errors, String? status}) {
    return $403(
        code: code ?? this.code,
        errors: errors ?? this.errors,
        status: status ?? this.status);
  }

  $403 copyWithWrapped(
      {Wrapped<int?>? code,
      Wrapped<Object?>? errors,
      Wrapped<String?>? status}) {
    return $403(
        code: (code != null ? code.value : this.code),
        errors: (errors != null ? errors.value : this.errors),
        status: (status != null ? status.value : this.status));
  }
}

@JsonSerializable(explicitToJson: true)
class $404 {
  $404({
    this.code,
    this.errors,
    this.status,
  });

  factory $404.fromJson(Map<String, dynamic> json) => _$$404FromJson(json);

  @JsonKey(name: 'code', includeIfNull: false)
  final int? code;
  @JsonKey(name: 'errors', includeIfNull: false)
  final Object? errors;
  @JsonKey(name: 'status', includeIfNull: false, defaultValue: '')
  final String? status;
  static const fromJsonFactory = _$$404FromJson;
  static const toJsonFactory = _$$404ToJson;
  Map<String, dynamic> toJson() => _$$404ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is $404 &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.errors, errors) ||
                const DeepCollectionEquality().equals(other.errors, errors)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(code) ^
      const DeepCollectionEquality().hash(errors) ^
      const DeepCollectionEquality().hash(status) ^
      runtimeType.hashCode;
}

extension $$404Extension on $404 {
  $404 copyWith({int? code, Object? errors, String? status}) {
    return $404(
        code: code ?? this.code,
        errors: errors ?? this.errors,
        status: status ?? this.status);
  }

  $404 copyWithWrapped(
      {Wrapped<int?>? code,
      Wrapped<Object?>? errors,
      Wrapped<String?>? status}) {
    return $404(
        code: (code != null ? code.value : this.code),
        errors: (errors != null ? errors.value : this.errors),
        status: (status != null ? status.value : this.status));
  }
}

@JsonSerializable(explicitToJson: true)
class $409 {
  $409({
    this.code,
    this.errors,
    this.status,
  });

  factory $409.fromJson(Map<String, dynamic> json) => _$$409FromJson(json);

  @JsonKey(name: 'code', includeIfNull: false)
  final int? code;
  @JsonKey(name: 'errors', includeIfNull: false)
  final Object? errors;
  @JsonKey(name: 'status', includeIfNull: false, defaultValue: '')
  final String? status;
  static const fromJsonFactory = _$$409FromJson;
  static const toJsonFactory = _$$409ToJson;
  Map<String, dynamic> toJson() => _$$409ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is $409 &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.errors, errors) ||
                const DeepCollectionEquality().equals(other.errors, errors)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(code) ^
      const DeepCollectionEquality().hash(errors) ^
      const DeepCollectionEquality().hash(status) ^
      runtimeType.hashCode;
}

extension $$409Extension on $409 {
  $409 copyWith({int? code, Object? errors, String? status}) {
    return $409(
        code: code ?? this.code,
        errors: errors ?? this.errors,
        status: status ?? this.status);
  }

  $409 copyWithWrapped(
      {Wrapped<int?>? code,
      Wrapped<Object?>? errors,
      Wrapped<String?>? status}) {
    return $409(
        code: (code != null ? code.value : this.code),
        errors: (errors != null ? errors.value : this.errors),
        status: (status != null ? status.value : this.status));
  }
}

@JsonSerializable(explicitToJson: true)
class $500 {
  $500({
    this.code,
    this.errors,
    this.status,
  });

  factory $500.fromJson(Map<String, dynamic> json) => _$$500FromJson(json);

  @JsonKey(name: 'code', includeIfNull: false)
  final int? code;
  @JsonKey(name: 'errors', includeIfNull: false)
  final Object? errors;
  @JsonKey(name: 'status', includeIfNull: false, defaultValue: '')
  final String? status;
  static const fromJsonFactory = _$$500FromJson;
  static const toJsonFactory = _$$500ToJson;
  Map<String, dynamic> toJson() => _$$500ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is $500 &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.errors, errors) ||
                const DeepCollectionEquality().equals(other.errors, errors)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(code) ^
      const DeepCollectionEquality().hash(errors) ^
      const DeepCollectionEquality().hash(status) ^
      runtimeType.hashCode;
}

extension $$500Extension on $500 {
  $500 copyWith({int? code, Object? errors, String? status}) {
    return $500(
        code: code ?? this.code,
        errors: errors ?? this.errors,
        status: status ?? this.status);
  }

  $500 copyWithWrapped(
      {Wrapped<int?>? code,
      Wrapped<Object?>? errors,
      Wrapped<String?>? status}) {
    return $500(
        code: (code != null ? code.value : this.code),
        errors: (errors != null ? errors.value : this.errors),
        status: (status != null ? status.value : this.status));
  }
}

@JsonSerializable(explicitToJson: true)
class CompartmentsPost$RequestBody {
  CompartmentsPost$RequestBody({
    this.contents,
    this.fridge,
    required this.name,
  });

  factory CompartmentsPost$RequestBody.fromJson(Map<String, dynamic> json) =>
      _$CompartmentsPost$RequestBodyFromJson(json);

  @JsonKey(name: 'contents', includeIfNull: false, defaultValue: <int>[])
  final List<int>? contents;
  @JsonKey(name: 'fridge', includeIfNull: false)
  final int? fridge;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  static const fromJsonFactory = _$CompartmentsPost$RequestBodyFromJson;
  static const toJsonFactory = _$CompartmentsPost$RequestBodyToJson;
  Map<String, dynamic> toJson() => _$CompartmentsPost$RequestBodyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CompartmentsPost$RequestBody &&
            (identical(other.contents, contents) ||
                const DeepCollectionEquality()
                    .equals(other.contents, contents)) &&
            (identical(other.fridge, fridge) ||
                const DeepCollectionEquality().equals(other.fridge, fridge)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(contents) ^
      const DeepCollectionEquality().hash(fridge) ^
      const DeepCollectionEquality().hash(name) ^
      runtimeType.hashCode;
}

extension $CompartmentsPost$RequestBodyExtension
    on CompartmentsPost$RequestBody {
  CompartmentsPost$RequestBody copyWith(
      {List<int>? contents, int? fridge, String? name}) {
    return CompartmentsPost$RequestBody(
        contents: contents ?? this.contents,
        fridge: fridge ?? this.fridge,
        name: name ?? this.name);
  }

  CompartmentsPost$RequestBody copyWithWrapped(
      {Wrapped<List<int>?>? contents,
      Wrapped<int?>? fridge,
      Wrapped<String>? name}) {
    return CompartmentsPost$RequestBody(
        contents: (contents != null ? contents.value : this.contents),
        fridge: (fridge != null ? fridge.value : this.fridge),
        name: (name != null ? name.value : this.name));
  }
}

@JsonSerializable(explicitToJson: true)
class CompartmentsIdPatch$RequestBody {
  CompartmentsIdPatch$RequestBody({
    this.contents,
    this.fridge,
    required this.name,
  });

  factory CompartmentsIdPatch$RequestBody.fromJson(Map<String, dynamic> json) =>
      _$CompartmentsIdPatch$RequestBodyFromJson(json);

  @JsonKey(name: 'contents', includeIfNull: false, defaultValue: <int>[])
  final List<int>? contents;
  @JsonKey(name: 'fridge', includeIfNull: false)
  final int? fridge;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  static const fromJsonFactory = _$CompartmentsIdPatch$RequestBodyFromJson;
  static const toJsonFactory = _$CompartmentsIdPatch$RequestBodyToJson;
  Map<String, dynamic> toJson() =>
      _$CompartmentsIdPatch$RequestBodyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CompartmentsIdPatch$RequestBody &&
            (identical(other.contents, contents) ||
                const DeepCollectionEquality()
                    .equals(other.contents, contents)) &&
            (identical(other.fridge, fridge) ||
                const DeepCollectionEquality().equals(other.fridge, fridge)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(contents) ^
      const DeepCollectionEquality().hash(fridge) ^
      const DeepCollectionEquality().hash(name) ^
      runtimeType.hashCode;
}

extension $CompartmentsIdPatch$RequestBodyExtension
    on CompartmentsIdPatch$RequestBody {
  CompartmentsIdPatch$RequestBody copyWith(
      {List<int>? contents, int? fridge, String? name}) {
    return CompartmentsIdPatch$RequestBody(
        contents: contents ?? this.contents,
        fridge: fridge ?? this.fridge,
        name: name ?? this.name);
  }

  CompartmentsIdPatch$RequestBody copyWithWrapped(
      {Wrapped<List<int>?>? contents,
      Wrapped<int?>? fridge,
      Wrapped<String>? name}) {
    return CompartmentsIdPatch$RequestBody(
        contents: (contents != null ? contents.value : this.contents),
        fridge: (fridge != null ? fridge.value : this.fridge),
        name: (name != null ? name.value : this.name));
  }
}

@JsonSerializable(explicitToJson: true)
class FridgesPost$RequestBody {
  FridgesPost$RequestBody({
    this.compartments,
    required this.title,
  });

  factory FridgesPost$RequestBody.fromJson(Map<String, dynamic> json) =>
      _$FridgesPost$RequestBodyFromJson(json);

  @JsonKey(name: 'compartments', includeIfNull: false, defaultValue: <int>[])
  final List<int>? compartments;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  static const fromJsonFactory = _$FridgesPost$RequestBodyFromJson;
  static const toJsonFactory = _$FridgesPost$RequestBodyToJson;
  Map<String, dynamic> toJson() => _$FridgesPost$RequestBodyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FridgesPost$RequestBody &&
            (identical(other.compartments, compartments) ||
                const DeepCollectionEquality()
                    .equals(other.compartments, compartments)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(compartments) ^
      const DeepCollectionEquality().hash(title) ^
      runtimeType.hashCode;
}

extension $FridgesPost$RequestBodyExtension on FridgesPost$RequestBody {
  FridgesPost$RequestBody copyWith({List<int>? compartments, String? title}) {
    return FridgesPost$RequestBody(
        compartments: compartments ?? this.compartments,
        title: title ?? this.title);
  }

  FridgesPost$RequestBody copyWithWrapped(
      {Wrapped<List<int>?>? compartments, Wrapped<String>? title}) {
    return FridgesPost$RequestBody(
        compartments:
            (compartments != null ? compartments.value : this.compartments),
        title: (title != null ? title.value : this.title));
  }
}

@JsonSerializable(explicitToJson: true)
class FridgesIdPatch$RequestBody {
  FridgesIdPatch$RequestBody({
    this.compartments,
    required this.title,
  });

  factory FridgesIdPatch$RequestBody.fromJson(Map<String, dynamic> json) =>
      _$FridgesIdPatch$RequestBodyFromJson(json);

  @JsonKey(name: 'compartments', includeIfNull: false, defaultValue: <int>[])
  final List<int>? compartments;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  static const fromJsonFactory = _$FridgesIdPatch$RequestBodyFromJson;
  static const toJsonFactory = _$FridgesIdPatch$RequestBodyToJson;
  Map<String, dynamic> toJson() => _$FridgesIdPatch$RequestBodyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FridgesIdPatch$RequestBody &&
            (identical(other.compartments, compartments) ||
                const DeepCollectionEquality()
                    .equals(other.compartments, compartments)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(compartments) ^
      const DeepCollectionEquality().hash(title) ^
      runtimeType.hashCode;
}

extension $FridgesIdPatch$RequestBodyExtension on FridgesIdPatch$RequestBody {
  FridgesIdPatch$RequestBody copyWith(
      {List<int>? compartments, String? title}) {
    return FridgesIdPatch$RequestBody(
        compartments: compartments ?? this.compartments,
        title: title ?? this.title);
  }

  FridgesIdPatch$RequestBody copyWithWrapped(
      {Wrapped<List<int>?>? compartments, Wrapped<String>? title}) {
    return FridgesIdPatch$RequestBody(
        compartments:
            (compartments != null ? compartments.value : this.compartments),
        title: (title != null ? title.value : this.title));
  }
}

@JsonSerializable(explicitToJson: true)
class ItemsPost$RequestBody {
  ItemsPost$RequestBody({
    this.compartment,
    required this.name,
  });

  factory ItemsPost$RequestBody.fromJson(Map<String, dynamic> json) =>
      _$ItemsPost$RequestBodyFromJson(json);

  @JsonKey(name: 'compartment', includeIfNull: false)
  final int? compartment;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  static const fromJsonFactory = _$ItemsPost$RequestBodyFromJson;
  static const toJsonFactory = _$ItemsPost$RequestBodyToJson;
  Map<String, dynamic> toJson() => _$ItemsPost$RequestBodyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ItemsPost$RequestBody &&
            (identical(other.compartment, compartment) ||
                const DeepCollectionEquality()
                    .equals(other.compartment, compartment)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(compartment) ^
      const DeepCollectionEquality().hash(name) ^
      runtimeType.hashCode;
}

extension $ItemsPost$RequestBodyExtension on ItemsPost$RequestBody {
  ItemsPost$RequestBody copyWith({int? compartment, String? name}) {
    return ItemsPost$RequestBody(
        compartment: compartment ?? this.compartment, name: name ?? this.name);
  }

  ItemsPost$RequestBody copyWithWrapped(
      {Wrapped<int?>? compartment, Wrapped<String>? name}) {
    return ItemsPost$RequestBody(
        compartment:
            (compartment != null ? compartment.value : this.compartment),
        name: (name != null ? name.value : this.name));
  }
}

@JsonSerializable(explicitToJson: true)
class ItemsIdPatch$RequestBody {
  ItemsIdPatch$RequestBody({
    this.compartment,
    required this.name,
  });

  factory ItemsIdPatch$RequestBody.fromJson(Map<String, dynamic> json) =>
      _$ItemsIdPatch$RequestBodyFromJson(json);

  @JsonKey(name: 'compartment', includeIfNull: false)
  final int? compartment;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  static const fromJsonFactory = _$ItemsIdPatch$RequestBodyFromJson;
  static const toJsonFactory = _$ItemsIdPatch$RequestBodyToJson;
  Map<String, dynamic> toJson() => _$ItemsIdPatch$RequestBodyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ItemsIdPatch$RequestBody &&
            (identical(other.compartment, compartment) ||
                const DeepCollectionEquality()
                    .equals(other.compartment, compartment)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(compartment) ^
      const DeepCollectionEquality().hash(name) ^
      runtimeType.hashCode;
}

extension $ItemsIdPatch$RequestBodyExtension on ItemsIdPatch$RequestBody {
  ItemsIdPatch$RequestBody copyWith({int? compartment, String? name}) {
    return ItemsIdPatch$RequestBody(
        compartment: compartment ?? this.compartment, name: name ?? this.name);
  }

  ItemsIdPatch$RequestBody copyWithWrapped(
      {Wrapped<int?>? compartment, Wrapped<String>? name}) {
    return ItemsIdPatch$RequestBody(
        compartment:
            (compartment != null ? compartment.value : this.compartment),
        name: (name != null ? name.value : this.name));
  }
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
