// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;

part 'payment_remote_data_source.swagger.chopper.dart';
part 'payment_remote_data_source.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class PaymentRemoteDataSource extends ChopperService {
  static PaymentRemoteDataSource create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$PaymentRemoteDataSource(client);
    }

    final newClient = ChopperClient(
        services: [_$PaymentRemoteDataSource()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ??
            'http://appie-ing-payment-bff.ah-tst.k8s.digitaldev.nl/');
    return _$PaymentRemoteDataSource(newClient);
  }

  ///error
  Future<chopper.Response<ErrorJson>> errorGet({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorGet(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///error
  @Get(path: '/error')
  Future<chopper.Response<ErrorJson>> _errorGet({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///error
  Future<chopper.Response<ErrorJson>> errorHead({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorHead(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///error
  @Head(path: '/error')
  Future<chopper.Response<ErrorJson>> _errorHead({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///error
  Future<chopper.Response<ErrorJson>> errorPost({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorPost(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///error
  @Post(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<ErrorJson>> _errorPost({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///error
  Future<chopper.Response<ErrorJson>> errorPut({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorPut(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///error
  @Put(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<ErrorJson>> _errorPut({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///error
  Future<chopper.Response<ErrorJson>> errorDelete({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorDelete(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///error
  @Delete(path: '/error')
  Future<chopper.Response<ErrorJson>> _errorDelete({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///error
  Future<chopper.Response<ErrorJson>> errorPatch({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorPatch(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///error
  @Patch(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<ErrorJson>> _errorPatch({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///transaction
  ///@param id id
  Future<chopper.Response<IngPaymentRequestStatus>> v1PaymentsTransactionsGet({
    required String? id,
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        IngPaymentRequestStatus, () => IngPaymentRequestStatus.fromJsonFactory);

    return _v1PaymentsTransactionsGet(
        id: id, xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///transaction
  ///@param id id
  @Get(path: '/v1/payments/transactions')
  Future<chopper.Response<IngPaymentRequestStatus>> _v1PaymentsTransactionsGet({
    @Query('id') required String? id,
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class ErrorJson {
  ErrorJson({
    this.error,
    this.message,
    this.status,
  });

  factory ErrorJson.fromJson(Map<String, dynamic> json) =>
      _$ErrorJsonFromJson(json);

  @JsonKey(name: 'error', includeIfNull: false, defaultValue: '')
  final String? error;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'status', includeIfNull: false)
  final int? status;
  static const fromJsonFactory = _$ErrorJsonFromJson;
  static const toJsonFactory = _$ErrorJsonToJson;
  Map<String, dynamic> toJson() => _$ErrorJsonToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ErrorJson &&
            (identical(other.error, error) ||
                const DeepCollectionEquality().equals(other.error, error)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(error) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(status) ^
      runtimeType.hashCode;
}

extension $ErrorJsonExtension on ErrorJson {
  ErrorJson copyWith({String? error, String? message, int? status}) {
    return ErrorJson(
        error: error ?? this.error,
        message: message ?? this.message,
        status: status ?? this.status);
  }

  ErrorJson copyWithWrapped(
      {Wrapped<String?>? error,
      Wrapped<String?>? message,
      Wrapped<int?>? status}) {
    return ErrorJson(
        error: (error != null ? error.value : this.error),
        message: (message != null ? message.value : this.message),
        status: (status != null ? status.value : this.status));
  }
}

@JsonSerializable(explicitToJson: true)
class IngPaymentRequestStatus {
  IngPaymentRequestStatus({
    required this.isValid,
  });

  factory IngPaymentRequestStatus.fromJson(Map<String, dynamic> json) =>
      _$IngPaymentRequestStatusFromJson(json);

  @JsonKey(name: 'isValid', includeIfNull: false)
  final bool isValid;
  static const fromJsonFactory = _$IngPaymentRequestStatusFromJson;
  static const toJsonFactory = _$IngPaymentRequestStatusToJson;
  Map<String, dynamic> toJson() => _$IngPaymentRequestStatusToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is IngPaymentRequestStatus &&
            (identical(other.isValid, isValid) ||
                const DeepCollectionEquality().equals(other.isValid, isValid)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(isValid) ^ runtimeType.hashCode;
}

extension $IngPaymentRequestStatusExtension on IngPaymentRequestStatus {
  IngPaymentRequestStatus copyWith({bool? isValid}) {
    return IngPaymentRequestStatus(isValid: isValid ?? this.isValid);
  }

  IngPaymentRequestStatus copyWithWrapped({Wrapped<bool>? isValid}) {
    return IngPaymentRequestStatus(
        isValid: (isValid != null ? isValid.value : this.isValid));
  }
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
