// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;

part 'plugins.swagger.chopper.dart';
part 'plugins.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class Plugins extends ChopperService {
  static Plugins create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$Plugins(client);
    }

    final newClient = ChopperClient(
        services: [_$Plugins()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$Plugins(newClient);
  }

  ///
  Future<chopper.Response<WebApiModulesPluginsAzureADGetAzureADGroupsResponse>>
      apiV1AzureadpluginLoadadgroupsPost({
    String? cacheControl,
    required WebApiModulesPluginsAzureADGetAzureADGroupsRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesPluginsAzureADGetAzureADGroupsResponse,
        () => WebApiModulesPluginsAzureADGetAzureADGroupsResponse
            .fromJsonFactory);

    return _apiV1AzureadpluginLoadadgroupsPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/azureadplugin/loadadgroups')
  Future<chopper.Response<WebApiModulesPluginsAzureADGetAzureADGroupsResponse>>
      _apiV1AzureadpluginLoadadgroupsPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesPluginsAzureADGetAzureADGroupsRequest? body,
  });

  ///
  Future<chopper.Response<WebApiModulesPluginsAzureADImportGroupResponse>>
      apiV1AzureadpluginImportgroupPost({
    String? cacheControl,
    required WebApiModulesPluginsAzureADImportGroupRequest? body,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesPluginsAzureADImportGroupResponse,
        () => WebApiModulesPluginsAzureADImportGroupResponse.fromJsonFactory);

    return _apiV1AzureadpluginImportgroupPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/azureadplugin/importgroup')
  Future<chopper.Response<WebApiModulesPluginsAzureADImportGroupResponse>>
      _apiV1AzureadpluginImportgroupPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesPluginsAzureADImportGroupRequest? body,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1AzureadpluginEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1AzureadpluginEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/azureadplugin/emptyobject')
  Future<chopper.Response> _apiV1AzureadpluginEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1AzureadpluginEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1AzureadpluginEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/azureadplugin/emptybrowseobject')
  Future<chopper.Response> _apiV1AzureadpluginEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1AzureadpluginKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1AzureadpluginKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/azureadplugin/keyfieldnames')
  Future<chopper.Response> _apiV1AzureadpluginKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<
          chopper.Response<
              WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBool>>
      apiV1HubspotpluginHashubspotrefreshtokenPost({String? cacheControl}) {
    generatedMapping.putIfAbsent(
        WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBool,
        () => WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBool
            .fromJsonFactory);

    return _apiV1HubspotpluginHashubspotrefreshtokenPost(
        cacheControl: cacheControl);
  }

  ///
  @Post(
    path: '/api/v1/hubspotplugin/hashubspotrefreshtoken',
    optionalBody: true,
  )
  Future<
          chopper.Response<
              WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBool>>
      _apiV1HubspotpluginHashubspotrefreshtokenPost(
          {@Header('Cache-Control') String? cacheControl});

  ///
  Future<
          chopper
              .Response<WebApiModulesAccountServicesHubSpotDeleteHubSpotTokens>>
      apiV1HubspotpluginDeletehubspottokensPost({String? cacheControl}) {
    generatedMapping.putIfAbsent(
        WebApiModulesAccountServicesHubSpotDeleteHubSpotTokens,
        () => WebApiModulesAccountServicesHubSpotDeleteHubSpotTokens
            .fromJsonFactory);

    return _apiV1HubspotpluginDeletehubspottokensPost(
        cacheControl: cacheControl);
  }

  ///
  @Post(
    path: '/api/v1/hubspotplugin/deletehubspottokens',
    optionalBody: true,
  )
  Future<
          chopper
              .Response<WebApiModulesAccountServicesHubSpotDeleteHubSpotTokens>>
      _apiV1HubspotpluginDeletehubspottokensPost(
          {@Header('Cache-Control') String? cacheControl});

  ///Get an empty object
  Future<chopper.Response> apiV1HubspotpluginEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1HubspotpluginEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/hubspotplugin/emptyobject')
  Future<chopper.Response> _apiV1HubspotpluginEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1HubspotpluginEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1HubspotpluginEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/hubspotplugin/emptybrowseobject')
  Future<chopper.Response> _apiV1HubspotpluginEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1HubspotpluginKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1HubspotpluginKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/hubspotplugin/keyfieldnames')
  Future<chopper.Response> _apiV1HubspotpluginKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});
}

@JsonSerializable(explicitToJson: true)
class FwCoreApiSwashbuckleBadRequestResponse {
  FwCoreApiSwashbuckleBadRequestResponse();

  factory FwCoreApiSwashbuckleBadRequestResponse.fromJson(
          Map<String, dynamic> json) =>
      _$FwCoreApiSwashbuckleBadRequestResponseFromJson(json);

  static const fromJsonFactory =
      _$FwCoreApiSwashbuckleBadRequestResponseFromJson;
  static const toJsonFactory = _$FwCoreApiSwashbuckleBadRequestResponseToJson;
  Map<String, dynamic> toJson() =>
      _$FwCoreApiSwashbuckleBadRequestResponseToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode => runtimeType.hashCode;
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwApiException {
  FwStandardModelsFwApiException({
    this.statusCode,
    this.message,
    this.stackTrace,
  });

  factory FwStandardModelsFwApiException.fromJson(Map<String, dynamic> json) =>
      _$FwStandardModelsFwApiExceptionFromJson(json);

  @JsonKey(name: 'StatusCode', includeIfNull: false)
  final int? statusCode;
  @JsonKey(name: 'Message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'StackTrace', includeIfNull: false, defaultValue: '')
  final String? stackTrace;
  static const fromJsonFactory = _$FwStandardModelsFwApiExceptionFromJson;
  static const toJsonFactory = _$FwStandardModelsFwApiExceptionToJson;
  Map<String, dynamic> toJson() => _$FwStandardModelsFwApiExceptionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwApiException &&
            (identical(other.statusCode, statusCode) ||
                const DeepCollectionEquality()
                    .equals(other.statusCode, statusCode)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.stackTrace, stackTrace) ||
                const DeepCollectionEquality()
                    .equals(other.stackTrace, stackTrace)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(statusCode) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(stackTrace) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwApiExceptionExtension
    on FwStandardModelsFwApiException {
  FwStandardModelsFwApiException copyWith(
      {int? statusCode, String? message, String? stackTrace}) {
    return FwStandardModelsFwApiException(
        statusCode: statusCode ?? this.statusCode,
        message: message ?? this.message,
        stackTrace: stackTrace ?? this.stackTrace);
  }

  FwStandardModelsFwApiException copyWithWrapped(
      {Wrapped<int?>? statusCode,
      Wrapped<String?>? message,
      Wrapped<String?>? stackTrace}) {
    return FwStandardModelsFwApiException(
        statusCode: (statusCode != null ? statusCode.value : this.statusCode),
        message: (message != null ? message.value : this.message),
        stackTrace: (stackTrace != null ? stackTrace.value : this.stackTrace));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAccountServicesHubSpotDeleteHubSpotTokens {
  WebApiModulesAccountServicesHubSpotDeleteHubSpotTokens({
    this.message,
  });

  factory WebApiModulesAccountServicesHubSpotDeleteHubSpotTokens.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAccountServicesHubSpotDeleteHubSpotTokensFromJson(json);

  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  static const fromJsonFactory =
      _$WebApiModulesAccountServicesHubSpotDeleteHubSpotTokensFromJson;
  static const toJsonFactory =
      _$WebApiModulesAccountServicesHubSpotDeleteHubSpotTokensToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAccountServicesHubSpotDeleteHubSpotTokensToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAccountServicesHubSpotDeleteHubSpotTokens &&
            (identical(other.message, message) ||
                const DeepCollectionEquality().equals(other.message, message)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(message) ^ runtimeType.hashCode;
}

extension $WebApiModulesAccountServicesHubSpotDeleteHubSpotTokensExtension
    on WebApiModulesAccountServicesHubSpotDeleteHubSpotTokens {
  WebApiModulesAccountServicesHubSpotDeleteHubSpotTokens copyWith(
      {String? message}) {
    return WebApiModulesAccountServicesHubSpotDeleteHubSpotTokens(
        message: message ?? this.message);
  }

  WebApiModulesAccountServicesHubSpotDeleteHubSpotTokens copyWithWrapped(
      {Wrapped<String?>? message}) {
    return WebApiModulesAccountServicesHubSpotDeleteHubSpotTokens(
        message: (message != null ? message.value : this.message));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBool {
  WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBool({
    this.hasRefreshToken,
  });

  factory WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBool.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBoolFromJson(
          json);

  @JsonKey(name: 'hasRefreshToken', includeIfNull: false)
  final bool? hasRefreshToken;
  static const fromJsonFactory =
      _$WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBoolFromJson;
  static const toJsonFactory =
      _$WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBoolToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBoolToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBool &&
            (identical(other.hasRefreshToken, hasRefreshToken) ||
                const DeepCollectionEquality()
                    .equals(other.hasRefreshToken, hasRefreshToken)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(hasRefreshToken) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBoolExtension
    on WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBool {
  WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBool copyWith(
      {bool? hasRefreshToken}) {
    return WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBool(
        hasRefreshToken: hasRefreshToken ?? this.hasRefreshToken);
  }

  WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBool copyWithWrapped(
      {Wrapped<bool?>? hasRefreshToken}) {
    return WebApiModulesAccountServicesHubSpotGetHubSpotRefreshTokenBool(
        hasRefreshToken: (hasRefreshToken != null
            ? hasRefreshToken.value
            : this.hasRefreshToken));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesPluginsAzureADAzureADGroup {
  WebApiModulesPluginsAzureADAzureADGroup({
    this.id,
    this.displayName,
  });

  factory WebApiModulesPluginsAzureADAzureADGroup.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesPluginsAzureADAzureADGroupFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'displayName', includeIfNull: false, defaultValue: '')
  final String? displayName;
  static const fromJsonFactory =
      _$WebApiModulesPluginsAzureADAzureADGroupFromJson;
  static const toJsonFactory = _$WebApiModulesPluginsAzureADAzureADGroupToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesPluginsAzureADAzureADGroupToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesPluginsAzureADAzureADGroup &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.displayName, displayName) ||
                const DeepCollectionEquality()
                    .equals(other.displayName, displayName)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(displayName) ^
      runtimeType.hashCode;
}

extension $WebApiModulesPluginsAzureADAzureADGroupExtension
    on WebApiModulesPluginsAzureADAzureADGroup {
  WebApiModulesPluginsAzureADAzureADGroup copyWith(
      {String? id, String? displayName}) {
    return WebApiModulesPluginsAzureADAzureADGroup(
        id: id ?? this.id, displayName: displayName ?? this.displayName);
  }

  WebApiModulesPluginsAzureADAzureADGroup copyWithWrapped(
      {Wrapped<String?>? id, Wrapped<String?>? displayName}) {
    return WebApiModulesPluginsAzureADAzureADGroup(
        id: (id != null ? id.value : this.id),
        displayName:
            (displayName != null ? displayName.value : this.displayName));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesPluginsAzureADGetAzureADGroupsRequest {
  WebApiModulesPluginsAzureADGetAzureADGroupsRequest({
    this.groupSearch,
  });

  factory WebApiModulesPluginsAzureADGetAzureADGroupsRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesPluginsAzureADGetAzureADGroupsRequestFromJson(json);

  @JsonKey(name: 'GroupSearch', includeIfNull: false, defaultValue: '')
  final String? groupSearch;
  static const fromJsonFactory =
      _$WebApiModulesPluginsAzureADGetAzureADGroupsRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesPluginsAzureADGetAzureADGroupsRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesPluginsAzureADGetAzureADGroupsRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesPluginsAzureADGetAzureADGroupsRequest &&
            (identical(other.groupSearch, groupSearch) ||
                const DeepCollectionEquality()
                    .equals(other.groupSearch, groupSearch)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(groupSearch) ^ runtimeType.hashCode;
}

extension $WebApiModulesPluginsAzureADGetAzureADGroupsRequestExtension
    on WebApiModulesPluginsAzureADGetAzureADGroupsRequest {
  WebApiModulesPluginsAzureADGetAzureADGroupsRequest copyWith(
      {String? groupSearch}) {
    return WebApiModulesPluginsAzureADGetAzureADGroupsRequest(
        groupSearch: groupSearch ?? this.groupSearch);
  }

  WebApiModulesPluginsAzureADGetAzureADGroupsRequest copyWithWrapped(
      {Wrapped<String?>? groupSearch}) {
    return WebApiModulesPluginsAzureADGetAzureADGroupsRequest(
        groupSearch:
            (groupSearch != null ? groupSearch.value : this.groupSearch));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesPluginsAzureADGetAzureADGroupsResponse {
  WebApiModulesPluginsAzureADGetAzureADGroupsResponse({
    this.groups,
    this.tooManyResults,
    this.statusCode,
    this.message,
  });

  factory WebApiModulesPluginsAzureADGetAzureADGroupsResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesPluginsAzureADGetAzureADGroupsResponseFromJson(json);

  @JsonKey(
      name: 'Groups',
      includeIfNull: false,
      defaultValue: <WebApiModulesPluginsAzureADAzureADGroup>[])
  final List<WebApiModulesPluginsAzureADAzureADGroup>? groups;
  @JsonKey(name: 'TooManyResults', includeIfNull: false)
  final bool? tooManyResults;
  @JsonKey(name: 'StatusCode', includeIfNull: false)
  final int? statusCode;
  @JsonKey(name: 'Message', includeIfNull: false, defaultValue: '')
  final String? message;
  static const fromJsonFactory =
      _$WebApiModulesPluginsAzureADGetAzureADGroupsResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesPluginsAzureADGetAzureADGroupsResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesPluginsAzureADGetAzureADGroupsResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesPluginsAzureADGetAzureADGroupsResponse &&
            (identical(other.groups, groups) ||
                const DeepCollectionEquality().equals(other.groups, groups)) &&
            (identical(other.tooManyResults, tooManyResults) ||
                const DeepCollectionEquality()
                    .equals(other.tooManyResults, tooManyResults)) &&
            (identical(other.statusCode, statusCode) ||
                const DeepCollectionEquality()
                    .equals(other.statusCode, statusCode)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality().equals(other.message, message)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(groups) ^
      const DeepCollectionEquality().hash(tooManyResults) ^
      const DeepCollectionEquality().hash(statusCode) ^
      const DeepCollectionEquality().hash(message) ^
      runtimeType.hashCode;
}

extension $WebApiModulesPluginsAzureADGetAzureADGroupsResponseExtension
    on WebApiModulesPluginsAzureADGetAzureADGroupsResponse {
  WebApiModulesPluginsAzureADGetAzureADGroupsResponse copyWith(
      {List<WebApiModulesPluginsAzureADAzureADGroup>? groups,
      bool? tooManyResults,
      int? statusCode,
      String? message}) {
    return WebApiModulesPluginsAzureADGetAzureADGroupsResponse(
        groups: groups ?? this.groups,
        tooManyResults: tooManyResults ?? this.tooManyResults,
        statusCode: statusCode ?? this.statusCode,
        message: message ?? this.message);
  }

  WebApiModulesPluginsAzureADGetAzureADGroupsResponse copyWithWrapped(
      {Wrapped<List<WebApiModulesPluginsAzureADAzureADGroup>?>? groups,
      Wrapped<bool?>? tooManyResults,
      Wrapped<int?>? statusCode,
      Wrapped<String?>? message}) {
    return WebApiModulesPluginsAzureADGetAzureADGroupsResponse(
        groups: (groups != null ? groups.value : this.groups),
        tooManyResults: (tooManyResults != null
            ? tooManyResults.value
            : this.tooManyResults),
        statusCode: (statusCode != null ? statusCode.value : this.statusCode),
        message: (message != null ? message.value : this.message));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesPluginsAzureADImportGroupRequest {
  WebApiModulesPluginsAzureADImportGroupRequest({
    this.azureADGroupId,
    this.contactTitleId,
  });

  factory WebApiModulesPluginsAzureADImportGroupRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesPluginsAzureADImportGroupRequestFromJson(json);

  @JsonKey(name: 'AzureADGroupId', includeIfNull: false, defaultValue: '')
  final String? azureADGroupId;
  @JsonKey(name: 'ContactTitleId', includeIfNull: false, defaultValue: '')
  final String? contactTitleId;
  static const fromJsonFactory =
      _$WebApiModulesPluginsAzureADImportGroupRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesPluginsAzureADImportGroupRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesPluginsAzureADImportGroupRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesPluginsAzureADImportGroupRequest &&
            (identical(other.azureADGroupId, azureADGroupId) ||
                const DeepCollectionEquality()
                    .equals(other.azureADGroupId, azureADGroupId)) &&
            (identical(other.contactTitleId, contactTitleId) ||
                const DeepCollectionEquality()
                    .equals(other.contactTitleId, contactTitleId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(azureADGroupId) ^
      const DeepCollectionEquality().hash(contactTitleId) ^
      runtimeType.hashCode;
}

extension $WebApiModulesPluginsAzureADImportGroupRequestExtension
    on WebApiModulesPluginsAzureADImportGroupRequest {
  WebApiModulesPluginsAzureADImportGroupRequest copyWith(
      {String? azureADGroupId, String? contactTitleId}) {
    return WebApiModulesPluginsAzureADImportGroupRequest(
        azureADGroupId: azureADGroupId ?? this.azureADGroupId,
        contactTitleId: contactTitleId ?? this.contactTitleId);
  }

  WebApiModulesPluginsAzureADImportGroupRequest copyWithWrapped(
      {Wrapped<String?>? azureADGroupId, Wrapped<String?>? contactTitleId}) {
    return WebApiModulesPluginsAzureADImportGroupRequest(
        azureADGroupId: (azureADGroupId != null
            ? azureADGroupId.value
            : this.azureADGroupId),
        contactTitleId: (contactTitleId != null
            ? contactTitleId.value
            : this.contactTitleId));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesPluginsAzureADImportGroupResponse {
  WebApiModulesPluginsAzureADImportGroupResponse({
    this.lastImported,
    this.users,
    this.statusCode,
    this.message,
  });

  factory WebApiModulesPluginsAzureADImportGroupResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesPluginsAzureADImportGroupResponseFromJson(json);

  @JsonKey(name: 'LastImported', includeIfNull: false, defaultValue: '')
  final String? lastImported;
  @JsonKey(
      name: 'Users',
      includeIfNull: false,
      defaultValue: <WebApiModulesPluginsAzureADUserData>[])
  final List<WebApiModulesPluginsAzureADUserData>? users;
  @JsonKey(name: 'StatusCode', includeIfNull: false)
  final int? statusCode;
  @JsonKey(name: 'Message', includeIfNull: false, defaultValue: '')
  final String? message;
  static const fromJsonFactory =
      _$WebApiModulesPluginsAzureADImportGroupResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesPluginsAzureADImportGroupResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesPluginsAzureADImportGroupResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesPluginsAzureADImportGroupResponse &&
            (identical(other.lastImported, lastImported) ||
                const DeepCollectionEquality()
                    .equals(other.lastImported, lastImported)) &&
            (identical(other.users, users) ||
                const DeepCollectionEquality().equals(other.users, users)) &&
            (identical(other.statusCode, statusCode) ||
                const DeepCollectionEquality()
                    .equals(other.statusCode, statusCode)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality().equals(other.message, message)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(lastImported) ^
      const DeepCollectionEquality().hash(users) ^
      const DeepCollectionEquality().hash(statusCode) ^
      const DeepCollectionEquality().hash(message) ^
      runtimeType.hashCode;
}

extension $WebApiModulesPluginsAzureADImportGroupResponseExtension
    on WebApiModulesPluginsAzureADImportGroupResponse {
  WebApiModulesPluginsAzureADImportGroupResponse copyWith(
      {String? lastImported,
      List<WebApiModulesPluginsAzureADUserData>? users,
      int? statusCode,
      String? message}) {
    return WebApiModulesPluginsAzureADImportGroupResponse(
        lastImported: lastImported ?? this.lastImported,
        users: users ?? this.users,
        statusCode: statusCode ?? this.statusCode,
        message: message ?? this.message);
  }

  WebApiModulesPluginsAzureADImportGroupResponse copyWithWrapped(
      {Wrapped<String?>? lastImported,
      Wrapped<List<WebApiModulesPluginsAzureADUserData>?>? users,
      Wrapped<int?>? statusCode,
      Wrapped<String?>? message}) {
    return WebApiModulesPluginsAzureADImportGroupResponse(
        lastImported:
            (lastImported != null ? lastImported.value : this.lastImported),
        users: (users != null ? users.value : this.users),
        statusCode: (statusCode != null ? statusCode.value : this.statusCode),
        message: (message != null ? message.value : this.message));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesPluginsAzureADUserData {
  WebApiModulesPluginsAzureADUserData({
    this.contactId,
    this.firstName,
    this.lastName,
    this.email,
    this.sourceId,
  });

  factory WebApiModulesPluginsAzureADUserData.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesPluginsAzureADUserDataFromJson(json);

  @JsonKey(name: 'ContactId', includeIfNull: false, defaultValue: '')
  final String? contactId;
  @JsonKey(name: 'FirstName', includeIfNull: false, defaultValue: '')
  final String? firstName;
  @JsonKey(name: 'LastName', includeIfNull: false, defaultValue: '')
  final String? lastName;
  @JsonKey(name: 'Email', includeIfNull: false, defaultValue: '')
  final String? email;
  @JsonKey(name: 'SourceId', includeIfNull: false, defaultValue: '')
  final String? sourceId;
  static const fromJsonFactory = _$WebApiModulesPluginsAzureADUserDataFromJson;
  static const toJsonFactory = _$WebApiModulesPluginsAzureADUserDataToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesPluginsAzureADUserDataToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesPluginsAzureADUserData &&
            (identical(other.contactId, contactId) ||
                const DeepCollectionEquality()
                    .equals(other.contactId, contactId)) &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.lastName, lastName) ||
                const DeepCollectionEquality()
                    .equals(other.lastName, lastName)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.sourceId, sourceId) ||
                const DeepCollectionEquality()
                    .equals(other.sourceId, sourceId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(contactId) ^
      const DeepCollectionEquality().hash(firstName) ^
      const DeepCollectionEquality().hash(lastName) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(sourceId) ^
      runtimeType.hashCode;
}

extension $WebApiModulesPluginsAzureADUserDataExtension
    on WebApiModulesPluginsAzureADUserData {
  WebApiModulesPluginsAzureADUserData copyWith(
      {String? contactId,
      String? firstName,
      String? lastName,
      String? email,
      String? sourceId}) {
    return WebApiModulesPluginsAzureADUserData(
        contactId: contactId ?? this.contactId,
        firstName: firstName ?? this.firstName,
        lastName: lastName ?? this.lastName,
        email: email ?? this.email,
        sourceId: sourceId ?? this.sourceId);
  }

  WebApiModulesPluginsAzureADUserData copyWithWrapped(
      {Wrapped<String?>? contactId,
      Wrapped<String?>? firstName,
      Wrapped<String?>? lastName,
      Wrapped<String?>? email,
      Wrapped<String?>? sourceId}) {
    return WebApiModulesPluginsAzureADUserData(
        contactId: (contactId != null ? contactId.value : this.contactId),
        firstName: (firstName != null ? firstName.value : this.firstName),
        lastName: (lastName != null ? lastName.value : this.lastName),
        email: (email != null ? email.value : this.email),
        sourceId: (sourceId != null ? sourceId.value : this.sourceId));
  }
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
