// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'product_recommendations_remote_data_source.enums.swagger.dart' as enums;
export 'product_recommendations_remote_data_source.enums.swagger.dart';

part 'product_recommendations_remote_data_source.swagger.chopper.dart';
part 'product_recommendations_remote_data_source.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class ProductRecommendationsRemoteDataSource extends ChopperService {
  static ProductRecommendationsRemoteDataSource create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$ProductRecommendationsRemoteDataSource(client);
    }

    final newClient = ChopperClient(
        services: [_$ProductRecommendationsRemoteDataSource()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$ProductRecommendationsRemoteDataSource(newClient);
  }

  ///
  ///@param webshopId WebshopId of a product
  Future<chopper.Response<List<ProductCard>>>
      v2RecommendationsSamplesProductsWebshopIdGet({
    required num? webshopId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ProductCard, () => ProductCard.fromJsonFactory);

    return _v2RecommendationsSamplesProductsWebshopIdGet(
        webshopId: webshopId, cacheControl: cacheControl);
  }

  ///
  ///@param webshopId WebshopId of a product
  @Get(path: '/v2/recommendations/samples/products/{webshopId}')
  Future<chopper.Response<List<ProductCard>>>
      _v2RecommendationsSamplesProductsWebshopIdGet({
    @Path('webshopId') required num? webshopId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param webshopId WebshopId of a product
  ///@param size The desired number of results
  ///@param model Type of recommendation
  ///@param Appie-Current-Order-Id
  ///@param x-application
  Future<chopper.Response<Recommendations>>
      v2RecommendationsProductsWebshopIdGet({
    required num? webshopId,
    int? size,
    enums.V2RecommendationsProductsWebshopIdGetModel? model,
    String? appieCurrentOrderId,
    String? xApplication,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Recommendations, () => Recommendations.fromJsonFactory);

    return _v2RecommendationsProductsWebshopIdGet(
        webshopId: webshopId,
        size: size,
        model: enums.$V2RecommendationsProductsWebshopIdGetModelMap[model]
            ?.toString(),
        appieCurrentOrderId: appieCurrentOrderId,
        xApplication: xApplication,
        cacheControl: cacheControl);
  }

  ///
  ///@param webshopId WebshopId of a product
  ///@param size The desired number of results
  ///@param model Type of recommendation
  ///@param Appie-Current-Order-Id
  ///@param x-application
  @Get(path: '/v2/recommendations/products/{webshopId}')
  Future<chopper.Response<Recommendations>>
      _v2RecommendationsProductsWebshopIdGet({
    @Path('webshopId') required num? webshopId,
    @Query('size') int? size,
    @Query('model') String? model,
    @Header('Appie-Current-Order-Id') String? appieCurrentOrderId,
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param webshopId WebshopId of a product
  ///@param size The desired number of results
  ///@param model Type of recommendation
  ///@param Appie-Current-Order-Id
  ///@param x-application
  Future<chopper.Response<List<ProductCard>>>
      v1RecommendationsProductsWebshopIdGet({
    required num? webshopId,
    int? size,
    enums.V1RecommendationsProductsWebshopIdGetModel? model,
    String? appieCurrentOrderId,
    String? xApplication,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ProductCard, () => ProductCard.fromJsonFactory);

    return _v1RecommendationsProductsWebshopIdGet(
        webshopId: webshopId,
        size: size,
        model: enums.$V1RecommendationsProductsWebshopIdGetModelMap[model]
            ?.toString(),
        appieCurrentOrderId: appieCurrentOrderId,
        xApplication: xApplication,
        cacheControl: cacheControl);
  }

  ///
  ///@param webshopId WebshopId of a product
  ///@param size The desired number of results
  ///@param model Type of recommendation
  ///@param Appie-Current-Order-Id
  ///@param x-application
  @Get(path: '/v1/recommendations/products/{webshopId}')
  Future<chopper.Response<List<ProductCard>>>
      _v1RecommendationsProductsWebshopIdGet({
    @Path('webshopId') required num? webshopId,
    @Query('size') int? size,
    @Query('model') String? model,
    @Header('Appie-Current-Order-Id') String? appieCurrentOrderId,
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class Image {
  Image({
    required this.width,
    required this.height,
    required this.url,
  });

  factory Image.fromJson(Map<String, dynamic> json) => _$ImageFromJson(json);

  @JsonKey(name: 'width', includeIfNull: false)
  final int width;
  @JsonKey(name: 'height', includeIfNull: false)
  final int height;
  @JsonKey(name: 'url', includeIfNull: false, defaultValue: '')
  final String url;
  static const fromJsonFactory = _$ImageFromJson;
  static const toJsonFactory = _$ImageToJson;
  Map<String, dynamic> toJson() => _$ImageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Image &&
            (identical(other.width, width) ||
                const DeepCollectionEquality().equals(other.width, width)) &&
            (identical(other.height, height) ||
                const DeepCollectionEquality().equals(other.height, height)) &&
            (identical(other.url, url) ||
                const DeepCollectionEquality().equals(other.url, url)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(width) ^
      const DeepCollectionEquality().hash(height) ^
      const DeepCollectionEquality().hash(url) ^
      runtimeType.hashCode;
}

extension $ImageExtension on Image {
  Image copyWith({int? width, int? height, String? url}) {
    return Image(
        width: width ?? this.width,
        height: height ?? this.height,
        url: url ?? this.url);
  }

  Image copyWithWrapped(
      {Wrapped<int>? width, Wrapped<int>? height, Wrapped<String>? url}) {
    return Image(
        width: (width != null ? width.value : this.width),
        height: (height != null ? height.value : this.height),
        url: (url != null ? url.value : this.url));
  }
}

@JsonSerializable(explicitToJson: true)
class ProductCard {
  ProductCard({
    required this.webshopId,
    required this.hqId,
    required this.title,
    this.specialDescription,
    this.salesUnitSize,
    this.unitPriceDescription,
    this.images,
    this.bonusStartDate,
    this.bonusEndDate,
    this.discountType,
    this.promotionType,
    this.segmentType,
    this.bonusMechanism,
    this.currentPrice,
    this.priceBeforeBonus,
    this.orderAvailabilityStatus,
    this.orderAvailabilityDescription,
    this.mainCategory,
    this.subCategory,
    this.subCategoryId,
    this.brand,
    this.shopType,
    this.bonusPeriodDescription,
    this.availableOnline,
    this.isPreviouslyBought,
    this.descriptionHighlights,
    this.propertyIcons,
    this.properties,
    this.nix18,
    this.isStapelBonus,
    this.extraDescriptions,
    this.bonusSegmentId,
    this.bonusSegmentDescription,
    this.isBonus,
    this.descriptionFull,
    required this.isOrderable,
    required this.isInfiniteBonus,
    required this.isSample,
    this.isBonusPrice,
  });

  factory ProductCard.fromJson(Map<String, dynamic> json) =>
      _$ProductCardFromJson(json);

  @JsonKey(name: 'webshopId', includeIfNull: false)
  final num webshopId;
  @JsonKey(name: 'hqId', includeIfNull: false)
  final num hqId;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  @JsonKey(name: 'specialDescription', includeIfNull: false, defaultValue: '')
  final String? specialDescription;
  @JsonKey(name: 'salesUnitSize', includeIfNull: false, defaultValue: '')
  final String? salesUnitSize;
  @JsonKey(name: 'unitPriceDescription', includeIfNull: false, defaultValue: '')
  final String? unitPriceDescription;
  @JsonKey(name: 'images', includeIfNull: false, defaultValue: <Image>[])
  final List<Image>? images;
  @JsonKey(name: 'bonusStartDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? bonusStartDate;
  @JsonKey(name: 'bonusEndDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? bonusEndDate;
  @JsonKey(name: 'discountType', includeIfNull: false, defaultValue: '')
  final String? discountType;
  @JsonKey(name: 'promotionType', includeIfNull: false, defaultValue: '')
  final String? promotionType;
  @JsonKey(name: 'segmentType', includeIfNull: false, defaultValue: '')
  final String? segmentType;
  @JsonKey(name: 'bonusMechanism', includeIfNull: false, defaultValue: '')
  final String? bonusMechanism;
  @JsonKey(name: 'currentPrice', includeIfNull: false)
  final double? currentPrice;
  @JsonKey(name: 'priceBeforeBonus', includeIfNull: false)
  final double? priceBeforeBonus;
  @JsonKey(
      name: 'orderAvailabilityStatus', includeIfNull: false, defaultValue: '')
  final String? orderAvailabilityStatus;
  @JsonKey(
      name: 'orderAvailabilityDescription',
      includeIfNull: false,
      defaultValue: '')
  final String? orderAvailabilityDescription;
  @JsonKey(name: 'mainCategory', includeIfNull: false, defaultValue: '')
  final String? mainCategory;
  @JsonKey(name: 'subCategory', includeIfNull: false, defaultValue: '')
  final String? subCategory;
  @JsonKey(name: 'subCategoryId', includeIfNull: false)
  final num? subCategoryId;
  @JsonKey(name: 'brand', includeIfNull: false, defaultValue: '')
  final String? brand;
  @JsonKey(name: 'shopType', includeIfNull: false, defaultValue: '')
  final String? shopType;
  @JsonKey(
      name: 'bonusPeriodDescription', includeIfNull: false, defaultValue: '')
  final String? bonusPeriodDescription;
  @JsonKey(name: 'availableOnline', includeIfNull: false)
  final bool? availableOnline;
  @JsonKey(name: 'isPreviouslyBought', includeIfNull: false)
  final bool? isPreviouslyBought;
  @JsonKey(
      name: 'descriptionHighlights', includeIfNull: false, defaultValue: '')
  final String? descriptionHighlights;
  @JsonKey(
      name: 'propertyIcons', includeIfNull: false, defaultValue: <String>[])
  final List<String>? propertyIcons;
  @JsonKey(name: 'properties', includeIfNull: false)
  final Map<String, dynamic>? properties;
  @JsonKey(name: 'nix18', includeIfNull: false)
  final bool? nix18;
  @JsonKey(name: 'isStapelBonus', includeIfNull: false)
  final bool? isStapelBonus;
  @JsonKey(
      name: 'extraDescriptions', includeIfNull: false, defaultValue: <String>[])
  final List<String>? extraDescriptions;
  @JsonKey(name: 'bonusSegmentId', includeIfNull: false)
  final num? bonusSegmentId;
  @JsonKey(
      name: 'bonusSegmentDescription', includeIfNull: false, defaultValue: '')
  final String? bonusSegmentDescription;
  @JsonKey(name: 'isBonus', includeIfNull: false)
  final bool? isBonus;
  @JsonKey(name: 'descriptionFull', includeIfNull: false, defaultValue: '')
  final String? descriptionFull;
  @JsonKey(name: 'isOrderable', includeIfNull: false)
  final bool isOrderable;
  @JsonKey(name: 'isInfiniteBonus', includeIfNull: false)
  final bool isInfiniteBonus;
  @JsonKey(name: 'isSample', includeIfNull: false)
  final bool isSample;
  @JsonKey(name: 'isBonusPrice', includeIfNull: false)
  final bool? isBonusPrice;
  static const fromJsonFactory = _$ProductCardFromJson;
  static const toJsonFactory = _$ProductCardToJson;
  Map<String, dynamic> toJson() => _$ProductCardToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProductCard &&
            (identical(other.webshopId, webshopId) ||
                const DeepCollectionEquality()
                    .equals(other.webshopId, webshopId)) &&
            (identical(other.hqId, hqId) ||
                const DeepCollectionEquality().equals(other.hqId, hqId)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.specialDescription, specialDescription) ||
                const DeepCollectionEquality()
                    .equals(other.specialDescription, specialDescription)) &&
            (identical(other.salesUnitSize, salesUnitSize) ||
                const DeepCollectionEquality()
                    .equals(other.salesUnitSize, salesUnitSize)) &&
            (identical(other.unitPriceDescription, unitPriceDescription) ||
                const DeepCollectionEquality().equals(
                    other.unitPriceDescription, unitPriceDescription)) &&
            (identical(other.images, images) ||
                const DeepCollectionEquality().equals(other.images, images)) &&
            (identical(other.bonusStartDate, bonusStartDate) ||
                const DeepCollectionEquality()
                    .equals(other.bonusStartDate, bonusStartDate)) &&
            (identical(other.bonusEndDate, bonusEndDate) ||
                const DeepCollectionEquality()
                    .equals(other.bonusEndDate, bonusEndDate)) &&
            (identical(other.discountType, discountType) ||
                const DeepCollectionEquality()
                    .equals(other.discountType, discountType)) &&
            (identical(other.promotionType, promotionType) ||
                const DeepCollectionEquality()
                    .equals(other.promotionType, promotionType)) &&
            (identical(other.segmentType, segmentType) ||
                const DeepCollectionEquality()
                    .equals(other.segmentType, segmentType)) &&
            (identical(other.bonusMechanism, bonusMechanism) ||
                const DeepCollectionEquality()
                    .equals(other.bonusMechanism, bonusMechanism)) &&
            (identical(other.currentPrice, currentPrice) ||
                const DeepCollectionEquality()
                    .equals(other.currentPrice, currentPrice)) &&
            (identical(other.priceBeforeBonus, priceBeforeBonus) ||
                const DeepCollectionEquality()
                    .equals(other.priceBeforeBonus, priceBeforeBonus)) &&
            (identical(other.orderAvailabilityStatus, orderAvailabilityStatus) ||
                const DeepCollectionEquality().equals(
                    other.orderAvailabilityStatus, orderAvailabilityStatus)) &&
            (identical(other.orderAvailabilityDescription, orderAvailabilityDescription) ||
                const DeepCollectionEquality().equals(
                    other.orderAvailabilityDescription,
                    orderAvailabilityDescription)) &&
            (identical(other.mainCategory, mainCategory) ||
                const DeepCollectionEquality()
                    .equals(other.mainCategory, mainCategory)) &&
            (identical(other.subCategory, subCategory) ||
                const DeepCollectionEquality()
                    .equals(other.subCategory, subCategory)) &&
            (identical(other.subCategoryId, subCategoryId) ||
                const DeepCollectionEquality()
                    .equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.brand, brand) ||
                const DeepCollectionEquality().equals(other.brand, brand)) &&
            (identical(other.shopType, shopType) ||
                const DeepCollectionEquality().equals(other.shopType, shopType)) &&
            (identical(other.bonusPeriodDescription, bonusPeriodDescription) || const DeepCollectionEquality().equals(other.bonusPeriodDescription, bonusPeriodDescription)) &&
            (identical(other.availableOnline, availableOnline) || const DeepCollectionEquality().equals(other.availableOnline, availableOnline)) &&
            (identical(other.isPreviouslyBought, isPreviouslyBought) || const DeepCollectionEquality().equals(other.isPreviouslyBought, isPreviouslyBought)) &&
            (identical(other.descriptionHighlights, descriptionHighlights) || const DeepCollectionEquality().equals(other.descriptionHighlights, descriptionHighlights)) &&
            (identical(other.propertyIcons, propertyIcons) || const DeepCollectionEquality().equals(other.propertyIcons, propertyIcons)) &&
            (identical(other.properties, properties) || const DeepCollectionEquality().equals(other.properties, properties)) &&
            (identical(other.nix18, nix18) || const DeepCollectionEquality().equals(other.nix18, nix18)) &&
            (identical(other.isStapelBonus, isStapelBonus) || const DeepCollectionEquality().equals(other.isStapelBonus, isStapelBonus)) &&
            (identical(other.extraDescriptions, extraDescriptions) || const DeepCollectionEquality().equals(other.extraDescriptions, extraDescriptions)) &&
            (identical(other.bonusSegmentId, bonusSegmentId) || const DeepCollectionEquality().equals(other.bonusSegmentId, bonusSegmentId)) &&
            (identical(other.bonusSegmentDescription, bonusSegmentDescription) || const DeepCollectionEquality().equals(other.bonusSegmentDescription, bonusSegmentDescription)) &&
            (identical(other.isBonus, isBonus) || const DeepCollectionEquality().equals(other.isBonus, isBonus)) &&
            (identical(other.descriptionFull, descriptionFull) || const DeepCollectionEquality().equals(other.descriptionFull, descriptionFull)) &&
            (identical(other.isOrderable, isOrderable) || const DeepCollectionEquality().equals(other.isOrderable, isOrderable)) &&
            (identical(other.isInfiniteBonus, isInfiniteBonus) || const DeepCollectionEquality().equals(other.isInfiniteBonus, isInfiniteBonus)) &&
            (identical(other.isSample, isSample) || const DeepCollectionEquality().equals(other.isSample, isSample)) &&
            (identical(other.isBonusPrice, isBonusPrice) || const DeepCollectionEquality().equals(other.isBonusPrice, isBonusPrice)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(webshopId) ^
      const DeepCollectionEquality().hash(hqId) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(specialDescription) ^
      const DeepCollectionEquality().hash(salesUnitSize) ^
      const DeepCollectionEquality().hash(unitPriceDescription) ^
      const DeepCollectionEquality().hash(images) ^
      const DeepCollectionEquality().hash(bonusStartDate) ^
      const DeepCollectionEquality().hash(bonusEndDate) ^
      const DeepCollectionEquality().hash(discountType) ^
      const DeepCollectionEquality().hash(promotionType) ^
      const DeepCollectionEquality().hash(segmentType) ^
      const DeepCollectionEquality().hash(bonusMechanism) ^
      const DeepCollectionEquality().hash(currentPrice) ^
      const DeepCollectionEquality().hash(priceBeforeBonus) ^
      const DeepCollectionEquality().hash(orderAvailabilityStatus) ^
      const DeepCollectionEquality().hash(orderAvailabilityDescription) ^
      const DeepCollectionEquality().hash(mainCategory) ^
      const DeepCollectionEquality().hash(subCategory) ^
      const DeepCollectionEquality().hash(subCategoryId) ^
      const DeepCollectionEquality().hash(brand) ^
      const DeepCollectionEquality().hash(shopType) ^
      const DeepCollectionEquality().hash(bonusPeriodDescription) ^
      const DeepCollectionEquality().hash(availableOnline) ^
      const DeepCollectionEquality().hash(isPreviouslyBought) ^
      const DeepCollectionEquality().hash(descriptionHighlights) ^
      const DeepCollectionEquality().hash(propertyIcons) ^
      const DeepCollectionEquality().hash(properties) ^
      const DeepCollectionEquality().hash(nix18) ^
      const DeepCollectionEquality().hash(isStapelBonus) ^
      const DeepCollectionEquality().hash(extraDescriptions) ^
      const DeepCollectionEquality().hash(bonusSegmentId) ^
      const DeepCollectionEquality().hash(bonusSegmentDescription) ^
      const DeepCollectionEquality().hash(isBonus) ^
      const DeepCollectionEquality().hash(descriptionFull) ^
      const DeepCollectionEquality().hash(isOrderable) ^
      const DeepCollectionEquality().hash(isInfiniteBonus) ^
      const DeepCollectionEquality().hash(isSample) ^
      const DeepCollectionEquality().hash(isBonusPrice) ^
      runtimeType.hashCode;
}

extension $ProductCardExtension on ProductCard {
  ProductCard copyWith(
      {num? webshopId,
      num? hqId,
      String? title,
      String? specialDescription,
      String? salesUnitSize,
      String? unitPriceDescription,
      List<Image>? images,
      DateTime? bonusStartDate,
      DateTime? bonusEndDate,
      String? discountType,
      String? promotionType,
      String? segmentType,
      String? bonusMechanism,
      double? currentPrice,
      double? priceBeforeBonus,
      String? orderAvailabilityStatus,
      String? orderAvailabilityDescription,
      String? mainCategory,
      String? subCategory,
      num? subCategoryId,
      String? brand,
      String? shopType,
      String? bonusPeriodDescription,
      bool? availableOnline,
      bool? isPreviouslyBought,
      String? descriptionHighlights,
      List<String>? propertyIcons,
      Map<String, dynamic>? properties,
      bool? nix18,
      bool? isStapelBonus,
      List<String>? extraDescriptions,
      num? bonusSegmentId,
      String? bonusSegmentDescription,
      bool? isBonus,
      String? descriptionFull,
      bool? isOrderable,
      bool? isInfiniteBonus,
      bool? isSample,
      bool? isBonusPrice}) {
    return ProductCard(
        webshopId: webshopId ?? this.webshopId,
        hqId: hqId ?? this.hqId,
        title: title ?? this.title,
        specialDescription: specialDescription ?? this.specialDescription,
        salesUnitSize: salesUnitSize ?? this.salesUnitSize,
        unitPriceDescription: unitPriceDescription ?? this.unitPriceDescription,
        images: images ?? this.images,
        bonusStartDate: bonusStartDate ?? this.bonusStartDate,
        bonusEndDate: bonusEndDate ?? this.bonusEndDate,
        discountType: discountType ?? this.discountType,
        promotionType: promotionType ?? this.promotionType,
        segmentType: segmentType ?? this.segmentType,
        bonusMechanism: bonusMechanism ?? this.bonusMechanism,
        currentPrice: currentPrice ?? this.currentPrice,
        priceBeforeBonus: priceBeforeBonus ?? this.priceBeforeBonus,
        orderAvailabilityStatus:
            orderAvailabilityStatus ?? this.orderAvailabilityStatus,
        orderAvailabilityDescription:
            orderAvailabilityDescription ?? this.orderAvailabilityDescription,
        mainCategory: mainCategory ?? this.mainCategory,
        subCategory: subCategory ?? this.subCategory,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        brand: brand ?? this.brand,
        shopType: shopType ?? this.shopType,
        bonusPeriodDescription:
            bonusPeriodDescription ?? this.bonusPeriodDescription,
        availableOnline: availableOnline ?? this.availableOnline,
        isPreviouslyBought: isPreviouslyBought ?? this.isPreviouslyBought,
        descriptionHighlights:
            descriptionHighlights ?? this.descriptionHighlights,
        propertyIcons: propertyIcons ?? this.propertyIcons,
        properties: properties ?? this.properties,
        nix18: nix18 ?? this.nix18,
        isStapelBonus: isStapelBonus ?? this.isStapelBonus,
        extraDescriptions: extraDescriptions ?? this.extraDescriptions,
        bonusSegmentId: bonusSegmentId ?? this.bonusSegmentId,
        bonusSegmentDescription:
            bonusSegmentDescription ?? this.bonusSegmentDescription,
        isBonus: isBonus ?? this.isBonus,
        descriptionFull: descriptionFull ?? this.descriptionFull,
        isOrderable: isOrderable ?? this.isOrderable,
        isInfiniteBonus: isInfiniteBonus ?? this.isInfiniteBonus,
        isSample: isSample ?? this.isSample,
        isBonusPrice: isBonusPrice ?? this.isBonusPrice);
  }

  ProductCard copyWithWrapped(
      {Wrapped<num>? webshopId,
      Wrapped<num>? hqId,
      Wrapped<String>? title,
      Wrapped<String?>? specialDescription,
      Wrapped<String?>? salesUnitSize,
      Wrapped<String?>? unitPriceDescription,
      Wrapped<List<Image>?>? images,
      Wrapped<DateTime?>? bonusStartDate,
      Wrapped<DateTime?>? bonusEndDate,
      Wrapped<String?>? discountType,
      Wrapped<String?>? promotionType,
      Wrapped<String?>? segmentType,
      Wrapped<String?>? bonusMechanism,
      Wrapped<double?>? currentPrice,
      Wrapped<double?>? priceBeforeBonus,
      Wrapped<String?>? orderAvailabilityStatus,
      Wrapped<String?>? orderAvailabilityDescription,
      Wrapped<String?>? mainCategory,
      Wrapped<String?>? subCategory,
      Wrapped<num?>? subCategoryId,
      Wrapped<String?>? brand,
      Wrapped<String?>? shopType,
      Wrapped<String?>? bonusPeriodDescription,
      Wrapped<bool?>? availableOnline,
      Wrapped<bool?>? isPreviouslyBought,
      Wrapped<String?>? descriptionHighlights,
      Wrapped<List<String>?>? propertyIcons,
      Wrapped<Map<String, dynamic>?>? properties,
      Wrapped<bool?>? nix18,
      Wrapped<bool?>? isStapelBonus,
      Wrapped<List<String>?>? extraDescriptions,
      Wrapped<num?>? bonusSegmentId,
      Wrapped<String?>? bonusSegmentDescription,
      Wrapped<bool?>? isBonus,
      Wrapped<String?>? descriptionFull,
      Wrapped<bool>? isOrderable,
      Wrapped<bool>? isInfiniteBonus,
      Wrapped<bool>? isSample,
      Wrapped<bool?>? isBonusPrice}) {
    return ProductCard(
        webshopId: (webshopId != null ? webshopId.value : this.webshopId),
        hqId: (hqId != null ? hqId.value : this.hqId),
        title: (title != null ? title.value : this.title),
        specialDescription: (specialDescription != null
            ? specialDescription.value
            : this.specialDescription),
        salesUnitSize:
            (salesUnitSize != null ? salesUnitSize.value : this.salesUnitSize),
        unitPriceDescription: (unitPriceDescription != null
            ? unitPriceDescription.value
            : this.unitPriceDescription),
        images: (images != null ? images.value : this.images),
        bonusStartDate: (bonusStartDate != null
            ? bonusStartDate.value
            : this.bonusStartDate),
        bonusEndDate:
            (bonusEndDate != null ? bonusEndDate.value : this.bonusEndDate),
        discountType:
            (discountType != null ? discountType.value : this.discountType),
        promotionType:
            (promotionType != null ? promotionType.value : this.promotionType),
        segmentType:
            (segmentType != null ? segmentType.value : this.segmentType),
        bonusMechanism: (bonusMechanism != null
            ? bonusMechanism.value
            : this.bonusMechanism),
        currentPrice:
            (currentPrice != null ? currentPrice.value : this.currentPrice),
        priceBeforeBonus: (priceBeforeBonus != null
            ? priceBeforeBonus.value
            : this.priceBeforeBonus),
        orderAvailabilityStatus: (orderAvailabilityStatus != null
            ? orderAvailabilityStatus.value
            : this.orderAvailabilityStatus),
        orderAvailabilityDescription: (orderAvailabilityDescription != null
            ? orderAvailabilityDescription.value
            : this.orderAvailabilityDescription),
        mainCategory:
            (mainCategory != null ? mainCategory.value : this.mainCategory),
        subCategory:
            (subCategory != null ? subCategory.value : this.subCategory),
        subCategoryId:
            (subCategoryId != null ? subCategoryId.value : this.subCategoryId),
        brand: (brand != null ? brand.value : this.brand),
        shopType: (shopType != null ? shopType.value : this.shopType),
        bonusPeriodDescription: (bonusPeriodDescription != null
            ? bonusPeriodDescription.value
            : this.bonusPeriodDescription),
        availableOnline: (availableOnline != null
            ? availableOnline.value
            : this.availableOnline),
        isPreviouslyBought: (isPreviouslyBought != null
            ? isPreviouslyBought.value
            : this.isPreviouslyBought),
        descriptionHighlights: (descriptionHighlights != null
            ? descriptionHighlights.value
            : this.descriptionHighlights),
        propertyIcons:
            (propertyIcons != null ? propertyIcons.value : this.propertyIcons),
        properties: (properties != null ? properties.value : this.properties),
        nix18: (nix18 != null ? nix18.value : this.nix18),
        isStapelBonus:
            (isStapelBonus != null ? isStapelBonus.value : this.isStapelBonus),
        extraDescriptions: (extraDescriptions != null
            ? extraDescriptions.value
            : this.extraDescriptions),
        bonusSegmentId: (bonusSegmentId != null
            ? bonusSegmentId.value
            : this.bonusSegmentId),
        bonusSegmentDescription: (bonusSegmentDescription != null
            ? bonusSegmentDescription.value
            : this.bonusSegmentDescription),
        isBonus: (isBonus != null ? isBonus.value : this.isBonus),
        descriptionFull: (descriptionFull != null
            ? descriptionFull.value
            : this.descriptionFull),
        isOrderable:
            (isOrderable != null ? isOrderable.value : this.isOrderable),
        isInfiniteBonus: (isInfiniteBonus != null
            ? isInfiniteBonus.value
            : this.isInfiniteBonus),
        isSample: (isSample != null ? isSample.value : this.isSample),
        isBonusPrice:
            (isBonusPrice != null ? isBonusPrice.value : this.isBonusPrice));
  }
}

@JsonSerializable(explicitToJson: true)
class Analytics {
  Analytics({
    required this.name,
    this.requestId,
    required this.version,
  });

  factory Analytics.fromJson(Map<String, dynamic> json) =>
      _$AnalyticsFromJson(json);

  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'requestId', includeIfNull: false, defaultValue: '')
  final String? requestId;
  @JsonKey(name: 'version', includeIfNull: false, defaultValue: '')
  final String version;
  static const fromJsonFactory = _$AnalyticsFromJson;
  static const toJsonFactory = _$AnalyticsToJson;
  Map<String, dynamic> toJson() => _$AnalyticsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Analytics &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.requestId, requestId) ||
                const DeepCollectionEquality()
                    .equals(other.requestId, requestId)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality().equals(other.version, version)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(requestId) ^
      const DeepCollectionEquality().hash(version) ^
      runtimeType.hashCode;
}

extension $AnalyticsExtension on Analytics {
  Analytics copyWith({String? name, String? requestId, String? version}) {
    return Analytics(
        name: name ?? this.name,
        requestId: requestId ?? this.requestId,
        version: version ?? this.version);
  }

  Analytics copyWithWrapped(
      {Wrapped<String>? name,
      Wrapped<String?>? requestId,
      Wrapped<String>? version}) {
    return Analytics(
        name: (name != null ? name.value : this.name),
        requestId: (requestId != null ? requestId.value : this.requestId),
        version: (version != null ? version.value : this.version));
  }
}

@JsonSerializable(explicitToJson: true)
class Recommendations {
  Recommendations({
    required this.productCards,
    required this.dataLakeModel,
  });

  factory Recommendations.fromJson(Map<String, dynamic> json) =>
      _$RecommendationsFromJson(json);

  @JsonKey(
      name: 'productCards', includeIfNull: false, defaultValue: <ProductCard>[])
  final List<ProductCard> productCards;
  @JsonKey(name: 'dataLakeModel', includeIfNull: false)
  final Analytics dataLakeModel;
  static const fromJsonFactory = _$RecommendationsFromJson;
  static const toJsonFactory = _$RecommendationsToJson;
  Map<String, dynamic> toJson() => _$RecommendationsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Recommendations &&
            (identical(other.productCards, productCards) ||
                const DeepCollectionEquality()
                    .equals(other.productCards, productCards)) &&
            (identical(other.dataLakeModel, dataLakeModel) ||
                const DeepCollectionEquality()
                    .equals(other.dataLakeModel, dataLakeModel)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(productCards) ^
      const DeepCollectionEquality().hash(dataLakeModel) ^
      runtimeType.hashCode;
}

extension $RecommendationsExtension on Recommendations {
  Recommendations copyWith(
      {List<ProductCard>? productCards, Analytics? dataLakeModel}) {
    return Recommendations(
        productCards: productCards ?? this.productCards,
        dataLakeModel: dataLakeModel ?? this.dataLakeModel);
  }

  Recommendations copyWithWrapped(
      {Wrapped<List<ProductCard>>? productCards,
      Wrapped<Analytics>? dataLakeModel}) {
    return Recommendations(
        productCards:
            (productCards != null ? productCards.value : this.productCards),
        dataLakeModel:
            (dataLakeModel != null ? dataLakeModel.value : this.dataLakeModel));
  }
}

String? v2RecommendationsProductsWebshopIdGetModelToJson(
    enums.V2RecommendationsProductsWebshopIdGetModel?
        v2RecommendationsProductsWebshopIdGetModel) {
  return enums.$V2RecommendationsProductsWebshopIdGetModelMap[
      v2RecommendationsProductsWebshopIdGetModel];
}

enums.V2RecommendationsProductsWebshopIdGetModel
    v2RecommendationsProductsWebshopIdGetModelFromJson(
  Object? v2RecommendationsProductsWebshopIdGetModel, [
  enums.V2RecommendationsProductsWebshopIdGetModel? defaultValue,
]) {
  if (v2RecommendationsProductsWebshopIdGetModel is String) {
    return enums.$V2RecommendationsProductsWebshopIdGetModelMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                v2RecommendationsProductsWebshopIdGetModel.toLowerCase(),
            orElse: () => const MapEntry(
                enums.V2RecommendationsProductsWebshopIdGetModel
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$V2RecommendationsProductsWebshopIdGetModelMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.V2RecommendationsProductsWebshopIdGetModel.swaggerGeneratedUnknown;
}

List<String> v2RecommendationsProductsWebshopIdGetModelListToJson(
    List<enums.V2RecommendationsProductsWebshopIdGetModel>?
        v2RecommendationsProductsWebshopIdGetModel) {
  if (v2RecommendationsProductsWebshopIdGetModel == null) {
    return [];
  }

  return v2RecommendationsProductsWebshopIdGetModel
      .map((e) => enums.$V2RecommendationsProductsWebshopIdGetModelMap[e]!)
      .toList();
}

List<enums.V2RecommendationsProductsWebshopIdGetModel>
    v2RecommendationsProductsWebshopIdGetModelListFromJson(
  List? v2RecommendationsProductsWebshopIdGetModel, [
  List<enums.V2RecommendationsProductsWebshopIdGetModel>? defaultValue,
]) {
  if (v2RecommendationsProductsWebshopIdGetModel == null) {
    return defaultValue ?? [];
  }

  return v2RecommendationsProductsWebshopIdGetModel
      .map((e) =>
          v2RecommendationsProductsWebshopIdGetModelFromJson(e.toString()))
      .toList();
}

List<enums.V2RecommendationsProductsWebshopIdGetModel>?
    v2RecommendationsProductsWebshopIdGetModelNullableListFromJson(
  List? v2RecommendationsProductsWebshopIdGetModel, [
  List<enums.V2RecommendationsProductsWebshopIdGetModel>? defaultValue,
]) {
  if (v2RecommendationsProductsWebshopIdGetModel == null) {
    return defaultValue;
  }

  return v2RecommendationsProductsWebshopIdGetModel
      .map((e) =>
          v2RecommendationsProductsWebshopIdGetModelFromJson(e.toString()))
      .toList();
}

String? v1RecommendationsProductsWebshopIdGetModelToJson(
    enums.V1RecommendationsProductsWebshopIdGetModel?
        v1RecommendationsProductsWebshopIdGetModel) {
  return enums.$V1RecommendationsProductsWebshopIdGetModelMap[
      v1RecommendationsProductsWebshopIdGetModel];
}

enums.V1RecommendationsProductsWebshopIdGetModel
    v1RecommendationsProductsWebshopIdGetModelFromJson(
  Object? v1RecommendationsProductsWebshopIdGetModel, [
  enums.V1RecommendationsProductsWebshopIdGetModel? defaultValue,
]) {
  if (v1RecommendationsProductsWebshopIdGetModel is String) {
    return enums.$V1RecommendationsProductsWebshopIdGetModelMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                v1RecommendationsProductsWebshopIdGetModel.toLowerCase(),
            orElse: () => const MapEntry(
                enums.V1RecommendationsProductsWebshopIdGetModel
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$V1RecommendationsProductsWebshopIdGetModelMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.V1RecommendationsProductsWebshopIdGetModel.swaggerGeneratedUnknown;
}

List<String> v1RecommendationsProductsWebshopIdGetModelListToJson(
    List<enums.V1RecommendationsProductsWebshopIdGetModel>?
        v1RecommendationsProductsWebshopIdGetModel) {
  if (v1RecommendationsProductsWebshopIdGetModel == null) {
    return [];
  }

  return v1RecommendationsProductsWebshopIdGetModel
      .map((e) => enums.$V1RecommendationsProductsWebshopIdGetModelMap[e]!)
      .toList();
}

List<enums.V1RecommendationsProductsWebshopIdGetModel>
    v1RecommendationsProductsWebshopIdGetModelListFromJson(
  List? v1RecommendationsProductsWebshopIdGetModel, [
  List<enums.V1RecommendationsProductsWebshopIdGetModel>? defaultValue,
]) {
  if (v1RecommendationsProductsWebshopIdGetModel == null) {
    return defaultValue ?? [];
  }

  return v1RecommendationsProductsWebshopIdGetModel
      .map((e) =>
          v1RecommendationsProductsWebshopIdGetModelFromJson(e.toString()))
      .toList();
}

List<enums.V1RecommendationsProductsWebshopIdGetModel>?
    v1RecommendationsProductsWebshopIdGetModelNullableListFromJson(
  List? v1RecommendationsProductsWebshopIdGetModel, [
  List<enums.V1RecommendationsProductsWebshopIdGetModel>? defaultValue,
]) {
  if (v1RecommendationsProductsWebshopIdGetModel == null) {
    return defaultValue;
  }

  return v1RecommendationsProductsWebshopIdGetModel
      .map((e) =>
          v1RecommendationsProductsWebshopIdGetModelFromJson(e.toString()))
      .toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
