// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'purchases_remote_data_source.enums.swagger.dart' as enums;
export 'purchases_remote_data_source.enums.swagger.dart';

part 'purchases_remote_data_source.swagger.chopper.dart';
part 'purchases_remote_data_source.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class PurchasesRemoteDataSource extends ChopperService {
  static PurchasesRemoteDataSource create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$PurchasesRemoteDataSource(client);
    }

    final newClient = ChopperClient(
        services: [_$PurchasesRemoteDataSource()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$PurchasesRemoteDataSource(newClient);
  }

  ///
  ///@param Appie-Current-Order-Id
  ///@param pboSortType
  ///@param page
  ///@param size
  ///@param applications
  ///@param x-application The application header which is propagated to the downstream dependencies to get proper information about the products.
  Future<chopper.Response<PagedResponseProductCard>> v1PboSortTypeGet({
    String? appieCurrentOrderId,
    required enums.V1PboSortTypeGetPboSortType? pboSortType,
    int? page,
    int? size,
    List<String>? applications,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(PagedResponseProductCard,
        () => PagedResponseProductCard.fromJsonFactory);

    return _v1PboSortTypeGet(
        appieCurrentOrderId: appieCurrentOrderId,
        pboSortType:
            enums.$V1PboSortTypeGetPboSortTypeMap[pboSortType]?.toString(),
        page: page,
        size: size,
        applications: applications,
        cacheControl: cacheControl);
  }

  ///
  ///@param Appie-Current-Order-Id
  ///@param pboSortType
  ///@param page
  ///@param size
  ///@param applications
  ///@param x-application The application header which is propagated to the downstream dependencies to get proper information about the products.
  @Get(path: '/v1/{pboSortType}')
  Future<chopper.Response<PagedResponseProductCard>> _v1PboSortTypeGet({
    @Header('Appie-Current-Order-Id') String? appieCurrentOrderId,
    @Path('pboSortType') required String? pboSortType,
    @Query('page') int? page,
    @Query('size') int? size,
    @Query('applications') List<String>? applications,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param Appie-Current-Order-Id
  ///@param nutrientCode
  ///@param size
  Future<chopper.Response<PagedResponseProductCard>>
      v1NutrientsTopContributorsGet({
    String? appieCurrentOrderId,
    required String? nutrientCode,
    int? size,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(PagedResponseProductCard,
        () => PagedResponseProductCard.fromJsonFactory);

    return _v1NutrientsTopContributorsGet(
        appieCurrentOrderId: appieCurrentOrderId,
        nutrientCode: nutrientCode,
        size: size,
        cacheControl: cacheControl);
  }

  ///
  ///@param Appie-Current-Order-Id
  ///@param nutrientCode
  ///@param size
  @Get(path: '/v1/nutrients/top-contributors')
  Future<chopper.Response<PagedResponseProductCard>>
      _v1NutrientsTopContributorsGet({
    @Header('Appie-Current-Order-Id') String? appieCurrentOrderId,
    @Query('nutrientCode') required String? nutrientCode,
    @Query('size') int? size,
    @Header('Cache-Control') String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class Image {
  Image({
    required this.width,
    required this.height,
    required this.url,
  });

  factory Image.fromJson(Map<String, dynamic> json) => _$ImageFromJson(json);

  @JsonKey(name: 'width', includeIfNull: false)
  final int width;
  @JsonKey(name: 'height', includeIfNull: false)
  final int height;
  @JsonKey(name: 'url', includeIfNull: false, defaultValue: '')
  final String url;
  static const fromJsonFactory = _$ImageFromJson;
  static const toJsonFactory = _$ImageToJson;
  Map<String, dynamic> toJson() => _$ImageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Image &&
            (identical(other.width, width) ||
                const DeepCollectionEquality().equals(other.width, width)) &&
            (identical(other.height, height) ||
                const DeepCollectionEquality().equals(other.height, height)) &&
            (identical(other.url, url) ||
                const DeepCollectionEquality().equals(other.url, url)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(width) ^
      const DeepCollectionEquality().hash(height) ^
      const DeepCollectionEquality().hash(url) ^
      runtimeType.hashCode;
}

extension $ImageExtension on Image {
  Image copyWith({int? width, int? height, String? url}) {
    return Image(
        width: width ?? this.width,
        height: height ?? this.height,
        url: url ?? this.url);
  }

  Image copyWithWrapped(
      {Wrapped<int>? width, Wrapped<int>? height, Wrapped<String>? url}) {
    return Image(
        width: (width != null ? width.value : this.width),
        height: (height != null ? height.value : this.height),
        url: (url != null ? url.value : this.url));
  }
}

@JsonSerializable(explicitToJson: true)
class PageProductCard {
  PageProductCard({
    this.totalElements,
    this.size,
    this.totalPages,
    this.number,
  });

  factory PageProductCard.fromJson(Map<String, dynamic> json) =>
      _$PageProductCardFromJson(json);

  @JsonKey(name: 'totalElements', includeIfNull: false)
  final num? totalElements;
  @JsonKey(name: 'size', includeIfNull: false)
  final num? size;
  @JsonKey(name: 'totalPages', includeIfNull: false)
  final num? totalPages;
  @JsonKey(name: 'number', includeIfNull: false)
  final num? number;
  static const fromJsonFactory = _$PageProductCardFromJson;
  static const toJsonFactory = _$PageProductCardToJson;
  Map<String, dynamic> toJson() => _$PageProductCardToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PageProductCard &&
            (identical(other.totalElements, totalElements) ||
                const DeepCollectionEquality()
                    .equals(other.totalElements, totalElements)) &&
            (identical(other.size, size) ||
                const DeepCollectionEquality().equals(other.size, size)) &&
            (identical(other.totalPages, totalPages) ||
                const DeepCollectionEquality()
                    .equals(other.totalPages, totalPages)) &&
            (identical(other.number, number) ||
                const DeepCollectionEquality().equals(other.number, number)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(totalElements) ^
      const DeepCollectionEquality().hash(size) ^
      const DeepCollectionEquality().hash(totalPages) ^
      const DeepCollectionEquality().hash(number) ^
      runtimeType.hashCode;
}

extension $PageProductCardExtension on PageProductCard {
  PageProductCard copyWith(
      {num? totalElements, num? size, num? totalPages, num? number}) {
    return PageProductCard(
        totalElements: totalElements ?? this.totalElements,
        size: size ?? this.size,
        totalPages: totalPages ?? this.totalPages,
        number: number ?? this.number);
  }

  PageProductCard copyWithWrapped(
      {Wrapped<num?>? totalElements,
      Wrapped<num?>? size,
      Wrapped<num?>? totalPages,
      Wrapped<num?>? number}) {
    return PageProductCard(
        totalElements:
            (totalElements != null ? totalElements.value : this.totalElements),
        size: (size != null ? size.value : this.size),
        totalPages: (totalPages != null ? totalPages.value : this.totalPages),
        number: (number != null ? number.value : this.number));
  }
}

@JsonSerializable(explicitToJson: true)
class PagedResponseProductCard {
  PagedResponseProductCard({
    this.content,
    required this.page,
  });

  factory PagedResponseProductCard.fromJson(Map<String, dynamic> json) =>
      _$PagedResponseProductCardFromJson(json);

  @JsonKey(name: 'content', includeIfNull: false, defaultValue: <ProductCard>[])
  final List<ProductCard>? content;
  @JsonKey(name: 'page', includeIfNull: false)
  final PageProductCard page;
  static const fromJsonFactory = _$PagedResponseProductCardFromJson;
  static const toJsonFactory = _$PagedResponseProductCardToJson;
  Map<String, dynamic> toJson() => _$PagedResponseProductCardToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PagedResponseProductCard &&
            (identical(other.content, content) ||
                const DeepCollectionEquality()
                    .equals(other.content, content)) &&
            (identical(other.page, page) ||
                const DeepCollectionEquality().equals(other.page, page)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(content) ^
      const DeepCollectionEquality().hash(page) ^
      runtimeType.hashCode;
}

extension $PagedResponseProductCardExtension on PagedResponseProductCard {
  PagedResponseProductCard copyWith(
      {List<ProductCard>? content, PageProductCard? page}) {
    return PagedResponseProductCard(
        content: content ?? this.content, page: page ?? this.page);
  }

  PagedResponseProductCard copyWithWrapped(
      {Wrapped<List<ProductCard>?>? content, Wrapped<PageProductCard>? page}) {
    return PagedResponseProductCard(
        content: (content != null ? content.value : this.content),
        page: (page != null ? page.value : this.page));
  }
}

@JsonSerializable(explicitToJson: true)
class ProductCard {
  ProductCard({
    required this.webshopId,
    required this.title,
    this.specialDescription,
    this.salesUnitSize,
    this.images,
    this.discountType,
    this.segmentType,
    this.promotionType,
    this.bonusMechanism,
    this.currentPrice,
    this.priceBeforeBonus,
    this.orderAvailabilityStatus,
    this.orderAvailabilityDescription,
    this.mainCategory,
    this.subCategory,
    this.brand,
    this.shopType,
    this.bonusPeriodDescription,
    this.availableOnline,
    this.isPreviouslyBought,
    this.propertyIcons,
    this.isStapelBonus,
    this.extraDescriptions,
    this.isBonus,
    required this.isSample,
    this.isBonusPrice,
  });

  factory ProductCard.fromJson(Map<String, dynamic> json) =>
      _$ProductCardFromJson(json);

  @JsonKey(name: 'webshopId', includeIfNull: false)
  final num webshopId;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  @JsonKey(name: 'specialDescription', includeIfNull: false, defaultValue: '')
  final String? specialDescription;
  @JsonKey(name: 'salesUnitSize', includeIfNull: false, defaultValue: '')
  final String? salesUnitSize;
  @JsonKey(name: 'images', includeIfNull: false, defaultValue: <Image>[])
  final List<Image>? images;
  @JsonKey(name: 'discountType', includeIfNull: false, defaultValue: '')
  final String? discountType;
  @JsonKey(name: 'segmentType', includeIfNull: false, defaultValue: '')
  final String? segmentType;
  @JsonKey(name: 'promotionType', includeIfNull: false, defaultValue: '')
  final String? promotionType;
  @JsonKey(name: 'bonusMechanism', includeIfNull: false, defaultValue: '')
  final String? bonusMechanism;
  @JsonKey(name: 'currentPrice', includeIfNull: false)
  final double? currentPrice;
  @JsonKey(name: 'priceBeforeBonus', includeIfNull: false)
  final double? priceBeforeBonus;
  @JsonKey(
      name: 'orderAvailabilityStatus', includeIfNull: false, defaultValue: '')
  final String? orderAvailabilityStatus;
  @JsonKey(
      name: 'orderAvailabilityDescription',
      includeIfNull: false,
      defaultValue: '')
  final String? orderAvailabilityDescription;
  @JsonKey(name: 'mainCategory', includeIfNull: false, defaultValue: '')
  final String? mainCategory;
  @JsonKey(name: 'subCategory', includeIfNull: false, defaultValue: '')
  final String? subCategory;
  @JsonKey(name: 'brand', includeIfNull: false, defaultValue: '')
  final String? brand;
  @JsonKey(name: 'shopType', includeIfNull: false, defaultValue: '')
  final String? shopType;
  @JsonKey(
      name: 'bonusPeriodDescription', includeIfNull: false, defaultValue: '')
  final String? bonusPeriodDescription;
  @JsonKey(name: 'availableOnline', includeIfNull: false)
  final bool? availableOnline;
  @JsonKey(name: 'isPreviouslyBought', includeIfNull: false)
  final bool? isPreviouslyBought;
  @JsonKey(
      name: 'propertyIcons', includeIfNull: false, defaultValue: <String>[])
  final List<String>? propertyIcons;
  @JsonKey(name: 'isStapelBonus', includeIfNull: false)
  final bool? isStapelBonus;
  @JsonKey(
      name: 'extraDescriptions', includeIfNull: false, defaultValue: <String>[])
  final List<String>? extraDescriptions;
  @JsonKey(name: 'isBonus', includeIfNull: false)
  final bool? isBonus;
  @JsonKey(name: 'isSample', includeIfNull: false)
  final bool isSample;
  @JsonKey(name: 'isBonusPrice', includeIfNull: false)
  final bool? isBonusPrice;
  static const fromJsonFactory = _$ProductCardFromJson;
  static const toJsonFactory = _$ProductCardToJson;
  Map<String, dynamic> toJson() => _$ProductCardToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProductCard &&
            (identical(other.webshopId, webshopId) ||
                const DeepCollectionEquality()
                    .equals(other.webshopId, webshopId)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.specialDescription, specialDescription) ||
                const DeepCollectionEquality()
                    .equals(other.specialDescription, specialDescription)) &&
            (identical(other.salesUnitSize, salesUnitSize) ||
                const DeepCollectionEquality()
                    .equals(other.salesUnitSize, salesUnitSize)) &&
            (identical(other.images, images) ||
                const DeepCollectionEquality().equals(other.images, images)) &&
            (identical(other.discountType, discountType) ||
                const DeepCollectionEquality()
                    .equals(other.discountType, discountType)) &&
            (identical(other.segmentType, segmentType) ||
                const DeepCollectionEquality()
                    .equals(other.segmentType, segmentType)) &&
            (identical(other.promotionType, promotionType) ||
                const DeepCollectionEquality()
                    .equals(other.promotionType, promotionType)) &&
            (identical(other.bonusMechanism, bonusMechanism) ||
                const DeepCollectionEquality()
                    .equals(other.bonusMechanism, bonusMechanism)) &&
            (identical(other.currentPrice, currentPrice) ||
                const DeepCollectionEquality()
                    .equals(other.currentPrice, currentPrice)) &&
            (identical(other.priceBeforeBonus, priceBeforeBonus) ||
                const DeepCollectionEquality()
                    .equals(other.priceBeforeBonus, priceBeforeBonus)) &&
            (identical(other.orderAvailabilityStatus, orderAvailabilityStatus) ||
                const DeepCollectionEquality().equals(
                    other.orderAvailabilityStatus, orderAvailabilityStatus)) &&
            (identical(other.orderAvailabilityDescription, orderAvailabilityDescription) ||
                const DeepCollectionEquality().equals(
                    other.orderAvailabilityDescription,
                    orderAvailabilityDescription)) &&
            (identical(other.mainCategory, mainCategory) ||
                const DeepCollectionEquality()
                    .equals(other.mainCategory, mainCategory)) &&
            (identical(other.subCategory, subCategory) ||
                const DeepCollectionEquality()
                    .equals(other.subCategory, subCategory)) &&
            (identical(other.brand, brand) ||
                const DeepCollectionEquality().equals(other.brand, brand)) &&
            (identical(other.shopType, shopType) ||
                const DeepCollectionEquality()
                    .equals(other.shopType, shopType)) &&
            (identical(other.bonusPeriodDescription, bonusPeriodDescription) ||
                const DeepCollectionEquality().equals(
                    other.bonusPeriodDescription, bonusPeriodDescription)) &&
            (identical(other.availableOnline, availableOnline) ||
                const DeepCollectionEquality()
                    .equals(other.availableOnline, availableOnline)) &&
            (identical(other.isPreviouslyBought, isPreviouslyBought) || const DeepCollectionEquality().equals(other.isPreviouslyBought, isPreviouslyBought)) &&
            (identical(other.propertyIcons, propertyIcons) || const DeepCollectionEquality().equals(other.propertyIcons, propertyIcons)) &&
            (identical(other.isStapelBonus, isStapelBonus) || const DeepCollectionEquality().equals(other.isStapelBonus, isStapelBonus)) &&
            (identical(other.extraDescriptions, extraDescriptions) || const DeepCollectionEquality().equals(other.extraDescriptions, extraDescriptions)) &&
            (identical(other.isBonus, isBonus) || const DeepCollectionEquality().equals(other.isBonus, isBonus)) &&
            (identical(other.isSample, isSample) || const DeepCollectionEquality().equals(other.isSample, isSample)) &&
            (identical(other.isBonusPrice, isBonusPrice) || const DeepCollectionEquality().equals(other.isBonusPrice, isBonusPrice)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(webshopId) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(specialDescription) ^
      const DeepCollectionEquality().hash(salesUnitSize) ^
      const DeepCollectionEquality().hash(images) ^
      const DeepCollectionEquality().hash(discountType) ^
      const DeepCollectionEquality().hash(segmentType) ^
      const DeepCollectionEquality().hash(promotionType) ^
      const DeepCollectionEquality().hash(bonusMechanism) ^
      const DeepCollectionEquality().hash(currentPrice) ^
      const DeepCollectionEquality().hash(priceBeforeBonus) ^
      const DeepCollectionEquality().hash(orderAvailabilityStatus) ^
      const DeepCollectionEquality().hash(orderAvailabilityDescription) ^
      const DeepCollectionEquality().hash(mainCategory) ^
      const DeepCollectionEquality().hash(subCategory) ^
      const DeepCollectionEquality().hash(brand) ^
      const DeepCollectionEquality().hash(shopType) ^
      const DeepCollectionEquality().hash(bonusPeriodDescription) ^
      const DeepCollectionEquality().hash(availableOnline) ^
      const DeepCollectionEquality().hash(isPreviouslyBought) ^
      const DeepCollectionEquality().hash(propertyIcons) ^
      const DeepCollectionEquality().hash(isStapelBonus) ^
      const DeepCollectionEquality().hash(extraDescriptions) ^
      const DeepCollectionEquality().hash(isBonus) ^
      const DeepCollectionEquality().hash(isSample) ^
      const DeepCollectionEquality().hash(isBonusPrice) ^
      runtimeType.hashCode;
}

extension $ProductCardExtension on ProductCard {
  ProductCard copyWith(
      {num? webshopId,
      String? title,
      String? specialDescription,
      String? salesUnitSize,
      List<Image>? images,
      String? discountType,
      String? segmentType,
      String? promotionType,
      String? bonusMechanism,
      double? currentPrice,
      double? priceBeforeBonus,
      String? orderAvailabilityStatus,
      String? orderAvailabilityDescription,
      String? mainCategory,
      String? subCategory,
      String? brand,
      String? shopType,
      String? bonusPeriodDescription,
      bool? availableOnline,
      bool? isPreviouslyBought,
      List<String>? propertyIcons,
      bool? isStapelBonus,
      List<String>? extraDescriptions,
      bool? isBonus,
      bool? isSample,
      bool? isBonusPrice}) {
    return ProductCard(
        webshopId: webshopId ?? this.webshopId,
        title: title ?? this.title,
        specialDescription: specialDescription ?? this.specialDescription,
        salesUnitSize: salesUnitSize ?? this.salesUnitSize,
        images: images ?? this.images,
        discountType: discountType ?? this.discountType,
        segmentType: segmentType ?? this.segmentType,
        promotionType: promotionType ?? this.promotionType,
        bonusMechanism: bonusMechanism ?? this.bonusMechanism,
        currentPrice: currentPrice ?? this.currentPrice,
        priceBeforeBonus: priceBeforeBonus ?? this.priceBeforeBonus,
        orderAvailabilityStatus:
            orderAvailabilityStatus ?? this.orderAvailabilityStatus,
        orderAvailabilityDescription:
            orderAvailabilityDescription ?? this.orderAvailabilityDescription,
        mainCategory: mainCategory ?? this.mainCategory,
        subCategory: subCategory ?? this.subCategory,
        brand: brand ?? this.brand,
        shopType: shopType ?? this.shopType,
        bonusPeriodDescription:
            bonusPeriodDescription ?? this.bonusPeriodDescription,
        availableOnline: availableOnline ?? this.availableOnline,
        isPreviouslyBought: isPreviouslyBought ?? this.isPreviouslyBought,
        propertyIcons: propertyIcons ?? this.propertyIcons,
        isStapelBonus: isStapelBonus ?? this.isStapelBonus,
        extraDescriptions: extraDescriptions ?? this.extraDescriptions,
        isBonus: isBonus ?? this.isBonus,
        isSample: isSample ?? this.isSample,
        isBonusPrice: isBonusPrice ?? this.isBonusPrice);
  }

  ProductCard copyWithWrapped(
      {Wrapped<num>? webshopId,
      Wrapped<String>? title,
      Wrapped<String?>? specialDescription,
      Wrapped<String?>? salesUnitSize,
      Wrapped<List<Image>?>? images,
      Wrapped<String?>? discountType,
      Wrapped<String?>? segmentType,
      Wrapped<String?>? promotionType,
      Wrapped<String?>? bonusMechanism,
      Wrapped<double?>? currentPrice,
      Wrapped<double?>? priceBeforeBonus,
      Wrapped<String?>? orderAvailabilityStatus,
      Wrapped<String?>? orderAvailabilityDescription,
      Wrapped<String?>? mainCategory,
      Wrapped<String?>? subCategory,
      Wrapped<String?>? brand,
      Wrapped<String?>? shopType,
      Wrapped<String?>? bonusPeriodDescription,
      Wrapped<bool?>? availableOnline,
      Wrapped<bool?>? isPreviouslyBought,
      Wrapped<List<String>?>? propertyIcons,
      Wrapped<bool?>? isStapelBonus,
      Wrapped<List<String>?>? extraDescriptions,
      Wrapped<bool?>? isBonus,
      Wrapped<bool>? isSample,
      Wrapped<bool?>? isBonusPrice}) {
    return ProductCard(
        webshopId: (webshopId != null ? webshopId.value : this.webshopId),
        title: (title != null ? title.value : this.title),
        specialDescription: (specialDescription != null
            ? specialDescription.value
            : this.specialDescription),
        salesUnitSize:
            (salesUnitSize != null ? salesUnitSize.value : this.salesUnitSize),
        images: (images != null ? images.value : this.images),
        discountType:
            (discountType != null ? discountType.value : this.discountType),
        segmentType:
            (segmentType != null ? segmentType.value : this.segmentType),
        promotionType:
            (promotionType != null ? promotionType.value : this.promotionType),
        bonusMechanism: (bonusMechanism != null
            ? bonusMechanism.value
            : this.bonusMechanism),
        currentPrice:
            (currentPrice != null ? currentPrice.value : this.currentPrice),
        priceBeforeBonus: (priceBeforeBonus != null
            ? priceBeforeBonus.value
            : this.priceBeforeBonus),
        orderAvailabilityStatus: (orderAvailabilityStatus != null
            ? orderAvailabilityStatus.value
            : this.orderAvailabilityStatus),
        orderAvailabilityDescription: (orderAvailabilityDescription != null
            ? orderAvailabilityDescription.value
            : this.orderAvailabilityDescription),
        mainCategory:
            (mainCategory != null ? mainCategory.value : this.mainCategory),
        subCategory:
            (subCategory != null ? subCategory.value : this.subCategory),
        brand: (brand != null ? brand.value : this.brand),
        shopType: (shopType != null ? shopType.value : this.shopType),
        bonusPeriodDescription: (bonusPeriodDescription != null
            ? bonusPeriodDescription.value
            : this.bonusPeriodDescription),
        availableOnline: (availableOnline != null
            ? availableOnline.value
            : this.availableOnline),
        isPreviouslyBought: (isPreviouslyBought != null
            ? isPreviouslyBought.value
            : this.isPreviouslyBought),
        propertyIcons:
            (propertyIcons != null ? propertyIcons.value : this.propertyIcons),
        isStapelBonus:
            (isStapelBonus != null ? isStapelBonus.value : this.isStapelBonus),
        extraDescriptions: (extraDescriptions != null
            ? extraDescriptions.value
            : this.extraDescriptions),
        isBonus: (isBonus != null ? isBonus.value : this.isBonus),
        isSample: (isSample != null ? isSample.value : this.isSample),
        isBonusPrice:
            (isBonusPrice != null ? isBonusPrice.value : this.isBonusPrice));
  }
}

String? v1PboSortTypeGetPboSortTypeToJson(
    enums.V1PboSortTypeGetPboSortType? v1PboSortTypeGetPboSortType) {
  return enums.$V1PboSortTypeGetPboSortTypeMap[v1PboSortTypeGetPboSortType];
}

enums.V1PboSortTypeGetPboSortType v1PboSortTypeGetPboSortTypeFromJson(
  Object? v1PboSortTypeGetPboSortType, [
  enums.V1PboSortTypeGetPboSortType? defaultValue,
]) {
  if (v1PboSortTypeGetPboSortType is String) {
    return enums.$V1PboSortTypeGetPboSortTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                v1PboSortTypeGetPboSortType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.V1PboSortTypeGetPboSortType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$V1PboSortTypeGetPboSortTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.V1PboSortTypeGetPboSortType.swaggerGeneratedUnknown;
}

List<String> v1PboSortTypeGetPboSortTypeListToJson(
    List<enums.V1PboSortTypeGetPboSortType>? v1PboSortTypeGetPboSortType) {
  if (v1PboSortTypeGetPboSortType == null) {
    return [];
  }

  return v1PboSortTypeGetPboSortType
      .map((e) => enums.$V1PboSortTypeGetPboSortTypeMap[e]!)
      .toList();
}

List<enums.V1PboSortTypeGetPboSortType> v1PboSortTypeGetPboSortTypeListFromJson(
  List? v1PboSortTypeGetPboSortType, [
  List<enums.V1PboSortTypeGetPboSortType>? defaultValue,
]) {
  if (v1PboSortTypeGetPboSortType == null) {
    return defaultValue ?? [];
  }

  return v1PboSortTypeGetPboSortType
      .map((e) => v1PboSortTypeGetPboSortTypeFromJson(e.toString()))
      .toList();
}

List<enums.V1PboSortTypeGetPboSortType>?
    v1PboSortTypeGetPboSortTypeNullableListFromJson(
  List? v1PboSortTypeGetPboSortType, [
  List<enums.V1PboSortTypeGetPboSortType>? defaultValue,
]) {
  if (v1PboSortTypeGetPboSortType == null) {
    return defaultValue;
  }

  return v1PboSortTypeGetPboSortType
      .map((e) => v1PboSortTypeGetPboSortTypeFromJson(e.toString()))
      .toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
