import 'package:json_annotation/json_annotation.dart';

enum RecordingState {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('recorded')
  recorded,
  @JsonValue('partiallyRecorded')
  partiallyrecorded,
  @JsonValue('planned')
  planned,
  @JsonValue('ongoing')
  ongoing,
  @JsonValue('failed')
  failed,
  @JsonValue('blackedOut')
  blackedout,
  @JsonValue('quotaExceeded')
  quotaexceeded,
  @JsonValue('bookingPending')
  bookingpending,
  @JsonValue('cancelled')
  cancelled
}

const $RecordingStateMap = {
  RecordingState.recorded: 'recorded',
  RecordingState.partiallyrecorded: 'partiallyRecorded',
  RecordingState.planned: 'planned',
  RecordingState.ongoing: 'ongoing',
  RecordingState.failed: 'failed',
  RecordingState.blackedout: 'blackedOut',
  RecordingState.quotaexceeded: 'quotaExceeded',
  RecordingState.bookingpending: 'bookingPending',
  RecordingState.cancelled: 'cancelled'
};

enum RecordingType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('nDVR')
  ndvr,
  @JsonValue('LDVR')
  ldvr
}

const $RecordingTypeMap = {
  RecordingType.ndvr: 'nDVR',
  RecordingType.ldvr: 'LDVR'
};

enum ExpansionType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('fromThisSeason')
  fromthisseason,
  @JsonValue('fromThisEpisode')
  fromthisepisode,
  @JsonValue('wholeShow')
  wholeshow,
  @JsonValue('onlyThisSeason')
  onlythisseason,
  @JsonValue('premiere')
  premiere
}

const $ExpansionTypeMap = {
  ExpansionType.fromthisseason: 'fromThisSeason',
  ExpansionType.fromthisepisode: 'fromThisEpisode',
  ExpansionType.wholeshow: 'wholeShow',
  ExpansionType.onlythisseason: 'onlyThisSeason',
  ExpansionType.premiere: 'premiere'
};

enum ItemType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('single')
  single,
  @JsonValue('season')
  season,
  @JsonValue('show')
  show
}

const $ItemTypeMap = {
  ItemType.single: 'single',
  ItemType.season: 'season',
  ItemType.show: 'show'
};

enum AssetizationStatus {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('pending')
  pending,
  @JsonValue('inProcess')
  inprocess,
  @JsonValue('completed')
  completed,
  @JsonValue('failed')
  failed
}

const $AssetizationStatusMap = {
  AssetizationStatus.pending: 'pending',
  AssetizationStatus.inprocess: 'inProcess',
  AssetizationStatus.completed: 'completed',
  AssetizationStatus.failed: 'failed'
};

enum FailureReason {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('USER_ACTION')
  userAction,
  @JsonValue('NOT_IN_REVIEW_BUFFER')
  notInReviewBuffer,
  @JsonValue('DISK_FULL')
  diskFull,
  @JsonValue('NO_ENTITLEMENT')
  noEntitlement,
  @JsonValue('POWER_CUT')
  powerCut,
  @JsonValue('MANUAL_CONFLICT_RESOLUTION')
  manualConflictResolution,
  @JsonValue('AUTO_CONFLICT_RESOLUTION')
  autoConflictResolution,
  @JsonValue('SIGNAL_LOSS')
  signalLoss,
  @JsonValue('EPG_UPDATE')
  epgUpdate,
  @JsonValue('CHANNEL_LINEUP_CHANGE')
  channelLineupChange,
  @JsonValue('INTERNAL_ERROR')
  internalError,
  @JsonValue('CHANNEL_OFF_AIR')
  channelOffAir,
  @JsonValue('BLACKOUT')
  blackout,
  @JsonValue('QUOTA_EXCEEDED')
  quotaExceeded
}

const $FailureReasonMap = {
  FailureReason.userAction: 'USER_ACTION',
  FailureReason.notInReviewBuffer: 'NOT_IN_REVIEW_BUFFER',
  FailureReason.diskFull: 'DISK_FULL',
  FailureReason.noEntitlement: 'NO_ENTITLEMENT',
  FailureReason.powerCut: 'POWER_CUT',
  FailureReason.manualConflictResolution: 'MANUAL_CONFLICT_RESOLUTION',
  FailureReason.autoConflictResolution: 'AUTO_CONFLICT_RESOLUTION',
  FailureReason.signalLoss: 'SIGNAL_LOSS',
  FailureReason.epgUpdate: 'EPG_UPDATE',
  FailureReason.channelLineupChange: 'CHANNEL_LINEUP_CHANGE',
  FailureReason.internalError: 'INTERNAL_ERROR',
  FailureReason.channelOffAir: 'CHANNEL_OFF_AIR',
  FailureReason.blackout: 'BLACKOUT',
  FailureReason.quotaExceeded: 'QUOTA_EXCEEDED'
};

enum Source {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('single')
  single,
  @JsonValue('show')
  show
}

const $SourceMap = {Source.single: 'single', Source.show: 'show'};

enum RecordingsKind {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('bookings')
  bookings,
  @JsonValue('recordings')
  recordings
}

const $RecordingsKindMap = {
  RecordingsKind.bookings: 'bookings',
  RecordingsKind.recordings: 'recordings'
};

enum Recordings$ItemType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('abr')
  abr,
  @JsonValue('cbr')
  cbr
}

const $Recordings$ItemTypeMap = {
  Recordings$ItemType.abr: 'abr',
  Recordings$ItemType.cbr: 'cbr'
};

enum OpWithNetworkRecordingsOp {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('update')
  update
}

const $OpWithNetworkRecordingsOpMap = {
  OpWithNetworkRecordingsOp.update: 'update'
};

enum Op {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('update')
  update,
  @JsonValue('delete')
  delete
}

const $OpMap = {Op.update: 'update', Op.delete: 'delete'};

enum CustomersCustomerIdRecordingsGetMostRelevantEpisodeFor {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('bookings')
  bookings,
  @JsonValue('recordings')
  recordings
}

const $CustomersCustomerIdRecordingsGetMostRelevantEpisodeForMap = {
  CustomersCustomerIdRecordingsGetMostRelevantEpisodeFor.bookings: 'bookings',
  CustomersCustomerIdRecordingsGetMostRelevantEpisodeFor.recordings:
      'recordings'
};

enum CustomersCustomerIdRecordingsGetRecordingsKind {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('bookings')
  bookings,
  @JsonValue('recordings')
  recordings
}

const $CustomersCustomerIdRecordingsGetRecordingsKindMap = {
  CustomersCustomerIdRecordingsGetRecordingsKind.bookings: 'bookings',
  CustomersCustomerIdRecordingsGetRecordingsKind.recordings: 'recordings'
};

enum CustomersCustomerIdRecordingsGetSort {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('time')
  time,
  @JsonValue('title')
  title,
  @JsonValue('episode')
  episode,
  @JsonValue('diskSpace')
  diskspace
}

const $CustomersCustomerIdRecordingsGetSortMap = {
  CustomersCustomerIdRecordingsGetSort.time: 'time',
  CustomersCustomerIdRecordingsGetSort.title: 'title',
  CustomersCustomerIdRecordingsGetSort.episode: 'episode',
  CustomersCustomerIdRecordingsGetSort.diskspace: 'diskSpace'
};

enum CustomersCustomerIdRecordingsGetSortOrder {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('asc')
  asc,
  @JsonValue('desc')
  desc
}

const $CustomersCustomerIdRecordingsGetSortOrderMap = {
  CustomersCustomerIdRecordingsGetSortOrder.asc: 'asc',
  CustomersCustomerIdRecordingsGetSortOrder.desc: 'desc'
};

enum CustomersCustomerIdRecordingsShowGetRecordingType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('nDVR')
  ndvr,
  @JsonValue('LDVR')
  ldvr
}

const $CustomersCustomerIdRecordingsShowGetRecordingTypeMap = {
  CustomersCustomerIdRecordingsShowGetRecordingType.ndvr: 'nDVR',
  CustomersCustomerIdRecordingsShowGetRecordingType.ldvr: 'LDVR'
};
