// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'showing_swagger.enums.swagger.dart' as enums;
export 'showing_swagger.enums.swagger.dart';

part 'showing_swagger.swagger.chopper.dart';
part 'showing_swagger.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class ShowingSwagger extends ChopperService {
  static ShowingSwagger create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$ShowingSwagger(client);
    }

    final newClient = ChopperClient(
        services: [_$ShowingSwagger()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$ShowingSwagger(newClient);
  }

  ///
  ///@param Jwt
  Future<chopper.Response<AttributeReadDtoListBaseResponseDto>>
      apiV1ShowingAttributesGet({
    String? jwt,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(AttributeReadDtoListBaseResponseDto,
        () => AttributeReadDtoListBaseResponseDto.fromJsonFactory);

    return _apiV1ShowingAttributesGet(jwt: jwt, cacheControl: cacheControl);
  }

  ///
  ///@param Jwt
  @Get(path: '/api/v1/showing/attributes')
  Future<chopper.Response<AttributeReadDtoListBaseResponseDto>>
      _apiV1ShowingAttributesGet({
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param cinemaId
  ///@param Jwt
  Future<chopper.Response<ShowingAttributeReadDtoListBaseResponseDto>>
      apiV1ShowingAttributesShowingAttributeGroupsCinemaIdGet({
    required String? cinemaId,
    String? jwt,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ShowingAttributeReadDtoListBaseResponseDto,
        () => ShowingAttributeReadDtoListBaseResponseDto.fromJsonFactory);

    return _apiV1ShowingAttributesShowingAttributeGroupsCinemaIdGet(
        cinemaId: cinemaId, jwt: jwt, cacheControl: cacheControl);
  }

  ///
  ///@param cinemaId
  ///@param Jwt
  @Get(path: '/api/v1/showing/attributes/showingAttributeGroups/{cinemaId}')
  Future<chopper.Response<ShowingAttributeReadDtoListBaseResponseDto>>
      _apiV1ShowingAttributesShowingAttributeGroupsCinemaIdGet({
    @Path('cinemaId') required String? cinemaId,
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param Jwt
  Future<chopper.Response<CinemaReadDtoListBaseResponseDto>>
      apiV1ShowingCinemasDetailedGet({
    String? jwt,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CinemaReadDtoListBaseResponseDto,
        () => CinemaReadDtoListBaseResponseDto.fromJsonFactory);

    return _apiV1ShowingCinemasDetailedGet(
        jwt: jwt, cacheControl: cacheControl);
  }

  ///
  ///@param Jwt
  @Get(path: '/api/v1/showing/cinemas/detailed')
  Future<chopper.Response<CinemaReadDtoListBaseResponseDto>>
      _apiV1ShowingCinemasDetailedGet({
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param cinemaId
  ///@param graceMinutes
  ///@param Jwt
  Future<chopper.Response<ShowingReadDtoListBaseResponseDto>>
      apiV1ShowingCinemasCinemaIdShowingsGet({
    required String? cinemaId,
    int? graceMinutes,
    String? jwt,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ShowingReadDtoListBaseResponseDto,
        () => ShowingReadDtoListBaseResponseDto.fromJsonFactory);

    return _apiV1ShowingCinemasCinemaIdShowingsGet(
        cinemaId: cinemaId,
        graceMinutes: graceMinutes,
        jwt: jwt,
        cacheControl: cacheControl);
  }

  ///
  ///@param cinemaId
  ///@param graceMinutes
  ///@param Jwt
  @Get(path: '/api/v1/showing/cinemas/{cinemaId}/showings')
  Future<chopper.Response<ShowingReadDtoListBaseResponseDto>>
      _apiV1ShowingCinemasCinemaIdShowingsGet({
    @Path('cinemaId') required String? cinemaId,
    @Query('graceMinutes') int? graceMinutes,
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param cinemaId
  ///@param ediFilmId
  ///@param graceMinutes
  ///@param Jwt
  Future<chopper.Response<ShowingReadDtoListBaseResponseDto>>
      apiV1ShowingCinemasCinemaIdFilmsEdiFilmIdShowingsGet({
    required String? cinemaId,
    required String? ediFilmId,
    int? graceMinutes,
    String? jwt,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ShowingReadDtoListBaseResponseDto,
        () => ShowingReadDtoListBaseResponseDto.fromJsonFactory);

    return _apiV1ShowingCinemasCinemaIdFilmsEdiFilmIdShowingsGet(
        cinemaId: cinemaId,
        ediFilmId: ediFilmId,
        graceMinutes: graceMinutes,
        jwt: jwt,
        cacheControl: cacheControl);
  }

  ///
  ///@param cinemaId
  ///@param ediFilmId
  ///@param graceMinutes
  ///@param Jwt
  @Get(path: '/api/v1/showing/cinemas/{cinemaId}/films/{ediFilmId}/showings')
  Future<chopper.Response<ShowingReadDtoListBaseResponseDto>>
      _apiV1ShowingCinemasCinemaIdFilmsEdiFilmIdShowingsGet({
    @Path('cinemaId') required String? cinemaId,
    @Path('ediFilmId') required String? ediFilmId,
    @Query('graceMinutes') int? graceMinutes,
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param cinemaId
  ///@param ediFilmId
  ///@param showingDate
  ///@param Jwt
  Future<chopper.Response<ShowingReadDtoListBaseResponseDto>>
      apiV1ShowingCinemasCinemaIdFilmsEdiFilmIdShowingsShowingDateGet({
    required String? cinemaId,
    required String? ediFilmId,
    required String? showingDate,
    String? jwt,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ShowingReadDtoListBaseResponseDto,
        () => ShowingReadDtoListBaseResponseDto.fromJsonFactory);

    return _apiV1ShowingCinemasCinemaIdFilmsEdiFilmIdShowingsShowingDateGet(
        cinemaId: cinemaId,
        ediFilmId: ediFilmId,
        showingDate: showingDate,
        jwt: jwt,
        cacheControl: cacheControl);
  }

  ///
  ///@param cinemaId
  ///@param ediFilmId
  ///@param showingDate
  ///@param Jwt
  @Get(
      path:
          '/api/v1/showing/cinemas/{cinemaId}/films/{ediFilmId}/showings/{showingDate}')
  Future<chopper.Response<ShowingReadDtoListBaseResponseDto>>
      _apiV1ShowingCinemasCinemaIdFilmsEdiFilmIdShowingsShowingDateGet({
    @Path('cinemaId') required String? cinemaId,
    @Path('ediFilmId') required String? ediFilmId,
    @Path('showingDate') required String? showingDate,
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param ediFilmId
  ///@param date
  ///@param Jwt
  Future<chopper.Response<NameGroupedCinemaListItemReadDtoListBaseResponseDto>>
      apiV1ShowingCinemasGet({
    String? ediFilmId,
    String? date,
    String? jwt,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        NameGroupedCinemaListItemReadDtoListBaseResponseDto,
        () => NameGroupedCinemaListItemReadDtoListBaseResponseDto
            .fromJsonFactory);

    return _apiV1ShowingCinemasGet(
        ediFilmId: ediFilmId, date: date, jwt: jwt, cacheControl: cacheControl);
  }

  ///
  ///@param ediFilmId
  ///@param date
  ///@param Jwt
  @Get(path: '/api/v1/showing/cinemas')
  Future<chopper.Response<NameGroupedCinemaListItemReadDtoListBaseResponseDto>>
      _apiV1ShowingCinemasGet({
    @Query('ediFilmId') String? ediFilmId,
    @Query('date') String? date,
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param cinemaId
  ///@param ediFilmId
  ///@param showingDate
  ///@param Jwt
  Future<chopper.Response<ShowingGroupReadDtoListBaseResponseDto>>
      apiV1ShowingCinemasCinemaIdFilmsEdiFilmIdShowingGroupsGet({
    required String? cinemaId,
    required String? ediFilmId,
    String? showingDate,
    String? jwt,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ShowingGroupReadDtoListBaseResponseDto,
        () => ShowingGroupReadDtoListBaseResponseDto.fromJsonFactory);

    return _apiV1ShowingCinemasCinemaIdFilmsEdiFilmIdShowingGroupsGet(
        cinemaId: cinemaId,
        ediFilmId: ediFilmId,
        showingDate: showingDate,
        jwt: jwt,
        cacheControl: cacheControl);
  }

  ///
  ///@param cinemaId
  ///@param ediFilmId
  ///@param showingDate
  ///@param Jwt
  @Get(
      path:
          '/api/v1/showing/cinemas/{cinemaId}/films/{ediFilmId}/showingGroups')
  Future<chopper.Response<ShowingGroupReadDtoListBaseResponseDto>>
      _apiV1ShowingCinemasCinemaIdFilmsEdiFilmIdShowingGroupsGet({
    @Path('cinemaId') required String? cinemaId,
    @Path('ediFilmId') required String? ediFilmId,
    @Query('showingDate') String? showingDate,
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param cinemaId
  ///@param showingDate
  ///@param Jwt
  Future<chopper.Response<FilmWithShowingsReadDtoListBaseResponseDto>>
      apiV1ShowingCinemasCinemaIdShowingDatesShowingDateFilmsGet({
    required String? cinemaId,
    required String? showingDate,
    String? jwt,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(FilmWithShowingsReadDtoListBaseResponseDto,
        () => FilmWithShowingsReadDtoListBaseResponseDto.fromJsonFactory);

    return _apiV1ShowingCinemasCinemaIdShowingDatesShowingDateFilmsGet(
        cinemaId: cinemaId,
        showingDate: showingDate,
        jwt: jwt,
        cacheControl: cacheControl);
  }

  ///
  ///@param cinemaId
  ///@param showingDate
  ///@param Jwt
  @Get(
      path:
          '/api/v1/showing/cinemas/{cinemaId}/showingDates/{showingDate}/films')
  Future<chopper.Response<FilmWithShowingsReadDtoListBaseResponseDto>>
      _apiV1ShowingCinemasCinemaIdShowingDatesShowingDateFilmsGet({
    @Path('cinemaId') required String? cinemaId,
    @Path('showingDate') required String? showingDate,
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param cinemaId
  ///@param Jwt
  Future<chopper.Response<FilmWithShowingsReadDtoListBaseResponseDto>>
      apiV1ShowingCinemasCinemaIdFilmsGet({
    required String? cinemaId,
    String? jwt,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(FilmWithShowingsReadDtoListBaseResponseDto,
        () => FilmWithShowingsReadDtoListBaseResponseDto.fromJsonFactory);

    return _apiV1ShowingCinemasCinemaIdFilmsGet(
        cinemaId: cinemaId, jwt: jwt, cacheControl: cacheControl);
  }

  ///
  ///@param cinemaId
  ///@param Jwt
  @Get(path: '/api/v1/showing/cinemas/{cinemaId}/films')
  Future<chopper.Response<FilmWithShowingsReadDtoListBaseResponseDto>>
      _apiV1ShowingCinemasCinemaIdFilmsGet({
    @Path('cinemaId') required String? cinemaId,
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param Jwt
  Future<chopper.Response<FilmReadDtoListBaseResponseDto>>
      apiV1ShowingFilmsDetailedGet({
    String? jwt,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(FilmReadDtoListBaseResponseDto,
        () => FilmReadDtoListBaseResponseDto.fromJsonFactory);

    return _apiV1ShowingFilmsDetailedGet(jwt: jwt, cacheControl: cacheControl);
  }

  ///
  ///@param Jwt
  @Get(path: '/api/v1/showing/films/detailed')
  Future<chopper.Response<FilmReadDtoListBaseResponseDto>>
      _apiV1ShowingFilmsDetailedGet({
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param cinemaId
  ///@param showingDate
  ///@param Jwt
  Future<chopper.Response<FilmListItemReadDtoListBaseResponseDto>>
      apiV1ShowingFilmsGet({
    String? cinemaId,
    String? showingDate,
    String? jwt,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(FilmListItemReadDtoListBaseResponseDto,
        () => FilmListItemReadDtoListBaseResponseDto.fromJsonFactory);

    return _apiV1ShowingFilmsGet(
        cinemaId: cinemaId,
        showingDate: showingDate,
        jwt: jwt,
        cacheControl: cacheControl);
  }

  ///
  ///@param cinemaId
  ///@param showingDate
  ///@param Jwt
  @Get(path: '/api/v1/showing/films')
  Future<chopper.Response<FilmListItemReadDtoListBaseResponseDto>>
      _apiV1ShowingFilmsGet({
    @Query('cinemaId') String? cinemaId,
    @Query('showingDate') String? showingDate,
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param ediFilmId
  ///@param territoryCode
  ///@param Jwt
  Future<chopper.Response> apiV1ShowingFilmsEdiFilmIdMxdataTerritoryCodeGet({
    required String? ediFilmId,
    required String? territoryCode,
    String? jwt,
    String? cacheControl,
  }) {
    return _apiV1ShowingFilmsEdiFilmIdMxdataTerritoryCodeGet(
        ediFilmId: ediFilmId,
        territoryCode: territoryCode,
        jwt: jwt,
        cacheControl: cacheControl);
  }

  ///
  ///@param ediFilmId
  ///@param territoryCode
  ///@param Jwt
  @Get(path: '/api/v1/showing/films/{ediFilmId}/mxdata/{territoryCode}')
  Future<chopper.Response> _apiV1ShowingFilmsEdiFilmIdMxdataTerritoryCodeGet({
    @Path('ediFilmId') required String? ediFilmId,
    @Path('territoryCode') required String? territoryCode,
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param Jwt
  Future<chopper.Response<GenreReadDtoListBaseResponseDto>>
      apiV1ShowingGenresGet({
    String? jwt,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(GenreReadDtoListBaseResponseDto,
        () => GenreReadDtoListBaseResponseDto.fromJsonFactory);

    return _apiV1ShowingGenresGet(jwt: jwt, cacheControl: cacheControl);
  }

  ///
  ///@param Jwt
  @Get(path: '/api/v1/showing/genres')
  Future<chopper.Response<GenreReadDtoListBaseResponseDto>>
      _apiV1ShowingGenresGet({
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param Jwt
  Future<chopper.Response> healthGet({
    String? jwt,
    String? cacheControl,
  }) {
    return _healthGet(jwt: jwt, cacheControl: cacheControl);
  }

  ///
  ///@param Jwt
  @Get(path: '/health')
  Future<chopper.Response> _healthGet({
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param releaseId
  ///@param territoryCode
  ///@param Jwt
  Future<chopper.Response<MovieXchangeReleaseDtoBaseResponseDto>>
      releaseIdTerritoryCodeGet({
    required String? releaseId,
    String? territoryCode,
    String? jwt,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(MovieXchangeReleaseDtoBaseResponseDto,
        () => MovieXchangeReleaseDtoBaseResponseDto.fromJsonFactory);

    return _releaseIdTerritoryCodeGet(
        releaseId: releaseId,
        territoryCode: territoryCode,
        jwt: jwt,
        cacheControl: cacheControl);
  }

  ///
  ///@param releaseId
  ///@param territoryCode
  ///@param Jwt
  @Get(path: '/{releaseId}/{territoryCode}')
  Future<chopper.Response<MovieXchangeReleaseDtoBaseResponseDto>>
      _releaseIdTerritoryCodeGet({
    @Path('releaseId') required String? releaseId,
    @Query('territoryCode') String? territoryCode,
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param Jwt
  Future<chopper.Response<SessionPricingAttributeReadDtoListBaseResponseDto>>
      apiV1ShowingSessionPricingAttributesGet({
    String? jwt,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SessionPricingAttributeReadDtoListBaseResponseDto,
        () =>
            SessionPricingAttributeReadDtoListBaseResponseDto.fromJsonFactory);

    return _apiV1ShowingSessionPricingAttributesGet(
        jwt: jwt, cacheControl: cacheControl);
  }

  ///
  ///@param Jwt
  @Get(path: '/api/v1/showing/sessionPricingAttributes')
  Future<chopper.Response<SessionPricingAttributeReadDtoListBaseResponseDto>>
      _apiV1ShowingSessionPricingAttributesGet({
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param graceMinutes
  ///@param Jwt
  Future<chopper.Response<ShowingReadDtoListBaseResponseDto>>
      apiV1ShowingShowingsGet({
    int? graceMinutes,
    String? jwt,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ShowingReadDtoListBaseResponseDto,
        () => ShowingReadDtoListBaseResponseDto.fromJsonFactory);

    return _apiV1ShowingShowingsGet(
        graceMinutes: graceMinutes, jwt: jwt, cacheControl: cacheControl);
  }

  ///
  ///@param graceMinutes
  ///@param Jwt
  @Get(path: '/api/v1/showing/showings')
  Future<chopper.Response<ShowingReadDtoListBaseResponseDto>>
      _apiV1ShowingShowingsGet({
    @Query('graceMinutes') int? graceMinutes,
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param cinemaId
  ///@param ediFilmId
  ///@param Jwt
  Future<chopper.Response<ShowingDateReadDtoListBaseResponseDto>>
      apiV1ShowingShowingDatesGet({
    String? cinemaId,
    String? ediFilmId,
    String? jwt,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ShowingDateReadDtoListBaseResponseDto,
        () => ShowingDateReadDtoListBaseResponseDto.fromJsonFactory);

    return _apiV1ShowingShowingDatesGet(
        cinemaId: cinemaId,
        ediFilmId: ediFilmId,
        jwt: jwt,
        cacheControl: cacheControl);
  }

  ///
  ///@param cinemaId
  ///@param ediFilmId
  ///@param Jwt
  @Get(path: '/api/v1/showing/showingDates')
  Future<chopper.Response<ShowingDateReadDtoListBaseResponseDto>>
      _apiV1ShowingShowingDatesGet({
    @Query('cinemaId') String? cinemaId,
    @Query('ediFilmId') String? ediFilmId,
    @Header('Jwt') String? jwt,
    @Header('Cache-Control') String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class AttributeReadDto {
  AttributeReadDto({
    this.attributeId,
    this.name,
    this.code,
    this.description,
    this.salesChannel,
    this.priority,
  });

  factory AttributeReadDto.fromJson(Map<String, dynamic> json) =>
      _$AttributeReadDtoFromJson(json);

  @JsonKey(name: 'attributeId', includeIfNull: false, defaultValue: '')
  final String? attributeId;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'code', includeIfNull: false, defaultValue: '')
  final String? code;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'salesChannel', includeIfNull: false, defaultValue: '')
  final String? salesChannel;
  @JsonKey(name: 'priority', includeIfNull: false)
  final int? priority;
  static const fromJsonFactory = _$AttributeReadDtoFromJson;
  static const toJsonFactory = _$AttributeReadDtoToJson;
  Map<String, dynamic> toJson() => _$AttributeReadDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AttributeReadDto &&
            (identical(other.attributeId, attributeId) ||
                const DeepCollectionEquality()
                    .equals(other.attributeId, attributeId)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.salesChannel, salesChannel) ||
                const DeepCollectionEquality()
                    .equals(other.salesChannel, salesChannel)) &&
            (identical(other.priority, priority) ||
                const DeepCollectionEquality()
                    .equals(other.priority, priority)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(attributeId) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(code) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(salesChannel) ^
      const DeepCollectionEquality().hash(priority) ^
      runtimeType.hashCode;
}

extension $AttributeReadDtoExtension on AttributeReadDto {
  AttributeReadDto copyWith(
      {String? attributeId,
      String? name,
      String? code,
      String? description,
      String? salesChannel,
      int? priority}) {
    return AttributeReadDto(
        attributeId: attributeId ?? this.attributeId,
        name: name ?? this.name,
        code: code ?? this.code,
        description: description ?? this.description,
        salesChannel: salesChannel ?? this.salesChannel,
        priority: priority ?? this.priority);
  }

  AttributeReadDto copyWithWrapped(
      {Wrapped<String?>? attributeId,
      Wrapped<String?>? name,
      Wrapped<String?>? code,
      Wrapped<String?>? description,
      Wrapped<String?>? salesChannel,
      Wrapped<int?>? priority}) {
    return AttributeReadDto(
        attributeId:
            (attributeId != null ? attributeId.value : this.attributeId),
        name: (name != null ? name.value : this.name),
        code: (code != null ? code.value : this.code),
        description:
            (description != null ? description.value : this.description),
        salesChannel:
            (salesChannel != null ? salesChannel.value : this.salesChannel),
        priority: (priority != null ? priority.value : this.priority));
  }
}

@JsonSerializable(explicitToJson: true)
class AttributeReadDtoListBaseResponseDto {
  AttributeReadDtoListBaseResponseDto({
    this.result,
    this.responseCode,
    this.errorMessage,
  });

  factory AttributeReadDtoListBaseResponseDto.fromJson(
          Map<String, dynamic> json) =>
      _$AttributeReadDtoListBaseResponseDtoFromJson(json);

  @JsonKey(
      name: 'result', includeIfNull: false, defaultValue: <AttributeReadDto>[])
  final List<AttributeReadDto>? result;
  @JsonKey(
    name: 'responseCode',
    includeIfNull: false,
    toJson: errorCodeToJson,
    fromJson: errorCodeFromJson,
  )
  final enums.ErrorCode? responseCode;
  @JsonKey(name: 'errorMessage', includeIfNull: false, defaultValue: '')
  final String? errorMessage;
  static const fromJsonFactory = _$AttributeReadDtoListBaseResponseDtoFromJson;
  static const toJsonFactory = _$AttributeReadDtoListBaseResponseDtoToJson;
  Map<String, dynamic> toJson() =>
      _$AttributeReadDtoListBaseResponseDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AttributeReadDtoListBaseResponseDto &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.responseCode, responseCode) ||
                const DeepCollectionEquality()
                    .equals(other.responseCode, responseCode)) &&
            (identical(other.errorMessage, errorMessage) ||
                const DeepCollectionEquality()
                    .equals(other.errorMessage, errorMessage)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(result) ^
      const DeepCollectionEquality().hash(responseCode) ^
      const DeepCollectionEquality().hash(errorMessage) ^
      runtimeType.hashCode;
}

extension $AttributeReadDtoListBaseResponseDtoExtension
    on AttributeReadDtoListBaseResponseDto {
  AttributeReadDtoListBaseResponseDto copyWith(
      {List<AttributeReadDto>? result,
      enums.ErrorCode? responseCode,
      String? errorMessage}) {
    return AttributeReadDtoListBaseResponseDto(
        result: result ?? this.result,
        responseCode: responseCode ?? this.responseCode,
        errorMessage: errorMessage ?? this.errorMessage);
  }

  AttributeReadDtoListBaseResponseDto copyWithWrapped(
      {Wrapped<List<AttributeReadDto>?>? result,
      Wrapped<enums.ErrorCode?>? responseCode,
      Wrapped<String?>? errorMessage}) {
    return AttributeReadDtoListBaseResponseDto(
        result: (result != null ? result.value : this.result),
        responseCode:
            (responseCode != null ? responseCode.value : this.responseCode),
        errorMessage:
            (errorMessage != null ? errorMessage.value : this.errorMessage));
  }
}

@JsonSerializable(explicitToJson: true)
class CastAndCrew {
  CastAndCrew({
    this.id,
    this.firstName,
    this.lastName,
    this.type,
  });

  factory CastAndCrew.fromJson(Map<String, dynamic> json) =>
      _$CastAndCrewFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'firstName', includeIfNull: false, defaultValue: '')
  final String? firstName;
  @JsonKey(name: 'lastName', includeIfNull: false, defaultValue: '')
  final String? lastName;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$CastAndCrewFromJson;
  static const toJsonFactory = _$CastAndCrewToJson;
  Map<String, dynamic> toJson() => _$CastAndCrewToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CastAndCrew &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.lastName, lastName) ||
                const DeepCollectionEquality()
                    .equals(other.lastName, lastName)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(firstName) ^
      const DeepCollectionEquality().hash(lastName) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $CastAndCrewExtension on CastAndCrew {
  CastAndCrew copyWith(
      {String? id, String? firstName, String? lastName, String? type}) {
    return CastAndCrew(
        id: id ?? this.id,
        firstName: firstName ?? this.firstName,
        lastName: lastName ?? this.lastName,
        type: type ?? this.type);
  }

  CastAndCrew copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? firstName,
      Wrapped<String?>? lastName,
      Wrapped<String?>? type}) {
    return CastAndCrew(
        id: (id != null ? id.value : this.id),
        firstName: (firstName != null ? firstName.value : this.firstName),
        lastName: (lastName != null ? lastName.value : this.lastName),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class CinemaDto {
  CinemaDto({
    this.cinemaId,
    this.cinemaName,
    this.fullName,
  });

  factory CinemaDto.fromJson(Map<String, dynamic> json) =>
      _$CinemaDtoFromJson(json);

  @JsonKey(name: 'cinemaId', includeIfNull: false, defaultValue: '')
  final String? cinemaId;
  @JsonKey(name: 'cinemaName', includeIfNull: false, defaultValue: '')
  final String? cinemaName;
  @JsonKey(name: 'fullName', includeIfNull: false, defaultValue: '')
  final String? fullName;
  static const fromJsonFactory = _$CinemaDtoFromJson;
  static const toJsonFactory = _$CinemaDtoToJson;
  Map<String, dynamic> toJson() => _$CinemaDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CinemaDto &&
            (identical(other.cinemaId, cinemaId) ||
                const DeepCollectionEquality()
                    .equals(other.cinemaId, cinemaId)) &&
            (identical(other.cinemaName, cinemaName) ||
                const DeepCollectionEquality()
                    .equals(other.cinemaName, cinemaName)) &&
            (identical(other.fullName, fullName) ||
                const DeepCollectionEquality()
                    .equals(other.fullName, fullName)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(cinemaId) ^
      const DeepCollectionEquality().hash(cinemaName) ^
      const DeepCollectionEquality().hash(fullName) ^
      runtimeType.hashCode;
}

extension $CinemaDtoExtension on CinemaDto {
  CinemaDto copyWith({String? cinemaId, String? cinemaName, String? fullName}) {
    return CinemaDto(
        cinemaId: cinemaId ?? this.cinemaId,
        cinemaName: cinemaName ?? this.cinemaName,
        fullName: fullName ?? this.fullName);
  }

  CinemaDto copyWithWrapped(
      {Wrapped<String?>? cinemaId,
      Wrapped<String?>? cinemaName,
      Wrapped<String?>? fullName}) {
    return CinemaDto(
        cinemaId: (cinemaId != null ? cinemaId.value : this.cinemaId),
        cinemaName: (cinemaName != null ? cinemaName.value : this.cinemaName),
        fullName: (fullName != null ? fullName.value : this.fullName));
  }
}

@JsonSerializable(explicitToJson: true)
class CinemaReadDto {
  CinemaReadDto({
    this.id,
    this.name,
    this.latitude,
    this.longitude,
    this.searchName,
    this.offPeakStartTime,
    this.offPeakEndTime,
    this.contactTrackingLevel,
    this.isUnder16OptionEnabled,
  });

  factory CinemaReadDto.fromJson(Map<String, dynamic> json) =>
      _$CinemaReadDtoFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'latitude', includeIfNull: false)
  final double? latitude;
  @JsonKey(name: 'longitude', includeIfNull: false)
  final double? longitude;
  @JsonKey(name: 'searchName', includeIfNull: false, defaultValue: '')
  final String? searchName;
  @JsonKey(name: 'offPeakStartTime', includeIfNull: false)
  final TimeSpan? offPeakStartTime;
  @JsonKey(name: 'offPeakEndTime', includeIfNull: false)
  final TimeSpan? offPeakEndTime;
  @JsonKey(name: 'contactTrackingLevel', includeIfNull: false)
  final int? contactTrackingLevel;
  @JsonKey(name: 'isUnder16OptionEnabled', includeIfNull: false)
  final bool? isUnder16OptionEnabled;
  static const fromJsonFactory = _$CinemaReadDtoFromJson;
  static const toJsonFactory = _$CinemaReadDtoToJson;
  Map<String, dynamic> toJson() => _$CinemaReadDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CinemaReadDto &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.latitude, latitude) ||
                const DeepCollectionEquality()
                    .equals(other.latitude, latitude)) &&
            (identical(other.longitude, longitude) ||
                const DeepCollectionEquality()
                    .equals(other.longitude, longitude)) &&
            (identical(other.searchName, searchName) ||
                const DeepCollectionEquality()
                    .equals(other.searchName, searchName)) &&
            (identical(other.offPeakStartTime, offPeakStartTime) ||
                const DeepCollectionEquality()
                    .equals(other.offPeakStartTime, offPeakStartTime)) &&
            (identical(other.offPeakEndTime, offPeakEndTime) ||
                const DeepCollectionEquality()
                    .equals(other.offPeakEndTime, offPeakEndTime)) &&
            (identical(other.contactTrackingLevel, contactTrackingLevel) ||
                const DeepCollectionEquality().equals(
                    other.contactTrackingLevel, contactTrackingLevel)) &&
            (identical(other.isUnder16OptionEnabled, isUnder16OptionEnabled) ||
                const DeepCollectionEquality().equals(
                    other.isUnder16OptionEnabled, isUnder16OptionEnabled)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(latitude) ^
      const DeepCollectionEquality().hash(longitude) ^
      const DeepCollectionEquality().hash(searchName) ^
      const DeepCollectionEquality().hash(offPeakStartTime) ^
      const DeepCollectionEquality().hash(offPeakEndTime) ^
      const DeepCollectionEquality().hash(contactTrackingLevel) ^
      const DeepCollectionEquality().hash(isUnder16OptionEnabled) ^
      runtimeType.hashCode;
}

extension $CinemaReadDtoExtension on CinemaReadDto {
  CinemaReadDto copyWith(
      {String? id,
      String? name,
      double? latitude,
      double? longitude,
      String? searchName,
      TimeSpan? offPeakStartTime,
      TimeSpan? offPeakEndTime,
      int? contactTrackingLevel,
      bool? isUnder16OptionEnabled}) {
    return CinemaReadDto(
        id: id ?? this.id,
        name: name ?? this.name,
        latitude: latitude ?? this.latitude,
        longitude: longitude ?? this.longitude,
        searchName: searchName ?? this.searchName,
        offPeakStartTime: offPeakStartTime ?? this.offPeakStartTime,
        offPeakEndTime: offPeakEndTime ?? this.offPeakEndTime,
        contactTrackingLevel: contactTrackingLevel ?? this.contactTrackingLevel,
        isUnder16OptionEnabled:
            isUnder16OptionEnabled ?? this.isUnder16OptionEnabled);
  }

  CinemaReadDto copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? name,
      Wrapped<double?>? latitude,
      Wrapped<double?>? longitude,
      Wrapped<String?>? searchName,
      Wrapped<TimeSpan?>? offPeakStartTime,
      Wrapped<TimeSpan?>? offPeakEndTime,
      Wrapped<int?>? contactTrackingLevel,
      Wrapped<bool?>? isUnder16OptionEnabled}) {
    return CinemaReadDto(
        id: (id != null ? id.value : this.id),
        name: (name != null ? name.value : this.name),
        latitude: (latitude != null ? latitude.value : this.latitude),
        longitude: (longitude != null ? longitude.value : this.longitude),
        searchName: (searchName != null ? searchName.value : this.searchName),
        offPeakStartTime: (offPeakStartTime != null
            ? offPeakStartTime.value
            : this.offPeakStartTime),
        offPeakEndTime: (offPeakEndTime != null
            ? offPeakEndTime.value
            : this.offPeakEndTime),
        contactTrackingLevel: (contactTrackingLevel != null
            ? contactTrackingLevel.value
            : this.contactTrackingLevel),
        isUnder16OptionEnabled: (isUnder16OptionEnabled != null
            ? isUnder16OptionEnabled.value
            : this.isUnder16OptionEnabled));
  }
}

@JsonSerializable(explicitToJson: true)
class CinemaReadDtoListBaseResponseDto {
  CinemaReadDtoListBaseResponseDto({
    this.result,
    this.responseCode,
    this.errorMessage,
  });

  factory CinemaReadDtoListBaseResponseDto.fromJson(
          Map<String, dynamic> json) =>
      _$CinemaReadDtoListBaseResponseDtoFromJson(json);

  @JsonKey(
      name: 'result', includeIfNull: false, defaultValue: <CinemaReadDto>[])
  final List<CinemaReadDto>? result;
  @JsonKey(
    name: 'responseCode',
    includeIfNull: false,
    toJson: errorCodeToJson,
    fromJson: errorCodeFromJson,
  )
  final enums.ErrorCode? responseCode;
  @JsonKey(name: 'errorMessage', includeIfNull: false, defaultValue: '')
  final String? errorMessage;
  static const fromJsonFactory = _$CinemaReadDtoListBaseResponseDtoFromJson;
  static const toJsonFactory = _$CinemaReadDtoListBaseResponseDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CinemaReadDtoListBaseResponseDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CinemaReadDtoListBaseResponseDto &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.responseCode, responseCode) ||
                const DeepCollectionEquality()
                    .equals(other.responseCode, responseCode)) &&
            (identical(other.errorMessage, errorMessage) ||
                const DeepCollectionEquality()
                    .equals(other.errorMessage, errorMessage)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(result) ^
      const DeepCollectionEquality().hash(responseCode) ^
      const DeepCollectionEquality().hash(errorMessage) ^
      runtimeType.hashCode;
}

extension $CinemaReadDtoListBaseResponseDtoExtension
    on CinemaReadDtoListBaseResponseDto {
  CinemaReadDtoListBaseResponseDto copyWith(
      {List<CinemaReadDto>? result,
      enums.ErrorCode? responseCode,
      String? errorMessage}) {
    return CinemaReadDtoListBaseResponseDto(
        result: result ?? this.result,
        responseCode: responseCode ?? this.responseCode,
        errorMessage: errorMessage ?? this.errorMessage);
  }

  CinemaReadDtoListBaseResponseDto copyWithWrapped(
      {Wrapped<List<CinemaReadDto>?>? result,
      Wrapped<enums.ErrorCode?>? responseCode,
      Wrapped<String?>? errorMessage}) {
    return CinemaReadDtoListBaseResponseDto(
        result: (result != null ? result.value : this.result),
        responseCode:
            (responseCode != null ? responseCode.value : this.responseCode),
        errorMessage:
            (errorMessage != null ? errorMessage.value : this.errorMessage));
  }
}

@JsonSerializable(explicitToJson: true)
class CountryOfOrigin {
  CountryOfOrigin({
    this.id,
    this.description,
    this.code,
  });

  factory CountryOfOrigin.fromJson(Map<String, dynamic> json) =>
      _$CountryOfOriginFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'code', includeIfNull: false, defaultValue: '')
  final String? code;
  static const fromJsonFactory = _$CountryOfOriginFromJson;
  static const toJsonFactory = _$CountryOfOriginToJson;
  Map<String, dynamic> toJson() => _$CountryOfOriginToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CountryOfOrigin &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(code) ^
      runtimeType.hashCode;
}

extension $CountryOfOriginExtension on CountryOfOrigin {
  CountryOfOrigin copyWith({String? id, String? description, String? code}) {
    return CountryOfOrigin(
        id: id ?? this.id,
        description: description ?? this.description,
        code: code ?? this.code);
  }

  CountryOfOrigin copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? description,
      Wrapped<String?>? code}) {
    return CountryOfOrigin(
        id: (id != null ? id.value : this.id),
        description:
            (description != null ? description.value : this.description),
        code: (code != null ? code.value : this.code));
  }
}

@JsonSerializable(explicitToJson: true)
class CustomProperty {
  CustomProperty({
    this.type,
    this.key,
    this.value,
  });

  factory CustomProperty.fromJson(Map<String, dynamic> json) =>
      _$CustomPropertyFromJson(json);

  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  @JsonKey(name: 'key', includeIfNull: false, defaultValue: '')
  final String? key;
  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String? value;
  static const fromJsonFactory = _$CustomPropertyFromJson;
  static const toJsonFactory = _$CustomPropertyToJson;
  Map<String, dynamic> toJson() => _$CustomPropertyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CustomProperty &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.key, key) ||
                const DeepCollectionEquality().equals(other.key, key)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(key) ^
      const DeepCollectionEquality().hash(value) ^
      runtimeType.hashCode;
}

extension $CustomPropertyExtension on CustomProperty {
  CustomProperty copyWith({String? type, String? key, String? value}) {
    return CustomProperty(
        type: type ?? this.type,
        key: key ?? this.key,
        value: value ?? this.value);
  }

  CustomProperty copyWithWrapped(
      {Wrapped<String?>? type,
      Wrapped<String?>? key,
      Wrapped<String?>? value}) {
    return CustomProperty(
        type: (type != null ? type.value : this.type),
        key: (key != null ? key.value : this.key),
        value: (value != null ? value.value : this.value));
  }
}

@JsonSerializable(explicitToJson: true)
class Distributor {
  Distributor({
    this.id,
    this.description,
    this.organizationCodes,
  });

  factory Distributor.fromJson(Map<String, dynamic> json) =>
      _$DistributorFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'organizationCodes', includeIfNull: false)
  final OrganizationCode? organizationCodes;
  static const fromJsonFactory = _$DistributorFromJson;
  static const toJsonFactory = _$DistributorToJson;
  Map<String, dynamic> toJson() => _$DistributorToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Distributor &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.organizationCodes, organizationCodes) ||
                const DeepCollectionEquality()
                    .equals(other.organizationCodes, organizationCodes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(organizationCodes) ^
      runtimeType.hashCode;
}

extension $DistributorExtension on Distributor {
  Distributor copyWith(
      {String? id, String? description, OrganizationCode? organizationCodes}) {
    return Distributor(
        id: id ?? this.id,
        description: description ?? this.description,
        organizationCodes: organizationCodes ?? this.organizationCodes);
  }

  Distributor copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? description,
      Wrapped<OrganizationCode?>? organizationCodes}) {
    return Distributor(
        id: (id != null ? id.value : this.id),
        description:
            (description != null ? description.value : this.description),
        organizationCodes: (organizationCodes != null
            ? organizationCodes.value
            : this.organizationCodes));
  }
}

@JsonSerializable(explicitToJson: true)
class FilmListItemReadDto {
  FilmListItemReadDto({
    this.filmUrl,
    this.filmId,
    this.filmTitle,
  });

  factory FilmListItemReadDto.fromJson(Map<String, dynamic> json) =>
      _$FilmListItemReadDtoFromJson(json);

  @JsonKey(name: 'filmUrl', includeIfNull: false, defaultValue: '')
  final String? filmUrl;
  @JsonKey(name: 'filmId', includeIfNull: false, defaultValue: '')
  final String? filmId;
  @JsonKey(name: 'filmTitle', includeIfNull: false, defaultValue: '')
  final String? filmTitle;
  static const fromJsonFactory = _$FilmListItemReadDtoFromJson;
  static const toJsonFactory = _$FilmListItemReadDtoToJson;
  Map<String, dynamic> toJson() => _$FilmListItemReadDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FilmListItemReadDto &&
            (identical(other.filmUrl, filmUrl) ||
                const DeepCollectionEquality()
                    .equals(other.filmUrl, filmUrl)) &&
            (identical(other.filmId, filmId) ||
                const DeepCollectionEquality().equals(other.filmId, filmId)) &&
            (identical(other.filmTitle, filmTitle) ||
                const DeepCollectionEquality()
                    .equals(other.filmTitle, filmTitle)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(filmUrl) ^
      const DeepCollectionEquality().hash(filmId) ^
      const DeepCollectionEquality().hash(filmTitle) ^
      runtimeType.hashCode;
}

extension $FilmListItemReadDtoExtension on FilmListItemReadDto {
  FilmListItemReadDto copyWith(
      {String? filmUrl, String? filmId, String? filmTitle}) {
    return FilmListItemReadDto(
        filmUrl: filmUrl ?? this.filmUrl,
        filmId: filmId ?? this.filmId,
        filmTitle: filmTitle ?? this.filmTitle);
  }

  FilmListItemReadDto copyWithWrapped(
      {Wrapped<String?>? filmUrl,
      Wrapped<String?>? filmId,
      Wrapped<String?>? filmTitle}) {
    return FilmListItemReadDto(
        filmUrl: (filmUrl != null ? filmUrl.value : this.filmUrl),
        filmId: (filmId != null ? filmId.value : this.filmId),
        filmTitle: (filmTitle != null ? filmTitle.value : this.filmTitle));
  }
}

@JsonSerializable(explicitToJson: true)
class FilmListItemReadDtoListBaseResponseDto {
  FilmListItemReadDtoListBaseResponseDto({
    this.result,
    this.responseCode,
    this.errorMessage,
  });

  factory FilmListItemReadDtoListBaseResponseDto.fromJson(
          Map<String, dynamic> json) =>
      _$FilmListItemReadDtoListBaseResponseDtoFromJson(json);

  @JsonKey(
      name: 'result',
      includeIfNull: false,
      defaultValue: <FilmListItemReadDto>[])
  final List<FilmListItemReadDto>? result;
  @JsonKey(
    name: 'responseCode',
    includeIfNull: false,
    toJson: errorCodeToJson,
    fromJson: errorCodeFromJson,
  )
  final enums.ErrorCode? responseCode;
  @JsonKey(name: 'errorMessage', includeIfNull: false, defaultValue: '')
  final String? errorMessage;
  static const fromJsonFactory =
      _$FilmListItemReadDtoListBaseResponseDtoFromJson;
  static const toJsonFactory = _$FilmListItemReadDtoListBaseResponseDtoToJson;
  Map<String, dynamic> toJson() =>
      _$FilmListItemReadDtoListBaseResponseDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FilmListItemReadDtoListBaseResponseDto &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.responseCode, responseCode) ||
                const DeepCollectionEquality()
                    .equals(other.responseCode, responseCode)) &&
            (identical(other.errorMessage, errorMessage) ||
                const DeepCollectionEquality()
                    .equals(other.errorMessage, errorMessage)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(result) ^
      const DeepCollectionEquality().hash(responseCode) ^
      const DeepCollectionEquality().hash(errorMessage) ^
      runtimeType.hashCode;
}

extension $FilmListItemReadDtoListBaseResponseDtoExtension
    on FilmListItemReadDtoListBaseResponseDto {
  FilmListItemReadDtoListBaseResponseDto copyWith(
      {List<FilmListItemReadDto>? result,
      enums.ErrorCode? responseCode,
      String? errorMessage}) {
    return FilmListItemReadDtoListBaseResponseDto(
        result: result ?? this.result,
        responseCode: responseCode ?? this.responseCode,
        errorMessage: errorMessage ?? this.errorMessage);
  }

  FilmListItemReadDtoListBaseResponseDto copyWithWrapped(
      {Wrapped<List<FilmListItemReadDto>?>? result,
      Wrapped<enums.ErrorCode?>? responseCode,
      Wrapped<String?>? errorMessage}) {
    return FilmListItemReadDtoListBaseResponseDto(
        result: (result != null ? result.value : this.result),
        responseCode:
            (responseCode != null ? responseCode.value : this.responseCode),
        errorMessage:
            (errorMessage != null ? errorMessage.value : this.errorMessage));
  }
}

@JsonSerializable(explicitToJson: true)
class FilmReadDto {
  FilmReadDto({
    this.id,
    this.ediFilmId,
    this.vistaFilmId,
    this.title,
    this.duration,
    this.vistaGenreId,
    this.openingDate,
    this.synopsis,
    this.certificate,
    this.advice,
    this.firstInserted,
    this.lastUpdated,
    this.bookingPartnerFilmId,
    this.headOfficeFilmCode,
  });

  factory FilmReadDto.fromJson(Map<String, dynamic> json) =>
      _$FilmReadDtoFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'ediFilmId', includeIfNull: false, defaultValue: '')
  final String? ediFilmId;
  @JsonKey(name: 'vistaFilmId', includeIfNull: false, defaultValue: '')
  final String? vistaFilmId;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'duration', includeIfNull: false)
  final int? duration;
  @JsonKey(name: 'vistaGenreId', includeIfNull: false, defaultValue: '')
  final String? vistaGenreId;
  @JsonKey(name: 'openingDate', includeIfNull: false, defaultValue: '')
  final String? openingDate;
  @JsonKey(name: 'synopsis', includeIfNull: false, defaultValue: '')
  final String? synopsis;
  @JsonKey(name: 'certificate', includeIfNull: false, defaultValue: '')
  final String? certificate;
  @JsonKey(name: 'advice', includeIfNull: false, defaultValue: '')
  final String? advice;
  @JsonKey(name: 'firstInserted', includeIfNull: false, defaultValue: '')
  final String? firstInserted;
  @JsonKey(name: 'lastUpdated', includeIfNull: false, defaultValue: '')
  final String? lastUpdated;
  @JsonKey(name: 'bookingPartnerFilmId', includeIfNull: false)
  final int? bookingPartnerFilmId;
  @JsonKey(name: 'headOfficeFilmCode', includeIfNull: false, defaultValue: '')
  final String? headOfficeFilmCode;
  static const fromJsonFactory = _$FilmReadDtoFromJson;
  static const toJsonFactory = _$FilmReadDtoToJson;
  Map<String, dynamic> toJson() => _$FilmReadDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FilmReadDto &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.ediFilmId, ediFilmId) ||
                const DeepCollectionEquality()
                    .equals(other.ediFilmId, ediFilmId)) &&
            (identical(other.vistaFilmId, vistaFilmId) ||
                const DeepCollectionEquality()
                    .equals(other.vistaFilmId, vistaFilmId)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.duration, duration) ||
                const DeepCollectionEquality()
                    .equals(other.duration, duration)) &&
            (identical(other.vistaGenreId, vistaGenreId) ||
                const DeepCollectionEquality()
                    .equals(other.vistaGenreId, vistaGenreId)) &&
            (identical(other.openingDate, openingDate) ||
                const DeepCollectionEquality()
                    .equals(other.openingDate, openingDate)) &&
            (identical(other.synopsis, synopsis) ||
                const DeepCollectionEquality()
                    .equals(other.synopsis, synopsis)) &&
            (identical(other.certificate, certificate) ||
                const DeepCollectionEquality()
                    .equals(other.certificate, certificate)) &&
            (identical(other.advice, advice) ||
                const DeepCollectionEquality().equals(other.advice, advice)) &&
            (identical(other.firstInserted, firstInserted) ||
                const DeepCollectionEquality()
                    .equals(other.firstInserted, firstInserted)) &&
            (identical(other.lastUpdated, lastUpdated) ||
                const DeepCollectionEquality()
                    .equals(other.lastUpdated, lastUpdated)) &&
            (identical(other.bookingPartnerFilmId, bookingPartnerFilmId) ||
                const DeepCollectionEquality().equals(
                    other.bookingPartnerFilmId, bookingPartnerFilmId)) &&
            (identical(other.headOfficeFilmCode, headOfficeFilmCode) ||
                const DeepCollectionEquality()
                    .equals(other.headOfficeFilmCode, headOfficeFilmCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(ediFilmId) ^
      const DeepCollectionEquality().hash(vistaFilmId) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(duration) ^
      const DeepCollectionEquality().hash(vistaGenreId) ^
      const DeepCollectionEquality().hash(openingDate) ^
      const DeepCollectionEquality().hash(synopsis) ^
      const DeepCollectionEquality().hash(certificate) ^
      const DeepCollectionEquality().hash(advice) ^
      const DeepCollectionEquality().hash(firstInserted) ^
      const DeepCollectionEquality().hash(lastUpdated) ^
      const DeepCollectionEquality().hash(bookingPartnerFilmId) ^
      const DeepCollectionEquality().hash(headOfficeFilmCode) ^
      runtimeType.hashCode;
}

extension $FilmReadDtoExtension on FilmReadDto {
  FilmReadDto copyWith(
      {String? id,
      String? ediFilmId,
      String? vistaFilmId,
      String? title,
      int? duration,
      String? vistaGenreId,
      String? openingDate,
      String? synopsis,
      String? certificate,
      String? advice,
      String? firstInserted,
      String? lastUpdated,
      int? bookingPartnerFilmId,
      String? headOfficeFilmCode}) {
    return FilmReadDto(
        id: id ?? this.id,
        ediFilmId: ediFilmId ?? this.ediFilmId,
        vistaFilmId: vistaFilmId ?? this.vistaFilmId,
        title: title ?? this.title,
        duration: duration ?? this.duration,
        vistaGenreId: vistaGenreId ?? this.vistaGenreId,
        openingDate: openingDate ?? this.openingDate,
        synopsis: synopsis ?? this.synopsis,
        certificate: certificate ?? this.certificate,
        advice: advice ?? this.advice,
        firstInserted: firstInserted ?? this.firstInserted,
        lastUpdated: lastUpdated ?? this.lastUpdated,
        bookingPartnerFilmId: bookingPartnerFilmId ?? this.bookingPartnerFilmId,
        headOfficeFilmCode: headOfficeFilmCode ?? this.headOfficeFilmCode);
  }

  FilmReadDto copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? ediFilmId,
      Wrapped<String?>? vistaFilmId,
      Wrapped<String?>? title,
      Wrapped<int?>? duration,
      Wrapped<String?>? vistaGenreId,
      Wrapped<String?>? openingDate,
      Wrapped<String?>? synopsis,
      Wrapped<String?>? certificate,
      Wrapped<String?>? advice,
      Wrapped<String?>? firstInserted,
      Wrapped<String?>? lastUpdated,
      Wrapped<int?>? bookingPartnerFilmId,
      Wrapped<String?>? headOfficeFilmCode}) {
    return FilmReadDto(
        id: (id != null ? id.value : this.id),
        ediFilmId: (ediFilmId != null ? ediFilmId.value : this.ediFilmId),
        vistaFilmId:
            (vistaFilmId != null ? vistaFilmId.value : this.vistaFilmId),
        title: (title != null ? title.value : this.title),
        duration: (duration != null ? duration.value : this.duration),
        vistaGenreId:
            (vistaGenreId != null ? vistaGenreId.value : this.vistaGenreId),
        openingDate:
            (openingDate != null ? openingDate.value : this.openingDate),
        synopsis: (synopsis != null ? synopsis.value : this.synopsis),
        certificate:
            (certificate != null ? certificate.value : this.certificate),
        advice: (advice != null ? advice.value : this.advice),
        firstInserted:
            (firstInserted != null ? firstInserted.value : this.firstInserted),
        lastUpdated:
            (lastUpdated != null ? lastUpdated.value : this.lastUpdated),
        bookingPartnerFilmId: (bookingPartnerFilmId != null
            ? bookingPartnerFilmId.value
            : this.bookingPartnerFilmId),
        headOfficeFilmCode: (headOfficeFilmCode != null
            ? headOfficeFilmCode.value
            : this.headOfficeFilmCode));
  }
}

@JsonSerializable(explicitToJson: true)
class FilmReadDtoListBaseResponseDto {
  FilmReadDtoListBaseResponseDto({
    this.result,
    this.responseCode,
    this.errorMessage,
  });

  factory FilmReadDtoListBaseResponseDto.fromJson(Map<String, dynamic> json) =>
      _$FilmReadDtoListBaseResponseDtoFromJson(json);

  @JsonKey(name: 'result', includeIfNull: false, defaultValue: <FilmReadDto>[])
  final List<FilmReadDto>? result;
  @JsonKey(
    name: 'responseCode',
    includeIfNull: false,
    toJson: errorCodeToJson,
    fromJson: errorCodeFromJson,
  )
  final enums.ErrorCode? responseCode;
  @JsonKey(name: 'errorMessage', includeIfNull: false, defaultValue: '')
  final String? errorMessage;
  static const fromJsonFactory = _$FilmReadDtoListBaseResponseDtoFromJson;
  static const toJsonFactory = _$FilmReadDtoListBaseResponseDtoToJson;
  Map<String, dynamic> toJson() => _$FilmReadDtoListBaseResponseDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FilmReadDtoListBaseResponseDto &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.responseCode, responseCode) ||
                const DeepCollectionEquality()
                    .equals(other.responseCode, responseCode)) &&
            (identical(other.errorMessage, errorMessage) ||
                const DeepCollectionEquality()
                    .equals(other.errorMessage, errorMessage)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(result) ^
      const DeepCollectionEquality().hash(responseCode) ^
      const DeepCollectionEquality().hash(errorMessage) ^
      runtimeType.hashCode;
}

extension $FilmReadDtoListBaseResponseDtoExtension
    on FilmReadDtoListBaseResponseDto {
  FilmReadDtoListBaseResponseDto copyWith(
      {List<FilmReadDto>? result,
      enums.ErrorCode? responseCode,
      String? errorMessage}) {
    return FilmReadDtoListBaseResponseDto(
        result: result ?? this.result,
        responseCode: responseCode ?? this.responseCode,
        errorMessage: errorMessage ?? this.errorMessage);
  }

  FilmReadDtoListBaseResponseDto copyWithWrapped(
      {Wrapped<List<FilmReadDto>?>? result,
      Wrapped<enums.ErrorCode?>? responseCode,
      Wrapped<String?>? errorMessage}) {
    return FilmReadDtoListBaseResponseDto(
        result: (result != null ? result.value : this.result),
        responseCode:
            (responseCode != null ? responseCode.value : this.responseCode),
        errorMessage:
            (errorMessage != null ? errorMessage.value : this.errorMessage));
  }
}

@JsonSerializable(explicitToJson: true)
class FilmWithShowingsReadDto {
  FilmWithShowingsReadDto({
    this.filmCertificateSrc,
    this.filmUrl,
    this.filmAttributes,
    this.filmId,
    this.posterImageSrc,
    this.cast,
    this.releaseDate,
    this.runningTime,
    this.synopsisShort,
    this.filmTitle,
    this.showingGroups,
  });

  factory FilmWithShowingsReadDto.fromJson(Map<String, dynamic> json) =>
      _$FilmWithShowingsReadDtoFromJson(json);

  @JsonKey(name: 'filmCertificateSrc', includeIfNull: false, defaultValue: '')
  final String? filmCertificateSrc;
  @JsonKey(name: 'filmUrl', includeIfNull: false, defaultValue: '')
  final String? filmUrl;
  @JsonKey(
      name: 'filmAttributes',
      includeIfNull: false,
      defaultValue: <ShowingAttributeReadDto>[])
  final List<ShowingAttributeReadDto>? filmAttributes;
  @JsonKey(name: 'filmId', includeIfNull: false, defaultValue: '')
  final String? filmId;
  @JsonKey(name: 'posterImageSrc', includeIfNull: false, defaultValue: '')
  final String? posterImageSrc;
  @JsonKey(name: 'cast', includeIfNull: false, defaultValue: '')
  final String? cast;
  @JsonKey(name: 'releaseDate', includeIfNull: false, defaultValue: '')
  final String? releaseDate;
  @JsonKey(name: 'runningTime', includeIfNull: false)
  final int? runningTime;
  @JsonKey(name: 'synopsisShort', includeIfNull: false, defaultValue: '')
  final String? synopsisShort;
  @JsonKey(name: 'filmTitle', includeIfNull: false, defaultValue: '')
  final String? filmTitle;
  @JsonKey(
      name: 'showingGroups',
      includeIfNull: false,
      defaultValue: <ShowingGroupReadDto>[])
  final List<ShowingGroupReadDto>? showingGroups;
  static const fromJsonFactory = _$FilmWithShowingsReadDtoFromJson;
  static const toJsonFactory = _$FilmWithShowingsReadDtoToJson;
  Map<String, dynamic> toJson() => _$FilmWithShowingsReadDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FilmWithShowingsReadDto &&
            (identical(other.filmCertificateSrc, filmCertificateSrc) ||
                const DeepCollectionEquality()
                    .equals(other.filmCertificateSrc, filmCertificateSrc)) &&
            (identical(other.filmUrl, filmUrl) ||
                const DeepCollectionEquality()
                    .equals(other.filmUrl, filmUrl)) &&
            (identical(other.filmAttributes, filmAttributes) ||
                const DeepCollectionEquality()
                    .equals(other.filmAttributes, filmAttributes)) &&
            (identical(other.filmId, filmId) ||
                const DeepCollectionEquality().equals(other.filmId, filmId)) &&
            (identical(other.posterImageSrc, posterImageSrc) ||
                const DeepCollectionEquality()
                    .equals(other.posterImageSrc, posterImageSrc)) &&
            (identical(other.cast, cast) ||
                const DeepCollectionEquality().equals(other.cast, cast)) &&
            (identical(other.releaseDate, releaseDate) ||
                const DeepCollectionEquality()
                    .equals(other.releaseDate, releaseDate)) &&
            (identical(other.runningTime, runningTime) ||
                const DeepCollectionEquality()
                    .equals(other.runningTime, runningTime)) &&
            (identical(other.synopsisShort, synopsisShort) ||
                const DeepCollectionEquality()
                    .equals(other.synopsisShort, synopsisShort)) &&
            (identical(other.filmTitle, filmTitle) ||
                const DeepCollectionEquality()
                    .equals(other.filmTitle, filmTitle)) &&
            (identical(other.showingGroups, showingGroups) ||
                const DeepCollectionEquality()
                    .equals(other.showingGroups, showingGroups)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(filmCertificateSrc) ^
      const DeepCollectionEquality().hash(filmUrl) ^
      const DeepCollectionEquality().hash(filmAttributes) ^
      const DeepCollectionEquality().hash(filmId) ^
      const DeepCollectionEquality().hash(posterImageSrc) ^
      const DeepCollectionEquality().hash(cast) ^
      const DeepCollectionEquality().hash(releaseDate) ^
      const DeepCollectionEquality().hash(runningTime) ^
      const DeepCollectionEquality().hash(synopsisShort) ^
      const DeepCollectionEquality().hash(filmTitle) ^
      const DeepCollectionEquality().hash(showingGroups) ^
      runtimeType.hashCode;
}

extension $FilmWithShowingsReadDtoExtension on FilmWithShowingsReadDto {
  FilmWithShowingsReadDto copyWith(
      {String? filmCertificateSrc,
      String? filmUrl,
      List<ShowingAttributeReadDto>? filmAttributes,
      String? filmId,
      String? posterImageSrc,
      String? cast,
      String? releaseDate,
      int? runningTime,
      String? synopsisShort,
      String? filmTitle,
      List<ShowingGroupReadDto>? showingGroups}) {
    return FilmWithShowingsReadDto(
        filmCertificateSrc: filmCertificateSrc ?? this.filmCertificateSrc,
        filmUrl: filmUrl ?? this.filmUrl,
        filmAttributes: filmAttributes ?? this.filmAttributes,
        filmId: filmId ?? this.filmId,
        posterImageSrc: posterImageSrc ?? this.posterImageSrc,
        cast: cast ?? this.cast,
        releaseDate: releaseDate ?? this.releaseDate,
        runningTime: runningTime ?? this.runningTime,
        synopsisShort: synopsisShort ?? this.synopsisShort,
        filmTitle: filmTitle ?? this.filmTitle,
        showingGroups: showingGroups ?? this.showingGroups);
  }

  FilmWithShowingsReadDto copyWithWrapped(
      {Wrapped<String?>? filmCertificateSrc,
      Wrapped<String?>? filmUrl,
      Wrapped<List<ShowingAttributeReadDto>?>? filmAttributes,
      Wrapped<String?>? filmId,
      Wrapped<String?>? posterImageSrc,
      Wrapped<String?>? cast,
      Wrapped<String?>? releaseDate,
      Wrapped<int?>? runningTime,
      Wrapped<String?>? synopsisShort,
      Wrapped<String?>? filmTitle,
      Wrapped<List<ShowingGroupReadDto>?>? showingGroups}) {
    return FilmWithShowingsReadDto(
        filmCertificateSrc: (filmCertificateSrc != null
            ? filmCertificateSrc.value
            : this.filmCertificateSrc),
        filmUrl: (filmUrl != null ? filmUrl.value : this.filmUrl),
        filmAttributes: (filmAttributes != null
            ? filmAttributes.value
            : this.filmAttributes),
        filmId: (filmId != null ? filmId.value : this.filmId),
        posterImageSrc: (posterImageSrc != null
            ? posterImageSrc.value
            : this.posterImageSrc),
        cast: (cast != null ? cast.value : this.cast),
        releaseDate:
            (releaseDate != null ? releaseDate.value : this.releaseDate),
        runningTime:
            (runningTime != null ? runningTime.value : this.runningTime),
        synopsisShort:
            (synopsisShort != null ? synopsisShort.value : this.synopsisShort),
        filmTitle: (filmTitle != null ? filmTitle.value : this.filmTitle),
        showingGroups:
            (showingGroups != null ? showingGroups.value : this.showingGroups));
  }
}

@JsonSerializable(explicitToJson: true)
class FilmWithShowingsReadDtoListBaseResponseDto {
  FilmWithShowingsReadDtoListBaseResponseDto({
    this.result,
    this.responseCode,
    this.errorMessage,
  });

  factory FilmWithShowingsReadDtoListBaseResponseDto.fromJson(
          Map<String, dynamic> json) =>
      _$FilmWithShowingsReadDtoListBaseResponseDtoFromJson(json);

  @JsonKey(
      name: 'result',
      includeIfNull: false,
      defaultValue: <FilmWithShowingsReadDto>[])
  final List<FilmWithShowingsReadDto>? result;
  @JsonKey(
    name: 'responseCode',
    includeIfNull: false,
    toJson: errorCodeToJson,
    fromJson: errorCodeFromJson,
  )
  final enums.ErrorCode? responseCode;
  @JsonKey(name: 'errorMessage', includeIfNull: false, defaultValue: '')
  final String? errorMessage;
  static const fromJsonFactory =
      _$FilmWithShowingsReadDtoListBaseResponseDtoFromJson;
  static const toJsonFactory =
      _$FilmWithShowingsReadDtoListBaseResponseDtoToJson;
  Map<String, dynamic> toJson() =>
      _$FilmWithShowingsReadDtoListBaseResponseDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FilmWithShowingsReadDtoListBaseResponseDto &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.responseCode, responseCode) ||
                const DeepCollectionEquality()
                    .equals(other.responseCode, responseCode)) &&
            (identical(other.errorMessage, errorMessage) ||
                const DeepCollectionEquality()
                    .equals(other.errorMessage, errorMessage)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(result) ^
      const DeepCollectionEquality().hash(responseCode) ^
      const DeepCollectionEquality().hash(errorMessage) ^
      runtimeType.hashCode;
}

extension $FilmWithShowingsReadDtoListBaseResponseDtoExtension
    on FilmWithShowingsReadDtoListBaseResponseDto {
  FilmWithShowingsReadDtoListBaseResponseDto copyWith(
      {List<FilmWithShowingsReadDto>? result,
      enums.ErrorCode? responseCode,
      String? errorMessage}) {
    return FilmWithShowingsReadDtoListBaseResponseDto(
        result: result ?? this.result,
        responseCode: responseCode ?? this.responseCode,
        errorMessage: errorMessage ?? this.errorMessage);
  }

  FilmWithShowingsReadDtoListBaseResponseDto copyWithWrapped(
      {Wrapped<List<FilmWithShowingsReadDto>?>? result,
      Wrapped<enums.ErrorCode?>? responseCode,
      Wrapped<String?>? errorMessage}) {
    return FilmWithShowingsReadDtoListBaseResponseDto(
        result: (result != null ? result.value : this.result),
        responseCode:
            (responseCode != null ? responseCode.value : this.responseCode),
        errorMessage:
            (errorMessage != null ? errorMessage.value : this.errorMessage));
  }
}

@JsonSerializable(explicitToJson: true)
class Genre {
  Genre({
    this.id,
    this.description,
    this.code,
  });

  factory Genre.fromJson(Map<String, dynamic> json) => _$GenreFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'code', includeIfNull: false, defaultValue: '')
  final String? code;
  static const fromJsonFactory = _$GenreFromJson;
  static const toJsonFactory = _$GenreToJson;
  Map<String, dynamic> toJson() => _$GenreToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Genre &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(code) ^
      runtimeType.hashCode;
}

extension $GenreExtension on Genre {
  Genre copyWith({String? id, String? description, String? code}) {
    return Genre(
        id: id ?? this.id,
        description: description ?? this.description,
        code: code ?? this.code);
  }

  Genre copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? description,
      Wrapped<String?>? code}) {
    return Genre(
        id: (id != null ? id.value : this.id),
        description:
            (description != null ? description.value : this.description),
        code: (code != null ? code.value : this.code));
  }
}

@JsonSerializable(explicitToJson: true)
class GenreReadDto {
  GenreReadDto({
    this.id,
    this.name,
  });

  factory GenreReadDto.fromJson(Map<String, dynamic> json) =>
      _$GenreReadDtoFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  static const fromJsonFactory = _$GenreReadDtoFromJson;
  static const toJsonFactory = _$GenreReadDtoToJson;
  Map<String, dynamic> toJson() => _$GenreReadDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is GenreReadDto &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(name) ^
      runtimeType.hashCode;
}

extension $GenreReadDtoExtension on GenreReadDto {
  GenreReadDto copyWith({String? id, String? name}) {
    return GenreReadDto(id: id ?? this.id, name: name ?? this.name);
  }

  GenreReadDto copyWithWrapped({Wrapped<String?>? id, Wrapped<String?>? name}) {
    return GenreReadDto(
        id: (id != null ? id.value : this.id),
        name: (name != null ? name.value : this.name));
  }
}

@JsonSerializable(explicitToJson: true)
class GenreReadDtoListBaseResponseDto {
  GenreReadDtoListBaseResponseDto({
    this.result,
    this.responseCode,
    this.errorMessage,
  });

  factory GenreReadDtoListBaseResponseDto.fromJson(Map<String, dynamic> json) =>
      _$GenreReadDtoListBaseResponseDtoFromJson(json);

  @JsonKey(name: 'result', includeIfNull: false, defaultValue: <GenreReadDto>[])
  final List<GenreReadDto>? result;
  @JsonKey(
    name: 'responseCode',
    includeIfNull: false,
    toJson: errorCodeToJson,
    fromJson: errorCodeFromJson,
  )
  final enums.ErrorCode? responseCode;
  @JsonKey(name: 'errorMessage', includeIfNull: false, defaultValue: '')
  final String? errorMessage;
  static const fromJsonFactory = _$GenreReadDtoListBaseResponseDtoFromJson;
  static const toJsonFactory = _$GenreReadDtoListBaseResponseDtoToJson;
  Map<String, dynamic> toJson() =>
      _$GenreReadDtoListBaseResponseDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is GenreReadDtoListBaseResponseDto &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.responseCode, responseCode) ||
                const DeepCollectionEquality()
                    .equals(other.responseCode, responseCode)) &&
            (identical(other.errorMessage, errorMessage) ||
                const DeepCollectionEquality()
                    .equals(other.errorMessage, errorMessage)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(result) ^
      const DeepCollectionEquality().hash(responseCode) ^
      const DeepCollectionEquality().hash(errorMessage) ^
      runtimeType.hashCode;
}

extension $GenreReadDtoListBaseResponseDtoExtension
    on GenreReadDtoListBaseResponseDto {
  GenreReadDtoListBaseResponseDto copyWith(
      {List<GenreReadDto>? result,
      enums.ErrorCode? responseCode,
      String? errorMessage}) {
    return GenreReadDtoListBaseResponseDto(
        result: result ?? this.result,
        responseCode: responseCode ?? this.responseCode,
        errorMessage: errorMessage ?? this.errorMessage);
  }

  GenreReadDtoListBaseResponseDto copyWithWrapped(
      {Wrapped<List<GenreReadDto>?>? result,
      Wrapped<enums.ErrorCode?>? responseCode,
      Wrapped<String?>? errorMessage}) {
    return GenreReadDtoListBaseResponseDto(
        result: (result != null ? result.value : this.result),
        responseCode:
            (responseCode != null ? responseCode.value : this.responseCode),
        errorMessage:
            (errorMessage != null ? errorMessage.value : this.errorMessage));
  }
}

@JsonSerializable(explicitToJson: true)
class Language {
  Language({
    this.id,
    this.description,
    this.code,
  });

  factory Language.fromJson(Map<String, dynamic> json) =>
      _$LanguageFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'code', includeIfNull: false, defaultValue: '')
  final String? code;
  static const fromJsonFactory = _$LanguageFromJson;
  static const toJsonFactory = _$LanguageToJson;
  Map<String, dynamic> toJson() => _$LanguageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Language &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(code) ^
      runtimeType.hashCode;
}

extension $LanguageExtension on Language {
  Language copyWith({String? id, String? description, String? code}) {
    return Language(
        id: id ?? this.id,
        description: description ?? this.description,
        code: code ?? this.code);
  }

  Language copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? description,
      Wrapped<String?>? code}) {
    return Language(
        id: (id != null ? id.value : this.id),
        description:
            (description != null ? description.value : this.description),
        code: (code != null ? code.value : this.code));
  }
}

@JsonSerializable(explicitToJson: true)
class Movie {
  Movie({
    this.id,
    this.title,
    this.countriesOfOrigin,
    this.originalLanguages,
    this.castAndCrew,
    this.studio,
    this.productionCompanies,
    this.productionYear,
  });

  factory Movie.fromJson(Map<String, dynamic> json) => _$MovieFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(
      name: 'countriesOfOrigin',
      includeIfNull: false,
      defaultValue: <CountryOfOrigin>[])
  final List<CountryOfOrigin>? countriesOfOrigin;
  @JsonKey(
      name: 'originalLanguages',
      includeIfNull: false,
      defaultValue: <OriginalLanguage>[])
  final List<OriginalLanguage>? originalLanguages;
  @JsonKey(
      name: 'castAndCrew', includeIfNull: false, defaultValue: <CastAndCrew>[])
  final List<CastAndCrew>? castAndCrew;
  @JsonKey(name: 'studio', includeIfNull: false)
  final Studio? studio;
  @JsonKey(
      name: 'productionCompanies',
      includeIfNull: false,
      defaultValue: <ProductionCompany>[])
  final List<ProductionCompany>? productionCompanies;
  @JsonKey(name: 'productionYear', includeIfNull: false)
  final int? productionYear;
  static const fromJsonFactory = _$MovieFromJson;
  static const toJsonFactory = _$MovieToJson;
  Map<String, dynamic> toJson() => _$MovieToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Movie &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.countriesOfOrigin, countriesOfOrigin) ||
                const DeepCollectionEquality()
                    .equals(other.countriesOfOrigin, countriesOfOrigin)) &&
            (identical(other.originalLanguages, originalLanguages) ||
                const DeepCollectionEquality()
                    .equals(other.originalLanguages, originalLanguages)) &&
            (identical(other.castAndCrew, castAndCrew) ||
                const DeepCollectionEquality()
                    .equals(other.castAndCrew, castAndCrew)) &&
            (identical(other.studio, studio) ||
                const DeepCollectionEquality().equals(other.studio, studio)) &&
            (identical(other.productionCompanies, productionCompanies) ||
                const DeepCollectionEquality()
                    .equals(other.productionCompanies, productionCompanies)) &&
            (identical(other.productionYear, productionYear) ||
                const DeepCollectionEquality()
                    .equals(other.productionYear, productionYear)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(countriesOfOrigin) ^
      const DeepCollectionEquality().hash(originalLanguages) ^
      const DeepCollectionEquality().hash(castAndCrew) ^
      const DeepCollectionEquality().hash(studio) ^
      const DeepCollectionEquality().hash(productionCompanies) ^
      const DeepCollectionEquality().hash(productionYear) ^
      runtimeType.hashCode;
}

extension $MovieExtension on Movie {
  Movie copyWith(
      {String? id,
      String? title,
      List<CountryOfOrigin>? countriesOfOrigin,
      List<OriginalLanguage>? originalLanguages,
      List<CastAndCrew>? castAndCrew,
      Studio? studio,
      List<ProductionCompany>? productionCompanies,
      int? productionYear}) {
    return Movie(
        id: id ?? this.id,
        title: title ?? this.title,
        countriesOfOrigin: countriesOfOrigin ?? this.countriesOfOrigin,
        originalLanguages: originalLanguages ?? this.originalLanguages,
        castAndCrew: castAndCrew ?? this.castAndCrew,
        studio: studio ?? this.studio,
        productionCompanies: productionCompanies ?? this.productionCompanies,
        productionYear: productionYear ?? this.productionYear);
  }

  Movie copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? title,
      Wrapped<List<CountryOfOrigin>?>? countriesOfOrigin,
      Wrapped<List<OriginalLanguage>?>? originalLanguages,
      Wrapped<List<CastAndCrew>?>? castAndCrew,
      Wrapped<Studio?>? studio,
      Wrapped<List<ProductionCompany>?>? productionCompanies,
      Wrapped<int?>? productionYear}) {
    return Movie(
        id: (id != null ? id.value : this.id),
        title: (title != null ? title.value : this.title),
        countriesOfOrigin: (countriesOfOrigin != null
            ? countriesOfOrigin.value
            : this.countriesOfOrigin),
        originalLanguages: (originalLanguages != null
            ? originalLanguages.value
            : this.originalLanguages),
        castAndCrew:
            (castAndCrew != null ? castAndCrew.value : this.castAndCrew),
        studio: (studio != null ? studio.value : this.studio),
        productionCompanies: (productionCompanies != null
            ? productionCompanies.value
            : this.productionCompanies),
        productionYear: (productionYear != null
            ? productionYear.value
            : this.productionYear));
  }
}

@JsonSerializable(explicitToJson: true)
class MovieCodeModel {
  MovieCodeModel({
    this.movieCodeType,
    this.movieCode,
  });

  factory MovieCodeModel.fromJson(Map<String, dynamic> json) =>
      _$MovieCodeModelFromJson(json);

  @JsonKey(name: 'movieCodeType', includeIfNull: false, defaultValue: '')
  final String? movieCodeType;
  @JsonKey(name: 'movieCode', includeIfNull: false, defaultValue: '')
  final String? movieCode;
  static const fromJsonFactory = _$MovieCodeModelFromJson;
  static const toJsonFactory = _$MovieCodeModelToJson;
  Map<String, dynamic> toJson() => _$MovieCodeModelToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MovieCodeModel &&
            (identical(other.movieCodeType, movieCodeType) ||
                const DeepCollectionEquality()
                    .equals(other.movieCodeType, movieCodeType)) &&
            (identical(other.movieCode, movieCode) ||
                const DeepCollectionEquality()
                    .equals(other.movieCode, movieCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(movieCodeType) ^
      const DeepCollectionEquality().hash(movieCode) ^
      runtimeType.hashCode;
}

extension $MovieCodeModelExtension on MovieCodeModel {
  MovieCodeModel copyWith({String? movieCodeType, String? movieCode}) {
    return MovieCodeModel(
        movieCodeType: movieCodeType ?? this.movieCodeType,
        movieCode: movieCode ?? this.movieCode);
  }

  MovieCodeModel copyWithWrapped(
      {Wrapped<String?>? movieCodeType, Wrapped<String?>? movieCode}) {
    return MovieCodeModel(
        movieCodeType:
            (movieCodeType != null ? movieCodeType.value : this.movieCodeType),
        movieCode: (movieCode != null ? movieCode.value : this.movieCode));
  }
}

@JsonSerializable(explicitToJson: true)
class MovieFormat {
  MovieFormat({
    this.id,
    this.description,
    this.code,
  });

  factory MovieFormat.fromJson(Map<String, dynamic> json) =>
      _$MovieFormatFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'code', includeIfNull: false, defaultValue: '')
  final String? code;
  static const fromJsonFactory = _$MovieFormatFromJson;
  static const toJsonFactory = _$MovieFormatToJson;
  Map<String, dynamic> toJson() => _$MovieFormatToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MovieFormat &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(code) ^
      runtimeType.hashCode;
}

extension $MovieFormatExtension on MovieFormat {
  MovieFormat copyWith({String? id, String? description, String? code}) {
    return MovieFormat(
        id: id ?? this.id,
        description: description ?? this.description,
        code: code ?? this.code);
  }

  MovieFormat copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? description,
      Wrapped<String?>? code}) {
    return MovieFormat(
        id: (id != null ? id.value : this.id),
        description:
            (description != null ? description.value : this.description),
        code: (code != null ? code.value : this.code));
  }
}

@JsonSerializable(explicitToJson: true)
class MovieXchangeReleaseDto {
  MovieXchangeReleaseDto({
    this.id,
    this.created,
    this.modified,
    this.associatedObjectModified,
    this.tagline,
    this.title,
    this.posterImageUrl,
    this.isPosterImageUnofficial,
    this.originalSizePosterImageId,
    this.trailerUrl,
    this.synopsis,
    this.durationInMinutes,
    this.releaseDate,
    this.releaseMonth,
    this.releaseYear,
    this.shortSynopsis,
    this.shortTitle,
    this.signageText,
    this.signageTitle,
    this.distributor,
    this.territory,
    this.movie,
    this.rating,
    this.promotionalLanguage,
    this.ratingReasons,
    this.externalMovieCodes,
    this.socialMedia,
    this.genres,
    this.releaseVersions,
    this.customProperties,
  });

  factory MovieXchangeReleaseDto.fromJson(Map<String, dynamic> json) =>
      _$MovieXchangeReleaseDtoFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'created', includeIfNull: false, defaultValue: '')
  final String? created;
  @JsonKey(name: 'modified', includeIfNull: false, defaultValue: '')
  final String? modified;
  @JsonKey(
      name: 'associatedObjectModified', includeIfNull: false, defaultValue: '')
  final String? associatedObjectModified;
  @JsonKey(name: 'tagline', includeIfNull: false, defaultValue: '')
  final String? tagline;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'posterImageUrl', includeIfNull: false, defaultValue: '')
  final String? posterImageUrl;
  @JsonKey(name: 'isPosterImageUnofficial', includeIfNull: false)
  final bool? isPosterImageUnofficial;
  @JsonKey(
      name: 'originalSizePosterImageId', includeIfNull: false, defaultValue: '')
  final String? originalSizePosterImageId;
  @JsonKey(name: 'trailerUrl', includeIfNull: false, defaultValue: '')
  final String? trailerUrl;
  @JsonKey(name: 'synopsis', includeIfNull: false, defaultValue: '')
  final String? synopsis;
  @JsonKey(name: 'durationInMinutes', includeIfNull: false, defaultValue: '')
  final String? durationInMinutes;
  @JsonKey(name: 'releaseDate', includeIfNull: false, defaultValue: '')
  final String? releaseDate;
  @JsonKey(name: 'releaseMonth', includeIfNull: false)
  final int? releaseMonth;
  @JsonKey(name: 'releaseYear', includeIfNull: false)
  final int? releaseYear;
  @JsonKey(name: 'shortSynopsis', includeIfNull: false, defaultValue: '')
  final String? shortSynopsis;
  @JsonKey(name: 'shortTitle', includeIfNull: false, defaultValue: '')
  final String? shortTitle;
  @JsonKey(name: 'signageText', includeIfNull: false, defaultValue: '')
  final String? signageText;
  @JsonKey(name: 'signageTitle', includeIfNull: false, defaultValue: '')
  final String? signageTitle;
  @JsonKey(name: 'distributor', includeIfNull: false)
  final Distributor? distributor;
  @JsonKey(name: 'territory', includeIfNull: false)
  final Territory? territory;
  @JsonKey(name: 'movie', includeIfNull: false)
  final Movie? movie;
  @JsonKey(name: 'rating', includeIfNull: false)
  final Rating? rating;
  @JsonKey(name: 'promotionalLanguage', includeIfNull: false)
  final PromotionalLanguage? promotionalLanguage;
  @JsonKey(
      name: 'ratingReasons',
      includeIfNull: false,
      defaultValue: <RatingReason>[])
  final List<RatingReason>? ratingReasons;
  @JsonKey(
      name: 'externalMovieCodes',
      includeIfNull: false,
      defaultValue: <MovieCodeModel>[])
  final List<MovieCodeModel>? externalMovieCodes;
  @JsonKey(
      name: 'socialMedia', includeIfNull: false, defaultValue: <SocialMedia>[])
  final List<SocialMedia>? socialMedia;
  @JsonKey(name: 'genres', includeIfNull: false, defaultValue: <Genre>[])
  final List<Genre>? genres;
  @JsonKey(
      name: 'releaseVersions',
      includeIfNull: false,
      defaultValue: <ReleaseVersion>[])
  final List<ReleaseVersion>? releaseVersions;
  @JsonKey(
      name: 'customProperties',
      includeIfNull: false,
      defaultValue: <CustomProperty>[])
  final List<CustomProperty>? customProperties;
  static const fromJsonFactory = _$MovieXchangeReleaseDtoFromJson;
  static const toJsonFactory = _$MovieXchangeReleaseDtoToJson;
  Map<String, dynamic> toJson() => _$MovieXchangeReleaseDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MovieXchangeReleaseDto &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.created, created) ||
                const DeepCollectionEquality()
                    .equals(other.created, created)) &&
            (identical(other.modified, modified) ||
                const DeepCollectionEquality()
                    .equals(other.modified, modified)) &&
            (identical(other.associatedObjectModified, associatedObjectModified) ||
                const DeepCollectionEquality().equals(
                    other.associatedObjectModified,
                    associatedObjectModified)) &&
            (identical(other.tagline, tagline) ||
                const DeepCollectionEquality()
                    .equals(other.tagline, tagline)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.posterImageUrl, posterImageUrl) ||
                const DeepCollectionEquality()
                    .equals(other.posterImageUrl, posterImageUrl)) &&
            (identical(other.isPosterImageUnofficial, isPosterImageUnofficial) ||
                const DeepCollectionEquality().equals(
                    other.isPosterImageUnofficial, isPosterImageUnofficial)) &&
            (identical(other.originalSizePosterImageId, originalSizePosterImageId) ||
                const DeepCollectionEquality().equals(
                    other.originalSizePosterImageId,
                    originalSizePosterImageId)) &&
            (identical(other.trailerUrl, trailerUrl) ||
                const DeepCollectionEquality()
                    .equals(other.trailerUrl, trailerUrl)) &&
            (identical(other.synopsis, synopsis) ||
                const DeepCollectionEquality()
                    .equals(other.synopsis, synopsis)) &&
            (identical(other.durationInMinutes, durationInMinutes) ||
                const DeepCollectionEquality()
                    .equals(other.durationInMinutes, durationInMinutes)) &&
            (identical(other.releaseDate, releaseDate) ||
                const DeepCollectionEquality()
                    .equals(other.releaseDate, releaseDate)) &&
            (identical(other.releaseMonth, releaseMonth) ||
                const DeepCollectionEquality()
                    .equals(other.releaseMonth, releaseMonth)) &&
            (identical(other.releaseYear, releaseYear) || const DeepCollectionEquality().equals(other.releaseYear, releaseYear)) &&
            (identical(other.shortSynopsis, shortSynopsis) || const DeepCollectionEquality().equals(other.shortSynopsis, shortSynopsis)) &&
            (identical(other.shortTitle, shortTitle) || const DeepCollectionEquality().equals(other.shortTitle, shortTitle)) &&
            (identical(other.signageText, signageText) || const DeepCollectionEquality().equals(other.signageText, signageText)) &&
            (identical(other.signageTitle, signageTitle) || const DeepCollectionEquality().equals(other.signageTitle, signageTitle)) &&
            (identical(other.distributor, distributor) || const DeepCollectionEquality().equals(other.distributor, distributor)) &&
            (identical(other.territory, territory) || const DeepCollectionEquality().equals(other.territory, territory)) &&
            (identical(other.movie, movie) || const DeepCollectionEquality().equals(other.movie, movie)) &&
            (identical(other.rating, rating) || const DeepCollectionEquality().equals(other.rating, rating)) &&
            (identical(other.promotionalLanguage, promotionalLanguage) || const DeepCollectionEquality().equals(other.promotionalLanguage, promotionalLanguage)) &&
            (identical(other.ratingReasons, ratingReasons) || const DeepCollectionEquality().equals(other.ratingReasons, ratingReasons)) &&
            (identical(other.externalMovieCodes, externalMovieCodes) || const DeepCollectionEquality().equals(other.externalMovieCodes, externalMovieCodes)) &&
            (identical(other.socialMedia, socialMedia) || const DeepCollectionEquality().equals(other.socialMedia, socialMedia)) &&
            (identical(other.genres, genres) || const DeepCollectionEquality().equals(other.genres, genres)) &&
            (identical(other.releaseVersions, releaseVersions) || const DeepCollectionEquality().equals(other.releaseVersions, releaseVersions)) &&
            (identical(other.customProperties, customProperties) || const DeepCollectionEquality().equals(other.customProperties, customProperties)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(created) ^
      const DeepCollectionEquality().hash(modified) ^
      const DeepCollectionEquality().hash(associatedObjectModified) ^
      const DeepCollectionEquality().hash(tagline) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(posterImageUrl) ^
      const DeepCollectionEquality().hash(isPosterImageUnofficial) ^
      const DeepCollectionEquality().hash(originalSizePosterImageId) ^
      const DeepCollectionEquality().hash(trailerUrl) ^
      const DeepCollectionEquality().hash(synopsis) ^
      const DeepCollectionEquality().hash(durationInMinutes) ^
      const DeepCollectionEquality().hash(releaseDate) ^
      const DeepCollectionEquality().hash(releaseMonth) ^
      const DeepCollectionEquality().hash(releaseYear) ^
      const DeepCollectionEquality().hash(shortSynopsis) ^
      const DeepCollectionEquality().hash(shortTitle) ^
      const DeepCollectionEquality().hash(signageText) ^
      const DeepCollectionEquality().hash(signageTitle) ^
      const DeepCollectionEquality().hash(distributor) ^
      const DeepCollectionEquality().hash(territory) ^
      const DeepCollectionEquality().hash(movie) ^
      const DeepCollectionEquality().hash(rating) ^
      const DeepCollectionEquality().hash(promotionalLanguage) ^
      const DeepCollectionEquality().hash(ratingReasons) ^
      const DeepCollectionEquality().hash(externalMovieCodes) ^
      const DeepCollectionEquality().hash(socialMedia) ^
      const DeepCollectionEquality().hash(genres) ^
      const DeepCollectionEquality().hash(releaseVersions) ^
      const DeepCollectionEquality().hash(customProperties) ^
      runtimeType.hashCode;
}

extension $MovieXchangeReleaseDtoExtension on MovieXchangeReleaseDto {
  MovieXchangeReleaseDto copyWith(
      {String? id,
      String? created,
      String? modified,
      String? associatedObjectModified,
      String? tagline,
      String? title,
      String? posterImageUrl,
      bool? isPosterImageUnofficial,
      String? originalSizePosterImageId,
      String? trailerUrl,
      String? synopsis,
      String? durationInMinutes,
      String? releaseDate,
      int? releaseMonth,
      int? releaseYear,
      String? shortSynopsis,
      String? shortTitle,
      String? signageText,
      String? signageTitle,
      Distributor? distributor,
      Territory? territory,
      Movie? movie,
      Rating? rating,
      PromotionalLanguage? promotionalLanguage,
      List<RatingReason>? ratingReasons,
      List<MovieCodeModel>? externalMovieCodes,
      List<SocialMedia>? socialMedia,
      List<Genre>? genres,
      List<ReleaseVersion>? releaseVersions,
      List<CustomProperty>? customProperties}) {
    return MovieXchangeReleaseDto(
        id: id ?? this.id,
        created: created ?? this.created,
        modified: modified ?? this.modified,
        associatedObjectModified:
            associatedObjectModified ?? this.associatedObjectModified,
        tagline: tagline ?? this.tagline,
        title: title ?? this.title,
        posterImageUrl: posterImageUrl ?? this.posterImageUrl,
        isPosterImageUnofficial:
            isPosterImageUnofficial ?? this.isPosterImageUnofficial,
        originalSizePosterImageId:
            originalSizePosterImageId ?? this.originalSizePosterImageId,
        trailerUrl: trailerUrl ?? this.trailerUrl,
        synopsis: synopsis ?? this.synopsis,
        durationInMinutes: durationInMinutes ?? this.durationInMinutes,
        releaseDate: releaseDate ?? this.releaseDate,
        releaseMonth: releaseMonth ?? this.releaseMonth,
        releaseYear: releaseYear ?? this.releaseYear,
        shortSynopsis: shortSynopsis ?? this.shortSynopsis,
        shortTitle: shortTitle ?? this.shortTitle,
        signageText: signageText ?? this.signageText,
        signageTitle: signageTitle ?? this.signageTitle,
        distributor: distributor ?? this.distributor,
        territory: territory ?? this.territory,
        movie: movie ?? this.movie,
        rating: rating ?? this.rating,
        promotionalLanguage: promotionalLanguage ?? this.promotionalLanguage,
        ratingReasons: ratingReasons ?? this.ratingReasons,
        externalMovieCodes: externalMovieCodes ?? this.externalMovieCodes,
        socialMedia: socialMedia ?? this.socialMedia,
        genres: genres ?? this.genres,
        releaseVersions: releaseVersions ?? this.releaseVersions,
        customProperties: customProperties ?? this.customProperties);
  }

  MovieXchangeReleaseDto copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? created,
      Wrapped<String?>? modified,
      Wrapped<String?>? associatedObjectModified,
      Wrapped<String?>? tagline,
      Wrapped<String?>? title,
      Wrapped<String?>? posterImageUrl,
      Wrapped<bool?>? isPosterImageUnofficial,
      Wrapped<String?>? originalSizePosterImageId,
      Wrapped<String?>? trailerUrl,
      Wrapped<String?>? synopsis,
      Wrapped<String?>? durationInMinutes,
      Wrapped<String?>? releaseDate,
      Wrapped<int?>? releaseMonth,
      Wrapped<int?>? releaseYear,
      Wrapped<String?>? shortSynopsis,
      Wrapped<String?>? shortTitle,
      Wrapped<String?>? signageText,
      Wrapped<String?>? signageTitle,
      Wrapped<Distributor?>? distributor,
      Wrapped<Territory?>? territory,
      Wrapped<Movie?>? movie,
      Wrapped<Rating?>? rating,
      Wrapped<PromotionalLanguage?>? promotionalLanguage,
      Wrapped<List<RatingReason>?>? ratingReasons,
      Wrapped<List<MovieCodeModel>?>? externalMovieCodes,
      Wrapped<List<SocialMedia>?>? socialMedia,
      Wrapped<List<Genre>?>? genres,
      Wrapped<List<ReleaseVersion>?>? releaseVersions,
      Wrapped<List<CustomProperty>?>? customProperties}) {
    return MovieXchangeReleaseDto(
        id: (id != null ? id.value : this.id),
        created: (created != null ? created.value : this.created),
        modified: (modified != null ? modified.value : this.modified),
        associatedObjectModified: (associatedObjectModified != null
            ? associatedObjectModified.value
            : this.associatedObjectModified),
        tagline: (tagline != null ? tagline.value : this.tagline),
        title: (title != null ? title.value : this.title),
        posterImageUrl: (posterImageUrl != null
            ? posterImageUrl.value
            : this.posterImageUrl),
        isPosterImageUnofficial: (isPosterImageUnofficial != null
            ? isPosterImageUnofficial.value
            : this.isPosterImageUnofficial),
        originalSizePosterImageId: (originalSizePosterImageId != null
            ? originalSizePosterImageId.value
            : this.originalSizePosterImageId),
        trailerUrl: (trailerUrl != null ? trailerUrl.value : this.trailerUrl),
        synopsis: (synopsis != null ? synopsis.value : this.synopsis),
        durationInMinutes: (durationInMinutes != null
            ? durationInMinutes.value
            : this.durationInMinutes),
        releaseDate:
            (releaseDate != null ? releaseDate.value : this.releaseDate),
        releaseMonth:
            (releaseMonth != null ? releaseMonth.value : this.releaseMonth),
        releaseYear:
            (releaseYear != null ? releaseYear.value : this.releaseYear),
        shortSynopsis:
            (shortSynopsis != null ? shortSynopsis.value : this.shortSynopsis),
        shortTitle: (shortTitle != null ? shortTitle.value : this.shortTitle),
        signageText:
            (signageText != null ? signageText.value : this.signageText),
        signageTitle:
            (signageTitle != null ? signageTitle.value : this.signageTitle),
        distributor:
            (distributor != null ? distributor.value : this.distributor),
        territory: (territory != null ? territory.value : this.territory),
        movie: (movie != null ? movie.value : this.movie),
        rating: (rating != null ? rating.value : this.rating),
        promotionalLanguage: (promotionalLanguage != null
            ? promotionalLanguage.value
            : this.promotionalLanguage),
        ratingReasons:
            (ratingReasons != null ? ratingReasons.value : this.ratingReasons),
        externalMovieCodes: (externalMovieCodes != null
            ? externalMovieCodes.value
            : this.externalMovieCodes),
        socialMedia:
            (socialMedia != null ? socialMedia.value : this.socialMedia),
        genres: (genres != null ? genres.value : this.genres),
        releaseVersions: (releaseVersions != null
            ? releaseVersions.value
            : this.releaseVersions),
        customProperties: (customProperties != null
            ? customProperties.value
            : this.customProperties));
  }
}

@JsonSerializable(explicitToJson: true)
class MovieXchangeReleaseDtoBaseResponseDto {
  MovieXchangeReleaseDtoBaseResponseDto({
    this.result,
    this.responseCode,
    this.errorMessage,
  });

  factory MovieXchangeReleaseDtoBaseResponseDto.fromJson(
          Map<String, dynamic> json) =>
      _$MovieXchangeReleaseDtoBaseResponseDtoFromJson(json);

  @JsonKey(name: 'result', includeIfNull: false)
  final MovieXchangeReleaseDto? result;
  @JsonKey(
    name: 'responseCode',
    includeIfNull: false,
    toJson: errorCodeToJson,
    fromJson: errorCodeFromJson,
  )
  final enums.ErrorCode? responseCode;
  @JsonKey(name: 'errorMessage', includeIfNull: false, defaultValue: '')
  final String? errorMessage;
  static const fromJsonFactory =
      _$MovieXchangeReleaseDtoBaseResponseDtoFromJson;
  static const toJsonFactory = _$MovieXchangeReleaseDtoBaseResponseDtoToJson;
  Map<String, dynamic> toJson() =>
      _$MovieXchangeReleaseDtoBaseResponseDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MovieXchangeReleaseDtoBaseResponseDto &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.responseCode, responseCode) ||
                const DeepCollectionEquality()
                    .equals(other.responseCode, responseCode)) &&
            (identical(other.errorMessage, errorMessage) ||
                const DeepCollectionEquality()
                    .equals(other.errorMessage, errorMessage)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(result) ^
      const DeepCollectionEquality().hash(responseCode) ^
      const DeepCollectionEquality().hash(errorMessage) ^
      runtimeType.hashCode;
}

extension $MovieXchangeReleaseDtoBaseResponseDtoExtension
    on MovieXchangeReleaseDtoBaseResponseDto {
  MovieXchangeReleaseDtoBaseResponseDto copyWith(
      {MovieXchangeReleaseDto? result,
      enums.ErrorCode? responseCode,
      String? errorMessage}) {
    return MovieXchangeReleaseDtoBaseResponseDto(
        result: result ?? this.result,
        responseCode: responseCode ?? this.responseCode,
        errorMessage: errorMessage ?? this.errorMessage);
  }

  MovieXchangeReleaseDtoBaseResponseDto copyWithWrapped(
      {Wrapped<MovieXchangeReleaseDto?>? result,
      Wrapped<enums.ErrorCode?>? responseCode,
      Wrapped<String?>? errorMessage}) {
    return MovieXchangeReleaseDtoBaseResponseDto(
        result: (result != null ? result.value : this.result),
        responseCode:
            (responseCode != null ? responseCode.value : this.responseCode),
        errorMessage:
            (errorMessage != null ? errorMessage.value : this.errorMessage));
  }
}

@JsonSerializable(explicitToJson: true)
class NameGroupedCinemaListItemReadDto {
  NameGroupedCinemaListItemReadDto({
    this.alpha,
    this.cinemas,
  });

  factory NameGroupedCinemaListItemReadDto.fromJson(
          Map<String, dynamic> json) =>
      _$NameGroupedCinemaListItemReadDtoFromJson(json);

  @JsonKey(name: 'alpha', includeIfNull: false, defaultValue: '')
  final String? alpha;
  @JsonKey(name: 'cinemas', includeIfNull: false, defaultValue: <CinemaDto>[])
  final List<CinemaDto>? cinemas;
  static const fromJsonFactory = _$NameGroupedCinemaListItemReadDtoFromJson;
  static const toJsonFactory = _$NameGroupedCinemaListItemReadDtoToJson;
  Map<String, dynamic> toJson() =>
      _$NameGroupedCinemaListItemReadDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NameGroupedCinemaListItemReadDto &&
            (identical(other.alpha, alpha) ||
                const DeepCollectionEquality().equals(other.alpha, alpha)) &&
            (identical(other.cinemas, cinemas) ||
                const DeepCollectionEquality().equals(other.cinemas, cinemas)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(alpha) ^
      const DeepCollectionEquality().hash(cinemas) ^
      runtimeType.hashCode;
}

extension $NameGroupedCinemaListItemReadDtoExtension
    on NameGroupedCinemaListItemReadDto {
  NameGroupedCinemaListItemReadDto copyWith(
      {String? alpha, List<CinemaDto>? cinemas}) {
    return NameGroupedCinemaListItemReadDto(
        alpha: alpha ?? this.alpha, cinemas: cinemas ?? this.cinemas);
  }

  NameGroupedCinemaListItemReadDto copyWithWrapped(
      {Wrapped<String?>? alpha, Wrapped<List<CinemaDto>?>? cinemas}) {
    return NameGroupedCinemaListItemReadDto(
        alpha: (alpha != null ? alpha.value : this.alpha),
        cinemas: (cinemas != null ? cinemas.value : this.cinemas));
  }
}

@JsonSerializable(explicitToJson: true)
class NameGroupedCinemaListItemReadDtoListBaseResponseDto {
  NameGroupedCinemaListItemReadDtoListBaseResponseDto({
    this.result,
    this.responseCode,
    this.errorMessage,
  });

  factory NameGroupedCinemaListItemReadDtoListBaseResponseDto.fromJson(
          Map<String, dynamic> json) =>
      _$NameGroupedCinemaListItemReadDtoListBaseResponseDtoFromJson(json);

  @JsonKey(
      name: 'result',
      includeIfNull: false,
      defaultValue: <NameGroupedCinemaListItemReadDto>[])
  final List<NameGroupedCinemaListItemReadDto>? result;
  @JsonKey(
    name: 'responseCode',
    includeIfNull: false,
    toJson: errorCodeToJson,
    fromJson: errorCodeFromJson,
  )
  final enums.ErrorCode? responseCode;
  @JsonKey(name: 'errorMessage', includeIfNull: false, defaultValue: '')
  final String? errorMessage;
  static const fromJsonFactory =
      _$NameGroupedCinemaListItemReadDtoListBaseResponseDtoFromJson;
  static const toJsonFactory =
      _$NameGroupedCinemaListItemReadDtoListBaseResponseDtoToJson;
  Map<String, dynamic> toJson() =>
      _$NameGroupedCinemaListItemReadDtoListBaseResponseDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NameGroupedCinemaListItemReadDtoListBaseResponseDto &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.responseCode, responseCode) ||
                const DeepCollectionEquality()
                    .equals(other.responseCode, responseCode)) &&
            (identical(other.errorMessage, errorMessage) ||
                const DeepCollectionEquality()
                    .equals(other.errorMessage, errorMessage)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(result) ^
      const DeepCollectionEquality().hash(responseCode) ^
      const DeepCollectionEquality().hash(errorMessage) ^
      runtimeType.hashCode;
}

extension $NameGroupedCinemaListItemReadDtoListBaseResponseDtoExtension
    on NameGroupedCinemaListItemReadDtoListBaseResponseDto {
  NameGroupedCinemaListItemReadDtoListBaseResponseDto copyWith(
      {List<NameGroupedCinemaListItemReadDto>? result,
      enums.ErrorCode? responseCode,
      String? errorMessage}) {
    return NameGroupedCinemaListItemReadDtoListBaseResponseDto(
        result: result ?? this.result,
        responseCode: responseCode ?? this.responseCode,
        errorMessage: errorMessage ?? this.errorMessage);
  }

  NameGroupedCinemaListItemReadDtoListBaseResponseDto copyWithWrapped(
      {Wrapped<List<NameGroupedCinemaListItemReadDto>?>? result,
      Wrapped<enums.ErrorCode?>? responseCode,
      Wrapped<String?>? errorMessage}) {
    return NameGroupedCinemaListItemReadDtoListBaseResponseDto(
        result: (result != null ? result.value : this.result),
        responseCode:
            (responseCode != null ? responseCode.value : this.responseCode),
        errorMessage:
            (errorMessage != null ? errorMessage.value : this.errorMessage));
  }
}

@JsonSerializable(explicitToJson: true)
class OrganizationCode {
  OrganizationCode({
    this.icaaCode,
  });

  factory OrganizationCode.fromJson(Map<String, dynamic> json) =>
      _$OrganizationCodeFromJson(json);

  @JsonKey(name: 'icaaCode', includeIfNull: false, defaultValue: '')
  final String? icaaCode;
  static const fromJsonFactory = _$OrganizationCodeFromJson;
  static const toJsonFactory = _$OrganizationCodeToJson;
  Map<String, dynamic> toJson() => _$OrganizationCodeToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OrganizationCode &&
            (identical(other.icaaCode, icaaCode) ||
                const DeepCollectionEquality()
                    .equals(other.icaaCode, icaaCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(icaaCode) ^ runtimeType.hashCode;
}

extension $OrganizationCodeExtension on OrganizationCode {
  OrganizationCode copyWith({String? icaaCode}) {
    return OrganizationCode(icaaCode: icaaCode ?? this.icaaCode);
  }

  OrganizationCode copyWithWrapped({Wrapped<String?>? icaaCode}) {
    return OrganizationCode(
        icaaCode: (icaaCode != null ? icaaCode.value : this.icaaCode));
  }
}

@JsonSerializable(explicitToJson: true)
class OriginalLanguage {
  OriginalLanguage({
    this.id,
    this.description,
    this.code,
  });

  factory OriginalLanguage.fromJson(Map<String, dynamic> json) =>
      _$OriginalLanguageFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'code', includeIfNull: false, defaultValue: '')
  final String? code;
  static const fromJsonFactory = _$OriginalLanguageFromJson;
  static const toJsonFactory = _$OriginalLanguageToJson;
  Map<String, dynamic> toJson() => _$OriginalLanguageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OriginalLanguage &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(code) ^
      runtimeType.hashCode;
}

extension $OriginalLanguageExtension on OriginalLanguage {
  OriginalLanguage copyWith({String? id, String? description, String? code}) {
    return OriginalLanguage(
        id: id ?? this.id,
        description: description ?? this.description,
        code: code ?? this.code);
  }

  OriginalLanguage copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? description,
      Wrapped<String?>? code}) {
    return OriginalLanguage(
        id: (id != null ? id.value : this.id),
        description:
            (description != null ? description.value : this.description),
        code: (code != null ? code.value : this.code));
  }
}

@JsonSerializable(explicitToJson: true)
class PricingTypeDto {
  PricingTypeDto({
    this.name,
    this.attributeType,
    this.value,
    this.color,
  });

  factory PricingTypeDto.fromJson(Map<String, dynamic> json) =>
      _$PricingTypeDtoFromJson(json);

  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'attributeType', includeIfNull: false, defaultValue: '')
  final String? attributeType;
  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String? value;
  @JsonKey(name: 'color', includeIfNull: false, defaultValue: '')
  final String? color;
  static const fromJsonFactory = _$PricingTypeDtoFromJson;
  static const toJsonFactory = _$PricingTypeDtoToJson;
  Map<String, dynamic> toJson() => _$PricingTypeDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PricingTypeDto &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.attributeType, attributeType) ||
                const DeepCollectionEquality()
                    .equals(other.attributeType, attributeType)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)) &&
            (identical(other.color, color) ||
                const DeepCollectionEquality().equals(other.color, color)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(attributeType) ^
      const DeepCollectionEquality().hash(value) ^
      const DeepCollectionEquality().hash(color) ^
      runtimeType.hashCode;
}

extension $PricingTypeDtoExtension on PricingTypeDto {
  PricingTypeDto copyWith(
      {String? name, String? attributeType, String? value, String? color}) {
    return PricingTypeDto(
        name: name ?? this.name,
        attributeType: attributeType ?? this.attributeType,
        value: value ?? this.value,
        color: color ?? this.color);
  }

  PricingTypeDto copyWithWrapped(
      {Wrapped<String?>? name,
      Wrapped<String?>? attributeType,
      Wrapped<String?>? value,
      Wrapped<String?>? color}) {
    return PricingTypeDto(
        name: (name != null ? name.value : this.name),
        attributeType:
            (attributeType != null ? attributeType.value : this.attributeType),
        value: (value != null ? value.value : this.value),
        color: (color != null ? color.value : this.color));
  }
}

@JsonSerializable(explicitToJson: true)
class ProductionCompany {
  ProductionCompany({
    this.id,
    this.description,
    this.organizationCodes,
  });

  factory ProductionCompany.fromJson(Map<String, dynamic> json) =>
      _$ProductionCompanyFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'organizationCodes', includeIfNull: false)
  final OrganizationCode? organizationCodes;
  static const fromJsonFactory = _$ProductionCompanyFromJson;
  static const toJsonFactory = _$ProductionCompanyToJson;
  Map<String, dynamic> toJson() => _$ProductionCompanyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProductionCompany &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.organizationCodes, organizationCodes) ||
                const DeepCollectionEquality()
                    .equals(other.organizationCodes, organizationCodes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(organizationCodes) ^
      runtimeType.hashCode;
}

extension $ProductionCompanyExtension on ProductionCompany {
  ProductionCompany copyWith(
      {String? id, String? description, OrganizationCode? organizationCodes}) {
    return ProductionCompany(
        id: id ?? this.id,
        description: description ?? this.description,
        organizationCodes: organizationCodes ?? this.organizationCodes);
  }

  ProductionCompany copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? description,
      Wrapped<OrganizationCode?>? organizationCodes}) {
    return ProductionCompany(
        id: (id != null ? id.value : this.id),
        description:
            (description != null ? description.value : this.description),
        organizationCodes: (organizationCodes != null
            ? organizationCodes.value
            : this.organizationCodes));
  }
}

@JsonSerializable(explicitToJson: true)
class PromotionalLanguage {
  PromotionalLanguage({
    this.id,
    this.description,
    this.code,
  });

  factory PromotionalLanguage.fromJson(Map<String, dynamic> json) =>
      _$PromotionalLanguageFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'code', includeIfNull: false, defaultValue: '')
  final String? code;
  static const fromJsonFactory = _$PromotionalLanguageFromJson;
  static const toJsonFactory = _$PromotionalLanguageToJson;
  Map<String, dynamic> toJson() => _$PromotionalLanguageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PromotionalLanguage &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(code) ^
      runtimeType.hashCode;
}

extension $PromotionalLanguageExtension on PromotionalLanguage {
  PromotionalLanguage copyWith(
      {String? id, String? description, String? code}) {
    return PromotionalLanguage(
        id: id ?? this.id,
        description: description ?? this.description,
        code: code ?? this.code);
  }

  PromotionalLanguage copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? description,
      Wrapped<String?>? code}) {
    return PromotionalLanguage(
        id: (id != null ? id.value : this.id),
        description:
            (description != null ? description.value : this.description),
        code: (code != null ? code.value : this.code));
  }
}

@JsonSerializable(explicitToJson: true)
class Rating {
  Rating({
    this.id,
    this.classification,
    this.ratingNotes,
    this.territoryCode,
  });

  factory Rating.fromJson(Map<String, dynamic> json) => _$RatingFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'classification', includeIfNull: false, defaultValue: '')
  final String? classification;
  @JsonKey(name: 'ratingNotes', includeIfNull: false, defaultValue: '')
  final String? ratingNotes;
  @JsonKey(name: 'territoryCode', includeIfNull: false, defaultValue: '')
  final String? territoryCode;
  static const fromJsonFactory = _$RatingFromJson;
  static const toJsonFactory = _$RatingToJson;
  Map<String, dynamic> toJson() => _$RatingToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Rating &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.classification, classification) ||
                const DeepCollectionEquality()
                    .equals(other.classification, classification)) &&
            (identical(other.ratingNotes, ratingNotes) ||
                const DeepCollectionEquality()
                    .equals(other.ratingNotes, ratingNotes)) &&
            (identical(other.territoryCode, territoryCode) ||
                const DeepCollectionEquality()
                    .equals(other.territoryCode, territoryCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(classification) ^
      const DeepCollectionEquality().hash(ratingNotes) ^
      const DeepCollectionEquality().hash(territoryCode) ^
      runtimeType.hashCode;
}

extension $RatingExtension on Rating {
  Rating copyWith(
      {String? id,
      String? classification,
      String? ratingNotes,
      String? territoryCode}) {
    return Rating(
        id: id ?? this.id,
        classification: classification ?? this.classification,
        ratingNotes: ratingNotes ?? this.ratingNotes,
        territoryCode: territoryCode ?? this.territoryCode);
  }

  Rating copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? classification,
      Wrapped<String?>? ratingNotes,
      Wrapped<String?>? territoryCode}) {
    return Rating(
        id: (id != null ? id.value : this.id),
        classification: (classification != null
            ? classification.value
            : this.classification),
        ratingNotes:
            (ratingNotes != null ? ratingNotes.value : this.ratingNotes),
        territoryCode:
            (territoryCode != null ? territoryCode.value : this.territoryCode));
  }
}

@JsonSerializable(explicitToJson: true)
class RatingReason {
  RatingReason({
    this.description,
  });

  factory RatingReason.fromJson(Map<String, dynamic> json) =>
      _$RatingReasonFromJson(json);

  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  static const fromJsonFactory = _$RatingReasonFromJson;
  static const toJsonFactory = _$RatingReasonToJson;
  Map<String, dynamic> toJson() => _$RatingReasonToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is RatingReason &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(description) ^ runtimeType.hashCode;
}

extension $RatingReasonExtension on RatingReason {
  RatingReason copyWith({String? description}) {
    return RatingReason(description: description ?? this.description);
  }

  RatingReason copyWithWrapped({Wrapped<String?>? description}) {
    return RatingReason(
        description:
            (description != null ? description.value : this.description));
  }
}

@JsonSerializable(explicitToJson: true)
class ReleaseVersion {
  ReleaseVersion({
    this.id,
    this.releaseId,
    this.aspectRadio,
    this.durationInMinutes,
    this.creditRollTime,
    this.shortTitle,
    this.frameRate,
    this.luminance,
    this.movieFormat,
    this.languages,
    this.resolution,
    this.externalMovieCodes,
    this.soundFormats,
    this.subtitles,
  });

  factory ReleaseVersion.fromJson(Map<String, dynamic> json) =>
      _$ReleaseVersionFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'releaseId', includeIfNull: false, defaultValue: '')
  final String? releaseId;
  @JsonKey(name: 'aspectRadio', includeIfNull: false, defaultValue: '')
  final String? aspectRadio;
  @JsonKey(name: 'durationInMinutes', includeIfNull: false, defaultValue: '')
  final String? durationInMinutes;
  @JsonKey(name: 'creditRollTime', includeIfNull: false, defaultValue: '')
  final String? creditRollTime;
  @JsonKey(name: 'shortTitle', includeIfNull: false, defaultValue: '')
  final String? shortTitle;
  @JsonKey(name: 'frameRate', includeIfNull: false)
  final int? frameRate;
  @JsonKey(name: 'luminance', includeIfNull: false, defaultValue: '')
  final String? luminance;
  @JsonKey(name: 'movieFormat', includeIfNull: false)
  final MovieFormat? movieFormat;
  @JsonKey(name: 'languages', includeIfNull: false, defaultValue: <Language>[])
  final List<Language>? languages;
  @JsonKey(name: 'resolution', includeIfNull: false, defaultValue: '')
  final String? resolution;
  @JsonKey(
      name: 'externalMovieCodes',
      includeIfNull: false,
      defaultValue: <MovieCodeModel>[])
  final List<MovieCodeModel>? externalMovieCodes;
  @JsonKey(
      name: 'soundFormats', includeIfNull: false, defaultValue: <SoundFormat>[])
  final List<SoundFormat>? soundFormats;
  @JsonKey(name: 'subtitles', includeIfNull: false, defaultValue: <Subtitle>[])
  final List<Subtitle>? subtitles;
  static const fromJsonFactory = _$ReleaseVersionFromJson;
  static const toJsonFactory = _$ReleaseVersionToJson;
  Map<String, dynamic> toJson() => _$ReleaseVersionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ReleaseVersion &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.releaseId, releaseId) ||
                const DeepCollectionEquality()
                    .equals(other.releaseId, releaseId)) &&
            (identical(other.aspectRadio, aspectRadio) ||
                const DeepCollectionEquality()
                    .equals(other.aspectRadio, aspectRadio)) &&
            (identical(other.durationInMinutes, durationInMinutes) ||
                const DeepCollectionEquality()
                    .equals(other.durationInMinutes, durationInMinutes)) &&
            (identical(other.creditRollTime, creditRollTime) ||
                const DeepCollectionEquality()
                    .equals(other.creditRollTime, creditRollTime)) &&
            (identical(other.shortTitle, shortTitle) ||
                const DeepCollectionEquality()
                    .equals(other.shortTitle, shortTitle)) &&
            (identical(other.frameRate, frameRate) ||
                const DeepCollectionEquality()
                    .equals(other.frameRate, frameRate)) &&
            (identical(other.luminance, luminance) ||
                const DeepCollectionEquality()
                    .equals(other.luminance, luminance)) &&
            (identical(other.movieFormat, movieFormat) ||
                const DeepCollectionEquality()
                    .equals(other.movieFormat, movieFormat)) &&
            (identical(other.languages, languages) ||
                const DeepCollectionEquality()
                    .equals(other.languages, languages)) &&
            (identical(other.resolution, resolution) ||
                const DeepCollectionEquality()
                    .equals(other.resolution, resolution)) &&
            (identical(other.externalMovieCodes, externalMovieCodes) ||
                const DeepCollectionEquality()
                    .equals(other.externalMovieCodes, externalMovieCodes)) &&
            (identical(other.soundFormats, soundFormats) ||
                const DeepCollectionEquality()
                    .equals(other.soundFormats, soundFormats)) &&
            (identical(other.subtitles, subtitles) ||
                const DeepCollectionEquality()
                    .equals(other.subtitles, subtitles)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(releaseId) ^
      const DeepCollectionEquality().hash(aspectRadio) ^
      const DeepCollectionEquality().hash(durationInMinutes) ^
      const DeepCollectionEquality().hash(creditRollTime) ^
      const DeepCollectionEquality().hash(shortTitle) ^
      const DeepCollectionEquality().hash(frameRate) ^
      const DeepCollectionEquality().hash(luminance) ^
      const DeepCollectionEquality().hash(movieFormat) ^
      const DeepCollectionEquality().hash(languages) ^
      const DeepCollectionEquality().hash(resolution) ^
      const DeepCollectionEquality().hash(externalMovieCodes) ^
      const DeepCollectionEquality().hash(soundFormats) ^
      const DeepCollectionEquality().hash(subtitles) ^
      runtimeType.hashCode;
}

extension $ReleaseVersionExtension on ReleaseVersion {
  ReleaseVersion copyWith(
      {String? id,
      String? releaseId,
      String? aspectRadio,
      String? durationInMinutes,
      String? creditRollTime,
      String? shortTitle,
      int? frameRate,
      String? luminance,
      MovieFormat? movieFormat,
      List<Language>? languages,
      String? resolution,
      List<MovieCodeModel>? externalMovieCodes,
      List<SoundFormat>? soundFormats,
      List<Subtitle>? subtitles}) {
    return ReleaseVersion(
        id: id ?? this.id,
        releaseId: releaseId ?? this.releaseId,
        aspectRadio: aspectRadio ?? this.aspectRadio,
        durationInMinutes: durationInMinutes ?? this.durationInMinutes,
        creditRollTime: creditRollTime ?? this.creditRollTime,
        shortTitle: shortTitle ?? this.shortTitle,
        frameRate: frameRate ?? this.frameRate,
        luminance: luminance ?? this.luminance,
        movieFormat: movieFormat ?? this.movieFormat,
        languages: languages ?? this.languages,
        resolution: resolution ?? this.resolution,
        externalMovieCodes: externalMovieCodes ?? this.externalMovieCodes,
        soundFormats: soundFormats ?? this.soundFormats,
        subtitles: subtitles ?? this.subtitles);
  }

  ReleaseVersion copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? releaseId,
      Wrapped<String?>? aspectRadio,
      Wrapped<String?>? durationInMinutes,
      Wrapped<String?>? creditRollTime,
      Wrapped<String?>? shortTitle,
      Wrapped<int?>? frameRate,
      Wrapped<String?>? luminance,
      Wrapped<MovieFormat?>? movieFormat,
      Wrapped<List<Language>?>? languages,
      Wrapped<String?>? resolution,
      Wrapped<List<MovieCodeModel>?>? externalMovieCodes,
      Wrapped<List<SoundFormat>?>? soundFormats,
      Wrapped<List<Subtitle>?>? subtitles}) {
    return ReleaseVersion(
        id: (id != null ? id.value : this.id),
        releaseId: (releaseId != null ? releaseId.value : this.releaseId),
        aspectRadio:
            (aspectRadio != null ? aspectRadio.value : this.aspectRadio),
        durationInMinutes: (durationInMinutes != null
            ? durationInMinutes.value
            : this.durationInMinutes),
        creditRollTime: (creditRollTime != null
            ? creditRollTime.value
            : this.creditRollTime),
        shortTitle: (shortTitle != null ? shortTitle.value : this.shortTitle),
        frameRate: (frameRate != null ? frameRate.value : this.frameRate),
        luminance: (luminance != null ? luminance.value : this.luminance),
        movieFormat:
            (movieFormat != null ? movieFormat.value : this.movieFormat),
        languages: (languages != null ? languages.value : this.languages),
        resolution: (resolution != null ? resolution.value : this.resolution),
        externalMovieCodes: (externalMovieCodes != null
            ? externalMovieCodes.value
            : this.externalMovieCodes),
        soundFormats:
            (soundFormats != null ? soundFormats.value : this.soundFormats),
        subtitles: (subtitles != null ? subtitles.value : this.subtitles));
  }
}

@JsonSerializable(explicitToJson: true)
class SessionPricingAttributeReadDto {
  SessionPricingAttributeReadDto({
    this.id,
    this.color,
    this.displayName,
    this.attributeShortName,
  });

  factory SessionPricingAttributeReadDto.fromJson(Map<String, dynamic> json) =>
      _$SessionPricingAttributeReadDtoFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'color', includeIfNull: false, defaultValue: '')
  final String? color;
  @JsonKey(name: 'displayName', includeIfNull: false, defaultValue: '')
  final String? displayName;
  @JsonKey(name: 'attributeShortName', includeIfNull: false, defaultValue: '')
  final String? attributeShortName;
  static const fromJsonFactory = _$SessionPricingAttributeReadDtoFromJson;
  static const toJsonFactory = _$SessionPricingAttributeReadDtoToJson;
  Map<String, dynamic> toJson() => _$SessionPricingAttributeReadDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SessionPricingAttributeReadDto &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.color, color) ||
                const DeepCollectionEquality().equals(other.color, color)) &&
            (identical(other.displayName, displayName) ||
                const DeepCollectionEquality()
                    .equals(other.displayName, displayName)) &&
            (identical(other.attributeShortName, attributeShortName) ||
                const DeepCollectionEquality()
                    .equals(other.attributeShortName, attributeShortName)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(color) ^
      const DeepCollectionEquality().hash(displayName) ^
      const DeepCollectionEquality().hash(attributeShortName) ^
      runtimeType.hashCode;
}

extension $SessionPricingAttributeReadDtoExtension
    on SessionPricingAttributeReadDto {
  SessionPricingAttributeReadDto copyWith(
      {String? id,
      String? color,
      String? displayName,
      String? attributeShortName}) {
    return SessionPricingAttributeReadDto(
        id: id ?? this.id,
        color: color ?? this.color,
        displayName: displayName ?? this.displayName,
        attributeShortName: attributeShortName ?? this.attributeShortName);
  }

  SessionPricingAttributeReadDto copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? color,
      Wrapped<String?>? displayName,
      Wrapped<String?>? attributeShortName}) {
    return SessionPricingAttributeReadDto(
        id: (id != null ? id.value : this.id),
        color: (color != null ? color.value : this.color),
        displayName:
            (displayName != null ? displayName.value : this.displayName),
        attributeShortName: (attributeShortName != null
            ? attributeShortName.value
            : this.attributeShortName));
  }
}

@JsonSerializable(explicitToJson: true)
class SessionPricingAttributeReadDtoListBaseResponseDto {
  SessionPricingAttributeReadDtoListBaseResponseDto({
    this.result,
    this.responseCode,
    this.errorMessage,
  });

  factory SessionPricingAttributeReadDtoListBaseResponseDto.fromJson(
          Map<String, dynamic> json) =>
      _$SessionPricingAttributeReadDtoListBaseResponseDtoFromJson(json);

  @JsonKey(
      name: 'result',
      includeIfNull: false,
      defaultValue: <SessionPricingAttributeReadDto>[])
  final List<SessionPricingAttributeReadDto>? result;
  @JsonKey(
    name: 'responseCode',
    includeIfNull: false,
    toJson: errorCodeToJson,
    fromJson: errorCodeFromJson,
  )
  final enums.ErrorCode? responseCode;
  @JsonKey(name: 'errorMessage', includeIfNull: false, defaultValue: '')
  final String? errorMessage;
  static const fromJsonFactory =
      _$SessionPricingAttributeReadDtoListBaseResponseDtoFromJson;
  static const toJsonFactory =
      _$SessionPricingAttributeReadDtoListBaseResponseDtoToJson;
  Map<String, dynamic> toJson() =>
      _$SessionPricingAttributeReadDtoListBaseResponseDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SessionPricingAttributeReadDtoListBaseResponseDto &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.responseCode, responseCode) ||
                const DeepCollectionEquality()
                    .equals(other.responseCode, responseCode)) &&
            (identical(other.errorMessage, errorMessage) ||
                const DeepCollectionEquality()
                    .equals(other.errorMessage, errorMessage)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(result) ^
      const DeepCollectionEquality().hash(responseCode) ^
      const DeepCollectionEquality().hash(errorMessage) ^
      runtimeType.hashCode;
}

extension $SessionPricingAttributeReadDtoListBaseResponseDtoExtension
    on SessionPricingAttributeReadDtoListBaseResponseDto {
  SessionPricingAttributeReadDtoListBaseResponseDto copyWith(
      {List<SessionPricingAttributeReadDto>? result,
      enums.ErrorCode? responseCode,
      String? errorMessage}) {
    return SessionPricingAttributeReadDtoListBaseResponseDto(
        result: result ?? this.result,
        responseCode: responseCode ?? this.responseCode,
        errorMessage: errorMessage ?? this.errorMessage);
  }

  SessionPricingAttributeReadDtoListBaseResponseDto copyWithWrapped(
      {Wrapped<List<SessionPricingAttributeReadDto>?>? result,
      Wrapped<enums.ErrorCode?>? responseCode,
      Wrapped<String?>? errorMessage}) {
    return SessionPricingAttributeReadDtoListBaseResponseDto(
        result: (result != null ? result.value : this.result),
        responseCode:
            (responseCode != null ? responseCode.value : this.responseCode),
        errorMessage:
            (errorMessage != null ? errorMessage.value : this.errorMessage));
  }
}

@JsonSerializable(explicitToJson: true)
class ShowingAttributeReadDto {
  ShowingAttributeReadDto({
    this.name,
    this.attributeType,
    this.shortName,
    this.value,
  });

  factory ShowingAttributeReadDto.fromJson(Map<String, dynamic> json) =>
      _$ShowingAttributeReadDtoFromJson(json);

  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'attributeType', includeIfNull: false, defaultValue: '')
  final String? attributeType;
  @JsonKey(name: 'shortName', includeIfNull: false, defaultValue: '')
  final String? shortName;
  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String? value;
  static const fromJsonFactory = _$ShowingAttributeReadDtoFromJson;
  static const toJsonFactory = _$ShowingAttributeReadDtoToJson;
  Map<String, dynamic> toJson() => _$ShowingAttributeReadDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ShowingAttributeReadDto &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.attributeType, attributeType) ||
                const DeepCollectionEquality()
                    .equals(other.attributeType, attributeType)) &&
            (identical(other.shortName, shortName) ||
                const DeepCollectionEquality()
                    .equals(other.shortName, shortName)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(attributeType) ^
      const DeepCollectionEquality().hash(shortName) ^
      const DeepCollectionEquality().hash(value) ^
      runtimeType.hashCode;
}

extension $ShowingAttributeReadDtoExtension on ShowingAttributeReadDto {
  ShowingAttributeReadDto copyWith(
      {String? name, String? attributeType, String? shortName, String? value}) {
    return ShowingAttributeReadDto(
        name: name ?? this.name,
        attributeType: attributeType ?? this.attributeType,
        shortName: shortName ?? this.shortName,
        value: value ?? this.value);
  }

  ShowingAttributeReadDto copyWithWrapped(
      {Wrapped<String?>? name,
      Wrapped<String?>? attributeType,
      Wrapped<String?>? shortName,
      Wrapped<String?>? value}) {
    return ShowingAttributeReadDto(
        name: (name != null ? name.value : this.name),
        attributeType:
            (attributeType != null ? attributeType.value : this.attributeType),
        shortName: (shortName != null ? shortName.value : this.shortName),
        value: (value != null ? value.value : this.value));
  }
}

@JsonSerializable(explicitToJson: true)
class ShowingAttributeReadDtoListBaseResponseDto {
  ShowingAttributeReadDtoListBaseResponseDto({
    this.result,
    this.responseCode,
    this.errorMessage,
  });

  factory ShowingAttributeReadDtoListBaseResponseDto.fromJson(
          Map<String, dynamic> json) =>
      _$ShowingAttributeReadDtoListBaseResponseDtoFromJson(json);

  @JsonKey(
      name: 'result',
      includeIfNull: false,
      defaultValue: <ShowingAttributeReadDto>[])
  final List<ShowingAttributeReadDto>? result;
  @JsonKey(
    name: 'responseCode',
    includeIfNull: false,
    toJson: errorCodeToJson,
    fromJson: errorCodeFromJson,
  )
  final enums.ErrorCode? responseCode;
  @JsonKey(name: 'errorMessage', includeIfNull: false, defaultValue: '')
  final String? errorMessage;
  static const fromJsonFactory =
      _$ShowingAttributeReadDtoListBaseResponseDtoFromJson;
  static const toJsonFactory =
      _$ShowingAttributeReadDtoListBaseResponseDtoToJson;
  Map<String, dynamic> toJson() =>
      _$ShowingAttributeReadDtoListBaseResponseDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ShowingAttributeReadDtoListBaseResponseDto &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.responseCode, responseCode) ||
                const DeepCollectionEquality()
                    .equals(other.responseCode, responseCode)) &&
            (identical(other.errorMessage, errorMessage) ||
                const DeepCollectionEquality()
                    .equals(other.errorMessage, errorMessage)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(result) ^
      const DeepCollectionEquality().hash(responseCode) ^
      const DeepCollectionEquality().hash(errorMessage) ^
      runtimeType.hashCode;
}

extension $ShowingAttributeReadDtoListBaseResponseDtoExtension
    on ShowingAttributeReadDtoListBaseResponseDto {
  ShowingAttributeReadDtoListBaseResponseDto copyWith(
      {List<ShowingAttributeReadDto>? result,
      enums.ErrorCode? responseCode,
      String? errorMessage}) {
    return ShowingAttributeReadDtoListBaseResponseDto(
        result: result ?? this.result,
        responseCode: responseCode ?? this.responseCode,
        errorMessage: errorMessage ?? this.errorMessage);
  }

  ShowingAttributeReadDtoListBaseResponseDto copyWithWrapped(
      {Wrapped<List<ShowingAttributeReadDto>?>? result,
      Wrapped<enums.ErrorCode?>? responseCode,
      Wrapped<String?>? errorMessage}) {
    return ShowingAttributeReadDtoListBaseResponseDto(
        result: (result != null ? result.value : this.result),
        responseCode:
            (responseCode != null ? responseCode.value : this.responseCode),
        errorMessage:
            (errorMessage != null ? errorMessage.value : this.errorMessage));
  }
}

@JsonSerializable(explicitToJson: true)
class ShowingDateReadDto {
  ShowingDateReadDto({
    this.showingDate,
    this.hasShowings,
    this.datePrefix,
  });

  factory ShowingDateReadDto.fromJson(Map<String, dynamic> json) =>
      _$ShowingDateReadDtoFromJson(json);

  @JsonKey(name: 'showingDate', includeIfNull: false, defaultValue: '')
  final String? showingDate;
  @JsonKey(name: 'hasShowings', includeIfNull: false)
  final bool? hasShowings;
  @JsonKey(name: 'datePrefix', includeIfNull: false, defaultValue: '')
  final String? datePrefix;
  static const fromJsonFactory = _$ShowingDateReadDtoFromJson;
  static const toJsonFactory = _$ShowingDateReadDtoToJson;
  Map<String, dynamic> toJson() => _$ShowingDateReadDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ShowingDateReadDto &&
            (identical(other.showingDate, showingDate) ||
                const DeepCollectionEquality()
                    .equals(other.showingDate, showingDate)) &&
            (identical(other.hasShowings, hasShowings) ||
                const DeepCollectionEquality()
                    .equals(other.hasShowings, hasShowings)) &&
            (identical(other.datePrefix, datePrefix) ||
                const DeepCollectionEquality()
                    .equals(other.datePrefix, datePrefix)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(showingDate) ^
      const DeepCollectionEquality().hash(hasShowings) ^
      const DeepCollectionEquality().hash(datePrefix) ^
      runtimeType.hashCode;
}

extension $ShowingDateReadDtoExtension on ShowingDateReadDto {
  ShowingDateReadDto copyWith(
      {String? showingDate, bool? hasShowings, String? datePrefix}) {
    return ShowingDateReadDto(
        showingDate: showingDate ?? this.showingDate,
        hasShowings: hasShowings ?? this.hasShowings,
        datePrefix: datePrefix ?? this.datePrefix);
  }

  ShowingDateReadDto copyWithWrapped(
      {Wrapped<String?>? showingDate,
      Wrapped<bool?>? hasShowings,
      Wrapped<String?>? datePrefix}) {
    return ShowingDateReadDto(
        showingDate:
            (showingDate != null ? showingDate.value : this.showingDate),
        hasShowings:
            (hasShowings != null ? hasShowings.value : this.hasShowings),
        datePrefix: (datePrefix != null ? datePrefix.value : this.datePrefix));
  }
}

@JsonSerializable(explicitToJson: true)
class ShowingDateReadDtoListBaseResponseDto {
  ShowingDateReadDtoListBaseResponseDto({
    this.result,
    this.responseCode,
    this.errorMessage,
  });

  factory ShowingDateReadDtoListBaseResponseDto.fromJson(
          Map<String, dynamic> json) =>
      _$ShowingDateReadDtoListBaseResponseDtoFromJson(json);

  @JsonKey(
      name: 'result',
      includeIfNull: false,
      defaultValue: <ShowingDateReadDto>[])
  final List<ShowingDateReadDto>? result;
  @JsonKey(
    name: 'responseCode',
    includeIfNull: false,
    toJson: errorCodeToJson,
    fromJson: errorCodeFromJson,
  )
  final enums.ErrorCode? responseCode;
  @JsonKey(name: 'errorMessage', includeIfNull: false, defaultValue: '')
  final String? errorMessage;
  static const fromJsonFactory =
      _$ShowingDateReadDtoListBaseResponseDtoFromJson;
  static const toJsonFactory = _$ShowingDateReadDtoListBaseResponseDtoToJson;
  Map<String, dynamic> toJson() =>
      _$ShowingDateReadDtoListBaseResponseDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ShowingDateReadDtoListBaseResponseDto &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.responseCode, responseCode) ||
                const DeepCollectionEquality()
                    .equals(other.responseCode, responseCode)) &&
            (identical(other.errorMessage, errorMessage) ||
                const DeepCollectionEquality()
                    .equals(other.errorMessage, errorMessage)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(result) ^
      const DeepCollectionEquality().hash(responseCode) ^
      const DeepCollectionEquality().hash(errorMessage) ^
      runtimeType.hashCode;
}

extension $ShowingDateReadDtoListBaseResponseDtoExtension
    on ShowingDateReadDtoListBaseResponseDto {
  ShowingDateReadDtoListBaseResponseDto copyWith(
      {List<ShowingDateReadDto>? result,
      enums.ErrorCode? responseCode,
      String? errorMessage}) {
    return ShowingDateReadDtoListBaseResponseDto(
        result: result ?? this.result,
        responseCode: responseCode ?? this.responseCode,
        errorMessage: errorMessage ?? this.errorMessage);
  }

  ShowingDateReadDtoListBaseResponseDto copyWithWrapped(
      {Wrapped<List<ShowingDateReadDto>?>? result,
      Wrapped<enums.ErrorCode?>? responseCode,
      Wrapped<String?>? errorMessage}) {
    return ShowingDateReadDtoListBaseResponseDto(
        result: (result != null ? result.value : this.result),
        responseCode:
            (responseCode != null ? responseCode.value : this.responseCode),
        errorMessage:
            (errorMessage != null ? errorMessage.value : this.errorMessage));
  }
}

@JsonSerializable(explicitToJson: true)
class ShowingGroupReadDto {
  ShowingGroupReadDto({
    this.date,
    this.datePrefix,
    this.pricingTypes,
    this.sessions,
  });

  factory ShowingGroupReadDto.fromJson(Map<String, dynamic> json) =>
      _$ShowingGroupReadDtoFromJson(json);

  @JsonKey(name: 'date', includeIfNull: false, defaultValue: '')
  final String? date;
  @JsonKey(name: 'datePrefix', includeIfNull: false, defaultValue: '')
  final String? datePrefix;
  @JsonKey(
      name: 'pricingTypes',
      includeIfNull: false,
      defaultValue: <PricingTypeDto>[])
  final List<PricingTypeDto>? pricingTypes;
  @JsonKey(
      name: 'sessions',
      includeIfNull: false,
      defaultValue: <ShowingSessionGroup>[])
  final List<ShowingSessionGroup>? sessions;
  static const fromJsonFactory = _$ShowingGroupReadDtoFromJson;
  static const toJsonFactory = _$ShowingGroupReadDtoToJson;
  Map<String, dynamic> toJson() => _$ShowingGroupReadDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ShowingGroupReadDto &&
            (identical(other.date, date) ||
                const DeepCollectionEquality().equals(other.date, date)) &&
            (identical(other.datePrefix, datePrefix) ||
                const DeepCollectionEquality()
                    .equals(other.datePrefix, datePrefix)) &&
            (identical(other.pricingTypes, pricingTypes) ||
                const DeepCollectionEquality()
                    .equals(other.pricingTypes, pricingTypes)) &&
            (identical(other.sessions, sessions) ||
                const DeepCollectionEquality()
                    .equals(other.sessions, sessions)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(date) ^
      const DeepCollectionEquality().hash(datePrefix) ^
      const DeepCollectionEquality().hash(pricingTypes) ^
      const DeepCollectionEquality().hash(sessions) ^
      runtimeType.hashCode;
}

extension $ShowingGroupReadDtoExtension on ShowingGroupReadDto {
  ShowingGroupReadDto copyWith(
      {String? date,
      String? datePrefix,
      List<PricingTypeDto>? pricingTypes,
      List<ShowingSessionGroup>? sessions}) {
    return ShowingGroupReadDto(
        date: date ?? this.date,
        datePrefix: datePrefix ?? this.datePrefix,
        pricingTypes: pricingTypes ?? this.pricingTypes,
        sessions: sessions ?? this.sessions);
  }

  ShowingGroupReadDto copyWithWrapped(
      {Wrapped<String?>? date,
      Wrapped<String?>? datePrefix,
      Wrapped<List<PricingTypeDto>?>? pricingTypes,
      Wrapped<List<ShowingSessionGroup>?>? sessions}) {
    return ShowingGroupReadDto(
        date: (date != null ? date.value : this.date),
        datePrefix: (datePrefix != null ? datePrefix.value : this.datePrefix),
        pricingTypes:
            (pricingTypes != null ? pricingTypes.value : this.pricingTypes),
        sessions: (sessions != null ? sessions.value : this.sessions));
  }
}

@JsonSerializable(explicitToJson: true)
class ShowingGroupReadDtoListBaseResponseDto {
  ShowingGroupReadDtoListBaseResponseDto({
    this.result,
    this.responseCode,
    this.errorMessage,
  });

  factory ShowingGroupReadDtoListBaseResponseDto.fromJson(
          Map<String, dynamic> json) =>
      _$ShowingGroupReadDtoListBaseResponseDtoFromJson(json);

  @JsonKey(
      name: 'result',
      includeIfNull: false,
      defaultValue: <ShowingGroupReadDto>[])
  final List<ShowingGroupReadDto>? result;
  @JsonKey(
    name: 'responseCode',
    includeIfNull: false,
    toJson: errorCodeToJson,
    fromJson: errorCodeFromJson,
  )
  final enums.ErrorCode? responseCode;
  @JsonKey(name: 'errorMessage', includeIfNull: false, defaultValue: '')
  final String? errorMessage;
  static const fromJsonFactory =
      _$ShowingGroupReadDtoListBaseResponseDtoFromJson;
  static const toJsonFactory = _$ShowingGroupReadDtoListBaseResponseDtoToJson;
  Map<String, dynamic> toJson() =>
      _$ShowingGroupReadDtoListBaseResponseDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ShowingGroupReadDtoListBaseResponseDto &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.responseCode, responseCode) ||
                const DeepCollectionEquality()
                    .equals(other.responseCode, responseCode)) &&
            (identical(other.errorMessage, errorMessage) ||
                const DeepCollectionEquality()
                    .equals(other.errorMessage, errorMessage)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(result) ^
      const DeepCollectionEquality().hash(responseCode) ^
      const DeepCollectionEquality().hash(errorMessage) ^
      runtimeType.hashCode;
}

extension $ShowingGroupReadDtoListBaseResponseDtoExtension
    on ShowingGroupReadDtoListBaseResponseDto {
  ShowingGroupReadDtoListBaseResponseDto copyWith(
      {List<ShowingGroupReadDto>? result,
      enums.ErrorCode? responseCode,
      String? errorMessage}) {
    return ShowingGroupReadDtoListBaseResponseDto(
        result: result ?? this.result,
        responseCode: responseCode ?? this.responseCode,
        errorMessage: errorMessage ?? this.errorMessage);
  }

  ShowingGroupReadDtoListBaseResponseDto copyWithWrapped(
      {Wrapped<List<ShowingGroupReadDto>?>? result,
      Wrapped<enums.ErrorCode?>? responseCode,
      Wrapped<String?>? errorMessage}) {
    return ShowingGroupReadDtoListBaseResponseDto(
        result: (result != null ? result.value : this.result),
        responseCode:
            (responseCode != null ? responseCode.value : this.responseCode),
        errorMessage:
            (errorMessage != null ? errorMessage.value : this.errorMessage));
  }
}

@JsonSerializable(explicitToJson: true)
class ShowingReadDto {
  ShowingReadDto({
    this.ediFilmId,
    this.url,
    this.posterUrl,
    this.panelImageUrl,
    this.priority,
    this.title,
    this.certificate,
    this.advice,
    this.secondaryCertificate,
    this.secondaryAdvice,
    this.isEvent,
    this.isComingSoon,
    this.duration,
    this.embargoUntil,
    this.embargoMessage,
    this.onSaleDateVisibility,
    this.releaseDate,
    this.showTime,
    this.sessionBusinessDate,
    this.isMidnightShowing,
  });

  factory ShowingReadDto.fromJson(Map<String, dynamic> json) =>
      _$ShowingReadDtoFromJson(json);

  @JsonKey(name: 'ediFilmId', includeIfNull: false, defaultValue: '')
  final String? ediFilmId;
  @JsonKey(name: 'url', includeIfNull: false, defaultValue: '')
  final String? url;
  @JsonKey(name: 'posterUrl', includeIfNull: false, defaultValue: '')
  final String? posterUrl;
  @JsonKey(name: 'panelImageUrl', includeIfNull: false, defaultValue: '')
  final String? panelImageUrl;
  @JsonKey(name: 'priority', includeIfNull: false)
  final int? priority;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'certificate', includeIfNull: false, defaultValue: '')
  final String? certificate;
  @JsonKey(name: 'advice', includeIfNull: false, defaultValue: '')
  final String? advice;
  @JsonKey(name: 'secondaryCertificate', includeIfNull: false, defaultValue: '')
  final String? secondaryCertificate;
  @JsonKey(name: 'secondaryAdvice', includeIfNull: false, defaultValue: '')
  final String? secondaryAdvice;
  @JsonKey(name: 'isEvent', includeIfNull: false)
  final bool? isEvent;
  @JsonKey(name: 'isComingSoon', includeIfNull: false)
  final bool? isComingSoon;
  @JsonKey(name: 'duration', includeIfNull: false)
  final int? duration;
  @JsonKey(name: 'embargoUntil', includeIfNull: false, defaultValue: '')
  final String? embargoUntil;
  @JsonKey(name: 'embargoMessage', includeIfNull: false, defaultValue: '')
  final String? embargoMessage;
  @JsonKey(name: 'onSaleDateVisibility', includeIfNull: false)
  final bool? onSaleDateVisibility;
  @JsonKey(name: 'releaseDate', includeIfNull: false, defaultValue: '')
  final String? releaseDate;
  @JsonKey(name: 'showTime', includeIfNull: false, defaultValue: '')
  final String? showTime;
  @JsonKey(name: 'sessionBusinessDate', includeIfNull: false, defaultValue: '')
  final String? sessionBusinessDate;
  @JsonKey(name: 'isMidnightShowing', includeIfNull: false)
  final bool? isMidnightShowing;
  static const fromJsonFactory = _$ShowingReadDtoFromJson;
  static const toJsonFactory = _$ShowingReadDtoToJson;
  Map<String, dynamic> toJson() => _$ShowingReadDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ShowingReadDto &&
            (identical(other.ediFilmId, ediFilmId) ||
                const DeepCollectionEquality()
                    .equals(other.ediFilmId, ediFilmId)) &&
            (identical(other.url, url) ||
                const DeepCollectionEquality().equals(other.url, url)) &&
            (identical(other.posterUrl, posterUrl) ||
                const DeepCollectionEquality()
                    .equals(other.posterUrl, posterUrl)) &&
            (identical(other.panelImageUrl, panelImageUrl) ||
                const DeepCollectionEquality()
                    .equals(other.panelImageUrl, panelImageUrl)) &&
            (identical(other.priority, priority) ||
                const DeepCollectionEquality()
                    .equals(other.priority, priority)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.certificate, certificate) ||
                const DeepCollectionEquality()
                    .equals(other.certificate, certificate)) &&
            (identical(other.advice, advice) ||
                const DeepCollectionEquality().equals(other.advice, advice)) &&
            (identical(other.secondaryCertificate, secondaryCertificate) ||
                const DeepCollectionEquality().equals(
                    other.secondaryCertificate, secondaryCertificate)) &&
            (identical(other.secondaryAdvice, secondaryAdvice) ||
                const DeepCollectionEquality()
                    .equals(other.secondaryAdvice, secondaryAdvice)) &&
            (identical(other.isEvent, isEvent) ||
                const DeepCollectionEquality()
                    .equals(other.isEvent, isEvent)) &&
            (identical(other.isComingSoon, isComingSoon) ||
                const DeepCollectionEquality()
                    .equals(other.isComingSoon, isComingSoon)) &&
            (identical(other.duration, duration) ||
                const DeepCollectionEquality()
                    .equals(other.duration, duration)) &&
            (identical(other.embargoUntil, embargoUntil) ||
                const DeepCollectionEquality()
                    .equals(other.embargoUntil, embargoUntil)) &&
            (identical(other.embargoMessage, embargoMessage) ||
                const DeepCollectionEquality()
                    .equals(other.embargoMessage, embargoMessage)) &&
            (identical(other.onSaleDateVisibility, onSaleDateVisibility) ||
                const DeepCollectionEquality().equals(
                    other.onSaleDateVisibility, onSaleDateVisibility)) &&
            (identical(other.releaseDate, releaseDate) ||
                const DeepCollectionEquality()
                    .equals(other.releaseDate, releaseDate)) &&
            (identical(other.showTime, showTime) ||
                const DeepCollectionEquality()
                    .equals(other.showTime, showTime)) &&
            (identical(other.sessionBusinessDate, sessionBusinessDate) ||
                const DeepCollectionEquality()
                    .equals(other.sessionBusinessDate, sessionBusinessDate)) &&
            (identical(other.isMidnightShowing, isMidnightShowing) ||
                const DeepCollectionEquality()
                    .equals(other.isMidnightShowing, isMidnightShowing)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(ediFilmId) ^
      const DeepCollectionEquality().hash(url) ^
      const DeepCollectionEquality().hash(posterUrl) ^
      const DeepCollectionEquality().hash(panelImageUrl) ^
      const DeepCollectionEquality().hash(priority) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(certificate) ^
      const DeepCollectionEquality().hash(advice) ^
      const DeepCollectionEquality().hash(secondaryCertificate) ^
      const DeepCollectionEquality().hash(secondaryAdvice) ^
      const DeepCollectionEquality().hash(isEvent) ^
      const DeepCollectionEquality().hash(isComingSoon) ^
      const DeepCollectionEquality().hash(duration) ^
      const DeepCollectionEquality().hash(embargoUntil) ^
      const DeepCollectionEquality().hash(embargoMessage) ^
      const DeepCollectionEquality().hash(onSaleDateVisibility) ^
      const DeepCollectionEquality().hash(releaseDate) ^
      const DeepCollectionEquality().hash(showTime) ^
      const DeepCollectionEquality().hash(sessionBusinessDate) ^
      const DeepCollectionEquality().hash(isMidnightShowing) ^
      runtimeType.hashCode;
}

extension $ShowingReadDtoExtension on ShowingReadDto {
  ShowingReadDto copyWith(
      {String? ediFilmId,
      String? url,
      String? posterUrl,
      String? panelImageUrl,
      int? priority,
      String? title,
      String? certificate,
      String? advice,
      String? secondaryCertificate,
      String? secondaryAdvice,
      bool? isEvent,
      bool? isComingSoon,
      int? duration,
      String? embargoUntil,
      String? embargoMessage,
      bool? onSaleDateVisibility,
      String? releaseDate,
      String? showTime,
      String? sessionBusinessDate,
      bool? isMidnightShowing}) {
    return ShowingReadDto(
        ediFilmId: ediFilmId ?? this.ediFilmId,
        url: url ?? this.url,
        posterUrl: posterUrl ?? this.posterUrl,
        panelImageUrl: panelImageUrl ?? this.panelImageUrl,
        priority: priority ?? this.priority,
        title: title ?? this.title,
        certificate: certificate ?? this.certificate,
        advice: advice ?? this.advice,
        secondaryCertificate: secondaryCertificate ?? this.secondaryCertificate,
        secondaryAdvice: secondaryAdvice ?? this.secondaryAdvice,
        isEvent: isEvent ?? this.isEvent,
        isComingSoon: isComingSoon ?? this.isComingSoon,
        duration: duration ?? this.duration,
        embargoUntil: embargoUntil ?? this.embargoUntil,
        embargoMessage: embargoMessage ?? this.embargoMessage,
        onSaleDateVisibility: onSaleDateVisibility ?? this.onSaleDateVisibility,
        releaseDate: releaseDate ?? this.releaseDate,
        showTime: showTime ?? this.showTime,
        sessionBusinessDate: sessionBusinessDate ?? this.sessionBusinessDate,
        isMidnightShowing: isMidnightShowing ?? this.isMidnightShowing);
  }

  ShowingReadDto copyWithWrapped(
      {Wrapped<String?>? ediFilmId,
      Wrapped<String?>? url,
      Wrapped<String?>? posterUrl,
      Wrapped<String?>? panelImageUrl,
      Wrapped<int?>? priority,
      Wrapped<String?>? title,
      Wrapped<String?>? certificate,
      Wrapped<String?>? advice,
      Wrapped<String?>? secondaryCertificate,
      Wrapped<String?>? secondaryAdvice,
      Wrapped<bool?>? isEvent,
      Wrapped<bool?>? isComingSoon,
      Wrapped<int?>? duration,
      Wrapped<String?>? embargoUntil,
      Wrapped<String?>? embargoMessage,
      Wrapped<bool?>? onSaleDateVisibility,
      Wrapped<String?>? releaseDate,
      Wrapped<String?>? showTime,
      Wrapped<String?>? sessionBusinessDate,
      Wrapped<bool?>? isMidnightShowing}) {
    return ShowingReadDto(
        ediFilmId: (ediFilmId != null ? ediFilmId.value : this.ediFilmId),
        url: (url != null ? url.value : this.url),
        posterUrl: (posterUrl != null ? posterUrl.value : this.posterUrl),
        panelImageUrl:
            (panelImageUrl != null ? panelImageUrl.value : this.panelImageUrl),
        priority: (priority != null ? priority.value : this.priority),
        title: (title != null ? title.value : this.title),
        certificate:
            (certificate != null ? certificate.value : this.certificate),
        advice: (advice != null ? advice.value : this.advice),
        secondaryCertificate: (secondaryCertificate != null
            ? secondaryCertificate.value
            : this.secondaryCertificate),
        secondaryAdvice: (secondaryAdvice != null
            ? secondaryAdvice.value
            : this.secondaryAdvice),
        isEvent: (isEvent != null ? isEvent.value : this.isEvent),
        isComingSoon:
            (isComingSoon != null ? isComingSoon.value : this.isComingSoon),
        duration: (duration != null ? duration.value : this.duration),
        embargoUntil:
            (embargoUntil != null ? embargoUntil.value : this.embargoUntil),
        embargoMessage: (embargoMessage != null
            ? embargoMessage.value
            : this.embargoMessage),
        onSaleDateVisibility: (onSaleDateVisibility != null
            ? onSaleDateVisibility.value
            : this.onSaleDateVisibility),
        releaseDate:
            (releaseDate != null ? releaseDate.value : this.releaseDate),
        showTime: (showTime != null ? showTime.value : this.showTime),
        sessionBusinessDate: (sessionBusinessDate != null
            ? sessionBusinessDate.value
            : this.sessionBusinessDate),
        isMidnightShowing: (isMidnightShowing != null
            ? isMidnightShowing.value
            : this.isMidnightShowing));
  }
}

@JsonSerializable(explicitToJson: true)
class ShowingReadDtoListBaseResponseDto {
  ShowingReadDtoListBaseResponseDto({
    this.result,
    this.responseCode,
    this.errorMessage,
  });

  factory ShowingReadDtoListBaseResponseDto.fromJson(
          Map<String, dynamic> json) =>
      _$ShowingReadDtoListBaseResponseDtoFromJson(json);

  @JsonKey(
      name: 'result', includeIfNull: false, defaultValue: <ShowingReadDto>[])
  final List<ShowingReadDto>? result;
  @JsonKey(
    name: 'responseCode',
    includeIfNull: false,
    toJson: errorCodeToJson,
    fromJson: errorCodeFromJson,
  )
  final enums.ErrorCode? responseCode;
  @JsonKey(name: 'errorMessage', includeIfNull: false, defaultValue: '')
  final String? errorMessage;
  static const fromJsonFactory = _$ShowingReadDtoListBaseResponseDtoFromJson;
  static const toJsonFactory = _$ShowingReadDtoListBaseResponseDtoToJson;
  Map<String, dynamic> toJson() =>
      _$ShowingReadDtoListBaseResponseDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ShowingReadDtoListBaseResponseDto &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.responseCode, responseCode) ||
                const DeepCollectionEquality()
                    .equals(other.responseCode, responseCode)) &&
            (identical(other.errorMessage, errorMessage) ||
                const DeepCollectionEquality()
                    .equals(other.errorMessage, errorMessage)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(result) ^
      const DeepCollectionEquality().hash(responseCode) ^
      const DeepCollectionEquality().hash(errorMessage) ^
      runtimeType.hashCode;
}

extension $ShowingReadDtoListBaseResponseDtoExtension
    on ShowingReadDtoListBaseResponseDto {
  ShowingReadDtoListBaseResponseDto copyWith(
      {List<ShowingReadDto>? result,
      enums.ErrorCode? responseCode,
      String? errorMessage}) {
    return ShowingReadDtoListBaseResponseDto(
        result: result ?? this.result,
        responseCode: responseCode ?? this.responseCode,
        errorMessage: errorMessage ?? this.errorMessage);
  }

  ShowingReadDtoListBaseResponseDto copyWithWrapped(
      {Wrapped<List<ShowingReadDto>?>? result,
      Wrapped<enums.ErrorCode?>? responseCode,
      Wrapped<String?>? errorMessage}) {
    return ShowingReadDtoListBaseResponseDto(
        result: (result != null ? result.value : this.result),
        responseCode:
            (responseCode != null ? responseCode.value : this.responseCode),
        errorMessage:
            (errorMessage != null ? errorMessage.value : this.errorMessage));
  }
}

@JsonSerializable(explicitToJson: true)
class ShowingSessionGroup {
  ShowingSessionGroup({
    this.sessionId,
    this.bookingUrl,
    this.formattedPrice,
    this.startTime,
    this.endTime,
    this.isSoldOut,
    this.attributes,
    this.color,
    this.isMidnightSession,
  });

  factory ShowingSessionGroup.fromJson(Map<String, dynamic> json) =>
      _$ShowingSessionGroupFromJson(json);

  @JsonKey(name: 'sessionId', includeIfNull: false, defaultValue: '')
  final String? sessionId;
  @JsonKey(name: 'bookingUrl', includeIfNull: false, defaultValue: '')
  final String? bookingUrl;
  @JsonKey(name: 'formattedPrice', includeIfNull: false, defaultValue: '')
  final String? formattedPrice;
  @JsonKey(name: 'startTime', includeIfNull: false, defaultValue: '')
  final String? startTime;
  @JsonKey(name: 'endTime', includeIfNull: false, defaultValue: '')
  final String? endTime;
  @JsonKey(name: 'isSoldOut', includeIfNull: false)
  final bool? isSoldOut;
  @JsonKey(
      name: 'attributes',
      includeIfNull: false,
      defaultValue: <ShowingAttributeReadDto>[])
  final List<ShowingAttributeReadDto>? attributes;
  @JsonKey(name: 'color', includeIfNull: false, defaultValue: '')
  final String? color;
  @JsonKey(name: 'isMidnightSession', includeIfNull: false)
  final bool? isMidnightSession;
  static const fromJsonFactory = _$ShowingSessionGroupFromJson;
  static const toJsonFactory = _$ShowingSessionGroupToJson;
  Map<String, dynamic> toJson() => _$ShowingSessionGroupToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ShowingSessionGroup &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.bookingUrl, bookingUrl) ||
                const DeepCollectionEquality()
                    .equals(other.bookingUrl, bookingUrl)) &&
            (identical(other.formattedPrice, formattedPrice) ||
                const DeepCollectionEquality()
                    .equals(other.formattedPrice, formattedPrice)) &&
            (identical(other.startTime, startTime) ||
                const DeepCollectionEquality()
                    .equals(other.startTime, startTime)) &&
            (identical(other.endTime, endTime) ||
                const DeepCollectionEquality()
                    .equals(other.endTime, endTime)) &&
            (identical(other.isSoldOut, isSoldOut) ||
                const DeepCollectionEquality()
                    .equals(other.isSoldOut, isSoldOut)) &&
            (identical(other.attributes, attributes) ||
                const DeepCollectionEquality()
                    .equals(other.attributes, attributes)) &&
            (identical(other.color, color) ||
                const DeepCollectionEquality().equals(other.color, color)) &&
            (identical(other.isMidnightSession, isMidnightSession) ||
                const DeepCollectionEquality()
                    .equals(other.isMidnightSession, isMidnightSession)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(sessionId) ^
      const DeepCollectionEquality().hash(bookingUrl) ^
      const DeepCollectionEquality().hash(formattedPrice) ^
      const DeepCollectionEquality().hash(startTime) ^
      const DeepCollectionEquality().hash(endTime) ^
      const DeepCollectionEquality().hash(isSoldOut) ^
      const DeepCollectionEquality().hash(attributes) ^
      const DeepCollectionEquality().hash(color) ^
      const DeepCollectionEquality().hash(isMidnightSession) ^
      runtimeType.hashCode;
}

extension $ShowingSessionGroupExtension on ShowingSessionGroup {
  ShowingSessionGroup copyWith(
      {String? sessionId,
      String? bookingUrl,
      String? formattedPrice,
      String? startTime,
      String? endTime,
      bool? isSoldOut,
      List<ShowingAttributeReadDto>? attributes,
      String? color,
      bool? isMidnightSession}) {
    return ShowingSessionGroup(
        sessionId: sessionId ?? this.sessionId,
        bookingUrl: bookingUrl ?? this.bookingUrl,
        formattedPrice: formattedPrice ?? this.formattedPrice,
        startTime: startTime ?? this.startTime,
        endTime: endTime ?? this.endTime,
        isSoldOut: isSoldOut ?? this.isSoldOut,
        attributes: attributes ?? this.attributes,
        color: color ?? this.color,
        isMidnightSession: isMidnightSession ?? this.isMidnightSession);
  }

  ShowingSessionGroup copyWithWrapped(
      {Wrapped<String?>? sessionId,
      Wrapped<String?>? bookingUrl,
      Wrapped<String?>? formattedPrice,
      Wrapped<String?>? startTime,
      Wrapped<String?>? endTime,
      Wrapped<bool?>? isSoldOut,
      Wrapped<List<ShowingAttributeReadDto>?>? attributes,
      Wrapped<String?>? color,
      Wrapped<bool?>? isMidnightSession}) {
    return ShowingSessionGroup(
        sessionId: (sessionId != null ? sessionId.value : this.sessionId),
        bookingUrl: (bookingUrl != null ? bookingUrl.value : this.bookingUrl),
        formattedPrice: (formattedPrice != null
            ? formattedPrice.value
            : this.formattedPrice),
        startTime: (startTime != null ? startTime.value : this.startTime),
        endTime: (endTime != null ? endTime.value : this.endTime),
        isSoldOut: (isSoldOut != null ? isSoldOut.value : this.isSoldOut),
        attributes: (attributes != null ? attributes.value : this.attributes),
        color: (color != null ? color.value : this.color),
        isMidnightSession: (isMidnightSession != null
            ? isMidnightSession.value
            : this.isMidnightSession));
  }
}

@JsonSerializable(explicitToJson: true)
class SocialMedia {
  SocialMedia({
    this.socialMediaType,
    this.url,
  });

  factory SocialMedia.fromJson(Map<String, dynamic> json) =>
      _$SocialMediaFromJson(json);

  @JsonKey(name: 'socialMediaType', includeIfNull: false, defaultValue: '')
  final String? socialMediaType;
  @JsonKey(name: 'url', includeIfNull: false, defaultValue: '')
  final String? url;
  static const fromJsonFactory = _$SocialMediaFromJson;
  static const toJsonFactory = _$SocialMediaToJson;
  Map<String, dynamic> toJson() => _$SocialMediaToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SocialMedia &&
            (identical(other.socialMediaType, socialMediaType) ||
                const DeepCollectionEquality()
                    .equals(other.socialMediaType, socialMediaType)) &&
            (identical(other.url, url) ||
                const DeepCollectionEquality().equals(other.url, url)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(socialMediaType) ^
      const DeepCollectionEquality().hash(url) ^
      runtimeType.hashCode;
}

extension $SocialMediaExtension on SocialMedia {
  SocialMedia copyWith({String? socialMediaType, String? url}) {
    return SocialMedia(
        socialMediaType: socialMediaType ?? this.socialMediaType,
        url: url ?? this.url);
  }

  SocialMedia copyWithWrapped(
      {Wrapped<String?>? socialMediaType, Wrapped<String?>? url}) {
    return SocialMedia(
        socialMediaType: (socialMediaType != null
            ? socialMediaType.value
            : this.socialMediaType),
        url: (url != null ? url.value : this.url));
  }
}

@JsonSerializable(explicitToJson: true)
class SoundFormat {
  SoundFormat({
    this.id,
    this.description,
    this.code,
  });

  factory SoundFormat.fromJson(Map<String, dynamic> json) =>
      _$SoundFormatFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'code', includeIfNull: false, defaultValue: '')
  final String? code;
  static const fromJsonFactory = _$SoundFormatFromJson;
  static const toJsonFactory = _$SoundFormatToJson;
  Map<String, dynamic> toJson() => _$SoundFormatToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SoundFormat &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(code) ^
      runtimeType.hashCode;
}

extension $SoundFormatExtension on SoundFormat {
  SoundFormat copyWith({String? id, String? description, String? code}) {
    return SoundFormat(
        id: id ?? this.id,
        description: description ?? this.description,
        code: code ?? this.code);
  }

  SoundFormat copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? description,
      Wrapped<String?>? code}) {
    return SoundFormat(
        id: (id != null ? id.value : this.id),
        description:
            (description != null ? description.value : this.description),
        code: (code != null ? code.value : this.code));
  }
}

@JsonSerializable(explicitToJson: true)
class Studio {
  Studio({
    this.id,
    this.description,
    this.organizationCodes,
  });

  factory Studio.fromJson(Map<String, dynamic> json) => _$StudioFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'organizationCodes', includeIfNull: false)
  final OrganizationCode? organizationCodes;
  static const fromJsonFactory = _$StudioFromJson;
  static const toJsonFactory = _$StudioToJson;
  Map<String, dynamic> toJson() => _$StudioToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Studio &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.organizationCodes, organizationCodes) ||
                const DeepCollectionEquality()
                    .equals(other.organizationCodes, organizationCodes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(organizationCodes) ^
      runtimeType.hashCode;
}

extension $StudioExtension on Studio {
  Studio copyWith(
      {String? id, String? description, OrganizationCode? organizationCodes}) {
    return Studio(
        id: id ?? this.id,
        description: description ?? this.description,
        organizationCodes: organizationCodes ?? this.organizationCodes);
  }

  Studio copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? description,
      Wrapped<OrganizationCode?>? organizationCodes}) {
    return Studio(
        id: (id != null ? id.value : this.id),
        description:
            (description != null ? description.value : this.description),
        organizationCodes: (organizationCodes != null
            ? organizationCodes.value
            : this.organizationCodes));
  }
}

@JsonSerializable(explicitToJson: true)
class Subtitle {
  Subtitle({
    this.id,
    this.description,
    this.code,
  });

  factory Subtitle.fromJson(Map<String, dynamic> json) =>
      _$SubtitleFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'code', includeIfNull: false, defaultValue: '')
  final String? code;
  static const fromJsonFactory = _$SubtitleFromJson;
  static const toJsonFactory = _$SubtitleToJson;
  Map<String, dynamic> toJson() => _$SubtitleToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Subtitle &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(code) ^
      runtimeType.hashCode;
}

extension $SubtitleExtension on Subtitle {
  Subtitle copyWith({String? id, String? description, String? code}) {
    return Subtitle(
        id: id ?? this.id,
        description: description ?? this.description,
        code: code ?? this.code);
  }

  Subtitle copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? description,
      Wrapped<String?>? code}) {
    return Subtitle(
        id: (id != null ? id.value : this.id),
        description:
            (description != null ? description.value : this.description),
        code: (code != null ? code.value : this.code));
  }
}

@JsonSerializable(explicitToJson: true)
class Territory {
  Territory({
    this.id,
    this.description,
    this.code,
    this.countryCode,
  });

  factory Territory.fromJson(Map<String, dynamic> json) =>
      _$TerritoryFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'code', includeIfNull: false, defaultValue: '')
  final String? code;
  @JsonKey(name: 'countryCode', includeIfNull: false, defaultValue: '')
  final String? countryCode;
  static const fromJsonFactory = _$TerritoryFromJson;
  static const toJsonFactory = _$TerritoryToJson;
  Map<String, dynamic> toJson() => _$TerritoryToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Territory &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.countryCode, countryCode) ||
                const DeepCollectionEquality()
                    .equals(other.countryCode, countryCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(code) ^
      const DeepCollectionEquality().hash(countryCode) ^
      runtimeType.hashCode;
}

extension $TerritoryExtension on Territory {
  Territory copyWith(
      {String? id, String? description, String? code, String? countryCode}) {
    return Territory(
        id: id ?? this.id,
        description: description ?? this.description,
        code: code ?? this.code,
        countryCode: countryCode ?? this.countryCode);
  }

  Territory copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? description,
      Wrapped<String?>? code,
      Wrapped<String?>? countryCode}) {
    return Territory(
        id: (id != null ? id.value : this.id),
        description:
            (description != null ? description.value : this.description),
        code: (code != null ? code.value : this.code),
        countryCode:
            (countryCode != null ? countryCode.value : this.countryCode));
  }
}

@JsonSerializable(explicitToJson: true)
class TimeSpan {
  TimeSpan({
    this.ticks,
    this.days,
    this.hours,
    this.milliseconds,
    this.minutes,
    this.seconds,
    this.totalDays,
    this.totalHours,
    this.totalMilliseconds,
    this.totalMinutes,
    this.totalSeconds,
  });

  factory TimeSpan.fromJson(Map<String, dynamic> json) =>
      _$TimeSpanFromJson(json);

  @JsonKey(name: 'ticks', includeIfNull: false)
  final num? ticks;
  @JsonKey(name: 'days', includeIfNull: false)
  final int? days;
  @JsonKey(name: 'hours', includeIfNull: false)
  final int? hours;
  @JsonKey(name: 'milliseconds', includeIfNull: false)
  final int? milliseconds;
  @JsonKey(name: 'minutes', includeIfNull: false)
  final int? minutes;
  @JsonKey(name: 'seconds', includeIfNull: false)
  final int? seconds;
  @JsonKey(name: 'totalDays', includeIfNull: false)
  final double? totalDays;
  @JsonKey(name: 'totalHours', includeIfNull: false)
  final double? totalHours;
  @JsonKey(name: 'totalMilliseconds', includeIfNull: false)
  final double? totalMilliseconds;
  @JsonKey(name: 'totalMinutes', includeIfNull: false)
  final double? totalMinutes;
  @JsonKey(name: 'totalSeconds', includeIfNull: false)
  final double? totalSeconds;
  static const fromJsonFactory = _$TimeSpanFromJson;
  static const toJsonFactory = _$TimeSpanToJson;
  Map<String, dynamic> toJson() => _$TimeSpanToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TimeSpan &&
            (identical(other.ticks, ticks) ||
                const DeepCollectionEquality().equals(other.ticks, ticks)) &&
            (identical(other.days, days) ||
                const DeepCollectionEquality().equals(other.days, days)) &&
            (identical(other.hours, hours) ||
                const DeepCollectionEquality().equals(other.hours, hours)) &&
            (identical(other.milliseconds, milliseconds) ||
                const DeepCollectionEquality()
                    .equals(other.milliseconds, milliseconds)) &&
            (identical(other.minutes, minutes) ||
                const DeepCollectionEquality()
                    .equals(other.minutes, minutes)) &&
            (identical(other.seconds, seconds) ||
                const DeepCollectionEquality()
                    .equals(other.seconds, seconds)) &&
            (identical(other.totalDays, totalDays) ||
                const DeepCollectionEquality()
                    .equals(other.totalDays, totalDays)) &&
            (identical(other.totalHours, totalHours) ||
                const DeepCollectionEquality()
                    .equals(other.totalHours, totalHours)) &&
            (identical(other.totalMilliseconds, totalMilliseconds) ||
                const DeepCollectionEquality()
                    .equals(other.totalMilliseconds, totalMilliseconds)) &&
            (identical(other.totalMinutes, totalMinutes) ||
                const DeepCollectionEquality()
                    .equals(other.totalMinutes, totalMinutes)) &&
            (identical(other.totalSeconds, totalSeconds) ||
                const DeepCollectionEquality()
                    .equals(other.totalSeconds, totalSeconds)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(ticks) ^
      const DeepCollectionEquality().hash(days) ^
      const DeepCollectionEquality().hash(hours) ^
      const DeepCollectionEquality().hash(milliseconds) ^
      const DeepCollectionEquality().hash(minutes) ^
      const DeepCollectionEquality().hash(seconds) ^
      const DeepCollectionEquality().hash(totalDays) ^
      const DeepCollectionEquality().hash(totalHours) ^
      const DeepCollectionEquality().hash(totalMilliseconds) ^
      const DeepCollectionEquality().hash(totalMinutes) ^
      const DeepCollectionEquality().hash(totalSeconds) ^
      runtimeType.hashCode;
}

extension $TimeSpanExtension on TimeSpan {
  TimeSpan copyWith(
      {num? ticks,
      int? days,
      int? hours,
      int? milliseconds,
      int? minutes,
      int? seconds,
      double? totalDays,
      double? totalHours,
      double? totalMilliseconds,
      double? totalMinutes,
      double? totalSeconds}) {
    return TimeSpan(
        ticks: ticks ?? this.ticks,
        days: days ?? this.days,
        hours: hours ?? this.hours,
        milliseconds: milliseconds ?? this.milliseconds,
        minutes: minutes ?? this.minutes,
        seconds: seconds ?? this.seconds,
        totalDays: totalDays ?? this.totalDays,
        totalHours: totalHours ?? this.totalHours,
        totalMilliseconds: totalMilliseconds ?? this.totalMilliseconds,
        totalMinutes: totalMinutes ?? this.totalMinutes,
        totalSeconds: totalSeconds ?? this.totalSeconds);
  }

  TimeSpan copyWithWrapped(
      {Wrapped<num?>? ticks,
      Wrapped<int?>? days,
      Wrapped<int?>? hours,
      Wrapped<int?>? milliseconds,
      Wrapped<int?>? minutes,
      Wrapped<int?>? seconds,
      Wrapped<double?>? totalDays,
      Wrapped<double?>? totalHours,
      Wrapped<double?>? totalMilliseconds,
      Wrapped<double?>? totalMinutes,
      Wrapped<double?>? totalSeconds}) {
    return TimeSpan(
        ticks: (ticks != null ? ticks.value : this.ticks),
        days: (days != null ? days.value : this.days),
        hours: (hours != null ? hours.value : this.hours),
        milliseconds:
            (milliseconds != null ? milliseconds.value : this.milliseconds),
        minutes: (minutes != null ? minutes.value : this.minutes),
        seconds: (seconds != null ? seconds.value : this.seconds),
        totalDays: (totalDays != null ? totalDays.value : this.totalDays),
        totalHours: (totalHours != null ? totalHours.value : this.totalHours),
        totalMilliseconds: (totalMilliseconds != null
            ? totalMilliseconds.value
            : this.totalMilliseconds),
        totalMinutes:
            (totalMinutes != null ? totalMinutes.value : this.totalMinutes),
        totalSeconds:
            (totalSeconds != null ? totalSeconds.value : this.totalSeconds));
  }
}

int? errorCodeToJson(enums.ErrorCode? errorCode) {
  return enums.$ErrorCodeMap[errorCode];
}

enums.ErrorCode errorCodeFromJson(
  Object? errorCode, [
  enums.ErrorCode? defaultValue,
]) {
  if (errorCode is int) {
    return enums.$ErrorCodeMap.entries
        .firstWhere((element) => element.value == errorCode,
            orElse: () =>
                const MapEntry(enums.ErrorCode.swaggerGeneratedUnknown, 0))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ErrorCodeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ErrorCode.swaggerGeneratedUnknown;
}

List<int> errorCodeListToJson(List<enums.ErrorCode>? errorCode) {
  if (errorCode == null) {
    return [];
  }

  return errorCode.map((e) => enums.$ErrorCodeMap[e]!).toList();
}

List<enums.ErrorCode> errorCodeListFromJson(
  List? errorCode, [
  List<enums.ErrorCode>? defaultValue,
]) {
  if (errorCode == null) {
    return defaultValue ?? [];
  }

  return errorCode.map((e) => errorCodeFromJson(e.toString())).toList();
}

List<enums.ErrorCode>? errorCodeNullableListFromJson(
  List? errorCode, [
  List<enums.ErrorCode>? defaultValue,
]) {
  if (errorCode == null) {
    return defaultValue;
  }

  return errorCode.map((e) => errorCodeFromJson(e.toString())).toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
