// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;

part 'siteassist.swagger.chopper.dart';
part 'siteassist.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class Siteassist extends ChopperService {
  static Siteassist create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$Siteassist(client);
    }

    final newClient = ChopperClient(
        services: [_$Siteassist()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl:
            baseUrl ?? 'http://f1a4-65-2-165-202.in.ngrok.io/ddc/api/v1.0');
    return _$Siteassist(newClient);
  }

  ///
  Future<chopper.Response> testUploadPost({
    String? cacheControl,
    List<String>? image,
    String? fileId,
  }) {
    return _testUploadPost(
        cacheControl: cacheControl, image: image, fileId: fileId);
  }

  ///
  @Post(path: '/test/upload')
  Future<chopper.Response> _testUploadPost({
    @Header('Cache-Control') String? cacheControl,
    @Part() List<String>? image,
    @Part() String? fileId,
  });
}

@JsonSerializable(explicitToJson: true)
class StorageDto {
  StorageDto({
    this.image,
    this.fileId,
  });

  factory StorageDto.fromJson(Map<String, dynamic> json) =>
      _$StorageDtoFromJson(json);

  @JsonKey(name: 'image', includeIfNull: false)
  final StorageDto$Image? image;
  @JsonKey(name: 'fileId', includeIfNull: false, defaultValue: '')
  final String? fileId;
  static const fromJsonFactory = _$StorageDtoFromJson;
  static const toJsonFactory = _$StorageDtoToJson;
  Map<String, dynamic> toJson() => _$StorageDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StorageDto &&
            (identical(other.image, image) ||
                const DeepCollectionEquality().equals(other.image, image)) &&
            (identical(other.fileId, fileId) ||
                const DeepCollectionEquality().equals(other.fileId, fileId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(image) ^
      const DeepCollectionEquality().hash(fileId) ^
      runtimeType.hashCode;
}

extension $StorageDtoExtension on StorageDto {
  StorageDto copyWith({StorageDto$Image? image, String? fileId}) {
    return StorageDto(
        image: image ?? this.image, fileId: fileId ?? this.fileId);
  }

  StorageDto copyWithWrapped(
      {Wrapped<StorageDto$Image?>? image, Wrapped<String?>? fileId}) {
    return StorageDto(
        image: (image != null ? image.value : this.image),
        fileId: (fileId != null ? fileId.value : this.fileId));
  }
}

@JsonSerializable(explicitToJson: true)
class StorageDto$Image {
  StorageDto$Image({
    this.image,
  });

  factory StorageDto$Image.fromJson(Map<String, dynamic> json) =>
      _$StorageDto$ImageFromJson(json);

  @JsonKey(name: 'image', includeIfNull: false, defaultValue: '')
  final String? image;
  static const fromJsonFactory = _$StorageDto$ImageFromJson;
  static const toJsonFactory = _$StorageDto$ImageToJson;
  Map<String, dynamic> toJson() => _$StorageDto$ImageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StorageDto$Image &&
            (identical(other.image, image) ||
                const DeepCollectionEquality().equals(other.image, image)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(image) ^ runtimeType.hashCode;
}

extension $StorageDto$ImageExtension on StorageDto$Image {
  StorageDto$Image copyWith({String? image}) {
    return StorageDto$Image(image: image ?? this.image);
  }

  StorageDto$Image copyWithWrapped({Wrapped<String?>? image}) {
    return StorageDto$Image(image: (image != null ? image.value : this.image));
  }
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
