import 'package:json_annotation/json_annotation.dart';

enum ModelAndViewStatus {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('100 CONTINUE')
  value_100Continue,
  @JsonValue('101 SWITCHING_PROTOCOLS')
  value_101SwitchingProtocols,
  @JsonValue('102 PROCESSING')
  value_102Processing,
  @JsonValue('103 CHECKPOINT')
  value_103Checkpoint,
  @JsonValue('200 OK')
  value_200Ok,
  @JsonValue('201 CREATED')
  value_201Created,
  @JsonValue('202 ACCEPTED')
  value_202Accepted,
  @JsonValue('203 NON_AUTHORITATIVE_INFORMATION')
  value_203NonAuthoritativeInformation,
  @JsonValue('204 NO_CONTENT')
  value_204NoContent,
  @JsonValue('205 RESET_CONTENT')
  value_205ResetContent,
  @JsonValue('206 PARTIAL_CONTENT')
  value_206PartialContent,
  @JsonValue('207 MULTI_STATUS')
  value_207MultiStatus,
  @JsonValue('208 ALREADY_REPORTED')
  value_208AlreadyReported,
  @JsonValue('226 IM_USED')
  value_226ImUsed,
  @JsonValue('300 MULTIPLE_CHOICES')
  value_300MultipleChoices,
  @JsonValue('301 MOVED_PERMANENTLY')
  value_301MovedPermanently,
  @JsonValue('302 FOUND')
  value_302Found,
  @JsonValue('302 MOVED_TEMPORARILY')
  value_302MovedTemporarily,
  @JsonValue('303 SEE_OTHER')
  value_303SeeOther,
  @JsonValue('304 NOT_MODIFIED')
  value_304NotModified,
  @JsonValue('305 USE_PROXY')
  value_305UseProxy,
  @JsonValue('307 TEMPORARY_REDIRECT')
  value_307TemporaryRedirect,
  @JsonValue('308 PERMANENT_REDIRECT')
  value_308PermanentRedirect,
  @JsonValue('400 BAD_REQUEST')
  value_400BadRequest,
  @JsonValue('401 UNAUTHORIZED')
  value_401Unauthorized,
  @JsonValue('402 PAYMENT_REQUIRED')
  value_402PaymentRequired,
  @JsonValue('403 FORBIDDEN')
  value_403Forbidden,
  @JsonValue('404 NOT_FOUND')
  value_404NotFound,
  @JsonValue('405 METHOD_NOT_ALLOWED')
  value_405MethodNotAllowed,
  @JsonValue('406 NOT_ACCEPTABLE')
  value_406NotAcceptable,
  @JsonValue('407 PROXY_AUTHENTICATION_REQUIRED')
  value_407ProxyAuthenticationRequired,
  @JsonValue('408 REQUEST_TIMEOUT')
  value_408RequestTimeout,
  @JsonValue('409 CONFLICT')
  value_409Conflict,
  @JsonValue('410 GONE')
  value_410Gone,
  @JsonValue('411 LENGTH_REQUIRED')
  value_411LengthRequired,
  @JsonValue('412 PRECONDITION_FAILED')
  value_412PreconditionFailed,
  @JsonValue('413 PAYLOAD_TOO_LARGE')
  value_413PayloadTooLarge,
  @JsonValue('413 REQUEST_ENTITY_TOO_LARGE')
  value_413RequestEntityTooLarge,
  @JsonValue('414 URI_TOO_LONG')
  value_414UriTooLong,
  @JsonValue('414 REQUEST_URI_TOO_LONG')
  value_414RequestUriTooLong,
  @JsonValue('415 UNSUPPORTED_MEDIA_TYPE')
  value_415UnsupportedMediaType,
  @JsonValue('416 REQUESTED_RANGE_NOT_SATISFIABLE')
  value_416RequestedRangeNotSatisfiable,
  @JsonValue('417 EXPECTATION_FAILED')
  value_417ExpectationFailed,
  @JsonValue('418 I_AM_A_TEAPOT')
  value_418IAmATeapot,
  @JsonValue('419 INSUFFICIENT_SPACE_ON_RESOURCE')
  value_419InsufficientSpaceOnResource,
  @JsonValue('420 METHOD_FAILURE')
  value_420MethodFailure,
  @JsonValue('421 DESTINATION_LOCKED')
  value_421DestinationLocked,
  @JsonValue('422 UNPROCESSABLE_ENTITY')
  value_422UnprocessableEntity,
  @JsonValue('423 LOCKED')
  value_423Locked,
  @JsonValue('424 FAILED_DEPENDENCY')
  value_424FailedDependency,
  @JsonValue('426 UPGRADE_REQUIRED')
  value_426UpgradeRequired,
  @JsonValue('428 PRECONDITION_REQUIRED')
  value_428PreconditionRequired,
  @JsonValue('429 TOO_MANY_REQUESTS')
  value_429TooManyRequests,
  @JsonValue('431 REQUEST_HEADER_FIELDS_TOO_LARGE')
  value_431RequestHeaderFieldsTooLarge,
  @JsonValue('451 UNAVAILABLE_FOR_LEGAL_REASONS')
  value_451UnavailableForLegalReasons,
  @JsonValue('500 INTERNAL_SERVER_ERROR')
  value_500InternalServerError,
  @JsonValue('501 NOT_IMPLEMENTED')
  value_501NotImplemented,
  @JsonValue('502 BAD_GATEWAY')
  value_502BadGateway,
  @JsonValue('503 SERVICE_UNAVAILABLE')
  value_503ServiceUnavailable,
  @JsonValue('504 GATEWAY_TIMEOUT')
  value_504GatewayTimeout,
  @JsonValue('505 HTTP_VERSION_NOT_SUPPORTED')
  value_505HttpVersionNotSupported,
  @JsonValue('506 VARIANT_ALSO_NEGOTIATES')
  value_506VariantAlsoNegotiates,
  @JsonValue('507 INSUFFICIENT_STORAGE')
  value_507InsufficientStorage,
  @JsonValue('508 LOOP_DETECTED')
  value_508LoopDetected,
  @JsonValue('509 BANDWIDTH_LIMIT_EXCEEDED')
  value_509BandwidthLimitExceeded,
  @JsonValue('510 NOT_EXTENDED')
  value_510NotExtended,
  @JsonValue('511 NETWORK_AUTHENTICATION_REQUIRED')
  value_511NetworkAuthenticationRequired
}

const $ModelAndViewStatusMap = {
  ModelAndViewStatus.value_100Continue: '100 CONTINUE',
  ModelAndViewStatus.value_101SwitchingProtocols: '101 SWITCHING_PROTOCOLS',
  ModelAndViewStatus.value_102Processing: '102 PROCESSING',
  ModelAndViewStatus.value_103Checkpoint: '103 CHECKPOINT',
  ModelAndViewStatus.value_200Ok: '200 OK',
  ModelAndViewStatus.value_201Created: '201 CREATED',
  ModelAndViewStatus.value_202Accepted: '202 ACCEPTED',
  ModelAndViewStatus.value_203NonAuthoritativeInformation:
      '203 NON_AUTHORITATIVE_INFORMATION',
  ModelAndViewStatus.value_204NoContent: '204 NO_CONTENT',
  ModelAndViewStatus.value_205ResetContent: '205 RESET_CONTENT',
  ModelAndViewStatus.value_206PartialContent: '206 PARTIAL_CONTENT',
  ModelAndViewStatus.value_207MultiStatus: '207 MULTI_STATUS',
  ModelAndViewStatus.value_208AlreadyReported: '208 ALREADY_REPORTED',
  ModelAndViewStatus.value_226ImUsed: '226 IM_USED',
  ModelAndViewStatus.value_300MultipleChoices: '300 MULTIPLE_CHOICES',
  ModelAndViewStatus.value_301MovedPermanently: '301 MOVED_PERMANENTLY',
  ModelAndViewStatus.value_302Found: '302 FOUND',
  ModelAndViewStatus.value_302MovedTemporarily: '302 MOVED_TEMPORARILY',
  ModelAndViewStatus.value_303SeeOther: '303 SEE_OTHER',
  ModelAndViewStatus.value_304NotModified: '304 NOT_MODIFIED',
  ModelAndViewStatus.value_305UseProxy: '305 USE_PROXY',
  ModelAndViewStatus.value_307TemporaryRedirect: '307 TEMPORARY_REDIRECT',
  ModelAndViewStatus.value_308PermanentRedirect: '308 PERMANENT_REDIRECT',
  ModelAndViewStatus.value_400BadRequest: '400 BAD_REQUEST',
  ModelAndViewStatus.value_401Unauthorized: '401 UNAUTHORIZED',
  ModelAndViewStatus.value_402PaymentRequired: '402 PAYMENT_REQUIRED',
  ModelAndViewStatus.value_403Forbidden: '403 FORBIDDEN',
  ModelAndViewStatus.value_404NotFound: '404 NOT_FOUND',
  ModelAndViewStatus.value_405MethodNotAllowed: '405 METHOD_NOT_ALLOWED',
  ModelAndViewStatus.value_406NotAcceptable: '406 NOT_ACCEPTABLE',
  ModelAndViewStatus.value_407ProxyAuthenticationRequired:
      '407 PROXY_AUTHENTICATION_REQUIRED',
  ModelAndViewStatus.value_408RequestTimeout: '408 REQUEST_TIMEOUT',
  ModelAndViewStatus.value_409Conflict: '409 CONFLICT',
  ModelAndViewStatus.value_410Gone: '410 GONE',
  ModelAndViewStatus.value_411LengthRequired: '411 LENGTH_REQUIRED',
  ModelAndViewStatus.value_412PreconditionFailed: '412 PRECONDITION_FAILED',
  ModelAndViewStatus.value_413PayloadTooLarge: '413 PAYLOAD_TOO_LARGE',
  ModelAndViewStatus.value_413RequestEntityTooLarge:
      '413 REQUEST_ENTITY_TOO_LARGE',
  ModelAndViewStatus.value_414UriTooLong: '414 URI_TOO_LONG',
  ModelAndViewStatus.value_414RequestUriTooLong: '414 REQUEST_URI_TOO_LONG',
  ModelAndViewStatus.value_415UnsupportedMediaType:
      '415 UNSUPPORTED_MEDIA_TYPE',
  ModelAndViewStatus.value_416RequestedRangeNotSatisfiable:
      '416 REQUESTED_RANGE_NOT_SATISFIABLE',
  ModelAndViewStatus.value_417ExpectationFailed: '417 EXPECTATION_FAILED',
  ModelAndViewStatus.value_418IAmATeapot: '418 I_AM_A_TEAPOT',
  ModelAndViewStatus.value_419InsufficientSpaceOnResource:
      '419 INSUFFICIENT_SPACE_ON_RESOURCE',
  ModelAndViewStatus.value_420MethodFailure: '420 METHOD_FAILURE',
  ModelAndViewStatus.value_421DestinationLocked: '421 DESTINATION_LOCKED',
  ModelAndViewStatus.value_422UnprocessableEntity: '422 UNPROCESSABLE_ENTITY',
  ModelAndViewStatus.value_423Locked: '423 LOCKED',
  ModelAndViewStatus.value_424FailedDependency: '424 FAILED_DEPENDENCY',
  ModelAndViewStatus.value_426UpgradeRequired: '426 UPGRADE_REQUIRED',
  ModelAndViewStatus.value_428PreconditionRequired: '428 PRECONDITION_REQUIRED',
  ModelAndViewStatus.value_429TooManyRequests: '429 TOO_MANY_REQUESTS',
  ModelAndViewStatus.value_431RequestHeaderFieldsTooLarge:
      '431 REQUEST_HEADER_FIELDS_TOO_LARGE',
  ModelAndViewStatus.value_451UnavailableForLegalReasons:
      '451 UNAVAILABLE_FOR_LEGAL_REASONS',
  ModelAndViewStatus.value_500InternalServerError: '500 INTERNAL_SERVER_ERROR',
  ModelAndViewStatus.value_501NotImplemented: '501 NOT_IMPLEMENTED',
  ModelAndViewStatus.value_502BadGateway: '502 BAD_GATEWAY',
  ModelAndViewStatus.value_503ServiceUnavailable: '503 SERVICE_UNAVAILABLE',
  ModelAndViewStatus.value_504GatewayTimeout: '504 GATEWAY_TIMEOUT',
  ModelAndViewStatus.value_505HttpVersionNotSupported:
      '505 HTTP_VERSION_NOT_SUPPORTED',
  ModelAndViewStatus.value_506VariantAlsoNegotiates:
      '506 VARIANT_ALSO_NEGOTIATES',
  ModelAndViewStatus.value_507InsufficientStorage: '507 INSUFFICIENT_STORAGE',
  ModelAndViewStatus.value_508LoopDetected: '508 LOOP_DETECTED',
  ModelAndViewStatus.value_509BandwidthLimitExceeded:
      '509 BANDWIDTH_LIMIT_EXCEEDED',
  ModelAndViewStatus.value_510NotExtended: '510 NOT_EXTENDED',
  ModelAndViewStatus.value_511NetworkAuthenticationRequired:
      '511 NETWORK_AUTHENTICATION_REQUIRED'
};

enum SlotDiscountType {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('NORMAL')
  normal,
  @JsonValue('DISCOUNTED')
  discounted,
  @JsonValue('LOWEST')
  lowest
}

const $SlotDiscountTypeMap = {
  SlotDiscountType.normal: 'NORMAL',
  SlotDiscountType.discounted: 'DISCOUNTED',
  SlotDiscountType.lowest: 'LOWEST'
};

enum SlotProductionRunCode {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('PO')
  po,
  @JsonValue('PA')
  pa
}

const $SlotProductionRunCodeMap = {
  SlotProductionRunCode.po: 'PO',
  SlotProductionRunCode.pa: 'PA'
};

enum SlotStatus {
  @JsonValue('swaggerGeneratedUnknown')
  swaggerGeneratedUnknown,
  @JsonValue('OPEN')
  open,
  @JsonValue('CLOSED')
  closed,
  @JsonValue('SELECTED')
  selected,
  @JsonValue('FULL')
  full,
  @JsonValue('EXPIRED')
  expired
}

const $SlotStatusMap = {
  SlotStatus.open: 'OPEN',
  SlotStatus.closed: 'CLOSED',
  SlotStatus.selected: 'SELECTED',
  SlotStatus.full: 'FULL',
  SlotStatus.expired: 'EXPIRED'
};
