// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'slots_remote_data_source.enums.swagger.dart' as enums;
export 'slots_remote_data_source.enums.swagger.dart';

part 'slots_remote_data_source.swagger.chopper.dart';
part 'slots_remote_data_source.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class SlotsRemoteDataSource extends ChopperService {
  static SlotsRemoteDataSource create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$SlotsRemoteDataSource(client);
    }

    final newClient = ChopperClient(
        services: [_$SlotsRemoteDataSource()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://appie-slot-bff.ah-tst.k8s.digitaldev.nl/');
    return _$SlotsRemoteDataSource(newClient);
  }

  ///errorHtml
  Future<chopper.Response<ModelAndView>> errorGet({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ModelAndView, () => ModelAndView.fromJsonFactory);

    return _errorGet(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///errorHtml
  @Get(path: '/error')
  Future<chopper.Response<ModelAndView>> _errorGet({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///errorHtml
  Future<chopper.Response<ModelAndView>> errorHead({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ModelAndView, () => ModelAndView.fromJsonFactory);

    return _errorHead(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///errorHtml
  @Head(path: '/error')
  Future<chopper.Response<ModelAndView>> _errorHead({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///errorHtml
  Future<chopper.Response<ModelAndView>> errorPost({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ModelAndView, () => ModelAndView.fromJsonFactory);

    return _errorPost(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///errorHtml
  @Post(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<ModelAndView>> _errorPost({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///errorHtml
  Future<chopper.Response<ModelAndView>> errorPut({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ModelAndView, () => ModelAndView.fromJsonFactory);

    return _errorPut(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///errorHtml
  @Put(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<ModelAndView>> _errorPut({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///errorHtml
  Future<chopper.Response<ModelAndView>> errorDelete({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ModelAndView, () => ModelAndView.fromJsonFactory);

    return _errorDelete(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///errorHtml
  @Delete(path: '/error')
  Future<chopper.Response<ModelAndView>> _errorDelete({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///errorHtml
  Future<chopper.Response<ModelAndView>> errorPatch({
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ModelAndView, () => ModelAndView.fromJsonFactory);

    return _errorPatch(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///errorHtml
  @Patch(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<ModelAndView>> _errorPatch({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the delivery slots for a given Pick Up Point or postal code of the user
  ///@param city City
  ///@param houseNumber House number
  ///@param postalCode Postal code (trailing alphabetic part is discarded)
  ///@param productIds IDs of the ordered products. If not supplied, product lead times are not considered.
  ///@param pupId ID of the Pick Up Point. When not provided, the users postal code is used to search for available slots
  ///@param street Street
  ///@param x-application x-application
  Future<chopper.Response<List<SlotDay>>> v1SlotsGet({
    String? city,
    String? houseNumber,
    String? postalCode,
    List<int>? productIds,
    int? pupId,
    String? street,
    String? xApplication,
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(SlotDay, () => SlotDay.fromJsonFactory);

    return _v1SlotsGet(
        city: city,
        houseNumber: houseNumber,
        postalCode: postalCode,
        productIds: productIds,
        pupId: pupId,
        street: street,
        xApplication: xApplication,
        xAuthorization: xAuthorization,
        cacheControl: cacheControl);
  }

  ///Get the delivery slots for a given Pick Up Point or postal code of the user
  ///@param city City
  ///@param houseNumber House number
  ///@param postalCode Postal code (trailing alphabetic part is discarded)
  ///@param productIds IDs of the ordered products. If not supplied, product lead times are not considered.
  ///@param pupId ID of the Pick Up Point. When not provided, the users postal code is used to search for available slots
  ///@param street Street
  ///@param x-application x-application
  @Get(path: '/v1/slots')
  Future<chopper.Response<List<SlotDay>>> _v1SlotsGet({
    @Query('city') String? city,
    @Query('houseNumber') String? houseNumber,
    @Query('postalCode') String? postalCode,
    @Query('productIds') List<int>? productIds,
    @Query('pupId') int? pupId,
    @Query('street') String? street,
    @Header('x-application') String? xApplication,
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Validate address
  ///@param city city
  ///@param houseNumber houseNumber
  ///@param postalCode postalCode
  ///@param street street
  Future<chopper.Response<AddressValidationResponse>> v1ValidateAddressGet({
    String? city,
    String? houseNumber,
    required String? postalCode,
    String? street,
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(AddressValidationResponse,
        () => AddressValidationResponse.fromJsonFactory);

    return _v1ValidateAddressGet(
        city: city,
        houseNumber: houseNumber,
        postalCode: postalCode,
        street: street,
        xAuthorization: xAuthorization,
        cacheControl: cacheControl);
  }

  ///Validate address
  ///@param city city
  ///@param houseNumber houseNumber
  ///@param postalCode postalCode
  ///@param street street
  @Get(path: '/v1/validate-address')
  Future<chopper.Response<AddressValidationResponse>> _v1ValidateAddressGet({
    @Query('city') String? city,
    @Query('houseNumber') String? houseNumber,
    @Query('postalCode') required String? postalCode,
    @Query('street') String? street,
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class AddressValidationResponse {
  AddressValidationResponse({
    required this.isSuccessful,
    this.message,
  });

  factory AddressValidationResponse.fromJson(Map<String, dynamic> json) =>
      _$AddressValidationResponseFromJson(json);

  @JsonKey(name: 'isSuccessful', includeIfNull: false)
  final bool isSuccessful;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  static const fromJsonFactory = _$AddressValidationResponseFromJson;
  static const toJsonFactory = _$AddressValidationResponseToJson;
  Map<String, dynamic> toJson() => _$AddressValidationResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AddressValidationResponse &&
            (identical(other.isSuccessful, isSuccessful) ||
                const DeepCollectionEquality()
                    .equals(other.isSuccessful, isSuccessful)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality().equals(other.message, message)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(isSuccessful) ^
      const DeepCollectionEquality().hash(message) ^
      runtimeType.hashCode;
}

extension $AddressValidationResponseExtension on AddressValidationResponse {
  AddressValidationResponse copyWith({bool? isSuccessful, String? message}) {
    return AddressValidationResponse(
        isSuccessful: isSuccessful ?? this.isSuccessful,
        message: message ?? this.message);
  }

  AddressValidationResponse copyWithWrapped(
      {Wrapped<bool>? isSuccessful, Wrapped<String?>? message}) {
    return AddressValidationResponse(
        isSuccessful:
            (isSuccessful != null ? isSuccessful.value : this.isSuccessful),
        message: (message != null ? message.value : this.message));
  }
}

@JsonSerializable(explicitToJson: true)
class ModelAndView {
  ModelAndView({
    this.empty,
    this.model,
    this.modelMap,
    this.reference,
    this.status,
    this.view,
    this.viewName,
  });

  factory ModelAndView.fromJson(Map<String, dynamic> json) =>
      _$ModelAndViewFromJson(json);

  @JsonKey(name: 'empty', includeIfNull: false)
  final bool? empty;
  @JsonKey(name: 'model', includeIfNull: false)
  final Object? model;
  @JsonKey(name: 'modelMap', includeIfNull: false)
  final Map<String, dynamic>? modelMap;
  @JsonKey(name: 'reference', includeIfNull: false)
  final bool? reference;
  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: modelAndViewStatusToJson,
    fromJson: modelAndViewStatusFromJson,
  )
  final enums.ModelAndViewStatus? status;
  @JsonKey(name: 'view', includeIfNull: false)
  final View? view;
  @JsonKey(name: 'viewName', includeIfNull: false, defaultValue: '')
  final String? viewName;
  static const fromJsonFactory = _$ModelAndViewFromJson;
  static const toJsonFactory = _$ModelAndViewToJson;
  Map<String, dynamic> toJson() => _$ModelAndViewToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ModelAndView &&
            (identical(other.empty, empty) ||
                const DeepCollectionEquality().equals(other.empty, empty)) &&
            (identical(other.model, model) ||
                const DeepCollectionEquality().equals(other.model, model)) &&
            (identical(other.modelMap, modelMap) ||
                const DeepCollectionEquality()
                    .equals(other.modelMap, modelMap)) &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.view, view) ||
                const DeepCollectionEquality().equals(other.view, view)) &&
            (identical(other.viewName, viewName) ||
                const DeepCollectionEquality()
                    .equals(other.viewName, viewName)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(empty) ^
      const DeepCollectionEquality().hash(model) ^
      const DeepCollectionEquality().hash(modelMap) ^
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(view) ^
      const DeepCollectionEquality().hash(viewName) ^
      runtimeType.hashCode;
}

extension $ModelAndViewExtension on ModelAndView {
  ModelAndView copyWith(
      {bool? empty,
      Object? model,
      Map<String, dynamic>? modelMap,
      bool? reference,
      enums.ModelAndViewStatus? status,
      View? view,
      String? viewName}) {
    return ModelAndView(
        empty: empty ?? this.empty,
        model: model ?? this.model,
        modelMap: modelMap ?? this.modelMap,
        reference: reference ?? this.reference,
        status: status ?? this.status,
        view: view ?? this.view,
        viewName: viewName ?? this.viewName);
  }

  ModelAndView copyWithWrapped(
      {Wrapped<bool?>? empty,
      Wrapped<Object?>? model,
      Wrapped<Map<String, dynamic>?>? modelMap,
      Wrapped<bool?>? reference,
      Wrapped<enums.ModelAndViewStatus?>? status,
      Wrapped<View?>? view,
      Wrapped<String?>? viewName}) {
    return ModelAndView(
        empty: (empty != null ? empty.value : this.empty),
        model: (model != null ? model.value : this.model),
        modelMap: (modelMap != null ? modelMap.value : this.modelMap),
        reference: (reference != null ? reference.value : this.reference),
        status: (status != null ? status.value : this.status),
        view: (view != null ? view.value : this.view),
        viewName: (viewName != null ? viewName.value : this.viewName));
  }
}

@JsonSerializable(explicitToJson: true)
class Slot {
  Slot({
    this.defaultServiceCharge,
    this.deliveryLocationId,
    this.discountType,
    this.eco,
    required this.endTime,
    required this.productionRunCode,
    this.serviceCharge,
    this.shiftCode,
    required this.startTime,
    this.status,
  });

  factory Slot.fromJson(Map<String, dynamic> json) => _$SlotFromJson(json);

  @JsonKey(name: 'defaultServiceCharge', includeIfNull: false)
  final double? defaultServiceCharge;
  @JsonKey(name: 'deliveryLocationId', includeIfNull: false)
  final num? deliveryLocationId;
  @JsonKey(
    name: 'discountType',
    includeIfNull: false,
    toJson: slotDiscountTypeToJson,
    fromJson: slotDiscountTypeFromJson,
  )
  final enums.SlotDiscountType? discountType;
  @JsonKey(name: 'eco', includeIfNull: false)
  final bool? eco;
  @JsonKey(name: 'endTime', includeIfNull: false)
  final DateTime endTime;
  @JsonKey(
    name: 'productionRunCode',
    includeIfNull: false,
    toJson: slotProductionRunCodeToJson,
    fromJson: slotProductionRunCodeFromJson,
  )
  final enums.SlotProductionRunCode productionRunCode;
  @JsonKey(name: 'serviceCharge', includeIfNull: false)
  final double? serviceCharge;
  @JsonKey(name: 'shiftCode', includeIfNull: false, defaultValue: '')
  final String? shiftCode;
  @JsonKey(name: 'startTime', includeIfNull: false)
  final DateTime startTime;
  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: slotStatusToJson,
    fromJson: slotStatusFromJson,
  )
  final enums.SlotStatus? status;
  static const fromJsonFactory = _$SlotFromJson;
  static const toJsonFactory = _$SlotToJson;
  Map<String, dynamic> toJson() => _$SlotToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Slot &&
            (identical(other.defaultServiceCharge, defaultServiceCharge) ||
                const DeepCollectionEquality().equals(
                    other.defaultServiceCharge, defaultServiceCharge)) &&
            (identical(other.deliveryLocationId, deliveryLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryLocationId, deliveryLocationId)) &&
            (identical(other.discountType, discountType) ||
                const DeepCollectionEquality()
                    .equals(other.discountType, discountType)) &&
            (identical(other.eco, eco) ||
                const DeepCollectionEquality().equals(other.eco, eco)) &&
            (identical(other.endTime, endTime) ||
                const DeepCollectionEquality()
                    .equals(other.endTime, endTime)) &&
            (identical(other.productionRunCode, productionRunCode) ||
                const DeepCollectionEquality()
                    .equals(other.productionRunCode, productionRunCode)) &&
            (identical(other.serviceCharge, serviceCharge) ||
                const DeepCollectionEquality()
                    .equals(other.serviceCharge, serviceCharge)) &&
            (identical(other.shiftCode, shiftCode) ||
                const DeepCollectionEquality()
                    .equals(other.shiftCode, shiftCode)) &&
            (identical(other.startTime, startTime) ||
                const DeepCollectionEquality()
                    .equals(other.startTime, startTime)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(defaultServiceCharge) ^
      const DeepCollectionEquality().hash(deliveryLocationId) ^
      const DeepCollectionEquality().hash(discountType) ^
      const DeepCollectionEquality().hash(eco) ^
      const DeepCollectionEquality().hash(endTime) ^
      const DeepCollectionEquality().hash(productionRunCode) ^
      const DeepCollectionEquality().hash(serviceCharge) ^
      const DeepCollectionEquality().hash(shiftCode) ^
      const DeepCollectionEquality().hash(startTime) ^
      const DeepCollectionEquality().hash(status) ^
      runtimeType.hashCode;
}

extension $SlotExtension on Slot {
  Slot copyWith(
      {double? defaultServiceCharge,
      num? deliveryLocationId,
      enums.SlotDiscountType? discountType,
      bool? eco,
      DateTime? endTime,
      enums.SlotProductionRunCode? productionRunCode,
      double? serviceCharge,
      String? shiftCode,
      DateTime? startTime,
      enums.SlotStatus? status}) {
    return Slot(
        defaultServiceCharge: defaultServiceCharge ?? this.defaultServiceCharge,
        deliveryLocationId: deliveryLocationId ?? this.deliveryLocationId,
        discountType: discountType ?? this.discountType,
        eco: eco ?? this.eco,
        endTime: endTime ?? this.endTime,
        productionRunCode: productionRunCode ?? this.productionRunCode,
        serviceCharge: serviceCharge ?? this.serviceCharge,
        shiftCode: shiftCode ?? this.shiftCode,
        startTime: startTime ?? this.startTime,
        status: status ?? this.status);
  }

  Slot copyWithWrapped(
      {Wrapped<double?>? defaultServiceCharge,
      Wrapped<num?>? deliveryLocationId,
      Wrapped<enums.SlotDiscountType?>? discountType,
      Wrapped<bool?>? eco,
      Wrapped<DateTime>? endTime,
      Wrapped<enums.SlotProductionRunCode>? productionRunCode,
      Wrapped<double?>? serviceCharge,
      Wrapped<String?>? shiftCode,
      Wrapped<DateTime>? startTime,
      Wrapped<enums.SlotStatus?>? status}) {
    return Slot(
        defaultServiceCharge: (defaultServiceCharge != null
            ? defaultServiceCharge.value
            : this.defaultServiceCharge),
        deliveryLocationId: (deliveryLocationId != null
            ? deliveryLocationId.value
            : this.deliveryLocationId),
        discountType:
            (discountType != null ? discountType.value : this.discountType),
        eco: (eco != null ? eco.value : this.eco),
        endTime: (endTime != null ? endTime.value : this.endTime),
        productionRunCode: (productionRunCode != null
            ? productionRunCode.value
            : this.productionRunCode),
        serviceCharge:
            (serviceCharge != null ? serviceCharge.value : this.serviceCharge),
        shiftCode: (shiftCode != null ? shiftCode.value : this.shiftCode),
        startTime: (startTime != null ? startTime.value : this.startTime),
        status: (status != null ? status.value : this.status));
  }
}

@JsonSerializable(explicitToJson: true)
class SlotDay {
  SlotDay({
    required this.date,
    required this.freeDelivery,
    this.freeDeliveryTitle,
    required this.slots,
  });

  factory SlotDay.fromJson(Map<String, dynamic> json) =>
      _$SlotDayFromJson(json);

  @JsonKey(name: 'date', includeIfNull: false, toJson: _dateToJson)
  final DateTime date;
  @JsonKey(name: 'freeDelivery', includeIfNull: false)
  final bool freeDelivery;
  @JsonKey(name: 'freeDeliveryTitle', includeIfNull: false, defaultValue: '')
  final String? freeDeliveryTitle;
  @JsonKey(name: 'slots', includeIfNull: false, defaultValue: <Slot>[])
  final List<Slot> slots;
  static const fromJsonFactory = _$SlotDayFromJson;
  static const toJsonFactory = _$SlotDayToJson;
  Map<String, dynamic> toJson() => _$SlotDayToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SlotDay &&
            (identical(other.date, date) ||
                const DeepCollectionEquality().equals(other.date, date)) &&
            (identical(other.freeDelivery, freeDelivery) ||
                const DeepCollectionEquality()
                    .equals(other.freeDelivery, freeDelivery)) &&
            (identical(other.freeDeliveryTitle, freeDeliveryTitle) ||
                const DeepCollectionEquality()
                    .equals(other.freeDeliveryTitle, freeDeliveryTitle)) &&
            (identical(other.slots, slots) ||
                const DeepCollectionEquality().equals(other.slots, slots)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(date) ^
      const DeepCollectionEquality().hash(freeDelivery) ^
      const DeepCollectionEquality().hash(freeDeliveryTitle) ^
      const DeepCollectionEquality().hash(slots) ^
      runtimeType.hashCode;
}

extension $SlotDayExtension on SlotDay {
  SlotDay copyWith(
      {DateTime? date,
      bool? freeDelivery,
      String? freeDeliveryTitle,
      List<Slot>? slots}) {
    return SlotDay(
        date: date ?? this.date,
        freeDelivery: freeDelivery ?? this.freeDelivery,
        freeDeliveryTitle: freeDeliveryTitle ?? this.freeDeliveryTitle,
        slots: slots ?? this.slots);
  }

  SlotDay copyWithWrapped(
      {Wrapped<DateTime>? date,
      Wrapped<bool>? freeDelivery,
      Wrapped<String?>? freeDeliveryTitle,
      Wrapped<List<Slot>>? slots}) {
    return SlotDay(
        date: (date != null ? date.value : this.date),
        freeDelivery:
            (freeDelivery != null ? freeDelivery.value : this.freeDelivery),
        freeDeliveryTitle: (freeDeliveryTitle != null
            ? freeDeliveryTitle.value
            : this.freeDeliveryTitle),
        slots: (slots != null ? slots.value : this.slots));
  }
}

@JsonSerializable(explicitToJson: true)
class View {
  View({
    this.contentType,
  });

  factory View.fromJson(Map<String, dynamic> json) => _$ViewFromJson(json);

  @JsonKey(name: 'contentType', includeIfNull: false, defaultValue: '')
  final String? contentType;
  static const fromJsonFactory = _$ViewFromJson;
  static const toJsonFactory = _$ViewToJson;
  Map<String, dynamic> toJson() => _$ViewToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is View &&
            (identical(other.contentType, contentType) ||
                const DeepCollectionEquality()
                    .equals(other.contentType, contentType)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(contentType) ^ runtimeType.hashCode;
}

extension $ViewExtension on View {
  View copyWith({String? contentType}) {
    return View(contentType: contentType ?? this.contentType);
  }

  View copyWithWrapped({Wrapped<String?>? contentType}) {
    return View(
        contentType:
            (contentType != null ? contentType.value : this.contentType));
  }
}

String? modelAndViewStatusToJson(enums.ModelAndViewStatus? modelAndViewStatus) {
  return enums.$ModelAndViewStatusMap[modelAndViewStatus];
}

enums.ModelAndViewStatus modelAndViewStatusFromJson(
  Object? modelAndViewStatus, [
  enums.ModelAndViewStatus? defaultValue,
]) {
  if (modelAndViewStatus is String) {
    return enums.$ModelAndViewStatusMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == modelAndViewStatus.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ModelAndViewStatus.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ModelAndViewStatusMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ModelAndViewStatus.swaggerGeneratedUnknown;
}

List<String> modelAndViewStatusListToJson(
    List<enums.ModelAndViewStatus>? modelAndViewStatus) {
  if (modelAndViewStatus == null) {
    return [];
  }

  return modelAndViewStatus
      .map((e) => enums.$ModelAndViewStatusMap[e]!)
      .toList();
}

List<enums.ModelAndViewStatus> modelAndViewStatusListFromJson(
  List? modelAndViewStatus, [
  List<enums.ModelAndViewStatus>? defaultValue,
]) {
  if (modelAndViewStatus == null) {
    return defaultValue ?? [];
  }

  return modelAndViewStatus
      .map((e) => modelAndViewStatusFromJson(e.toString()))
      .toList();
}

List<enums.ModelAndViewStatus>? modelAndViewStatusNullableListFromJson(
  List? modelAndViewStatus, [
  List<enums.ModelAndViewStatus>? defaultValue,
]) {
  if (modelAndViewStatus == null) {
    return defaultValue;
  }

  return modelAndViewStatus
      .map((e) => modelAndViewStatusFromJson(e.toString()))
      .toList();
}

String? slotDiscountTypeToJson(enums.SlotDiscountType? slotDiscountType) {
  return enums.$SlotDiscountTypeMap[slotDiscountType];
}

enums.SlotDiscountType slotDiscountTypeFromJson(
  Object? slotDiscountType, [
  enums.SlotDiscountType? defaultValue,
]) {
  if (slotDiscountType is String) {
    return enums.$SlotDiscountTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == slotDiscountType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.SlotDiscountType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SlotDiscountTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SlotDiscountType.swaggerGeneratedUnknown;
}

List<String> slotDiscountTypeListToJson(
    List<enums.SlotDiscountType>? slotDiscountType) {
  if (slotDiscountType == null) {
    return [];
  }

  return slotDiscountType.map((e) => enums.$SlotDiscountTypeMap[e]!).toList();
}

List<enums.SlotDiscountType> slotDiscountTypeListFromJson(
  List? slotDiscountType, [
  List<enums.SlotDiscountType>? defaultValue,
]) {
  if (slotDiscountType == null) {
    return defaultValue ?? [];
  }

  return slotDiscountType
      .map((e) => slotDiscountTypeFromJson(e.toString()))
      .toList();
}

List<enums.SlotDiscountType>? slotDiscountTypeNullableListFromJson(
  List? slotDiscountType, [
  List<enums.SlotDiscountType>? defaultValue,
]) {
  if (slotDiscountType == null) {
    return defaultValue;
  }

  return slotDiscountType
      .map((e) => slotDiscountTypeFromJson(e.toString()))
      .toList();
}

String? slotProductionRunCodeToJson(
    enums.SlotProductionRunCode? slotProductionRunCode) {
  return enums.$SlotProductionRunCodeMap[slotProductionRunCode];
}

enums.SlotProductionRunCode slotProductionRunCodeFromJson(
  Object? slotProductionRunCode, [
  enums.SlotProductionRunCode? defaultValue,
]) {
  if (slotProductionRunCode is String) {
    return enums.$SlotProductionRunCodeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                slotProductionRunCode.toLowerCase(),
            orElse: () => const MapEntry(
                enums.SlotProductionRunCode.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SlotProductionRunCodeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SlotProductionRunCode.swaggerGeneratedUnknown;
}

List<String> slotProductionRunCodeListToJson(
    List<enums.SlotProductionRunCode>? slotProductionRunCode) {
  if (slotProductionRunCode == null) {
    return [];
  }

  return slotProductionRunCode
      .map((e) => enums.$SlotProductionRunCodeMap[e]!)
      .toList();
}

List<enums.SlotProductionRunCode> slotProductionRunCodeListFromJson(
  List? slotProductionRunCode, [
  List<enums.SlotProductionRunCode>? defaultValue,
]) {
  if (slotProductionRunCode == null) {
    return defaultValue ?? [];
  }

  return slotProductionRunCode
      .map((e) => slotProductionRunCodeFromJson(e.toString()))
      .toList();
}

List<enums.SlotProductionRunCode>? slotProductionRunCodeNullableListFromJson(
  List? slotProductionRunCode, [
  List<enums.SlotProductionRunCode>? defaultValue,
]) {
  if (slotProductionRunCode == null) {
    return defaultValue;
  }

  return slotProductionRunCode
      .map((e) => slotProductionRunCodeFromJson(e.toString()))
      .toList();
}

String? slotStatusToJson(enums.SlotStatus? slotStatus) {
  return enums.$SlotStatusMap[slotStatus];
}

enums.SlotStatus slotStatusFromJson(
  Object? slotStatus, [
  enums.SlotStatus? defaultValue,
]) {
  if (slotStatus is String) {
    return enums.$SlotStatusMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == slotStatus.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.SlotStatus.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SlotStatusMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SlotStatus.swaggerGeneratedUnknown;
}

List<String> slotStatusListToJson(List<enums.SlotStatus>? slotStatus) {
  if (slotStatus == null) {
    return [];
  }

  return slotStatus.map((e) => enums.$SlotStatusMap[e]!).toList();
}

List<enums.SlotStatus> slotStatusListFromJson(
  List? slotStatus, [
  List<enums.SlotStatus>? defaultValue,
]) {
  if (slotStatus == null) {
    return defaultValue ?? [];
  }

  return slotStatus.map((e) => slotStatusFromJson(e.toString())).toList();
}

List<enums.SlotStatus>? slotStatusNullableListFromJson(
  List? slotStatus, [
  List<enums.SlotStatus>? defaultValue,
]) {
  if (slotStatus == null) {
    return defaultValue;
  }

  return slotStatus.map((e) => slotStatusFromJson(e.toString())).toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
