// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'theme_pages_remote_data_source.enums.swagger.dart' as enums;
export 'theme_pages_remote_data_source.enums.swagger.dart';

part 'theme_pages_remote_data_source.swagger.chopper.dart';
part 'theme_pages_remote_data_source.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class ThemePagesRemoteDataSource extends ChopperService {
  static ThemePagesRemoteDataSource create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$ThemePagesRemoteDataSource(client);
    }

    final newClient = ChopperClient(
        services: [_$ThemePagesRemoteDataSource()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$ThemePagesRemoteDataSource(newClient);
  }

  ///List of ThemePages
  ///@param x-application
  Future<chopper.Response<List<ThemePage>>> v1ThemepagesFoodfirstDiscoverGet({
    String? xApplication,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ThemePage, () => ThemePage.fromJsonFactory);

    return _v1ThemepagesFoodfirstDiscoverGet(
        xApplication: xApplication, cacheControl: cacheControl);
  }

  ///List of ThemePages
  ///@param x-application
  @Get(path: '/v1/themepages/foodfirst/discover')
  Future<chopper.Response<List<ThemePage>>> _v1ThemepagesFoodfirstDiscoverGet({
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Returns ThemePageResponse
  ///@param pageId
  ///@param Appie-Current-Order-Id
  ///@param x-application
  Future<chopper.Response<List<ThemePageArticle>>> v1ThemepagesGet({
    required String? pageId,
    String? appieCurrentOrderId,
    String? xApplication,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ThemePageArticle, () => ThemePageArticle.fromJsonFactory);

    return _v1ThemepagesGet(
        pageId: pageId,
        appieCurrentOrderId: appieCurrentOrderId,
        xApplication: xApplication,
        cacheControl: cacheControl);
  }

  ///Returns ThemePageResponse
  ///@param pageId
  ///@param Appie-Current-Order-Id
  ///@param x-application
  @Get(path: '/v1/themepages')
  Future<chopper.Response<List<ThemePageArticle>>> _v1ThemepagesGet({
    @Query('pageId') required String? pageId,
    @Header('Appie-Current-Order-Id') String? appieCurrentOrderId,
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
  });

  ///List of ThemePages
  ///@param pageId
  ///@param Appie-Current-Order-Id
  ///@param x-application
  Future<chopper.Response<List<ThemePage>>> v1ThemepagesDiscoverGet({
    String? pageId,
    String? appieCurrentOrderId,
    String? xApplication,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ThemePage, () => ThemePage.fromJsonFactory);

    return _v1ThemepagesDiscoverGet(
        pageId: pageId,
        appieCurrentOrderId: appieCurrentOrderId,
        xApplication: xApplication,
        cacheControl: cacheControl);
  }

  ///List of ThemePages
  ///@param pageId
  ///@param Appie-Current-Order-Id
  ///@param x-application
  @Get(path: '/v1/themepages/discover')
  Future<chopper.Response<List<ThemePage>>> _v1ThemepagesDiscoverGet({
    @Query('pageId') String? pageId,
    @Header('Appie-Current-Order-Id') String? appieCurrentOrderId,
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<ErrorJson>> errorGet({String? cacheControl}) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorGet(cacheControl: cacheControl);
  }

  ///
  @Get(path: '/error')
  Future<chopper.Response<ErrorJson>> _errorGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<ErrorJson>> errorPut({String? cacheControl}) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorPut(cacheControl: cacheControl);
  }

  ///
  @Put(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<ErrorJson>> _errorPut(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<ErrorJson>> errorPost({String? cacheControl}) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorPost(cacheControl: cacheControl);
  }

  ///
  @Post(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<ErrorJson>> _errorPost(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<ErrorJson>> errorDelete({String? cacheControl}) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorDelete(cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/error')
  Future<chopper.Response<ErrorJson>> _errorDelete(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<ErrorJson>> errorHead({String? cacheControl}) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorHead(cacheControl: cacheControl);
  }

  ///
  @Head(path: '/error')
  Future<chopper.Response<ErrorJson>> _errorHead(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<ErrorJson>> errorPatch({String? cacheControl}) {
    generatedMapping.putIfAbsent(ErrorJson, () => ErrorJson.fromJsonFactory);

    return _errorPatch(cacheControl: cacheControl);
  }

  ///
  @Patch(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<ErrorJson>> _errorPatch(
      {@Header('Cache-Control') String? cacheControl});
}

@JsonSerializable(explicitToJson: true)
class Colors {
  Colors({
    this.tint,
    this.background,
  });

  factory Colors.fromJson(Map<String, dynamic> json) => _$ColorsFromJson(json);

  @JsonKey(name: 'tint', includeIfNull: false, defaultValue: '')
  final String? tint;
  @JsonKey(name: 'background', includeIfNull: false, defaultValue: '')
  final String? background;
  static const fromJsonFactory = _$ColorsFromJson;
  static const toJsonFactory = _$ColorsToJson;
  Map<String, dynamic> toJson() => _$ColorsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Colors &&
            (identical(other.tint, tint) ||
                const DeepCollectionEquality().equals(other.tint, tint)) &&
            (identical(other.background, background) ||
                const DeepCollectionEquality()
                    .equals(other.background, background)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(tint) ^
      const DeepCollectionEquality().hash(background) ^
      runtimeType.hashCode;
}

extension $ColorsExtension on Colors {
  Colors copyWith({String? tint, String? background}) {
    return Colors(
        tint: tint ?? this.tint, background: background ?? this.background);
  }

  Colors copyWithWrapped(
      {Wrapped<String?>? tint, Wrapped<String?>? background}) {
    return Colors(
        tint: (tint != null ? tint.value : this.tint),
        background: (background != null ? background.value : this.background));
  }
}

@JsonSerializable(explicitToJson: true)
class Image {
  Image({
    this.width,
    this.height,
    this.url,
  });

  factory Image.fromJson(Map<String, dynamic> json) => _$ImageFromJson(json);

  @JsonKey(name: 'width', includeIfNull: false)
  final int? width;
  @JsonKey(name: 'height', includeIfNull: false)
  final int? height;
  @JsonKey(name: 'url', includeIfNull: false, defaultValue: '')
  final String? url;
  static const fromJsonFactory = _$ImageFromJson;
  static const toJsonFactory = _$ImageToJson;
  Map<String, dynamic> toJson() => _$ImageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Image &&
            (identical(other.width, width) ||
                const DeepCollectionEquality().equals(other.width, width)) &&
            (identical(other.height, height) ||
                const DeepCollectionEquality().equals(other.height, height)) &&
            (identical(other.url, url) ||
                const DeepCollectionEquality().equals(other.url, url)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(width) ^
      const DeepCollectionEquality().hash(height) ^
      const DeepCollectionEquality().hash(url) ^
      runtimeType.hashCode;
}

extension $ImageExtension on Image {
  Image copyWith({int? width, int? height, String? url}) {
    return Image(
        width: width ?? this.width,
        height: height ?? this.height,
        url: url ?? this.url);
  }

  Image copyWithWrapped(
      {Wrapped<int?>? width, Wrapped<int?>? height, Wrapped<String?>? url}) {
    return Image(
        width: (width != null ? width.value : this.width),
        height: (height != null ? height.value : this.height),
        url: (url != null ? url.value : this.url));
  }
}

@JsonSerializable(explicitToJson: true)
class ThemePage {
  ThemePage({
    this.link,
    required this.type,
    this.title,
    this.text,
    required this.colors,
    this.images,
    required this.linkType,
  });

  factory ThemePage.fromJson(Map<String, dynamic> json) =>
      _$ThemePageFromJson(json);

  @JsonKey(name: 'link', includeIfNull: false, defaultValue: '')
  final String? link;
  @JsonKey(
    name: 'type',
    includeIfNull: false,
    toJson: themePageTypeToJson,
    fromJson: themePageTypeFromJson,
  )
  final enums.ThemePageType type;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'text', includeIfNull: false, defaultValue: '')
  final String? text;
  @JsonKey(name: 'colors', includeIfNull: false)
  final Colors colors;
  @JsonKey(name: 'images', includeIfNull: false, defaultValue: <Image>[])
  final List<Image>? images;
  @JsonKey(
    name: 'linkType',
    includeIfNull: false,
    toJson: themePageLinkTypeToJson,
    fromJson: themePageLinkTypeFromJson,
  )
  final enums.ThemePageLinkType linkType;
  static const fromJsonFactory = _$ThemePageFromJson;
  static const toJsonFactory = _$ThemePageToJson;
  Map<String, dynamic> toJson() => _$ThemePageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ThemePage &&
            (identical(other.link, link) ||
                const DeepCollectionEquality().equals(other.link, link)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.text, text) ||
                const DeepCollectionEquality().equals(other.text, text)) &&
            (identical(other.colors, colors) ||
                const DeepCollectionEquality().equals(other.colors, colors)) &&
            (identical(other.images, images) ||
                const DeepCollectionEquality().equals(other.images, images)) &&
            (identical(other.linkType, linkType) ||
                const DeepCollectionEquality()
                    .equals(other.linkType, linkType)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(link) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(text) ^
      const DeepCollectionEquality().hash(colors) ^
      const DeepCollectionEquality().hash(images) ^
      const DeepCollectionEquality().hash(linkType) ^
      runtimeType.hashCode;
}

extension $ThemePageExtension on ThemePage {
  ThemePage copyWith(
      {String? link,
      enums.ThemePageType? type,
      String? title,
      String? text,
      Colors? colors,
      List<Image>? images,
      enums.ThemePageLinkType? linkType}) {
    return ThemePage(
        link: link ?? this.link,
        type: type ?? this.type,
        title: title ?? this.title,
        text: text ?? this.text,
        colors: colors ?? this.colors,
        images: images ?? this.images,
        linkType: linkType ?? this.linkType);
  }

  ThemePage copyWithWrapped(
      {Wrapped<String?>? link,
      Wrapped<enums.ThemePageType>? type,
      Wrapped<String?>? title,
      Wrapped<String?>? text,
      Wrapped<Colors>? colors,
      Wrapped<List<Image>?>? images,
      Wrapped<enums.ThemePageLinkType>? linkType}) {
    return ThemePage(
        link: (link != null ? link.value : this.link),
        type: (type != null ? type.value : this.type),
        title: (title != null ? title.value : this.title),
        text: (text != null ? text.value : this.text),
        colors: (colors != null ? colors.value : this.colors),
        images: (images != null ? images.value : this.images),
        linkType: (linkType != null ? linkType.value : this.linkType));
  }
}

@JsonSerializable(explicitToJson: true)
class HeroEditorial {
  HeroEditorial({
    this.image,
    this.title,
  });

  factory HeroEditorial.fromJson(Map<String, dynamic> json) =>
      _$HeroEditorialFromJson(json);

  @JsonKey(name: 'image', includeIfNull: false)
  final Image? image;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  static const fromJsonFactory = _$HeroEditorialFromJson;
  static const toJsonFactory = _$HeroEditorialToJson;
  Map<String, dynamic> toJson() => _$HeroEditorialToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is HeroEditorial &&
            (identical(other.image, image) ||
                const DeepCollectionEquality().equals(other.image, image)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(image) ^
      const DeepCollectionEquality().hash(title) ^
      runtimeType.hashCode;
}

extension $HeroEditorialExtension on HeroEditorial {
  HeroEditorial copyWith({Image? image, String? title}) {
    return HeroEditorial(
        image: image ?? this.image, title: title ?? this.title);
  }

  HeroEditorial copyWithWrapped(
      {Wrapped<Image?>? image, Wrapped<String?>? title}) {
    return HeroEditorial(
        image: (image != null ? image.value : this.image),
        title: (title != null ? title.value : this.title));
  }
}

@JsonSerializable(explicitToJson: true)
class ProductCard {
  ProductCard({
    required this.webshopId,
    required this.hqId,
    required this.title,
    this.specialDescription,
    this.salesUnitSize,
    this.unitPriceDescription,
    this.images,
    this.bonusStartDate,
    this.bonusEndDate,
    this.discountType,
    this.promotionType,
    this.segmentType,
    this.bonusMechanism,
    this.currentPrice,
    this.priceBeforeBonus,
    this.orderAvailabilityStatus,
    this.orderAvailabilityDescription,
    this.mainCategory,
    this.subCategory,
    this.subCategoryId,
    this.brand,
    this.shopType,
    this.bonusPeriodDescription,
    this.availableOnline,
    this.isPreviouslyBought,
    this.descriptionHighlights,
    this.propertyIcons,
    this.properties,
    this.nix18,
    this.isStapelBonus,
    this.extraDescriptions,
    this.bonusSegmentId,
    this.bonusSegmentDescription,
    this.isBonus,
    this.descriptionFull,
    required this.isOrderable,
    required this.isInfiniteBonus,
    required this.isSample,
    this.isBonusPrice,
  });

  factory ProductCard.fromJson(Map<String, dynamic> json) =>
      _$ProductCardFromJson(json);

  @JsonKey(name: 'webshopId', includeIfNull: false)
  final num webshopId;
  @JsonKey(name: 'hqId', includeIfNull: false)
  final num hqId;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  @JsonKey(name: 'specialDescription', includeIfNull: false, defaultValue: '')
  final String? specialDescription;
  @JsonKey(name: 'salesUnitSize', includeIfNull: false, defaultValue: '')
  final String? salesUnitSize;
  @JsonKey(name: 'unitPriceDescription', includeIfNull: false, defaultValue: '')
  final String? unitPriceDescription;
  @JsonKey(name: 'images', includeIfNull: false, defaultValue: <Image>[])
  final List<Image>? images;
  @JsonKey(name: 'bonusStartDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? bonusStartDate;
  @JsonKey(name: 'bonusEndDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? bonusEndDate;
  @JsonKey(name: 'discountType', includeIfNull: false, defaultValue: '')
  final String? discountType;
  @JsonKey(name: 'promotionType', includeIfNull: false, defaultValue: '')
  final String? promotionType;
  @JsonKey(name: 'segmentType', includeIfNull: false, defaultValue: '')
  final String? segmentType;
  @JsonKey(name: 'bonusMechanism', includeIfNull: false, defaultValue: '')
  final String? bonusMechanism;
  @JsonKey(name: 'currentPrice', includeIfNull: false)
  final double? currentPrice;
  @JsonKey(name: 'priceBeforeBonus', includeIfNull: false)
  final double? priceBeforeBonus;
  @JsonKey(
      name: 'orderAvailabilityStatus', includeIfNull: false, defaultValue: '')
  final String? orderAvailabilityStatus;
  @JsonKey(
      name: 'orderAvailabilityDescription',
      includeIfNull: false,
      defaultValue: '')
  final String? orderAvailabilityDescription;
  @JsonKey(name: 'mainCategory', includeIfNull: false, defaultValue: '')
  final String? mainCategory;
  @JsonKey(name: 'subCategory', includeIfNull: false, defaultValue: '')
  final String? subCategory;
  @JsonKey(name: 'subCategoryId', includeIfNull: false)
  final num? subCategoryId;
  @JsonKey(name: 'brand', includeIfNull: false, defaultValue: '')
  final String? brand;
  @JsonKey(name: 'shopType', includeIfNull: false, defaultValue: '')
  final String? shopType;
  @JsonKey(
      name: 'bonusPeriodDescription', includeIfNull: false, defaultValue: '')
  final String? bonusPeriodDescription;
  @JsonKey(name: 'availableOnline', includeIfNull: false)
  final bool? availableOnline;
  @JsonKey(name: 'isPreviouslyBought', includeIfNull: false)
  final bool? isPreviouslyBought;
  @JsonKey(
      name: 'descriptionHighlights', includeIfNull: false, defaultValue: '')
  final String? descriptionHighlights;
  @JsonKey(
      name: 'propertyIcons', includeIfNull: false, defaultValue: <String>[])
  final List<String>? propertyIcons;
  @JsonKey(name: 'properties', includeIfNull: false)
  final Map<String, dynamic>? properties;
  @JsonKey(name: 'nix18', includeIfNull: false)
  final bool? nix18;
  @JsonKey(name: 'isStapelBonus', includeIfNull: false)
  final bool? isStapelBonus;
  @JsonKey(
      name: 'extraDescriptions', includeIfNull: false, defaultValue: <String>[])
  final List<String>? extraDescriptions;
  @JsonKey(name: 'bonusSegmentId', includeIfNull: false)
  final num? bonusSegmentId;
  @JsonKey(
      name: 'bonusSegmentDescription', includeIfNull: false, defaultValue: '')
  final String? bonusSegmentDescription;
  @JsonKey(name: 'isBonus', includeIfNull: false)
  final bool? isBonus;
  @JsonKey(name: 'descriptionFull', includeIfNull: false, defaultValue: '')
  final String? descriptionFull;
  @JsonKey(name: 'isOrderable', includeIfNull: false)
  final bool isOrderable;
  @JsonKey(name: 'isInfiniteBonus', includeIfNull: false)
  final bool isInfiniteBonus;
  @JsonKey(name: 'isSample', includeIfNull: false)
  final bool isSample;
  @JsonKey(name: 'isBonusPrice', includeIfNull: false)
  final bool? isBonusPrice;
  static const fromJsonFactory = _$ProductCardFromJson;
  static const toJsonFactory = _$ProductCardToJson;
  Map<String, dynamic> toJson() => _$ProductCardToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProductCard &&
            (identical(other.webshopId, webshopId) ||
                const DeepCollectionEquality()
                    .equals(other.webshopId, webshopId)) &&
            (identical(other.hqId, hqId) ||
                const DeepCollectionEquality().equals(other.hqId, hqId)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.specialDescription, specialDescription) ||
                const DeepCollectionEquality()
                    .equals(other.specialDescription, specialDescription)) &&
            (identical(other.salesUnitSize, salesUnitSize) ||
                const DeepCollectionEquality()
                    .equals(other.salesUnitSize, salesUnitSize)) &&
            (identical(other.unitPriceDescription, unitPriceDescription) ||
                const DeepCollectionEquality().equals(
                    other.unitPriceDescription, unitPriceDescription)) &&
            (identical(other.images, images) ||
                const DeepCollectionEquality().equals(other.images, images)) &&
            (identical(other.bonusStartDate, bonusStartDate) ||
                const DeepCollectionEquality()
                    .equals(other.bonusStartDate, bonusStartDate)) &&
            (identical(other.bonusEndDate, bonusEndDate) ||
                const DeepCollectionEquality()
                    .equals(other.bonusEndDate, bonusEndDate)) &&
            (identical(other.discountType, discountType) ||
                const DeepCollectionEquality()
                    .equals(other.discountType, discountType)) &&
            (identical(other.promotionType, promotionType) ||
                const DeepCollectionEquality()
                    .equals(other.promotionType, promotionType)) &&
            (identical(other.segmentType, segmentType) ||
                const DeepCollectionEquality()
                    .equals(other.segmentType, segmentType)) &&
            (identical(other.bonusMechanism, bonusMechanism) ||
                const DeepCollectionEquality()
                    .equals(other.bonusMechanism, bonusMechanism)) &&
            (identical(other.currentPrice, currentPrice) ||
                const DeepCollectionEquality()
                    .equals(other.currentPrice, currentPrice)) &&
            (identical(other.priceBeforeBonus, priceBeforeBonus) ||
                const DeepCollectionEquality()
                    .equals(other.priceBeforeBonus, priceBeforeBonus)) &&
            (identical(other.orderAvailabilityStatus, orderAvailabilityStatus) ||
                const DeepCollectionEquality().equals(
                    other.orderAvailabilityStatus, orderAvailabilityStatus)) &&
            (identical(other.orderAvailabilityDescription, orderAvailabilityDescription) ||
                const DeepCollectionEquality().equals(
                    other.orderAvailabilityDescription,
                    orderAvailabilityDescription)) &&
            (identical(other.mainCategory, mainCategory) ||
                const DeepCollectionEquality()
                    .equals(other.mainCategory, mainCategory)) &&
            (identical(other.subCategory, subCategory) ||
                const DeepCollectionEquality()
                    .equals(other.subCategory, subCategory)) &&
            (identical(other.subCategoryId, subCategoryId) ||
                const DeepCollectionEquality()
                    .equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.brand, brand) ||
                const DeepCollectionEquality().equals(other.brand, brand)) &&
            (identical(other.shopType, shopType) ||
                const DeepCollectionEquality().equals(other.shopType, shopType)) &&
            (identical(other.bonusPeriodDescription, bonusPeriodDescription) || const DeepCollectionEquality().equals(other.bonusPeriodDescription, bonusPeriodDescription)) &&
            (identical(other.availableOnline, availableOnline) || const DeepCollectionEquality().equals(other.availableOnline, availableOnline)) &&
            (identical(other.isPreviouslyBought, isPreviouslyBought) || const DeepCollectionEquality().equals(other.isPreviouslyBought, isPreviouslyBought)) &&
            (identical(other.descriptionHighlights, descriptionHighlights) || const DeepCollectionEquality().equals(other.descriptionHighlights, descriptionHighlights)) &&
            (identical(other.propertyIcons, propertyIcons) || const DeepCollectionEquality().equals(other.propertyIcons, propertyIcons)) &&
            (identical(other.properties, properties) || const DeepCollectionEquality().equals(other.properties, properties)) &&
            (identical(other.nix18, nix18) || const DeepCollectionEquality().equals(other.nix18, nix18)) &&
            (identical(other.isStapelBonus, isStapelBonus) || const DeepCollectionEquality().equals(other.isStapelBonus, isStapelBonus)) &&
            (identical(other.extraDescriptions, extraDescriptions) || const DeepCollectionEquality().equals(other.extraDescriptions, extraDescriptions)) &&
            (identical(other.bonusSegmentId, bonusSegmentId) || const DeepCollectionEquality().equals(other.bonusSegmentId, bonusSegmentId)) &&
            (identical(other.bonusSegmentDescription, bonusSegmentDescription) || const DeepCollectionEquality().equals(other.bonusSegmentDescription, bonusSegmentDescription)) &&
            (identical(other.isBonus, isBonus) || const DeepCollectionEquality().equals(other.isBonus, isBonus)) &&
            (identical(other.descriptionFull, descriptionFull) || const DeepCollectionEquality().equals(other.descriptionFull, descriptionFull)) &&
            (identical(other.isOrderable, isOrderable) || const DeepCollectionEquality().equals(other.isOrderable, isOrderable)) &&
            (identical(other.isInfiniteBonus, isInfiniteBonus) || const DeepCollectionEquality().equals(other.isInfiniteBonus, isInfiniteBonus)) &&
            (identical(other.isSample, isSample) || const DeepCollectionEquality().equals(other.isSample, isSample)) &&
            (identical(other.isBonusPrice, isBonusPrice) || const DeepCollectionEquality().equals(other.isBonusPrice, isBonusPrice)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(webshopId) ^
      const DeepCollectionEquality().hash(hqId) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(specialDescription) ^
      const DeepCollectionEquality().hash(salesUnitSize) ^
      const DeepCollectionEquality().hash(unitPriceDescription) ^
      const DeepCollectionEquality().hash(images) ^
      const DeepCollectionEquality().hash(bonusStartDate) ^
      const DeepCollectionEquality().hash(bonusEndDate) ^
      const DeepCollectionEquality().hash(discountType) ^
      const DeepCollectionEquality().hash(promotionType) ^
      const DeepCollectionEquality().hash(segmentType) ^
      const DeepCollectionEquality().hash(bonusMechanism) ^
      const DeepCollectionEquality().hash(currentPrice) ^
      const DeepCollectionEquality().hash(priceBeforeBonus) ^
      const DeepCollectionEquality().hash(orderAvailabilityStatus) ^
      const DeepCollectionEquality().hash(orderAvailabilityDescription) ^
      const DeepCollectionEquality().hash(mainCategory) ^
      const DeepCollectionEquality().hash(subCategory) ^
      const DeepCollectionEquality().hash(subCategoryId) ^
      const DeepCollectionEquality().hash(brand) ^
      const DeepCollectionEquality().hash(shopType) ^
      const DeepCollectionEquality().hash(bonusPeriodDescription) ^
      const DeepCollectionEquality().hash(availableOnline) ^
      const DeepCollectionEquality().hash(isPreviouslyBought) ^
      const DeepCollectionEquality().hash(descriptionHighlights) ^
      const DeepCollectionEquality().hash(propertyIcons) ^
      const DeepCollectionEquality().hash(properties) ^
      const DeepCollectionEquality().hash(nix18) ^
      const DeepCollectionEquality().hash(isStapelBonus) ^
      const DeepCollectionEquality().hash(extraDescriptions) ^
      const DeepCollectionEquality().hash(bonusSegmentId) ^
      const DeepCollectionEquality().hash(bonusSegmentDescription) ^
      const DeepCollectionEquality().hash(isBonus) ^
      const DeepCollectionEquality().hash(descriptionFull) ^
      const DeepCollectionEquality().hash(isOrderable) ^
      const DeepCollectionEquality().hash(isInfiniteBonus) ^
      const DeepCollectionEquality().hash(isSample) ^
      const DeepCollectionEquality().hash(isBonusPrice) ^
      runtimeType.hashCode;
}

extension $ProductCardExtension on ProductCard {
  ProductCard copyWith(
      {num? webshopId,
      num? hqId,
      String? title,
      String? specialDescription,
      String? salesUnitSize,
      String? unitPriceDescription,
      List<Image>? images,
      DateTime? bonusStartDate,
      DateTime? bonusEndDate,
      String? discountType,
      String? promotionType,
      String? segmentType,
      String? bonusMechanism,
      double? currentPrice,
      double? priceBeforeBonus,
      String? orderAvailabilityStatus,
      String? orderAvailabilityDescription,
      String? mainCategory,
      String? subCategory,
      num? subCategoryId,
      String? brand,
      String? shopType,
      String? bonusPeriodDescription,
      bool? availableOnline,
      bool? isPreviouslyBought,
      String? descriptionHighlights,
      List<String>? propertyIcons,
      Map<String, dynamic>? properties,
      bool? nix18,
      bool? isStapelBonus,
      List<String>? extraDescriptions,
      num? bonusSegmentId,
      String? bonusSegmentDescription,
      bool? isBonus,
      String? descriptionFull,
      bool? isOrderable,
      bool? isInfiniteBonus,
      bool? isSample,
      bool? isBonusPrice}) {
    return ProductCard(
        webshopId: webshopId ?? this.webshopId,
        hqId: hqId ?? this.hqId,
        title: title ?? this.title,
        specialDescription: specialDescription ?? this.specialDescription,
        salesUnitSize: salesUnitSize ?? this.salesUnitSize,
        unitPriceDescription: unitPriceDescription ?? this.unitPriceDescription,
        images: images ?? this.images,
        bonusStartDate: bonusStartDate ?? this.bonusStartDate,
        bonusEndDate: bonusEndDate ?? this.bonusEndDate,
        discountType: discountType ?? this.discountType,
        promotionType: promotionType ?? this.promotionType,
        segmentType: segmentType ?? this.segmentType,
        bonusMechanism: bonusMechanism ?? this.bonusMechanism,
        currentPrice: currentPrice ?? this.currentPrice,
        priceBeforeBonus: priceBeforeBonus ?? this.priceBeforeBonus,
        orderAvailabilityStatus:
            orderAvailabilityStatus ?? this.orderAvailabilityStatus,
        orderAvailabilityDescription:
            orderAvailabilityDescription ?? this.orderAvailabilityDescription,
        mainCategory: mainCategory ?? this.mainCategory,
        subCategory: subCategory ?? this.subCategory,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        brand: brand ?? this.brand,
        shopType: shopType ?? this.shopType,
        bonusPeriodDescription:
            bonusPeriodDescription ?? this.bonusPeriodDescription,
        availableOnline: availableOnline ?? this.availableOnline,
        isPreviouslyBought: isPreviouslyBought ?? this.isPreviouslyBought,
        descriptionHighlights:
            descriptionHighlights ?? this.descriptionHighlights,
        propertyIcons: propertyIcons ?? this.propertyIcons,
        properties: properties ?? this.properties,
        nix18: nix18 ?? this.nix18,
        isStapelBonus: isStapelBonus ?? this.isStapelBonus,
        extraDescriptions: extraDescriptions ?? this.extraDescriptions,
        bonusSegmentId: bonusSegmentId ?? this.bonusSegmentId,
        bonusSegmentDescription:
            bonusSegmentDescription ?? this.bonusSegmentDescription,
        isBonus: isBonus ?? this.isBonus,
        descriptionFull: descriptionFull ?? this.descriptionFull,
        isOrderable: isOrderable ?? this.isOrderable,
        isInfiniteBonus: isInfiniteBonus ?? this.isInfiniteBonus,
        isSample: isSample ?? this.isSample,
        isBonusPrice: isBonusPrice ?? this.isBonusPrice);
  }

  ProductCard copyWithWrapped(
      {Wrapped<num>? webshopId,
      Wrapped<num>? hqId,
      Wrapped<String>? title,
      Wrapped<String?>? specialDescription,
      Wrapped<String?>? salesUnitSize,
      Wrapped<String?>? unitPriceDescription,
      Wrapped<List<Image>?>? images,
      Wrapped<DateTime?>? bonusStartDate,
      Wrapped<DateTime?>? bonusEndDate,
      Wrapped<String?>? discountType,
      Wrapped<String?>? promotionType,
      Wrapped<String?>? segmentType,
      Wrapped<String?>? bonusMechanism,
      Wrapped<double?>? currentPrice,
      Wrapped<double?>? priceBeforeBonus,
      Wrapped<String?>? orderAvailabilityStatus,
      Wrapped<String?>? orderAvailabilityDescription,
      Wrapped<String?>? mainCategory,
      Wrapped<String?>? subCategory,
      Wrapped<num?>? subCategoryId,
      Wrapped<String?>? brand,
      Wrapped<String?>? shopType,
      Wrapped<String?>? bonusPeriodDescription,
      Wrapped<bool?>? availableOnline,
      Wrapped<bool?>? isPreviouslyBought,
      Wrapped<String?>? descriptionHighlights,
      Wrapped<List<String>?>? propertyIcons,
      Wrapped<Map<String, dynamic>?>? properties,
      Wrapped<bool?>? nix18,
      Wrapped<bool?>? isStapelBonus,
      Wrapped<List<String>?>? extraDescriptions,
      Wrapped<num?>? bonusSegmentId,
      Wrapped<String?>? bonusSegmentDescription,
      Wrapped<bool?>? isBonus,
      Wrapped<String?>? descriptionFull,
      Wrapped<bool>? isOrderable,
      Wrapped<bool>? isInfiniteBonus,
      Wrapped<bool>? isSample,
      Wrapped<bool?>? isBonusPrice}) {
    return ProductCard(
        webshopId: (webshopId != null ? webshopId.value : this.webshopId),
        hqId: (hqId != null ? hqId.value : this.hqId),
        title: (title != null ? title.value : this.title),
        specialDescription: (specialDescription != null
            ? specialDescription.value
            : this.specialDescription),
        salesUnitSize:
            (salesUnitSize != null ? salesUnitSize.value : this.salesUnitSize),
        unitPriceDescription: (unitPriceDescription != null
            ? unitPriceDescription.value
            : this.unitPriceDescription),
        images: (images != null ? images.value : this.images),
        bonusStartDate: (bonusStartDate != null
            ? bonusStartDate.value
            : this.bonusStartDate),
        bonusEndDate:
            (bonusEndDate != null ? bonusEndDate.value : this.bonusEndDate),
        discountType:
            (discountType != null ? discountType.value : this.discountType),
        promotionType:
            (promotionType != null ? promotionType.value : this.promotionType),
        segmentType:
            (segmentType != null ? segmentType.value : this.segmentType),
        bonusMechanism: (bonusMechanism != null
            ? bonusMechanism.value
            : this.bonusMechanism),
        currentPrice:
            (currentPrice != null ? currentPrice.value : this.currentPrice),
        priceBeforeBonus: (priceBeforeBonus != null
            ? priceBeforeBonus.value
            : this.priceBeforeBonus),
        orderAvailabilityStatus: (orderAvailabilityStatus != null
            ? orderAvailabilityStatus.value
            : this.orderAvailabilityStatus),
        orderAvailabilityDescription: (orderAvailabilityDescription != null
            ? orderAvailabilityDescription.value
            : this.orderAvailabilityDescription),
        mainCategory:
            (mainCategory != null ? mainCategory.value : this.mainCategory),
        subCategory:
            (subCategory != null ? subCategory.value : this.subCategory),
        subCategoryId:
            (subCategoryId != null ? subCategoryId.value : this.subCategoryId),
        brand: (brand != null ? brand.value : this.brand),
        shopType: (shopType != null ? shopType.value : this.shopType),
        bonusPeriodDescription: (bonusPeriodDescription != null
            ? bonusPeriodDescription.value
            : this.bonusPeriodDescription),
        availableOnline: (availableOnline != null
            ? availableOnline.value
            : this.availableOnline),
        isPreviouslyBought: (isPreviouslyBought != null
            ? isPreviouslyBought.value
            : this.isPreviouslyBought),
        descriptionHighlights: (descriptionHighlights != null
            ? descriptionHighlights.value
            : this.descriptionHighlights),
        propertyIcons:
            (propertyIcons != null ? propertyIcons.value : this.propertyIcons),
        properties: (properties != null ? properties.value : this.properties),
        nix18: (nix18 != null ? nix18.value : this.nix18),
        isStapelBonus:
            (isStapelBonus != null ? isStapelBonus.value : this.isStapelBonus),
        extraDescriptions: (extraDescriptions != null
            ? extraDescriptions.value
            : this.extraDescriptions),
        bonusSegmentId: (bonusSegmentId != null
            ? bonusSegmentId.value
            : this.bonusSegmentId),
        bonusSegmentDescription: (bonusSegmentDescription != null
            ? bonusSegmentDescription.value
            : this.bonusSegmentDescription),
        isBonus: (isBonus != null ? isBonus.value : this.isBonus),
        descriptionFull: (descriptionFull != null
            ? descriptionFull.value
            : this.descriptionFull),
        isOrderable:
            (isOrderable != null ? isOrderable.value : this.isOrderable),
        isInfiniteBonus: (isInfiniteBonus != null
            ? isInfiniteBonus.value
            : this.isInfiniteBonus),
        isSample: (isSample != null ? isSample.value : this.isSample),
        isBonusPrice:
            (isBonusPrice != null ? isBonusPrice.value : this.isBonusPrice));
  }
}

@JsonSerializable(explicitToJson: true)
class ProductGridLane {
  ProductGridLane({
    this.title,
    this.maxRows,
    this.products,
  });

  factory ProductGridLane.fromJson(Map<String, dynamic> json) =>
      _$ProductGridLaneFromJson(json);

  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'maxRows', includeIfNull: false)
  final int? maxRows;
  @JsonKey(
      name: 'products', includeIfNull: false, defaultValue: <ProductCard>[])
  final List<ProductCard>? products;
  static const fromJsonFactory = _$ProductGridLaneFromJson;
  static const toJsonFactory = _$ProductGridLaneToJson;
  Map<String, dynamic> toJson() => _$ProductGridLaneToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProductGridLane &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.maxRows, maxRows) ||
                const DeepCollectionEquality()
                    .equals(other.maxRows, maxRows)) &&
            (identical(other.products, products) ||
                const DeepCollectionEquality()
                    .equals(other.products, products)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(maxRows) ^
      const DeepCollectionEquality().hash(products) ^
      runtimeType.hashCode;
}

extension $ProductGridLaneExtension on ProductGridLane {
  ProductGridLane copyWith(
      {String? title, int? maxRows, List<ProductCard>? products}) {
    return ProductGridLane(
        title: title ?? this.title,
        maxRows: maxRows ?? this.maxRows,
        products: products ?? this.products);
  }

  ProductGridLane copyWithWrapped(
      {Wrapped<String?>? title,
      Wrapped<int?>? maxRows,
      Wrapped<List<ProductCard>?>? products}) {
    return ProductGridLane(
        title: (title != null ? title.value : this.title),
        maxRows: (maxRows != null ? maxRows.value : this.maxRows),
        products: (products != null ? products.value : this.products));
  }
}

@JsonSerializable(explicitToJson: true)
class Section {
  Section({
    this.paragraphs,
    this.image,
  });

  factory Section.fromJson(Map<String, dynamic> json) =>
      _$SectionFromJson(json);

  @JsonKey(name: 'paragraphs', includeIfNull: false, defaultValue: <String>[])
  final List<String>? paragraphs;
  @JsonKey(name: 'image', includeIfNull: false)
  final Image? image;
  static const fromJsonFactory = _$SectionFromJson;
  static const toJsonFactory = _$SectionToJson;
  Map<String, dynamic> toJson() => _$SectionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Section &&
            (identical(other.paragraphs, paragraphs) ||
                const DeepCollectionEquality()
                    .equals(other.paragraphs, paragraphs)) &&
            (identical(other.image, image) ||
                const DeepCollectionEquality().equals(other.image, image)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(paragraphs) ^
      const DeepCollectionEquality().hash(image) ^
      runtimeType.hashCode;
}

extension $SectionExtension on Section {
  Section copyWith({List<String>? paragraphs, Image? image}) {
    return Section(
        paragraphs: paragraphs ?? this.paragraphs, image: image ?? this.image);
  }

  Section copyWithWrapped(
      {Wrapped<List<String>?>? paragraphs, Wrapped<Image?>? image}) {
    return Section(
        paragraphs: (paragraphs != null ? paragraphs.value : this.paragraphs),
        image: (image != null ? image.value : this.image));
  }
}

@JsonSerializable(explicitToJson: true)
class Story {
  Story({
    this.title,
    this.subTitle,
    this.sections,
  });

  factory Story.fromJson(Map<String, dynamic> json) => _$StoryFromJson(json);

  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'subTitle', includeIfNull: false, defaultValue: '')
  final String? subTitle;
  @JsonKey(name: 'sections', includeIfNull: false, defaultValue: <Section>[])
  final List<Section>? sections;
  static const fromJsonFactory = _$StoryFromJson;
  static const toJsonFactory = _$StoryToJson;
  Map<String, dynamic> toJson() => _$StoryToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Story &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.subTitle, subTitle) ||
                const DeepCollectionEquality()
                    .equals(other.subTitle, subTitle)) &&
            (identical(other.sections, sections) ||
                const DeepCollectionEquality()
                    .equals(other.sections, sections)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(subTitle) ^
      const DeepCollectionEquality().hash(sections) ^
      runtimeType.hashCode;
}

extension $StoryExtension on Story {
  Story copyWith({String? title, String? subTitle, List<Section>? sections}) {
    return Story(
        title: title ?? this.title,
        subTitle: subTitle ?? this.subTitle,
        sections: sections ?? this.sections);
  }

  Story copyWithWrapped(
      {Wrapped<String?>? title,
      Wrapped<String?>? subTitle,
      Wrapped<List<Section>?>? sections}) {
    return Story(
        title: (title != null ? title.value : this.title),
        subTitle: (subTitle != null ? subTitle.value : this.subTitle),
        sections: (sections != null ? sections.value : this.sections));
  }
}

@JsonSerializable(explicitToJson: true)
class StoryLane {
  StoryLane({
    this.title,
    this.subtitle,
    this.stories,
  });

  factory StoryLane.fromJson(Map<String, dynamic> json) =>
      _$StoryLaneFromJson(json);

  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'subtitle', includeIfNull: false, defaultValue: '')
  final String? subtitle;
  @JsonKey(name: 'stories', includeIfNull: false, defaultValue: <Story>[])
  final List<Story>? stories;
  static const fromJsonFactory = _$StoryLaneFromJson;
  static const toJsonFactory = _$StoryLaneToJson;
  Map<String, dynamic> toJson() => _$StoryLaneToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StoryLane &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.subtitle, subtitle) ||
                const DeepCollectionEquality()
                    .equals(other.subtitle, subtitle)) &&
            (identical(other.stories, stories) ||
                const DeepCollectionEquality().equals(other.stories, stories)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(subtitle) ^
      const DeepCollectionEquality().hash(stories) ^
      runtimeType.hashCode;
}

extension $StoryLaneExtension on StoryLane {
  StoryLane copyWith({String? title, String? subtitle, List<Story>? stories}) {
    return StoryLane(
        title: title ?? this.title,
        subtitle: subtitle ?? this.subtitle,
        stories: stories ?? this.stories);
  }

  StoryLane copyWithWrapped(
      {Wrapped<String?>? title,
      Wrapped<String?>? subtitle,
      Wrapped<List<Story>?>? stories}) {
    return StoryLane(
        title: (title != null ? title.value : this.title),
        subtitle: (subtitle != null ? subtitle.value : this.subtitle),
        stories: (stories != null ? stories.value : this.stories));
  }
}

@JsonSerializable(explicitToJson: true)
class ThemePageArticle {
  ThemePageArticle({
    this.productGridLane,
    this.themePageGridLane,
    this.storyGridLane,
    this.heroEditorial,
  });

  factory ThemePageArticle.fromJson(Map<String, dynamic> json) =>
      _$ThemePageArticleFromJson(json);

  @JsonKey(name: 'productGridLane', includeIfNull: false)
  final ProductGridLane? productGridLane;
  @JsonKey(name: 'themePageGridLane', includeIfNull: false)
  final ThemePageGridLane? themePageGridLane;
  @JsonKey(name: 'storyGridLane', includeIfNull: false)
  final StoryLane? storyGridLane;
  @JsonKey(name: 'heroEditorial', includeIfNull: false)
  final HeroEditorial? heroEditorial;
  static const fromJsonFactory = _$ThemePageArticleFromJson;
  static const toJsonFactory = _$ThemePageArticleToJson;
  Map<String, dynamic> toJson() => _$ThemePageArticleToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ThemePageArticle &&
            (identical(other.productGridLane, productGridLane) ||
                const DeepCollectionEquality()
                    .equals(other.productGridLane, productGridLane)) &&
            (identical(other.themePageGridLane, themePageGridLane) ||
                const DeepCollectionEquality()
                    .equals(other.themePageGridLane, themePageGridLane)) &&
            (identical(other.storyGridLane, storyGridLane) ||
                const DeepCollectionEquality()
                    .equals(other.storyGridLane, storyGridLane)) &&
            (identical(other.heroEditorial, heroEditorial) ||
                const DeepCollectionEquality()
                    .equals(other.heroEditorial, heroEditorial)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(productGridLane) ^
      const DeepCollectionEquality().hash(themePageGridLane) ^
      const DeepCollectionEquality().hash(storyGridLane) ^
      const DeepCollectionEquality().hash(heroEditorial) ^
      runtimeType.hashCode;
}

extension $ThemePageArticleExtension on ThemePageArticle {
  ThemePageArticle copyWith(
      {ProductGridLane? productGridLane,
      ThemePageGridLane? themePageGridLane,
      StoryLane? storyGridLane,
      HeroEditorial? heroEditorial}) {
    return ThemePageArticle(
        productGridLane: productGridLane ?? this.productGridLane,
        themePageGridLane: themePageGridLane ?? this.themePageGridLane,
        storyGridLane: storyGridLane ?? this.storyGridLane,
        heroEditorial: heroEditorial ?? this.heroEditorial);
  }

  ThemePageArticle copyWithWrapped(
      {Wrapped<ProductGridLane?>? productGridLane,
      Wrapped<ThemePageGridLane?>? themePageGridLane,
      Wrapped<StoryLane?>? storyGridLane,
      Wrapped<HeroEditorial?>? heroEditorial}) {
    return ThemePageArticle(
        productGridLane: (productGridLane != null
            ? productGridLane.value
            : this.productGridLane),
        themePageGridLane: (themePageGridLane != null
            ? themePageGridLane.value
            : this.themePageGridLane),
        storyGridLane:
            (storyGridLane != null ? storyGridLane.value : this.storyGridLane),
        heroEditorial:
            (heroEditorial != null ? heroEditorial.value : this.heroEditorial));
  }
}

@JsonSerializable(explicitToJson: true)
class ThemePageGridLane {
  ThemePageGridLane({
    this.themePages,
  });

  factory ThemePageGridLane.fromJson(Map<String, dynamic> json) =>
      _$ThemePageGridLaneFromJson(json);

  @JsonKey(
      name: 'themePages', includeIfNull: false, defaultValue: <ThemePage>[])
  final List<ThemePage>? themePages;
  static const fromJsonFactory = _$ThemePageGridLaneFromJson;
  static const toJsonFactory = _$ThemePageGridLaneToJson;
  Map<String, dynamic> toJson() => _$ThemePageGridLaneToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ThemePageGridLane &&
            (identical(other.themePages, themePages) ||
                const DeepCollectionEquality()
                    .equals(other.themePages, themePages)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(themePages) ^ runtimeType.hashCode;
}

extension $ThemePageGridLaneExtension on ThemePageGridLane {
  ThemePageGridLane copyWith({List<ThemePage>? themePages}) {
    return ThemePageGridLane(themePages: themePages ?? this.themePages);
  }

  ThemePageGridLane copyWithWrapped({Wrapped<List<ThemePage>?>? themePages}) {
    return ThemePageGridLane(
        themePages: (themePages != null ? themePages.value : this.themePages));
  }
}

@JsonSerializable(explicitToJson: true)
class ErrorJson {
  ErrorJson({
    this.status,
    this.error,
    this.message,
  });

  factory ErrorJson.fromJson(Map<String, dynamic> json) =>
      _$ErrorJsonFromJson(json);

  @JsonKey(name: 'status', includeIfNull: false)
  final int? status;
  @JsonKey(name: 'error', includeIfNull: false, defaultValue: '')
  final String? error;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  static const fromJsonFactory = _$ErrorJsonFromJson;
  static const toJsonFactory = _$ErrorJsonToJson;
  Map<String, dynamic> toJson() => _$ErrorJsonToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ErrorJson &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.error, error) ||
                const DeepCollectionEquality().equals(other.error, error)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality().equals(other.message, message)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(error) ^
      const DeepCollectionEquality().hash(message) ^
      runtimeType.hashCode;
}

extension $ErrorJsonExtension on ErrorJson {
  ErrorJson copyWith({int? status, String? error, String? message}) {
    return ErrorJson(
        status: status ?? this.status,
        error: error ?? this.error,
        message: message ?? this.message);
  }

  ErrorJson copyWithWrapped(
      {Wrapped<int?>? status,
      Wrapped<String?>? error,
      Wrapped<String?>? message}) {
    return ErrorJson(
        status: (status != null ? status.value : this.status),
        error: (error != null ? error.value : this.error),
        message: (message != null ? message.value : this.message));
  }
}

String? themePageTypeToJson(enums.ThemePageType? themePageType) {
  return enums.$ThemePageTypeMap[themePageType];
}

enums.ThemePageType themePageTypeFromJson(
  Object? themePageType, [
  enums.ThemePageType? defaultValue,
]) {
  if (themePageType is String) {
    return enums.$ThemePageTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == themePageType.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.ThemePageType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ThemePageTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ThemePageType.swaggerGeneratedUnknown;
}

List<String> themePageTypeListToJson(List<enums.ThemePageType>? themePageType) {
  if (themePageType == null) {
    return [];
  }

  return themePageType.map((e) => enums.$ThemePageTypeMap[e]!).toList();
}

List<enums.ThemePageType> themePageTypeListFromJson(
  List? themePageType, [
  List<enums.ThemePageType>? defaultValue,
]) {
  if (themePageType == null) {
    return defaultValue ?? [];
  }

  return themePageType.map((e) => themePageTypeFromJson(e.toString())).toList();
}

List<enums.ThemePageType>? themePageTypeNullableListFromJson(
  List? themePageType, [
  List<enums.ThemePageType>? defaultValue,
]) {
  if (themePageType == null) {
    return defaultValue;
  }

  return themePageType.map((e) => themePageTypeFromJson(e.toString())).toList();
}

String? themePageLinkTypeToJson(enums.ThemePageLinkType? themePageLinkType) {
  return enums.$ThemePageLinkTypeMap[themePageLinkType];
}

enums.ThemePageLinkType themePageLinkTypeFromJson(
  Object? themePageLinkType, [
  enums.ThemePageLinkType? defaultValue,
]) {
  if (themePageLinkType is String) {
    return enums.$ThemePageLinkTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == themePageLinkType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ThemePageLinkType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ThemePageLinkTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ThemePageLinkType.swaggerGeneratedUnknown;
}

List<String> themePageLinkTypeListToJson(
    List<enums.ThemePageLinkType>? themePageLinkType) {
  if (themePageLinkType == null) {
    return [];
  }

  return themePageLinkType.map((e) => enums.$ThemePageLinkTypeMap[e]!).toList();
}

List<enums.ThemePageLinkType> themePageLinkTypeListFromJson(
  List? themePageLinkType, [
  List<enums.ThemePageLinkType>? defaultValue,
]) {
  if (themePageLinkType == null) {
    return defaultValue ?? [];
  }

  return themePageLinkType
      .map((e) => themePageLinkTypeFromJson(e.toString()))
      .toList();
}

List<enums.ThemePageLinkType>? themePageLinkTypeNullableListFromJson(
  List? themePageLinkType, [
  List<enums.ThemePageLinkType>? defaultValue,
]) {
  if (themePageLinkType == null) {
    return defaultValue;
  }

  return themePageLinkType
      .map((e) => themePageLinkTypeFromJson(e.toString()))
      .toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
