// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'version_control_remote_data_source.enums.swagger.dart' as enums;
export 'version_control_remote_data_source.enums.swagger.dart';

part 'version_control_remote_data_source.swagger.chopper.dart';
part 'version_control_remote_data_source.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class VersionControlRemoteDataSource extends ChopperService {
  static VersionControlRemoteDataSource create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$VersionControlRemoteDataSource(client);
    }

    final newClient = ChopperClient(
        services: [_$VersionControlRemoteDataSource()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ??
            'http://appie-version-control-service.ah-tst.k8s.digitaldev.nl/');
    return _$VersionControlRemoteDataSource(newClient);
  }

  ///error
  Future<chopper.Response<Object>> errorGet({
    String? xAuthorization,
    String? cacheControl,
  }) {
    return _errorGet(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///error
  @Get(path: '/error')
  Future<chopper.Response<Object>> _errorGet({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///error
  Future<chopper.Response<Object>> errorHead({
    String? xAuthorization,
    String? cacheControl,
  }) {
    return _errorHead(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///error
  @Head(path: '/error')
  Future<chopper.Response<Object>> _errorHead({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///error
  Future<chopper.Response<Object>> errorPost({
    String? xAuthorization,
    String? cacheControl,
  }) {
    return _errorPost(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///error
  @Post(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<Object>> _errorPost({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///error
  Future<chopper.Response<Object>> errorPut({
    String? xAuthorization,
    String? cacheControl,
  }) {
    return _errorPut(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///error
  @Put(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<Object>> _errorPut({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///error
  Future<chopper.Response<Object>> errorDelete({
    String? xAuthorization,
    String? cacheControl,
  }) {
    return _errorDelete(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///error
  @Delete(path: '/error')
  Future<chopper.Response<Object>> _errorDelete({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///error
  Future<chopper.Response<Object>> errorPatch({
    String? xAuthorization,
    String? cacheControl,
  }) {
    return _errorPatch(
        xAuthorization: xAuthorization, cacheControl: cacheControl);
  }

  ///error
  @Patch(
    path: '/error',
    optionalBody: true,
  )
  Future<chopper.Response<Object>> _errorPatch({
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///List<String>
  ///@param clientName clientName
  ///@param clientVersion clientVersion
  Future<chopper.Response<String>> versioncheckV1VersionUtilCheckGet({
    required String? clientName,
    required String? clientVersion,
    String? xAuthorization,
    String? cacheControl,
  }) {
    return _versioncheckV1VersionUtilCheckGet(
        clientName: clientName,
        clientVersion: clientVersion,
        xAuthorization: xAuthorization,
        cacheControl: cacheControl);
  }

  ///List<String>
  ///@param clientName clientName
  ///@param clientVersion clientVersion
  @Get(path: '/versioncheck/v1/version-util/check')
  Future<chopper.Response<String>> _versioncheckV1VersionUtilCheckGet({
    @Query('clientName') required String? clientName,
    @Query('clientVersion') required String? clientVersion,
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///List<String>
  ///@param clientName clientName
  ///@param clientVersion clientVersion
  Future<chopper.Response<String>>
      versioncheckV2ClientNameClientVersionCheckGet({
    required String? clientName,
    required String? clientVersion,
    String? xAuthorization,
    String? cacheControl,
  }) {
    return _versioncheckV2ClientNameClientVersionCheckGet(
        clientName: clientName,
        clientVersion: clientVersion,
        xAuthorization: xAuthorization,
        cacheControl: cacheControl);
  }

  ///List<String>
  ///@param clientName clientName
  ///@param clientVersion clientVersion
  @Get(path: '/versioncheck/v2/{clientName}/{clientVersion}/check')
  Future<chopper.Response<String>>
      _versioncheckV2ClientNameClientVersionCheckGet({
    @Path('clientName') required String? clientName,
    @Path('clientVersion') required String? clientVersion,
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Check if app version is supported
  ///@param clientName One of the predefined names indicating app/OS combination: 'android' (for appie), 'ipad' (for appie iOS), 'essentials-ios' or 'essentials-android'. In any other case, the version will always be indicated as supported.
  ///@param clientVersion The version of the app to be checked, which must conform the regular expression of: '[0-9*]+(.[0-9*]+)*'
  ///@param x-application Based on the application the CMS channel will be determined and passed to Hippo to fetch the proper document.
  Future<chopper.Response<VersionSupportResponse>>
      versioncheckV3ClientNameClientVersionCheckGet({
    required String? clientName,
    required String? clientVersion,
    String? xApplication,
    String? xAuthorization,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        VersionSupportResponse, () => VersionSupportResponse.fromJsonFactory);

    return _versioncheckV3ClientNameClientVersionCheckGet(
        clientName: clientName,
        clientVersion: clientVersion,
        xApplication: xApplication,
        xAuthorization: xAuthorization,
        cacheControl: cacheControl);
  }

  ///Check if app version is supported
  ///@param clientName One of the predefined names indicating app/OS combination: 'android' (for appie), 'ipad' (for appie iOS), 'essentials-ios' or 'essentials-android'. In any other case, the version will always be indicated as supported.
  ///@param clientVersion The version of the app to be checked, which must conform the regular expression of: '[0-9*]+(.[0-9*]+)*'
  ///@param x-application Based on the application the CMS channel will be determined and passed to Hippo to fetch the proper document.
  @Get(path: '/versioncheck/v3/{clientName}/{clientVersion}/check')
  Future<chopper.Response<VersionSupportResponse>>
      _versioncheckV3ClientNameClientVersionCheckGet({
    @Path('clientName') required String? clientName,
    @Path('clientVersion') required String? clientVersion,
    @Header('x-application') String? xApplication,
    @Header('x-authorization') String? xAuthorization,
    @Header('Cache-Control') String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class ModelAndView {
  ModelAndView({
    this.empty,
    this.model,
    this.modelMap,
    this.reference,
    this.status,
    this.view,
    this.viewName,
  });

  factory ModelAndView.fromJson(Map<String, dynamic> json) =>
      _$ModelAndViewFromJson(json);

  @JsonKey(name: 'empty', includeIfNull: false)
  final bool? empty;
  @JsonKey(name: 'model', includeIfNull: false)
  final Object? model;
  @JsonKey(name: 'modelMap', includeIfNull: false)
  final Map<String, dynamic>? modelMap;
  @JsonKey(name: 'reference', includeIfNull: false)
  final bool? reference;
  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: modelAndViewStatusToJson,
    fromJson: modelAndViewStatusFromJson,
  )
  final enums.ModelAndViewStatus? status;
  @JsonKey(name: 'view', includeIfNull: false)
  final View? view;
  @JsonKey(name: 'viewName', includeIfNull: false, defaultValue: '')
  final String? viewName;
  static const fromJsonFactory = _$ModelAndViewFromJson;
  static const toJsonFactory = _$ModelAndViewToJson;
  Map<String, dynamic> toJson() => _$ModelAndViewToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ModelAndView &&
            (identical(other.empty, empty) ||
                const DeepCollectionEquality().equals(other.empty, empty)) &&
            (identical(other.model, model) ||
                const DeepCollectionEquality().equals(other.model, model)) &&
            (identical(other.modelMap, modelMap) ||
                const DeepCollectionEquality()
                    .equals(other.modelMap, modelMap)) &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.view, view) ||
                const DeepCollectionEquality().equals(other.view, view)) &&
            (identical(other.viewName, viewName) ||
                const DeepCollectionEquality()
                    .equals(other.viewName, viewName)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(empty) ^
      const DeepCollectionEquality().hash(model) ^
      const DeepCollectionEquality().hash(modelMap) ^
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(view) ^
      const DeepCollectionEquality().hash(viewName) ^
      runtimeType.hashCode;
}

extension $ModelAndViewExtension on ModelAndView {
  ModelAndView copyWith(
      {bool? empty,
      Object? model,
      Map<String, dynamic>? modelMap,
      bool? reference,
      enums.ModelAndViewStatus? status,
      View? view,
      String? viewName}) {
    return ModelAndView(
        empty: empty ?? this.empty,
        model: model ?? this.model,
        modelMap: modelMap ?? this.modelMap,
        reference: reference ?? this.reference,
        status: status ?? this.status,
        view: view ?? this.view,
        viewName: viewName ?? this.viewName);
  }

  ModelAndView copyWithWrapped(
      {Wrapped<bool?>? empty,
      Wrapped<Object?>? model,
      Wrapped<Map<String, dynamic>?>? modelMap,
      Wrapped<bool?>? reference,
      Wrapped<enums.ModelAndViewStatus?>? status,
      Wrapped<View?>? view,
      Wrapped<String?>? viewName}) {
    return ModelAndView(
        empty: (empty != null ? empty.value : this.empty),
        model: (model != null ? model.value : this.model),
        modelMap: (modelMap != null ? modelMap.value : this.modelMap),
        reference: (reference != null ? reference.value : this.reference),
        status: (status != null ? status.value : this.status),
        view: (view != null ? view.value : this.view),
        viewName: (viewName != null ? viewName.value : this.viewName));
  }
}

@JsonSerializable(explicitToJson: true)
class SupportImage {
  SupportImage({
    this.height,
    this.url,
    this.width,
  });

  factory SupportImage.fromJson(Map<String, dynamic> json) =>
      _$SupportImageFromJson(json);

  @JsonKey(name: 'height', includeIfNull: false)
  final int? height;
  @JsonKey(name: 'url', includeIfNull: false, defaultValue: '')
  final String? url;
  @JsonKey(name: 'width', includeIfNull: false)
  final int? width;
  static const fromJsonFactory = _$SupportImageFromJson;
  static const toJsonFactory = _$SupportImageToJson;
  Map<String, dynamic> toJson() => _$SupportImageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SupportImage &&
            (identical(other.height, height) ||
                const DeepCollectionEquality().equals(other.height, height)) &&
            (identical(other.url, url) ||
                const DeepCollectionEquality().equals(other.url, url)) &&
            (identical(other.width, width) ||
                const DeepCollectionEquality().equals(other.width, width)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(height) ^
      const DeepCollectionEquality().hash(url) ^
      const DeepCollectionEquality().hash(width) ^
      runtimeType.hashCode;
}

extension $SupportImageExtension on SupportImage {
  SupportImage copyWith({int? height, String? url, int? width}) {
    return SupportImage(
        height: height ?? this.height,
        url: url ?? this.url,
        width: width ?? this.width);
  }

  SupportImage copyWithWrapped(
      {Wrapped<int?>? height, Wrapped<String?>? url, Wrapped<int?>? width}) {
    return SupportImage(
        height: (height != null ? height.value : this.height),
        url: (url != null ? url.value : this.url),
        width: (width != null ? width.value : this.width));
  }
}

@JsonSerializable(explicitToJson: true)
class VersionSupportResponse {
  VersionSupportResponse({
    this.buttonText,
    this.contents,
    this.header,
    this.image,
    this.supportLevel,
    this.title,
    this.url,
  });

  factory VersionSupportResponse.fromJson(Map<String, dynamic> json) =>
      _$VersionSupportResponseFromJson(json);

  @JsonKey(name: 'buttonText', includeIfNull: false, defaultValue: '')
  final String? buttonText;
  @JsonKey(name: 'contents', includeIfNull: false, defaultValue: '')
  final String? contents;
  @JsonKey(name: 'header', includeIfNull: false, defaultValue: '')
  final String? header;
  @JsonKey(name: 'image', includeIfNull: false)
  final SupportImage? image;
  @JsonKey(
    name: 'supportLevel',
    includeIfNull: false,
    toJson: versionSupportResponseSupportLevelToJson,
    fromJson: versionSupportResponseSupportLevelFromJson,
  )
  final enums.VersionSupportResponseSupportLevel? supportLevel;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'url', includeIfNull: false, defaultValue: '')
  final String? url;
  static const fromJsonFactory = _$VersionSupportResponseFromJson;
  static const toJsonFactory = _$VersionSupportResponseToJson;
  Map<String, dynamic> toJson() => _$VersionSupportResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is VersionSupportResponse &&
            (identical(other.buttonText, buttonText) ||
                const DeepCollectionEquality()
                    .equals(other.buttonText, buttonText)) &&
            (identical(other.contents, contents) ||
                const DeepCollectionEquality()
                    .equals(other.contents, contents)) &&
            (identical(other.header, header) ||
                const DeepCollectionEquality().equals(other.header, header)) &&
            (identical(other.image, image) ||
                const DeepCollectionEquality().equals(other.image, image)) &&
            (identical(other.supportLevel, supportLevel) ||
                const DeepCollectionEquality()
                    .equals(other.supportLevel, supportLevel)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.url, url) ||
                const DeepCollectionEquality().equals(other.url, url)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(buttonText) ^
      const DeepCollectionEquality().hash(contents) ^
      const DeepCollectionEquality().hash(header) ^
      const DeepCollectionEquality().hash(image) ^
      const DeepCollectionEquality().hash(supportLevel) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(url) ^
      runtimeType.hashCode;
}

extension $VersionSupportResponseExtension on VersionSupportResponse {
  VersionSupportResponse copyWith(
      {String? buttonText,
      String? contents,
      String? header,
      SupportImage? image,
      enums.VersionSupportResponseSupportLevel? supportLevel,
      String? title,
      String? url}) {
    return VersionSupportResponse(
        buttonText: buttonText ?? this.buttonText,
        contents: contents ?? this.contents,
        header: header ?? this.header,
        image: image ?? this.image,
        supportLevel: supportLevel ?? this.supportLevel,
        title: title ?? this.title,
        url: url ?? this.url);
  }

  VersionSupportResponse copyWithWrapped(
      {Wrapped<String?>? buttonText,
      Wrapped<String?>? contents,
      Wrapped<String?>? header,
      Wrapped<SupportImage?>? image,
      Wrapped<enums.VersionSupportResponseSupportLevel?>? supportLevel,
      Wrapped<String?>? title,
      Wrapped<String?>? url}) {
    return VersionSupportResponse(
        buttonText: (buttonText != null ? buttonText.value : this.buttonText),
        contents: (contents != null ? contents.value : this.contents),
        header: (header != null ? header.value : this.header),
        image: (image != null ? image.value : this.image),
        supportLevel:
            (supportLevel != null ? supportLevel.value : this.supportLevel),
        title: (title != null ? title.value : this.title),
        url: (url != null ? url.value : this.url));
  }
}

@JsonSerializable(explicitToJson: true)
class View {
  View({
    this.contentType,
  });

  factory View.fromJson(Map<String, dynamic> json) => _$ViewFromJson(json);

  @JsonKey(name: 'contentType', includeIfNull: false, defaultValue: '')
  final String? contentType;
  static const fromJsonFactory = _$ViewFromJson;
  static const toJsonFactory = _$ViewToJson;
  Map<String, dynamic> toJson() => _$ViewToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is View &&
            (identical(other.contentType, contentType) ||
                const DeepCollectionEquality()
                    .equals(other.contentType, contentType)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(contentType) ^ runtimeType.hashCode;
}

extension $ViewExtension on View {
  View copyWith({String? contentType}) {
    return View(contentType: contentType ?? this.contentType);
  }

  View copyWithWrapped({Wrapped<String?>? contentType}) {
    return View(
        contentType:
            (contentType != null ? contentType.value : this.contentType));
  }
}

String? modelAndViewStatusToJson(enums.ModelAndViewStatus? modelAndViewStatus) {
  return enums.$ModelAndViewStatusMap[modelAndViewStatus];
}

enums.ModelAndViewStatus modelAndViewStatusFromJson(
  Object? modelAndViewStatus, [
  enums.ModelAndViewStatus? defaultValue,
]) {
  if (modelAndViewStatus is String) {
    return enums.$ModelAndViewStatusMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == modelAndViewStatus.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ModelAndViewStatus.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ModelAndViewStatusMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ModelAndViewStatus.swaggerGeneratedUnknown;
}

List<String> modelAndViewStatusListToJson(
    List<enums.ModelAndViewStatus>? modelAndViewStatus) {
  if (modelAndViewStatus == null) {
    return [];
  }

  return modelAndViewStatus
      .map((e) => enums.$ModelAndViewStatusMap[e]!)
      .toList();
}

List<enums.ModelAndViewStatus> modelAndViewStatusListFromJson(
  List? modelAndViewStatus, [
  List<enums.ModelAndViewStatus>? defaultValue,
]) {
  if (modelAndViewStatus == null) {
    return defaultValue ?? [];
  }

  return modelAndViewStatus
      .map((e) => modelAndViewStatusFromJson(e.toString()))
      .toList();
}

List<enums.ModelAndViewStatus>? modelAndViewStatusNullableListFromJson(
  List? modelAndViewStatus, [
  List<enums.ModelAndViewStatus>? defaultValue,
]) {
  if (modelAndViewStatus == null) {
    return defaultValue;
  }

  return modelAndViewStatus
      .map((e) => modelAndViewStatusFromJson(e.toString()))
      .toList();
}

String? versionSupportResponseSupportLevelToJson(
    enums.VersionSupportResponseSupportLevel?
        versionSupportResponseSupportLevel) {
  return enums.$VersionSupportResponseSupportLevelMap[
      versionSupportResponseSupportLevel];
}

enums.VersionSupportResponseSupportLevel
    versionSupportResponseSupportLevelFromJson(
  Object? versionSupportResponseSupportLevel, [
  enums.VersionSupportResponseSupportLevel? defaultValue,
]) {
  if (versionSupportResponseSupportLevel is String) {
    return enums.$VersionSupportResponseSupportLevelMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                versionSupportResponseSupportLevel.toLowerCase(),
            orElse: () => const MapEntry(
                enums
                    .VersionSupportResponseSupportLevel.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$VersionSupportResponseSupportLevelMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.VersionSupportResponseSupportLevel.swaggerGeneratedUnknown;
}

List<String> versionSupportResponseSupportLevelListToJson(
    List<enums.VersionSupportResponseSupportLevel>?
        versionSupportResponseSupportLevel) {
  if (versionSupportResponseSupportLevel == null) {
    return [];
  }

  return versionSupportResponseSupportLevel
      .map((e) => enums.$VersionSupportResponseSupportLevelMap[e]!)
      .toList();
}

List<enums.VersionSupportResponseSupportLevel>
    versionSupportResponseSupportLevelListFromJson(
  List? versionSupportResponseSupportLevel, [
  List<enums.VersionSupportResponseSupportLevel>? defaultValue,
]) {
  if (versionSupportResponseSupportLevel == null) {
    return defaultValue ?? [];
  }

  return versionSupportResponseSupportLevel
      .map((e) => versionSupportResponseSupportLevelFromJson(e.toString()))
      .toList();
}

List<enums.VersionSupportResponseSupportLevel>?
    versionSupportResponseSupportLevelNullableListFromJson(
  List? versionSupportResponseSupportLevel, [
  List<enums.VersionSupportResponseSupportLevel>? defaultValue,
]) {
  if (versionSupportResponseSupportLevel == null) {
    return defaultValue;
  }

  return versionSupportResponseSupportLevel
      .map((e) => versionSupportResponseSupportLevelFromJson(e.toString()))
      .toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
