// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'administrator.enums.swagger.dart' as enums;
export 'administrator.enums.swagger.dart';

part 'administrator.swagger.chopper.dart';
part 'administrator.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class Administrator extends ChopperService {
  static Administrator create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$Administrator(client);
    }

    final newClient = ChopperClient(
        services: [_$Administrator()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$Administrator(newClient);
  }

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1AlertBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1AlertBrowsePost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/alert/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1AlertBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1AlertExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1AlertExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/alert/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1AlertExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogic>>
      apiV1AlertGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogic,
        () =>
            FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogic
                .fromJsonFactory);

    return _apiV1AlertGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/alert')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogic>>
      _apiV1AlertGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<FwStandardModulesAdministratorAlertAlertLogic>>
      apiV1AlertPost({
    String? cacheControl,
    required FwStandardModulesAdministratorAlertAlertLogic? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardModulesAdministratorAlertAlertLogic,
        () => FwStandardModulesAdministratorAlertAlertLogic.fromJsonFactory);

    return _apiV1AlertPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/alert')
  Future<chopper.Response<FwStandardModulesAdministratorAlertAlertLogic>>
      _apiV1AlertPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModulesAdministratorAlertAlertLogic? body,
  });

  ///
  ///@param id
  Future<chopper.Response<FwStandardModulesAdministratorAlertAlertLogic>>
      apiV1AlertIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(FwStandardModulesAdministratorAlertAlertLogic,
        () => FwStandardModulesAdministratorAlertAlertLogic.fromJsonFactory);

    return _apiV1AlertIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/alert/{id}')
  Future<chopper.Response<FwStandardModulesAdministratorAlertAlertLogic>>
      _apiV1AlertIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<chopper.Response<FwStandardModulesAdministratorAlertAlertLogic>>
      apiV1AlertIdPut({
    required String? id,
    String? cacheControl,
    required FwStandardModulesAdministratorAlertAlertLogic? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardModulesAdministratorAlertAlertLogic,
        () => FwStandardModulesAdministratorAlertAlertLogic.fromJsonFactory);

    return _apiV1AlertIdPut(id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/alert/{id}')
  Future<chopper.Response<FwStandardModulesAdministratorAlertAlertLogic>>
      _apiV1AlertIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModulesAdministratorAlertAlertLogic? body,
  });

  ///
  ///@param id
  Future<chopper.Response<bool>> apiV1AlertIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _apiV1AlertIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Delete(path: '/api/v1/alert/{id}')
  Future<chopper.Response<bool>> _apiV1AlertIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1AlertEmptyobjectGet({String? cacheControl}) {
    return _apiV1AlertEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/alert/emptyobject')
  Future<chopper.Response> _apiV1AlertEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1AlertEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1AlertEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/alert/emptybrowseobject')
  Future<chopper.Response> _apiV1AlertEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1AlertKeyfieldnamesGet({String? cacheControl}) {
    return _apiV1AlertKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/alert/keyfieldnames')
  Future<chopper.Response> _apiV1AlertKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1AlertconditionBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1AlertconditionBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/alertcondition/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1AlertconditionBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1AlertconditionExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1AlertconditionExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/alertcondition/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1AlertconditionExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogic>>
      apiV1AlertconditionGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogic,
        () =>
            FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogic
                .fromJsonFactory);

    return _apiV1AlertconditionGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/alertcondition')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogic>>
      _apiV1AlertconditionGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<
          chopper.Response<
              FwStandardModulesAdministratorAlertConditionAlertConditionLogic>>
      apiV1AlertconditionPost({
    String? cacheControl,
    required FwStandardModulesAdministratorAlertConditionAlertConditionLogic?
        body,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorAlertConditionAlertConditionLogic,
        () => FwStandardModulesAdministratorAlertConditionAlertConditionLogic
            .fromJsonFactory);

    return _apiV1AlertconditionPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/alertcondition')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorAlertConditionAlertConditionLogic>>
      _apiV1AlertconditionPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required FwStandardModulesAdministratorAlertConditionAlertConditionLogic?
            body,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              FwStandardModulesAdministratorAlertConditionAlertConditionLogic>>
      apiV1AlertconditionIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorAlertConditionAlertConditionLogic,
        () => FwStandardModulesAdministratorAlertConditionAlertConditionLogic
            .fromJsonFactory);

    return _apiV1AlertconditionIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/alertcondition/{id}')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorAlertConditionAlertConditionLogic>>
      _apiV1AlertconditionIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              FwStandardModulesAdministratorAlertConditionAlertConditionLogic>>
      apiV1AlertconditionIdPut({
    required String? id,
    String? cacheControl,
    required FwStandardModulesAdministratorAlertConditionAlertConditionLogic?
        body,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorAlertConditionAlertConditionLogic,
        () => FwStandardModulesAdministratorAlertConditionAlertConditionLogic
            .fromJsonFactory);

    return _apiV1AlertconditionIdPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/alertcondition/{id}')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorAlertConditionAlertConditionLogic>>
      _apiV1AlertconditionIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required FwStandardModulesAdministratorAlertConditionAlertConditionLogic?
            body,
  });

  ///
  ///@param id
  Future<chopper.Response<bool>> apiV1AlertconditionIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _apiV1AlertconditionIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Delete(path: '/api/v1/alertcondition/{id}')
  Future<chopper.Response<bool>> _apiV1AlertconditionIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1AlertconditionEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1AlertconditionEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/alertcondition/emptyobject')
  Future<chopper.Response> _apiV1AlertconditionEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1AlertconditionEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1AlertconditionEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/alertcondition/emptybrowseobject')
  Future<chopper.Response> _apiV1AlertconditionEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1AlertconditionKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1AlertconditionKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/alertcondition/keyfieldnames')
  Future<chopper.Response> _apiV1AlertconditionKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1AlertwebusersBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1AlertwebusersBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/alertwebusers/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1AlertwebusersBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1AlertwebusersExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1AlertwebusersExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/alertwebusers/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1AlertwebusersExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic>>
      apiV1AlertwebusersGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic,
        () =>
            FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic
                .fromJsonFactory);

    return _apiV1AlertwebusersGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/alertwebusers')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic>>
      _apiV1AlertwebusersGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<
          chopper.Response<
              FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic>>
      apiV1AlertwebusersPost({
    String? cacheControl,
    required FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic?
        body,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic,
        () => FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic
            .fromJsonFactory);

    return _apiV1AlertwebusersPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/alertwebusers')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic>>
      _apiV1AlertwebusersPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic?
            body,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic>>
      apiV1AlertwebusersIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic,
        () => FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic
            .fromJsonFactory);

    return _apiV1AlertwebusersIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/alertwebusers/{id}')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic>>
      _apiV1AlertwebusersIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic>>
      apiV1AlertwebusersIdPut({
    required String? id,
    String? cacheControl,
    required FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic?
        body,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic,
        () => FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic
            .fromJsonFactory);

    return _apiV1AlertwebusersIdPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/alertwebusers/{id}')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic>>
      _apiV1AlertwebusersIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic?
            body,
  });

  ///
  ///@param id
  Future<chopper.Response<bool>> apiV1AlertwebusersIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _apiV1AlertwebusersIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Delete(path: '/api/v1/alertwebusers/{id}')
  Future<chopper.Response<bool>> _apiV1AlertwebusersIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1AlertwebusersValidateuserBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1AlertwebusersValidateuserBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/alertwebusers/validateuser/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1AlertwebusersValidateuserBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1AlertwebusersEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1AlertwebusersEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/alertwebusers/emptyobject')
  Future<chopper.Response> _apiV1AlertwebusersEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1AlertwebusersEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1AlertwebusersEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/alertwebusers/emptybrowseobject')
  Future<chopper.Response> _apiV1AlertwebusersEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1AlertwebusersKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1AlertwebusersKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/alertwebusers/keyfieldnames')
  Future<chopper.Response> _apiV1AlertwebusersKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1AssignedcustomformBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1AssignedcustomformBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/assignedcustomform/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1AssignedcustomformBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1AssignedcustomformExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1AssignedcustomformExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/assignedcustomform/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1AssignedcustomformExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1AssignedcustomformEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1AssignedcustomformEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/assignedcustomform/emptyobject')
  Future<chopper.Response> _apiV1AssignedcustomformEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1AssignedcustomformEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1AssignedcustomformEmptybrowseobjectGet(
        cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/assignedcustomform/emptybrowseobject')
  Future<chopper.Response> _apiV1AssignedcustomformEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1AssignedcustomformKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1AssignedcustomformKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/assignedcustomform/keyfieldnames')
  Future<chopper.Response> _apiV1AssignedcustomformKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1CustomfieldBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1CustomfieldBrowsePost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customfield/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1CustomfieldBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1CustomfieldExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1CustomfieldExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customfield/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1CustomfieldExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogic>>
      apiV1CustomfieldGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogic
                .fromJsonFactory);

    return _apiV1CustomfieldGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/customfield')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogic>>
      _apiV1CustomfieldGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<WebApiModulesAdministratorCustomFieldCustomField>>
      apiV1CustomfieldPost({
    String? cacheControl,
    required WebApiModulesAdministratorCustomFieldCustomField? body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorCustomFieldCustomField,
        () => WebApiModulesAdministratorCustomFieldCustomField.fromJsonFactory);

    return _apiV1CustomfieldPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customfield')
  Future<chopper.Response<WebApiModulesAdministratorCustomFieldCustomField>>
      _apiV1CustomfieldPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesAdministratorCustomFieldCustomField? body,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesAdministratorCustomFieldCustomField>>
      apiV1CustomfieldIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorCustomFieldCustomField,
        () => WebApiModulesAdministratorCustomFieldCustomField.fromJsonFactory);

    return _apiV1CustomfieldIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/customfield/{id}')
  Future<chopper.Response<WebApiModulesAdministratorCustomFieldCustomField>>
      _apiV1CustomfieldIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesAdministratorCustomFieldCustomField>>
      apiV1CustomfieldIdPut({
    required String? id,
    String? cacheControl,
    required WebApiModulesAdministratorCustomFieldCustomField? body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorCustomFieldCustomField,
        () => WebApiModulesAdministratorCustomFieldCustomField.fromJsonFactory);

    return _apiV1CustomfieldIdPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/customfield/{id}')
  Future<chopper.Response<WebApiModulesAdministratorCustomFieldCustomField>>
      _apiV1CustomfieldIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesAdministratorCustomFieldCustomField? body,
  });

  ///
  ///@param id
  Future<chopper.Response<bool>> apiV1CustomfieldIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _apiV1CustomfieldIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Delete(path: '/api/v1/customfield/{id}')
  Future<chopper.Response<bool>> _apiV1CustomfieldIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1CustomfieldEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1CustomfieldEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/customfield/emptyobject')
  Future<chopper.Response> _apiV1CustomfieldEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1CustomfieldEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1CustomfieldEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/customfield/emptybrowseobject')
  Future<chopper.Response> _apiV1CustomfieldEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1CustomfieldKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1CustomfieldKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/customfield/keyfieldnames')
  Future<chopper.Response> _apiV1CustomfieldKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1CustomformBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1CustomformBrowsePost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customform/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1CustomformBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1CustomformExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1CustomformExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customform/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1CustomformExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogic>>
      apiV1CustomformGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogic
                .fromJsonFactory);

    return _apiV1CustomformGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/customform')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogic>>
      _apiV1CustomformGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<WebApiModulesAdministratorCustomFormCustomForm>>
      apiV1CustomformPost({
    String? cacheControl,
    required WebApiModulesAdministratorCustomFormCustomForm? body,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesAdministratorCustomFormCustomForm,
        () => WebApiModulesAdministratorCustomFormCustomForm.fromJsonFactory);

    return _apiV1CustomformPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customform')
  Future<chopper.Response<WebApiModulesAdministratorCustomFormCustomForm>>
      _apiV1CustomformPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesAdministratorCustomFormCustomForm? body,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesAdministratorCustomFormCustomForm>>
      apiV1CustomformIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesAdministratorCustomFormCustomForm,
        () => WebApiModulesAdministratorCustomFormCustomForm.fromJsonFactory);

    return _apiV1CustomformIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/customform/{id}')
  Future<chopper.Response<WebApiModulesAdministratorCustomFormCustomForm>>
      _apiV1CustomformIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesAdministratorCustomFormCustomForm>>
      apiV1CustomformIdPut({
    required String? id,
    String? cacheControl,
    required WebApiModulesAdministratorCustomFormCustomForm? body,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesAdministratorCustomFormCustomForm,
        () => WebApiModulesAdministratorCustomFormCustomForm.fromJsonFactory);

    return _apiV1CustomformIdPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/customform/{id}')
  Future<chopper.Response<WebApiModulesAdministratorCustomFormCustomForm>>
      _apiV1CustomformIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesAdministratorCustomFormCustomForm? body,
  });

  ///
  ///@param id
  Future<chopper.Response<bool>> apiV1CustomformIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _apiV1CustomformIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Delete(path: '/api/v1/customform/{id}')
  Future<chopper.Response<bool>> _apiV1CustomformIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<WebApiModulesAdministratorCustomFormCustomForm>>
      apiV1CustomformSelfassignPost({
    String? cacheControl,
    required WebApiModulesAdministratorCustomFormCustomForm? body,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesAdministratorCustomFormCustomForm,
        () => WebApiModulesAdministratorCustomFormCustomForm.fromJsonFactory);

    return _apiV1CustomformSelfassignPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customform/selfassign')
  Future<chopper.Response<WebApiModulesAdministratorCustomFormCustomForm>>
      _apiV1CustomformSelfassignPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesAdministratorCustomFormCustomForm? body,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesAdministratorCustomFormCustomForm>>
      apiV1CustomformSelfassignIdPut({
    required String? id,
    String? cacheControl,
    required WebApiModulesAdministratorCustomFormCustomForm? body,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesAdministratorCustomFormCustomForm,
        () => WebApiModulesAdministratorCustomFormCustomForm.fromJsonFactory);

    return _apiV1CustomformSelfassignIdPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/customform/selfassign/{id}')
  Future<chopper.Response<WebApiModulesAdministratorCustomFormCustomForm>>
      _apiV1CustomformSelfassignIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesAdministratorCustomFormCustomForm? body,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1CustomformEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1CustomformEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/customform/emptyobject')
  Future<chopper.Response> _apiV1CustomformEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1CustomformEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1CustomformEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/customform/emptybrowseobject')
  Future<chopper.Response> _apiV1CustomformEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1CustomformKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1CustomformKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/customform/keyfieldnames')
  Future<chopper.Response> _apiV1CustomformKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1CustomformgroupBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1CustomformgroupBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customformgroup/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1CustomformgroupBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1CustomformgroupExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1CustomformgroupExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customformgroup/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1CustomformgroupExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogic>>
      apiV1CustomformgroupGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogic
                .fromJsonFactory);

    return _apiV1CustomformgroupGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/customformgroup')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogic>>
      _apiV1CustomformgroupGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup>>
      apiV1CustomformgroupPost({
    String? cacheControl,
    required WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup?
        body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup,
        () => WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup
            .fromJsonFactory);

    return _apiV1CustomformgroupPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customformgroup')
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup>>
      _apiV1CustomformgroupPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup?
            body,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup>>
      apiV1CustomformgroupIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup,
        () => WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup
            .fromJsonFactory);

    return _apiV1CustomformgroupIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/customformgroup/{id}')
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup>>
      _apiV1CustomformgroupIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup>>
      apiV1CustomformgroupIdPut({
    required String? id,
    String? cacheControl,
    required WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup?
        body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup,
        () => WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup
            .fromJsonFactory);

    return _apiV1CustomformgroupIdPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/customformgroup/{id}')
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup>>
      _apiV1CustomformgroupIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup?
            body,
  });

  ///
  ///@param id
  Future<chopper.Response<bool>> apiV1CustomformgroupIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _apiV1CustomformgroupIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Delete(path: '/api/v1/customformgroup/{id}')
  Future<chopper.Response<bool>> _apiV1CustomformgroupIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1CustomformgroupValidategroupnameBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1CustomformgroupValidategroupnameBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customformgroup/validategroupname/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1CustomformgroupValidategroupnameBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1CustomformgroupEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1CustomformgroupEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/customformgroup/emptyobject')
  Future<chopper.Response> _apiV1CustomformgroupEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1CustomformgroupEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1CustomformgroupEmptybrowseobjectGet(
        cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/customformgroup/emptybrowseobject')
  Future<chopper.Response> _apiV1CustomformgroupEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1CustomformgroupKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1CustomformgroupKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/customformgroup/keyfieldnames')
  Future<chopper.Response> _apiV1CustomformgroupKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1CustomformuserBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1CustomformuserBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customformuser/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1CustomformuserBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1CustomformuserExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1CustomformuserExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customformuser/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1CustomformuserExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogic>>
      apiV1CustomformuserGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogic
                .fromJsonFactory);

    return _apiV1CustomformuserGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/customformuser')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogic>>
      _apiV1CustomformuserGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomFormUserCustomFormUser>>
      apiV1CustomformuserPost({
    String? cacheControl,
    required WebApiModulesAdministratorControlsCustomFormUserCustomFormUser?
        body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorControlsCustomFormUserCustomFormUser,
        () => WebApiModulesAdministratorControlsCustomFormUserCustomFormUser
            .fromJsonFactory);

    return _apiV1CustomformuserPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customformuser')
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomFormUserCustomFormUser>>
      _apiV1CustomformuserPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAdministratorControlsCustomFormUserCustomFormUser?
            body,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomFormUserCustomFormUser>>
      apiV1CustomformuserIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorControlsCustomFormUserCustomFormUser,
        () => WebApiModulesAdministratorControlsCustomFormUserCustomFormUser
            .fromJsonFactory);

    return _apiV1CustomformuserIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/customformuser/{id}')
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomFormUserCustomFormUser>>
      _apiV1CustomformuserIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomFormUserCustomFormUser>>
      apiV1CustomformuserIdPut({
    required String? id,
    String? cacheControl,
    required WebApiModulesAdministratorControlsCustomFormUserCustomFormUser?
        body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorControlsCustomFormUserCustomFormUser,
        () => WebApiModulesAdministratorControlsCustomFormUserCustomFormUser
            .fromJsonFactory);

    return _apiV1CustomformuserIdPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/customformuser/{id}')
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomFormUserCustomFormUser>>
      _apiV1CustomformuserIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAdministratorControlsCustomFormUserCustomFormUser?
            body,
  });

  ///
  ///@param id
  Future<chopper.Response<bool>> apiV1CustomformuserIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _apiV1CustomformuserIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Delete(path: '/api/v1/customformuser/{id}')
  Future<chopper.Response<bool>> _apiV1CustomformuserIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1CustomformuserValidateuserBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1CustomformuserValidateuserBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customformuser/validateuser/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1CustomformuserValidateuserBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1CustomformuserEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1CustomformuserEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/customformuser/emptyobject')
  Future<chopper.Response> _apiV1CustomformuserEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1CustomformuserEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1CustomformuserEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/customformuser/emptybrowseobject')
  Future<chopper.Response> _apiV1CustomformuserEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1CustomformuserKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1CustomformuserKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/customformuser/keyfieldnames')
  Future<chopper.Response> _apiV1CustomformuserKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1CustommoduleBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1CustommoduleBrowsePost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/custommodule/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1CustommoduleBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1CustommoduleExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1CustommoduleExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/custommodule/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1CustommoduleExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogic>>
      apiV1CustommoduleGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogic
                .fromJsonFactory);

    return _apiV1CustommoduleGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/custommodule')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogic>>
      _apiV1CustommoduleGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1CustommoduleEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1CustommoduleEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/custommodule/emptyobject')
  Future<chopper.Response> _apiV1CustommoduleEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1CustommoduleEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1CustommoduleEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/custommodule/emptybrowseobject')
  Future<chopper.Response> _apiV1CustommoduleEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1CustommoduleKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1CustommoduleKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/custommodule/keyfieldnames')
  Future<chopper.Response> _apiV1CustommoduleKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1CustomreportlayoutBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1CustomreportlayoutBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customreportlayout/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1CustomreportlayoutBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1CustomreportlayoutExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1CustomreportlayoutExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customreportlayout/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1CustomreportlayoutExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic>>
      apiV1CustomreportlayoutGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic,
        () =>
            FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic
                .fromJsonFactory);

    return _apiV1CustomreportlayoutGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/customreportlayout')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic>>
      _apiV1CustomreportlayoutGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<
          chopper.Response<
              FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic>>
      apiV1CustomreportlayoutPost({
    String? cacheControl,
    required FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic?
        body,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic,
        () =>
            FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic
                .fromJsonFactory);

    return _apiV1CustomreportlayoutPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customreportlayout')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic>>
      _apiV1CustomreportlayoutPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic?
            body,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic>>
      apiV1CustomreportlayoutIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic,
        () =>
            FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic
                .fromJsonFactory);

    return _apiV1CustomreportlayoutIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/customreportlayout/{id}')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic>>
      _apiV1CustomreportlayoutIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic>>
      apiV1CustomreportlayoutIdPut({
    required String? id,
    String? cacheControl,
    required FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic?
        body,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic,
        () =>
            FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic
                .fromJsonFactory);

    return _apiV1CustomreportlayoutIdPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/customreportlayout/{id}')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic>>
      _apiV1CustomreportlayoutIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic?
            body,
  });

  ///
  ///@param id
  Future<chopper.Response<bool>> apiV1CustomreportlayoutIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _apiV1CustomreportlayoutIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Delete(path: '/api/v1/customreportlayout/{id}')
  Future<chopper.Response<bool>> _apiV1CustomreportlayoutIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param report
  Future<
          chopper.Response<
              WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponse>>
      apiV1CustomreportlayoutTemplateReportGet({
    required String? report,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponse,
        () =>
            WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponse
                .fromJsonFactory);

    return _apiV1CustomreportlayoutTemplateReportGet(
        report: report, cacheControl: cacheControl);
  }

  ///
  ///@param report
  @Get(path: '/api/v1/customreportlayout/template/{report}')
  Future<
          chopper.Response<
              WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponse>>
      _apiV1CustomreportlayoutTemplateReportGet({
    @Path('report') required String? report,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1CustomreportlayoutEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1CustomreportlayoutEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/customreportlayout/emptyobject')
  Future<chopper.Response> _apiV1CustomreportlayoutEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1CustomreportlayoutEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1CustomreportlayoutEmptybrowseobjectGet(
        cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/customreportlayout/emptybrowseobject')
  Future<chopper.Response> _apiV1CustomreportlayoutEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1CustomreportlayoutKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1CustomreportlayoutKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/customreportlayout/keyfieldnames')
  Future<chopper.Response> _apiV1CustomreportlayoutKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1CustomreportlayoutgroupBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1CustomreportlayoutgroupBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customreportlayoutgroup/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1CustomreportlayoutgroupBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1CustomreportlayoutgroupExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1CustomreportlayoutgroupExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customreportlayoutgroup/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1CustomreportlayoutgroupExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogic>>
      apiV1CustomreportlayoutgroupGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogic
                .fromJsonFactory);

    return _apiV1CustomreportlayoutgroupGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/customreportlayoutgroup')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogic>>
      _apiV1CustomreportlayoutgroupGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup>>
      apiV1CustomreportlayoutgroupPost({
    String? cacheControl,
    required WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup?
        body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup,
        () =>
            WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup
                .fromJsonFactory);

    return _apiV1CustomreportlayoutgroupPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customreportlayoutgroup')
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup>>
      _apiV1CustomreportlayoutgroupPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup?
            body,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup>>
      apiV1CustomreportlayoutgroupIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup,
        () =>
            WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup
                .fromJsonFactory);

    return _apiV1CustomreportlayoutgroupIdGet(
        id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/customreportlayoutgroup/{id}')
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup>>
      _apiV1CustomreportlayoutgroupIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup>>
      apiV1CustomreportlayoutgroupIdPut({
    required String? id,
    String? cacheControl,
    required WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup?
        body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup,
        () =>
            WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup
                .fromJsonFactory);

    return _apiV1CustomreportlayoutgroupIdPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/customreportlayoutgroup/{id}')
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup>>
      _apiV1CustomreportlayoutgroupIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup?
            body,
  });

  ///
  ///@param id
  Future<chopper.Response<bool>> apiV1CustomreportlayoutgroupIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _apiV1CustomreportlayoutgroupIdDelete(
        id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Delete(path: '/api/v1/customreportlayoutgroup/{id}')
  Future<chopper.Response<bool>> _apiV1CustomreportlayoutgroupIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1CustomreportlayoutgroupValidategroupnameBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1CustomreportlayoutgroupValidategroupnameBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customreportlayoutgroup/validategroupname/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1CustomreportlayoutgroupValidategroupnameBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1CustomreportlayoutgroupEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1CustomreportlayoutgroupEmptyobjectGet(
        cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/customreportlayoutgroup/emptyobject')
  Future<chopper.Response> _apiV1CustomreportlayoutgroupEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1CustomreportlayoutgroupEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1CustomreportlayoutgroupEmptybrowseobjectGet(
        cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/customreportlayoutgroup/emptybrowseobject')
  Future<chopper.Response> _apiV1CustomreportlayoutgroupEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1CustomreportlayoutgroupKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1CustomreportlayoutgroupKeyfieldnamesGet(
        cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/customreportlayoutgroup/keyfieldnames')
  Future<chopper.Response> _apiV1CustomreportlayoutgroupKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1CustomreportlayoutuserBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1CustomreportlayoutuserBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customreportlayoutuser/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1CustomreportlayoutuserBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1CustomreportlayoutuserExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1CustomreportlayoutuserExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customreportlayoutuser/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1CustomreportlayoutuserExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogic>>
      apiV1CustomreportlayoutuserGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogic
                .fromJsonFactory);

    return _apiV1CustomreportlayoutuserGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/customreportlayoutuser')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogic>>
      _apiV1CustomreportlayoutuserGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<
          chopper.Response<
              WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser>>
      apiV1CustomreportlayoutuserPost({
    String? cacheControl,
    required WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser?
        body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser,
        () =>
            WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser
                .fromJsonFactory);

    return _apiV1CustomreportlayoutuserPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customreportlayoutuser')
  Future<
          chopper.Response<
              WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser>>
      _apiV1CustomreportlayoutuserPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser?
            body,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser>>
      apiV1CustomreportlayoutuserIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser,
        () =>
            WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser
                .fromJsonFactory);

    return _apiV1CustomreportlayoutuserIdGet(
        id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/customreportlayoutuser/{id}')
  Future<
          chopper.Response<
              WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser>>
      _apiV1CustomreportlayoutuserIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser>>
      apiV1CustomreportlayoutuserIdPut({
    required String? id,
    String? cacheControl,
    required WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser?
        body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser,
        () =>
            WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser
                .fromJsonFactory);

    return _apiV1CustomreportlayoutuserIdPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/customreportlayoutuser/{id}')
  Future<
          chopper.Response<
              WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser>>
      _apiV1CustomreportlayoutuserIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser?
            body,
  });

  ///
  ///@param id
  Future<chopper.Response<bool>> apiV1CustomreportlayoutuserIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _apiV1CustomreportlayoutuserIdDelete(
        id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Delete(path: '/api/v1/customreportlayoutuser/{id}')
  Future<chopper.Response<bool>> _apiV1CustomreportlayoutuserIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1CustomreportlayoutuserValidateuserBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1CustomreportlayoutuserValidateuserBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/customreportlayoutuser/validateuser/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1CustomreportlayoutuserValidateuserBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1CustomreportlayoutuserEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1CustomreportlayoutuserEmptyobjectGet(
        cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/customreportlayoutuser/emptyobject')
  Future<chopper.Response> _apiV1CustomreportlayoutuserEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1CustomreportlayoutuserEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1CustomreportlayoutuserEmptybrowseobjectGet(
        cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/customreportlayoutuser/emptybrowseobject')
  Future<chopper.Response> _apiV1CustomreportlayoutuserEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1CustomreportlayoutuserKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1CustomreportlayoutuserKeyfieldnamesGet(
        cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/customreportlayoutuser/keyfieldnames')
  Future<chopper.Response> _apiV1CustomreportlayoutuserKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<Object>> apiV1DatahealthLegendGet(
      {String? cacheControl}) {
    return _apiV1DatahealthLegendGet(cacheControl: cacheControl);
  }

  ///
  @Get(path: '/api/v1/datahealth/legend')
  Future<chopper.Response<Object>> _apiV1DatahealthLegendGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1DatahealthBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1DatahealthBrowsePost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/datahealth/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1DatahealthBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1DatahealthExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1DatahealthExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/datahealth/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1DatahealthExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogic>>
      apiV1DatahealthGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogic
                .fromJsonFactory);

    return _apiV1DatahealthGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/datahealth')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogic>>
      _apiV1DatahealthGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesAdministratorDataHealthDataHealth>>
      apiV1DatahealthIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesAdministratorDataHealthDataHealth,
        () => WebApiModulesAdministratorDataHealthDataHealth.fromJsonFactory);

    return _apiV1DatahealthIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/datahealth/{id}')
  Future<chopper.Response<WebApiModulesAdministratorDataHealthDataHealth>>
      _apiV1DatahealthIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesAdministratorDataHealthDataHealth>>
      apiV1DatahealthIdPut({
    required String? id,
    String? cacheControl,
    required WebApiModulesAdministratorDataHealthDataHealth? body,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesAdministratorDataHealthDataHealth,
        () => WebApiModulesAdministratorDataHealthDataHealth.fromJsonFactory);

    return _apiV1DatahealthIdPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/datahealth/{id}')
  Future<chopper.Response<WebApiModulesAdministratorDataHealthDataHealth>>
      _apiV1DatahealthIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesAdministratorDataHealthDataHealth? body,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1DatahealthEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1DatahealthEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/datahealth/emptyobject')
  Future<chopper.Response> _apiV1DatahealthEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1DatahealthEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1DatahealthEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/datahealth/emptybrowseobject')
  Future<chopper.Response> _apiV1DatahealthEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1DatahealthKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1DatahealthKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/datahealth/keyfieldnames')
  Future<chopper.Response> _apiV1DatahealthKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1DuplicateruleBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1DuplicateruleBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/duplicaterule/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1DuplicateruleBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1DuplicateruleExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1DuplicateruleExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/duplicaterule/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1DuplicateruleExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic>>
      apiV1DuplicateruleGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic,
        () =>
            FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic
                .fromJsonFactory);

    return _apiV1DuplicateruleGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/duplicaterule')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic>>
      _apiV1DuplicateruleGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<
          chopper.Response<
              FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic>>
      apiV1DuplicaterulePost({
    String? cacheControl,
    required FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic?
        body,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic,
        () => FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic
            .fromJsonFactory);

    return _apiV1DuplicaterulePost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/duplicaterule')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic>>
      _apiV1DuplicaterulePost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic?
            body,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic>>
      apiV1DuplicateruleIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic,
        () => FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic
            .fromJsonFactory);

    return _apiV1DuplicateruleIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/duplicaterule/{id}')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic>>
      _apiV1DuplicateruleIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic>>
      apiV1DuplicateruleIdPut({
    required String? id,
    String? cacheControl,
    required FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic?
        body,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic,
        () => FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic
            .fromJsonFactory);

    return _apiV1DuplicateruleIdPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/duplicaterule/{id}')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic>>
      _apiV1DuplicateruleIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic?
            body,
  });

  ///
  ///@param id
  Future<chopper.Response<bool>> apiV1DuplicateruleIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _apiV1DuplicateruleIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Delete(path: '/api/v1/duplicaterule/{id}')
  Future<chopper.Response<bool>> _apiV1DuplicateruleIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1DuplicateruleEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1DuplicateruleEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/duplicaterule/emptyobject')
  Future<chopper.Response> _apiV1DuplicateruleEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1DuplicateruleEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1DuplicateruleEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/duplicaterule/emptybrowseobject')
  Future<chopper.Response> _apiV1DuplicateruleEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1DuplicateruleKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1DuplicateruleKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/duplicaterule/keyfieldnames')
  Future<chopper.Response> _apiV1DuplicateruleKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1DuplicaterulefieldBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1DuplicaterulefieldBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/duplicaterulefield/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1DuplicaterulefieldBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1DuplicaterulefieldExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1DuplicaterulefieldExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/duplicaterulefield/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1DuplicaterulefieldExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogic>>
      apiV1DuplicaterulefieldGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogic
                .fromJsonFactory);

    return _apiV1DuplicaterulefieldGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/duplicaterulefield')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogic>>
      _apiV1DuplicaterulefieldGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField>>
      apiV1DuplicaterulefieldPost({
    String? cacheControl,
    required WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField?
        body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField,
        () =>
            WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField
                .fromJsonFactory);

    return _apiV1DuplicaterulefieldPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/duplicaterulefield')
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField>>
      _apiV1DuplicaterulefieldPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField?
            body,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField>>
      apiV1DuplicaterulefieldIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField,
        () =>
            WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField
                .fromJsonFactory);

    return _apiV1DuplicaterulefieldIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/duplicaterulefield/{id}')
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField>>
      _apiV1DuplicaterulefieldIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField>>
      apiV1DuplicaterulefieldIdPut({
    required String? id,
    String? cacheControl,
    required WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField?
        body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField,
        () =>
            WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField
                .fromJsonFactory);

    return _apiV1DuplicaterulefieldIdPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/duplicaterulefield/{id}')
  Future<
          chopper.Response<
              WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField>>
      _apiV1DuplicaterulefieldIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField?
            body,
  });

  ///
  ///@param id
  Future<chopper.Response<bool>> apiV1DuplicaterulefieldIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _apiV1DuplicaterulefieldIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Delete(path: '/api/v1/duplicaterulefield/{id}')
  Future<chopper.Response<bool>> _apiV1DuplicaterulefieldIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1DuplicaterulefieldEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1DuplicaterulefieldEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/duplicaterulefield/emptyobject')
  Future<chopper.Response> _apiV1DuplicaterulefieldEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1DuplicaterulefieldEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1DuplicaterulefieldEmptybrowseobjectGet(
        cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/duplicaterulefield/emptybrowseobject')
  Future<chopper.Response> _apiV1DuplicaterulefieldEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1DuplicaterulefieldKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1DuplicaterulefieldKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/duplicaterulefield/keyfieldnames')
  Future<chopper.Response> _apiV1DuplicaterulefieldKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1EmailhistoryBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1EmailhistoryBrowsePost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/emailhistory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1EmailhistoryBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1EmailhistoryExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1EmailhistoryExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/emailhistory/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1EmailhistoryExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogic>>
      apiV1EmailhistoryGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogic
                .fromJsonFactory);

    return _apiV1EmailhistoryGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/emailhistory')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogic>>
      _apiV1EmailhistoryGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesAdministratorEmailHistoryEmailHistory>>
      apiV1EmailhistoryIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorEmailHistoryEmailHistory,
        () =>
            WebApiModulesAdministratorEmailHistoryEmailHistory.fromJsonFactory);

    return _apiV1EmailhistoryIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/emailhistory/{id}')
  Future<chopper.Response<WebApiModulesAdministratorEmailHistoryEmailHistory>>
      _apiV1EmailhistoryIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1EmailhistoryEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1EmailhistoryEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/emailhistory/emptyobject')
  Future<chopper.Response> _apiV1EmailhistoryEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1EmailhistoryEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1EmailhistoryEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/emailhistory/emptybrowseobject')
  Future<chopper.Response> _apiV1EmailhistoryEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1EmailhistoryKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1EmailhistoryKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/emailhistory/keyfieldnames')
  Future<chopper.Response> _apiV1EmailhistoryKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1EmailtemplateBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1EmailtemplateBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/emailtemplate/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1EmailtemplateBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogic>>
      apiV1EmailtemplateGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogic,
        () =>
            FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogic
                .fromJsonFactory);

    return _apiV1EmailtemplateGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/emailtemplate')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogic>>
      _apiV1EmailtemplateGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<
          chopper.Response<
              FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic>>
      apiV1EmailtemplatePost({
    String? cacheControl,
    required FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic?
        body,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic,
        () => FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic
            .fromJsonFactory);

    return _apiV1EmailtemplatePost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/emailtemplate')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic>>
      _apiV1EmailtemplatePost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic?
            body,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic>>
      apiV1EmailtemplateIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic,
        () => FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic
            .fromJsonFactory);

    return _apiV1EmailtemplateIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/emailtemplate/{id}')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic>>
      _apiV1EmailtemplateIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<chopper.Response<bool>> apiV1EmailtemplateIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _apiV1EmailtemplateIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Delete(path: '/api/v1/emailtemplate/{id}')
  Future<chopper.Response<bool>> _apiV1EmailtemplateIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic>>
      apiV1EmailtemplateIdPut({
    required String? id,
    String? cacheControl,
    required FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic?
        body,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic,
        () => FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic
            .fromJsonFactory);

    return _apiV1EmailtemplateIdPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/emailtemplate/{id}')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic>>
      _apiV1EmailtemplateIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic?
            body,
  });

  ///
  Future<
          chopper.Response<
              FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponse>>
      apiV1EmailtemplateTemplatecategoriesPost({
    String? cacheControl,
    required FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic?
        body,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponse,
        () =>
            FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponse
                .fromJsonFactory);

    return _apiV1EmailtemplateTemplatecategoriesPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/emailtemplate/templatecategories')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponse>>
      _apiV1EmailtemplateTemplatecategoriesPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic?
            body,
  });

  ///
  Future<
          chopper.Response<
              FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponse>>
      apiV1EmailtemplateTemplatefieldsPost({
    String? cacheControl,
    required FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicGetTemplateFieldsRequest?
        body,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponse,
        () =>
            FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponse
                .fromJsonFactory);

    return _apiV1EmailtemplateTemplatefieldsPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/emailtemplate/templatefields')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponse>>
      _apiV1EmailtemplateTemplatefieldsPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicGetTemplateFieldsRequest?
            body,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1EmailtemplateEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1EmailtemplateEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/emailtemplate/emptyobject')
  Future<chopper.Response> _apiV1EmailtemplateEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1EmailtemplateEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1EmailtemplateEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/emailtemplate/emptybrowseobject')
  Future<chopper.Response> _apiV1EmailtemplateEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1EmailtemplateKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1EmailtemplateKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/emailtemplate/keyfieldnames')
  Future<chopper.Response> _apiV1EmailtemplateKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1GroupBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1GroupBrowsePost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/group/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1GroupBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1GroupExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1GroupExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/group/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1GroupExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogic>>
      apiV1GroupGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogic
                .fromJsonFactory);

    return _apiV1GroupGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/group')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogic>>
      _apiV1GroupGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<WebApiModulesAdministratorGroupGroup>>
      apiV1GroupPost({
    String? cacheControl,
    required WebApiModulesAdministratorGroupGroup? body,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesAdministratorGroupGroup,
        () => WebApiModulesAdministratorGroupGroup.fromJsonFactory);

    return _apiV1GroupPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/group')
  Future<chopper.Response<WebApiModulesAdministratorGroupGroup>>
      _apiV1GroupPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesAdministratorGroupGroup? body,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesAdministratorGroupGroup>>
      apiV1GroupIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesAdministratorGroupGroup,
        () => WebApiModulesAdministratorGroupGroup.fromJsonFactory);

    return _apiV1GroupIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/group/{id}')
  Future<chopper.Response<WebApiModulesAdministratorGroupGroup>>
      _apiV1GroupIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesAdministratorGroupGroup>>
      apiV1GroupIdPut({
    required String? id,
    String? cacheControl,
    required WebApiModulesAdministratorGroupGroup? body,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesAdministratorGroupGroup,
        () => WebApiModulesAdministratorGroupGroup.fromJsonFactory);

    return _apiV1GroupIdPut(id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/group/{id}')
  Future<chopper.Response<WebApiModulesAdministratorGroupGroup>>
      _apiV1GroupIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesAdministratorGroupGroup? body,
  });

  ///
  ///@param id
  Future<chopper.Response<bool>> apiV1GroupIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _apiV1GroupIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Delete(path: '/api/v1/group/{id}')
  Future<chopper.Response<bool>> _apiV1GroupIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<chopper.Response<FwStandardAppManagerFwAmSecurityTreeNode>>
      apiV1GroupApplicationtreeIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(FwStandardAppManagerFwAmSecurityTreeNode,
        () => FwStandardAppManagerFwAmSecurityTreeNode.fromJsonFactory);

    return _apiV1GroupApplicationtreeIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/group/applicationtree/{id}')
  Future<chopper.Response<FwStandardAppManagerFwAmSecurityTreeNode>>
      _apiV1GroupApplicationtreeIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<FwStandardAppManagerFwAmSecurityTreeNode>>
      apiV1GroupCopysecuritynodePost({
    String? cacheControl,
    required FwCoreModulesAdministratorGroupCopySecurityNodeRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardAppManagerFwAmSecurityTreeNode,
        () => FwStandardAppManagerFwAmSecurityTreeNode.fromJsonFactory);

    return _apiV1GroupCopysecuritynodePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/group/copysecuritynode')
  Future<chopper.Response<FwStandardAppManagerFwAmSecurityTreeNode>>
      _apiV1GroupCopysecuritynodePost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required FwCoreModulesAdministratorGroupCopySecurityNodeRequest? body,
  });

  ///
  ///@param GroupId Identifier [Key|Filter|Sort]
  ///@param Name Name of Group [Filter|Sort]
  ///@param PageNo The page number in the result set starting from 1.  PageNo is required when the PageSize is specified.
  ///@param PageSize Limit result set to the specified amount.
  ///@param Sort A sort expression to use of the form: Field1:asc,Field2:desc
  Future<
          chopper.Response<
              FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponse>>
      apiV1GroupLookupgroupGet({
    String? groupId,
    String? name,
    int? pageNo,
    int? pageSize,
    String? sort,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponse,
        () =>
            FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponse
                .fromJsonFactory);

    return _apiV1GroupLookupgroupGet(
        groupId: groupId,
        name: name,
        pageNo: pageNo,
        pageSize: pageSize,
        sort: sort,
        cacheControl: cacheControl);
  }

  ///
  ///@param GroupId Identifier [Key|Filter|Sort]
  ///@param Name Name of Group [Filter|Sort]
  ///@param PageNo The page number in the result set starting from 1.  PageNo is required when the PageSize is specified.
  ///@param PageSize Limit result set to the specified amount.
  ///@param Sort A sort expression to use of the form: Field1:asc,Field2:desc
  @Get(path: '/api/v1/group/lookupgroup')
  Future<
          chopper.Response<
              FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponse>>
      _apiV1GroupLookupgroupGet({
    @Query('GroupId') String? groupId,
    @Query('Name') String? name,
    @Query('PageNo') int? pageNo,
    @Query('PageSize') int? pageSize,
    @Query('Sort') String? sort,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<Object>> apiV1GroupLegendGet({String? cacheControl}) {
    return _apiV1GroupLegendGet(cacheControl: cacheControl);
  }

  ///
  @Get(path: '/api/v1/group/legend')
  Future<chopper.Response<Object>> _apiV1GroupLegendGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty object
  Future<chopper.Response> apiV1GroupEmptyobjectGet({String? cacheControl}) {
    return _apiV1GroupEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/group/emptyobject')
  Future<chopper.Response> _apiV1GroupEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1GroupEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1GroupEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/group/emptybrowseobject')
  Future<chopper.Response> _apiV1GroupEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1GroupKeyfieldnamesGet({String? cacheControl}) {
    return _apiV1GroupKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/group/keyfieldnames')
  Future<chopper.Response> _apiV1GroupKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1HotfixBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1HotfixBrowsePost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/hotfix/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1HotfixBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1HotfixExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1HotfixExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/hotfix/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1HotfixExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogic>>
      apiV1HotfixGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogic
                .fromJsonFactory);

    return _apiV1HotfixGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/hotfix')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogic>>
      _apiV1HotfixGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesAdministratorHotfixHotfix>>
      apiV1HotfixIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesAdministratorHotfixHotfix,
        () => WebApiModulesAdministratorHotfixHotfix.fromJsonFactory);

    return _apiV1HotfixIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/hotfix/{id}')
  Future<chopper.Response<WebApiModulesAdministratorHotfixHotfix>>
      _apiV1HotfixIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1HotfixEmptyobjectGet({String? cacheControl}) {
    return _apiV1HotfixEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/hotfix/emptyobject')
  Future<chopper.Response> _apiV1HotfixEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1HotfixEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1HotfixEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/hotfix/emptybrowseobject')
  Future<chopper.Response> _apiV1HotfixEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1HotfixKeyfieldnamesGet({String? cacheControl}) {
    return _apiV1HotfixKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/hotfix/keyfieldnames')
  Future<chopper.Response> _apiV1HotfixKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<String>> apiV1HubspotAllcontactsPost({
    String? cacheControl,
    required WebApiModulesAccountServicesHubSpotGetHubSpotContactsRequest? body,
  }) {
    return _apiV1HubspotAllcontactsPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/hubspot/allcontacts')
  Future<chopper.Response<String>> _apiV1HubspotAllcontactsPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAccountServicesHubSpotGetHubSpotContactsRequest?
            body,
  });

  ///
  Future<chopper.Response<String>> apiV1HubspotNewcontactPost({
    String? cacheControl,
    required WebApiModulesAccountServicesHubSpotPostHubSpotContactRequest? body,
  }) {
    return _apiV1HubspotNewcontactPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/hubspot/newcontact')
  Future<chopper.Response<String>> _apiV1HubspotNewcontactPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAccountServicesHubSpotPostHubSpotContactRequest?
            body,
  });

  ///
  Future<
          chopper.Response<
              WebApiModulesAccountServicesHubSpotGetWriteTokensResponse>>
      apiV1HubspotGettokensPost({
    String? cacheControl,
    required WebApiModulesAccountServicesHubSpotGetHubSpotTokensRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAccountServicesHubSpotGetWriteTokensResponse,
        () => WebApiModulesAccountServicesHubSpotGetWriteTokensResponse
            .fromJsonFactory);

    return _apiV1HubspotGettokensPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/hubspot/gettokens')
  Future<
          chopper.Response<
              WebApiModulesAccountServicesHubSpotGetWriteTokensResponse>>
      _apiV1HubspotGettokensPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAccountServicesHubSpotGetHubSpotTokensRequest?
            body,
  });

  ///
  Future<chopper.Response> apiV1HubspotGetcontactsepochPost({
    String? cacheControl,
    required WebApiModulesAccountServicesHubSpotSearchHubSpotContactsWithinPeriodRequest?
        body,
  }) {
    return _apiV1HubspotGetcontactsepochPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/hubspot/getcontactsepoch')
  Future<chopper.Response> _apiV1HubspotGetcontactsepochPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAccountServicesHubSpotSearchHubSpotContactsWithinPeriodRequest?
            body,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1HubspotEmptyobjectGet({String? cacheControl}) {
    return _apiV1HubspotEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/hubspot/emptyobject')
  Future<chopper.Response> _apiV1HubspotEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1HubspotEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1HubspotEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/hubspot/emptybrowseobject')
  Future<chopper.Response> _apiV1HubspotEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1HubspotKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1HubspotKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/hubspot/keyfieldnames')
  Future<chopper.Response> _apiV1HubspotKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1PersonBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1PersonBrowsePost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/person/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1PersonBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1PersonExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1PersonExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/person/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1PersonExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1PersonEmptyobjectGet({String? cacheControl}) {
    return _apiV1PersonEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/person/emptyobject')
  Future<chopper.Response> _apiV1PersonEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1PersonEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1PersonEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/person/emptybrowseobject')
  Future<chopper.Response> _apiV1PersonEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1PersonKeyfieldnamesGet({String? cacheControl}) {
    return _apiV1PersonKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/person/keyfieldnames')
  Future<chopper.Response> _apiV1PersonKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1PluginBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1PluginBrowsePost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/plugin/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1PluginBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1PluginExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1PluginExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/plugin/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1PluginExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogic>>
      apiV1PluginGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogic
                .fromJsonFactory);

    return _apiV1PluginGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/plugin')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogic>>
      _apiV1PluginGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesAdministratorPluginPlugin>>
      apiV1PluginIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesAdministratorPluginPlugin,
        () => WebApiModulesAdministratorPluginPlugin.fromJsonFactory);

    return _apiV1PluginIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/plugin/{id}')
  Future<chopper.Response<WebApiModulesAdministratorPluginPlugin>>
      _apiV1PluginIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesAdministratorPluginPlugin>>
      apiV1PluginIdPut({
    required String? id,
    String? cacheControl,
    required WebApiModulesAdministratorPluginPlugin? body,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesAdministratorPluginPlugin,
        () => WebApiModulesAdministratorPluginPlugin.fromJsonFactory);

    return _apiV1PluginIdPut(id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/plugin/{id}')
  Future<chopper.Response<WebApiModulesAdministratorPluginPlugin>>
      _apiV1PluginIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesAdministratorPluginPlugin? body,
  });

  ///
  ///@param description
  Future<chopper.Response<WebApiModulesAdministratorPluginPlugin>>
      apiV1PluginDescriptionDescriptionGet({
    required String? description,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesAdministratorPluginPlugin,
        () => WebApiModulesAdministratorPluginPlugin.fromJsonFactory);

    return _apiV1PluginDescriptionDescriptionGet(
        description: description, cacheControl: cacheControl);
  }

  ///
  ///@param description
  @Get(path: '/api/v1/plugin/description/{description}')
  Future<chopper.Response<WebApiModulesAdministratorPluginPlugin>>
      _apiV1PluginDescriptionDescriptionGet({
    @Path('description') required String? description,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1PluginEmptyobjectGet({String? cacheControl}) {
    return _apiV1PluginEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/plugin/emptyobject')
  Future<chopper.Response> _apiV1PluginEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1PluginEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1PluginEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/plugin/emptybrowseobject')
  Future<chopper.Response> _apiV1PluginEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1PluginKeyfieldnamesGet({String? cacheControl}) {
    return _apiV1PluginKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/plugin/keyfieldnames')
  Future<chopper.Response> _apiV1PluginKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<
          chopper.Response<
              WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponse>>
      apiV1SystemupdateVersionhotfixPost({
    String? cacheControl,
    required WebApiModulesAdministratorSystemUpdateGetVersionHotfixRequest?
        body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponse,
        () => WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponse
            .fromJsonFactory);

    return _apiV1SystemupdateVersionhotfixPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/systemupdate/versionhotfix')
  Future<
          chopper.Response<
              WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponse>>
      _apiV1SystemupdateVersionhotfixPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAdministratorSystemUpdateGetVersionHotfixRequest?
            body,
  });

  ///
  Future<
          chopper.Response<
              WebApiModulesAdministratorSystemUpdateAvailableVersionsResponse>>
      apiV1SystemupdateAvailableversionsPost({
    String? cacheControl,
    required WebApiModulesAdministratorSystemUpdateAvailableVersionsRequest?
        body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorSystemUpdateAvailableVersionsResponse,
        () => WebApiModulesAdministratorSystemUpdateAvailableVersionsResponse
            .fromJsonFactory);

    return _apiV1SystemupdateAvailableversionsPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/systemupdate/availableversions')
  Future<
          chopper.Response<
              WebApiModulesAdministratorSystemUpdateAvailableVersionsResponse>>
      _apiV1SystemupdateAvailableversionsPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAdministratorSystemUpdateAvailableVersionsRequest?
            body,
  });

  ///
  Future<
          chopper.Response<
              WebApiModulesAdministratorSystemUpdateBuildDocumentsResponse>>
      apiV1SystemupdateBuilddocumentsPost({
    String? cacheControl,
    required WebApiModulesAdministratorSystemUpdateBuildDocumentsRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorSystemUpdateBuildDocumentsResponse,
        () => WebApiModulesAdministratorSystemUpdateBuildDocumentsResponse
            .fromJsonFactory);

    return _apiV1SystemupdateBuilddocumentsPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/systemupdate/builddocuments')
  Future<
          chopper.Response<
              WebApiModulesAdministratorSystemUpdateBuildDocumentsResponse>>
      _apiV1SystemupdateBuilddocumentsPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAdministratorSystemUpdateBuildDocumentsRequest?
            body,
  });

  ///
  Future<
          chopper.Response<
              WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponse>>
      apiV1SystemupdateDownloadbuilddocumentPost({
    String? cacheControl,
    required WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentRequest?
        body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponse,
        () =>
            WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponse
                .fromJsonFactory);

    return _apiV1SystemupdateDownloadbuilddocumentPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/systemupdate/downloadbuilddocument')
  Future<
          chopper.Response<
              WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponse>>
      _apiV1SystemupdateDownloadbuilddocumentPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentRequest?
            body,
  });

  ///
  Future<
          chopper.Response<
              WebApiModulesAdministratorSystemUpdateApplyUpdateResponse>>
      apiV1SystemupdateApplyupdatePost({
    String? cacheControl,
    required WebApiModulesAdministratorSystemUpdateApplyUpdateRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorSystemUpdateApplyUpdateResponse,
        () => WebApiModulesAdministratorSystemUpdateApplyUpdateResponse
            .fromJsonFactory);

    return _apiV1SystemupdateApplyupdatePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/systemupdate/applyupdate')
  Future<
          chopper.Response<
              WebApiModulesAdministratorSystemUpdateApplyUpdateResponse>>
      _apiV1SystemupdateApplyupdatePost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAdministratorSystemUpdateApplyUpdateRequest? body,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1SystemupdateEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1SystemupdateEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/systemupdate/emptyobject')
  Future<chopper.Response> _apiV1SystemupdateEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1SystemupdateEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1SystemupdateEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/systemupdate/emptybrowseobject')
  Future<chopper.Response> _apiV1SystemupdateEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1SystemupdateKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1SystemupdateKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/systemupdate/keyfieldnames')
  Future<chopper.Response> _apiV1SystemupdateKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1SystemupdatehistoryBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1SystemupdatehistoryBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/systemupdatehistory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1SystemupdatehistoryBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1SystemupdatehistoryExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1SystemupdatehistoryExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/systemupdatehistory/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1SystemupdatehistoryExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogic>>
      apiV1SystemupdatehistoryGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogic
                .fromJsonFactory);

    return _apiV1SystemupdatehistoryGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/systemupdatehistory')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogic>>
      _apiV1SystemupdatehistoryGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<
          chopper.Response<
              WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory>>
      apiV1SystemupdatehistoryPost({
    String? cacheControl,
    required WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory?
        body,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory,
        () => WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory
            .fromJsonFactory);

    return _apiV1SystemupdatehistoryPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/systemupdatehistory')
  Future<
          chopper.Response<
              WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory>>
      _apiV1SystemupdatehistoryPost({
    @Header('Cache-Control') String? cacheControl,
    @Body()
        required WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory?
            body,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory>>
      apiV1SystemupdatehistoryIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory,
        () => WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory
            .fromJsonFactory);

    return _apiV1SystemupdatehistoryIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/systemupdatehistory/{id}')
  Future<
          chopper.Response<
              WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory>>
      _apiV1SystemupdatehistoryIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1SystemupdatehistoryEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1SystemupdatehistoryEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/systemupdatehistory/emptyobject')
  Future<chopper.Response> _apiV1SystemupdatehistoryEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1SystemupdatehistoryEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1SystemupdatehistoryEmptybrowseobjectGet(
        cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/systemupdatehistory/emptybrowseobject')
  Future<chopper.Response> _apiV1SystemupdatehistoryEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1SystemupdatehistoryKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1SystemupdatehistoryKeyfieldnamesGet(
        cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/systemupdatehistory/keyfieldnames')
  Future<chopper.Response> _apiV1SystemupdatehistoryKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1SystemupdatehistorylogBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1SystemupdatehistorylogBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/systemupdatehistorylog/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1SystemupdatehistorylogBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1SystemupdatehistorylogExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1SystemupdatehistorylogExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/systemupdatehistorylog/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1SystemupdatehistorylogExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogic>>
      apiV1SystemupdatehistorylogGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogic
                .fromJsonFactory);

    return _apiV1SystemupdatehistorylogGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/systemupdatehistorylog')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogic>>
      _apiV1SystemupdatehistorylogGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLog>>
      apiV1SystemupdatehistorylogIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLog,
        () =>
            WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLog
                .fromJsonFactory);

    return _apiV1SystemupdatehistorylogIdGet(
        id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/systemupdatehistorylog/{id}')
  Future<
          chopper.Response<
              WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLog>>
      _apiV1SystemupdatehistorylogIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1SystemupdatehistorylogEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1SystemupdatehistorylogEmptyobjectGet(
        cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/systemupdatehistorylog/emptyobject')
  Future<chopper.Response> _apiV1SystemupdatehistorylogEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1SystemupdatehistorylogEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1SystemupdatehistorylogEmptybrowseobjectGet(
        cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/systemupdatehistorylog/emptybrowseobject')
  Future<chopper.Response> _apiV1SystemupdatehistorylogEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1SystemupdatehistorylogKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1SystemupdatehistorylogKeyfieldnamesGet(
        cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/systemupdatehistorylog/keyfieldnames')
  Future<chopper.Response> _apiV1SystemupdatehistorylogKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserBrowsePost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1UserExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1UserExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1UserExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogic>>
      apiV1UserGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogic
                .fromJsonFactory);

    return _apiV1UserGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/user')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogic>>
      _apiV1UserGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<WebApiModulesAdministratorUserUser>> apiV1UserPost({
    String? cacheControl,
    required WebApiModulesAdministratorUserUser? body,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesAdministratorUserUser,
        () => WebApiModulesAdministratorUserUser.fromJsonFactory);

    return _apiV1UserPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user')
  Future<chopper.Response<WebApiModulesAdministratorUserUser>> _apiV1UserPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesAdministratorUserUser? body,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesAdministratorUserUser>> apiV1UserIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesAdministratorUserUser,
        () => WebApiModulesAdministratorUserUser.fromJsonFactory);

    return _apiV1UserIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/user/{id}')
  Future<chopper.Response<WebApiModulesAdministratorUserUser>> _apiV1UserIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesAdministratorUserUser>> apiV1UserIdPut({
    required String? id,
    String? cacheControl,
    required WebApiModulesAdministratorUserUser? body,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesAdministratorUserUser,
        () => WebApiModulesAdministratorUserUser.fromJsonFactory);

    return _apiV1UserIdPut(id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/user/{id}')
  Future<chopper.Response<WebApiModulesAdministratorUserUser>> _apiV1UserIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesAdministratorUserUser? body,
  });

  ///
  ///@param id
  Future<chopper.Response<bool>> apiV1UserIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _apiV1UserIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Delete(path: '/api/v1/user/{id}')
  Future<chopper.Response<bool>> _apiV1UserIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidategroupBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidategroupBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validategroup/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidategroupBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidateusertitleBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidateusertitleBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validateusertitle/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidateusertitleBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidateofficelocationBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidateofficelocationBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validateofficelocation/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidateofficelocationBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidatewarehouselocationBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidatewarehouselocationBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validatewarehouselocation/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidatewarehouselocationBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidatestateBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidatestateBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validatestate/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidatestateBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidatecountryBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidatecountryBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validatecountry/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidatecountryBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidaterentaldepartmentBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidaterentaldepartmentBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validaterentaldepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidaterentaldepartmentBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidatesalesdepartmentBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidatesalesdepartmentBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validatesalesdepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidatesalesdepartmentBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidatelabordepartmentBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidatelabordepartmentBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validatelabordepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidatelabordepartmentBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidatemiscdepartmentBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidatemiscdepartmentBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validatemiscdepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidatemiscdepartmentBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidatepartsdepartmentBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidatepartsdepartmentBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validatepartsdepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidatepartsdepartmentBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidatefacilitydepartmentBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidatefacilitydepartmentBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validatefacilitydepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidatefacilitydepartmentBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidatetransportationdepartmentBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidatetransportationdepartmentBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validatetransportationdepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidatetransportationdepartmentBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidaterentalinventoryBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidaterentalinventoryBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validaterentalinventory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidaterentalinventoryBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidatesalesinventorytypeBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidatesalesinventorytypeBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validatesalesinventorytype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidatesalesinventorytypeBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidatepartsinventorytypeBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidatepartsinventorytypeBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validatepartsinventorytype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidatepartsinventorytypeBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidatetransportationtypeBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidatetransportationtypeBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validatetransportationtype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidatetransportationtypeBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidatelabortypeBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidatelabortypeBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validatelabortype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidatelabortypeBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidatemisctypeBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidatemisctypeBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validatemisctype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidatemisctypeBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidatefacilitytypeBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidatefacilitytypeBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validatefacilitytype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidatefacilitytypeBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidatesuccesssoundBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidatesuccesssoundBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validatesuccesssound/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidatesuccesssoundBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidateerrorsoundBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidateerrorsoundBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validateerrorsound/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidateerrorsoundBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1UserValidatenotificationsoundBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1UserValidatenotificationsoundBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/user/validatenotificationsound/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1UserValidatenotificationsoundBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<chopper.Response<WebApiModulesAdministratorUserUserCountResponse>>
      apiV1UserGetusercountsGet({String? cacheControl}) {
    generatedMapping.putIfAbsent(
        WebApiModulesAdministratorUserUserCountResponse,
        () => WebApiModulesAdministratorUserUserCountResponse.fromJsonFactory);

    return _apiV1UserGetusercountsGet(cacheControl: cacheControl);
  }

  ///
  @Get(path: '/api/v1/user/getusercounts')
  Future<chopper.Response<WebApiModulesAdministratorUserUserCountResponse>>
      _apiV1UserGetusercountsGet(
          {@Header('Cache-Control') String? cacheControl});

  ///Get an empty object
  Future<chopper.Response> apiV1UserEmptyobjectGet({String? cacheControl}) {
    return _apiV1UserEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/user/emptyobject')
  Future<chopper.Response> _apiV1UserEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1UserEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1UserEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/user/emptybrowseobject')
  Future<chopper.Response> _apiV1UserEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1UserKeyfieldnamesGet({String? cacheControl}) {
    return _apiV1UserKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/user/keyfieldnames')
  Future<chopper.Response> _apiV1UserKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1WebalertlogBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1WebalertlogBrowsePost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/webalertlog/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1WebalertlogBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1WebalertlogExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1WebalertlogExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/webalertlog/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1WebalertlogExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogic>>
      apiV1WebalertlogGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogic,
        () =>
            FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogic
                .fromJsonFactory);

    return _apiV1WebalertlogGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/webalertlog')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogic>>
      _apiV1WebalertlogGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              FwStandardModulesAdministratorWebAlertLogWebAlertLogLogic>>
      apiV1WebalertlogIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorWebAlertLogWebAlertLogLogic,
        () => FwStandardModulesAdministratorWebAlertLogWebAlertLogLogic
            .fromJsonFactory);

    return _apiV1WebalertlogIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/webalertlog/{id}')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorWebAlertLogWebAlertLogLogic>>
      _apiV1WebalertlogIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1WebalertlogEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1WebalertlogEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/webalertlog/emptyobject')
  Future<chopper.Response> _apiV1WebalertlogEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1WebalertlogEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1WebalertlogEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/webalertlog/emptybrowseobject')
  Future<chopper.Response> _apiV1WebalertlogEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1WebalertlogKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1WebalertlogKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/webalertlog/keyfieldnames')
  Future<chopper.Response> _apiV1WebalertlogKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1WebauditjsonBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1WebauditjsonBrowsePost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/webauditjson/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1WebauditjsonBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1WebauditjsonExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1WebauditjsonExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/webauditjson/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1WebauditjsonExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param id
  Future<
          chopper.Response<
              FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogic>>
      apiV1WebauditjsonIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogic,
        () => FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogic
            .fromJsonFactory);

    return _apiV1WebauditjsonIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/webauditjson/{id}')
  Future<
          chopper.Response<
              FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogic>>
      _apiV1WebauditjsonIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1WebauditjsonEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1WebauditjsonEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/webauditjson/emptyobject')
  Future<chopper.Response> _apiV1WebauditjsonEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1WebauditjsonEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1WebauditjsonEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/webauditjson/emptybrowseobject')
  Future<chopper.Response> _apiV1WebauditjsonEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1WebauditjsonKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1WebauditjsonKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/webauditjson/keyfieldnames')
  Future<chopper.Response> _apiV1WebauditjsonKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1WidgetgroupBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1WidgetgroupBrowsePost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/widgetgroup/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1WidgetgroupBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1WidgetgroupExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1WidgetgroupExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/widgetgroup/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1WidgetgroupExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogic>>
      apiV1WidgetgroupGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogic
                .fromJsonFactory);

    return _apiV1WidgetgroupGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/widgetgroup')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogic>>
      _apiV1WidgetgroupGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<WebApiModulesSettingsWidgetGroupWidgetGroup>>
      apiV1WidgetgroupPost({
    String? cacheControl,
    required WebApiModulesSettingsWidgetGroupWidgetGroup? body,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesSettingsWidgetGroupWidgetGroup,
        () => WebApiModulesSettingsWidgetGroupWidgetGroup.fromJsonFactory);

    return _apiV1WidgetgroupPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/widgetgroup')
  Future<chopper.Response<WebApiModulesSettingsWidgetGroupWidgetGroup>>
      _apiV1WidgetgroupPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesSettingsWidgetGroupWidgetGroup? body,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesSettingsWidgetGroupWidgetGroup>>
      apiV1WidgetgroupIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesSettingsWidgetGroupWidgetGroup,
        () => WebApiModulesSettingsWidgetGroupWidgetGroup.fromJsonFactory);

    return _apiV1WidgetgroupIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/widgetgroup/{id}')
  Future<chopper.Response<WebApiModulesSettingsWidgetGroupWidgetGroup>>
      _apiV1WidgetgroupIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesSettingsWidgetGroupWidgetGroup>>
      apiV1WidgetgroupIdPut({
    required String? id,
    String? cacheControl,
    required WebApiModulesSettingsWidgetGroupWidgetGroup? body,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesSettingsWidgetGroupWidgetGroup,
        () => WebApiModulesSettingsWidgetGroupWidgetGroup.fromJsonFactory);

    return _apiV1WidgetgroupIdPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/widgetgroup/{id}')
  Future<chopper.Response<WebApiModulesSettingsWidgetGroupWidgetGroup>>
      _apiV1WidgetgroupIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesSettingsWidgetGroupWidgetGroup? body,
  });

  ///
  ///@param id
  Future<chopper.Response<bool>> apiV1WidgetgroupIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _apiV1WidgetgroupIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Delete(path: '/api/v1/widgetgroup/{id}')
  Future<chopper.Response<bool>> _apiV1WidgetgroupIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1WidgetgroupValidategroupBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1WidgetgroupValidategroupBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/widgetgroup/validategroup/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1WidgetgroupValidategroupBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1WidgetgroupEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1WidgetgroupEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/widgetgroup/emptyobject')
  Future<chopper.Response> _apiV1WidgetgroupEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1WidgetgroupEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1WidgetgroupEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/widgetgroup/emptybrowseobject')
  Future<chopper.Response> _apiV1WidgetgroupEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1WidgetgroupKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1WidgetgroupKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/widgetgroup/keyfieldnames')
  Future<chopper.Response> _apiV1WidgetgroupKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1WidgetuserBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1WidgetuserBrowsePost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/widgetuser/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1WidgetuserBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      apiV1WidgetuserExportexcelxlsxPost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult,
        () =>
            FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
                .fromJsonFactory);

    return _apiV1WidgetuserExportexcelxlsxPost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/widgetuser/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      _apiV1WidgetuserExportexcelxlsxPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogic>>
      apiV1WidgetuserGet({
    int? pageno,
    int? pagesize,
    String? sort,
    List<FwStandardModelsFwQueryFilter>? filter,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogic,
        () =>
            FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogic
                .fromJsonFactory);

    return _apiV1WidgetuserGet(
        pageno: pageno,
        pagesize: pagesize,
        sort: sort,
        filter: filter,
        cacheControl: cacheControl);
  }

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/api/v1/widgetuser')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogic>>
      _apiV1WidgetuserGet({
    @Query('pageno') int? pageno,
    @Query('pagesize') int? pagesize,
    @Query('sort') String? sort,
    @Query('filter') List<FwStandardModelsFwQueryFilter>? filter,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<WebApiModulesSettingsWidgetUserWidgetUser>>
      apiV1WidgetuserPost({
    String? cacheControl,
    required WebApiModulesSettingsWidgetUserWidgetUser? body,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesSettingsWidgetUserWidgetUser,
        () => WebApiModulesSettingsWidgetUserWidgetUser.fromJsonFactory);

    return _apiV1WidgetuserPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/widgetuser')
  Future<chopper.Response<WebApiModulesSettingsWidgetUserWidgetUser>>
      _apiV1WidgetuserPost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesSettingsWidgetUserWidgetUser? body,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesSettingsWidgetUserWidgetUser>>
      apiV1WidgetuserIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesSettingsWidgetUserWidgetUser,
        () => WebApiModulesSettingsWidgetUserWidgetUser.fromJsonFactory);

    return _apiV1WidgetuserIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/api/v1/widgetuser/{id}')
  Future<chopper.Response<WebApiModulesSettingsWidgetUserWidgetUser>>
      _apiV1WidgetuserIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param id
  Future<chopper.Response<WebApiModulesSettingsWidgetUserWidgetUser>>
      apiV1WidgetuserIdPut({
    required String? id,
    String? cacheControl,
    required WebApiModulesSettingsWidgetUserWidgetUser? body,
  }) {
    generatedMapping.putIfAbsent(WebApiModulesSettingsWidgetUserWidgetUser,
        () => WebApiModulesSettingsWidgetUserWidgetUser.fromJsonFactory);

    return _apiV1WidgetuserIdPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/api/v1/widgetuser/{id}')
  Future<chopper.Response<WebApiModulesSettingsWidgetUserWidgetUser>>
      _apiV1WidgetuserIdPut({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
    @Body() required WebApiModulesSettingsWidgetUserWidgetUser? body,
  });

  ///
  ///@param id
  Future<chopper.Response<bool>> apiV1WidgetuserIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _apiV1WidgetuserIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Delete(path: '/api/v1/widgetuser/{id}')
  Future<chopper.Response<bool>> _apiV1WidgetuserIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      apiV1WidgetuserValidateuserBrowsePost({
    String? cacheControl,
    required FwStandardModelsBrowseRequest? body,
  }) {
    generatedMapping.putIfAbsent(FwStandardSqlServerFwJsonDataTable,
        () => FwStandardSqlServerFwJsonDataTable.fromJsonFactory);

    return _apiV1WidgetuserValidateuserBrowsePost(
        cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/api/v1/widgetuser/validateuser/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      _apiV1WidgetuserValidateuserBrowsePost({
    @Header('Cache-Control') String? cacheControl,
    @Body() required FwStandardModelsBrowseRequest? body,
  });

  ///Get an empty object
  Future<chopper.Response> apiV1WidgetuserEmptyobjectGet(
      {String? cacheControl}) {
    return _apiV1WidgetuserEmptyobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty object
  @Get(path: '/api/v1/widgetuser/emptyobject')
  Future<chopper.Response> _apiV1WidgetuserEmptyobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an empty browse object
  Future<chopper.Response> apiV1WidgetuserEmptybrowseobjectGet(
      {String? cacheControl}) {
    return _apiV1WidgetuserEmptybrowseobjectGet(cacheControl: cacheControl);
  }

  ///Get an empty browse object
  @Get(path: '/api/v1/widgetuser/emptybrowseobject')
  Future<chopper.Response> _apiV1WidgetuserEmptybrowseobjectGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Get an array of primary key field names
  Future<chopper.Response> apiV1WidgetuserKeyfieldnamesGet(
      {String? cacheControl}) {
    return _apiV1WidgetuserKeyfieldnamesGet(cacheControl: cacheControl);
  }

  ///Get an array of primary key field names
  @Get(path: '/api/v1/widgetuser/keyfieldnames')
  Future<chopper.Response> _apiV1WidgetuserKeyfieldnamesGet(
      {@Header('Cache-Control') String? cacheControl});
}

@JsonSerializable(explicitToJson: true)
class FwCoreApiSwashbuckleBadRequestResponse {
  FwCoreApiSwashbuckleBadRequestResponse();

  factory FwCoreApiSwashbuckleBadRequestResponse.fromJson(
          Map<String, dynamic> json) =>
      _$FwCoreApiSwashbuckleBadRequestResponseFromJson(json);

  static const fromJsonFactory =
      _$FwCoreApiSwashbuckleBadRequestResponseFromJson;
  static const toJsonFactory = _$FwCoreApiSwashbuckleBadRequestResponseToJson;
  Map<String, dynamic> toJson() =>
      _$FwCoreApiSwashbuckleBadRequestResponseToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode => runtimeType.hashCode;
}

@JsonSerializable(explicitToJson: true)
class FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult {
  FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult({
    this.downloadUrl,
  });

  factory FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult.fromJson(
          Map<String, dynamic> json) =>
      _$FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResultFromJson(
          json);

  @JsonKey(name: 'downloadUrl', includeIfNull: false, defaultValue: '')
  final String? downloadUrl;
  static const fromJsonFactory =
      _$FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResultFromJson;
  static const toJsonFactory =
      _$FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResultToJson;
  Map<String, dynamic> toJson() =>
      _$FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResultToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult &&
            (identical(other.downloadUrl, downloadUrl) ||
                const DeepCollectionEquality()
                    .equals(other.downloadUrl, downloadUrl)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(downloadUrl) ^ runtimeType.hashCode;
}

extension $FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResultExtension
    on FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult {
  FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
      copyWith({String? downloadUrl}) {
    return FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult(
        downloadUrl: downloadUrl ?? this.downloadUrl);
  }

  FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
      copyWithWrapped({Wrapped<String?>? downloadUrl}) {
    return FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult(
        downloadUrl:
            (downloadUrl != null ? downloadUrl.value : this.downloadUrl));
  }
}

@JsonSerializable(explicitToJson: true)
class FwCoreModulesAdministratorGroupCopySecurityNodeRequest {
  FwCoreModulesAdministratorGroupCopySecurityNodeRequest({
    this.fromGroupId,
    this.toGroupIds,
    this.securityId,
  });

  factory FwCoreModulesAdministratorGroupCopySecurityNodeRequest.fromJson(
          Map<String, dynamic> json) =>
      _$FwCoreModulesAdministratorGroupCopySecurityNodeRequestFromJson(json);

  @JsonKey(name: 'FromGroupId', includeIfNull: false, defaultValue: '')
  final String? fromGroupId;
  @JsonKey(name: 'ToGroupIds', includeIfNull: false, defaultValue: '')
  final String? toGroupIds;
  @JsonKey(name: 'SecurityId', includeIfNull: false, defaultValue: '')
  final String? securityId;
  static const fromJsonFactory =
      _$FwCoreModulesAdministratorGroupCopySecurityNodeRequestFromJson;
  static const toJsonFactory =
      _$FwCoreModulesAdministratorGroupCopySecurityNodeRequestToJson;
  Map<String, dynamic> toJson() =>
      _$FwCoreModulesAdministratorGroupCopySecurityNodeRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwCoreModulesAdministratorGroupCopySecurityNodeRequest &&
            (identical(other.fromGroupId, fromGroupId) ||
                const DeepCollectionEquality()
                    .equals(other.fromGroupId, fromGroupId)) &&
            (identical(other.toGroupIds, toGroupIds) ||
                const DeepCollectionEquality()
                    .equals(other.toGroupIds, toGroupIds)) &&
            (identical(other.securityId, securityId) ||
                const DeepCollectionEquality()
                    .equals(other.securityId, securityId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(fromGroupId) ^
      const DeepCollectionEquality().hash(toGroupIds) ^
      const DeepCollectionEquality().hash(securityId) ^
      runtimeType.hashCode;
}

extension $FwCoreModulesAdministratorGroupCopySecurityNodeRequestExtension
    on FwCoreModulesAdministratorGroupCopySecurityNodeRequest {
  FwCoreModulesAdministratorGroupCopySecurityNodeRequest copyWith(
      {String? fromGroupId, String? toGroupIds, String? securityId}) {
    return FwCoreModulesAdministratorGroupCopySecurityNodeRequest(
        fromGroupId: fromGroupId ?? this.fromGroupId,
        toGroupIds: toGroupIds ?? this.toGroupIds,
        securityId: securityId ?? this.securityId);
  }

  FwCoreModulesAdministratorGroupCopySecurityNodeRequest copyWithWrapped(
      {Wrapped<String?>? fromGroupId,
      Wrapped<String?>? toGroupIds,
      Wrapped<String?>? securityId}) {
    return FwCoreModulesAdministratorGroupCopySecurityNodeRequest(
        fromGroupId:
            (fromGroupId != null ? fromGroupId.value : this.fromGroupId),
        toGroupIds: (toGroupIds != null ? toGroupIds.value : this.toGroupIds),
        securityId: (securityId != null ? securityId.value : this.securityId));
  }
}

@JsonSerializable(explicitToJson: true)
class FwCoreModulesAdministratorGroupLookupGroupResponse {
  FwCoreModulesAdministratorGroupLookupGroupResponse({
    this.groupId,
    this.name,
  });

  factory FwCoreModulesAdministratorGroupLookupGroupResponse.fromJson(
          Map<String, dynamic> json) =>
      _$FwCoreModulesAdministratorGroupLookupGroupResponseFromJson(json);

  @JsonKey(name: 'GroupId', includeIfNull: false, defaultValue: '')
  final String? groupId;
  @JsonKey(name: 'Name', includeIfNull: false, defaultValue: '')
  final String? name;
  static const fromJsonFactory =
      _$FwCoreModulesAdministratorGroupLookupGroupResponseFromJson;
  static const toJsonFactory =
      _$FwCoreModulesAdministratorGroupLookupGroupResponseToJson;
  Map<String, dynamic> toJson() =>
      _$FwCoreModulesAdministratorGroupLookupGroupResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwCoreModulesAdministratorGroupLookupGroupResponse &&
            (identical(other.groupId, groupId) ||
                const DeepCollectionEquality()
                    .equals(other.groupId, groupId)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(groupId) ^
      const DeepCollectionEquality().hash(name) ^
      runtimeType.hashCode;
}

extension $FwCoreModulesAdministratorGroupLookupGroupResponseExtension
    on FwCoreModulesAdministratorGroupLookupGroupResponse {
  FwCoreModulesAdministratorGroupLookupGroupResponse copyWith(
      {String? groupId, String? name}) {
    return FwCoreModulesAdministratorGroupLookupGroupResponse(
        groupId: groupId ?? this.groupId, name: name ?? this.name);
  }

  FwCoreModulesAdministratorGroupLookupGroupResponse copyWithWrapped(
      {Wrapped<String?>? groupId, Wrapped<String?>? name}) {
    return FwCoreModulesAdministratorGroupLookupGroupResponse(
        groupId: (groupId != null ? groupId.value : this.groupId),
        name: (name != null ? name.value : this.name));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardAppManagerFwAmSecurityTreeNode {
  FwStandardAppManagerFwAmSecurityTreeNode({
    this.id,
    this.caption,
    this.nodetype,
    this.properties,
    this.children,
  });

  factory FwStandardAppManagerFwAmSecurityTreeNode.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardAppManagerFwAmSecurityTreeNodeFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'caption', includeIfNull: false, defaultValue: '')
  final String? caption;
  @JsonKey(name: 'nodetype', includeIfNull: false, defaultValue: '')
  final String? nodetype;
  @JsonKey(name: 'properties', includeIfNull: false)
  final Map<String, dynamic>? properties;
  @JsonKey(
      name: 'children',
      includeIfNull: false,
      defaultValue: <FwStandardAppManagerFwAmSecurityTreeNode>[])
  final List<FwStandardAppManagerFwAmSecurityTreeNode>? children;
  static const fromJsonFactory =
      _$FwStandardAppManagerFwAmSecurityTreeNodeFromJson;
  static const toJsonFactory = _$FwStandardAppManagerFwAmSecurityTreeNodeToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardAppManagerFwAmSecurityTreeNodeToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardAppManagerFwAmSecurityTreeNode &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.caption, caption) ||
                const DeepCollectionEquality()
                    .equals(other.caption, caption)) &&
            (identical(other.nodetype, nodetype) ||
                const DeepCollectionEquality()
                    .equals(other.nodetype, nodetype)) &&
            (identical(other.properties, properties) ||
                const DeepCollectionEquality()
                    .equals(other.properties, properties)) &&
            (identical(other.children, children) ||
                const DeepCollectionEquality()
                    .equals(other.children, children)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(caption) ^
      const DeepCollectionEquality().hash(nodetype) ^
      const DeepCollectionEquality().hash(properties) ^
      const DeepCollectionEquality().hash(children) ^
      runtimeType.hashCode;
}

extension $FwStandardAppManagerFwAmSecurityTreeNodeExtension
    on FwStandardAppManagerFwAmSecurityTreeNode {
  FwStandardAppManagerFwAmSecurityTreeNode copyWith(
      {String? id,
      String? caption,
      String? nodetype,
      Map<String, dynamic>? properties,
      List<FwStandardAppManagerFwAmSecurityTreeNode>? children}) {
    return FwStandardAppManagerFwAmSecurityTreeNode(
        id: id ?? this.id,
        caption: caption ?? this.caption,
        nodetype: nodetype ?? this.nodetype,
        properties: properties ?? this.properties,
        children: children ?? this.children);
  }

  FwStandardAppManagerFwAmSecurityTreeNode copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? caption,
      Wrapped<String?>? nodetype,
      Wrapped<Map<String, dynamic>?>? properties,
      Wrapped<List<FwStandardAppManagerFwAmSecurityTreeNode>?>? children}) {
    return FwStandardAppManagerFwAmSecurityTreeNode(
        id: (id != null ? id.value : this.id),
        caption: (caption != null ? caption.value : this.caption),
        nodetype: (nodetype != null ? nodetype.value : this.nodetype),
        properties: (properties != null ? properties.value : this.properties),
        children: (children != null ? children.value : this.children));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardBusinessLogicFwBusinessLogicFieldDefinition {
  FwStandardBusinessLogicFwBusinessLogicFieldDefinition({
    this.name,
    this.dataType,
  });

  factory FwStandardBusinessLogicFwBusinessLogicFieldDefinition.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardBusinessLogicFwBusinessLogicFieldDefinitionFromJson(json);

  @JsonKey(name: 'Name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(
    name: 'DataType',
    includeIfNull: false,
    toJson: fwStandardSqlServerFwDataTypesToJson,
    fromJson: fwStandardSqlServerFwDataTypesFromJson,
  )
  final enums.FwStandardSqlServerFwDataTypes? dataType;
  static const fromJsonFactory =
      _$FwStandardBusinessLogicFwBusinessLogicFieldDefinitionFromJson;
  static const toJsonFactory =
      _$FwStandardBusinessLogicFwBusinessLogicFieldDefinitionToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardBusinessLogicFwBusinessLogicFieldDefinitionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardBusinessLogicFwBusinessLogicFieldDefinition &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(dataType) ^
      runtimeType.hashCode;
}

extension $FwStandardBusinessLogicFwBusinessLogicFieldDefinitionExtension
    on FwStandardBusinessLogicFwBusinessLogicFieldDefinition {
  FwStandardBusinessLogicFwBusinessLogicFieldDefinition copyWith(
      {String? name, enums.FwStandardSqlServerFwDataTypes? dataType}) {
    return FwStandardBusinessLogicFwBusinessLogicFieldDefinition(
        name: name ?? this.name, dataType: dataType ?? this.dataType);
  }

  FwStandardBusinessLogicFwBusinessLogicFieldDefinition copyWithWrapped(
      {Wrapped<String?>? name,
      Wrapped<enums.FwStandardSqlServerFwDataTypes?>? dataType}) {
    return FwStandardBusinessLogicFwBusinessLogicFieldDefinition(
        name: (name != null ? name.value : this.name),
        dataType: (dataType != null ? dataType.value : this.dataType));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardDataFwCustomValue {
  FwStandardDataFwCustomValue({
    this.fieldName,
    this.fieldValue,
    this.fieldType,
  });

  factory FwStandardDataFwCustomValue.fromJson(Map<String, dynamic> json) =>
      _$FwStandardDataFwCustomValueFromJson(json);

  @JsonKey(name: 'FieldName', includeIfNull: false, defaultValue: '')
  final String? fieldName;
  @JsonKey(name: 'FieldValue', includeIfNull: false, defaultValue: '')
  final String? fieldValue;
  @JsonKey(name: 'FieldType', includeIfNull: false, defaultValue: '')
  final String? fieldType;
  static const fromJsonFactory = _$FwStandardDataFwCustomValueFromJson;
  static const toJsonFactory = _$FwStandardDataFwCustomValueToJson;
  Map<String, dynamic> toJson() => _$FwStandardDataFwCustomValueToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardDataFwCustomValue &&
            (identical(other.fieldName, fieldName) ||
                const DeepCollectionEquality()
                    .equals(other.fieldName, fieldName)) &&
            (identical(other.fieldValue, fieldValue) ||
                const DeepCollectionEquality()
                    .equals(other.fieldValue, fieldValue)) &&
            (identical(other.fieldType, fieldType) ||
                const DeepCollectionEquality()
                    .equals(other.fieldType, fieldType)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(fieldName) ^
      const DeepCollectionEquality().hash(fieldValue) ^
      const DeepCollectionEquality().hash(fieldType) ^
      runtimeType.hashCode;
}

extension $FwStandardDataFwCustomValueExtension on FwStandardDataFwCustomValue {
  FwStandardDataFwCustomValue copyWith(
      {String? fieldName, String? fieldValue, String? fieldType}) {
    return FwStandardDataFwCustomValue(
        fieldName: fieldName ?? this.fieldName,
        fieldValue: fieldValue ?? this.fieldValue,
        fieldType: fieldType ?? this.fieldType);
  }

  FwStandardDataFwCustomValue copyWithWrapped(
      {Wrapped<String?>? fieldName,
      Wrapped<String?>? fieldValue,
      Wrapped<String?>? fieldType}) {
    return FwStandardDataFwCustomValue(
        fieldName: (fieldName != null ? fieldName.value : this.fieldName),
        fieldValue: (fieldValue != null ? fieldValue.value : this.fieldValue),
        fieldType: (fieldType != null ? fieldType.value : this.fieldType));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardDataFwDefaultAttribute {
  FwStandardDataFwDefaultAttribute({
    this.fieldName,
    this.attributeName,
    this.defaultValue,
  });

  factory FwStandardDataFwDefaultAttribute.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardDataFwDefaultAttributeFromJson(json);

  @JsonKey(name: 'FieldName', includeIfNull: false, defaultValue: '')
  final String? fieldName;
  @JsonKey(name: 'AttributeName', includeIfNull: false, defaultValue: '')
  final String? attributeName;
  @JsonKey(name: 'DefaultValue', includeIfNull: false, defaultValue: '')
  final String? defaultValue;
  static const fromJsonFactory = _$FwStandardDataFwDefaultAttributeFromJson;
  static const toJsonFactory = _$FwStandardDataFwDefaultAttributeToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardDataFwDefaultAttributeToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardDataFwDefaultAttribute &&
            (identical(other.fieldName, fieldName) ||
                const DeepCollectionEquality()
                    .equals(other.fieldName, fieldName)) &&
            (identical(other.attributeName, attributeName) ||
                const DeepCollectionEquality()
                    .equals(other.attributeName, attributeName)) &&
            (identical(other.defaultValue, defaultValue) ||
                const DeepCollectionEquality()
                    .equals(other.defaultValue, defaultValue)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(fieldName) ^
      const DeepCollectionEquality().hash(attributeName) ^
      const DeepCollectionEquality().hash(defaultValue) ^
      runtimeType.hashCode;
}

extension $FwStandardDataFwDefaultAttributeExtension
    on FwStandardDataFwDefaultAttribute {
  FwStandardDataFwDefaultAttribute copyWith(
      {String? fieldName, String? attributeName, String? defaultValue}) {
    return FwStandardDataFwDefaultAttribute(
        fieldName: fieldName ?? this.fieldName,
        attributeName: attributeName ?? this.attributeName,
        defaultValue: defaultValue ?? this.defaultValue);
  }

  FwStandardDataFwDefaultAttribute copyWithWrapped(
      {Wrapped<String?>? fieldName,
      Wrapped<String?>? attributeName,
      Wrapped<String?>? defaultValue}) {
    return FwStandardDataFwDefaultAttribute(
        fieldName: (fieldName != null ? fieldName.value : this.fieldName),
        attributeName:
            (attributeName != null ? attributeName.value : this.attributeName),
        defaultValue:
            (defaultValue != null ? defaultValue.value : this.defaultValue));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsBrowseRequest {
  FwStandardModelsBrowseRequest({
    this.miscfields,
    this.module,
    this.options,
    this.orderby,
    this.orderbydirection,
    this.top,
    this.pageno,
    this.pagesize,
    this.searchfieldoperators,
    this.searchfields,
    this.searchfieldvalues,
    this.searchfieldtypes,
    this.searchseparators,
    this.searchcondition,
    this.searchconjunctions,
    this.uniqueids,
    this.boundids,
    this.filterfields,
    this.activeview,
    this.emptyobject,
    this.forexcel,
    this.excelfields,
    this.totalfields,
    this.activeviewfields,
  });

  factory FwStandardModelsBrowseRequest.fromJson(Map<String, dynamic> json) =>
      _$FwStandardModelsBrowseRequestFromJson(json);

  @JsonKey(name: 'miscfields', includeIfNull: false)
  final dynamic miscfields;
  @JsonKey(name: 'module', includeIfNull: false, defaultValue: '')
  final String? module;
  @JsonKey(name: 'options', includeIfNull: false)
  final dynamic options;
  @JsonKey(name: 'orderby', includeIfNull: false, defaultValue: '')
  final String? orderby;
  @JsonKey(name: 'orderbydirection', includeIfNull: false, defaultValue: '')
  final String? orderbydirection;
  @JsonKey(name: 'top', includeIfNull: false)
  final int? top;
  @JsonKey(name: 'pageno', includeIfNull: false)
  final int? pageno;
  @JsonKey(name: 'pagesize', includeIfNull: false)
  final int? pagesize;
  @JsonKey(
      name: 'searchfieldoperators',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? searchfieldoperators;
  @JsonKey(name: 'searchfields', includeIfNull: false, defaultValue: <String>[])
  final List<String>? searchfields;
  @JsonKey(
      name: 'searchfieldvalues', includeIfNull: false, defaultValue: <String>[])
  final List<String>? searchfieldvalues;
  @JsonKey(
      name: 'searchfieldtypes', includeIfNull: false, defaultValue: <String>[])
  final List<String>? searchfieldtypes;
  @JsonKey(
      name: 'searchseparators', includeIfNull: false, defaultValue: <String>[])
  final List<String>? searchseparators;
  @JsonKey(
      name: 'searchcondition', includeIfNull: false, defaultValue: <String>[])
  final List<String>? searchcondition;
  @JsonKey(
      name: 'searchconjunctions',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? searchconjunctions;
  @JsonKey(name: 'uniqueids', includeIfNull: false)
  final dynamic uniqueids;
  @JsonKey(name: 'boundids', includeIfNull: false)
  final dynamic boundids;
  @JsonKey(name: 'filterfields', includeIfNull: false)
  final Map<String, dynamic>? filterfields;
  @JsonKey(name: 'activeview', includeIfNull: false, defaultValue: '')
  final String? activeview;
  @JsonKey(name: 'emptyobject', includeIfNull: false)
  final bool? emptyobject;
  @JsonKey(name: 'forexcel', includeIfNull: false)
  final bool? forexcel;
  @JsonKey(
      name: 'excelfields',
      includeIfNull: false,
      defaultValue: <FwStandardModelsCheckBoxListItem>[])
  final List<FwStandardModelsCheckBoxListItem>? excelfields;
  @JsonKey(name: 'totalfields', includeIfNull: false, defaultValue: <String>[])
  final List<String>? totalfields;
  @JsonKey(name: 'activeviewfields', includeIfNull: false)
  final Map<String, dynamic>? activeviewfields;
  static const fromJsonFactory = _$FwStandardModelsBrowseRequestFromJson;
  static const toJsonFactory = _$FwStandardModelsBrowseRequestToJson;
  Map<String, dynamic> toJson() => _$FwStandardModelsBrowseRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsBrowseRequest &&
            (identical(other.miscfields, miscfields) ||
                const DeepCollectionEquality()
                    .equals(other.miscfields, miscfields)) &&
            (identical(other.module, module) ||
                const DeepCollectionEquality().equals(other.module, module)) &&
            (identical(other.options, options) ||
                const DeepCollectionEquality()
                    .equals(other.options, options)) &&
            (identical(other.orderby, orderby) ||
                const DeepCollectionEquality()
                    .equals(other.orderby, orderby)) &&
            (identical(other.orderbydirection, orderbydirection) ||
                const DeepCollectionEquality()
                    .equals(other.orderbydirection, orderbydirection)) &&
            (identical(other.top, top) ||
                const DeepCollectionEquality().equals(other.top, top)) &&
            (identical(other.pageno, pageno) ||
                const DeepCollectionEquality().equals(other.pageno, pageno)) &&
            (identical(other.pagesize, pagesize) ||
                const DeepCollectionEquality()
                    .equals(other.pagesize, pagesize)) &&
            (identical(other.searchfieldoperators, searchfieldoperators) ||
                const DeepCollectionEquality().equals(
                    other.searchfieldoperators, searchfieldoperators)) &&
            (identical(other.searchfields, searchfields) ||
                const DeepCollectionEquality()
                    .equals(other.searchfields, searchfields)) &&
            (identical(other.searchfieldvalues, searchfieldvalues) ||
                const DeepCollectionEquality()
                    .equals(other.searchfieldvalues, searchfieldvalues)) &&
            (identical(other.searchfieldtypes, searchfieldtypes) ||
                const DeepCollectionEquality()
                    .equals(other.searchfieldtypes, searchfieldtypes)) &&
            (identical(other.searchseparators, searchseparators) ||
                const DeepCollectionEquality()
                    .equals(other.searchseparators, searchseparators)) &&
            (identical(other.searchcondition, searchcondition) ||
                const DeepCollectionEquality()
                    .equals(other.searchcondition, searchcondition)) &&
            (identical(other.searchconjunctions, searchconjunctions) ||
                const DeepCollectionEquality()
                    .equals(other.searchconjunctions, searchconjunctions)) &&
            (identical(other.uniqueids, uniqueids) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueids, uniqueids)) &&
            (identical(other.boundids, boundids) ||
                const DeepCollectionEquality()
                    .equals(other.boundids, boundids)) &&
            (identical(other.filterfields, filterfields) ||
                const DeepCollectionEquality()
                    .equals(other.filterfields, filterfields)) &&
            (identical(other.activeview, activeview) ||
                const DeepCollectionEquality()
                    .equals(other.activeview, activeview)) &&
            (identical(other.emptyobject, emptyobject) ||
                const DeepCollectionEquality()
                    .equals(other.emptyobject, emptyobject)) &&
            (identical(other.forexcel, forexcel) ||
                const DeepCollectionEquality()
                    .equals(other.forexcel, forexcel)) &&
            (identical(other.excelfields, excelfields) ||
                const DeepCollectionEquality()
                    .equals(other.excelfields, excelfields)) &&
            (identical(other.totalfields, totalfields) ||
                const DeepCollectionEquality()
                    .equals(other.totalfields, totalfields)) &&
            (identical(other.activeviewfields, activeviewfields) || const DeepCollectionEquality().equals(other.activeviewfields, activeviewfields)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(miscfields) ^
      const DeepCollectionEquality().hash(module) ^
      const DeepCollectionEquality().hash(options) ^
      const DeepCollectionEquality().hash(orderby) ^
      const DeepCollectionEquality().hash(orderbydirection) ^
      const DeepCollectionEquality().hash(top) ^
      const DeepCollectionEquality().hash(pageno) ^
      const DeepCollectionEquality().hash(pagesize) ^
      const DeepCollectionEquality().hash(searchfieldoperators) ^
      const DeepCollectionEquality().hash(searchfields) ^
      const DeepCollectionEquality().hash(searchfieldvalues) ^
      const DeepCollectionEquality().hash(searchfieldtypes) ^
      const DeepCollectionEquality().hash(searchseparators) ^
      const DeepCollectionEquality().hash(searchcondition) ^
      const DeepCollectionEquality().hash(searchconjunctions) ^
      const DeepCollectionEquality().hash(uniqueids) ^
      const DeepCollectionEquality().hash(boundids) ^
      const DeepCollectionEquality().hash(filterfields) ^
      const DeepCollectionEquality().hash(activeview) ^
      const DeepCollectionEquality().hash(emptyobject) ^
      const DeepCollectionEquality().hash(forexcel) ^
      const DeepCollectionEquality().hash(excelfields) ^
      const DeepCollectionEquality().hash(totalfields) ^
      const DeepCollectionEquality().hash(activeviewfields) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsBrowseRequestExtension
    on FwStandardModelsBrowseRequest {
  FwStandardModelsBrowseRequest copyWith(
      {dynamic miscfields,
      String? module,
      dynamic options,
      String? orderby,
      String? orderbydirection,
      int? top,
      int? pageno,
      int? pagesize,
      List<String>? searchfieldoperators,
      List<String>? searchfields,
      List<String>? searchfieldvalues,
      List<String>? searchfieldtypes,
      List<String>? searchseparators,
      List<String>? searchcondition,
      List<String>? searchconjunctions,
      dynamic uniqueids,
      dynamic boundids,
      Map<String, dynamic>? filterfields,
      String? activeview,
      bool? emptyobject,
      bool? forexcel,
      List<FwStandardModelsCheckBoxListItem>? excelfields,
      List<String>? totalfields,
      Map<String, dynamic>? activeviewfields}) {
    return FwStandardModelsBrowseRequest(
        miscfields: miscfields ?? this.miscfields,
        module: module ?? this.module,
        options: options ?? this.options,
        orderby: orderby ?? this.orderby,
        orderbydirection: orderbydirection ?? this.orderbydirection,
        top: top ?? this.top,
        pageno: pageno ?? this.pageno,
        pagesize: pagesize ?? this.pagesize,
        searchfieldoperators: searchfieldoperators ?? this.searchfieldoperators,
        searchfields: searchfields ?? this.searchfields,
        searchfieldvalues: searchfieldvalues ?? this.searchfieldvalues,
        searchfieldtypes: searchfieldtypes ?? this.searchfieldtypes,
        searchseparators: searchseparators ?? this.searchseparators,
        searchcondition: searchcondition ?? this.searchcondition,
        searchconjunctions: searchconjunctions ?? this.searchconjunctions,
        uniqueids: uniqueids ?? this.uniqueids,
        boundids: boundids ?? this.boundids,
        filterfields: filterfields ?? this.filterfields,
        activeview: activeview ?? this.activeview,
        emptyobject: emptyobject ?? this.emptyobject,
        forexcel: forexcel ?? this.forexcel,
        excelfields: excelfields ?? this.excelfields,
        totalfields: totalfields ?? this.totalfields,
        activeviewfields: activeviewfields ?? this.activeviewfields);
  }

  FwStandardModelsBrowseRequest copyWithWrapped(
      {Wrapped<dynamic>? miscfields,
      Wrapped<String?>? module,
      Wrapped<dynamic>? options,
      Wrapped<String?>? orderby,
      Wrapped<String?>? orderbydirection,
      Wrapped<int?>? top,
      Wrapped<int?>? pageno,
      Wrapped<int?>? pagesize,
      Wrapped<List<String>?>? searchfieldoperators,
      Wrapped<List<String>?>? searchfields,
      Wrapped<List<String>?>? searchfieldvalues,
      Wrapped<List<String>?>? searchfieldtypes,
      Wrapped<List<String>?>? searchseparators,
      Wrapped<List<String>?>? searchcondition,
      Wrapped<List<String>?>? searchconjunctions,
      Wrapped<dynamic>? uniqueids,
      Wrapped<dynamic>? boundids,
      Wrapped<Map<String, dynamic>?>? filterfields,
      Wrapped<String?>? activeview,
      Wrapped<bool?>? emptyobject,
      Wrapped<bool?>? forexcel,
      Wrapped<List<FwStandardModelsCheckBoxListItem>?>? excelfields,
      Wrapped<List<String>?>? totalfields,
      Wrapped<Map<String, dynamic>?>? activeviewfields}) {
    return FwStandardModelsBrowseRequest(
        miscfields: (miscfields != null ? miscfields.value : this.miscfields),
        module: (module != null ? module.value : this.module),
        options: (options != null ? options.value : this.options),
        orderby: (orderby != null ? orderby.value : this.orderby),
        orderbydirection: (orderbydirection != null
            ? orderbydirection.value
            : this.orderbydirection),
        top: (top != null ? top.value : this.top),
        pageno: (pageno != null ? pageno.value : this.pageno),
        pagesize: (pagesize != null ? pagesize.value : this.pagesize),
        searchfieldoperators: (searchfieldoperators != null
            ? searchfieldoperators.value
            : this.searchfieldoperators),
        searchfields:
            (searchfields != null ? searchfields.value : this.searchfields),
        searchfieldvalues: (searchfieldvalues != null
            ? searchfieldvalues.value
            : this.searchfieldvalues),
        searchfieldtypes: (searchfieldtypes != null
            ? searchfieldtypes.value
            : this.searchfieldtypes),
        searchseparators: (searchseparators != null
            ? searchseparators.value
            : this.searchseparators),
        searchcondition: (searchcondition != null
            ? searchcondition.value
            : this.searchcondition),
        searchconjunctions: (searchconjunctions != null
            ? searchconjunctions.value
            : this.searchconjunctions),
        uniqueids: (uniqueids != null ? uniqueids.value : this.uniqueids),
        boundids: (boundids != null ? boundids.value : this.boundids),
        filterfields:
            (filterfields != null ? filterfields.value : this.filterfields),
        activeview: (activeview != null ? activeview.value : this.activeview),
        emptyobject:
            (emptyobject != null ? emptyobject.value : this.emptyobject),
        forexcel: (forexcel != null ? forexcel.value : this.forexcel),
        excelfields:
            (excelfields != null ? excelfields.value : this.excelfields),
        totalfields:
            (totalfields != null ? totalfields.value : this.totalfields),
        activeviewfields: (activeviewfields != null
            ? activeviewfields.value
            : this.activeviewfields));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsCheckBoxListItem {
  FwStandardModelsCheckBoxListItem({
    this.value,
    this.text,
    this.selected,
  });

  factory FwStandardModelsCheckBoxListItem.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsCheckBoxListItemFromJson(json);

  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String? value;
  @JsonKey(name: 'text', includeIfNull: false, defaultValue: '')
  final String? text;
  @JsonKey(name: 'selected', includeIfNull: false)
  final bool? selected;
  static const fromJsonFactory = _$FwStandardModelsCheckBoxListItemFromJson;
  static const toJsonFactory = _$FwStandardModelsCheckBoxListItemToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsCheckBoxListItemToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsCheckBoxListItem &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)) &&
            (identical(other.text, text) ||
                const DeepCollectionEquality().equals(other.text, text)) &&
            (identical(other.selected, selected) ||
                const DeepCollectionEquality()
                    .equals(other.selected, selected)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(value) ^
      const DeepCollectionEquality().hash(text) ^
      const DeepCollectionEquality().hash(selected) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsCheckBoxListItemExtension
    on FwStandardModelsCheckBoxListItem {
  FwStandardModelsCheckBoxListItem copyWith(
      {String? value, String? text, bool? selected}) {
    return FwStandardModelsCheckBoxListItem(
        value: value ?? this.value,
        text: text ?? this.text,
        selected: selected ?? this.selected);
  }

  FwStandardModelsCheckBoxListItem copyWithWrapped(
      {Wrapped<String?>? value,
      Wrapped<String?>? text,
      Wrapped<bool?>? selected}) {
    return FwStandardModelsCheckBoxListItem(
        value: (value != null ? value.value : this.value),
        text: (text != null ? text.value : this.text),
        selected: (selected != null ? selected.value : this.selected));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwApiException {
  FwStandardModelsFwApiException({
    this.statusCode,
    this.message,
    this.stackTrace,
  });

  factory FwStandardModelsFwApiException.fromJson(Map<String, dynamic> json) =>
      _$FwStandardModelsFwApiExceptionFromJson(json);

  @JsonKey(name: 'StatusCode', includeIfNull: false)
  final int? statusCode;
  @JsonKey(name: 'Message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'StackTrace', includeIfNull: false, defaultValue: '')
  final String? stackTrace;
  static const fromJsonFactory = _$FwStandardModelsFwApiExceptionFromJson;
  static const toJsonFactory = _$FwStandardModelsFwApiExceptionToJson;
  Map<String, dynamic> toJson() => _$FwStandardModelsFwApiExceptionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwApiException &&
            (identical(other.statusCode, statusCode) ||
                const DeepCollectionEquality()
                    .equals(other.statusCode, statusCode)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.stackTrace, stackTrace) ||
                const DeepCollectionEquality()
                    .equals(other.stackTrace, stackTrace)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(statusCode) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(stackTrace) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwApiExceptionExtension
    on FwStandardModelsFwApiException {
  FwStandardModelsFwApiException copyWith(
      {int? statusCode, String? message, String? stackTrace}) {
    return FwStandardModelsFwApiException(
        statusCode: statusCode ?? this.statusCode,
        message: message ?? this.message,
        stackTrace: stackTrace ?? this.stackTrace);
  }

  FwStandardModelsFwApiException copyWithWrapped(
      {Wrapped<int?>? statusCode,
      Wrapped<String?>? message,
      Wrapped<String?>? stackTrace}) {
    return FwStandardModelsFwApiException(
        statusCode: (statusCode != null ? statusCode.value : this.statusCode),
        message: (message != null ? message.value : this.message),
        stackTrace: (stackTrace != null ? stackTrace.value : this.stackTrace));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryFilter {
  FwStandardModelsFwQueryFilter({
    required this.field,
    required this.op,
    this.value,
  });

  factory FwStandardModelsFwQueryFilter.fromJson(Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryFilterFromJson(json);

  @JsonKey(name: 'Field', includeIfNull: false, defaultValue: '')
  final String field;
  @JsonKey(name: 'Op', includeIfNull: false, defaultValue: '')
  final String op;
  @JsonKey(name: 'Value', includeIfNull: false, defaultValue: '')
  final String? value;
  static const fromJsonFactory = _$FwStandardModelsFwQueryFilterFromJson;
  static const toJsonFactory = _$FwStandardModelsFwQueryFilterToJson;
  Map<String, dynamic> toJson() => _$FwStandardModelsFwQueryFilterToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryFilter &&
            (identical(other.field, field) ||
                const DeepCollectionEquality().equals(other.field, field)) &&
            (identical(other.op, op) ||
                const DeepCollectionEquality().equals(other.op, op)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(field) ^
      const DeepCollectionEquality().hash(op) ^
      const DeepCollectionEquality().hash(value) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryFilterExtension
    on FwStandardModelsFwQueryFilter {
  FwStandardModelsFwQueryFilter copyWith(
      {String? field, String? op, String? value}) {
    return FwStandardModelsFwQueryFilter(
        field: field ?? this.field,
        op: op ?? this.op,
        value: value ?? this.value);
  }

  FwStandardModelsFwQueryFilter copyWithWrapped(
      {Wrapped<String>? field, Wrapped<String>? op, Wrapped<String?>? value}) {
    return FwStandardModelsFwQueryFilter(
        field: (field != null ? field.value : this.field),
        op: (op != null ? op.value : this.op),
        value: (value != null ? value.value : this.value));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogic {
  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      includeIfNull: false,
      defaultValue: <FwStandardModulesAdministratorAlertAlertLogic>[])
  final List<FwStandardModulesAdministratorAlertAlertLogic>? items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogicExtension
    on FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogic {
  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogic
      copyWith(
          {List<FwStandardModulesAdministratorAlertAlertLogic>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogic
      copyWithWrapped(
          {Wrapped<List<FwStandardModulesAdministratorAlertAlertLogic>?>? items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertAlertLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogic {
  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogicFromJson(
          json);

  @JsonKey(name: 'Items', includeIfNull: false, defaultValue: <
      FwStandardModulesAdministratorAlertConditionAlertConditionLogic>[])
  final List<FwStandardModulesAdministratorAlertConditionAlertConditionLogic>?
      items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogicExtension
    on FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogic {
  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogic
      copyWith(
          {List<FwStandardModulesAdministratorAlertConditionAlertConditionLogic>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogic
      copyWithWrapped(
          {Wrapped<
                  List<
                      FwStandardModulesAdministratorAlertConditionAlertConditionLogic>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertConditionAlertConditionLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic {
  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogicFromJson(
          json);

  @JsonKey(name: 'Items', includeIfNull: false, defaultValue: <
      FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic>[])
  final List<FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic>?
      items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogicExtension
    on FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic {
  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic
      copyWith(
          {List<FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic
      copyWithWrapped(
          {Wrapped<
                  List<
                      FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseFwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic {
  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogicFromJson(
          json);

  @JsonKey(name: 'Items', includeIfNull: false, defaultValue: <
      FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic>[])
  final List<
          FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic>?
      items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogicExtension
    on FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic {
  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic
      copyWith(
          {List<FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic
      copyWithWrapped(
          {Wrapped<
                  List<
                      FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseFwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic {
  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogicFromJson(
          json);

  @JsonKey(name: 'Items', includeIfNull: false, defaultValue: <
      FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic>[])
  final List<FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic>?
      items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogicExtension
    on FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic {
  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic
      copyWith(
          {List<FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic
      copyWithWrapped(
          {Wrapped<
                  List<
                      FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseFwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogic {
  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogicFromJson(
          json);

  @JsonKey(name: 'Items', includeIfNull: false, defaultValue: <
      FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic>[])
  final List<FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic>?
      items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogicExtension
    on FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogic {
  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogic
      copyWith(
          {List<FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogic
      copyWithWrapped(
          {Wrapped<
                  List<
                      FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseFwStandardModulesAdministratorEmailTemplateEmailTemplateLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogic {
  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogicFromJson(
          json);

  @JsonKey(name: 'Items', includeIfNull: false, defaultValue: <
      FwStandardModulesAdministratorWebAlertLogWebAlertLogLogic>[])
  final List<FwStandardModulesAdministratorWebAlertLogWebAlertLogLogic>? items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogicExtension
    on FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogic {
  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogic
      copyWith(
          {List<FwStandardModulesAdministratorWebAlertLogWebAlertLogLogic>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogic
      copyWithWrapped(
          {Wrapped<
                  List<
                      FwStandardModulesAdministratorWebAlertLogWebAlertLogLogic>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseFwStandardModulesAdministratorWebAlertLogWebAlertLogLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      includeIfNull: false,
      defaultValue: <WebApiModulesAdministratorCustomFieldCustomField>[])
  final List<WebApiModulesAdministratorCustomFieldCustomField>? items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogic
      copyWith(
          {List<WebApiModulesAdministratorCustomFieldCustomField>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogic
      copyWithWrapped(
          {Wrapped<List<WebApiModulesAdministratorCustomFieldCustomField>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFieldCustomFieldLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      includeIfNull: false,
      defaultValue: <WebApiModulesAdministratorCustomFormCustomForm>[])
  final List<WebApiModulesAdministratorCustomFormCustomForm>? items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogic
      copyWith(
          {List<WebApiModulesAdministratorCustomFormCustomForm>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogic
      copyWithWrapped(
          {Wrapped<List<WebApiModulesAdministratorCustomFormCustomForm>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorCustomFormCustomFormLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      includeIfNull: false,
      defaultValue: <WebApiModulesAdministratorDataHealthDataHealth>[])
  final List<WebApiModulesAdministratorDataHealthDataHealth>? items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogic
      copyWith(
          {List<WebApiModulesAdministratorDataHealthDataHealth>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogic
      copyWithWrapped(
          {Wrapped<List<WebApiModulesAdministratorDataHealthDataHealth>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorDataHealthDataHealthLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      includeIfNull: false,
      defaultValue: <WebApiModulesAdministratorEmailHistoryEmailHistory>[])
  final List<WebApiModulesAdministratorEmailHistoryEmailHistory>? items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogic
      copyWith(
          {List<WebApiModulesAdministratorEmailHistoryEmailHistory>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogic
      copyWithWrapped(
          {Wrapped<List<WebApiModulesAdministratorEmailHistoryEmailHistory>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorEmailHistoryEmailHistoryLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      includeIfNull: false,
      defaultValue: <WebApiModulesAdministratorGroupGroup>[])
  final List<WebApiModulesAdministratorGroupGroup>? items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogic
      copyWith(
          {List<WebApiModulesAdministratorGroupGroup>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogic
      copyWithWrapped(
          {Wrapped<List<WebApiModulesAdministratorGroupGroup>?>? items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorGroupGroupLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      includeIfNull: false,
      defaultValue: <WebApiModulesAdministratorHotfixHotfix>[])
  final List<WebApiModulesAdministratorHotfixHotfix>? items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogic
      copyWith(
          {List<WebApiModulesAdministratorHotfixHotfix>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogic
      copyWithWrapped(
          {Wrapped<List<WebApiModulesAdministratorHotfixHotfix>?>? items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorHotfixHotfixLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      includeIfNull: false,
      defaultValue: <WebApiModulesAdministratorPluginPlugin>[])
  final List<WebApiModulesAdministratorPluginPlugin>? items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogic
      copyWith(
          {List<WebApiModulesAdministratorPluginPlugin>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogic
      copyWithWrapped(
          {Wrapped<List<WebApiModulesAdministratorPluginPlugin>?>? items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorPluginPluginLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogicFromJson(
          json);

  @JsonKey(name: 'Items', includeIfNull: false, defaultValue: <
      WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory>[])
  final List<WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory>?
      items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogic
      copyWith(
          {List<WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogic
      copyWithWrapped(
          {Wrapped<
                  List<
                      WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogicFromJson(
          json);

  @JsonKey(name: 'Items', includeIfNull: false, defaultValue: <
      WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLog>[])
  final List<
          WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLog>?
      items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogic
      copyWith(
          {List<WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLog>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogic
      copyWithWrapped(
          {Wrapped<
                  List<
                      WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLog>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      includeIfNull: false,
      defaultValue: <WebApiModulesAdministratorUserUser>[])
  final List<WebApiModulesAdministratorUserUser>? items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogic
      copyWith(
          {List<WebApiModulesAdministratorUserUser>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogic
      copyWithWrapped(
          {Wrapped<List<WebApiModulesAdministratorUserUser>?>? items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorUserUserLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogicFromJson(
          json);

  @JsonKey(name: 'Items', includeIfNull: false, defaultValue: <
      WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup>[])
  final List<WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup>?
      items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogic
      copyWith(
          {List<WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogic
      copyWithWrapped(
          {Wrapped<
                  List<
                      WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogicFromJson(
          json);

  @JsonKey(name: 'Items', includeIfNull: false, defaultValue: <
      WebApiModulesAdministratorControlsCustomFormUserCustomFormUser>[])
  final List<WebApiModulesAdministratorControlsCustomFormUserCustomFormUser>?
      items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogic
      copyWith(
          {List<WebApiModulesAdministratorControlsCustomFormUserCustomFormUser>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogic
      copyWithWrapped(
          {Wrapped<
                  List<
                      WebApiModulesAdministratorControlsCustomFormUserCustomFormUser>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomFormUserCustomFormUserLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogicFromJson(
          json);

  @JsonKey(name: 'Items', includeIfNull: false, defaultValue: <
      WebApiModulesAdministratorControlsCustomModuleCustomModule>[])
  final List<WebApiModulesAdministratorControlsCustomModuleCustomModule>? items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogic
      copyWith(
          {List<WebApiModulesAdministratorControlsCustomModuleCustomModule>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogic
      copyWithWrapped(
          {Wrapped<
                  List<
                      WebApiModulesAdministratorControlsCustomModuleCustomModule>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomModuleCustomModuleLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogicFromJson(
          json);

  @JsonKey(name: 'Items', includeIfNull: false, defaultValue: <
      WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup>[])
  final List<
          WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup>?
      items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogic
      copyWith(
          {List<WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogic
      copyWithWrapped(
          {Wrapped<
                  List<
                      WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogicFromJson(
          json);

  @JsonKey(name: 'Items', includeIfNull: false, defaultValue: <
      WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField>[])
  final List<
          WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField>?
      items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogic
      copyWith(
          {List<WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogic
      copyWithWrapped(
          {Wrapped<
                  List<
                      WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogic {
  FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      includeIfNull: false,
      defaultValue: <WebApiModulesSettingsWidgetGroupWidgetGroup>[])
  final List<WebApiModulesSettingsWidgetGroupWidgetGroup>? items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogic {
  FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogic
      copyWith(
          {List<WebApiModulesSettingsWidgetGroupWidgetGroup>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogic
      copyWithWrapped(
          {Wrapped<List<WebApiModulesSettingsWidgetGroupWidgetGroup>?>? items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetGroupWidgetGroupLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogic {
  FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      includeIfNull: false,
      defaultValue: <WebApiModulesSettingsWidgetUserWidgetUser>[])
  final List<WebApiModulesSettingsWidgetUserWidgetUser>? items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogic {
  FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogic
      copyWith(
          {List<WebApiModulesSettingsWidgetUserWidgetUser>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogic
      copyWithWrapped(
          {Wrapped<List<WebApiModulesSettingsWidgetUserWidgetUser>?>? items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesSettingsWidgetUserWidgetUserLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogic {
  FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogicFromJson(
          json);

  @JsonKey(name: 'Items', includeIfNull: false, defaultValue: <
      WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser>[])
  final List<
          WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser>?
      items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalItems', includeIfNull: false)
  final int? totalItems;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalItems) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogic {
  FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogic
      copyWith(
          {List<WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }

  FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogic
      copyWithWrapped(
          {Wrapped<
                  List<
                      WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalItems,
          Wrapped<String?>? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserLogic(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalItems: (totalItems != null ? totalItems.value : this.totalItems),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponse {
  FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponse({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalRows,
    this.sort,
  });

  factory FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponse.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponseFromJson(
          json);

  @JsonKey(
      name: 'Items',
      includeIfNull: false,
      defaultValue: <FwCoreModulesAdministratorGroupLookupGroupResponse>[])
  final List<FwCoreModulesAdministratorGroupLookupGroupResponse>? items;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalRows', includeIfNull: false)
  final int? totalRows;
  @JsonKey(name: 'Sort', includeIfNull: false, defaultValue: '')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponseFromJson;
  static const toJsonFactory =
      _$FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponseToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponse &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalRows, totalRows) ||
                const DeepCollectionEquality()
                    .equals(other.totalRows, totalRows)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalRows) ^
      const DeepCollectionEquality().hash(sort) ^
      runtimeType.hashCode;
}

extension $FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponseExtension
    on FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponse {
  FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponse
      copyWith(
          {List<FwCoreModulesAdministratorGroupLookupGroupResponse>? items,
          int? pageNo,
          int? pageSize,
          int? totalRows,
          String? sort}) {
    return FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponse(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalRows: totalRows ?? this.totalRows,
        sort: sort ?? this.sort);
  }

  FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponse
      copyWithWrapped(
          {Wrapped<List<FwCoreModulesAdministratorGroupLookupGroupResponse>?>?
              items,
          Wrapped<int?>? pageNo,
          Wrapped<int?>? pageSize,
          Wrapped<int?>? totalRows,
          Wrapped<String?>? sort}) {
    return FwStandardModelsGetResponseFwCoreModulesAdministratorGroupLookupGroupResponse(
        items: (items != null ? items.value : this.items),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalRows: (totalRows != null ? totalRows.value : this.totalRows),
        sort: (sort != null ? sort.value : this.sort));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModulesAdministratorAlertAlertCondition {
  FwStandardModulesAdministratorAlertAlertCondition({
    this.alertConditionId,
    this.alertId,
    this.fieldName1,
    this.fieldName2,
    this.condition,
    this.value,
  });

  factory FwStandardModulesAdministratorAlertAlertCondition.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModulesAdministratorAlertAlertConditionFromJson(json);

  @JsonKey(name: 'AlertConditionId', includeIfNull: false, defaultValue: '')
  final String? alertConditionId;
  @JsonKey(name: 'AlertId', includeIfNull: false, defaultValue: '')
  final String? alertId;
  @JsonKey(name: 'FieldName1', includeIfNull: false, defaultValue: '')
  final String? fieldName1;
  @JsonKey(name: 'FieldName2', includeIfNull: false, defaultValue: '')
  final String? fieldName2;
  @JsonKey(name: 'Condition', includeIfNull: false, defaultValue: '')
  final String? condition;
  @JsonKey(name: 'Value', includeIfNull: false, defaultValue: '')
  final String? value;
  static const fromJsonFactory =
      _$FwStandardModulesAdministratorAlertAlertConditionFromJson;
  static const toJsonFactory =
      _$FwStandardModulesAdministratorAlertAlertConditionToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModulesAdministratorAlertAlertConditionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModulesAdministratorAlertAlertCondition &&
            (identical(other.alertConditionId, alertConditionId) ||
                const DeepCollectionEquality()
                    .equals(other.alertConditionId, alertConditionId)) &&
            (identical(other.alertId, alertId) ||
                const DeepCollectionEquality()
                    .equals(other.alertId, alertId)) &&
            (identical(other.fieldName1, fieldName1) ||
                const DeepCollectionEquality()
                    .equals(other.fieldName1, fieldName1)) &&
            (identical(other.fieldName2, fieldName2) ||
                const DeepCollectionEquality()
                    .equals(other.fieldName2, fieldName2)) &&
            (identical(other.condition, condition) ||
                const DeepCollectionEquality()
                    .equals(other.condition, condition)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(alertConditionId) ^
      const DeepCollectionEquality().hash(alertId) ^
      const DeepCollectionEquality().hash(fieldName1) ^
      const DeepCollectionEquality().hash(fieldName2) ^
      const DeepCollectionEquality().hash(condition) ^
      const DeepCollectionEquality().hash(value) ^
      runtimeType.hashCode;
}

extension $FwStandardModulesAdministratorAlertAlertConditionExtension
    on FwStandardModulesAdministratorAlertAlertCondition {
  FwStandardModulesAdministratorAlertAlertCondition copyWith(
      {String? alertConditionId,
      String? alertId,
      String? fieldName1,
      String? fieldName2,
      String? condition,
      String? value}) {
    return FwStandardModulesAdministratorAlertAlertCondition(
        alertConditionId: alertConditionId ?? this.alertConditionId,
        alertId: alertId ?? this.alertId,
        fieldName1: fieldName1 ?? this.fieldName1,
        fieldName2: fieldName2 ?? this.fieldName2,
        condition: condition ?? this.condition,
        value: value ?? this.value);
  }

  FwStandardModulesAdministratorAlertAlertCondition copyWithWrapped(
      {Wrapped<String?>? alertConditionId,
      Wrapped<String?>? alertId,
      Wrapped<String?>? fieldName1,
      Wrapped<String?>? fieldName2,
      Wrapped<String?>? condition,
      Wrapped<String?>? value}) {
    return FwStandardModulesAdministratorAlertAlertCondition(
        alertConditionId: (alertConditionId != null
            ? alertConditionId.value
            : this.alertConditionId),
        alertId: (alertId != null ? alertId.value : this.alertId),
        fieldName1: (fieldName1 != null ? fieldName1.value : this.fieldName1),
        fieldName2: (fieldName2 != null ? fieldName2.value : this.fieldName2),
        condition: (condition != null ? condition.value : this.condition),
        value: (value != null ? value.value : this.value));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModulesAdministratorAlertAlertLogic {
  FwStandardModulesAdministratorAlertAlertLogic({
    this.alertId,
    this.alertName,
    this.moduleName,
    this.actionNew,
    this.actionEdit,
    this.actionDelete,
    this.alertSubject,
    this.alertBody,
    this.inactive,
    this.alertConditionList,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory FwStandardModulesAdministratorAlertAlertLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModulesAdministratorAlertAlertLogicFromJson(json);

  @JsonKey(name: 'AlertId', includeIfNull: false, defaultValue: '')
  final String? alertId;
  @JsonKey(name: 'AlertName', includeIfNull: false, defaultValue: '')
  final String? alertName;
  @JsonKey(name: 'ModuleName', includeIfNull: false, defaultValue: '')
  final String? moduleName;
  @JsonKey(name: 'ActionNew', includeIfNull: false)
  final bool? actionNew;
  @JsonKey(name: 'ActionEdit', includeIfNull: false)
  final bool? actionEdit;
  @JsonKey(name: 'ActionDelete', includeIfNull: false)
  final bool? actionDelete;
  @JsonKey(name: 'AlertSubject', includeIfNull: false, defaultValue: '')
  final String? alertSubject;
  @JsonKey(name: 'AlertBody', includeIfNull: false, defaultValue: '')
  final String? alertBody;
  @JsonKey(name: 'Inactive', includeIfNull: false)
  final bool? inactive;
  @JsonKey(
      name: 'AlertConditionList',
      includeIfNull: false,
      defaultValue: <FwStandardModulesAdministratorAlertAlertCondition>[])
  final List<FwStandardModulesAdministratorAlertAlertCondition>?
      alertConditionList;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$FwStandardModulesAdministratorAlertAlertLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModulesAdministratorAlertAlertLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModulesAdministratorAlertAlertLogicToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModulesAdministratorAlertAlertLogic &&
            (identical(other.alertId, alertId) ||
                const DeepCollectionEquality()
                    .equals(other.alertId, alertId)) &&
            (identical(other.alertName, alertName) ||
                const DeepCollectionEquality()
                    .equals(other.alertName, alertName)) &&
            (identical(other.moduleName, moduleName) ||
                const DeepCollectionEquality()
                    .equals(other.moduleName, moduleName)) &&
            (identical(other.actionNew, actionNew) ||
                const DeepCollectionEquality()
                    .equals(other.actionNew, actionNew)) &&
            (identical(other.actionEdit, actionEdit) ||
                const DeepCollectionEquality()
                    .equals(other.actionEdit, actionEdit)) &&
            (identical(other.actionDelete, actionDelete) ||
                const DeepCollectionEquality()
                    .equals(other.actionDelete, actionDelete)) &&
            (identical(other.alertSubject, alertSubject) ||
                const DeepCollectionEquality()
                    .equals(other.alertSubject, alertSubject)) &&
            (identical(other.alertBody, alertBody) ||
                const DeepCollectionEquality()
                    .equals(other.alertBody, alertBody)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.alertConditionList, alertConditionList) ||
                const DeepCollectionEquality()
                    .equals(other.alertConditionList, alertConditionList)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(alertId) ^
      const DeepCollectionEquality().hash(alertName) ^
      const DeepCollectionEquality().hash(moduleName) ^
      const DeepCollectionEquality().hash(actionNew) ^
      const DeepCollectionEquality().hash(actionEdit) ^
      const DeepCollectionEquality().hash(actionDelete) ^
      const DeepCollectionEquality().hash(alertSubject) ^
      const DeepCollectionEquality().hash(alertBody) ^
      const DeepCollectionEquality().hash(inactive) ^
      const DeepCollectionEquality().hash(alertConditionList) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $FwStandardModulesAdministratorAlertAlertLogicExtension
    on FwStandardModulesAdministratorAlertAlertLogic {
  FwStandardModulesAdministratorAlertAlertLogic copyWith(
      {String? alertId,
      String? alertName,
      String? moduleName,
      bool? actionNew,
      bool? actionEdit,
      bool? actionDelete,
      String? alertSubject,
      String? alertBody,
      bool? inactive,
      List<FwStandardModulesAdministratorAlertAlertCondition>?
          alertConditionList,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return FwStandardModulesAdministratorAlertAlertLogic(
        alertId: alertId ?? this.alertId,
        alertName: alertName ?? this.alertName,
        moduleName: moduleName ?? this.moduleName,
        actionNew: actionNew ?? this.actionNew,
        actionEdit: actionEdit ?? this.actionEdit,
        actionDelete: actionDelete ?? this.actionDelete,
        alertSubject: alertSubject ?? this.alertSubject,
        alertBody: alertBody ?? this.alertBody,
        inactive: inactive ?? this.inactive,
        alertConditionList: alertConditionList ?? this.alertConditionList,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  FwStandardModulesAdministratorAlertAlertLogic copyWithWrapped(
      {Wrapped<String?>? alertId,
      Wrapped<String?>? alertName,
      Wrapped<String?>? moduleName,
      Wrapped<bool?>? actionNew,
      Wrapped<bool?>? actionEdit,
      Wrapped<bool?>? actionDelete,
      Wrapped<String?>? alertSubject,
      Wrapped<String?>? alertBody,
      Wrapped<bool?>? inactive,
      Wrapped<List<FwStandardModulesAdministratorAlertAlertCondition>?>?
          alertConditionList,
      Wrapped<String?>? dateStamp,
      Wrapped<String?>? recordTitle,
      Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
          fields,
      Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
      Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
          defaultFieldAttributes}) {
    return FwStandardModulesAdministratorAlertAlertLogic(
        alertId: (alertId != null ? alertId.value : this.alertId),
        alertName: (alertName != null ? alertName.value : this.alertName),
        moduleName: (moduleName != null ? moduleName.value : this.moduleName),
        actionNew: (actionNew != null ? actionNew.value : this.actionNew),
        actionEdit: (actionEdit != null ? actionEdit.value : this.actionEdit),
        actionDelete:
            (actionDelete != null ? actionDelete.value : this.actionDelete),
        alertSubject:
            (alertSubject != null ? alertSubject.value : this.alertSubject),
        alertBody: (alertBody != null ? alertBody.value : this.alertBody),
        inactive: (inactive != null ? inactive.value : this.inactive),
        alertConditionList: (alertConditionList != null
            ? alertConditionList.value
            : this.alertConditionList),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModulesAdministratorAlertConditionAlertConditionLogic {
  FwStandardModulesAdministratorAlertConditionAlertConditionLogic({
    this.alertId,
    this.alertConditionId,
    this.fieldName1,
    this.condition,
    this.fieldName2,
    this.value,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory FwStandardModulesAdministratorAlertConditionAlertConditionLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModulesAdministratorAlertConditionAlertConditionLogicFromJson(
          json);

  @JsonKey(name: 'AlertId', includeIfNull: false, defaultValue: '')
  final String? alertId;
  @JsonKey(name: 'AlertConditionId', includeIfNull: false, defaultValue: '')
  final String? alertConditionId;
  @JsonKey(name: 'FieldName1', includeIfNull: false, defaultValue: '')
  final String? fieldName1;
  @JsonKey(name: 'Condition', includeIfNull: false, defaultValue: '')
  final String? condition;
  @JsonKey(name: 'FieldName2', includeIfNull: false, defaultValue: '')
  final String? fieldName2;
  @JsonKey(name: 'Value', includeIfNull: false, defaultValue: '')
  final String? value;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$FwStandardModulesAdministratorAlertConditionAlertConditionLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModulesAdministratorAlertConditionAlertConditionLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModulesAdministratorAlertConditionAlertConditionLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModulesAdministratorAlertConditionAlertConditionLogic &&
            (identical(other.alertId, alertId) ||
                const DeepCollectionEquality()
                    .equals(other.alertId, alertId)) &&
            (identical(other.alertConditionId, alertConditionId) ||
                const DeepCollectionEquality()
                    .equals(other.alertConditionId, alertConditionId)) &&
            (identical(other.fieldName1, fieldName1) ||
                const DeepCollectionEquality()
                    .equals(other.fieldName1, fieldName1)) &&
            (identical(other.condition, condition) ||
                const DeepCollectionEquality()
                    .equals(other.condition, condition)) &&
            (identical(other.fieldName2, fieldName2) ||
                const DeepCollectionEquality()
                    .equals(other.fieldName2, fieldName2)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(alertId) ^
      const DeepCollectionEquality().hash(alertConditionId) ^
      const DeepCollectionEquality().hash(fieldName1) ^
      const DeepCollectionEquality().hash(condition) ^
      const DeepCollectionEquality().hash(fieldName2) ^
      const DeepCollectionEquality().hash(value) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $FwStandardModulesAdministratorAlertConditionAlertConditionLogicExtension
    on FwStandardModulesAdministratorAlertConditionAlertConditionLogic {
  FwStandardModulesAdministratorAlertConditionAlertConditionLogic copyWith(
      {String? alertId,
      String? alertConditionId,
      String? fieldName1,
      String? condition,
      String? fieldName2,
      String? value,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return FwStandardModulesAdministratorAlertConditionAlertConditionLogic(
        alertId: alertId ?? this.alertId,
        alertConditionId: alertConditionId ?? this.alertConditionId,
        fieldName1: fieldName1 ?? this.fieldName1,
        condition: condition ?? this.condition,
        fieldName2: fieldName2 ?? this.fieldName2,
        value: value ?? this.value,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  FwStandardModulesAdministratorAlertConditionAlertConditionLogic
      copyWithWrapped(
          {Wrapped<String?>? alertId,
          Wrapped<String?>? alertConditionId,
          Wrapped<String?>? fieldName1,
          Wrapped<String?>? condition,
          Wrapped<String?>? fieldName2,
          Wrapped<String?>? value,
          Wrapped<String?>? dateStamp,
          Wrapped<String?>? recordTitle,
          Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
              fields,
          Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
          Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
              defaultFieldAttributes}) {
    return FwStandardModulesAdministratorAlertConditionAlertConditionLogic(
        alertId: (alertId != null ? alertId.value : this.alertId),
        alertConditionId: (alertConditionId != null
            ? alertConditionId.value
            : this.alertConditionId),
        fieldName1: (fieldName1 != null ? fieldName1.value : this.fieldName1),
        condition: (condition != null ? condition.value : this.condition),
        fieldName2: (fieldName2 != null ? fieldName2.value : this.fieldName2),
        value: (value != null ? value.value : this.value),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic {
  FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic({
    this.alertWebUserId,
    this.alertId,
    this.description,
    this.webUserId,
    this.userId,
    this.userName,
    this.email,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogicFromJson(
          json);

  @JsonKey(name: 'AlertWebUserId', includeIfNull: false, defaultValue: '')
  final String? alertWebUserId;
  @JsonKey(name: 'AlertId', includeIfNull: false, defaultValue: '')
  final String? alertId;
  @JsonKey(name: 'Description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'WebUserId', includeIfNull: false, defaultValue: '')
  final String? webUserId;
  @JsonKey(name: 'UserId', includeIfNull: false, defaultValue: '')
  final String? userId;
  @JsonKey(name: 'UserName', includeIfNull: false, defaultValue: '')
  final String? userName;
  @JsonKey(name: 'Email', includeIfNull: false, defaultValue: '')
  final String? email;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic &&
            (identical(other.alertWebUserId, alertWebUserId) ||
                const DeepCollectionEquality()
                    .equals(other.alertWebUserId, alertWebUserId)) &&
            (identical(other.alertId, alertId) ||
                const DeepCollectionEquality()
                    .equals(other.alertId, alertId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.webUserId, webUserId) ||
                const DeepCollectionEquality()
                    .equals(other.webUserId, webUserId)) &&
            (identical(other.userId, userId) ||
                const DeepCollectionEquality().equals(other.userId, userId)) &&
            (identical(other.userName, userName) ||
                const DeepCollectionEquality()
                    .equals(other.userName, userName)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(alertWebUserId) ^
      const DeepCollectionEquality().hash(alertId) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(webUserId) ^
      const DeepCollectionEquality().hash(userId) ^
      const DeepCollectionEquality().hash(userName) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogicExtension
    on FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic {
  FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic copyWith(
      {String? alertWebUserId,
      String? alertId,
      String? description,
      String? webUserId,
      String? userId,
      String? userName,
      String? email,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic(
        alertWebUserId: alertWebUserId ?? this.alertWebUserId,
        alertId: alertId ?? this.alertId,
        description: description ?? this.description,
        webUserId: webUserId ?? this.webUserId,
        userId: userId ?? this.userId,
        userName: userName ?? this.userName,
        email: email ?? this.email,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic copyWithWrapped(
      {Wrapped<String?>? alertWebUserId,
      Wrapped<String?>? alertId,
      Wrapped<String?>? description,
      Wrapped<String?>? webUserId,
      Wrapped<String?>? userId,
      Wrapped<String?>? userName,
      Wrapped<String?>? email,
      Wrapped<String?>? dateStamp,
      Wrapped<String?>? recordTitle,
      Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
          fields,
      Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
      Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
          defaultFieldAttributes}) {
    return FwStandardModulesAdministratorAlertWebUsersAlertWebUsersLogic(
        alertWebUserId: (alertWebUserId != null
            ? alertWebUserId.value
            : this.alertWebUserId),
        alertId: (alertId != null ? alertId.value : this.alertId),
        description:
            (description != null ? description.value : this.description),
        webUserId: (webUserId != null ? webUserId.value : this.webUserId),
        userId: (userId != null ? userId.value : this.userId),
        userName: (userName != null ? userName.value : this.userName),
        email: (email != null ? email.value : this.email),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic {
  FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic({
    this.customReportLayoutId,
    this.webUserId,
    this.userName,
    this.baseReport,
    this.description,
    this.category,
    this.html,
    this.active,
    this.inactive,
    this.assignTo,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogicFromJson(
          json);

  @JsonKey(name: 'CustomReportLayoutId', includeIfNull: false, defaultValue: '')
  final String? customReportLayoutId;
  @JsonKey(name: 'WebUserId', includeIfNull: false, defaultValue: '')
  final String? webUserId;
  @JsonKey(name: 'UserName', includeIfNull: false, defaultValue: '')
  final String? userName;
  @JsonKey(name: 'BaseReport', includeIfNull: false, defaultValue: '')
  final String? baseReport;
  @JsonKey(name: 'Description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'Category', includeIfNull: false, defaultValue: '')
  final String? category;
  @JsonKey(name: 'Html', includeIfNull: false, defaultValue: '')
  final String? html;
  @JsonKey(name: 'Active', includeIfNull: false)
  final bool? active;
  @JsonKey(name: 'Inactive', includeIfNull: false)
  final bool? inactive;
  @JsonKey(name: 'AssignTo', includeIfNull: false, defaultValue: '')
  final String? assignTo;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic &&
            (identical(other.customReportLayoutId, customReportLayoutId) ||
                const DeepCollectionEquality().equals(
                    other.customReportLayoutId, customReportLayoutId)) &&
            (identical(other.webUserId, webUserId) ||
                const DeepCollectionEquality()
                    .equals(other.webUserId, webUserId)) &&
            (identical(other.userName, userName) ||
                const DeepCollectionEquality()
                    .equals(other.userName, userName)) &&
            (identical(other.baseReport, baseReport) ||
                const DeepCollectionEquality()
                    .equals(other.baseReport, baseReport)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.category, category) ||
                const DeepCollectionEquality()
                    .equals(other.category, category)) &&
            (identical(other.html, html) ||
                const DeepCollectionEquality().equals(other.html, html)) &&
            (identical(other.active, active) ||
                const DeepCollectionEquality().equals(other.active, active)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.assignTo, assignTo) ||
                const DeepCollectionEquality()
                    .equals(other.assignTo, assignTo)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(customReportLayoutId) ^
      const DeepCollectionEquality().hash(webUserId) ^
      const DeepCollectionEquality().hash(userName) ^
      const DeepCollectionEquality().hash(baseReport) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(category) ^
      const DeepCollectionEquality().hash(html) ^
      const DeepCollectionEquality().hash(active) ^
      const DeepCollectionEquality().hash(inactive) ^
      const DeepCollectionEquality().hash(assignTo) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogicExtension
    on FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic {
  FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic
      copyWith(
          {String? customReportLayoutId,
          String? webUserId,
          String? userName,
          String? baseReport,
          String? description,
          String? category,
          String? html,
          bool? active,
          bool? inactive,
          String? assignTo,
          String? dateStamp,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic(
        customReportLayoutId: customReportLayoutId ?? this.customReportLayoutId,
        webUserId: webUserId ?? this.webUserId,
        userName: userName ?? this.userName,
        baseReport: baseReport ?? this.baseReport,
        description: description ?? this.description,
        category: category ?? this.category,
        html: html ?? this.html,
        active: active ?? this.active,
        inactive: inactive ?? this.inactive,
        assignTo: assignTo ?? this.assignTo,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic
      copyWithWrapped(
          {Wrapped<String?>? customReportLayoutId,
          Wrapped<String?>? webUserId,
          Wrapped<String?>? userName,
          Wrapped<String?>? baseReport,
          Wrapped<String?>? description,
          Wrapped<String?>? category,
          Wrapped<String?>? html,
          Wrapped<bool?>? active,
          Wrapped<bool?>? inactive,
          Wrapped<String?>? assignTo,
          Wrapped<String?>? dateStamp,
          Wrapped<String?>? recordTitle,
          Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
              fields,
          Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
          Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
              defaultFieldAttributes}) {
    return FwStandardModulesAdministratorCustomReportLayoutCustomReportLayoutLogic(
        customReportLayoutId: (customReportLayoutId != null
            ? customReportLayoutId.value
            : this.customReportLayoutId),
        webUserId: (webUserId != null ? webUserId.value : this.webUserId),
        userName: (userName != null ? userName.value : this.userName),
        baseReport: (baseReport != null ? baseReport.value : this.baseReport),
        description:
            (description != null ? description.value : this.description),
        category: (category != null ? category.value : this.category),
        html: (html != null ? html.value : this.html),
        active: (active != null ? active.value : this.active),
        inactive: (inactive != null ? inactive.value : this.inactive),
        assignTo: (assignTo != null ? assignTo.value : this.assignTo),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic {
  FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic({
    this.duplicateRuleId,
    this.moduleName,
    this.ruleName,
    this.caseSensitive,
    this.systemRule,
    this.fields,
    this.fieldTypes,
    this.ruleNameColor,
    this.considerBlanks,
    this.dateStamp,
    this.recordTitle,
    this.$fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogicFromJson(
          json);

  @JsonKey(name: 'DuplicateRuleId', includeIfNull: false, defaultValue: '')
  final String? duplicateRuleId;
  @JsonKey(name: 'ModuleName', includeIfNull: false, defaultValue: '')
  final String? moduleName;
  @JsonKey(name: 'RuleName', includeIfNull: false, defaultValue: '')
  final String? ruleName;
  @JsonKey(name: 'CaseSensitive', includeIfNull: false)
  final bool? caseSensitive;
  @JsonKey(name: 'SystemRule', includeIfNull: false)
  final bool? systemRule;
  @JsonKey(name: 'Fields', includeIfNull: false, defaultValue: '')
  final String? fields;
  @JsonKey(name: 'FieldTypes', includeIfNull: false, defaultValue: '')
  final String? fieldTypes;
  @JsonKey(name: 'RuleNameColor', includeIfNull: false, defaultValue: '')
  final String? ruleNameColor;
  @JsonKey(name: 'ConsiderBlanks', includeIfNull: false)
  final bool? considerBlanks;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? $fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic &&
            (identical(other.duplicateRuleId, duplicateRuleId) ||
                const DeepCollectionEquality()
                    .equals(other.duplicateRuleId, duplicateRuleId)) &&
            (identical(other.moduleName, moduleName) ||
                const DeepCollectionEquality()
                    .equals(other.moduleName, moduleName)) &&
            (identical(other.ruleName, ruleName) ||
                const DeepCollectionEquality()
                    .equals(other.ruleName, ruleName)) &&
            (identical(other.caseSensitive, caseSensitive) ||
                const DeepCollectionEquality()
                    .equals(other.caseSensitive, caseSensitive)) &&
            (identical(other.systemRule, systemRule) ||
                const DeepCollectionEquality()
                    .equals(other.systemRule, systemRule)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.fieldTypes, fieldTypes) ||
                const DeepCollectionEquality()
                    .equals(other.fieldTypes, fieldTypes)) &&
            (identical(other.ruleNameColor, ruleNameColor) ||
                const DeepCollectionEquality()
                    .equals(other.ruleNameColor, ruleNameColor)) &&
            (identical(other.considerBlanks, considerBlanks) ||
                const DeepCollectionEquality()
                    .equals(other.considerBlanks, considerBlanks)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.$fields, $fields) ||
                const DeepCollectionEquality()
                    .equals(other.$fields, $fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(duplicateRuleId) ^
      const DeepCollectionEquality().hash(moduleName) ^
      const DeepCollectionEquality().hash(ruleName) ^
      const DeepCollectionEquality().hash(caseSensitive) ^
      const DeepCollectionEquality().hash(systemRule) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(fieldTypes) ^
      const DeepCollectionEquality().hash(ruleNameColor) ^
      const DeepCollectionEquality().hash(considerBlanks) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash($fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogicExtension
    on FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic {
  FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic copyWith(
      {String? duplicateRuleId,
      String? moduleName,
      String? ruleName,
      bool? caseSensitive,
      bool? systemRule,
      String? fields,
      String? fieldTypes,
      String? ruleNameColor,
      bool? considerBlanks,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? $fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic(
        duplicateRuleId: duplicateRuleId ?? this.duplicateRuleId,
        moduleName: moduleName ?? this.moduleName,
        ruleName: ruleName ?? this.ruleName,
        caseSensitive: caseSensitive ?? this.caseSensitive,
        systemRule: systemRule ?? this.systemRule,
        fields: fields ?? this.fields,
        fieldTypes: fieldTypes ?? this.fieldTypes,
        ruleNameColor: ruleNameColor ?? this.ruleNameColor,
        considerBlanks: considerBlanks ?? this.considerBlanks,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        $fields: $fields ?? this.$fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic copyWithWrapped(
      {Wrapped<String?>? duplicateRuleId,
      Wrapped<String?>? moduleName,
      Wrapped<String?>? ruleName,
      Wrapped<bool?>? caseSensitive,
      Wrapped<bool?>? systemRule,
      Wrapped<String?>? fields,
      Wrapped<String?>? fieldTypes,
      Wrapped<String?>? ruleNameColor,
      Wrapped<bool?>? considerBlanks,
      Wrapped<String?>? dateStamp,
      Wrapped<String?>? recordTitle,
      Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
          $fields,
      Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
      Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
          defaultFieldAttributes}) {
    return FwStandardModulesAdministratorDuplicateRuleDuplicateRuleLogic(
        duplicateRuleId: (duplicateRuleId != null
            ? duplicateRuleId.value
            : this.duplicateRuleId),
        moduleName: (moduleName != null ? moduleName.value : this.moduleName),
        ruleName: (ruleName != null ? ruleName.value : this.ruleName),
        caseSensitive:
            (caseSensitive != null ? caseSensitive.value : this.caseSensitive),
        systemRule: (systemRule != null ? systemRule.value : this.systemRule),
        fields: (fields != null ? fields.value : this.fields),
        fieldTypes: (fieldTypes != null ? fieldTypes.value : this.fieldTypes),
        ruleNameColor:
            (ruleNameColor != null ? ruleNameColor.value : this.ruleNameColor),
        considerBlanks: (considerBlanks != null
            ? considerBlanks.value
            : this.considerBlanks),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        $fields: ($fields != null ? $fields.value : this.$fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic {
  FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic({
    this.appEmailId,
    this.description,
    this.filterId,
    this.subject,
    this.emailText,
    this.category,
    this.bodyFormat,
    this.emailType,
    this.inactive,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicFromJson(
          json);

  @JsonKey(name: 'AppEmailId', includeIfNull: false, defaultValue: '')
  final String? appEmailId;
  @JsonKey(name: 'Description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'FilterId', includeIfNull: false, defaultValue: '')
  final String? filterId;
  @JsonKey(name: 'Subject', includeIfNull: false, defaultValue: '')
  final String? subject;
  @JsonKey(name: 'EmailText', includeIfNull: false, defaultValue: '')
  final String? emailText;
  @JsonKey(name: 'Category', includeIfNull: false, defaultValue: '')
  final String? category;
  @JsonKey(name: 'BodyFormat', includeIfNull: false, defaultValue: '')
  final String? bodyFormat;
  @JsonKey(name: 'EmailType', includeIfNull: false, defaultValue: '')
  final String? emailType;
  @JsonKey(name: 'Inactive', includeIfNull: false)
  final bool? inactive;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic &&
            (identical(other.appEmailId, appEmailId) ||
                const DeepCollectionEquality()
                    .equals(other.appEmailId, appEmailId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.filterId, filterId) ||
                const DeepCollectionEquality()
                    .equals(other.filterId, filterId)) &&
            (identical(other.subject, subject) ||
                const DeepCollectionEquality()
                    .equals(other.subject, subject)) &&
            (identical(other.emailText, emailText) ||
                const DeepCollectionEquality()
                    .equals(other.emailText, emailText)) &&
            (identical(other.category, category) ||
                const DeepCollectionEquality()
                    .equals(other.category, category)) &&
            (identical(other.bodyFormat, bodyFormat) ||
                const DeepCollectionEquality()
                    .equals(other.bodyFormat, bodyFormat)) &&
            (identical(other.emailType, emailType) ||
                const DeepCollectionEquality()
                    .equals(other.emailType, emailType)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(appEmailId) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(filterId) ^
      const DeepCollectionEquality().hash(subject) ^
      const DeepCollectionEquality().hash(emailText) ^
      const DeepCollectionEquality().hash(category) ^
      const DeepCollectionEquality().hash(bodyFormat) ^
      const DeepCollectionEquality().hash(emailType) ^
      const DeepCollectionEquality().hash(inactive) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicExtension
    on FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic {
  FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic copyWith(
      {String? appEmailId,
      String? description,
      String? filterId,
      String? subject,
      String? emailText,
      String? category,
      String? bodyFormat,
      String? emailType,
      bool? inactive,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic(
        appEmailId: appEmailId ?? this.appEmailId,
        description: description ?? this.description,
        filterId: filterId ?? this.filterId,
        subject: subject ?? this.subject,
        emailText: emailText ?? this.emailText,
        category: category ?? this.category,
        bodyFormat: bodyFormat ?? this.bodyFormat,
        emailType: emailType ?? this.emailType,
        inactive: inactive ?? this.inactive,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic copyWithWrapped(
      {Wrapped<String?>? appEmailId,
      Wrapped<String?>? description,
      Wrapped<String?>? filterId,
      Wrapped<String?>? subject,
      Wrapped<String?>? emailText,
      Wrapped<String?>? category,
      Wrapped<String?>? bodyFormat,
      Wrapped<String?>? emailType,
      Wrapped<bool?>? inactive,
      Wrapped<String?>? recordTitle,
      Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
          fields,
      Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
      Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
          defaultFieldAttributes}) {
    return FwStandardModulesAdministratorEmailTemplateEmailTemplateLogic(
        appEmailId: (appEmailId != null ? appEmailId.value : this.appEmailId),
        description:
            (description != null ? description.value : this.description),
        filterId: (filterId != null ? filterId.value : this.filterId),
        subject: (subject != null ? subject.value : this.subject),
        emailText: (emailText != null ? emailText.value : this.emailText),
        category: (category != null ? category.value : this.category),
        bodyFormat: (bodyFormat != null ? bodyFormat.value : this.bodyFormat),
        emailType: (emailType != null ? emailType.value : this.emailType),
        inactive: (inactive != null ? inactive.value : this.inactive),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicGetTemplateFieldsRequest {
  FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicGetTemplateFieldsRequest({
    this.category,
  });

  factory FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicGetTemplateFieldsRequest.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicGetTemplateFieldsRequestFromJson(
          json);

  @JsonKey(name: 'category', includeIfNull: false, defaultValue: '')
  final String? category;
  static const fromJsonFactory =
      _$FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicGetTemplateFieldsRequestFromJson;
  static const toJsonFactory =
      _$FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicGetTemplateFieldsRequestToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicGetTemplateFieldsRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicGetTemplateFieldsRequest &&
            (identical(other.category, category) ||
                const DeepCollectionEquality()
                    .equals(other.category, category)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(category) ^ runtimeType.hashCode;
}

extension $FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicGetTemplateFieldsRequestExtension
    on FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicGetTemplateFieldsRequest {
  FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicGetTemplateFieldsRequest
      copyWith({String? category}) {
    return FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicGetTemplateFieldsRequest(
        category: category ?? this.category);
  }

  FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicGetTemplateFieldsRequest
      copyWithWrapped({Wrapped<String?>? category}) {
    return FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicGetTemplateFieldsRequest(
        category: (category != null ? category.value : this.category));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponse {
  FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponse({
    this.categories,
  });

  factory FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponse.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponseFromJson(
          json);

  @JsonKey(name: 'categories', includeIfNull: false)
  final List<String>? categories;
  static const fromJsonFactory =
      _$FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponseFromJson;
  static const toJsonFactory =
      _$FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponseToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponse &&
            (identical(other.categories, categories) ||
                const DeepCollectionEquality()
                    .equals(other.categories, categories)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(categories) ^ runtimeType.hashCode;
}

extension $FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponseExtension
    on FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponse {
  FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponse
      copyWith({List<String>? categories}) {
    return FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponse(
        categories: categories ?? this.categories);
  }

  FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponse
      copyWithWrapped({Wrapped<List<String>?>? categories}) {
    return FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateCategoriesResponse(
        categories: (categories != null ? categories.value : this.categories));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponse {
  FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponse({
    this.fields,
  });

  factory FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponse.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponseFromJson(
          json);

  @JsonKey(name: 'fields', includeIfNull: false, defaultValue: <String>[])
  final List<String>? fields;
  static const fromJsonFactory =
      _$FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponseFromJson;
  static const toJsonFactory =
      _$FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponseToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponse &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(fields) ^ runtimeType.hashCode;
}

extension $FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponseExtension
    on FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponse {
  FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponse
      copyWith({List<String>? fields}) {
    return FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponse(
        fields: fields ?? this.fields);
  }

  FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponse
      copyWithWrapped({Wrapped<List<String>?>? fields}) {
    return FwStandardModulesAdministratorEmailTemplateEmailTemplateLogicTemplateFieldsResponse(
        fields: (fields != null ? fields.value : this.fields));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModulesAdministratorWebAlertLogWebAlertLogLogic {
  FwStandardModulesAdministratorWebAlertLogWebAlertLogLogic({
    this.webAlertLogId,
    this.alertId,
    this.createDateTime,
    this.alertSubject,
    this.alertBody,
    this.alertFrom,
    this.alertTo,
    this.status,
    this.errorMessage,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory FwStandardModulesAdministratorWebAlertLogWebAlertLogLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModulesAdministratorWebAlertLogWebAlertLogLogicFromJson(json);

  @JsonKey(name: 'WebAlertLogId', includeIfNull: false)
  final int? webAlertLogId;
  @JsonKey(name: 'AlertId', includeIfNull: false, defaultValue: '')
  final String? alertId;
  @JsonKey(name: 'CreateDateTime', includeIfNull: false)
  final DateTime? createDateTime;
  @JsonKey(name: 'AlertSubject', includeIfNull: false, defaultValue: '')
  final String? alertSubject;
  @JsonKey(name: 'AlertBody', includeIfNull: false, defaultValue: '')
  final String? alertBody;
  @JsonKey(name: 'AlertFrom', includeIfNull: false, defaultValue: '')
  final String? alertFrom;
  @JsonKey(name: 'AlertTo', includeIfNull: false, defaultValue: '')
  final String? alertTo;
  @JsonKey(name: 'Status', includeIfNull: false, defaultValue: '')
  final String? status;
  @JsonKey(name: 'ErrorMessage', includeIfNull: false, defaultValue: '')
  final String? errorMessage;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$FwStandardModulesAdministratorWebAlertLogWebAlertLogLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModulesAdministratorWebAlertLogWebAlertLogLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModulesAdministratorWebAlertLogWebAlertLogLogicToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModulesAdministratorWebAlertLogWebAlertLogLogic &&
            (identical(other.webAlertLogId, webAlertLogId) ||
                const DeepCollectionEquality()
                    .equals(other.webAlertLogId, webAlertLogId)) &&
            (identical(other.alertId, alertId) ||
                const DeepCollectionEquality()
                    .equals(other.alertId, alertId)) &&
            (identical(other.createDateTime, createDateTime) ||
                const DeepCollectionEquality()
                    .equals(other.createDateTime, createDateTime)) &&
            (identical(other.alertSubject, alertSubject) ||
                const DeepCollectionEquality()
                    .equals(other.alertSubject, alertSubject)) &&
            (identical(other.alertBody, alertBody) ||
                const DeepCollectionEquality()
                    .equals(other.alertBody, alertBody)) &&
            (identical(other.alertFrom, alertFrom) ||
                const DeepCollectionEquality()
                    .equals(other.alertFrom, alertFrom)) &&
            (identical(other.alertTo, alertTo) ||
                const DeepCollectionEquality()
                    .equals(other.alertTo, alertTo)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.errorMessage, errorMessage) ||
                const DeepCollectionEquality()
                    .equals(other.errorMessage, errorMessage)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(webAlertLogId) ^
      const DeepCollectionEquality().hash(alertId) ^
      const DeepCollectionEquality().hash(createDateTime) ^
      const DeepCollectionEquality().hash(alertSubject) ^
      const DeepCollectionEquality().hash(alertBody) ^
      const DeepCollectionEquality().hash(alertFrom) ^
      const DeepCollectionEquality().hash(alertTo) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(errorMessage) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $FwStandardModulesAdministratorWebAlertLogWebAlertLogLogicExtension
    on FwStandardModulesAdministratorWebAlertLogWebAlertLogLogic {
  FwStandardModulesAdministratorWebAlertLogWebAlertLogLogic copyWith(
      {int? webAlertLogId,
      String? alertId,
      DateTime? createDateTime,
      String? alertSubject,
      String? alertBody,
      String? alertFrom,
      String? alertTo,
      String? status,
      String? errorMessage,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return FwStandardModulesAdministratorWebAlertLogWebAlertLogLogic(
        webAlertLogId: webAlertLogId ?? this.webAlertLogId,
        alertId: alertId ?? this.alertId,
        createDateTime: createDateTime ?? this.createDateTime,
        alertSubject: alertSubject ?? this.alertSubject,
        alertBody: alertBody ?? this.alertBody,
        alertFrom: alertFrom ?? this.alertFrom,
        alertTo: alertTo ?? this.alertTo,
        status: status ?? this.status,
        errorMessage: errorMessage ?? this.errorMessage,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  FwStandardModulesAdministratorWebAlertLogWebAlertLogLogic copyWithWrapped(
      {Wrapped<int?>? webAlertLogId,
      Wrapped<String?>? alertId,
      Wrapped<DateTime?>? createDateTime,
      Wrapped<String?>? alertSubject,
      Wrapped<String?>? alertBody,
      Wrapped<String?>? alertFrom,
      Wrapped<String?>? alertTo,
      Wrapped<String?>? status,
      Wrapped<String?>? errorMessage,
      Wrapped<String?>? dateStamp,
      Wrapped<String?>? recordTitle,
      Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
          fields,
      Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
      Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
          defaultFieldAttributes}) {
    return FwStandardModulesAdministratorWebAlertLogWebAlertLogLogic(
        webAlertLogId:
            (webAlertLogId != null ? webAlertLogId.value : this.webAlertLogId),
        alertId: (alertId != null ? alertId.value : this.alertId),
        createDateTime: (createDateTime != null
            ? createDateTime.value
            : this.createDateTime),
        alertSubject:
            (alertSubject != null ? alertSubject.value : this.alertSubject),
        alertBody: (alertBody != null ? alertBody.value : this.alertBody),
        alertFrom: (alertFrom != null ? alertFrom.value : this.alertFrom),
        alertTo: (alertTo != null ? alertTo.value : this.alertTo),
        status: (status != null ? status.value : this.status),
        errorMessage:
            (errorMessage != null ? errorMessage.value : this.errorMessage),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogic {
  FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogic({
    this.webAuditId,
    this.moduleName,
    this.title,
    this.uniqueId1,
    this.uniqueId2,
    this.uniqueId3,
    this.webUserId,
    this.userName,
    this.json,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogicFromJson(
          json);

  @JsonKey(name: 'WebAuditId', includeIfNull: false)
  final int? webAuditId;
  @JsonKey(name: 'ModuleName', includeIfNull: false, defaultValue: '')
  final String? moduleName;
  @JsonKey(name: 'Title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'UniqueId1', includeIfNull: false, defaultValue: '')
  final String? uniqueId1;
  @JsonKey(name: 'UniqueId2', includeIfNull: false, defaultValue: '')
  final String? uniqueId2;
  @JsonKey(name: 'UniqueId3', includeIfNull: false, defaultValue: '')
  final String? uniqueId3;
  @JsonKey(name: 'WebUserId', includeIfNull: false, defaultValue: '')
  final String? webUserId;
  @JsonKey(name: 'UserName', includeIfNull: false, defaultValue: '')
  final String? userName;
  @JsonKey(name: 'Json', includeIfNull: false, defaultValue: '')
  final String? json;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogicToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogic &&
            (identical(other.webAuditId, webAuditId) ||
                const DeepCollectionEquality()
                    .equals(other.webAuditId, webAuditId)) &&
            (identical(other.moduleName, moduleName) ||
                const DeepCollectionEquality()
                    .equals(other.moduleName, moduleName)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.uniqueId1, uniqueId1) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1, uniqueId1)) &&
            (identical(other.uniqueId2, uniqueId2) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId2, uniqueId2)) &&
            (identical(other.uniqueId3, uniqueId3) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId3, uniqueId3)) &&
            (identical(other.webUserId, webUserId) ||
                const DeepCollectionEquality()
                    .equals(other.webUserId, webUserId)) &&
            (identical(other.userName, userName) ||
                const DeepCollectionEquality()
                    .equals(other.userName, userName)) &&
            (identical(other.json, json) ||
                const DeepCollectionEquality().equals(other.json, json)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(webAuditId) ^
      const DeepCollectionEquality().hash(moduleName) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(uniqueId1) ^
      const DeepCollectionEquality().hash(uniqueId2) ^
      const DeepCollectionEquality().hash(uniqueId3) ^
      const DeepCollectionEquality().hash(webUserId) ^
      const DeepCollectionEquality().hash(userName) ^
      const DeepCollectionEquality().hash(json) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogicExtension
    on FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogic {
  FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogic copyWith(
      {int? webAuditId,
      String? moduleName,
      String? title,
      String? uniqueId1,
      String? uniqueId2,
      String? uniqueId3,
      String? webUserId,
      String? userName,
      String? json,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogic(
        webAuditId: webAuditId ?? this.webAuditId,
        moduleName: moduleName ?? this.moduleName,
        title: title ?? this.title,
        uniqueId1: uniqueId1 ?? this.uniqueId1,
        uniqueId2: uniqueId2 ?? this.uniqueId2,
        uniqueId3: uniqueId3 ?? this.uniqueId3,
        webUserId: webUserId ?? this.webUserId,
        userName: userName ?? this.userName,
        json: json ?? this.json,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogic copyWithWrapped(
      {Wrapped<int?>? webAuditId,
      Wrapped<String?>? moduleName,
      Wrapped<String?>? title,
      Wrapped<String?>? uniqueId1,
      Wrapped<String?>? uniqueId2,
      Wrapped<String?>? uniqueId3,
      Wrapped<String?>? webUserId,
      Wrapped<String?>? userName,
      Wrapped<String?>? json,
      Wrapped<String?>? dateStamp,
      Wrapped<String?>? recordTitle,
      Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
          fields,
      Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
      Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
          defaultFieldAttributes}) {
    return FwStandardModulesAdministratorWebAuditJsonWebAuditJsonLogic(
        webAuditId: (webAuditId != null ? webAuditId.value : this.webAuditId),
        moduleName: (moduleName != null ? moduleName.value : this.moduleName),
        title: (title != null ? title.value : this.title),
        uniqueId1: (uniqueId1 != null ? uniqueId1.value : this.uniqueId1),
        uniqueId2: (uniqueId2 != null ? uniqueId2.value : this.uniqueId2),
        uniqueId3: (uniqueId3 != null ? uniqueId3.value : this.uniqueId3),
        webUserId: (webUserId != null ? webUserId.value : this.webUserId),
        userName: (userName != null ? userName.value : this.userName),
        json: (json != null ? json.value : this.json),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardSqlServerFwJsonDataTable {
  FwStandardSqlServerFwJsonDataTable({
    this.columnIndex,
    this.totals,
    this.columns,
    this.rows,
    this.pageNo,
    this.pageSize,
    this.totalPages,
    this.totalRows,
    this.dateFields,
    this.columnNameByIndex,
  });

  factory FwStandardSqlServerFwJsonDataTable.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardSqlServerFwJsonDataTableFromJson(json);

  @JsonKey(name: 'ColumnIndex', includeIfNull: false)
  final Map<String, dynamic>? columnIndex;
  @JsonKey(name: 'Totals', includeIfNull: false)
  final Map<String, dynamic>? totals;
  @JsonKey(
      name: 'Columns',
      includeIfNull: false,
      defaultValue: <FwStandardSqlServerFwJsonDataTableColumn>[])
  final List<FwStandardSqlServerFwJsonDataTableColumn>? columns;
  @JsonKey(name: 'Rows', includeIfNull: false, defaultValue: <List<Object>>[])
  final List<List<Object>>? rows;
  @JsonKey(name: 'PageNo', includeIfNull: false)
  final int? pageNo;
  @JsonKey(name: 'PageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'TotalPages', includeIfNull: false)
  final int? totalPages;
  @JsonKey(name: 'TotalRows', includeIfNull: false)
  final int? totalRows;
  @JsonKey(name: 'DateFields', includeIfNull: false, defaultValue: <String>[])
  final List<String>? dateFields;
  @JsonKey(name: 'ColumnNameByIndex', includeIfNull: false)
  final Map<String, dynamic>? columnNameByIndex;
  static const fromJsonFactory = _$FwStandardSqlServerFwJsonDataTableFromJson;
  static const toJsonFactory = _$FwStandardSqlServerFwJsonDataTableToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardSqlServerFwJsonDataTableToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardSqlServerFwJsonDataTable &&
            (identical(other.columnIndex, columnIndex) ||
                const DeepCollectionEquality()
                    .equals(other.columnIndex, columnIndex)) &&
            (identical(other.totals, totals) ||
                const DeepCollectionEquality().equals(other.totals, totals)) &&
            (identical(other.columns, columns) ||
                const DeepCollectionEquality()
                    .equals(other.columns, columns)) &&
            (identical(other.rows, rows) ||
                const DeepCollectionEquality().equals(other.rows, rows)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalPages, totalPages) ||
                const DeepCollectionEquality()
                    .equals(other.totalPages, totalPages)) &&
            (identical(other.totalRows, totalRows) ||
                const DeepCollectionEquality()
                    .equals(other.totalRows, totalRows)) &&
            (identical(other.dateFields, dateFields) ||
                const DeepCollectionEquality()
                    .equals(other.dateFields, dateFields)) &&
            (identical(other.columnNameByIndex, columnNameByIndex) ||
                const DeepCollectionEquality()
                    .equals(other.columnNameByIndex, columnNameByIndex)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(columnIndex) ^
      const DeepCollectionEquality().hash(totals) ^
      const DeepCollectionEquality().hash(columns) ^
      const DeepCollectionEquality().hash(rows) ^
      const DeepCollectionEquality().hash(pageNo) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(totalPages) ^
      const DeepCollectionEquality().hash(totalRows) ^
      const DeepCollectionEquality().hash(dateFields) ^
      const DeepCollectionEquality().hash(columnNameByIndex) ^
      runtimeType.hashCode;
}

extension $FwStandardSqlServerFwJsonDataTableExtension
    on FwStandardSqlServerFwJsonDataTable {
  FwStandardSqlServerFwJsonDataTable copyWith(
      {Map<String, dynamic>? columnIndex,
      Map<String, dynamic>? totals,
      List<FwStandardSqlServerFwJsonDataTableColumn>? columns,
      List<List<Object>>? rows,
      int? pageNo,
      int? pageSize,
      int? totalPages,
      int? totalRows,
      List<String>? dateFields,
      Map<String, dynamic>? columnNameByIndex}) {
    return FwStandardSqlServerFwJsonDataTable(
        columnIndex: columnIndex ?? this.columnIndex,
        totals: totals ?? this.totals,
        columns: columns ?? this.columns,
        rows: rows ?? this.rows,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalPages: totalPages ?? this.totalPages,
        totalRows: totalRows ?? this.totalRows,
        dateFields: dateFields ?? this.dateFields,
        columnNameByIndex: columnNameByIndex ?? this.columnNameByIndex);
  }

  FwStandardSqlServerFwJsonDataTable copyWithWrapped(
      {Wrapped<Map<String, dynamic>?>? columnIndex,
      Wrapped<Map<String, dynamic>?>? totals,
      Wrapped<List<FwStandardSqlServerFwJsonDataTableColumn>?>? columns,
      Wrapped<List<List<Object>>?>? rows,
      Wrapped<int?>? pageNo,
      Wrapped<int?>? pageSize,
      Wrapped<int?>? totalPages,
      Wrapped<int?>? totalRows,
      Wrapped<List<String>?>? dateFields,
      Wrapped<Map<String, dynamic>?>? columnNameByIndex}) {
    return FwStandardSqlServerFwJsonDataTable(
        columnIndex:
            (columnIndex != null ? columnIndex.value : this.columnIndex),
        totals: (totals != null ? totals.value : this.totals),
        columns: (columns != null ? columns.value : this.columns),
        rows: (rows != null ? rows.value : this.rows),
        pageNo: (pageNo != null ? pageNo.value : this.pageNo),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        totalPages: (totalPages != null ? totalPages.value : this.totalPages),
        totalRows: (totalRows != null ? totalRows.value : this.totalRows),
        dateFields: (dateFields != null ? dateFields.value : this.dateFields),
        columnNameByIndex: (columnNameByIndex != null
            ? columnNameByIndex.value
            : this.columnNameByIndex));
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardSqlServerFwJsonDataTableColumn {
  FwStandardSqlServerFwJsonDataTableColumn({
    this.name,
    this.dataField,
    this.dataType,
    this.isUniqueId,
    this.isVisible,
  });

  factory FwStandardSqlServerFwJsonDataTableColumn.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardSqlServerFwJsonDataTableColumnFromJson(json);

  @JsonKey(name: 'Name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'DataField', includeIfNull: false, defaultValue: '')
  final String? dataField;
  @JsonKey(
    name: 'DataType',
    includeIfNull: false,
    toJson: fwStandardSqlServerFwDataTypesToJson,
    fromJson: fwStandardSqlServerFwDataTypesFromJson,
  )
  final enums.FwStandardSqlServerFwDataTypes? dataType;
  @JsonKey(name: 'IsUniqueId', includeIfNull: false)
  final bool? isUniqueId;
  @JsonKey(name: 'IsVisible', includeIfNull: false)
  final bool? isVisible;
  static const fromJsonFactory =
      _$FwStandardSqlServerFwJsonDataTableColumnFromJson;
  static const toJsonFactory = _$FwStandardSqlServerFwJsonDataTableColumnToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardSqlServerFwJsonDataTableColumnToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardSqlServerFwJsonDataTableColumn &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.dataField, dataField) ||
                const DeepCollectionEquality()
                    .equals(other.dataField, dataField)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.isUniqueId, isUniqueId) ||
                const DeepCollectionEquality()
                    .equals(other.isUniqueId, isUniqueId)) &&
            (identical(other.isVisible, isVisible) ||
                const DeepCollectionEquality()
                    .equals(other.isVisible, isVisible)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(dataField) ^
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(isUniqueId) ^
      const DeepCollectionEquality().hash(isVisible) ^
      runtimeType.hashCode;
}

extension $FwStandardSqlServerFwJsonDataTableColumnExtension
    on FwStandardSqlServerFwJsonDataTableColumn {
  FwStandardSqlServerFwJsonDataTableColumn copyWith(
      {String? name,
      String? dataField,
      enums.FwStandardSqlServerFwDataTypes? dataType,
      bool? isUniqueId,
      bool? isVisible}) {
    return FwStandardSqlServerFwJsonDataTableColumn(
        name: name ?? this.name,
        dataField: dataField ?? this.dataField,
        dataType: dataType ?? this.dataType,
        isUniqueId: isUniqueId ?? this.isUniqueId,
        isVisible: isVisible ?? this.isVisible);
  }

  FwStandardSqlServerFwJsonDataTableColumn copyWithWrapped(
      {Wrapped<String?>? name,
      Wrapped<String?>? dataField,
      Wrapped<enums.FwStandardSqlServerFwDataTypes?>? dataType,
      Wrapped<bool?>? isUniqueId,
      Wrapped<bool?>? isVisible}) {
    return FwStandardSqlServerFwJsonDataTableColumn(
        name: (name != null ? name.value : this.name),
        dataField: (dataField != null ? dataField.value : this.dataField),
        dataType: (dataType != null ? dataType.value : this.dataType),
        isUniqueId: (isUniqueId != null ? isUniqueId.value : this.isUniqueId),
        isVisible: (isVisible != null ? isVisible.value : this.isVisible));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAccountServicesHubSpotGetHubSpotContactsRequest {
  WebApiModulesAccountServicesHubSpotGetHubSpotContactsRequest({
    this.accessToken,
  });

  factory WebApiModulesAccountServicesHubSpotGetHubSpotContactsRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAccountServicesHubSpotGetHubSpotContactsRequestFromJson(
          json);

  @JsonKey(name: 'accessToken', includeIfNull: false, defaultValue: '')
  final String? accessToken;
  static const fromJsonFactory =
      _$WebApiModulesAccountServicesHubSpotGetHubSpotContactsRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAccountServicesHubSpotGetHubSpotContactsRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAccountServicesHubSpotGetHubSpotContactsRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAccountServicesHubSpotGetHubSpotContactsRequest &&
            (identical(other.accessToken, accessToken) ||
                const DeepCollectionEquality()
                    .equals(other.accessToken, accessToken)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(accessToken) ^ runtimeType.hashCode;
}

extension $WebApiModulesAccountServicesHubSpotGetHubSpotContactsRequestExtension
    on WebApiModulesAccountServicesHubSpotGetHubSpotContactsRequest {
  WebApiModulesAccountServicesHubSpotGetHubSpotContactsRequest copyWith(
      {String? accessToken}) {
    return WebApiModulesAccountServicesHubSpotGetHubSpotContactsRequest(
        accessToken: accessToken ?? this.accessToken);
  }

  WebApiModulesAccountServicesHubSpotGetHubSpotContactsRequest copyWithWrapped(
      {Wrapped<String?>? accessToken}) {
    return WebApiModulesAccountServicesHubSpotGetHubSpotContactsRequest(
        accessToken:
            (accessToken != null ? accessToken.value : this.accessToken));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAccountServicesHubSpotGetHubSpotTokensRequest {
  WebApiModulesAccountServicesHubSpotGetHubSpotTokensRequest({
    this.authorizationCode,
  });

  factory WebApiModulesAccountServicesHubSpotGetHubSpotTokensRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAccountServicesHubSpotGetHubSpotTokensRequestFromJson(
          json);

  @JsonKey(name: 'authorizationCode', includeIfNull: false, defaultValue: '')
  final String? authorizationCode;
  static const fromJsonFactory =
      _$WebApiModulesAccountServicesHubSpotGetHubSpotTokensRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAccountServicesHubSpotGetHubSpotTokensRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAccountServicesHubSpotGetHubSpotTokensRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAccountServicesHubSpotGetHubSpotTokensRequest &&
            (identical(other.authorizationCode, authorizationCode) ||
                const DeepCollectionEquality()
                    .equals(other.authorizationCode, authorizationCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(authorizationCode) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAccountServicesHubSpotGetHubSpotTokensRequestExtension
    on WebApiModulesAccountServicesHubSpotGetHubSpotTokensRequest {
  WebApiModulesAccountServicesHubSpotGetHubSpotTokensRequest copyWith(
      {String? authorizationCode}) {
    return WebApiModulesAccountServicesHubSpotGetHubSpotTokensRequest(
        authorizationCode: authorizationCode ?? this.authorizationCode);
  }

  WebApiModulesAccountServicesHubSpotGetHubSpotTokensRequest copyWithWrapped(
      {Wrapped<String?>? authorizationCode}) {
    return WebApiModulesAccountServicesHubSpotGetHubSpotTokensRequest(
        authorizationCode: (authorizationCode != null
            ? authorizationCode.value
            : this.authorizationCode));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAccountServicesHubSpotGetWriteTokensResponse {
  WebApiModulesAccountServicesHubSpotGetWriteTokensResponse({
    this.message,
  });

  factory WebApiModulesAccountServicesHubSpotGetWriteTokensResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAccountServicesHubSpotGetWriteTokensResponseFromJson(json);

  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  static const fromJsonFactory =
      _$WebApiModulesAccountServicesHubSpotGetWriteTokensResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAccountServicesHubSpotGetWriteTokensResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAccountServicesHubSpotGetWriteTokensResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAccountServicesHubSpotGetWriteTokensResponse &&
            (identical(other.message, message) ||
                const DeepCollectionEquality().equals(other.message, message)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(message) ^ runtimeType.hashCode;
}

extension $WebApiModulesAccountServicesHubSpotGetWriteTokensResponseExtension
    on WebApiModulesAccountServicesHubSpotGetWriteTokensResponse {
  WebApiModulesAccountServicesHubSpotGetWriteTokensResponse copyWith(
      {String? message}) {
    return WebApiModulesAccountServicesHubSpotGetWriteTokensResponse(
        message: message ?? this.message);
  }

  WebApiModulesAccountServicesHubSpotGetWriteTokensResponse copyWithWrapped(
      {Wrapped<String?>? message}) {
    return WebApiModulesAccountServicesHubSpotGetWriteTokensResponse(
        message: (message != null ? message.value : this.message));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAccountServicesHubSpotPostHubSpotContactRequest {
  WebApiModulesAccountServicesHubSpotPostHubSpotContactRequest({
    this.accessToken,
    this.email,
    this.firstname,
    this.lastname,
  });

  factory WebApiModulesAccountServicesHubSpotPostHubSpotContactRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAccountServicesHubSpotPostHubSpotContactRequestFromJson(
          json);

  @JsonKey(name: 'accessToken', includeIfNull: false, defaultValue: '')
  final String? accessToken;
  @JsonKey(name: 'email', includeIfNull: false, defaultValue: '')
  final String? email;
  @JsonKey(name: 'firstname', includeIfNull: false, defaultValue: '')
  final String? firstname;
  @JsonKey(name: 'lastname', includeIfNull: false, defaultValue: '')
  final String? lastname;
  static const fromJsonFactory =
      _$WebApiModulesAccountServicesHubSpotPostHubSpotContactRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAccountServicesHubSpotPostHubSpotContactRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAccountServicesHubSpotPostHubSpotContactRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAccountServicesHubSpotPostHubSpotContactRequest &&
            (identical(other.accessToken, accessToken) ||
                const DeepCollectionEquality()
                    .equals(other.accessToken, accessToken)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.firstname, firstname) ||
                const DeepCollectionEquality()
                    .equals(other.firstname, firstname)) &&
            (identical(other.lastname, lastname) ||
                const DeepCollectionEquality()
                    .equals(other.lastname, lastname)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(accessToken) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(firstname) ^
      const DeepCollectionEquality().hash(lastname) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAccountServicesHubSpotPostHubSpotContactRequestExtension
    on WebApiModulesAccountServicesHubSpotPostHubSpotContactRequest {
  WebApiModulesAccountServicesHubSpotPostHubSpotContactRequest copyWith(
      {String? accessToken,
      String? email,
      String? firstname,
      String? lastname}) {
    return WebApiModulesAccountServicesHubSpotPostHubSpotContactRequest(
        accessToken: accessToken ?? this.accessToken,
        email: email ?? this.email,
        firstname: firstname ?? this.firstname,
        lastname: lastname ?? this.lastname);
  }

  WebApiModulesAccountServicesHubSpotPostHubSpotContactRequest copyWithWrapped(
      {Wrapped<String?>? accessToken,
      Wrapped<String?>? email,
      Wrapped<String?>? firstname,
      Wrapped<String?>? lastname}) {
    return WebApiModulesAccountServicesHubSpotPostHubSpotContactRequest(
        accessToken:
            (accessToken != null ? accessToken.value : this.accessToken),
        email: (email != null ? email.value : this.email),
        firstname: (firstname != null ? firstname.value : this.firstname),
        lastname: (lastname != null ? lastname.value : this.lastname));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAccountServicesHubSpotSearchHubSpotContactsWithinPeriodRequest {
  WebApiModulesAccountServicesHubSpotSearchHubSpotContactsWithinPeriodRequest({
    this.webusersid,
    this.accessToken,
    this.lastSyncEpoch,
  });

  factory WebApiModulesAccountServicesHubSpotSearchHubSpotContactsWithinPeriodRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAccountServicesHubSpotSearchHubSpotContactsWithinPeriodRequestFromJson(
          json);

  @JsonKey(name: 'webusersid', includeIfNull: false, defaultValue: '')
  final String? webusersid;
  @JsonKey(name: 'accessToken', includeIfNull: false, defaultValue: '')
  final String? accessToken;
  @JsonKey(name: 'lastSyncEpoch', includeIfNull: false)
  final int? lastSyncEpoch;
  static const fromJsonFactory =
      _$WebApiModulesAccountServicesHubSpotSearchHubSpotContactsWithinPeriodRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAccountServicesHubSpotSearchHubSpotContactsWithinPeriodRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAccountServicesHubSpotSearchHubSpotContactsWithinPeriodRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAccountServicesHubSpotSearchHubSpotContactsWithinPeriodRequest &&
            (identical(other.webusersid, webusersid) ||
                const DeepCollectionEquality()
                    .equals(other.webusersid, webusersid)) &&
            (identical(other.accessToken, accessToken) ||
                const DeepCollectionEquality()
                    .equals(other.accessToken, accessToken)) &&
            (identical(other.lastSyncEpoch, lastSyncEpoch) ||
                const DeepCollectionEquality()
                    .equals(other.lastSyncEpoch, lastSyncEpoch)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(webusersid) ^
      const DeepCollectionEquality().hash(accessToken) ^
      const DeepCollectionEquality().hash(lastSyncEpoch) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAccountServicesHubSpotSearchHubSpotContactsWithinPeriodRequestExtension
    on WebApiModulesAccountServicesHubSpotSearchHubSpotContactsWithinPeriodRequest {
  WebApiModulesAccountServicesHubSpotSearchHubSpotContactsWithinPeriodRequest
      copyWith({String? webusersid, String? accessToken, int? lastSyncEpoch}) {
    return WebApiModulesAccountServicesHubSpotSearchHubSpotContactsWithinPeriodRequest(
        webusersid: webusersid ?? this.webusersid,
        accessToken: accessToken ?? this.accessToken,
        lastSyncEpoch: lastSyncEpoch ?? this.lastSyncEpoch);
  }

  WebApiModulesAccountServicesHubSpotSearchHubSpotContactsWithinPeriodRequest
      copyWithWrapped(
          {Wrapped<String?>? webusersid,
          Wrapped<String?>? accessToken,
          Wrapped<int?>? lastSyncEpoch}) {
    return WebApiModulesAccountServicesHubSpotSearchHubSpotContactsWithinPeriodRequest(
        webusersid: (webusersid != null ? webusersid.value : this.webusersid),
        accessToken:
            (accessToken != null ? accessToken.value : this.accessToken),
        lastSyncEpoch:
            (lastSyncEpoch != null ? lastSyncEpoch.value : this.lastSyncEpoch));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorCustomFieldCustomField {
  WebApiModulesAdministratorCustomFieldCustomField({
    this.customFieldId,
    this.moduleName,
    this.fieldName,
    this.customTableName,
    this.customFieldName,
    this.fieldType,
    this.controlType,
    this.stringLength,
    this.floatDecimalDigits,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAdministratorCustomFieldCustomField.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorCustomFieldCustomFieldFromJson(json);

  @JsonKey(name: 'CustomFieldId', includeIfNull: false, defaultValue: '')
  final String? customFieldId;
  @JsonKey(name: 'ModuleName', includeIfNull: false, defaultValue: '')
  final String? moduleName;
  @JsonKey(name: 'FieldName', includeIfNull: false, defaultValue: '')
  final String? fieldName;
  @JsonKey(name: 'CustomTableName', includeIfNull: false, defaultValue: '')
  final String? customTableName;
  @JsonKey(name: 'CustomFieldName', includeIfNull: false, defaultValue: '')
  final String? customFieldName;
  @JsonKey(name: 'FieldType', includeIfNull: false, defaultValue: '')
  final String? fieldType;
  @JsonKey(name: 'ControlType', includeIfNull: false, defaultValue: '')
  final String? controlType;
  @JsonKey(name: 'StringLength', includeIfNull: false)
  final int? stringLength;
  @JsonKey(name: 'FloatDecimalDigits', includeIfNull: false)
  final int? floatDecimalDigits;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorCustomFieldCustomFieldFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorCustomFieldCustomFieldToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorCustomFieldCustomFieldToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorCustomFieldCustomField &&
            (identical(other.customFieldId, customFieldId) ||
                const DeepCollectionEquality()
                    .equals(other.customFieldId, customFieldId)) &&
            (identical(other.moduleName, moduleName) ||
                const DeepCollectionEquality()
                    .equals(other.moduleName, moduleName)) &&
            (identical(other.fieldName, fieldName) ||
                const DeepCollectionEquality()
                    .equals(other.fieldName, fieldName)) &&
            (identical(other.customTableName, customTableName) ||
                const DeepCollectionEquality()
                    .equals(other.customTableName, customTableName)) &&
            (identical(other.customFieldName, customFieldName) ||
                const DeepCollectionEquality()
                    .equals(other.customFieldName, customFieldName)) &&
            (identical(other.fieldType, fieldType) ||
                const DeepCollectionEquality()
                    .equals(other.fieldType, fieldType)) &&
            (identical(other.controlType, controlType) ||
                const DeepCollectionEquality()
                    .equals(other.controlType, controlType)) &&
            (identical(other.stringLength, stringLength) ||
                const DeepCollectionEquality()
                    .equals(other.stringLength, stringLength)) &&
            (identical(other.floatDecimalDigits, floatDecimalDigits) ||
                const DeepCollectionEquality()
                    .equals(other.floatDecimalDigits, floatDecimalDigits)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(customFieldId) ^
      const DeepCollectionEquality().hash(moduleName) ^
      const DeepCollectionEquality().hash(fieldName) ^
      const DeepCollectionEquality().hash(customTableName) ^
      const DeepCollectionEquality().hash(customFieldName) ^
      const DeepCollectionEquality().hash(fieldType) ^
      const DeepCollectionEquality().hash(controlType) ^
      const DeepCollectionEquality().hash(stringLength) ^
      const DeepCollectionEquality().hash(floatDecimalDigits) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorCustomFieldCustomFieldExtension
    on WebApiModulesAdministratorCustomFieldCustomField {
  WebApiModulesAdministratorCustomFieldCustomField copyWith(
      {String? customFieldId,
      String? moduleName,
      String? fieldName,
      String? customTableName,
      String? customFieldName,
      String? fieldType,
      String? controlType,
      int? stringLength,
      int? floatDecimalDigits,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAdministratorCustomFieldCustomField(
        customFieldId: customFieldId ?? this.customFieldId,
        moduleName: moduleName ?? this.moduleName,
        fieldName: fieldName ?? this.fieldName,
        customTableName: customTableName ?? this.customTableName,
        customFieldName: customFieldName ?? this.customFieldName,
        fieldType: fieldType ?? this.fieldType,
        controlType: controlType ?? this.controlType,
        stringLength: stringLength ?? this.stringLength,
        floatDecimalDigits: floatDecimalDigits ?? this.floatDecimalDigits,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesAdministratorCustomFieldCustomField copyWithWrapped(
      {Wrapped<String?>? customFieldId,
      Wrapped<String?>? moduleName,
      Wrapped<String?>? fieldName,
      Wrapped<String?>? customTableName,
      Wrapped<String?>? customFieldName,
      Wrapped<String?>? fieldType,
      Wrapped<String?>? controlType,
      Wrapped<int?>? stringLength,
      Wrapped<int?>? floatDecimalDigits,
      Wrapped<String?>? dateStamp,
      Wrapped<String?>? recordTitle,
      Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
          fields,
      Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
      Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
          defaultFieldAttributes}) {
    return WebApiModulesAdministratorCustomFieldCustomField(
        customFieldId:
            (customFieldId != null ? customFieldId.value : this.customFieldId),
        moduleName: (moduleName != null ? moduleName.value : this.moduleName),
        fieldName: (fieldName != null ? fieldName.value : this.fieldName),
        customTableName: (customTableName != null
            ? customTableName.value
            : this.customTableName),
        customFieldName: (customFieldName != null
            ? customFieldName.value
            : this.customFieldName),
        fieldType: (fieldType != null ? fieldType.value : this.fieldType),
        controlType:
            (controlType != null ? controlType.value : this.controlType),
        stringLength:
            (stringLength != null ? stringLength.value : this.stringLength),
        floatDecimalDigits: (floatDecimalDigits != null
            ? floatDecimalDigits.value
            : this.floatDecimalDigits),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorCustomFormCustomForm {
  WebApiModulesAdministratorCustomFormCustomForm({
    this.customFormId,
    this.webUserId,
    this.userName,
    this.baseForm,
    this.description,
    this.html,
    this.active,
    this.inactive,
    this.assignTo,
    this.selfAssign,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAdministratorCustomFormCustomForm.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorCustomFormCustomFormFromJson(json);

  @JsonKey(name: 'CustomFormId', includeIfNull: false, defaultValue: '')
  final String? customFormId;
  @JsonKey(name: 'WebUserId', includeIfNull: false, defaultValue: '')
  final String? webUserId;
  @JsonKey(name: 'UserName', includeIfNull: false, defaultValue: '')
  final String? userName;
  @JsonKey(name: 'BaseForm', includeIfNull: false, defaultValue: '')
  final String? baseForm;
  @JsonKey(name: 'Description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'Html', includeIfNull: false, defaultValue: '')
  final String? html;
  @JsonKey(name: 'Active', includeIfNull: false)
  final bool? active;
  @JsonKey(name: 'Inactive', includeIfNull: false)
  final bool? inactive;
  @JsonKey(name: 'AssignTo', includeIfNull: false, defaultValue: '')
  final String? assignTo;
  @JsonKey(name: 'SelfAssign', includeIfNull: false)
  final bool? selfAssign;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorCustomFormCustomFormFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorCustomFormCustomFormToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorCustomFormCustomFormToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorCustomFormCustomForm &&
            (identical(other.customFormId, customFormId) ||
                const DeepCollectionEquality()
                    .equals(other.customFormId, customFormId)) &&
            (identical(other.webUserId, webUserId) ||
                const DeepCollectionEquality()
                    .equals(other.webUserId, webUserId)) &&
            (identical(other.userName, userName) ||
                const DeepCollectionEquality()
                    .equals(other.userName, userName)) &&
            (identical(other.baseForm, baseForm) ||
                const DeepCollectionEquality()
                    .equals(other.baseForm, baseForm)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.html, html) ||
                const DeepCollectionEquality().equals(other.html, html)) &&
            (identical(other.active, active) ||
                const DeepCollectionEquality().equals(other.active, active)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.assignTo, assignTo) ||
                const DeepCollectionEquality()
                    .equals(other.assignTo, assignTo)) &&
            (identical(other.selfAssign, selfAssign) ||
                const DeepCollectionEquality()
                    .equals(other.selfAssign, selfAssign)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(customFormId) ^
      const DeepCollectionEquality().hash(webUserId) ^
      const DeepCollectionEquality().hash(userName) ^
      const DeepCollectionEquality().hash(baseForm) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(html) ^
      const DeepCollectionEquality().hash(active) ^
      const DeepCollectionEquality().hash(inactive) ^
      const DeepCollectionEquality().hash(assignTo) ^
      const DeepCollectionEquality().hash(selfAssign) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorCustomFormCustomFormExtension
    on WebApiModulesAdministratorCustomFormCustomForm {
  WebApiModulesAdministratorCustomFormCustomForm copyWith(
      {String? customFormId,
      String? webUserId,
      String? userName,
      String? baseForm,
      String? description,
      String? html,
      bool? active,
      bool? inactive,
      String? assignTo,
      bool? selfAssign,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAdministratorCustomFormCustomForm(
        customFormId: customFormId ?? this.customFormId,
        webUserId: webUserId ?? this.webUserId,
        userName: userName ?? this.userName,
        baseForm: baseForm ?? this.baseForm,
        description: description ?? this.description,
        html: html ?? this.html,
        active: active ?? this.active,
        inactive: inactive ?? this.inactive,
        assignTo: assignTo ?? this.assignTo,
        selfAssign: selfAssign ?? this.selfAssign,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesAdministratorCustomFormCustomForm copyWithWrapped(
      {Wrapped<String?>? customFormId,
      Wrapped<String?>? webUserId,
      Wrapped<String?>? userName,
      Wrapped<String?>? baseForm,
      Wrapped<String?>? description,
      Wrapped<String?>? html,
      Wrapped<bool?>? active,
      Wrapped<bool?>? inactive,
      Wrapped<String?>? assignTo,
      Wrapped<bool?>? selfAssign,
      Wrapped<String?>? dateStamp,
      Wrapped<String?>? recordTitle,
      Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
          fields,
      Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
      Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
          defaultFieldAttributes}) {
    return WebApiModulesAdministratorCustomFormCustomForm(
        customFormId:
            (customFormId != null ? customFormId.value : this.customFormId),
        webUserId: (webUserId != null ? webUserId.value : this.webUserId),
        userName: (userName != null ? userName.value : this.userName),
        baseForm: (baseForm != null ? baseForm.value : this.baseForm),
        description:
            (description != null ? description.value : this.description),
        html: (html != null ? html.value : this.html),
        active: (active != null ? active.value : this.active),
        inactive: (inactive != null ? inactive.value : this.inactive),
        assignTo: (assignTo != null ? assignTo.value : this.assignTo),
        selfAssign: (selfAssign != null ? selfAssign.value : this.selfAssign),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponse {
  WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponse({
    this.reportTemplate,
  });

  factory WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponseFromJson(
          json);

  @JsonKey(name: 'ReportTemplate', includeIfNull: false, defaultValue: '')
  final String? reportTemplate;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponse &&
            (identical(other.reportTemplate, reportTemplate) ||
                const DeepCollectionEquality()
                    .equals(other.reportTemplate, reportTemplate)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(reportTemplate) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponseExtension
    on WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponse {
  WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponse
      copyWith({String? reportTemplate}) {
    return WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponse(
        reportTemplate: reportTemplate ?? this.reportTemplate);
  }

  WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponse
      copyWithWrapped({Wrapped<String?>? reportTemplate}) {
    return WebApiModulesAdministratorCustomReportLayoutCustomReportLayoutControllerCustomReportLayoutResponse(
        reportTemplate: (reportTemplate != null
            ? reportTemplate.value
            : this.reportTemplate));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorDataHealthDataHealth {
  WebApiModulesAdministratorDataHealthDataHealth({
    this.dataHealthId,
    this.dataHealthType,
    this.captureDateTime,
    this.captureDate,
    this.json,
    this.severity,
    this.severityColor,
    this.notes,
    this.resolved,
    this.inactive,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAdministratorDataHealthDataHealth.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorDataHealthDataHealthFromJson(json);

  @JsonKey(name: 'DataHealthId', includeIfNull: false)
  final int? dataHealthId;
  @JsonKey(name: 'DataHealthType', includeIfNull: false, defaultValue: '')
  final String? dataHealthType;
  @JsonKey(name: 'CaptureDateTime', includeIfNull: false, defaultValue: '')
  final String? captureDateTime;
  @JsonKey(name: 'CaptureDate', includeIfNull: false, defaultValue: '')
  final String? captureDate;
  @JsonKey(name: 'Json', includeIfNull: false, defaultValue: '')
  final String? json;
  @JsonKey(name: 'Severity', includeIfNull: false, defaultValue: '')
  final String? severity;
  @JsonKey(name: 'SeverityColor', includeIfNull: false, defaultValue: '')
  final String? severityColor;
  @JsonKey(name: 'Notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'Resolved', includeIfNull: false)
  final bool? resolved;
  @JsonKey(name: 'Inactive', includeIfNull: false)
  final bool? inactive;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorDataHealthDataHealthFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorDataHealthDataHealthToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorDataHealthDataHealthToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorDataHealthDataHealth &&
            (identical(other.dataHealthId, dataHealthId) ||
                const DeepCollectionEquality()
                    .equals(other.dataHealthId, dataHealthId)) &&
            (identical(other.dataHealthType, dataHealthType) ||
                const DeepCollectionEquality()
                    .equals(other.dataHealthType, dataHealthType)) &&
            (identical(other.captureDateTime, captureDateTime) ||
                const DeepCollectionEquality()
                    .equals(other.captureDateTime, captureDateTime)) &&
            (identical(other.captureDate, captureDate) ||
                const DeepCollectionEquality()
                    .equals(other.captureDate, captureDate)) &&
            (identical(other.json, json) ||
                const DeepCollectionEquality().equals(other.json, json)) &&
            (identical(other.severity, severity) ||
                const DeepCollectionEquality()
                    .equals(other.severity, severity)) &&
            (identical(other.severityColor, severityColor) ||
                const DeepCollectionEquality()
                    .equals(other.severityColor, severityColor)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.resolved, resolved) ||
                const DeepCollectionEquality()
                    .equals(other.resolved, resolved)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(dataHealthId) ^
      const DeepCollectionEquality().hash(dataHealthType) ^
      const DeepCollectionEquality().hash(captureDateTime) ^
      const DeepCollectionEquality().hash(captureDate) ^
      const DeepCollectionEquality().hash(json) ^
      const DeepCollectionEquality().hash(severity) ^
      const DeepCollectionEquality().hash(severityColor) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(resolved) ^
      const DeepCollectionEquality().hash(inactive) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorDataHealthDataHealthExtension
    on WebApiModulesAdministratorDataHealthDataHealth {
  WebApiModulesAdministratorDataHealthDataHealth copyWith(
      {int? dataHealthId,
      String? dataHealthType,
      String? captureDateTime,
      String? captureDate,
      String? json,
      String? severity,
      String? severityColor,
      String? notes,
      bool? resolved,
      bool? inactive,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAdministratorDataHealthDataHealth(
        dataHealthId: dataHealthId ?? this.dataHealthId,
        dataHealthType: dataHealthType ?? this.dataHealthType,
        captureDateTime: captureDateTime ?? this.captureDateTime,
        captureDate: captureDate ?? this.captureDate,
        json: json ?? this.json,
        severity: severity ?? this.severity,
        severityColor: severityColor ?? this.severityColor,
        notes: notes ?? this.notes,
        resolved: resolved ?? this.resolved,
        inactive: inactive ?? this.inactive,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesAdministratorDataHealthDataHealth copyWithWrapped(
      {Wrapped<int?>? dataHealthId,
      Wrapped<String?>? dataHealthType,
      Wrapped<String?>? captureDateTime,
      Wrapped<String?>? captureDate,
      Wrapped<String?>? json,
      Wrapped<String?>? severity,
      Wrapped<String?>? severityColor,
      Wrapped<String?>? notes,
      Wrapped<bool?>? resolved,
      Wrapped<bool?>? inactive,
      Wrapped<String?>? recordTitle,
      Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
          fields,
      Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
      Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
          defaultFieldAttributes}) {
    return WebApiModulesAdministratorDataHealthDataHealth(
        dataHealthId:
            (dataHealthId != null ? dataHealthId.value : this.dataHealthId),
        dataHealthType: (dataHealthType != null
            ? dataHealthType.value
            : this.dataHealthType),
        captureDateTime: (captureDateTime != null
            ? captureDateTime.value
            : this.captureDateTime),
        captureDate:
            (captureDate != null ? captureDate.value : this.captureDate),
        json: (json != null ? json.value : this.json),
        severity: (severity != null ? severity.value : this.severity),
        severityColor:
            (severityColor != null ? severityColor.value : this.severityColor),
        notes: (notes != null ? notes.value : this.notes),
        resolved: (resolved != null ? resolved.value : this.resolved),
        inactive: (inactive != null ? inactive.value : this.inactive),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorEmailHistoryEmailHistory {
  WebApiModulesAdministratorEmailHistoryEmailHistory({
    this.emailHistoryId,
    this.reportId,
    this.fromUserId,
    this.fromWebUserId,
    this.fromUser,
    this.emailDate,
    this.status,
    this.emailText,
    this.emailTo,
    this.emailSubject,
    this.emailCC,
    this.title,
    this.relatedToId,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAdministratorEmailHistoryEmailHistory.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorEmailHistoryEmailHistoryFromJson(json);

  @JsonKey(name: 'EmailHistoryId', includeIfNull: false, defaultValue: '')
  final String? emailHistoryId;
  @JsonKey(name: 'ReportId', includeIfNull: false, defaultValue: '')
  final String? reportId;
  @JsonKey(name: 'FromUserId', includeIfNull: false, defaultValue: '')
  final String? fromUserId;
  @JsonKey(name: 'FromWebUserId', includeIfNull: false, defaultValue: '')
  final String? fromWebUserId;
  @JsonKey(name: 'FromUser', includeIfNull: false, defaultValue: '')
  final String? fromUser;
  @JsonKey(name: 'EmailDate', includeIfNull: false, defaultValue: '')
  final String? emailDate;
  @JsonKey(name: 'Status', includeIfNull: false, defaultValue: '')
  final String? status;
  @JsonKey(name: 'EmailText', includeIfNull: false, defaultValue: '')
  final String? emailText;
  @JsonKey(name: 'EmailTo', includeIfNull: false, defaultValue: '')
  final String? emailTo;
  @JsonKey(name: 'EmailSubject', includeIfNull: false, defaultValue: '')
  final String? emailSubject;
  @JsonKey(name: 'EmailCC', includeIfNull: false, defaultValue: '')
  final String? emailCC;
  @JsonKey(name: 'Title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'RelatedToId', includeIfNull: false, defaultValue: '')
  final String? relatedToId;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorEmailHistoryEmailHistoryFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorEmailHistoryEmailHistoryToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorEmailHistoryEmailHistoryToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorEmailHistoryEmailHistory &&
            (identical(other.emailHistoryId, emailHistoryId) ||
                const DeepCollectionEquality()
                    .equals(other.emailHistoryId, emailHistoryId)) &&
            (identical(other.reportId, reportId) ||
                const DeepCollectionEquality()
                    .equals(other.reportId, reportId)) &&
            (identical(other.fromUserId, fromUserId) ||
                const DeepCollectionEquality()
                    .equals(other.fromUserId, fromUserId)) &&
            (identical(other.fromWebUserId, fromWebUserId) ||
                const DeepCollectionEquality()
                    .equals(other.fromWebUserId, fromWebUserId)) &&
            (identical(other.fromUser, fromUser) ||
                const DeepCollectionEquality()
                    .equals(other.fromUser, fromUser)) &&
            (identical(other.emailDate, emailDate) ||
                const DeepCollectionEquality()
                    .equals(other.emailDate, emailDate)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.emailText, emailText) ||
                const DeepCollectionEquality()
                    .equals(other.emailText, emailText)) &&
            (identical(other.emailTo, emailTo) ||
                const DeepCollectionEquality()
                    .equals(other.emailTo, emailTo)) &&
            (identical(other.emailSubject, emailSubject) ||
                const DeepCollectionEquality()
                    .equals(other.emailSubject, emailSubject)) &&
            (identical(other.emailCC, emailCC) ||
                const DeepCollectionEquality()
                    .equals(other.emailCC, emailCC)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.relatedToId, relatedToId) ||
                const DeepCollectionEquality()
                    .equals(other.relatedToId, relatedToId)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(emailHistoryId) ^
      const DeepCollectionEquality().hash(reportId) ^
      const DeepCollectionEquality().hash(fromUserId) ^
      const DeepCollectionEquality().hash(fromWebUserId) ^
      const DeepCollectionEquality().hash(fromUser) ^
      const DeepCollectionEquality().hash(emailDate) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(emailText) ^
      const DeepCollectionEquality().hash(emailTo) ^
      const DeepCollectionEquality().hash(emailSubject) ^
      const DeepCollectionEquality().hash(emailCC) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(relatedToId) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorEmailHistoryEmailHistoryExtension
    on WebApiModulesAdministratorEmailHistoryEmailHistory {
  WebApiModulesAdministratorEmailHistoryEmailHistory copyWith(
      {String? emailHistoryId,
      String? reportId,
      String? fromUserId,
      String? fromWebUserId,
      String? fromUser,
      String? emailDate,
      String? status,
      String? emailText,
      String? emailTo,
      String? emailSubject,
      String? emailCC,
      String? title,
      String? relatedToId,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAdministratorEmailHistoryEmailHistory(
        emailHistoryId: emailHistoryId ?? this.emailHistoryId,
        reportId: reportId ?? this.reportId,
        fromUserId: fromUserId ?? this.fromUserId,
        fromWebUserId: fromWebUserId ?? this.fromWebUserId,
        fromUser: fromUser ?? this.fromUser,
        emailDate: emailDate ?? this.emailDate,
        status: status ?? this.status,
        emailText: emailText ?? this.emailText,
        emailTo: emailTo ?? this.emailTo,
        emailSubject: emailSubject ?? this.emailSubject,
        emailCC: emailCC ?? this.emailCC,
        title: title ?? this.title,
        relatedToId: relatedToId ?? this.relatedToId,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesAdministratorEmailHistoryEmailHistory copyWithWrapped(
      {Wrapped<String?>? emailHistoryId,
      Wrapped<String?>? reportId,
      Wrapped<String?>? fromUserId,
      Wrapped<String?>? fromWebUserId,
      Wrapped<String?>? fromUser,
      Wrapped<String?>? emailDate,
      Wrapped<String?>? status,
      Wrapped<String?>? emailText,
      Wrapped<String?>? emailTo,
      Wrapped<String?>? emailSubject,
      Wrapped<String?>? emailCC,
      Wrapped<String?>? title,
      Wrapped<String?>? relatedToId,
      Wrapped<String?>? dateStamp,
      Wrapped<String?>? recordTitle,
      Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
          fields,
      Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
      Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
          defaultFieldAttributes}) {
    return WebApiModulesAdministratorEmailHistoryEmailHistory(
        emailHistoryId: (emailHistoryId != null
            ? emailHistoryId.value
            : this.emailHistoryId),
        reportId: (reportId != null ? reportId.value : this.reportId),
        fromUserId: (fromUserId != null ? fromUserId.value : this.fromUserId),
        fromWebUserId:
            (fromWebUserId != null ? fromWebUserId.value : this.fromWebUserId),
        fromUser: (fromUser != null ? fromUser.value : this.fromUser),
        emailDate: (emailDate != null ? emailDate.value : this.emailDate),
        status: (status != null ? status.value : this.status),
        emailText: (emailText != null ? emailText.value : this.emailText),
        emailTo: (emailTo != null ? emailTo.value : this.emailTo),
        emailSubject:
            (emailSubject != null ? emailSubject.value : this.emailSubject),
        emailCC: (emailCC != null ? emailCC.value : this.emailCC),
        title: (title != null ? title.value : this.title),
        relatedToId:
            (relatedToId != null ? relatedToId.value : this.relatedToId),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorGroupGroup {
  WebApiModulesAdministratorGroupGroup({
    this.groupId,
    this.name,
    this.memo,
    this.security,
    this.hideNewMenuOptionsByDefault,
    this.isMyGroup,
    this.groupColor,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAdministratorGroupGroup.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorGroupGroupFromJson(json);

  @JsonKey(name: 'GroupId', includeIfNull: false, defaultValue: '')
  final String? groupId;
  @JsonKey(name: 'Name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'Memo', includeIfNull: false, defaultValue: '')
  final String? memo;
  @JsonKey(name: 'Security', includeIfNull: false, defaultValue: '')
  final String? security;
  @JsonKey(name: 'HideNewMenuOptionsByDefault', includeIfNull: false)
  final bool? hideNewMenuOptionsByDefault;
  @JsonKey(name: 'IsMyGroup', includeIfNull: false)
  final bool? isMyGroup;
  @JsonKey(name: 'GroupColor', includeIfNull: false, defaultValue: '')
  final String? groupColor;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesAdministratorGroupGroupFromJson;
  static const toJsonFactory = _$WebApiModulesAdministratorGroupGroupToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorGroupGroupToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorGroupGroup &&
            (identical(other.groupId, groupId) ||
                const DeepCollectionEquality()
                    .equals(other.groupId, groupId)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.memo, memo) ||
                const DeepCollectionEquality().equals(other.memo, memo)) &&
            (identical(other.security, security) ||
                const DeepCollectionEquality()
                    .equals(other.security, security)) &&
            (identical(other.hideNewMenuOptionsByDefault,
                    hideNewMenuOptionsByDefault) ||
                const DeepCollectionEquality().equals(
                    other.hideNewMenuOptionsByDefault,
                    hideNewMenuOptionsByDefault)) &&
            (identical(other.isMyGroup, isMyGroup) ||
                const DeepCollectionEquality()
                    .equals(other.isMyGroup, isMyGroup)) &&
            (identical(other.groupColor, groupColor) ||
                const DeepCollectionEquality()
                    .equals(other.groupColor, groupColor)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(groupId) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(memo) ^
      const DeepCollectionEquality().hash(security) ^
      const DeepCollectionEquality().hash(hideNewMenuOptionsByDefault) ^
      const DeepCollectionEquality().hash(isMyGroup) ^
      const DeepCollectionEquality().hash(groupColor) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorGroupGroupExtension
    on WebApiModulesAdministratorGroupGroup {
  WebApiModulesAdministratorGroupGroup copyWith(
      {String? groupId,
      String? name,
      String? memo,
      String? security,
      bool? hideNewMenuOptionsByDefault,
      bool? isMyGroup,
      String? groupColor,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAdministratorGroupGroup(
        groupId: groupId ?? this.groupId,
        name: name ?? this.name,
        memo: memo ?? this.memo,
        security: security ?? this.security,
        hideNewMenuOptionsByDefault:
            hideNewMenuOptionsByDefault ?? this.hideNewMenuOptionsByDefault,
        isMyGroup: isMyGroup ?? this.isMyGroup,
        groupColor: groupColor ?? this.groupColor,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesAdministratorGroupGroup copyWithWrapped(
      {Wrapped<String?>? groupId,
      Wrapped<String?>? name,
      Wrapped<String?>? memo,
      Wrapped<String?>? security,
      Wrapped<bool?>? hideNewMenuOptionsByDefault,
      Wrapped<bool?>? isMyGroup,
      Wrapped<String?>? groupColor,
      Wrapped<String?>? dateStamp,
      Wrapped<String?>? recordTitle,
      Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
          fields,
      Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
      Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
          defaultFieldAttributes}) {
    return WebApiModulesAdministratorGroupGroup(
        groupId: (groupId != null ? groupId.value : this.groupId),
        name: (name != null ? name.value : this.name),
        memo: (memo != null ? memo.value : this.memo),
        security: (security != null ? security.value : this.security),
        hideNewMenuOptionsByDefault: (hideNewMenuOptionsByDefault != null
            ? hideNewMenuOptionsByDefault.value
            : this.hideNewMenuOptionsByDefault),
        isMyGroup: (isMyGroup != null ? isMyGroup.value : this.isMyGroup),
        groupColor: (groupColor != null ? groupColor.value : this.groupColor),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorHotfixHotfix {
  WebApiModulesAdministratorHotfixHotfix({
    this.hotfixId,
    this.fileName,
    this.description,
    this.hotfixBegin,
    this.hotfixEnd,
    this.hotfixSeconds,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAdministratorHotfixHotfix.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorHotfixHotfixFromJson(json);

  @JsonKey(name: 'HotfixId', includeIfNull: false, defaultValue: '')
  final String? hotfixId;
  @JsonKey(name: 'FileName', includeIfNull: false, defaultValue: '')
  final String? fileName;
  @JsonKey(name: 'Description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'HotfixBegin', includeIfNull: false, defaultValue: '')
  final String? hotfixBegin;
  @JsonKey(name: 'HotfixEnd', includeIfNull: false, defaultValue: '')
  final String? hotfixEnd;
  @JsonKey(name: 'HotfixSeconds', includeIfNull: false)
  final double? hotfixSeconds;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorHotfixHotfixFromJson;
  static const toJsonFactory = _$WebApiModulesAdministratorHotfixHotfixToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorHotfixHotfixToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorHotfixHotfix &&
            (identical(other.hotfixId, hotfixId) ||
                const DeepCollectionEquality()
                    .equals(other.hotfixId, hotfixId)) &&
            (identical(other.fileName, fileName) ||
                const DeepCollectionEquality()
                    .equals(other.fileName, fileName)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.hotfixBegin, hotfixBegin) ||
                const DeepCollectionEquality()
                    .equals(other.hotfixBegin, hotfixBegin)) &&
            (identical(other.hotfixEnd, hotfixEnd) ||
                const DeepCollectionEquality()
                    .equals(other.hotfixEnd, hotfixEnd)) &&
            (identical(other.hotfixSeconds, hotfixSeconds) ||
                const DeepCollectionEquality()
                    .equals(other.hotfixSeconds, hotfixSeconds)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(hotfixId) ^
      const DeepCollectionEquality().hash(fileName) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(hotfixBegin) ^
      const DeepCollectionEquality().hash(hotfixEnd) ^
      const DeepCollectionEquality().hash(hotfixSeconds) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorHotfixHotfixExtension
    on WebApiModulesAdministratorHotfixHotfix {
  WebApiModulesAdministratorHotfixHotfix copyWith(
      {String? hotfixId,
      String? fileName,
      String? description,
      String? hotfixBegin,
      String? hotfixEnd,
      double? hotfixSeconds,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAdministratorHotfixHotfix(
        hotfixId: hotfixId ?? this.hotfixId,
        fileName: fileName ?? this.fileName,
        description: description ?? this.description,
        hotfixBegin: hotfixBegin ?? this.hotfixBegin,
        hotfixEnd: hotfixEnd ?? this.hotfixEnd,
        hotfixSeconds: hotfixSeconds ?? this.hotfixSeconds,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesAdministratorHotfixHotfix copyWithWrapped(
      {Wrapped<String?>? hotfixId,
      Wrapped<String?>? fileName,
      Wrapped<String?>? description,
      Wrapped<String?>? hotfixBegin,
      Wrapped<String?>? hotfixEnd,
      Wrapped<double?>? hotfixSeconds,
      Wrapped<String?>? recordTitle,
      Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
          fields,
      Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
      Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
          defaultFieldAttributes}) {
    return WebApiModulesAdministratorHotfixHotfix(
        hotfixId: (hotfixId != null ? hotfixId.value : this.hotfixId),
        fileName: (fileName != null ? fileName.value : this.fileName),
        description:
            (description != null ? description.value : this.description),
        hotfixBegin:
            (hotfixBegin != null ? hotfixBegin.value : this.hotfixBegin),
        hotfixEnd: (hotfixEnd != null ? hotfixEnd.value : this.hotfixEnd),
        hotfixSeconds:
            (hotfixSeconds != null ? hotfixSeconds.value : this.hotfixSeconds),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorPluginPlugin {
  WebApiModulesAdministratorPluginPlugin({
    this.pluginId,
    this.category,
    this.description,
    this.settings,
    this.inactive,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAdministratorPluginPlugin.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorPluginPluginFromJson(json);

  @JsonKey(name: 'PluginId', includeIfNull: false)
  final int? pluginId;
  @JsonKey(name: 'Category', includeIfNull: false, defaultValue: '')
  final String? category;
  @JsonKey(name: 'Description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'Settings', includeIfNull: false, defaultValue: '')
  final String? settings;
  @JsonKey(name: 'Inactive', includeIfNull: false)
  final bool? inactive;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorPluginPluginFromJson;
  static const toJsonFactory = _$WebApiModulesAdministratorPluginPluginToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorPluginPluginToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorPluginPlugin &&
            (identical(other.pluginId, pluginId) ||
                const DeepCollectionEquality()
                    .equals(other.pluginId, pluginId)) &&
            (identical(other.category, category) ||
                const DeepCollectionEquality()
                    .equals(other.category, category)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.settings, settings) ||
                const DeepCollectionEquality()
                    .equals(other.settings, settings)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(pluginId) ^
      const DeepCollectionEquality().hash(category) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(settings) ^
      const DeepCollectionEquality().hash(inactive) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorPluginPluginExtension
    on WebApiModulesAdministratorPluginPlugin {
  WebApiModulesAdministratorPluginPlugin copyWith(
      {int? pluginId,
      String? category,
      String? description,
      String? settings,
      bool? inactive,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAdministratorPluginPlugin(
        pluginId: pluginId ?? this.pluginId,
        category: category ?? this.category,
        description: description ?? this.description,
        settings: settings ?? this.settings,
        inactive: inactive ?? this.inactive,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesAdministratorPluginPlugin copyWithWrapped(
      {Wrapped<int?>? pluginId,
      Wrapped<String?>? category,
      Wrapped<String?>? description,
      Wrapped<String?>? settings,
      Wrapped<bool?>? inactive,
      Wrapped<String?>? recordTitle,
      Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
          fields,
      Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
      Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
          defaultFieldAttributes}) {
    return WebApiModulesAdministratorPluginPlugin(
        pluginId: (pluginId != null ? pluginId.value : this.pluginId),
        category: (category != null ? category.value : this.category),
        description:
            (description != null ? description.value : this.description),
        settings: (settings != null ? settings.value : this.settings),
        inactive: (inactive != null ? inactive.value : this.inactive),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorSystemUpdateApplyUpdateRequest {
  WebApiModulesAdministratorSystemUpdateApplyUpdateRequest({
    this.currentVersion,
    this.toVersion,
  });

  factory WebApiModulesAdministratorSystemUpdateApplyUpdateRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorSystemUpdateApplyUpdateRequestFromJson(json);

  @JsonKey(name: 'CurrentVersion', includeIfNull: false, defaultValue: '')
  final String? currentVersion;
  @JsonKey(name: 'ToVersion', includeIfNull: false, defaultValue: '')
  final String? toVersion;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateApplyUpdateRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateApplyUpdateRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorSystemUpdateApplyUpdateRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorSystemUpdateApplyUpdateRequest &&
            (identical(other.currentVersion, currentVersion) ||
                const DeepCollectionEquality()
                    .equals(other.currentVersion, currentVersion)) &&
            (identical(other.toVersion, toVersion) ||
                const DeepCollectionEquality()
                    .equals(other.toVersion, toVersion)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(currentVersion) ^
      const DeepCollectionEquality().hash(toVersion) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorSystemUpdateApplyUpdateRequestExtension
    on WebApiModulesAdministratorSystemUpdateApplyUpdateRequest {
  WebApiModulesAdministratorSystemUpdateApplyUpdateRequest copyWith(
      {String? currentVersion, String? toVersion}) {
    return WebApiModulesAdministratorSystemUpdateApplyUpdateRequest(
        currentVersion: currentVersion ?? this.currentVersion,
        toVersion: toVersion ?? this.toVersion);
  }

  WebApiModulesAdministratorSystemUpdateApplyUpdateRequest copyWithWrapped(
      {Wrapped<String?>? currentVersion, Wrapped<String?>? toVersion}) {
    return WebApiModulesAdministratorSystemUpdateApplyUpdateRequest(
        currentVersion: (currentVersion != null
            ? currentVersion.value
            : this.currentVersion),
        toVersion: (toVersion != null ? toVersion.value : this.toVersion));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorSystemUpdateApplyUpdateResponse {
  WebApiModulesAdministratorSystemUpdateApplyUpdateResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesAdministratorSystemUpdateApplyUpdateResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorSystemUpdateApplyUpdateResponseFromJson(json);

  @JsonKey(name: 'status', includeIfNull: false)
  final int? status;
  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'msg', includeIfNull: false, defaultValue: '')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateApplyUpdateResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateApplyUpdateResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorSystemUpdateApplyUpdateResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorSystemUpdateApplyUpdateResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(msg) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorSystemUpdateApplyUpdateResponseExtension
    on WebApiModulesAdministratorSystemUpdateApplyUpdateResponse {
  WebApiModulesAdministratorSystemUpdateApplyUpdateResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesAdministratorSystemUpdateApplyUpdateResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }

  WebApiModulesAdministratorSystemUpdateApplyUpdateResponse copyWithWrapped(
      {Wrapped<int?>? status, Wrapped<bool?>? success, Wrapped<String?>? msg}) {
    return WebApiModulesAdministratorSystemUpdateApplyUpdateResponse(
        status: (status != null ? status.value : this.status),
        success: (success != null ? success.value : this.success),
        msg: (msg != null ? msg.value : this.msg));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorSystemUpdateAvailableVersion {
  WebApiModulesAdministratorSystemUpdateAvailableVersion({
    this.value,
    this.text,
    this.version,
    this.versionDate,
  });

  factory WebApiModulesAdministratorSystemUpdateAvailableVersion.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorSystemUpdateAvailableVersionFromJson(json);

  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String? value;
  @JsonKey(name: 'text', includeIfNull: false, defaultValue: '')
  final String? text;
  @JsonKey(name: 'Version', includeIfNull: false, defaultValue: '')
  final String? version;
  @JsonKey(name: 'VersionDate', includeIfNull: false)
  final DateTime? versionDate;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateAvailableVersionFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateAvailableVersionToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorSystemUpdateAvailableVersionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorSystemUpdateAvailableVersion &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)) &&
            (identical(other.text, text) ||
                const DeepCollectionEquality().equals(other.text, text)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.versionDate, versionDate) ||
                const DeepCollectionEquality()
                    .equals(other.versionDate, versionDate)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(value) ^
      const DeepCollectionEquality().hash(text) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(versionDate) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorSystemUpdateAvailableVersionExtension
    on WebApiModulesAdministratorSystemUpdateAvailableVersion {
  WebApiModulesAdministratorSystemUpdateAvailableVersion copyWith(
      {String? value, String? text, String? version, DateTime? versionDate}) {
    return WebApiModulesAdministratorSystemUpdateAvailableVersion(
        value: value ?? this.value,
        text: text ?? this.text,
        version: version ?? this.version,
        versionDate: versionDate ?? this.versionDate);
  }

  WebApiModulesAdministratorSystemUpdateAvailableVersion copyWithWrapped(
      {Wrapped<String?>? value,
      Wrapped<String?>? text,
      Wrapped<String?>? version,
      Wrapped<DateTime?>? versionDate}) {
    return WebApiModulesAdministratorSystemUpdateAvailableVersion(
        value: (value != null ? value.value : this.value),
        text: (text != null ? text.value : this.text),
        version: (version != null ? version.value : this.version),
        versionDate:
            (versionDate != null ? versionDate.value : this.versionDate));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorSystemUpdateAvailableVersionsRequest {
  WebApiModulesAdministratorSystemUpdateAvailableVersionsRequest({
    this.currentVersion,
    this.onlyIncludeNewerVersions,
  });

  factory WebApiModulesAdministratorSystemUpdateAvailableVersionsRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorSystemUpdateAvailableVersionsRequestFromJson(
          json);

  @JsonKey(name: 'CurrentVersion', includeIfNull: false, defaultValue: '')
  final String? currentVersion;
  @JsonKey(name: 'OnlyIncludeNewerVersions', includeIfNull: false)
  final bool? onlyIncludeNewerVersions;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateAvailableVersionsRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateAvailableVersionsRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorSystemUpdateAvailableVersionsRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorSystemUpdateAvailableVersionsRequest &&
            (identical(other.currentVersion, currentVersion) ||
                const DeepCollectionEquality()
                    .equals(other.currentVersion, currentVersion)) &&
            (identical(
                    other.onlyIncludeNewerVersions, onlyIncludeNewerVersions) ||
                const DeepCollectionEquality().equals(
                    other.onlyIncludeNewerVersions, onlyIncludeNewerVersions)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(currentVersion) ^
      const DeepCollectionEquality().hash(onlyIncludeNewerVersions) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorSystemUpdateAvailableVersionsRequestExtension
    on WebApiModulesAdministratorSystemUpdateAvailableVersionsRequest {
  WebApiModulesAdministratorSystemUpdateAvailableVersionsRequest copyWith(
      {String? currentVersion, bool? onlyIncludeNewerVersions}) {
    return WebApiModulesAdministratorSystemUpdateAvailableVersionsRequest(
        currentVersion: currentVersion ?? this.currentVersion,
        onlyIncludeNewerVersions:
            onlyIncludeNewerVersions ?? this.onlyIncludeNewerVersions);
  }

  WebApiModulesAdministratorSystemUpdateAvailableVersionsRequest
      copyWithWrapped(
          {Wrapped<String?>? currentVersion,
          Wrapped<bool?>? onlyIncludeNewerVersions}) {
    return WebApiModulesAdministratorSystemUpdateAvailableVersionsRequest(
        currentVersion: (currentVersion != null
            ? currentVersion.value
            : this.currentVersion),
        onlyIncludeNewerVersions: (onlyIncludeNewerVersions != null
            ? onlyIncludeNewerVersions.value
            : this.onlyIncludeNewerVersions));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorSystemUpdateAvailableVersionsResponse {
  WebApiModulesAdministratorSystemUpdateAvailableVersionsResponse({
    this.status,
    this.success,
    this.msg,
    this.versions,
  });

  factory WebApiModulesAdministratorSystemUpdateAvailableVersionsResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorSystemUpdateAvailableVersionsResponseFromJson(
          json);

  @JsonKey(name: 'status', includeIfNull: false)
  final int? status;
  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'msg', includeIfNull: false, defaultValue: '')
  final String? msg;
  @JsonKey(
      name: 'Versions',
      includeIfNull: false,
      defaultValue: <WebApiModulesAdministratorSystemUpdateAvailableVersion>[])
  final List<WebApiModulesAdministratorSystemUpdateAvailableVersion>? versions;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateAvailableVersionsResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateAvailableVersionsResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorSystemUpdateAvailableVersionsResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorSystemUpdateAvailableVersionsResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.versions, versions) ||
                const DeepCollectionEquality()
                    .equals(other.versions, versions)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(msg) ^
      const DeepCollectionEquality().hash(versions) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorSystemUpdateAvailableVersionsResponseExtension
    on WebApiModulesAdministratorSystemUpdateAvailableVersionsResponse {
  WebApiModulesAdministratorSystemUpdateAvailableVersionsResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      List<WebApiModulesAdministratorSystemUpdateAvailableVersion>? versions}) {
    return WebApiModulesAdministratorSystemUpdateAvailableVersionsResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        versions: versions ?? this.versions);
  }

  WebApiModulesAdministratorSystemUpdateAvailableVersionsResponse
      copyWithWrapped(
          {Wrapped<int?>? status,
          Wrapped<bool?>? success,
          Wrapped<String?>? msg,
          Wrapped<
                  List<
                      WebApiModulesAdministratorSystemUpdateAvailableVersion>?>?
              versions}) {
    return WebApiModulesAdministratorSystemUpdateAvailableVersionsResponse(
        status: (status != null ? status.value : this.status),
        success: (success != null ? success.value : this.success),
        msg: (msg != null ? msg.value : this.msg),
        versions: (versions != null ? versions.value : this.versions));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorSystemUpdateBuildDocument {
  WebApiModulesAdministratorSystemUpdateBuildDocument({
    this.buildNumber,
    this.buildDate,
  });

  factory WebApiModulesAdministratorSystemUpdateBuildDocument.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorSystemUpdateBuildDocumentFromJson(json);

  @JsonKey(name: 'BuildNumber', includeIfNull: false, defaultValue: '')
  final String? buildNumber;
  @JsonKey(name: 'BuildDate', includeIfNull: false)
  final DateTime? buildDate;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateBuildDocumentFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateBuildDocumentToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorSystemUpdateBuildDocumentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorSystemUpdateBuildDocument &&
            (identical(other.buildNumber, buildNumber) ||
                const DeepCollectionEquality()
                    .equals(other.buildNumber, buildNumber)) &&
            (identical(other.buildDate, buildDate) ||
                const DeepCollectionEquality()
                    .equals(other.buildDate, buildDate)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(buildNumber) ^
      const DeepCollectionEquality().hash(buildDate) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorSystemUpdateBuildDocumentExtension
    on WebApiModulesAdministratorSystemUpdateBuildDocument {
  WebApiModulesAdministratorSystemUpdateBuildDocument copyWith(
      {String? buildNumber, DateTime? buildDate}) {
    return WebApiModulesAdministratorSystemUpdateBuildDocument(
        buildNumber: buildNumber ?? this.buildNumber,
        buildDate: buildDate ?? this.buildDate);
  }

  WebApiModulesAdministratorSystemUpdateBuildDocument copyWithWrapped(
      {Wrapped<String?>? buildNumber, Wrapped<DateTime?>? buildDate}) {
    return WebApiModulesAdministratorSystemUpdateBuildDocument(
        buildNumber:
            (buildNumber != null ? buildNumber.value : this.buildNumber),
        buildDate: (buildDate != null ? buildDate.value : this.buildDate));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorSystemUpdateBuildDocumentsRequest {
  WebApiModulesAdministratorSystemUpdateBuildDocumentsRequest({
    this.currentVersion,
    this.onlyIncludeNewerVersions,
  });

  factory WebApiModulesAdministratorSystemUpdateBuildDocumentsRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorSystemUpdateBuildDocumentsRequestFromJson(
          json);

  @JsonKey(name: 'CurrentVersion', includeIfNull: false, defaultValue: '')
  final String? currentVersion;
  @JsonKey(name: 'OnlyIncludeNewerVersions', includeIfNull: false)
  final bool? onlyIncludeNewerVersions;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateBuildDocumentsRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateBuildDocumentsRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorSystemUpdateBuildDocumentsRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorSystemUpdateBuildDocumentsRequest &&
            (identical(other.currentVersion, currentVersion) ||
                const DeepCollectionEquality()
                    .equals(other.currentVersion, currentVersion)) &&
            (identical(
                    other.onlyIncludeNewerVersions, onlyIncludeNewerVersions) ||
                const DeepCollectionEquality().equals(
                    other.onlyIncludeNewerVersions, onlyIncludeNewerVersions)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(currentVersion) ^
      const DeepCollectionEquality().hash(onlyIncludeNewerVersions) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorSystemUpdateBuildDocumentsRequestExtension
    on WebApiModulesAdministratorSystemUpdateBuildDocumentsRequest {
  WebApiModulesAdministratorSystemUpdateBuildDocumentsRequest copyWith(
      {String? currentVersion, bool? onlyIncludeNewerVersions}) {
    return WebApiModulesAdministratorSystemUpdateBuildDocumentsRequest(
        currentVersion: currentVersion ?? this.currentVersion,
        onlyIncludeNewerVersions:
            onlyIncludeNewerVersions ?? this.onlyIncludeNewerVersions);
  }

  WebApiModulesAdministratorSystemUpdateBuildDocumentsRequest copyWithWrapped(
      {Wrapped<String?>? currentVersion,
      Wrapped<bool?>? onlyIncludeNewerVersions}) {
    return WebApiModulesAdministratorSystemUpdateBuildDocumentsRequest(
        currentVersion: (currentVersion != null
            ? currentVersion.value
            : this.currentVersion),
        onlyIncludeNewerVersions: (onlyIncludeNewerVersions != null
            ? onlyIncludeNewerVersions.value
            : this.onlyIncludeNewerVersions));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorSystemUpdateBuildDocumentsResponse {
  WebApiModulesAdministratorSystemUpdateBuildDocumentsResponse({
    this.status,
    this.success,
    this.msg,
    this.documentsList,
    this.documents,
  });

  factory WebApiModulesAdministratorSystemUpdateBuildDocumentsResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorSystemUpdateBuildDocumentsResponseFromJson(
          json);

  @JsonKey(name: 'status', includeIfNull: false)
  final int? status;
  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'msg', includeIfNull: false, defaultValue: '')
  final String? msg;
  @JsonKey(
      name: 'DocumentsList', includeIfNull: false, defaultValue: <String>[])
  final List<String>? documentsList;
  @JsonKey(
      name: 'Documents',
      includeIfNull: false,
      defaultValue: <WebApiModulesAdministratorSystemUpdateBuildDocument>[])
  final List<WebApiModulesAdministratorSystemUpdateBuildDocument>? documents;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateBuildDocumentsResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateBuildDocumentsResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorSystemUpdateBuildDocumentsResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorSystemUpdateBuildDocumentsResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.documentsList, documentsList) ||
                const DeepCollectionEquality()
                    .equals(other.documentsList, documentsList)) &&
            (identical(other.documents, documents) ||
                const DeepCollectionEquality()
                    .equals(other.documents, documents)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(msg) ^
      const DeepCollectionEquality().hash(documentsList) ^
      const DeepCollectionEquality().hash(documents) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorSystemUpdateBuildDocumentsResponseExtension
    on WebApiModulesAdministratorSystemUpdateBuildDocumentsResponse {
  WebApiModulesAdministratorSystemUpdateBuildDocumentsResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      List<String>? documentsList,
      List<WebApiModulesAdministratorSystemUpdateBuildDocument>? documents}) {
    return WebApiModulesAdministratorSystemUpdateBuildDocumentsResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        documentsList: documentsList ?? this.documentsList,
        documents: documents ?? this.documents);
  }

  WebApiModulesAdministratorSystemUpdateBuildDocumentsResponse copyWithWrapped(
      {Wrapped<int?>? status,
      Wrapped<bool?>? success,
      Wrapped<String?>? msg,
      Wrapped<List<String>?>? documentsList,
      Wrapped<List<WebApiModulesAdministratorSystemUpdateBuildDocument>?>?
          documents}) {
    return WebApiModulesAdministratorSystemUpdateBuildDocumentsResponse(
        status: (status != null ? status.value : this.status),
        success: (success != null ? success.value : this.success),
        msg: (msg != null ? msg.value : this.msg),
        documentsList:
            (documentsList != null ? documentsList.value : this.documentsList),
        documents: (documents != null ? documents.value : this.documents));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentRequest {
  WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentRequest({
    this.version,
  });

  factory WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentRequestFromJson(
          json);

  @JsonKey(name: 'Version', includeIfNull: false, defaultValue: '')
  final String? version;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentRequest &&
            (identical(other.version, version) ||
                const DeepCollectionEquality().equals(other.version, version)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(version) ^ runtimeType.hashCode;
}

extension $WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentRequestExtension
    on WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentRequest {
  WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentRequest copyWith(
      {String? version}) {
    return WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentRequest(
        version: version ?? this.version);
  }

  WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentRequest
      copyWithWrapped({Wrapped<String?>? version}) {
    return WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentRequest(
        version: (version != null ? version.value : this.version));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponse {
  WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponse({
    this.status,
    this.success,
    this.msg,
    this.downloadUrl,
  });

  factory WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponseFromJson(
          json);

  @JsonKey(name: 'status', includeIfNull: false)
  final int? status;
  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'msg', includeIfNull: false, defaultValue: '')
  final String? msg;
  @JsonKey(name: 'downloadUrl', includeIfNull: false, defaultValue: '')
  final String? downloadUrl;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.downloadUrl, downloadUrl) ||
                const DeepCollectionEquality()
                    .equals(other.downloadUrl, downloadUrl)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(msg) ^
      const DeepCollectionEquality().hash(downloadUrl) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponseExtension
    on WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponse {
  WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponse copyWith(
      {int? status, bool? success, String? msg, String? downloadUrl}) {
    return WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        downloadUrl: downloadUrl ?? this.downloadUrl);
  }

  WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponse
      copyWithWrapped(
          {Wrapped<int?>? status,
          Wrapped<bool?>? success,
          Wrapped<String?>? msg,
          Wrapped<String?>? downloadUrl}) {
    return WebApiModulesAdministratorSystemUpdateDownloadBuildDocumentResponse(
        status: (status != null ? status.value : this.status),
        success: (success != null ? success.value : this.success),
        msg: (msg != null ? msg.value : this.msg),
        downloadUrl:
            (downloadUrl != null ? downloadUrl.value : this.downloadUrl));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorSystemUpdateGetVersionHotfixRequest {
  WebApiModulesAdministratorSystemUpdateGetVersionHotfixRequest({
    this.version,
  });

  factory WebApiModulesAdministratorSystemUpdateGetVersionHotfixRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorSystemUpdateGetVersionHotfixRequestFromJson(
          json);

  @JsonKey(name: 'Version', includeIfNull: false, defaultValue: '')
  final String? version;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateGetVersionHotfixRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateGetVersionHotfixRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorSystemUpdateGetVersionHotfixRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorSystemUpdateGetVersionHotfixRequest &&
            (identical(other.version, version) ||
                const DeepCollectionEquality().equals(other.version, version)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(version) ^ runtimeType.hashCode;
}

extension $WebApiModulesAdministratorSystemUpdateGetVersionHotfixRequestExtension
    on WebApiModulesAdministratorSystemUpdateGetVersionHotfixRequest {
  WebApiModulesAdministratorSystemUpdateGetVersionHotfixRequest copyWith(
      {String? version}) {
    return WebApiModulesAdministratorSystemUpdateGetVersionHotfixRequest(
        version: version ?? this.version);
  }

  WebApiModulesAdministratorSystemUpdateGetVersionHotfixRequest copyWithWrapped(
      {Wrapped<String?>? version}) {
    return WebApiModulesAdministratorSystemUpdateGetVersionHotfixRequest(
        version: (version != null ? version.value : this.version));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponse {
  WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponse({
    this.status,
    this.success,
    this.msg,
    this.hotfix,
  });

  factory WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponseFromJson(
          json);

  @JsonKey(name: 'status', includeIfNull: false)
  final int? status;
  @JsonKey(name: 'success', includeIfNull: false)
  final bool? success;
  @JsonKey(name: 'msg', includeIfNull: false, defaultValue: '')
  final String? msg;
  @JsonKey(name: 'Hotfix', includeIfNull: false, defaultValue: '')
  final String? hotfix;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.hotfix, hotfix) ||
                const DeepCollectionEquality().equals(other.hotfix, hotfix)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(success) ^
      const DeepCollectionEquality().hash(msg) ^
      const DeepCollectionEquality().hash(hotfix) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponseExtension
    on WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponse {
  WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponse copyWith(
      {int? status, bool? success, String? msg, String? hotfix}) {
    return WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        hotfix: hotfix ?? this.hotfix);
  }

  WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponse
      copyWithWrapped(
          {Wrapped<int?>? status,
          Wrapped<bool?>? success,
          Wrapped<String?>? msg,
          Wrapped<String?>? hotfix}) {
    return WebApiModulesAdministratorSystemUpdateGetVersionHotfixResponse(
        status: (status != null ? status.value : this.status),
        success: (success != null ? success.value : this.success),
        msg: (msg != null ? msg.value : this.msg),
        hotfix: (hotfix != null ? hotfix.value : this.hotfix));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory {
  WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory({
    this.systemUpdateHistoryId,
    this.usersId,
    this.userName,
    this.updateDateTime,
    this.fromVersion,
    this.toVersion,
    this.errorMessage,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryFromJson(
          json);

  @JsonKey(name: 'SystemUpdateHistoryId', includeIfNull: false)
  final int? systemUpdateHistoryId;
  @JsonKey(name: 'UsersId', includeIfNull: false, defaultValue: '')
  final String? usersId;
  @JsonKey(name: 'UserName', includeIfNull: false, defaultValue: '')
  final String? userName;
  @JsonKey(name: 'UpdateDateTime', includeIfNull: false)
  final DateTime? updateDateTime;
  @JsonKey(name: 'FromVersion', includeIfNull: false, defaultValue: '')
  final String? fromVersion;
  @JsonKey(name: 'ToVersion', includeIfNull: false, defaultValue: '')
  final String? toVersion;
  @JsonKey(name: 'ErrorMessage', includeIfNull: false, defaultValue: '')
  final String? errorMessage;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory &&
            (identical(other.systemUpdateHistoryId, systemUpdateHistoryId) ||
                const DeepCollectionEquality().equals(
                    other.systemUpdateHistoryId, systemUpdateHistoryId)) &&
            (identical(other.usersId, usersId) ||
                const DeepCollectionEquality()
                    .equals(other.usersId, usersId)) &&
            (identical(other.userName, userName) ||
                const DeepCollectionEquality()
                    .equals(other.userName, userName)) &&
            (identical(other.updateDateTime, updateDateTime) ||
                const DeepCollectionEquality()
                    .equals(other.updateDateTime, updateDateTime)) &&
            (identical(other.fromVersion, fromVersion) ||
                const DeepCollectionEquality()
                    .equals(other.fromVersion, fromVersion)) &&
            (identical(other.toVersion, toVersion) ||
                const DeepCollectionEquality()
                    .equals(other.toVersion, toVersion)) &&
            (identical(other.errorMessage, errorMessage) ||
                const DeepCollectionEquality()
                    .equals(other.errorMessage, errorMessage)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(systemUpdateHistoryId) ^
      const DeepCollectionEquality().hash(usersId) ^
      const DeepCollectionEquality().hash(userName) ^
      const DeepCollectionEquality().hash(updateDateTime) ^
      const DeepCollectionEquality().hash(fromVersion) ^
      const DeepCollectionEquality().hash(toVersion) ^
      const DeepCollectionEquality().hash(errorMessage) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistoryExtension
    on WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory {
  WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory copyWith(
      {int? systemUpdateHistoryId,
      String? usersId,
      String? userName,
      DateTime? updateDateTime,
      String? fromVersion,
      String? toVersion,
      String? errorMessage,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory(
        systemUpdateHistoryId:
            systemUpdateHistoryId ?? this.systemUpdateHistoryId,
        usersId: usersId ?? this.usersId,
        userName: userName ?? this.userName,
        updateDateTime: updateDateTime ?? this.updateDateTime,
        fromVersion: fromVersion ?? this.fromVersion,
        toVersion: toVersion ?? this.toVersion,
        errorMessage: errorMessage ?? this.errorMessage,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory
      copyWithWrapped(
          {Wrapped<int?>? systemUpdateHistoryId,
          Wrapped<String?>? usersId,
          Wrapped<String?>? userName,
          Wrapped<DateTime?>? updateDateTime,
          Wrapped<String?>? fromVersion,
          Wrapped<String?>? toVersion,
          Wrapped<String?>? errorMessage,
          Wrapped<String?>? dateStamp,
          Wrapped<String?>? recordTitle,
          Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
              fields,
          Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
          Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
              defaultFieldAttributes}) {
    return WebApiModulesAdministratorSystemUpdateHistorySystemUpdateHistory(
        systemUpdateHistoryId: (systemUpdateHistoryId != null
            ? systemUpdateHistoryId.value
            : this.systemUpdateHistoryId),
        usersId: (usersId != null ? usersId.value : this.usersId),
        userName: (userName != null ? userName.value : this.userName),
        updateDateTime: (updateDateTime != null
            ? updateDateTime.value
            : this.updateDateTime),
        fromVersion:
            (fromVersion != null ? fromVersion.value : this.fromVersion),
        toVersion: (toVersion != null ? toVersion.value : this.toVersion),
        errorMessage:
            (errorMessage != null ? errorMessage.value : this.errorMessage),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLog {
  WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLog({
    this.systemUpdateHistoryLogId,
    this.systemUpdateHistoryId,
    this.messsage,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLog.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogFromJson(
          json);

  @JsonKey(name: 'SystemUpdateHistoryLogId', includeIfNull: false)
  final int? systemUpdateHistoryLogId;
  @JsonKey(name: 'SystemUpdateHistoryId', includeIfNull: false)
  final int? systemUpdateHistoryId;
  @JsonKey(name: 'Messsage', includeIfNull: false, defaultValue: '')
  final String? messsage;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLog &&
            (identical(
                    other.systemUpdateHistoryLogId, systemUpdateHistoryLogId) ||
                const DeepCollectionEquality().equals(
                    other.systemUpdateHistoryLogId,
                    systemUpdateHistoryLogId)) &&
            (identical(other.systemUpdateHistoryId, systemUpdateHistoryId) ||
                const DeepCollectionEquality().equals(
                    other.systemUpdateHistoryId, systemUpdateHistoryId)) &&
            (identical(other.messsage, messsage) ||
                const DeepCollectionEquality()
                    .equals(other.messsage, messsage)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(systemUpdateHistoryLogId) ^
      const DeepCollectionEquality().hash(systemUpdateHistoryId) ^
      const DeepCollectionEquality().hash(messsage) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLogExtension
    on WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLog {
  WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLog
      copyWith(
          {int? systemUpdateHistoryLogId,
          int? systemUpdateHistoryId,
          String? messsage,
          String? dateStamp,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLog(
        systemUpdateHistoryLogId:
            systemUpdateHistoryLogId ?? this.systemUpdateHistoryLogId,
        systemUpdateHistoryId:
            systemUpdateHistoryId ?? this.systemUpdateHistoryId,
        messsage: messsage ?? this.messsage,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLog
      copyWithWrapped(
          {Wrapped<int?>? systemUpdateHistoryLogId,
          Wrapped<int?>? systemUpdateHistoryId,
          Wrapped<String?>? messsage,
          Wrapped<String?>? dateStamp,
          Wrapped<String?>? recordTitle,
          Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
              fields,
          Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
          Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
              defaultFieldAttributes}) {
    return WebApiModulesAdministratorSystemUpdateHistoryLogSystemUpdateHistoryLog(
        systemUpdateHistoryLogId: (systemUpdateHistoryLogId != null
            ? systemUpdateHistoryLogId.value
            : this.systemUpdateHistoryLogId),
        systemUpdateHistoryId: (systemUpdateHistoryId != null
            ? systemUpdateHistoryId.value
            : this.systemUpdateHistoryId),
        messsage: (messsage != null ? messsage.value : this.messsage),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorUserUser {
  WebApiModulesAdministratorUserUser({
    this.userId,
    this.name,
    this.loginName,
    this.fullName,
    this.firstName,
    this.middleInitial,
    this.lastName,
    this.password,
    this.passwordChanged,
    this.barCode,
    this.groupId,
    this.groupName,
    this.scheduleColor,
    this.userTitleId,
    this.userTitle,
    this.email,
    this.officeLocationId,
    this.officeLocation,
    this.warehouseId,
    this.warehouse,
    this.address1,
    this.address2,
    this.city,
    this.state,
    this.zipCode,
    this.countryId,
    this.country,
    this.officePhone,
    this.officeExtension,
    this.fax,
    this.directPhone,
    this.pager,
    this.pagerPin,
    this.cellular,
    this.homePhone,
    this.defaultDepartmentType,
    this.primaryDepartmentId,
    this.primaryDepartment,
    this.rentalDepartmentId,
    this.rentalDepartment,
    this.salesDepartmentId,
    this.salesDepartment,
    this.partsDepartmentId,
    this.partsDepartment,
    this.miscDepartmentId,
    this.miscDepartment,
    this.laborDepartmentId,
    this.laborDepartment,
    this.facilityDepartmentId,
    this.facilityDepartment,
    this.transportationDepartmentId,
    this.transportationDepartment,
    this.rentalInventoryTypeId,
    this.rentalInventoryType,
    this.salesInventoryTypeId,
    this.salesInventoryType,
    this.partsInventoryTypeId,
    this.partsInventoryType,
    this.miscTypeId,
    this.miscType,
    this.laborTypeId,
    this.laborType,
    this.facilityTypeId,
    this.facilityType,
    this.transportationTypeId,
    this.transportationType,
    this.noMiscellaneousOnQuotes,
    this.noMiscellaneousOnOrders,
    this.noMiscellaneousOnPurchaseOrders,
    this.limitDaysPerWeek,
    this.minimumDaysPerWeek,
    this.allowCreditLimitOverride,
    this.limitDiscount,
    this.maximumDiscount,
    this.limitSubDiscount,
    this.maximumSubDiscount,
    this.discountRule,
    this.stagingAllowIncreaseDecreaseOrderQuantity,
    this.allowStagingOfItemsWhenReservedOnOtherOrdersQuotes,
    this.allowContractIfDealRequiresPOAndOrderHasPendingPO,
    this.allowContractIfPendingItemsExist,
    this.allowContractIfCustomerDealDoesNotHaveApprovedCredit,
    this.allowContractIfCustomerDealIsOverTheirCreditLimit,
    this.allowContractIfCustomerDealInsuranceCoverageIsLess,
    this.allowContractIfCustomerDealDoesNotHaveValidInsuranceCertificate,
    this.allowContractIfCustomerDealDoesNotHaveValidNonTaxCertificate,
    this.allowReceiveSubsWhenPositiveConflictExists,
    this.allowStagingOfUnreservedConsignedItems,
    this.allowStagingOfUnapprovedItems,
    this.allowSubstitutesAtStaging,
    this.deleteOriginalOnSubstitution,
    this.quikActivityAllowPrintDollarAmounts,
    this.quikScanAllowCreateContract,
    this.quikScanAllowApplyAll,
    this.allowCrossICodeExchange,
    this.allowCrossICodePendingExchange,
    this.allowChangeAvailabilityPriority,
    this.userMustChangePassword,
    this.passwordExpires,
    this.passwordExpireDays,
    this.passwordUpdatedDateTime,
    this.accountLocked,
    this.memo,
    this.allowCrossLocationEditAndDelete,
    this.lastLoggedOn,
    this.inactive,
    this.dateStamp,
    this.webUserId,
    this.webAccess,
    this.webAdministrator,
    this.browseDefaultRows,
    this.applicationTheme,
    this.homeMenuGuid,
    this.homeMenuPath,
    this.successSoundId,
    this.successSound,
    this.successBase64Sound,
    this.errorSoundId,
    this.errorSound,
    this.errorBase64Sound,
    this.notificationSoundId,
    this.notificationSound,
    this.notificationBase64Sound,
    this.firstDayOfWeek,
    this.settingsNavigationMenuVisible,
    this.reportsNavigationMenuVisible,
    this.webQuoteRequest,
    this.emailSignature,
    this.locale,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAdministratorUserUser.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorUserUserFromJson(json);

  @JsonKey(name: 'UserId', includeIfNull: false, defaultValue: '')
  final String? userId;
  @JsonKey(name: 'Name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'LoginName', includeIfNull: false, defaultValue: '')
  final String? loginName;
  @JsonKey(name: 'FullName', includeIfNull: false, defaultValue: '')
  final String? fullName;
  @JsonKey(name: 'FirstName', includeIfNull: false, defaultValue: '')
  final String? firstName;
  @JsonKey(name: 'MiddleInitial', includeIfNull: false, defaultValue: '')
  final String? middleInitial;
  @JsonKey(name: 'LastName', includeIfNull: false, defaultValue: '')
  final String? lastName;
  @JsonKey(name: 'Password', includeIfNull: false, defaultValue: '')
  final String? password;
  @JsonKey(name: 'PasswordChanged', includeIfNull: false)
  final bool? passwordChanged;
  @JsonKey(name: 'BarCode', includeIfNull: false, defaultValue: '')
  final String? barCode;
  @JsonKey(name: 'GroupId', includeIfNull: false, defaultValue: '')
  final String? groupId;
  @JsonKey(name: 'GroupName', includeIfNull: false, defaultValue: '')
  final String? groupName;
  @JsonKey(name: 'ScheduleColor', includeIfNull: false, defaultValue: '')
  final String? scheduleColor;
  @JsonKey(name: 'UserTitleId', includeIfNull: false, defaultValue: '')
  final String? userTitleId;
  @JsonKey(name: 'UserTitle', includeIfNull: false, defaultValue: '')
  final String? userTitle;
  @JsonKey(name: 'Email', includeIfNull: false, defaultValue: '')
  final String? email;
  @JsonKey(name: 'OfficeLocationId', includeIfNull: false, defaultValue: '')
  final String? officeLocationId;
  @JsonKey(name: 'OfficeLocation', includeIfNull: false, defaultValue: '')
  final String? officeLocation;
  @JsonKey(name: 'WarehouseId', includeIfNull: false, defaultValue: '')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse', includeIfNull: false, defaultValue: '')
  final String? warehouse;
  @JsonKey(name: 'Address1', includeIfNull: false, defaultValue: '')
  final String? address1;
  @JsonKey(name: 'Address2', includeIfNull: false, defaultValue: '')
  final String? address2;
  @JsonKey(name: 'City', includeIfNull: false, defaultValue: '')
  final String? city;
  @JsonKey(name: 'State', includeIfNull: false, defaultValue: '')
  final String? state;
  @JsonKey(name: 'ZipCode', includeIfNull: false, defaultValue: '')
  final String? zipCode;
  @JsonKey(name: 'CountryId', includeIfNull: false, defaultValue: '')
  final String? countryId;
  @JsonKey(name: 'Country', includeIfNull: false, defaultValue: '')
  final String? country;
  @JsonKey(name: 'OfficePhone', includeIfNull: false, defaultValue: '')
  final String? officePhone;
  @JsonKey(name: 'OfficeExtension', includeIfNull: false, defaultValue: '')
  final String? officeExtension;
  @JsonKey(name: 'Fax', includeIfNull: false, defaultValue: '')
  final String? fax;
  @JsonKey(name: 'DirectPhone', includeIfNull: false, defaultValue: '')
  final String? directPhone;
  @JsonKey(name: 'Pager', includeIfNull: false, defaultValue: '')
  final String? pager;
  @JsonKey(name: 'PagerPin', includeIfNull: false, defaultValue: '')
  final String? pagerPin;
  @JsonKey(name: 'Cellular', includeIfNull: false, defaultValue: '')
  final String? cellular;
  @JsonKey(name: 'HomePhone', includeIfNull: false, defaultValue: '')
  final String? homePhone;
  @JsonKey(
      name: 'DefaultDepartmentType', includeIfNull: false, defaultValue: '')
  final String? defaultDepartmentType;
  @JsonKey(name: 'PrimaryDepartmentId', includeIfNull: false, defaultValue: '')
  final String? primaryDepartmentId;
  @JsonKey(name: 'PrimaryDepartment', includeIfNull: false, defaultValue: '')
  final String? primaryDepartment;
  @JsonKey(name: 'RentalDepartmentId', includeIfNull: false, defaultValue: '')
  final String? rentalDepartmentId;
  @JsonKey(name: 'RentalDepartment', includeIfNull: false, defaultValue: '')
  final String? rentalDepartment;
  @JsonKey(name: 'SalesDepartmentId', includeIfNull: false, defaultValue: '')
  final String? salesDepartmentId;
  @JsonKey(name: 'SalesDepartment', includeIfNull: false, defaultValue: '')
  final String? salesDepartment;
  @JsonKey(name: 'PartsDepartmentId', includeIfNull: false, defaultValue: '')
  final String? partsDepartmentId;
  @JsonKey(name: 'PartsDepartment', includeIfNull: false, defaultValue: '')
  final String? partsDepartment;
  @JsonKey(name: 'MiscDepartmentId', includeIfNull: false, defaultValue: '')
  final String? miscDepartmentId;
  @JsonKey(name: 'MiscDepartment', includeIfNull: false, defaultValue: '')
  final String? miscDepartment;
  @JsonKey(name: 'LaborDepartmentId', includeIfNull: false, defaultValue: '')
  final String? laborDepartmentId;
  @JsonKey(name: 'LaborDepartment', includeIfNull: false, defaultValue: '')
  final String? laborDepartment;
  @JsonKey(name: 'FacilityDepartmentId', includeIfNull: false, defaultValue: '')
  final String? facilityDepartmentId;
  @JsonKey(name: 'FacilityDepartment', includeIfNull: false, defaultValue: '')
  final String? facilityDepartment;
  @JsonKey(
      name: 'TransportationDepartmentId',
      includeIfNull: false,
      defaultValue: '')
  final String? transportationDepartmentId;
  @JsonKey(
      name: 'TransportationDepartment', includeIfNull: false, defaultValue: '')
  final String? transportationDepartment;
  @JsonKey(
      name: 'RentalInventoryTypeId', includeIfNull: false, defaultValue: '')
  final String? rentalInventoryTypeId;
  @JsonKey(name: 'RentalInventoryType', includeIfNull: false, defaultValue: '')
  final String? rentalInventoryType;
  @JsonKey(name: 'SalesInventoryTypeId', includeIfNull: false, defaultValue: '')
  final String? salesInventoryTypeId;
  @JsonKey(name: 'SalesInventoryType', includeIfNull: false, defaultValue: '')
  final String? salesInventoryType;
  @JsonKey(name: 'PartsInventoryTypeId', includeIfNull: false, defaultValue: '')
  final String? partsInventoryTypeId;
  @JsonKey(name: 'PartsInventoryType', includeIfNull: false, defaultValue: '')
  final String? partsInventoryType;
  @JsonKey(name: 'MiscTypeId', includeIfNull: false, defaultValue: '')
  final String? miscTypeId;
  @JsonKey(name: 'MiscType', includeIfNull: false, defaultValue: '')
  final String? miscType;
  @JsonKey(name: 'LaborTypeId', includeIfNull: false, defaultValue: '')
  final String? laborTypeId;
  @JsonKey(name: 'LaborType', includeIfNull: false, defaultValue: '')
  final String? laborType;
  @JsonKey(name: 'FacilityTypeId', includeIfNull: false, defaultValue: '')
  final String? facilityTypeId;
  @JsonKey(name: 'FacilityType', includeIfNull: false, defaultValue: '')
  final String? facilityType;
  @JsonKey(name: 'TransportationTypeId', includeIfNull: false, defaultValue: '')
  final String? transportationTypeId;
  @JsonKey(name: 'TransportationType', includeIfNull: false, defaultValue: '')
  final String? transportationType;
  @JsonKey(name: 'NoMiscellaneousOnQuotes', includeIfNull: false)
  final bool? noMiscellaneousOnQuotes;
  @JsonKey(name: 'NoMiscellaneousOnOrders', includeIfNull: false)
  final bool? noMiscellaneousOnOrders;
  @JsonKey(name: 'NoMiscellaneousOnPurchaseOrders', includeIfNull: false)
  final bool? noMiscellaneousOnPurchaseOrders;
  @JsonKey(name: 'LimitDaysPerWeek', includeIfNull: false)
  final bool? limitDaysPerWeek;
  @JsonKey(name: 'MinimumDaysPerWeek', includeIfNull: false)
  final double? minimumDaysPerWeek;
  @JsonKey(name: 'AllowCreditLimitOverride', includeIfNull: false)
  final bool? allowCreditLimitOverride;
  @JsonKey(name: 'LimitDiscount', includeIfNull: false)
  final bool? limitDiscount;
  @JsonKey(name: 'MaximumDiscount', includeIfNull: false)
  final double? maximumDiscount;
  @JsonKey(name: 'LimitSubDiscount', includeIfNull: false)
  final bool? limitSubDiscount;
  @JsonKey(name: 'MaximumSubDiscount', includeIfNull: false)
  final double? maximumSubDiscount;
  @JsonKey(name: 'DiscountRule', includeIfNull: false, defaultValue: '')
  final String? discountRule;
  @JsonKey(
      name: 'StagingAllowIncreaseDecreaseOrderQuantity', includeIfNull: false)
  final bool? stagingAllowIncreaseDecreaseOrderQuantity;
  @JsonKey(
      name: 'AllowStagingOfItemsWhenReservedOnOtherOrdersQuotes',
      includeIfNull: false)
  final bool? allowStagingOfItemsWhenReservedOnOtherOrdersQuotes;
  @JsonKey(
      name: 'AllowContractIfDealRequiresPOAndOrderHasPendingPO',
      includeIfNull: false)
  final bool? allowContractIfDealRequiresPOAndOrderHasPendingPO;
  @JsonKey(name: 'AllowContractIfPendingItemsExist', includeIfNull: false)
  final bool? allowContractIfPendingItemsExist;
  @JsonKey(
      name: 'AllowContractIfCustomerDealDoesNotHaveApprovedCredit',
      includeIfNull: false)
  final bool? allowContractIfCustomerDealDoesNotHaveApprovedCredit;
  @JsonKey(
      name: 'AllowContractIfCustomerDealIsOverTheirCreditLimit',
      includeIfNull: false)
  final bool? allowContractIfCustomerDealIsOverTheirCreditLimit;
  @JsonKey(
      name: 'AllowContractIfCustomerDealInsuranceCoverageIsLess',
      includeIfNull: false)
  final bool? allowContractIfCustomerDealInsuranceCoverageIsLess;
  @JsonKey(
      name: 'AllowContractIfCustomerDealDoesNotHaveValidInsuranceCertificate',
      includeIfNull: false)
  final bool? allowContractIfCustomerDealDoesNotHaveValidInsuranceCertificate;
  @JsonKey(
      name: 'AllowContractIfCustomerDealDoesNotHaveValidNonTaxCertificate',
      includeIfNull: false)
  final bool? allowContractIfCustomerDealDoesNotHaveValidNonTaxCertificate;
  @JsonKey(
      name: 'AllowReceiveSubsWhenPositiveConflictExists', includeIfNull: false)
  final bool? allowReceiveSubsWhenPositiveConflictExists;
  @JsonKey(name: 'AllowStagingOfUnreservedConsignedItems', includeIfNull: false)
  final bool? allowStagingOfUnreservedConsignedItems;
  @JsonKey(name: 'AllowStagingOfUnapprovedItems', includeIfNull: false)
  final bool? allowStagingOfUnapprovedItems;
  @JsonKey(name: 'AllowSubstitutesAtStaging', includeIfNull: false)
  final bool? allowSubstitutesAtStaging;
  @JsonKey(name: 'DeleteOriginalOnSubstitution', includeIfNull: false)
  final bool? deleteOriginalOnSubstitution;
  @JsonKey(name: 'QuikActivityAllowPrintDollarAmounts', includeIfNull: false)
  final bool? quikActivityAllowPrintDollarAmounts;
  @JsonKey(name: 'QuikScanAllowCreateContract', includeIfNull: false)
  final bool? quikScanAllowCreateContract;
  @JsonKey(name: 'QuikScanAllowApplyAll', includeIfNull: false)
  final bool? quikScanAllowApplyAll;
  @JsonKey(name: 'AllowCrossICodeExchange', includeIfNull: false)
  final bool? allowCrossICodeExchange;
  @JsonKey(name: 'AllowCrossICodePendingExchange', includeIfNull: false)
  final bool? allowCrossICodePendingExchange;
  @JsonKey(name: 'AllowChangeAvailabilityPriority', includeIfNull: false)
  final bool? allowChangeAvailabilityPriority;
  @JsonKey(name: 'UserMustChangePassword', includeIfNull: false)
  final bool? userMustChangePassword;
  @JsonKey(name: 'PasswordExpires', includeIfNull: false)
  final bool? passwordExpires;
  @JsonKey(name: 'PasswordExpireDays', includeIfNull: false)
  final int? passwordExpireDays;
  @JsonKey(
      name: 'PasswordUpdatedDateTime', includeIfNull: false, defaultValue: '')
  final String? passwordUpdatedDateTime;
  @JsonKey(name: 'AccountLocked', includeIfNull: false)
  final bool? accountLocked;
  @JsonKey(name: 'Memo', includeIfNull: false, defaultValue: '')
  final String? memo;
  @JsonKey(name: 'AllowCrossLocationEditAndDelete', includeIfNull: false)
  final bool? allowCrossLocationEditAndDelete;
  @JsonKey(name: 'LastLoggedOn', includeIfNull: false, defaultValue: '')
  final String? lastLoggedOn;
  @JsonKey(name: 'Inactive', includeIfNull: false)
  final bool? inactive;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'WebUserId', includeIfNull: false, defaultValue: '')
  final String? webUserId;
  @JsonKey(name: 'WebAccess', includeIfNull: false)
  final bool? webAccess;
  @JsonKey(name: 'WebAdministrator', includeIfNull: false)
  final bool? webAdministrator;
  @JsonKey(name: 'BrowseDefaultRows', includeIfNull: false)
  final int? browseDefaultRows;
  @JsonKey(name: 'ApplicationTheme', includeIfNull: false, defaultValue: '')
  final String? applicationTheme;
  @JsonKey(name: 'HomeMenuGuid', includeIfNull: false, defaultValue: '')
  final String? homeMenuGuid;
  @JsonKey(name: 'HomeMenuPath', includeIfNull: false, defaultValue: '')
  final String? homeMenuPath;
  @JsonKey(name: 'SuccessSoundId', includeIfNull: false, defaultValue: '')
  final String? successSoundId;
  @JsonKey(name: 'SuccessSound', includeIfNull: false, defaultValue: '')
  final String? successSound;
  @JsonKey(name: 'SuccessBase64Sound', includeIfNull: false, defaultValue: '')
  final String? successBase64Sound;
  @JsonKey(name: 'ErrorSoundId', includeIfNull: false, defaultValue: '')
  final String? errorSoundId;
  @JsonKey(name: 'ErrorSound', includeIfNull: false, defaultValue: '')
  final String? errorSound;
  @JsonKey(name: 'ErrorBase64Sound', includeIfNull: false, defaultValue: '')
  final String? errorBase64Sound;
  @JsonKey(name: 'NotificationSoundId', includeIfNull: false, defaultValue: '')
  final String? notificationSoundId;
  @JsonKey(name: 'NotificationSound', includeIfNull: false, defaultValue: '')
  final String? notificationSound;
  @JsonKey(
      name: 'NotificationBase64Sound', includeIfNull: false, defaultValue: '')
  final String? notificationBase64Sound;
  @JsonKey(name: 'FirstDayOfWeek', includeIfNull: false)
  final int? firstDayOfWeek;
  @JsonKey(name: 'SettingsNavigationMenuVisible', includeIfNull: false)
  final bool? settingsNavigationMenuVisible;
  @JsonKey(name: 'ReportsNavigationMenuVisible', includeIfNull: false)
  final bool? reportsNavigationMenuVisible;
  @JsonKey(name: 'WebQuoteRequest', includeIfNull: false)
  final bool? webQuoteRequest;
  @JsonKey(name: 'EmailSignature', includeIfNull: false, defaultValue: '')
  final String? emailSignature;
  @JsonKey(name: 'Locale', includeIfNull: false, defaultValue: '')
  final String? locale;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesAdministratorUserUserFromJson;
  static const toJsonFactory = _$WebApiModulesAdministratorUserUserToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorUserUserToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorUserUser &&
            (identical(other.userId, userId) ||
                const DeepCollectionEquality().equals(other.userId, userId)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.loginName, loginName) ||
                const DeepCollectionEquality()
                    .equals(other.loginName, loginName)) &&
            (identical(other.fullName, fullName) ||
                const DeepCollectionEquality()
                    .equals(other.fullName, fullName)) &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.middleInitial, middleInitial) ||
                const DeepCollectionEquality()
                    .equals(other.middleInitial, middleInitial)) &&
            (identical(other.lastName, lastName) ||
                const DeepCollectionEquality()
                    .equals(other.lastName, lastName)) &&
            (identical(other.password, password) ||
                const DeepCollectionEquality()
                    .equals(other.password, password)) &&
            (identical(other.passwordChanged, passwordChanged) ||
                const DeepCollectionEquality()
                    .equals(other.passwordChanged, passwordChanged)) &&
            (identical(other.barCode, barCode) ||
                const DeepCollectionEquality()
                    .equals(other.barCode, barCode)) &&
            (identical(other.groupId, groupId) ||
                const DeepCollectionEquality()
                    .equals(other.groupId, groupId)) &&
            (identical(other.groupName, groupName) ||
                const DeepCollectionEquality()
                    .equals(other.groupName, groupName)) &&
            (identical(other.scheduleColor, scheduleColor) ||
                const DeepCollectionEquality()
                    .equals(other.scheduleColor, scheduleColor)) &&
            (identical(other.userTitleId, userTitleId) ||
                const DeepCollectionEquality()
                    .equals(other.userTitleId, userTitleId)) &&
            (identical(other.userTitle, userTitle) ||
                const DeepCollectionEquality()
                    .equals(other.userTitle, userTitle)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.officeLocation, officeLocation) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocation, officeLocation)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.address1, address1) ||
                const DeepCollectionEquality()
                    .equals(other.address1, address1)) &&
            (identical(other.address2, address2) ||
                const DeepCollectionEquality()
                    .equals(other.address2, address2)) &&
            (identical(other.city, city) ||
                const DeepCollectionEquality().equals(other.city, city)) &&
            (identical(other.state, state) ||
                const DeepCollectionEquality().equals(other.state, state)) &&
            (identical(other.zipCode, zipCode) || const DeepCollectionEquality().equals(other.zipCode, zipCode)) &&
            (identical(other.countryId, countryId) || const DeepCollectionEquality().equals(other.countryId, countryId)) &&
            (identical(other.country, country) || const DeepCollectionEquality().equals(other.country, country)) &&
            (identical(other.officePhone, officePhone) || const DeepCollectionEquality().equals(other.officePhone, officePhone)) &&
            (identical(other.officeExtension, officeExtension) || const DeepCollectionEquality().equals(other.officeExtension, officeExtension)) &&
            (identical(other.fax, fax) || const DeepCollectionEquality().equals(other.fax, fax)) &&
            (identical(other.directPhone, directPhone) || const DeepCollectionEquality().equals(other.directPhone, directPhone)) &&
            (identical(other.pager, pager) || const DeepCollectionEquality().equals(other.pager, pager)) &&
            (identical(other.pagerPin, pagerPin) || const DeepCollectionEquality().equals(other.pagerPin, pagerPin)) &&
            (identical(other.cellular, cellular) || const DeepCollectionEquality().equals(other.cellular, cellular)) &&
            (identical(other.homePhone, homePhone) || const DeepCollectionEquality().equals(other.homePhone, homePhone)) &&
            (identical(other.defaultDepartmentType, defaultDepartmentType) || const DeepCollectionEquality().equals(other.defaultDepartmentType, defaultDepartmentType)) &&
            (identical(other.primaryDepartmentId, primaryDepartmentId) || const DeepCollectionEquality().equals(other.primaryDepartmentId, primaryDepartmentId)) &&
            (identical(other.primaryDepartment, primaryDepartment) || const DeepCollectionEquality().equals(other.primaryDepartment, primaryDepartment)) &&
            (identical(other.rentalDepartmentId, rentalDepartmentId) || const DeepCollectionEquality().equals(other.rentalDepartmentId, rentalDepartmentId)) &&
            (identical(other.rentalDepartment, rentalDepartment) || const DeepCollectionEquality().equals(other.rentalDepartment, rentalDepartment)) &&
            (identical(other.salesDepartmentId, salesDepartmentId) || const DeepCollectionEquality().equals(other.salesDepartmentId, salesDepartmentId)) &&
            (identical(other.salesDepartment, salesDepartment) || const DeepCollectionEquality().equals(other.salesDepartment, salesDepartment)) &&
            (identical(other.partsDepartmentId, partsDepartmentId) || const DeepCollectionEquality().equals(other.partsDepartmentId, partsDepartmentId)) &&
            (identical(other.partsDepartment, partsDepartment) || const DeepCollectionEquality().equals(other.partsDepartment, partsDepartment)) &&
            (identical(other.miscDepartmentId, miscDepartmentId) || const DeepCollectionEquality().equals(other.miscDepartmentId, miscDepartmentId)) &&
            (identical(other.miscDepartment, miscDepartment) || const DeepCollectionEquality().equals(other.miscDepartment, miscDepartment)) &&
            (identical(other.laborDepartmentId, laborDepartmentId) || const DeepCollectionEquality().equals(other.laborDepartmentId, laborDepartmentId)) &&
            (identical(other.laborDepartment, laborDepartment) || const DeepCollectionEquality().equals(other.laborDepartment, laborDepartment)) &&
            (identical(other.facilityDepartmentId, facilityDepartmentId) || const DeepCollectionEquality().equals(other.facilityDepartmentId, facilityDepartmentId)) &&
            (identical(other.facilityDepartment, facilityDepartment) || const DeepCollectionEquality().equals(other.facilityDepartment, facilityDepartment)) &&
            (identical(other.transportationDepartmentId, transportationDepartmentId) || const DeepCollectionEquality().equals(other.transportationDepartmentId, transportationDepartmentId)) &&
            (identical(other.transportationDepartment, transportationDepartment) || const DeepCollectionEquality().equals(other.transportationDepartment, transportationDepartment)) &&
            (identical(other.rentalInventoryTypeId, rentalInventoryTypeId) || const DeepCollectionEquality().equals(other.rentalInventoryTypeId, rentalInventoryTypeId)) &&
            (identical(other.rentalInventoryType, rentalInventoryType) || const DeepCollectionEquality().equals(other.rentalInventoryType, rentalInventoryType)) &&
            (identical(other.salesInventoryTypeId, salesInventoryTypeId) || const DeepCollectionEquality().equals(other.salesInventoryTypeId, salesInventoryTypeId)) &&
            (identical(other.salesInventoryType, salesInventoryType) || const DeepCollectionEquality().equals(other.salesInventoryType, salesInventoryType)) &&
            (identical(other.partsInventoryTypeId, partsInventoryTypeId) || const DeepCollectionEquality().equals(other.partsInventoryTypeId, partsInventoryTypeId)) &&
            (identical(other.partsInventoryType, partsInventoryType) || const DeepCollectionEquality().equals(other.partsInventoryType, partsInventoryType)) &&
            (identical(other.miscTypeId, miscTypeId) || const DeepCollectionEquality().equals(other.miscTypeId, miscTypeId)) &&
            (identical(other.miscType, miscType) || const DeepCollectionEquality().equals(other.miscType, miscType)) &&
            (identical(other.laborTypeId, laborTypeId) || const DeepCollectionEquality().equals(other.laborTypeId, laborTypeId)) &&
            (identical(other.laborType, laborType) || const DeepCollectionEquality().equals(other.laborType, laborType)) &&
            (identical(other.facilityTypeId, facilityTypeId) || const DeepCollectionEquality().equals(other.facilityTypeId, facilityTypeId)) &&
            (identical(other.facilityType, facilityType) || const DeepCollectionEquality().equals(other.facilityType, facilityType)) &&
            (identical(other.transportationTypeId, transportationTypeId) || const DeepCollectionEquality().equals(other.transportationTypeId, transportationTypeId)) &&
            (identical(other.transportationType, transportationType) || const DeepCollectionEquality().equals(other.transportationType, transportationType)) &&
            (identical(other.noMiscellaneousOnQuotes, noMiscellaneousOnQuotes) || const DeepCollectionEquality().equals(other.noMiscellaneousOnQuotes, noMiscellaneousOnQuotes)) &&
            (identical(other.noMiscellaneousOnOrders, noMiscellaneousOnOrders) || const DeepCollectionEquality().equals(other.noMiscellaneousOnOrders, noMiscellaneousOnOrders)) &&
            (identical(other.noMiscellaneousOnPurchaseOrders, noMiscellaneousOnPurchaseOrders) || const DeepCollectionEquality().equals(other.noMiscellaneousOnPurchaseOrders, noMiscellaneousOnPurchaseOrders)) &&
            (identical(other.limitDaysPerWeek, limitDaysPerWeek) || const DeepCollectionEquality().equals(other.limitDaysPerWeek, limitDaysPerWeek)) &&
            (identical(other.minimumDaysPerWeek, minimumDaysPerWeek) || const DeepCollectionEquality().equals(other.minimumDaysPerWeek, minimumDaysPerWeek)) &&
            (identical(other.allowCreditLimitOverride, allowCreditLimitOverride) || const DeepCollectionEquality().equals(other.allowCreditLimitOverride, allowCreditLimitOverride)) &&
            (identical(other.limitDiscount, limitDiscount) || const DeepCollectionEquality().equals(other.limitDiscount, limitDiscount)) &&
            (identical(other.maximumDiscount, maximumDiscount) || const DeepCollectionEquality().equals(other.maximumDiscount, maximumDiscount)) &&
            (identical(other.limitSubDiscount, limitSubDiscount) || const DeepCollectionEquality().equals(other.limitSubDiscount, limitSubDiscount)) &&
            (identical(other.maximumSubDiscount, maximumSubDiscount) || const DeepCollectionEquality().equals(other.maximumSubDiscount, maximumSubDiscount)) &&
            (identical(other.discountRule, discountRule) || const DeepCollectionEquality().equals(other.discountRule, discountRule)) &&
            (identical(other.stagingAllowIncreaseDecreaseOrderQuantity, stagingAllowIncreaseDecreaseOrderQuantity) || const DeepCollectionEquality().equals(other.stagingAllowIncreaseDecreaseOrderQuantity, stagingAllowIncreaseDecreaseOrderQuantity)) &&
            (identical(other.allowStagingOfItemsWhenReservedOnOtherOrdersQuotes, allowStagingOfItemsWhenReservedOnOtherOrdersQuotes) || const DeepCollectionEquality().equals(other.allowStagingOfItemsWhenReservedOnOtherOrdersQuotes, allowStagingOfItemsWhenReservedOnOtherOrdersQuotes)) &&
            (identical(other.allowContractIfDealRequiresPOAndOrderHasPendingPO, allowContractIfDealRequiresPOAndOrderHasPendingPO) || const DeepCollectionEquality().equals(other.allowContractIfDealRequiresPOAndOrderHasPendingPO, allowContractIfDealRequiresPOAndOrderHasPendingPO)) &&
            (identical(other.allowContractIfPendingItemsExist, allowContractIfPendingItemsExist) || const DeepCollectionEquality().equals(other.allowContractIfPendingItemsExist, allowContractIfPendingItemsExist)) &&
            (identical(other.allowContractIfCustomerDealDoesNotHaveApprovedCredit, allowContractIfCustomerDealDoesNotHaveApprovedCredit) || const DeepCollectionEquality().equals(other.allowContractIfCustomerDealDoesNotHaveApprovedCredit, allowContractIfCustomerDealDoesNotHaveApprovedCredit)) &&
            (identical(other.allowContractIfCustomerDealIsOverTheirCreditLimit, allowContractIfCustomerDealIsOverTheirCreditLimit) || const DeepCollectionEquality().equals(other.allowContractIfCustomerDealIsOverTheirCreditLimit, allowContractIfCustomerDealIsOverTheirCreditLimit)) &&
            (identical(other.allowContractIfCustomerDealInsuranceCoverageIsLess, allowContractIfCustomerDealInsuranceCoverageIsLess) || const DeepCollectionEquality().equals(other.allowContractIfCustomerDealInsuranceCoverageIsLess, allowContractIfCustomerDealInsuranceCoverageIsLess)) &&
            (identical(other.allowContractIfCustomerDealDoesNotHaveValidInsuranceCertificate, allowContractIfCustomerDealDoesNotHaveValidInsuranceCertificate) || const DeepCollectionEquality().equals(other.allowContractIfCustomerDealDoesNotHaveValidInsuranceCertificate, allowContractIfCustomerDealDoesNotHaveValidInsuranceCertificate)) &&
            (identical(other.allowContractIfCustomerDealDoesNotHaveValidNonTaxCertificate, allowContractIfCustomerDealDoesNotHaveValidNonTaxCertificate) || const DeepCollectionEquality().equals(other.allowContractIfCustomerDealDoesNotHaveValidNonTaxCertificate, allowContractIfCustomerDealDoesNotHaveValidNonTaxCertificate)) &&
            (identical(other.allowReceiveSubsWhenPositiveConflictExists, allowReceiveSubsWhenPositiveConflictExists) || const DeepCollectionEquality().equals(other.allowReceiveSubsWhenPositiveConflictExists, allowReceiveSubsWhenPositiveConflictExists)) &&
            (identical(other.allowStagingOfUnreservedConsignedItems, allowStagingOfUnreservedConsignedItems) || const DeepCollectionEquality().equals(other.allowStagingOfUnreservedConsignedItems, allowStagingOfUnreservedConsignedItems)) &&
            (identical(other.allowStagingOfUnapprovedItems, allowStagingOfUnapprovedItems) || const DeepCollectionEquality().equals(other.allowStagingOfUnapprovedItems, allowStagingOfUnapprovedItems)) &&
            (identical(other.allowSubstitutesAtStaging, allowSubstitutesAtStaging) || const DeepCollectionEquality().equals(other.allowSubstitutesAtStaging, allowSubstitutesAtStaging)) &&
            (identical(other.deleteOriginalOnSubstitution, deleteOriginalOnSubstitution) || const DeepCollectionEquality().equals(other.deleteOriginalOnSubstitution, deleteOriginalOnSubstitution)) &&
            (identical(other.quikActivityAllowPrintDollarAmounts, quikActivityAllowPrintDollarAmounts) || const DeepCollectionEquality().equals(other.quikActivityAllowPrintDollarAmounts, quikActivityAllowPrintDollarAmounts)) &&
            (identical(other.quikScanAllowCreateContract, quikScanAllowCreateContract) || const DeepCollectionEquality().equals(other.quikScanAllowCreateContract, quikScanAllowCreateContract)) &&
            (identical(other.quikScanAllowApplyAll, quikScanAllowApplyAll) || const DeepCollectionEquality().equals(other.quikScanAllowApplyAll, quikScanAllowApplyAll)) &&
            (identical(other.allowCrossICodeExchange, allowCrossICodeExchange) || const DeepCollectionEquality().equals(other.allowCrossICodeExchange, allowCrossICodeExchange)) &&
            (identical(other.allowCrossICodePendingExchange, allowCrossICodePendingExchange) || const DeepCollectionEquality().equals(other.allowCrossICodePendingExchange, allowCrossICodePendingExchange)) &&
            (identical(other.allowChangeAvailabilityPriority, allowChangeAvailabilityPriority) || const DeepCollectionEquality().equals(other.allowChangeAvailabilityPriority, allowChangeAvailabilityPriority)) &&
            (identical(other.userMustChangePassword, userMustChangePassword) || const DeepCollectionEquality().equals(other.userMustChangePassword, userMustChangePassword)) &&
            (identical(other.passwordExpires, passwordExpires) || const DeepCollectionEquality().equals(other.passwordExpires, passwordExpires)) &&
            (identical(other.passwordExpireDays, passwordExpireDays) || const DeepCollectionEquality().equals(other.passwordExpireDays, passwordExpireDays)) &&
            (identical(other.passwordUpdatedDateTime, passwordUpdatedDateTime) || const DeepCollectionEquality().equals(other.passwordUpdatedDateTime, passwordUpdatedDateTime)) &&
            (identical(other.accountLocked, accountLocked) || const DeepCollectionEquality().equals(other.accountLocked, accountLocked)) &&
            (identical(other.memo, memo) || const DeepCollectionEquality().equals(other.memo, memo)) &&
            (identical(other.allowCrossLocationEditAndDelete, allowCrossLocationEditAndDelete) || const DeepCollectionEquality().equals(other.allowCrossLocationEditAndDelete, allowCrossLocationEditAndDelete)) &&
            (identical(other.lastLoggedOn, lastLoggedOn) || const DeepCollectionEquality().equals(other.lastLoggedOn, lastLoggedOn)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.webUserId, webUserId) || const DeepCollectionEquality().equals(other.webUserId, webUserId)) &&
            (identical(other.webAccess, webAccess) || const DeepCollectionEquality().equals(other.webAccess, webAccess)) &&
            (identical(other.webAdministrator, webAdministrator) || const DeepCollectionEquality().equals(other.webAdministrator, webAdministrator)) &&
            (identical(other.browseDefaultRows, browseDefaultRows) || const DeepCollectionEquality().equals(other.browseDefaultRows, browseDefaultRows)) &&
            (identical(other.applicationTheme, applicationTheme) || const DeepCollectionEquality().equals(other.applicationTheme, applicationTheme)) &&
            (identical(other.homeMenuGuid, homeMenuGuid) || const DeepCollectionEquality().equals(other.homeMenuGuid, homeMenuGuid)) &&
            (identical(other.homeMenuPath, homeMenuPath) || const DeepCollectionEquality().equals(other.homeMenuPath, homeMenuPath)) &&
            (identical(other.successSoundId, successSoundId) || const DeepCollectionEquality().equals(other.successSoundId, successSoundId)) &&
            (identical(other.successSound, successSound) || const DeepCollectionEquality().equals(other.successSound, successSound)) &&
            (identical(other.successBase64Sound, successBase64Sound) || const DeepCollectionEquality().equals(other.successBase64Sound, successBase64Sound)) &&
            (identical(other.errorSoundId, errorSoundId) || const DeepCollectionEquality().equals(other.errorSoundId, errorSoundId)) &&
            (identical(other.errorSound, errorSound) || const DeepCollectionEquality().equals(other.errorSound, errorSound)) &&
            (identical(other.errorBase64Sound, errorBase64Sound) || const DeepCollectionEquality().equals(other.errorBase64Sound, errorBase64Sound)) &&
            (identical(other.notificationSoundId, notificationSoundId) || const DeepCollectionEquality().equals(other.notificationSoundId, notificationSoundId)) &&
            (identical(other.notificationSound, notificationSound) || const DeepCollectionEquality().equals(other.notificationSound, notificationSound)) &&
            (identical(other.notificationBase64Sound, notificationBase64Sound) || const DeepCollectionEquality().equals(other.notificationBase64Sound, notificationBase64Sound)) &&
            (identical(other.firstDayOfWeek, firstDayOfWeek) || const DeepCollectionEquality().equals(other.firstDayOfWeek, firstDayOfWeek)) &&
            (identical(other.settingsNavigationMenuVisible, settingsNavigationMenuVisible) || const DeepCollectionEquality().equals(other.settingsNavigationMenuVisible, settingsNavigationMenuVisible)) &&
            (identical(other.reportsNavigationMenuVisible, reportsNavigationMenuVisible) || const DeepCollectionEquality().equals(other.reportsNavigationMenuVisible, reportsNavigationMenuVisible)) &&
            (identical(other.webQuoteRequest, webQuoteRequest) || const DeepCollectionEquality().equals(other.webQuoteRequest, webQuoteRequest)) &&
            (identical(other.emailSignature, emailSignature) || const DeepCollectionEquality().equals(other.emailSignature, emailSignature)) &&
            (identical(other.locale, locale) || const DeepCollectionEquality().equals(other.locale, locale)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(userId) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(loginName) ^
      const DeepCollectionEquality().hash(fullName) ^
      const DeepCollectionEquality().hash(firstName) ^
      const DeepCollectionEquality().hash(middleInitial) ^
      const DeepCollectionEquality().hash(lastName) ^
      const DeepCollectionEquality().hash(password) ^
      const DeepCollectionEquality().hash(passwordChanged) ^
      const DeepCollectionEquality().hash(barCode) ^
      const DeepCollectionEquality().hash(groupId) ^
      const DeepCollectionEquality().hash(groupName) ^
      const DeepCollectionEquality().hash(scheduleColor) ^
      const DeepCollectionEquality().hash(userTitleId) ^
      const DeepCollectionEquality().hash(userTitle) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(officeLocationId) ^
      const DeepCollectionEquality().hash(officeLocation) ^
      const DeepCollectionEquality().hash(warehouseId) ^
      const DeepCollectionEquality().hash(warehouse) ^
      const DeepCollectionEquality().hash(address1) ^
      const DeepCollectionEquality().hash(address2) ^
      const DeepCollectionEquality().hash(city) ^
      const DeepCollectionEquality().hash(state) ^
      const DeepCollectionEquality().hash(zipCode) ^
      const DeepCollectionEquality().hash(countryId) ^
      const DeepCollectionEquality().hash(country) ^
      const DeepCollectionEquality().hash(officePhone) ^
      const DeepCollectionEquality().hash(officeExtension) ^
      const DeepCollectionEquality().hash(fax) ^
      const DeepCollectionEquality().hash(directPhone) ^
      const DeepCollectionEquality().hash(pager) ^
      const DeepCollectionEquality().hash(pagerPin) ^
      const DeepCollectionEquality().hash(cellular) ^
      const DeepCollectionEquality().hash(homePhone) ^
      const DeepCollectionEquality().hash(defaultDepartmentType) ^
      const DeepCollectionEquality().hash(primaryDepartmentId) ^
      const DeepCollectionEquality().hash(primaryDepartment) ^
      const DeepCollectionEquality().hash(rentalDepartmentId) ^
      const DeepCollectionEquality().hash(rentalDepartment) ^
      const DeepCollectionEquality().hash(salesDepartmentId) ^
      const DeepCollectionEquality().hash(salesDepartment) ^
      const DeepCollectionEquality().hash(partsDepartmentId) ^
      const DeepCollectionEquality().hash(partsDepartment) ^
      const DeepCollectionEquality().hash(miscDepartmentId) ^
      const DeepCollectionEquality().hash(miscDepartment) ^
      const DeepCollectionEquality().hash(laborDepartmentId) ^
      const DeepCollectionEquality().hash(laborDepartment) ^
      const DeepCollectionEquality().hash(facilityDepartmentId) ^
      const DeepCollectionEquality().hash(facilityDepartment) ^
      const DeepCollectionEquality().hash(transportationDepartmentId) ^
      const DeepCollectionEquality().hash(transportationDepartment) ^
      const DeepCollectionEquality().hash(rentalInventoryTypeId) ^
      const DeepCollectionEquality().hash(rentalInventoryType) ^
      const DeepCollectionEquality().hash(salesInventoryTypeId) ^
      const DeepCollectionEquality().hash(salesInventoryType) ^
      const DeepCollectionEquality().hash(partsInventoryTypeId) ^
      const DeepCollectionEquality().hash(partsInventoryType) ^
      const DeepCollectionEquality().hash(miscTypeId) ^
      const DeepCollectionEquality().hash(miscType) ^
      const DeepCollectionEquality().hash(laborTypeId) ^
      const DeepCollectionEquality().hash(laborType) ^
      const DeepCollectionEquality().hash(facilityTypeId) ^
      const DeepCollectionEquality().hash(facilityType) ^
      const DeepCollectionEquality().hash(transportationTypeId) ^
      const DeepCollectionEquality().hash(transportationType) ^
      const DeepCollectionEquality().hash(noMiscellaneousOnQuotes) ^
      const DeepCollectionEquality().hash(noMiscellaneousOnOrders) ^
      const DeepCollectionEquality().hash(noMiscellaneousOnPurchaseOrders) ^
      const DeepCollectionEquality().hash(limitDaysPerWeek) ^
      const DeepCollectionEquality().hash(minimumDaysPerWeek) ^
      const DeepCollectionEquality().hash(allowCreditLimitOverride) ^
      const DeepCollectionEquality().hash(limitDiscount) ^
      const DeepCollectionEquality().hash(maximumDiscount) ^
      const DeepCollectionEquality().hash(limitSubDiscount) ^
      const DeepCollectionEquality().hash(maximumSubDiscount) ^
      const DeepCollectionEquality().hash(discountRule) ^
      const DeepCollectionEquality()
          .hash(stagingAllowIncreaseDecreaseOrderQuantity) ^
      const DeepCollectionEquality()
          .hash(allowStagingOfItemsWhenReservedOnOtherOrdersQuotes) ^
      const DeepCollectionEquality()
          .hash(allowContractIfDealRequiresPOAndOrderHasPendingPO) ^
      const DeepCollectionEquality().hash(allowContractIfPendingItemsExist) ^
      const DeepCollectionEquality()
          .hash(allowContractIfCustomerDealDoesNotHaveApprovedCredit) ^
      const DeepCollectionEquality()
          .hash(allowContractIfCustomerDealIsOverTheirCreditLimit) ^
      const DeepCollectionEquality()
          .hash(allowContractIfCustomerDealInsuranceCoverageIsLess) ^
      const DeepCollectionEquality().hash(
          allowContractIfCustomerDealDoesNotHaveValidInsuranceCertificate) ^
      const DeepCollectionEquality()
          .hash(allowContractIfCustomerDealDoesNotHaveValidNonTaxCertificate) ^
      const DeepCollectionEquality()
          .hash(allowReceiveSubsWhenPositiveConflictExists) ^
      const DeepCollectionEquality()
          .hash(allowStagingOfUnreservedConsignedItems) ^
      const DeepCollectionEquality().hash(allowStagingOfUnapprovedItems) ^
      const DeepCollectionEquality().hash(allowSubstitutesAtStaging) ^
      const DeepCollectionEquality().hash(deleteOriginalOnSubstitution) ^
      const DeepCollectionEquality().hash(quikActivityAllowPrintDollarAmounts) ^
      const DeepCollectionEquality().hash(quikScanAllowCreateContract) ^
      const DeepCollectionEquality().hash(quikScanAllowApplyAll) ^
      const DeepCollectionEquality().hash(allowCrossICodeExchange) ^
      const DeepCollectionEquality().hash(allowCrossICodePendingExchange) ^
      const DeepCollectionEquality().hash(allowChangeAvailabilityPriority) ^
      const DeepCollectionEquality().hash(userMustChangePassword) ^
      const DeepCollectionEquality().hash(passwordExpires) ^
      const DeepCollectionEquality().hash(passwordExpireDays) ^
      const DeepCollectionEquality().hash(passwordUpdatedDateTime) ^
      const DeepCollectionEquality().hash(accountLocked) ^
      const DeepCollectionEquality().hash(memo) ^
      const DeepCollectionEquality().hash(allowCrossLocationEditAndDelete) ^
      const DeepCollectionEquality().hash(lastLoggedOn) ^
      const DeepCollectionEquality().hash(inactive) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(webUserId) ^
      const DeepCollectionEquality().hash(webAccess) ^
      const DeepCollectionEquality().hash(webAdministrator) ^
      const DeepCollectionEquality().hash(browseDefaultRows) ^
      const DeepCollectionEquality().hash(applicationTheme) ^
      const DeepCollectionEquality().hash(homeMenuGuid) ^
      const DeepCollectionEquality().hash(homeMenuPath) ^
      const DeepCollectionEquality().hash(successSoundId) ^
      const DeepCollectionEquality().hash(successSound) ^
      const DeepCollectionEquality().hash(successBase64Sound) ^
      const DeepCollectionEquality().hash(errorSoundId) ^
      const DeepCollectionEquality().hash(errorSound) ^
      const DeepCollectionEquality().hash(errorBase64Sound) ^
      const DeepCollectionEquality().hash(notificationSoundId) ^
      const DeepCollectionEquality().hash(notificationSound) ^
      const DeepCollectionEquality().hash(notificationBase64Sound) ^
      const DeepCollectionEquality().hash(firstDayOfWeek) ^
      const DeepCollectionEquality().hash(settingsNavigationMenuVisible) ^
      const DeepCollectionEquality().hash(reportsNavigationMenuVisible) ^
      const DeepCollectionEquality().hash(webQuoteRequest) ^
      const DeepCollectionEquality().hash(emailSignature) ^
      const DeepCollectionEquality().hash(locale) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorUserUserExtension
    on WebApiModulesAdministratorUserUser {
  WebApiModulesAdministratorUserUser copyWith(
      {String? userId,
      String? name,
      String? loginName,
      String? fullName,
      String? firstName,
      String? middleInitial,
      String? lastName,
      String? password,
      bool? passwordChanged,
      String? barCode,
      String? groupId,
      String? groupName,
      String? scheduleColor,
      String? userTitleId,
      String? userTitle,
      String? email,
      String? officeLocationId,
      String? officeLocation,
      String? warehouseId,
      String? warehouse,
      String? address1,
      String? address2,
      String? city,
      String? state,
      String? zipCode,
      String? countryId,
      String? country,
      String? officePhone,
      String? officeExtension,
      String? fax,
      String? directPhone,
      String? pager,
      String? pagerPin,
      String? cellular,
      String? homePhone,
      String? defaultDepartmentType,
      String? primaryDepartmentId,
      String? primaryDepartment,
      String? rentalDepartmentId,
      String? rentalDepartment,
      String? salesDepartmentId,
      String? salesDepartment,
      String? partsDepartmentId,
      String? partsDepartment,
      String? miscDepartmentId,
      String? miscDepartment,
      String? laborDepartmentId,
      String? laborDepartment,
      String? facilityDepartmentId,
      String? facilityDepartment,
      String? transportationDepartmentId,
      String? transportationDepartment,
      String? rentalInventoryTypeId,
      String? rentalInventoryType,
      String? salesInventoryTypeId,
      String? salesInventoryType,
      String? partsInventoryTypeId,
      String? partsInventoryType,
      String? miscTypeId,
      String? miscType,
      String? laborTypeId,
      String? laborType,
      String? facilityTypeId,
      String? facilityType,
      String? transportationTypeId,
      String? transportationType,
      bool? noMiscellaneousOnQuotes,
      bool? noMiscellaneousOnOrders,
      bool? noMiscellaneousOnPurchaseOrders,
      bool? limitDaysPerWeek,
      double? minimumDaysPerWeek,
      bool? allowCreditLimitOverride,
      bool? limitDiscount,
      double? maximumDiscount,
      bool? limitSubDiscount,
      double? maximumSubDiscount,
      String? discountRule,
      bool? stagingAllowIncreaseDecreaseOrderQuantity,
      bool? allowStagingOfItemsWhenReservedOnOtherOrdersQuotes,
      bool? allowContractIfDealRequiresPOAndOrderHasPendingPO,
      bool? allowContractIfPendingItemsExist,
      bool? allowContractIfCustomerDealDoesNotHaveApprovedCredit,
      bool? allowContractIfCustomerDealIsOverTheirCreditLimit,
      bool? allowContractIfCustomerDealInsuranceCoverageIsLess,
      bool? allowContractIfCustomerDealDoesNotHaveValidInsuranceCertificate,
      bool? allowContractIfCustomerDealDoesNotHaveValidNonTaxCertificate,
      bool? allowReceiveSubsWhenPositiveConflictExists,
      bool? allowStagingOfUnreservedConsignedItems,
      bool? allowStagingOfUnapprovedItems,
      bool? allowSubstitutesAtStaging,
      bool? deleteOriginalOnSubstitution,
      bool? quikActivityAllowPrintDollarAmounts,
      bool? quikScanAllowCreateContract,
      bool? quikScanAllowApplyAll,
      bool? allowCrossICodeExchange,
      bool? allowCrossICodePendingExchange,
      bool? allowChangeAvailabilityPriority,
      bool? userMustChangePassword,
      bool? passwordExpires,
      int? passwordExpireDays,
      String? passwordUpdatedDateTime,
      bool? accountLocked,
      String? memo,
      bool? allowCrossLocationEditAndDelete,
      String? lastLoggedOn,
      bool? inactive,
      String? dateStamp,
      String? webUserId,
      bool? webAccess,
      bool? webAdministrator,
      int? browseDefaultRows,
      String? applicationTheme,
      String? homeMenuGuid,
      String? homeMenuPath,
      String? successSoundId,
      String? successSound,
      String? successBase64Sound,
      String? errorSoundId,
      String? errorSound,
      String? errorBase64Sound,
      String? notificationSoundId,
      String? notificationSound,
      String? notificationBase64Sound,
      int? firstDayOfWeek,
      bool? settingsNavigationMenuVisible,
      bool? reportsNavigationMenuVisible,
      bool? webQuoteRequest,
      String? emailSignature,
      String? locale,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAdministratorUserUser(
        userId: userId ?? this.userId,
        name: name ?? this.name,
        loginName: loginName ?? this.loginName,
        fullName: fullName ?? this.fullName,
        firstName: firstName ?? this.firstName,
        middleInitial: middleInitial ?? this.middleInitial,
        lastName: lastName ?? this.lastName,
        password: password ?? this.password,
        passwordChanged: passwordChanged ?? this.passwordChanged,
        barCode: barCode ?? this.barCode,
        groupId: groupId ?? this.groupId,
        groupName: groupName ?? this.groupName,
        scheduleColor: scheduleColor ?? this.scheduleColor,
        userTitleId: userTitleId ?? this.userTitleId,
        userTitle: userTitle ?? this.userTitle,
        email: email ?? this.email,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        officeLocation: officeLocation ?? this.officeLocation,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        address1: address1 ?? this.address1,
        address2: address2 ?? this.address2,
        city: city ?? this.city,
        state: state ?? this.state,
        zipCode: zipCode ?? this.zipCode,
        countryId: countryId ?? this.countryId,
        country: country ?? this.country,
        officePhone: officePhone ?? this.officePhone,
        officeExtension: officeExtension ?? this.officeExtension,
        fax: fax ?? this.fax,
        directPhone: directPhone ?? this.directPhone,
        pager: pager ?? this.pager,
        pagerPin: pagerPin ?? this.pagerPin,
        cellular: cellular ?? this.cellular,
        homePhone: homePhone ?? this.homePhone,
        defaultDepartmentType:
            defaultDepartmentType ?? this.defaultDepartmentType,
        primaryDepartmentId: primaryDepartmentId ?? this.primaryDepartmentId,
        primaryDepartment: primaryDepartment ?? this.primaryDepartment,
        rentalDepartmentId: rentalDepartmentId ?? this.rentalDepartmentId,
        rentalDepartment: rentalDepartment ?? this.rentalDepartment,
        salesDepartmentId: salesDepartmentId ?? this.salesDepartmentId,
        salesDepartment: salesDepartment ?? this.salesDepartment,
        partsDepartmentId: partsDepartmentId ?? this.partsDepartmentId,
        partsDepartment: partsDepartment ?? this.partsDepartment,
        miscDepartmentId: miscDepartmentId ?? this.miscDepartmentId,
        miscDepartment: miscDepartment ?? this.miscDepartment,
        laborDepartmentId: laborDepartmentId ?? this.laborDepartmentId,
        laborDepartment: laborDepartment ?? this.laborDepartment,
        facilityDepartmentId: facilityDepartmentId ?? this.facilityDepartmentId,
        facilityDepartment: facilityDepartment ?? this.facilityDepartment,
        transportationDepartmentId:
            transportationDepartmentId ?? this.transportationDepartmentId,
        transportationDepartment:
            transportationDepartment ?? this.transportationDepartment,
        rentalInventoryTypeId:
            rentalInventoryTypeId ?? this.rentalInventoryTypeId,
        rentalInventoryType: rentalInventoryType ?? this.rentalInventoryType,
        salesInventoryTypeId: salesInventoryTypeId ?? this.salesInventoryTypeId,
        salesInventoryType: salesInventoryType ?? this.salesInventoryType,
        partsInventoryTypeId: partsInventoryTypeId ?? this.partsInventoryTypeId,
        partsInventoryType: partsInventoryType ?? this.partsInventoryType,
        miscTypeId: miscTypeId ?? this.miscTypeId,
        miscType: miscType ?? this.miscType,
        laborTypeId: laborTypeId ?? this.laborTypeId,
        laborType: laborType ?? this.laborType,
        facilityTypeId: facilityTypeId ?? this.facilityTypeId,
        facilityType: facilityType ?? this.facilityType,
        transportationTypeId: transportationTypeId ?? this.transportationTypeId,
        transportationType: transportationType ?? this.transportationType,
        noMiscellaneousOnQuotes:
            noMiscellaneousOnQuotes ?? this.noMiscellaneousOnQuotes,
        noMiscellaneousOnOrders:
            noMiscellaneousOnOrders ?? this.noMiscellaneousOnOrders,
        noMiscellaneousOnPurchaseOrders: noMiscellaneousOnPurchaseOrders ??
            this.noMiscellaneousOnPurchaseOrders,
        limitDaysPerWeek: limitDaysPerWeek ?? this.limitDaysPerWeek,
        minimumDaysPerWeek: minimumDaysPerWeek ?? this.minimumDaysPerWeek,
        allowCreditLimitOverride:
            allowCreditLimitOverride ?? this.allowCreditLimitOverride,
        limitDiscount: limitDiscount ?? this.limitDiscount,
        maximumDiscount: maximumDiscount ?? this.maximumDiscount,
        limitSubDiscount: limitSubDiscount ?? this.limitSubDiscount,
        maximumSubDiscount: maximumSubDiscount ?? this.maximumSubDiscount,
        discountRule: discountRule ?? this.discountRule,
        stagingAllowIncreaseDecreaseOrderQuantity:
            stagingAllowIncreaseDecreaseOrderQuantity ??
                this.stagingAllowIncreaseDecreaseOrderQuantity,
        allowStagingOfItemsWhenReservedOnOtherOrdersQuotes:
            allowStagingOfItemsWhenReservedOnOtherOrdersQuotes ??
                this.allowStagingOfItemsWhenReservedOnOtherOrdersQuotes,
        allowContractIfDealRequiresPOAndOrderHasPendingPO:
            allowContractIfDealRequiresPOAndOrderHasPendingPO ??
                this.allowContractIfDealRequiresPOAndOrderHasPendingPO,
        allowContractIfPendingItemsExist: allowContractIfPendingItemsExist ??
            this.allowContractIfPendingItemsExist,
        allowContractIfCustomerDealDoesNotHaveApprovedCredit:
            allowContractIfCustomerDealDoesNotHaveApprovedCredit ??
                this.allowContractIfCustomerDealDoesNotHaveApprovedCredit,
        allowContractIfCustomerDealIsOverTheirCreditLimit:
            allowContractIfCustomerDealIsOverTheirCreditLimit ??
                this.allowContractIfCustomerDealIsOverTheirCreditLimit,
        allowContractIfCustomerDealInsuranceCoverageIsLess:
            allowContractIfCustomerDealInsuranceCoverageIsLess ??
                this.allowContractIfCustomerDealInsuranceCoverageIsLess,
        allowContractIfCustomerDealDoesNotHaveValidInsuranceCertificate:
            allowContractIfCustomerDealDoesNotHaveValidInsuranceCertificate ??
                this
                    .allowContractIfCustomerDealDoesNotHaveValidInsuranceCertificate,
        allowContractIfCustomerDealDoesNotHaveValidNonTaxCertificate:
            allowContractIfCustomerDealDoesNotHaveValidNonTaxCertificate ??
                this.allowContractIfCustomerDealDoesNotHaveValidNonTaxCertificate,
        allowReceiveSubsWhenPositiveConflictExists: allowReceiveSubsWhenPositiveConflictExists ?? this.allowReceiveSubsWhenPositiveConflictExists,
        allowStagingOfUnreservedConsignedItems: allowStagingOfUnreservedConsignedItems ?? this.allowStagingOfUnreservedConsignedItems,
        allowStagingOfUnapprovedItems: allowStagingOfUnapprovedItems ?? this.allowStagingOfUnapprovedItems,
        allowSubstitutesAtStaging: allowSubstitutesAtStaging ?? this.allowSubstitutesAtStaging,
        deleteOriginalOnSubstitution: deleteOriginalOnSubstitution ?? this.deleteOriginalOnSubstitution,
        quikActivityAllowPrintDollarAmounts: quikActivityAllowPrintDollarAmounts ?? this.quikActivityAllowPrintDollarAmounts,
        quikScanAllowCreateContract: quikScanAllowCreateContract ?? this.quikScanAllowCreateContract,
        quikScanAllowApplyAll: quikScanAllowApplyAll ?? this.quikScanAllowApplyAll,
        allowCrossICodeExchange: allowCrossICodeExchange ?? this.allowCrossICodeExchange,
        allowCrossICodePendingExchange: allowCrossICodePendingExchange ?? this.allowCrossICodePendingExchange,
        allowChangeAvailabilityPriority: allowChangeAvailabilityPriority ?? this.allowChangeAvailabilityPriority,
        userMustChangePassword: userMustChangePassword ?? this.userMustChangePassword,
        passwordExpires: passwordExpires ?? this.passwordExpires,
        passwordExpireDays: passwordExpireDays ?? this.passwordExpireDays,
        passwordUpdatedDateTime: passwordUpdatedDateTime ?? this.passwordUpdatedDateTime,
        accountLocked: accountLocked ?? this.accountLocked,
        memo: memo ?? this.memo,
        allowCrossLocationEditAndDelete: allowCrossLocationEditAndDelete ?? this.allowCrossLocationEditAndDelete,
        lastLoggedOn: lastLoggedOn ?? this.lastLoggedOn,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        webUserId: webUserId ?? this.webUserId,
        webAccess: webAccess ?? this.webAccess,
        webAdministrator: webAdministrator ?? this.webAdministrator,
        browseDefaultRows: browseDefaultRows ?? this.browseDefaultRows,
        applicationTheme: applicationTheme ?? this.applicationTheme,
        homeMenuGuid: homeMenuGuid ?? this.homeMenuGuid,
        homeMenuPath: homeMenuPath ?? this.homeMenuPath,
        successSoundId: successSoundId ?? this.successSoundId,
        successSound: successSound ?? this.successSound,
        successBase64Sound: successBase64Sound ?? this.successBase64Sound,
        errorSoundId: errorSoundId ?? this.errorSoundId,
        errorSound: errorSound ?? this.errorSound,
        errorBase64Sound: errorBase64Sound ?? this.errorBase64Sound,
        notificationSoundId: notificationSoundId ?? this.notificationSoundId,
        notificationSound: notificationSound ?? this.notificationSound,
        notificationBase64Sound: notificationBase64Sound ?? this.notificationBase64Sound,
        firstDayOfWeek: firstDayOfWeek ?? this.firstDayOfWeek,
        settingsNavigationMenuVisible: settingsNavigationMenuVisible ?? this.settingsNavigationMenuVisible,
        reportsNavigationMenuVisible: reportsNavigationMenuVisible ?? this.reportsNavigationMenuVisible,
        webQuoteRequest: webQuoteRequest ?? this.webQuoteRequest,
        emailSignature: emailSignature ?? this.emailSignature,
        locale: locale ?? this.locale,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes: defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesAdministratorUserUser copyWithWrapped(
      {Wrapped<String?>? userId,
      Wrapped<String?>? name,
      Wrapped<String?>? loginName,
      Wrapped<String?>? fullName,
      Wrapped<String?>? firstName,
      Wrapped<String?>? middleInitial,
      Wrapped<String?>? lastName,
      Wrapped<String?>? password,
      Wrapped<bool?>? passwordChanged,
      Wrapped<String?>? barCode,
      Wrapped<String?>? groupId,
      Wrapped<String?>? groupName,
      Wrapped<String?>? scheduleColor,
      Wrapped<String?>? userTitleId,
      Wrapped<String?>? userTitle,
      Wrapped<String?>? email,
      Wrapped<String?>? officeLocationId,
      Wrapped<String?>? officeLocation,
      Wrapped<String?>? warehouseId,
      Wrapped<String?>? warehouse,
      Wrapped<String?>? address1,
      Wrapped<String?>? address2,
      Wrapped<String?>? city,
      Wrapped<String?>? state,
      Wrapped<String?>? zipCode,
      Wrapped<String?>? countryId,
      Wrapped<String?>? country,
      Wrapped<String?>? officePhone,
      Wrapped<String?>? officeExtension,
      Wrapped<String?>? fax,
      Wrapped<String?>? directPhone,
      Wrapped<String?>? pager,
      Wrapped<String?>? pagerPin,
      Wrapped<String?>? cellular,
      Wrapped<String?>? homePhone,
      Wrapped<String?>? defaultDepartmentType,
      Wrapped<String?>? primaryDepartmentId,
      Wrapped<String?>? primaryDepartment,
      Wrapped<String?>? rentalDepartmentId,
      Wrapped<String?>? rentalDepartment,
      Wrapped<String?>? salesDepartmentId,
      Wrapped<String?>? salesDepartment,
      Wrapped<String?>? partsDepartmentId,
      Wrapped<String?>? partsDepartment,
      Wrapped<String?>? miscDepartmentId,
      Wrapped<String?>? miscDepartment,
      Wrapped<String?>? laborDepartmentId,
      Wrapped<String?>? laborDepartment,
      Wrapped<String?>? facilityDepartmentId,
      Wrapped<String?>? facilityDepartment,
      Wrapped<String?>? transportationDepartmentId,
      Wrapped<String?>? transportationDepartment,
      Wrapped<String?>? rentalInventoryTypeId,
      Wrapped<String?>? rentalInventoryType,
      Wrapped<String?>? salesInventoryTypeId,
      Wrapped<String?>? salesInventoryType,
      Wrapped<String?>? partsInventoryTypeId,
      Wrapped<String?>? partsInventoryType,
      Wrapped<String?>? miscTypeId,
      Wrapped<String?>? miscType,
      Wrapped<String?>? laborTypeId,
      Wrapped<String?>? laborType,
      Wrapped<String?>? facilityTypeId,
      Wrapped<String?>? facilityType,
      Wrapped<String?>? transportationTypeId,
      Wrapped<String?>? transportationType,
      Wrapped<bool?>? noMiscellaneousOnQuotes,
      Wrapped<bool?>? noMiscellaneousOnOrders,
      Wrapped<bool?>? noMiscellaneousOnPurchaseOrders,
      Wrapped<bool?>? limitDaysPerWeek,
      Wrapped<double?>? minimumDaysPerWeek,
      Wrapped<bool?>? allowCreditLimitOverride,
      Wrapped<bool?>? limitDiscount,
      Wrapped<double?>? maximumDiscount,
      Wrapped<bool?>? limitSubDiscount,
      Wrapped<double?>? maximumSubDiscount,
      Wrapped<String?>? discountRule,
      Wrapped<bool?>? stagingAllowIncreaseDecreaseOrderQuantity,
      Wrapped<bool?>? allowStagingOfItemsWhenReservedOnOtherOrdersQuotes,
      Wrapped<bool?>? allowContractIfDealRequiresPOAndOrderHasPendingPO,
      Wrapped<bool?>? allowContractIfPendingItemsExist,
      Wrapped<bool?>? allowContractIfCustomerDealDoesNotHaveApprovedCredit,
      Wrapped<bool?>? allowContractIfCustomerDealIsOverTheirCreditLimit,
      Wrapped<bool?>? allowContractIfCustomerDealInsuranceCoverageIsLess,
      Wrapped<bool?>?
          allowContractIfCustomerDealDoesNotHaveValidInsuranceCertificate,
      Wrapped<bool?>?
          allowContractIfCustomerDealDoesNotHaveValidNonTaxCertificate,
      Wrapped<bool?>? allowReceiveSubsWhenPositiveConflictExists,
      Wrapped<bool?>? allowStagingOfUnreservedConsignedItems,
      Wrapped<bool?>? allowStagingOfUnapprovedItems,
      Wrapped<bool?>? allowSubstitutesAtStaging,
      Wrapped<bool?>? deleteOriginalOnSubstitution,
      Wrapped<bool?>? quikActivityAllowPrintDollarAmounts,
      Wrapped<bool?>? quikScanAllowCreateContract,
      Wrapped<bool?>? quikScanAllowApplyAll,
      Wrapped<bool?>? allowCrossICodeExchange,
      Wrapped<bool?>? allowCrossICodePendingExchange,
      Wrapped<bool?>? allowChangeAvailabilityPriority,
      Wrapped<bool?>? userMustChangePassword,
      Wrapped<bool?>? passwordExpires,
      Wrapped<int?>? passwordExpireDays,
      Wrapped<String?>? passwordUpdatedDateTime,
      Wrapped<bool?>? accountLocked,
      Wrapped<String?>? memo,
      Wrapped<bool?>? allowCrossLocationEditAndDelete,
      Wrapped<String?>? lastLoggedOn,
      Wrapped<bool?>? inactive,
      Wrapped<String?>? dateStamp,
      Wrapped<String?>? webUserId,
      Wrapped<bool?>? webAccess,
      Wrapped<bool?>? webAdministrator,
      Wrapped<int?>? browseDefaultRows,
      Wrapped<String?>? applicationTheme,
      Wrapped<String?>? homeMenuGuid,
      Wrapped<String?>? homeMenuPath,
      Wrapped<String?>? successSoundId,
      Wrapped<String?>? successSound,
      Wrapped<String?>? successBase64Sound,
      Wrapped<String?>? errorSoundId,
      Wrapped<String?>? errorSound,
      Wrapped<String?>? errorBase64Sound,
      Wrapped<String?>? notificationSoundId,
      Wrapped<String?>? notificationSound,
      Wrapped<String?>? notificationBase64Sound,
      Wrapped<int?>? firstDayOfWeek,
      Wrapped<bool?>? settingsNavigationMenuVisible,
      Wrapped<bool?>? reportsNavigationMenuVisible,
      Wrapped<bool?>? webQuoteRequest,
      Wrapped<String?>? emailSignature,
      Wrapped<String?>? locale,
      Wrapped<String?>? recordTitle,
      Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
          fields,
      Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
      Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
          defaultFieldAttributes}) {
    return WebApiModulesAdministratorUserUser(
        userId: (userId != null ? userId.value : this.userId),
        name: (name != null ? name.value : this.name),
        loginName: (loginName != null ? loginName.value : this.loginName),
        fullName: (fullName != null ? fullName.value : this.fullName),
        firstName: (firstName != null ? firstName.value : this.firstName),
        middleInitial:
            (middleInitial != null ? middleInitial.value : this.middleInitial),
        lastName: (lastName != null ? lastName.value : this.lastName),
        password: (password != null ? password.value : this.password),
        passwordChanged: (passwordChanged != null
            ? passwordChanged.value
            : this.passwordChanged),
        barCode: (barCode != null ? barCode.value : this.barCode),
        groupId: (groupId != null ? groupId.value : this.groupId),
        groupName: (groupName != null ? groupName.value : this.groupName),
        scheduleColor:
            (scheduleColor != null ? scheduleColor.value : this.scheduleColor),
        userTitleId:
            (userTitleId != null ? userTitleId.value : this.userTitleId),
        userTitle: (userTitle != null ? userTitle.value : this.userTitle),
        email: (email != null ? email.value : this.email),
        officeLocationId: (officeLocationId != null
            ? officeLocationId.value
            : this.officeLocationId),
        officeLocation: (officeLocation != null
            ? officeLocation.value
            : this.officeLocation),
        warehouseId:
            (warehouseId != null ? warehouseId.value : this.warehouseId),
        warehouse: (warehouse != null ? warehouse.value : this.warehouse),
        address1: (address1 != null ? address1.value : this.address1),
        address2: (address2 != null ? address2.value : this.address2),
        city: (city != null ? city.value : this.city),
        state: (state != null ? state.value : this.state),
        zipCode: (zipCode != null ? zipCode.value : this.zipCode),
        countryId: (countryId != null ? countryId.value : this.countryId),
        country: (country != null ? country.value : this.country),
        officePhone:
            (officePhone != null ? officePhone.value : this.officePhone),
        officeExtension: (officeExtension != null
            ? officeExtension.value
            : this.officeExtension),
        fax: (fax != null ? fax.value : this.fax),
        directPhone:
            (directPhone != null ? directPhone.value : this.directPhone),
        pager: (pager != null ? pager.value : this.pager),
        pagerPin: (pagerPin != null ? pagerPin.value : this.pagerPin),
        cellular: (cellular != null ? cellular.value : this.cellular),
        homePhone: (homePhone != null ? homePhone.value : this.homePhone),
        defaultDepartmentType: (defaultDepartmentType != null
            ? defaultDepartmentType.value
            : this.defaultDepartmentType),
        primaryDepartmentId: (primaryDepartmentId != null
            ? primaryDepartmentId.value
            : this.primaryDepartmentId),
        primaryDepartment: (primaryDepartment != null
            ? primaryDepartment.value
            : this.primaryDepartment),
        rentalDepartmentId: (rentalDepartmentId != null
            ? rentalDepartmentId.value
            : this.rentalDepartmentId),
        rentalDepartment: (rentalDepartment != null
            ? rentalDepartment.value
            : this.rentalDepartment),
        salesDepartmentId: (salesDepartmentId != null
            ? salesDepartmentId.value
            : this.salesDepartmentId),
        salesDepartment: (salesDepartment != null
            ? salesDepartment.value
            : this.salesDepartment),
        partsDepartmentId: (partsDepartmentId != null
            ? partsDepartmentId.value
            : this.partsDepartmentId),
        partsDepartment: (partsDepartment != null
            ? partsDepartment.value
            : this.partsDepartment),
        miscDepartmentId: (miscDepartmentId != null
            ? miscDepartmentId.value
            : this.miscDepartmentId),
        miscDepartment: (miscDepartment != null
            ? miscDepartment.value
            : this.miscDepartment),
        laborDepartmentId: (laborDepartmentId != null
            ? laborDepartmentId.value
            : this.laborDepartmentId),
        laborDepartment: (laborDepartment != null
            ? laborDepartment.value
            : this.laborDepartment),
        facilityDepartmentId: (facilityDepartmentId != null
            ? facilityDepartmentId.value
            : this.facilityDepartmentId),
        facilityDepartment: (facilityDepartment != null
            ? facilityDepartment.value
            : this.facilityDepartment),
        transportationDepartmentId: (transportationDepartmentId != null
            ? transportationDepartmentId.value
            : this.transportationDepartmentId),
        transportationDepartment: (transportationDepartment != null
            ? transportationDepartment.value
            : this.transportationDepartment),
        rentalInventoryTypeId: (rentalInventoryTypeId != null
            ? rentalInventoryTypeId.value
            : this.rentalInventoryTypeId),
        rentalInventoryType: (rentalInventoryType != null
            ? rentalInventoryType.value
            : this.rentalInventoryType),
        salesInventoryTypeId: (salesInventoryTypeId != null
            ? salesInventoryTypeId.value
            : this.salesInventoryTypeId),
        salesInventoryType: (salesInventoryType != null
            ? salesInventoryType.value
            : this.salesInventoryType),
        partsInventoryTypeId: (partsInventoryTypeId != null
            ? partsInventoryTypeId.value
            : this.partsInventoryTypeId),
        partsInventoryType: (partsInventoryType != null
            ? partsInventoryType.value
            : this.partsInventoryType),
        miscTypeId: (miscTypeId != null ? miscTypeId.value : this.miscTypeId),
        miscType: (miscType != null ? miscType.value : this.miscType),
        laborTypeId:
            (laborTypeId != null ? laborTypeId.value : this.laborTypeId),
        laborType: (laborType != null ? laborType.value : this.laborType),
        facilityTypeId: (facilityTypeId != null
            ? facilityTypeId.value
            : this.facilityTypeId),
        facilityType:
            (facilityType != null ? facilityType.value : this.facilityType),
        transportationTypeId: (transportationTypeId != null
            ? transportationTypeId.value
            : this.transportationTypeId),
        transportationType: (transportationType != null
            ? transportationType.value
            : this.transportationType),
        noMiscellaneousOnQuotes: (noMiscellaneousOnQuotes != null
            ? noMiscellaneousOnQuotes.value
            : this.noMiscellaneousOnQuotes),
        noMiscellaneousOnOrders: (noMiscellaneousOnOrders != null
            ? noMiscellaneousOnOrders.value
            : this.noMiscellaneousOnOrders),
        noMiscellaneousOnPurchaseOrders: (noMiscellaneousOnPurchaseOrders != null
            ? noMiscellaneousOnPurchaseOrders.value
            : this.noMiscellaneousOnPurchaseOrders),
        limitDaysPerWeek: (limitDaysPerWeek != null
            ? limitDaysPerWeek.value
            : this.limitDaysPerWeek),
        minimumDaysPerWeek: (minimumDaysPerWeek != null
            ? minimumDaysPerWeek.value
            : this.minimumDaysPerWeek),
        allowCreditLimitOverride: (allowCreditLimitOverride != null
            ? allowCreditLimitOverride.value
            : this.allowCreditLimitOverride),
        limitDiscount:
            (limitDiscount != null ? limitDiscount.value : this.limitDiscount),
        maximumDiscount: (maximumDiscount != null
            ? maximumDiscount.value
            : this.maximumDiscount),
        limitSubDiscount: (limitSubDiscount != null
            ? limitSubDiscount.value
            : this.limitSubDiscount),
        maximumSubDiscount: (maximumSubDiscount != null
            ? maximumSubDiscount.value
            : this.maximumSubDiscount),
        discountRule:
            (discountRule != null ? discountRule.value : this.discountRule),
        stagingAllowIncreaseDecreaseOrderQuantity: (stagingAllowIncreaseDecreaseOrderQuantity != null
            ? stagingAllowIncreaseDecreaseOrderQuantity.value
            : this.stagingAllowIncreaseDecreaseOrderQuantity),
        allowStagingOfItemsWhenReservedOnOtherOrdersQuotes:
            (allowStagingOfItemsWhenReservedOnOtherOrdersQuotes != null
                ? allowStagingOfItemsWhenReservedOnOtherOrdersQuotes.value
                : this.allowStagingOfItemsWhenReservedOnOtherOrdersQuotes),
        allowContractIfDealRequiresPOAndOrderHasPendingPO:
            (allowContractIfDealRequiresPOAndOrderHasPendingPO != null
                ? allowContractIfDealRequiresPOAndOrderHasPendingPO.value
                : this.allowContractIfDealRequiresPOAndOrderHasPendingPO),
        allowContractIfPendingItemsExist: (allowContractIfPendingItemsExist != null
            ? allowContractIfPendingItemsExist.value
            : this.allowContractIfPendingItemsExist),
        allowContractIfCustomerDealDoesNotHaveApprovedCredit: (allowContractIfCustomerDealDoesNotHaveApprovedCredit != null ? allowContractIfCustomerDealDoesNotHaveApprovedCredit.value : this.allowContractIfCustomerDealDoesNotHaveApprovedCredit),
        allowContractIfCustomerDealIsOverTheirCreditLimit: (allowContractIfCustomerDealIsOverTheirCreditLimit != null ? allowContractIfCustomerDealIsOverTheirCreditLimit.value : this.allowContractIfCustomerDealIsOverTheirCreditLimit),
        allowContractIfCustomerDealInsuranceCoverageIsLess: (allowContractIfCustomerDealInsuranceCoverageIsLess != null ? allowContractIfCustomerDealInsuranceCoverageIsLess.value : this.allowContractIfCustomerDealInsuranceCoverageIsLess),
        allowContractIfCustomerDealDoesNotHaveValidInsuranceCertificate: (allowContractIfCustomerDealDoesNotHaveValidInsuranceCertificate != null ? allowContractIfCustomerDealDoesNotHaveValidInsuranceCertificate.value : this.allowContractIfCustomerDealDoesNotHaveValidInsuranceCertificate),
        allowContractIfCustomerDealDoesNotHaveValidNonTaxCertificate: (allowContractIfCustomerDealDoesNotHaveValidNonTaxCertificate != null ? allowContractIfCustomerDealDoesNotHaveValidNonTaxCertificate.value : this.allowContractIfCustomerDealDoesNotHaveValidNonTaxCertificate),
        allowReceiveSubsWhenPositiveConflictExists: (allowReceiveSubsWhenPositiveConflictExists != null ? allowReceiveSubsWhenPositiveConflictExists.value : this.allowReceiveSubsWhenPositiveConflictExists),
        allowStagingOfUnreservedConsignedItems: (allowStagingOfUnreservedConsignedItems != null ? allowStagingOfUnreservedConsignedItems.value : this.allowStagingOfUnreservedConsignedItems),
        allowStagingOfUnapprovedItems: (allowStagingOfUnapprovedItems != null ? allowStagingOfUnapprovedItems.value : this.allowStagingOfUnapprovedItems),
        allowSubstitutesAtStaging: (allowSubstitutesAtStaging != null ? allowSubstitutesAtStaging.value : this.allowSubstitutesAtStaging),
        deleteOriginalOnSubstitution: (deleteOriginalOnSubstitution != null ? deleteOriginalOnSubstitution.value : this.deleteOriginalOnSubstitution),
        quikActivityAllowPrintDollarAmounts: (quikActivityAllowPrintDollarAmounts != null ? quikActivityAllowPrintDollarAmounts.value : this.quikActivityAllowPrintDollarAmounts),
        quikScanAllowCreateContract: (quikScanAllowCreateContract != null ? quikScanAllowCreateContract.value : this.quikScanAllowCreateContract),
        quikScanAllowApplyAll: (quikScanAllowApplyAll != null ? quikScanAllowApplyAll.value : this.quikScanAllowApplyAll),
        allowCrossICodeExchange: (allowCrossICodeExchange != null ? allowCrossICodeExchange.value : this.allowCrossICodeExchange),
        allowCrossICodePendingExchange: (allowCrossICodePendingExchange != null ? allowCrossICodePendingExchange.value : this.allowCrossICodePendingExchange),
        allowChangeAvailabilityPriority: (allowChangeAvailabilityPriority != null ? allowChangeAvailabilityPriority.value : this.allowChangeAvailabilityPriority),
        userMustChangePassword: (userMustChangePassword != null ? userMustChangePassword.value : this.userMustChangePassword),
        passwordExpires: (passwordExpires != null ? passwordExpires.value : this.passwordExpires),
        passwordExpireDays: (passwordExpireDays != null ? passwordExpireDays.value : this.passwordExpireDays),
        passwordUpdatedDateTime: (passwordUpdatedDateTime != null ? passwordUpdatedDateTime.value : this.passwordUpdatedDateTime),
        accountLocked: (accountLocked != null ? accountLocked.value : this.accountLocked),
        memo: (memo != null ? memo.value : this.memo),
        allowCrossLocationEditAndDelete: (allowCrossLocationEditAndDelete != null ? allowCrossLocationEditAndDelete.value : this.allowCrossLocationEditAndDelete),
        lastLoggedOn: (lastLoggedOn != null ? lastLoggedOn.value : this.lastLoggedOn),
        inactive: (inactive != null ? inactive.value : this.inactive),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        webUserId: (webUserId != null ? webUserId.value : this.webUserId),
        webAccess: (webAccess != null ? webAccess.value : this.webAccess),
        webAdministrator: (webAdministrator != null ? webAdministrator.value : this.webAdministrator),
        browseDefaultRows: (browseDefaultRows != null ? browseDefaultRows.value : this.browseDefaultRows),
        applicationTheme: (applicationTheme != null ? applicationTheme.value : this.applicationTheme),
        homeMenuGuid: (homeMenuGuid != null ? homeMenuGuid.value : this.homeMenuGuid),
        homeMenuPath: (homeMenuPath != null ? homeMenuPath.value : this.homeMenuPath),
        successSoundId: (successSoundId != null ? successSoundId.value : this.successSoundId),
        successSound: (successSound != null ? successSound.value : this.successSound),
        successBase64Sound: (successBase64Sound != null ? successBase64Sound.value : this.successBase64Sound),
        errorSoundId: (errorSoundId != null ? errorSoundId.value : this.errorSoundId),
        errorSound: (errorSound != null ? errorSound.value : this.errorSound),
        errorBase64Sound: (errorBase64Sound != null ? errorBase64Sound.value : this.errorBase64Sound),
        notificationSoundId: (notificationSoundId != null ? notificationSoundId.value : this.notificationSoundId),
        notificationSound: (notificationSound != null ? notificationSound.value : this.notificationSound),
        notificationBase64Sound: (notificationBase64Sound != null ? notificationBase64Sound.value : this.notificationBase64Sound),
        firstDayOfWeek: (firstDayOfWeek != null ? firstDayOfWeek.value : this.firstDayOfWeek),
        settingsNavigationMenuVisible: (settingsNavigationMenuVisible != null ? settingsNavigationMenuVisible.value : this.settingsNavigationMenuVisible),
        reportsNavigationMenuVisible: (reportsNavigationMenuVisible != null ? reportsNavigationMenuVisible.value : this.reportsNavigationMenuVisible),
        webQuoteRequest: (webQuoteRequest != null ? webQuoteRequest.value : this.webQuoteRequest),
        emailSignature: (emailSignature != null ? emailSignature.value : this.emailSignature),
        locale: (locale != null ? locale.value : this.locale),
        recordTitle: (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null ? defaultFieldAttributes.value : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorUserUserCountResponse {
  WebApiModulesAdministratorUserUserCountResponse({
    this.maxConnections,
    this.userCount,
  });

  factory WebApiModulesAdministratorUserUserCountResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorUserUserCountResponseFromJson(json);

  @JsonKey(name: 'MaxConnections', includeIfNull: false)
  final int? maxConnections;
  @JsonKey(name: 'UserCount', includeIfNull: false)
  final int? userCount;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorUserUserCountResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorUserUserCountResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorUserUserCountResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorUserUserCountResponse &&
            (identical(other.maxConnections, maxConnections) ||
                const DeepCollectionEquality()
                    .equals(other.maxConnections, maxConnections)) &&
            (identical(other.userCount, userCount) ||
                const DeepCollectionEquality()
                    .equals(other.userCount, userCount)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(maxConnections) ^
      const DeepCollectionEquality().hash(userCount) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorUserUserCountResponseExtension
    on WebApiModulesAdministratorUserUserCountResponse {
  WebApiModulesAdministratorUserUserCountResponse copyWith(
      {int? maxConnections, int? userCount}) {
    return WebApiModulesAdministratorUserUserCountResponse(
        maxConnections: maxConnections ?? this.maxConnections,
        userCount: userCount ?? this.userCount);
  }

  WebApiModulesAdministratorUserUserCountResponse copyWithWrapped(
      {Wrapped<int?>? maxConnections, Wrapped<int?>? userCount}) {
    return WebApiModulesAdministratorUserUserCountResponse(
        maxConnections: (maxConnections != null
            ? maxConnections.value
            : this.maxConnections),
        userCount: (userCount != null ? userCount.value : this.userCount));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup {
  WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup({
    this.customFormGroupId,
    this.customFormId,
    this.customFormDescription,
    this.groupId,
    this.groupName,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupFromJson(
          json);

  @JsonKey(name: 'CustomFormGroupId', includeIfNull: false, defaultValue: '')
  final String? customFormGroupId;
  @JsonKey(name: 'CustomFormId', includeIfNull: false, defaultValue: '')
  final String? customFormId;
  @JsonKey(
      name: 'CustomFormDescription', includeIfNull: false, defaultValue: '')
  final String? customFormDescription;
  @JsonKey(name: 'GroupId', includeIfNull: false, defaultValue: '')
  final String? groupId;
  @JsonKey(name: 'GroupName', includeIfNull: false, defaultValue: '')
  final String? groupName;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup &&
            (identical(other.customFormGroupId, customFormGroupId) ||
                const DeepCollectionEquality()
                    .equals(other.customFormGroupId, customFormGroupId)) &&
            (identical(other.customFormId, customFormId) ||
                const DeepCollectionEquality()
                    .equals(other.customFormId, customFormId)) &&
            (identical(other.customFormDescription, customFormDescription) ||
                const DeepCollectionEquality().equals(
                    other.customFormDescription, customFormDescription)) &&
            (identical(other.groupId, groupId) ||
                const DeepCollectionEquality()
                    .equals(other.groupId, groupId)) &&
            (identical(other.groupName, groupName) ||
                const DeepCollectionEquality()
                    .equals(other.groupName, groupName)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(customFormGroupId) ^
      const DeepCollectionEquality().hash(customFormId) ^
      const DeepCollectionEquality().hash(customFormDescription) ^
      const DeepCollectionEquality().hash(groupId) ^
      const DeepCollectionEquality().hash(groupName) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroupExtension
    on WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup {
  WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup copyWith(
      {String? customFormGroupId,
      String? customFormId,
      String? customFormDescription,
      String? groupId,
      String? groupName,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup(
        customFormGroupId: customFormGroupId ?? this.customFormGroupId,
        customFormId: customFormId ?? this.customFormId,
        customFormDescription:
            customFormDescription ?? this.customFormDescription,
        groupId: groupId ?? this.groupId,
        groupName: groupName ?? this.groupName,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup
      copyWithWrapped(
          {Wrapped<String?>? customFormGroupId,
          Wrapped<String?>? customFormId,
          Wrapped<String?>? customFormDescription,
          Wrapped<String?>? groupId,
          Wrapped<String?>? groupName,
          Wrapped<String?>? dateStamp,
          Wrapped<String?>? recordTitle,
          Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
              fields,
          Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
          Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
              defaultFieldAttributes}) {
    return WebApiModulesAdministratorControlsCustomFormGroupCustomFormGroup(
        customFormGroupId: (customFormGroupId != null
            ? customFormGroupId.value
            : this.customFormGroupId),
        customFormId:
            (customFormId != null ? customFormId.value : this.customFormId),
        customFormDescription: (customFormDescription != null
            ? customFormDescription.value
            : this.customFormDescription),
        groupId: (groupId != null ? groupId.value : this.groupId),
        groupName: (groupName != null ? groupName.value : this.groupName),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorControlsCustomFormUserCustomFormUser {
  WebApiModulesAdministratorControlsCustomFormUserCustomFormUser({
    this.customFormUserId,
    this.customFormId,
    this.customFormDescription,
    this.webUserId,
    this.userId,
    this.userName,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAdministratorControlsCustomFormUserCustomFormUser.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorControlsCustomFormUserCustomFormUserFromJson(
          json);

  @JsonKey(name: 'CustomFormUserId', includeIfNull: false, defaultValue: '')
  final String? customFormUserId;
  @JsonKey(name: 'CustomFormId', includeIfNull: false, defaultValue: '')
  final String? customFormId;
  @JsonKey(
      name: 'CustomFormDescription', includeIfNull: false, defaultValue: '')
  final String? customFormDescription;
  @JsonKey(name: 'WebUserId', includeIfNull: false, defaultValue: '')
  final String? webUserId;
  @JsonKey(name: 'UserId', includeIfNull: false, defaultValue: '')
  final String? userId;
  @JsonKey(name: 'UserName', includeIfNull: false, defaultValue: '')
  final String? userName;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorControlsCustomFormUserCustomFormUserFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorControlsCustomFormUserCustomFormUserToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorControlsCustomFormUserCustomFormUserToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorControlsCustomFormUserCustomFormUser &&
            (identical(other.customFormUserId, customFormUserId) ||
                const DeepCollectionEquality()
                    .equals(other.customFormUserId, customFormUserId)) &&
            (identical(other.customFormId, customFormId) ||
                const DeepCollectionEquality()
                    .equals(other.customFormId, customFormId)) &&
            (identical(other.customFormDescription, customFormDescription) ||
                const DeepCollectionEquality().equals(
                    other.customFormDescription, customFormDescription)) &&
            (identical(other.webUserId, webUserId) ||
                const DeepCollectionEquality()
                    .equals(other.webUserId, webUserId)) &&
            (identical(other.userId, userId) ||
                const DeepCollectionEquality().equals(other.userId, userId)) &&
            (identical(other.userName, userName) ||
                const DeepCollectionEquality()
                    .equals(other.userName, userName)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(customFormUserId) ^
      const DeepCollectionEquality().hash(customFormId) ^
      const DeepCollectionEquality().hash(customFormDescription) ^
      const DeepCollectionEquality().hash(webUserId) ^
      const DeepCollectionEquality().hash(userId) ^
      const DeepCollectionEquality().hash(userName) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorControlsCustomFormUserCustomFormUserExtension
    on WebApiModulesAdministratorControlsCustomFormUserCustomFormUser {
  WebApiModulesAdministratorControlsCustomFormUserCustomFormUser copyWith(
      {String? customFormUserId,
      String? customFormId,
      String? customFormDescription,
      String? webUserId,
      String? userId,
      String? userName,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAdministratorControlsCustomFormUserCustomFormUser(
        customFormUserId: customFormUserId ?? this.customFormUserId,
        customFormId: customFormId ?? this.customFormId,
        customFormDescription:
            customFormDescription ?? this.customFormDescription,
        webUserId: webUserId ?? this.webUserId,
        userId: userId ?? this.userId,
        userName: userName ?? this.userName,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesAdministratorControlsCustomFormUserCustomFormUser
      copyWithWrapped(
          {Wrapped<String?>? customFormUserId,
          Wrapped<String?>? customFormId,
          Wrapped<String?>? customFormDescription,
          Wrapped<String?>? webUserId,
          Wrapped<String?>? userId,
          Wrapped<String?>? userName,
          Wrapped<String?>? dateStamp,
          Wrapped<String?>? recordTitle,
          Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
              fields,
          Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
          Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
              defaultFieldAttributes}) {
    return WebApiModulesAdministratorControlsCustomFormUserCustomFormUser(
        customFormUserId: (customFormUserId != null
            ? customFormUserId.value
            : this.customFormUserId),
        customFormId:
            (customFormId != null ? customFormId.value : this.customFormId),
        customFormDescription: (customFormDescription != null
            ? customFormDescription.value
            : this.customFormDescription),
        webUserId: (webUserId != null ? webUserId.value : this.webUserId),
        userId: (userId != null ? userId.value : this.userId),
        userName: (userName != null ? userName.value : this.userName),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorControlsCustomModuleCustomModule {
  WebApiModulesAdministratorControlsCustomModuleCustomModule({
    this.moduleName,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAdministratorControlsCustomModuleCustomModule.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorControlsCustomModuleCustomModuleFromJson(
          json);

  @JsonKey(name: 'ModuleName', includeIfNull: false, defaultValue: '')
  final String? moduleName;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorControlsCustomModuleCustomModuleFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorControlsCustomModuleCustomModuleToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorControlsCustomModuleCustomModuleToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorControlsCustomModuleCustomModule &&
            (identical(other.moduleName, moduleName) ||
                const DeepCollectionEquality()
                    .equals(other.moduleName, moduleName)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(moduleName) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorControlsCustomModuleCustomModuleExtension
    on WebApiModulesAdministratorControlsCustomModuleCustomModule {
  WebApiModulesAdministratorControlsCustomModuleCustomModule copyWith(
      {String? moduleName,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAdministratorControlsCustomModuleCustomModule(
        moduleName: moduleName ?? this.moduleName,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesAdministratorControlsCustomModuleCustomModule copyWithWrapped(
      {Wrapped<String?>? moduleName,
      Wrapped<String?>? recordTitle,
      Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
          fields,
      Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
      Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
          defaultFieldAttributes}) {
    return WebApiModulesAdministratorControlsCustomModuleCustomModule(
        moduleName: (moduleName != null ? moduleName.value : this.moduleName),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup {
  WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup({
    this.customReportLayoutGroupId,
    this.customReportLayoutId,
    this.customReportLayoutDescription,
    this.groupId,
    this.groupName,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupFromJson(
          json);

  @JsonKey(
      name: 'CustomReportLayoutGroupId', includeIfNull: false, defaultValue: '')
  final String? customReportLayoutGroupId;
  @JsonKey(name: 'CustomReportLayoutId', includeIfNull: false, defaultValue: '')
  final String? customReportLayoutId;
  @JsonKey(
      name: 'CustomReportLayoutDescription',
      includeIfNull: false,
      defaultValue: '')
  final String? customReportLayoutDescription;
  @JsonKey(name: 'GroupId', includeIfNull: false, defaultValue: '')
  final String? groupId;
  @JsonKey(name: 'GroupName', includeIfNull: false, defaultValue: '')
  final String? groupName;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup &&
            (identical(other.customReportLayoutGroupId, customReportLayoutGroupId) ||
                const DeepCollectionEquality().equals(
                    other.customReportLayoutGroupId,
                    customReportLayoutGroupId)) &&
            (identical(other.customReportLayoutId, customReportLayoutId) ||
                const DeepCollectionEquality().equals(
                    other.customReportLayoutId, customReportLayoutId)) &&
            (identical(other.customReportLayoutDescription,
                    customReportLayoutDescription) ||
                const DeepCollectionEquality().equals(
                    other.customReportLayoutDescription,
                    customReportLayoutDescription)) &&
            (identical(other.groupId, groupId) ||
                const DeepCollectionEquality()
                    .equals(other.groupId, groupId)) &&
            (identical(other.groupName, groupName) ||
                const DeepCollectionEquality()
                    .equals(other.groupName, groupName)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(customReportLayoutGroupId) ^
      const DeepCollectionEquality().hash(customReportLayoutId) ^
      const DeepCollectionEquality().hash(customReportLayoutDescription) ^
      const DeepCollectionEquality().hash(groupId) ^
      const DeepCollectionEquality().hash(groupName) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroupExtension
    on WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup {
  WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup
      copyWith(
          {String? customReportLayoutGroupId,
          String? customReportLayoutId,
          String? customReportLayoutDescription,
          String? groupId,
          String? groupName,
          String? dateStamp,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup(
        customReportLayoutGroupId:
            customReportLayoutGroupId ?? this.customReportLayoutGroupId,
        customReportLayoutId: customReportLayoutId ?? this.customReportLayoutId,
        customReportLayoutDescription:
            customReportLayoutDescription ?? this.customReportLayoutDescription,
        groupId: groupId ?? this.groupId,
        groupName: groupName ?? this.groupName,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup
      copyWithWrapped(
          {Wrapped<String?>? customReportLayoutGroupId,
          Wrapped<String?>? customReportLayoutId,
          Wrapped<String?>? customReportLayoutDescription,
          Wrapped<String?>? groupId,
          Wrapped<String?>? groupName,
          Wrapped<String?>? dateStamp,
          Wrapped<String?>? recordTitle,
          Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
              fields,
          Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
          Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
              defaultFieldAttributes}) {
    return WebApiModulesAdministratorControlsCustomReportLayoutGroupCustomReportLayoutGroup(
        customReportLayoutGroupId: (customReportLayoutGroupId != null
            ? customReportLayoutGroupId.value
            : this.customReportLayoutGroupId),
        customReportLayoutId: (customReportLayoutId != null
            ? customReportLayoutId.value
            : this.customReportLayoutId),
        customReportLayoutDescription: (customReportLayoutDescription != null
            ? customReportLayoutDescription.value
            : this.customReportLayoutDescription),
        groupId: (groupId != null ? groupId.value : this.groupId),
        groupName: (groupName != null ? groupName.value : this.groupName),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField {
  WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField({
    this.duplicateRuleFieldId,
    this.duplicateRuleId,
    this.fieldName,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldFromJson(
          json);

  @JsonKey(name: 'DuplicateRuleFieldId', includeIfNull: false, defaultValue: '')
  final String? duplicateRuleFieldId;
  @JsonKey(name: 'DuplicateRuleId', includeIfNull: false, defaultValue: '')
  final String? duplicateRuleId;
  @JsonKey(name: 'FieldName', includeIfNull: false, defaultValue: '')
  final String? fieldName;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldFromJson;
  static const toJsonFactory =
      _$WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField &&
            (identical(other.duplicateRuleFieldId, duplicateRuleFieldId) ||
                const DeepCollectionEquality().equals(
                    other.duplicateRuleFieldId, duplicateRuleFieldId)) &&
            (identical(other.duplicateRuleId, duplicateRuleId) ||
                const DeepCollectionEquality()
                    .equals(other.duplicateRuleId, duplicateRuleId)) &&
            (identical(other.fieldName, fieldName) ||
                const DeepCollectionEquality()
                    .equals(other.fieldName, fieldName)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(duplicateRuleFieldId) ^
      const DeepCollectionEquality().hash(duplicateRuleId) ^
      const DeepCollectionEquality().hash(fieldName) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleFieldExtension
    on WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField {
  WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField
      copyWith(
          {String? duplicateRuleFieldId,
          String? duplicateRuleId,
          String? fieldName,
          String? dateStamp,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField(
        duplicateRuleFieldId: duplicateRuleFieldId ?? this.duplicateRuleFieldId,
        duplicateRuleId: duplicateRuleId ?? this.duplicateRuleId,
        fieldName: fieldName ?? this.fieldName,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField
      copyWithWrapped(
          {Wrapped<String?>? duplicateRuleFieldId,
          Wrapped<String?>? duplicateRuleId,
          Wrapped<String?>? fieldName,
          Wrapped<String?>? dateStamp,
          Wrapped<String?>? recordTitle,
          Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
              fields,
          Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
          Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
              defaultFieldAttributes}) {
    return WebApiModulesAdministratorControlsDuplicateRuleFieldDuplicateRuleField(
        duplicateRuleFieldId: (duplicateRuleFieldId != null
            ? duplicateRuleFieldId.value
            : this.duplicateRuleFieldId),
        duplicateRuleId: (duplicateRuleId != null
            ? duplicateRuleId.value
            : this.duplicateRuleId),
        fieldName: (fieldName != null ? fieldName.value : this.fieldName),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesSettingsWidgetGroupWidgetGroup {
  WebApiModulesSettingsWidgetGroupWidgetGroup({
    this.widgetGroupId,
    this.widgetId,
    this.widgetDescription,
    this.groupId,
    this.groupName,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesSettingsWidgetGroupWidgetGroup.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesSettingsWidgetGroupWidgetGroupFromJson(json);

  @JsonKey(name: 'WidgetGroupId', includeIfNull: false, defaultValue: '')
  final String? widgetGroupId;
  @JsonKey(name: 'WidgetId', includeIfNull: false, defaultValue: '')
  final String? widgetId;
  @JsonKey(name: 'WidgetDescription', includeIfNull: false, defaultValue: '')
  final String? widgetDescription;
  @JsonKey(name: 'GroupId', includeIfNull: false, defaultValue: '')
  final String? groupId;
  @JsonKey(name: 'GroupName', includeIfNull: false, defaultValue: '')
  final String? groupName;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesSettingsWidgetGroupWidgetGroupFromJson;
  static const toJsonFactory =
      _$WebApiModulesSettingsWidgetGroupWidgetGroupToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesSettingsWidgetGroupWidgetGroupToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesSettingsWidgetGroupWidgetGroup &&
            (identical(other.widgetGroupId, widgetGroupId) ||
                const DeepCollectionEquality()
                    .equals(other.widgetGroupId, widgetGroupId)) &&
            (identical(other.widgetId, widgetId) ||
                const DeepCollectionEquality()
                    .equals(other.widgetId, widgetId)) &&
            (identical(other.widgetDescription, widgetDescription) ||
                const DeepCollectionEquality()
                    .equals(other.widgetDescription, widgetDescription)) &&
            (identical(other.groupId, groupId) ||
                const DeepCollectionEquality()
                    .equals(other.groupId, groupId)) &&
            (identical(other.groupName, groupName) ||
                const DeepCollectionEquality()
                    .equals(other.groupName, groupName)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(widgetGroupId) ^
      const DeepCollectionEquality().hash(widgetId) ^
      const DeepCollectionEquality().hash(widgetDescription) ^
      const DeepCollectionEquality().hash(groupId) ^
      const DeepCollectionEquality().hash(groupName) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesSettingsWidgetGroupWidgetGroupExtension
    on WebApiModulesSettingsWidgetGroupWidgetGroup {
  WebApiModulesSettingsWidgetGroupWidgetGroup copyWith(
      {String? widgetGroupId,
      String? widgetId,
      String? widgetDescription,
      String? groupId,
      String? groupName,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesSettingsWidgetGroupWidgetGroup(
        widgetGroupId: widgetGroupId ?? this.widgetGroupId,
        widgetId: widgetId ?? this.widgetId,
        widgetDescription: widgetDescription ?? this.widgetDescription,
        groupId: groupId ?? this.groupId,
        groupName: groupName ?? this.groupName,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesSettingsWidgetGroupWidgetGroup copyWithWrapped(
      {Wrapped<String?>? widgetGroupId,
      Wrapped<String?>? widgetId,
      Wrapped<String?>? widgetDescription,
      Wrapped<String?>? groupId,
      Wrapped<String?>? groupName,
      Wrapped<String?>? dateStamp,
      Wrapped<String?>? recordTitle,
      Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
          fields,
      Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
      Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
          defaultFieldAttributes}) {
    return WebApiModulesSettingsWidgetGroupWidgetGroup(
        widgetGroupId:
            (widgetGroupId != null ? widgetGroupId.value : this.widgetGroupId),
        widgetId: (widgetId != null ? widgetId.value : this.widgetId),
        widgetDescription: (widgetDescription != null
            ? widgetDescription.value
            : this.widgetDescription),
        groupId: (groupId != null ? groupId.value : this.groupId),
        groupName: (groupName != null ? groupName.value : this.groupName),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesSettingsWidgetUserWidgetUser {
  WebApiModulesSettingsWidgetUserWidgetUser({
    this.widgetUserId,
    this.widgetId,
    this.widgetDescription,
    this.webUserId,
    this.userId,
    this.userName,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesSettingsWidgetUserWidgetUser.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesSettingsWidgetUserWidgetUserFromJson(json);

  @JsonKey(name: 'WidgetUserId', includeIfNull: false, defaultValue: '')
  final String? widgetUserId;
  @JsonKey(name: 'WidgetId', includeIfNull: false, defaultValue: '')
  final String? widgetId;
  @JsonKey(name: 'WidgetDescription', includeIfNull: false, defaultValue: '')
  final String? widgetDescription;
  @JsonKey(name: 'WebUserId', includeIfNull: false, defaultValue: '')
  final String? webUserId;
  @JsonKey(name: 'UserId', includeIfNull: false, defaultValue: '')
  final String? userId;
  @JsonKey(name: 'UserName', includeIfNull: false, defaultValue: '')
  final String? userName;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesSettingsWidgetUserWidgetUserFromJson;
  static const toJsonFactory =
      _$WebApiModulesSettingsWidgetUserWidgetUserToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesSettingsWidgetUserWidgetUserToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesSettingsWidgetUserWidgetUser &&
            (identical(other.widgetUserId, widgetUserId) ||
                const DeepCollectionEquality()
                    .equals(other.widgetUserId, widgetUserId)) &&
            (identical(other.widgetId, widgetId) ||
                const DeepCollectionEquality()
                    .equals(other.widgetId, widgetId)) &&
            (identical(other.widgetDescription, widgetDescription) ||
                const DeepCollectionEquality()
                    .equals(other.widgetDescription, widgetDescription)) &&
            (identical(other.webUserId, webUserId) ||
                const DeepCollectionEquality()
                    .equals(other.webUserId, webUserId)) &&
            (identical(other.userId, userId) ||
                const DeepCollectionEquality().equals(other.userId, userId)) &&
            (identical(other.userName, userName) ||
                const DeepCollectionEquality()
                    .equals(other.userName, userName)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(widgetUserId) ^
      const DeepCollectionEquality().hash(widgetId) ^
      const DeepCollectionEquality().hash(widgetDescription) ^
      const DeepCollectionEquality().hash(webUserId) ^
      const DeepCollectionEquality().hash(userId) ^
      const DeepCollectionEquality().hash(userName) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesSettingsWidgetUserWidgetUserExtension
    on WebApiModulesSettingsWidgetUserWidgetUser {
  WebApiModulesSettingsWidgetUserWidgetUser copyWith(
      {String? widgetUserId,
      String? widgetId,
      String? widgetDescription,
      String? webUserId,
      String? userId,
      String? userName,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesSettingsWidgetUserWidgetUser(
        widgetUserId: widgetUserId ?? this.widgetUserId,
        widgetId: widgetId ?? this.widgetId,
        widgetDescription: widgetDescription ?? this.widgetDescription,
        webUserId: webUserId ?? this.webUserId,
        userId: userId ?? this.userId,
        userName: userName ?? this.userName,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesSettingsWidgetUserWidgetUser copyWithWrapped(
      {Wrapped<String?>? widgetUserId,
      Wrapped<String?>? widgetId,
      Wrapped<String?>? widgetDescription,
      Wrapped<String?>? webUserId,
      Wrapped<String?>? userId,
      Wrapped<String?>? userName,
      Wrapped<String?>? dateStamp,
      Wrapped<String?>? recordTitle,
      Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
          fields,
      Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
      Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
          defaultFieldAttributes}) {
    return WebApiModulesSettingsWidgetUserWidgetUser(
        widgetUserId:
            (widgetUserId != null ? widgetUserId.value : this.widgetUserId),
        widgetId: (widgetId != null ? widgetId.value : this.widgetId),
        widgetDescription: (widgetDescription != null
            ? widgetDescription.value
            : this.widgetDescription),
        webUserId: (webUserId != null ? webUserId.value : this.webUserId),
        userId: (userId != null ? userId.value : this.userId),
        userName: (userName != null ? userName.value : this.userName),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser {
  WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser({
    this.customReportLayoutUserId,
    this.customReportLayoutId,
    this.customReportLayoutDescription,
    this.webUserId,
    this.userId,
    this.userName,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserFromJson(
          json);

  @JsonKey(
      name: 'CustomReportLayoutUserId', includeIfNull: false, defaultValue: '')
  final String? customReportLayoutUserId;
  @JsonKey(name: 'CustomReportLayoutId', includeIfNull: false, defaultValue: '')
  final String? customReportLayoutId;
  @JsonKey(
      name: 'CustomReportLayoutDescription',
      includeIfNull: false,
      defaultValue: '')
  final String? customReportLayoutDescription;
  @JsonKey(name: 'WebUserId', includeIfNull: false, defaultValue: '')
  final String? webUserId;
  @JsonKey(name: 'UserId', includeIfNull: false, defaultValue: '')
  final String? userId;
  @JsonKey(name: 'UserName', includeIfNull: false, defaultValue: '')
  final String? userName;
  @JsonKey(name: 'DateStamp', includeIfNull: false, defaultValue: '')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle', includeIfNull: false, defaultValue: '')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      includeIfNull: false,
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: '_Custom',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      includeIfNull: false,
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserFromJson;
  static const toJsonFactory =
      _$WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser &&
            (identical(other.customReportLayoutUserId, customReportLayoutUserId) ||
                const DeepCollectionEquality().equals(
                    other.customReportLayoutUserId,
                    customReportLayoutUserId)) &&
            (identical(other.customReportLayoutId, customReportLayoutId) ||
                const DeepCollectionEquality().equals(
                    other.customReportLayoutId, customReportLayoutId)) &&
            (identical(other.customReportLayoutDescription, customReportLayoutDescription) ||
                const DeepCollectionEquality().equals(
                    other.customReportLayoutDescription,
                    customReportLayoutDescription)) &&
            (identical(other.webUserId, webUserId) ||
                const DeepCollectionEquality()
                    .equals(other.webUserId, webUserId)) &&
            (identical(other.userId, userId) ||
                const DeepCollectionEquality().equals(other.userId, userId)) &&
            (identical(other.userName, userName) ||
                const DeepCollectionEquality()
                    .equals(other.userName, userName)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(customReportLayoutUserId) ^
      const DeepCollectionEquality().hash(customReportLayoutId) ^
      const DeepCollectionEquality().hash(customReportLayoutDescription) ^
      const DeepCollectionEquality().hash(webUserId) ^
      const DeepCollectionEquality().hash(userId) ^
      const DeepCollectionEquality().hash(userName) ^
      const DeepCollectionEquality().hash(dateStamp) ^
      const DeepCollectionEquality().hash(recordTitle) ^
      const DeepCollectionEquality().hash(fields) ^
      const DeepCollectionEquality().hash(custom) ^
      const DeepCollectionEquality().hash(defaultFieldAttributes) ^
      runtimeType.hashCode;
}

extension $WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUserExtension
    on WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser {
  WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser
      copyWith(
          {String? customReportLayoutUserId,
          String? customReportLayoutId,
          String? customReportLayoutDescription,
          String? webUserId,
          String? userId,
          String? userName,
          String? dateStamp,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser(
        customReportLayoutUserId:
            customReportLayoutUserId ?? this.customReportLayoutUserId,
        customReportLayoutId: customReportLayoutId ?? this.customReportLayoutId,
        customReportLayoutDescription:
            customReportLayoutDescription ?? this.customReportLayoutDescription,
        webUserId: webUserId ?? this.webUserId,
        userId: userId ?? this.userId,
        userName: userName ?? this.userName,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }

  WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser
      copyWithWrapped(
          {Wrapped<String?>? customReportLayoutUserId,
          Wrapped<String?>? customReportLayoutId,
          Wrapped<String?>? customReportLayoutDescription,
          Wrapped<String?>? webUserId,
          Wrapped<String?>? userId,
          Wrapped<String?>? userName,
          Wrapped<String?>? dateStamp,
          Wrapped<String?>? recordTitle,
          Wrapped<List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>?>?
              fields,
          Wrapped<List<FwStandardDataFwCustomValue>?>? custom,
          Wrapped<List<FwStandardDataFwDefaultAttribute>?>?
              defaultFieldAttributes}) {
    return WebApiModulesSharedControlsCustomReportLayoutUserCustomReportLayoutUser(
        customReportLayoutUserId: (customReportLayoutUserId != null
            ? customReportLayoutUserId.value
            : this.customReportLayoutUserId),
        customReportLayoutId: (customReportLayoutId != null
            ? customReportLayoutId.value
            : this.customReportLayoutId),
        customReportLayoutDescription: (customReportLayoutDescription != null
            ? customReportLayoutDescription.value
            : this.customReportLayoutDescription),
        webUserId: (webUserId != null ? webUserId.value : this.webUserId),
        userId: (userId != null ? userId.value : this.userId),
        userName: (userName != null ? userName.value : this.userName),
        dateStamp: (dateStamp != null ? dateStamp.value : this.dateStamp),
        recordTitle:
            (recordTitle != null ? recordTitle.value : this.recordTitle),
        fields: (fields != null ? fields.value : this.fields),
        custom: (custom != null ? custom.value : this.custom),
        defaultFieldAttributes: (defaultFieldAttributes != null
            ? defaultFieldAttributes.value
            : this.defaultFieldAttributes));
  }
}

String? fwStandardSqlServerFwDataTypesToJson(
    enums.FwStandardSqlServerFwDataTypes? fwStandardSqlServerFwDataTypes) {
  return enums
      .$FwStandardSqlServerFwDataTypesMap[fwStandardSqlServerFwDataTypes];
}

enums.FwStandardSqlServerFwDataTypes fwStandardSqlServerFwDataTypesFromJson(
  Object? fwStandardSqlServerFwDataTypes, [
  enums.FwStandardSqlServerFwDataTypes? defaultValue,
]) {
  if (fwStandardSqlServerFwDataTypes is String) {
    return enums.$FwStandardSqlServerFwDataTypesMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                fwStandardSqlServerFwDataTypes.toLowerCase(),
            orElse: () => const MapEntry(
                enums.FwStandardSqlServerFwDataTypes.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$FwStandardSqlServerFwDataTypesMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.FwStandardSqlServerFwDataTypes.swaggerGeneratedUnknown;
}

List<String> fwStandardSqlServerFwDataTypesListToJson(
    List<enums.FwStandardSqlServerFwDataTypes>?
        fwStandardSqlServerFwDataTypes) {
  if (fwStandardSqlServerFwDataTypes == null) {
    return [];
  }

  return fwStandardSqlServerFwDataTypes
      .map((e) => enums.$FwStandardSqlServerFwDataTypesMap[e]!)
      .toList();
}

List<enums.FwStandardSqlServerFwDataTypes>
    fwStandardSqlServerFwDataTypesListFromJson(
  List? fwStandardSqlServerFwDataTypes, [
  List<enums.FwStandardSqlServerFwDataTypes>? defaultValue,
]) {
  if (fwStandardSqlServerFwDataTypes == null) {
    return defaultValue ?? [];
  }

  return fwStandardSqlServerFwDataTypes
      .map((e) => fwStandardSqlServerFwDataTypesFromJson(e.toString()))
      .toList();
}

List<enums.FwStandardSqlServerFwDataTypes>?
    fwStandardSqlServerFwDataTypesNullableListFromJson(
  List? fwStandardSqlServerFwDataTypes, [
  List<enums.FwStandardSqlServerFwDataTypes>? defaultValue,
]) {
  if (fwStandardSqlServerFwDataTypes == null) {
    return defaultValue;
  }

  return fwStandardSqlServerFwDataTypes
      .map((e) => fwStandardSqlServerFwDataTypesFromJson(e.toString()))
      .toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
