// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'nex_example.enums.swagger.dart' as enums;
export 'nex_example.enums.swagger.dart';

part 'nex_example.swagger.chopper.dart';
part 'nex_example.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class NexExample extends ChopperService {
  static NexExample create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$NexExample(client);
    }

    final newClient = ChopperClient(
        services: [_$NexExample()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://getcargo.express/api');
    return _$NexExample(newClient);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<CarCarGet$Response>> carCarGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CarCarGet$Response, () => CarCarGet$Response.fromJsonFactory);

    return _carCarGet(limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/car/car/')
  Future<chopper.Response<CarCarGet$Response>> _carCarGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Car>> carCarPost({
    required Car? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Car, () => Car.fromJsonFactory);

    return _carCarPost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/car/car/')
  Future<chopper.Response<Car>> _carCarPost({
    @Body() required Car? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<Car>> carCarIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Car, () => Car.fromJsonFactory);

    return _carCarIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/car/car/{id}/')
  Future<chopper.Response<Car>> _carCarIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Car>> carCarIdPut({
    required Car? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Car, () => Car.fromJsonFactory);

    return _carCarIdPut(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/car/car/{id}/')
  Future<chopper.Response<Car>> _carCarIdPut({
    @Body() required Car? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Car>> carCarIdPatch({
    required Car? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Car, () => Car.fromJsonFactory);

    return _carCarIdPatch(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/car/car/{id}/')
  Future<chopper.Response<Car>> _carCarIdPatch({
    @Body() required Car? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> carCarIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _carCarIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/car/car/{id}/')
  Future<chopper.Response> _carCarIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<CarPassportFileGet$Response>> carPassportFileGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CarPassportFileGet$Response,
        () => CarPassportFileGet$Response.fromJsonFactory);

    return _carPassportFileGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/car/passport_file/')
  Future<chopper.Response<CarPassportFileGet$Response>> _carPassportFileGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<CarPassportFile>> carPassportFilePost({
    required CarPassportFile? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CarPassportFile, () => CarPassportFile.fromJsonFactory);

    return _carPassportFilePost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/car/passport_file/')
  Future<chopper.Response<CarPassportFile>> _carPassportFilePost({
    @Body() required CarPassportFile? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<CarPassportFile>> carPassportFileIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CarPassportFile, () => CarPassportFile.fromJsonFactory);

    return _carPassportFileIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/car/passport_file/{id}/')
  Future<chopper.Response<CarPassportFile>> _carPassportFileIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> carPassportFileIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _carPassportFileIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/car/passport_file/{id}/')
  Future<chopper.Response> _carPassportFileIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<CarTrailerGet$Response>> carTrailerGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CarTrailerGet$Response, () => CarTrailerGet$Response.fromJsonFactory);

    return _carTrailerGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/car/trailer/')
  Future<chopper.Response<CarTrailerGet$Response>> _carTrailerGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Trailer>> carTrailerPost({
    required Trailer? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Trailer, () => Trailer.fromJsonFactory);

    return _carTrailerPost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/car/trailer/')
  Future<chopper.Response<Trailer>> _carTrailerPost({
    @Body() required Trailer? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<Trailer>> carTrailerIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Trailer, () => Trailer.fromJsonFactory);

    return _carTrailerIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/car/trailer/{id}/')
  Future<chopper.Response<Trailer>> _carTrailerIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Trailer>> carTrailerIdPut({
    required Trailer? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Trailer, () => Trailer.fromJsonFactory);

    return _carTrailerIdPut(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/car/trailer/{id}/')
  Future<chopper.Response<Trailer>> _carTrailerIdPut({
    @Body() required Trailer? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Trailer>> carTrailerIdPatch({
    required Trailer? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Trailer, () => Trailer.fromJsonFactory);

    return _carTrailerIdPatch(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/car/trailer/{id}/')
  Future<chopper.Response<Trailer>> _carTrailerIdPatch({
    @Body() required Trailer? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> carTrailerIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _carTrailerIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/car/trailer/{id}/')
  Future<chopper.Response> _carTrailerIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<CarTypeGet$Response>> carTypeGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CarTypeGet$Response, () => CarTypeGet$Response.fromJsonFactory);

    return _carTypeGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/car/type/')
  Future<chopper.Response<CarTypeGet$Response>> _carTypeGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<CarType>> carTypePost({
    required CarType? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CarType, () => CarType.fromJsonFactory);

    return _carTypePost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/car/type/')
  Future<chopper.Response<CarType>> _carTypePost({
    @Body() required CarType? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<CarType>> carTypeIdGet({
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CarType, () => CarType.fromJsonFactory);

    return _carTypeIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/car/type/{id}/')
  Future<chopper.Response<CarType>> _carTypeIdGet({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<CarType>> carTypeIdPut({
    required CarType? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CarType, () => CarType.fromJsonFactory);

    return _carTypeIdPut(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/car/type/{id}/')
  Future<chopper.Response<CarType>> _carTypeIdPut({
    @Body() required CarType? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<CarType>> carTypeIdPatch({
    required CarType? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CarType, () => CarType.fromJsonFactory);

    return _carTypeIdPatch(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/car/type/{id}/')
  Future<chopper.Response<CarType>> _carTypeIdPatch({
    @Body() required CarType? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> carTypeIdDelete({
    required int? id,
    String? cacheControl,
  }) {
    return _carTypeIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/car/type/{id}/')
  Future<chopper.Response> _carTypeIdDelete({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<CargoCargoGet$Response>> cargoCargoGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CargoCargoGet$Response, () => CargoCargoGet$Response.fromJsonFactory);

    return _cargoCargoGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/cargo/cargo/')
  Future<chopper.Response<CargoCargoGet$Response>> _cargoCargoGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Cargo>> cargoCargoPost({
    required Cargo? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Cargo, () => Cargo.fromJsonFactory);

    return _cargoCargoPost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/cargo/cargo/')
  Future<chopper.Response<Cargo>> _cargoCargoPost({
    @Body() required Cargo? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<Cargo>> cargoCargoIdGet({
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Cargo, () => Cargo.fromJsonFactory);

    return _cargoCargoIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/cargo/cargo/{id}/')
  Future<chopper.Response<Cargo>> _cargoCargoIdGet({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Cargo>> cargoCargoIdPut({
    required Cargo? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Cargo, () => Cargo.fromJsonFactory);

    return _cargoCargoIdPut(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/cargo/cargo/{id}/')
  Future<chopper.Response<Cargo>> _cargoCargoIdPut({
    @Body() required Cargo? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Cargo>> cargoCargoIdPatch({
    required Cargo? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Cargo, () => Cargo.fromJsonFactory);

    return _cargoCargoIdPatch(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/cargo/cargo/{id}/')
  Future<chopper.Response<Cargo>> _cargoCargoIdPatch({
    @Body() required Cargo? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> cargoCargoIdDelete({
    required int? id,
    String? cacheControl,
  }) {
    return _cargoCargoIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/cargo/cargo/{id}/')
  Future<chopper.Response> _cargoCargoIdDelete({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<CargoTypeGet$Response>> cargoTypeGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CargoTypeGet$Response, () => CargoTypeGet$Response.fromJsonFactory);

    return _cargoTypeGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/cargo/type/')
  Future<chopper.Response<CargoTypeGet$Response>> _cargoTypeGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<CargoType>> cargoTypePost({
    required CargoType? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CargoType, () => CargoType.fromJsonFactory);

    return _cargoTypePost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/cargo/type/')
  Future<chopper.Response<CargoType>> _cargoTypePost({
    @Body() required CargoType? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<CargoType>> cargoTypeIdGet({
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CargoType, () => CargoType.fromJsonFactory);

    return _cargoTypeIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/cargo/type/{id}/')
  Future<chopper.Response<CargoType>> _cargoTypeIdGet({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<CargoType>> cargoTypeIdPut({
    required CargoType? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CargoType, () => CargoType.fromJsonFactory);

    return _cargoTypeIdPut(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/cargo/type/{id}/')
  Future<chopper.Response<CargoType>> _cargoTypeIdPut({
    @Body() required CargoType? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<CargoType>> cargoTypeIdPatch({
    required CargoType? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CargoType, () => CargoType.fromJsonFactory);

    return _cargoTypeIdPatch(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/cargo/type/{id}/')
  Future<chopper.Response<CargoType>> _cargoTypeIdPatch({
    @Body() required CargoType? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> cargoTypeIdDelete({
    required int? id,
    String? cacheControl,
  }) {
    return _cargoTypeIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/cargo/type/{id}/')
  Future<chopper.Response> _cargoTypeIdDelete({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<CityCityGet$Response>> cityCityGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CityCityGet$Response, () => CityCityGet$Response.fromJsonFactory);

    return _cityCityGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/city/city/')
  Future<chopper.Response<CityCityGet$Response>> _cityCityGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<City>> cityCityPost({
    required City? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(City, () => City.fromJsonFactory);

    return _cityCityPost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/city/city/')
  Future<chopper.Response<City>> _cityCityPost({
    @Body() required City? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<City>> cityCityIdGet({
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(City, () => City.fromJsonFactory);

    return _cityCityIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/city/city/{id}/')
  Future<chopper.Response<City>> _cityCityIdGet({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<City>> cityCityIdPut({
    required City? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(City, () => City.fromJsonFactory);

    return _cityCityIdPut(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/city/city/{id}/')
  Future<chopper.Response<City>> _cityCityIdPut({
    @Body() required City? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<City>> cityCityIdPatch({
    required City? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(City, () => City.fromJsonFactory);

    return _cityCityIdPatch(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/city/city/{id}/')
  Future<chopper.Response<City>> _cityCityIdPatch({
    @Body() required City? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> cityCityIdDelete({
    required int? id,
    String? cacheControl,
  }) {
    return _cityCityIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/city/city/{id}/')
  Future<chopper.Response> _cityCityIdDelete({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<CompanyCompanyGet$Response>> companyCompanyGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CompanyCompanyGet$Response,
        () => CompanyCompanyGet$Response.fromJsonFactory);

    return _companyCompanyGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/company/company/')
  Future<chopper.Response<CompanyCompanyGet$Response>> _companyCompanyGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Company>> companyCompanyPost({
    required Company? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Company, () => Company.fromJsonFactory);

    return _companyCompanyPost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/company/company/')
  Future<chopper.Response<Company>> _companyCompanyPost({
    @Body() required Company? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<Company>> companyCompanyIdGet({
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Company, () => Company.fromJsonFactory);

    return _companyCompanyIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/company/company/{id}/')
  Future<chopper.Response<Company>> _companyCompanyIdGet({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Company>> companyCompanyIdPut({
    required Company? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Company, () => Company.fromJsonFactory);

    return _companyCompanyIdPut(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/company/company/{id}/')
  Future<chopper.Response<Company>> _companyCompanyIdPut({
    @Body() required Company? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Company>> companyCompanyIdPatch({
    required Company? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Company, () => Company.fromJsonFactory);

    return _companyCompanyIdPatch(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/company/company/{id}/')
  Future<chopper.Response<Company>> _companyCompanyIdPatch({
    @Body() required Company? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> companyCompanyIdDelete({
    required int? id,
    String? cacheControl,
  }) {
    return _companyCompanyIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/company/company/{id}/')
  Future<chopper.Response> _companyCompanyIdDelete({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<DealAdditionalInfoGet$Response>>
      dealAdditionalInfoGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(DealAdditionalInfoGet$Response,
        () => DealAdditionalInfoGet$Response.fromJsonFactory);

    return _dealAdditionalInfoGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/deal/additional_info/')
  Future<chopper.Response<DealAdditionalInfoGet$Response>>
      _dealAdditionalInfoGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<AdditionalInfo>> dealAdditionalInfoPost({
    required AdditionalInfo? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AdditionalInfo, () => AdditionalInfo.fromJsonFactory);

    return _dealAdditionalInfoPost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/deal/additional_info/')
  Future<chopper.Response<AdditionalInfo>> _dealAdditionalInfoPost({
    @Body() required AdditionalInfo? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<AdditionalInfo>> dealAdditionalInfoIdGet({
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AdditionalInfo, () => AdditionalInfo.fromJsonFactory);

    return _dealAdditionalInfoIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/deal/additional_info/{id}/')
  Future<chopper.Response<AdditionalInfo>> _dealAdditionalInfoIdGet({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<AdditionalInfo>> dealAdditionalInfoIdPut({
    required AdditionalInfo? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AdditionalInfo, () => AdditionalInfo.fromJsonFactory);

    return _dealAdditionalInfoIdPut(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/deal/additional_info/{id}/')
  Future<chopper.Response<AdditionalInfo>> _dealAdditionalInfoIdPut({
    @Body() required AdditionalInfo? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<AdditionalInfo>> dealAdditionalInfoIdPatch({
    required AdditionalInfo? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AdditionalInfo, () => AdditionalInfo.fromJsonFactory);

    return _dealAdditionalInfoIdPatch(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/deal/additional_info/{id}/')
  Future<chopper.Response<AdditionalInfo>> _dealAdditionalInfoIdPatch({
    @Body() required AdditionalInfo? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> dealAdditionalInfoIdDelete({
    required int? id,
    String? cacheControl,
  }) {
    return _dealAdditionalInfoIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/deal/additional_info/{id}/')
  Future<chopper.Response> _dealAdditionalInfoIdDelete({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<DealDealGet$Response>> dealDealGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        DealDealGet$Response, () => DealDealGet$Response.fromJsonFactory);

    return _dealDealGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/deal/deal/')
  Future<chopper.Response<DealDealGet$Response>> _dealDealGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Deal>> dealDealPost({
    required Deal? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Deal, () => Deal.fromJsonFactory);

    return _dealDealPost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/deal/deal/')
  Future<chopper.Response<Deal>> _dealDealPost({
    @Body() required Deal? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<Deal>> dealDealIdGet({
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Deal, () => Deal.fromJsonFactory);

    return _dealDealIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/deal/deal/{id}/')
  Future<chopper.Response<Deal>> _dealDealIdGet({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Deal>> dealDealIdPut({
    required Deal? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Deal, () => Deal.fromJsonFactory);

    return _dealDealIdPut(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/deal/deal/{id}/')
  Future<chopper.Response<Deal>> _dealDealIdPut({
    @Body() required Deal? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Deal>> dealDealIdPatch({
    required Deal? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Deal, () => Deal.fromJsonFactory);

    return _dealDealIdPatch(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/deal/deal/{id}/')
  Future<chopper.Response<Deal>> _dealDealIdPatch({
    @Body() required Deal? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> dealDealIdDelete({
    required int? id,
    String? cacheControl,
  }) {
    return _dealDealIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/deal/deal/{id}/')
  Future<chopper.Response> _dealDealIdDelete({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<TokenObtainPair>> tokenPost({
    required TokenObtainPair? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        TokenObtainPair, () => TokenObtainPair.fromJsonFactory);

    return _tokenPost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/token/')
  Future<chopper.Response<TokenObtainPair>> _tokenPost({
    @Body() required TokenObtainPair? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<TokenRefresh>> tokenRefreshPost({
    required TokenRefresh? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        TokenRefresh, () => TokenRefresh.fromJsonFactory);

    return _tokenRefreshPost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/token/refresh/')
  Future<chopper.Response<TokenRefresh>> _tokenRefreshPost({
    @Body() required TokenRefresh? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<UserCarriageAgreementGet$Response>>
      userCarriageAgreementGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(UserCarriageAgreementGet$Response,
        () => UserCarriageAgreementGet$Response.fromJsonFactory);

    return _userCarriageAgreementGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/user/carriage_agreement/')
  Future<chopper.Response<UserCarriageAgreementGet$Response>>
      _userCarriageAgreementGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<CarriageAgreement>> userCarriageAgreementPost({
    required CarriageAgreement? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CarriageAgreement, () => CarriageAgreement.fromJsonFactory);

    return _userCarriageAgreementPost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/user/carriage_agreement/')
  Future<chopper.Response<CarriageAgreement>> _userCarriageAgreementPost({
    @Body() required CarriageAgreement? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<CarriageAgreement>> userCarriageAgreementIdGet({
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CarriageAgreement, () => CarriageAgreement.fromJsonFactory);

    return _userCarriageAgreementIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/user/carriage_agreement/{id}/')
  Future<chopper.Response<CarriageAgreement>> _userCarriageAgreementIdGet({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<CarriageAgreement>> userCarriageAgreementIdPut({
    required CarriageAgreement? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CarriageAgreement, () => CarriageAgreement.fromJsonFactory);

    return _userCarriageAgreementIdPut(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/user/carriage_agreement/{id}/')
  Future<chopper.Response<CarriageAgreement>> _userCarriageAgreementIdPut({
    @Body() required CarriageAgreement? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<CarriageAgreement>> userCarriageAgreementIdPatch({
    required CarriageAgreement? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CarriageAgreement, () => CarriageAgreement.fromJsonFactory);

    return _userCarriageAgreementIdPatch(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/user/carriage_agreement/{id}/')
  Future<chopper.Response<CarriageAgreement>> _userCarriageAgreementIdPatch({
    @Body() required CarriageAgreement? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> userCarriageAgreementIdDelete({
    required int? id,
    String? cacheControl,
  }) {
    return _userCarriageAgreementIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/user/carriage_agreement/{id}/')
  Future<chopper.Response> _userCarriageAgreementIdDelete({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<UserContactInfoGet$Response>> userContactInfoGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(UserContactInfoGet$Response,
        () => UserContactInfoGet$Response.fromJsonFactory);

    return _userContactInfoGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/user/contact-info/')
  Future<chopper.Response<UserContactInfoGet$Response>> _userContactInfoGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<ContactInfo>> userContactInfoPost({
    required ContactInfo? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ContactInfo, () => ContactInfo.fromJsonFactory);

    return _userContactInfoPost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/user/contact-info/')
  Future<chopper.Response<ContactInfo>> _userContactInfoPost({
    @Body() required ContactInfo? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<ContactInfo>> userContactInfoIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ContactInfo, () => ContactInfo.fromJsonFactory);

    return _userContactInfoIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/user/contact-info/{id}/')
  Future<chopper.Response<ContactInfo>> _userContactInfoIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<ContactInfo>> userContactInfoIdPut({
    required ContactInfo? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ContactInfo, () => ContactInfo.fromJsonFactory);

    return _userContactInfoIdPut(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/user/contact-info/{id}/')
  Future<chopper.Response<ContactInfo>> _userContactInfoIdPut({
    @Body() required ContactInfo? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<ContactInfo>> userContactInfoIdPatch({
    required ContactInfo? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ContactInfo, () => ContactInfo.fromJsonFactory);

    return _userContactInfoIdPatch(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/user/contact-info/{id}/')
  Future<chopper.Response<ContactInfo>> _userContactInfoIdPatch({
    @Body() required ContactInfo? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> userContactInfoIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _userContactInfoIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/user/contact-info/{id}/')
  Future<chopper.Response> _userContactInfoIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<UserCountryPassGet$Response>> userCountryPassGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(UserCountryPassGet$Response,
        () => UserCountryPassGet$Response.fromJsonFactory);

    return _userCountryPassGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/user/country_pass/')
  Future<chopper.Response<UserCountryPassGet$Response>> _userCountryPassGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<CountryPass>> userCountryPassPost({
    required CountryPass? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CountryPass, () => CountryPass.fromJsonFactory);

    return _userCountryPassPost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/user/country_pass/')
  Future<chopper.Response<CountryPass>> _userCountryPassPost({
    @Body() required CountryPass? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<CountryPass>> userCountryPassIdGet({
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CountryPass, () => CountryPass.fromJsonFactory);

    return _userCountryPassIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/user/country_pass/{id}/')
  Future<chopper.Response<CountryPass>> _userCountryPassIdGet({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<CountryPass>> userCountryPassIdPut({
    required CountryPass? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CountryPass, () => CountryPass.fromJsonFactory);

    return _userCountryPassIdPut(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/user/country_pass/{id}/')
  Future<chopper.Response<CountryPass>> _userCountryPassIdPut({
    @Body() required CountryPass? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<CountryPass>> userCountryPassIdPatch({
    required CountryPass? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CountryPass, () => CountryPass.fromJsonFactory);

    return _userCountryPassIdPatch(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/user/country_pass/{id}/')
  Future<chopper.Response<CountryPass>> _userCountryPassIdPatch({
    @Body() required CountryPass? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> userCountryPassIdDelete({
    required int? id,
    String? cacheControl,
  }) {
    return _userCountryPassIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/user/country_pass/{id}/')
  Future<chopper.Response> _userCountryPassIdDelete({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<UserInsuranceGet$Response>> userInsuranceGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(UserInsuranceGet$Response,
        () => UserInsuranceGet$Response.fromJsonFactory);

    return _userInsuranceGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/user/insurance/')
  Future<chopper.Response<UserInsuranceGet$Response>> _userInsuranceGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Insurance>> userInsurancePost({
    required Insurance? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Insurance, () => Insurance.fromJsonFactory);

    return _userInsurancePost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/user/insurance/')
  Future<chopper.Response<Insurance>> _userInsurancePost({
    @Body() required Insurance? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<UserInsuranceUploadFilesGet$Response>>
      userInsuranceUploadFilesGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(UserInsuranceUploadFilesGet$Response,
        () => UserInsuranceUploadFilesGet$Response.fromJsonFactory);

    return _userInsuranceUploadFilesGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/user/insurance/upload/files/')
  Future<chopper.Response<UserInsuranceUploadFilesGet$Response>>
      _userInsuranceUploadFilesGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<InsuranceFile>> userInsuranceUploadFilesPost({
    required InsuranceFile? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        InsuranceFile, () => InsuranceFile.fromJsonFactory);

    return _userInsuranceUploadFilesPost(
        data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/user/insurance/upload/files/')
  Future<chopper.Response<InsuranceFile>> _userInsuranceUploadFilesPost({
    @Body() required InsuranceFile? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<InsuranceFile>> userInsuranceUploadFilesIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        InsuranceFile, () => InsuranceFile.fromJsonFactory);

    return _userInsuranceUploadFilesIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/user/insurance/upload/files/{id}/')
  Future<chopper.Response<InsuranceFile>> _userInsuranceUploadFilesIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<InsuranceFile>> userInsuranceUploadFilesIdPut({
    required InsuranceFile? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        InsuranceFile, () => InsuranceFile.fromJsonFactory);

    return _userInsuranceUploadFilesIdPut(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/user/insurance/upload/files/{id}/')
  Future<chopper.Response<InsuranceFile>> _userInsuranceUploadFilesIdPut({
    @Body() required InsuranceFile? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<InsuranceFile>> userInsuranceUploadFilesIdPatch({
    required InsuranceFile? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        InsuranceFile, () => InsuranceFile.fromJsonFactory);

    return _userInsuranceUploadFilesIdPatch(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/user/insurance/upload/files/{id}/')
  Future<chopper.Response<InsuranceFile>> _userInsuranceUploadFilesIdPatch({
    @Body() required InsuranceFile? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> userInsuranceUploadFilesIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _userInsuranceUploadFilesIdDelete(
        id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/user/insurance/upload/files/{id}/')
  Future<chopper.Response> _userInsuranceUploadFilesIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<Insurance>> userInsuranceIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Insurance, () => Insurance.fromJsonFactory);

    return _userInsuranceIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/user/insurance/{id}/')
  Future<chopper.Response<Insurance>> _userInsuranceIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Insurance>> userInsuranceIdPut({
    required Insurance? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Insurance, () => Insurance.fromJsonFactory);

    return _userInsuranceIdPut(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/user/insurance/{id}/')
  Future<chopper.Response<Insurance>> _userInsuranceIdPut({
    @Body() required Insurance? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Insurance>> userInsuranceIdPatch({
    required Insurance? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Insurance, () => Insurance.fromJsonFactory);

    return _userInsuranceIdPatch(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/user/insurance/{id}/')
  Future<chopper.Response<Insurance>> _userInsuranceIdPatch({
    @Body() required Insurance? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> userInsuranceIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _userInsuranceIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/user/insurance/{id}/')
  Future<chopper.Response> _userInsuranceIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<UserLegalEntityCertificateGet$Response>>
      userLegalEntityCertificateGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(UserLegalEntityCertificateGet$Response,
        () => UserLegalEntityCertificateGet$Response.fromJsonFactory);

    return _userLegalEntityCertificateGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/user/legal_entity_certificate/')
  Future<chopper.Response<UserLegalEntityCertificateGet$Response>>
      _userLegalEntityCertificateGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Certificate>> userLegalEntityCertificatePost({
    required Certificate? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Certificate, () => Certificate.fromJsonFactory);

    return _userLegalEntityCertificatePost(
        data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/user/legal_entity_certificate/')
  Future<chopper.Response<Certificate>> _userLegalEntityCertificatePost({
    @Body() required Certificate? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<UserLegalEntityCertificateUploadFilesGet$Response>>
      userLegalEntityCertificateUploadFilesGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UserLegalEntityCertificateUploadFilesGet$Response,
        () =>
            UserLegalEntityCertificateUploadFilesGet$Response.fromJsonFactory);

    return _userLegalEntityCertificateUploadFilesGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/user/legal_entity_certificate/upload/files/')
  Future<chopper.Response<UserLegalEntityCertificateUploadFilesGet$Response>>
      _userLegalEntityCertificateUploadFilesGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<CertificateFile>>
      userLegalEntityCertificateUploadFilesPost({
    required CertificateFile? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CertificateFile, () => CertificateFile.fromJsonFactory);

    return _userLegalEntityCertificateUploadFilesPost(
        data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/user/legal_entity_certificate/upload/files/')
  Future<chopper.Response<CertificateFile>>
      _userLegalEntityCertificateUploadFilesPost({
    @Body() required CertificateFile? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<CertificateFile>>
      userLegalEntityCertificateUploadFilesIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CertificateFile, () => CertificateFile.fromJsonFactory);

    return _userLegalEntityCertificateUploadFilesIdGet(
        id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/user/legal_entity_certificate/upload/files/{id}/')
  Future<chopper.Response<CertificateFile>>
      _userLegalEntityCertificateUploadFilesIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<CertificateFile>>
      userLegalEntityCertificateUploadFilesIdPut({
    required CertificateFile? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CertificateFile, () => CertificateFile.fromJsonFactory);

    return _userLegalEntityCertificateUploadFilesIdPut(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/user/legal_entity_certificate/upload/files/{id}/')
  Future<chopper.Response<CertificateFile>>
      _userLegalEntityCertificateUploadFilesIdPut({
    @Body() required CertificateFile? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<CertificateFile>>
      userLegalEntityCertificateUploadFilesIdPatch({
    required CertificateFile? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CertificateFile, () => CertificateFile.fromJsonFactory);

    return _userLegalEntityCertificateUploadFilesIdPatch(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/user/legal_entity_certificate/upload/files/{id}/')
  Future<chopper.Response<CertificateFile>>
      _userLegalEntityCertificateUploadFilesIdPatch({
    @Body() required CertificateFile? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> userLegalEntityCertificateUploadFilesIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _userLegalEntityCertificateUploadFilesIdDelete(
        id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/user/legal_entity_certificate/upload/files/{id}/')
  Future<chopper.Response> _userLegalEntityCertificateUploadFilesIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<Certificate>> userLegalEntityCertificateIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Certificate, () => Certificate.fromJsonFactory);

    return _userLegalEntityCertificateIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/user/legal_entity_certificate/{id}/')
  Future<chopper.Response<Certificate>> _userLegalEntityCertificateIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Certificate>> userLegalEntityCertificateIdPut({
    required Certificate? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Certificate, () => Certificate.fromJsonFactory);

    return _userLegalEntityCertificateIdPut(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/user/legal_entity_certificate/{id}/')
  Future<chopper.Response<Certificate>> _userLegalEntityCertificateIdPut({
    @Body() required Certificate? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Certificate>> userLegalEntityCertificateIdPatch({
    required Certificate? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Certificate, () => Certificate.fromJsonFactory);

    return _userLegalEntityCertificateIdPatch(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/user/legal_entity_certificate/{id}/')
  Future<chopper.Response<Certificate>> _userLegalEntityCertificateIdPatch({
    @Body() required Certificate? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> userLegalEntityCertificateIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _userLegalEntityCertificateIdDelete(
        id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/user/legal_entity_certificate/{id}/')
  Future<chopper.Response> _userLegalEntityCertificateIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<UserPassportGet$Response>> userPassportGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(UserPassportGet$Response,
        () => UserPassportGet$Response.fromJsonFactory);

    return _userPassportGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/user/passport/')
  Future<chopper.Response<UserPassportGet$Response>> _userPassportGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Passport>> userPassportPost({
    required Passport? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Passport, () => Passport.fromJsonFactory);

    return _userPassportPost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/user/passport/')
  Future<chopper.Response<Passport>> _userPassportPost({
    @Body() required Passport? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<UserPassportUploadFilesGet$Response>>
      userPassportUploadFilesGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(UserPassportUploadFilesGet$Response,
        () => UserPassportUploadFilesGet$Response.fromJsonFactory);

    return _userPassportUploadFilesGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/user/passport/upload/files/')
  Future<chopper.Response<UserPassportUploadFilesGet$Response>>
      _userPassportUploadFilesGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<PassportFile>> userPassportUploadFilesPost({
    required PassportFile? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        PassportFile, () => PassportFile.fromJsonFactory);

    return _userPassportUploadFilesPost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/user/passport/upload/files/')
  Future<chopper.Response<PassportFile>> _userPassportUploadFilesPost({
    @Body() required PassportFile? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<PassportFile>> userPassportUploadFilesIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        PassportFile, () => PassportFile.fromJsonFactory);

    return _userPassportUploadFilesIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/user/passport/upload/files/{id}/')
  Future<chopper.Response<PassportFile>> _userPassportUploadFilesIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<PassportFile>> userPassportUploadFilesIdPut({
    required PassportFile? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        PassportFile, () => PassportFile.fromJsonFactory);

    return _userPassportUploadFilesIdPut(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/user/passport/upload/files/{id}/')
  Future<chopper.Response<PassportFile>> _userPassportUploadFilesIdPut({
    @Body() required PassportFile? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<PassportFile>> userPassportUploadFilesIdPatch({
    required PassportFile? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        PassportFile, () => PassportFile.fromJsonFactory);

    return _userPassportUploadFilesIdPatch(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/user/passport/upload/files/{id}/')
  Future<chopper.Response<PassportFile>> _userPassportUploadFilesIdPatch({
    @Body() required PassportFile? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> userPassportUploadFilesIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _userPassportUploadFilesIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/user/passport/upload/files/{id}/')
  Future<chopper.Response> _userPassportUploadFilesIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<Passport>> userPassportIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Passport, () => Passport.fromJsonFactory);

    return _userPassportIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/user/passport/{id}/')
  Future<chopper.Response<Passport>> _userPassportIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Passport>> userPassportIdPut({
    required Passport? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Passport, () => Passport.fromJsonFactory);

    return _userPassportIdPut(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/user/passport/{id}/')
  Future<chopper.Response<Passport>> _userPassportIdPut({
    @Body() required Passport? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<Passport>> userPassportIdPatch({
    required Passport? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Passport, () => Passport.fromJsonFactory);

    return _userPassportIdPatch(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/user/passport/{id}/')
  Future<chopper.Response<Passport>> _userPassportIdPatch({
    @Body() required Passport? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> userPassportIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _userPassportIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/user/passport/{id}/')
  Future<chopper.Response> _userPassportIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<UserTransportLicenseGet$Response>>
      userTransportLicenseGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(UserTransportLicenseGet$Response,
        () => UserTransportLicenseGet$Response.fromJsonFactory);

    return _userTransportLicenseGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/user/transport_license/')
  Future<chopper.Response<UserTransportLicenseGet$Response>>
      _userTransportLicenseGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<TransportLicense>> userTransportLicensePost({
    required TransportLicense? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        TransportLicense, () => TransportLicense.fromJsonFactory);

    return _userTransportLicensePost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/user/transport_license/')
  Future<chopper.Response<TransportLicense>> _userTransportLicensePost({
    @Body() required TransportLicense? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<UserTransportLicenseUploadFilesGet$Response>>
      userTransportLicenseUploadFilesGet({
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(UserTransportLicenseUploadFilesGet$Response,
        () => UserTransportLicenseUploadFilesGet$Response.fromJsonFactory);

    return _userTransportLicenseUploadFilesGet(
        limit: limit, offset: offset, cacheControl: cacheControl);
  }

  ///
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/user/transport_license/upload/files/')
  Future<chopper.Response<UserTransportLicenseUploadFilesGet$Response>>
      _userTransportLicenseUploadFilesGet({
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<TransportLicenseFile>>
      userTransportLicenseUploadFilesPost({
    required TransportLicenseFile? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        TransportLicenseFile, () => TransportLicenseFile.fromJsonFactory);

    return _userTransportLicenseUploadFilesPost(
        data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/user/transport_license/upload/files/')
  Future<chopper.Response<TransportLicenseFile>>
      _userTransportLicenseUploadFilesPost({
    @Body() required TransportLicenseFile? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<TransportLicenseFile>>
      userTransportLicenseUploadFilesIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        TransportLicenseFile, () => TransportLicenseFile.fromJsonFactory);

    return _userTransportLicenseUploadFilesIdGet(
        id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/user/transport_license/upload/files/{id}/')
  Future<chopper.Response<TransportLicenseFile>>
      _userTransportLicenseUploadFilesIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<TransportLicenseFile>>
      userTransportLicenseUploadFilesIdPut({
    required TransportLicenseFile? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        TransportLicenseFile, () => TransportLicenseFile.fromJsonFactory);

    return _userTransportLicenseUploadFilesIdPut(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/user/transport_license/upload/files/{id}/')
  Future<chopper.Response<TransportLicenseFile>>
      _userTransportLicenseUploadFilesIdPut({
    @Body() required TransportLicenseFile? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<TransportLicenseFile>>
      userTransportLicenseUploadFilesIdPatch({
    required TransportLicenseFile? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        TransportLicenseFile, () => TransportLicenseFile.fromJsonFactory);

    return _userTransportLicenseUploadFilesIdPatch(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/user/transport_license/upload/files/{id}/')
  Future<chopper.Response<TransportLicenseFile>>
      _userTransportLicenseUploadFilesIdPatch({
    @Body() required TransportLicenseFile? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> userTransportLicenseUploadFilesIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _userTransportLicenseUploadFilesIdDelete(
        id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/user/transport_license/upload/files/{id}/')
  Future<chopper.Response> _userTransportLicenseUploadFilesIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<TransportLicense>> userTransportLicenseIdGet({
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        TransportLicense, () => TransportLicense.fromJsonFactory);

    return _userTransportLicenseIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/user/transport_license/{id}/')
  Future<chopper.Response<TransportLicense>> _userTransportLicenseIdGet({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<TransportLicense>> userTransportLicenseIdPut({
    required TransportLicense? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        TransportLicense, () => TransportLicense.fromJsonFactory);

    return _userTransportLicenseIdPut(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/user/transport_license/{id}/')
  Future<chopper.Response<TransportLicense>> _userTransportLicenseIdPut({
    @Body() required TransportLicense? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<TransportLicense>> userTransportLicenseIdPatch({
    required TransportLicense? data,
    required String? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        TransportLicense, () => TransportLicense.fromJsonFactory);

    return _userTransportLicenseIdPatch(
        data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/user/transport_license/{id}/')
  Future<chopper.Response<TransportLicense>> _userTransportLicenseIdPatch({
    @Body() required TransportLicense? data,
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> userTransportLicenseIdDelete({
    required String? id,
    String? cacheControl,
  }) {
    return _userTransportLicenseIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/user/transport_license/{id}/')
  Future<chopper.Response> _userTransportLicenseIdDelete({
    @Path('id') required String? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param search A search term.
  ///@param ordering Which field to use when ordering the results.
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  Future<chopper.Response<UserUserGet$Response>> userUserGet({
    String? search,
    String? ordering,
    int? limit,
    int? offset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UserUserGet$Response, () => UserUserGet$Response.fromJsonFactory);

    return _userUserGet(
        search: search,
        ordering: ordering,
        limit: limit,
        offset: offset,
        cacheControl: cacheControl);
  }

  ///
  ///@param search A search term.
  ///@param ordering Which field to use when ordering the results.
  ///@param limit Number of results to return per page.
  ///@param offset The initial index from which to return the results.
  @Get(path: '/user/user/')
  Future<chopper.Response<UserUserGet$Response>> _userUserGet({
    @Query('search') String? search,
    @Query('ordering') String? ordering,
    @Query('limit') int? limit,
    @Query('offset') int? offset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<User>> userUserPost({
    required User? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(User, () => User.fromJsonFactory);

    return _userUserPost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/user/user/')
  Future<chopper.Response<User>> _userUserPost({
    @Body() required User? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response> userUserGetTokenViaCodePost({
    required UserGetTokenViaCode? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UserGetTokenViaCode, () => UserGetTokenViaCode.fromJsonFactory);

    return _userUserGetTokenViaCodePost(data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/user/user/get_token_via_code/')
  Future<chopper.Response> _userUserGetTokenViaCodePost({
    @Body() required UserGetTokenViaCode? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response> userUserSendAuthCodeToPhonePost({
    required UserAuthViaPhoneNumber? data,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UserAuthViaPhoneNumber, () => UserAuthViaPhoneNumber.fromJsonFactory);

    return _userUserSendAuthCodeToPhonePost(
        data: data, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Post(path: '/user/user/send_auth_code_to_phone/')
  Future<chopper.Response> _userUserSendAuthCodeToPhonePost({
    @Body() required UserAuthViaPhoneNumber? data,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<User>> userUserIdGet({
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(User, () => User.fromJsonFactory);

    return _userUserIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  @Get(path: '/user/user/{id}/')
  Future<chopper.Response<User>> _userUserIdGet({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<User>> userUserIdPut({
    required User? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(User, () => User.fromJsonFactory);

    return _userUserIdPut(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Put(path: '/user/user/{id}/')
  Future<chopper.Response<User>> _userUserIdPut({
    @Body() required User? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param data
  Future<chopper.Response<User>> userUserIdPatch({
    required User? data,
    required int? id,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(User, () => User.fromJsonFactory);

    return _userUserIdPatch(data: data, id: id, cacheControl: cacheControl);
  }

  ///
  ///@param data
  @Patch(path: '/user/user/{id}/')
  Future<chopper.Response<User>> _userUserIdPatch({
    @Body() required User? data,
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response> userUserIdDelete({
    required int? id,
    String? cacheControl,
  }) {
    return _userUserIdDelete(id: id, cacheControl: cacheControl);
  }

  ///
  @Delete(path: '/user/user/{id}/')
  Future<chopper.Response> _userUserIdDelete({
    @Path('id') required int? id,
    @Header('Cache-Control') String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class ObjectSize {
  ObjectSize({
    this.id,
    this.length,
    this.width,
    this.volume,
    this.height,
  });

  factory ObjectSize.fromJson(Map<String, dynamic> json) =>
      _$ObjectSizeFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'length', includeIfNull: false)
  final int? length;
  @JsonKey(name: 'width', includeIfNull: false)
  final int? width;
  @JsonKey(name: 'volume', includeIfNull: false)
  final int? volume;
  @JsonKey(name: 'height', includeIfNull: false)
  final int? height;
  static const fromJsonFactory = _$ObjectSizeFromJson;
  static const toJsonFactory = _$ObjectSizeToJson;
  Map<String, dynamic> toJson() => _$ObjectSizeToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ObjectSize &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.length, length) ||
                const DeepCollectionEquality().equals(other.length, length)) &&
            (identical(other.width, width) ||
                const DeepCollectionEquality().equals(other.width, width)) &&
            (identical(other.volume, volume) ||
                const DeepCollectionEquality().equals(other.volume, volume)) &&
            (identical(other.height, height) ||
                const DeepCollectionEquality().equals(other.height, height)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(length) ^
      const DeepCollectionEquality().hash(width) ^
      const DeepCollectionEquality().hash(volume) ^
      const DeepCollectionEquality().hash(height) ^
      runtimeType.hashCode;
}

extension $ObjectSizeExtension on ObjectSize {
  ObjectSize copyWith(
      {int? id, int? length, int? width, int? volume, int? height}) {
    return ObjectSize(
        id: id ?? this.id,
        length: length ?? this.length,
        width: width ?? this.width,
        volume: volume ?? this.volume,
        height: height ?? this.height);
  }

  ObjectSize copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<int?>? length,
      Wrapped<int?>? width,
      Wrapped<int?>? volume,
      Wrapped<int?>? height}) {
    return ObjectSize(
        id: (id != null ? id.value : this.id),
        length: (length != null ? length.value : this.length),
        width: (width != null ? width.value : this.width),
        volume: (volume != null ? volume.value : this.volume),
        height: (height != null ? height.value : this.height));
  }
}

@JsonSerializable(explicitToJson: true)
class CarParameter {
  CarParameter({
    this.id,
    this.size,
    this.startTemperatureMode,
    this.endTemperatureMode,
    this.loadingType,
    this.createdDate,
    this.updatedDate,
    this.carType,
  });

  factory CarParameter.fromJson(Map<String, dynamic> json) =>
      _$CarParameterFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'size', includeIfNull: false)
  final ObjectSize? size;
  @JsonKey(name: 'start_temperature_mode', includeIfNull: false)
  final int? startTemperatureMode;
  @JsonKey(name: 'end_temperature_mode', includeIfNull: false)
  final int? endTemperatureMode;
  @JsonKey(name: 'loading_type', includeIfNull: false)
  final int? loadingType;
  @JsonKey(name: 'created_date', includeIfNull: false)
  final DateTime? createdDate;
  @JsonKey(name: 'updated_date', includeIfNull: false)
  final DateTime? updatedDate;
  @JsonKey(name: 'car_type', includeIfNull: false)
  final int? carType;
  static const fromJsonFactory = _$CarParameterFromJson;
  static const toJsonFactory = _$CarParameterToJson;
  Map<String, dynamic> toJson() => _$CarParameterToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CarParameter &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.size, size) ||
                const DeepCollectionEquality().equals(other.size, size)) &&
            (identical(other.startTemperatureMode, startTemperatureMode) ||
                const DeepCollectionEquality().equals(
                    other.startTemperatureMode, startTemperatureMode)) &&
            (identical(other.endTemperatureMode, endTemperatureMode) ||
                const DeepCollectionEquality()
                    .equals(other.endTemperatureMode, endTemperatureMode)) &&
            (identical(other.loadingType, loadingType) ||
                const DeepCollectionEquality()
                    .equals(other.loadingType, loadingType)) &&
            (identical(other.createdDate, createdDate) ||
                const DeepCollectionEquality()
                    .equals(other.createdDate, createdDate)) &&
            (identical(other.updatedDate, updatedDate) ||
                const DeepCollectionEquality()
                    .equals(other.updatedDate, updatedDate)) &&
            (identical(other.carType, carType) ||
                const DeepCollectionEquality().equals(other.carType, carType)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(size) ^
      const DeepCollectionEquality().hash(startTemperatureMode) ^
      const DeepCollectionEquality().hash(endTemperatureMode) ^
      const DeepCollectionEquality().hash(loadingType) ^
      const DeepCollectionEquality().hash(createdDate) ^
      const DeepCollectionEquality().hash(updatedDate) ^
      const DeepCollectionEquality().hash(carType) ^
      runtimeType.hashCode;
}

extension $CarParameterExtension on CarParameter {
  CarParameter copyWith(
      {int? id,
      ObjectSize? size,
      int? startTemperatureMode,
      int? endTemperatureMode,
      int? loadingType,
      DateTime? createdDate,
      DateTime? updatedDate,
      int? carType}) {
    return CarParameter(
        id: id ?? this.id,
        size: size ?? this.size,
        startTemperatureMode: startTemperatureMode ?? this.startTemperatureMode,
        endTemperatureMode: endTemperatureMode ?? this.endTemperatureMode,
        loadingType: loadingType ?? this.loadingType,
        createdDate: createdDate ?? this.createdDate,
        updatedDate: updatedDate ?? this.updatedDate,
        carType: carType ?? this.carType);
  }

  CarParameter copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<ObjectSize?>? size,
      Wrapped<int?>? startTemperatureMode,
      Wrapped<int?>? endTemperatureMode,
      Wrapped<int?>? loadingType,
      Wrapped<DateTime?>? createdDate,
      Wrapped<DateTime?>? updatedDate,
      Wrapped<int?>? carType}) {
    return CarParameter(
        id: (id != null ? id.value : this.id),
        size: (size != null ? size.value : this.size),
        startTemperatureMode: (startTemperatureMode != null
            ? startTemperatureMode.value
            : this.startTemperatureMode),
        endTemperatureMode: (endTemperatureMode != null
            ? endTemperatureMode.value
            : this.endTemperatureMode),
        loadingType:
            (loadingType != null ? loadingType.value : this.loadingType),
        createdDate:
            (createdDate != null ? createdDate.value : this.createdDate),
        updatedDate:
            (updatedDate != null ? updatedDate.value : this.updatedDate),
        carType: (carType != null ? carType.value : this.carType));
  }
}

@JsonSerializable(explicitToJson: true)
class CarInfo {
  CarInfo({
    this.id,
    required this.brand,
    required this.issueYear,
    required this.licensePlate,
    required this.passportNo,
  });

  factory CarInfo.fromJson(Map<String, dynamic> json) =>
      _$CarInfoFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'brand', includeIfNull: false, defaultValue: '')
  final String brand;
  @JsonKey(name: 'issue_year', includeIfNull: false, toJson: _dateToJson)
  final DateTime issueYear;
  @JsonKey(name: 'license_plate', includeIfNull: false, defaultValue: '')
  final String licensePlate;
  @JsonKey(name: 'passport_no', includeIfNull: false, defaultValue: '')
  final String passportNo;
  static const fromJsonFactory = _$CarInfoFromJson;
  static const toJsonFactory = _$CarInfoToJson;
  Map<String, dynamic> toJson() => _$CarInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CarInfo &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.brand, brand) ||
                const DeepCollectionEquality().equals(other.brand, brand)) &&
            (identical(other.issueYear, issueYear) ||
                const DeepCollectionEquality()
                    .equals(other.issueYear, issueYear)) &&
            (identical(other.licensePlate, licensePlate) ||
                const DeepCollectionEquality()
                    .equals(other.licensePlate, licensePlate)) &&
            (identical(other.passportNo, passportNo) ||
                const DeepCollectionEquality()
                    .equals(other.passportNo, passportNo)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(brand) ^
      const DeepCollectionEquality().hash(issueYear) ^
      const DeepCollectionEquality().hash(licensePlate) ^
      const DeepCollectionEquality().hash(passportNo) ^
      runtimeType.hashCode;
}

extension $CarInfoExtension on CarInfo {
  CarInfo copyWith(
      {int? id,
      String? brand,
      DateTime? issueYear,
      String? licensePlate,
      String? passportNo}) {
    return CarInfo(
        id: id ?? this.id,
        brand: brand ?? this.brand,
        issueYear: issueYear ?? this.issueYear,
        licensePlate: licensePlate ?? this.licensePlate,
        passportNo: passportNo ?? this.passportNo);
  }

  CarInfo copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<String>? brand,
      Wrapped<DateTime>? issueYear,
      Wrapped<String>? licensePlate,
      Wrapped<String>? passportNo}) {
    return CarInfo(
        id: (id != null ? id.value : this.id),
        brand: (brand != null ? brand.value : this.brand),
        issueYear: (issueYear != null ? issueYear.value : this.issueYear),
        licensePlate:
            (licensePlate != null ? licensePlate.value : this.licensePlate),
        passportNo: (passportNo != null ? passportNo.value : this.passportNo));
  }
}

@JsonSerializable(explicitToJson: true)
class Trailer {
  Trailer({
    this.id,
    this.reinforcedCrate,
    this.conics,
    this.dopelstocks,
  });

  factory Trailer.fromJson(Map<String, dynamic> json) =>
      _$TrailerFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'reinforced_crate', includeIfNull: false)
  final bool? reinforcedCrate;
  @JsonKey(name: 'conics', includeIfNull: false)
  final bool? conics;
  @JsonKey(name: 'dopelstocks', includeIfNull: false)
  final bool? dopelstocks;
  static const fromJsonFactory = _$TrailerFromJson;
  static const toJsonFactory = _$TrailerToJson;
  Map<String, dynamic> toJson() => _$TrailerToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Trailer &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.reinforcedCrate, reinforcedCrate) ||
                const DeepCollectionEquality()
                    .equals(other.reinforcedCrate, reinforcedCrate)) &&
            (identical(other.conics, conics) ||
                const DeepCollectionEquality().equals(other.conics, conics)) &&
            (identical(other.dopelstocks, dopelstocks) ||
                const DeepCollectionEquality()
                    .equals(other.dopelstocks, dopelstocks)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(reinforcedCrate) ^
      const DeepCollectionEquality().hash(conics) ^
      const DeepCollectionEquality().hash(dopelstocks) ^
      runtimeType.hashCode;
}

extension $TrailerExtension on Trailer {
  Trailer copyWith(
      {int? id, bool? reinforcedCrate, bool? conics, bool? dopelstocks}) {
    return Trailer(
        id: id ?? this.id,
        reinforcedCrate: reinforcedCrate ?? this.reinforcedCrate,
        conics: conics ?? this.conics,
        dopelstocks: dopelstocks ?? this.dopelstocks);
  }

  Trailer copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<bool?>? reinforcedCrate,
      Wrapped<bool?>? conics,
      Wrapped<bool?>? dopelstocks}) {
    return Trailer(
        id: (id != null ? id.value : this.id),
        reinforcedCrate: (reinforcedCrate != null
            ? reinforcedCrate.value
            : this.reinforcedCrate),
        conics: (conics != null ? conics.value : this.conics),
        dopelstocks:
            (dopelstocks != null ? dopelstocks.value : this.dopelstocks));
  }
}

@JsonSerializable(explicitToJson: true)
class Car {
  Car({
    this.id,
    required this.owner,
    this.parameters,
    this.info,
    this.trailer,
    this.driver,
  });

  factory Car.fromJson(Map<String, dynamic> json) => _$CarFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'owner', includeIfNull: false)
  final int owner;
  @JsonKey(name: 'parameters', includeIfNull: false)
  final CarParameter? parameters;
  @JsonKey(name: 'info', includeIfNull: false)
  final CarInfo? info;
  @JsonKey(name: 'trailer', includeIfNull: false)
  final Trailer? trailer;
  @JsonKey(name: 'driver', includeIfNull: false)
  final int? driver;
  static const fromJsonFactory = _$CarFromJson;
  static const toJsonFactory = _$CarToJson;
  Map<String, dynamic> toJson() => _$CarToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Car &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.owner, owner) ||
                const DeepCollectionEquality().equals(other.owner, owner)) &&
            (identical(other.parameters, parameters) ||
                const DeepCollectionEquality()
                    .equals(other.parameters, parameters)) &&
            (identical(other.info, info) ||
                const DeepCollectionEquality().equals(other.info, info)) &&
            (identical(other.trailer, trailer) ||
                const DeepCollectionEquality()
                    .equals(other.trailer, trailer)) &&
            (identical(other.driver, driver) ||
                const DeepCollectionEquality().equals(other.driver, driver)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(owner) ^
      const DeepCollectionEquality().hash(parameters) ^
      const DeepCollectionEquality().hash(info) ^
      const DeepCollectionEquality().hash(trailer) ^
      const DeepCollectionEquality().hash(driver) ^
      runtimeType.hashCode;
}

extension $CarExtension on Car {
  Car copyWith(
      {int? id,
      int? owner,
      CarParameter? parameters,
      CarInfo? info,
      Trailer? trailer,
      int? driver}) {
    return Car(
        id: id ?? this.id,
        owner: owner ?? this.owner,
        parameters: parameters ?? this.parameters,
        info: info ?? this.info,
        trailer: trailer ?? this.trailer,
        driver: driver ?? this.driver);
  }

  Car copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<int>? owner,
      Wrapped<CarParameter?>? parameters,
      Wrapped<CarInfo?>? info,
      Wrapped<Trailer?>? trailer,
      Wrapped<int?>? driver}) {
    return Car(
        id: (id != null ? id.value : this.id),
        owner: (owner != null ? owner.value : this.owner),
        parameters: (parameters != null ? parameters.value : this.parameters),
        info: (info != null ? info.value : this.info),
        trailer: (trailer != null ? trailer.value : this.trailer),
        driver: (driver != null ? driver.value : this.driver));
  }
}

@JsonSerializable(explicitToJson: true)
class CarPassportFile {
  CarPassportFile({
    this.id,
    this.file,
    required this.car,
  });

  factory CarPassportFile.fromJson(Map<String, dynamic> json) =>
      _$CarPassportFileFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'file', includeIfNull: false, defaultValue: '')
  final String? file;
  @JsonKey(name: 'car', includeIfNull: false)
  final int car;
  static const fromJsonFactory = _$CarPassportFileFromJson;
  static const toJsonFactory = _$CarPassportFileToJson;
  Map<String, dynamic> toJson() => _$CarPassportFileToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CarPassportFile &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.file, file) ||
                const DeepCollectionEquality().equals(other.file, file)) &&
            (identical(other.car, car) ||
                const DeepCollectionEquality().equals(other.car, car)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(file) ^
      const DeepCollectionEquality().hash(car) ^
      runtimeType.hashCode;
}

extension $CarPassportFileExtension on CarPassportFile {
  CarPassportFile copyWith({int? id, String? file, int? car}) {
    return CarPassportFile(
        id: id ?? this.id, file: file ?? this.file, car: car ?? this.car);
  }

  CarPassportFile copyWithWrapped(
      {Wrapped<int?>? id, Wrapped<String?>? file, Wrapped<int>? car}) {
    return CarPassportFile(
        id: (id != null ? id.value : this.id),
        file: (file != null ? file.value : this.file),
        car: (car != null ? car.value : this.car));
  }
}

@JsonSerializable(explicitToJson: true)
class CarType {
  CarType({
    this.id,
    required this.title,
  });

  factory CarType.fromJson(Map<String, dynamic> json) =>
      _$CarTypeFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  static const fromJsonFactory = _$CarTypeFromJson;
  static const toJsonFactory = _$CarTypeToJson;
  Map<String, dynamic> toJson() => _$CarTypeToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CarType &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(title) ^
      runtimeType.hashCode;
}

extension $CarTypeExtension on CarType {
  CarType copyWith({int? id, String? title}) {
    return CarType(id: id ?? this.id, title: title ?? this.title);
  }

  CarType copyWithWrapped({Wrapped<int?>? id, Wrapped<String>? title}) {
    return CarType(
        id: (id != null ? id.value : this.id),
        title: (title != null ? title.value : this.title));
  }
}

@JsonSerializable(explicitToJson: true)
class Cargo {
  Cargo({
    this.id,
    required this.loadDate,
    required this.price,
    required this.weight,
    this.createdDate,
    this.updatedDate,
    this.customer,
    this.sender,
    this.recipient,
    this.cargoType,
    this.packageType,
  });

  factory Cargo.fromJson(Map<String, dynamic> json) => _$CargoFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'load_date', includeIfNull: false)
  final DateTime loadDate;
  @JsonKey(name: 'price', includeIfNull: false, defaultValue: '')
  final String price;
  @JsonKey(name: 'weight', includeIfNull: false, defaultValue: '')
  final String weight;
  @JsonKey(name: 'created_date', includeIfNull: false)
  final DateTime? createdDate;
  @JsonKey(name: 'updated_date', includeIfNull: false)
  final DateTime? updatedDate;
  @JsonKey(name: 'customer', includeIfNull: false)
  final int? customer;
  @JsonKey(name: 'sender', includeIfNull: false)
  final int? sender;
  @JsonKey(name: 'recipient', includeIfNull: false)
  final int? recipient;
  @JsonKey(name: 'cargo_type', includeIfNull: false)
  final int? cargoType;
  @JsonKey(name: 'package_type', includeIfNull: false)
  final int? packageType;
  static const fromJsonFactory = _$CargoFromJson;
  static const toJsonFactory = _$CargoToJson;
  Map<String, dynamic> toJson() => _$CargoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Cargo &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.loadDate, loadDate) ||
                const DeepCollectionEquality()
                    .equals(other.loadDate, loadDate)) &&
            (identical(other.price, price) ||
                const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.weight, weight) ||
                const DeepCollectionEquality().equals(other.weight, weight)) &&
            (identical(other.createdDate, createdDate) ||
                const DeepCollectionEquality()
                    .equals(other.createdDate, createdDate)) &&
            (identical(other.updatedDate, updatedDate) ||
                const DeepCollectionEquality()
                    .equals(other.updatedDate, updatedDate)) &&
            (identical(other.customer, customer) ||
                const DeepCollectionEquality()
                    .equals(other.customer, customer)) &&
            (identical(other.sender, sender) ||
                const DeepCollectionEquality().equals(other.sender, sender)) &&
            (identical(other.recipient, recipient) ||
                const DeepCollectionEquality()
                    .equals(other.recipient, recipient)) &&
            (identical(other.cargoType, cargoType) ||
                const DeepCollectionEquality()
                    .equals(other.cargoType, cargoType)) &&
            (identical(other.packageType, packageType) ||
                const DeepCollectionEquality()
                    .equals(other.packageType, packageType)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(loadDate) ^
      const DeepCollectionEquality().hash(price) ^
      const DeepCollectionEquality().hash(weight) ^
      const DeepCollectionEquality().hash(createdDate) ^
      const DeepCollectionEquality().hash(updatedDate) ^
      const DeepCollectionEquality().hash(customer) ^
      const DeepCollectionEquality().hash(sender) ^
      const DeepCollectionEquality().hash(recipient) ^
      const DeepCollectionEquality().hash(cargoType) ^
      const DeepCollectionEquality().hash(packageType) ^
      runtimeType.hashCode;
}

extension $CargoExtension on Cargo {
  Cargo copyWith(
      {int? id,
      DateTime? loadDate,
      String? price,
      String? weight,
      DateTime? createdDate,
      DateTime? updatedDate,
      int? customer,
      int? sender,
      int? recipient,
      int? cargoType,
      int? packageType}) {
    return Cargo(
        id: id ?? this.id,
        loadDate: loadDate ?? this.loadDate,
        price: price ?? this.price,
        weight: weight ?? this.weight,
        createdDate: createdDate ?? this.createdDate,
        updatedDate: updatedDate ?? this.updatedDate,
        customer: customer ?? this.customer,
        sender: sender ?? this.sender,
        recipient: recipient ?? this.recipient,
        cargoType: cargoType ?? this.cargoType,
        packageType: packageType ?? this.packageType);
  }

  Cargo copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<DateTime>? loadDate,
      Wrapped<String>? price,
      Wrapped<String>? weight,
      Wrapped<DateTime?>? createdDate,
      Wrapped<DateTime?>? updatedDate,
      Wrapped<int?>? customer,
      Wrapped<int?>? sender,
      Wrapped<int?>? recipient,
      Wrapped<int?>? cargoType,
      Wrapped<int?>? packageType}) {
    return Cargo(
        id: (id != null ? id.value : this.id),
        loadDate: (loadDate != null ? loadDate.value : this.loadDate),
        price: (price != null ? price.value : this.price),
        weight: (weight != null ? weight.value : this.weight),
        createdDate:
            (createdDate != null ? createdDate.value : this.createdDate),
        updatedDate:
            (updatedDate != null ? updatedDate.value : this.updatedDate),
        customer: (customer != null ? customer.value : this.customer),
        sender: (sender != null ? sender.value : this.sender),
        recipient: (recipient != null ? recipient.value : this.recipient),
        cargoType: (cargoType != null ? cargoType.value : this.cargoType),
        packageType:
            (packageType != null ? packageType.value : this.packageType));
  }
}

@JsonSerializable(explicitToJson: true)
class CargoType {
  CargoType({
    this.id,
    required this.title,
  });

  factory CargoType.fromJson(Map<String, dynamic> json) =>
      _$CargoTypeFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  static const fromJsonFactory = _$CargoTypeFromJson;
  static const toJsonFactory = _$CargoTypeToJson;
  Map<String, dynamic> toJson() => _$CargoTypeToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CargoType &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(title) ^
      runtimeType.hashCode;
}

extension $CargoTypeExtension on CargoType {
  CargoType copyWith({int? id, String? title}) {
    return CargoType(id: id ?? this.id, title: title ?? this.title);
  }

  CargoType copyWithWrapped({Wrapped<int?>? id, Wrapped<String>? title}) {
    return CargoType(
        id: (id != null ? id.value : this.id),
        title: (title != null ? title.value : this.title));
  }
}

@JsonSerializable(explicitToJson: true)
class City {
  City({
    this.id,
    required this.title,
  });

  factory City.fromJson(Map<String, dynamic> json) => _$CityFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  static const fromJsonFactory = _$CityFromJson;
  static const toJsonFactory = _$CityToJson;
  Map<String, dynamic> toJson() => _$CityToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is City &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(title) ^
      runtimeType.hashCode;
}

extension $CityExtension on City {
  City copyWith({int? id, String? title}) {
    return City(id: id ?? this.id, title: title ?? this.title);
  }

  City copyWithWrapped({Wrapped<int?>? id, Wrapped<String>? title}) {
    return City(
        id: (id != null ? id.value : this.id),
        title: (title != null ? title.value : this.title));
  }
}

@JsonSerializable(explicitToJson: true)
class Company {
  Company({
    this.id,
    this.owner,
    required this.name,
    this.createdDate,
    this.updatedDate,
    required this.directions,
  });

  factory Company.fromJson(Map<String, dynamic> json) =>
      _$CompanyFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'owner', includeIfNull: false)
  final int? owner;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'created_date', includeIfNull: false)
  final DateTime? createdDate;
  @JsonKey(name: 'updated_date', includeIfNull: false)
  final DateTime? updatedDate;
  @JsonKey(name: 'directions', includeIfNull: false, defaultValue: <int>[])
  final List<int> directions;
  static const fromJsonFactory = _$CompanyFromJson;
  static const toJsonFactory = _$CompanyToJson;
  Map<String, dynamic> toJson() => _$CompanyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Company &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.owner, owner) ||
                const DeepCollectionEquality().equals(other.owner, owner)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.createdDate, createdDate) ||
                const DeepCollectionEquality()
                    .equals(other.createdDate, createdDate)) &&
            (identical(other.updatedDate, updatedDate) ||
                const DeepCollectionEquality()
                    .equals(other.updatedDate, updatedDate)) &&
            (identical(other.directions, directions) ||
                const DeepCollectionEquality()
                    .equals(other.directions, directions)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(owner) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(createdDate) ^
      const DeepCollectionEquality().hash(updatedDate) ^
      const DeepCollectionEquality().hash(directions) ^
      runtimeType.hashCode;
}

extension $CompanyExtension on Company {
  Company copyWith(
      {int? id,
      int? owner,
      String? name,
      DateTime? createdDate,
      DateTime? updatedDate,
      List<int>? directions}) {
    return Company(
        id: id ?? this.id,
        owner: owner ?? this.owner,
        name: name ?? this.name,
        createdDate: createdDate ?? this.createdDate,
        updatedDate: updatedDate ?? this.updatedDate,
        directions: directions ?? this.directions);
  }

  Company copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<int?>? owner,
      Wrapped<String>? name,
      Wrapped<DateTime?>? createdDate,
      Wrapped<DateTime?>? updatedDate,
      Wrapped<List<int>>? directions}) {
    return Company(
        id: (id != null ? id.value : this.id),
        owner: (owner != null ? owner.value : this.owner),
        name: (name != null ? name.value : this.name),
        createdDate:
            (createdDate != null ? createdDate.value : this.createdDate),
        updatedDate:
            (updatedDate != null ? updatedDate.value : this.updatedDate),
        directions: (directions != null ? directions.value : this.directions));
  }
}

@JsonSerializable(explicitToJson: true)
class AdditionalInfo {
  AdditionalInfo({
    this.id,
    required this.title,
  });

  factory AdditionalInfo.fromJson(Map<String, dynamic> json) =>
      _$AdditionalInfoFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  static const fromJsonFactory = _$AdditionalInfoFromJson;
  static const toJsonFactory = _$AdditionalInfoToJson;
  Map<String, dynamic> toJson() => _$AdditionalInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AdditionalInfo &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(title) ^
      runtimeType.hashCode;
}

extension $AdditionalInfoExtension on AdditionalInfo {
  AdditionalInfo copyWith({int? id, String? title}) {
    return AdditionalInfo(id: id ?? this.id, title: title ?? this.title);
  }

  AdditionalInfo copyWithWrapped({Wrapped<int?>? id, Wrapped<String>? title}) {
    return AdditionalInfo(
        id: (id != null ? id.value : this.id),
        title: (title != null ? title.value : this.title));
  }
}

@JsonSerializable(explicitToJson: true)
class Deal {
  Deal({
    this.id,
    required this.price,
    this.registrationOnLoad,
    this.registrationOnLoadWithPhoto,
    this.showToManagerExecutor,
    this.showToCompanyExecutor,
    this.createdDate,
    this.updatedDate,
    this.creator,
    this.manager,
    this.driver,
    this.secondDriver,
  });

  factory Deal.fromJson(Map<String, dynamic> json) => _$DealFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'price', includeIfNull: false, defaultValue: '')
  final String price;
  @JsonKey(name: 'registration_on_load', includeIfNull: false)
  final bool? registrationOnLoad;
  @JsonKey(name: 'registration_on_load_with_photo', includeIfNull: false)
  final bool? registrationOnLoadWithPhoto;
  @JsonKey(name: 'show_to_manager_executor', includeIfNull: false)
  final bool? showToManagerExecutor;
  @JsonKey(name: 'show_to_company_executor', includeIfNull: false)
  final bool? showToCompanyExecutor;
  @JsonKey(name: 'created_date', includeIfNull: false)
  final DateTime? createdDate;
  @JsonKey(name: 'updated_date', includeIfNull: false)
  final DateTime? updatedDate;
  @JsonKey(name: 'creator', includeIfNull: false)
  final int? creator;
  @JsonKey(name: 'manager', includeIfNull: false)
  final int? manager;
  @JsonKey(name: 'driver', includeIfNull: false)
  final int? driver;
  @JsonKey(name: 'second_driver', includeIfNull: false)
  final int? secondDriver;
  static const fromJsonFactory = _$DealFromJson;
  static const toJsonFactory = _$DealToJson;
  Map<String, dynamic> toJson() => _$DealToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Deal &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.price, price) ||
                const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.registrationOnLoad, registrationOnLoad) ||
                const DeepCollectionEquality()
                    .equals(other.registrationOnLoad, registrationOnLoad)) &&
            (identical(other.registrationOnLoadWithPhoto,
                    registrationOnLoadWithPhoto) ||
                const DeepCollectionEquality().equals(
                    other.registrationOnLoadWithPhoto,
                    registrationOnLoadWithPhoto)) &&
            (identical(other.showToManagerExecutor, showToManagerExecutor) ||
                const DeepCollectionEquality().equals(
                    other.showToManagerExecutor, showToManagerExecutor)) &&
            (identical(other.showToCompanyExecutor, showToCompanyExecutor) ||
                const DeepCollectionEquality().equals(
                    other.showToCompanyExecutor, showToCompanyExecutor)) &&
            (identical(other.createdDate, createdDate) ||
                const DeepCollectionEquality()
                    .equals(other.createdDate, createdDate)) &&
            (identical(other.updatedDate, updatedDate) ||
                const DeepCollectionEquality()
                    .equals(other.updatedDate, updatedDate)) &&
            (identical(other.creator, creator) ||
                const DeepCollectionEquality()
                    .equals(other.creator, creator)) &&
            (identical(other.manager, manager) ||
                const DeepCollectionEquality()
                    .equals(other.manager, manager)) &&
            (identical(other.driver, driver) ||
                const DeepCollectionEquality().equals(other.driver, driver)) &&
            (identical(other.secondDriver, secondDriver) ||
                const DeepCollectionEquality()
                    .equals(other.secondDriver, secondDriver)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(price) ^
      const DeepCollectionEquality().hash(registrationOnLoad) ^
      const DeepCollectionEquality().hash(registrationOnLoadWithPhoto) ^
      const DeepCollectionEquality().hash(showToManagerExecutor) ^
      const DeepCollectionEquality().hash(showToCompanyExecutor) ^
      const DeepCollectionEquality().hash(createdDate) ^
      const DeepCollectionEquality().hash(updatedDate) ^
      const DeepCollectionEquality().hash(creator) ^
      const DeepCollectionEquality().hash(manager) ^
      const DeepCollectionEquality().hash(driver) ^
      const DeepCollectionEquality().hash(secondDriver) ^
      runtimeType.hashCode;
}

extension $DealExtension on Deal {
  Deal copyWith(
      {int? id,
      String? price,
      bool? registrationOnLoad,
      bool? registrationOnLoadWithPhoto,
      bool? showToManagerExecutor,
      bool? showToCompanyExecutor,
      DateTime? createdDate,
      DateTime? updatedDate,
      int? creator,
      int? manager,
      int? driver,
      int? secondDriver}) {
    return Deal(
        id: id ?? this.id,
        price: price ?? this.price,
        registrationOnLoad: registrationOnLoad ?? this.registrationOnLoad,
        registrationOnLoadWithPhoto:
            registrationOnLoadWithPhoto ?? this.registrationOnLoadWithPhoto,
        showToManagerExecutor:
            showToManagerExecutor ?? this.showToManagerExecutor,
        showToCompanyExecutor:
            showToCompanyExecutor ?? this.showToCompanyExecutor,
        createdDate: createdDate ?? this.createdDate,
        updatedDate: updatedDate ?? this.updatedDate,
        creator: creator ?? this.creator,
        manager: manager ?? this.manager,
        driver: driver ?? this.driver,
        secondDriver: secondDriver ?? this.secondDriver);
  }

  Deal copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<String>? price,
      Wrapped<bool?>? registrationOnLoad,
      Wrapped<bool?>? registrationOnLoadWithPhoto,
      Wrapped<bool?>? showToManagerExecutor,
      Wrapped<bool?>? showToCompanyExecutor,
      Wrapped<DateTime?>? createdDate,
      Wrapped<DateTime?>? updatedDate,
      Wrapped<int?>? creator,
      Wrapped<int?>? manager,
      Wrapped<int?>? driver,
      Wrapped<int?>? secondDriver}) {
    return Deal(
        id: (id != null ? id.value : this.id),
        price: (price != null ? price.value : this.price),
        registrationOnLoad: (registrationOnLoad != null
            ? registrationOnLoad.value
            : this.registrationOnLoad),
        registrationOnLoadWithPhoto: (registrationOnLoadWithPhoto != null
            ? registrationOnLoadWithPhoto.value
            : this.registrationOnLoadWithPhoto),
        showToManagerExecutor: (showToManagerExecutor != null
            ? showToManagerExecutor.value
            : this.showToManagerExecutor),
        showToCompanyExecutor: (showToCompanyExecutor != null
            ? showToCompanyExecutor.value
            : this.showToCompanyExecutor),
        createdDate:
            (createdDate != null ? createdDate.value : this.createdDate),
        updatedDate:
            (updatedDate != null ? updatedDate.value : this.updatedDate),
        creator: (creator != null ? creator.value : this.creator),
        manager: (manager != null ? manager.value : this.manager),
        driver: (driver != null ? driver.value : this.driver),
        secondDriver:
            (secondDriver != null ? secondDriver.value : this.secondDriver));
  }
}

@JsonSerializable(explicitToJson: true)
class TokenObtainPair {
  TokenObtainPair({
    required this.username,
    required this.password,
  });

  factory TokenObtainPair.fromJson(Map<String, dynamic> json) =>
      _$TokenObtainPairFromJson(json);

  @JsonKey(name: 'username', includeIfNull: false, defaultValue: '')
  final String username;
  @JsonKey(name: 'password', includeIfNull: false, defaultValue: '')
  final String password;
  static const fromJsonFactory = _$TokenObtainPairFromJson;
  static const toJsonFactory = _$TokenObtainPairToJson;
  Map<String, dynamic> toJson() => _$TokenObtainPairToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TokenObtainPair &&
            (identical(other.username, username) ||
                const DeepCollectionEquality()
                    .equals(other.username, username)) &&
            (identical(other.password, password) ||
                const DeepCollectionEquality()
                    .equals(other.password, password)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(username) ^
      const DeepCollectionEquality().hash(password) ^
      runtimeType.hashCode;
}

extension $TokenObtainPairExtension on TokenObtainPair {
  TokenObtainPair copyWith({String? username, String? password}) {
    return TokenObtainPair(
        username: username ?? this.username,
        password: password ?? this.password);
  }

  TokenObtainPair copyWithWrapped(
      {Wrapped<String>? username, Wrapped<String>? password}) {
    return TokenObtainPair(
        username: (username != null ? username.value : this.username),
        password: (password != null ? password.value : this.password));
  }
}

@JsonSerializable(explicitToJson: true)
class TokenRefresh {
  TokenRefresh({
    required this.refresh,
  });

  factory TokenRefresh.fromJson(Map<String, dynamic> json) =>
      _$TokenRefreshFromJson(json);

  @JsonKey(name: 'refresh', includeIfNull: false, defaultValue: '')
  final String refresh;
  static const fromJsonFactory = _$TokenRefreshFromJson;
  static const toJsonFactory = _$TokenRefreshToJson;
  Map<String, dynamic> toJson() => _$TokenRefreshToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TokenRefresh &&
            (identical(other.refresh, refresh) ||
                const DeepCollectionEquality().equals(other.refresh, refresh)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(refresh) ^ runtimeType.hashCode;
}

extension $TokenRefreshExtension on TokenRefresh {
  TokenRefresh copyWith({String? refresh}) {
    return TokenRefresh(refresh: refresh ?? this.refresh);
  }

  TokenRefresh copyWithWrapped({Wrapped<String>? refresh}) {
    return TokenRefresh(
        refresh: (refresh != null ? refresh.value : this.refresh));
  }
}

@JsonSerializable(explicitToJson: true)
class CarriageAgreement {
  CarriageAgreement({
    this.id,
    required this.subclass,
    required this.number,
    required this.expiryStartDate,
    required this.expiryEndDate,
    this.createdDate,
    this.updatedDate,
    this.user,
  });

  factory CarriageAgreement.fromJson(Map<String, dynamic> json) =>
      _$CarriageAgreementFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'subclass', includeIfNull: false, defaultValue: '')
  final String subclass;
  @JsonKey(name: 'number', includeIfNull: false, defaultValue: '')
  final String number;
  @JsonKey(name: 'expiry_start_date', includeIfNull: false, toJson: _dateToJson)
  final DateTime expiryStartDate;
  @JsonKey(name: 'expiry_end_date', includeIfNull: false, toJson: _dateToJson)
  final DateTime expiryEndDate;
  @JsonKey(name: 'created_date', includeIfNull: false)
  final DateTime? createdDate;
  @JsonKey(name: 'updated_date', includeIfNull: false)
  final DateTime? updatedDate;
  @JsonKey(name: 'user', includeIfNull: false)
  final int? user;
  static const fromJsonFactory = _$CarriageAgreementFromJson;
  static const toJsonFactory = _$CarriageAgreementToJson;
  Map<String, dynamic> toJson() => _$CarriageAgreementToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CarriageAgreement &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.subclass, subclass) ||
                const DeepCollectionEquality()
                    .equals(other.subclass, subclass)) &&
            (identical(other.number, number) ||
                const DeepCollectionEquality().equals(other.number, number)) &&
            (identical(other.expiryStartDate, expiryStartDate) ||
                const DeepCollectionEquality()
                    .equals(other.expiryStartDate, expiryStartDate)) &&
            (identical(other.expiryEndDate, expiryEndDate) ||
                const DeepCollectionEquality()
                    .equals(other.expiryEndDate, expiryEndDate)) &&
            (identical(other.createdDate, createdDate) ||
                const DeepCollectionEquality()
                    .equals(other.createdDate, createdDate)) &&
            (identical(other.updatedDate, updatedDate) ||
                const DeepCollectionEquality()
                    .equals(other.updatedDate, updatedDate)) &&
            (identical(other.user, user) ||
                const DeepCollectionEquality().equals(other.user, user)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(subclass) ^
      const DeepCollectionEquality().hash(number) ^
      const DeepCollectionEquality().hash(expiryStartDate) ^
      const DeepCollectionEquality().hash(expiryEndDate) ^
      const DeepCollectionEquality().hash(createdDate) ^
      const DeepCollectionEquality().hash(updatedDate) ^
      const DeepCollectionEquality().hash(user) ^
      runtimeType.hashCode;
}

extension $CarriageAgreementExtension on CarriageAgreement {
  CarriageAgreement copyWith(
      {int? id,
      String? subclass,
      String? number,
      DateTime? expiryStartDate,
      DateTime? expiryEndDate,
      DateTime? createdDate,
      DateTime? updatedDate,
      int? user}) {
    return CarriageAgreement(
        id: id ?? this.id,
        subclass: subclass ?? this.subclass,
        number: number ?? this.number,
        expiryStartDate: expiryStartDate ?? this.expiryStartDate,
        expiryEndDate: expiryEndDate ?? this.expiryEndDate,
        createdDate: createdDate ?? this.createdDate,
        updatedDate: updatedDate ?? this.updatedDate,
        user: user ?? this.user);
  }

  CarriageAgreement copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<String>? subclass,
      Wrapped<String>? number,
      Wrapped<DateTime>? expiryStartDate,
      Wrapped<DateTime>? expiryEndDate,
      Wrapped<DateTime?>? createdDate,
      Wrapped<DateTime?>? updatedDate,
      Wrapped<int?>? user}) {
    return CarriageAgreement(
        id: (id != null ? id.value : this.id),
        subclass: (subclass != null ? subclass.value : this.subclass),
        number: (number != null ? number.value : this.number),
        expiryStartDate: (expiryStartDate != null
            ? expiryStartDate.value
            : this.expiryStartDate),
        expiryEndDate:
            (expiryEndDate != null ? expiryEndDate.value : this.expiryEndDate),
        createdDate:
            (createdDate != null ? createdDate.value : this.createdDate),
        updatedDate:
            (updatedDate != null ? updatedDate.value : this.updatedDate),
        user: (user != null ? user.value : this.user));
  }
}

@JsonSerializable(explicitToJson: true)
class ContactInfo {
  ContactInfo({
    this.id,
    this.type,
    required this.value,
    this.createdDate,
    this.updatedDate,
    this.user,
  });

  factory ContactInfo.fromJson(Map<String, dynamic> json) =>
      _$ContactInfoFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'type', includeIfNull: false)
  final int? type;
  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String value;
  @JsonKey(name: 'created_date', includeIfNull: false)
  final DateTime? createdDate;
  @JsonKey(name: 'updated_date', includeIfNull: false)
  final DateTime? updatedDate;
  @JsonKey(name: 'user', includeIfNull: false)
  final int? user;
  static const fromJsonFactory = _$ContactInfoFromJson;
  static const toJsonFactory = _$ContactInfoToJson;
  Map<String, dynamic> toJson() => _$ContactInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ContactInfo &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)) &&
            (identical(other.createdDate, createdDate) ||
                const DeepCollectionEquality()
                    .equals(other.createdDate, createdDate)) &&
            (identical(other.updatedDate, updatedDate) ||
                const DeepCollectionEquality()
                    .equals(other.updatedDate, updatedDate)) &&
            (identical(other.user, user) ||
                const DeepCollectionEquality().equals(other.user, user)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(value) ^
      const DeepCollectionEquality().hash(createdDate) ^
      const DeepCollectionEquality().hash(updatedDate) ^
      const DeepCollectionEquality().hash(user) ^
      runtimeType.hashCode;
}

extension $ContactInfoExtension on ContactInfo {
  ContactInfo copyWith(
      {int? id,
      int? type,
      String? value,
      DateTime? createdDate,
      DateTime? updatedDate,
      int? user}) {
    return ContactInfo(
        id: id ?? this.id,
        type: type ?? this.type,
        value: value ?? this.value,
        createdDate: createdDate ?? this.createdDate,
        updatedDate: updatedDate ?? this.updatedDate,
        user: user ?? this.user);
  }

  ContactInfo copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<int?>? type,
      Wrapped<String>? value,
      Wrapped<DateTime?>? createdDate,
      Wrapped<DateTime?>? updatedDate,
      Wrapped<int?>? user}) {
    return ContactInfo(
        id: (id != null ? id.value : this.id),
        type: (type != null ? type.value : this.type),
        value: (value != null ? value.value : this.value),
        createdDate:
            (createdDate != null ? createdDate.value : this.createdDate),
        updatedDate:
            (updatedDate != null ? updatedDate.value : this.updatedDate),
        user: (user != null ? user.value : this.user));
  }
}

@JsonSerializable(explicitToJson: true)
class CountryPass {
  CountryPass({
    this.id,
    required this.countryName,
    required this.expiryStartDate,
    required this.expiryEndDate,
    this.createdDate,
    this.updatedDate,
    this.user,
  });

  factory CountryPass.fromJson(Map<String, dynamic> json) =>
      _$CountryPassFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'country_name', includeIfNull: false, defaultValue: '')
  final String countryName;
  @JsonKey(name: 'expiry_start_date', includeIfNull: false, toJson: _dateToJson)
  final DateTime expiryStartDate;
  @JsonKey(name: 'expiry_end_date', includeIfNull: false, toJson: _dateToJson)
  final DateTime expiryEndDate;
  @JsonKey(name: 'created_date', includeIfNull: false)
  final DateTime? createdDate;
  @JsonKey(name: 'updated_date', includeIfNull: false)
  final DateTime? updatedDate;
  @JsonKey(name: 'user', includeIfNull: false)
  final int? user;
  static const fromJsonFactory = _$CountryPassFromJson;
  static const toJsonFactory = _$CountryPassToJson;
  Map<String, dynamic> toJson() => _$CountryPassToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CountryPass &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.countryName, countryName) ||
                const DeepCollectionEquality()
                    .equals(other.countryName, countryName)) &&
            (identical(other.expiryStartDate, expiryStartDate) ||
                const DeepCollectionEquality()
                    .equals(other.expiryStartDate, expiryStartDate)) &&
            (identical(other.expiryEndDate, expiryEndDate) ||
                const DeepCollectionEquality()
                    .equals(other.expiryEndDate, expiryEndDate)) &&
            (identical(other.createdDate, createdDate) ||
                const DeepCollectionEquality()
                    .equals(other.createdDate, createdDate)) &&
            (identical(other.updatedDate, updatedDate) ||
                const DeepCollectionEquality()
                    .equals(other.updatedDate, updatedDate)) &&
            (identical(other.user, user) ||
                const DeepCollectionEquality().equals(other.user, user)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(countryName) ^
      const DeepCollectionEquality().hash(expiryStartDate) ^
      const DeepCollectionEquality().hash(expiryEndDate) ^
      const DeepCollectionEquality().hash(createdDate) ^
      const DeepCollectionEquality().hash(updatedDate) ^
      const DeepCollectionEquality().hash(user) ^
      runtimeType.hashCode;
}

extension $CountryPassExtension on CountryPass {
  CountryPass copyWith(
      {int? id,
      String? countryName,
      DateTime? expiryStartDate,
      DateTime? expiryEndDate,
      DateTime? createdDate,
      DateTime? updatedDate,
      int? user}) {
    return CountryPass(
        id: id ?? this.id,
        countryName: countryName ?? this.countryName,
        expiryStartDate: expiryStartDate ?? this.expiryStartDate,
        expiryEndDate: expiryEndDate ?? this.expiryEndDate,
        createdDate: createdDate ?? this.createdDate,
        updatedDate: updatedDate ?? this.updatedDate,
        user: user ?? this.user);
  }

  CountryPass copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<String>? countryName,
      Wrapped<DateTime>? expiryStartDate,
      Wrapped<DateTime>? expiryEndDate,
      Wrapped<DateTime?>? createdDate,
      Wrapped<DateTime?>? updatedDate,
      Wrapped<int?>? user}) {
    return CountryPass(
        id: (id != null ? id.value : this.id),
        countryName:
            (countryName != null ? countryName.value : this.countryName),
        expiryStartDate: (expiryStartDate != null
            ? expiryStartDate.value
            : this.expiryStartDate),
        expiryEndDate:
            (expiryEndDate != null ? expiryEndDate.value : this.expiryEndDate),
        createdDate:
            (createdDate != null ? createdDate.value : this.createdDate),
        updatedDate:
            (updatedDate != null ? updatedDate.value : this.updatedDate),
        user: (user != null ? user.value : this.user));
  }
}

@JsonSerializable(explicitToJson: true)
class InsuranceFile {
  InsuranceFile({
    this.id,
    this.file,
    this.createdDate,
    this.updatedDate,
    required this.insurance,
  });

  factory InsuranceFile.fromJson(Map<String, dynamic> json) =>
      _$InsuranceFileFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'file', includeIfNull: false, defaultValue: '')
  final String? file;
  @JsonKey(name: 'created_date', includeIfNull: false)
  final DateTime? createdDate;
  @JsonKey(name: 'updated_date', includeIfNull: false)
  final DateTime? updatedDate;
  @JsonKey(name: 'insurance', includeIfNull: false)
  final int insurance;
  static const fromJsonFactory = _$InsuranceFileFromJson;
  static const toJsonFactory = _$InsuranceFileToJson;
  Map<String, dynamic> toJson() => _$InsuranceFileToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is InsuranceFile &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.file, file) ||
                const DeepCollectionEquality().equals(other.file, file)) &&
            (identical(other.createdDate, createdDate) ||
                const DeepCollectionEquality()
                    .equals(other.createdDate, createdDate)) &&
            (identical(other.updatedDate, updatedDate) ||
                const DeepCollectionEquality()
                    .equals(other.updatedDate, updatedDate)) &&
            (identical(other.insurance, insurance) ||
                const DeepCollectionEquality()
                    .equals(other.insurance, insurance)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(file) ^
      const DeepCollectionEquality().hash(createdDate) ^
      const DeepCollectionEquality().hash(updatedDate) ^
      const DeepCollectionEquality().hash(insurance) ^
      runtimeType.hashCode;
}

extension $InsuranceFileExtension on InsuranceFile {
  InsuranceFile copyWith(
      {int? id,
      String? file,
      DateTime? createdDate,
      DateTime? updatedDate,
      int? insurance}) {
    return InsuranceFile(
        id: id ?? this.id,
        file: file ?? this.file,
        createdDate: createdDate ?? this.createdDate,
        updatedDate: updatedDate ?? this.updatedDate,
        insurance: insurance ?? this.insurance);
  }

  InsuranceFile copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<String?>? file,
      Wrapped<DateTime?>? createdDate,
      Wrapped<DateTime?>? updatedDate,
      Wrapped<int>? insurance}) {
    return InsuranceFile(
        id: (id != null ? id.value : this.id),
        file: (file != null ? file.value : this.file),
        createdDate:
            (createdDate != null ? createdDate.value : this.createdDate),
        updatedDate:
            (updatedDate != null ? updatedDate.value : this.updatedDate),
        insurance: (insurance != null ? insurance.value : this.insurance));
  }
}

@JsonSerializable(explicitToJson: true)
class Insurance {
  Insurance({
    this.id,
    this.files,
    required this.user,
    required this.number,
    required this.name,
    required this.company,
    required this.issueDate,
    this.createdDate,
    this.updatedDate,
  });

  factory Insurance.fromJson(Map<String, dynamic> json) =>
      _$InsuranceFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'files', includeIfNull: false, defaultValue: <InsuranceFile>[])
  final List<InsuranceFile>? files;
  @JsonKey(name: 'user', includeIfNull: false)
  final int user;
  @JsonKey(name: 'number', includeIfNull: false, defaultValue: '')
  final String number;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'company', includeIfNull: false, defaultValue: '')
  final String company;
  @JsonKey(name: 'issue_date', includeIfNull: false, toJson: _dateToJson)
  final DateTime issueDate;
  @JsonKey(name: 'created_date', includeIfNull: false)
  final DateTime? createdDate;
  @JsonKey(name: 'updated_date', includeIfNull: false)
  final DateTime? updatedDate;
  static const fromJsonFactory = _$InsuranceFromJson;
  static const toJsonFactory = _$InsuranceToJson;
  Map<String, dynamic> toJson() => _$InsuranceToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Insurance &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.files, files) ||
                const DeepCollectionEquality().equals(other.files, files)) &&
            (identical(other.user, user) ||
                const DeepCollectionEquality().equals(other.user, user)) &&
            (identical(other.number, number) ||
                const DeepCollectionEquality().equals(other.number, number)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.company, company) ||
                const DeepCollectionEquality()
                    .equals(other.company, company)) &&
            (identical(other.issueDate, issueDate) ||
                const DeepCollectionEquality()
                    .equals(other.issueDate, issueDate)) &&
            (identical(other.createdDate, createdDate) ||
                const DeepCollectionEquality()
                    .equals(other.createdDate, createdDate)) &&
            (identical(other.updatedDate, updatedDate) ||
                const DeepCollectionEquality()
                    .equals(other.updatedDate, updatedDate)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(files) ^
      const DeepCollectionEquality().hash(user) ^
      const DeepCollectionEquality().hash(number) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(company) ^
      const DeepCollectionEquality().hash(issueDate) ^
      const DeepCollectionEquality().hash(createdDate) ^
      const DeepCollectionEquality().hash(updatedDate) ^
      runtimeType.hashCode;
}

extension $InsuranceExtension on Insurance {
  Insurance copyWith(
      {int? id,
      List<InsuranceFile>? files,
      int? user,
      String? number,
      String? name,
      String? company,
      DateTime? issueDate,
      DateTime? createdDate,
      DateTime? updatedDate}) {
    return Insurance(
        id: id ?? this.id,
        files: files ?? this.files,
        user: user ?? this.user,
        number: number ?? this.number,
        name: name ?? this.name,
        company: company ?? this.company,
        issueDate: issueDate ?? this.issueDate,
        createdDate: createdDate ?? this.createdDate,
        updatedDate: updatedDate ?? this.updatedDate);
  }

  Insurance copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<List<InsuranceFile>?>? files,
      Wrapped<int>? user,
      Wrapped<String>? number,
      Wrapped<String>? name,
      Wrapped<String>? company,
      Wrapped<DateTime>? issueDate,
      Wrapped<DateTime?>? createdDate,
      Wrapped<DateTime?>? updatedDate}) {
    return Insurance(
        id: (id != null ? id.value : this.id),
        files: (files != null ? files.value : this.files),
        user: (user != null ? user.value : this.user),
        number: (number != null ? number.value : this.number),
        name: (name != null ? name.value : this.name),
        company: (company != null ? company.value : this.company),
        issueDate: (issueDate != null ? issueDate.value : this.issueDate),
        createdDate:
            (createdDate != null ? createdDate.value : this.createdDate),
        updatedDate:
            (updatedDate != null ? updatedDate.value : this.updatedDate));
  }
}

@JsonSerializable(explicitToJson: true)
class CertificateFile {
  CertificateFile({
    this.id,
    this.file,
    this.createdDate,
    this.updatedDate,
    required this.certificate,
  });

  factory CertificateFile.fromJson(Map<String, dynamic> json) =>
      _$CertificateFileFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'file', includeIfNull: false, defaultValue: '')
  final String? file;
  @JsonKey(name: 'created_date', includeIfNull: false)
  final DateTime? createdDate;
  @JsonKey(name: 'updated_date', includeIfNull: false)
  final DateTime? updatedDate;
  @JsonKey(name: 'certificate', includeIfNull: false)
  final int certificate;
  static const fromJsonFactory = _$CertificateFileFromJson;
  static const toJsonFactory = _$CertificateFileToJson;
  Map<String, dynamic> toJson() => _$CertificateFileToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CertificateFile &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.file, file) ||
                const DeepCollectionEquality().equals(other.file, file)) &&
            (identical(other.createdDate, createdDate) ||
                const DeepCollectionEquality()
                    .equals(other.createdDate, createdDate)) &&
            (identical(other.updatedDate, updatedDate) ||
                const DeepCollectionEquality()
                    .equals(other.updatedDate, updatedDate)) &&
            (identical(other.certificate, certificate) ||
                const DeepCollectionEquality()
                    .equals(other.certificate, certificate)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(file) ^
      const DeepCollectionEquality().hash(createdDate) ^
      const DeepCollectionEquality().hash(updatedDate) ^
      const DeepCollectionEquality().hash(certificate) ^
      runtimeType.hashCode;
}

extension $CertificateFileExtension on CertificateFile {
  CertificateFile copyWith(
      {int? id,
      String? file,
      DateTime? createdDate,
      DateTime? updatedDate,
      int? certificate}) {
    return CertificateFile(
        id: id ?? this.id,
        file: file ?? this.file,
        createdDate: createdDate ?? this.createdDate,
        updatedDate: updatedDate ?? this.updatedDate,
        certificate: certificate ?? this.certificate);
  }

  CertificateFile copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<String?>? file,
      Wrapped<DateTime?>? createdDate,
      Wrapped<DateTime?>? updatedDate,
      Wrapped<int>? certificate}) {
    return CertificateFile(
        id: (id != null ? id.value : this.id),
        file: (file != null ? file.value : this.file),
        createdDate:
            (createdDate != null ? createdDate.value : this.createdDate),
        updatedDate:
            (updatedDate != null ? updatedDate.value : this.updatedDate),
        certificate:
            (certificate != null ? certificate.value : this.certificate));
  }
}

@JsonSerializable(explicitToJson: true)
class Certificate {
  Certificate({
    this.id,
    this.files,
    required this.user,
    required this.number,
    required this.authority,
    required this.issueDate,
    this.createdDate,
    this.updatedDate,
  });

  factory Certificate.fromJson(Map<String, dynamic> json) =>
      _$CertificateFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(
      name: 'files', includeIfNull: false, defaultValue: <CertificateFile>[])
  final List<CertificateFile>? files;
  @JsonKey(name: 'user', includeIfNull: false)
  final int user;
  @JsonKey(name: 'number', includeIfNull: false, defaultValue: '')
  final String number;
  @JsonKey(name: 'authority', includeIfNull: false, defaultValue: '')
  final String authority;
  @JsonKey(name: 'issue_date', includeIfNull: false, toJson: _dateToJson)
  final DateTime issueDate;
  @JsonKey(name: 'created_date', includeIfNull: false)
  final DateTime? createdDate;
  @JsonKey(name: 'updated_date', includeIfNull: false)
  final DateTime? updatedDate;
  static const fromJsonFactory = _$CertificateFromJson;
  static const toJsonFactory = _$CertificateToJson;
  Map<String, dynamic> toJson() => _$CertificateToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Certificate &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.files, files) ||
                const DeepCollectionEquality().equals(other.files, files)) &&
            (identical(other.user, user) ||
                const DeepCollectionEquality().equals(other.user, user)) &&
            (identical(other.number, number) ||
                const DeepCollectionEquality().equals(other.number, number)) &&
            (identical(other.authority, authority) ||
                const DeepCollectionEquality()
                    .equals(other.authority, authority)) &&
            (identical(other.issueDate, issueDate) ||
                const DeepCollectionEquality()
                    .equals(other.issueDate, issueDate)) &&
            (identical(other.createdDate, createdDate) ||
                const DeepCollectionEquality()
                    .equals(other.createdDate, createdDate)) &&
            (identical(other.updatedDate, updatedDate) ||
                const DeepCollectionEquality()
                    .equals(other.updatedDate, updatedDate)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(files) ^
      const DeepCollectionEquality().hash(user) ^
      const DeepCollectionEquality().hash(number) ^
      const DeepCollectionEquality().hash(authority) ^
      const DeepCollectionEquality().hash(issueDate) ^
      const DeepCollectionEquality().hash(createdDate) ^
      const DeepCollectionEquality().hash(updatedDate) ^
      runtimeType.hashCode;
}

extension $CertificateExtension on Certificate {
  Certificate copyWith(
      {int? id,
      List<CertificateFile>? files,
      int? user,
      String? number,
      String? authority,
      DateTime? issueDate,
      DateTime? createdDate,
      DateTime? updatedDate}) {
    return Certificate(
        id: id ?? this.id,
        files: files ?? this.files,
        user: user ?? this.user,
        number: number ?? this.number,
        authority: authority ?? this.authority,
        issueDate: issueDate ?? this.issueDate,
        createdDate: createdDate ?? this.createdDate,
        updatedDate: updatedDate ?? this.updatedDate);
  }

  Certificate copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<List<CertificateFile>?>? files,
      Wrapped<int>? user,
      Wrapped<String>? number,
      Wrapped<String>? authority,
      Wrapped<DateTime>? issueDate,
      Wrapped<DateTime?>? createdDate,
      Wrapped<DateTime?>? updatedDate}) {
    return Certificate(
        id: (id != null ? id.value : this.id),
        files: (files != null ? files.value : this.files),
        user: (user != null ? user.value : this.user),
        number: (number != null ? number.value : this.number),
        authority: (authority != null ? authority.value : this.authority),
        issueDate: (issueDate != null ? issueDate.value : this.issueDate),
        createdDate:
            (createdDate != null ? createdDate.value : this.createdDate),
        updatedDate:
            (updatedDate != null ? updatedDate.value : this.updatedDate));
  }
}

@JsonSerializable(explicitToJson: true)
class PassportFile {
  PassportFile({
    this.id,
    this.file,
    this.createdDate,
    this.updatedDate,
    required this.passport,
  });

  factory PassportFile.fromJson(Map<String, dynamic> json) =>
      _$PassportFileFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'file', includeIfNull: false, defaultValue: '')
  final String? file;
  @JsonKey(name: 'created_date', includeIfNull: false)
  final DateTime? createdDate;
  @JsonKey(name: 'updated_date', includeIfNull: false)
  final DateTime? updatedDate;
  @JsonKey(name: 'passport', includeIfNull: false)
  final int passport;
  static const fromJsonFactory = _$PassportFileFromJson;
  static const toJsonFactory = _$PassportFileToJson;
  Map<String, dynamic> toJson() => _$PassportFileToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PassportFile &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.file, file) ||
                const DeepCollectionEquality().equals(other.file, file)) &&
            (identical(other.createdDate, createdDate) ||
                const DeepCollectionEquality()
                    .equals(other.createdDate, createdDate)) &&
            (identical(other.updatedDate, updatedDate) ||
                const DeepCollectionEquality()
                    .equals(other.updatedDate, updatedDate)) &&
            (identical(other.passport, passport) ||
                const DeepCollectionEquality()
                    .equals(other.passport, passport)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(file) ^
      const DeepCollectionEquality().hash(createdDate) ^
      const DeepCollectionEquality().hash(updatedDate) ^
      const DeepCollectionEquality().hash(passport) ^
      runtimeType.hashCode;
}

extension $PassportFileExtension on PassportFile {
  PassportFile copyWith(
      {int? id,
      String? file,
      DateTime? createdDate,
      DateTime? updatedDate,
      int? passport}) {
    return PassportFile(
        id: id ?? this.id,
        file: file ?? this.file,
        createdDate: createdDate ?? this.createdDate,
        updatedDate: updatedDate ?? this.updatedDate,
        passport: passport ?? this.passport);
  }

  PassportFile copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<String?>? file,
      Wrapped<DateTime?>? createdDate,
      Wrapped<DateTime?>? updatedDate,
      Wrapped<int>? passport}) {
    return PassportFile(
        id: (id != null ? id.value : this.id),
        file: (file != null ? file.value : this.file),
        createdDate:
            (createdDate != null ? createdDate.value : this.createdDate),
        updatedDate:
            (updatedDate != null ? updatedDate.value : this.updatedDate),
        passport: (passport != null ? passport.value : this.passport));
  }
}

@JsonSerializable(explicitToJson: true)
class Passport {
  Passport({
    this.id,
    this.files,
    this.user,
    this.passportNo,
    this.personalNo,
    this.authority,
    this.registrationPlace,
    this.issueDate,
    this.expiryDate,
    this.createdDate,
    this.updatedDate,
  });

  factory Passport.fromJson(Map<String, dynamic> json) =>
      _$PassportFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'files', includeIfNull: false, defaultValue: <PassportFile>[])
  final List<PassportFile>? files;
  @JsonKey(name: 'user', includeIfNull: false)
  final int? user;
  @JsonKey(name: 'passport_no', includeIfNull: false, defaultValue: '')
  final String? passportNo;
  @JsonKey(name: 'personal_no', includeIfNull: false, defaultValue: '')
  final String? personalNo;
  @JsonKey(name: 'authority', includeIfNull: false, defaultValue: '')
  final String? authority;
  @JsonKey(name: 'registration_place', includeIfNull: false, defaultValue: '')
  final String? registrationPlace;
  @JsonKey(name: 'issue_date', includeIfNull: false, toJson: _dateToJson)
  final DateTime? issueDate;
  @JsonKey(name: 'expiry_date', includeIfNull: false, toJson: _dateToJson)
  final DateTime? expiryDate;
  @JsonKey(name: 'created_date', includeIfNull: false)
  final DateTime? createdDate;
  @JsonKey(name: 'updated_date', includeIfNull: false)
  final DateTime? updatedDate;
  static const fromJsonFactory = _$PassportFromJson;
  static const toJsonFactory = _$PassportToJson;
  Map<String, dynamic> toJson() => _$PassportToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Passport &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.files, files) ||
                const DeepCollectionEquality().equals(other.files, files)) &&
            (identical(other.user, user) ||
                const DeepCollectionEquality().equals(other.user, user)) &&
            (identical(other.passportNo, passportNo) ||
                const DeepCollectionEquality()
                    .equals(other.passportNo, passportNo)) &&
            (identical(other.personalNo, personalNo) ||
                const DeepCollectionEquality()
                    .equals(other.personalNo, personalNo)) &&
            (identical(other.authority, authority) ||
                const DeepCollectionEquality()
                    .equals(other.authority, authority)) &&
            (identical(other.registrationPlace, registrationPlace) ||
                const DeepCollectionEquality()
                    .equals(other.registrationPlace, registrationPlace)) &&
            (identical(other.issueDate, issueDate) ||
                const DeepCollectionEquality()
                    .equals(other.issueDate, issueDate)) &&
            (identical(other.expiryDate, expiryDate) ||
                const DeepCollectionEquality()
                    .equals(other.expiryDate, expiryDate)) &&
            (identical(other.createdDate, createdDate) ||
                const DeepCollectionEquality()
                    .equals(other.createdDate, createdDate)) &&
            (identical(other.updatedDate, updatedDate) ||
                const DeepCollectionEquality()
                    .equals(other.updatedDate, updatedDate)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(files) ^
      const DeepCollectionEquality().hash(user) ^
      const DeepCollectionEquality().hash(passportNo) ^
      const DeepCollectionEquality().hash(personalNo) ^
      const DeepCollectionEquality().hash(authority) ^
      const DeepCollectionEquality().hash(registrationPlace) ^
      const DeepCollectionEquality().hash(issueDate) ^
      const DeepCollectionEquality().hash(expiryDate) ^
      const DeepCollectionEquality().hash(createdDate) ^
      const DeepCollectionEquality().hash(updatedDate) ^
      runtimeType.hashCode;
}

extension $PassportExtension on Passport {
  Passport copyWith(
      {int? id,
      List<PassportFile>? files,
      int? user,
      String? passportNo,
      String? personalNo,
      String? authority,
      String? registrationPlace,
      DateTime? issueDate,
      DateTime? expiryDate,
      DateTime? createdDate,
      DateTime? updatedDate}) {
    return Passport(
        id: id ?? this.id,
        files: files ?? this.files,
        user: user ?? this.user,
        passportNo: passportNo ?? this.passportNo,
        personalNo: personalNo ?? this.personalNo,
        authority: authority ?? this.authority,
        registrationPlace: registrationPlace ?? this.registrationPlace,
        issueDate: issueDate ?? this.issueDate,
        expiryDate: expiryDate ?? this.expiryDate,
        createdDate: createdDate ?? this.createdDate,
        updatedDate: updatedDate ?? this.updatedDate);
  }

  Passport copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<List<PassportFile>?>? files,
      Wrapped<int?>? user,
      Wrapped<String?>? passportNo,
      Wrapped<String?>? personalNo,
      Wrapped<String?>? authority,
      Wrapped<String?>? registrationPlace,
      Wrapped<DateTime?>? issueDate,
      Wrapped<DateTime?>? expiryDate,
      Wrapped<DateTime?>? createdDate,
      Wrapped<DateTime?>? updatedDate}) {
    return Passport(
        id: (id != null ? id.value : this.id),
        files: (files != null ? files.value : this.files),
        user: (user != null ? user.value : this.user),
        passportNo: (passportNo != null ? passportNo.value : this.passportNo),
        personalNo: (personalNo != null ? personalNo.value : this.personalNo),
        authority: (authority != null ? authority.value : this.authority),
        registrationPlace: (registrationPlace != null
            ? registrationPlace.value
            : this.registrationPlace),
        issueDate: (issueDate != null ? issueDate.value : this.issueDate),
        expiryDate: (expiryDate != null ? expiryDate.value : this.expiryDate),
        createdDate:
            (createdDate != null ? createdDate.value : this.createdDate),
        updatedDate:
            (updatedDate != null ? updatedDate.value : this.updatedDate));
  }
}

@JsonSerializable(explicitToJson: true)
class TransportLicenseFile {
  TransportLicenseFile({
    this.id,
    this.file,
    this.createdDate,
    this.updatedDate,
    required this.license,
  });

  factory TransportLicenseFile.fromJson(Map<String, dynamic> json) =>
      _$TransportLicenseFileFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'file', includeIfNull: false, defaultValue: '')
  final String? file;
  @JsonKey(name: 'created_date', includeIfNull: false)
  final DateTime? createdDate;
  @JsonKey(name: 'updated_date', includeIfNull: false)
  final DateTime? updatedDate;
  @JsonKey(name: 'license', includeIfNull: false)
  final int license;
  static const fromJsonFactory = _$TransportLicenseFileFromJson;
  static const toJsonFactory = _$TransportLicenseFileToJson;
  Map<String, dynamic> toJson() => _$TransportLicenseFileToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TransportLicenseFile &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.file, file) ||
                const DeepCollectionEquality().equals(other.file, file)) &&
            (identical(other.createdDate, createdDate) ||
                const DeepCollectionEquality()
                    .equals(other.createdDate, createdDate)) &&
            (identical(other.updatedDate, updatedDate) ||
                const DeepCollectionEquality()
                    .equals(other.updatedDate, updatedDate)) &&
            (identical(other.license, license) ||
                const DeepCollectionEquality().equals(other.license, license)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(file) ^
      const DeepCollectionEquality().hash(createdDate) ^
      const DeepCollectionEquality().hash(updatedDate) ^
      const DeepCollectionEquality().hash(license) ^
      runtimeType.hashCode;
}

extension $TransportLicenseFileExtension on TransportLicenseFile {
  TransportLicenseFile copyWith(
      {int? id,
      String? file,
      DateTime? createdDate,
      DateTime? updatedDate,
      int? license}) {
    return TransportLicenseFile(
        id: id ?? this.id,
        file: file ?? this.file,
        createdDate: createdDate ?? this.createdDate,
        updatedDate: updatedDate ?? this.updatedDate,
        license: license ?? this.license);
  }

  TransportLicenseFile copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<String?>? file,
      Wrapped<DateTime?>? createdDate,
      Wrapped<DateTime?>? updatedDate,
      Wrapped<int>? license}) {
    return TransportLicenseFile(
        id: (id != null ? id.value : this.id),
        file: (file != null ? file.value : this.file),
        createdDate:
            (createdDate != null ? createdDate.value : this.createdDate),
        updatedDate:
            (updatedDate != null ? updatedDate.value : this.updatedDate),
        license: (license != null ? license.value : this.license));
  }
}

@JsonSerializable(explicitToJson: true)
class TransportLicense {
  TransportLicense({
    this.id,
    this.files,
    required this.user,
    required this.number,
    required this.authority,
    required this.issueDate,
    this.createdDate,
    this.updatedDate,
  });

  factory TransportLicense.fromJson(Map<String, dynamic> json) =>
      _$TransportLicenseFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(
      name: 'files',
      includeIfNull: false,
      defaultValue: <TransportLicenseFile>[])
  final List<TransportLicenseFile>? files;
  @JsonKey(name: 'user', includeIfNull: false)
  final int user;
  @JsonKey(name: 'number', includeIfNull: false, defaultValue: '')
  final String number;
  @JsonKey(name: 'authority', includeIfNull: false, defaultValue: '')
  final String authority;
  @JsonKey(name: 'issue_date', includeIfNull: false, toJson: _dateToJson)
  final DateTime issueDate;
  @JsonKey(name: 'created_date', includeIfNull: false)
  final DateTime? createdDate;
  @JsonKey(name: 'updated_date', includeIfNull: false)
  final DateTime? updatedDate;
  static const fromJsonFactory = _$TransportLicenseFromJson;
  static const toJsonFactory = _$TransportLicenseToJson;
  Map<String, dynamic> toJson() => _$TransportLicenseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TransportLicense &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.files, files) ||
                const DeepCollectionEquality().equals(other.files, files)) &&
            (identical(other.user, user) ||
                const DeepCollectionEquality().equals(other.user, user)) &&
            (identical(other.number, number) ||
                const DeepCollectionEquality().equals(other.number, number)) &&
            (identical(other.authority, authority) ||
                const DeepCollectionEquality()
                    .equals(other.authority, authority)) &&
            (identical(other.issueDate, issueDate) ||
                const DeepCollectionEquality()
                    .equals(other.issueDate, issueDate)) &&
            (identical(other.createdDate, createdDate) ||
                const DeepCollectionEquality()
                    .equals(other.createdDate, createdDate)) &&
            (identical(other.updatedDate, updatedDate) ||
                const DeepCollectionEquality()
                    .equals(other.updatedDate, updatedDate)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(files) ^
      const DeepCollectionEquality().hash(user) ^
      const DeepCollectionEquality().hash(number) ^
      const DeepCollectionEquality().hash(authority) ^
      const DeepCollectionEquality().hash(issueDate) ^
      const DeepCollectionEquality().hash(createdDate) ^
      const DeepCollectionEquality().hash(updatedDate) ^
      runtimeType.hashCode;
}

extension $TransportLicenseExtension on TransportLicense {
  TransportLicense copyWith(
      {int? id,
      List<TransportLicenseFile>? files,
      int? user,
      String? number,
      String? authority,
      DateTime? issueDate,
      DateTime? createdDate,
      DateTime? updatedDate}) {
    return TransportLicense(
        id: id ?? this.id,
        files: files ?? this.files,
        user: user ?? this.user,
        number: number ?? this.number,
        authority: authority ?? this.authority,
        issueDate: issueDate ?? this.issueDate,
        createdDate: createdDate ?? this.createdDate,
        updatedDate: updatedDate ?? this.updatedDate);
  }

  TransportLicense copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<List<TransportLicenseFile>?>? files,
      Wrapped<int>? user,
      Wrapped<String>? number,
      Wrapped<String>? authority,
      Wrapped<DateTime>? issueDate,
      Wrapped<DateTime?>? createdDate,
      Wrapped<DateTime?>? updatedDate}) {
    return TransportLicense(
        id: (id != null ? id.value : this.id),
        files: (files != null ? files.value : this.files),
        user: (user != null ? user.value : this.user),
        number: (number != null ? number.value : this.number),
        authority: (authority != null ? authority.value : this.authority),
        issueDate: (issueDate != null ? issueDate.value : this.issueDate),
        createdDate:
            (createdDate != null ? createdDate.value : this.createdDate),
        updatedDate:
            (updatedDate != null ? updatedDate.value : this.updatedDate));
  }
}

@JsonSerializable(explicitToJson: true)
class PersonalInfo {
  PersonalInfo({
    this.id,
    this.firstName,
    this.lastName,
    this.middleName,
  });

  factory PersonalInfo.fromJson(Map<String, dynamic> json) =>
      _$PersonalInfoFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'first_name', includeIfNull: false, defaultValue: '')
  final String? firstName;
  @JsonKey(name: 'last_name', includeIfNull: false, defaultValue: '')
  final String? lastName;
  @JsonKey(name: 'middle_name', includeIfNull: false, defaultValue: '')
  final String? middleName;
  static const fromJsonFactory = _$PersonalInfoFromJson;
  static const toJsonFactory = _$PersonalInfoToJson;
  Map<String, dynamic> toJson() => _$PersonalInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PersonalInfo &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.lastName, lastName) ||
                const DeepCollectionEquality()
                    .equals(other.lastName, lastName)) &&
            (identical(other.middleName, middleName) ||
                const DeepCollectionEquality()
                    .equals(other.middleName, middleName)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(firstName) ^
      const DeepCollectionEquality().hash(lastName) ^
      const DeepCollectionEquality().hash(middleName) ^
      runtimeType.hashCode;
}

extension $PersonalInfoExtension on PersonalInfo {
  PersonalInfo copyWith(
      {int? id, String? firstName, String? lastName, String? middleName}) {
    return PersonalInfo(
        id: id ?? this.id,
        firstName: firstName ?? this.firstName,
        lastName: lastName ?? this.lastName,
        middleName: middleName ?? this.middleName);
  }

  PersonalInfo copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<String?>? firstName,
      Wrapped<String?>? lastName,
      Wrapped<String?>? middleName}) {
    return PersonalInfo(
        id: (id != null ? id.value : this.id),
        firstName: (firstName != null ? firstName.value : this.firstName),
        lastName: (lastName != null ? lastName.value : this.lastName),
        middleName: (middleName != null ? middleName.value : this.middleName));
  }
}

@JsonSerializable(explicitToJson: true)
class User {
  User({
    this.id,
    this.directions,
    required this.contactInfo,
    required this.personalInfo,
    this.company,
    this.passport,
    this.lastLogin,
    this.password,
    this.isActive,
    required this.username,
    this.createdDate,
    this.updatedDate,
    this.userType,
    this.jobCompany,
  });

  factory User.fromJson(Map<String, dynamic> json) => _$UserFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final int? id;
  @JsonKey(name: 'directions', includeIfNull: false, defaultValue: <int>[])
  final List<int>? directions;
  @JsonKey(
      name: 'contact_info', includeIfNull: false, defaultValue: <ContactInfo>[])
  final List<ContactInfo> contactInfo;
  @JsonKey(name: 'personal_info', includeIfNull: false)
  final PersonalInfo personalInfo;
  @JsonKey(name: 'company', includeIfNull: false)
  final Company? company;
  @JsonKey(name: 'passport', includeIfNull: false)
  final Passport? passport;
  @JsonKey(name: 'last_login', includeIfNull: false)
  final DateTime? lastLogin;
  @JsonKey(name: 'password', includeIfNull: false, defaultValue: '')
  final String? password;
  @JsonKey(name: 'is_active', includeIfNull: false)
  final bool? isActive;
  @JsonKey(name: 'username', includeIfNull: false, defaultValue: '')
  final String username;
  @JsonKey(name: 'created_date', includeIfNull: false)
  final DateTime? createdDate;
  @JsonKey(name: 'updated_date', includeIfNull: false)
  final DateTime? updatedDate;
  @JsonKey(name: 'user_type', includeIfNull: false)
  final int? userType;
  @JsonKey(name: 'job_company', includeIfNull: false)
  final int? jobCompany;
  static const fromJsonFactory = _$UserFromJson;
  static const toJsonFactory = _$UserToJson;
  Map<String, dynamic> toJson() => _$UserToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is User &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.directions, directions) ||
                const DeepCollectionEquality()
                    .equals(other.directions, directions)) &&
            (identical(other.contactInfo, contactInfo) ||
                const DeepCollectionEquality()
                    .equals(other.contactInfo, contactInfo)) &&
            (identical(other.personalInfo, personalInfo) ||
                const DeepCollectionEquality()
                    .equals(other.personalInfo, personalInfo)) &&
            (identical(other.company, company) ||
                const DeepCollectionEquality()
                    .equals(other.company, company)) &&
            (identical(other.passport, passport) ||
                const DeepCollectionEquality()
                    .equals(other.passport, passport)) &&
            (identical(other.lastLogin, lastLogin) ||
                const DeepCollectionEquality()
                    .equals(other.lastLogin, lastLogin)) &&
            (identical(other.password, password) ||
                const DeepCollectionEquality()
                    .equals(other.password, password)) &&
            (identical(other.isActive, isActive) ||
                const DeepCollectionEquality()
                    .equals(other.isActive, isActive)) &&
            (identical(other.username, username) ||
                const DeepCollectionEquality()
                    .equals(other.username, username)) &&
            (identical(other.createdDate, createdDate) ||
                const DeepCollectionEquality()
                    .equals(other.createdDate, createdDate)) &&
            (identical(other.updatedDate, updatedDate) ||
                const DeepCollectionEquality()
                    .equals(other.updatedDate, updatedDate)) &&
            (identical(other.userType, userType) ||
                const DeepCollectionEquality()
                    .equals(other.userType, userType)) &&
            (identical(other.jobCompany, jobCompany) ||
                const DeepCollectionEquality()
                    .equals(other.jobCompany, jobCompany)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(directions) ^
      const DeepCollectionEquality().hash(contactInfo) ^
      const DeepCollectionEquality().hash(personalInfo) ^
      const DeepCollectionEquality().hash(company) ^
      const DeepCollectionEquality().hash(passport) ^
      const DeepCollectionEquality().hash(lastLogin) ^
      const DeepCollectionEquality().hash(password) ^
      const DeepCollectionEquality().hash(isActive) ^
      const DeepCollectionEquality().hash(username) ^
      const DeepCollectionEquality().hash(createdDate) ^
      const DeepCollectionEquality().hash(updatedDate) ^
      const DeepCollectionEquality().hash(userType) ^
      const DeepCollectionEquality().hash(jobCompany) ^
      runtimeType.hashCode;
}

extension $UserExtension on User {
  User copyWith(
      {int? id,
      List<int>? directions,
      List<ContactInfo>? contactInfo,
      PersonalInfo? personalInfo,
      Company? company,
      Passport? passport,
      DateTime? lastLogin,
      String? password,
      bool? isActive,
      String? username,
      DateTime? createdDate,
      DateTime? updatedDate,
      int? userType,
      int? jobCompany}) {
    return User(
        id: id ?? this.id,
        directions: directions ?? this.directions,
        contactInfo: contactInfo ?? this.contactInfo,
        personalInfo: personalInfo ?? this.personalInfo,
        company: company ?? this.company,
        passport: passport ?? this.passport,
        lastLogin: lastLogin ?? this.lastLogin,
        password: password ?? this.password,
        isActive: isActive ?? this.isActive,
        username: username ?? this.username,
        createdDate: createdDate ?? this.createdDate,
        updatedDate: updatedDate ?? this.updatedDate,
        userType: userType ?? this.userType,
        jobCompany: jobCompany ?? this.jobCompany);
  }

  User copyWithWrapped(
      {Wrapped<int?>? id,
      Wrapped<List<int>?>? directions,
      Wrapped<List<ContactInfo>>? contactInfo,
      Wrapped<PersonalInfo>? personalInfo,
      Wrapped<Company?>? company,
      Wrapped<Passport?>? passport,
      Wrapped<DateTime?>? lastLogin,
      Wrapped<String?>? password,
      Wrapped<bool?>? isActive,
      Wrapped<String>? username,
      Wrapped<DateTime?>? createdDate,
      Wrapped<DateTime?>? updatedDate,
      Wrapped<int?>? userType,
      Wrapped<int?>? jobCompany}) {
    return User(
        id: (id != null ? id.value : this.id),
        directions: (directions != null ? directions.value : this.directions),
        contactInfo:
            (contactInfo != null ? contactInfo.value : this.contactInfo),
        personalInfo:
            (personalInfo != null ? personalInfo.value : this.personalInfo),
        company: (company != null ? company.value : this.company),
        passport: (passport != null ? passport.value : this.passport),
        lastLogin: (lastLogin != null ? lastLogin.value : this.lastLogin),
        password: (password != null ? password.value : this.password),
        isActive: (isActive != null ? isActive.value : this.isActive),
        username: (username != null ? username.value : this.username),
        createdDate:
            (createdDate != null ? createdDate.value : this.createdDate),
        updatedDate:
            (updatedDate != null ? updatedDate.value : this.updatedDate),
        userType: (userType != null ? userType.value : this.userType),
        jobCompany: (jobCompany != null ? jobCompany.value : this.jobCompany));
  }
}

@JsonSerializable(explicitToJson: true)
class UserGetTokenViaCode {
  UserGetTokenViaCode({
    required this.username,
    required this.code,
  });

  factory UserGetTokenViaCode.fromJson(Map<String, dynamic> json) =>
      _$UserGetTokenViaCodeFromJson(json);

  @JsonKey(name: 'username', includeIfNull: false, defaultValue: '')
  final String username;
  @JsonKey(name: 'code', includeIfNull: false)
  final int code;
  static const fromJsonFactory = _$UserGetTokenViaCodeFromJson;
  static const toJsonFactory = _$UserGetTokenViaCodeToJson;
  Map<String, dynamic> toJson() => _$UserGetTokenViaCodeToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserGetTokenViaCode &&
            (identical(other.username, username) ||
                const DeepCollectionEquality()
                    .equals(other.username, username)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(username) ^
      const DeepCollectionEquality().hash(code) ^
      runtimeType.hashCode;
}

extension $UserGetTokenViaCodeExtension on UserGetTokenViaCode {
  UserGetTokenViaCode copyWith({String? username, int? code}) {
    return UserGetTokenViaCode(
        username: username ?? this.username, code: code ?? this.code);
  }

  UserGetTokenViaCode copyWithWrapped(
      {Wrapped<String>? username, Wrapped<int>? code}) {
    return UserGetTokenViaCode(
        username: (username != null ? username.value : this.username),
        code: (code != null ? code.value : this.code));
  }
}

@JsonSerializable(explicitToJson: true)
class UserAuthViaPhoneNumber {
  UserAuthViaPhoneNumber({
    required this.username,
  });

  factory UserAuthViaPhoneNumber.fromJson(Map<String, dynamic> json) =>
      _$UserAuthViaPhoneNumberFromJson(json);

  @JsonKey(name: 'username', includeIfNull: false, defaultValue: '')
  final String username;
  static const fromJsonFactory = _$UserAuthViaPhoneNumberFromJson;
  static const toJsonFactory = _$UserAuthViaPhoneNumberToJson;
  Map<String, dynamic> toJson() => _$UserAuthViaPhoneNumberToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserAuthViaPhoneNumber &&
            (identical(other.username, username) ||
                const DeepCollectionEquality()
                    .equals(other.username, username)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(username) ^ runtimeType.hashCode;
}

extension $UserAuthViaPhoneNumberExtension on UserAuthViaPhoneNumber {
  UserAuthViaPhoneNumber copyWith({String? username}) {
    return UserAuthViaPhoneNumber(username: username ?? this.username);
  }

  UserAuthViaPhoneNumber copyWithWrapped({Wrapped<String>? username}) {
    return UserAuthViaPhoneNumber(
        username: (username != null ? username.value : this.username));
  }
}

@JsonSerializable(explicitToJson: true)
class CarCarGet$Response {
  CarCarGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory CarCarGet$Response.fromJson(Map<String, dynamic> json) =>
      _$CarCarGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(name: 'results', includeIfNull: false, defaultValue: <Car>[])
  final List<Car> results;
  static const fromJsonFactory = _$CarCarGet$ResponseFromJson;
  static const toJsonFactory = _$CarCarGet$ResponseToJson;
  Map<String, dynamic> toJson() => _$CarCarGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CarCarGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $CarCarGet$ResponseExtension on CarCarGet$Response {
  CarCarGet$Response copyWith(
      {int? count, String? next, String? previous, List<Car>? results}) {
    return CarCarGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  CarCarGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<Car>>? results}) {
    return CarCarGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class CarPassportFileGet$Response {
  CarPassportFileGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory CarPassportFileGet$Response.fromJson(Map<String, dynamic> json) =>
      _$CarPassportFileGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(
      name: 'results', includeIfNull: false, defaultValue: <CarPassportFile>[])
  final List<CarPassportFile> results;
  static const fromJsonFactory = _$CarPassportFileGet$ResponseFromJson;
  static const toJsonFactory = _$CarPassportFileGet$ResponseToJson;
  Map<String, dynamic> toJson() => _$CarPassportFileGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CarPassportFileGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $CarPassportFileGet$ResponseExtension on CarPassportFileGet$Response {
  CarPassportFileGet$Response copyWith(
      {int? count,
      String? next,
      String? previous,
      List<CarPassportFile>? results}) {
    return CarPassportFileGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  CarPassportFileGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<CarPassportFile>>? results}) {
    return CarPassportFileGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class CarTrailerGet$Response {
  CarTrailerGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory CarTrailerGet$Response.fromJson(Map<String, dynamic> json) =>
      _$CarTrailerGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(name: 'results', includeIfNull: false, defaultValue: <Trailer>[])
  final List<Trailer> results;
  static const fromJsonFactory = _$CarTrailerGet$ResponseFromJson;
  static const toJsonFactory = _$CarTrailerGet$ResponseToJson;
  Map<String, dynamic> toJson() => _$CarTrailerGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CarTrailerGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $CarTrailerGet$ResponseExtension on CarTrailerGet$Response {
  CarTrailerGet$Response copyWith(
      {int? count, String? next, String? previous, List<Trailer>? results}) {
    return CarTrailerGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  CarTrailerGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<Trailer>>? results}) {
    return CarTrailerGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class CarTypeGet$Response {
  CarTypeGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory CarTypeGet$Response.fromJson(Map<String, dynamic> json) =>
      _$CarTypeGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(name: 'results', includeIfNull: false, defaultValue: <CarType>[])
  final List<CarType> results;
  static const fromJsonFactory = _$CarTypeGet$ResponseFromJson;
  static const toJsonFactory = _$CarTypeGet$ResponseToJson;
  Map<String, dynamic> toJson() => _$CarTypeGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CarTypeGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $CarTypeGet$ResponseExtension on CarTypeGet$Response {
  CarTypeGet$Response copyWith(
      {int? count, String? next, String? previous, List<CarType>? results}) {
    return CarTypeGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  CarTypeGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<CarType>>? results}) {
    return CarTypeGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class CargoCargoGet$Response {
  CargoCargoGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory CargoCargoGet$Response.fromJson(Map<String, dynamic> json) =>
      _$CargoCargoGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(name: 'results', includeIfNull: false, defaultValue: <Cargo>[])
  final List<Cargo> results;
  static const fromJsonFactory = _$CargoCargoGet$ResponseFromJson;
  static const toJsonFactory = _$CargoCargoGet$ResponseToJson;
  Map<String, dynamic> toJson() => _$CargoCargoGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CargoCargoGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $CargoCargoGet$ResponseExtension on CargoCargoGet$Response {
  CargoCargoGet$Response copyWith(
      {int? count, String? next, String? previous, List<Cargo>? results}) {
    return CargoCargoGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  CargoCargoGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<Cargo>>? results}) {
    return CargoCargoGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class CargoTypeGet$Response {
  CargoTypeGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory CargoTypeGet$Response.fromJson(Map<String, dynamic> json) =>
      _$CargoTypeGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(name: 'results', includeIfNull: false, defaultValue: <CargoType>[])
  final List<CargoType> results;
  static const fromJsonFactory = _$CargoTypeGet$ResponseFromJson;
  static const toJsonFactory = _$CargoTypeGet$ResponseToJson;
  Map<String, dynamic> toJson() => _$CargoTypeGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CargoTypeGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $CargoTypeGet$ResponseExtension on CargoTypeGet$Response {
  CargoTypeGet$Response copyWith(
      {int? count, String? next, String? previous, List<CargoType>? results}) {
    return CargoTypeGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  CargoTypeGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<CargoType>>? results}) {
    return CargoTypeGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class CityCityGet$Response {
  CityCityGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory CityCityGet$Response.fromJson(Map<String, dynamic> json) =>
      _$CityCityGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(name: 'results', includeIfNull: false, defaultValue: <City>[])
  final List<City> results;
  static const fromJsonFactory = _$CityCityGet$ResponseFromJson;
  static const toJsonFactory = _$CityCityGet$ResponseToJson;
  Map<String, dynamic> toJson() => _$CityCityGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CityCityGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $CityCityGet$ResponseExtension on CityCityGet$Response {
  CityCityGet$Response copyWith(
      {int? count, String? next, String? previous, List<City>? results}) {
    return CityCityGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  CityCityGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<City>>? results}) {
    return CityCityGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class CompanyCompanyGet$Response {
  CompanyCompanyGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory CompanyCompanyGet$Response.fromJson(Map<String, dynamic> json) =>
      _$CompanyCompanyGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(name: 'results', includeIfNull: false, defaultValue: <Company>[])
  final List<Company> results;
  static const fromJsonFactory = _$CompanyCompanyGet$ResponseFromJson;
  static const toJsonFactory = _$CompanyCompanyGet$ResponseToJson;
  Map<String, dynamic> toJson() => _$CompanyCompanyGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CompanyCompanyGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $CompanyCompanyGet$ResponseExtension on CompanyCompanyGet$Response {
  CompanyCompanyGet$Response copyWith(
      {int? count, String? next, String? previous, List<Company>? results}) {
    return CompanyCompanyGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  CompanyCompanyGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<Company>>? results}) {
    return CompanyCompanyGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class DealAdditionalInfoGet$Response {
  DealAdditionalInfoGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory DealAdditionalInfoGet$Response.fromJson(Map<String, dynamic> json) =>
      _$DealAdditionalInfoGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(
      name: 'results', includeIfNull: false, defaultValue: <AdditionalInfo>[])
  final List<AdditionalInfo> results;
  static const fromJsonFactory = _$DealAdditionalInfoGet$ResponseFromJson;
  static const toJsonFactory = _$DealAdditionalInfoGet$ResponseToJson;
  Map<String, dynamic> toJson() => _$DealAdditionalInfoGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DealAdditionalInfoGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $DealAdditionalInfoGet$ResponseExtension
    on DealAdditionalInfoGet$Response {
  DealAdditionalInfoGet$Response copyWith(
      {int? count,
      String? next,
      String? previous,
      List<AdditionalInfo>? results}) {
    return DealAdditionalInfoGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  DealAdditionalInfoGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<AdditionalInfo>>? results}) {
    return DealAdditionalInfoGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class DealDealGet$Response {
  DealDealGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory DealDealGet$Response.fromJson(Map<String, dynamic> json) =>
      _$DealDealGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(name: 'results', includeIfNull: false, defaultValue: <Deal>[])
  final List<Deal> results;
  static const fromJsonFactory = _$DealDealGet$ResponseFromJson;
  static const toJsonFactory = _$DealDealGet$ResponseToJson;
  Map<String, dynamic> toJson() => _$DealDealGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DealDealGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $DealDealGet$ResponseExtension on DealDealGet$Response {
  DealDealGet$Response copyWith(
      {int? count, String? next, String? previous, List<Deal>? results}) {
    return DealDealGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  DealDealGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<Deal>>? results}) {
    return DealDealGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class UserCarriageAgreementGet$Response {
  UserCarriageAgreementGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory UserCarriageAgreementGet$Response.fromJson(
          Map<String, dynamic> json) =>
      _$UserCarriageAgreementGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(
      name: 'results',
      includeIfNull: false,
      defaultValue: <CarriageAgreement>[])
  final List<CarriageAgreement> results;
  static const fromJsonFactory = _$UserCarriageAgreementGet$ResponseFromJson;
  static const toJsonFactory = _$UserCarriageAgreementGet$ResponseToJson;
  Map<String, dynamic> toJson() =>
      _$UserCarriageAgreementGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserCarriageAgreementGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $UserCarriageAgreementGet$ResponseExtension
    on UserCarriageAgreementGet$Response {
  UserCarriageAgreementGet$Response copyWith(
      {int? count,
      String? next,
      String? previous,
      List<CarriageAgreement>? results}) {
    return UserCarriageAgreementGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  UserCarriageAgreementGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<CarriageAgreement>>? results}) {
    return UserCarriageAgreementGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class UserContactInfoGet$Response {
  UserContactInfoGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory UserContactInfoGet$Response.fromJson(Map<String, dynamic> json) =>
      _$UserContactInfoGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(name: 'results', includeIfNull: false, defaultValue: <ContactInfo>[])
  final List<ContactInfo> results;
  static const fromJsonFactory = _$UserContactInfoGet$ResponseFromJson;
  static const toJsonFactory = _$UserContactInfoGet$ResponseToJson;
  Map<String, dynamic> toJson() => _$UserContactInfoGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserContactInfoGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $UserContactInfoGet$ResponseExtension on UserContactInfoGet$Response {
  UserContactInfoGet$Response copyWith(
      {int? count,
      String? next,
      String? previous,
      List<ContactInfo>? results}) {
    return UserContactInfoGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  UserContactInfoGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<ContactInfo>>? results}) {
    return UserContactInfoGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class UserCountryPassGet$Response {
  UserCountryPassGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory UserCountryPassGet$Response.fromJson(Map<String, dynamic> json) =>
      _$UserCountryPassGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(name: 'results', includeIfNull: false, defaultValue: <CountryPass>[])
  final List<CountryPass> results;
  static const fromJsonFactory = _$UserCountryPassGet$ResponseFromJson;
  static const toJsonFactory = _$UserCountryPassGet$ResponseToJson;
  Map<String, dynamic> toJson() => _$UserCountryPassGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserCountryPassGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $UserCountryPassGet$ResponseExtension on UserCountryPassGet$Response {
  UserCountryPassGet$Response copyWith(
      {int? count,
      String? next,
      String? previous,
      List<CountryPass>? results}) {
    return UserCountryPassGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  UserCountryPassGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<CountryPass>>? results}) {
    return UserCountryPassGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class UserInsuranceGet$Response {
  UserInsuranceGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory UserInsuranceGet$Response.fromJson(Map<String, dynamic> json) =>
      _$UserInsuranceGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(name: 'results', includeIfNull: false, defaultValue: <Insurance>[])
  final List<Insurance> results;
  static const fromJsonFactory = _$UserInsuranceGet$ResponseFromJson;
  static const toJsonFactory = _$UserInsuranceGet$ResponseToJson;
  Map<String, dynamic> toJson() => _$UserInsuranceGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserInsuranceGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $UserInsuranceGet$ResponseExtension on UserInsuranceGet$Response {
  UserInsuranceGet$Response copyWith(
      {int? count, String? next, String? previous, List<Insurance>? results}) {
    return UserInsuranceGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  UserInsuranceGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<Insurance>>? results}) {
    return UserInsuranceGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class UserInsuranceUploadFilesGet$Response {
  UserInsuranceUploadFilesGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory UserInsuranceUploadFilesGet$Response.fromJson(
          Map<String, dynamic> json) =>
      _$UserInsuranceUploadFilesGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(
      name: 'results', includeIfNull: false, defaultValue: <InsuranceFile>[])
  final List<InsuranceFile> results;
  static const fromJsonFactory = _$UserInsuranceUploadFilesGet$ResponseFromJson;
  static const toJsonFactory = _$UserInsuranceUploadFilesGet$ResponseToJson;
  Map<String, dynamic> toJson() =>
      _$UserInsuranceUploadFilesGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserInsuranceUploadFilesGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $UserInsuranceUploadFilesGet$ResponseExtension
    on UserInsuranceUploadFilesGet$Response {
  UserInsuranceUploadFilesGet$Response copyWith(
      {int? count,
      String? next,
      String? previous,
      List<InsuranceFile>? results}) {
    return UserInsuranceUploadFilesGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  UserInsuranceUploadFilesGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<InsuranceFile>>? results}) {
    return UserInsuranceUploadFilesGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class UserLegalEntityCertificateGet$Response {
  UserLegalEntityCertificateGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory UserLegalEntityCertificateGet$Response.fromJson(
          Map<String, dynamic> json) =>
      _$UserLegalEntityCertificateGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(name: 'results', includeIfNull: false, defaultValue: <Certificate>[])
  final List<Certificate> results;
  static const fromJsonFactory =
      _$UserLegalEntityCertificateGet$ResponseFromJson;
  static const toJsonFactory = _$UserLegalEntityCertificateGet$ResponseToJson;
  Map<String, dynamic> toJson() =>
      _$UserLegalEntityCertificateGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserLegalEntityCertificateGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $UserLegalEntityCertificateGet$ResponseExtension
    on UserLegalEntityCertificateGet$Response {
  UserLegalEntityCertificateGet$Response copyWith(
      {int? count,
      String? next,
      String? previous,
      List<Certificate>? results}) {
    return UserLegalEntityCertificateGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  UserLegalEntityCertificateGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<Certificate>>? results}) {
    return UserLegalEntityCertificateGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class UserLegalEntityCertificateUploadFilesGet$Response {
  UserLegalEntityCertificateUploadFilesGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory UserLegalEntityCertificateUploadFilesGet$Response.fromJson(
          Map<String, dynamic> json) =>
      _$UserLegalEntityCertificateUploadFilesGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(
      name: 'results', includeIfNull: false, defaultValue: <CertificateFile>[])
  final List<CertificateFile> results;
  static const fromJsonFactory =
      _$UserLegalEntityCertificateUploadFilesGet$ResponseFromJson;
  static const toJsonFactory =
      _$UserLegalEntityCertificateUploadFilesGet$ResponseToJson;
  Map<String, dynamic> toJson() =>
      _$UserLegalEntityCertificateUploadFilesGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserLegalEntityCertificateUploadFilesGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $UserLegalEntityCertificateUploadFilesGet$ResponseExtension
    on UserLegalEntityCertificateUploadFilesGet$Response {
  UserLegalEntityCertificateUploadFilesGet$Response copyWith(
      {int? count,
      String? next,
      String? previous,
      List<CertificateFile>? results}) {
    return UserLegalEntityCertificateUploadFilesGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  UserLegalEntityCertificateUploadFilesGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<CertificateFile>>? results}) {
    return UserLegalEntityCertificateUploadFilesGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class UserPassportGet$Response {
  UserPassportGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory UserPassportGet$Response.fromJson(Map<String, dynamic> json) =>
      _$UserPassportGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(name: 'results', includeIfNull: false, defaultValue: <Passport>[])
  final List<Passport> results;
  static const fromJsonFactory = _$UserPassportGet$ResponseFromJson;
  static const toJsonFactory = _$UserPassportGet$ResponseToJson;
  Map<String, dynamic> toJson() => _$UserPassportGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserPassportGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $UserPassportGet$ResponseExtension on UserPassportGet$Response {
  UserPassportGet$Response copyWith(
      {int? count, String? next, String? previous, List<Passport>? results}) {
    return UserPassportGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  UserPassportGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<Passport>>? results}) {
    return UserPassportGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class UserPassportUploadFilesGet$Response {
  UserPassportUploadFilesGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory UserPassportUploadFilesGet$Response.fromJson(
          Map<String, dynamic> json) =>
      _$UserPassportUploadFilesGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(
      name: 'results', includeIfNull: false, defaultValue: <PassportFile>[])
  final List<PassportFile> results;
  static const fromJsonFactory = _$UserPassportUploadFilesGet$ResponseFromJson;
  static const toJsonFactory = _$UserPassportUploadFilesGet$ResponseToJson;
  Map<String, dynamic> toJson() =>
      _$UserPassportUploadFilesGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserPassportUploadFilesGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $UserPassportUploadFilesGet$ResponseExtension
    on UserPassportUploadFilesGet$Response {
  UserPassportUploadFilesGet$Response copyWith(
      {int? count,
      String? next,
      String? previous,
      List<PassportFile>? results}) {
    return UserPassportUploadFilesGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  UserPassportUploadFilesGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<PassportFile>>? results}) {
    return UserPassportUploadFilesGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class UserTransportLicenseGet$Response {
  UserTransportLicenseGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory UserTransportLicenseGet$Response.fromJson(
          Map<String, dynamic> json) =>
      _$UserTransportLicenseGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(
      name: 'results', includeIfNull: false, defaultValue: <TransportLicense>[])
  final List<TransportLicense> results;
  static const fromJsonFactory = _$UserTransportLicenseGet$ResponseFromJson;
  static const toJsonFactory = _$UserTransportLicenseGet$ResponseToJson;
  Map<String, dynamic> toJson() =>
      _$UserTransportLicenseGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserTransportLicenseGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $UserTransportLicenseGet$ResponseExtension
    on UserTransportLicenseGet$Response {
  UserTransportLicenseGet$Response copyWith(
      {int? count,
      String? next,
      String? previous,
      List<TransportLicense>? results}) {
    return UserTransportLicenseGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  UserTransportLicenseGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<TransportLicense>>? results}) {
    return UserTransportLicenseGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class UserTransportLicenseUploadFilesGet$Response {
  UserTransportLicenseUploadFilesGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory UserTransportLicenseUploadFilesGet$Response.fromJson(
          Map<String, dynamic> json) =>
      _$UserTransportLicenseUploadFilesGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(
      name: 'results',
      includeIfNull: false,
      defaultValue: <TransportLicenseFile>[])
  final List<TransportLicenseFile> results;
  static const fromJsonFactory =
      _$UserTransportLicenseUploadFilesGet$ResponseFromJson;
  static const toJsonFactory =
      _$UserTransportLicenseUploadFilesGet$ResponseToJson;
  Map<String, dynamic> toJson() =>
      _$UserTransportLicenseUploadFilesGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserTransportLicenseUploadFilesGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $UserTransportLicenseUploadFilesGet$ResponseExtension
    on UserTransportLicenseUploadFilesGet$Response {
  UserTransportLicenseUploadFilesGet$Response copyWith(
      {int? count,
      String? next,
      String? previous,
      List<TransportLicenseFile>? results}) {
    return UserTransportLicenseUploadFilesGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  UserTransportLicenseUploadFilesGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<TransportLicenseFile>>? results}) {
    return UserTransportLicenseUploadFilesGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

@JsonSerializable(explicitToJson: true)
class UserUserGet$Response {
  UserUserGet$Response({
    required this.count,
    this.next,
    this.previous,
    required this.results,
  });

  factory UserUserGet$Response.fromJson(Map<String, dynamic> json) =>
      _$UserUserGet$ResponseFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'next', includeIfNull: false, defaultValue: '')
  final String? next;
  @JsonKey(name: 'previous', includeIfNull: false, defaultValue: '')
  final String? previous;
  @JsonKey(name: 'results', includeIfNull: false, defaultValue: <User>[])
  final List<User> results;
  static const fromJsonFactory = _$UserUserGet$ResponseFromJson;
  static const toJsonFactory = _$UserUserGet$ResponseToJson;
  Map<String, dynamic> toJson() => _$UserUserGet$ResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserUserGet$Response &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.next, next) ||
                const DeepCollectionEquality().equals(other.next, next)) &&
            (identical(other.previous, previous) ||
                const DeepCollectionEquality()
                    .equals(other.previous, previous)) &&
            (identical(other.results, results) ||
                const DeepCollectionEquality().equals(other.results, results)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(next) ^
      const DeepCollectionEquality().hash(previous) ^
      const DeepCollectionEquality().hash(results) ^
      runtimeType.hashCode;
}

extension $UserUserGet$ResponseExtension on UserUserGet$Response {
  UserUserGet$Response copyWith(
      {int? count, String? next, String? previous, List<User>? results}) {
    return UserUserGet$Response(
        count: count ?? this.count,
        next: next ?? this.next,
        previous: previous ?? this.previous,
        results: results ?? this.results);
  }

  UserUserGet$Response copyWithWrapped(
      {Wrapped<int>? count,
      Wrapped<String?>? next,
      Wrapped<String?>? previous,
      Wrapped<List<User>>? results}) {
    return UserUserGet$Response(
        count: (count != null ? count.value : this.count),
        next: (next != null ? next.value : this.next),
        previous: (previous != null ? previous.value : this.previous),
        results: (results != null ? results.value : this.results));
  }
}

int? carParameterLoadingTypeToJson(
    enums.CarParameterLoadingType? carParameterLoadingType) {
  return enums.$CarParameterLoadingTypeMap[carParameterLoadingType];
}

enums.CarParameterLoadingType carParameterLoadingTypeFromJson(
  Object? carParameterLoadingType, [
  enums.CarParameterLoadingType? defaultValue,
]) {
  if (carParameterLoadingType is int) {
    return enums.$CarParameterLoadingTypeMap.entries
        .firstWhere((element) => element.value == carParameterLoadingType,
            orElse: () => const MapEntry(
                enums.CarParameterLoadingType.swaggerGeneratedUnknown, 0))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CarParameterLoadingTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CarParameterLoadingType.swaggerGeneratedUnknown;
}

List<int> carParameterLoadingTypeListToJson(
    List<enums.CarParameterLoadingType>? carParameterLoadingType) {
  if (carParameterLoadingType == null) {
    return [];
  }

  return carParameterLoadingType
      .map((e) => enums.$CarParameterLoadingTypeMap[e]!)
      .toList();
}

List<enums.CarParameterLoadingType> carParameterLoadingTypeListFromJson(
  List? carParameterLoadingType, [
  List<enums.CarParameterLoadingType>? defaultValue,
]) {
  if (carParameterLoadingType == null) {
    return defaultValue ?? [];
  }

  return carParameterLoadingType
      .map((e) => carParameterLoadingTypeFromJson(e.toString()))
      .toList();
}

List<enums.CarParameterLoadingType>?
    carParameterLoadingTypeNullableListFromJson(
  List? carParameterLoadingType, [
  List<enums.CarParameterLoadingType>? defaultValue,
]) {
  if (carParameterLoadingType == null) {
    return defaultValue;
  }

  return carParameterLoadingType
      .map((e) => carParameterLoadingTypeFromJson(e.toString()))
      .toList();
}

int? contactInfoTypeToJson(enums.ContactInfoType? contactInfoType) {
  return enums.$ContactInfoTypeMap[contactInfoType];
}

enums.ContactInfoType contactInfoTypeFromJson(
  Object? contactInfoType, [
  enums.ContactInfoType? defaultValue,
]) {
  if (contactInfoType is int) {
    return enums.$ContactInfoTypeMap.entries
        .firstWhere((element) => element.value == contactInfoType,
            orElse: () => const MapEntry(
                enums.ContactInfoType.swaggerGeneratedUnknown, 0))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ContactInfoTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ContactInfoType.swaggerGeneratedUnknown;
}

List<int> contactInfoTypeListToJson(
    List<enums.ContactInfoType>? contactInfoType) {
  if (contactInfoType == null) {
    return [];
  }

  return contactInfoType.map((e) => enums.$ContactInfoTypeMap[e]!).toList();
}

List<enums.ContactInfoType> contactInfoTypeListFromJson(
  List? contactInfoType, [
  List<enums.ContactInfoType>? defaultValue,
]) {
  if (contactInfoType == null) {
    return defaultValue ?? [];
  }

  return contactInfoType
      .map((e) => contactInfoTypeFromJson(e.toString()))
      .toList();
}

List<enums.ContactInfoType>? contactInfoTypeNullableListFromJson(
  List? contactInfoType, [
  List<enums.ContactInfoType>? defaultValue,
]) {
  if (contactInfoType == null) {
    return defaultValue;
  }

  return contactInfoType
      .map((e) => contactInfoTypeFromJson(e.toString()))
      .toList();
}

int? userUserTypeToJson(enums.UserUserType? userUserType) {
  return enums.$UserUserTypeMap[userUserType];
}

enums.UserUserType userUserTypeFromJson(
  Object? userUserType, [
  enums.UserUserType? defaultValue,
]) {
  if (userUserType is int) {
    return enums.$UserUserTypeMap.entries
        .firstWhere((element) => element.value == userUserType,
            orElse: () =>
                const MapEntry(enums.UserUserType.swaggerGeneratedUnknown, 0))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$UserUserTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.UserUserType.swaggerGeneratedUnknown;
}

List<int> userUserTypeListToJson(List<enums.UserUserType>? userUserType) {
  if (userUserType == null) {
    return [];
  }

  return userUserType.map((e) => enums.$UserUserTypeMap[e]!).toList();
}

List<enums.UserUserType> userUserTypeListFromJson(
  List? userUserType, [
  List<enums.UserUserType>? defaultValue,
]) {
  if (userUserType == null) {
    return defaultValue ?? [];
  }

  return userUserType.map((e) => userUserTypeFromJson(e.toString())).toList();
}

List<enums.UserUserType>? userUserTypeNullableListFromJson(
  List? userUserType, [
  List<enums.UserUserType>? defaultValue,
]) {
  if (userUserType == null) {
    return defaultValue;
  }

  return userUserType.map((e) => userUserTypeFromJson(e.toString())).toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
