// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'order_remote_data_source.enums.swagger.dart' as enums;
export 'order_remote_data_source.enums.swagger.dart';

part 'order_remote_data_source.swagger.chopper.dart';
part 'order_remote_data_source.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class OrderRemoteDataSource extends ChopperService {
  static OrderRemoteDataSource create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$OrderRemoteDataSource(client);
    }

    final newClient = ChopperClient(
        services: [_$OrderRemoteDataSource()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$OrderRemoteDataSource(newClient);
  }

  ///
  ///@param orderId
  Future<chopper.Response<OrderDelta>> orderV1AnalyticsDeltaOrderIdGet({
    required num? orderId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(OrderDelta, () => OrderDelta.fromJsonFactory);

    return _orderV1AnalyticsDeltaOrderIdGet(
        orderId: orderId, cacheControl: cacheControl);
  }

  ///
  ///@param orderId
  @Get(path: '/order/v1/analytics/delta/{orderId}')
  Future<chopper.Response<OrderDelta>> _orderV1AnalyticsDeltaOrderIdGet({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param orderId
  Future<chopper.Response<String>> orderV1OrderIdDelete({
    required num? orderId,
    String? cacheControl,
  }) {
    return _orderV1OrderIdDelete(orderId: orderId, cacheControl: cacheControl);
  }

  ///
  ///@param orderId
  @Delete(path: '/order/v1/{orderId}')
  Future<chopper.Response<String>> _orderV1OrderIdDelete({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param orderId
  Future<chopper.Response<OrderDelta>> v2OrderAnalyticsDeltaOrderIdGet({
    required num? orderId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(OrderDelta, () => OrderDelta.fromJsonFactory);

    return _v2OrderAnalyticsDeltaOrderIdGet(
        orderId: orderId, cacheControl: cacheControl);
  }

  ///
  ///@param orderId
  @Get(path: '/v2/order/analytics/delta/{orderId}')
  Future<chopper.Response<OrderDelta>> _v2OrderAnalyticsDeltaOrderIdGet({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<ItemList>> v2OrderItemsPut({
    String? cacheControl,
    required ItemList? body,
  }) {
    generatedMapping.putIfAbsent(ItemList, () => ItemList.fromJsonFactory);

    return _v2OrderItemsPut(cacheControl: cacheControl, body: body);
  }

  ///
  @Put(path: '/v2/order/items')
  Future<chopper.Response<ItemList>> _v2OrderItemsPut({
    @Header('Cache-Control') String? cacheControl,
    @Body() required ItemList? body,
  });

  ///
  ///@param x-application
  Future<chopper.Response<List<OrderSummary>>> v2OrderSummariesGet({
    String? xApplication,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        OrderSummary, () => OrderSummary.fromJsonFactory);

    return _v2OrderSummariesGet(
        xApplication: xApplication, cacheControl: cacheControl);
  }

  ///
  ///@param x-application
  @Get(path: '/v2/order/summaries')
  Future<chopper.Response<List<OrderSummary>>> _v2OrderSummariesGet({
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param x-application
  Future<chopper.Response<LatestOrderSummary>> v2OrderSummariesLatestGet({
    String? xApplication,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        LatestOrderSummary, () => LatestOrderSummary.fromJsonFactory);

    return _v2OrderSummariesLatestGet(
        xApplication: xApplication, cacheControl: cacheControl);
  }

  ///
  ///@param x-application
  @Get(path: '/v2/order/summaries/latest')
  Future<chopper.Response<LatestOrderSummary>> _v2OrderSummariesLatestGet({
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param orderId
  Future<chopper.Response<String>> v2OrderOrderIdDelete({
    required num? orderId,
    String? cacheControl,
  }) {
    return _v2OrderOrderIdDelete(orderId: orderId, cacheControl: cacheControl);
  }

  ///
  ///@param orderId
  @Delete(path: '/v2/order/{orderId}')
  Future<chopper.Response<String>> _v2OrderOrderIdDelete({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param orderId
  Future<chopper.Response<OrderDetails>> v2OrderOrderIdDetailsGet({
    required num? orderId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        OrderDetails, () => OrderDetails.fromJsonFactory);

    return _v2OrderOrderIdDetailsGet(
        orderId: orderId, cacheControl: cacheControl);
  }

  ///
  ///@param orderId
  @Get(path: '/v2/order/{orderId}/details')
  Future<chopper.Response<OrderDetails>> _v2OrderOrderIdDetailsGet({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param orderId
  Future<chopper.Response<OrderDetailsGroupedByTaxonomy>>
      v2OrderOrderIdDetailsGroupedByTaxonomyGet({
    required num? orderId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(OrderDetailsGroupedByTaxonomy,
        () => OrderDetailsGroupedByTaxonomy.fromJsonFactory);

    return _v2OrderOrderIdDetailsGroupedByTaxonomyGet(
        orderId: orderId, cacheControl: cacheControl);
  }

  ///
  ///@param orderId
  @Get(path: '/v2/order/{orderId}/details-grouped-by-taxonomy')
  Future<chopper.Response<OrderDetailsGroupedByTaxonomy>>
      _v2OrderOrderIdDetailsGroupedByTaxonomyGet({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param orderId
  Future<chopper.Response<String>> v2OrderOrderIdSubmitPost({
    required num? orderId,
    String? cacheControl,
  }) {
    return _v2OrderOrderIdSubmitPost(
        orderId: orderId, cacheControl: cacheControl);
  }

  ///
  ///@param orderId
  @Post(
    path: '/v2/order/{orderId}/submit',
    optionalBody: true,
  )
  Future<chopper.Response<String>> _v2OrderOrderIdSubmitPost({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param x-application
  Future<chopper.Response<CreateOrderResponse>> v3OrderPost({
    String? xApplication,
    String? cacheControl,
    required CreateOrderRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        CreateOrderResponse, () => CreateOrderResponse.fromJsonFactory);

    return _v3OrderPost(
        xApplication: xApplication, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param x-application
  @Post(path: '/v3/order')
  Future<chopper.Response<CreateOrderResponse>> _v3OrderPost({
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
    @Body() required CreateOrderRequest? body,
  });

  ///
  ///@param invoiceId
  Future<chopper.Response<String>> v3OrderInvoiceDownloadGet({
    required String? invoiceId,
    String? cacheControl,
  }) {
    return _v3OrderInvoiceDownloadGet(
        invoiceId: invoiceId, cacheControl: cacheControl);
  }

  ///
  ///@param invoiceId
  @Get(path: '/v3/order/invoice/download')
  Future<chopper.Response<String>> _v3OrderInvoiceDownloadGet({
    @Query('invoiceId') required String? invoiceId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param x-application
  Future<chopper.Response<ActiveOrderAndListSummary>>
      v3OrderSummariesActiveGet({
    String? xApplication,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ActiveOrderAndListSummary,
        () => ActiveOrderAndListSummary.fromJsonFactory);

    return _v3OrderSummariesActiveGet(
        xApplication: xApplication, cacheControl: cacheControl);
  }

  ///
  ///@param x-application
  @Get(path: '/v3/order/summaries/active')
  Future<chopper.Response<ActiveOrderAndListSummary>>
      _v3OrderSummariesActiveGet({
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param x-application
  Future<chopper.Response<List<OrderSummary>>> v3OrderSummariesCurrentGet({
    String? xApplication,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        OrderSummary, () => OrderSummary.fromJsonFactory);

    return _v3OrderSummariesCurrentGet(
        xApplication: xApplication, cacheControl: cacheControl);
  }

  ///
  ///@param x-application
  @Get(path: '/v3/order/summaries/current')
  Future<chopper.Response<List<OrderSummary>>> _v3OrderSummariesCurrentGet({
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param x-application
  Future<chopper.Response<LatestOrderSummary>> v3OrderSummariesLatestGet({
    String? xApplication,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        LatestOrderSummary, () => LatestOrderSummary.fromJsonFactory);

    return _v3OrderSummariesLatestGet(
        xApplication: xApplication, cacheControl: cacheControl);
  }

  ///
  ///@param x-application
  @Get(path: '/v3/order/summaries/latest')
  Future<chopper.Response<LatestOrderSummary>> _v3OrderSummariesLatestGet({
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param orderId Id of the order
  Future<chopper.Response<Receipt>> v3OrderOrderIdActioncodePost({
    required num? orderId,
    String? cacheControl,
    required ActionCode? body,
  }) {
    generatedMapping.putIfAbsent(Receipt, () => Receipt.fromJsonFactory);

    return _v3OrderOrderIdActioncodePost(
        orderId: orderId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param orderId Id of the order
  @Post(path: '/v3/order/{orderId}/actioncode')
  Future<chopper.Response<Receipt>> _v3OrderOrderIdActioncodePost({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
    @Body() required ActionCode? body,
  });

  ///
  ///@param x-application
  ///@param orderId Id of the order
  Future<chopper.Response<CheckOut>> v3OrderOrderIdCheckoutGet({
    String? xApplication,
    required num? orderId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CheckOut, () => CheckOut.fromJsonFactory);

    return _v3OrderOrderIdCheckoutGet(
        xApplication: xApplication,
        orderId: orderId,
        cacheControl: cacheControl);
  }

  ///
  ///@param x-application
  ///@param orderId Id of the order
  @Get(path: '/v3/order/{orderId}/checkout')
  Future<chopper.Response<CheckOut>> _v3OrderOrderIdCheckoutGet({
    @Header('x-application') String? xApplication,
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param orderId
  Future<chopper.Response<num>> v3OrderOrderIdMovGet({
    required num? orderId,
    String? cacheControl,
  }) {
    return _v3OrderOrderIdMovGet(orderId: orderId, cacheControl: cacheControl);
  }

  ///
  ///@param orderId
  @Get(path: '/v3/order/{orderId}/mov')
  Future<chopper.Response<num>> _v3OrderOrderIdMovGet({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param orderId Id of the order
  Future<chopper.Response<Receipt>> v3OrderOrderIdReceiptGet({
    required num? orderId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Receipt, () => Receipt.fromJsonFactory);

    return _v3OrderOrderIdReceiptGet(
        orderId: orderId, cacheControl: cacheControl);
  }

  ///
  ///@param orderId Id of the order
  @Get(path: '/v3/order/{orderId}/receipt')
  Future<chopper.Response<Receipt>> _v3OrderOrderIdReceiptGet({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param orderId Id of the order
  Future<chopper.Response<UpdateSampleResponse>> v3OrderOrderIdSamplePost({
    required num? orderId,
    String? cacheControl,
    required UpdateSampleRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        UpdateSampleResponse, () => UpdateSampleResponse.fromJsonFactory);

    return _v3OrderOrderIdSamplePost(
        orderId: orderId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param orderId Id of the order
  @Post(path: '/v3/order/{orderId}/sample')
  Future<chopper.Response<UpdateSampleResponse>> _v3OrderOrderIdSamplePost({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
    @Body() required UpdateSampleRequest? body,
  });

  ///
  ///@param orderId Id of the order
  Future<chopper.Response<Object>> v3OrderOrderIdStatePut({
    required num? orderId,
    String? cacheControl,
    required String? body,
  }) {
    return _v3OrderOrderIdStatePut(
        orderId: orderId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param orderId Id of the order
  @Put(path: '/v3/order/{orderId}/state')
  Future<chopper.Response<Object>> _v3OrderOrderIdStatePut({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
    @Body() required String? body,
  });

  ///
  ///@param orderId Id of the order
  Future<chopper.Response<List<OrderValidation>>> v3OrderOrderIdValidateGet({
    required num? orderId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        OrderValidation, () => OrderValidation.fromJsonFactory);

    return _v3OrderOrderIdValidateGet(
        orderId: orderId, cacheControl: cacheControl);
  }

  ///
  ///@param orderId Id of the order
  @Get(path: '/v3/order/{orderId}/validate')
  Future<chopper.Response<List<OrderValidation>>> _v3OrderOrderIdValidateGet({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param x-application
  Future<chopper.Response<CreateOrderResponse>> v4OrderPost({
    String? xApplication,
    String? cacheControl,
    required CreateOrderRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        CreateOrderResponse, () => CreateOrderResponse.fromJsonFactory);

    return _v4OrderPost(
        xApplication: xApplication, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param x-application
  @Post(path: '/v4/order')
  Future<chopper.Response<CreateOrderResponse>> _v4OrderPost({
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
    @Body() required CreateOrderRequest? body,
  });

  ///
  ///@param invoiceId
  Future<chopper.Response<String>> v4OrderInvoiceDownloadGet({
    required String? invoiceId,
    String? cacheControl,
  }) {
    return _v4OrderInvoiceDownloadGet(
        invoiceId: invoiceId, cacheControl: cacheControl);
  }

  ///
  ///@param invoiceId
  @Get(path: '/v4/order/invoice/download')
  Future<chopper.Response<String>> _v4OrderInvoiceDownloadGet({
    @Query('invoiceId') required String? invoiceId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param Appie-Current-Order-Id
  Future<chopper.Response<UpdateOrderResponse>> v4OrderItemsPut({
    String? appieCurrentOrderId,
    String? cacheControl,
    required UpdateOrderRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        UpdateOrderResponse, () => UpdateOrderResponse.fromJsonFactory);

    return _v4OrderItemsPut(
        appieCurrentOrderId: appieCurrentOrderId,
        cacheControl: cacheControl,
        body: body);
  }

  ///
  ///@param Appie-Current-Order-Id
  @Put(path: '/v4/order/items')
  Future<chopper.Response<UpdateOrderResponse>> _v4OrderItemsPut({
    @Header('Appie-Current-Order-Id') String? appieCurrentOrderId,
    @Header('Cache-Control') String? cacheControl,
    @Body() required UpdateOrderRequest? body,
  });

  ///
  ///@param x-application
  Future<chopper.Response<List<OrderSummary>>> v4OrderSummariesGet({
    String? xApplication,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        OrderSummary, () => OrderSummary.fromJsonFactory);

    return _v4OrderSummariesGet(
        xApplication: xApplication, cacheControl: cacheControl);
  }

  ///
  ///@param x-application
  @Get(path: '/v4/order/summaries')
  Future<chopper.Response<List<OrderSummary>>> _v4OrderSummariesGet({
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param x-application
  ///@param current
  ///@param addProductCards
  Future<chopper.Response<OrderSummary>> v4OrderSummariesFirstGet({
    String? xApplication,
    bool? current,
    bool? addProductCards,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        OrderSummary, () => OrderSummary.fromJsonFactory);

    return _v4OrderSummariesFirstGet(
        xApplication: xApplication,
        current: current,
        addProductCards: addProductCards,
        cacheControl: cacheControl);
  }

  ///
  ///@param x-application
  ///@param current
  ///@param addProductCards
  @Get(path: '/v4/order/summaries/first')
  Future<chopper.Response<OrderSummary>> _v4OrderSummariesFirstGet({
    @Header('x-application') String? xApplication,
    @Query('current') bool? current,
    @Query('addProductCards') bool? addProductCards,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get summary of latest order
  ///@param x-application
  Future<chopper.Response<LatestOrderSummary>> v4OrderSummariesLatestGet({
    String? xApplication,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        LatestOrderSummary, () => LatestOrderSummary.fromJsonFactory);

    return _v4OrderSummariesLatestGet(
        xApplication: xApplication, cacheControl: cacheControl);
  }

  ///Get summary of latest order
  ///@param x-application
  @Get(path: '/v4/order/summaries/latest')
  Future<chopper.Response<LatestOrderSummary>> _v4OrderSummariesLatestGet({
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param x-application
  Future<chopper.Response<List<OrderSummary>>> v4OrderSummariesReopenableGet({
    String? xApplication,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        OrderSummary, () => OrderSummary.fromJsonFactory);

    return _v4OrderSummariesReopenableGet(
        xApplication: xApplication, cacheControl: cacheControl);
  }

  ///
  ///@param x-application
  @Get(path: '/v4/order/summaries/reopenable')
  Future<chopper.Response<List<OrderSummary>>> _v4OrderSummariesReopenableGet({
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param orderId Id of the order
  Future<chopper.Response<Receipt>> v4OrderOrderIdActioncodePost({
    required num? orderId,
    String? cacheControl,
    required ActionCode? body,
  }) {
    generatedMapping.putIfAbsent(Receipt, () => Receipt.fromJsonFactory);

    return _v4OrderOrderIdActioncodePost(
        orderId: orderId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param orderId Id of the order
  @Post(path: '/v4/order/{orderId}/actioncode')
  Future<chopper.Response<Receipt>> _v4OrderOrderIdActioncodePost({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
    @Body() required ActionCode? body,
  });

  ///
  ///@param x-application
  ///@param orderId Id of the order
  Future<chopper.Response<CheckOut>> v4OrderOrderIdCheckoutGet({
    String? xApplication,
    required num? orderId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CheckOut, () => CheckOut.fromJsonFactory);

    return _v4OrderOrderIdCheckoutGet(
        xApplication: xApplication,
        orderId: orderId,
        cacheControl: cacheControl);
  }

  ///
  ///@param x-application
  ///@param orderId Id of the order
  @Get(path: '/v4/order/{orderId}/checkout')
  Future<chopper.Response<CheckOut>> _v4OrderOrderIdCheckoutGet({
    @Header('x-application') String? xApplication,
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param orderId
  Future<chopper.Response<OrderDetails>> v4OrderOrderIdDetailsGet({
    required num? orderId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        OrderDetails, () => OrderDetails.fromJsonFactory);

    return _v4OrderOrderIdDetailsGet(
        orderId: orderId, cacheControl: cacheControl);
  }

  ///
  ///@param orderId
  @Get(path: '/v4/order/{orderId}/details')
  Future<chopper.Response<OrderDetails>> _v4OrderOrderIdDetailsGet({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param orderId
  Future<chopper.Response<num>> v4OrderOrderIdMovGet({
    required num? orderId,
    String? cacheControl,
  }) {
    return _v4OrderOrderIdMovGet(orderId: orderId, cacheControl: cacheControl);
  }

  ///
  ///@param orderId
  @Get(path: '/v4/order/{orderId}/mov')
  Future<chopper.Response<num>> _v4OrderOrderIdMovGet({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param orderId Id of the order
  Future<chopper.Response<Receipt>> v4OrderOrderIdReceiptGet({
    required num? orderId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Receipt, () => Receipt.fromJsonFactory);

    return _v4OrderOrderIdReceiptGet(
        orderId: orderId, cacheControl: cacheControl);
  }

  ///
  ///@param orderId Id of the order
  @Get(path: '/v4/order/{orderId}/receipt')
  Future<chopper.Response<Receipt>> _v4OrderOrderIdReceiptGet({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param orderId Id of the order
  Future<chopper.Response<UpdateSampleResponse>> v4OrderOrderIdSamplePost({
    required num? orderId,
    String? cacheControl,
    required UpdateSampleRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        UpdateSampleResponse, () => UpdateSampleResponse.fromJsonFactory);

    return _v4OrderOrderIdSamplePost(
        orderId: orderId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param orderId Id of the order
  @Post(path: '/v4/order/{orderId}/sample')
  Future<chopper.Response<UpdateSampleResponse>> _v4OrderOrderIdSamplePost({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
    @Body() required UpdateSampleRequest? body,
  });

  ///
  ///@param orderId Id of the order
  ///@param date Desired slot date (yyyy-mm-dd)
  ///@param shiftCode shiftCode
  ///@param pickupLocationId pickupLocationId
  Future<chopper.Response<UpdateSlotResponse>> v4OrderOrderIdSlotPut({
    required num? orderId,
    required String? date,
    required String? shiftCode,
    num? pickupLocationId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UpdateSlotResponse, () => UpdateSlotResponse.fromJsonFactory);

    return _v4OrderOrderIdSlotPut(
        orderId: orderId,
        date: date,
        shiftCode: shiftCode,
        pickupLocationId: pickupLocationId,
        cacheControl: cacheControl);
  }

  ///
  ///@param orderId Id of the order
  ///@param date Desired slot date (yyyy-mm-dd)
  ///@param shiftCode shiftCode
  ///@param pickupLocationId pickupLocationId
  @Put(
    path: '/v4/order/{orderId}/slot',
    optionalBody: true,
  )
  Future<chopper.Response<UpdateSlotResponse>> _v4OrderOrderIdSlotPut({
    @Path('orderId') required num? orderId,
    @Query('date') required String? date,
    @Query('shiftCode') required String? shiftCode,
    @Query('pickupLocationId') num? pickupLocationId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param orderId Id of the order
  Future<chopper.Response<OrderDetails>> v4OrderOrderIdStatePut({
    required num? orderId,
    String? cacheControl,
    required String? body,
  }) {
    generatedMapping.putIfAbsent(
        OrderDetails, () => OrderDetails.fromJsonFactory);

    return _v4OrderOrderIdStatePut(
        orderId: orderId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param orderId Id of the order
  @Put(path: '/v4/order/{orderId}/state')
  Future<chopper.Response<OrderDetails>> _v4OrderOrderIdStatePut({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
    @Body() required String? body,
  });

  ///
  ///@param orderId Id of the order
  Future<chopper.Response<OrderDetails>> v4OrderOrderIdSubmitPut({
    required num? orderId,
    String? cacheControl,
    required SubmittedOrder? body,
  }) {
    generatedMapping.putIfAbsent(
        OrderDetails, () => OrderDetails.fromJsonFactory);

    return _v4OrderOrderIdSubmitPut(
        orderId: orderId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param orderId Id of the order
  @Put(path: '/v4/order/{orderId}/submit')
  Future<chopper.Response<OrderDetails>> _v4OrderOrderIdSubmitPut({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
    @Body() required SubmittedOrder? body,
  });

  ///
  ///@param orderId Id of the order
  Future<chopper.Response<List<OrderValidation>>> v4OrderOrderIdValidateGet({
    required num? orderId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        OrderValidation, () => OrderValidation.fromJsonFactory);

    return _v4OrderOrderIdValidateGet(
        orderId: orderId, cacheControl: cacheControl);
  }

  ///
  ///@param orderId Id of the order
  @Get(path: '/v4/order/{orderId}/validate')
  Future<chopper.Response<List<OrderValidation>>> _v4OrderOrderIdValidateGet({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param x-application
  Future<chopper.Response> v5OrderPost({
    String? xApplication,
    String? cacheControl,
    required CreateOrderRequest? body,
  }) {
    return _v5OrderPost(
        xApplication: xApplication, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param x-application
  @Post(path: '/v5/order')
  Future<chopper.Response> _v5OrderPost({
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
    @Body() required CreateOrderRequest? body,
  });

  ///
  ///@param Appie-Current-Order-Id
  Future<chopper.Response<UpdateOrderResponse>> v5OrderItemsPut({
    String? appieCurrentOrderId,
    String? cacheControl,
    required UpdateOrderRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        UpdateOrderResponse, () => UpdateOrderResponse.fromJsonFactory);

    return _v5OrderItemsPut(
        appieCurrentOrderId: appieCurrentOrderId,
        cacheControl: cacheControl,
        body: body);
  }

  ///
  ///@param Appie-Current-Order-Id
  @Put(path: '/v5/order/items')
  Future<chopper.Response<UpdateOrderResponse>> _v5OrderItemsPut({
    @Header('Appie-Current-Order-Id') String? appieCurrentOrderId,
    @Header('Cache-Control') String? cacheControl,
    @Body() required UpdateOrderRequest? body,
  });

  ///
  ///@param x-application
  ///@param orderId Id of the order
  Future<chopper.Response> v5OrderOrderIdSlotPut({
    String? xApplication,
    required num? orderId,
    String? cacheControl,
    required UpdateOrderSlotRequest? body,
  }) {
    return _v5OrderOrderIdSlotPut(
        xApplication: xApplication,
        orderId: orderId,
        cacheControl: cacheControl,
        body: body);
  }

  ///
  ///@param x-application
  ///@param orderId Id of the order
  @Put(path: '/v5/order/{orderId}/slot')
  Future<chopper.Response> _v5OrderOrderIdSlotPut({
    @Header('x-application') String? xApplication,
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
    @Body() required UpdateOrderSlotRequest? body,
  });

  ///
  ///@param x-application
  Future<chopper.Response> v6OrderPost({
    String? xApplication,
    String? cacheControl,
    required CreateOrderRequest? body,
  }) {
    return _v6OrderPost(
        xApplication: xApplication, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param x-application
  @Post(path: '/v6/order')
  Future<chopper.Response> _v6OrderPost({
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
    @Body() required CreateOrderRequest? body,
  });

  ///
  ///@param x-application
  Future<chopper.Response<CreateOrderResponseV7>> v7OrderPost({
    String? xApplication,
    String? cacheControl,
    required CreateOrderRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        CreateOrderResponseV7, () => CreateOrderResponseV7.fromJsonFactory);

    return _v7OrderPost(
        xApplication: xApplication, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param x-application
  @Post(path: '/v7/order')
  Future<chopper.Response<CreateOrderResponseV7>> _v7OrderPost({
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
    @Body() required CreateOrderRequest? body,
  });

  ///
  ///@param x-application
  ///@param Appie-Current-Order-Id
  Future<chopper.Response<ActiveOrderAndListSummaryV7>> v7OrderItemsPost({
    String? xApplication,
    String? appieCurrentOrderId,
    String? cacheControl,
    required PostItemRequestV7? body,
  }) {
    generatedMapping.putIfAbsent(ActiveOrderAndListSummaryV7,
        () => ActiveOrderAndListSummaryV7.fromJsonFactory);

    return _v7OrderItemsPost(
        xApplication: xApplication,
        appieCurrentOrderId: appieCurrentOrderId,
        cacheControl: cacheControl,
        body: body);
  }

  ///
  ///@param x-application
  ///@param Appie-Current-Order-Id
  @Post(path: '/v7/order/items')
  Future<chopper.Response<ActiveOrderAndListSummaryV7>> _v7OrderItemsPost({
    @Header('x-application') String? xApplication,
    @Header('Appie-Current-Order-Id') String? appieCurrentOrderId,
    @Header('Cache-Control') String? cacheControl,
    @Body() required PostItemRequestV7? body,
  });

  ///
  ///@param x-application
  Future<chopper.Response<ActiveOrderAndListSummaryV7>>
      v7OrderSummariesActiveGet({
    String? xApplication,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ActiveOrderAndListSummaryV7,
        () => ActiveOrderAndListSummaryV7.fromJsonFactory);

    return _v7OrderSummariesActiveGet(
        xApplication: xApplication, cacheControl: cacheControl);
  }

  ///
  ///@param x-application
  @Get(path: '/v7/order/summaries/active')
  Future<chopper.Response<ActiveOrderAndListSummaryV7>>
      _v7OrderSummariesActiveGet({
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param orderId
  Future<chopper.Response<UpdateSlotResponseV7>> v7OrderOrderIdSlotPut({
    required num? orderId,
    String? cacheControl,
    required UpdateOrderSlotRequest? body,
  }) {
    generatedMapping.putIfAbsent(
        UpdateSlotResponseV7, () => UpdateSlotResponseV7.fromJsonFactory);

    return _v7OrderOrderIdSlotPut(
        orderId: orderId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param orderId
  @Put(path: '/v7/order/{orderId}/slot')
  Future<chopper.Response<UpdateSlotResponseV7>> _v7OrderOrderIdSlotPut({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
    @Body() required UpdateOrderSlotRequest? body,
  });

  ///
  ///@param x-application
  ///@param orderId Id of the order
  Future<chopper.Response<OrderDetailsV7>> v7OrderOrderIdStatePut({
    String? xApplication,
    required num? orderId,
    String? cacheControl,
    required String? body,
  }) {
    generatedMapping.putIfAbsent(
        OrderDetailsV7, () => OrderDetailsV7.fromJsonFactory);

    return _v7OrderOrderIdStatePut(
        xApplication: xApplication,
        orderId: orderId,
        cacheControl: cacheControl,
        body: body);
  }

  ///
  ///@param x-application
  ///@param orderId Id of the order
  @Put(path: '/v7/order/{orderId}/state')
  Future<chopper.Response<OrderDetailsV7>> _v7OrderOrderIdStatePut({
    @Header('x-application') String? xApplication,
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
    @Body() required String? body,
  });

  ///
  ///@param orderId Id of the order
  Future<chopper.Response<OrderDetailsV7>> v7OrderOrderIdSubmitPut({
    required num? orderId,
    String? cacheControl,
    required SubmittedOrderV7? body,
  }) {
    generatedMapping.putIfAbsent(
        OrderDetailsV7, () => OrderDetailsV7.fromJsonFactory);

    return _v7OrderOrderIdSubmitPut(
        orderId: orderId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param orderId Id of the order
  @Put(path: '/v7/order/{orderId}/submit')
  Future<chopper.Response<OrderDetailsV7>> _v7OrderOrderIdSubmitPut({
    @Path('orderId') required num? orderId,
    @Header('Cache-Control') String? cacheControl,
    @Body() required SubmittedOrderV7? body,
  });
}

@JsonSerializable(explicitToJson: true)
class ActionCode {
  ActionCode({
    required this.actionCode,
  });

  factory ActionCode.fromJson(Map<String, dynamic> json) =>
      _$ActionCodeFromJson(json);

  @JsonKey(name: 'actionCode', includeIfNull: false, defaultValue: '')
  final String actionCode;
  static const fromJsonFactory = _$ActionCodeFromJson;
  static const toJsonFactory = _$ActionCodeToJson;
  Map<String, dynamic> toJson() => _$ActionCodeToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ActionCode &&
            (identical(other.actionCode, actionCode) ||
                const DeepCollectionEquality()
                    .equals(other.actionCode, actionCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(actionCode) ^ runtimeType.hashCode;
}

extension $ActionCodeExtension on ActionCode {
  ActionCode copyWith({String? actionCode}) {
    return ActionCode(actionCode: actionCode ?? this.actionCode);
  }

  ActionCode copyWithWrapped({Wrapped<String>? actionCode}) {
    return ActionCode(
        actionCode: (actionCode != null ? actionCode.value : this.actionCode));
  }
}

@JsonSerializable(explicitToJson: true)
class ActiveOrderAndListSummary {
  ActiveOrderAndListSummary({
    required this.closingTime,
    this.deliveryDate,
    required this.id,
    this.lastSyncedDate,
    this.orderLastChangedTime,
    this.orderedProducts,
    this.price,
    this.shoppingListItems,
    required this.shoppingType,
    required this.slotReservationHours,
    required this.state,
  });

  factory ActiveOrderAndListSummary.fromJson(Map<String, dynamic> json) =>
      _$ActiveOrderAndListSummaryFromJson(json);

  @JsonKey(name: 'closingTime', includeIfNull: false)
  final DateTime closingTime;
  @JsonKey(name: 'deliveryDate', includeIfNull: false)
  final DeliveryDto? deliveryDate;
  @JsonKey(name: 'id', includeIfNull: false)
  final num id;
  @JsonKey(name: 'lastSyncedDate', includeIfNull: false)
  final DateTime? lastSyncedDate;
  @JsonKey(name: 'orderLastChangedTime', includeIfNull: false)
  final DateTime? orderLastChangedTime;
  @JsonKey(
      name: 'orderedProducts',
      includeIfNull: false,
      defaultValue: <OrderedProductCardV7>[])
  final List<OrderedProductCardV7>? orderedProducts;
  @JsonKey(name: 'price', includeIfNull: false)
  final PriceDto? price;
  @JsonKey(
      name: 'shoppingListItems', includeIfNull: false, defaultValue: <Item>[])
  final List<Item>? shoppingListItems;
  @JsonKey(
    name: 'shoppingType',
    includeIfNull: false,
    toJson: activeOrderAndListSummaryShoppingTypeToJson,
    fromJson: activeOrderAndListSummaryShoppingTypeFromJson,
  )
  final enums.ActiveOrderAndListSummaryShoppingType shoppingType;
  @JsonKey(name: 'slotReservationHours', includeIfNull: false)
  final double slotReservationHours;
  @JsonKey(
    name: 'state',
    includeIfNull: false,
    toJson: activeOrderAndListSummaryStateToJson,
    fromJson: activeOrderAndListSummaryStateFromJson,
  )
  final enums.ActiveOrderAndListSummaryState state;
  static const fromJsonFactory = _$ActiveOrderAndListSummaryFromJson;
  static const toJsonFactory = _$ActiveOrderAndListSummaryToJson;
  Map<String, dynamic> toJson() => _$ActiveOrderAndListSummaryToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ActiveOrderAndListSummary &&
            (identical(other.closingTime, closingTime) ||
                const DeepCollectionEquality()
                    .equals(other.closingTime, closingTime)) &&
            (identical(other.deliveryDate, deliveryDate) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryDate, deliveryDate)) &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.lastSyncedDate, lastSyncedDate) ||
                const DeepCollectionEquality()
                    .equals(other.lastSyncedDate, lastSyncedDate)) &&
            (identical(other.orderLastChangedTime, orderLastChangedTime) ||
                const DeepCollectionEquality().equals(
                    other.orderLastChangedTime, orderLastChangedTime)) &&
            (identical(other.orderedProducts, orderedProducts) ||
                const DeepCollectionEquality()
                    .equals(other.orderedProducts, orderedProducts)) &&
            (identical(other.price, price) ||
                const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.shoppingListItems, shoppingListItems) ||
                const DeepCollectionEquality()
                    .equals(other.shoppingListItems, shoppingListItems)) &&
            (identical(other.shoppingType, shoppingType) ||
                const DeepCollectionEquality()
                    .equals(other.shoppingType, shoppingType)) &&
            (identical(other.slotReservationHours, slotReservationHours) ||
                const DeepCollectionEquality().equals(
                    other.slotReservationHours, slotReservationHours)) &&
            (identical(other.state, state) ||
                const DeepCollectionEquality().equals(other.state, state)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(closingTime) ^
      const DeepCollectionEquality().hash(deliveryDate) ^
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(lastSyncedDate) ^
      const DeepCollectionEquality().hash(orderLastChangedTime) ^
      const DeepCollectionEquality().hash(orderedProducts) ^
      const DeepCollectionEquality().hash(price) ^
      const DeepCollectionEquality().hash(shoppingListItems) ^
      const DeepCollectionEquality().hash(shoppingType) ^
      const DeepCollectionEquality().hash(slotReservationHours) ^
      const DeepCollectionEquality().hash(state) ^
      runtimeType.hashCode;
}

extension $ActiveOrderAndListSummaryExtension on ActiveOrderAndListSummary {
  ActiveOrderAndListSummary copyWith(
      {DateTime? closingTime,
      DeliveryDto? deliveryDate,
      num? id,
      DateTime? lastSyncedDate,
      DateTime? orderLastChangedTime,
      List<OrderedProductCardV7>? orderedProducts,
      PriceDto? price,
      List<Item>? shoppingListItems,
      enums.ActiveOrderAndListSummaryShoppingType? shoppingType,
      double? slotReservationHours,
      enums.ActiveOrderAndListSummaryState? state}) {
    return ActiveOrderAndListSummary(
        closingTime: closingTime ?? this.closingTime,
        deliveryDate: deliveryDate ?? this.deliveryDate,
        id: id ?? this.id,
        lastSyncedDate: lastSyncedDate ?? this.lastSyncedDate,
        orderLastChangedTime: orderLastChangedTime ?? this.orderLastChangedTime,
        orderedProducts: orderedProducts ?? this.orderedProducts,
        price: price ?? this.price,
        shoppingListItems: shoppingListItems ?? this.shoppingListItems,
        shoppingType: shoppingType ?? this.shoppingType,
        slotReservationHours: slotReservationHours ?? this.slotReservationHours,
        state: state ?? this.state);
  }

  ActiveOrderAndListSummary copyWithWrapped(
      {Wrapped<DateTime>? closingTime,
      Wrapped<DeliveryDto?>? deliveryDate,
      Wrapped<num>? id,
      Wrapped<DateTime?>? lastSyncedDate,
      Wrapped<DateTime?>? orderLastChangedTime,
      Wrapped<List<OrderedProductCardV7>?>? orderedProducts,
      Wrapped<PriceDto?>? price,
      Wrapped<List<Item>?>? shoppingListItems,
      Wrapped<enums.ActiveOrderAndListSummaryShoppingType>? shoppingType,
      Wrapped<double>? slotReservationHours,
      Wrapped<enums.ActiveOrderAndListSummaryState>? state}) {
    return ActiveOrderAndListSummary(
        closingTime:
            (closingTime != null ? closingTime.value : this.closingTime),
        deliveryDate:
            (deliveryDate != null ? deliveryDate.value : this.deliveryDate),
        id: (id != null ? id.value : this.id),
        lastSyncedDate: (lastSyncedDate != null
            ? lastSyncedDate.value
            : this.lastSyncedDate),
        orderLastChangedTime: (orderLastChangedTime != null
            ? orderLastChangedTime.value
            : this.orderLastChangedTime),
        orderedProducts: (orderedProducts != null
            ? orderedProducts.value
            : this.orderedProducts),
        price: (price != null ? price.value : this.price),
        shoppingListItems: (shoppingListItems != null
            ? shoppingListItems.value
            : this.shoppingListItems),
        shoppingType:
            (shoppingType != null ? shoppingType.value : this.shoppingType),
        slotReservationHours: (slotReservationHours != null
            ? slotReservationHours.value
            : this.slotReservationHours),
        state: (state != null ? state.value : this.state));
  }
}

@JsonSerializable(explicitToJson: true)
class ActiveOrderAndListSummaryV7 {
  ActiveOrderAndListSummaryV7({
    required this.closingTime,
    this.deliveryDate,
    required this.id,
    this.orderedProducts,
    this.price,
    this.shoppingListItems,
    required this.shoppingType,
    required this.slotReservationHours,
    required this.state,
    required this.syncTimes,
  });

  factory ActiveOrderAndListSummaryV7.fromJson(Map<String, dynamic> json) =>
      _$ActiveOrderAndListSummaryV7FromJson(json);

  @JsonKey(name: 'closingTime', includeIfNull: false)
  final DateTime closingTime;
  @JsonKey(name: 'deliveryDate', includeIfNull: false)
  final DeliveryDto? deliveryDate;
  @JsonKey(name: 'id', includeIfNull: false)
  final num id;
  @JsonKey(
      name: 'orderedProducts',
      includeIfNull: false,
      defaultValue: <OrderedProductCardV7>[])
  final List<OrderedProductCardV7>? orderedProducts;
  @JsonKey(name: 'price', includeIfNull: false)
  final PriceDto? price;
  @JsonKey(
      name: 'shoppingListItems', includeIfNull: false, defaultValue: <Item>[])
  final List<Item>? shoppingListItems;
  @JsonKey(
    name: 'shoppingType',
    includeIfNull: false,
    toJson: activeOrderAndListSummaryV7ShoppingTypeToJson,
    fromJson: activeOrderAndListSummaryV7ShoppingTypeFromJson,
  )
  final enums.ActiveOrderAndListSummaryV7ShoppingType shoppingType;
  @JsonKey(name: 'slotReservationHours', includeIfNull: false)
  final double slotReservationHours;
  @JsonKey(
    name: 'state',
    includeIfNull: false,
    toJson: activeOrderAndListSummaryV7StateToJson,
    fromJson: activeOrderAndListSummaryV7StateFromJson,
  )
  final enums.ActiveOrderAndListSummaryV7State state;
  @JsonKey(name: 'syncTimes', includeIfNull: false)
  final SyncTimesV7 syncTimes;
  static const fromJsonFactory = _$ActiveOrderAndListSummaryV7FromJson;
  static const toJsonFactory = _$ActiveOrderAndListSummaryV7ToJson;
  Map<String, dynamic> toJson() => _$ActiveOrderAndListSummaryV7ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ActiveOrderAndListSummaryV7 &&
            (identical(other.closingTime, closingTime) ||
                const DeepCollectionEquality()
                    .equals(other.closingTime, closingTime)) &&
            (identical(other.deliveryDate, deliveryDate) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryDate, deliveryDate)) &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.orderedProducts, orderedProducts) ||
                const DeepCollectionEquality()
                    .equals(other.orderedProducts, orderedProducts)) &&
            (identical(other.price, price) ||
                const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.shoppingListItems, shoppingListItems) ||
                const DeepCollectionEquality()
                    .equals(other.shoppingListItems, shoppingListItems)) &&
            (identical(other.shoppingType, shoppingType) ||
                const DeepCollectionEquality()
                    .equals(other.shoppingType, shoppingType)) &&
            (identical(other.slotReservationHours, slotReservationHours) ||
                const DeepCollectionEquality().equals(
                    other.slotReservationHours, slotReservationHours)) &&
            (identical(other.state, state) ||
                const DeepCollectionEquality().equals(other.state, state)) &&
            (identical(other.syncTimes, syncTimes) ||
                const DeepCollectionEquality()
                    .equals(other.syncTimes, syncTimes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(closingTime) ^
      const DeepCollectionEquality().hash(deliveryDate) ^
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(orderedProducts) ^
      const DeepCollectionEquality().hash(price) ^
      const DeepCollectionEquality().hash(shoppingListItems) ^
      const DeepCollectionEquality().hash(shoppingType) ^
      const DeepCollectionEquality().hash(slotReservationHours) ^
      const DeepCollectionEquality().hash(state) ^
      const DeepCollectionEquality().hash(syncTimes) ^
      runtimeType.hashCode;
}

extension $ActiveOrderAndListSummaryV7Extension on ActiveOrderAndListSummaryV7 {
  ActiveOrderAndListSummaryV7 copyWith(
      {DateTime? closingTime,
      DeliveryDto? deliveryDate,
      num? id,
      List<OrderedProductCardV7>? orderedProducts,
      PriceDto? price,
      List<Item>? shoppingListItems,
      enums.ActiveOrderAndListSummaryV7ShoppingType? shoppingType,
      double? slotReservationHours,
      enums.ActiveOrderAndListSummaryV7State? state,
      SyncTimesV7? syncTimes}) {
    return ActiveOrderAndListSummaryV7(
        closingTime: closingTime ?? this.closingTime,
        deliveryDate: deliveryDate ?? this.deliveryDate,
        id: id ?? this.id,
        orderedProducts: orderedProducts ?? this.orderedProducts,
        price: price ?? this.price,
        shoppingListItems: shoppingListItems ?? this.shoppingListItems,
        shoppingType: shoppingType ?? this.shoppingType,
        slotReservationHours: slotReservationHours ?? this.slotReservationHours,
        state: state ?? this.state,
        syncTimes: syncTimes ?? this.syncTimes);
  }

  ActiveOrderAndListSummaryV7 copyWithWrapped(
      {Wrapped<DateTime>? closingTime,
      Wrapped<DeliveryDto?>? deliveryDate,
      Wrapped<num>? id,
      Wrapped<List<OrderedProductCardV7>?>? orderedProducts,
      Wrapped<PriceDto?>? price,
      Wrapped<List<Item>?>? shoppingListItems,
      Wrapped<enums.ActiveOrderAndListSummaryV7ShoppingType>? shoppingType,
      Wrapped<double>? slotReservationHours,
      Wrapped<enums.ActiveOrderAndListSummaryV7State>? state,
      Wrapped<SyncTimesV7>? syncTimes}) {
    return ActiveOrderAndListSummaryV7(
        closingTime:
            (closingTime != null ? closingTime.value : this.closingTime),
        deliveryDate:
            (deliveryDate != null ? deliveryDate.value : this.deliveryDate),
        id: (id != null ? id.value : this.id),
        orderedProducts: (orderedProducts != null
            ? orderedProducts.value
            : this.orderedProducts),
        price: (price != null ? price.value : this.price),
        shoppingListItems: (shoppingListItems != null
            ? shoppingListItems.value
            : this.shoppingListItems),
        shoppingType:
            (shoppingType != null ? shoppingType.value : this.shoppingType),
        slotReservationHours: (slotReservationHours != null
            ? slotReservationHours.value
            : this.slotReservationHours),
        state: (state != null ? state.value : this.state),
        syncTimes: (syncTimes != null ? syncTimes.value : this.syncTimes));
  }
}

@JsonSerializable(explicitToJson: true)
class Address {
  Address({
    this.city,
    this.countryCode,
    this.houseNumber,
    this.houseNumberExtra,
    this.street,
    required this.type,
    this.zipCode,
    this.zipCodeExtra,
  });

  factory Address.fromJson(Map<String, dynamic> json) =>
      _$AddressFromJson(json);

  @JsonKey(name: 'city', includeIfNull: false, defaultValue: '')
  final String? city;
  @JsonKey(name: 'countryCode', includeIfNull: false, defaultValue: '')
  final String? countryCode;
  @JsonKey(name: 'houseNumber', includeIfNull: false)
  final int? houseNumber;
  @JsonKey(name: 'houseNumberExtra', includeIfNull: false, defaultValue: '')
  final String? houseNumberExtra;
  @JsonKey(name: 'street', includeIfNull: false, defaultValue: '')
  final String? street;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String type;
  @JsonKey(name: 'zipCode', includeIfNull: false)
  final int? zipCode;
  @JsonKey(name: 'zipCodeExtra', includeIfNull: false, defaultValue: '')
  final String? zipCodeExtra;
  static const fromJsonFactory = _$AddressFromJson;
  static const toJsonFactory = _$AddressToJson;
  Map<String, dynamic> toJson() => _$AddressToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Address &&
            (identical(other.city, city) ||
                const DeepCollectionEquality().equals(other.city, city)) &&
            (identical(other.countryCode, countryCode) ||
                const DeepCollectionEquality()
                    .equals(other.countryCode, countryCode)) &&
            (identical(other.houseNumber, houseNumber) ||
                const DeepCollectionEquality()
                    .equals(other.houseNumber, houseNumber)) &&
            (identical(other.houseNumberExtra, houseNumberExtra) ||
                const DeepCollectionEquality()
                    .equals(other.houseNumberExtra, houseNumberExtra)) &&
            (identical(other.street, street) ||
                const DeepCollectionEquality().equals(other.street, street)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.zipCode, zipCode) ||
                const DeepCollectionEquality()
                    .equals(other.zipCode, zipCode)) &&
            (identical(other.zipCodeExtra, zipCodeExtra) ||
                const DeepCollectionEquality()
                    .equals(other.zipCodeExtra, zipCodeExtra)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(city) ^
      const DeepCollectionEquality().hash(countryCode) ^
      const DeepCollectionEquality().hash(houseNumber) ^
      const DeepCollectionEquality().hash(houseNumberExtra) ^
      const DeepCollectionEquality().hash(street) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(zipCode) ^
      const DeepCollectionEquality().hash(zipCodeExtra) ^
      runtimeType.hashCode;
}

extension $AddressExtension on Address {
  Address copyWith(
      {String? city,
      String? countryCode,
      int? houseNumber,
      String? houseNumberExtra,
      String? street,
      String? type,
      int? zipCode,
      String? zipCodeExtra}) {
    return Address(
        city: city ?? this.city,
        countryCode: countryCode ?? this.countryCode,
        houseNumber: houseNumber ?? this.houseNumber,
        houseNumberExtra: houseNumberExtra ?? this.houseNumberExtra,
        street: street ?? this.street,
        type: type ?? this.type,
        zipCode: zipCode ?? this.zipCode,
        zipCodeExtra: zipCodeExtra ?? this.zipCodeExtra);
  }

  Address copyWithWrapped(
      {Wrapped<String?>? city,
      Wrapped<String?>? countryCode,
      Wrapped<int?>? houseNumber,
      Wrapped<String?>? houseNumberExtra,
      Wrapped<String?>? street,
      Wrapped<String>? type,
      Wrapped<int?>? zipCode,
      Wrapped<String?>? zipCodeExtra}) {
    return Address(
        city: (city != null ? city.value : this.city),
        countryCode:
            (countryCode != null ? countryCode.value : this.countryCode),
        houseNumber:
            (houseNumber != null ? houseNumber.value : this.houseNumber),
        houseNumberExtra: (houseNumberExtra != null
            ? houseNumberExtra.value
            : this.houseNumberExtra),
        street: (street != null ? street.value : this.street),
        type: (type != null ? type.value : this.type),
        zipCode: (zipCode != null ? zipCode.value : this.zipCode),
        zipCodeExtra:
            (zipCodeExtra != null ? zipCodeExtra.value : this.zipCodeExtra));
  }
}

@JsonSerializable(explicitToJson: true)
class AddressDto {
  AddressDto({
    this.city,
    this.countryCode,
    this.houseNumber,
    this.houseNumberExtra,
    this.street,
    required this.type,
    this.zipCode,
    this.zipCodeExtra,
  });

  factory AddressDto.fromJson(Map<String, dynamic> json) =>
      _$AddressDtoFromJson(json);

  @JsonKey(name: 'city', includeIfNull: false, defaultValue: '')
  final String? city;
  @JsonKey(name: 'countryCode', includeIfNull: false, defaultValue: '')
  final String? countryCode;
  @JsonKey(name: 'houseNumber', includeIfNull: false)
  final int? houseNumber;
  @JsonKey(name: 'houseNumberExtra', includeIfNull: false, defaultValue: '')
  final String? houseNumberExtra;
  @JsonKey(name: 'street', includeIfNull: false, defaultValue: '')
  final String? street;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String type;
  @JsonKey(name: 'zipCode', includeIfNull: false)
  final int? zipCode;
  @JsonKey(name: 'zipCodeExtra', includeIfNull: false, defaultValue: '')
  final String? zipCodeExtra;
  static const fromJsonFactory = _$AddressDtoFromJson;
  static const toJsonFactory = _$AddressDtoToJson;
  Map<String, dynamic> toJson() => _$AddressDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AddressDto &&
            (identical(other.city, city) ||
                const DeepCollectionEquality().equals(other.city, city)) &&
            (identical(other.countryCode, countryCode) ||
                const DeepCollectionEquality()
                    .equals(other.countryCode, countryCode)) &&
            (identical(other.houseNumber, houseNumber) ||
                const DeepCollectionEquality()
                    .equals(other.houseNumber, houseNumber)) &&
            (identical(other.houseNumberExtra, houseNumberExtra) ||
                const DeepCollectionEquality()
                    .equals(other.houseNumberExtra, houseNumberExtra)) &&
            (identical(other.street, street) ||
                const DeepCollectionEquality().equals(other.street, street)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.zipCode, zipCode) ||
                const DeepCollectionEquality()
                    .equals(other.zipCode, zipCode)) &&
            (identical(other.zipCodeExtra, zipCodeExtra) ||
                const DeepCollectionEquality()
                    .equals(other.zipCodeExtra, zipCodeExtra)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(city) ^
      const DeepCollectionEquality().hash(countryCode) ^
      const DeepCollectionEquality().hash(houseNumber) ^
      const DeepCollectionEquality().hash(houseNumberExtra) ^
      const DeepCollectionEquality().hash(street) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(zipCode) ^
      const DeepCollectionEquality().hash(zipCodeExtra) ^
      runtimeType.hashCode;
}

extension $AddressDtoExtension on AddressDto {
  AddressDto copyWith(
      {String? city,
      String? countryCode,
      int? houseNumber,
      String? houseNumberExtra,
      String? street,
      String? type,
      int? zipCode,
      String? zipCodeExtra}) {
    return AddressDto(
        city: city ?? this.city,
        countryCode: countryCode ?? this.countryCode,
        houseNumber: houseNumber ?? this.houseNumber,
        houseNumberExtra: houseNumberExtra ?? this.houseNumberExtra,
        street: street ?? this.street,
        type: type ?? this.type,
        zipCode: zipCode ?? this.zipCode,
        zipCodeExtra: zipCodeExtra ?? this.zipCodeExtra);
  }

  AddressDto copyWithWrapped(
      {Wrapped<String?>? city,
      Wrapped<String?>? countryCode,
      Wrapped<int?>? houseNumber,
      Wrapped<String?>? houseNumberExtra,
      Wrapped<String?>? street,
      Wrapped<String>? type,
      Wrapped<int?>? zipCode,
      Wrapped<String?>? zipCodeExtra}) {
    return AddressDto(
        city: (city != null ? city.value : this.city),
        countryCode:
            (countryCode != null ? countryCode.value : this.countryCode),
        houseNumber:
            (houseNumber != null ? houseNumber.value : this.houseNumber),
        houseNumberExtra: (houseNumberExtra != null
            ? houseNumberExtra.value
            : this.houseNumberExtra),
        street: (street != null ? street.value : this.street),
        type: (type != null ? type.value : this.type),
        zipCode: (zipCode != null ? zipCode.value : this.zipCode),
        zipCodeExtra:
            (zipCodeExtra != null ? zipCodeExtra.value : this.zipCodeExtra));
  }
}

@JsonSerializable(explicitToJson: true)
class Amount {
  Amount({
    required this.amount,
    required this.currency,
  });

  factory Amount.fromJson(Map<String, dynamic> json) => _$AmountFromJson(json);

  @JsonKey(name: 'amount', includeIfNull: false)
  final double amount;
  @JsonKey(name: 'currency', includeIfNull: false, defaultValue: '')
  final String currency;
  static const fromJsonFactory = _$AmountFromJson;
  static const toJsonFactory = _$AmountToJson;
  Map<String, dynamic> toJson() => _$AmountToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Amount &&
            (identical(other.amount, amount) ||
                const DeepCollectionEquality().equals(other.amount, amount)) &&
            (identical(other.currency, currency) ||
                const DeepCollectionEquality()
                    .equals(other.currency, currency)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(amount) ^
      const DeepCollectionEquality().hash(currency) ^
      runtimeType.hashCode;
}

extension $AmountExtension on Amount {
  Amount copyWith({double? amount, String? currency}) {
    return Amount(
        amount: amount ?? this.amount, currency: currency ?? this.currency);
  }

  Amount copyWithWrapped({Wrapped<double>? amount, Wrapped<String>? currency}) {
    return Amount(
        amount: (amount != null ? amount.value : this.amount),
        currency: (currency != null ? currency.value : this.currency));
  }
}

@JsonSerializable(explicitToJson: true)
class CheckOut {
  CheckOut({
    required this.kassaKoopjes,
    required this.missingBonus,
    required this.nonDeliverables,
    required this.samples,
  });

  factory CheckOut.fromJson(Map<String, dynamic> json) =>
      _$CheckOutFromJson(json);

  @JsonKey(
      name: 'kassaKoopjes', includeIfNull: false, defaultValue: <KassaKoopje>[])
  final List<KassaKoopje> kassaKoopjes;
  @JsonKey(
      name: 'missingBonus',
      includeIfNull: false,
      defaultValue: <MissingBonus>[])
  final List<MissingBonus> missingBonus;
  @JsonKey(
      name: 'nonDeliverables',
      includeIfNull: false,
      defaultValue: <NonDeliverable>[])
  final List<NonDeliverable> nonDeliverables;
  @JsonKey(name: 'samples', includeIfNull: false, defaultValue: <Sample>[])
  final List<Sample> samples;
  static const fromJsonFactory = _$CheckOutFromJson;
  static const toJsonFactory = _$CheckOutToJson;
  Map<String, dynamic> toJson() => _$CheckOutToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CheckOut &&
            (identical(other.kassaKoopjes, kassaKoopjes) ||
                const DeepCollectionEquality()
                    .equals(other.kassaKoopjes, kassaKoopjes)) &&
            (identical(other.missingBonus, missingBonus) ||
                const DeepCollectionEquality()
                    .equals(other.missingBonus, missingBonus)) &&
            (identical(other.nonDeliverables, nonDeliverables) ||
                const DeepCollectionEquality()
                    .equals(other.nonDeliverables, nonDeliverables)) &&
            (identical(other.samples, samples) ||
                const DeepCollectionEquality().equals(other.samples, samples)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(kassaKoopjes) ^
      const DeepCollectionEquality().hash(missingBonus) ^
      const DeepCollectionEquality().hash(nonDeliverables) ^
      const DeepCollectionEquality().hash(samples) ^
      runtimeType.hashCode;
}

extension $CheckOutExtension on CheckOut {
  CheckOut copyWith(
      {List<KassaKoopje>? kassaKoopjes,
      List<MissingBonus>? missingBonus,
      List<NonDeliverable>? nonDeliverables,
      List<Sample>? samples}) {
    return CheckOut(
        kassaKoopjes: kassaKoopjes ?? this.kassaKoopjes,
        missingBonus: missingBonus ?? this.missingBonus,
        nonDeliverables: nonDeliverables ?? this.nonDeliverables,
        samples: samples ?? this.samples);
  }

  CheckOut copyWithWrapped(
      {Wrapped<List<KassaKoopje>>? kassaKoopjes,
      Wrapped<List<MissingBonus>>? missingBonus,
      Wrapped<List<NonDeliverable>>? nonDeliverables,
      Wrapped<List<Sample>>? samples}) {
    return CheckOut(
        kassaKoopjes:
            (kassaKoopjes != null ? kassaKoopjes.value : this.kassaKoopjes),
        missingBonus:
            (missingBonus != null ? missingBonus.value : this.missingBonus),
        nonDeliverables: (nonDeliverables != null
            ? nonDeliverables.value
            : this.nonDeliverables),
        samples: (samples != null ? samples.value : this.samples));
  }
}

@JsonSerializable(explicitToJson: true)
class CreateOrderRequest {
  CreateOrderRequest({
    this.address,
    required this.deliveryDate,
    required this.deliveryLocationId,
    required this.deliveryShiftCode,
    required this.orderMethod,
    this.pickupLocationNumber,
  });

  factory CreateOrderRequest.fromJson(Map<String, dynamic> json) =>
      _$CreateOrderRequestFromJson(json);

  @JsonKey(name: 'address', includeIfNull: false)
  final Address? address;
  @JsonKey(name: 'deliveryDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime deliveryDate;
  @JsonKey(name: 'deliveryLocationId', includeIfNull: false)
  final num deliveryLocationId;
  @JsonKey(name: 'deliveryShiftCode', includeIfNull: false, defaultValue: '')
  final String deliveryShiftCode;
  @JsonKey(
    name: 'orderMethod',
    includeIfNull: false,
    toJson: createOrderRequestOrderMethodToJson,
    fromJson: createOrderRequestOrderMethodFromJson,
  )
  final enums.CreateOrderRequestOrderMethod orderMethod;
  @JsonKey(name: 'pickupLocationNumber', includeIfNull: false)
  final num? pickupLocationNumber;
  static const fromJsonFactory = _$CreateOrderRequestFromJson;
  static const toJsonFactory = _$CreateOrderRequestToJson;
  Map<String, dynamic> toJson() => _$CreateOrderRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CreateOrderRequest &&
            (identical(other.address, address) ||
                const DeepCollectionEquality()
                    .equals(other.address, address)) &&
            (identical(other.deliveryDate, deliveryDate) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryDate, deliveryDate)) &&
            (identical(other.deliveryLocationId, deliveryLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryLocationId, deliveryLocationId)) &&
            (identical(other.deliveryShiftCode, deliveryShiftCode) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryShiftCode, deliveryShiftCode)) &&
            (identical(other.orderMethod, orderMethod) ||
                const DeepCollectionEquality()
                    .equals(other.orderMethod, orderMethod)) &&
            (identical(other.pickupLocationNumber, pickupLocationNumber) ||
                const DeepCollectionEquality()
                    .equals(other.pickupLocationNumber, pickupLocationNumber)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(address) ^
      const DeepCollectionEquality().hash(deliveryDate) ^
      const DeepCollectionEquality().hash(deliveryLocationId) ^
      const DeepCollectionEquality().hash(deliveryShiftCode) ^
      const DeepCollectionEquality().hash(orderMethod) ^
      const DeepCollectionEquality().hash(pickupLocationNumber) ^
      runtimeType.hashCode;
}

extension $CreateOrderRequestExtension on CreateOrderRequest {
  CreateOrderRequest copyWith(
      {Address? address,
      DateTime? deliveryDate,
      num? deliveryLocationId,
      String? deliveryShiftCode,
      enums.CreateOrderRequestOrderMethod? orderMethod,
      num? pickupLocationNumber}) {
    return CreateOrderRequest(
        address: address ?? this.address,
        deliveryDate: deliveryDate ?? this.deliveryDate,
        deliveryLocationId: deliveryLocationId ?? this.deliveryLocationId,
        deliveryShiftCode: deliveryShiftCode ?? this.deliveryShiftCode,
        orderMethod: orderMethod ?? this.orderMethod,
        pickupLocationNumber:
            pickupLocationNumber ?? this.pickupLocationNumber);
  }

  CreateOrderRequest copyWithWrapped(
      {Wrapped<Address?>? address,
      Wrapped<DateTime>? deliveryDate,
      Wrapped<num>? deliveryLocationId,
      Wrapped<String>? deliveryShiftCode,
      Wrapped<enums.CreateOrderRequestOrderMethod>? orderMethod,
      Wrapped<num?>? pickupLocationNumber}) {
    return CreateOrderRequest(
        address: (address != null ? address.value : this.address),
        deliveryDate:
            (deliveryDate != null ? deliveryDate.value : this.deliveryDate),
        deliveryLocationId: (deliveryLocationId != null
            ? deliveryLocationId.value
            : this.deliveryLocationId),
        deliveryShiftCode: (deliveryShiftCode != null
            ? deliveryShiftCode.value
            : this.deliveryShiftCode),
        orderMethod:
            (orderMethod != null ? orderMethod.value : this.orderMethod),
        pickupLocationNumber: (pickupLocationNumber != null
            ? pickupLocationNumber.value
            : this.pickupLocationNumber));
  }
}

@JsonSerializable(explicitToJson: true)
class CreateOrderResponse {
  CreateOrderResponse({
    required this.id,
    required this.lastChangedTime,
    required this.lastUserChangeTime,
    required this.shoppingType,
    required this.state,
  });

  factory CreateOrderResponse.fromJson(Map<String, dynamic> json) =>
      _$CreateOrderResponseFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false)
  final num id;
  @JsonKey(name: 'lastChangedTime', includeIfNull: false)
  final DateTime lastChangedTime;
  @JsonKey(name: 'lastUserChangeTime', includeIfNull: false)
  final DateTime lastUserChangeTime;
  @JsonKey(
    name: 'shoppingType',
    includeIfNull: false,
    toJson: createOrderResponseShoppingTypeToJson,
    fromJson: createOrderResponseShoppingTypeFromJson,
  )
  final enums.CreateOrderResponseShoppingType shoppingType;
  @JsonKey(
    name: 'state',
    includeIfNull: false,
    toJson: createOrderResponseStateToJson,
    fromJson: createOrderResponseStateFromJson,
  )
  final enums.CreateOrderResponseState state;
  static const fromJsonFactory = _$CreateOrderResponseFromJson;
  static const toJsonFactory = _$CreateOrderResponseToJson;
  Map<String, dynamic> toJson() => _$CreateOrderResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CreateOrderResponse &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.lastChangedTime, lastChangedTime) ||
                const DeepCollectionEquality()
                    .equals(other.lastChangedTime, lastChangedTime)) &&
            (identical(other.lastUserChangeTime, lastUserChangeTime) ||
                const DeepCollectionEquality()
                    .equals(other.lastUserChangeTime, lastUserChangeTime)) &&
            (identical(other.shoppingType, shoppingType) ||
                const DeepCollectionEquality()
                    .equals(other.shoppingType, shoppingType)) &&
            (identical(other.state, state) ||
                const DeepCollectionEquality().equals(other.state, state)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(lastChangedTime) ^
      const DeepCollectionEquality().hash(lastUserChangeTime) ^
      const DeepCollectionEquality().hash(shoppingType) ^
      const DeepCollectionEquality().hash(state) ^
      runtimeType.hashCode;
}

extension $CreateOrderResponseExtension on CreateOrderResponse {
  CreateOrderResponse copyWith(
      {num? id,
      DateTime? lastChangedTime,
      DateTime? lastUserChangeTime,
      enums.CreateOrderResponseShoppingType? shoppingType,
      enums.CreateOrderResponseState? state}) {
    return CreateOrderResponse(
        id: id ?? this.id,
        lastChangedTime: lastChangedTime ?? this.lastChangedTime,
        lastUserChangeTime: lastUserChangeTime ?? this.lastUserChangeTime,
        shoppingType: shoppingType ?? this.shoppingType,
        state: state ?? this.state);
  }

  CreateOrderResponse copyWithWrapped(
      {Wrapped<num>? id,
      Wrapped<DateTime>? lastChangedTime,
      Wrapped<DateTime>? lastUserChangeTime,
      Wrapped<enums.CreateOrderResponseShoppingType>? shoppingType,
      Wrapped<enums.CreateOrderResponseState>? state}) {
    return CreateOrderResponse(
        id: (id != null ? id.value : this.id),
        lastChangedTime: (lastChangedTime != null
            ? lastChangedTime.value
            : this.lastChangedTime),
        lastUserChangeTime: (lastUserChangeTime != null
            ? lastUserChangeTime.value
            : this.lastUserChangeTime),
        shoppingType:
            (shoppingType != null ? shoppingType.value : this.shoppingType),
        state: (state != null ? state.value : this.state));
  }
}

@JsonSerializable(explicitToJson: true)
class CreateOrderResponseV6 {
  CreateOrderResponseV6({
    this.deliveryInformation,
    this.items,
    this.lastSyncedDate,
    required this.order,
    required this.shoppingType,
    required this.state,
    required this.totalPrice,
  });

  factory CreateOrderResponseV6.fromJson(Map<String, dynamic> json) =>
      _$CreateOrderResponseV6FromJson(json);

  @JsonKey(name: 'deliveryInformation', includeIfNull: false)
  final DeliveryInformation? deliveryInformation;
  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <Item>[])
  final List<Item>? items;
  @JsonKey(name: 'lastSyncedDate', includeIfNull: false)
  final DateTime? lastSyncedDate;
  @JsonKey(name: 'order', includeIfNull: false)
  final Order order;
  @JsonKey(
    name: 'shoppingType',
    includeIfNull: false,
    toJson: createOrderResponseV6ShoppingTypeToJson,
    fromJson: createOrderResponseV6ShoppingTypeFromJson,
  )
  final enums.CreateOrderResponseV6ShoppingType shoppingType;
  @JsonKey(
    name: 'state',
    includeIfNull: false,
    toJson: createOrderResponseV6StateToJson,
    fromJson: createOrderResponseV6StateFromJson,
  )
  final enums.CreateOrderResponseV6State state;
  @JsonKey(name: 'totalPrice', includeIfNull: false)
  final OrderTotalPrice totalPrice;
  static const fromJsonFactory = _$CreateOrderResponseV6FromJson;
  static const toJsonFactory = _$CreateOrderResponseV6ToJson;
  Map<String, dynamic> toJson() => _$CreateOrderResponseV6ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CreateOrderResponseV6 &&
            (identical(other.deliveryInformation, deliveryInformation) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryInformation, deliveryInformation)) &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.lastSyncedDate, lastSyncedDate) ||
                const DeepCollectionEquality()
                    .equals(other.lastSyncedDate, lastSyncedDate)) &&
            (identical(other.order, order) ||
                const DeepCollectionEquality().equals(other.order, order)) &&
            (identical(other.shoppingType, shoppingType) ||
                const DeepCollectionEquality()
                    .equals(other.shoppingType, shoppingType)) &&
            (identical(other.state, state) ||
                const DeepCollectionEquality().equals(other.state, state)) &&
            (identical(other.totalPrice, totalPrice) ||
                const DeepCollectionEquality()
                    .equals(other.totalPrice, totalPrice)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(deliveryInformation) ^
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(lastSyncedDate) ^
      const DeepCollectionEquality().hash(order) ^
      const DeepCollectionEquality().hash(shoppingType) ^
      const DeepCollectionEquality().hash(state) ^
      const DeepCollectionEquality().hash(totalPrice) ^
      runtimeType.hashCode;
}

extension $CreateOrderResponseV6Extension on CreateOrderResponseV6 {
  CreateOrderResponseV6 copyWith(
      {DeliveryInformation? deliveryInformation,
      List<Item>? items,
      DateTime? lastSyncedDate,
      Order? order,
      enums.CreateOrderResponseV6ShoppingType? shoppingType,
      enums.CreateOrderResponseV6State? state,
      OrderTotalPrice? totalPrice}) {
    return CreateOrderResponseV6(
        deliveryInformation: deliveryInformation ?? this.deliveryInformation,
        items: items ?? this.items,
        lastSyncedDate: lastSyncedDate ?? this.lastSyncedDate,
        order: order ?? this.order,
        shoppingType: shoppingType ?? this.shoppingType,
        state: state ?? this.state,
        totalPrice: totalPrice ?? this.totalPrice);
  }

  CreateOrderResponseV6 copyWithWrapped(
      {Wrapped<DeliveryInformation?>? deliveryInformation,
      Wrapped<List<Item>?>? items,
      Wrapped<DateTime?>? lastSyncedDate,
      Wrapped<Order>? order,
      Wrapped<enums.CreateOrderResponseV6ShoppingType>? shoppingType,
      Wrapped<enums.CreateOrderResponseV6State>? state,
      Wrapped<OrderTotalPrice>? totalPrice}) {
    return CreateOrderResponseV6(
        deliveryInformation: (deliveryInformation != null
            ? deliveryInformation.value
            : this.deliveryInformation),
        items: (items != null ? items.value : this.items),
        lastSyncedDate: (lastSyncedDate != null
            ? lastSyncedDate.value
            : this.lastSyncedDate),
        order: (order != null ? order.value : this.order),
        shoppingType:
            (shoppingType != null ? shoppingType.value : this.shoppingType),
        state: (state != null ? state.value : this.state),
        totalPrice: (totalPrice != null ? totalPrice.value : this.totalPrice));
  }
}

@JsonSerializable(explicitToJson: true)
class CreateOrderResponseV7 {
  CreateOrderResponseV7({
    this.deliveryInformation,
    this.items,
    required this.order,
    required this.shoppingType,
    required this.state,
    required this.syncTimes,
    required this.totalPrice,
  });

  factory CreateOrderResponseV7.fromJson(Map<String, dynamic> json) =>
      _$CreateOrderResponseV7FromJson(json);

  @JsonKey(name: 'deliveryInformation', includeIfNull: false)
  final DeliveryInformation? deliveryInformation;
  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <Item>[])
  final List<Item>? items;
  @JsonKey(name: 'order', includeIfNull: false)
  final Order order;
  @JsonKey(
    name: 'shoppingType',
    includeIfNull: false,
    toJson: createOrderResponseV7ShoppingTypeToJson,
    fromJson: createOrderResponseV7ShoppingTypeFromJson,
  )
  final enums.CreateOrderResponseV7ShoppingType shoppingType;
  @JsonKey(
    name: 'state',
    includeIfNull: false,
    toJson: createOrderResponseV7StateToJson,
    fromJson: createOrderResponseV7StateFromJson,
  )
  final enums.CreateOrderResponseV7State state;
  @JsonKey(name: 'syncTimes', includeIfNull: false)
  final SyncTimesV7 syncTimes;
  @JsonKey(name: 'totalPrice', includeIfNull: false)
  final OrderTotalPrice totalPrice;
  static const fromJsonFactory = _$CreateOrderResponseV7FromJson;
  static const toJsonFactory = _$CreateOrderResponseV7ToJson;
  Map<String, dynamic> toJson() => _$CreateOrderResponseV7ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CreateOrderResponseV7 &&
            (identical(other.deliveryInformation, deliveryInformation) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryInformation, deliveryInformation)) &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.order, order) ||
                const DeepCollectionEquality().equals(other.order, order)) &&
            (identical(other.shoppingType, shoppingType) ||
                const DeepCollectionEquality()
                    .equals(other.shoppingType, shoppingType)) &&
            (identical(other.state, state) ||
                const DeepCollectionEquality().equals(other.state, state)) &&
            (identical(other.syncTimes, syncTimes) ||
                const DeepCollectionEquality()
                    .equals(other.syncTimes, syncTimes)) &&
            (identical(other.totalPrice, totalPrice) ||
                const DeepCollectionEquality()
                    .equals(other.totalPrice, totalPrice)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(deliveryInformation) ^
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(order) ^
      const DeepCollectionEquality().hash(shoppingType) ^
      const DeepCollectionEquality().hash(state) ^
      const DeepCollectionEquality().hash(syncTimes) ^
      const DeepCollectionEquality().hash(totalPrice) ^
      runtimeType.hashCode;
}

extension $CreateOrderResponseV7Extension on CreateOrderResponseV7 {
  CreateOrderResponseV7 copyWith(
      {DeliveryInformation? deliveryInformation,
      List<Item>? items,
      Order? order,
      enums.CreateOrderResponseV7ShoppingType? shoppingType,
      enums.CreateOrderResponseV7State? state,
      SyncTimesV7? syncTimes,
      OrderTotalPrice? totalPrice}) {
    return CreateOrderResponseV7(
        deliveryInformation: deliveryInformation ?? this.deliveryInformation,
        items: items ?? this.items,
        order: order ?? this.order,
        shoppingType: shoppingType ?? this.shoppingType,
        state: state ?? this.state,
        syncTimes: syncTimes ?? this.syncTimes,
        totalPrice: totalPrice ?? this.totalPrice);
  }

  CreateOrderResponseV7 copyWithWrapped(
      {Wrapped<DeliveryInformation?>? deliveryInformation,
      Wrapped<List<Item>?>? items,
      Wrapped<Order>? order,
      Wrapped<enums.CreateOrderResponseV7ShoppingType>? shoppingType,
      Wrapped<enums.CreateOrderResponseV7State>? state,
      Wrapped<SyncTimesV7>? syncTimes,
      Wrapped<OrderTotalPrice>? totalPrice}) {
    return CreateOrderResponseV7(
        deliveryInformation: (deliveryInformation != null
            ? deliveryInformation.value
            : this.deliveryInformation),
        items: (items != null ? items.value : this.items),
        order: (order != null ? order.value : this.order),
        shoppingType:
            (shoppingType != null ? shoppingType.value : this.shoppingType),
        state: (state != null ? state.value : this.state),
        syncTimes: (syncTimes != null ? syncTimes.value : this.syncTimes),
        totalPrice: (totalPrice != null ? totalPrice.value : this.totalPrice));
  }
}

@JsonSerializable(explicitToJson: true)
class DeliveryDto {
  DeliveryDto({
    required this.active,
    this.address,
    required this.deliveryDate,
    required this.deliveryEndTime,
    required this.deliveryShiftCode,
    required this.deliveryStartTime,
    required this.deliveryStatus,
    required this.deliveryUtcEndTime,
    required this.deliveryUtcStartTime,
    required this.notDelivered,
    required this.open,
    required this.orderId,
    this.pickupInfo,
    required this.trackAndTraceable,
  });

  factory DeliveryDto.fromJson(Map<String, dynamic> json) =>
      _$DeliveryDtoFromJson(json);

  @JsonKey(name: 'active', includeIfNull: false)
  final bool active;
  @JsonKey(name: 'address', includeIfNull: false)
  final AddressDto? address;
  @JsonKey(name: 'deliveryDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime deliveryDate;
  @JsonKey(name: 'deliveryEndTime', includeIfNull: false, defaultValue: '')
  final String deliveryEndTime;
  @JsonKey(name: 'deliveryShiftCode', includeIfNull: false, defaultValue: '')
  final String deliveryShiftCode;
  @JsonKey(name: 'deliveryStartTime', includeIfNull: false, defaultValue: '')
  final String deliveryStartTime;
  @JsonKey(
    name: 'deliveryStatus',
    includeIfNull: false,
    toJson: deliveryDtoDeliveryStatusToJson,
    fromJson: deliveryDtoDeliveryStatusFromJson,
  )
  final enums.DeliveryDtoDeliveryStatus deliveryStatus;
  @JsonKey(name: 'deliveryUtcEndTime', includeIfNull: false)
  final DateTime deliveryUtcEndTime;
  @JsonKey(name: 'deliveryUtcStartTime', includeIfNull: false)
  final DateTime deliveryUtcStartTime;
  @JsonKey(name: 'notDelivered', includeIfNull: false)
  final bool notDelivered;
  @JsonKey(name: 'open', includeIfNull: false)
  final bool open;
  @JsonKey(name: 'orderId', includeIfNull: false)
  final num orderId;
  @JsonKey(name: 'pickupInfo', includeIfNull: false)
  final PickupInfo? pickupInfo;
  @JsonKey(name: 'trackAndTraceable', includeIfNull: false)
  final bool trackAndTraceable;
  static const fromJsonFactory = _$DeliveryDtoFromJson;
  static const toJsonFactory = _$DeliveryDtoToJson;
  Map<String, dynamic> toJson() => _$DeliveryDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DeliveryDto &&
            (identical(other.active, active) ||
                const DeepCollectionEquality().equals(other.active, active)) &&
            (identical(other.address, address) ||
                const DeepCollectionEquality()
                    .equals(other.address, address)) &&
            (identical(other.deliveryDate, deliveryDate) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryDate, deliveryDate)) &&
            (identical(other.deliveryEndTime, deliveryEndTime) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryEndTime, deliveryEndTime)) &&
            (identical(other.deliveryShiftCode, deliveryShiftCode) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryShiftCode, deliveryShiftCode)) &&
            (identical(other.deliveryStartTime, deliveryStartTime) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryStartTime, deliveryStartTime)) &&
            (identical(other.deliveryStatus, deliveryStatus) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryStatus, deliveryStatus)) &&
            (identical(other.deliveryUtcEndTime, deliveryUtcEndTime) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryUtcEndTime, deliveryUtcEndTime)) &&
            (identical(other.deliveryUtcStartTime, deliveryUtcStartTime) ||
                const DeepCollectionEquality().equals(
                    other.deliveryUtcStartTime, deliveryUtcStartTime)) &&
            (identical(other.notDelivered, notDelivered) ||
                const DeepCollectionEquality()
                    .equals(other.notDelivered, notDelivered)) &&
            (identical(other.open, open) ||
                const DeepCollectionEquality().equals(other.open, open)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.pickupInfo, pickupInfo) ||
                const DeepCollectionEquality()
                    .equals(other.pickupInfo, pickupInfo)) &&
            (identical(other.trackAndTraceable, trackAndTraceable) ||
                const DeepCollectionEquality()
                    .equals(other.trackAndTraceable, trackAndTraceable)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(active) ^
      const DeepCollectionEquality().hash(address) ^
      const DeepCollectionEquality().hash(deliveryDate) ^
      const DeepCollectionEquality().hash(deliveryEndTime) ^
      const DeepCollectionEquality().hash(deliveryShiftCode) ^
      const DeepCollectionEquality().hash(deliveryStartTime) ^
      const DeepCollectionEquality().hash(deliveryStatus) ^
      const DeepCollectionEquality().hash(deliveryUtcEndTime) ^
      const DeepCollectionEquality().hash(deliveryUtcStartTime) ^
      const DeepCollectionEquality().hash(notDelivered) ^
      const DeepCollectionEquality().hash(open) ^
      const DeepCollectionEquality().hash(orderId) ^
      const DeepCollectionEquality().hash(pickupInfo) ^
      const DeepCollectionEquality().hash(trackAndTraceable) ^
      runtimeType.hashCode;
}

extension $DeliveryDtoExtension on DeliveryDto {
  DeliveryDto copyWith(
      {bool? active,
      AddressDto? address,
      DateTime? deliveryDate,
      String? deliveryEndTime,
      String? deliveryShiftCode,
      String? deliveryStartTime,
      enums.DeliveryDtoDeliveryStatus? deliveryStatus,
      DateTime? deliveryUtcEndTime,
      DateTime? deliveryUtcStartTime,
      bool? notDelivered,
      bool? open,
      num? orderId,
      PickupInfo? pickupInfo,
      bool? trackAndTraceable}) {
    return DeliveryDto(
        active: active ?? this.active,
        address: address ?? this.address,
        deliveryDate: deliveryDate ?? this.deliveryDate,
        deliveryEndTime: deliveryEndTime ?? this.deliveryEndTime,
        deliveryShiftCode: deliveryShiftCode ?? this.deliveryShiftCode,
        deliveryStartTime: deliveryStartTime ?? this.deliveryStartTime,
        deliveryStatus: deliveryStatus ?? this.deliveryStatus,
        deliveryUtcEndTime: deliveryUtcEndTime ?? this.deliveryUtcEndTime,
        deliveryUtcStartTime: deliveryUtcStartTime ?? this.deliveryUtcStartTime,
        notDelivered: notDelivered ?? this.notDelivered,
        open: open ?? this.open,
        orderId: orderId ?? this.orderId,
        pickupInfo: pickupInfo ?? this.pickupInfo,
        trackAndTraceable: trackAndTraceable ?? this.trackAndTraceable);
  }

  DeliveryDto copyWithWrapped(
      {Wrapped<bool>? active,
      Wrapped<AddressDto?>? address,
      Wrapped<DateTime>? deliveryDate,
      Wrapped<String>? deliveryEndTime,
      Wrapped<String>? deliveryShiftCode,
      Wrapped<String>? deliveryStartTime,
      Wrapped<enums.DeliveryDtoDeliveryStatus>? deliveryStatus,
      Wrapped<DateTime>? deliveryUtcEndTime,
      Wrapped<DateTime>? deliveryUtcStartTime,
      Wrapped<bool>? notDelivered,
      Wrapped<bool>? open,
      Wrapped<num>? orderId,
      Wrapped<PickupInfo?>? pickupInfo,
      Wrapped<bool>? trackAndTraceable}) {
    return DeliveryDto(
        active: (active != null ? active.value : this.active),
        address: (address != null ? address.value : this.address),
        deliveryDate:
            (deliveryDate != null ? deliveryDate.value : this.deliveryDate),
        deliveryEndTime: (deliveryEndTime != null
            ? deliveryEndTime.value
            : this.deliveryEndTime),
        deliveryShiftCode: (deliveryShiftCode != null
            ? deliveryShiftCode.value
            : this.deliveryShiftCode),
        deliveryStartTime: (deliveryStartTime != null
            ? deliveryStartTime.value
            : this.deliveryStartTime),
        deliveryStatus: (deliveryStatus != null
            ? deliveryStatus.value
            : this.deliveryStatus),
        deliveryUtcEndTime: (deliveryUtcEndTime != null
            ? deliveryUtcEndTime.value
            : this.deliveryUtcEndTime),
        deliveryUtcStartTime: (deliveryUtcStartTime != null
            ? deliveryUtcStartTime.value
            : this.deliveryUtcStartTime),
        notDelivered:
            (notDelivered != null ? notDelivered.value : this.notDelivered),
        open: (open != null ? open.value : this.open),
        orderId: (orderId != null ? orderId.value : this.orderId),
        pickupInfo: (pickupInfo != null ? pickupInfo.value : this.pickupInfo),
        trackAndTraceable: (trackAndTraceable != null
            ? trackAndTraceable.value
            : this.trackAndTraceable));
  }
}

@JsonSerializable(explicitToJson: true)
class DeliveryInformation {
  DeliveryInformation({
    this.address,
    required this.deliveryDate,
    required this.deliveryEndTime,
    required this.deliveryShiftCode,
    required this.deliveryStartTime,
    required this.deliveryUtcEndTime,
    required this.deliveryUtcStartTime,
    this.locationId,
  });

  factory DeliveryInformation.fromJson(Map<String, dynamic> json) =>
      _$DeliveryInformationFromJson(json);

  @JsonKey(name: 'address', includeIfNull: false)
  final Address? address;
  @JsonKey(name: 'deliveryDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime deliveryDate;
  @JsonKey(name: 'deliveryEndTime', includeIfNull: false, defaultValue: '')
  final String deliveryEndTime;
  @JsonKey(name: 'deliveryShiftCode', includeIfNull: false, defaultValue: '')
  final String deliveryShiftCode;
  @JsonKey(name: 'deliveryStartTime', includeIfNull: false, defaultValue: '')
  final String deliveryStartTime;
  @JsonKey(name: 'deliveryUtcEndTime', includeIfNull: false)
  final DateTime deliveryUtcEndTime;
  @JsonKey(name: 'deliveryUtcStartTime', includeIfNull: false)
  final DateTime deliveryUtcStartTime;
  @JsonKey(name: 'locationId', includeIfNull: false)
  final num? locationId;
  static const fromJsonFactory = _$DeliveryInformationFromJson;
  static const toJsonFactory = _$DeliveryInformationToJson;
  Map<String, dynamic> toJson() => _$DeliveryInformationToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DeliveryInformation &&
            (identical(other.address, address) ||
                const DeepCollectionEquality()
                    .equals(other.address, address)) &&
            (identical(other.deliveryDate, deliveryDate) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryDate, deliveryDate)) &&
            (identical(other.deliveryEndTime, deliveryEndTime) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryEndTime, deliveryEndTime)) &&
            (identical(other.deliveryShiftCode, deliveryShiftCode) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryShiftCode, deliveryShiftCode)) &&
            (identical(other.deliveryStartTime, deliveryStartTime) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryStartTime, deliveryStartTime)) &&
            (identical(other.deliveryUtcEndTime, deliveryUtcEndTime) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryUtcEndTime, deliveryUtcEndTime)) &&
            (identical(other.deliveryUtcStartTime, deliveryUtcStartTime) ||
                const DeepCollectionEquality().equals(
                    other.deliveryUtcStartTime, deliveryUtcStartTime)) &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(address) ^
      const DeepCollectionEquality().hash(deliveryDate) ^
      const DeepCollectionEquality().hash(deliveryEndTime) ^
      const DeepCollectionEquality().hash(deliveryShiftCode) ^
      const DeepCollectionEquality().hash(deliveryStartTime) ^
      const DeepCollectionEquality().hash(deliveryUtcEndTime) ^
      const DeepCollectionEquality().hash(deliveryUtcStartTime) ^
      const DeepCollectionEquality().hash(locationId) ^
      runtimeType.hashCode;
}

extension $DeliveryInformationExtension on DeliveryInformation {
  DeliveryInformation copyWith(
      {Address? address,
      DateTime? deliveryDate,
      String? deliveryEndTime,
      String? deliveryShiftCode,
      String? deliveryStartTime,
      DateTime? deliveryUtcEndTime,
      DateTime? deliveryUtcStartTime,
      num? locationId}) {
    return DeliveryInformation(
        address: address ?? this.address,
        deliveryDate: deliveryDate ?? this.deliveryDate,
        deliveryEndTime: deliveryEndTime ?? this.deliveryEndTime,
        deliveryShiftCode: deliveryShiftCode ?? this.deliveryShiftCode,
        deliveryStartTime: deliveryStartTime ?? this.deliveryStartTime,
        deliveryUtcEndTime: deliveryUtcEndTime ?? this.deliveryUtcEndTime,
        deliveryUtcStartTime: deliveryUtcStartTime ?? this.deliveryUtcStartTime,
        locationId: locationId ?? this.locationId);
  }

  DeliveryInformation copyWithWrapped(
      {Wrapped<Address?>? address,
      Wrapped<DateTime>? deliveryDate,
      Wrapped<String>? deliveryEndTime,
      Wrapped<String>? deliveryShiftCode,
      Wrapped<String>? deliveryStartTime,
      Wrapped<DateTime>? deliveryUtcEndTime,
      Wrapped<DateTime>? deliveryUtcStartTime,
      Wrapped<num?>? locationId}) {
    return DeliveryInformation(
        address: (address != null ? address.value : this.address),
        deliveryDate:
            (deliveryDate != null ? deliveryDate.value : this.deliveryDate),
        deliveryEndTime: (deliveryEndTime != null
            ? deliveryEndTime.value
            : this.deliveryEndTime),
        deliveryShiftCode: (deliveryShiftCode != null
            ? deliveryShiftCode.value
            : this.deliveryShiftCode),
        deliveryStartTime: (deliveryStartTime != null
            ? deliveryStartTime.value
            : this.deliveryStartTime),
        deliveryUtcEndTime: (deliveryUtcEndTime != null
            ? deliveryUtcEndTime.value
            : this.deliveryUtcEndTime),
        deliveryUtcStartTime: (deliveryUtcStartTime != null
            ? deliveryUtcStartTime.value
            : this.deliveryUtcStartTime),
        locationId: (locationId != null ? locationId.value : this.locationId));
  }
}

@JsonSerializable(explicitToJson: true)
class DeliveryStateInformation {
  DeliveryStateInformation({
    this.message,
    this.state,
  });

  factory DeliveryStateInformation.fromJson(Map<String, dynamic> json) =>
      _$DeliveryStateInformationFromJson(json);

  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(
    name: 'state',
    includeIfNull: false,
    toJson: deliveryStateInformationStateToJson,
    fromJson: deliveryStateInformationStateFromJson,
  )
  final enums.DeliveryStateInformationState? state;
  static const fromJsonFactory = _$DeliveryStateInformationFromJson;
  static const toJsonFactory = _$DeliveryStateInformationToJson;
  Map<String, dynamic> toJson() => _$DeliveryStateInformationToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DeliveryStateInformation &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.state, state) ||
                const DeepCollectionEquality().equals(other.state, state)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(state) ^
      runtimeType.hashCode;
}

extension $DeliveryStateInformationExtension on DeliveryStateInformation {
  DeliveryStateInformation copyWith(
      {String? message, enums.DeliveryStateInformationState? state}) {
    return DeliveryStateInformation(
        message: message ?? this.message, state: state ?? this.state);
  }

  DeliveryStateInformation copyWithWrapped(
      {Wrapped<String?>? message,
      Wrapped<enums.DeliveryStateInformationState?>? state}) {
    return DeliveryStateInformation(
        message: (message != null ? message.value : this.message),
        state: (state != null ? state.value : this.state));
  }
}

@JsonSerializable(explicitToJson: true)
class DeliveryTimePeriod {
  DeliveryTimePeriod({
    this.endDateTime,
    required this.endTimeUtc,
    this.startDateTime,
    required this.startTimeUtc,
  });

  factory DeliveryTimePeriod.fromJson(Map<String, dynamic> json) =>
      _$DeliveryTimePeriodFromJson(json);

  @JsonKey(name: 'endDateTime', includeIfNull: false)
  final DateTime? endDateTime;
  @JsonKey(name: 'endTimeUtc', includeIfNull: false)
  final DateTime endTimeUtc;
  @JsonKey(name: 'startDateTime', includeIfNull: false)
  final DateTime? startDateTime;
  @JsonKey(name: 'startTimeUtc', includeIfNull: false)
  final DateTime startTimeUtc;
  static const fromJsonFactory = _$DeliveryTimePeriodFromJson;
  static const toJsonFactory = _$DeliveryTimePeriodToJson;
  Map<String, dynamic> toJson() => _$DeliveryTimePeriodToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DeliveryTimePeriod &&
            (identical(other.endDateTime, endDateTime) ||
                const DeepCollectionEquality()
                    .equals(other.endDateTime, endDateTime)) &&
            (identical(other.endTimeUtc, endTimeUtc) ||
                const DeepCollectionEquality()
                    .equals(other.endTimeUtc, endTimeUtc)) &&
            (identical(other.startDateTime, startDateTime) ||
                const DeepCollectionEquality()
                    .equals(other.startDateTime, startDateTime)) &&
            (identical(other.startTimeUtc, startTimeUtc) ||
                const DeepCollectionEquality()
                    .equals(other.startTimeUtc, startTimeUtc)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(endDateTime) ^
      const DeepCollectionEquality().hash(endTimeUtc) ^
      const DeepCollectionEquality().hash(startDateTime) ^
      const DeepCollectionEquality().hash(startTimeUtc) ^
      runtimeType.hashCode;
}

extension $DeliveryTimePeriodExtension on DeliveryTimePeriod {
  DeliveryTimePeriod copyWith(
      {DateTime? endDateTime,
      DateTime? endTimeUtc,
      DateTime? startDateTime,
      DateTime? startTimeUtc}) {
    return DeliveryTimePeriod(
        endDateTime: endDateTime ?? this.endDateTime,
        endTimeUtc: endTimeUtc ?? this.endTimeUtc,
        startDateTime: startDateTime ?? this.startDateTime,
        startTimeUtc: startTimeUtc ?? this.startTimeUtc);
  }

  DeliveryTimePeriod copyWithWrapped(
      {Wrapped<DateTime?>? endDateTime,
      Wrapped<DateTime>? endTimeUtc,
      Wrapped<DateTime?>? startDateTime,
      Wrapped<DateTime>? startTimeUtc}) {
    return DeliveryTimePeriod(
        endDateTime:
            (endDateTime != null ? endDateTime.value : this.endDateTime),
        endTimeUtc: (endTimeUtc != null ? endTimeUtc.value : this.endTimeUtc),
        startDateTime:
            (startDateTime != null ? startDateTime.value : this.startDateTime),
        startTimeUtc:
            (startTimeUtc != null ? startTimeUtc.value : this.startTimeUtc));
  }
}

@JsonSerializable(explicitToJson: true)
class GroupedProductsInTaxonomy {
  GroupedProductsInTaxonomy({
    this.orderedProducts,
    this.taxonomyName,
  });

  factory GroupedProductsInTaxonomy.fromJson(Map<String, dynamic> json) =>
      _$GroupedProductsInTaxonomyFromJson(json);

  @JsonKey(
      name: 'orderedProducts',
      includeIfNull: false,
      defaultValue: <OrderedProductCardV7>[])
  final List<OrderedProductCardV7>? orderedProducts;
  @JsonKey(name: 'taxonomyName', includeIfNull: false, defaultValue: '')
  final String? taxonomyName;
  static const fromJsonFactory = _$GroupedProductsInTaxonomyFromJson;
  static const toJsonFactory = _$GroupedProductsInTaxonomyToJson;
  Map<String, dynamic> toJson() => _$GroupedProductsInTaxonomyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is GroupedProductsInTaxonomy &&
            (identical(other.orderedProducts, orderedProducts) ||
                const DeepCollectionEquality()
                    .equals(other.orderedProducts, orderedProducts)) &&
            (identical(other.taxonomyName, taxonomyName) ||
                const DeepCollectionEquality()
                    .equals(other.taxonomyName, taxonomyName)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(orderedProducts) ^
      const DeepCollectionEquality().hash(taxonomyName) ^
      runtimeType.hashCode;
}

extension $GroupedProductsInTaxonomyExtension on GroupedProductsInTaxonomy {
  GroupedProductsInTaxonomy copyWith(
      {List<OrderedProductCardV7>? orderedProducts, String? taxonomyName}) {
    return GroupedProductsInTaxonomy(
        orderedProducts: orderedProducts ?? this.orderedProducts,
        taxonomyName: taxonomyName ?? this.taxonomyName);
  }

  GroupedProductsInTaxonomy copyWithWrapped(
      {Wrapped<List<OrderedProductCardV7>?>? orderedProducts,
      Wrapped<String?>? taxonomyName}) {
    return GroupedProductsInTaxonomy(
        orderedProducts: (orderedProducts != null
            ? orderedProducts.value
            : this.orderedProducts),
        taxonomyName:
            (taxonomyName != null ? taxonomyName.value : this.taxonomyName));
  }
}

@JsonSerializable(explicitToJson: true)
class Image {
  Image({
    required this.height,
    required this.url,
    required this.width,
  });

  factory Image.fromJson(Map<String, dynamic> json) => _$ImageFromJson(json);

  @JsonKey(name: 'height', includeIfNull: false)
  final int height;
  @JsonKey(name: 'url', includeIfNull: false, defaultValue: '')
  final String url;
  @JsonKey(name: 'width', includeIfNull: false)
  final int width;
  static const fromJsonFactory = _$ImageFromJson;
  static const toJsonFactory = _$ImageToJson;
  Map<String, dynamic> toJson() => _$ImageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Image &&
            (identical(other.height, height) ||
                const DeepCollectionEquality().equals(other.height, height)) &&
            (identical(other.url, url) ||
                const DeepCollectionEquality().equals(other.url, url)) &&
            (identical(other.width, width) ||
                const DeepCollectionEquality().equals(other.width, width)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(height) ^
      const DeepCollectionEquality().hash(url) ^
      const DeepCollectionEquality().hash(width) ^
      runtimeType.hashCode;
}

extension $ImageExtension on Image {
  Image copyWith({int? height, String? url, int? width}) {
    return Image(
        height: height ?? this.height,
        url: url ?? this.url,
        width: width ?? this.width);
  }

  Image copyWithWrapped(
      {Wrapped<int>? height, Wrapped<String>? url, Wrapped<int>? width}) {
    return Image(
        height: (height != null ? height.value : this.height),
        url: (url != null ? url.value : this.url),
        width: (width != null ? width.value : this.width));
  }
}

@JsonSerializable(explicitToJson: true)
class Item {
  Item({
    this.description,
    this.originCode,
    this.position,
    this.product,
    this.productId,
    this.quantity,
    this.sourceId,
    this.strikedThrough,
  });

  factory Item.fromJson(Map<String, dynamic> json) => _$ItemFromJson(json);

  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'originCode', includeIfNull: false, defaultValue: '')
  final String? originCode;
  @JsonKey(name: 'position', includeIfNull: false)
  final int? position;
  @JsonKey(name: 'product', includeIfNull: false)
  final ProductCard? product;
  @JsonKey(name: 'productId', includeIfNull: false)
  final num? productId;
  @JsonKey(name: 'quantity', includeIfNull: false)
  final int? quantity;
  @JsonKey(name: 'sourceId', includeIfNull: false)
  final num? sourceId;
  @JsonKey(name: 'strikedThrough', includeIfNull: false)
  final bool? strikedThrough;
  static const fromJsonFactory = _$ItemFromJson;
  static const toJsonFactory = _$ItemToJson;
  Map<String, dynamic> toJson() => _$ItemToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Item &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.originCode, originCode) ||
                const DeepCollectionEquality()
                    .equals(other.originCode, originCode)) &&
            (identical(other.position, position) ||
                const DeepCollectionEquality()
                    .equals(other.position, position)) &&
            (identical(other.product, product) ||
                const DeepCollectionEquality()
                    .equals(other.product, product)) &&
            (identical(other.productId, productId) ||
                const DeepCollectionEquality()
                    .equals(other.productId, productId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.sourceId, sourceId) ||
                const DeepCollectionEquality()
                    .equals(other.sourceId, sourceId)) &&
            (identical(other.strikedThrough, strikedThrough) ||
                const DeepCollectionEquality()
                    .equals(other.strikedThrough, strikedThrough)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(originCode) ^
      const DeepCollectionEquality().hash(position) ^
      const DeepCollectionEquality().hash(product) ^
      const DeepCollectionEquality().hash(productId) ^
      const DeepCollectionEquality().hash(quantity) ^
      const DeepCollectionEquality().hash(sourceId) ^
      const DeepCollectionEquality().hash(strikedThrough) ^
      runtimeType.hashCode;
}

extension $ItemExtension on Item {
  Item copyWith(
      {String? description,
      String? originCode,
      int? position,
      ProductCard? product,
      num? productId,
      int? quantity,
      num? sourceId,
      bool? strikedThrough}) {
    return Item(
        description: description ?? this.description,
        originCode: originCode ?? this.originCode,
        position: position ?? this.position,
        product: product ?? this.product,
        productId: productId ?? this.productId,
        quantity: quantity ?? this.quantity,
        sourceId: sourceId ?? this.sourceId,
        strikedThrough: strikedThrough ?? this.strikedThrough);
  }

  Item copyWithWrapped(
      {Wrapped<String?>? description,
      Wrapped<String?>? originCode,
      Wrapped<int?>? position,
      Wrapped<ProductCard?>? product,
      Wrapped<num?>? productId,
      Wrapped<int?>? quantity,
      Wrapped<num?>? sourceId,
      Wrapped<bool?>? strikedThrough}) {
    return Item(
        description:
            (description != null ? description.value : this.description),
        originCode: (originCode != null ? originCode.value : this.originCode),
        position: (position != null ? position.value : this.position),
        product: (product != null ? product.value : this.product),
        productId: (productId != null ? productId.value : this.productId),
        quantity: (quantity != null ? quantity.value : this.quantity),
        sourceId: (sourceId != null ? sourceId.value : this.sourceId),
        strikedThrough: (strikedThrough != null
            ? strikedThrough.value
            : this.strikedThrough));
  }
}

@JsonSerializable(explicitToJson: true)
class ItemDtoV7 {
  ItemDtoV7({
    this.description,
    this.originCode,
    this.productId,
    required this.quantity,
    this.sourceId,
    this.storeSequence,
    this.strikeThrough,
  });

  factory ItemDtoV7.fromJson(Map<String, dynamic> json) =>
      _$ItemDtoV7FromJson(json);

  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'originCode', includeIfNull: false, defaultValue: '')
  final String? originCode;
  @JsonKey(name: 'productId', includeIfNull: false)
  final num? productId;
  @JsonKey(name: 'quantity', includeIfNull: false)
  final int quantity;
  @JsonKey(name: 'sourceId', includeIfNull: false)
  final num? sourceId;
  @JsonKey(name: 'storeSequence', includeIfNull: false)
  final int? storeSequence;
  @JsonKey(name: 'strikeThrough', includeIfNull: false)
  final bool? strikeThrough;
  static const fromJsonFactory = _$ItemDtoV7FromJson;
  static const toJsonFactory = _$ItemDtoV7ToJson;
  Map<String, dynamic> toJson() => _$ItemDtoV7ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ItemDtoV7 &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.originCode, originCode) ||
                const DeepCollectionEquality()
                    .equals(other.originCode, originCode)) &&
            (identical(other.productId, productId) ||
                const DeepCollectionEquality()
                    .equals(other.productId, productId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.sourceId, sourceId) ||
                const DeepCollectionEquality()
                    .equals(other.sourceId, sourceId)) &&
            (identical(other.storeSequence, storeSequence) ||
                const DeepCollectionEquality()
                    .equals(other.storeSequence, storeSequence)) &&
            (identical(other.strikeThrough, strikeThrough) ||
                const DeepCollectionEquality()
                    .equals(other.strikeThrough, strikeThrough)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(originCode) ^
      const DeepCollectionEquality().hash(productId) ^
      const DeepCollectionEquality().hash(quantity) ^
      const DeepCollectionEquality().hash(sourceId) ^
      const DeepCollectionEquality().hash(storeSequence) ^
      const DeepCollectionEquality().hash(strikeThrough) ^
      runtimeType.hashCode;
}

extension $ItemDtoV7Extension on ItemDtoV7 {
  ItemDtoV7 copyWith(
      {String? description,
      String? originCode,
      num? productId,
      int? quantity,
      num? sourceId,
      int? storeSequence,
      bool? strikeThrough}) {
    return ItemDtoV7(
        description: description ?? this.description,
        originCode: originCode ?? this.originCode,
        productId: productId ?? this.productId,
        quantity: quantity ?? this.quantity,
        sourceId: sourceId ?? this.sourceId,
        storeSequence: storeSequence ?? this.storeSequence,
        strikeThrough: strikeThrough ?? this.strikeThrough);
  }

  ItemDtoV7 copyWithWrapped(
      {Wrapped<String?>? description,
      Wrapped<String?>? originCode,
      Wrapped<num?>? productId,
      Wrapped<int>? quantity,
      Wrapped<num?>? sourceId,
      Wrapped<int?>? storeSequence,
      Wrapped<bool?>? strikeThrough}) {
    return ItemDtoV7(
        description:
            (description != null ? description.value : this.description),
        originCode: (originCode != null ? originCode.value : this.originCode),
        productId: (productId != null ? productId.value : this.productId),
        quantity: (quantity != null ? quantity.value : this.quantity),
        sourceId: (sourceId != null ? sourceId.value : this.sourceId),
        storeSequence:
            (storeSequence != null ? storeSequence.value : this.storeSequence),
        strikeThrough:
            (strikeThrough != null ? strikeThrough.value : this.strikeThrough));
  }
}

@JsonSerializable(explicitToJson: true)
class ItemList {
  ItemList({
    this.items,
    this.lastSyncedDate,
  });

  factory ItemList.fromJson(Map<String, dynamic> json) =>
      _$ItemListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <Item>[])
  final List<Item>? items;
  @JsonKey(name: 'lastSyncedDate', includeIfNull: false)
  final DateTime? lastSyncedDate;
  static const fromJsonFactory = _$ItemListFromJson;
  static const toJsonFactory = _$ItemListToJson;
  Map<String, dynamic> toJson() => _$ItemListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ItemList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.lastSyncedDate, lastSyncedDate) ||
                const DeepCollectionEquality()
                    .equals(other.lastSyncedDate, lastSyncedDate)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(lastSyncedDate) ^
      runtimeType.hashCode;
}

extension $ItemListExtension on ItemList {
  ItemList copyWith({List<Item>? items, DateTime? lastSyncedDate}) {
    return ItemList(
        items: items ?? this.items,
        lastSyncedDate: lastSyncedDate ?? this.lastSyncedDate);
  }

  ItemList copyWithWrapped(
      {Wrapped<List<Item>?>? items, Wrapped<DateTime?>? lastSyncedDate}) {
    return ItemList(
        items: (items != null ? items.value : this.items),
        lastSyncedDate: (lastSyncedDate != null
            ? lastSyncedDate.value
            : this.lastSyncedDate));
  }
}

@JsonSerializable(explicitToJson: true)
class KassaKoopje {
  KassaKoopje({
    required this.product,
    required this.productId,
  });

  factory KassaKoopje.fromJson(Map<String, dynamic> json) =>
      _$KassaKoopjeFromJson(json);

  @JsonKey(name: 'product', includeIfNull: false)
  final ProductCard product;
  @JsonKey(name: 'productId', includeIfNull: false)
  final num productId;
  static const fromJsonFactory = _$KassaKoopjeFromJson;
  static const toJsonFactory = _$KassaKoopjeToJson;
  Map<String, dynamic> toJson() => _$KassaKoopjeToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is KassaKoopje &&
            (identical(other.product, product) ||
                const DeepCollectionEquality()
                    .equals(other.product, product)) &&
            (identical(other.productId, productId) ||
                const DeepCollectionEquality()
                    .equals(other.productId, productId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(product) ^
      const DeepCollectionEquality().hash(productId) ^
      runtimeType.hashCode;
}

extension $KassaKoopjeExtension on KassaKoopje {
  KassaKoopje copyWith({ProductCard? product, num? productId}) {
    return KassaKoopje(
        product: product ?? this.product,
        productId: productId ?? this.productId);
  }

  KassaKoopje copyWithWrapped(
      {Wrapped<ProductCard>? product, Wrapped<num>? productId}) {
    return KassaKoopje(
        product: (product != null ? product.value : this.product),
        productId: (productId != null ? productId.value : this.productId));
  }
}

@JsonSerializable(explicitToJson: true)
class LatestOrderSummary {
  LatestOrderSummary({
    required this.orderId,
    required this.orderType,
    required this.state,
  });

  factory LatestOrderSummary.fromJson(Map<String, dynamic> json) =>
      _$LatestOrderSummaryFromJson(json);

  @JsonKey(name: 'orderId', includeIfNull: false)
  final num orderId;
  @JsonKey(
    name: 'orderType',
    includeIfNull: false,
    toJson: latestOrderSummaryOrderTypeToJson,
    fromJson: latestOrderSummaryOrderTypeFromJson,
  )
  final enums.LatestOrderSummaryOrderType orderType;
  @JsonKey(
    name: 'state',
    includeIfNull: false,
    toJson: latestOrderSummaryStateToJson,
    fromJson: latestOrderSummaryStateFromJson,
  )
  final enums.LatestOrderSummaryState state;
  static const fromJsonFactory = _$LatestOrderSummaryFromJson;
  static const toJsonFactory = _$LatestOrderSummaryToJson;
  Map<String, dynamic> toJson() => _$LatestOrderSummaryToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is LatestOrderSummary &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderType, orderType) ||
                const DeepCollectionEquality()
                    .equals(other.orderType, orderType)) &&
            (identical(other.state, state) ||
                const DeepCollectionEquality().equals(other.state, state)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(orderId) ^
      const DeepCollectionEquality().hash(orderType) ^
      const DeepCollectionEquality().hash(state) ^
      runtimeType.hashCode;
}

extension $LatestOrderSummaryExtension on LatestOrderSummary {
  LatestOrderSummary copyWith(
      {num? orderId,
      enums.LatestOrderSummaryOrderType? orderType,
      enums.LatestOrderSummaryState? state}) {
    return LatestOrderSummary(
        orderId: orderId ?? this.orderId,
        orderType: orderType ?? this.orderType,
        state: state ?? this.state);
  }

  LatestOrderSummary copyWithWrapped(
      {Wrapped<num>? orderId,
      Wrapped<enums.LatestOrderSummaryOrderType>? orderType,
      Wrapped<enums.LatestOrderSummaryState>? state}) {
    return LatestOrderSummary(
        orderId: (orderId != null ? orderId.value : this.orderId),
        orderType: (orderType != null ? orderType.value : this.orderType),
        state: (state != null ? state.value : this.state));
  }
}

@JsonSerializable(explicitToJson: true)
class ListSyncTimesV7 {
  ListSyncTimesV7({
    required this.lastSync,
  });

  factory ListSyncTimesV7.fromJson(Map<String, dynamic> json) =>
      _$ListSyncTimesV7FromJson(json);

  @JsonKey(name: 'lastSync', includeIfNull: false)
  final DateTime lastSync;
  static const fromJsonFactory = _$ListSyncTimesV7FromJson;
  static const toJsonFactory = _$ListSyncTimesV7ToJson;
  Map<String, dynamic> toJson() => _$ListSyncTimesV7ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ListSyncTimesV7 &&
            (identical(other.lastSync, lastSync) ||
                const DeepCollectionEquality()
                    .equals(other.lastSync, lastSync)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(lastSync) ^ runtimeType.hashCode;
}

extension $ListSyncTimesV7Extension on ListSyncTimesV7 {
  ListSyncTimesV7 copyWith({DateTime? lastSync}) {
    return ListSyncTimesV7(lastSync: lastSync ?? this.lastSync);
  }

  ListSyncTimesV7 copyWithWrapped({Wrapped<DateTime>? lastSync}) {
    return ListSyncTimesV7(
        lastSync: (lastSync != null ? lastSync.value : this.lastSync));
  }
}

@JsonSerializable(explicitToJson: true)
class LocalTime {
  LocalTime({
    this.hour,
    this.minute,
    this.nano,
    this.second,
  });

  factory LocalTime.fromJson(Map<String, dynamic> json) =>
      _$LocalTimeFromJson(json);

  @JsonKey(name: 'hour', includeIfNull: false)
  final int? hour;
  @JsonKey(name: 'minute', includeIfNull: false)
  final int? minute;
  @JsonKey(name: 'nano', includeIfNull: false)
  final int? nano;
  @JsonKey(name: 'second', includeIfNull: false)
  final int? second;
  static const fromJsonFactory = _$LocalTimeFromJson;
  static const toJsonFactory = _$LocalTimeToJson;
  Map<String, dynamic> toJson() => _$LocalTimeToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is LocalTime &&
            (identical(other.hour, hour) ||
                const DeepCollectionEquality().equals(other.hour, hour)) &&
            (identical(other.minute, minute) ||
                const DeepCollectionEquality().equals(other.minute, minute)) &&
            (identical(other.nano, nano) ||
                const DeepCollectionEquality().equals(other.nano, nano)) &&
            (identical(other.second, second) ||
                const DeepCollectionEquality().equals(other.second, second)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(hour) ^
      const DeepCollectionEquality().hash(minute) ^
      const DeepCollectionEquality().hash(nano) ^
      const DeepCollectionEquality().hash(second) ^
      runtimeType.hashCode;
}

extension $LocalTimeExtension on LocalTime {
  LocalTime copyWith({int? hour, int? minute, int? nano, int? second}) {
    return LocalTime(
        hour: hour ?? this.hour,
        minute: minute ?? this.minute,
        nano: nano ?? this.nano,
        second: second ?? this.second);
  }

  LocalTime copyWithWrapped(
      {Wrapped<int?>? hour,
      Wrapped<int?>? minute,
      Wrapped<int?>? nano,
      Wrapped<int?>? second}) {
    return LocalTime(
        hour: (hour != null ? hour.value : this.hour),
        minute: (minute != null ? minute.value : this.minute),
        nano: (nano != null ? nano.value : this.nano),
        second: (second != null ? second.value : this.second));
  }
}

@JsonSerializable(explicitToJson: true)
class MissingBonus {
  MissingBonus({
    required this.discountUnitType,
    required this.missingBonusOfferQuantity,
    required this.product,
    required this.productCount,
  });

  factory MissingBonus.fromJson(Map<String, dynamic> json) =>
      _$MissingBonusFromJson(json);

  @JsonKey(name: 'discountUnitType', includeIfNull: false, defaultValue: '')
  final String discountUnitType;
  @JsonKey(name: 'missingBonusOfferQuantity', includeIfNull: false)
  final num missingBonusOfferQuantity;
  @JsonKey(name: 'product', includeIfNull: false)
  final ProductCard product;
  @JsonKey(name: 'productCount', includeIfNull: false)
  final num productCount;
  static const fromJsonFactory = _$MissingBonusFromJson;
  static const toJsonFactory = _$MissingBonusToJson;
  Map<String, dynamic> toJson() => _$MissingBonusToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MissingBonus &&
            (identical(other.discountUnitType, discountUnitType) ||
                const DeepCollectionEquality()
                    .equals(other.discountUnitType, discountUnitType)) &&
            (identical(other.missingBonusOfferQuantity,
                    missingBonusOfferQuantity) ||
                const DeepCollectionEquality().equals(
                    other.missingBonusOfferQuantity,
                    missingBonusOfferQuantity)) &&
            (identical(other.product, product) ||
                const DeepCollectionEquality()
                    .equals(other.product, product)) &&
            (identical(other.productCount, productCount) ||
                const DeepCollectionEquality()
                    .equals(other.productCount, productCount)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(discountUnitType) ^
      const DeepCollectionEquality().hash(missingBonusOfferQuantity) ^
      const DeepCollectionEquality().hash(product) ^
      const DeepCollectionEquality().hash(productCount) ^
      runtimeType.hashCode;
}

extension $MissingBonusExtension on MissingBonus {
  MissingBonus copyWith(
      {String? discountUnitType,
      num? missingBonusOfferQuantity,
      ProductCard? product,
      num? productCount}) {
    return MissingBonus(
        discountUnitType: discountUnitType ?? this.discountUnitType,
        missingBonusOfferQuantity:
            missingBonusOfferQuantity ?? this.missingBonusOfferQuantity,
        product: product ?? this.product,
        productCount: productCount ?? this.productCount);
  }

  MissingBonus copyWithWrapped(
      {Wrapped<String>? discountUnitType,
      Wrapped<num>? missingBonusOfferQuantity,
      Wrapped<ProductCard>? product,
      Wrapped<num>? productCount}) {
    return MissingBonus(
        discountUnitType: (discountUnitType != null
            ? discountUnitType.value
            : this.discountUnitType),
        missingBonusOfferQuantity: (missingBonusOfferQuantity != null
            ? missingBonusOfferQuantity.value
            : this.missingBonusOfferQuantity),
        product: (product != null ? product.value : this.product),
        productCount:
            (productCount != null ? productCount.value : this.productCount));
  }
}

@JsonSerializable(explicitToJson: true)
class NonDeliverable {
  NonDeliverable({
    required this.product,
    required this.productId,
  });

  factory NonDeliverable.fromJson(Map<String, dynamic> json) =>
      _$NonDeliverableFromJson(json);

  @JsonKey(name: 'product', includeIfNull: false)
  final ProductCard product;
  @JsonKey(name: 'productId', includeIfNull: false)
  final num productId;
  static const fromJsonFactory = _$NonDeliverableFromJson;
  static const toJsonFactory = _$NonDeliverableToJson;
  Map<String, dynamic> toJson() => _$NonDeliverableToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NonDeliverable &&
            (identical(other.product, product) ||
                const DeepCollectionEquality()
                    .equals(other.product, product)) &&
            (identical(other.productId, productId) ||
                const DeepCollectionEquality()
                    .equals(other.productId, productId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(product) ^
      const DeepCollectionEquality().hash(productId) ^
      runtimeType.hashCode;
}

extension $NonDeliverableExtension on NonDeliverable {
  NonDeliverable copyWith({ProductCard? product, num? productId}) {
    return NonDeliverable(
        product: product ?? this.product,
        productId: productId ?? this.productId);
  }

  NonDeliverable copyWithWrapped(
      {Wrapped<ProductCard>? product, Wrapped<num>? productId}) {
    return NonDeliverable(
        product: (product != null ? product.value : this.product),
        productId: (productId != null ? productId.value : this.productId));
  }
}

@JsonSerializable(explicitToJson: true)
class Order {
  Order({
    this.lastChangedTime,
    required this.orderId,
    required this.orderlines,
  });

  factory Order.fromJson(Map<String, dynamic> json) => _$OrderFromJson(json);

  @JsonKey(name: 'lastChangedTime', includeIfNull: false)
  final DateTime? lastChangedTime;
  @JsonKey(name: 'orderId', includeIfNull: false)
  final num orderId;
  @JsonKey(
      name: 'orderlines', includeIfNull: false, defaultValue: <OrderLine>[])
  final List<OrderLine> orderlines;
  static const fromJsonFactory = _$OrderFromJson;
  static const toJsonFactory = _$OrderToJson;
  Map<String, dynamic> toJson() => _$OrderToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Order &&
            (identical(other.lastChangedTime, lastChangedTime) ||
                const DeepCollectionEquality()
                    .equals(other.lastChangedTime, lastChangedTime)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderlines, orderlines) ||
                const DeepCollectionEquality()
                    .equals(other.orderlines, orderlines)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(lastChangedTime) ^
      const DeepCollectionEquality().hash(orderId) ^
      const DeepCollectionEquality().hash(orderlines) ^
      runtimeType.hashCode;
}

extension $OrderExtension on Order {
  Order copyWith(
      {DateTime? lastChangedTime, num? orderId, List<OrderLine>? orderlines}) {
    return Order(
        lastChangedTime: lastChangedTime ?? this.lastChangedTime,
        orderId: orderId ?? this.orderId,
        orderlines: orderlines ?? this.orderlines);
  }

  Order copyWithWrapped(
      {Wrapped<DateTime?>? lastChangedTime,
      Wrapped<num>? orderId,
      Wrapped<List<OrderLine>>? orderlines}) {
    return Order(
        lastChangedTime: (lastChangedTime != null
            ? lastChangedTime.value
            : this.lastChangedTime),
        orderId: (orderId != null ? orderId.value : this.orderId),
        orderlines: (orderlines != null ? orderlines.value : this.orderlines));
  }
}

@JsonSerializable(explicitToJson: true)
class OrderDelta {
  OrderDelta({
    this.orderDiscountDelta,
    this.orderLinesChanges,
    this.orderReopenedCount,
    this.orderServiceChargeDelta,
  });

  factory OrderDelta.fromJson(Map<String, dynamic> json) =>
      _$OrderDeltaFromJson(json);

  @JsonKey(name: 'orderDiscountDelta', includeIfNull: false)
  final double? orderDiscountDelta;
  @JsonKey(
      name: 'orderLinesChanges',
      includeIfNull: false,
      defaultValue: <OrderLinesChanges>[])
  final List<OrderLinesChanges>? orderLinesChanges;
  @JsonKey(name: 'orderReopenedCount', includeIfNull: false)
  final int? orderReopenedCount;
  @JsonKey(name: 'orderServiceChargeDelta', includeIfNull: false)
  final double? orderServiceChargeDelta;
  static const fromJsonFactory = _$OrderDeltaFromJson;
  static const toJsonFactory = _$OrderDeltaToJson;
  Map<String, dynamic> toJson() => _$OrderDeltaToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OrderDelta &&
            (identical(other.orderDiscountDelta, orderDiscountDelta) ||
                const DeepCollectionEquality()
                    .equals(other.orderDiscountDelta, orderDiscountDelta)) &&
            (identical(other.orderLinesChanges, orderLinesChanges) ||
                const DeepCollectionEquality()
                    .equals(other.orderLinesChanges, orderLinesChanges)) &&
            (identical(other.orderReopenedCount, orderReopenedCount) ||
                const DeepCollectionEquality()
                    .equals(other.orderReopenedCount, orderReopenedCount)) &&
            (identical(
                    other.orderServiceChargeDelta, orderServiceChargeDelta) ||
                const DeepCollectionEquality().equals(
                    other.orderServiceChargeDelta, orderServiceChargeDelta)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(orderDiscountDelta) ^
      const DeepCollectionEquality().hash(orderLinesChanges) ^
      const DeepCollectionEquality().hash(orderReopenedCount) ^
      const DeepCollectionEquality().hash(orderServiceChargeDelta) ^
      runtimeType.hashCode;
}

extension $OrderDeltaExtension on OrderDelta {
  OrderDelta copyWith(
      {double? orderDiscountDelta,
      List<OrderLinesChanges>? orderLinesChanges,
      int? orderReopenedCount,
      double? orderServiceChargeDelta}) {
    return OrderDelta(
        orderDiscountDelta: orderDiscountDelta ?? this.orderDiscountDelta,
        orderLinesChanges: orderLinesChanges ?? this.orderLinesChanges,
        orderReopenedCount: orderReopenedCount ?? this.orderReopenedCount,
        orderServiceChargeDelta:
            orderServiceChargeDelta ?? this.orderServiceChargeDelta);
  }

  OrderDelta copyWithWrapped(
      {Wrapped<double?>? orderDiscountDelta,
      Wrapped<List<OrderLinesChanges>?>? orderLinesChanges,
      Wrapped<int?>? orderReopenedCount,
      Wrapped<double?>? orderServiceChargeDelta}) {
    return OrderDelta(
        orderDiscountDelta: (orderDiscountDelta != null
            ? orderDiscountDelta.value
            : this.orderDiscountDelta),
        orderLinesChanges: (orderLinesChanges != null
            ? orderLinesChanges.value
            : this.orderLinesChanges),
        orderReopenedCount: (orderReopenedCount != null
            ? orderReopenedCount.value
            : this.orderReopenedCount),
        orderServiceChargeDelta: (orderServiceChargeDelta != null
            ? orderServiceChargeDelta.value
            : this.orderServiceChargeDelta));
  }
}

@JsonSerializable(explicitToJson: true)
class OrderDetails {
  OrderDetails({
    this.address,
    this.closingTime,
    this.deliveryDate,
    this.deliveryTimePeriod,
    this.deliveryType,
    required this.isDeliveryInfoLocked,
    this.lastChangedTime,
    required this.orderId,
    this.orderState,
    this.orderTotalPrice,
    this.orderedProducts,
  });

  factory OrderDetails.fromJson(Map<String, dynamic> json) =>
      _$OrderDetailsFromJson(json);

  @JsonKey(name: 'address', includeIfNull: false)
  final Address? address;
  @JsonKey(name: 'closingTime', includeIfNull: false)
  final DateTime? closingTime;
  @JsonKey(name: 'deliveryDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? deliveryDate;
  @JsonKey(name: 'deliveryTimePeriod', includeIfNull: false)
  final DeliveryTimePeriod? deliveryTimePeriod;
  @JsonKey(
    name: 'deliveryType',
    includeIfNull: false,
    toJson: orderDetailsDeliveryTypeToJson,
    fromJson: orderDetailsDeliveryTypeFromJson,
  )
  final enums.OrderDetailsDeliveryType? deliveryType;
  @JsonKey(name: 'isDeliveryInfoLocked', includeIfNull: false)
  final bool isDeliveryInfoLocked;
  @JsonKey(name: 'lastChangedTime', includeIfNull: false)
  final DateTime? lastChangedTime;
  @JsonKey(name: 'orderId', includeIfNull: false)
  final num orderId;
  @JsonKey(
    name: 'orderState',
    includeIfNull: false,
    toJson: orderDetailsOrderStateToJson,
    fromJson: orderDetailsOrderStateFromJson,
  )
  final enums.OrderDetailsOrderState? orderState;
  @JsonKey(name: 'orderTotalPrice', includeIfNull: false)
  final OrderTotalPrice? orderTotalPrice;
  @JsonKey(
      name: 'orderedProducts',
      includeIfNull: false,
      defaultValue: <OrderedProductCardV7>[])
  final List<OrderedProductCardV7>? orderedProducts;
  static const fromJsonFactory = _$OrderDetailsFromJson;
  static const toJsonFactory = _$OrderDetailsToJson;
  Map<String, dynamic> toJson() => _$OrderDetailsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OrderDetails &&
            (identical(other.address, address) ||
                const DeepCollectionEquality()
                    .equals(other.address, address)) &&
            (identical(other.closingTime, closingTime) ||
                const DeepCollectionEquality()
                    .equals(other.closingTime, closingTime)) &&
            (identical(other.deliveryDate, deliveryDate) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryDate, deliveryDate)) &&
            (identical(other.deliveryTimePeriod, deliveryTimePeriod) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryTimePeriod, deliveryTimePeriod)) &&
            (identical(other.deliveryType, deliveryType) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryType, deliveryType)) &&
            (identical(other.isDeliveryInfoLocked, isDeliveryInfoLocked) ||
                const DeepCollectionEquality().equals(
                    other.isDeliveryInfoLocked, isDeliveryInfoLocked)) &&
            (identical(other.lastChangedTime, lastChangedTime) ||
                const DeepCollectionEquality()
                    .equals(other.lastChangedTime, lastChangedTime)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderState, orderState) ||
                const DeepCollectionEquality()
                    .equals(other.orderState, orderState)) &&
            (identical(other.orderTotalPrice, orderTotalPrice) ||
                const DeepCollectionEquality()
                    .equals(other.orderTotalPrice, orderTotalPrice)) &&
            (identical(other.orderedProducts, orderedProducts) ||
                const DeepCollectionEquality()
                    .equals(other.orderedProducts, orderedProducts)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(address) ^
      const DeepCollectionEquality().hash(closingTime) ^
      const DeepCollectionEquality().hash(deliveryDate) ^
      const DeepCollectionEquality().hash(deliveryTimePeriod) ^
      const DeepCollectionEquality().hash(deliveryType) ^
      const DeepCollectionEquality().hash(isDeliveryInfoLocked) ^
      const DeepCollectionEquality().hash(lastChangedTime) ^
      const DeepCollectionEquality().hash(orderId) ^
      const DeepCollectionEquality().hash(orderState) ^
      const DeepCollectionEquality().hash(orderTotalPrice) ^
      const DeepCollectionEquality().hash(orderedProducts) ^
      runtimeType.hashCode;
}

extension $OrderDetailsExtension on OrderDetails {
  OrderDetails copyWith(
      {Address? address,
      DateTime? closingTime,
      DateTime? deliveryDate,
      DeliveryTimePeriod? deliveryTimePeriod,
      enums.OrderDetailsDeliveryType? deliveryType,
      bool? isDeliveryInfoLocked,
      DateTime? lastChangedTime,
      num? orderId,
      enums.OrderDetailsOrderState? orderState,
      OrderTotalPrice? orderTotalPrice,
      List<OrderedProductCardV7>? orderedProducts}) {
    return OrderDetails(
        address: address ?? this.address,
        closingTime: closingTime ?? this.closingTime,
        deliveryDate: deliveryDate ?? this.deliveryDate,
        deliveryTimePeriod: deliveryTimePeriod ?? this.deliveryTimePeriod,
        deliveryType: deliveryType ?? this.deliveryType,
        isDeliveryInfoLocked: isDeliveryInfoLocked ?? this.isDeliveryInfoLocked,
        lastChangedTime: lastChangedTime ?? this.lastChangedTime,
        orderId: orderId ?? this.orderId,
        orderState: orderState ?? this.orderState,
        orderTotalPrice: orderTotalPrice ?? this.orderTotalPrice,
        orderedProducts: orderedProducts ?? this.orderedProducts);
  }

  OrderDetails copyWithWrapped(
      {Wrapped<Address?>? address,
      Wrapped<DateTime?>? closingTime,
      Wrapped<DateTime?>? deliveryDate,
      Wrapped<DeliveryTimePeriod?>? deliveryTimePeriod,
      Wrapped<enums.OrderDetailsDeliveryType?>? deliveryType,
      Wrapped<bool>? isDeliveryInfoLocked,
      Wrapped<DateTime?>? lastChangedTime,
      Wrapped<num>? orderId,
      Wrapped<enums.OrderDetailsOrderState?>? orderState,
      Wrapped<OrderTotalPrice?>? orderTotalPrice,
      Wrapped<List<OrderedProductCardV7>?>? orderedProducts}) {
    return OrderDetails(
        address: (address != null ? address.value : this.address),
        closingTime:
            (closingTime != null ? closingTime.value : this.closingTime),
        deliveryDate:
            (deliveryDate != null ? deliveryDate.value : this.deliveryDate),
        deliveryTimePeriod: (deliveryTimePeriod != null
            ? deliveryTimePeriod.value
            : this.deliveryTimePeriod),
        deliveryType:
            (deliveryType != null ? deliveryType.value : this.deliveryType),
        isDeliveryInfoLocked: (isDeliveryInfoLocked != null
            ? isDeliveryInfoLocked.value
            : this.isDeliveryInfoLocked),
        lastChangedTime: (lastChangedTime != null
            ? lastChangedTime.value
            : this.lastChangedTime),
        orderId: (orderId != null ? orderId.value : this.orderId),
        orderState: (orderState != null ? orderState.value : this.orderState),
        orderTotalPrice: (orderTotalPrice != null
            ? orderTotalPrice.value
            : this.orderTotalPrice),
        orderedProducts: (orderedProducts != null
            ? orderedProducts.value
            : this.orderedProducts));
  }
}

@JsonSerializable(explicitToJson: true)
class OrderDetailsGroupedByTaxonomy {
  OrderDetailsGroupedByTaxonomy({
    required this.cancellable,
    this.closingTime,
    this.deliveryDate,
    this.deliveryTimePeriod,
    this.deliveryType,
    required this.groupedProductsInTaxonomy,
    this.invoiceId,
    required this.orderId,
    this.orderPayment,
    this.orderState,
  });

  factory OrderDetailsGroupedByTaxonomy.fromJson(Map<String, dynamic> json) =>
      _$OrderDetailsGroupedByTaxonomyFromJson(json);

  @JsonKey(name: 'cancellable', includeIfNull: false)
  final bool cancellable;
  @JsonKey(name: 'closingTime', includeIfNull: false)
  final DateTime? closingTime;
  @JsonKey(name: 'deliveryDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? deliveryDate;
  @JsonKey(name: 'deliveryTimePeriod', includeIfNull: false)
  final DeliveryTimePeriod? deliveryTimePeriod;
  @JsonKey(
    name: 'deliveryType',
    includeIfNull: false,
    toJson: orderDetailsGroupedByTaxonomyDeliveryTypeToJson,
    fromJson: orderDetailsGroupedByTaxonomyDeliveryTypeFromJson,
  )
  final enums.OrderDetailsGroupedByTaxonomyDeliveryType? deliveryType;
  @JsonKey(
      name: 'groupedProductsInTaxonomy',
      includeIfNull: false,
      defaultValue: <GroupedProductsInTaxonomy>[])
  final List<GroupedProductsInTaxonomy> groupedProductsInTaxonomy;
  @JsonKey(name: 'invoiceId', includeIfNull: false, defaultValue: '')
  final String? invoiceId;
  @JsonKey(name: 'orderId', includeIfNull: false)
  final num orderId;
  @JsonKey(name: 'orderPayment', includeIfNull: false)
  final OrderPayment? orderPayment;
  @JsonKey(
    name: 'orderState',
    includeIfNull: false,
    toJson: orderDetailsGroupedByTaxonomyOrderStateToJson,
    fromJson: orderDetailsGroupedByTaxonomyOrderStateFromJson,
  )
  final enums.OrderDetailsGroupedByTaxonomyOrderState? orderState;
  static const fromJsonFactory = _$OrderDetailsGroupedByTaxonomyFromJson;
  static const toJsonFactory = _$OrderDetailsGroupedByTaxonomyToJson;
  Map<String, dynamic> toJson() => _$OrderDetailsGroupedByTaxonomyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OrderDetailsGroupedByTaxonomy &&
            (identical(other.cancellable, cancellable) ||
                const DeepCollectionEquality()
                    .equals(other.cancellable, cancellable)) &&
            (identical(other.closingTime, closingTime) ||
                const DeepCollectionEquality()
                    .equals(other.closingTime, closingTime)) &&
            (identical(other.deliveryDate, deliveryDate) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryDate, deliveryDate)) &&
            (identical(other.deliveryTimePeriod, deliveryTimePeriod) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryTimePeriod, deliveryTimePeriod)) &&
            (identical(other.deliveryType, deliveryType) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryType, deliveryType)) &&
            (identical(other.groupedProductsInTaxonomy,
                    groupedProductsInTaxonomy) ||
                const DeepCollectionEquality().equals(
                    other.groupedProductsInTaxonomy,
                    groupedProductsInTaxonomy)) &&
            (identical(other.invoiceId, invoiceId) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceId, invoiceId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderPayment, orderPayment) ||
                const DeepCollectionEquality()
                    .equals(other.orderPayment, orderPayment)) &&
            (identical(other.orderState, orderState) ||
                const DeepCollectionEquality()
                    .equals(other.orderState, orderState)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(cancellable) ^
      const DeepCollectionEquality().hash(closingTime) ^
      const DeepCollectionEquality().hash(deliveryDate) ^
      const DeepCollectionEquality().hash(deliveryTimePeriod) ^
      const DeepCollectionEquality().hash(deliveryType) ^
      const DeepCollectionEquality().hash(groupedProductsInTaxonomy) ^
      const DeepCollectionEquality().hash(invoiceId) ^
      const DeepCollectionEquality().hash(orderId) ^
      const DeepCollectionEquality().hash(orderPayment) ^
      const DeepCollectionEquality().hash(orderState) ^
      runtimeType.hashCode;
}

extension $OrderDetailsGroupedByTaxonomyExtension
    on OrderDetailsGroupedByTaxonomy {
  OrderDetailsGroupedByTaxonomy copyWith(
      {bool? cancellable,
      DateTime? closingTime,
      DateTime? deliveryDate,
      DeliveryTimePeriod? deliveryTimePeriod,
      enums.OrderDetailsGroupedByTaxonomyDeliveryType? deliveryType,
      List<GroupedProductsInTaxonomy>? groupedProductsInTaxonomy,
      String? invoiceId,
      num? orderId,
      OrderPayment? orderPayment,
      enums.OrderDetailsGroupedByTaxonomyOrderState? orderState}) {
    return OrderDetailsGroupedByTaxonomy(
        cancellable: cancellable ?? this.cancellable,
        closingTime: closingTime ?? this.closingTime,
        deliveryDate: deliveryDate ?? this.deliveryDate,
        deliveryTimePeriod: deliveryTimePeriod ?? this.deliveryTimePeriod,
        deliveryType: deliveryType ?? this.deliveryType,
        groupedProductsInTaxonomy:
            groupedProductsInTaxonomy ?? this.groupedProductsInTaxonomy,
        invoiceId: invoiceId ?? this.invoiceId,
        orderId: orderId ?? this.orderId,
        orderPayment: orderPayment ?? this.orderPayment,
        orderState: orderState ?? this.orderState);
  }

  OrderDetailsGroupedByTaxonomy copyWithWrapped(
      {Wrapped<bool>? cancellable,
      Wrapped<DateTime?>? closingTime,
      Wrapped<DateTime?>? deliveryDate,
      Wrapped<DeliveryTimePeriod?>? deliveryTimePeriod,
      Wrapped<enums.OrderDetailsGroupedByTaxonomyDeliveryType?>? deliveryType,
      Wrapped<List<GroupedProductsInTaxonomy>>? groupedProductsInTaxonomy,
      Wrapped<String?>? invoiceId,
      Wrapped<num>? orderId,
      Wrapped<OrderPayment?>? orderPayment,
      Wrapped<enums.OrderDetailsGroupedByTaxonomyOrderState?>? orderState}) {
    return OrderDetailsGroupedByTaxonomy(
        cancellable:
            (cancellable != null ? cancellable.value : this.cancellable),
        closingTime:
            (closingTime != null ? closingTime.value : this.closingTime),
        deliveryDate:
            (deliveryDate != null ? deliveryDate.value : this.deliveryDate),
        deliveryTimePeriod: (deliveryTimePeriod != null
            ? deliveryTimePeriod.value
            : this.deliveryTimePeriod),
        deliveryType:
            (deliveryType != null ? deliveryType.value : this.deliveryType),
        groupedProductsInTaxonomy: (groupedProductsInTaxonomy != null
            ? groupedProductsInTaxonomy.value
            : this.groupedProductsInTaxonomy),
        invoiceId: (invoiceId != null ? invoiceId.value : this.invoiceId),
        orderId: (orderId != null ? orderId.value : this.orderId),
        orderPayment:
            (orderPayment != null ? orderPayment.value : this.orderPayment),
        orderState: (orderState != null ? orderState.value : this.orderState));
  }
}

@JsonSerializable(explicitToJson: true)
class OrderDetailsV7 {
  OrderDetailsV7({
    this.address,
    this.closingTime,
    this.deliveryDate,
    this.deliveryShiftCode,
    this.deliveryTimePeriod,
    this.deliveryType,
    required this.isDeliveryInfoLocked,
    required this.orderId,
    this.orderState,
    this.orderTotalPrice,
    this.orderedProducts,
    required this.syncTimes,
  });

  factory OrderDetailsV7.fromJson(Map<String, dynamic> json) =>
      _$OrderDetailsV7FromJson(json);

  @JsonKey(name: 'address', includeIfNull: false)
  final Address? address;
  @JsonKey(name: 'closingTime', includeIfNull: false)
  final DateTime? closingTime;
  @JsonKey(name: 'deliveryDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? deliveryDate;
  @JsonKey(name: 'deliveryShiftCode', includeIfNull: false, defaultValue: '')
  final String? deliveryShiftCode;
  @JsonKey(name: 'deliveryTimePeriod', includeIfNull: false)
  final DeliveryTimePeriod? deliveryTimePeriod;
  @JsonKey(
    name: 'deliveryType',
    includeIfNull: false,
    toJson: orderDetailsV7DeliveryTypeToJson,
    fromJson: orderDetailsV7DeliveryTypeFromJson,
  )
  final enums.OrderDetailsV7DeliveryType? deliveryType;
  @JsonKey(name: 'isDeliveryInfoLocked', includeIfNull: false)
  final bool isDeliveryInfoLocked;
  @JsonKey(name: 'orderId', includeIfNull: false)
  final num orderId;
  @JsonKey(
    name: 'orderState',
    includeIfNull: false,
    toJson: orderDetailsV7OrderStateToJson,
    fromJson: orderDetailsV7OrderStateFromJson,
  )
  final enums.OrderDetailsV7OrderState? orderState;
  @JsonKey(name: 'orderTotalPrice', includeIfNull: false)
  final OrderTotalPrice? orderTotalPrice;
  @JsonKey(
      name: 'orderedProducts',
      includeIfNull: false,
      defaultValue: <OrderedProductCardV7>[])
  final List<OrderedProductCardV7>? orderedProducts;
  @JsonKey(name: 'syncTimes', includeIfNull: false)
  final SyncTimesV7 syncTimes;
  static const fromJsonFactory = _$OrderDetailsV7FromJson;
  static const toJsonFactory = _$OrderDetailsV7ToJson;
  Map<String, dynamic> toJson() => _$OrderDetailsV7ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OrderDetailsV7 &&
            (identical(other.address, address) ||
                const DeepCollectionEquality()
                    .equals(other.address, address)) &&
            (identical(other.closingTime, closingTime) ||
                const DeepCollectionEquality()
                    .equals(other.closingTime, closingTime)) &&
            (identical(other.deliveryDate, deliveryDate) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryDate, deliveryDate)) &&
            (identical(other.deliveryShiftCode, deliveryShiftCode) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryShiftCode, deliveryShiftCode)) &&
            (identical(other.deliveryTimePeriod, deliveryTimePeriod) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryTimePeriod, deliveryTimePeriod)) &&
            (identical(other.deliveryType, deliveryType) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryType, deliveryType)) &&
            (identical(other.isDeliveryInfoLocked, isDeliveryInfoLocked) ||
                const DeepCollectionEquality().equals(
                    other.isDeliveryInfoLocked, isDeliveryInfoLocked)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderState, orderState) ||
                const DeepCollectionEquality()
                    .equals(other.orderState, orderState)) &&
            (identical(other.orderTotalPrice, orderTotalPrice) ||
                const DeepCollectionEquality()
                    .equals(other.orderTotalPrice, orderTotalPrice)) &&
            (identical(other.orderedProducts, orderedProducts) ||
                const DeepCollectionEquality()
                    .equals(other.orderedProducts, orderedProducts)) &&
            (identical(other.syncTimes, syncTimes) ||
                const DeepCollectionEquality()
                    .equals(other.syncTimes, syncTimes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(address) ^
      const DeepCollectionEquality().hash(closingTime) ^
      const DeepCollectionEquality().hash(deliveryDate) ^
      const DeepCollectionEquality().hash(deliveryShiftCode) ^
      const DeepCollectionEquality().hash(deliveryTimePeriod) ^
      const DeepCollectionEquality().hash(deliveryType) ^
      const DeepCollectionEquality().hash(isDeliveryInfoLocked) ^
      const DeepCollectionEquality().hash(orderId) ^
      const DeepCollectionEquality().hash(orderState) ^
      const DeepCollectionEquality().hash(orderTotalPrice) ^
      const DeepCollectionEquality().hash(orderedProducts) ^
      const DeepCollectionEquality().hash(syncTimes) ^
      runtimeType.hashCode;
}

extension $OrderDetailsV7Extension on OrderDetailsV7 {
  OrderDetailsV7 copyWith(
      {Address? address,
      DateTime? closingTime,
      DateTime? deliveryDate,
      String? deliveryShiftCode,
      DeliveryTimePeriod? deliveryTimePeriod,
      enums.OrderDetailsV7DeliveryType? deliveryType,
      bool? isDeliveryInfoLocked,
      num? orderId,
      enums.OrderDetailsV7OrderState? orderState,
      OrderTotalPrice? orderTotalPrice,
      List<OrderedProductCardV7>? orderedProducts,
      SyncTimesV7? syncTimes}) {
    return OrderDetailsV7(
        address: address ?? this.address,
        closingTime: closingTime ?? this.closingTime,
        deliveryDate: deliveryDate ?? this.deliveryDate,
        deliveryShiftCode: deliveryShiftCode ?? this.deliveryShiftCode,
        deliveryTimePeriod: deliveryTimePeriod ?? this.deliveryTimePeriod,
        deliveryType: deliveryType ?? this.deliveryType,
        isDeliveryInfoLocked: isDeliveryInfoLocked ?? this.isDeliveryInfoLocked,
        orderId: orderId ?? this.orderId,
        orderState: orderState ?? this.orderState,
        orderTotalPrice: orderTotalPrice ?? this.orderTotalPrice,
        orderedProducts: orderedProducts ?? this.orderedProducts,
        syncTimes: syncTimes ?? this.syncTimes);
  }

  OrderDetailsV7 copyWithWrapped(
      {Wrapped<Address?>? address,
      Wrapped<DateTime?>? closingTime,
      Wrapped<DateTime?>? deliveryDate,
      Wrapped<String?>? deliveryShiftCode,
      Wrapped<DeliveryTimePeriod?>? deliveryTimePeriod,
      Wrapped<enums.OrderDetailsV7DeliveryType?>? deliveryType,
      Wrapped<bool>? isDeliveryInfoLocked,
      Wrapped<num>? orderId,
      Wrapped<enums.OrderDetailsV7OrderState?>? orderState,
      Wrapped<OrderTotalPrice?>? orderTotalPrice,
      Wrapped<List<OrderedProductCardV7>?>? orderedProducts,
      Wrapped<SyncTimesV7>? syncTimes}) {
    return OrderDetailsV7(
        address: (address != null ? address.value : this.address),
        closingTime:
            (closingTime != null ? closingTime.value : this.closingTime),
        deliveryDate:
            (deliveryDate != null ? deliveryDate.value : this.deliveryDate),
        deliveryShiftCode: (deliveryShiftCode != null
            ? deliveryShiftCode.value
            : this.deliveryShiftCode),
        deliveryTimePeriod: (deliveryTimePeriod != null
            ? deliveryTimePeriod.value
            : this.deliveryTimePeriod),
        deliveryType:
            (deliveryType != null ? deliveryType.value : this.deliveryType),
        isDeliveryInfoLocked: (isDeliveryInfoLocked != null
            ? isDeliveryInfoLocked.value
            : this.isDeliveryInfoLocked),
        orderId: (orderId != null ? orderId.value : this.orderId),
        orderState: (orderState != null ? orderState.value : this.orderState),
        orderTotalPrice: (orderTotalPrice != null
            ? orderTotalPrice.value
            : this.orderTotalPrice),
        orderedProducts: (orderedProducts != null
            ? orderedProducts.value
            : this.orderedProducts),
        syncTimes: (syncTimes != null ? syncTimes.value : this.syncTimes));
  }
}

@JsonSerializable(explicitToJson: true)
class OrderLine {
  OrderLine({
    this.allocatedQuantity,
    required this.catalogCode,
    this.closedTime,
    this.creationTime,
    this.originCode,
    required this.position,
    this.product,
    required this.productCount,
    required this.productId,
    required this.quantity,
    required this.sample,
  });

  factory OrderLine.fromJson(Map<String, dynamic> json) =>
      _$OrderLineFromJson(json);

  @JsonKey(name: 'allocatedQuantity', includeIfNull: false)
  final int? allocatedQuantity;
  @JsonKey(name: 'catalogCode', includeIfNull: false, defaultValue: '')
  final String catalogCode;
  @JsonKey(name: 'closedTime', includeIfNull: false)
  final DateTime? closedTime;
  @JsonKey(name: 'creationTime', includeIfNull: false)
  final num? creationTime;
  @JsonKey(name: 'originCode', includeIfNull: false, defaultValue: '')
  final String? originCode;
  @JsonKey(name: 'position', includeIfNull: false)
  final int position;
  @JsonKey(name: 'product', includeIfNull: false)
  final ProductCard? product;
  @JsonKey(name: 'productCount', includeIfNull: false)
  final int productCount;
  @JsonKey(name: 'productId', includeIfNull: false)
  final num productId;
  @JsonKey(name: 'quantity', includeIfNull: false)
  final int quantity;
  @JsonKey(name: 'sample', includeIfNull: false)
  final bool sample;
  static const fromJsonFactory = _$OrderLineFromJson;
  static const toJsonFactory = _$OrderLineToJson;
  Map<String, dynamic> toJson() => _$OrderLineToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OrderLine &&
            (identical(other.allocatedQuantity, allocatedQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.allocatedQuantity, allocatedQuantity)) &&
            (identical(other.catalogCode, catalogCode) ||
                const DeepCollectionEquality()
                    .equals(other.catalogCode, catalogCode)) &&
            (identical(other.closedTime, closedTime) ||
                const DeepCollectionEquality()
                    .equals(other.closedTime, closedTime)) &&
            (identical(other.creationTime, creationTime) ||
                const DeepCollectionEquality()
                    .equals(other.creationTime, creationTime)) &&
            (identical(other.originCode, originCode) ||
                const DeepCollectionEquality()
                    .equals(other.originCode, originCode)) &&
            (identical(other.position, position) ||
                const DeepCollectionEquality()
                    .equals(other.position, position)) &&
            (identical(other.product, product) ||
                const DeepCollectionEquality()
                    .equals(other.product, product)) &&
            (identical(other.productCount, productCount) ||
                const DeepCollectionEquality()
                    .equals(other.productCount, productCount)) &&
            (identical(other.productId, productId) ||
                const DeepCollectionEquality()
                    .equals(other.productId, productId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.sample, sample) ||
                const DeepCollectionEquality().equals(other.sample, sample)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(allocatedQuantity) ^
      const DeepCollectionEquality().hash(catalogCode) ^
      const DeepCollectionEquality().hash(closedTime) ^
      const DeepCollectionEquality().hash(creationTime) ^
      const DeepCollectionEquality().hash(originCode) ^
      const DeepCollectionEquality().hash(position) ^
      const DeepCollectionEquality().hash(product) ^
      const DeepCollectionEquality().hash(productCount) ^
      const DeepCollectionEquality().hash(productId) ^
      const DeepCollectionEquality().hash(quantity) ^
      const DeepCollectionEquality().hash(sample) ^
      runtimeType.hashCode;
}

extension $OrderLineExtension on OrderLine {
  OrderLine copyWith(
      {int? allocatedQuantity,
      String? catalogCode,
      DateTime? closedTime,
      num? creationTime,
      String? originCode,
      int? position,
      ProductCard? product,
      int? productCount,
      num? productId,
      int? quantity,
      bool? sample}) {
    return OrderLine(
        allocatedQuantity: allocatedQuantity ?? this.allocatedQuantity,
        catalogCode: catalogCode ?? this.catalogCode,
        closedTime: closedTime ?? this.closedTime,
        creationTime: creationTime ?? this.creationTime,
        originCode: originCode ?? this.originCode,
        position: position ?? this.position,
        product: product ?? this.product,
        productCount: productCount ?? this.productCount,
        productId: productId ?? this.productId,
        quantity: quantity ?? this.quantity,
        sample: sample ?? this.sample);
  }

  OrderLine copyWithWrapped(
      {Wrapped<int?>? allocatedQuantity,
      Wrapped<String>? catalogCode,
      Wrapped<DateTime?>? closedTime,
      Wrapped<num?>? creationTime,
      Wrapped<String?>? originCode,
      Wrapped<int>? position,
      Wrapped<ProductCard?>? product,
      Wrapped<int>? productCount,
      Wrapped<num>? productId,
      Wrapped<int>? quantity,
      Wrapped<bool>? sample}) {
    return OrderLine(
        allocatedQuantity: (allocatedQuantity != null
            ? allocatedQuantity.value
            : this.allocatedQuantity),
        catalogCode:
            (catalogCode != null ? catalogCode.value : this.catalogCode),
        closedTime: (closedTime != null ? closedTime.value : this.closedTime),
        creationTime:
            (creationTime != null ? creationTime.value : this.creationTime),
        originCode: (originCode != null ? originCode.value : this.originCode),
        position: (position != null ? position.value : this.position),
        product: (product != null ? product.value : this.product),
        productCount:
            (productCount != null ? productCount.value : this.productCount),
        productId: (productId != null ? productId.value : this.productId),
        quantity: (quantity != null ? quantity.value : this.quantity),
        sample: (sample != null ? sample.value : this.sample));
  }
}

@JsonSerializable(explicitToJson: true)
class OrderLinesChanges {
  OrderLinesChanges({
    this.orderDelta,
    this.orderId,
    this.totalCurrentSalesPrice,
    this.totalItemsAllocated,
    this.totalItemsOrdered,
    this.unitPrice,
    this.webshopId,
  });

  factory OrderLinesChanges.fromJson(Map<String, dynamic> json) =>
      _$OrderLinesChangesFromJson(json);

  @JsonKey(name: 'orderDelta', includeIfNull: false)
  final int? orderDelta;
  @JsonKey(name: 'orderId', includeIfNull: false)
  final num? orderId;
  @JsonKey(name: 'totalCurrentSalesPrice', includeIfNull: false)
  final double? totalCurrentSalesPrice;
  @JsonKey(name: 'totalItemsAllocated', includeIfNull: false)
  final int? totalItemsAllocated;
  @JsonKey(name: 'totalItemsOrdered', includeIfNull: false)
  final int? totalItemsOrdered;
  @JsonKey(name: 'unitPrice', includeIfNull: false)
  final double? unitPrice;
  @JsonKey(name: 'webshopId', includeIfNull: false)
  final num? webshopId;
  static const fromJsonFactory = _$OrderLinesChangesFromJson;
  static const toJsonFactory = _$OrderLinesChangesToJson;
  Map<String, dynamic> toJson() => _$OrderLinesChangesToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OrderLinesChanges &&
            (identical(other.orderDelta, orderDelta) ||
                const DeepCollectionEquality()
                    .equals(other.orderDelta, orderDelta)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.totalCurrentSalesPrice, totalCurrentSalesPrice) ||
                const DeepCollectionEquality().equals(
                    other.totalCurrentSalesPrice, totalCurrentSalesPrice)) &&
            (identical(other.totalItemsAllocated, totalItemsAllocated) ||
                const DeepCollectionEquality()
                    .equals(other.totalItemsAllocated, totalItemsAllocated)) &&
            (identical(other.totalItemsOrdered, totalItemsOrdered) ||
                const DeepCollectionEquality()
                    .equals(other.totalItemsOrdered, totalItemsOrdered)) &&
            (identical(other.unitPrice, unitPrice) ||
                const DeepCollectionEquality()
                    .equals(other.unitPrice, unitPrice)) &&
            (identical(other.webshopId, webshopId) ||
                const DeepCollectionEquality()
                    .equals(other.webshopId, webshopId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(orderDelta) ^
      const DeepCollectionEquality().hash(orderId) ^
      const DeepCollectionEquality().hash(totalCurrentSalesPrice) ^
      const DeepCollectionEquality().hash(totalItemsAllocated) ^
      const DeepCollectionEquality().hash(totalItemsOrdered) ^
      const DeepCollectionEquality().hash(unitPrice) ^
      const DeepCollectionEquality().hash(webshopId) ^
      runtimeType.hashCode;
}

extension $OrderLinesChangesExtension on OrderLinesChanges {
  OrderLinesChanges copyWith(
      {int? orderDelta,
      num? orderId,
      double? totalCurrentSalesPrice,
      int? totalItemsAllocated,
      int? totalItemsOrdered,
      double? unitPrice,
      num? webshopId}) {
    return OrderLinesChanges(
        orderDelta: orderDelta ?? this.orderDelta,
        orderId: orderId ?? this.orderId,
        totalCurrentSalesPrice:
            totalCurrentSalesPrice ?? this.totalCurrentSalesPrice,
        totalItemsAllocated: totalItemsAllocated ?? this.totalItemsAllocated,
        totalItemsOrdered: totalItemsOrdered ?? this.totalItemsOrdered,
        unitPrice: unitPrice ?? this.unitPrice,
        webshopId: webshopId ?? this.webshopId);
  }

  OrderLinesChanges copyWithWrapped(
      {Wrapped<int?>? orderDelta,
      Wrapped<num?>? orderId,
      Wrapped<double?>? totalCurrentSalesPrice,
      Wrapped<int?>? totalItemsAllocated,
      Wrapped<int?>? totalItemsOrdered,
      Wrapped<double?>? unitPrice,
      Wrapped<num?>? webshopId}) {
    return OrderLinesChanges(
        orderDelta: (orderDelta != null ? orderDelta.value : this.orderDelta),
        orderId: (orderId != null ? orderId.value : this.orderId),
        totalCurrentSalesPrice: (totalCurrentSalesPrice != null
            ? totalCurrentSalesPrice.value
            : this.totalCurrentSalesPrice),
        totalItemsAllocated: (totalItemsAllocated != null
            ? totalItemsAllocated.value
            : this.totalItemsAllocated),
        totalItemsOrdered: (totalItemsOrdered != null
            ? totalItemsOrdered.value
            : this.totalItemsOrdered),
        unitPrice: (unitPrice != null ? unitPrice.value : this.unitPrice),
        webshopId: (webshopId != null ? webshopId.value : this.webshopId));
  }
}

@JsonSerializable(explicitToJson: true)
class OrderPayment {
  OrderPayment({
    this.amount,
    required this.method,
    required this.status,
  });

  factory OrderPayment.fromJson(Map<String, dynamic> json) =>
      _$OrderPaymentFromJson(json);

  @JsonKey(name: 'amount', includeIfNull: false)
  final Amount? amount;
  @JsonKey(name: 'method', includeIfNull: false, defaultValue: '')
  final String method;
  @JsonKey(name: 'status', includeIfNull: false, defaultValue: '')
  final String status;
  static const fromJsonFactory = _$OrderPaymentFromJson;
  static const toJsonFactory = _$OrderPaymentToJson;
  Map<String, dynamic> toJson() => _$OrderPaymentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OrderPayment &&
            (identical(other.amount, amount) ||
                const DeepCollectionEquality().equals(other.amount, amount)) &&
            (identical(other.method, method) ||
                const DeepCollectionEquality().equals(other.method, method)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(amount) ^
      const DeepCollectionEquality().hash(method) ^
      const DeepCollectionEquality().hash(status) ^
      runtimeType.hashCode;
}

extension $OrderPaymentExtension on OrderPayment {
  OrderPayment copyWith({Amount? amount, String? method, String? status}) {
    return OrderPayment(
        amount: amount ?? this.amount,
        method: method ?? this.method,
        status: status ?? this.status);
  }

  OrderPayment copyWithWrapped(
      {Wrapped<Amount?>? amount,
      Wrapped<String>? method,
      Wrapped<String>? status}) {
    return OrderPayment(
        amount: (amount != null ? amount.value : this.amount),
        method: (method != null ? method.value : this.method),
        status: (status != null ? status.value : this.status));
  }
}

@JsonSerializable(explicitToJson: true)
class OrderReceiptDiscount {
  OrderReceiptDiscount({
    required this.discount,
    required this.title,
  });

  factory OrderReceiptDiscount.fromJson(Map<String, dynamic> json) =>
      _$OrderReceiptDiscountFromJson(json);

  @JsonKey(name: 'discount', includeIfNull: false)
  final double discount;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  static const fromJsonFactory = _$OrderReceiptDiscountFromJson;
  static const toJsonFactory = _$OrderReceiptDiscountToJson;
  Map<String, dynamic> toJson() => _$OrderReceiptDiscountToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OrderReceiptDiscount &&
            (identical(other.discount, discount) ||
                const DeepCollectionEquality()
                    .equals(other.discount, discount)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(discount) ^
      const DeepCollectionEquality().hash(title) ^
      runtimeType.hashCode;
}

extension $OrderReceiptDiscountExtension on OrderReceiptDiscount {
  OrderReceiptDiscount copyWith({double? discount, String? title}) {
    return OrderReceiptDiscount(
        discount: discount ?? this.discount, title: title ?? this.title);
  }

  OrderReceiptDiscount copyWithWrapped(
      {Wrapped<double>? discount, Wrapped<String>? title}) {
    return OrderReceiptDiscount(
        discount: (discount != null ? discount.value : this.discount),
        title: (title != null ? title.value : this.title));
  }
}

@JsonSerializable(explicitToJson: true)
class OrderSummary {
  OrderSummary({
    this.closingTime,
    this.deliveryDate,
    this.isReopenable,
    required this.orderId,
    this.orderMethod,
    this.orderTotalPrice,
    this.orderType,
    this.orderedProducts,
    this.orderedProductsTotalAmount,
    this.slotInfo,
    this.state,
    required this.trackTraceInfo,
  });

  factory OrderSummary.fromJson(Map<String, dynamic> json) =>
      _$OrderSummaryFromJson(json);

  @JsonKey(name: 'closingTime', includeIfNull: false)
  final DateTime? closingTime;
  @JsonKey(name: 'deliveryDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? deliveryDate;
  @JsonKey(name: 'isReopenable', includeIfNull: false)
  final bool? isReopenable;
  @JsonKey(name: 'orderId', includeIfNull: false)
  final num orderId;
  @JsonKey(
    name: 'orderMethod',
    includeIfNull: false,
    toJson: orderSummaryOrderMethodToJson,
    fromJson: orderSummaryOrderMethodFromJson,
  )
  final enums.OrderSummaryOrderMethod? orderMethod;
  @JsonKey(name: 'orderTotalPrice', includeIfNull: false)
  final OrderTotalPrice? orderTotalPrice;
  @JsonKey(
    name: 'orderType',
    includeIfNull: false,
    toJson: orderSummaryOrderTypeToJson,
    fromJson: orderSummaryOrderTypeFromJson,
  )
  final enums.OrderSummaryOrderType? orderType;
  @JsonKey(
      name: 'orderedProducts',
      includeIfNull: false,
      defaultValue: <OrderedProductCardV7>[])
  final List<OrderedProductCardV7>? orderedProducts;
  @JsonKey(name: 'orderedProductsTotalAmount', includeIfNull: false)
  final int? orderedProductsTotalAmount;
  @JsonKey(name: 'slotInfo', includeIfNull: false)
  final Slot? slotInfo;
  @JsonKey(
    name: 'state',
    includeIfNull: false,
    toJson: orderSummaryStateToJson,
    fromJson: orderSummaryStateFromJson,
  )
  final enums.OrderSummaryState? state;
  @JsonKey(name: 'trackTraceInfo', includeIfNull: false)
  final DeliveryStateInformation trackTraceInfo;
  static const fromJsonFactory = _$OrderSummaryFromJson;
  static const toJsonFactory = _$OrderSummaryToJson;
  Map<String, dynamic> toJson() => _$OrderSummaryToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OrderSummary &&
            (identical(other.closingTime, closingTime) ||
                const DeepCollectionEquality()
                    .equals(other.closingTime, closingTime)) &&
            (identical(other.deliveryDate, deliveryDate) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryDate, deliveryDate)) &&
            (identical(other.isReopenable, isReopenable) ||
                const DeepCollectionEquality()
                    .equals(other.isReopenable, isReopenable)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderMethod, orderMethod) ||
                const DeepCollectionEquality()
                    .equals(other.orderMethod, orderMethod)) &&
            (identical(other.orderTotalPrice, orderTotalPrice) ||
                const DeepCollectionEquality()
                    .equals(other.orderTotalPrice, orderTotalPrice)) &&
            (identical(other.orderType, orderType) ||
                const DeepCollectionEquality()
                    .equals(other.orderType, orderType)) &&
            (identical(other.orderedProducts, orderedProducts) ||
                const DeepCollectionEquality()
                    .equals(other.orderedProducts, orderedProducts)) &&
            (identical(other.orderedProductsTotalAmount,
                    orderedProductsTotalAmount) ||
                const DeepCollectionEquality().equals(
                    other.orderedProductsTotalAmount,
                    orderedProductsTotalAmount)) &&
            (identical(other.slotInfo, slotInfo) ||
                const DeepCollectionEquality()
                    .equals(other.slotInfo, slotInfo)) &&
            (identical(other.state, state) ||
                const DeepCollectionEquality().equals(other.state, state)) &&
            (identical(other.trackTraceInfo, trackTraceInfo) ||
                const DeepCollectionEquality()
                    .equals(other.trackTraceInfo, trackTraceInfo)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(closingTime) ^
      const DeepCollectionEquality().hash(deliveryDate) ^
      const DeepCollectionEquality().hash(isReopenable) ^
      const DeepCollectionEquality().hash(orderId) ^
      const DeepCollectionEquality().hash(orderMethod) ^
      const DeepCollectionEquality().hash(orderTotalPrice) ^
      const DeepCollectionEquality().hash(orderType) ^
      const DeepCollectionEquality().hash(orderedProducts) ^
      const DeepCollectionEquality().hash(orderedProductsTotalAmount) ^
      const DeepCollectionEquality().hash(slotInfo) ^
      const DeepCollectionEquality().hash(state) ^
      const DeepCollectionEquality().hash(trackTraceInfo) ^
      runtimeType.hashCode;
}

extension $OrderSummaryExtension on OrderSummary {
  OrderSummary copyWith(
      {DateTime? closingTime,
      DateTime? deliveryDate,
      bool? isReopenable,
      num? orderId,
      enums.OrderSummaryOrderMethod? orderMethod,
      OrderTotalPrice? orderTotalPrice,
      enums.OrderSummaryOrderType? orderType,
      List<OrderedProductCardV7>? orderedProducts,
      int? orderedProductsTotalAmount,
      Slot? slotInfo,
      enums.OrderSummaryState? state,
      DeliveryStateInformation? trackTraceInfo}) {
    return OrderSummary(
        closingTime: closingTime ?? this.closingTime,
        deliveryDate: deliveryDate ?? this.deliveryDate,
        isReopenable: isReopenable ?? this.isReopenable,
        orderId: orderId ?? this.orderId,
        orderMethod: orderMethod ?? this.orderMethod,
        orderTotalPrice: orderTotalPrice ?? this.orderTotalPrice,
        orderType: orderType ?? this.orderType,
        orderedProducts: orderedProducts ?? this.orderedProducts,
        orderedProductsTotalAmount:
            orderedProductsTotalAmount ?? this.orderedProductsTotalAmount,
        slotInfo: slotInfo ?? this.slotInfo,
        state: state ?? this.state,
        trackTraceInfo: trackTraceInfo ?? this.trackTraceInfo);
  }

  OrderSummary copyWithWrapped(
      {Wrapped<DateTime?>? closingTime,
      Wrapped<DateTime?>? deliveryDate,
      Wrapped<bool?>? isReopenable,
      Wrapped<num>? orderId,
      Wrapped<enums.OrderSummaryOrderMethod?>? orderMethod,
      Wrapped<OrderTotalPrice?>? orderTotalPrice,
      Wrapped<enums.OrderSummaryOrderType?>? orderType,
      Wrapped<List<OrderedProductCardV7>?>? orderedProducts,
      Wrapped<int?>? orderedProductsTotalAmount,
      Wrapped<Slot?>? slotInfo,
      Wrapped<enums.OrderSummaryState?>? state,
      Wrapped<DeliveryStateInformation>? trackTraceInfo}) {
    return OrderSummary(
        closingTime:
            (closingTime != null ? closingTime.value : this.closingTime),
        deliveryDate:
            (deliveryDate != null ? deliveryDate.value : this.deliveryDate),
        isReopenable:
            (isReopenable != null ? isReopenable.value : this.isReopenable),
        orderId: (orderId != null ? orderId.value : this.orderId),
        orderMethod:
            (orderMethod != null ? orderMethod.value : this.orderMethod),
        orderTotalPrice: (orderTotalPrice != null
            ? orderTotalPrice.value
            : this.orderTotalPrice),
        orderType: (orderType != null ? orderType.value : this.orderType),
        orderedProducts: (orderedProducts != null
            ? orderedProducts.value
            : this.orderedProducts),
        orderedProductsTotalAmount: (orderedProductsTotalAmount != null
            ? orderedProductsTotalAmount.value
            : this.orderedProductsTotalAmount),
        slotInfo: (slotInfo != null ? slotInfo.value : this.slotInfo),
        state: (state != null ? state.value : this.state),
        trackTraceInfo: (trackTraceInfo != null
            ? trackTraceInfo.value
            : this.trackTraceInfo));
  }
}

@JsonSerializable(explicitToJson: true)
class OrderSyncTimesV7 {
  OrderSyncTimesV7({
    required this.lastChange,
    required this.lastUserChange,
  });

  factory OrderSyncTimesV7.fromJson(Map<String, dynamic> json) =>
      _$OrderSyncTimesV7FromJson(json);

  @JsonKey(name: 'lastChange', includeIfNull: false)
  final DateTime lastChange;
  @JsonKey(name: 'lastUserChange', includeIfNull: false)
  final DateTime lastUserChange;
  static const fromJsonFactory = _$OrderSyncTimesV7FromJson;
  static const toJsonFactory = _$OrderSyncTimesV7ToJson;
  Map<String, dynamic> toJson() => _$OrderSyncTimesV7ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OrderSyncTimesV7 &&
            (identical(other.lastChange, lastChange) ||
                const DeepCollectionEquality()
                    .equals(other.lastChange, lastChange)) &&
            (identical(other.lastUserChange, lastUserChange) ||
                const DeepCollectionEquality()
                    .equals(other.lastUserChange, lastUserChange)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(lastChange) ^
      const DeepCollectionEquality().hash(lastUserChange) ^
      runtimeType.hashCode;
}

extension $OrderSyncTimesV7Extension on OrderSyncTimesV7 {
  OrderSyncTimesV7 copyWith({DateTime? lastChange, DateTime? lastUserChange}) {
    return OrderSyncTimesV7(
        lastChange: lastChange ?? this.lastChange,
        lastUserChange: lastUserChange ?? this.lastUserChange);
  }

  OrderSyncTimesV7 copyWithWrapped(
      {Wrapped<DateTime>? lastChange, Wrapped<DateTime>? lastUserChange}) {
    return OrderSyncTimesV7(
        lastChange: (lastChange != null ? lastChange.value : this.lastChange),
        lastUserChange: (lastUserChange != null
            ? lastUserChange.value
            : this.lastUserChange));
  }
}

@JsonSerializable(explicitToJson: true)
class OrderTotalPrice {
  OrderTotalPrice({
    this.priceAfterDiscount,
    this.priceBeforeDiscount,
    this.priceDiscount,
    this.priceTotalPayable,
  });

  factory OrderTotalPrice.fromJson(Map<String, dynamic> json) =>
      _$OrderTotalPriceFromJson(json);

  @JsonKey(name: 'priceAfterDiscount', includeIfNull: false)
  final double? priceAfterDiscount;
  @JsonKey(name: 'priceBeforeDiscount', includeIfNull: false)
  final double? priceBeforeDiscount;
  @JsonKey(name: 'priceDiscount', includeIfNull: false)
  final double? priceDiscount;
  @JsonKey(name: 'priceTotalPayable', includeIfNull: false)
  final double? priceTotalPayable;
  static const fromJsonFactory = _$OrderTotalPriceFromJson;
  static const toJsonFactory = _$OrderTotalPriceToJson;
  Map<String, dynamic> toJson() => _$OrderTotalPriceToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OrderTotalPrice &&
            (identical(other.priceAfterDiscount, priceAfterDiscount) ||
                const DeepCollectionEquality()
                    .equals(other.priceAfterDiscount, priceAfterDiscount)) &&
            (identical(other.priceBeforeDiscount, priceBeforeDiscount) ||
                const DeepCollectionEquality()
                    .equals(other.priceBeforeDiscount, priceBeforeDiscount)) &&
            (identical(other.priceDiscount, priceDiscount) ||
                const DeepCollectionEquality()
                    .equals(other.priceDiscount, priceDiscount)) &&
            (identical(other.priceTotalPayable, priceTotalPayable) ||
                const DeepCollectionEquality()
                    .equals(other.priceTotalPayable, priceTotalPayable)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(priceAfterDiscount) ^
      const DeepCollectionEquality().hash(priceBeforeDiscount) ^
      const DeepCollectionEquality().hash(priceDiscount) ^
      const DeepCollectionEquality().hash(priceTotalPayable) ^
      runtimeType.hashCode;
}

extension $OrderTotalPriceExtension on OrderTotalPrice {
  OrderTotalPrice copyWith(
      {double? priceAfterDiscount,
      double? priceBeforeDiscount,
      double? priceDiscount,
      double? priceTotalPayable}) {
    return OrderTotalPrice(
        priceAfterDiscount: priceAfterDiscount ?? this.priceAfterDiscount,
        priceBeforeDiscount: priceBeforeDiscount ?? this.priceBeforeDiscount,
        priceDiscount: priceDiscount ?? this.priceDiscount,
        priceTotalPayable: priceTotalPayable ?? this.priceTotalPayable);
  }

  OrderTotalPrice copyWithWrapped(
      {Wrapped<double?>? priceAfterDiscount,
      Wrapped<double?>? priceBeforeDiscount,
      Wrapped<double?>? priceDiscount,
      Wrapped<double?>? priceTotalPayable}) {
    return OrderTotalPrice(
        priceAfterDiscount: (priceAfterDiscount != null
            ? priceAfterDiscount.value
            : this.priceAfterDiscount),
        priceBeforeDiscount: (priceBeforeDiscount != null
            ? priceBeforeDiscount.value
            : this.priceBeforeDiscount),
        priceDiscount:
            (priceDiscount != null ? priceDiscount.value : this.priceDiscount),
        priceTotalPayable: (priceTotalPayable != null
            ? priceTotalPayable.value
            : this.priceTotalPayable));
  }
}

@JsonSerializable(explicitToJson: true)
class OrderValidation {
  OrderValidation({
    this.code,
    this.detail,
    this.validationData,
  });

  factory OrderValidation.fromJson(Map<String, dynamic> json) =>
      _$OrderValidationFromJson(json);

  @JsonKey(name: 'code', includeIfNull: false, defaultValue: '')
  final String? code;
  @JsonKey(name: 'detail', includeIfNull: false, defaultValue: '')
  final String? detail;
  @JsonKey(
      name: 'validationData',
      includeIfNull: false,
      defaultValue: <ValidationData>[])
  final List<ValidationData>? validationData;
  static const fromJsonFactory = _$OrderValidationFromJson;
  static const toJsonFactory = _$OrderValidationToJson;
  Map<String, dynamic> toJson() => _$OrderValidationToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OrderValidation &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.detail, detail) ||
                const DeepCollectionEquality().equals(other.detail, detail)) &&
            (identical(other.validationData, validationData) ||
                const DeepCollectionEquality()
                    .equals(other.validationData, validationData)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(code) ^
      const DeepCollectionEquality().hash(detail) ^
      const DeepCollectionEquality().hash(validationData) ^
      runtimeType.hashCode;
}

extension $OrderValidationExtension on OrderValidation {
  OrderValidation copyWith(
      {String? code, String? detail, List<ValidationData>? validationData}) {
    return OrderValidation(
        code: code ?? this.code,
        detail: detail ?? this.detail,
        validationData: validationData ?? this.validationData);
  }

  OrderValidation copyWithWrapped(
      {Wrapped<String?>? code,
      Wrapped<String?>? detail,
      Wrapped<List<ValidationData>?>? validationData}) {
    return OrderValidation(
        code: (code != null ? code.value : this.code),
        detail: (detail != null ? detail.value : this.detail),
        validationData: (validationData != null
            ? validationData.value
            : this.validationData));
  }
}

@JsonSerializable(explicitToJson: true)
class OrderedProductCardV7 {
  OrderedProductCardV7({
    this.allocatedQuantity,
    this.amount,
    this.position,
    this.product,
  });

  factory OrderedProductCardV7.fromJson(Map<String, dynamic> json) =>
      _$OrderedProductCardV7FromJson(json);

  @JsonKey(name: 'allocatedQuantity', includeIfNull: false)
  final int? allocatedQuantity;
  @JsonKey(name: 'amount', includeIfNull: false)
  final int? amount;
  @JsonKey(name: 'position', includeIfNull: false)
  final int? position;
  @JsonKey(name: 'product', includeIfNull: false)
  final ProductCard? product;
  static const fromJsonFactory = _$OrderedProductCardV7FromJson;
  static const toJsonFactory = _$OrderedProductCardV7ToJson;
  Map<String, dynamic> toJson() => _$OrderedProductCardV7ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OrderedProductCardV7 &&
            (identical(other.allocatedQuantity, allocatedQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.allocatedQuantity, allocatedQuantity)) &&
            (identical(other.amount, amount) ||
                const DeepCollectionEquality().equals(other.amount, amount)) &&
            (identical(other.position, position) ||
                const DeepCollectionEquality()
                    .equals(other.position, position)) &&
            (identical(other.product, product) ||
                const DeepCollectionEquality().equals(other.product, product)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(allocatedQuantity) ^
      const DeepCollectionEquality().hash(amount) ^
      const DeepCollectionEquality().hash(position) ^
      const DeepCollectionEquality().hash(product) ^
      runtimeType.hashCode;
}

extension $OrderedProductCardV7Extension on OrderedProductCardV7 {
  OrderedProductCardV7 copyWith(
      {int? allocatedQuantity,
      int? amount,
      int? position,
      ProductCard? product}) {
    return OrderedProductCardV7(
        allocatedQuantity: allocatedQuantity ?? this.allocatedQuantity,
        amount: amount ?? this.amount,
        position: position ?? this.position,
        product: product ?? this.product);
  }

  OrderedProductCardV7 copyWithWrapped(
      {Wrapped<int?>? allocatedQuantity,
      Wrapped<int?>? amount,
      Wrapped<int?>? position,
      Wrapped<ProductCard?>? product}) {
    return OrderedProductCardV7(
        allocatedQuantity: (allocatedQuantity != null
            ? allocatedQuantity.value
            : this.allocatedQuantity),
        amount: (amount != null ? amount.value : this.amount),
        position: (position != null ? position.value : this.position),
        product: (product != null ? product.value : this.product));
  }
}

@JsonSerializable(explicitToJson: true)
class PickupInfo {
  PickupInfo({
    required this.locationId,
    required this.time,
  });

  factory PickupInfo.fromJson(Map<String, dynamic> json) =>
      _$PickupInfoFromJson(json);

  @JsonKey(name: 'locationId', includeIfNull: false)
  final num locationId;
  @JsonKey(name: 'time', includeIfNull: false, defaultValue: '')
  final String time;
  static const fromJsonFactory = _$PickupInfoFromJson;
  static const toJsonFactory = _$PickupInfoToJson;
  Map<String, dynamic> toJson() => _$PickupInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PickupInfo &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.time, time) ||
                const DeepCollectionEquality().equals(other.time, time)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(locationId) ^
      const DeepCollectionEquality().hash(time) ^
      runtimeType.hashCode;
}

extension $PickupInfoExtension on PickupInfo {
  PickupInfo copyWith({num? locationId, String? time}) {
    return PickupInfo(
        locationId: locationId ?? this.locationId, time: time ?? this.time);
  }

  PickupInfo copyWithWrapped(
      {Wrapped<num>? locationId, Wrapped<String>? time}) {
    return PickupInfo(
        locationId: (locationId != null ? locationId.value : this.locationId),
        time: (time != null ? time.value : this.time));
  }
}

@JsonSerializable(explicitToJson: true)
class PostItemRequestV7 {
  PostItemRequestV7({
    required this.items,
  });

  factory PostItemRequestV7.fromJson(Map<String, dynamic> json) =>
      _$PostItemRequestV7FromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <ItemDtoV7>[])
  final List<ItemDtoV7> items;
  static const fromJsonFactory = _$PostItemRequestV7FromJson;
  static const toJsonFactory = _$PostItemRequestV7ToJson;
  Map<String, dynamic> toJson() => _$PostItemRequestV7ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PostItemRequestV7 &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $PostItemRequestV7Extension on PostItemRequestV7 {
  PostItemRequestV7 copyWith({List<ItemDtoV7>? items}) {
    return PostItemRequestV7(items: items ?? this.items);
  }

  PostItemRequestV7 copyWithWrapped({Wrapped<List<ItemDtoV7>>? items}) {
    return PostItemRequestV7(items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class PriceDto {
  PriceDto({
    this.priceAfterDiscount,
    this.priceBeforeDiscount,
    this.priceDiscount,
    this.priceTotalPayable,
  });

  factory PriceDto.fromJson(Map<String, dynamic> json) =>
      _$PriceDtoFromJson(json);

  @JsonKey(name: 'priceAfterDiscount', includeIfNull: false)
  final double? priceAfterDiscount;
  @JsonKey(name: 'priceBeforeDiscount', includeIfNull: false)
  final double? priceBeforeDiscount;
  @JsonKey(name: 'priceDiscount', includeIfNull: false)
  final double? priceDiscount;
  @JsonKey(name: 'priceTotalPayable', includeIfNull: false)
  final double? priceTotalPayable;
  static const fromJsonFactory = _$PriceDtoFromJson;
  static const toJsonFactory = _$PriceDtoToJson;
  Map<String, dynamic> toJson() => _$PriceDtoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PriceDto &&
            (identical(other.priceAfterDiscount, priceAfterDiscount) ||
                const DeepCollectionEquality()
                    .equals(other.priceAfterDiscount, priceAfterDiscount)) &&
            (identical(other.priceBeforeDiscount, priceBeforeDiscount) ||
                const DeepCollectionEquality()
                    .equals(other.priceBeforeDiscount, priceBeforeDiscount)) &&
            (identical(other.priceDiscount, priceDiscount) ||
                const DeepCollectionEquality()
                    .equals(other.priceDiscount, priceDiscount)) &&
            (identical(other.priceTotalPayable, priceTotalPayable) ||
                const DeepCollectionEquality()
                    .equals(other.priceTotalPayable, priceTotalPayable)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(priceAfterDiscount) ^
      const DeepCollectionEquality().hash(priceBeforeDiscount) ^
      const DeepCollectionEquality().hash(priceDiscount) ^
      const DeepCollectionEquality().hash(priceTotalPayable) ^
      runtimeType.hashCode;
}

extension $PriceDtoExtension on PriceDto {
  PriceDto copyWith(
      {double? priceAfterDiscount,
      double? priceBeforeDiscount,
      double? priceDiscount,
      double? priceTotalPayable}) {
    return PriceDto(
        priceAfterDiscount: priceAfterDiscount ?? this.priceAfterDiscount,
        priceBeforeDiscount: priceBeforeDiscount ?? this.priceBeforeDiscount,
        priceDiscount: priceDiscount ?? this.priceDiscount,
        priceTotalPayable: priceTotalPayable ?? this.priceTotalPayable);
  }

  PriceDto copyWithWrapped(
      {Wrapped<double?>? priceAfterDiscount,
      Wrapped<double?>? priceBeforeDiscount,
      Wrapped<double?>? priceDiscount,
      Wrapped<double?>? priceTotalPayable}) {
    return PriceDto(
        priceAfterDiscount: (priceAfterDiscount != null
            ? priceAfterDiscount.value
            : this.priceAfterDiscount),
        priceBeforeDiscount: (priceBeforeDiscount != null
            ? priceBeforeDiscount.value
            : this.priceBeforeDiscount),
        priceDiscount:
            (priceDiscount != null ? priceDiscount.value : this.priceDiscount),
        priceTotalPayable: (priceTotalPayable != null
            ? priceTotalPayable.value
            : this.priceTotalPayable));
  }
}

@JsonSerializable(explicitToJson: true)
class ProductCard {
  ProductCard({
    this.availableOnline,
    this.bonusEndDate,
    this.bonusMechanism,
    this.bonusPeriodDescription,
    this.bonusSegmentDescription,
    this.bonusSegmentId,
    this.bonusStartDate,
    this.brand,
    this.currentPrice,
    this.descriptionFull,
    this.descriptionHighlights,
    this.discountType,
    this.extraDescriptions,
    required this.hqId,
    this.images,
    this.isBonus,
    this.isBonusPrice,
    required this.isInfiniteBonus,
    required this.isOrderable,
    this.isPreviouslyBought,
    required this.isSample,
    this.isStapelBonus,
    this.mainCategory,
    this.nix18,
    this.orderAvailabilityDescription,
    this.orderAvailabilityStatus,
    this.priceBeforeBonus,
    this.promotionType,
    this.properties,
    this.propertyIcons,
    this.salesUnitSize,
    this.segmentType,
    this.shopType,
    this.specialDescription,
    this.subCategory,
    this.subCategoryId,
    required this.title,
    this.unitPriceDescription,
    required this.webshopId,
  });

  factory ProductCard.fromJson(Map<String, dynamic> json) =>
      _$ProductCardFromJson(json);

  @JsonKey(name: 'availableOnline', includeIfNull: false)
  final bool? availableOnline;
  @JsonKey(name: 'bonusEndDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? bonusEndDate;
  @JsonKey(name: 'bonusMechanism', includeIfNull: false, defaultValue: '')
  final String? bonusMechanism;
  @JsonKey(
      name: 'bonusPeriodDescription', includeIfNull: false, defaultValue: '')
  final String? bonusPeriodDescription;
  @JsonKey(
      name: 'bonusSegmentDescription', includeIfNull: false, defaultValue: '')
  final String? bonusSegmentDescription;
  @JsonKey(name: 'bonusSegmentId', includeIfNull: false)
  final num? bonusSegmentId;
  @JsonKey(name: 'bonusStartDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? bonusStartDate;
  @JsonKey(name: 'brand', includeIfNull: false, defaultValue: '')
  final String? brand;
  @JsonKey(name: 'currentPrice', includeIfNull: false)
  final double? currentPrice;
  @JsonKey(name: 'descriptionFull', includeIfNull: false, defaultValue: '')
  final String? descriptionFull;
  @JsonKey(
      name: 'descriptionHighlights', includeIfNull: false, defaultValue: '')
  final String? descriptionHighlights;
  @JsonKey(name: 'discountType', includeIfNull: false, defaultValue: '')
  final String? discountType;
  @JsonKey(
      name: 'extraDescriptions', includeIfNull: false, defaultValue: <String>[])
  final List<String>? extraDescriptions;
  @JsonKey(name: 'hqId', includeIfNull: false)
  final num hqId;
  @JsonKey(name: 'images', includeIfNull: false, defaultValue: <Image>[])
  final List<Image>? images;
  @JsonKey(name: 'isBonus', includeIfNull: false)
  final bool? isBonus;
  @JsonKey(name: 'isBonusPrice', includeIfNull: false)
  final bool? isBonusPrice;
  @JsonKey(name: 'isInfiniteBonus', includeIfNull: false)
  final bool isInfiniteBonus;
  @JsonKey(name: 'isOrderable', includeIfNull: false)
  final bool isOrderable;
  @JsonKey(name: 'isPreviouslyBought', includeIfNull: false)
  final bool? isPreviouslyBought;
  @JsonKey(name: 'isSample', includeIfNull: false)
  final bool isSample;
  @JsonKey(name: 'isStapelBonus', includeIfNull: false)
  final bool? isStapelBonus;
  @JsonKey(name: 'mainCategory', includeIfNull: false, defaultValue: '')
  final String? mainCategory;
  @JsonKey(name: 'nix18', includeIfNull: false)
  final bool? nix18;
  @JsonKey(
      name: 'orderAvailabilityDescription',
      includeIfNull: false,
      defaultValue: '')
  final String? orderAvailabilityDescription;
  @JsonKey(
      name: 'orderAvailabilityStatus', includeIfNull: false, defaultValue: '')
  final String? orderAvailabilityStatus;
  @JsonKey(name: 'priceBeforeBonus', includeIfNull: false)
  final double? priceBeforeBonus;
  @JsonKey(name: 'promotionType', includeIfNull: false, defaultValue: '')
  final String? promotionType;
  @JsonKey(name: 'properties', includeIfNull: false)
  final Map<String, dynamic>? properties;
  @JsonKey(
      name: 'propertyIcons', includeIfNull: false, defaultValue: <String>[])
  final List<String>? propertyIcons;
  @JsonKey(name: 'salesUnitSize', includeIfNull: false, defaultValue: '')
  final String? salesUnitSize;
  @JsonKey(name: 'segmentType', includeIfNull: false, defaultValue: '')
  final String? segmentType;
  @JsonKey(name: 'shopType', includeIfNull: false, defaultValue: '')
  final String? shopType;
  @JsonKey(name: 'specialDescription', includeIfNull: false, defaultValue: '')
  final String? specialDescription;
  @JsonKey(name: 'subCategory', includeIfNull: false, defaultValue: '')
  final String? subCategory;
  @JsonKey(name: 'subCategoryId', includeIfNull: false)
  final num? subCategoryId;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  @JsonKey(name: 'unitPriceDescription', includeIfNull: false, defaultValue: '')
  final String? unitPriceDescription;
  @JsonKey(name: 'webshopId', includeIfNull: false)
  final num webshopId;
  static const fromJsonFactory = _$ProductCardFromJson;
  static const toJsonFactory = _$ProductCardToJson;
  Map<String, dynamic> toJson() => _$ProductCardToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProductCard &&
            (identical(other.availableOnline, availableOnline) ||
                const DeepCollectionEquality()
                    .equals(other.availableOnline, availableOnline)) &&
            (identical(other.bonusEndDate, bonusEndDate) ||
                const DeepCollectionEquality()
                    .equals(other.bonusEndDate, bonusEndDate)) &&
            (identical(other.bonusMechanism, bonusMechanism) ||
                const DeepCollectionEquality()
                    .equals(other.bonusMechanism, bonusMechanism)) &&
            (identical(other.bonusPeriodDescription, bonusPeriodDescription) ||
                const DeepCollectionEquality().equals(
                    other.bonusPeriodDescription, bonusPeriodDescription)) &&
            (identical(other.bonusSegmentDescription, bonusSegmentDescription) ||
                const DeepCollectionEquality().equals(
                    other.bonusSegmentDescription, bonusSegmentDescription)) &&
            (identical(other.bonusSegmentId, bonusSegmentId) ||
                const DeepCollectionEquality()
                    .equals(other.bonusSegmentId, bonusSegmentId)) &&
            (identical(other.bonusStartDate, bonusStartDate) ||
                const DeepCollectionEquality()
                    .equals(other.bonusStartDate, bonusStartDate)) &&
            (identical(other.brand, brand) ||
                const DeepCollectionEquality().equals(other.brand, brand)) &&
            (identical(other.currentPrice, currentPrice) ||
                const DeepCollectionEquality()
                    .equals(other.currentPrice, currentPrice)) &&
            (identical(other.descriptionFull, descriptionFull) ||
                const DeepCollectionEquality()
                    .equals(other.descriptionFull, descriptionFull)) &&
            (identical(other.descriptionHighlights, descriptionHighlights) ||
                const DeepCollectionEquality().equals(
                    other.descriptionHighlights, descriptionHighlights)) &&
            (identical(other.discountType, discountType) ||
                const DeepCollectionEquality()
                    .equals(other.discountType, discountType)) &&
            (identical(other.extraDescriptions, extraDescriptions) ||
                const DeepCollectionEquality()
                    .equals(other.extraDescriptions, extraDescriptions)) &&
            (identical(other.hqId, hqId) ||
                const DeepCollectionEquality().equals(other.hqId, hqId)) &&
            (identical(other.images, images) ||
                const DeepCollectionEquality().equals(other.images, images)) &&
            (identical(other.isBonus, isBonus) ||
                const DeepCollectionEquality()
                    .equals(other.isBonus, isBonus)) &&
            (identical(other.isBonusPrice, isBonusPrice) ||
                const DeepCollectionEquality()
                    .equals(other.isBonusPrice, isBonusPrice)) &&
            (identical(other.isInfiniteBonus, isInfiniteBonus) ||
                const DeepCollectionEquality()
                    .equals(other.isInfiniteBonus, isInfiniteBonus)) &&
            (identical(other.isOrderable, isOrderable) || const DeepCollectionEquality().equals(other.isOrderable, isOrderable)) &&
            (identical(other.isPreviouslyBought, isPreviouslyBought) || const DeepCollectionEquality().equals(other.isPreviouslyBought, isPreviouslyBought)) &&
            (identical(other.isSample, isSample) || const DeepCollectionEquality().equals(other.isSample, isSample)) &&
            (identical(other.isStapelBonus, isStapelBonus) || const DeepCollectionEquality().equals(other.isStapelBonus, isStapelBonus)) &&
            (identical(other.mainCategory, mainCategory) || const DeepCollectionEquality().equals(other.mainCategory, mainCategory)) &&
            (identical(other.nix18, nix18) || const DeepCollectionEquality().equals(other.nix18, nix18)) &&
            (identical(other.orderAvailabilityDescription, orderAvailabilityDescription) || const DeepCollectionEquality().equals(other.orderAvailabilityDescription, orderAvailabilityDescription)) &&
            (identical(other.orderAvailabilityStatus, orderAvailabilityStatus) || const DeepCollectionEquality().equals(other.orderAvailabilityStatus, orderAvailabilityStatus)) &&
            (identical(other.priceBeforeBonus, priceBeforeBonus) || const DeepCollectionEquality().equals(other.priceBeforeBonus, priceBeforeBonus)) &&
            (identical(other.promotionType, promotionType) || const DeepCollectionEquality().equals(other.promotionType, promotionType)) &&
            (identical(other.properties, properties) || const DeepCollectionEquality().equals(other.properties, properties)) &&
            (identical(other.propertyIcons, propertyIcons) || const DeepCollectionEquality().equals(other.propertyIcons, propertyIcons)) &&
            (identical(other.salesUnitSize, salesUnitSize) || const DeepCollectionEquality().equals(other.salesUnitSize, salesUnitSize)) &&
            (identical(other.segmentType, segmentType) || const DeepCollectionEquality().equals(other.segmentType, segmentType)) &&
            (identical(other.shopType, shopType) || const DeepCollectionEquality().equals(other.shopType, shopType)) &&
            (identical(other.specialDescription, specialDescription) || const DeepCollectionEquality().equals(other.specialDescription, specialDescription)) &&
            (identical(other.subCategory, subCategory) || const DeepCollectionEquality().equals(other.subCategory, subCategory)) &&
            (identical(other.subCategoryId, subCategoryId) || const DeepCollectionEquality().equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.title, title) || const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.unitPriceDescription, unitPriceDescription) || const DeepCollectionEquality().equals(other.unitPriceDescription, unitPriceDescription)) &&
            (identical(other.webshopId, webshopId) || const DeepCollectionEquality().equals(other.webshopId, webshopId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(availableOnline) ^
      const DeepCollectionEquality().hash(bonusEndDate) ^
      const DeepCollectionEquality().hash(bonusMechanism) ^
      const DeepCollectionEquality().hash(bonusPeriodDescription) ^
      const DeepCollectionEquality().hash(bonusSegmentDescription) ^
      const DeepCollectionEquality().hash(bonusSegmentId) ^
      const DeepCollectionEquality().hash(bonusStartDate) ^
      const DeepCollectionEquality().hash(brand) ^
      const DeepCollectionEquality().hash(currentPrice) ^
      const DeepCollectionEquality().hash(descriptionFull) ^
      const DeepCollectionEquality().hash(descriptionHighlights) ^
      const DeepCollectionEquality().hash(discountType) ^
      const DeepCollectionEquality().hash(extraDescriptions) ^
      const DeepCollectionEquality().hash(hqId) ^
      const DeepCollectionEquality().hash(images) ^
      const DeepCollectionEquality().hash(isBonus) ^
      const DeepCollectionEquality().hash(isBonusPrice) ^
      const DeepCollectionEquality().hash(isInfiniteBonus) ^
      const DeepCollectionEquality().hash(isOrderable) ^
      const DeepCollectionEquality().hash(isPreviouslyBought) ^
      const DeepCollectionEquality().hash(isSample) ^
      const DeepCollectionEquality().hash(isStapelBonus) ^
      const DeepCollectionEquality().hash(mainCategory) ^
      const DeepCollectionEquality().hash(nix18) ^
      const DeepCollectionEquality().hash(orderAvailabilityDescription) ^
      const DeepCollectionEquality().hash(orderAvailabilityStatus) ^
      const DeepCollectionEquality().hash(priceBeforeBonus) ^
      const DeepCollectionEquality().hash(promotionType) ^
      const DeepCollectionEquality().hash(properties) ^
      const DeepCollectionEquality().hash(propertyIcons) ^
      const DeepCollectionEquality().hash(salesUnitSize) ^
      const DeepCollectionEquality().hash(segmentType) ^
      const DeepCollectionEquality().hash(shopType) ^
      const DeepCollectionEquality().hash(specialDescription) ^
      const DeepCollectionEquality().hash(subCategory) ^
      const DeepCollectionEquality().hash(subCategoryId) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(unitPriceDescription) ^
      const DeepCollectionEquality().hash(webshopId) ^
      runtimeType.hashCode;
}

extension $ProductCardExtension on ProductCard {
  ProductCard copyWith(
      {bool? availableOnline,
      DateTime? bonusEndDate,
      String? bonusMechanism,
      String? bonusPeriodDescription,
      String? bonusSegmentDescription,
      num? bonusSegmentId,
      DateTime? bonusStartDate,
      String? brand,
      double? currentPrice,
      String? descriptionFull,
      String? descriptionHighlights,
      String? discountType,
      List<String>? extraDescriptions,
      num? hqId,
      List<Image>? images,
      bool? isBonus,
      bool? isBonusPrice,
      bool? isInfiniteBonus,
      bool? isOrderable,
      bool? isPreviouslyBought,
      bool? isSample,
      bool? isStapelBonus,
      String? mainCategory,
      bool? nix18,
      String? orderAvailabilityDescription,
      String? orderAvailabilityStatus,
      double? priceBeforeBonus,
      String? promotionType,
      Map<String, dynamic>? properties,
      List<String>? propertyIcons,
      String? salesUnitSize,
      String? segmentType,
      String? shopType,
      String? specialDescription,
      String? subCategory,
      num? subCategoryId,
      String? title,
      String? unitPriceDescription,
      num? webshopId}) {
    return ProductCard(
        availableOnline: availableOnline ?? this.availableOnline,
        bonusEndDate: bonusEndDate ?? this.bonusEndDate,
        bonusMechanism: bonusMechanism ?? this.bonusMechanism,
        bonusPeriodDescription:
            bonusPeriodDescription ?? this.bonusPeriodDescription,
        bonusSegmentDescription:
            bonusSegmentDescription ?? this.bonusSegmentDescription,
        bonusSegmentId: bonusSegmentId ?? this.bonusSegmentId,
        bonusStartDate: bonusStartDate ?? this.bonusStartDate,
        brand: brand ?? this.brand,
        currentPrice: currentPrice ?? this.currentPrice,
        descriptionFull: descriptionFull ?? this.descriptionFull,
        descriptionHighlights:
            descriptionHighlights ?? this.descriptionHighlights,
        discountType: discountType ?? this.discountType,
        extraDescriptions: extraDescriptions ?? this.extraDescriptions,
        hqId: hqId ?? this.hqId,
        images: images ?? this.images,
        isBonus: isBonus ?? this.isBonus,
        isBonusPrice: isBonusPrice ?? this.isBonusPrice,
        isInfiniteBonus: isInfiniteBonus ?? this.isInfiniteBonus,
        isOrderable: isOrderable ?? this.isOrderable,
        isPreviouslyBought: isPreviouslyBought ?? this.isPreviouslyBought,
        isSample: isSample ?? this.isSample,
        isStapelBonus: isStapelBonus ?? this.isStapelBonus,
        mainCategory: mainCategory ?? this.mainCategory,
        nix18: nix18 ?? this.nix18,
        orderAvailabilityDescription:
            orderAvailabilityDescription ?? this.orderAvailabilityDescription,
        orderAvailabilityStatus:
            orderAvailabilityStatus ?? this.orderAvailabilityStatus,
        priceBeforeBonus: priceBeforeBonus ?? this.priceBeforeBonus,
        promotionType: promotionType ?? this.promotionType,
        properties: properties ?? this.properties,
        propertyIcons: propertyIcons ?? this.propertyIcons,
        salesUnitSize: salesUnitSize ?? this.salesUnitSize,
        segmentType: segmentType ?? this.segmentType,
        shopType: shopType ?? this.shopType,
        specialDescription: specialDescription ?? this.specialDescription,
        subCategory: subCategory ?? this.subCategory,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        title: title ?? this.title,
        unitPriceDescription: unitPriceDescription ?? this.unitPriceDescription,
        webshopId: webshopId ?? this.webshopId);
  }

  ProductCard copyWithWrapped(
      {Wrapped<bool?>? availableOnline,
      Wrapped<DateTime?>? bonusEndDate,
      Wrapped<String?>? bonusMechanism,
      Wrapped<String?>? bonusPeriodDescription,
      Wrapped<String?>? bonusSegmentDescription,
      Wrapped<num?>? bonusSegmentId,
      Wrapped<DateTime?>? bonusStartDate,
      Wrapped<String?>? brand,
      Wrapped<double?>? currentPrice,
      Wrapped<String?>? descriptionFull,
      Wrapped<String?>? descriptionHighlights,
      Wrapped<String?>? discountType,
      Wrapped<List<String>?>? extraDescriptions,
      Wrapped<num>? hqId,
      Wrapped<List<Image>?>? images,
      Wrapped<bool?>? isBonus,
      Wrapped<bool?>? isBonusPrice,
      Wrapped<bool>? isInfiniteBonus,
      Wrapped<bool>? isOrderable,
      Wrapped<bool?>? isPreviouslyBought,
      Wrapped<bool>? isSample,
      Wrapped<bool?>? isStapelBonus,
      Wrapped<String?>? mainCategory,
      Wrapped<bool?>? nix18,
      Wrapped<String?>? orderAvailabilityDescription,
      Wrapped<String?>? orderAvailabilityStatus,
      Wrapped<double?>? priceBeforeBonus,
      Wrapped<String?>? promotionType,
      Wrapped<Map<String, dynamic>?>? properties,
      Wrapped<List<String>?>? propertyIcons,
      Wrapped<String?>? salesUnitSize,
      Wrapped<String?>? segmentType,
      Wrapped<String?>? shopType,
      Wrapped<String?>? specialDescription,
      Wrapped<String?>? subCategory,
      Wrapped<num?>? subCategoryId,
      Wrapped<String>? title,
      Wrapped<String?>? unitPriceDescription,
      Wrapped<num>? webshopId}) {
    return ProductCard(
        availableOnline: (availableOnline != null
            ? availableOnline.value
            : this.availableOnline),
        bonusEndDate:
            (bonusEndDate != null ? bonusEndDate.value : this.bonusEndDate),
        bonusMechanism: (bonusMechanism != null
            ? bonusMechanism.value
            : this.bonusMechanism),
        bonusPeriodDescription: (bonusPeriodDescription != null
            ? bonusPeriodDescription.value
            : this.bonusPeriodDescription),
        bonusSegmentDescription: (bonusSegmentDescription != null
            ? bonusSegmentDescription.value
            : this.bonusSegmentDescription),
        bonusSegmentId: (bonusSegmentId != null
            ? bonusSegmentId.value
            : this.bonusSegmentId),
        bonusStartDate: (bonusStartDate != null
            ? bonusStartDate.value
            : this.bonusStartDate),
        brand: (brand != null ? brand.value : this.brand),
        currentPrice:
            (currentPrice != null ? currentPrice.value : this.currentPrice),
        descriptionFull: (descriptionFull != null
            ? descriptionFull.value
            : this.descriptionFull),
        descriptionHighlights: (descriptionHighlights != null
            ? descriptionHighlights.value
            : this.descriptionHighlights),
        discountType:
            (discountType != null ? discountType.value : this.discountType),
        extraDescriptions: (extraDescriptions != null
            ? extraDescriptions.value
            : this.extraDescriptions),
        hqId: (hqId != null ? hqId.value : this.hqId),
        images: (images != null ? images.value : this.images),
        isBonus: (isBonus != null ? isBonus.value : this.isBonus),
        isBonusPrice:
            (isBonusPrice != null ? isBonusPrice.value : this.isBonusPrice),
        isInfiniteBonus: (isInfiniteBonus != null
            ? isInfiniteBonus.value
            : this.isInfiniteBonus),
        isOrderable:
            (isOrderable != null ? isOrderable.value : this.isOrderable),
        isPreviouslyBought: (isPreviouslyBought != null
            ? isPreviouslyBought.value
            : this.isPreviouslyBought),
        isSample: (isSample != null ? isSample.value : this.isSample),
        isStapelBonus:
            (isStapelBonus != null ? isStapelBonus.value : this.isStapelBonus),
        mainCategory:
            (mainCategory != null ? mainCategory.value : this.mainCategory),
        nix18: (nix18 != null ? nix18.value : this.nix18),
        orderAvailabilityDescription: (orderAvailabilityDescription != null
            ? orderAvailabilityDescription.value
            : this.orderAvailabilityDescription),
        orderAvailabilityStatus: (orderAvailabilityStatus != null
            ? orderAvailabilityStatus.value
            : this.orderAvailabilityStatus),
        priceBeforeBonus: (priceBeforeBonus != null
            ? priceBeforeBonus.value
            : this.priceBeforeBonus),
        promotionType:
            (promotionType != null ? promotionType.value : this.promotionType),
        properties: (properties != null ? properties.value : this.properties),
        propertyIcons:
            (propertyIcons != null ? propertyIcons.value : this.propertyIcons),
        salesUnitSize:
            (salesUnitSize != null ? salesUnitSize.value : this.salesUnitSize),
        segmentType:
            (segmentType != null ? segmentType.value : this.segmentType),
        shopType: (shopType != null ? shopType.value : this.shopType),
        specialDescription: (specialDescription != null
            ? specialDescription.value
            : this.specialDescription),
        subCategory:
            (subCategory != null ? subCategory.value : this.subCategory),
        subCategoryId:
            (subCategoryId != null ? subCategoryId.value : this.subCategoryId),
        title: (title != null ? title.value : this.title),
        unitPriceDescription: (unitPriceDescription != null
            ? unitPriceDescription.value
            : this.unitPriceDescription),
        webshopId: (webshopId != null ? webshopId.value : this.webshopId));
  }
}

@JsonSerializable(explicitToJson: true)
class Receipt {
  Receipt({
    required this.deposit,
    required this.netPrice,
    required this.orderId,
    required this.personalDiscountAdvantage,
    required this.serviceCostsAndDiscounts,
    required this.subtotalPrice,
    required this.totalBonusDiscount,
    required this.totalDeliveryCosts,
    required this.totalPrice,
  });

  factory Receipt.fromJson(Map<String, dynamic> json) =>
      _$ReceiptFromJson(json);

  @JsonKey(name: 'deposit', includeIfNull: false)
  final double deposit;
  @JsonKey(name: 'netPrice', includeIfNull: false)
  final double netPrice;
  @JsonKey(name: 'orderId', includeIfNull: false)
  final num orderId;
  @JsonKey(name: 'personalDiscountAdvantage', includeIfNull: false)
  final double personalDiscountAdvantage;
  @JsonKey(
      name: 'serviceCostsAndDiscounts',
      includeIfNull: false,
      defaultValue: <OrderReceiptDiscount>[])
  final List<OrderReceiptDiscount> serviceCostsAndDiscounts;
  @JsonKey(name: 'subtotalPrice', includeIfNull: false)
  final double subtotalPrice;
  @JsonKey(name: 'totalBonusDiscount', includeIfNull: false)
  final double totalBonusDiscount;
  @JsonKey(name: 'totalDeliveryCosts', includeIfNull: false)
  final double totalDeliveryCosts;
  @JsonKey(name: 'totalPrice', includeIfNull: false)
  final double totalPrice;
  static const fromJsonFactory = _$ReceiptFromJson;
  static const toJsonFactory = _$ReceiptToJson;
  Map<String, dynamic> toJson() => _$ReceiptToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Receipt &&
            (identical(other.deposit, deposit) ||
                const DeepCollectionEquality()
                    .equals(other.deposit, deposit)) &&
            (identical(other.netPrice, netPrice) ||
                const DeepCollectionEquality()
                    .equals(other.netPrice, netPrice)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.personalDiscountAdvantage,
                    personalDiscountAdvantage) ||
                const DeepCollectionEquality().equals(
                    other.personalDiscountAdvantage,
                    personalDiscountAdvantage)) &&
            (identical(
                    other.serviceCostsAndDiscounts, serviceCostsAndDiscounts) ||
                const DeepCollectionEquality().equals(
                    other.serviceCostsAndDiscounts,
                    serviceCostsAndDiscounts)) &&
            (identical(other.subtotalPrice, subtotalPrice) ||
                const DeepCollectionEquality()
                    .equals(other.subtotalPrice, subtotalPrice)) &&
            (identical(other.totalBonusDiscount, totalBonusDiscount) ||
                const DeepCollectionEquality()
                    .equals(other.totalBonusDiscount, totalBonusDiscount)) &&
            (identical(other.totalDeliveryCosts, totalDeliveryCosts) ||
                const DeepCollectionEquality()
                    .equals(other.totalDeliveryCosts, totalDeliveryCosts)) &&
            (identical(other.totalPrice, totalPrice) ||
                const DeepCollectionEquality()
                    .equals(other.totalPrice, totalPrice)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(deposit) ^
      const DeepCollectionEquality().hash(netPrice) ^
      const DeepCollectionEquality().hash(orderId) ^
      const DeepCollectionEquality().hash(personalDiscountAdvantage) ^
      const DeepCollectionEquality().hash(serviceCostsAndDiscounts) ^
      const DeepCollectionEquality().hash(subtotalPrice) ^
      const DeepCollectionEquality().hash(totalBonusDiscount) ^
      const DeepCollectionEquality().hash(totalDeliveryCosts) ^
      const DeepCollectionEquality().hash(totalPrice) ^
      runtimeType.hashCode;
}

extension $ReceiptExtension on Receipt {
  Receipt copyWith(
      {double? deposit,
      double? netPrice,
      num? orderId,
      double? personalDiscountAdvantage,
      List<OrderReceiptDiscount>? serviceCostsAndDiscounts,
      double? subtotalPrice,
      double? totalBonusDiscount,
      double? totalDeliveryCosts,
      double? totalPrice}) {
    return Receipt(
        deposit: deposit ?? this.deposit,
        netPrice: netPrice ?? this.netPrice,
        orderId: orderId ?? this.orderId,
        personalDiscountAdvantage:
            personalDiscountAdvantage ?? this.personalDiscountAdvantage,
        serviceCostsAndDiscounts:
            serviceCostsAndDiscounts ?? this.serviceCostsAndDiscounts,
        subtotalPrice: subtotalPrice ?? this.subtotalPrice,
        totalBonusDiscount: totalBonusDiscount ?? this.totalBonusDiscount,
        totalDeliveryCosts: totalDeliveryCosts ?? this.totalDeliveryCosts,
        totalPrice: totalPrice ?? this.totalPrice);
  }

  Receipt copyWithWrapped(
      {Wrapped<double>? deposit,
      Wrapped<double>? netPrice,
      Wrapped<num>? orderId,
      Wrapped<double>? personalDiscountAdvantage,
      Wrapped<List<OrderReceiptDiscount>>? serviceCostsAndDiscounts,
      Wrapped<double>? subtotalPrice,
      Wrapped<double>? totalBonusDiscount,
      Wrapped<double>? totalDeliveryCosts,
      Wrapped<double>? totalPrice}) {
    return Receipt(
        deposit: (deposit != null ? deposit.value : this.deposit),
        netPrice: (netPrice != null ? netPrice.value : this.netPrice),
        orderId: (orderId != null ? orderId.value : this.orderId),
        personalDiscountAdvantage: (personalDiscountAdvantage != null
            ? personalDiscountAdvantage.value
            : this.personalDiscountAdvantage),
        serviceCostsAndDiscounts: (serviceCostsAndDiscounts != null
            ? serviceCostsAndDiscounts.value
            : this.serviceCostsAndDiscounts),
        subtotalPrice:
            (subtotalPrice != null ? subtotalPrice.value : this.subtotalPrice),
        totalBonusDiscount: (totalBonusDiscount != null
            ? totalBonusDiscount.value
            : this.totalBonusDiscount),
        totalDeliveryCosts: (totalDeliveryCosts != null
            ? totalDeliveryCosts.value
            : this.totalDeliveryCosts),
        totalPrice: (totalPrice != null ? totalPrice.value : this.totalPrice));
  }
}

@JsonSerializable(explicitToJson: true)
class Sample {
  Sample({
    required this.isPremium,
    required this.isRejectable,
    required this.isRejected,
    required this.product,
  });

  factory Sample.fromJson(Map<String, dynamic> json) => _$SampleFromJson(json);

  @JsonKey(name: 'isPremium', includeIfNull: false)
  final bool isPremium;
  @JsonKey(name: 'isRejectable', includeIfNull: false)
  final bool isRejectable;
  @JsonKey(name: 'isRejected', includeIfNull: false)
  final bool isRejected;
  @JsonKey(name: 'product', includeIfNull: false)
  final ProductCard product;
  static const fromJsonFactory = _$SampleFromJson;
  static const toJsonFactory = _$SampleToJson;
  Map<String, dynamic> toJson() => _$SampleToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Sample &&
            (identical(other.isPremium, isPremium) ||
                const DeepCollectionEquality()
                    .equals(other.isPremium, isPremium)) &&
            (identical(other.isRejectable, isRejectable) ||
                const DeepCollectionEquality()
                    .equals(other.isRejectable, isRejectable)) &&
            (identical(other.isRejected, isRejected) ||
                const DeepCollectionEquality()
                    .equals(other.isRejected, isRejected)) &&
            (identical(other.product, product) ||
                const DeepCollectionEquality().equals(other.product, product)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(isPremium) ^
      const DeepCollectionEquality().hash(isRejectable) ^
      const DeepCollectionEquality().hash(isRejected) ^
      const DeepCollectionEquality().hash(product) ^
      runtimeType.hashCode;
}

extension $SampleExtension on Sample {
  Sample copyWith(
      {bool? isPremium,
      bool? isRejectable,
      bool? isRejected,
      ProductCard? product}) {
    return Sample(
        isPremium: isPremium ?? this.isPremium,
        isRejectable: isRejectable ?? this.isRejectable,
        isRejected: isRejected ?? this.isRejected,
        product: product ?? this.product);
  }

  Sample copyWithWrapped(
      {Wrapped<bool>? isPremium,
      Wrapped<bool>? isRejectable,
      Wrapped<bool>? isRejected,
      Wrapped<ProductCard>? product}) {
    return Sample(
        isPremium: (isPremium != null ? isPremium.value : this.isPremium),
        isRejectable:
            (isRejectable != null ? isRejectable.value : this.isRejectable),
        isRejected: (isRejected != null ? isRejected.value : this.isRejected),
        product: (product != null ? product.value : this.product));
  }
}

@JsonSerializable(explicitToJson: true)
class Slot {
  Slot({
    required this.date,
    required this.endTime,
    required this.endTimeUtc,
    this.pickupLocationId,
    required this.shiftCode,
    required this.startTime,
    required this.startTimeUtc,
  });

  factory Slot.fromJson(Map<String, dynamic> json) => _$SlotFromJson(json);

  @JsonKey(name: 'date', includeIfNull: false, toJson: _dateToJson)
  final DateTime date;
  @JsonKey(name: 'endTime', includeIfNull: false, defaultValue: '')
  final String endTime;
  @JsonKey(name: 'endTimeUtc', includeIfNull: false)
  final DateTime endTimeUtc;
  @JsonKey(name: 'pickupLocationId', includeIfNull: false)
  final num? pickupLocationId;
  @JsonKey(name: 'shiftCode', includeIfNull: false, defaultValue: '')
  final String shiftCode;
  @JsonKey(name: 'startTime', includeIfNull: false, defaultValue: '')
  final String startTime;
  @JsonKey(name: 'startTimeUtc', includeIfNull: false)
  final DateTime startTimeUtc;
  static const fromJsonFactory = _$SlotFromJson;
  static const toJsonFactory = _$SlotToJson;
  Map<String, dynamic> toJson() => _$SlotToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Slot &&
            (identical(other.date, date) ||
                const DeepCollectionEquality().equals(other.date, date)) &&
            (identical(other.endTime, endTime) ||
                const DeepCollectionEquality()
                    .equals(other.endTime, endTime)) &&
            (identical(other.endTimeUtc, endTimeUtc) ||
                const DeepCollectionEquality()
                    .equals(other.endTimeUtc, endTimeUtc)) &&
            (identical(other.pickupLocationId, pickupLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.pickupLocationId, pickupLocationId)) &&
            (identical(other.shiftCode, shiftCode) ||
                const DeepCollectionEquality()
                    .equals(other.shiftCode, shiftCode)) &&
            (identical(other.startTime, startTime) ||
                const DeepCollectionEquality()
                    .equals(other.startTime, startTime)) &&
            (identical(other.startTimeUtc, startTimeUtc) ||
                const DeepCollectionEquality()
                    .equals(other.startTimeUtc, startTimeUtc)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(date) ^
      const DeepCollectionEquality().hash(endTime) ^
      const DeepCollectionEquality().hash(endTimeUtc) ^
      const DeepCollectionEquality().hash(pickupLocationId) ^
      const DeepCollectionEquality().hash(shiftCode) ^
      const DeepCollectionEquality().hash(startTime) ^
      const DeepCollectionEquality().hash(startTimeUtc) ^
      runtimeType.hashCode;
}

extension $SlotExtension on Slot {
  Slot copyWith(
      {DateTime? date,
      String? endTime,
      DateTime? endTimeUtc,
      num? pickupLocationId,
      String? shiftCode,
      String? startTime,
      DateTime? startTimeUtc}) {
    return Slot(
        date: date ?? this.date,
        endTime: endTime ?? this.endTime,
        endTimeUtc: endTimeUtc ?? this.endTimeUtc,
        pickupLocationId: pickupLocationId ?? this.pickupLocationId,
        shiftCode: shiftCode ?? this.shiftCode,
        startTime: startTime ?? this.startTime,
        startTimeUtc: startTimeUtc ?? this.startTimeUtc);
  }

  Slot copyWithWrapped(
      {Wrapped<DateTime>? date,
      Wrapped<String>? endTime,
      Wrapped<DateTime>? endTimeUtc,
      Wrapped<num?>? pickupLocationId,
      Wrapped<String>? shiftCode,
      Wrapped<String>? startTime,
      Wrapped<DateTime>? startTimeUtc}) {
    return Slot(
        date: (date != null ? date.value : this.date),
        endTime: (endTime != null ? endTime.value : this.endTime),
        endTimeUtc: (endTimeUtc != null ? endTimeUtc.value : this.endTimeUtc),
        pickupLocationId: (pickupLocationId != null
            ? pickupLocationId.value
            : this.pickupLocationId),
        shiftCode: (shiftCode != null ? shiftCode.value : this.shiftCode),
        startTime: (startTime != null ? startTime.value : this.startTime),
        startTimeUtc:
            (startTimeUtc != null ? startTimeUtc.value : this.startTimeUtc));
  }
}

@JsonSerializable(explicitToJson: true)
class SubmittedOrder {
  SubmittedOrder({
    required this.lastUpdateTime,
  });

  factory SubmittedOrder.fromJson(Map<String, dynamic> json) =>
      _$SubmittedOrderFromJson(json);

  @JsonKey(name: 'lastUpdateTime', includeIfNull: false)
  final DateTime lastUpdateTime;
  static const fromJsonFactory = _$SubmittedOrderFromJson;
  static const toJsonFactory = _$SubmittedOrderToJson;
  Map<String, dynamic> toJson() => _$SubmittedOrderToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SubmittedOrder &&
            (identical(other.lastUpdateTime, lastUpdateTime) ||
                const DeepCollectionEquality()
                    .equals(other.lastUpdateTime, lastUpdateTime)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(lastUpdateTime) ^
      runtimeType.hashCode;
}

extension $SubmittedOrderExtension on SubmittedOrder {
  SubmittedOrder copyWith({DateTime? lastUpdateTime}) {
    return SubmittedOrder(
        lastUpdateTime: lastUpdateTime ?? this.lastUpdateTime);
  }

  SubmittedOrder copyWithWrapped({Wrapped<DateTime>? lastUpdateTime}) {
    return SubmittedOrder(
        lastUpdateTime: (lastUpdateTime != null
            ? lastUpdateTime.value
            : this.lastUpdateTime));
  }
}

@JsonSerializable(explicitToJson: true)
class SubmittedOrderV7 {
  SubmittedOrderV7({
    this.application,
    this.issuerId,
    required this.paymentOption,
    this.returnUrl,
    required this.syncTimes,
    this.tokenId,
  });

  factory SubmittedOrderV7.fromJson(Map<String, dynamic> json) =>
      _$SubmittedOrderV7FromJson(json);

  @JsonKey(name: 'application', includeIfNull: false, defaultValue: '')
  final String? application;
  @JsonKey(name: 'issuerId', includeIfNull: false, defaultValue: '')
  final String? issuerId;
  @JsonKey(
    name: 'paymentOption',
    includeIfNull: false,
    toJson: submittedOrderV7PaymentOptionToJson,
    fromJson: submittedOrderV7PaymentOptionFromJson,
  )
  final enums.SubmittedOrderV7PaymentOption paymentOption;
  @JsonKey(name: 'returnUrl', includeIfNull: false, defaultValue: '')
  final String? returnUrl;
  @JsonKey(name: 'syncTimes', includeIfNull: false)
  final SyncTimesV7 syncTimes;
  @JsonKey(name: 'tokenId', includeIfNull: false, defaultValue: '')
  final String? tokenId;
  static const fromJsonFactory = _$SubmittedOrderV7FromJson;
  static const toJsonFactory = _$SubmittedOrderV7ToJson;
  Map<String, dynamic> toJson() => _$SubmittedOrderV7ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SubmittedOrderV7 &&
            (identical(other.application, application) ||
                const DeepCollectionEquality()
                    .equals(other.application, application)) &&
            (identical(other.issuerId, issuerId) ||
                const DeepCollectionEquality()
                    .equals(other.issuerId, issuerId)) &&
            (identical(other.paymentOption, paymentOption) ||
                const DeepCollectionEquality()
                    .equals(other.paymentOption, paymentOption)) &&
            (identical(other.returnUrl, returnUrl) ||
                const DeepCollectionEquality()
                    .equals(other.returnUrl, returnUrl)) &&
            (identical(other.syncTimes, syncTimes) ||
                const DeepCollectionEquality()
                    .equals(other.syncTimes, syncTimes)) &&
            (identical(other.tokenId, tokenId) ||
                const DeepCollectionEquality().equals(other.tokenId, tokenId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(application) ^
      const DeepCollectionEquality().hash(issuerId) ^
      const DeepCollectionEquality().hash(paymentOption) ^
      const DeepCollectionEquality().hash(returnUrl) ^
      const DeepCollectionEquality().hash(syncTimes) ^
      const DeepCollectionEquality().hash(tokenId) ^
      runtimeType.hashCode;
}

extension $SubmittedOrderV7Extension on SubmittedOrderV7 {
  SubmittedOrderV7 copyWith(
      {String? application,
      String? issuerId,
      enums.SubmittedOrderV7PaymentOption? paymentOption,
      String? returnUrl,
      SyncTimesV7? syncTimes,
      String? tokenId}) {
    return SubmittedOrderV7(
        application: application ?? this.application,
        issuerId: issuerId ?? this.issuerId,
        paymentOption: paymentOption ?? this.paymentOption,
        returnUrl: returnUrl ?? this.returnUrl,
        syncTimes: syncTimes ?? this.syncTimes,
        tokenId: tokenId ?? this.tokenId);
  }

  SubmittedOrderV7 copyWithWrapped(
      {Wrapped<String?>? application,
      Wrapped<String?>? issuerId,
      Wrapped<enums.SubmittedOrderV7PaymentOption>? paymentOption,
      Wrapped<String?>? returnUrl,
      Wrapped<SyncTimesV7>? syncTimes,
      Wrapped<String?>? tokenId}) {
    return SubmittedOrderV7(
        application:
            (application != null ? application.value : this.application),
        issuerId: (issuerId != null ? issuerId.value : this.issuerId),
        paymentOption:
            (paymentOption != null ? paymentOption.value : this.paymentOption),
        returnUrl: (returnUrl != null ? returnUrl.value : this.returnUrl),
        syncTimes: (syncTimes != null ? syncTimes.value : this.syncTimes),
        tokenId: (tokenId != null ? tokenId.value : this.tokenId));
  }
}

@JsonSerializable(explicitToJson: true)
class SyncTimesV7 {
  SyncTimesV7({
    this.list,
    this.order,
  });

  factory SyncTimesV7.fromJson(Map<String, dynamic> json) =>
      _$SyncTimesV7FromJson(json);

  @JsonKey(name: 'list', includeIfNull: false)
  final ListSyncTimesV7? list;
  @JsonKey(name: 'order', includeIfNull: false)
  final OrderSyncTimesV7? order;
  static const fromJsonFactory = _$SyncTimesV7FromJson;
  static const toJsonFactory = _$SyncTimesV7ToJson;
  Map<String, dynamic> toJson() => _$SyncTimesV7ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SyncTimesV7 &&
            (identical(other.list, list) ||
                const DeepCollectionEquality().equals(other.list, list)) &&
            (identical(other.order, order) ||
                const DeepCollectionEquality().equals(other.order, order)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(list) ^
      const DeepCollectionEquality().hash(order) ^
      runtimeType.hashCode;
}

extension $SyncTimesV7Extension on SyncTimesV7 {
  SyncTimesV7 copyWith({ListSyncTimesV7? list, OrderSyncTimesV7? order}) {
    return SyncTimesV7(list: list ?? this.list, order: order ?? this.order);
  }

  SyncTimesV7 copyWithWrapped(
      {Wrapped<ListSyncTimesV7?>? list, Wrapped<OrderSyncTimesV7?>? order}) {
    return SyncTimesV7(
        list: (list != null ? list.value : this.list),
        order: (order != null ? order.value : this.order));
  }
}

@JsonSerializable(explicitToJson: true)
class UpdateItemRequest {
  UpdateItemRequest({
    this.description,
    this.originCode,
    required this.position,
    this.productId,
    required this.quantity,
    this.sourceId,
    required this.strikedThrough,
  });

  factory UpdateItemRequest.fromJson(Map<String, dynamic> json) =>
      _$UpdateItemRequestFromJson(json);

  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'originCode', includeIfNull: false, defaultValue: '')
  final String? originCode;
  @JsonKey(name: 'position', includeIfNull: false)
  final int position;
  @JsonKey(name: 'productId', includeIfNull: false)
  final num? productId;
  @JsonKey(name: 'quantity', includeIfNull: false)
  final int quantity;
  @JsonKey(name: 'sourceId', includeIfNull: false)
  final num? sourceId;
  @JsonKey(name: 'strikedThrough', includeIfNull: false)
  final bool strikedThrough;
  static const fromJsonFactory = _$UpdateItemRequestFromJson;
  static const toJsonFactory = _$UpdateItemRequestToJson;
  Map<String, dynamic> toJson() => _$UpdateItemRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UpdateItemRequest &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.originCode, originCode) ||
                const DeepCollectionEquality()
                    .equals(other.originCode, originCode)) &&
            (identical(other.position, position) ||
                const DeepCollectionEquality()
                    .equals(other.position, position)) &&
            (identical(other.productId, productId) ||
                const DeepCollectionEquality()
                    .equals(other.productId, productId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.sourceId, sourceId) ||
                const DeepCollectionEquality()
                    .equals(other.sourceId, sourceId)) &&
            (identical(other.strikedThrough, strikedThrough) ||
                const DeepCollectionEquality()
                    .equals(other.strikedThrough, strikedThrough)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(originCode) ^
      const DeepCollectionEquality().hash(position) ^
      const DeepCollectionEquality().hash(productId) ^
      const DeepCollectionEquality().hash(quantity) ^
      const DeepCollectionEquality().hash(sourceId) ^
      const DeepCollectionEquality().hash(strikedThrough) ^
      runtimeType.hashCode;
}

extension $UpdateItemRequestExtension on UpdateItemRequest {
  UpdateItemRequest copyWith(
      {String? description,
      String? originCode,
      int? position,
      num? productId,
      int? quantity,
      num? sourceId,
      bool? strikedThrough}) {
    return UpdateItemRequest(
        description: description ?? this.description,
        originCode: originCode ?? this.originCode,
        position: position ?? this.position,
        productId: productId ?? this.productId,
        quantity: quantity ?? this.quantity,
        sourceId: sourceId ?? this.sourceId,
        strikedThrough: strikedThrough ?? this.strikedThrough);
  }

  UpdateItemRequest copyWithWrapped(
      {Wrapped<String?>? description,
      Wrapped<String?>? originCode,
      Wrapped<int>? position,
      Wrapped<num?>? productId,
      Wrapped<int>? quantity,
      Wrapped<num?>? sourceId,
      Wrapped<bool>? strikedThrough}) {
    return UpdateItemRequest(
        description:
            (description != null ? description.value : this.description),
        originCode: (originCode != null ? originCode.value : this.originCode),
        position: (position != null ? position.value : this.position),
        productId: (productId != null ? productId.value : this.productId),
        quantity: (quantity != null ? quantity.value : this.quantity),
        sourceId: (sourceId != null ? sourceId.value : this.sourceId),
        strikedThrough: (strikedThrough != null
            ? strikedThrough.value
            : this.strikedThrough));
  }
}

@JsonSerializable(explicitToJson: true)
class UpdateOrderRequest {
  UpdateOrderRequest({
    required this.items,
    required this.lastSyncedDate,
  });

  factory UpdateOrderRequest.fromJson(Map<String, dynamic> json) =>
      _$UpdateOrderRequestFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <UpdateItemRequest>[])
  final List<UpdateItemRequest> items;
  @JsonKey(name: 'lastSyncedDate', includeIfNull: false)
  final DateTime lastSyncedDate;
  static const fromJsonFactory = _$UpdateOrderRequestFromJson;
  static const toJsonFactory = _$UpdateOrderRequestToJson;
  Map<String, dynamic> toJson() => _$UpdateOrderRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UpdateOrderRequest &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.lastSyncedDate, lastSyncedDate) ||
                const DeepCollectionEquality()
                    .equals(other.lastSyncedDate, lastSyncedDate)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(lastSyncedDate) ^
      runtimeType.hashCode;
}

extension $UpdateOrderRequestExtension on UpdateOrderRequest {
  UpdateOrderRequest copyWith(
      {List<UpdateItemRequest>? items, DateTime? lastSyncedDate}) {
    return UpdateOrderRequest(
        items: items ?? this.items,
        lastSyncedDate: lastSyncedDate ?? this.lastSyncedDate);
  }

  UpdateOrderRequest copyWithWrapped(
      {Wrapped<List<UpdateItemRequest>>? items,
      Wrapped<DateTime>? lastSyncedDate}) {
    return UpdateOrderRequest(
        items: (items != null ? items.value : this.items),
        lastSyncedDate: (lastSyncedDate != null
            ? lastSyncedDate.value
            : this.lastSyncedDate));
  }
}

@JsonSerializable(explicitToJson: true)
class UpdateOrderResponse {
  UpdateOrderResponse({
    this.deliveryInformation,
    required this.isDeliveryInfoLocked,
    required this.items,
    this.lastSyncedDate,
    required this.order,
    required this.totalPrice,
  });

  factory UpdateOrderResponse.fromJson(Map<String, dynamic> json) =>
      _$UpdateOrderResponseFromJson(json);

  @JsonKey(name: 'deliveryInformation', includeIfNull: false)
  final DeliveryInformation? deliveryInformation;
  @JsonKey(name: 'isDeliveryInfoLocked', includeIfNull: false)
  final bool isDeliveryInfoLocked;
  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <Item>[])
  final List<Item> items;
  @JsonKey(name: 'lastSyncedDate', includeIfNull: false)
  final DateTime? lastSyncedDate;
  @JsonKey(name: 'order', includeIfNull: false)
  final Order order;
  @JsonKey(name: 'totalPrice', includeIfNull: false)
  final OrderTotalPrice totalPrice;
  static const fromJsonFactory = _$UpdateOrderResponseFromJson;
  static const toJsonFactory = _$UpdateOrderResponseToJson;
  Map<String, dynamic> toJson() => _$UpdateOrderResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UpdateOrderResponse &&
            (identical(other.deliveryInformation, deliveryInformation) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryInformation, deliveryInformation)) &&
            (identical(other.isDeliveryInfoLocked, isDeliveryInfoLocked) ||
                const DeepCollectionEquality().equals(
                    other.isDeliveryInfoLocked, isDeliveryInfoLocked)) &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.lastSyncedDate, lastSyncedDate) ||
                const DeepCollectionEquality()
                    .equals(other.lastSyncedDate, lastSyncedDate)) &&
            (identical(other.order, order) ||
                const DeepCollectionEquality().equals(other.order, order)) &&
            (identical(other.totalPrice, totalPrice) ||
                const DeepCollectionEquality()
                    .equals(other.totalPrice, totalPrice)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(deliveryInformation) ^
      const DeepCollectionEquality().hash(isDeliveryInfoLocked) ^
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(lastSyncedDate) ^
      const DeepCollectionEquality().hash(order) ^
      const DeepCollectionEquality().hash(totalPrice) ^
      runtimeType.hashCode;
}

extension $UpdateOrderResponseExtension on UpdateOrderResponse {
  UpdateOrderResponse copyWith(
      {DeliveryInformation? deliveryInformation,
      bool? isDeliveryInfoLocked,
      List<Item>? items,
      DateTime? lastSyncedDate,
      Order? order,
      OrderTotalPrice? totalPrice}) {
    return UpdateOrderResponse(
        deliveryInformation: deliveryInformation ?? this.deliveryInformation,
        isDeliveryInfoLocked: isDeliveryInfoLocked ?? this.isDeliveryInfoLocked,
        items: items ?? this.items,
        lastSyncedDate: lastSyncedDate ?? this.lastSyncedDate,
        order: order ?? this.order,
        totalPrice: totalPrice ?? this.totalPrice);
  }

  UpdateOrderResponse copyWithWrapped(
      {Wrapped<DeliveryInformation?>? deliveryInformation,
      Wrapped<bool>? isDeliveryInfoLocked,
      Wrapped<List<Item>>? items,
      Wrapped<DateTime?>? lastSyncedDate,
      Wrapped<Order>? order,
      Wrapped<OrderTotalPrice>? totalPrice}) {
    return UpdateOrderResponse(
        deliveryInformation: (deliveryInformation != null
            ? deliveryInformation.value
            : this.deliveryInformation),
        isDeliveryInfoLocked: (isDeliveryInfoLocked != null
            ? isDeliveryInfoLocked.value
            : this.isDeliveryInfoLocked),
        items: (items != null ? items.value : this.items),
        lastSyncedDate: (lastSyncedDate != null
            ? lastSyncedDate.value
            : this.lastSyncedDate),
        order: (order != null ? order.value : this.order),
        totalPrice: (totalPrice != null ? totalPrice.value : this.totalPrice));
  }
}

@JsonSerializable(explicitToJson: true)
class UpdateOrderSlotRequest {
  UpdateOrderSlotRequest({
    required this.date,
    required this.deliveryLocationId,
    this.pickupLocationId,
    required this.shiftCode,
  });

  factory UpdateOrderSlotRequest.fromJson(Map<String, dynamic> json) =>
      _$UpdateOrderSlotRequestFromJson(json);

  @JsonKey(name: 'date', includeIfNull: false, toJson: _dateToJson)
  final DateTime date;
  @JsonKey(name: 'deliveryLocationId', includeIfNull: false)
  final num deliveryLocationId;
  @JsonKey(name: 'pickupLocationId', includeIfNull: false)
  final num? pickupLocationId;
  @JsonKey(name: 'shiftCode', includeIfNull: false, defaultValue: '')
  final String shiftCode;
  static const fromJsonFactory = _$UpdateOrderSlotRequestFromJson;
  static const toJsonFactory = _$UpdateOrderSlotRequestToJson;
  Map<String, dynamic> toJson() => _$UpdateOrderSlotRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UpdateOrderSlotRequest &&
            (identical(other.date, date) ||
                const DeepCollectionEquality().equals(other.date, date)) &&
            (identical(other.deliveryLocationId, deliveryLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryLocationId, deliveryLocationId)) &&
            (identical(other.pickupLocationId, pickupLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.pickupLocationId, pickupLocationId)) &&
            (identical(other.shiftCode, shiftCode) ||
                const DeepCollectionEquality()
                    .equals(other.shiftCode, shiftCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(date) ^
      const DeepCollectionEquality().hash(deliveryLocationId) ^
      const DeepCollectionEquality().hash(pickupLocationId) ^
      const DeepCollectionEquality().hash(shiftCode) ^
      runtimeType.hashCode;
}

extension $UpdateOrderSlotRequestExtension on UpdateOrderSlotRequest {
  UpdateOrderSlotRequest copyWith(
      {DateTime? date,
      num? deliveryLocationId,
      num? pickupLocationId,
      String? shiftCode}) {
    return UpdateOrderSlotRequest(
        date: date ?? this.date,
        deliveryLocationId: deliveryLocationId ?? this.deliveryLocationId,
        pickupLocationId: pickupLocationId ?? this.pickupLocationId,
        shiftCode: shiftCode ?? this.shiftCode);
  }

  UpdateOrderSlotRequest copyWithWrapped(
      {Wrapped<DateTime>? date,
      Wrapped<num>? deliveryLocationId,
      Wrapped<num?>? pickupLocationId,
      Wrapped<String>? shiftCode}) {
    return UpdateOrderSlotRequest(
        date: (date != null ? date.value : this.date),
        deliveryLocationId: (deliveryLocationId != null
            ? deliveryLocationId.value
            : this.deliveryLocationId),
        pickupLocationId: (pickupLocationId != null
            ? pickupLocationId.value
            : this.pickupLocationId),
        shiftCode: (shiftCode != null ? shiftCode.value : this.shiftCode));
  }
}

@JsonSerializable(explicitToJson: true)
class UpdateSampleRequest {
  UpdateSampleRequest({
    required this.isRejected,
    required this.sampleId,
  });

  factory UpdateSampleRequest.fromJson(Map<String, dynamic> json) =>
      _$UpdateSampleRequestFromJson(json);

  @JsonKey(name: 'isRejected', includeIfNull: false)
  final bool isRejected;
  @JsonKey(name: 'sampleId', includeIfNull: false)
  final num sampleId;
  static const fromJsonFactory = _$UpdateSampleRequestFromJson;
  static const toJsonFactory = _$UpdateSampleRequestToJson;
  Map<String, dynamic> toJson() => _$UpdateSampleRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UpdateSampleRequest &&
            (identical(other.isRejected, isRejected) ||
                const DeepCollectionEquality()
                    .equals(other.isRejected, isRejected)) &&
            (identical(other.sampleId, sampleId) ||
                const DeepCollectionEquality()
                    .equals(other.sampleId, sampleId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(isRejected) ^
      const DeepCollectionEquality().hash(sampleId) ^
      runtimeType.hashCode;
}

extension $UpdateSampleRequestExtension on UpdateSampleRequest {
  UpdateSampleRequest copyWith({bool? isRejected, num? sampleId}) {
    return UpdateSampleRequest(
        isRejected: isRejected ?? this.isRejected,
        sampleId: sampleId ?? this.sampleId);
  }

  UpdateSampleRequest copyWithWrapped(
      {Wrapped<bool>? isRejected, Wrapped<num>? sampleId}) {
    return UpdateSampleRequest(
        isRejected: (isRejected != null ? isRejected.value : this.isRejected),
        sampleId: (sampleId != null ? sampleId.value : this.sampleId));
  }
}

@JsonSerializable(explicitToJson: true)
class UpdateSampleResponse {
  UpdateSampleResponse({
    required this.message,
    required this.orderId,
    required this.rejected,
    required this.sampleId,
  });

  factory UpdateSampleResponse.fromJson(Map<String, dynamic> json) =>
      _$UpdateSampleResponseFromJson(json);

  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String message;
  @JsonKey(name: 'orderId', includeIfNull: false)
  final num orderId;
  @JsonKey(name: 'rejected', includeIfNull: false)
  final bool rejected;
  @JsonKey(name: 'sampleId', includeIfNull: false)
  final num sampleId;
  static const fromJsonFactory = _$UpdateSampleResponseFromJson;
  static const toJsonFactory = _$UpdateSampleResponseToJson;
  Map<String, dynamic> toJson() => _$UpdateSampleResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UpdateSampleResponse &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.rejected, rejected) ||
                const DeepCollectionEquality()
                    .equals(other.rejected, rejected)) &&
            (identical(other.sampleId, sampleId) ||
                const DeepCollectionEquality()
                    .equals(other.sampleId, sampleId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(orderId) ^
      const DeepCollectionEquality().hash(rejected) ^
      const DeepCollectionEquality().hash(sampleId) ^
      runtimeType.hashCode;
}

extension $UpdateSampleResponseExtension on UpdateSampleResponse {
  UpdateSampleResponse copyWith(
      {String? message, num? orderId, bool? rejected, num? sampleId}) {
    return UpdateSampleResponse(
        message: message ?? this.message,
        orderId: orderId ?? this.orderId,
        rejected: rejected ?? this.rejected,
        sampleId: sampleId ?? this.sampleId);
  }

  UpdateSampleResponse copyWithWrapped(
      {Wrapped<String>? message,
      Wrapped<num>? orderId,
      Wrapped<bool>? rejected,
      Wrapped<num>? sampleId}) {
    return UpdateSampleResponse(
        message: (message != null ? message.value : this.message),
        orderId: (orderId != null ? orderId.value : this.orderId),
        rejected: (rejected != null ? rejected.value : this.rejected),
        sampleId: (sampleId != null ? sampleId.value : this.sampleId));
  }
}

@JsonSerializable(explicitToJson: true)
class UpdateSlotResponse {
  UpdateSlotResponse({
    required this.lastSyncedDate,
  });

  factory UpdateSlotResponse.fromJson(Map<String, dynamic> json) =>
      _$UpdateSlotResponseFromJson(json);

  @JsonKey(name: 'lastSyncedDate', includeIfNull: false)
  final DateTime lastSyncedDate;
  static const fromJsonFactory = _$UpdateSlotResponseFromJson;
  static const toJsonFactory = _$UpdateSlotResponseToJson;
  Map<String, dynamic> toJson() => _$UpdateSlotResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UpdateSlotResponse &&
            (identical(other.lastSyncedDate, lastSyncedDate) ||
                const DeepCollectionEquality()
                    .equals(other.lastSyncedDate, lastSyncedDate)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(lastSyncedDate) ^
      runtimeType.hashCode;
}

extension $UpdateSlotResponseExtension on UpdateSlotResponse {
  UpdateSlotResponse copyWith({DateTime? lastSyncedDate}) {
    return UpdateSlotResponse(
        lastSyncedDate: lastSyncedDate ?? this.lastSyncedDate);
  }

  UpdateSlotResponse copyWithWrapped({Wrapped<DateTime>? lastSyncedDate}) {
    return UpdateSlotResponse(
        lastSyncedDate: (lastSyncedDate != null
            ? lastSyncedDate.value
            : this.lastSyncedDate));
  }
}

@JsonSerializable(explicitToJson: true)
class UpdateSlotResponseV7 {
  UpdateSlotResponseV7({
    required this.syncTimes,
  });

  factory UpdateSlotResponseV7.fromJson(Map<String, dynamic> json) =>
      _$UpdateSlotResponseV7FromJson(json);

  @JsonKey(name: 'syncTimes', includeIfNull: false)
  final SyncTimesV7 syncTimes;
  static const fromJsonFactory = _$UpdateSlotResponseV7FromJson;
  static const toJsonFactory = _$UpdateSlotResponseV7ToJson;
  Map<String, dynamic> toJson() => _$UpdateSlotResponseV7ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UpdateSlotResponseV7 &&
            (identical(other.syncTimes, syncTimes) ||
                const DeepCollectionEquality()
                    .equals(other.syncTimes, syncTimes)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(syncTimes) ^ runtimeType.hashCode;
}

extension $UpdateSlotResponseV7Extension on UpdateSlotResponseV7 {
  UpdateSlotResponseV7 copyWith({SyncTimesV7? syncTimes}) {
    return UpdateSlotResponseV7(syncTimes: syncTimes ?? this.syncTimes);
  }

  UpdateSlotResponseV7 copyWithWrapped({Wrapped<SyncTimesV7>? syncTimes}) {
    return UpdateSlotResponseV7(
        syncTimes: (syncTimes != null ? syncTimes.value : this.syncTimes));
  }
}

@JsonSerializable(explicitToJson: true)
class ValidationData {
  ValidationData({
    this.categoryName,
    this.errorType,
    this.minimalAmount,
    this.mov,
    this.orderLines,
    this.totalAmount,
  });

  factory ValidationData.fromJson(Map<String, dynamic> json) =>
      _$ValidationDataFromJson(json);

  @JsonKey(name: 'categoryName', includeIfNull: false, defaultValue: '')
  final String? categoryName;
  @JsonKey(name: 'errorType', includeIfNull: false, defaultValue: '')
  final String? errorType;
  @JsonKey(name: 'minimalAmount', includeIfNull: false)
  final Amount? minimalAmount;
  @JsonKey(name: 'mov', includeIfNull: false)
  final int? mov;
  @JsonKey(
      name: 'orderLines',
      includeIfNull: false,
      defaultValue: <ValidationOrderLine>[])
  final List<ValidationOrderLine>? orderLines;
  @JsonKey(name: 'totalAmount', includeIfNull: false)
  final Amount? totalAmount;
  static const fromJsonFactory = _$ValidationDataFromJson;
  static const toJsonFactory = _$ValidationDataToJson;
  Map<String, dynamic> toJson() => _$ValidationDataToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ValidationData &&
            (identical(other.categoryName, categoryName) ||
                const DeepCollectionEquality()
                    .equals(other.categoryName, categoryName)) &&
            (identical(other.errorType, errorType) ||
                const DeepCollectionEquality()
                    .equals(other.errorType, errorType)) &&
            (identical(other.minimalAmount, minimalAmount) ||
                const DeepCollectionEquality()
                    .equals(other.minimalAmount, minimalAmount)) &&
            (identical(other.mov, mov) ||
                const DeepCollectionEquality().equals(other.mov, mov)) &&
            (identical(other.orderLines, orderLines) ||
                const DeepCollectionEquality()
                    .equals(other.orderLines, orderLines)) &&
            (identical(other.totalAmount, totalAmount) ||
                const DeepCollectionEquality()
                    .equals(other.totalAmount, totalAmount)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(categoryName) ^
      const DeepCollectionEquality().hash(errorType) ^
      const DeepCollectionEquality().hash(minimalAmount) ^
      const DeepCollectionEquality().hash(mov) ^
      const DeepCollectionEquality().hash(orderLines) ^
      const DeepCollectionEquality().hash(totalAmount) ^
      runtimeType.hashCode;
}

extension $ValidationDataExtension on ValidationData {
  ValidationData copyWith(
      {String? categoryName,
      String? errorType,
      Amount? minimalAmount,
      int? mov,
      List<ValidationOrderLine>? orderLines,
      Amount? totalAmount}) {
    return ValidationData(
        categoryName: categoryName ?? this.categoryName,
        errorType: errorType ?? this.errorType,
        minimalAmount: minimalAmount ?? this.minimalAmount,
        mov: mov ?? this.mov,
        orderLines: orderLines ?? this.orderLines,
        totalAmount: totalAmount ?? this.totalAmount);
  }

  ValidationData copyWithWrapped(
      {Wrapped<String?>? categoryName,
      Wrapped<String?>? errorType,
      Wrapped<Amount?>? minimalAmount,
      Wrapped<int?>? mov,
      Wrapped<List<ValidationOrderLine>?>? orderLines,
      Wrapped<Amount?>? totalAmount}) {
    return ValidationData(
        categoryName:
            (categoryName != null ? categoryName.value : this.categoryName),
        errorType: (errorType != null ? errorType.value : this.errorType),
        minimalAmount:
            (minimalAmount != null ? minimalAmount.value : this.minimalAmount),
        mov: (mov != null ? mov.value : this.mov),
        orderLines: (orderLines != null ? orderLines.value : this.orderLines),
        totalAmount:
            (totalAmount != null ? totalAmount.value : this.totalAmount));
  }
}

@JsonSerializable(explicitToJson: true)
class ValidationOrderLine {
  ValidationOrderLine({
    required this.available,
    required this.count,
    required this.limitType,
    this.product,
    required this.productId,
  });

  factory ValidationOrderLine.fromJson(Map<String, dynamic> json) =>
      _$ValidationOrderLineFromJson(json);

  @JsonKey(name: 'available', includeIfNull: false)
  final int available;
  @JsonKey(name: 'count', includeIfNull: false)
  final int count;
  @JsonKey(name: 'limitType', includeIfNull: false, defaultValue: '')
  final String limitType;
  @JsonKey(name: 'product', includeIfNull: false)
  final ProductCard? product;
  @JsonKey(name: 'productId', includeIfNull: false)
  final num productId;
  static const fromJsonFactory = _$ValidationOrderLineFromJson;
  static const toJsonFactory = _$ValidationOrderLineToJson;
  Map<String, dynamic> toJson() => _$ValidationOrderLineToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ValidationOrderLine &&
            (identical(other.available, available) ||
                const DeepCollectionEquality()
                    .equals(other.available, available)) &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.limitType, limitType) ||
                const DeepCollectionEquality()
                    .equals(other.limitType, limitType)) &&
            (identical(other.product, product) ||
                const DeepCollectionEquality()
                    .equals(other.product, product)) &&
            (identical(other.productId, productId) ||
                const DeepCollectionEquality()
                    .equals(other.productId, productId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(available) ^
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(limitType) ^
      const DeepCollectionEquality().hash(product) ^
      const DeepCollectionEquality().hash(productId) ^
      runtimeType.hashCode;
}

extension $ValidationOrderLineExtension on ValidationOrderLine {
  ValidationOrderLine copyWith(
      {int? available,
      int? count,
      String? limitType,
      ProductCard? product,
      num? productId}) {
    return ValidationOrderLine(
        available: available ?? this.available,
        count: count ?? this.count,
        limitType: limitType ?? this.limitType,
        product: product ?? this.product,
        productId: productId ?? this.productId);
  }

  ValidationOrderLine copyWithWrapped(
      {Wrapped<int>? available,
      Wrapped<int>? count,
      Wrapped<String>? limitType,
      Wrapped<ProductCard?>? product,
      Wrapped<num>? productId}) {
    return ValidationOrderLine(
        available: (available != null ? available.value : this.available),
        count: (count != null ? count.value : this.count),
        limitType: (limitType != null ? limitType.value : this.limitType),
        product: (product != null ? product.value : this.product),
        productId: (productId != null ? productId.value : this.productId));
  }
}

String? activeOrderAndListSummaryShoppingTypeToJson(
    enums.ActiveOrderAndListSummaryShoppingType?
        activeOrderAndListSummaryShoppingType) {
  return enums.$ActiveOrderAndListSummaryShoppingTypeMap[
      activeOrderAndListSummaryShoppingType];
}

enums.ActiveOrderAndListSummaryShoppingType
    activeOrderAndListSummaryShoppingTypeFromJson(
  Object? activeOrderAndListSummaryShoppingType, [
  enums.ActiveOrderAndListSummaryShoppingType? defaultValue,
]) {
  if (activeOrderAndListSummaryShoppingType is String) {
    return enums.$ActiveOrderAndListSummaryShoppingTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                activeOrderAndListSummaryShoppingType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ActiveOrderAndListSummaryShoppingType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ActiveOrderAndListSummaryShoppingTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ActiveOrderAndListSummaryShoppingType.swaggerGeneratedUnknown;
}

List<String> activeOrderAndListSummaryShoppingTypeListToJson(
    List<enums.ActiveOrderAndListSummaryShoppingType>?
        activeOrderAndListSummaryShoppingType) {
  if (activeOrderAndListSummaryShoppingType == null) {
    return [];
  }

  return activeOrderAndListSummaryShoppingType
      .map((e) => enums.$ActiveOrderAndListSummaryShoppingTypeMap[e]!)
      .toList();
}

List<enums.ActiveOrderAndListSummaryShoppingType>
    activeOrderAndListSummaryShoppingTypeListFromJson(
  List? activeOrderAndListSummaryShoppingType, [
  List<enums.ActiveOrderAndListSummaryShoppingType>? defaultValue,
]) {
  if (activeOrderAndListSummaryShoppingType == null) {
    return defaultValue ?? [];
  }

  return activeOrderAndListSummaryShoppingType
      .map((e) => activeOrderAndListSummaryShoppingTypeFromJson(e.toString()))
      .toList();
}

List<enums.ActiveOrderAndListSummaryShoppingType>?
    activeOrderAndListSummaryShoppingTypeNullableListFromJson(
  List? activeOrderAndListSummaryShoppingType, [
  List<enums.ActiveOrderAndListSummaryShoppingType>? defaultValue,
]) {
  if (activeOrderAndListSummaryShoppingType == null) {
    return defaultValue;
  }

  return activeOrderAndListSummaryShoppingType
      .map((e) => activeOrderAndListSummaryShoppingTypeFromJson(e.toString()))
      .toList();
}

String? activeOrderAndListSummaryStateToJson(
    enums.ActiveOrderAndListSummaryState? activeOrderAndListSummaryState) {
  return enums
      .$ActiveOrderAndListSummaryStateMap[activeOrderAndListSummaryState];
}

enums.ActiveOrderAndListSummaryState activeOrderAndListSummaryStateFromJson(
  Object? activeOrderAndListSummaryState, [
  enums.ActiveOrderAndListSummaryState? defaultValue,
]) {
  if (activeOrderAndListSummaryState is String) {
    return enums.$ActiveOrderAndListSummaryStateMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                activeOrderAndListSummaryState.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ActiveOrderAndListSummaryState.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ActiveOrderAndListSummaryStateMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ActiveOrderAndListSummaryState.swaggerGeneratedUnknown;
}

List<String> activeOrderAndListSummaryStateListToJson(
    List<enums.ActiveOrderAndListSummaryState>?
        activeOrderAndListSummaryState) {
  if (activeOrderAndListSummaryState == null) {
    return [];
  }

  return activeOrderAndListSummaryState
      .map((e) => enums.$ActiveOrderAndListSummaryStateMap[e]!)
      .toList();
}

List<enums.ActiveOrderAndListSummaryState>
    activeOrderAndListSummaryStateListFromJson(
  List? activeOrderAndListSummaryState, [
  List<enums.ActiveOrderAndListSummaryState>? defaultValue,
]) {
  if (activeOrderAndListSummaryState == null) {
    return defaultValue ?? [];
  }

  return activeOrderAndListSummaryState
      .map((e) => activeOrderAndListSummaryStateFromJson(e.toString()))
      .toList();
}

List<enums.ActiveOrderAndListSummaryState>?
    activeOrderAndListSummaryStateNullableListFromJson(
  List? activeOrderAndListSummaryState, [
  List<enums.ActiveOrderAndListSummaryState>? defaultValue,
]) {
  if (activeOrderAndListSummaryState == null) {
    return defaultValue;
  }

  return activeOrderAndListSummaryState
      .map((e) => activeOrderAndListSummaryStateFromJson(e.toString()))
      .toList();
}

String? activeOrderAndListSummaryV7ShoppingTypeToJson(
    enums.ActiveOrderAndListSummaryV7ShoppingType?
        activeOrderAndListSummaryV7ShoppingType) {
  return enums.$ActiveOrderAndListSummaryV7ShoppingTypeMap[
      activeOrderAndListSummaryV7ShoppingType];
}

enums.ActiveOrderAndListSummaryV7ShoppingType
    activeOrderAndListSummaryV7ShoppingTypeFromJson(
  Object? activeOrderAndListSummaryV7ShoppingType, [
  enums.ActiveOrderAndListSummaryV7ShoppingType? defaultValue,
]) {
  if (activeOrderAndListSummaryV7ShoppingType is String) {
    return enums.$ActiveOrderAndListSummaryV7ShoppingTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                activeOrderAndListSummaryV7ShoppingType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ActiveOrderAndListSummaryV7ShoppingType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ActiveOrderAndListSummaryV7ShoppingTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ActiveOrderAndListSummaryV7ShoppingType.swaggerGeneratedUnknown;
}

List<String> activeOrderAndListSummaryV7ShoppingTypeListToJson(
    List<enums.ActiveOrderAndListSummaryV7ShoppingType>?
        activeOrderAndListSummaryV7ShoppingType) {
  if (activeOrderAndListSummaryV7ShoppingType == null) {
    return [];
  }

  return activeOrderAndListSummaryV7ShoppingType
      .map((e) => enums.$ActiveOrderAndListSummaryV7ShoppingTypeMap[e]!)
      .toList();
}

List<enums.ActiveOrderAndListSummaryV7ShoppingType>
    activeOrderAndListSummaryV7ShoppingTypeListFromJson(
  List? activeOrderAndListSummaryV7ShoppingType, [
  List<enums.ActiveOrderAndListSummaryV7ShoppingType>? defaultValue,
]) {
  if (activeOrderAndListSummaryV7ShoppingType == null) {
    return defaultValue ?? [];
  }

  return activeOrderAndListSummaryV7ShoppingType
      .map((e) => activeOrderAndListSummaryV7ShoppingTypeFromJson(e.toString()))
      .toList();
}

List<enums.ActiveOrderAndListSummaryV7ShoppingType>?
    activeOrderAndListSummaryV7ShoppingTypeNullableListFromJson(
  List? activeOrderAndListSummaryV7ShoppingType, [
  List<enums.ActiveOrderAndListSummaryV7ShoppingType>? defaultValue,
]) {
  if (activeOrderAndListSummaryV7ShoppingType == null) {
    return defaultValue;
  }

  return activeOrderAndListSummaryV7ShoppingType
      .map((e) => activeOrderAndListSummaryV7ShoppingTypeFromJson(e.toString()))
      .toList();
}

String? activeOrderAndListSummaryV7StateToJson(
    enums.ActiveOrderAndListSummaryV7State? activeOrderAndListSummaryV7State) {
  return enums
      .$ActiveOrderAndListSummaryV7StateMap[activeOrderAndListSummaryV7State];
}

enums.ActiveOrderAndListSummaryV7State activeOrderAndListSummaryV7StateFromJson(
  Object? activeOrderAndListSummaryV7State, [
  enums.ActiveOrderAndListSummaryV7State? defaultValue,
]) {
  if (activeOrderAndListSummaryV7State is String) {
    return enums.$ActiveOrderAndListSummaryV7StateMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                activeOrderAndListSummaryV7State.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ActiveOrderAndListSummaryV7State.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ActiveOrderAndListSummaryV7StateMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ActiveOrderAndListSummaryV7State.swaggerGeneratedUnknown;
}

List<String> activeOrderAndListSummaryV7StateListToJson(
    List<enums.ActiveOrderAndListSummaryV7State>?
        activeOrderAndListSummaryV7State) {
  if (activeOrderAndListSummaryV7State == null) {
    return [];
  }

  return activeOrderAndListSummaryV7State
      .map((e) => enums.$ActiveOrderAndListSummaryV7StateMap[e]!)
      .toList();
}

List<enums.ActiveOrderAndListSummaryV7State>
    activeOrderAndListSummaryV7StateListFromJson(
  List? activeOrderAndListSummaryV7State, [
  List<enums.ActiveOrderAndListSummaryV7State>? defaultValue,
]) {
  if (activeOrderAndListSummaryV7State == null) {
    return defaultValue ?? [];
  }

  return activeOrderAndListSummaryV7State
      .map((e) => activeOrderAndListSummaryV7StateFromJson(e.toString()))
      .toList();
}

List<enums.ActiveOrderAndListSummaryV7State>?
    activeOrderAndListSummaryV7StateNullableListFromJson(
  List? activeOrderAndListSummaryV7State, [
  List<enums.ActiveOrderAndListSummaryV7State>? defaultValue,
]) {
  if (activeOrderAndListSummaryV7State == null) {
    return defaultValue;
  }

  return activeOrderAndListSummaryV7State
      .map((e) => activeOrderAndListSummaryV7StateFromJson(e.toString()))
      .toList();
}

String? createOrderRequestOrderMethodToJson(
    enums.CreateOrderRequestOrderMethod? createOrderRequestOrderMethod) {
  return enums.$CreateOrderRequestOrderMethodMap[createOrderRequestOrderMethod];
}

enums.CreateOrderRequestOrderMethod createOrderRequestOrderMethodFromJson(
  Object? createOrderRequestOrderMethod, [
  enums.CreateOrderRequestOrderMethod? defaultValue,
]) {
  if (createOrderRequestOrderMethod is String) {
    return enums.$CreateOrderRequestOrderMethodMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                createOrderRequestOrderMethod.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CreateOrderRequestOrderMethod.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CreateOrderRequestOrderMethodMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CreateOrderRequestOrderMethod.swaggerGeneratedUnknown;
}

List<String> createOrderRequestOrderMethodListToJson(
    List<enums.CreateOrderRequestOrderMethod>? createOrderRequestOrderMethod) {
  if (createOrderRequestOrderMethod == null) {
    return [];
  }

  return createOrderRequestOrderMethod
      .map((e) => enums.$CreateOrderRequestOrderMethodMap[e]!)
      .toList();
}

List<enums.CreateOrderRequestOrderMethod>
    createOrderRequestOrderMethodListFromJson(
  List? createOrderRequestOrderMethod, [
  List<enums.CreateOrderRequestOrderMethod>? defaultValue,
]) {
  if (createOrderRequestOrderMethod == null) {
    return defaultValue ?? [];
  }

  return createOrderRequestOrderMethod
      .map((e) => createOrderRequestOrderMethodFromJson(e.toString()))
      .toList();
}

List<enums.CreateOrderRequestOrderMethod>?
    createOrderRequestOrderMethodNullableListFromJson(
  List? createOrderRequestOrderMethod, [
  List<enums.CreateOrderRequestOrderMethod>? defaultValue,
]) {
  if (createOrderRequestOrderMethod == null) {
    return defaultValue;
  }

  return createOrderRequestOrderMethod
      .map((e) => createOrderRequestOrderMethodFromJson(e.toString()))
      .toList();
}

String? createOrderResponseShoppingTypeToJson(
    enums.CreateOrderResponseShoppingType? createOrderResponseShoppingType) {
  return enums
      .$CreateOrderResponseShoppingTypeMap[createOrderResponseShoppingType];
}

enums.CreateOrderResponseShoppingType createOrderResponseShoppingTypeFromJson(
  Object? createOrderResponseShoppingType, [
  enums.CreateOrderResponseShoppingType? defaultValue,
]) {
  if (createOrderResponseShoppingType is String) {
    return enums.$CreateOrderResponseShoppingTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                createOrderResponseShoppingType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CreateOrderResponseShoppingType.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CreateOrderResponseShoppingTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CreateOrderResponseShoppingType.swaggerGeneratedUnknown;
}

List<String> createOrderResponseShoppingTypeListToJson(
    List<enums.CreateOrderResponseShoppingType>?
        createOrderResponseShoppingType) {
  if (createOrderResponseShoppingType == null) {
    return [];
  }

  return createOrderResponseShoppingType
      .map((e) => enums.$CreateOrderResponseShoppingTypeMap[e]!)
      .toList();
}

List<enums.CreateOrderResponseShoppingType>
    createOrderResponseShoppingTypeListFromJson(
  List? createOrderResponseShoppingType, [
  List<enums.CreateOrderResponseShoppingType>? defaultValue,
]) {
  if (createOrderResponseShoppingType == null) {
    return defaultValue ?? [];
  }

  return createOrderResponseShoppingType
      .map((e) => createOrderResponseShoppingTypeFromJson(e.toString()))
      .toList();
}

List<enums.CreateOrderResponseShoppingType>?
    createOrderResponseShoppingTypeNullableListFromJson(
  List? createOrderResponseShoppingType, [
  List<enums.CreateOrderResponseShoppingType>? defaultValue,
]) {
  if (createOrderResponseShoppingType == null) {
    return defaultValue;
  }

  return createOrderResponseShoppingType
      .map((e) => createOrderResponseShoppingTypeFromJson(e.toString()))
      .toList();
}

String? createOrderResponseStateToJson(
    enums.CreateOrderResponseState? createOrderResponseState) {
  return enums.$CreateOrderResponseStateMap[createOrderResponseState];
}

enums.CreateOrderResponseState createOrderResponseStateFromJson(
  Object? createOrderResponseState, [
  enums.CreateOrderResponseState? defaultValue,
]) {
  if (createOrderResponseState is String) {
    return enums.$CreateOrderResponseStateMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                createOrderResponseState.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CreateOrderResponseState.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CreateOrderResponseStateMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CreateOrderResponseState.swaggerGeneratedUnknown;
}

List<String> createOrderResponseStateListToJson(
    List<enums.CreateOrderResponseState>? createOrderResponseState) {
  if (createOrderResponseState == null) {
    return [];
  }

  return createOrderResponseState
      .map((e) => enums.$CreateOrderResponseStateMap[e]!)
      .toList();
}

List<enums.CreateOrderResponseState> createOrderResponseStateListFromJson(
  List? createOrderResponseState, [
  List<enums.CreateOrderResponseState>? defaultValue,
]) {
  if (createOrderResponseState == null) {
    return defaultValue ?? [];
  }

  return createOrderResponseState
      .map((e) => createOrderResponseStateFromJson(e.toString()))
      .toList();
}

List<enums.CreateOrderResponseState>?
    createOrderResponseStateNullableListFromJson(
  List? createOrderResponseState, [
  List<enums.CreateOrderResponseState>? defaultValue,
]) {
  if (createOrderResponseState == null) {
    return defaultValue;
  }

  return createOrderResponseState
      .map((e) => createOrderResponseStateFromJson(e.toString()))
      .toList();
}

String? createOrderResponseV6ShoppingTypeToJson(
    enums.CreateOrderResponseV6ShoppingType?
        createOrderResponseV6ShoppingType) {
  return enums
      .$CreateOrderResponseV6ShoppingTypeMap[createOrderResponseV6ShoppingType];
}

enums.CreateOrderResponseV6ShoppingType
    createOrderResponseV6ShoppingTypeFromJson(
  Object? createOrderResponseV6ShoppingType, [
  enums.CreateOrderResponseV6ShoppingType? defaultValue,
]) {
  if (createOrderResponseV6ShoppingType is String) {
    return enums.$CreateOrderResponseV6ShoppingTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                createOrderResponseV6ShoppingType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CreateOrderResponseV6ShoppingType.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CreateOrderResponseV6ShoppingTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CreateOrderResponseV6ShoppingType.swaggerGeneratedUnknown;
}

List<String> createOrderResponseV6ShoppingTypeListToJson(
    List<enums.CreateOrderResponseV6ShoppingType>?
        createOrderResponseV6ShoppingType) {
  if (createOrderResponseV6ShoppingType == null) {
    return [];
  }

  return createOrderResponseV6ShoppingType
      .map((e) => enums.$CreateOrderResponseV6ShoppingTypeMap[e]!)
      .toList();
}

List<enums.CreateOrderResponseV6ShoppingType>
    createOrderResponseV6ShoppingTypeListFromJson(
  List? createOrderResponseV6ShoppingType, [
  List<enums.CreateOrderResponseV6ShoppingType>? defaultValue,
]) {
  if (createOrderResponseV6ShoppingType == null) {
    return defaultValue ?? [];
  }

  return createOrderResponseV6ShoppingType
      .map((e) => createOrderResponseV6ShoppingTypeFromJson(e.toString()))
      .toList();
}

List<enums.CreateOrderResponseV6ShoppingType>?
    createOrderResponseV6ShoppingTypeNullableListFromJson(
  List? createOrderResponseV6ShoppingType, [
  List<enums.CreateOrderResponseV6ShoppingType>? defaultValue,
]) {
  if (createOrderResponseV6ShoppingType == null) {
    return defaultValue;
  }

  return createOrderResponseV6ShoppingType
      .map((e) => createOrderResponseV6ShoppingTypeFromJson(e.toString()))
      .toList();
}

String? createOrderResponseV6StateToJson(
    enums.CreateOrderResponseV6State? createOrderResponseV6State) {
  return enums.$CreateOrderResponseV6StateMap[createOrderResponseV6State];
}

enums.CreateOrderResponseV6State createOrderResponseV6StateFromJson(
  Object? createOrderResponseV6State, [
  enums.CreateOrderResponseV6State? defaultValue,
]) {
  if (createOrderResponseV6State is String) {
    return enums.$CreateOrderResponseV6StateMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                createOrderResponseV6State.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CreateOrderResponseV6State.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CreateOrderResponseV6StateMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CreateOrderResponseV6State.swaggerGeneratedUnknown;
}

List<String> createOrderResponseV6StateListToJson(
    List<enums.CreateOrderResponseV6State>? createOrderResponseV6State) {
  if (createOrderResponseV6State == null) {
    return [];
  }

  return createOrderResponseV6State
      .map((e) => enums.$CreateOrderResponseV6StateMap[e]!)
      .toList();
}

List<enums.CreateOrderResponseV6State> createOrderResponseV6StateListFromJson(
  List? createOrderResponseV6State, [
  List<enums.CreateOrderResponseV6State>? defaultValue,
]) {
  if (createOrderResponseV6State == null) {
    return defaultValue ?? [];
  }

  return createOrderResponseV6State
      .map((e) => createOrderResponseV6StateFromJson(e.toString()))
      .toList();
}

List<enums.CreateOrderResponseV6State>?
    createOrderResponseV6StateNullableListFromJson(
  List? createOrderResponseV6State, [
  List<enums.CreateOrderResponseV6State>? defaultValue,
]) {
  if (createOrderResponseV6State == null) {
    return defaultValue;
  }

  return createOrderResponseV6State
      .map((e) => createOrderResponseV6StateFromJson(e.toString()))
      .toList();
}

String? createOrderResponseV7ShoppingTypeToJson(
    enums.CreateOrderResponseV7ShoppingType?
        createOrderResponseV7ShoppingType) {
  return enums
      .$CreateOrderResponseV7ShoppingTypeMap[createOrderResponseV7ShoppingType];
}

enums.CreateOrderResponseV7ShoppingType
    createOrderResponseV7ShoppingTypeFromJson(
  Object? createOrderResponseV7ShoppingType, [
  enums.CreateOrderResponseV7ShoppingType? defaultValue,
]) {
  if (createOrderResponseV7ShoppingType is String) {
    return enums.$CreateOrderResponseV7ShoppingTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                createOrderResponseV7ShoppingType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CreateOrderResponseV7ShoppingType.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CreateOrderResponseV7ShoppingTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CreateOrderResponseV7ShoppingType.swaggerGeneratedUnknown;
}

List<String> createOrderResponseV7ShoppingTypeListToJson(
    List<enums.CreateOrderResponseV7ShoppingType>?
        createOrderResponseV7ShoppingType) {
  if (createOrderResponseV7ShoppingType == null) {
    return [];
  }

  return createOrderResponseV7ShoppingType
      .map((e) => enums.$CreateOrderResponseV7ShoppingTypeMap[e]!)
      .toList();
}

List<enums.CreateOrderResponseV7ShoppingType>
    createOrderResponseV7ShoppingTypeListFromJson(
  List? createOrderResponseV7ShoppingType, [
  List<enums.CreateOrderResponseV7ShoppingType>? defaultValue,
]) {
  if (createOrderResponseV7ShoppingType == null) {
    return defaultValue ?? [];
  }

  return createOrderResponseV7ShoppingType
      .map((e) => createOrderResponseV7ShoppingTypeFromJson(e.toString()))
      .toList();
}

List<enums.CreateOrderResponseV7ShoppingType>?
    createOrderResponseV7ShoppingTypeNullableListFromJson(
  List? createOrderResponseV7ShoppingType, [
  List<enums.CreateOrderResponseV7ShoppingType>? defaultValue,
]) {
  if (createOrderResponseV7ShoppingType == null) {
    return defaultValue;
  }

  return createOrderResponseV7ShoppingType
      .map((e) => createOrderResponseV7ShoppingTypeFromJson(e.toString()))
      .toList();
}

String? createOrderResponseV7StateToJson(
    enums.CreateOrderResponseV7State? createOrderResponseV7State) {
  return enums.$CreateOrderResponseV7StateMap[createOrderResponseV7State];
}

enums.CreateOrderResponseV7State createOrderResponseV7StateFromJson(
  Object? createOrderResponseV7State, [
  enums.CreateOrderResponseV7State? defaultValue,
]) {
  if (createOrderResponseV7State is String) {
    return enums.$CreateOrderResponseV7StateMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                createOrderResponseV7State.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CreateOrderResponseV7State.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CreateOrderResponseV7StateMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CreateOrderResponseV7State.swaggerGeneratedUnknown;
}

List<String> createOrderResponseV7StateListToJson(
    List<enums.CreateOrderResponseV7State>? createOrderResponseV7State) {
  if (createOrderResponseV7State == null) {
    return [];
  }

  return createOrderResponseV7State
      .map((e) => enums.$CreateOrderResponseV7StateMap[e]!)
      .toList();
}

List<enums.CreateOrderResponseV7State> createOrderResponseV7StateListFromJson(
  List? createOrderResponseV7State, [
  List<enums.CreateOrderResponseV7State>? defaultValue,
]) {
  if (createOrderResponseV7State == null) {
    return defaultValue ?? [];
  }

  return createOrderResponseV7State
      .map((e) => createOrderResponseV7StateFromJson(e.toString()))
      .toList();
}

List<enums.CreateOrderResponseV7State>?
    createOrderResponseV7StateNullableListFromJson(
  List? createOrderResponseV7State, [
  List<enums.CreateOrderResponseV7State>? defaultValue,
]) {
  if (createOrderResponseV7State == null) {
    return defaultValue;
  }

  return createOrderResponseV7State
      .map((e) => createOrderResponseV7StateFromJson(e.toString()))
      .toList();
}

String? deliveryDtoDeliveryStatusToJson(
    enums.DeliveryDtoDeliveryStatus? deliveryDtoDeliveryStatus) {
  return enums.$DeliveryDtoDeliveryStatusMap[deliveryDtoDeliveryStatus];
}

enums.DeliveryDtoDeliveryStatus deliveryDtoDeliveryStatusFromJson(
  Object? deliveryDtoDeliveryStatus, [
  enums.DeliveryDtoDeliveryStatus? defaultValue,
]) {
  if (deliveryDtoDeliveryStatus is String) {
    return enums.$DeliveryDtoDeliveryStatusMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                deliveryDtoDeliveryStatus.toLowerCase(),
            orElse: () => const MapEntry(
                enums.DeliveryDtoDeliveryStatus.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$DeliveryDtoDeliveryStatusMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.DeliveryDtoDeliveryStatus.swaggerGeneratedUnknown;
}

List<String> deliveryDtoDeliveryStatusListToJson(
    List<enums.DeliveryDtoDeliveryStatus>? deliveryDtoDeliveryStatus) {
  if (deliveryDtoDeliveryStatus == null) {
    return [];
  }

  return deliveryDtoDeliveryStatus
      .map((e) => enums.$DeliveryDtoDeliveryStatusMap[e]!)
      .toList();
}

List<enums.DeliveryDtoDeliveryStatus> deliveryDtoDeliveryStatusListFromJson(
  List? deliveryDtoDeliveryStatus, [
  List<enums.DeliveryDtoDeliveryStatus>? defaultValue,
]) {
  if (deliveryDtoDeliveryStatus == null) {
    return defaultValue ?? [];
  }

  return deliveryDtoDeliveryStatus
      .map((e) => deliveryDtoDeliveryStatusFromJson(e.toString()))
      .toList();
}

List<enums.DeliveryDtoDeliveryStatus>?
    deliveryDtoDeliveryStatusNullableListFromJson(
  List? deliveryDtoDeliveryStatus, [
  List<enums.DeliveryDtoDeliveryStatus>? defaultValue,
]) {
  if (deliveryDtoDeliveryStatus == null) {
    return defaultValue;
  }

  return deliveryDtoDeliveryStatus
      .map((e) => deliveryDtoDeliveryStatusFromJson(e.toString()))
      .toList();
}

String? deliveryStateInformationStateToJson(
    enums.DeliveryStateInformationState? deliveryStateInformationState) {
  return enums.$DeliveryStateInformationStateMap[deliveryStateInformationState];
}

enums.DeliveryStateInformationState deliveryStateInformationStateFromJson(
  Object? deliveryStateInformationState, [
  enums.DeliveryStateInformationState? defaultValue,
]) {
  if (deliveryStateInformationState is String) {
    return enums.$DeliveryStateInformationStateMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                deliveryStateInformationState.toLowerCase(),
            orElse: () => const MapEntry(
                enums.DeliveryStateInformationState.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$DeliveryStateInformationStateMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.DeliveryStateInformationState.swaggerGeneratedUnknown;
}

List<String> deliveryStateInformationStateListToJson(
    List<enums.DeliveryStateInformationState>? deliveryStateInformationState) {
  if (deliveryStateInformationState == null) {
    return [];
  }

  return deliveryStateInformationState
      .map((e) => enums.$DeliveryStateInformationStateMap[e]!)
      .toList();
}

List<enums.DeliveryStateInformationState>
    deliveryStateInformationStateListFromJson(
  List? deliveryStateInformationState, [
  List<enums.DeliveryStateInformationState>? defaultValue,
]) {
  if (deliveryStateInformationState == null) {
    return defaultValue ?? [];
  }

  return deliveryStateInformationState
      .map((e) => deliveryStateInformationStateFromJson(e.toString()))
      .toList();
}

List<enums.DeliveryStateInformationState>?
    deliveryStateInformationStateNullableListFromJson(
  List? deliveryStateInformationState, [
  List<enums.DeliveryStateInformationState>? defaultValue,
]) {
  if (deliveryStateInformationState == null) {
    return defaultValue;
  }

  return deliveryStateInformationState
      .map((e) => deliveryStateInformationStateFromJson(e.toString()))
      .toList();
}

String? latestOrderSummaryOrderTypeToJson(
    enums.LatestOrderSummaryOrderType? latestOrderSummaryOrderType) {
  return enums.$LatestOrderSummaryOrderTypeMap[latestOrderSummaryOrderType];
}

enums.LatestOrderSummaryOrderType latestOrderSummaryOrderTypeFromJson(
  Object? latestOrderSummaryOrderType, [
  enums.LatestOrderSummaryOrderType? defaultValue,
]) {
  if (latestOrderSummaryOrderType is String) {
    return enums.$LatestOrderSummaryOrderTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                latestOrderSummaryOrderType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.LatestOrderSummaryOrderType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$LatestOrderSummaryOrderTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.LatestOrderSummaryOrderType.swaggerGeneratedUnknown;
}

List<String> latestOrderSummaryOrderTypeListToJson(
    List<enums.LatestOrderSummaryOrderType>? latestOrderSummaryOrderType) {
  if (latestOrderSummaryOrderType == null) {
    return [];
  }

  return latestOrderSummaryOrderType
      .map((e) => enums.$LatestOrderSummaryOrderTypeMap[e]!)
      .toList();
}

List<enums.LatestOrderSummaryOrderType> latestOrderSummaryOrderTypeListFromJson(
  List? latestOrderSummaryOrderType, [
  List<enums.LatestOrderSummaryOrderType>? defaultValue,
]) {
  if (latestOrderSummaryOrderType == null) {
    return defaultValue ?? [];
  }

  return latestOrderSummaryOrderType
      .map((e) => latestOrderSummaryOrderTypeFromJson(e.toString()))
      .toList();
}

List<enums.LatestOrderSummaryOrderType>?
    latestOrderSummaryOrderTypeNullableListFromJson(
  List? latestOrderSummaryOrderType, [
  List<enums.LatestOrderSummaryOrderType>? defaultValue,
]) {
  if (latestOrderSummaryOrderType == null) {
    return defaultValue;
  }

  return latestOrderSummaryOrderType
      .map((e) => latestOrderSummaryOrderTypeFromJson(e.toString()))
      .toList();
}

String? latestOrderSummaryStateToJson(
    enums.LatestOrderSummaryState? latestOrderSummaryState) {
  return enums.$LatestOrderSummaryStateMap[latestOrderSummaryState];
}

enums.LatestOrderSummaryState latestOrderSummaryStateFromJson(
  Object? latestOrderSummaryState, [
  enums.LatestOrderSummaryState? defaultValue,
]) {
  if (latestOrderSummaryState is String) {
    return enums.$LatestOrderSummaryStateMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                latestOrderSummaryState.toLowerCase(),
            orElse: () => const MapEntry(
                enums.LatestOrderSummaryState.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$LatestOrderSummaryStateMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.LatestOrderSummaryState.swaggerGeneratedUnknown;
}

List<String> latestOrderSummaryStateListToJson(
    List<enums.LatestOrderSummaryState>? latestOrderSummaryState) {
  if (latestOrderSummaryState == null) {
    return [];
  }

  return latestOrderSummaryState
      .map((e) => enums.$LatestOrderSummaryStateMap[e]!)
      .toList();
}

List<enums.LatestOrderSummaryState> latestOrderSummaryStateListFromJson(
  List? latestOrderSummaryState, [
  List<enums.LatestOrderSummaryState>? defaultValue,
]) {
  if (latestOrderSummaryState == null) {
    return defaultValue ?? [];
  }

  return latestOrderSummaryState
      .map((e) => latestOrderSummaryStateFromJson(e.toString()))
      .toList();
}

List<enums.LatestOrderSummaryState>?
    latestOrderSummaryStateNullableListFromJson(
  List? latestOrderSummaryState, [
  List<enums.LatestOrderSummaryState>? defaultValue,
]) {
  if (latestOrderSummaryState == null) {
    return defaultValue;
  }

  return latestOrderSummaryState
      .map((e) => latestOrderSummaryStateFromJson(e.toString()))
      .toList();
}

String? orderDetailsDeliveryTypeToJson(
    enums.OrderDetailsDeliveryType? orderDetailsDeliveryType) {
  return enums.$OrderDetailsDeliveryTypeMap[orderDetailsDeliveryType];
}

enums.OrderDetailsDeliveryType orderDetailsDeliveryTypeFromJson(
  Object? orderDetailsDeliveryType, [
  enums.OrderDetailsDeliveryType? defaultValue,
]) {
  if (orderDetailsDeliveryType is String) {
    return enums.$OrderDetailsDeliveryTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                orderDetailsDeliveryType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.OrderDetailsDeliveryType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$OrderDetailsDeliveryTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.OrderDetailsDeliveryType.swaggerGeneratedUnknown;
}

List<String> orderDetailsDeliveryTypeListToJson(
    List<enums.OrderDetailsDeliveryType>? orderDetailsDeliveryType) {
  if (orderDetailsDeliveryType == null) {
    return [];
  }

  return orderDetailsDeliveryType
      .map((e) => enums.$OrderDetailsDeliveryTypeMap[e]!)
      .toList();
}

List<enums.OrderDetailsDeliveryType> orderDetailsDeliveryTypeListFromJson(
  List? orderDetailsDeliveryType, [
  List<enums.OrderDetailsDeliveryType>? defaultValue,
]) {
  if (orderDetailsDeliveryType == null) {
    return defaultValue ?? [];
  }

  return orderDetailsDeliveryType
      .map((e) => orderDetailsDeliveryTypeFromJson(e.toString()))
      .toList();
}

List<enums.OrderDetailsDeliveryType>?
    orderDetailsDeliveryTypeNullableListFromJson(
  List? orderDetailsDeliveryType, [
  List<enums.OrderDetailsDeliveryType>? defaultValue,
]) {
  if (orderDetailsDeliveryType == null) {
    return defaultValue;
  }

  return orderDetailsDeliveryType
      .map((e) => orderDetailsDeliveryTypeFromJson(e.toString()))
      .toList();
}

String? orderDetailsOrderStateToJson(
    enums.OrderDetailsOrderState? orderDetailsOrderState) {
  return enums.$OrderDetailsOrderStateMap[orderDetailsOrderState];
}

enums.OrderDetailsOrderState orderDetailsOrderStateFromJson(
  Object? orderDetailsOrderState, [
  enums.OrderDetailsOrderState? defaultValue,
]) {
  if (orderDetailsOrderState is String) {
    return enums.$OrderDetailsOrderStateMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                orderDetailsOrderState.toLowerCase(),
            orElse: () => const MapEntry(
                enums.OrderDetailsOrderState.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$OrderDetailsOrderStateMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.OrderDetailsOrderState.swaggerGeneratedUnknown;
}

List<String> orderDetailsOrderStateListToJson(
    List<enums.OrderDetailsOrderState>? orderDetailsOrderState) {
  if (orderDetailsOrderState == null) {
    return [];
  }

  return orderDetailsOrderState
      .map((e) => enums.$OrderDetailsOrderStateMap[e]!)
      .toList();
}

List<enums.OrderDetailsOrderState> orderDetailsOrderStateListFromJson(
  List? orderDetailsOrderState, [
  List<enums.OrderDetailsOrderState>? defaultValue,
]) {
  if (orderDetailsOrderState == null) {
    return defaultValue ?? [];
  }

  return orderDetailsOrderState
      .map((e) => orderDetailsOrderStateFromJson(e.toString()))
      .toList();
}

List<enums.OrderDetailsOrderState>? orderDetailsOrderStateNullableListFromJson(
  List? orderDetailsOrderState, [
  List<enums.OrderDetailsOrderState>? defaultValue,
]) {
  if (orderDetailsOrderState == null) {
    return defaultValue;
  }

  return orderDetailsOrderState
      .map((e) => orderDetailsOrderStateFromJson(e.toString()))
      .toList();
}

String? orderDetailsGroupedByTaxonomyDeliveryTypeToJson(
    enums.OrderDetailsGroupedByTaxonomyDeliveryType?
        orderDetailsGroupedByTaxonomyDeliveryType) {
  return enums.$OrderDetailsGroupedByTaxonomyDeliveryTypeMap[
      orderDetailsGroupedByTaxonomyDeliveryType];
}

enums.OrderDetailsGroupedByTaxonomyDeliveryType
    orderDetailsGroupedByTaxonomyDeliveryTypeFromJson(
  Object? orderDetailsGroupedByTaxonomyDeliveryType, [
  enums.OrderDetailsGroupedByTaxonomyDeliveryType? defaultValue,
]) {
  if (orderDetailsGroupedByTaxonomyDeliveryType is String) {
    return enums.$OrderDetailsGroupedByTaxonomyDeliveryTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                orderDetailsGroupedByTaxonomyDeliveryType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.OrderDetailsGroupedByTaxonomyDeliveryType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$OrderDetailsGroupedByTaxonomyDeliveryTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.OrderDetailsGroupedByTaxonomyDeliveryType.swaggerGeneratedUnknown;
}

List<String> orderDetailsGroupedByTaxonomyDeliveryTypeListToJson(
    List<enums.OrderDetailsGroupedByTaxonomyDeliveryType>?
        orderDetailsGroupedByTaxonomyDeliveryType) {
  if (orderDetailsGroupedByTaxonomyDeliveryType == null) {
    return [];
  }

  return orderDetailsGroupedByTaxonomyDeliveryType
      .map((e) => enums.$OrderDetailsGroupedByTaxonomyDeliveryTypeMap[e]!)
      .toList();
}

List<enums.OrderDetailsGroupedByTaxonomyDeliveryType>
    orderDetailsGroupedByTaxonomyDeliveryTypeListFromJson(
  List? orderDetailsGroupedByTaxonomyDeliveryType, [
  List<enums.OrderDetailsGroupedByTaxonomyDeliveryType>? defaultValue,
]) {
  if (orderDetailsGroupedByTaxonomyDeliveryType == null) {
    return defaultValue ?? [];
  }

  return orderDetailsGroupedByTaxonomyDeliveryType
      .map((e) =>
          orderDetailsGroupedByTaxonomyDeliveryTypeFromJson(e.toString()))
      .toList();
}

List<enums.OrderDetailsGroupedByTaxonomyDeliveryType>?
    orderDetailsGroupedByTaxonomyDeliveryTypeNullableListFromJson(
  List? orderDetailsGroupedByTaxonomyDeliveryType, [
  List<enums.OrderDetailsGroupedByTaxonomyDeliveryType>? defaultValue,
]) {
  if (orderDetailsGroupedByTaxonomyDeliveryType == null) {
    return defaultValue;
  }

  return orderDetailsGroupedByTaxonomyDeliveryType
      .map((e) =>
          orderDetailsGroupedByTaxonomyDeliveryTypeFromJson(e.toString()))
      .toList();
}

String? orderDetailsGroupedByTaxonomyOrderStateToJson(
    enums.OrderDetailsGroupedByTaxonomyOrderState?
        orderDetailsGroupedByTaxonomyOrderState) {
  return enums.$OrderDetailsGroupedByTaxonomyOrderStateMap[
      orderDetailsGroupedByTaxonomyOrderState];
}

enums.OrderDetailsGroupedByTaxonomyOrderState
    orderDetailsGroupedByTaxonomyOrderStateFromJson(
  Object? orderDetailsGroupedByTaxonomyOrderState, [
  enums.OrderDetailsGroupedByTaxonomyOrderState? defaultValue,
]) {
  if (orderDetailsGroupedByTaxonomyOrderState is String) {
    return enums.$OrderDetailsGroupedByTaxonomyOrderStateMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                orderDetailsGroupedByTaxonomyOrderState.toLowerCase(),
            orElse: () => const MapEntry(
                enums.OrderDetailsGroupedByTaxonomyOrderState
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$OrderDetailsGroupedByTaxonomyOrderStateMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.OrderDetailsGroupedByTaxonomyOrderState.swaggerGeneratedUnknown;
}

List<String> orderDetailsGroupedByTaxonomyOrderStateListToJson(
    List<enums.OrderDetailsGroupedByTaxonomyOrderState>?
        orderDetailsGroupedByTaxonomyOrderState) {
  if (orderDetailsGroupedByTaxonomyOrderState == null) {
    return [];
  }

  return orderDetailsGroupedByTaxonomyOrderState
      .map((e) => enums.$OrderDetailsGroupedByTaxonomyOrderStateMap[e]!)
      .toList();
}

List<enums.OrderDetailsGroupedByTaxonomyOrderState>
    orderDetailsGroupedByTaxonomyOrderStateListFromJson(
  List? orderDetailsGroupedByTaxonomyOrderState, [
  List<enums.OrderDetailsGroupedByTaxonomyOrderState>? defaultValue,
]) {
  if (orderDetailsGroupedByTaxonomyOrderState == null) {
    return defaultValue ?? [];
  }

  return orderDetailsGroupedByTaxonomyOrderState
      .map((e) => orderDetailsGroupedByTaxonomyOrderStateFromJson(e.toString()))
      .toList();
}

List<enums.OrderDetailsGroupedByTaxonomyOrderState>?
    orderDetailsGroupedByTaxonomyOrderStateNullableListFromJson(
  List? orderDetailsGroupedByTaxonomyOrderState, [
  List<enums.OrderDetailsGroupedByTaxonomyOrderState>? defaultValue,
]) {
  if (orderDetailsGroupedByTaxonomyOrderState == null) {
    return defaultValue;
  }

  return orderDetailsGroupedByTaxonomyOrderState
      .map((e) => orderDetailsGroupedByTaxonomyOrderStateFromJson(e.toString()))
      .toList();
}

String? orderDetailsV7DeliveryTypeToJson(
    enums.OrderDetailsV7DeliveryType? orderDetailsV7DeliveryType) {
  return enums.$OrderDetailsV7DeliveryTypeMap[orderDetailsV7DeliveryType];
}

enums.OrderDetailsV7DeliveryType orderDetailsV7DeliveryTypeFromJson(
  Object? orderDetailsV7DeliveryType, [
  enums.OrderDetailsV7DeliveryType? defaultValue,
]) {
  if (orderDetailsV7DeliveryType is String) {
    return enums.$OrderDetailsV7DeliveryTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                orderDetailsV7DeliveryType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.OrderDetailsV7DeliveryType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$OrderDetailsV7DeliveryTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.OrderDetailsV7DeliveryType.swaggerGeneratedUnknown;
}

List<String> orderDetailsV7DeliveryTypeListToJson(
    List<enums.OrderDetailsV7DeliveryType>? orderDetailsV7DeliveryType) {
  if (orderDetailsV7DeliveryType == null) {
    return [];
  }

  return orderDetailsV7DeliveryType
      .map((e) => enums.$OrderDetailsV7DeliveryTypeMap[e]!)
      .toList();
}

List<enums.OrderDetailsV7DeliveryType> orderDetailsV7DeliveryTypeListFromJson(
  List? orderDetailsV7DeliveryType, [
  List<enums.OrderDetailsV7DeliveryType>? defaultValue,
]) {
  if (orderDetailsV7DeliveryType == null) {
    return defaultValue ?? [];
  }

  return orderDetailsV7DeliveryType
      .map((e) => orderDetailsV7DeliveryTypeFromJson(e.toString()))
      .toList();
}

List<enums.OrderDetailsV7DeliveryType>?
    orderDetailsV7DeliveryTypeNullableListFromJson(
  List? orderDetailsV7DeliveryType, [
  List<enums.OrderDetailsV7DeliveryType>? defaultValue,
]) {
  if (orderDetailsV7DeliveryType == null) {
    return defaultValue;
  }

  return orderDetailsV7DeliveryType
      .map((e) => orderDetailsV7DeliveryTypeFromJson(e.toString()))
      .toList();
}

String? orderDetailsV7OrderStateToJson(
    enums.OrderDetailsV7OrderState? orderDetailsV7OrderState) {
  return enums.$OrderDetailsV7OrderStateMap[orderDetailsV7OrderState];
}

enums.OrderDetailsV7OrderState orderDetailsV7OrderStateFromJson(
  Object? orderDetailsV7OrderState, [
  enums.OrderDetailsV7OrderState? defaultValue,
]) {
  if (orderDetailsV7OrderState is String) {
    return enums.$OrderDetailsV7OrderStateMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                orderDetailsV7OrderState.toLowerCase(),
            orElse: () => const MapEntry(
                enums.OrderDetailsV7OrderState.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$OrderDetailsV7OrderStateMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.OrderDetailsV7OrderState.swaggerGeneratedUnknown;
}

List<String> orderDetailsV7OrderStateListToJson(
    List<enums.OrderDetailsV7OrderState>? orderDetailsV7OrderState) {
  if (orderDetailsV7OrderState == null) {
    return [];
  }

  return orderDetailsV7OrderState
      .map((e) => enums.$OrderDetailsV7OrderStateMap[e]!)
      .toList();
}

List<enums.OrderDetailsV7OrderState> orderDetailsV7OrderStateListFromJson(
  List? orderDetailsV7OrderState, [
  List<enums.OrderDetailsV7OrderState>? defaultValue,
]) {
  if (orderDetailsV7OrderState == null) {
    return defaultValue ?? [];
  }

  return orderDetailsV7OrderState
      .map((e) => orderDetailsV7OrderStateFromJson(e.toString()))
      .toList();
}

List<enums.OrderDetailsV7OrderState>?
    orderDetailsV7OrderStateNullableListFromJson(
  List? orderDetailsV7OrderState, [
  List<enums.OrderDetailsV7OrderState>? defaultValue,
]) {
  if (orderDetailsV7OrderState == null) {
    return defaultValue;
  }

  return orderDetailsV7OrderState
      .map((e) => orderDetailsV7OrderStateFromJson(e.toString()))
      .toList();
}

String? orderSummaryOrderMethodToJson(
    enums.OrderSummaryOrderMethod? orderSummaryOrderMethod) {
  return enums.$OrderSummaryOrderMethodMap[orderSummaryOrderMethod];
}

enums.OrderSummaryOrderMethod orderSummaryOrderMethodFromJson(
  Object? orderSummaryOrderMethod, [
  enums.OrderSummaryOrderMethod? defaultValue,
]) {
  if (orderSummaryOrderMethod is String) {
    return enums.$OrderSummaryOrderMethodMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                orderSummaryOrderMethod.toLowerCase(),
            orElse: () => const MapEntry(
                enums.OrderSummaryOrderMethod.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$OrderSummaryOrderMethodMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.OrderSummaryOrderMethod.swaggerGeneratedUnknown;
}

List<String> orderSummaryOrderMethodListToJson(
    List<enums.OrderSummaryOrderMethod>? orderSummaryOrderMethod) {
  if (orderSummaryOrderMethod == null) {
    return [];
  }

  return orderSummaryOrderMethod
      .map((e) => enums.$OrderSummaryOrderMethodMap[e]!)
      .toList();
}

List<enums.OrderSummaryOrderMethod> orderSummaryOrderMethodListFromJson(
  List? orderSummaryOrderMethod, [
  List<enums.OrderSummaryOrderMethod>? defaultValue,
]) {
  if (orderSummaryOrderMethod == null) {
    return defaultValue ?? [];
  }

  return orderSummaryOrderMethod
      .map((e) => orderSummaryOrderMethodFromJson(e.toString()))
      .toList();
}

List<enums.OrderSummaryOrderMethod>?
    orderSummaryOrderMethodNullableListFromJson(
  List? orderSummaryOrderMethod, [
  List<enums.OrderSummaryOrderMethod>? defaultValue,
]) {
  if (orderSummaryOrderMethod == null) {
    return defaultValue;
  }

  return orderSummaryOrderMethod
      .map((e) => orderSummaryOrderMethodFromJson(e.toString()))
      .toList();
}

String? orderSummaryOrderTypeToJson(
    enums.OrderSummaryOrderType? orderSummaryOrderType) {
  return enums.$OrderSummaryOrderTypeMap[orderSummaryOrderType];
}

enums.OrderSummaryOrderType orderSummaryOrderTypeFromJson(
  Object? orderSummaryOrderType, [
  enums.OrderSummaryOrderType? defaultValue,
]) {
  if (orderSummaryOrderType is String) {
    return enums.$OrderSummaryOrderTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                orderSummaryOrderType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.OrderSummaryOrderType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$OrderSummaryOrderTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.OrderSummaryOrderType.swaggerGeneratedUnknown;
}

List<String> orderSummaryOrderTypeListToJson(
    List<enums.OrderSummaryOrderType>? orderSummaryOrderType) {
  if (orderSummaryOrderType == null) {
    return [];
  }

  return orderSummaryOrderType
      .map((e) => enums.$OrderSummaryOrderTypeMap[e]!)
      .toList();
}

List<enums.OrderSummaryOrderType> orderSummaryOrderTypeListFromJson(
  List? orderSummaryOrderType, [
  List<enums.OrderSummaryOrderType>? defaultValue,
]) {
  if (orderSummaryOrderType == null) {
    return defaultValue ?? [];
  }

  return orderSummaryOrderType
      .map((e) => orderSummaryOrderTypeFromJson(e.toString()))
      .toList();
}

List<enums.OrderSummaryOrderType>? orderSummaryOrderTypeNullableListFromJson(
  List? orderSummaryOrderType, [
  List<enums.OrderSummaryOrderType>? defaultValue,
]) {
  if (orderSummaryOrderType == null) {
    return defaultValue;
  }

  return orderSummaryOrderType
      .map((e) => orderSummaryOrderTypeFromJson(e.toString()))
      .toList();
}

String? orderSummaryStateToJson(enums.OrderSummaryState? orderSummaryState) {
  return enums.$OrderSummaryStateMap[orderSummaryState];
}

enums.OrderSummaryState orderSummaryStateFromJson(
  Object? orderSummaryState, [
  enums.OrderSummaryState? defaultValue,
]) {
  if (orderSummaryState is String) {
    return enums.$OrderSummaryStateMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == orderSummaryState.toLowerCase(),
            orElse: () => const MapEntry(
                enums.OrderSummaryState.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$OrderSummaryStateMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.OrderSummaryState.swaggerGeneratedUnknown;
}

List<String> orderSummaryStateListToJson(
    List<enums.OrderSummaryState>? orderSummaryState) {
  if (orderSummaryState == null) {
    return [];
  }

  return orderSummaryState.map((e) => enums.$OrderSummaryStateMap[e]!).toList();
}

List<enums.OrderSummaryState> orderSummaryStateListFromJson(
  List? orderSummaryState, [
  List<enums.OrderSummaryState>? defaultValue,
]) {
  if (orderSummaryState == null) {
    return defaultValue ?? [];
  }

  return orderSummaryState
      .map((e) => orderSummaryStateFromJson(e.toString()))
      .toList();
}

List<enums.OrderSummaryState>? orderSummaryStateNullableListFromJson(
  List? orderSummaryState, [
  List<enums.OrderSummaryState>? defaultValue,
]) {
  if (orderSummaryState == null) {
    return defaultValue;
  }

  return orderSummaryState
      .map((e) => orderSummaryStateFromJson(e.toString()))
      .toList();
}

String? submittedOrderV7PaymentOptionToJson(
    enums.SubmittedOrderV7PaymentOption? submittedOrderV7PaymentOption) {
  return enums.$SubmittedOrderV7PaymentOptionMap[submittedOrderV7PaymentOption];
}

enums.SubmittedOrderV7PaymentOption submittedOrderV7PaymentOptionFromJson(
  Object? submittedOrderV7PaymentOption, [
  enums.SubmittedOrderV7PaymentOption? defaultValue,
]) {
  if (submittedOrderV7PaymentOption is String) {
    return enums.$SubmittedOrderV7PaymentOptionMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                submittedOrderV7PaymentOption.toLowerCase(),
            orElse: () => const MapEntry(
                enums.SubmittedOrderV7PaymentOption.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SubmittedOrderV7PaymentOptionMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SubmittedOrderV7PaymentOption.swaggerGeneratedUnknown;
}

List<String> submittedOrderV7PaymentOptionListToJson(
    List<enums.SubmittedOrderV7PaymentOption>? submittedOrderV7PaymentOption) {
  if (submittedOrderV7PaymentOption == null) {
    return [];
  }

  return submittedOrderV7PaymentOption
      .map((e) => enums.$SubmittedOrderV7PaymentOptionMap[e]!)
      .toList();
}

List<enums.SubmittedOrderV7PaymentOption>
    submittedOrderV7PaymentOptionListFromJson(
  List? submittedOrderV7PaymentOption, [
  List<enums.SubmittedOrderV7PaymentOption>? defaultValue,
]) {
  if (submittedOrderV7PaymentOption == null) {
    return defaultValue ?? [];
  }

  return submittedOrderV7PaymentOption
      .map((e) => submittedOrderV7PaymentOptionFromJson(e.toString()))
      .toList();
}

List<enums.SubmittedOrderV7PaymentOption>?
    submittedOrderV7PaymentOptionNullableListFromJson(
  List? submittedOrderV7PaymentOption, [
  List<enums.SubmittedOrderV7PaymentOption>? defaultValue,
]) {
  if (submittedOrderV7PaymentOption == null) {
    return defaultValue;
  }

  return submittedOrderV7PaymentOption
      .map((e) => submittedOrderV7PaymentOptionFromJson(e.toString()))
      .toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
