// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'product_details_remote_data_source.enums.swagger.dart' as enums;
export 'product_details_remote_data_source.enums.swagger.dart';

part 'product_details_remote_data_source.swagger.chopper.dart';
part 'product_details_remote_data_source.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class ProductDetailsRemoteDataSource extends ChopperService {
  static ProductDetailsRemoteDataSource create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$ProductDetailsRemoteDataSource(client);
    }

    final newClient = ChopperClient(
        services: [_$ProductDetailsRemoteDataSource()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$ProductDetailsRemoteDataSource(newClient);
  }

  ///
  ///@param Appie-Current-Order-Id
  ///@param x-application
  ///@param webshopId
  Future<chopper.Response<ProductDetail>> productDetailV2WebshopIdGet({
    String? appieCurrentOrderId,
    String? xApplication,
    required num? webshopId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ProductDetail, () => ProductDetail.fromJsonFactory);

    return _productDetailV2WebshopIdGet(
        appieCurrentOrderId: appieCurrentOrderId,
        xApplication: xApplication,
        webshopId: webshopId,
        cacheControl: cacheControl);
  }

  ///
  ///@param Appie-Current-Order-Id
  ///@param x-application
  ///@param webshopId
  @Get(path: '/product/detail/v2/{webshopId}')
  Future<chopper.Response<ProductDetail>> _productDetailV2WebshopIdGet({
    @Header('Appie-Current-Order-Id') String? appieCurrentOrderId,
    @Header('x-application') String? xApplication,
    @Path('webshopId') required num? webshopId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param x-application
  ///@param webshopId
  Future<chopper.Response<Fir>> productDetailV3FirWebshopIdGet({
    String? xApplication,
    required num? webshopId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Fir, () => Fir.fromJsonFactory);

    return _productDetailV3FirWebshopIdGet(
        xApplication: xApplication,
        webshopId: webshopId,
        cacheControl: cacheControl);
  }

  ///
  ///@param x-application
  ///@param webshopId
  @Get(path: '/product/detail/v3/fir/{webshopId}')
  Future<chopper.Response<Fir>> _productDetailV3FirWebshopIdGet({
    @Header('x-application') String? xApplication,
    @Path('webshopId') required num? webshopId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param webshopId
  ///@param includeActivatableDiscount Indicate that the discount should be included even if the promotion has not been activated yet.
  ///@param Appie-Current-Order-Id
  ///@param x-application
  Future<chopper.Response<ProductDetailsBffApi>>
      productDetailV4FirWebshopIdGet({
    required num? webshopId,
    bool? includeActivatableDiscount,
    String? appieCurrentOrderId,
    String? xApplication,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ProductDetailsBffApi, () => ProductDetailsBffApi.fromJsonFactory);

    return _productDetailV4FirWebshopIdGet(
        webshopId: webshopId,
        includeActivatableDiscount: includeActivatableDiscount,
        appieCurrentOrderId: appieCurrentOrderId,
        xApplication: xApplication,
        cacheControl: cacheControl);
  }

  ///
  ///@param webshopId
  ///@param includeActivatableDiscount Indicate that the discount should be included even if the promotion has not been activated yet.
  ///@param Appie-Current-Order-Id
  ///@param x-application
  @Get(path: '/product/detail/v4/fir/{webshopId}')
  Future<chopper.Response<ProductDetailsBffApi>>
      _productDetailV4FirWebshopIdGet({
    @Path('webshopId') required num? webshopId,
    @Query('includeActivatableDiscount') bool? includeActivatableDiscount,
    @Header('Appie-Current-Order-Id') String? appieCurrentOrderId,
    @Header('x-application') String? xApplication,
    @Header('Cache-Control') String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class Image {
  Image({
    required this.width,
    required this.height,
    required this.url,
  });

  factory Image.fromJson(Map<String, dynamic> json) => _$ImageFromJson(json);

  @JsonKey(name: 'width', includeIfNull: false)
  final int width;
  @JsonKey(name: 'height', includeIfNull: false)
  final int height;
  @JsonKey(name: 'url', includeIfNull: false, defaultValue: '')
  final String url;
  static const fromJsonFactory = _$ImageFromJson;
  static const toJsonFactory = _$ImageToJson;
  Map<String, dynamic> toJson() => _$ImageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Image &&
            (identical(other.width, width) ||
                const DeepCollectionEquality().equals(other.width, width)) &&
            (identical(other.height, height) ||
                const DeepCollectionEquality().equals(other.height, height)) &&
            (identical(other.url, url) ||
                const DeepCollectionEquality().equals(other.url, url)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(width) ^
      const DeepCollectionEquality().hash(height) ^
      const DeepCollectionEquality().hash(url) ^
      runtimeType.hashCode;
}

extension $ImageExtension on Image {
  Image copyWith({int? width, int? height, String? url}) {
    return Image(
        width: width ?? this.width,
        height: height ?? this.height,
        url: url ?? this.url);
  }

  Image copyWithWrapped(
      {Wrapped<int>? width, Wrapped<int>? height, Wrapped<String>? url}) {
    return Image(
        width: (width != null ? width.value : this.width),
        height: (height != null ? height.value : this.height),
        url: (url != null ? url.value : this.url));
  }
}

@JsonSerializable(explicitToJson: true)
class ProductCard {
  ProductCard({
    required this.webshopId,
    required this.hqId,
    required this.title,
    this.specialDescription,
    this.salesUnitSize,
    this.unitPriceDescription,
    this.images,
    this.bonusStartDate,
    this.bonusEndDate,
    this.discountType,
    this.promotionType,
    this.segmentType,
    this.bonusMechanism,
    this.currentPrice,
    this.priceBeforeBonus,
    this.orderAvailabilityStatus,
    this.orderAvailabilityDescription,
    this.mainCategory,
    this.subCategory,
    this.subCategoryId,
    this.brand,
    this.shopType,
    this.bonusPeriodDescription,
    this.availableOnline,
    this.isPreviouslyBought,
    this.descriptionHighlights,
    this.propertyIcons,
    this.properties,
    this.nix18,
    this.isStapelBonus,
    this.extraDescriptions,
    this.bonusSegmentId,
    this.bonusSegmentDescription,
    this.isBonus,
    this.descriptionFull,
    required this.isOrderable,
    required this.isInfiniteBonus,
    required this.isSample,
    this.isBonusPrice,
  });

  factory ProductCard.fromJson(Map<String, dynamic> json) =>
      _$ProductCardFromJson(json);

  @JsonKey(name: 'webshopId', includeIfNull: false)
  final num webshopId;
  @JsonKey(name: 'hqId', includeIfNull: false)
  final num hqId;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  @JsonKey(name: 'specialDescription', includeIfNull: false, defaultValue: '')
  final String? specialDescription;
  @JsonKey(name: 'salesUnitSize', includeIfNull: false, defaultValue: '')
  final String? salesUnitSize;
  @JsonKey(name: 'unitPriceDescription', includeIfNull: false, defaultValue: '')
  final String? unitPriceDescription;
  @JsonKey(name: 'images', includeIfNull: false, defaultValue: <Image>[])
  final List<Image>? images;
  @JsonKey(name: 'bonusStartDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? bonusStartDate;
  @JsonKey(name: 'bonusEndDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? bonusEndDate;
  @JsonKey(name: 'discountType', includeIfNull: false, defaultValue: '')
  final String? discountType;
  @JsonKey(name: 'promotionType', includeIfNull: false, defaultValue: '')
  final String? promotionType;
  @JsonKey(name: 'segmentType', includeIfNull: false, defaultValue: '')
  final String? segmentType;
  @JsonKey(name: 'bonusMechanism', includeIfNull: false, defaultValue: '')
  final String? bonusMechanism;
  @JsonKey(name: 'currentPrice', includeIfNull: false)
  final double? currentPrice;
  @JsonKey(name: 'priceBeforeBonus', includeIfNull: false)
  final double? priceBeforeBonus;
  @JsonKey(
      name: 'orderAvailabilityStatus', includeIfNull: false, defaultValue: '')
  final String? orderAvailabilityStatus;
  @JsonKey(
      name: 'orderAvailabilityDescription',
      includeIfNull: false,
      defaultValue: '')
  final String? orderAvailabilityDescription;
  @JsonKey(name: 'mainCategory', includeIfNull: false, defaultValue: '')
  final String? mainCategory;
  @JsonKey(name: 'subCategory', includeIfNull: false, defaultValue: '')
  final String? subCategory;
  @JsonKey(name: 'subCategoryId', includeIfNull: false)
  final num? subCategoryId;
  @JsonKey(name: 'brand', includeIfNull: false, defaultValue: '')
  final String? brand;
  @JsonKey(name: 'shopType', includeIfNull: false, defaultValue: '')
  final String? shopType;
  @JsonKey(
      name: 'bonusPeriodDescription', includeIfNull: false, defaultValue: '')
  final String? bonusPeriodDescription;
  @JsonKey(name: 'availableOnline', includeIfNull: false)
  final bool? availableOnline;
  @JsonKey(name: 'isPreviouslyBought', includeIfNull: false)
  final bool? isPreviouslyBought;
  @JsonKey(
      name: 'descriptionHighlights', includeIfNull: false, defaultValue: '')
  final String? descriptionHighlights;
  @JsonKey(
      name: 'propertyIcons', includeIfNull: false, defaultValue: <String>[])
  final List<String>? propertyIcons;
  @JsonKey(name: 'properties', includeIfNull: false)
  final Map<String, dynamic>? properties;
  @JsonKey(name: 'nix18', includeIfNull: false)
  final bool? nix18;
  @JsonKey(name: 'isStapelBonus', includeIfNull: false)
  final bool? isStapelBonus;
  @JsonKey(
      name: 'extraDescriptions', includeIfNull: false, defaultValue: <String>[])
  final List<String>? extraDescriptions;
  @JsonKey(name: 'bonusSegmentId', includeIfNull: false)
  final num? bonusSegmentId;
  @JsonKey(
      name: 'bonusSegmentDescription', includeIfNull: false, defaultValue: '')
  final String? bonusSegmentDescription;
  @JsonKey(name: 'isBonus', includeIfNull: false)
  final bool? isBonus;
  @JsonKey(name: 'descriptionFull', includeIfNull: false, defaultValue: '')
  final String? descriptionFull;
  @JsonKey(name: 'isOrderable', includeIfNull: false)
  final bool isOrderable;
  @JsonKey(name: 'isInfiniteBonus', includeIfNull: false)
  final bool isInfiniteBonus;
  @JsonKey(name: 'isSample', includeIfNull: false)
  final bool isSample;
  @JsonKey(name: 'isBonusPrice', includeIfNull: false)
  final bool? isBonusPrice;
  static const fromJsonFactory = _$ProductCardFromJson;
  static const toJsonFactory = _$ProductCardToJson;
  Map<String, dynamic> toJson() => _$ProductCardToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProductCard &&
            (identical(other.webshopId, webshopId) ||
                const DeepCollectionEquality()
                    .equals(other.webshopId, webshopId)) &&
            (identical(other.hqId, hqId) ||
                const DeepCollectionEquality().equals(other.hqId, hqId)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.specialDescription, specialDescription) ||
                const DeepCollectionEquality()
                    .equals(other.specialDescription, specialDescription)) &&
            (identical(other.salesUnitSize, salesUnitSize) ||
                const DeepCollectionEquality()
                    .equals(other.salesUnitSize, salesUnitSize)) &&
            (identical(other.unitPriceDescription, unitPriceDescription) ||
                const DeepCollectionEquality().equals(
                    other.unitPriceDescription, unitPriceDescription)) &&
            (identical(other.images, images) ||
                const DeepCollectionEquality().equals(other.images, images)) &&
            (identical(other.bonusStartDate, bonusStartDate) ||
                const DeepCollectionEquality()
                    .equals(other.bonusStartDate, bonusStartDate)) &&
            (identical(other.bonusEndDate, bonusEndDate) ||
                const DeepCollectionEquality()
                    .equals(other.bonusEndDate, bonusEndDate)) &&
            (identical(other.discountType, discountType) ||
                const DeepCollectionEquality()
                    .equals(other.discountType, discountType)) &&
            (identical(other.promotionType, promotionType) ||
                const DeepCollectionEquality()
                    .equals(other.promotionType, promotionType)) &&
            (identical(other.segmentType, segmentType) ||
                const DeepCollectionEquality()
                    .equals(other.segmentType, segmentType)) &&
            (identical(other.bonusMechanism, bonusMechanism) ||
                const DeepCollectionEquality()
                    .equals(other.bonusMechanism, bonusMechanism)) &&
            (identical(other.currentPrice, currentPrice) ||
                const DeepCollectionEquality()
                    .equals(other.currentPrice, currentPrice)) &&
            (identical(other.priceBeforeBonus, priceBeforeBonus) ||
                const DeepCollectionEquality()
                    .equals(other.priceBeforeBonus, priceBeforeBonus)) &&
            (identical(other.orderAvailabilityStatus, orderAvailabilityStatus) ||
                const DeepCollectionEquality().equals(
                    other.orderAvailabilityStatus, orderAvailabilityStatus)) &&
            (identical(other.orderAvailabilityDescription, orderAvailabilityDescription) ||
                const DeepCollectionEquality().equals(
                    other.orderAvailabilityDescription,
                    orderAvailabilityDescription)) &&
            (identical(other.mainCategory, mainCategory) ||
                const DeepCollectionEquality()
                    .equals(other.mainCategory, mainCategory)) &&
            (identical(other.subCategory, subCategory) ||
                const DeepCollectionEquality()
                    .equals(other.subCategory, subCategory)) &&
            (identical(other.subCategoryId, subCategoryId) ||
                const DeepCollectionEquality()
                    .equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.brand, brand) ||
                const DeepCollectionEquality().equals(other.brand, brand)) &&
            (identical(other.shopType, shopType) ||
                const DeepCollectionEquality().equals(other.shopType, shopType)) &&
            (identical(other.bonusPeriodDescription, bonusPeriodDescription) || const DeepCollectionEquality().equals(other.bonusPeriodDescription, bonusPeriodDescription)) &&
            (identical(other.availableOnline, availableOnline) || const DeepCollectionEquality().equals(other.availableOnline, availableOnline)) &&
            (identical(other.isPreviouslyBought, isPreviouslyBought) || const DeepCollectionEquality().equals(other.isPreviouslyBought, isPreviouslyBought)) &&
            (identical(other.descriptionHighlights, descriptionHighlights) || const DeepCollectionEquality().equals(other.descriptionHighlights, descriptionHighlights)) &&
            (identical(other.propertyIcons, propertyIcons) || const DeepCollectionEquality().equals(other.propertyIcons, propertyIcons)) &&
            (identical(other.properties, properties) || const DeepCollectionEquality().equals(other.properties, properties)) &&
            (identical(other.nix18, nix18) || const DeepCollectionEquality().equals(other.nix18, nix18)) &&
            (identical(other.isStapelBonus, isStapelBonus) || const DeepCollectionEquality().equals(other.isStapelBonus, isStapelBonus)) &&
            (identical(other.extraDescriptions, extraDescriptions) || const DeepCollectionEquality().equals(other.extraDescriptions, extraDescriptions)) &&
            (identical(other.bonusSegmentId, bonusSegmentId) || const DeepCollectionEquality().equals(other.bonusSegmentId, bonusSegmentId)) &&
            (identical(other.bonusSegmentDescription, bonusSegmentDescription) || const DeepCollectionEquality().equals(other.bonusSegmentDescription, bonusSegmentDescription)) &&
            (identical(other.isBonus, isBonus) || const DeepCollectionEquality().equals(other.isBonus, isBonus)) &&
            (identical(other.descriptionFull, descriptionFull) || const DeepCollectionEquality().equals(other.descriptionFull, descriptionFull)) &&
            (identical(other.isOrderable, isOrderable) || const DeepCollectionEquality().equals(other.isOrderable, isOrderable)) &&
            (identical(other.isInfiniteBonus, isInfiniteBonus) || const DeepCollectionEquality().equals(other.isInfiniteBonus, isInfiniteBonus)) &&
            (identical(other.isSample, isSample) || const DeepCollectionEquality().equals(other.isSample, isSample)) &&
            (identical(other.isBonusPrice, isBonusPrice) || const DeepCollectionEquality().equals(other.isBonusPrice, isBonusPrice)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(webshopId) ^
      const DeepCollectionEquality().hash(hqId) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(specialDescription) ^
      const DeepCollectionEquality().hash(salesUnitSize) ^
      const DeepCollectionEquality().hash(unitPriceDescription) ^
      const DeepCollectionEquality().hash(images) ^
      const DeepCollectionEquality().hash(bonusStartDate) ^
      const DeepCollectionEquality().hash(bonusEndDate) ^
      const DeepCollectionEquality().hash(discountType) ^
      const DeepCollectionEquality().hash(promotionType) ^
      const DeepCollectionEquality().hash(segmentType) ^
      const DeepCollectionEquality().hash(bonusMechanism) ^
      const DeepCollectionEquality().hash(currentPrice) ^
      const DeepCollectionEquality().hash(priceBeforeBonus) ^
      const DeepCollectionEquality().hash(orderAvailabilityStatus) ^
      const DeepCollectionEquality().hash(orderAvailabilityDescription) ^
      const DeepCollectionEquality().hash(mainCategory) ^
      const DeepCollectionEquality().hash(subCategory) ^
      const DeepCollectionEquality().hash(subCategoryId) ^
      const DeepCollectionEquality().hash(brand) ^
      const DeepCollectionEquality().hash(shopType) ^
      const DeepCollectionEquality().hash(bonusPeriodDescription) ^
      const DeepCollectionEquality().hash(availableOnline) ^
      const DeepCollectionEquality().hash(isPreviouslyBought) ^
      const DeepCollectionEquality().hash(descriptionHighlights) ^
      const DeepCollectionEquality().hash(propertyIcons) ^
      const DeepCollectionEquality().hash(properties) ^
      const DeepCollectionEquality().hash(nix18) ^
      const DeepCollectionEquality().hash(isStapelBonus) ^
      const DeepCollectionEquality().hash(extraDescriptions) ^
      const DeepCollectionEquality().hash(bonusSegmentId) ^
      const DeepCollectionEquality().hash(bonusSegmentDescription) ^
      const DeepCollectionEquality().hash(isBonus) ^
      const DeepCollectionEquality().hash(descriptionFull) ^
      const DeepCollectionEquality().hash(isOrderable) ^
      const DeepCollectionEquality().hash(isInfiniteBonus) ^
      const DeepCollectionEquality().hash(isSample) ^
      const DeepCollectionEquality().hash(isBonusPrice) ^
      runtimeType.hashCode;
}

extension $ProductCardExtension on ProductCard {
  ProductCard copyWith(
      {num? webshopId,
      num? hqId,
      String? title,
      String? specialDescription,
      String? salesUnitSize,
      String? unitPriceDescription,
      List<Image>? images,
      DateTime? bonusStartDate,
      DateTime? bonusEndDate,
      String? discountType,
      String? promotionType,
      String? segmentType,
      String? bonusMechanism,
      double? currentPrice,
      double? priceBeforeBonus,
      String? orderAvailabilityStatus,
      String? orderAvailabilityDescription,
      String? mainCategory,
      String? subCategory,
      num? subCategoryId,
      String? brand,
      String? shopType,
      String? bonusPeriodDescription,
      bool? availableOnline,
      bool? isPreviouslyBought,
      String? descriptionHighlights,
      List<String>? propertyIcons,
      Map<String, dynamic>? properties,
      bool? nix18,
      bool? isStapelBonus,
      List<String>? extraDescriptions,
      num? bonusSegmentId,
      String? bonusSegmentDescription,
      bool? isBonus,
      String? descriptionFull,
      bool? isOrderable,
      bool? isInfiniteBonus,
      bool? isSample,
      bool? isBonusPrice}) {
    return ProductCard(
        webshopId: webshopId ?? this.webshopId,
        hqId: hqId ?? this.hqId,
        title: title ?? this.title,
        specialDescription: specialDescription ?? this.specialDescription,
        salesUnitSize: salesUnitSize ?? this.salesUnitSize,
        unitPriceDescription: unitPriceDescription ?? this.unitPriceDescription,
        images: images ?? this.images,
        bonusStartDate: bonusStartDate ?? this.bonusStartDate,
        bonusEndDate: bonusEndDate ?? this.bonusEndDate,
        discountType: discountType ?? this.discountType,
        promotionType: promotionType ?? this.promotionType,
        segmentType: segmentType ?? this.segmentType,
        bonusMechanism: bonusMechanism ?? this.bonusMechanism,
        currentPrice: currentPrice ?? this.currentPrice,
        priceBeforeBonus: priceBeforeBonus ?? this.priceBeforeBonus,
        orderAvailabilityStatus:
            orderAvailabilityStatus ?? this.orderAvailabilityStatus,
        orderAvailabilityDescription:
            orderAvailabilityDescription ?? this.orderAvailabilityDescription,
        mainCategory: mainCategory ?? this.mainCategory,
        subCategory: subCategory ?? this.subCategory,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        brand: brand ?? this.brand,
        shopType: shopType ?? this.shopType,
        bonusPeriodDescription:
            bonusPeriodDescription ?? this.bonusPeriodDescription,
        availableOnline: availableOnline ?? this.availableOnline,
        isPreviouslyBought: isPreviouslyBought ?? this.isPreviouslyBought,
        descriptionHighlights:
            descriptionHighlights ?? this.descriptionHighlights,
        propertyIcons: propertyIcons ?? this.propertyIcons,
        properties: properties ?? this.properties,
        nix18: nix18 ?? this.nix18,
        isStapelBonus: isStapelBonus ?? this.isStapelBonus,
        extraDescriptions: extraDescriptions ?? this.extraDescriptions,
        bonusSegmentId: bonusSegmentId ?? this.bonusSegmentId,
        bonusSegmentDescription:
            bonusSegmentDescription ?? this.bonusSegmentDescription,
        isBonus: isBonus ?? this.isBonus,
        descriptionFull: descriptionFull ?? this.descriptionFull,
        isOrderable: isOrderable ?? this.isOrderable,
        isInfiniteBonus: isInfiniteBonus ?? this.isInfiniteBonus,
        isSample: isSample ?? this.isSample,
        isBonusPrice: isBonusPrice ?? this.isBonusPrice);
  }

  ProductCard copyWithWrapped(
      {Wrapped<num>? webshopId,
      Wrapped<num>? hqId,
      Wrapped<String>? title,
      Wrapped<String?>? specialDescription,
      Wrapped<String?>? salesUnitSize,
      Wrapped<String?>? unitPriceDescription,
      Wrapped<List<Image>?>? images,
      Wrapped<DateTime?>? bonusStartDate,
      Wrapped<DateTime?>? bonusEndDate,
      Wrapped<String?>? discountType,
      Wrapped<String?>? promotionType,
      Wrapped<String?>? segmentType,
      Wrapped<String?>? bonusMechanism,
      Wrapped<double?>? currentPrice,
      Wrapped<double?>? priceBeforeBonus,
      Wrapped<String?>? orderAvailabilityStatus,
      Wrapped<String?>? orderAvailabilityDescription,
      Wrapped<String?>? mainCategory,
      Wrapped<String?>? subCategory,
      Wrapped<num?>? subCategoryId,
      Wrapped<String?>? brand,
      Wrapped<String?>? shopType,
      Wrapped<String?>? bonusPeriodDescription,
      Wrapped<bool?>? availableOnline,
      Wrapped<bool?>? isPreviouslyBought,
      Wrapped<String?>? descriptionHighlights,
      Wrapped<List<String>?>? propertyIcons,
      Wrapped<Map<String, dynamic>?>? properties,
      Wrapped<bool?>? nix18,
      Wrapped<bool?>? isStapelBonus,
      Wrapped<List<String>?>? extraDescriptions,
      Wrapped<num?>? bonusSegmentId,
      Wrapped<String?>? bonusSegmentDescription,
      Wrapped<bool?>? isBonus,
      Wrapped<String?>? descriptionFull,
      Wrapped<bool>? isOrderable,
      Wrapped<bool>? isInfiniteBonus,
      Wrapped<bool>? isSample,
      Wrapped<bool?>? isBonusPrice}) {
    return ProductCard(
        webshopId: (webshopId != null ? webshopId.value : this.webshopId),
        hqId: (hqId != null ? hqId.value : this.hqId),
        title: (title != null ? title.value : this.title),
        specialDescription: (specialDescription != null
            ? specialDescription.value
            : this.specialDescription),
        salesUnitSize:
            (salesUnitSize != null ? salesUnitSize.value : this.salesUnitSize),
        unitPriceDescription: (unitPriceDescription != null
            ? unitPriceDescription.value
            : this.unitPriceDescription),
        images: (images != null ? images.value : this.images),
        bonusStartDate: (bonusStartDate != null
            ? bonusStartDate.value
            : this.bonusStartDate),
        bonusEndDate:
            (bonusEndDate != null ? bonusEndDate.value : this.bonusEndDate),
        discountType:
            (discountType != null ? discountType.value : this.discountType),
        promotionType:
            (promotionType != null ? promotionType.value : this.promotionType),
        segmentType:
            (segmentType != null ? segmentType.value : this.segmentType),
        bonusMechanism: (bonusMechanism != null
            ? bonusMechanism.value
            : this.bonusMechanism),
        currentPrice:
            (currentPrice != null ? currentPrice.value : this.currentPrice),
        priceBeforeBonus: (priceBeforeBonus != null
            ? priceBeforeBonus.value
            : this.priceBeforeBonus),
        orderAvailabilityStatus: (orderAvailabilityStatus != null
            ? orderAvailabilityStatus.value
            : this.orderAvailabilityStatus),
        orderAvailabilityDescription: (orderAvailabilityDescription != null
            ? orderAvailabilityDescription.value
            : this.orderAvailabilityDescription),
        mainCategory:
            (mainCategory != null ? mainCategory.value : this.mainCategory),
        subCategory:
            (subCategory != null ? subCategory.value : this.subCategory),
        subCategoryId:
            (subCategoryId != null ? subCategoryId.value : this.subCategoryId),
        brand: (brand != null ? brand.value : this.brand),
        shopType: (shopType != null ? shopType.value : this.shopType),
        bonusPeriodDescription: (bonusPeriodDescription != null
            ? bonusPeriodDescription.value
            : this.bonusPeriodDescription),
        availableOnline: (availableOnline != null
            ? availableOnline.value
            : this.availableOnline),
        isPreviouslyBought: (isPreviouslyBought != null
            ? isPreviouslyBought.value
            : this.isPreviouslyBought),
        descriptionHighlights: (descriptionHighlights != null
            ? descriptionHighlights.value
            : this.descriptionHighlights),
        propertyIcons:
            (propertyIcons != null ? propertyIcons.value : this.propertyIcons),
        properties: (properties != null ? properties.value : this.properties),
        nix18: (nix18 != null ? nix18.value : this.nix18),
        isStapelBonus:
            (isStapelBonus != null ? isStapelBonus.value : this.isStapelBonus),
        extraDescriptions: (extraDescriptions != null
            ? extraDescriptions.value
            : this.extraDescriptions),
        bonusSegmentId: (bonusSegmentId != null
            ? bonusSegmentId.value
            : this.bonusSegmentId),
        bonusSegmentDescription: (bonusSegmentDescription != null
            ? bonusSegmentDescription.value
            : this.bonusSegmentDescription),
        isBonus: (isBonus != null ? isBonus.value : this.isBonus),
        descriptionFull: (descriptionFull != null
            ? descriptionFull.value
            : this.descriptionFull),
        isOrderable:
            (isOrderable != null ? isOrderable.value : this.isOrderable),
        isInfiniteBonus: (isInfiniteBonus != null
            ? isInfiniteBonus.value
            : this.isInfiniteBonus),
        isSample: (isSample != null ? isSample.value : this.isSample),
        isBonusPrice:
            (isBonusPrice != null ? isBonusPrice.value : this.isBonusPrice));
  }
}

@JsonSerializable(explicitToJson: true)
class ProductDetail {
  ProductDetail({
    required this.productCard,
    required this.hqId,
    this.unitPriceDescription,
    this.bonusSegmentId,
    this.bonusSegmentDescription,
    this.nix18,
    this.hasFIR,
    this.descriptionHighlights,
    this.descriptionProperties,
    this.descriptionExtension,
    this.disclaimerText,
    this.nutriscore,
  });

  factory ProductDetail.fromJson(Map<String, dynamic> json) =>
      _$ProductDetailFromJson(json);

  @JsonKey(name: 'productCard', includeIfNull: false)
  final ProductCard productCard;
  @JsonKey(name: 'hqId', includeIfNull: false)
  final num hqId;
  @JsonKey(name: 'unitPriceDescription', includeIfNull: false, defaultValue: '')
  final String? unitPriceDescription;
  @JsonKey(name: 'bonusSegmentId', includeIfNull: false)
  final num? bonusSegmentId;
  @JsonKey(
      name: 'bonusSegmentDescription', includeIfNull: false, defaultValue: '')
  final String? bonusSegmentDescription;
  @JsonKey(name: 'nix18', includeIfNull: false)
  final bool? nix18;
  @JsonKey(name: 'hasFIR', includeIfNull: false)
  final bool? hasFIR;
  @JsonKey(
      name: 'descriptionHighlights', includeIfNull: false, defaultValue: '')
  final String? descriptionHighlights;
  @JsonKey(
      name: 'descriptionProperties',
      includeIfNull: false,
      defaultValue: <ProductDetailProperty>[])
  final List<ProductDetailProperty>? descriptionProperties;
  @JsonKey(name: 'descriptionExtension', includeIfNull: false, defaultValue: '')
  final String? descriptionExtension;
  @JsonKey(name: 'disclaimerText', includeIfNull: false, defaultValue: '')
  final String? disclaimerText;
  @JsonKey(name: 'nutriscore', includeIfNull: false, defaultValue: '')
  final String? nutriscore;
  static const fromJsonFactory = _$ProductDetailFromJson;
  static const toJsonFactory = _$ProductDetailToJson;
  Map<String, dynamic> toJson() => _$ProductDetailToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProductDetail &&
            (identical(other.productCard, productCard) ||
                const DeepCollectionEquality()
                    .equals(other.productCard, productCard)) &&
            (identical(other.hqId, hqId) ||
                const DeepCollectionEquality().equals(other.hqId, hqId)) &&
            (identical(other.unitPriceDescription, unitPriceDescription) ||
                const DeepCollectionEquality().equals(
                    other.unitPriceDescription, unitPriceDescription)) &&
            (identical(other.bonusSegmentId, bonusSegmentId) ||
                const DeepCollectionEquality()
                    .equals(other.bonusSegmentId, bonusSegmentId)) &&
            (identical(
                    other.bonusSegmentDescription, bonusSegmentDescription) ||
                const DeepCollectionEquality().equals(
                    other.bonusSegmentDescription, bonusSegmentDescription)) &&
            (identical(other.nix18, nix18) ||
                const DeepCollectionEquality().equals(other.nix18, nix18)) &&
            (identical(other.hasFIR, hasFIR) ||
                const DeepCollectionEquality().equals(other.hasFIR, hasFIR)) &&
            (identical(other.descriptionHighlights, descriptionHighlights) ||
                const DeepCollectionEquality().equals(
                    other.descriptionHighlights, descriptionHighlights)) &&
            (identical(other.descriptionProperties, descriptionProperties) ||
                const DeepCollectionEquality().equals(
                    other.descriptionProperties, descriptionProperties)) &&
            (identical(other.descriptionExtension, descriptionExtension) ||
                const DeepCollectionEquality().equals(
                    other.descriptionExtension, descriptionExtension)) &&
            (identical(other.disclaimerText, disclaimerText) ||
                const DeepCollectionEquality()
                    .equals(other.disclaimerText, disclaimerText)) &&
            (identical(other.nutriscore, nutriscore) ||
                const DeepCollectionEquality()
                    .equals(other.nutriscore, nutriscore)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(productCard) ^
      const DeepCollectionEquality().hash(hqId) ^
      const DeepCollectionEquality().hash(unitPriceDescription) ^
      const DeepCollectionEquality().hash(bonusSegmentId) ^
      const DeepCollectionEquality().hash(bonusSegmentDescription) ^
      const DeepCollectionEquality().hash(nix18) ^
      const DeepCollectionEquality().hash(hasFIR) ^
      const DeepCollectionEquality().hash(descriptionHighlights) ^
      const DeepCollectionEquality().hash(descriptionProperties) ^
      const DeepCollectionEquality().hash(descriptionExtension) ^
      const DeepCollectionEquality().hash(disclaimerText) ^
      const DeepCollectionEquality().hash(nutriscore) ^
      runtimeType.hashCode;
}

extension $ProductDetailExtension on ProductDetail {
  ProductDetail copyWith(
      {ProductCard? productCard,
      num? hqId,
      String? unitPriceDescription,
      num? bonusSegmentId,
      String? bonusSegmentDescription,
      bool? nix18,
      bool? hasFIR,
      String? descriptionHighlights,
      List<ProductDetailProperty>? descriptionProperties,
      String? descriptionExtension,
      String? disclaimerText,
      String? nutriscore}) {
    return ProductDetail(
        productCard: productCard ?? this.productCard,
        hqId: hqId ?? this.hqId,
        unitPriceDescription: unitPriceDescription ?? this.unitPriceDescription,
        bonusSegmentId: bonusSegmentId ?? this.bonusSegmentId,
        bonusSegmentDescription:
            bonusSegmentDescription ?? this.bonusSegmentDescription,
        nix18: nix18 ?? this.nix18,
        hasFIR: hasFIR ?? this.hasFIR,
        descriptionHighlights:
            descriptionHighlights ?? this.descriptionHighlights,
        descriptionProperties:
            descriptionProperties ?? this.descriptionProperties,
        descriptionExtension: descriptionExtension ?? this.descriptionExtension,
        disclaimerText: disclaimerText ?? this.disclaimerText,
        nutriscore: nutriscore ?? this.nutriscore);
  }

  ProductDetail copyWithWrapped(
      {Wrapped<ProductCard>? productCard,
      Wrapped<num>? hqId,
      Wrapped<String?>? unitPriceDescription,
      Wrapped<num?>? bonusSegmentId,
      Wrapped<String?>? bonusSegmentDescription,
      Wrapped<bool?>? nix18,
      Wrapped<bool?>? hasFIR,
      Wrapped<String?>? descriptionHighlights,
      Wrapped<List<ProductDetailProperty>?>? descriptionProperties,
      Wrapped<String?>? descriptionExtension,
      Wrapped<String?>? disclaimerText,
      Wrapped<String?>? nutriscore}) {
    return ProductDetail(
        productCard:
            (productCard != null ? productCard.value : this.productCard),
        hqId: (hqId != null ? hqId.value : this.hqId),
        unitPriceDescription: (unitPriceDescription != null
            ? unitPriceDescription.value
            : this.unitPriceDescription),
        bonusSegmentId: (bonusSegmentId != null
            ? bonusSegmentId.value
            : this.bonusSegmentId),
        bonusSegmentDescription: (bonusSegmentDescription != null
            ? bonusSegmentDescription.value
            : this.bonusSegmentDescription),
        nix18: (nix18 != null ? nix18.value : this.nix18),
        hasFIR: (hasFIR != null ? hasFIR.value : this.hasFIR),
        descriptionHighlights: (descriptionHighlights != null
            ? descriptionHighlights.value
            : this.descriptionHighlights),
        descriptionProperties: (descriptionProperties != null
            ? descriptionProperties.value
            : this.descriptionProperties),
        descriptionExtension: (descriptionExtension != null
            ? descriptionExtension.value
            : this.descriptionExtension),
        disclaimerText: (disclaimerText != null
            ? disclaimerText.value
            : this.disclaimerText),
        nutriscore: (nutriscore != null ? nutriscore.value : this.nutriscore));
  }
}

@JsonSerializable(explicitToJson: true)
class ProductDetailProperty {
  ProductDetailProperty({
    this.key,
    this.values,
  });

  factory ProductDetailProperty.fromJson(Map<String, dynamic> json) =>
      _$ProductDetailPropertyFromJson(json);

  @JsonKey(name: 'key', includeIfNull: false, defaultValue: '')
  final String? key;
  @JsonKey(name: 'values', includeIfNull: false, defaultValue: <String>[])
  final List<String>? values;
  static const fromJsonFactory = _$ProductDetailPropertyFromJson;
  static const toJsonFactory = _$ProductDetailPropertyToJson;
  Map<String, dynamic> toJson() => _$ProductDetailPropertyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProductDetailProperty &&
            (identical(other.key, key) ||
                const DeepCollectionEquality().equals(other.key, key)) &&
            (identical(other.values, values) ||
                const DeepCollectionEquality().equals(other.values, values)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(key) ^
      const DeepCollectionEquality().hash(values) ^
      runtimeType.hashCode;
}

extension $ProductDetailPropertyExtension on ProductDetailProperty {
  ProductDetailProperty copyWith({String? key, List<String>? values}) {
    return ProductDetailProperty(
        key: key ?? this.key, values: values ?? this.values);
  }

  ProductDetailProperty copyWithWrapped(
      {Wrapped<String?>? key, Wrapped<List<String>?>? values}) {
    return ProductDetailProperty(
        key: (key != null ? key.value : this.key),
        values: (values != null ? values.value : this.values));
  }
}

@JsonSerializable(explicitToJson: true)
class Agent {
  Agent({
    this.name,
    this.address,
  });

  factory Agent.fromJson(Map<String, dynamic> json) => _$AgentFromJson(json);

  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'address', includeIfNull: false, defaultValue: '')
  final String? address;
  static const fromJsonFactory = _$AgentFromJson;
  static const toJsonFactory = _$AgentToJson;
  Map<String, dynamic> toJson() => _$AgentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Agent &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.address, address) ||
                const DeepCollectionEquality().equals(other.address, address)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(address) ^
      runtimeType.hashCode;
}

extension $AgentExtension on Agent {
  Agent copyWith({String? name, String? address}) {
    return Agent(name: name ?? this.name, address: address ?? this.address);
  }

  Agent copyWithWrapped({Wrapped<String?>? name, Wrapped<String?>? address}) {
    return Agent(
        name: (name != null ? name.value : this.name),
        address: (address != null ? address.value : this.address));
  }
}

@JsonSerializable(explicitToJson: true)
class CommunicationChannel {
  CommunicationChannel({
    this.type,
    this.value,
  });

  factory CommunicationChannel.fromJson(Map<String, dynamic> json) =>
      _$CommunicationChannelFromJson(json);

  @JsonKey(
    name: 'type',
    includeIfNull: false,
    toJson: communicationChannelTypeToJson,
    fromJson: communicationChannelTypeFromJson,
  )
  final enums.CommunicationChannelType? type;
  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String? value;
  static const fromJsonFactory = _$CommunicationChannelFromJson;
  static const toJsonFactory = _$CommunicationChannelToJson;
  Map<String, dynamic> toJson() => _$CommunicationChannelToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CommunicationChannel &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(value) ^
      runtimeType.hashCode;
}

extension $CommunicationChannelExtension on CommunicationChannel {
  CommunicationChannel copyWith(
      {enums.CommunicationChannelType? type, String? value}) {
    return CommunicationChannel(
        type: type ?? this.type, value: value ?? this.value);
  }

  CommunicationChannel copyWithWrapped(
      {Wrapped<enums.CommunicationChannelType?>? type,
      Wrapped<String?>? value}) {
    return CommunicationChannel(
        type: (type != null ? type.value : this.type),
        value: (value != null ? value.value : this.value));
  }
}

@JsonSerializable(explicitToJson: true)
class Contact {
  Contact({
    this.name,
    this.address,
  });

  factory Contact.fromJson(Map<String, dynamic> json) =>
      _$ContactFromJson(json);

  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'address', includeIfNull: false, defaultValue: '')
  final String? address;
  static const fromJsonFactory = _$ContactFromJson;
  static const toJsonFactory = _$ContactToJson;
  Map<String, dynamic> toJson() => _$ContactToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Contact &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.address, address) ||
                const DeepCollectionEquality().equals(other.address, address)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(address) ^
      runtimeType.hashCode;
}

extension $ContactExtension on Contact {
  Contact copyWith({String? name, String? address}) {
    return Contact(name: name ?? this.name, address: address ?? this.address);
  }

  Contact copyWithWrapped({Wrapped<String?>? name, Wrapped<String?>? address}) {
    return Contact(
        name: (name != null ? name.value : this.name),
        address: (address != null ? address.value : this.address));
  }
}

@JsonSerializable(explicitToJson: true)
class Contents {
  Contents({
    this.measurements,
    this.eMarkRequired,
    this.descriptiveSize,
    this.drainedWeight,
    this.portionSize,
    this.numberOfPortions,
  });

  factory Contents.fromJson(Map<String, dynamic> json) =>
      _$ContentsFromJson(json);

  @JsonKey(name: 'measurements', includeIfNull: false, defaultValue: <String>[])
  final List<String>? measurements;
  @JsonKey(name: 'eMarkRequired', includeIfNull: false)
  final bool? eMarkRequired;
  @JsonKey(name: 'descriptiveSize', includeIfNull: false, defaultValue: '')
  final String? descriptiveSize;
  @JsonKey(name: 'drainedWeight', includeIfNull: false, defaultValue: '')
  final String? drainedWeight;
  @JsonKey(name: 'portionSize', includeIfNull: false, defaultValue: '')
  final String? portionSize;
  @JsonKey(name: 'numberOfPortions', includeIfNull: false, defaultValue: '')
  final String? numberOfPortions;
  static const fromJsonFactory = _$ContentsFromJson;
  static const toJsonFactory = _$ContentsToJson;
  Map<String, dynamic> toJson() => _$ContentsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Contents &&
            (identical(other.measurements, measurements) ||
                const DeepCollectionEquality()
                    .equals(other.measurements, measurements)) &&
            (identical(other.eMarkRequired, eMarkRequired) ||
                const DeepCollectionEquality()
                    .equals(other.eMarkRequired, eMarkRequired)) &&
            (identical(other.descriptiveSize, descriptiveSize) ||
                const DeepCollectionEquality()
                    .equals(other.descriptiveSize, descriptiveSize)) &&
            (identical(other.drainedWeight, drainedWeight) ||
                const DeepCollectionEquality()
                    .equals(other.drainedWeight, drainedWeight)) &&
            (identical(other.portionSize, portionSize) ||
                const DeepCollectionEquality()
                    .equals(other.portionSize, portionSize)) &&
            (identical(other.numberOfPortions, numberOfPortions) ||
                const DeepCollectionEquality()
                    .equals(other.numberOfPortions, numberOfPortions)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(measurements) ^
      const DeepCollectionEquality().hash(eMarkRequired) ^
      const DeepCollectionEquality().hash(descriptiveSize) ^
      const DeepCollectionEquality().hash(drainedWeight) ^
      const DeepCollectionEquality().hash(portionSize) ^
      const DeepCollectionEquality().hash(numberOfPortions) ^
      runtimeType.hashCode;
}

extension $ContentsExtension on Contents {
  Contents copyWith(
      {List<String>? measurements,
      bool? eMarkRequired,
      String? descriptiveSize,
      String? drainedWeight,
      String? portionSize,
      String? numberOfPortions}) {
    return Contents(
        measurements: measurements ?? this.measurements,
        eMarkRequired: eMarkRequired ?? this.eMarkRequired,
        descriptiveSize: descriptiveSize ?? this.descriptiveSize,
        drainedWeight: drainedWeight ?? this.drainedWeight,
        portionSize: portionSize ?? this.portionSize,
        numberOfPortions: numberOfPortions ?? this.numberOfPortions);
  }

  Contents copyWithWrapped(
      {Wrapped<List<String>?>? measurements,
      Wrapped<bool?>? eMarkRequired,
      Wrapped<String?>? descriptiveSize,
      Wrapped<String?>? drainedWeight,
      Wrapped<String?>? portionSize,
      Wrapped<String?>? numberOfPortions}) {
    return Contents(
        measurements:
            (measurements != null ? measurements.value : this.measurements),
        eMarkRequired:
            (eMarkRequired != null ? eMarkRequired.value : this.eMarkRequired),
        descriptiveSize: (descriptiveSize != null
            ? descriptiveSize.value
            : this.descriptiveSize),
        drainedWeight:
            (drainedWeight != null ? drainedWeight.value : this.drainedWeight),
        portionSize:
            (portionSize != null ? portionSize.value : this.portionSize),
        numberOfPortions: (numberOfPortions != null
            ? numberOfPortions.value
            : this.numberOfPortions));
  }
}

@JsonSerializable(explicitToJson: true)
class ExtraInformation {
  ExtraInformation({
    this.certifications,
    this.identifications,
  });

  factory ExtraInformation.fromJson(Map<String, dynamic> json) =>
      _$ExtraInformationFromJson(json);

  @JsonKey(
      name: 'certifications', includeIfNull: false, defaultValue: <String>[])
  final List<String>? certifications;
  @JsonKey(
      name: 'identifications', includeIfNull: false, defaultValue: <String>[])
  final List<String>? identifications;
  static const fromJsonFactory = _$ExtraInformationFromJson;
  static const toJsonFactory = _$ExtraInformationToJson;
  Map<String, dynamic> toJson() => _$ExtraInformationToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ExtraInformation &&
            (identical(other.certifications, certifications) ||
                const DeepCollectionEquality()
                    .equals(other.certifications, certifications)) &&
            (identical(other.identifications, identifications) ||
                const DeepCollectionEquality()
                    .equals(other.identifications, identifications)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(certifications) ^
      const DeepCollectionEquality().hash(identifications) ^
      runtimeType.hashCode;
}

extension $ExtraInformationExtension on ExtraInformation {
  ExtraInformation copyWith(
      {List<String>? certifications, List<String>? identifications}) {
    return ExtraInformation(
        certifications: certifications ?? this.certifications,
        identifications: identifications ?? this.identifications);
  }

  ExtraInformation copyWithWrapped(
      {Wrapped<List<String>?>? certifications,
      Wrapped<List<String>?>? identifications}) {
    return ExtraInformation(
        certifications: (certifications != null
            ? certifications.value
            : this.certifications),
        identifications: (identifications != null
            ? identifications.value
            : this.identifications));
  }
}

@JsonSerializable(explicitToJson: true)
class FeatureIcon {
  FeatureIcon({
    this.identifier,
    this.text,
  });

  factory FeatureIcon.fromJson(Map<String, dynamic> json) =>
      _$FeatureIconFromJson(json);

  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String? identifier;
  @JsonKey(name: 'text', includeIfNull: false, defaultValue: '')
  final String? text;
  static const fromJsonFactory = _$FeatureIconFromJson;
  static const toJsonFactory = _$FeatureIconToJson;
  Map<String, dynamic> toJson() => _$FeatureIconToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FeatureIcon &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.text, text) ||
                const DeepCollectionEquality().equals(other.text, text)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(text) ^
      runtimeType.hashCode;
}

extension $FeatureIconExtension on FeatureIcon {
  FeatureIcon copyWith({String? identifier, String? text}) {
    return FeatureIcon(
        identifier: identifier ?? this.identifier, text: text ?? this.text);
  }

  FeatureIcon copyWithWrapped(
      {Wrapped<String?>? identifier, Wrapped<String?>? text}) {
    return FeatureIcon(
        identifier: (identifier != null ? identifier.value : this.identifier),
        text: (text != null ? text.value : this.text));
  }
}

@JsonSerializable(explicitToJson: true)
class Fir {
  Fir({
    this.title,
    this.description,
    this.featureIcons,
    this.consumerUsageStorageInstructions,
    this.origin,
    this.ingredients,
    this.usage,
    this.itemOwner,
    this.extraInfo,
    this.contents,
    this.nutritionValues,
    this.isMedicine,
  });

  factory Fir.fromJson(Map<String, dynamic> json) => _$FirFromJson(json);

  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: <String>[])
  final List<String>? description;
  @JsonKey(
      name: 'featureIcons', includeIfNull: false, defaultValue: <FeatureIcon>[])
  final List<FeatureIcon>? featureIcons;
  @JsonKey(
      name: 'consumerUsageStorageInstructions',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? consumerUsageStorageInstructions;
  @JsonKey(name: 'origin', includeIfNull: false)
  final Origin? origin;
  @JsonKey(name: 'ingredients', includeIfNull: false)
  final Ingredients? ingredients;
  @JsonKey(name: 'usage', includeIfNull: false)
  final Usage? usage;
  @JsonKey(name: 'itemOwner', includeIfNull: false)
  final ItemOwner? itemOwner;
  @JsonKey(name: 'extraInfo', includeIfNull: false)
  final ExtraInformation? extraInfo;
  @JsonKey(name: 'contents', includeIfNull: false)
  final Contents? contents;
  @JsonKey(name: 'nutritionValues', includeIfNull: false)
  final NutritionValues? nutritionValues;
  @JsonKey(name: 'isMedicine', includeIfNull: false)
  final bool? isMedicine;
  static const fromJsonFactory = _$FirFromJson;
  static const toJsonFactory = _$FirToJson;
  Map<String, dynamic> toJson() => _$FirToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Fir &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.featureIcons, featureIcons) ||
                const DeepCollectionEquality()
                    .equals(other.featureIcons, featureIcons)) &&
            (identical(other.consumerUsageStorageInstructions,
                    consumerUsageStorageInstructions) ||
                const DeepCollectionEquality().equals(
                    other.consumerUsageStorageInstructions,
                    consumerUsageStorageInstructions)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)) &&
            (identical(other.ingredients, ingredients) ||
                const DeepCollectionEquality()
                    .equals(other.ingredients, ingredients)) &&
            (identical(other.usage, usage) ||
                const DeepCollectionEquality().equals(other.usage, usage)) &&
            (identical(other.itemOwner, itemOwner) ||
                const DeepCollectionEquality()
                    .equals(other.itemOwner, itemOwner)) &&
            (identical(other.extraInfo, extraInfo) ||
                const DeepCollectionEquality()
                    .equals(other.extraInfo, extraInfo)) &&
            (identical(other.contents, contents) ||
                const DeepCollectionEquality()
                    .equals(other.contents, contents)) &&
            (identical(other.nutritionValues, nutritionValues) ||
                const DeepCollectionEquality()
                    .equals(other.nutritionValues, nutritionValues)) &&
            (identical(other.isMedicine, isMedicine) ||
                const DeepCollectionEquality()
                    .equals(other.isMedicine, isMedicine)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(featureIcons) ^
      const DeepCollectionEquality().hash(consumerUsageStorageInstructions) ^
      const DeepCollectionEquality().hash(origin) ^
      const DeepCollectionEquality().hash(ingredients) ^
      const DeepCollectionEquality().hash(usage) ^
      const DeepCollectionEquality().hash(itemOwner) ^
      const DeepCollectionEquality().hash(extraInfo) ^
      const DeepCollectionEquality().hash(contents) ^
      const DeepCollectionEquality().hash(nutritionValues) ^
      const DeepCollectionEquality().hash(isMedicine) ^
      runtimeType.hashCode;
}

extension $FirExtension on Fir {
  Fir copyWith(
      {String? title,
      List<String>? description,
      List<FeatureIcon>? featureIcons,
      List<String>? consumerUsageStorageInstructions,
      Origin? origin,
      Ingredients? ingredients,
      Usage? usage,
      ItemOwner? itemOwner,
      ExtraInformation? extraInfo,
      Contents? contents,
      NutritionValues? nutritionValues,
      bool? isMedicine}) {
    return Fir(
        title: title ?? this.title,
        description: description ?? this.description,
        featureIcons: featureIcons ?? this.featureIcons,
        consumerUsageStorageInstructions: consumerUsageStorageInstructions ??
            this.consumerUsageStorageInstructions,
        origin: origin ?? this.origin,
        ingredients: ingredients ?? this.ingredients,
        usage: usage ?? this.usage,
        itemOwner: itemOwner ?? this.itemOwner,
        extraInfo: extraInfo ?? this.extraInfo,
        contents: contents ?? this.contents,
        nutritionValues: nutritionValues ?? this.nutritionValues,
        isMedicine: isMedicine ?? this.isMedicine);
  }

  Fir copyWithWrapped(
      {Wrapped<String?>? title,
      Wrapped<List<String>?>? description,
      Wrapped<List<FeatureIcon>?>? featureIcons,
      Wrapped<List<String>?>? consumerUsageStorageInstructions,
      Wrapped<Origin?>? origin,
      Wrapped<Ingredients?>? ingredients,
      Wrapped<Usage?>? usage,
      Wrapped<ItemOwner?>? itemOwner,
      Wrapped<ExtraInformation?>? extraInfo,
      Wrapped<Contents?>? contents,
      Wrapped<NutritionValues?>? nutritionValues,
      Wrapped<bool?>? isMedicine}) {
    return Fir(
        title: (title != null ? title.value : this.title),
        description:
            (description != null ? description.value : this.description),
        featureIcons:
            (featureIcons != null ? featureIcons.value : this.featureIcons),
        consumerUsageStorageInstructions:
            (consumerUsageStorageInstructions != null
                ? consumerUsageStorageInstructions.value
                : this.consumerUsageStorageInstructions),
        origin: (origin != null ? origin.value : this.origin),
        ingredients:
            (ingredients != null ? ingredients.value : this.ingredients),
        usage: (usage != null ? usage.value : this.usage),
        itemOwner: (itemOwner != null ? itemOwner.value : this.itemOwner),
        extraInfo: (extraInfo != null ? extraInfo.value : this.extraInfo),
        contents: (contents != null ? contents.value : this.contents),
        nutritionValues: (nutritionValues != null
            ? nutritionValues.value
            : this.nutritionValues),
        isMedicine: (isMedicine != null ? isMedicine.value : this.isMedicine));
  }
}

@JsonSerializable(explicitToJson: true)
class Ingredients {
  Ingredients({
    this.addedNutritionalValues,
    this.alcoholPercentage,
    this.allergens,
    this.ingredientAllergens,
    this.ingredientStatement,
    this.nonFoodIngredients,
  });

  factory Ingredients.fromJson(Map<String, dynamic> json) =>
      _$IngredientsFromJson(json);

  @JsonKey(
      name: 'addedNutritionalValues', includeIfNull: false, defaultValue: '')
  final String? addedNutritionalValues;
  @JsonKey(name: 'alcoholPercentage', includeIfNull: false, defaultValue: '')
  final String? alcoholPercentage;
  @JsonKey(name: 'allergens', includeIfNull: false, defaultValue: '')
  final String? allergens;
  @JsonKey(
      name: 'ingredientAllergens',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? ingredientAllergens;
  @JsonKey(name: 'ingredientStatement', includeIfNull: false, defaultValue: '')
  final String? ingredientStatement;
  @JsonKey(
      name: 'nonFoodIngredients',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? nonFoodIngredients;
  static const fromJsonFactory = _$IngredientsFromJson;
  static const toJsonFactory = _$IngredientsToJson;
  Map<String, dynamic> toJson() => _$IngredientsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Ingredients &&
            (identical(other.addedNutritionalValues, addedNutritionalValues) ||
                const DeepCollectionEquality().equals(
                    other.addedNutritionalValues, addedNutritionalValues)) &&
            (identical(other.alcoholPercentage, alcoholPercentage) ||
                const DeepCollectionEquality()
                    .equals(other.alcoholPercentage, alcoholPercentage)) &&
            (identical(other.allergens, allergens) ||
                const DeepCollectionEquality()
                    .equals(other.allergens, allergens)) &&
            (identical(other.ingredientAllergens, ingredientAllergens) ||
                const DeepCollectionEquality()
                    .equals(other.ingredientAllergens, ingredientAllergens)) &&
            (identical(other.ingredientStatement, ingredientStatement) ||
                const DeepCollectionEquality()
                    .equals(other.ingredientStatement, ingredientStatement)) &&
            (identical(other.nonFoodIngredients, nonFoodIngredients) ||
                const DeepCollectionEquality()
                    .equals(other.nonFoodIngredients, nonFoodIngredients)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(addedNutritionalValues) ^
      const DeepCollectionEquality().hash(alcoholPercentage) ^
      const DeepCollectionEquality().hash(allergens) ^
      const DeepCollectionEquality().hash(ingredientAllergens) ^
      const DeepCollectionEquality().hash(ingredientStatement) ^
      const DeepCollectionEquality().hash(nonFoodIngredients) ^
      runtimeType.hashCode;
}

extension $IngredientsExtension on Ingredients {
  Ingredients copyWith(
      {String? addedNutritionalValues,
      String? alcoholPercentage,
      String? allergens,
      List<String>? ingredientAllergens,
      String? ingredientStatement,
      List<String>? nonFoodIngredients}) {
    return Ingredients(
        addedNutritionalValues:
            addedNutritionalValues ?? this.addedNutritionalValues,
        alcoholPercentage: alcoholPercentage ?? this.alcoholPercentage,
        allergens: allergens ?? this.allergens,
        ingredientAllergens: ingredientAllergens ?? this.ingredientAllergens,
        ingredientStatement: ingredientStatement ?? this.ingredientStatement,
        nonFoodIngredients: nonFoodIngredients ?? this.nonFoodIngredients);
  }

  Ingredients copyWithWrapped(
      {Wrapped<String?>? addedNutritionalValues,
      Wrapped<String?>? alcoholPercentage,
      Wrapped<String?>? allergens,
      Wrapped<List<String>?>? ingredientAllergens,
      Wrapped<String?>? ingredientStatement,
      Wrapped<List<String>?>? nonFoodIngredients}) {
    return Ingredients(
        addedNutritionalValues: (addedNutritionalValues != null
            ? addedNutritionalValues.value
            : this.addedNutritionalValues),
        alcoholPercentage: (alcoholPercentage != null
            ? alcoholPercentage.value
            : this.alcoholPercentage),
        allergens: (allergens != null ? allergens.value : this.allergens),
        ingredientAllergens: (ingredientAllergens != null
            ? ingredientAllergens.value
            : this.ingredientAllergens),
        ingredientStatement: (ingredientStatement != null
            ? ingredientStatement.value
            : this.ingredientStatement),
        nonFoodIngredients: (nonFoodIngredients != null
            ? nonFoodIngredients.value
            : this.nonFoodIngredients));
  }
}

@JsonSerializable(explicitToJson: true)
class ItemOwner {
  ItemOwner({
    this.contacts,
    this.communicationChannels,
    this.agents,
  });

  factory ItemOwner.fromJson(Map<String, dynamic> json) =>
      _$ItemOwnerFromJson(json);

  @JsonKey(name: 'contacts', includeIfNull: false, defaultValue: <Contact>[])
  final List<Contact>? contacts;
  @JsonKey(
      name: 'communicationChannels',
      includeIfNull: false,
      defaultValue: <CommunicationChannel>[])
  final List<CommunicationChannel>? communicationChannels;
  @JsonKey(name: 'agents', includeIfNull: false, defaultValue: <Agent>[])
  final List<Agent>? agents;
  static const fromJsonFactory = _$ItemOwnerFromJson;
  static const toJsonFactory = _$ItemOwnerToJson;
  Map<String, dynamic> toJson() => _$ItemOwnerToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ItemOwner &&
            (identical(other.contacts, contacts) ||
                const DeepCollectionEquality()
                    .equals(other.contacts, contacts)) &&
            (identical(other.communicationChannels, communicationChannels) ||
                const DeepCollectionEquality().equals(
                    other.communicationChannels, communicationChannels)) &&
            (identical(other.agents, agents) ||
                const DeepCollectionEquality().equals(other.agents, agents)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(contacts) ^
      const DeepCollectionEquality().hash(communicationChannels) ^
      const DeepCollectionEquality().hash(agents) ^
      runtimeType.hashCode;
}

extension $ItemOwnerExtension on ItemOwner {
  ItemOwner copyWith(
      {List<Contact>? contacts,
      List<CommunicationChannel>? communicationChannels,
      List<Agent>? agents}) {
    return ItemOwner(
        contacts: contacts ?? this.contacts,
        communicationChannels:
            communicationChannels ?? this.communicationChannels,
        agents: agents ?? this.agents);
  }

  ItemOwner copyWithWrapped(
      {Wrapped<List<Contact>?>? contacts,
      Wrapped<List<CommunicationChannel>?>? communicationChannels,
      Wrapped<List<Agent>?>? agents}) {
    return ItemOwner(
        contacts: (contacts != null ? contacts.value : this.contacts),
        communicationChannels: (communicationChannels != null
            ? communicationChannels.value
            : this.communicationChannels),
        agents: (agents != null ? agents.value : this.agents));
  }
}

@JsonSerializable(explicitToJson: true)
class NutritionValues {
  NutritionValues({
    this.preparationStateDescription,
    this.dailyValueIntakeReference,
    this.servingSizeDescription,
    this.nutritionalValues,
  });

  factory NutritionValues.fromJson(Map<String, dynamic> json) =>
      _$NutritionValuesFromJson(json);

  @JsonKey(
      name: 'preparationStateDescription',
      includeIfNull: false,
      defaultValue: '')
  final String? preparationStateDescription;
  @JsonKey(
      name: 'dailyValueIntakeReference', includeIfNull: false, defaultValue: '')
  final String? dailyValueIntakeReference;
  @JsonKey(
      name: 'servingSizeDescription', includeIfNull: false, defaultValue: '')
  final String? servingSizeDescription;
  @JsonKey(
      name: 'nutritionalValues',
      includeIfNull: false,
      defaultValue: <NutritionalValue>[])
  final List<NutritionalValue>? nutritionalValues;
  static const fromJsonFactory = _$NutritionValuesFromJson;
  static const toJsonFactory = _$NutritionValuesToJson;
  Map<String, dynamic> toJson() => _$NutritionValuesToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NutritionValues &&
            (identical(other.preparationStateDescription,
                    preparationStateDescription) ||
                const DeepCollectionEquality().equals(
                    other.preparationStateDescription,
                    preparationStateDescription)) &&
            (identical(other.dailyValueIntakeReference,
                    dailyValueIntakeReference) ||
                const DeepCollectionEquality().equals(
                    other.dailyValueIntakeReference,
                    dailyValueIntakeReference)) &&
            (identical(other.servingSizeDescription, servingSizeDescription) ||
                const DeepCollectionEquality().equals(
                    other.servingSizeDescription, servingSizeDescription)) &&
            (identical(other.nutritionalValues, nutritionalValues) ||
                const DeepCollectionEquality()
                    .equals(other.nutritionalValues, nutritionalValues)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(preparationStateDescription) ^
      const DeepCollectionEquality().hash(dailyValueIntakeReference) ^
      const DeepCollectionEquality().hash(servingSizeDescription) ^
      const DeepCollectionEquality().hash(nutritionalValues) ^
      runtimeType.hashCode;
}

extension $NutritionValuesExtension on NutritionValues {
  NutritionValues copyWith(
      {String? preparationStateDescription,
      String? dailyValueIntakeReference,
      String? servingSizeDescription,
      List<NutritionalValue>? nutritionalValues}) {
    return NutritionValues(
        preparationStateDescription:
            preparationStateDescription ?? this.preparationStateDescription,
        dailyValueIntakeReference:
            dailyValueIntakeReference ?? this.dailyValueIntakeReference,
        servingSizeDescription:
            servingSizeDescription ?? this.servingSizeDescription,
        nutritionalValues: nutritionalValues ?? this.nutritionalValues);
  }

  NutritionValues copyWithWrapped(
      {Wrapped<String?>? preparationStateDescription,
      Wrapped<String?>? dailyValueIntakeReference,
      Wrapped<String?>? servingSizeDescription,
      Wrapped<List<NutritionalValue>?>? nutritionalValues}) {
    return NutritionValues(
        preparationStateDescription: (preparationStateDescription != null
            ? preparationStateDescription.value
            : this.preparationStateDescription),
        dailyValueIntakeReference: (dailyValueIntakeReference != null
            ? dailyValueIntakeReference.value
            : this.dailyValueIntakeReference),
        servingSizeDescription: (servingSizeDescription != null
            ? servingSizeDescription.value
            : this.servingSizeDescription),
        nutritionalValues: (nutritionalValues != null
            ? nutritionalValues.value
            : this.nutritionalValues));
  }
}

@JsonSerializable(explicitToJson: true)
class NutritionalValue {
  NutritionalValue({
    this.label,
    this.description,
    this.perDailyValue,
  });

  factory NutritionalValue.fromJson(Map<String, dynamic> json) =>
      _$NutritionalValueFromJson(json);

  @JsonKey(name: 'label', includeIfNull: false, defaultValue: '')
  final String? label;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'perDailyValue', includeIfNull: false, defaultValue: '')
  final String? perDailyValue;
  static const fromJsonFactory = _$NutritionalValueFromJson;
  static const toJsonFactory = _$NutritionalValueToJson;
  Map<String, dynamic> toJson() => _$NutritionalValueToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NutritionalValue &&
            (identical(other.label, label) ||
                const DeepCollectionEquality().equals(other.label, label)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.perDailyValue, perDailyValue) ||
                const DeepCollectionEquality()
                    .equals(other.perDailyValue, perDailyValue)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(label) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(perDailyValue) ^
      runtimeType.hashCode;
}

extension $NutritionalValueExtension on NutritionalValue {
  NutritionalValue copyWith(
      {String? label, String? description, String? perDailyValue}) {
    return NutritionalValue(
        label: label ?? this.label,
        description: description ?? this.description,
        perDailyValue: perDailyValue ?? this.perDailyValue);
  }

  NutritionalValue copyWithWrapped(
      {Wrapped<String?>? label,
      Wrapped<String?>? description,
      Wrapped<String?>? perDailyValue}) {
    return NutritionalValue(
        label: (label != null ? label.value : this.label),
        description:
            (description != null ? description.value : this.description),
        perDailyValue:
            (perDailyValue != null ? perDailyValue.value : this.perDailyValue));
  }
}

@JsonSerializable(explicitToJson: true)
class Origin {
  Origin({
    this.countryOfOrigin,
    this.placeOfSlaughter,
    this.placeOfBirth,
  });

  factory Origin.fromJson(Map<String, dynamic> json) => _$OriginFromJson(json);

  @JsonKey(name: 'countryOfOrigin', includeIfNull: false, defaultValue: '')
  final String? countryOfOrigin;
  @JsonKey(name: 'placeOfSlaughter', includeIfNull: false, defaultValue: '')
  final String? placeOfSlaughter;
  @JsonKey(name: 'placeOfBirth', includeIfNull: false, defaultValue: '')
  final String? placeOfBirth;
  static const fromJsonFactory = _$OriginFromJson;
  static const toJsonFactory = _$OriginToJson;
  Map<String, dynamic> toJson() => _$OriginToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Origin &&
            (identical(other.countryOfOrigin, countryOfOrigin) ||
                const DeepCollectionEquality()
                    .equals(other.countryOfOrigin, countryOfOrigin)) &&
            (identical(other.placeOfSlaughter, placeOfSlaughter) ||
                const DeepCollectionEquality()
                    .equals(other.placeOfSlaughter, placeOfSlaughter)) &&
            (identical(other.placeOfBirth, placeOfBirth) ||
                const DeepCollectionEquality()
                    .equals(other.placeOfBirth, placeOfBirth)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(countryOfOrigin) ^
      const DeepCollectionEquality().hash(placeOfSlaughter) ^
      const DeepCollectionEquality().hash(placeOfBirth) ^
      runtimeType.hashCode;
}

extension $OriginExtension on Origin {
  Origin copyWith(
      {String? countryOfOrigin,
      String? placeOfSlaughter,
      String? placeOfBirth}) {
    return Origin(
        countryOfOrigin: countryOfOrigin ?? this.countryOfOrigin,
        placeOfSlaughter: placeOfSlaughter ?? this.placeOfSlaughter,
        placeOfBirth: placeOfBirth ?? this.placeOfBirth);
  }

  Origin copyWithWrapped(
      {Wrapped<String?>? countryOfOrigin,
      Wrapped<String?>? placeOfSlaughter,
      Wrapped<String?>? placeOfBirth}) {
    return Origin(
        countryOfOrigin: (countryOfOrigin != null
            ? countryOfOrigin.value
            : this.countryOfOrigin),
        placeOfSlaughter: (placeOfSlaughter != null
            ? placeOfSlaughter.value
            : this.placeOfSlaughter),
        placeOfBirth:
            (placeOfBirth != null ? placeOfBirth.value : this.placeOfBirth));
  }
}

@JsonSerializable(explicitToJson: true)
class Usage {
  Usage({
    this.preparationInstructions,
    this.drugSideEffects,
    this.recommendations,
    this.instructionsUrl,
    this.hazardStatement,
    this.precautions,
  });

  factory Usage.fromJson(Map<String, dynamic> json) => _$UsageFromJson(json);

  @JsonKey(
      name: 'preparationInstructions',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? preparationInstructions;
  @JsonKey(name: 'drugSideEffects', includeIfNull: false, defaultValue: '')
  final String? drugSideEffects;
  @JsonKey(
      name: 'recommendations', includeIfNull: false, defaultValue: <String>[])
  final List<String>? recommendations;
  @JsonKey(name: 'instructionsUrl', includeIfNull: false, defaultValue: '')
  final String? instructionsUrl;
  @JsonKey(name: 'hazardStatement', includeIfNull: false, defaultValue: '')
  final String? hazardStatement;
  @JsonKey(name: 'precautions', includeIfNull: false, defaultValue: '')
  final String? precautions;
  static const fromJsonFactory = _$UsageFromJson;
  static const toJsonFactory = _$UsageToJson;
  Map<String, dynamic> toJson() => _$UsageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Usage &&
            (identical(
                    other.preparationInstructions, preparationInstructions) ||
                const DeepCollectionEquality().equals(
                    other.preparationInstructions, preparationInstructions)) &&
            (identical(other.drugSideEffects, drugSideEffects) ||
                const DeepCollectionEquality()
                    .equals(other.drugSideEffects, drugSideEffects)) &&
            (identical(other.recommendations, recommendations) ||
                const DeepCollectionEquality()
                    .equals(other.recommendations, recommendations)) &&
            (identical(other.instructionsUrl, instructionsUrl) ||
                const DeepCollectionEquality()
                    .equals(other.instructionsUrl, instructionsUrl)) &&
            (identical(other.hazardStatement, hazardStatement) ||
                const DeepCollectionEquality()
                    .equals(other.hazardStatement, hazardStatement)) &&
            (identical(other.precautions, precautions) ||
                const DeepCollectionEquality()
                    .equals(other.precautions, precautions)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(preparationInstructions) ^
      const DeepCollectionEquality().hash(drugSideEffects) ^
      const DeepCollectionEquality().hash(recommendations) ^
      const DeepCollectionEquality().hash(instructionsUrl) ^
      const DeepCollectionEquality().hash(hazardStatement) ^
      const DeepCollectionEquality().hash(precautions) ^
      runtimeType.hashCode;
}

extension $UsageExtension on Usage {
  Usage copyWith(
      {List<String>? preparationInstructions,
      String? drugSideEffects,
      List<String>? recommendations,
      String? instructionsUrl,
      String? hazardStatement,
      String? precautions}) {
    return Usage(
        preparationInstructions:
            preparationInstructions ?? this.preparationInstructions,
        drugSideEffects: drugSideEffects ?? this.drugSideEffects,
        recommendations: recommendations ?? this.recommendations,
        instructionsUrl: instructionsUrl ?? this.instructionsUrl,
        hazardStatement: hazardStatement ?? this.hazardStatement,
        precautions: precautions ?? this.precautions);
  }

  Usage copyWithWrapped(
      {Wrapped<List<String>?>? preparationInstructions,
      Wrapped<String?>? drugSideEffects,
      Wrapped<List<String>?>? recommendations,
      Wrapped<String?>? instructionsUrl,
      Wrapped<String?>? hazardStatement,
      Wrapped<String?>? precautions}) {
    return Usage(
        preparationInstructions: (preparationInstructions != null
            ? preparationInstructions.value
            : this.preparationInstructions),
        drugSideEffects: (drugSideEffects != null
            ? drugSideEffects.value
            : this.drugSideEffects),
        recommendations: (recommendations != null
            ? recommendations.value
            : this.recommendations),
        instructionsUrl: (instructionsUrl != null
            ? instructionsUrl.value
            : this.instructionsUrl),
        hazardStatement: (hazardStatement != null
            ? hazardStatement.value
            : this.hazardStatement),
        precautions:
            (precautions != null ? precautions.value : this.precautions));
  }
}

@JsonSerializable(explicitToJson: true)
class AdditionalTradeItemIdentificationBffApi {
  AdditionalTradeItemIdentificationBffApi({
    this.value,
    this.typeCode,
  });

  factory AdditionalTradeItemIdentificationBffApi.fromJson(
          Map<String, dynamic> json) =>
      _$AdditionalTradeItemIdentificationBffApiFromJson(json);

  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String? value;
  @JsonKey(name: 'typeCode', includeIfNull: false)
  final CodeWithLabelBffApi? typeCode;
  static const fromJsonFactory =
      _$AdditionalTradeItemIdentificationBffApiFromJson;
  static const toJsonFactory = _$AdditionalTradeItemIdentificationBffApiToJson;
  Map<String, dynamic> toJson() =>
      _$AdditionalTradeItemIdentificationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AdditionalTradeItemIdentificationBffApi &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)) &&
            (identical(other.typeCode, typeCode) ||
                const DeepCollectionEquality()
                    .equals(other.typeCode, typeCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(value) ^
      const DeepCollectionEquality().hash(typeCode) ^
      runtimeType.hashCode;
}

extension $AdditionalTradeItemIdentificationBffApiExtension
    on AdditionalTradeItemIdentificationBffApi {
  AdditionalTradeItemIdentificationBffApi copyWith(
      {String? value, CodeWithLabelBffApi? typeCode}) {
    return AdditionalTradeItemIdentificationBffApi(
        value: value ?? this.value, typeCode: typeCode ?? this.typeCode);
  }

  AdditionalTradeItemIdentificationBffApi copyWithWrapped(
      {Wrapped<String?>? value, Wrapped<CodeWithLabelBffApi?>? typeCode}) {
    return AdditionalTradeItemIdentificationBffApi(
        value: (value != null ? value.value : this.value),
        typeCode: (typeCode != null ? typeCode.value : this.typeCode));
  }
}

@JsonSerializable(explicitToJson: true)
class AlcoholInformationBffApi {
  AlcoholInformationBffApi({
    this.percentageOfAlcoholByVolume,
  });

  factory AlcoholInformationBffApi.fromJson(Map<String, dynamic> json) =>
      _$AlcoholInformationBffApiFromJson(json);

  @JsonKey(name: 'percentageOfAlcoholByVolume', includeIfNull: false)
  final double? percentageOfAlcoholByVolume;
  static const fromJsonFactory = _$AlcoholInformationBffApiFromJson;
  static const toJsonFactory = _$AlcoholInformationBffApiToJson;
  Map<String, dynamic> toJson() => _$AlcoholInformationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AlcoholInformationBffApi &&
            (identical(other.percentageOfAlcoholByVolume,
                    percentageOfAlcoholByVolume) ||
                const DeepCollectionEquality().equals(
                    other.percentageOfAlcoholByVolume,
                    percentageOfAlcoholByVolume)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(percentageOfAlcoholByVolume) ^
      runtimeType.hashCode;
}

extension $AlcoholInformationBffApiExtension on AlcoholInformationBffApi {
  AlcoholInformationBffApi copyWith({double? percentageOfAlcoholByVolume}) {
    return AlcoholInformationBffApi(
        percentageOfAlcoholByVolume:
            percentageOfAlcoholByVolume ?? this.percentageOfAlcoholByVolume);
  }

  AlcoholInformationBffApi copyWithWrapped(
      {Wrapped<double?>? percentageOfAlcoholByVolume}) {
    return AlcoholInformationBffApi(
        percentageOfAlcoholByVolume: (percentageOfAlcoholByVolume != null
            ? percentageOfAlcoholByVolume.value
            : this.percentageOfAlcoholByVolume));
  }
}

@JsonSerializable(explicitToJson: true)
class AllergenBffApi {
  AllergenBffApi({
    this.typeCode,
    this.levelOfContainmentCode,
  });

  factory AllergenBffApi.fromJson(Map<String, dynamic> json) =>
      _$AllergenBffApiFromJson(json);

  @JsonKey(name: 'typeCode', includeIfNull: false)
  final CodeWithLabelBffApi? typeCode;
  @JsonKey(name: 'levelOfContainmentCode', includeIfNull: false)
  final CodeWithLabelBffApi? levelOfContainmentCode;
  static const fromJsonFactory = _$AllergenBffApiFromJson;
  static const toJsonFactory = _$AllergenBffApiToJson;
  Map<String, dynamic> toJson() => _$AllergenBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AllergenBffApi &&
            (identical(other.typeCode, typeCode) ||
                const DeepCollectionEquality()
                    .equals(other.typeCode, typeCode)) &&
            (identical(other.levelOfContainmentCode, levelOfContainmentCode) ||
                const DeepCollectionEquality().equals(
                    other.levelOfContainmentCode, levelOfContainmentCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(typeCode) ^
      const DeepCollectionEquality().hash(levelOfContainmentCode) ^
      runtimeType.hashCode;
}

extension $AllergenBffApiExtension on AllergenBffApi {
  AllergenBffApi copyWith(
      {CodeWithLabelBffApi? typeCode,
      CodeWithLabelBffApi? levelOfContainmentCode}) {
    return AllergenBffApi(
        typeCode: typeCode ?? this.typeCode,
        levelOfContainmentCode:
            levelOfContainmentCode ?? this.levelOfContainmentCode);
  }

  AllergenBffApi copyWithWrapped(
      {Wrapped<CodeWithLabelBffApi?>? typeCode,
      Wrapped<CodeWithLabelBffApi?>? levelOfContainmentCode}) {
    return AllergenBffApi(
        typeCode: (typeCode != null ? typeCode.value : this.typeCode),
        levelOfContainmentCode: (levelOfContainmentCode != null
            ? levelOfContainmentCode.value
            : this.levelOfContainmentCode));
  }
}

@JsonSerializable(explicitToJson: true)
class AllergenInformationBffApi {
  AllergenInformationBffApi({
    this.items,
    this.statement,
  });

  factory AllergenInformationBffApi.fromJson(Map<String, dynamic> json) =>
      _$AllergenInformationBffApiFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <AllergenBffApi>[])
  final List<AllergenBffApi>? items;
  @JsonKey(name: 'statement', includeIfNull: false, defaultValue: '')
  final String? statement;
  static const fromJsonFactory = _$AllergenInformationBffApiFromJson;
  static const toJsonFactory = _$AllergenInformationBffApiToJson;
  Map<String, dynamic> toJson() => _$AllergenInformationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AllergenInformationBffApi &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.statement, statement) ||
                const DeepCollectionEquality()
                    .equals(other.statement, statement)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(statement) ^
      runtimeType.hashCode;
}

extension $AllergenInformationBffApiExtension on AllergenInformationBffApi {
  AllergenInformationBffApi copyWith(
      {List<AllergenBffApi>? items, String? statement}) {
    return AllergenInformationBffApi(
        items: items ?? this.items, statement: statement ?? this.statement);
  }

  AllergenInformationBffApi copyWithWrapped(
      {Wrapped<List<AllergenBffApi>?>? items, Wrapped<String?>? statement}) {
    return AllergenInformationBffApi(
        items: (items != null ? items.value : this.items),
        statement: (statement != null ? statement.value : this.statement));
  }
}

@JsonSerializable(explicitToJson: true)
class AnimalFeedingBffApi {
  AnimalFeedingBffApi({
    this.additiveStatement,
    this.analyticalConstituentsStatement,
    this.compositionStatement,
    this.type,
    this.instructions,
    this.targetedConsumptionBy,
  });

  factory AnimalFeedingBffApi.fromJson(Map<String, dynamic> json) =>
      _$AnimalFeedingBffApiFromJson(json);

  @JsonKey(name: 'additiveStatement', includeIfNull: false, defaultValue: '')
  final String? additiveStatement;
  @JsonKey(
      name: 'analyticalConstituentsStatement',
      includeIfNull: false,
      defaultValue: '')
  final String? analyticalConstituentsStatement;
  @JsonKey(name: 'compositionStatement', includeIfNull: false, defaultValue: '')
  final String? compositionStatement;
  @JsonKey(
      name: 'type', includeIfNull: false, defaultValue: <CodeWithLabelBffApi>[])
  final List<CodeWithLabelBffApi>? type;
  @JsonKey(name: 'instructions', includeIfNull: false, defaultValue: '')
  final String? instructions;
  @JsonKey(
      name: 'targetedConsumptionBy',
      includeIfNull: false,
      defaultValue: <CodeWithLabelBffApi>[])
  final List<CodeWithLabelBffApi>? targetedConsumptionBy;
  static const fromJsonFactory = _$AnimalFeedingBffApiFromJson;
  static const toJsonFactory = _$AnimalFeedingBffApiToJson;
  Map<String, dynamic> toJson() => _$AnimalFeedingBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AnimalFeedingBffApi &&
            (identical(other.additiveStatement, additiveStatement) ||
                const DeepCollectionEquality()
                    .equals(other.additiveStatement, additiveStatement)) &&
            (identical(other.analyticalConstituentsStatement,
                    analyticalConstituentsStatement) ||
                const DeepCollectionEquality().equals(
                    other.analyticalConstituentsStatement,
                    analyticalConstituentsStatement)) &&
            (identical(other.compositionStatement, compositionStatement) ||
                const DeepCollectionEquality().equals(
                    other.compositionStatement, compositionStatement)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.instructions, instructions) ||
                const DeepCollectionEquality()
                    .equals(other.instructions, instructions)) &&
            (identical(other.targetedConsumptionBy, targetedConsumptionBy) ||
                const DeepCollectionEquality().equals(
                    other.targetedConsumptionBy, targetedConsumptionBy)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(additiveStatement) ^
      const DeepCollectionEquality().hash(analyticalConstituentsStatement) ^
      const DeepCollectionEquality().hash(compositionStatement) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(instructions) ^
      const DeepCollectionEquality().hash(targetedConsumptionBy) ^
      runtimeType.hashCode;
}

extension $AnimalFeedingBffApiExtension on AnimalFeedingBffApi {
  AnimalFeedingBffApi copyWith(
      {String? additiveStatement,
      String? analyticalConstituentsStatement,
      String? compositionStatement,
      List<CodeWithLabelBffApi>? type,
      String? instructions,
      List<CodeWithLabelBffApi>? targetedConsumptionBy}) {
    return AnimalFeedingBffApi(
        additiveStatement: additiveStatement ?? this.additiveStatement,
        analyticalConstituentsStatement: analyticalConstituentsStatement ??
            this.analyticalConstituentsStatement,
        compositionStatement: compositionStatement ?? this.compositionStatement,
        type: type ?? this.type,
        instructions: instructions ?? this.instructions,
        targetedConsumptionBy:
            targetedConsumptionBy ?? this.targetedConsumptionBy);
  }

  AnimalFeedingBffApi copyWithWrapped(
      {Wrapped<String?>? additiveStatement,
      Wrapped<String?>? analyticalConstituentsStatement,
      Wrapped<String?>? compositionStatement,
      Wrapped<List<CodeWithLabelBffApi>?>? type,
      Wrapped<String?>? instructions,
      Wrapped<List<CodeWithLabelBffApi>?>? targetedConsumptionBy}) {
    return AnimalFeedingBffApi(
        additiveStatement: (additiveStatement != null
            ? additiveStatement.value
            : this.additiveStatement),
        analyticalConstituentsStatement:
            (analyticalConstituentsStatement != null
                ? analyticalConstituentsStatement.value
                : this.analyticalConstituentsStatement),
        compositionStatement: (compositionStatement != null
            ? compositionStatement.value
            : this.compositionStatement),
        type: (type != null ? type.value : this.type),
        instructions:
            (instructions != null ? instructions.value : this.instructions),
        targetedConsumptionBy: (targetedConsumptionBy != null
            ? targetedConsumptionBy.value
            : this.targetedConsumptionBy));
  }
}

@JsonSerializable(explicitToJson: true)
class CertificationBffApi {
  CertificationBffApi({
    this.value,
  });

  factory CertificationBffApi.fromJson(Map<String, dynamic> json) =>
      _$CertificationBffApiFromJson(json);

  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String? value;
  static const fromJsonFactory = _$CertificationBffApiFromJson;
  static const toJsonFactory = _$CertificationBffApiToJson;
  Map<String, dynamic> toJson() => _$CertificationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CertificationBffApi &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(value) ^ runtimeType.hashCode;
}

extension $CertificationBffApiExtension on CertificationBffApi {
  CertificationBffApi copyWith({String? value}) {
    return CertificationBffApi(value: value ?? this.value);
  }

  CertificationBffApi copyWithWrapped({Wrapped<String?>? value}) {
    return CertificationBffApi(
        value: (value != null ? value.value : this.value));
  }
}

@JsonSerializable(explicitToJson: true)
class CertificationInformationBffApi {
  CertificationInformationBffApi({
    this.items,
    this.agency,
  });

  factory CertificationInformationBffApi.fromJson(Map<String, dynamic> json) =>
      _$CertificationInformationBffApiFromJson(json);

  @JsonKey(
      name: 'items',
      includeIfNull: false,
      defaultValue: <CertificationBffApi>[])
  final List<CertificationBffApi>? items;
  @JsonKey(name: 'agency', includeIfNull: false, defaultValue: '')
  final String? agency;
  static const fromJsonFactory = _$CertificationInformationBffApiFromJson;
  static const toJsonFactory = _$CertificationInformationBffApiToJson;
  Map<String, dynamic> toJson() => _$CertificationInformationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CertificationInformationBffApi &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.agency, agency) ||
                const DeepCollectionEquality().equals(other.agency, agency)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(agency) ^
      runtimeType.hashCode;
}

extension $CertificationInformationBffApiExtension
    on CertificationInformationBffApi {
  CertificationInformationBffApi copyWith(
      {List<CertificationBffApi>? items, String? agency}) {
    return CertificationInformationBffApi(
        items: items ?? this.items, agency: agency ?? this.agency);
  }

  CertificationInformationBffApi copyWithWrapped(
      {Wrapped<List<CertificationBffApi>?>? items, Wrapped<String?>? agency}) {
    return CertificationInformationBffApi(
        items: (items != null ? items.value : this.items),
        agency: (agency != null ? agency.value : this.agency));
  }
}

@JsonSerializable(explicitToJson: true)
class CodeWithLabelBffApi {
  CodeWithLabelBffApi({
    this.value,
    this.label,
  });

  factory CodeWithLabelBffApi.fromJson(Map<String, dynamic> json) =>
      _$CodeWithLabelBffApiFromJson(json);

  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String? value;
  @JsonKey(name: 'label', includeIfNull: false, defaultValue: '')
  final String? label;
  static const fromJsonFactory = _$CodeWithLabelBffApiFromJson;
  static const toJsonFactory = _$CodeWithLabelBffApiToJson;
  Map<String, dynamic> toJson() => _$CodeWithLabelBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CodeWithLabelBffApi &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)) &&
            (identical(other.label, label) ||
                const DeepCollectionEquality().equals(other.label, label)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(value) ^
      const DeepCollectionEquality().hash(label) ^
      runtimeType.hashCode;
}

extension $CodeWithLabelBffApiExtension on CodeWithLabelBffApi {
  CodeWithLabelBffApi copyWith({String? value, String? label}) {
    return CodeWithLabelBffApi(
        value: value ?? this.value, label: label ?? this.label);
  }

  CodeWithLabelBffApi copyWithWrapped(
      {Wrapped<String?>? value, Wrapped<String?>? label}) {
    return CodeWithLabelBffApi(
        value: (value != null ? value.value : this.value),
        label: (label != null ? label.value : this.label));
  }
}

@JsonSerializable(explicitToJson: true)
class CommunicationChannelBffApi {
  CommunicationChannelBffApi({
    this.code,
    this.name,
    this.value,
  });

  factory CommunicationChannelBffApi.fromJson(Map<String, dynamic> json) =>
      _$CommunicationChannelBffApiFromJson(json);

  @JsonKey(name: 'code', includeIfNull: false)
  final CodeWithLabelBffApi? code;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String? value;
  static const fromJsonFactory = _$CommunicationChannelBffApiFromJson;
  static const toJsonFactory = _$CommunicationChannelBffApiToJson;
  Map<String, dynamic> toJson() => _$CommunicationChannelBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CommunicationChannelBffApi &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(code) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(value) ^
      runtimeType.hashCode;
}

extension $CommunicationChannelBffApiExtension on CommunicationChannelBffApi {
  CommunicationChannelBffApi copyWith(
      {CodeWithLabelBffApi? code, String? name, String? value}) {
    return CommunicationChannelBffApi(
        code: code ?? this.code,
        name: name ?? this.name,
        value: value ?? this.value);
  }

  CommunicationChannelBffApi copyWithWrapped(
      {Wrapped<CodeWithLabelBffApi?>? code,
      Wrapped<String?>? name,
      Wrapped<String?>? value}) {
    return CommunicationChannelBffApi(
        code: (code != null ? code.value : this.code),
        name: (name != null ? name.value : this.name),
        value: (value != null ? value.value : this.value));
  }
}

@JsonSerializable(explicitToJson: true)
class ConsumerInstructionsBffApi {
  ConsumerInstructionsBffApi({
    this.storageInstructions,
    this.usageInstructions,
  });

  factory ConsumerInstructionsBffApi.fromJson(Map<String, dynamic> json) =>
      _$ConsumerInstructionsBffApiFromJson(json);

  @JsonKey(
      name: 'storageInstructions',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? storageInstructions;
  @JsonKey(
      name: 'usageInstructions', includeIfNull: false, defaultValue: <String>[])
  final List<String>? usageInstructions;
  static const fromJsonFactory = _$ConsumerInstructionsBffApiFromJson;
  static const toJsonFactory = _$ConsumerInstructionsBffApiToJson;
  Map<String, dynamic> toJson() => _$ConsumerInstructionsBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ConsumerInstructionsBffApi &&
            (identical(other.storageInstructions, storageInstructions) ||
                const DeepCollectionEquality()
                    .equals(other.storageInstructions, storageInstructions)) &&
            (identical(other.usageInstructions, usageInstructions) ||
                const DeepCollectionEquality()
                    .equals(other.usageInstructions, usageInstructions)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(storageInstructions) ^
      const DeepCollectionEquality().hash(usageInstructions) ^
      runtimeType.hashCode;
}

extension $ConsumerInstructionsBffApiExtension on ConsumerInstructionsBffApi {
  ConsumerInstructionsBffApi copyWith(
      {List<String>? storageInstructions, List<String>? usageInstructions}) {
    return ConsumerInstructionsBffApi(
        storageInstructions: storageInstructions ?? this.storageInstructions,
        usageInstructions: usageInstructions ?? this.usageInstructions);
  }

  ConsumerInstructionsBffApi copyWithWrapped(
      {Wrapped<List<String>?>? storageInstructions,
      Wrapped<List<String>?>? usageInstructions}) {
    return ConsumerInstructionsBffApi(
        storageInstructions: (storageInstructions != null
            ? storageInstructions.value
            : this.storageInstructions),
        usageInstructions: (usageInstructions != null
            ? usageInstructions.value
            : this.usageInstructions));
  }
}

@JsonSerializable(explicitToJson: true)
class DairyFishMeatPoultryInformationBffApi {
  DairyFishMeatPoultryInformationBffApi({
    this.fishReportingInformation,
  });

  factory DairyFishMeatPoultryInformationBffApi.fromJson(
          Map<String, dynamic> json) =>
      _$DairyFishMeatPoultryInformationBffApiFromJson(json);

  @JsonKey(name: 'fishReportingInformation', includeIfNull: false)
  final FishReportingInformationBffApi? fishReportingInformation;
  static const fromJsonFactory =
      _$DairyFishMeatPoultryInformationBffApiFromJson;
  static const toJsonFactory = _$DairyFishMeatPoultryInformationBffApiToJson;
  Map<String, dynamic> toJson() =>
      _$DairyFishMeatPoultryInformationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DairyFishMeatPoultryInformationBffApi &&
            (identical(
                    other.fishReportingInformation, fishReportingInformation) ||
                const DeepCollectionEquality().equals(
                    other.fishReportingInformation, fishReportingInformation)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(fishReportingInformation) ^
      runtimeType.hashCode;
}

extension $DairyFishMeatPoultryInformationBffApiExtension
    on DairyFishMeatPoultryInformationBffApi {
  DairyFishMeatPoultryInformationBffApi copyWith(
      {FishReportingInformationBffApi? fishReportingInformation}) {
    return DairyFishMeatPoultryInformationBffApi(
        fishReportingInformation:
            fishReportingInformation ?? this.fishReportingInformation);
  }

  DairyFishMeatPoultryInformationBffApi copyWithWrapped(
      {Wrapped<FishReportingInformationBffApi?>? fishReportingInformation}) {
    return DairyFishMeatPoultryInformationBffApi(
        fishReportingInformation: (fishReportingInformation != null
            ? fishReportingInformation.value
            : this.fishReportingInformation));
  }
}

@JsonSerializable(explicitToJson: true)
class DosageBffApi {
  DosageBffApi({
    this.formTypeCodeReference,
    this.recommendation,
  });

  factory DosageBffApi.fromJson(Map<String, dynamic> json) =>
      _$DosageBffApiFromJson(json);

  @JsonKey(
      name: 'formTypeCodeReference',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? formTypeCodeReference;
  @JsonKey(
      name: 'recommendation', includeIfNull: false, defaultValue: <String>[])
  final List<String>? recommendation;
  static const fromJsonFactory = _$DosageBffApiFromJson;
  static const toJsonFactory = _$DosageBffApiToJson;
  Map<String, dynamic> toJson() => _$DosageBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DosageBffApi &&
            (identical(other.formTypeCodeReference, formTypeCodeReference) ||
                const DeepCollectionEquality().equals(
                    other.formTypeCodeReference, formTypeCodeReference)) &&
            (identical(other.recommendation, recommendation) ||
                const DeepCollectionEquality()
                    .equals(other.recommendation, recommendation)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(formTypeCodeReference) ^
      const DeepCollectionEquality().hash(recommendation) ^
      runtimeType.hashCode;
}

extension $DosageBffApiExtension on DosageBffApi {
  DosageBffApi copyWith(
      {List<String>? formTypeCodeReference, List<String>? recommendation}) {
    return DosageBffApi(
        formTypeCodeReference:
            formTypeCodeReference ?? this.formTypeCodeReference,
        recommendation: recommendation ?? this.recommendation);
  }

  DosageBffApi copyWithWrapped(
      {Wrapped<List<String>?>? formTypeCodeReference,
      Wrapped<List<String>?>? recommendation}) {
    return DosageBffApi(
        formTypeCodeReference: (formTypeCodeReference != null
            ? formTypeCodeReference.value
            : this.formTypeCodeReference),
        recommendation: (recommendation != null
            ? recommendation.value
            : this.recommendation));
  }
}

@JsonSerializable(explicitToJson: true)
class FishCatchInformationBffApi {
  FishCatchInformationBffApi({
    this.catchMethodCode,
  });

  factory FishCatchInformationBffApi.fromJson(Map<String, dynamic> json) =>
      _$FishCatchInformationBffApiFromJson(json);

  @JsonKey(name: 'catchMethodCode', includeIfNull: false)
  final List<CodeWithLabelBffApi>? catchMethodCode;
  static const fromJsonFactory = _$FishCatchInformationBffApiFromJson;
  static const toJsonFactory = _$FishCatchInformationBffApiToJson;
  Map<String, dynamic> toJson() => _$FishCatchInformationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FishCatchInformationBffApi &&
            (identical(other.catchMethodCode, catchMethodCode) ||
                const DeepCollectionEquality()
                    .equals(other.catchMethodCode, catchMethodCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(catchMethodCode) ^
      runtimeType.hashCode;
}

extension $FishCatchInformationBffApiExtension on FishCatchInformationBffApi {
  FishCatchInformationBffApi copyWith(
      {List<CodeWithLabelBffApi>? catchMethodCode}) {
    return FishCatchInformationBffApi(
        catchMethodCode: catchMethodCode ?? this.catchMethodCode);
  }

  FishCatchInformationBffApi copyWithWrapped(
      {Wrapped<List<CodeWithLabelBffApi>?>? catchMethodCode}) {
    return FishCatchInformationBffApi(
        catchMethodCode: (catchMethodCode != null
            ? catchMethodCode.value
            : this.catchMethodCode));
  }
}

@JsonSerializable(explicitToJson: true)
class FishReportingInformationBffApi {
  FishReportingInformationBffApi({
    this.catchInformation,
  });

  factory FishReportingInformationBffApi.fromJson(Map<String, dynamic> json) =>
      _$FishReportingInformationBffApiFromJson(json);

  @JsonKey(name: 'catchInformation', includeIfNull: false)
  final FishCatchInformationBffApi? catchInformation;
  static const fromJsonFactory = _$FishReportingInformationBffApiFromJson;
  static const toJsonFactory = _$FishReportingInformationBffApiToJson;
  Map<String, dynamic> toJson() => _$FishReportingInformationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FishReportingInformationBffApi &&
            (identical(other.catchInformation, catchInformation) ||
                const DeepCollectionEquality()
                    .equals(other.catchInformation, catchInformation)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(catchInformation) ^
      runtimeType.hashCode;
}

extension $FishReportingInformationBffApiExtension
    on FishReportingInformationBffApi {
  FishReportingInformationBffApi copyWith(
      {FishCatchInformationBffApi? catchInformation}) {
    return FishReportingInformationBffApi(
        catchInformation: catchInformation ?? this.catchInformation);
  }

  FishReportingInformationBffApi copyWithWrapped(
      {Wrapped<FishCatchInformationBffApi?>? catchInformation}) {
    return FishReportingInformationBffApi(
        catchInformation: (catchInformation != null
            ? catchInformation.value
            : this.catchInformation));
  }
}

@JsonSerializable(explicitToJson: true)
class FoodAndBeveragePreparationServingBffApi {
  FoodAndBeveragePreparationServingBffApi({
    this.preparationServing,
    this.servingQuantityInformation,
  });

  factory FoodAndBeveragePreparationServingBffApi.fromJson(
          Map<String, dynamic> json) =>
      _$FoodAndBeveragePreparationServingBffApiFromJson(json);

  @JsonKey(
      name: 'preparationServing',
      includeIfNull: false,
      defaultValue: <PreparationServingBffApi>[])
  final List<PreparationServingBffApi>? preparationServing;
  @JsonKey(name: 'servingQuantityInformation', includeIfNull: false)
  final ServingQuantityInformationBffApi? servingQuantityInformation;
  static const fromJsonFactory =
      _$FoodAndBeveragePreparationServingBffApiFromJson;
  static const toJsonFactory = _$FoodAndBeveragePreparationServingBffApiToJson;
  Map<String, dynamic> toJson() =>
      _$FoodAndBeveragePreparationServingBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FoodAndBeveragePreparationServingBffApi &&
            (identical(other.preparationServing, preparationServing) ||
                const DeepCollectionEquality()
                    .equals(other.preparationServing, preparationServing)) &&
            (identical(other.servingQuantityInformation,
                    servingQuantityInformation) ||
                const DeepCollectionEquality().equals(
                    other.servingQuantityInformation,
                    servingQuantityInformation)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(preparationServing) ^
      const DeepCollectionEquality().hash(servingQuantityInformation) ^
      runtimeType.hashCode;
}

extension $FoodAndBeveragePreparationServingBffApiExtension
    on FoodAndBeveragePreparationServingBffApi {
  FoodAndBeveragePreparationServingBffApi copyWith(
      {List<PreparationServingBffApi>? preparationServing,
      ServingQuantityInformationBffApi? servingQuantityInformation}) {
    return FoodAndBeveragePreparationServingBffApi(
        preparationServing: preparationServing ?? this.preparationServing,
        servingQuantityInformation:
            servingQuantityInformation ?? this.servingQuantityInformation);
  }

  FoodAndBeveragePreparationServingBffApi copyWithWrapped(
      {Wrapped<List<PreparationServingBffApi>?>? preparationServing,
      Wrapped<ServingQuantityInformationBffApi?>? servingQuantityInformation}) {
    return FoodAndBeveragePreparationServingBffApi(
        preparationServing: (preparationServing != null
            ? preparationServing.value
            : this.preparationServing),
        servingQuantityInformation: (servingQuantityInformation != null
            ? servingQuantityInformation.value
            : this.servingQuantityInformation));
  }
}

@JsonSerializable(explicitToJson: true)
class GHSDetailBffApi {
  GHSDetailBffApi({
    this.ghsSymbolDescriptionCode,
    this.hazardStatement,
    this.precautionaryStatement,
    this.ghsSignalWordsCode,
  });

  factory GHSDetailBffApi.fromJson(Map<String, dynamic> json) =>
      _$GHSDetailBffApiFromJson(json);

  @JsonKey(
      name: 'ghsSymbolDescriptionCode',
      includeIfNull: false,
      defaultValue: <CodeWithLabelBffApi>[])
  final List<CodeWithLabelBffApi>? ghsSymbolDescriptionCode;
  @JsonKey(
      name: 'hazardStatement',
      includeIfNull: false,
      defaultValue: <HazardStatementBffApi>[])
  final List<HazardStatementBffApi>? hazardStatement;
  @JsonKey(
      name: 'precautionaryStatement',
      includeIfNull: false,
      defaultValue: <PrecautionaryStatementBffApi>[])
  final List<PrecautionaryStatementBffApi>? precautionaryStatement;
  @JsonKey(name: 'ghsSignalWordsCode', includeIfNull: false)
  final CodeWithLabelBffApi? ghsSignalWordsCode;
  static const fromJsonFactory = _$GHSDetailBffApiFromJson;
  static const toJsonFactory = _$GHSDetailBffApiToJson;
  Map<String, dynamic> toJson() => _$GHSDetailBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is GHSDetailBffApi &&
            (identical(
                    other.ghsSymbolDescriptionCode, ghsSymbolDescriptionCode) ||
                const DeepCollectionEquality().equals(
                    other.ghsSymbolDescriptionCode,
                    ghsSymbolDescriptionCode)) &&
            (identical(other.hazardStatement, hazardStatement) ||
                const DeepCollectionEquality()
                    .equals(other.hazardStatement, hazardStatement)) &&
            (identical(other.precautionaryStatement, precautionaryStatement) ||
                const DeepCollectionEquality().equals(
                    other.precautionaryStatement, precautionaryStatement)) &&
            (identical(other.ghsSignalWordsCode, ghsSignalWordsCode) ||
                const DeepCollectionEquality()
                    .equals(other.ghsSignalWordsCode, ghsSignalWordsCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(ghsSymbolDescriptionCode) ^
      const DeepCollectionEquality().hash(hazardStatement) ^
      const DeepCollectionEquality().hash(precautionaryStatement) ^
      const DeepCollectionEquality().hash(ghsSignalWordsCode) ^
      runtimeType.hashCode;
}

extension $GHSDetailBffApiExtension on GHSDetailBffApi {
  GHSDetailBffApi copyWith(
      {List<CodeWithLabelBffApi>? ghsSymbolDescriptionCode,
      List<HazardStatementBffApi>? hazardStatement,
      List<PrecautionaryStatementBffApi>? precautionaryStatement,
      CodeWithLabelBffApi? ghsSignalWordsCode}) {
    return GHSDetailBffApi(
        ghsSymbolDescriptionCode:
            ghsSymbolDescriptionCode ?? this.ghsSymbolDescriptionCode,
        hazardStatement: hazardStatement ?? this.hazardStatement,
        precautionaryStatement:
            precautionaryStatement ?? this.precautionaryStatement,
        ghsSignalWordsCode: ghsSignalWordsCode ?? this.ghsSignalWordsCode);
  }

  GHSDetailBffApi copyWithWrapped(
      {Wrapped<List<CodeWithLabelBffApi>?>? ghsSymbolDescriptionCode,
      Wrapped<List<HazardStatementBffApi>?>? hazardStatement,
      Wrapped<List<PrecautionaryStatementBffApi>?>? precautionaryStatement,
      Wrapped<CodeWithLabelBffApi?>? ghsSignalWordsCode}) {
    return GHSDetailBffApi(
        ghsSymbolDescriptionCode: (ghsSymbolDescriptionCode != null
            ? ghsSymbolDescriptionCode.value
            : this.ghsSymbolDescriptionCode),
        hazardStatement: (hazardStatement != null
            ? hazardStatement.value
            : this.hazardStatement),
        precautionaryStatement: (precautionaryStatement != null
            ? precautionaryStatement.value
            : this.precautionaryStatement),
        ghsSignalWordsCode: (ghsSignalWordsCode != null
            ? ghsSignalWordsCode.value
            : this.ghsSignalWordsCode));
  }
}

@JsonSerializable(explicitToJson: true)
class HazardStatementBffApi {
  HazardStatementBffApi({
    this.code,
    this.description,
  });

  factory HazardStatementBffApi.fromJson(Map<String, dynamic> json) =>
      _$HazardStatementBffApiFromJson(json);

  @JsonKey(name: 'code', includeIfNull: false)
  final CodeWithLabelBffApi? code;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: <String>[])
  final List<String>? description;
  static const fromJsonFactory = _$HazardStatementBffApiFromJson;
  static const toJsonFactory = _$HazardStatementBffApiToJson;
  Map<String, dynamic> toJson() => _$HazardStatementBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is HazardStatementBffApi &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(code) ^
      const DeepCollectionEquality().hash(description) ^
      runtimeType.hashCode;
}

extension $HazardStatementBffApiExtension on HazardStatementBffApi {
  HazardStatementBffApi copyWith(
      {CodeWithLabelBffApi? code, List<String>? description}) {
    return HazardStatementBffApi(
        code: code ?? this.code, description: description ?? this.description);
  }

  HazardStatementBffApi copyWithWrapped(
      {Wrapped<CodeWithLabelBffApi?>? code,
      Wrapped<List<String>?>? description}) {
    return HazardStatementBffApi(
        code: (code != null ? code.value : this.code),
        description:
            (description != null ? description.value : this.description));
  }
}

@JsonSerializable(explicitToJson: true)
class HealthRelatedInformationBffApi {
  HealthRelatedInformationBffApi({
    this.compulsoryAdditiveLabelInformation,
    this.healthClaimDescription,
    this.sunProtectionFactor,
  });

  factory HealthRelatedInformationBffApi.fromJson(Map<String, dynamic> json) =>
      _$HealthRelatedInformationBffApiFromJson(json);

  @JsonKey(
      name: 'compulsoryAdditiveLabelInformation',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? compulsoryAdditiveLabelInformation;
  @JsonKey(
      name: 'healthClaimDescription',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? healthClaimDescription;
  @JsonKey(name: 'sunProtectionFactor', includeIfNull: false, defaultValue: '')
  final String? sunProtectionFactor;
  static const fromJsonFactory = _$HealthRelatedInformationBffApiFromJson;
  static const toJsonFactory = _$HealthRelatedInformationBffApiToJson;
  Map<String, dynamic> toJson() => _$HealthRelatedInformationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is HealthRelatedInformationBffApi &&
            (identical(other.compulsoryAdditiveLabelInformation,
                    compulsoryAdditiveLabelInformation) ||
                const DeepCollectionEquality().equals(
                    other.compulsoryAdditiveLabelInformation,
                    compulsoryAdditiveLabelInformation)) &&
            (identical(other.healthClaimDescription, healthClaimDescription) ||
                const DeepCollectionEquality().equals(
                    other.healthClaimDescription, healthClaimDescription)) &&
            (identical(other.sunProtectionFactor, sunProtectionFactor) ||
                const DeepCollectionEquality()
                    .equals(other.sunProtectionFactor, sunProtectionFactor)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(compulsoryAdditiveLabelInformation) ^
      const DeepCollectionEquality().hash(healthClaimDescription) ^
      const DeepCollectionEquality().hash(sunProtectionFactor) ^
      runtimeType.hashCode;
}

extension $HealthRelatedInformationBffApiExtension
    on HealthRelatedInformationBffApi {
  HealthRelatedInformationBffApi copyWith(
      {List<String>? compulsoryAdditiveLabelInformation,
      List<String>? healthClaimDescription,
      String? sunProtectionFactor}) {
    return HealthRelatedInformationBffApi(
        compulsoryAdditiveLabelInformation:
            compulsoryAdditiveLabelInformation ??
                this.compulsoryAdditiveLabelInformation,
        healthClaimDescription:
            healthClaimDescription ?? this.healthClaimDescription,
        sunProtectionFactor: sunProtectionFactor ?? this.sunProtectionFactor);
  }

  HealthRelatedInformationBffApi copyWithWrapped(
      {Wrapped<List<String>?>? compulsoryAdditiveLabelInformation,
      Wrapped<List<String>?>? healthClaimDescription,
      Wrapped<String?>? sunProtectionFactor}) {
    return HealthRelatedInformationBffApi(
        compulsoryAdditiveLabelInformation:
            (compulsoryAdditiveLabelInformation != null
                ? compulsoryAdditiveLabelInformation.value
                : this.compulsoryAdditiveLabelInformation),
        healthClaimDescription: (healthClaimDescription != null
            ? healthClaimDescription.value
            : this.healthClaimDescription),
        sunProtectionFactor: (sunProtectionFactor != null
            ? sunProtectionFactor.value
            : this.sunProtectionFactor));
  }
}

@JsonSerializable(explicitToJson: true)
class HealthWellnessPackagingMarkingBffApi {
  HealthWellnessPackagingMarkingBffApi({
    this.packagingMarkedDietAllergenCode,
    this.packagingMarkedFreeFromCode,
  });

  factory HealthWellnessPackagingMarkingBffApi.fromJson(
          Map<String, dynamic> json) =>
      _$HealthWellnessPackagingMarkingBffApiFromJson(json);

  @JsonKey(
      name: 'packagingMarkedDietAllergenCode',
      includeIfNull: false,
      defaultValue: <CodeWithLabelBffApi>[])
  final List<CodeWithLabelBffApi>? packagingMarkedDietAllergenCode;
  @JsonKey(
      name: 'packagingMarkedFreeFromCode',
      includeIfNull: false,
      defaultValue: <CodeWithLabelBffApi>[])
  final List<CodeWithLabelBffApi>? packagingMarkedFreeFromCode;
  static const fromJsonFactory = _$HealthWellnessPackagingMarkingBffApiFromJson;
  static const toJsonFactory = _$HealthWellnessPackagingMarkingBffApiToJson;
  Map<String, dynamic> toJson() =>
      _$HealthWellnessPackagingMarkingBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is HealthWellnessPackagingMarkingBffApi &&
            (identical(other.packagingMarkedDietAllergenCode,
                    packagingMarkedDietAllergenCode) ||
                const DeepCollectionEquality().equals(
                    other.packagingMarkedDietAllergenCode,
                    packagingMarkedDietAllergenCode)) &&
            (identical(other.packagingMarkedFreeFromCode,
                    packagingMarkedFreeFromCode) ||
                const DeepCollectionEquality().equals(
                    other.packagingMarkedFreeFromCode,
                    packagingMarkedFreeFromCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(packagingMarkedDietAllergenCode) ^
      const DeepCollectionEquality().hash(packagingMarkedFreeFromCode) ^
      runtimeType.hashCode;
}

extension $HealthWellnessPackagingMarkingBffApiExtension
    on HealthWellnessPackagingMarkingBffApi {
  HealthWellnessPackagingMarkingBffApi copyWith(
      {List<CodeWithLabelBffApi>? packagingMarkedDietAllergenCode,
      List<CodeWithLabelBffApi>? packagingMarkedFreeFromCode}) {
    return HealthWellnessPackagingMarkingBffApi(
        packagingMarkedDietAllergenCode: packagingMarkedDietAllergenCode ??
            this.packagingMarkedDietAllergenCode,
        packagingMarkedFreeFromCode:
            packagingMarkedFreeFromCode ?? this.packagingMarkedFreeFromCode);
  }

  HealthWellnessPackagingMarkingBffApi copyWithWrapped(
      {Wrapped<List<CodeWithLabelBffApi>?>? packagingMarkedDietAllergenCode,
      Wrapped<List<CodeWithLabelBffApi>?>? packagingMarkedFreeFromCode}) {
    return HealthWellnessPackagingMarkingBffApi(
        packagingMarkedDietAllergenCode:
            (packagingMarkedDietAllergenCode != null
                ? packagingMarkedDietAllergenCode.value
                : this.packagingMarkedDietAllergenCode),
        packagingMarkedFreeFromCode: (packagingMarkedFreeFromCode != null
            ? packagingMarkedFreeFromCode.value
            : this.packagingMarkedFreeFromCode));
  }
}

@JsonSerializable(explicitToJson: true)
class HealthcareInformationBffApi {
  HealthcareInformationBffApi({
    this.itemMaximumUsageAge,
    this.itemMinimumUsageAge,
    this.itemUsageAgeDescription,
    this.usageDuringBreastFeedingCode,
    this.usageDuringPregnancyCode,
  });

  factory HealthcareInformationBffApi.fromJson(Map<String, dynamic> json) =>
      _$HealthcareInformationBffApiFromJson(json);

  @JsonKey(name: 'itemMaximumUsageAge', includeIfNull: false)
  final TimeMeasurementBffApi? itemMaximumUsageAge;
  @JsonKey(name: 'itemMinimumUsageAge', includeIfNull: false)
  final TimeMeasurementBffApi? itemMinimumUsageAge;
  @JsonKey(
      name: 'itemUsageAgeDescription', includeIfNull: false, defaultValue: '')
  final String? itemUsageAgeDescription;
  @JsonKey(name: 'usageDuringBreastFeedingCode', includeIfNull: false)
  final CodeWithLabelBffApi? usageDuringBreastFeedingCode;
  @JsonKey(name: 'usageDuringPregnancyCode', includeIfNull: false)
  final CodeWithLabelBffApi? usageDuringPregnancyCode;
  static const fromJsonFactory = _$HealthcareInformationBffApiFromJson;
  static const toJsonFactory = _$HealthcareInformationBffApiToJson;
  Map<String, dynamic> toJson() => _$HealthcareInformationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is HealthcareInformationBffApi &&
            (identical(other.itemMaximumUsageAge, itemMaximumUsageAge) ||
                const DeepCollectionEquality()
                    .equals(other.itemMaximumUsageAge, itemMaximumUsageAge)) &&
            (identical(other.itemMinimumUsageAge, itemMinimumUsageAge) ||
                const DeepCollectionEquality()
                    .equals(other.itemMinimumUsageAge, itemMinimumUsageAge)) &&
            (identical(
                    other.itemUsageAgeDescription, itemUsageAgeDescription) ||
                const DeepCollectionEquality().equals(
                    other.itemUsageAgeDescription, itemUsageAgeDescription)) &&
            (identical(other.usageDuringBreastFeedingCode,
                    usageDuringBreastFeedingCode) ||
                const DeepCollectionEquality().equals(
                    other.usageDuringBreastFeedingCode,
                    usageDuringBreastFeedingCode)) &&
            (identical(
                    other.usageDuringPregnancyCode, usageDuringPregnancyCode) ||
                const DeepCollectionEquality().equals(
                    other.usageDuringPregnancyCode, usageDuringPregnancyCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(itemMaximumUsageAge) ^
      const DeepCollectionEquality().hash(itemMinimumUsageAge) ^
      const DeepCollectionEquality().hash(itemUsageAgeDescription) ^
      const DeepCollectionEquality().hash(usageDuringBreastFeedingCode) ^
      const DeepCollectionEquality().hash(usageDuringPregnancyCode) ^
      runtimeType.hashCode;
}

extension $HealthcareInformationBffApiExtension on HealthcareInformationBffApi {
  HealthcareInformationBffApi copyWith(
      {TimeMeasurementBffApi? itemMaximumUsageAge,
      TimeMeasurementBffApi? itemMinimumUsageAge,
      String? itemUsageAgeDescription,
      CodeWithLabelBffApi? usageDuringBreastFeedingCode,
      CodeWithLabelBffApi? usageDuringPregnancyCode}) {
    return HealthcareInformationBffApi(
        itemMaximumUsageAge: itemMaximumUsageAge ?? this.itemMaximumUsageAge,
        itemMinimumUsageAge: itemMinimumUsageAge ?? this.itemMinimumUsageAge,
        itemUsageAgeDescription:
            itemUsageAgeDescription ?? this.itemUsageAgeDescription,
        usageDuringBreastFeedingCode:
            usageDuringBreastFeedingCode ?? this.usageDuringBreastFeedingCode,
        usageDuringPregnancyCode:
            usageDuringPregnancyCode ?? this.usageDuringPregnancyCode);
  }

  HealthcareInformationBffApi copyWithWrapped(
      {Wrapped<TimeMeasurementBffApi?>? itemMaximumUsageAge,
      Wrapped<TimeMeasurementBffApi?>? itemMinimumUsageAge,
      Wrapped<String?>? itemUsageAgeDescription,
      Wrapped<CodeWithLabelBffApi?>? usageDuringBreastFeedingCode,
      Wrapped<CodeWithLabelBffApi?>? usageDuringPregnancyCode}) {
    return HealthcareInformationBffApi(
        itemMaximumUsageAge: (itemMaximumUsageAge != null
            ? itemMaximumUsageAge.value
            : this.itemMaximumUsageAge),
        itemMinimumUsageAge: (itemMinimumUsageAge != null
            ? itemMinimumUsageAge.value
            : this.itemMinimumUsageAge),
        itemUsageAgeDescription: (itemUsageAgeDescription != null
            ? itemUsageAgeDescription.value
            : this.itemUsageAgeDescription),
        usageDuringBreastFeedingCode: (usageDuringBreastFeedingCode != null
            ? usageDuringBreastFeedingCode.value
            : this.usageDuringBreastFeedingCode),
        usageDuringPregnancyCode: (usageDuringPregnancyCode != null
            ? usageDuringPregnancyCode.value
            : this.usageDuringPregnancyCode));
  }
}

@JsonSerializable(explicitToJson: true)
class ImageBffApi {
  ImageBffApi({
    required this.width,
    required this.height,
    required this.url,
  });

  factory ImageBffApi.fromJson(Map<String, dynamic> json) =>
      _$ImageBffApiFromJson(json);

  @JsonKey(name: 'width', includeIfNull: false)
  final int width;
  @JsonKey(name: 'height', includeIfNull: false)
  final int height;
  @JsonKey(name: 'url', includeIfNull: false, defaultValue: '')
  final String url;
  static const fromJsonFactory = _$ImageBffApiFromJson;
  static const toJsonFactory = _$ImageBffApiToJson;
  Map<String, dynamic> toJson() => _$ImageBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ImageBffApi &&
            (identical(other.width, width) ||
                const DeepCollectionEquality().equals(other.width, width)) &&
            (identical(other.height, height) ||
                const DeepCollectionEquality().equals(other.height, height)) &&
            (identical(other.url, url) ||
                const DeepCollectionEquality().equals(other.url, url)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(width) ^
      const DeepCollectionEquality().hash(height) ^
      const DeepCollectionEquality().hash(url) ^
      runtimeType.hashCode;
}

extension $ImageBffApiExtension on ImageBffApi {
  ImageBffApi copyWith({int? width, int? height, String? url}) {
    return ImageBffApi(
        width: width ?? this.width,
        height: height ?? this.height,
        url: url ?? this.url);
  }

  ImageBffApi copyWithWrapped(
      {Wrapped<int>? width, Wrapped<int>? height, Wrapped<String>? url}) {
    return ImageBffApi(
        width: (width != null ? width.value : this.width),
        height: (height != null ? height.value : this.height),
        url: (url != null ? url.value : this.url));
  }
}

@JsonSerializable(explicitToJson: true)
class NutrientDetailBffApi {
  NutrientDetailBffApi({
    this.dailyValueIntakePercent,
    this.dailyValueIntakePercentMeasurementPrecisionCode,
    this.measurementPrecisionCode,
    this.nutrientSource,
    this.nutrientTypeCode,
    this.quantityContained,
  });

  factory NutrientDetailBffApi.fromJson(Map<String, dynamic> json) =>
      _$NutrientDetailBffApiFromJson(json);

  @JsonKey(name: 'dailyValueIntakePercent', includeIfNull: false)
  final double? dailyValueIntakePercent;
  @JsonKey(
      name: 'dailyValueIntakePercentMeasurementPrecisionCode',
      includeIfNull: false)
  final CodeWithLabelBffApi? dailyValueIntakePercentMeasurementPrecisionCode;
  @JsonKey(name: 'measurementPrecisionCode', includeIfNull: false)
  final CodeWithLabelBffApi? measurementPrecisionCode;
  @JsonKey(
      name: 'nutrientSource', includeIfNull: false, defaultValue: <String>[])
  final List<String>? nutrientSource;
  @JsonKey(name: 'nutrientTypeCode', includeIfNull: false)
  final CodeWithLabelBffApi? nutrientTypeCode;
  @JsonKey(
      name: 'quantityContained',
      includeIfNull: false,
      defaultValue: <QuantityBffApi>[])
  final List<QuantityBffApi>? quantityContained;
  static const fromJsonFactory = _$NutrientDetailBffApiFromJson;
  static const toJsonFactory = _$NutrientDetailBffApiToJson;
  Map<String, dynamic> toJson() => _$NutrientDetailBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NutrientDetailBffApi &&
            (identical(
                    other.dailyValueIntakePercent, dailyValueIntakePercent) ||
                const DeepCollectionEquality().equals(
                    other.dailyValueIntakePercent, dailyValueIntakePercent)) &&
            (identical(other.dailyValueIntakePercentMeasurementPrecisionCode,
                    dailyValueIntakePercentMeasurementPrecisionCode) ||
                const DeepCollectionEquality().equals(
                    other.dailyValueIntakePercentMeasurementPrecisionCode,
                    dailyValueIntakePercentMeasurementPrecisionCode)) &&
            (identical(
                    other.measurementPrecisionCode, measurementPrecisionCode) ||
                const DeepCollectionEquality().equals(
                    other.measurementPrecisionCode,
                    measurementPrecisionCode)) &&
            (identical(other.nutrientSource, nutrientSource) ||
                const DeepCollectionEquality()
                    .equals(other.nutrientSource, nutrientSource)) &&
            (identical(other.nutrientTypeCode, nutrientTypeCode) ||
                const DeepCollectionEquality()
                    .equals(other.nutrientTypeCode, nutrientTypeCode)) &&
            (identical(other.quantityContained, quantityContained) ||
                const DeepCollectionEquality()
                    .equals(other.quantityContained, quantityContained)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(dailyValueIntakePercent) ^
      const DeepCollectionEquality()
          .hash(dailyValueIntakePercentMeasurementPrecisionCode) ^
      const DeepCollectionEquality().hash(measurementPrecisionCode) ^
      const DeepCollectionEquality().hash(nutrientSource) ^
      const DeepCollectionEquality().hash(nutrientTypeCode) ^
      const DeepCollectionEquality().hash(quantityContained) ^
      runtimeType.hashCode;
}

extension $NutrientDetailBffApiExtension on NutrientDetailBffApi {
  NutrientDetailBffApi copyWith(
      {double? dailyValueIntakePercent,
      CodeWithLabelBffApi? dailyValueIntakePercentMeasurementPrecisionCode,
      CodeWithLabelBffApi? measurementPrecisionCode,
      List<String>? nutrientSource,
      CodeWithLabelBffApi? nutrientTypeCode,
      List<QuantityBffApi>? quantityContained}) {
    return NutrientDetailBffApi(
        dailyValueIntakePercent:
            dailyValueIntakePercent ?? this.dailyValueIntakePercent,
        dailyValueIntakePercentMeasurementPrecisionCode:
            dailyValueIntakePercentMeasurementPrecisionCode ??
                this.dailyValueIntakePercentMeasurementPrecisionCode,
        measurementPrecisionCode:
            measurementPrecisionCode ?? this.measurementPrecisionCode,
        nutrientSource: nutrientSource ?? this.nutrientSource,
        nutrientTypeCode: nutrientTypeCode ?? this.nutrientTypeCode,
        quantityContained: quantityContained ?? this.quantityContained);
  }

  NutrientDetailBffApi copyWithWrapped(
      {Wrapped<double?>? dailyValueIntakePercent,
      Wrapped<CodeWithLabelBffApi?>?
          dailyValueIntakePercentMeasurementPrecisionCode,
      Wrapped<CodeWithLabelBffApi?>? measurementPrecisionCode,
      Wrapped<List<String>?>? nutrientSource,
      Wrapped<CodeWithLabelBffApi?>? nutrientTypeCode,
      Wrapped<List<QuantityBffApi>?>? quantityContained}) {
    return NutrientDetailBffApi(
        dailyValueIntakePercent: (dailyValueIntakePercent != null
            ? dailyValueIntakePercent.value
            : this.dailyValueIntakePercent),
        dailyValueIntakePercentMeasurementPrecisionCode:
            (dailyValueIntakePercentMeasurementPrecisionCode != null
                ? dailyValueIntakePercentMeasurementPrecisionCode.value
                : this.dailyValueIntakePercentMeasurementPrecisionCode),
        measurementPrecisionCode: (measurementPrecisionCode != null
            ? measurementPrecisionCode.value
            : this.measurementPrecisionCode),
        nutrientSource: (nutrientSource != null
            ? nutrientSource.value
            : this.nutrientSource),
        nutrientTypeCode: (nutrientTypeCode != null
            ? nutrientTypeCode.value
            : this.nutrientTypeCode),
        quantityContained: (quantityContained != null
            ? quantityContained.value
            : this.quantityContained));
  }
}

@JsonSerializable(explicitToJson: true)
class NutrientHeaderBffApi {
  NutrientHeaderBffApi({
    this.dailyValueIntakeReference,
    this.nutrientBasisQuantity,
    this.nutrientBasisQuantityDescription,
    this.nutrientDetail,
    this.preparationStateCode,
  });

  factory NutrientHeaderBffApi.fromJson(Map<String, dynamic> json) =>
      _$NutrientHeaderBffApiFromJson(json);

  @JsonKey(
      name: 'dailyValueIntakeReference',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? dailyValueIntakeReference;
  @JsonKey(name: 'nutrientBasisQuantity', includeIfNull: false)
  final QuantityBffApi? nutrientBasisQuantity;
  @JsonKey(
      name: 'nutrientBasisQuantityDescription',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? nutrientBasisQuantityDescription;
  @JsonKey(
      name: 'nutrientDetail',
      includeIfNull: false,
      defaultValue: <NutrientDetailBffApi>[])
  final List<NutrientDetailBffApi>? nutrientDetail;
  @JsonKey(name: 'preparationStateCode', includeIfNull: false)
  final CodeWithLabelBffApi? preparationStateCode;
  static const fromJsonFactory = _$NutrientHeaderBffApiFromJson;
  static const toJsonFactory = _$NutrientHeaderBffApiToJson;
  Map<String, dynamic> toJson() => _$NutrientHeaderBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NutrientHeaderBffApi &&
            (identical(other.dailyValueIntakeReference,
                    dailyValueIntakeReference) ||
                const DeepCollectionEquality().equals(
                    other.dailyValueIntakeReference,
                    dailyValueIntakeReference)) &&
            (identical(other.nutrientBasisQuantity, nutrientBasisQuantity) ||
                const DeepCollectionEquality().equals(
                    other.nutrientBasisQuantity, nutrientBasisQuantity)) &&
            (identical(other.nutrientBasisQuantityDescription,
                    nutrientBasisQuantityDescription) ||
                const DeepCollectionEquality().equals(
                    other.nutrientBasisQuantityDescription,
                    nutrientBasisQuantityDescription)) &&
            (identical(other.nutrientDetail, nutrientDetail) ||
                const DeepCollectionEquality()
                    .equals(other.nutrientDetail, nutrientDetail)) &&
            (identical(other.preparationStateCode, preparationStateCode) ||
                const DeepCollectionEquality()
                    .equals(other.preparationStateCode, preparationStateCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(dailyValueIntakeReference) ^
      const DeepCollectionEquality().hash(nutrientBasisQuantity) ^
      const DeepCollectionEquality().hash(nutrientBasisQuantityDescription) ^
      const DeepCollectionEquality().hash(nutrientDetail) ^
      const DeepCollectionEquality().hash(preparationStateCode) ^
      runtimeType.hashCode;
}

extension $NutrientHeaderBffApiExtension on NutrientHeaderBffApi {
  NutrientHeaderBffApi copyWith(
      {List<String>? dailyValueIntakeReference,
      QuantityBffApi? nutrientBasisQuantity,
      List<String>? nutrientBasisQuantityDescription,
      List<NutrientDetailBffApi>? nutrientDetail,
      CodeWithLabelBffApi? preparationStateCode}) {
    return NutrientHeaderBffApi(
        dailyValueIntakeReference:
            dailyValueIntakeReference ?? this.dailyValueIntakeReference,
        nutrientBasisQuantity:
            nutrientBasisQuantity ?? this.nutrientBasisQuantity,
        nutrientBasisQuantityDescription: nutrientBasisQuantityDescription ??
            this.nutrientBasisQuantityDescription,
        nutrientDetail: nutrientDetail ?? this.nutrientDetail,
        preparationStateCode:
            preparationStateCode ?? this.preparationStateCode);
  }

  NutrientHeaderBffApi copyWithWrapped(
      {Wrapped<List<String>?>? dailyValueIntakeReference,
      Wrapped<QuantityBffApi?>? nutrientBasisQuantity,
      Wrapped<List<String>?>? nutrientBasisQuantityDescription,
      Wrapped<List<NutrientDetailBffApi>?>? nutrientDetail,
      Wrapped<CodeWithLabelBffApi?>? preparationStateCode}) {
    return NutrientHeaderBffApi(
        dailyValueIntakeReference: (dailyValueIntakeReference != null
            ? dailyValueIntakeReference.value
            : this.dailyValueIntakeReference),
        nutrientBasisQuantity: (nutrientBasisQuantity != null
            ? nutrientBasisQuantity.value
            : this.nutrientBasisQuantity),
        nutrientBasisQuantityDescription:
            (nutrientBasisQuantityDescription != null
                ? nutrientBasisQuantityDescription.value
                : this.nutrientBasisQuantityDescription),
        nutrientDetail: (nutrientDetail != null
            ? nutrientDetail.value
            : this.nutrientDetail),
        preparationStateCode: (preparationStateCode != null
            ? preparationStateCode.value
            : this.preparationStateCode));
  }
}

@JsonSerializable(explicitToJson: true)
class NutritionalInformationBffApi {
  NutritionalInformationBffApi({
    this.nutrientHeaders,
    this.nutritionalClaim,
  });

  factory NutritionalInformationBffApi.fromJson(Map<String, dynamic> json) =>
      _$NutritionalInformationBffApiFromJson(json);

  @JsonKey(
      name: 'nutrientHeaders',
      includeIfNull: false,
      defaultValue: <NutrientHeaderBffApi>[])
  final List<NutrientHeaderBffApi>? nutrientHeaders;
  @JsonKey(
      name: 'nutritionalClaim', includeIfNull: false, defaultValue: <String>[])
  final List<String>? nutritionalClaim;
  static const fromJsonFactory = _$NutritionalInformationBffApiFromJson;
  static const toJsonFactory = _$NutritionalInformationBffApiToJson;
  Map<String, dynamic> toJson() => _$NutritionalInformationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NutritionalInformationBffApi &&
            (identical(other.nutrientHeaders, nutrientHeaders) ||
                const DeepCollectionEquality()
                    .equals(other.nutrientHeaders, nutrientHeaders)) &&
            (identical(other.nutritionalClaim, nutritionalClaim) ||
                const DeepCollectionEquality()
                    .equals(other.nutritionalClaim, nutritionalClaim)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(nutrientHeaders) ^
      const DeepCollectionEquality().hash(nutritionalClaim) ^
      runtimeType.hashCode;
}

extension $NutritionalInformationBffApiExtension
    on NutritionalInformationBffApi {
  NutritionalInformationBffApi copyWith(
      {List<NutrientHeaderBffApi>? nutrientHeaders,
      List<String>? nutritionalClaim}) {
    return NutritionalInformationBffApi(
        nutrientHeaders: nutrientHeaders ?? this.nutrientHeaders,
        nutritionalClaim: nutritionalClaim ?? this.nutritionalClaim);
  }

  NutritionalInformationBffApi copyWithWrapped(
      {Wrapped<List<NutrientHeaderBffApi>?>? nutrientHeaders,
      Wrapped<List<String>?>? nutritionalClaim}) {
    return NutritionalInformationBffApi(
        nutrientHeaders: (nutrientHeaders != null
            ? nutrientHeaders.value
            : this.nutrientHeaders),
        nutritionalClaim: (nutritionalClaim != null
            ? nutritionalClaim.value
            : this.nutritionalClaim));
  }
}

@JsonSerializable(explicitToJson: true)
class PackagingMarkingBffApi {
  PackagingMarkingBffApi({
    this.localPackagingMarkedLabelAccreditationCodeReference,
    this.labelAccreditationCode,
  });

  factory PackagingMarkingBffApi.fromJson(Map<String, dynamic> json) =>
      _$PackagingMarkingBffApiFromJson(json);

  @JsonKey(
      name: 'localPackagingMarkedLabelAccreditationCodeReference',
      includeIfNull: false,
      defaultValue: <CodeWithLabelBffApi>[])
  final List<CodeWithLabelBffApi>?
      localPackagingMarkedLabelAccreditationCodeReference;
  @JsonKey(
      name: 'labelAccreditationCode',
      includeIfNull: false,
      defaultValue: <CodeWithLabelBffApi>[])
  final List<CodeWithLabelBffApi>? labelAccreditationCode;
  static const fromJsonFactory = _$PackagingMarkingBffApiFromJson;
  static const toJsonFactory = _$PackagingMarkingBffApiToJson;
  Map<String, dynamic> toJson() => _$PackagingMarkingBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PackagingMarkingBffApi &&
            (identical(
                    other.localPackagingMarkedLabelAccreditationCodeReference,
                    localPackagingMarkedLabelAccreditationCodeReference) ||
                const DeepCollectionEquality().equals(
                    other.localPackagingMarkedLabelAccreditationCodeReference,
                    localPackagingMarkedLabelAccreditationCodeReference)) &&
            (identical(other.labelAccreditationCode, labelAccreditationCode) ||
                const DeepCollectionEquality().equals(
                    other.labelAccreditationCode, labelAccreditationCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality()
          .hash(localPackagingMarkedLabelAccreditationCodeReference) ^
      const DeepCollectionEquality().hash(labelAccreditationCode) ^
      runtimeType.hashCode;
}

extension $PackagingMarkingBffApiExtension on PackagingMarkingBffApi {
  PackagingMarkingBffApi copyWith(
      {List<CodeWithLabelBffApi>?
          localPackagingMarkedLabelAccreditationCodeReference,
      List<CodeWithLabelBffApi>? labelAccreditationCode}) {
    return PackagingMarkingBffApi(
        localPackagingMarkedLabelAccreditationCodeReference:
            localPackagingMarkedLabelAccreditationCodeReference ??
                this.localPackagingMarkedLabelAccreditationCodeReference,
        labelAccreditationCode:
            labelAccreditationCode ?? this.labelAccreditationCode);
  }

  PackagingMarkingBffApi copyWithWrapped(
      {Wrapped<List<CodeWithLabelBffApi>?>?
          localPackagingMarkedLabelAccreditationCodeReference,
      Wrapped<List<CodeWithLabelBffApi>?>? labelAccreditationCode}) {
    return PackagingMarkingBffApi(
        localPackagingMarkedLabelAccreditationCodeReference:
            (localPackagingMarkedLabelAccreditationCodeReference != null
                ? localPackagingMarkedLabelAccreditationCodeReference.value
                : this.localPackagingMarkedLabelAccreditationCodeReference),
        labelAccreditationCode: (labelAccreditationCode != null
            ? labelAccreditationCode.value
            : this.labelAccreditationCode));
  }
}

@JsonSerializable(explicitToJson: true)
class PharmaceuticalInformationBffApi {
  PharmaceuticalInformationBffApi({
    this.dosages,
    this.drugSideEffectsAndWarnings,
  });

  factory PharmaceuticalInformationBffApi.fromJson(Map<String, dynamic> json) =>
      _$PharmaceuticalInformationBffApiFromJson(json);

  @JsonKey(
      name: 'dosages', includeIfNull: false, defaultValue: <DosageBffApi>[])
  final List<DosageBffApi>? dosages;
  @JsonKey(
      name: 'drugSideEffectsAndWarnings',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? drugSideEffectsAndWarnings;
  static const fromJsonFactory = _$PharmaceuticalInformationBffApiFromJson;
  static const toJsonFactory = _$PharmaceuticalInformationBffApiToJson;
  Map<String, dynamic> toJson() =>
      _$PharmaceuticalInformationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PharmaceuticalInformationBffApi &&
            (identical(other.dosages, dosages) ||
                const DeepCollectionEquality()
                    .equals(other.dosages, dosages)) &&
            (identical(other.drugSideEffectsAndWarnings,
                    drugSideEffectsAndWarnings) ||
                const DeepCollectionEquality().equals(
                    other.drugSideEffectsAndWarnings,
                    drugSideEffectsAndWarnings)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(dosages) ^
      const DeepCollectionEquality().hash(drugSideEffectsAndWarnings) ^
      runtimeType.hashCode;
}

extension $PharmaceuticalInformationBffApiExtension
    on PharmaceuticalInformationBffApi {
  PharmaceuticalInformationBffApi copyWith(
      {List<DosageBffApi>? dosages, List<String>? drugSideEffectsAndWarnings}) {
    return PharmaceuticalInformationBffApi(
        dosages: dosages ?? this.dosages,
        drugSideEffectsAndWarnings:
            drugSideEffectsAndWarnings ?? this.drugSideEffectsAndWarnings);
  }

  PharmaceuticalInformationBffApi copyWithWrapped(
      {Wrapped<List<DosageBffApi>?>? dosages,
      Wrapped<List<String>?>? drugSideEffectsAndWarnings}) {
    return PharmaceuticalInformationBffApi(
        dosages: (dosages != null ? dosages.value : this.dosages),
        drugSideEffectsAndWarnings: (drugSideEffectsAndWarnings != null
            ? drugSideEffectsAndWarnings.value
            : this.drugSideEffectsAndWarnings));
  }
}

@JsonSerializable(explicitToJson: true)
class PlaceOfItemActivityBffApi {
  PlaceOfItemActivityBffApi({
    this.placeOfProductActivity,
  });

  factory PlaceOfItemActivityBffApi.fromJson(Map<String, dynamic> json) =>
      _$PlaceOfItemActivityBffApiFromJson(json);

  @JsonKey(name: 'placeOfProductActivity', includeIfNull: false)
  final PlaceOfProductActivityBffApi? placeOfProductActivity;
  static const fromJsonFactory = _$PlaceOfItemActivityBffApiFromJson;
  static const toJsonFactory = _$PlaceOfItemActivityBffApiToJson;
  Map<String, dynamic> toJson() => _$PlaceOfItemActivityBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PlaceOfItemActivityBffApi &&
            (identical(other.placeOfProductActivity, placeOfProductActivity) ||
                const DeepCollectionEquality().equals(
                    other.placeOfProductActivity, placeOfProductActivity)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(placeOfProductActivity) ^
      runtimeType.hashCode;
}

extension $PlaceOfItemActivityBffApiExtension on PlaceOfItemActivityBffApi {
  PlaceOfItemActivityBffApi copyWith(
      {PlaceOfProductActivityBffApi? placeOfProductActivity}) {
    return PlaceOfItemActivityBffApi(
        placeOfProductActivity:
            placeOfProductActivity ?? this.placeOfProductActivity);
  }

  PlaceOfItemActivityBffApi copyWithWrapped(
      {Wrapped<PlaceOfProductActivityBffApi?>? placeOfProductActivity}) {
    return PlaceOfItemActivityBffApi(
        placeOfProductActivity: (placeOfProductActivity != null
            ? placeOfProductActivity.value
            : this.placeOfProductActivity));
  }
}

@JsonSerializable(explicitToJson: true)
class PlaceOfProductActivityBffApi {
  PlaceOfProductActivityBffApi({
    this.productActivityDetails,
    this.provenanceStatement,
  });

  factory PlaceOfProductActivityBffApi.fromJson(Map<String, dynamic> json) =>
      _$PlaceOfProductActivityBffApiFromJson(json);

  @JsonKey(
      name: 'productActivityDetails',
      includeIfNull: false,
      defaultValue: <ProductActivityDetailsBffApi>[])
  final List<ProductActivityDetailsBffApi>? productActivityDetails;
  @JsonKey(
      name: 'provenanceStatement',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? provenanceStatement;
  static const fromJsonFactory = _$PlaceOfProductActivityBffApiFromJson;
  static const toJsonFactory = _$PlaceOfProductActivityBffApiToJson;
  Map<String, dynamic> toJson() => _$PlaceOfProductActivityBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PlaceOfProductActivityBffApi &&
            (identical(other.productActivityDetails, productActivityDetails) ||
                const DeepCollectionEquality().equals(
                    other.productActivityDetails, productActivityDetails)) &&
            (identical(other.provenanceStatement, provenanceStatement) ||
                const DeepCollectionEquality()
                    .equals(other.provenanceStatement, provenanceStatement)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(productActivityDetails) ^
      const DeepCollectionEquality().hash(provenanceStatement) ^
      runtimeType.hashCode;
}

extension $PlaceOfProductActivityBffApiExtension
    on PlaceOfProductActivityBffApi {
  PlaceOfProductActivityBffApi copyWith(
      {List<ProductActivityDetailsBffApi>? productActivityDetails,
      List<String>? provenanceStatement}) {
    return PlaceOfProductActivityBffApi(
        productActivityDetails:
            productActivityDetails ?? this.productActivityDetails,
        provenanceStatement: provenanceStatement ?? this.provenanceStatement);
  }

  PlaceOfProductActivityBffApi copyWithWrapped(
      {Wrapped<List<ProductActivityDetailsBffApi>?>? productActivityDetails,
      Wrapped<List<String>?>? provenanceStatement}) {
    return PlaceOfProductActivityBffApi(
        productActivityDetails: (productActivityDetails != null
            ? productActivityDetails.value
            : this.productActivityDetails),
        provenanceStatement: (provenanceStatement != null
            ? provenanceStatement.value
            : this.provenanceStatement));
  }
}

@JsonSerializable(explicitToJson: true)
class PrecautionaryStatementBffApi {
  PrecautionaryStatementBffApi({
    this.code,
    this.description,
  });

  factory PrecautionaryStatementBffApi.fromJson(Map<String, dynamic> json) =>
      _$PrecautionaryStatementBffApiFromJson(json);

  @JsonKey(name: 'code', includeIfNull: false)
  final CodeWithLabelBffApi? code;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: <String>[])
  final List<String>? description;
  static const fromJsonFactory = _$PrecautionaryStatementBffApiFromJson;
  static const toJsonFactory = _$PrecautionaryStatementBffApiToJson;
  Map<String, dynamic> toJson() => _$PrecautionaryStatementBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PrecautionaryStatementBffApi &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(code) ^
      const DeepCollectionEquality().hash(description) ^
      runtimeType.hashCode;
}

extension $PrecautionaryStatementBffApiExtension
    on PrecautionaryStatementBffApi {
  PrecautionaryStatementBffApi copyWith(
      {CodeWithLabelBffApi? code, List<String>? description}) {
    return PrecautionaryStatementBffApi(
        code: code ?? this.code, description: description ?? this.description);
  }

  PrecautionaryStatementBffApi copyWithWrapped(
      {Wrapped<CodeWithLabelBffApi?>? code,
      Wrapped<List<String>?>? description}) {
    return PrecautionaryStatementBffApi(
        code: (code != null ? code.value : this.code),
        description:
            (description != null ? description.value : this.description));
  }
}

@JsonSerializable(explicitToJson: true)
class PreparationServingBffApi {
  PreparationServingBffApi({
    this.instructions,
    this.servingSuggestion,
  });

  factory PreparationServingBffApi.fromJson(Map<String, dynamic> json) =>
      _$PreparationServingBffApiFromJson(json);

  @JsonKey(name: 'instructions', includeIfNull: false, defaultValue: '')
  final String? instructions;
  @JsonKey(name: 'servingSuggestion', includeIfNull: false, defaultValue: '')
  final String? servingSuggestion;
  static const fromJsonFactory = _$PreparationServingBffApiFromJson;
  static const toJsonFactory = _$PreparationServingBffApiToJson;
  Map<String, dynamic> toJson() => _$PreparationServingBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PreparationServingBffApi &&
            (identical(other.instructions, instructions) ||
                const DeepCollectionEquality()
                    .equals(other.instructions, instructions)) &&
            (identical(other.servingSuggestion, servingSuggestion) ||
                const DeepCollectionEquality()
                    .equals(other.servingSuggestion, servingSuggestion)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(instructions) ^
      const DeepCollectionEquality().hash(servingSuggestion) ^
      runtimeType.hashCode;
}

extension $PreparationServingBffApiExtension on PreparationServingBffApi {
  PreparationServingBffApi copyWith(
      {String? instructions, String? servingSuggestion}) {
    return PreparationServingBffApi(
        instructions: instructions ?? this.instructions,
        servingSuggestion: servingSuggestion ?? this.servingSuggestion);
  }

  PreparationServingBffApi copyWithWrapped(
      {Wrapped<String?>? instructions, Wrapped<String?>? servingSuggestion}) {
    return PreparationServingBffApi(
        instructions:
            (instructions != null ? instructions.value : this.instructions),
        servingSuggestion: (servingSuggestion != null
            ? servingSuggestion.value
            : this.servingSuggestion));
  }
}

@JsonSerializable(explicitToJson: true)
class ProductActivityDetailsBffApi {
  ProductActivityDetailsBffApi({
    this.regionDescription,
    this.typeCode,
  });

  factory ProductActivityDetailsBffApi.fromJson(Map<String, dynamic> json) =>
      _$ProductActivityDetailsBffApiFromJson(json);

  @JsonKey(
      name: 'regionDescription', includeIfNull: false, defaultValue: <String>[])
  final List<String>? regionDescription;
  @JsonKey(name: 'typeCode', includeIfNull: false)
  final CodeWithLabelBffApi? typeCode;
  static const fromJsonFactory = _$ProductActivityDetailsBffApiFromJson;
  static const toJsonFactory = _$ProductActivityDetailsBffApiToJson;
  Map<String, dynamic> toJson() => _$ProductActivityDetailsBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProductActivityDetailsBffApi &&
            (identical(other.regionDescription, regionDescription) ||
                const DeepCollectionEquality()
                    .equals(other.regionDescription, regionDescription)) &&
            (identical(other.typeCode, typeCode) ||
                const DeepCollectionEquality()
                    .equals(other.typeCode, typeCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(regionDescription) ^
      const DeepCollectionEquality().hash(typeCode) ^
      runtimeType.hashCode;
}

extension $ProductActivityDetailsBffApiExtension
    on ProductActivityDetailsBffApi {
  ProductActivityDetailsBffApi copyWith(
      {List<String>? regionDescription, CodeWithLabelBffApi? typeCode}) {
    return ProductActivityDetailsBffApi(
        regionDescription: regionDescription ?? this.regionDescription,
        typeCode: typeCode ?? this.typeCode);
  }

  ProductActivityDetailsBffApi copyWithWrapped(
      {Wrapped<List<String>?>? regionDescription,
      Wrapped<CodeWithLabelBffApi?>? typeCode}) {
    return ProductActivityDetailsBffApi(
        regionDescription: (regionDescription != null
            ? regionDescription.value
            : this.regionDescription),
        typeCode: (typeCode != null ? typeCode.value : this.typeCode));
  }
}

@JsonSerializable(explicitToJson: true)
class ProductCardBffApi {
  ProductCardBffApi({
    required this.webshopId,
    required this.hqId,
    required this.title,
    this.salesUnitSize,
    this.unitPriceDescription,
    this.images,
    this.bonusStartDate,
    this.bonusEndDate,
    this.discountType,
    this.promotionType,
    this.segmentType,
    this.bonusMechanism,
    this.currentPrice,
    this.priceBeforeBonus,
    this.orderAvailabilityStatus,
    this.orderAvailabilityDescription,
    this.mainCategory,
    this.subCategory,
    this.subCategoryId,
    this.brand,
    this.shopType,
    this.bonusPeriodDescription,
    this.availableOnline,
    this.isPreviouslyBought,
    this.descriptionHighlights,
    this.propertyIcons,
    this.properties,
    this.nix18,
    this.isStapelBonus,
    this.extraDescriptions,
    this.bonusSegmentId,
    this.bonusSegmentDescription,
    this.isBonus,
    this.descriptionFull,
    required this.isOrderable,
    required this.isInfiniteBonus,
    required this.isSample,
    this.isBonusPrice,
  });

  factory ProductCardBffApi.fromJson(Map<String, dynamic> json) =>
      _$ProductCardBffApiFromJson(json);

  @JsonKey(name: 'webshopId', includeIfNull: false)
  final num webshopId;
  @JsonKey(name: 'hqId', includeIfNull: false)
  final num hqId;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  @JsonKey(name: 'salesUnitSize', includeIfNull: false, defaultValue: '')
  final String? salesUnitSize;
  @JsonKey(name: 'unitPriceDescription', includeIfNull: false, defaultValue: '')
  final String? unitPriceDescription;
  @JsonKey(name: 'images', includeIfNull: false, defaultValue: <ImageBffApi>[])
  final List<ImageBffApi>? images;
  @JsonKey(name: 'bonusStartDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? bonusStartDate;
  @JsonKey(name: 'bonusEndDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? bonusEndDate;
  @JsonKey(name: 'discountType', includeIfNull: false, defaultValue: '')
  final String? discountType;
  @JsonKey(name: 'promotionType', includeIfNull: false, defaultValue: '')
  final String? promotionType;
  @JsonKey(name: 'segmentType', includeIfNull: false, defaultValue: '')
  final String? segmentType;
  @JsonKey(name: 'bonusMechanism', includeIfNull: false, defaultValue: '')
  final String? bonusMechanism;
  @JsonKey(name: 'currentPrice', includeIfNull: false)
  final double? currentPrice;
  @JsonKey(name: 'priceBeforeBonus', includeIfNull: false)
  final double? priceBeforeBonus;
  @JsonKey(
      name: 'orderAvailabilityStatus', includeIfNull: false, defaultValue: '')
  final String? orderAvailabilityStatus;
  @JsonKey(
      name: 'orderAvailabilityDescription',
      includeIfNull: false,
      defaultValue: '')
  final String? orderAvailabilityDescription;
  @JsonKey(name: 'mainCategory', includeIfNull: false, defaultValue: '')
  final String? mainCategory;
  @JsonKey(name: 'subCategory', includeIfNull: false, defaultValue: '')
  final String? subCategory;
  @JsonKey(name: 'subCategoryId', includeIfNull: false)
  final num? subCategoryId;
  @JsonKey(name: 'brand', includeIfNull: false, defaultValue: '')
  final String? brand;
  @JsonKey(name: 'shopType', includeIfNull: false, defaultValue: '')
  final String? shopType;
  @JsonKey(
      name: 'bonusPeriodDescription', includeIfNull: false, defaultValue: '')
  final String? bonusPeriodDescription;
  @JsonKey(name: 'availableOnline', includeIfNull: false)
  final bool? availableOnline;
  @JsonKey(name: 'isPreviouslyBought', includeIfNull: false)
  final bool? isPreviouslyBought;
  @JsonKey(
      name: 'descriptionHighlights', includeIfNull: false, defaultValue: '')
  final String? descriptionHighlights;
  @JsonKey(
      name: 'propertyIcons', includeIfNull: false, defaultValue: <String>[])
  final List<String>? propertyIcons;
  @JsonKey(name: 'properties', includeIfNull: false)
  final Map<String, dynamic>? properties;
  @JsonKey(name: 'nix18', includeIfNull: false)
  final bool? nix18;
  @JsonKey(name: 'isStapelBonus', includeIfNull: false)
  final bool? isStapelBonus;
  @JsonKey(
      name: 'extraDescriptions', includeIfNull: false, defaultValue: <String>[])
  final List<String>? extraDescriptions;
  @JsonKey(name: 'bonusSegmentId', includeIfNull: false)
  final num? bonusSegmentId;
  @JsonKey(
      name: 'bonusSegmentDescription', includeIfNull: false, defaultValue: '')
  final String? bonusSegmentDescription;
  @JsonKey(name: 'isBonus', includeIfNull: false)
  final bool? isBonus;
  @JsonKey(name: 'descriptionFull', includeIfNull: false, defaultValue: '')
  final String? descriptionFull;
  @JsonKey(name: 'isOrderable', includeIfNull: false)
  final bool isOrderable;
  @JsonKey(name: 'isInfiniteBonus', includeIfNull: false)
  final bool isInfiniteBonus;
  @JsonKey(name: 'isSample', includeIfNull: false)
  final bool isSample;
  @JsonKey(name: 'isBonusPrice', includeIfNull: false)
  final bool? isBonusPrice;
  static const fromJsonFactory = _$ProductCardBffApiFromJson;
  static const toJsonFactory = _$ProductCardBffApiToJson;
  Map<String, dynamic> toJson() => _$ProductCardBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProductCardBffApi &&
            (identical(other.webshopId, webshopId) ||
                const DeepCollectionEquality()
                    .equals(other.webshopId, webshopId)) &&
            (identical(other.hqId, hqId) ||
                const DeepCollectionEquality().equals(other.hqId, hqId)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.salesUnitSize, salesUnitSize) ||
                const DeepCollectionEquality()
                    .equals(other.salesUnitSize, salesUnitSize)) &&
            (identical(other.unitPriceDescription, unitPriceDescription) ||
                const DeepCollectionEquality().equals(
                    other.unitPriceDescription, unitPriceDescription)) &&
            (identical(other.images, images) ||
                const DeepCollectionEquality().equals(other.images, images)) &&
            (identical(other.bonusStartDate, bonusStartDate) ||
                const DeepCollectionEquality()
                    .equals(other.bonusStartDate, bonusStartDate)) &&
            (identical(other.bonusEndDate, bonusEndDate) ||
                const DeepCollectionEquality()
                    .equals(other.bonusEndDate, bonusEndDate)) &&
            (identical(other.discountType, discountType) ||
                const DeepCollectionEquality()
                    .equals(other.discountType, discountType)) &&
            (identical(other.promotionType, promotionType) ||
                const DeepCollectionEquality()
                    .equals(other.promotionType, promotionType)) &&
            (identical(other.segmentType, segmentType) ||
                const DeepCollectionEquality()
                    .equals(other.segmentType, segmentType)) &&
            (identical(other.bonusMechanism, bonusMechanism) ||
                const DeepCollectionEquality()
                    .equals(other.bonusMechanism, bonusMechanism)) &&
            (identical(other.currentPrice, currentPrice) ||
                const DeepCollectionEquality()
                    .equals(other.currentPrice, currentPrice)) &&
            (identical(other.priceBeforeBonus, priceBeforeBonus) ||
                const DeepCollectionEquality()
                    .equals(other.priceBeforeBonus, priceBeforeBonus)) &&
            (identical(other.orderAvailabilityStatus, orderAvailabilityStatus) ||
                const DeepCollectionEquality().equals(
                    other.orderAvailabilityStatus, orderAvailabilityStatus)) &&
            (identical(other.orderAvailabilityDescription, orderAvailabilityDescription) ||
                const DeepCollectionEquality().equals(
                    other.orderAvailabilityDescription,
                    orderAvailabilityDescription)) &&
            (identical(other.mainCategory, mainCategory) ||
                const DeepCollectionEquality()
                    .equals(other.mainCategory, mainCategory)) &&
            (identical(other.subCategory, subCategory) ||
                const DeepCollectionEquality()
                    .equals(other.subCategory, subCategory)) &&
            (identical(other.subCategoryId, subCategoryId) ||
                const DeepCollectionEquality()
                    .equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.brand, brand) ||
                const DeepCollectionEquality().equals(other.brand, brand)) &&
            (identical(other.shopType, shopType) ||
                const DeepCollectionEquality()
                    .equals(other.shopType, shopType)) &&
            (identical(other.bonusPeriodDescription, bonusPeriodDescription) || const DeepCollectionEquality().equals(other.bonusPeriodDescription, bonusPeriodDescription)) &&
            (identical(other.availableOnline, availableOnline) || const DeepCollectionEquality().equals(other.availableOnline, availableOnline)) &&
            (identical(other.isPreviouslyBought, isPreviouslyBought) || const DeepCollectionEquality().equals(other.isPreviouslyBought, isPreviouslyBought)) &&
            (identical(other.descriptionHighlights, descriptionHighlights) || const DeepCollectionEquality().equals(other.descriptionHighlights, descriptionHighlights)) &&
            (identical(other.propertyIcons, propertyIcons) || const DeepCollectionEquality().equals(other.propertyIcons, propertyIcons)) &&
            (identical(other.properties, properties) || const DeepCollectionEquality().equals(other.properties, properties)) &&
            (identical(other.nix18, nix18) || const DeepCollectionEquality().equals(other.nix18, nix18)) &&
            (identical(other.isStapelBonus, isStapelBonus) || const DeepCollectionEquality().equals(other.isStapelBonus, isStapelBonus)) &&
            (identical(other.extraDescriptions, extraDescriptions) || const DeepCollectionEquality().equals(other.extraDescriptions, extraDescriptions)) &&
            (identical(other.bonusSegmentId, bonusSegmentId) || const DeepCollectionEquality().equals(other.bonusSegmentId, bonusSegmentId)) &&
            (identical(other.bonusSegmentDescription, bonusSegmentDescription) || const DeepCollectionEquality().equals(other.bonusSegmentDescription, bonusSegmentDescription)) &&
            (identical(other.isBonus, isBonus) || const DeepCollectionEquality().equals(other.isBonus, isBonus)) &&
            (identical(other.descriptionFull, descriptionFull) || const DeepCollectionEquality().equals(other.descriptionFull, descriptionFull)) &&
            (identical(other.isOrderable, isOrderable) || const DeepCollectionEquality().equals(other.isOrderable, isOrderable)) &&
            (identical(other.isInfiniteBonus, isInfiniteBonus) || const DeepCollectionEquality().equals(other.isInfiniteBonus, isInfiniteBonus)) &&
            (identical(other.isSample, isSample) || const DeepCollectionEquality().equals(other.isSample, isSample)) &&
            (identical(other.isBonusPrice, isBonusPrice) || const DeepCollectionEquality().equals(other.isBonusPrice, isBonusPrice)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(webshopId) ^
      const DeepCollectionEquality().hash(hqId) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(salesUnitSize) ^
      const DeepCollectionEquality().hash(unitPriceDescription) ^
      const DeepCollectionEquality().hash(images) ^
      const DeepCollectionEquality().hash(bonusStartDate) ^
      const DeepCollectionEquality().hash(bonusEndDate) ^
      const DeepCollectionEquality().hash(discountType) ^
      const DeepCollectionEquality().hash(promotionType) ^
      const DeepCollectionEquality().hash(segmentType) ^
      const DeepCollectionEquality().hash(bonusMechanism) ^
      const DeepCollectionEquality().hash(currentPrice) ^
      const DeepCollectionEquality().hash(priceBeforeBonus) ^
      const DeepCollectionEquality().hash(orderAvailabilityStatus) ^
      const DeepCollectionEquality().hash(orderAvailabilityDescription) ^
      const DeepCollectionEquality().hash(mainCategory) ^
      const DeepCollectionEquality().hash(subCategory) ^
      const DeepCollectionEquality().hash(subCategoryId) ^
      const DeepCollectionEquality().hash(brand) ^
      const DeepCollectionEquality().hash(shopType) ^
      const DeepCollectionEquality().hash(bonusPeriodDescription) ^
      const DeepCollectionEquality().hash(availableOnline) ^
      const DeepCollectionEquality().hash(isPreviouslyBought) ^
      const DeepCollectionEquality().hash(descriptionHighlights) ^
      const DeepCollectionEquality().hash(propertyIcons) ^
      const DeepCollectionEquality().hash(properties) ^
      const DeepCollectionEquality().hash(nix18) ^
      const DeepCollectionEquality().hash(isStapelBonus) ^
      const DeepCollectionEquality().hash(extraDescriptions) ^
      const DeepCollectionEquality().hash(bonusSegmentId) ^
      const DeepCollectionEquality().hash(bonusSegmentDescription) ^
      const DeepCollectionEquality().hash(isBonus) ^
      const DeepCollectionEquality().hash(descriptionFull) ^
      const DeepCollectionEquality().hash(isOrderable) ^
      const DeepCollectionEquality().hash(isInfiniteBonus) ^
      const DeepCollectionEquality().hash(isSample) ^
      const DeepCollectionEquality().hash(isBonusPrice) ^
      runtimeType.hashCode;
}

extension $ProductCardBffApiExtension on ProductCardBffApi {
  ProductCardBffApi copyWith(
      {num? webshopId,
      num? hqId,
      String? title,
      String? salesUnitSize,
      String? unitPriceDescription,
      List<ImageBffApi>? images,
      DateTime? bonusStartDate,
      DateTime? bonusEndDate,
      String? discountType,
      String? promotionType,
      String? segmentType,
      String? bonusMechanism,
      double? currentPrice,
      double? priceBeforeBonus,
      String? orderAvailabilityStatus,
      String? orderAvailabilityDescription,
      String? mainCategory,
      String? subCategory,
      num? subCategoryId,
      String? brand,
      String? shopType,
      String? bonusPeriodDescription,
      bool? availableOnline,
      bool? isPreviouslyBought,
      String? descriptionHighlights,
      List<String>? propertyIcons,
      Map<String, dynamic>? properties,
      bool? nix18,
      bool? isStapelBonus,
      List<String>? extraDescriptions,
      num? bonusSegmentId,
      String? bonusSegmentDescription,
      bool? isBonus,
      String? descriptionFull,
      bool? isOrderable,
      bool? isInfiniteBonus,
      bool? isSample,
      bool? isBonusPrice}) {
    return ProductCardBffApi(
        webshopId: webshopId ?? this.webshopId,
        hqId: hqId ?? this.hqId,
        title: title ?? this.title,
        salesUnitSize: salesUnitSize ?? this.salesUnitSize,
        unitPriceDescription: unitPriceDescription ?? this.unitPriceDescription,
        images: images ?? this.images,
        bonusStartDate: bonusStartDate ?? this.bonusStartDate,
        bonusEndDate: bonusEndDate ?? this.bonusEndDate,
        discountType: discountType ?? this.discountType,
        promotionType: promotionType ?? this.promotionType,
        segmentType: segmentType ?? this.segmentType,
        bonusMechanism: bonusMechanism ?? this.bonusMechanism,
        currentPrice: currentPrice ?? this.currentPrice,
        priceBeforeBonus: priceBeforeBonus ?? this.priceBeforeBonus,
        orderAvailabilityStatus:
            orderAvailabilityStatus ?? this.orderAvailabilityStatus,
        orderAvailabilityDescription:
            orderAvailabilityDescription ?? this.orderAvailabilityDescription,
        mainCategory: mainCategory ?? this.mainCategory,
        subCategory: subCategory ?? this.subCategory,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        brand: brand ?? this.brand,
        shopType: shopType ?? this.shopType,
        bonusPeriodDescription:
            bonusPeriodDescription ?? this.bonusPeriodDescription,
        availableOnline: availableOnline ?? this.availableOnline,
        isPreviouslyBought: isPreviouslyBought ?? this.isPreviouslyBought,
        descriptionHighlights:
            descriptionHighlights ?? this.descriptionHighlights,
        propertyIcons: propertyIcons ?? this.propertyIcons,
        properties: properties ?? this.properties,
        nix18: nix18 ?? this.nix18,
        isStapelBonus: isStapelBonus ?? this.isStapelBonus,
        extraDescriptions: extraDescriptions ?? this.extraDescriptions,
        bonusSegmentId: bonusSegmentId ?? this.bonusSegmentId,
        bonusSegmentDescription:
            bonusSegmentDescription ?? this.bonusSegmentDescription,
        isBonus: isBonus ?? this.isBonus,
        descriptionFull: descriptionFull ?? this.descriptionFull,
        isOrderable: isOrderable ?? this.isOrderable,
        isInfiniteBonus: isInfiniteBonus ?? this.isInfiniteBonus,
        isSample: isSample ?? this.isSample,
        isBonusPrice: isBonusPrice ?? this.isBonusPrice);
  }

  ProductCardBffApi copyWithWrapped(
      {Wrapped<num>? webshopId,
      Wrapped<num>? hqId,
      Wrapped<String>? title,
      Wrapped<String?>? salesUnitSize,
      Wrapped<String?>? unitPriceDescription,
      Wrapped<List<ImageBffApi>?>? images,
      Wrapped<DateTime?>? bonusStartDate,
      Wrapped<DateTime?>? bonusEndDate,
      Wrapped<String?>? discountType,
      Wrapped<String?>? promotionType,
      Wrapped<String?>? segmentType,
      Wrapped<String?>? bonusMechanism,
      Wrapped<double?>? currentPrice,
      Wrapped<double?>? priceBeforeBonus,
      Wrapped<String?>? orderAvailabilityStatus,
      Wrapped<String?>? orderAvailabilityDescription,
      Wrapped<String?>? mainCategory,
      Wrapped<String?>? subCategory,
      Wrapped<num?>? subCategoryId,
      Wrapped<String?>? brand,
      Wrapped<String?>? shopType,
      Wrapped<String?>? bonusPeriodDescription,
      Wrapped<bool?>? availableOnline,
      Wrapped<bool?>? isPreviouslyBought,
      Wrapped<String?>? descriptionHighlights,
      Wrapped<List<String>?>? propertyIcons,
      Wrapped<Map<String, dynamic>?>? properties,
      Wrapped<bool?>? nix18,
      Wrapped<bool?>? isStapelBonus,
      Wrapped<List<String>?>? extraDescriptions,
      Wrapped<num?>? bonusSegmentId,
      Wrapped<String?>? bonusSegmentDescription,
      Wrapped<bool?>? isBonus,
      Wrapped<String?>? descriptionFull,
      Wrapped<bool>? isOrderable,
      Wrapped<bool>? isInfiniteBonus,
      Wrapped<bool>? isSample,
      Wrapped<bool?>? isBonusPrice}) {
    return ProductCardBffApi(
        webshopId: (webshopId != null ? webshopId.value : this.webshopId),
        hqId: (hqId != null ? hqId.value : this.hqId),
        title: (title != null ? title.value : this.title),
        salesUnitSize:
            (salesUnitSize != null ? salesUnitSize.value : this.salesUnitSize),
        unitPriceDescription: (unitPriceDescription != null
            ? unitPriceDescription.value
            : this.unitPriceDescription),
        images: (images != null ? images.value : this.images),
        bonusStartDate: (bonusStartDate != null
            ? bonusStartDate.value
            : this.bonusStartDate),
        bonusEndDate:
            (bonusEndDate != null ? bonusEndDate.value : this.bonusEndDate),
        discountType:
            (discountType != null ? discountType.value : this.discountType),
        promotionType:
            (promotionType != null ? promotionType.value : this.promotionType),
        segmentType:
            (segmentType != null ? segmentType.value : this.segmentType),
        bonusMechanism: (bonusMechanism != null
            ? bonusMechanism.value
            : this.bonusMechanism),
        currentPrice:
            (currentPrice != null ? currentPrice.value : this.currentPrice),
        priceBeforeBonus: (priceBeforeBonus != null
            ? priceBeforeBonus.value
            : this.priceBeforeBonus),
        orderAvailabilityStatus: (orderAvailabilityStatus != null
            ? orderAvailabilityStatus.value
            : this.orderAvailabilityStatus),
        orderAvailabilityDescription: (orderAvailabilityDescription != null
            ? orderAvailabilityDescription.value
            : this.orderAvailabilityDescription),
        mainCategory:
            (mainCategory != null ? mainCategory.value : this.mainCategory),
        subCategory:
            (subCategory != null ? subCategory.value : this.subCategory),
        subCategoryId:
            (subCategoryId != null ? subCategoryId.value : this.subCategoryId),
        brand: (brand != null ? brand.value : this.brand),
        shopType: (shopType != null ? shopType.value : this.shopType),
        bonusPeriodDescription: (bonusPeriodDescription != null
            ? bonusPeriodDescription.value
            : this.bonusPeriodDescription),
        availableOnline: (availableOnline != null
            ? availableOnline.value
            : this.availableOnline),
        isPreviouslyBought: (isPreviouslyBought != null
            ? isPreviouslyBought.value
            : this.isPreviouslyBought),
        descriptionHighlights: (descriptionHighlights != null
            ? descriptionHighlights.value
            : this.descriptionHighlights),
        propertyIcons:
            (propertyIcons != null ? propertyIcons.value : this.propertyIcons),
        properties: (properties != null ? properties.value : this.properties),
        nix18: (nix18 != null ? nix18.value : this.nix18),
        isStapelBonus:
            (isStapelBonus != null ? isStapelBonus.value : this.isStapelBonus),
        extraDescriptions: (extraDescriptions != null
            ? extraDescriptions.value
            : this.extraDescriptions),
        bonusSegmentId: (bonusSegmentId != null
            ? bonusSegmentId.value
            : this.bonusSegmentId),
        bonusSegmentDescription: (bonusSegmentDescription != null
            ? bonusSegmentDescription.value
            : this.bonusSegmentDescription),
        isBonus: (isBonus != null ? isBonus.value : this.isBonus),
        descriptionFull: (descriptionFull != null
            ? descriptionFull.value
            : this.descriptionFull),
        isOrderable:
            (isOrderable != null ? isOrderable.value : this.isOrderable),
        isInfiniteBonus: (isInfiniteBonus != null
            ? isInfiniteBonus.value
            : this.isInfiniteBonus),
        isSample: (isSample != null ? isSample.value : this.isSample),
        isBonusPrice:
            (isBonusPrice != null ? isBonusPrice.value : this.isBonusPrice));
  }
}

@JsonSerializable(explicitToJson: true)
class ProductDetailsBffApi {
  ProductDetailsBffApi({
    required this.productId,
    required this.productCard,
    this.tradeItem,
    this.properties,
    required this.disclaimerText,
  });

  factory ProductDetailsBffApi.fromJson(Map<String, dynamic> json) =>
      _$ProductDetailsBffApiFromJson(json);

  @JsonKey(name: 'productId', includeIfNull: false)
  final num productId;
  @JsonKey(name: 'productCard', includeIfNull: false)
  final ProductCardBffApi productCard;
  @JsonKey(name: 'tradeItem', includeIfNull: false)
  final TradeItemBffApi? tradeItem;
  @JsonKey(name: 'properties', includeIfNull: false)
  final Map<String, dynamic>? properties;
  @JsonKey(name: 'disclaimerText', includeIfNull: false, defaultValue: '')
  final String disclaimerText;
  static const fromJsonFactory = _$ProductDetailsBffApiFromJson;
  static const toJsonFactory = _$ProductDetailsBffApiToJson;
  Map<String, dynamic> toJson() => _$ProductDetailsBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProductDetailsBffApi &&
            (identical(other.productId, productId) ||
                const DeepCollectionEquality()
                    .equals(other.productId, productId)) &&
            (identical(other.productCard, productCard) ||
                const DeepCollectionEquality()
                    .equals(other.productCard, productCard)) &&
            (identical(other.tradeItem, tradeItem) ||
                const DeepCollectionEquality()
                    .equals(other.tradeItem, tradeItem)) &&
            (identical(other.properties, properties) ||
                const DeepCollectionEquality()
                    .equals(other.properties, properties)) &&
            (identical(other.disclaimerText, disclaimerText) ||
                const DeepCollectionEquality()
                    .equals(other.disclaimerText, disclaimerText)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(productId) ^
      const DeepCollectionEquality().hash(productCard) ^
      const DeepCollectionEquality().hash(tradeItem) ^
      const DeepCollectionEquality().hash(properties) ^
      const DeepCollectionEquality().hash(disclaimerText) ^
      runtimeType.hashCode;
}

extension $ProductDetailsBffApiExtension on ProductDetailsBffApi {
  ProductDetailsBffApi copyWith(
      {num? productId,
      ProductCardBffApi? productCard,
      TradeItemBffApi? tradeItem,
      Map<String, dynamic>? properties,
      String? disclaimerText}) {
    return ProductDetailsBffApi(
        productId: productId ?? this.productId,
        productCard: productCard ?? this.productCard,
        tradeItem: tradeItem ?? this.tradeItem,
        properties: properties ?? this.properties,
        disclaimerText: disclaimerText ?? this.disclaimerText);
  }

  ProductDetailsBffApi copyWithWrapped(
      {Wrapped<num>? productId,
      Wrapped<ProductCardBffApi>? productCard,
      Wrapped<TradeItemBffApi?>? tradeItem,
      Wrapped<Map<String, dynamic>?>? properties,
      Wrapped<String>? disclaimerText}) {
    return ProductDetailsBffApi(
        productId: (productId != null ? productId.value : this.productId),
        productCard:
            (productCard != null ? productCard.value : this.productCard),
        tradeItem: (tradeItem != null ? tradeItem.value : this.tradeItem),
        properties: (properties != null ? properties.value : this.properties),
        disclaimerText: (disclaimerText != null
            ? disclaimerText.value
            : this.disclaimerText));
  }
}

@JsonSerializable(explicitToJson: true)
class QuantityBffApi {
  QuantityBffApi({
    this.value,
    this.measurementUnitCode,
  });

  factory QuantityBffApi.fromJson(Map<String, dynamic> json) =>
      _$QuantityBffApiFromJson(json);

  @JsonKey(name: 'value', includeIfNull: false)
  final double? value;
  @JsonKey(name: 'measurementUnitCode', includeIfNull: false)
  final CodeWithLabelBffApi? measurementUnitCode;
  static const fromJsonFactory = _$QuantityBffApiFromJson;
  static const toJsonFactory = _$QuantityBffApiToJson;
  Map<String, dynamic> toJson() => _$QuantityBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is QuantityBffApi &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)) &&
            (identical(other.measurementUnitCode, measurementUnitCode) ||
                const DeepCollectionEquality()
                    .equals(other.measurementUnitCode, measurementUnitCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(value) ^
      const DeepCollectionEquality().hash(measurementUnitCode) ^
      runtimeType.hashCode;
}

extension $QuantityBffApiExtension on QuantityBffApi {
  QuantityBffApi copyWith(
      {double? value, CodeWithLabelBffApi? measurementUnitCode}) {
    return QuantityBffApi(
        value: value ?? this.value,
        measurementUnitCode: measurementUnitCode ?? this.measurementUnitCode);
  }

  QuantityBffApi copyWithWrapped(
      {Wrapped<double?>? value,
      Wrapped<CodeWithLabelBffApi?>? measurementUnitCode}) {
    return QuantityBffApi(
        value: (value != null ? value.value : this.value),
        measurementUnitCode: (measurementUnitCode != null
            ? measurementUnitCode.value
            : this.measurementUnitCode));
  }
}

@JsonSerializable(explicitToJson: true)
class ReferencedFileDetailInformationBffApi {
  ReferencedFileDetailInformationBffApi({
    this.typeCode,
    this.uniformResourceIdentifier,
  });

  factory ReferencedFileDetailInformationBffApi.fromJson(
          Map<String, dynamic> json) =>
      _$ReferencedFileDetailInformationBffApiFromJson(json);

  @JsonKey(name: 'typeCode', includeIfNull: false)
  final CodeWithLabelBffApi? typeCode;
  @JsonKey(
      name: 'uniformResourceIdentifier', includeIfNull: false, defaultValue: '')
  final String? uniformResourceIdentifier;
  static const fromJsonFactory =
      _$ReferencedFileDetailInformationBffApiFromJson;
  static const toJsonFactory = _$ReferencedFileDetailInformationBffApiToJson;
  Map<String, dynamic> toJson() =>
      _$ReferencedFileDetailInformationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ReferencedFileDetailInformationBffApi &&
            (identical(other.typeCode, typeCode) ||
                const DeepCollectionEquality()
                    .equals(other.typeCode, typeCode)) &&
            (identical(other.uniformResourceIdentifier,
                    uniformResourceIdentifier) ||
                const DeepCollectionEquality().equals(
                    other.uniformResourceIdentifier,
                    uniformResourceIdentifier)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(typeCode) ^
      const DeepCollectionEquality().hash(uniformResourceIdentifier) ^
      runtimeType.hashCode;
}

extension $ReferencedFileDetailInformationBffApiExtension
    on ReferencedFileDetailInformationBffApi {
  ReferencedFileDetailInformationBffApi copyWith(
      {CodeWithLabelBffApi? typeCode, String? uniformResourceIdentifier}) {
    return ReferencedFileDetailInformationBffApi(
        typeCode: typeCode ?? this.typeCode,
        uniformResourceIdentifier:
            uniformResourceIdentifier ?? this.uniformResourceIdentifier);
  }

  ReferencedFileDetailInformationBffApi copyWithWrapped(
      {Wrapped<CodeWithLabelBffApi?>? typeCode,
      Wrapped<String?>? uniformResourceIdentifier}) {
    return ReferencedFileDetailInformationBffApi(
        typeCode: (typeCode != null ? typeCode.value : this.typeCode),
        uniformResourceIdentifier: (uniformResourceIdentifier != null
            ? uniformResourceIdentifier.value
            : this.uniformResourceIdentifier));
  }
}

@JsonSerializable(explicitToJson: true)
class RegulatoryInformationBffApi {
  RegulatoryInformationBffApi({
    this.permitIdentification,
    this.regulationTypeCode,
  });

  factory RegulatoryInformationBffApi.fromJson(Map<String, dynamic> json) =>
      _$RegulatoryInformationBffApiFromJson(json);

  @JsonKey(
      name: 'permitIdentification',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? permitIdentification;
  @JsonKey(
      name: 'regulationTypeCode',
      includeIfNull: false,
      defaultValue: <CodeWithLabelBffApi>[])
  final List<CodeWithLabelBffApi>? regulationTypeCode;
  static const fromJsonFactory = _$RegulatoryInformationBffApiFromJson;
  static const toJsonFactory = _$RegulatoryInformationBffApiToJson;
  Map<String, dynamic> toJson() => _$RegulatoryInformationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is RegulatoryInformationBffApi &&
            (identical(other.permitIdentification, permitIdentification) ||
                const DeepCollectionEquality().equals(
                    other.permitIdentification, permitIdentification)) &&
            (identical(other.regulationTypeCode, regulationTypeCode) ||
                const DeepCollectionEquality()
                    .equals(other.regulationTypeCode, regulationTypeCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(permitIdentification) ^
      const DeepCollectionEquality().hash(regulationTypeCode) ^
      runtimeType.hashCode;
}

extension $RegulatoryInformationBffApiExtension on RegulatoryInformationBffApi {
  RegulatoryInformationBffApi copyWith(
      {List<String>? permitIdentification,
      List<CodeWithLabelBffApi>? regulationTypeCode}) {
    return RegulatoryInformationBffApi(
        permitIdentification: permitIdentification ?? this.permitIdentification,
        regulationTypeCode: regulationTypeCode ?? this.regulationTypeCode);
  }

  RegulatoryInformationBffApi copyWithWrapped(
      {Wrapped<List<String>?>? permitIdentification,
      Wrapped<List<CodeWithLabelBffApi>?>? regulationTypeCode}) {
    return RegulatoryInformationBffApi(
        permitIdentification: (permitIdentification != null
            ? permitIdentification.value
            : this.permitIdentification),
        regulationTypeCode: (regulationTypeCode != null
            ? regulationTypeCode.value
            : this.regulationTypeCode));
  }
}

@JsonSerializable(explicitToJson: true)
class SafetyDataSheetInformationBffApi {
  SafetyDataSheetInformationBffApi({
    this.ghsDetail,
  });

  factory SafetyDataSheetInformationBffApi.fromJson(
          Map<String, dynamic> json) =>
      _$SafetyDataSheetInformationBffApiFromJson(json);

  @JsonKey(name: 'ghsDetail', includeIfNull: false)
  final GHSDetailBffApi? ghsDetail;
  static const fromJsonFactory = _$SafetyDataSheetInformationBffApiFromJson;
  static const toJsonFactory = _$SafetyDataSheetInformationBffApiToJson;
  Map<String, dynamic> toJson() =>
      _$SafetyDataSheetInformationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SafetyDataSheetInformationBffApi &&
            (identical(other.ghsDetail, ghsDetail) ||
                const DeepCollectionEquality()
                    .equals(other.ghsDetail, ghsDetail)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(ghsDetail) ^ runtimeType.hashCode;
}

extension $SafetyDataSheetInformationBffApiExtension
    on SafetyDataSheetInformationBffApi {
  SafetyDataSheetInformationBffApi copyWith({GHSDetailBffApi? ghsDetail}) {
    return SafetyDataSheetInformationBffApi(
        ghsDetail: ghsDetail ?? this.ghsDetail);
  }

  SafetyDataSheetInformationBffApi copyWithWrapped(
      {Wrapped<GHSDetailBffApi?>? ghsDetail}) {
    return SafetyDataSheetInformationBffApi(
        ghsDetail: (ghsDetail != null ? ghsDetail.value : this.ghsDetail));
  }
}

@JsonSerializable(explicitToJson: true)
class SalesInformationBffApi {
  SalesInformationBffApi({
    this.consumerSalesConditionCode,
  });

  factory SalesInformationBffApi.fromJson(Map<String, dynamic> json) =>
      _$SalesInformationBffApiFromJson(json);

  @JsonKey(
      name: 'consumerSalesConditionCode',
      includeIfNull: false,
      defaultValue: <CodeWithLabelBffApi>[])
  final List<CodeWithLabelBffApi>? consumerSalesConditionCode;
  static const fromJsonFactory = _$SalesInformationBffApiFromJson;
  static const toJsonFactory = _$SalesInformationBffApiToJson;
  Map<String, dynamic> toJson() => _$SalesInformationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SalesInformationBffApi &&
            (identical(other.consumerSalesConditionCode,
                    consumerSalesConditionCode) ||
                const DeepCollectionEquality().equals(
                    other.consumerSalesConditionCode,
                    consumerSalesConditionCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(consumerSalesConditionCode) ^
      runtimeType.hashCode;
}

extension $SalesInformationBffApiExtension on SalesInformationBffApi {
  SalesInformationBffApi copyWith(
      {List<CodeWithLabelBffApi>? consumerSalesConditionCode}) {
    return SalesInformationBffApi(
        consumerSalesConditionCode:
            consumerSalesConditionCode ?? this.consumerSalesConditionCode);
  }

  SalesInformationBffApi copyWithWrapped(
      {Wrapped<List<CodeWithLabelBffApi>?>? consumerSalesConditionCode}) {
    return SalesInformationBffApi(
        consumerSalesConditionCode: (consumerSalesConditionCode != null
            ? consumerSalesConditionCode.value
            : this.consumerSalesConditionCode));
  }
}

@JsonSerializable(explicitToJson: true)
class ServingQuantityInformationBffApi {
  ServingQuantityInformationBffApi({
    this.maximumNumberOfSmallestUnitsPerPackage,
    this.numberOfServingsPerPackage,
    this.numberOfSmallestUnitsPerPackage,
  });

  factory ServingQuantityInformationBffApi.fromJson(
          Map<String, dynamic> json) =>
      _$ServingQuantityInformationBffApiFromJson(json);

  @JsonKey(name: 'maximumNumberOfSmallestUnitsPerPackage', includeIfNull: false)
  final num? maximumNumberOfSmallestUnitsPerPackage;
  @JsonKey(name: 'numberOfServingsPerPackage', includeIfNull: false)
  final double? numberOfServingsPerPackage;
  @JsonKey(name: 'numberOfSmallestUnitsPerPackage', includeIfNull: false)
  final num? numberOfSmallestUnitsPerPackage;
  static const fromJsonFactory = _$ServingQuantityInformationBffApiFromJson;
  static const toJsonFactory = _$ServingQuantityInformationBffApiToJson;
  Map<String, dynamic> toJson() =>
      _$ServingQuantityInformationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ServingQuantityInformationBffApi &&
            (identical(other.maximumNumberOfSmallestUnitsPerPackage,
                    maximumNumberOfSmallestUnitsPerPackage) ||
                const DeepCollectionEquality().equals(
                    other.maximumNumberOfSmallestUnitsPerPackage,
                    maximumNumberOfSmallestUnitsPerPackage)) &&
            (identical(other.numberOfServingsPerPackage,
                    numberOfServingsPerPackage) ||
                const DeepCollectionEquality().equals(
                    other.numberOfServingsPerPackage,
                    numberOfServingsPerPackage)) &&
            (identical(other.numberOfSmallestUnitsPerPackage,
                    numberOfSmallestUnitsPerPackage) ||
                const DeepCollectionEquality().equals(
                    other.numberOfSmallestUnitsPerPackage,
                    numberOfSmallestUnitsPerPackage)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality()
          .hash(maximumNumberOfSmallestUnitsPerPackage) ^
      const DeepCollectionEquality().hash(numberOfServingsPerPackage) ^
      const DeepCollectionEquality().hash(numberOfSmallestUnitsPerPackage) ^
      runtimeType.hashCode;
}

extension $ServingQuantityInformationBffApiExtension
    on ServingQuantityInformationBffApi {
  ServingQuantityInformationBffApi copyWith(
      {num? maximumNumberOfSmallestUnitsPerPackage,
      double? numberOfServingsPerPackage,
      num? numberOfSmallestUnitsPerPackage}) {
    return ServingQuantityInformationBffApi(
        maximumNumberOfSmallestUnitsPerPackage:
            maximumNumberOfSmallestUnitsPerPackage ??
                this.maximumNumberOfSmallestUnitsPerPackage,
        numberOfServingsPerPackage:
            numberOfServingsPerPackage ?? this.numberOfServingsPerPackage,
        numberOfSmallestUnitsPerPackage: numberOfSmallestUnitsPerPackage ??
            this.numberOfSmallestUnitsPerPackage);
  }

  ServingQuantityInformationBffApi copyWithWrapped(
      {Wrapped<num?>? maximumNumberOfSmallestUnitsPerPackage,
      Wrapped<double?>? numberOfServingsPerPackage,
      Wrapped<num?>? numberOfSmallestUnitsPerPackage}) {
    return ServingQuantityInformationBffApi(
        maximumNumberOfSmallestUnitsPerPackage:
            (maximumNumberOfSmallestUnitsPerPackage != null
                ? maximumNumberOfSmallestUnitsPerPackage.value
                : this.maximumNumberOfSmallestUnitsPerPackage),
        numberOfServingsPerPackage: (numberOfServingsPerPackage != null
            ? numberOfServingsPerPackage.value
            : this.numberOfServingsPerPackage),
        numberOfSmallestUnitsPerPackage:
            (numberOfSmallestUnitsPerPackage != null
                ? numberOfSmallestUnitsPerPackage.value
                : this.numberOfSmallestUnitsPerPackage));
  }
}

@JsonSerializable(explicitToJson: true)
class TargetMarketCommunicationChannelBffApi {
  TargetMarketCommunicationChannelBffApi({
    this.communicationChannel,
  });

  factory TargetMarketCommunicationChannelBffApi.fromJson(
          Map<String, dynamic> json) =>
      _$TargetMarketCommunicationChannelBffApiFromJson(json);

  @JsonKey(
      name: 'communicationChannel',
      includeIfNull: false,
      defaultValue: <CommunicationChannelBffApi>[])
  final List<CommunicationChannelBffApi>? communicationChannel;
  static const fromJsonFactory =
      _$TargetMarketCommunicationChannelBffApiFromJson;
  static const toJsonFactory = _$TargetMarketCommunicationChannelBffApiToJson;
  Map<String, dynamic> toJson() =>
      _$TargetMarketCommunicationChannelBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TargetMarketCommunicationChannelBffApi &&
            (identical(other.communicationChannel, communicationChannel) ||
                const DeepCollectionEquality()
                    .equals(other.communicationChannel, communicationChannel)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(communicationChannel) ^
      runtimeType.hashCode;
}

extension $TargetMarketCommunicationChannelBffApiExtension
    on TargetMarketCommunicationChannelBffApi {
  TargetMarketCommunicationChannelBffApi copyWith(
      {List<CommunicationChannelBffApi>? communicationChannel}) {
    return TargetMarketCommunicationChannelBffApi(
        communicationChannel:
            communicationChannel ?? this.communicationChannel);
  }

  TargetMarketCommunicationChannelBffApi copyWithWrapped(
      {Wrapped<List<CommunicationChannelBffApi>?>? communicationChannel}) {
    return TargetMarketCommunicationChannelBffApi(
        communicationChannel: (communicationChannel != null
            ? communicationChannel.value
            : this.communicationChannel));
  }
}

@JsonSerializable(explicitToJson: true)
class TimeMeasurementBffApi {
  TimeMeasurementBffApi({
    this.value,
    this.timeMeasurementUnitCode,
  });

  factory TimeMeasurementBffApi.fromJson(Map<String, dynamic> json) =>
      _$TimeMeasurementBffApiFromJson(json);

  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String? value;
  @JsonKey(name: 'timeMeasurementUnitCode', includeIfNull: false)
  final CodeWithLabelBffApi? timeMeasurementUnitCode;
  static const fromJsonFactory = _$TimeMeasurementBffApiFromJson;
  static const toJsonFactory = _$TimeMeasurementBffApiToJson;
  Map<String, dynamic> toJson() => _$TimeMeasurementBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TimeMeasurementBffApi &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)) &&
            (identical(
                    other.timeMeasurementUnitCode, timeMeasurementUnitCode) ||
                const DeepCollectionEquality().equals(
                    other.timeMeasurementUnitCode, timeMeasurementUnitCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(value) ^
      const DeepCollectionEquality().hash(timeMeasurementUnitCode) ^
      runtimeType.hashCode;
}

extension $TimeMeasurementBffApiExtension on TimeMeasurementBffApi {
  TimeMeasurementBffApi copyWith(
      {String? value, CodeWithLabelBffApi? timeMeasurementUnitCode}) {
    return TimeMeasurementBffApi(
        value: value ?? this.value,
        timeMeasurementUnitCode:
            timeMeasurementUnitCode ?? this.timeMeasurementUnitCode);
  }

  TimeMeasurementBffApi copyWithWrapped(
      {Wrapped<String?>? value,
      Wrapped<CodeWithLabelBffApi?>? timeMeasurementUnitCode}) {
    return TimeMeasurementBffApi(
        value: (value != null ? value.value : this.value),
        timeMeasurementUnitCode: (timeMeasurementUnitCode != null
            ? timeMeasurementUnitCode.value
            : this.timeMeasurementUnitCode));
  }
}

@JsonSerializable(explicitToJson: true)
class TradeItemBffApi {
  TradeItemBffApi({
    this.gln,
    this.gtin,
    this.additionalTradeItemIdentification,
    this.alcoholInformation,
    this.allergenInformation,
    this.animalFeeding,
    this.certificationInformation,
    this.consumerInstructions,
    this.dairyFishMeatPoultryInformation,
    this.foodAndBeverageIngredientStatement,
    this.foodAndBeveragePreparationServing,
    this.healthRelatedInformation,
    this.healthcareInformation,
    this.healthWellnessPackagingMarking,
    this.nonfoodIngredientStatement,
    this.nutritionalInformation,
    this.packagingMarking,
    this.pharmaceuticalInformation,
    this.placeOfItemActivity,
    this.referencedFileDetailInformation,
    this.regulatoryInformation,
    this.safetyDataSheetInformation,
    this.salesInformation,
    this.contactInformation,
    this.description,
    this.lifespan,
    this.measurements,
  });

  factory TradeItemBffApi.fromJson(Map<String, dynamic> json) =>
      _$TradeItemBffApiFromJson(json);

  @JsonKey(name: 'gln', includeIfNull: false, defaultValue: '')
  final String? gln;
  @JsonKey(name: 'gtin', includeIfNull: false, defaultValue: '')
  final String? gtin;
  @JsonKey(
      name: 'additionalTradeItemIdentification',
      includeIfNull: false,
      defaultValue: <AdditionalTradeItemIdentificationBffApi>[])
  final List<AdditionalTradeItemIdentificationBffApi>?
      additionalTradeItemIdentification;
  @JsonKey(name: 'alcoholInformation', includeIfNull: false)
  final AlcoholInformationBffApi? alcoholInformation;
  @JsonKey(
      name: 'allergenInformation',
      includeIfNull: false,
      defaultValue: <AllergenInformationBffApi>[])
  final List<AllergenInformationBffApi>? allergenInformation;
  @JsonKey(name: 'animalFeeding', includeIfNull: false)
  final AnimalFeedingBffApi? animalFeeding;
  @JsonKey(
      name: 'certificationInformation',
      includeIfNull: false,
      defaultValue: <CertificationInformationBffApi>[])
  final List<CertificationInformationBffApi>? certificationInformation;
  @JsonKey(name: 'consumerInstructions', includeIfNull: false)
  final ConsumerInstructionsBffApi? consumerInstructions;
  @JsonKey(name: 'dairyFishMeatPoultryInformation', includeIfNull: false)
  final DairyFishMeatPoultryInformationBffApi? dairyFishMeatPoultryInformation;
  @JsonKey(
      name: 'foodAndBeverageIngredientStatement',
      includeIfNull: false,
      defaultValue: '')
  final String? foodAndBeverageIngredientStatement;
  @JsonKey(name: 'foodAndBeveragePreparationServing', includeIfNull: false)
  final FoodAndBeveragePreparationServingBffApi?
      foodAndBeveragePreparationServing;
  @JsonKey(name: 'healthRelatedInformation', includeIfNull: false)
  final HealthRelatedInformationBffApi? healthRelatedInformation;
  @JsonKey(name: 'healthcareInformation', includeIfNull: false)
  final HealthcareInformationBffApi? healthcareInformation;
  @JsonKey(name: 'healthWellnessPackagingMarking', includeIfNull: false)
  final HealthWellnessPackagingMarkingBffApi? healthWellnessPackagingMarking;
  @JsonKey(
      name: 'nonfoodIngredientStatement',
      includeIfNull: false,
      defaultValue: '')
  final String? nonfoodIngredientStatement;
  @JsonKey(name: 'nutritionalInformation', includeIfNull: false)
  final NutritionalInformationBffApi? nutritionalInformation;
  @JsonKey(name: 'packagingMarking', includeIfNull: false)
  final PackagingMarkingBffApi? packagingMarking;
  @JsonKey(name: 'pharmaceuticalInformation', includeIfNull: false)
  final PharmaceuticalInformationBffApi? pharmaceuticalInformation;
  @JsonKey(name: 'placeOfItemActivity', includeIfNull: false)
  final PlaceOfItemActivityBffApi? placeOfItemActivity;
  @JsonKey(
      name: 'referencedFileDetailInformation',
      includeIfNull: false,
      defaultValue: <ReferencedFileDetailInformationBffApi>[])
  final List<ReferencedFileDetailInformationBffApi>?
      referencedFileDetailInformation;
  @JsonKey(
      name: 'regulatoryInformation',
      includeIfNull: false,
      defaultValue: <RegulatoryInformationBffApi>[])
  final List<RegulatoryInformationBffApi>? regulatoryInformation;
  @JsonKey(
      name: 'safetyDataSheetInformation',
      includeIfNull: false,
      defaultValue: <SafetyDataSheetInformationBffApi>[])
  final List<SafetyDataSheetInformationBffApi>? safetyDataSheetInformation;
  @JsonKey(name: 'salesInformation', includeIfNull: false)
  final SalesInformationBffApi? salesInformation;
  @JsonKey(
      name: 'contactInformation',
      includeIfNull: false,
      defaultValue: <TradeItemContactInformationBffApi>[])
  final List<TradeItemContactInformationBffApi>? contactInformation;
  @JsonKey(name: 'description', includeIfNull: false)
  final TradeItemDescriptionBffApi? description;
  @JsonKey(name: 'lifespan', includeIfNull: false)
  final TradeItemLifespanBffApi? lifespan;
  @JsonKey(name: 'measurements', includeIfNull: false)
  final TradeItemMeasurementsBffApi? measurements;
  static const fromJsonFactory = _$TradeItemBffApiFromJson;
  static const toJsonFactory = _$TradeItemBffApiToJson;
  Map<String, dynamic> toJson() => _$TradeItemBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TradeItemBffApi &&
            (identical(other.gln, gln) ||
                const DeepCollectionEquality().equals(other.gln, gln)) &&
            (identical(other.gtin, gtin) ||
                const DeepCollectionEquality().equals(other.gtin, gtin)) &&
            (identical(other.additionalTradeItemIdentification, additionalTradeItemIdentification) ||
                const DeepCollectionEquality().equals(
                    other.additionalTradeItemIdentification,
                    additionalTradeItemIdentification)) &&
            (identical(other.alcoholInformation, alcoholInformation) ||
                const DeepCollectionEquality()
                    .equals(other.alcoholInformation, alcoholInformation)) &&
            (identical(other.allergenInformation, allergenInformation) ||
                const DeepCollectionEquality()
                    .equals(other.allergenInformation, allergenInformation)) &&
            (identical(other.animalFeeding, animalFeeding) ||
                const DeepCollectionEquality()
                    .equals(other.animalFeeding, animalFeeding)) &&
            (identical(other.certificationInformation, certificationInformation) ||
                const DeepCollectionEquality().equals(
                    other.certificationInformation,
                    certificationInformation)) &&
            (identical(other.consumerInstructions, consumerInstructions) ||
                const DeepCollectionEquality().equals(
                    other.consumerInstructions, consumerInstructions)) &&
            (identical(other.dairyFishMeatPoultryInformation, dairyFishMeatPoultryInformation) ||
                const DeepCollectionEquality().equals(
                    other.dairyFishMeatPoultryInformation,
                    dairyFishMeatPoultryInformation)) &&
            (identical(other.foodAndBeverageIngredientStatement, foodAndBeverageIngredientStatement) ||
                const DeepCollectionEquality().equals(
                    other.foodAndBeverageIngredientStatement,
                    foodAndBeverageIngredientStatement)) &&
            (identical(other.foodAndBeveragePreparationServing, foodAndBeveragePreparationServing) ||
                const DeepCollectionEquality().equals(
                    other.foodAndBeveragePreparationServing,
                    foodAndBeveragePreparationServing)) &&
            (identical(other.healthRelatedInformation, healthRelatedInformation) ||
                const DeepCollectionEquality().equals(
                    other.healthRelatedInformation, healthRelatedInformation)) &&
            (identical(other.healthcareInformation, healthcareInformation) || const DeepCollectionEquality().equals(other.healthcareInformation, healthcareInformation)) &&
            (identical(other.healthWellnessPackagingMarking, healthWellnessPackagingMarking) || const DeepCollectionEquality().equals(other.healthWellnessPackagingMarking, healthWellnessPackagingMarking)) &&
            (identical(other.nonfoodIngredientStatement, nonfoodIngredientStatement) || const DeepCollectionEquality().equals(other.nonfoodIngredientStatement, nonfoodIngredientStatement)) &&
            (identical(other.nutritionalInformation, nutritionalInformation) || const DeepCollectionEquality().equals(other.nutritionalInformation, nutritionalInformation)) &&
            (identical(other.packagingMarking, packagingMarking) || const DeepCollectionEquality().equals(other.packagingMarking, packagingMarking)) &&
            (identical(other.pharmaceuticalInformation, pharmaceuticalInformation) || const DeepCollectionEquality().equals(other.pharmaceuticalInformation, pharmaceuticalInformation)) &&
            (identical(other.placeOfItemActivity, placeOfItemActivity) || const DeepCollectionEquality().equals(other.placeOfItemActivity, placeOfItemActivity)) &&
            (identical(other.referencedFileDetailInformation, referencedFileDetailInformation) || const DeepCollectionEquality().equals(other.referencedFileDetailInformation, referencedFileDetailInformation)) &&
            (identical(other.regulatoryInformation, regulatoryInformation) || const DeepCollectionEquality().equals(other.regulatoryInformation, regulatoryInformation)) &&
            (identical(other.safetyDataSheetInformation, safetyDataSheetInformation) || const DeepCollectionEquality().equals(other.safetyDataSheetInformation, safetyDataSheetInformation)) &&
            (identical(other.salesInformation, salesInformation) || const DeepCollectionEquality().equals(other.salesInformation, salesInformation)) &&
            (identical(other.contactInformation, contactInformation) || const DeepCollectionEquality().equals(other.contactInformation, contactInformation)) &&
            (identical(other.description, description) || const DeepCollectionEquality().equals(other.description, description)) &&
            (identical(other.lifespan, lifespan) || const DeepCollectionEquality().equals(other.lifespan, lifespan)) &&
            (identical(other.measurements, measurements) || const DeepCollectionEquality().equals(other.measurements, measurements)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(gln) ^
      const DeepCollectionEquality().hash(gtin) ^
      const DeepCollectionEquality().hash(additionalTradeItemIdentification) ^
      const DeepCollectionEquality().hash(alcoholInformation) ^
      const DeepCollectionEquality().hash(allergenInformation) ^
      const DeepCollectionEquality().hash(animalFeeding) ^
      const DeepCollectionEquality().hash(certificationInformation) ^
      const DeepCollectionEquality().hash(consumerInstructions) ^
      const DeepCollectionEquality().hash(dairyFishMeatPoultryInformation) ^
      const DeepCollectionEquality().hash(foodAndBeverageIngredientStatement) ^
      const DeepCollectionEquality().hash(foodAndBeveragePreparationServing) ^
      const DeepCollectionEquality().hash(healthRelatedInformation) ^
      const DeepCollectionEquality().hash(healthcareInformation) ^
      const DeepCollectionEquality().hash(healthWellnessPackagingMarking) ^
      const DeepCollectionEquality().hash(nonfoodIngredientStatement) ^
      const DeepCollectionEquality().hash(nutritionalInformation) ^
      const DeepCollectionEquality().hash(packagingMarking) ^
      const DeepCollectionEquality().hash(pharmaceuticalInformation) ^
      const DeepCollectionEquality().hash(placeOfItemActivity) ^
      const DeepCollectionEquality().hash(referencedFileDetailInformation) ^
      const DeepCollectionEquality().hash(regulatoryInformation) ^
      const DeepCollectionEquality().hash(safetyDataSheetInformation) ^
      const DeepCollectionEquality().hash(salesInformation) ^
      const DeepCollectionEquality().hash(contactInformation) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(lifespan) ^
      const DeepCollectionEquality().hash(measurements) ^
      runtimeType.hashCode;
}

extension $TradeItemBffApiExtension on TradeItemBffApi {
  TradeItemBffApi copyWith(
      {String? gln,
      String? gtin,
      List<AdditionalTradeItemIdentificationBffApi>?
          additionalTradeItemIdentification,
      AlcoholInformationBffApi? alcoholInformation,
      List<AllergenInformationBffApi>? allergenInformation,
      AnimalFeedingBffApi? animalFeeding,
      List<CertificationInformationBffApi>? certificationInformation,
      ConsumerInstructionsBffApi? consumerInstructions,
      DairyFishMeatPoultryInformationBffApi? dairyFishMeatPoultryInformation,
      String? foodAndBeverageIngredientStatement,
      FoodAndBeveragePreparationServingBffApi?
          foodAndBeveragePreparationServing,
      HealthRelatedInformationBffApi? healthRelatedInformation,
      HealthcareInformationBffApi? healthcareInformation,
      HealthWellnessPackagingMarkingBffApi? healthWellnessPackagingMarking,
      String? nonfoodIngredientStatement,
      NutritionalInformationBffApi? nutritionalInformation,
      PackagingMarkingBffApi? packagingMarking,
      PharmaceuticalInformationBffApi? pharmaceuticalInformation,
      PlaceOfItemActivityBffApi? placeOfItemActivity,
      List<ReferencedFileDetailInformationBffApi>?
          referencedFileDetailInformation,
      List<RegulatoryInformationBffApi>? regulatoryInformation,
      List<SafetyDataSheetInformationBffApi>? safetyDataSheetInformation,
      SalesInformationBffApi? salesInformation,
      List<TradeItemContactInformationBffApi>? contactInformation,
      TradeItemDescriptionBffApi? description,
      TradeItemLifespanBffApi? lifespan,
      TradeItemMeasurementsBffApi? measurements}) {
    return TradeItemBffApi(
        gln: gln ?? this.gln,
        gtin: gtin ?? this.gtin,
        additionalTradeItemIdentification: additionalTradeItemIdentification ??
            this.additionalTradeItemIdentification,
        alcoholInformation: alcoholInformation ?? this.alcoholInformation,
        allergenInformation: allergenInformation ?? this.allergenInformation,
        animalFeeding: animalFeeding ?? this.animalFeeding,
        certificationInformation:
            certificationInformation ?? this.certificationInformation,
        consumerInstructions: consumerInstructions ?? this.consumerInstructions,
        dairyFishMeatPoultryInformation: dairyFishMeatPoultryInformation ??
            this.dairyFishMeatPoultryInformation,
        foodAndBeverageIngredientStatement:
            foodAndBeverageIngredientStatement ??
                this.foodAndBeverageIngredientStatement,
        foodAndBeveragePreparationServing: foodAndBeveragePreparationServing ??
            this.foodAndBeveragePreparationServing,
        healthRelatedInformation:
            healthRelatedInformation ?? this.healthRelatedInformation,
        healthcareInformation:
            healthcareInformation ?? this.healthcareInformation,
        healthWellnessPackagingMarking: healthWellnessPackagingMarking ??
            this.healthWellnessPackagingMarking,
        nonfoodIngredientStatement:
            nonfoodIngredientStatement ?? this.nonfoodIngredientStatement,
        nutritionalInformation:
            nutritionalInformation ?? this.nutritionalInformation,
        packagingMarking: packagingMarking ?? this.packagingMarking,
        pharmaceuticalInformation:
            pharmaceuticalInformation ?? this.pharmaceuticalInformation,
        placeOfItemActivity: placeOfItemActivity ?? this.placeOfItemActivity,
        referencedFileDetailInformation: referencedFileDetailInformation ??
            this.referencedFileDetailInformation,
        regulatoryInformation:
            regulatoryInformation ?? this.regulatoryInformation,
        safetyDataSheetInformation:
            safetyDataSheetInformation ?? this.safetyDataSheetInformation,
        salesInformation: salesInformation ?? this.salesInformation,
        contactInformation: contactInformation ?? this.contactInformation,
        description: description ?? this.description,
        lifespan: lifespan ?? this.lifespan,
        measurements: measurements ?? this.measurements);
  }

  TradeItemBffApi copyWithWrapped(
      {Wrapped<String?>? gln,
      Wrapped<String?>? gtin,
      Wrapped<List<AdditionalTradeItemIdentificationBffApi>?>?
          additionalTradeItemIdentification,
      Wrapped<AlcoholInformationBffApi?>? alcoholInformation,
      Wrapped<List<AllergenInformationBffApi>?>? allergenInformation,
      Wrapped<AnimalFeedingBffApi?>? animalFeeding,
      Wrapped<List<CertificationInformationBffApi>?>? certificationInformation,
      Wrapped<ConsumerInstructionsBffApi?>? consumerInstructions,
      Wrapped<DairyFishMeatPoultryInformationBffApi?>?
          dairyFishMeatPoultryInformation,
      Wrapped<String?>? foodAndBeverageIngredientStatement,
      Wrapped<FoodAndBeveragePreparationServingBffApi?>?
          foodAndBeveragePreparationServing,
      Wrapped<HealthRelatedInformationBffApi?>? healthRelatedInformation,
      Wrapped<HealthcareInformationBffApi?>? healthcareInformation,
      Wrapped<HealthWellnessPackagingMarkingBffApi?>?
          healthWellnessPackagingMarking,
      Wrapped<String?>? nonfoodIngredientStatement,
      Wrapped<NutritionalInformationBffApi?>? nutritionalInformation,
      Wrapped<PackagingMarkingBffApi?>? packagingMarking,
      Wrapped<PharmaceuticalInformationBffApi?>? pharmaceuticalInformation,
      Wrapped<PlaceOfItemActivityBffApi?>? placeOfItemActivity,
      Wrapped<List<ReferencedFileDetailInformationBffApi>?>?
          referencedFileDetailInformation,
      Wrapped<List<RegulatoryInformationBffApi>?>? regulatoryInformation,
      Wrapped<List<SafetyDataSheetInformationBffApi>?>?
          safetyDataSheetInformation,
      Wrapped<SalesInformationBffApi?>? salesInformation,
      Wrapped<List<TradeItemContactInformationBffApi>?>? contactInformation,
      Wrapped<TradeItemDescriptionBffApi?>? description,
      Wrapped<TradeItemLifespanBffApi?>? lifespan,
      Wrapped<TradeItemMeasurementsBffApi?>? measurements}) {
    return TradeItemBffApi(
        gln: (gln != null ? gln.value : this.gln),
        gtin: (gtin != null ? gtin.value : this.gtin),
        additionalTradeItemIdentification: (additionalTradeItemIdentification != null
            ? additionalTradeItemIdentification.value
            : this.additionalTradeItemIdentification),
        alcoholInformation: (alcoholInformation != null
            ? alcoholInformation.value
            : this.alcoholInformation),
        allergenInformation: (allergenInformation != null
            ? allergenInformation.value
            : this.allergenInformation),
        animalFeeding:
            (animalFeeding != null ? animalFeeding.value : this.animalFeeding),
        certificationInformation: (certificationInformation != null
            ? certificationInformation.value
            : this.certificationInformation),
        consumerInstructions: (consumerInstructions != null
            ? consumerInstructions.value
            : this.consumerInstructions),
        dairyFishMeatPoultryInformation: (dairyFishMeatPoultryInformation != null
            ? dairyFishMeatPoultryInformation.value
            : this.dairyFishMeatPoultryInformation),
        foodAndBeverageIngredientStatement: (foodAndBeverageIngredientStatement != null
            ? foodAndBeverageIngredientStatement.value
            : this.foodAndBeverageIngredientStatement),
        foodAndBeveragePreparationServing: (foodAndBeveragePreparationServing != null
            ? foodAndBeveragePreparationServing.value
            : this.foodAndBeveragePreparationServing),
        healthRelatedInformation: (healthRelatedInformation != null
            ? healthRelatedInformation.value
            : this.healthRelatedInformation),
        healthcareInformation: (healthcareInformation != null
            ? healthcareInformation.value
            : this.healthcareInformation),
        healthWellnessPackagingMarking: (healthWellnessPackagingMarking != null
            ? healthWellnessPackagingMarking.value
            : this.healthWellnessPackagingMarking),
        nonfoodIngredientStatement: (nonfoodIngredientStatement != null
            ? nonfoodIngredientStatement.value
            : this.nonfoodIngredientStatement),
        nutritionalInformation: (nutritionalInformation != null
            ? nutritionalInformation.value
            : this.nutritionalInformation),
        packagingMarking: (packagingMarking != null
            ? packagingMarking.value
            : this.packagingMarking),
        pharmaceuticalInformation: (pharmaceuticalInformation != null
            ? pharmaceuticalInformation.value
            : this.pharmaceuticalInformation),
        placeOfItemActivity: (placeOfItemActivity != null
            ? placeOfItemActivity.value
            : this.placeOfItemActivity),
        referencedFileDetailInformation: (referencedFileDetailInformation != null
            ? referencedFileDetailInformation.value
            : this.referencedFileDetailInformation),
        regulatoryInformation: (regulatoryInformation != null
            ? regulatoryInformation.value
            : this.regulatoryInformation),
        safetyDataSheetInformation: (safetyDataSheetInformation != null
            ? safetyDataSheetInformation.value
            : this.safetyDataSheetInformation),
        salesInformation: (salesInformation != null ? salesInformation.value : this.salesInformation),
        contactInformation: (contactInformation != null ? contactInformation.value : this.contactInformation),
        description: (description != null ? description.value : this.description),
        lifespan: (lifespan != null ? lifespan.value : this.lifespan),
        measurements: (measurements != null ? measurements.value : this.measurements));
  }
}

@JsonSerializable(explicitToJson: true)
class TradeItemContactInformationBffApi {
  TradeItemContactInformationBffApi({
    this.contactAddress,
    this.contactName,
    this.targetMarketCommunicationChannel,
    this.contactTypeCode,
  });

  factory TradeItemContactInformationBffApi.fromJson(
          Map<String, dynamic> json) =>
      _$TradeItemContactInformationBffApiFromJson(json);

  @JsonKey(name: 'contactAddress', includeIfNull: false, defaultValue: '')
  final String? contactAddress;
  @JsonKey(name: 'contactName', includeIfNull: false, defaultValue: '')
  final String? contactName;
  @JsonKey(
      name: 'targetMarketCommunicationChannel',
      includeIfNull: false,
      defaultValue: <TargetMarketCommunicationChannelBffApi>[])
  final List<TargetMarketCommunicationChannelBffApi>?
      targetMarketCommunicationChannel;
  @JsonKey(name: 'contactTypeCode', includeIfNull: false)
  final CodeWithLabelBffApi? contactTypeCode;
  static const fromJsonFactory = _$TradeItemContactInformationBffApiFromJson;
  static const toJsonFactory = _$TradeItemContactInformationBffApiToJson;
  Map<String, dynamic> toJson() =>
      _$TradeItemContactInformationBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TradeItemContactInformationBffApi &&
            (identical(other.contactAddress, contactAddress) ||
                const DeepCollectionEquality()
                    .equals(other.contactAddress, contactAddress)) &&
            (identical(other.contactName, contactName) ||
                const DeepCollectionEquality()
                    .equals(other.contactName, contactName)) &&
            (identical(other.targetMarketCommunicationChannel,
                    targetMarketCommunicationChannel) ||
                const DeepCollectionEquality().equals(
                    other.targetMarketCommunicationChannel,
                    targetMarketCommunicationChannel)) &&
            (identical(other.contactTypeCode, contactTypeCode) ||
                const DeepCollectionEquality()
                    .equals(other.contactTypeCode, contactTypeCode)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(contactAddress) ^
      const DeepCollectionEquality().hash(contactName) ^
      const DeepCollectionEquality().hash(targetMarketCommunicationChannel) ^
      const DeepCollectionEquality().hash(contactTypeCode) ^
      runtimeType.hashCode;
}

extension $TradeItemContactInformationBffApiExtension
    on TradeItemContactInformationBffApi {
  TradeItemContactInformationBffApi copyWith(
      {String? contactAddress,
      String? contactName,
      List<TargetMarketCommunicationChannelBffApi>?
          targetMarketCommunicationChannel,
      CodeWithLabelBffApi? contactTypeCode}) {
    return TradeItemContactInformationBffApi(
        contactAddress: contactAddress ?? this.contactAddress,
        contactName: contactName ?? this.contactName,
        targetMarketCommunicationChannel: targetMarketCommunicationChannel ??
            this.targetMarketCommunicationChannel,
        contactTypeCode: contactTypeCode ?? this.contactTypeCode);
  }

  TradeItemContactInformationBffApi copyWithWrapped(
      {Wrapped<String?>? contactAddress,
      Wrapped<String?>? contactName,
      Wrapped<List<TargetMarketCommunicationChannelBffApi>?>?
          targetMarketCommunicationChannel,
      Wrapped<CodeWithLabelBffApi?>? contactTypeCode}) {
    return TradeItemContactInformationBffApi(
        contactAddress: (contactAddress != null
            ? contactAddress.value
            : this.contactAddress),
        contactName:
            (contactName != null ? contactName.value : this.contactName),
        targetMarketCommunicationChannel:
            (targetMarketCommunicationChannel != null
                ? targetMarketCommunicationChannel.value
                : this.targetMarketCommunicationChannel),
        contactTypeCode: (contactTypeCode != null
            ? contactTypeCode.value
            : this.contactTypeCode));
  }
}

@JsonSerializable(explicitToJson: true)
class TradeItemDescriptionBffApi {
  TradeItemDescriptionBffApi({
    this.regulatedProductName,
  });

  factory TradeItemDescriptionBffApi.fromJson(Map<String, dynamic> json) =>
      _$TradeItemDescriptionBffApiFromJson(json);

  @JsonKey(
      name: 'regulatedProductName',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? regulatedProductName;
  static const fromJsonFactory = _$TradeItemDescriptionBffApiFromJson;
  static const toJsonFactory = _$TradeItemDescriptionBffApiToJson;
  Map<String, dynamic> toJson() => _$TradeItemDescriptionBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TradeItemDescriptionBffApi &&
            (identical(other.regulatedProductName, regulatedProductName) ||
                const DeepCollectionEquality()
                    .equals(other.regulatedProductName, regulatedProductName)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(regulatedProductName) ^
      runtimeType.hashCode;
}

extension $TradeItemDescriptionBffApiExtension on TradeItemDescriptionBffApi {
  TradeItemDescriptionBffApi copyWith({List<String>? regulatedProductName}) {
    return TradeItemDescriptionBffApi(
        regulatedProductName:
            regulatedProductName ?? this.regulatedProductName);
  }

  TradeItemDescriptionBffApi copyWithWrapped(
      {Wrapped<List<String>?>? regulatedProductName}) {
    return TradeItemDescriptionBffApi(
        regulatedProductName: (regulatedProductName != null
            ? regulatedProductName.value
            : this.regulatedProductName));
  }
}

@JsonSerializable(explicitToJson: true)
class TradeItemLifespanBffApi {
  TradeItemLifespanBffApi({
    this.itemPeriodSafeToUseAfterOpening,
  });

  factory TradeItemLifespanBffApi.fromJson(Map<String, dynamic> json) =>
      _$TradeItemLifespanBffApiFromJson(json);

  @JsonKey(
      name: 'itemPeriodSafeToUseAfterOpening',
      includeIfNull: false,
      defaultValue: <TimeMeasurementBffApi>[])
  final List<TimeMeasurementBffApi>? itemPeriodSafeToUseAfterOpening;
  static const fromJsonFactory = _$TradeItemLifespanBffApiFromJson;
  static const toJsonFactory = _$TradeItemLifespanBffApiToJson;
  Map<String, dynamic> toJson() => _$TradeItemLifespanBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TradeItemLifespanBffApi &&
            (identical(other.itemPeriodSafeToUseAfterOpening,
                    itemPeriodSafeToUseAfterOpening) ||
                const DeepCollectionEquality().equals(
                    other.itemPeriodSafeToUseAfterOpening,
                    itemPeriodSafeToUseAfterOpening)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(itemPeriodSafeToUseAfterOpening) ^
      runtimeType.hashCode;
}

extension $TradeItemLifespanBffApiExtension on TradeItemLifespanBffApi {
  TradeItemLifespanBffApi copyWith(
      {List<TimeMeasurementBffApi>? itemPeriodSafeToUseAfterOpening}) {
    return TradeItemLifespanBffApi(
        itemPeriodSafeToUseAfterOpening: itemPeriodSafeToUseAfterOpening ??
            this.itemPeriodSafeToUseAfterOpening);
  }

  TradeItemLifespanBffApi copyWithWrapped(
      {Wrapped<List<TimeMeasurementBffApi>?>?
          itemPeriodSafeToUseAfterOpening}) {
    return TradeItemLifespanBffApi(
        itemPeriodSafeToUseAfterOpening:
            (itemPeriodSafeToUseAfterOpening != null
                ? itemPeriodSafeToUseAfterOpening.value
                : this.itemPeriodSafeToUseAfterOpening));
  }
}

@JsonSerializable(explicitToJson: true)
class TradeItemMeasurementsBffApi {
  TradeItemMeasurementsBffApi({
    this.netContent,
    this.netContentStatement,
    this.weight,
  });

  factory TradeItemMeasurementsBffApi.fromJson(Map<String, dynamic> json) =>
      _$TradeItemMeasurementsBffApiFromJson(json);

  @JsonKey(
      name: 'netContent',
      includeIfNull: false,
      defaultValue: <QuantityBffApi>[])
  final List<QuantityBffApi>? netContent;
  @JsonKey(name: 'netContentStatement', includeIfNull: false, defaultValue: '')
  final String? netContentStatement;
  @JsonKey(name: 'weight', includeIfNull: false)
  final TradeItemWeightBffApi? weight;
  static const fromJsonFactory = _$TradeItemMeasurementsBffApiFromJson;
  static const toJsonFactory = _$TradeItemMeasurementsBffApiToJson;
  Map<String, dynamic> toJson() => _$TradeItemMeasurementsBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TradeItemMeasurementsBffApi &&
            (identical(other.netContent, netContent) ||
                const DeepCollectionEquality()
                    .equals(other.netContent, netContent)) &&
            (identical(other.netContentStatement, netContentStatement) ||
                const DeepCollectionEquality()
                    .equals(other.netContentStatement, netContentStatement)) &&
            (identical(other.weight, weight) ||
                const DeepCollectionEquality().equals(other.weight, weight)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(netContent) ^
      const DeepCollectionEquality().hash(netContentStatement) ^
      const DeepCollectionEquality().hash(weight) ^
      runtimeType.hashCode;
}

extension $TradeItemMeasurementsBffApiExtension on TradeItemMeasurementsBffApi {
  TradeItemMeasurementsBffApi copyWith(
      {List<QuantityBffApi>? netContent,
      String? netContentStatement,
      TradeItemWeightBffApi? weight}) {
    return TradeItemMeasurementsBffApi(
        netContent: netContent ?? this.netContent,
        netContentStatement: netContentStatement ?? this.netContentStatement,
        weight: weight ?? this.weight);
  }

  TradeItemMeasurementsBffApi copyWithWrapped(
      {Wrapped<List<QuantityBffApi>?>? netContent,
      Wrapped<String?>? netContentStatement,
      Wrapped<TradeItemWeightBffApi?>? weight}) {
    return TradeItemMeasurementsBffApi(
        netContent: (netContent != null ? netContent.value : this.netContent),
        netContentStatement: (netContentStatement != null
            ? netContentStatement.value
            : this.netContentStatement),
        weight: (weight != null ? weight.value : this.weight));
  }
}

@JsonSerializable(explicitToJson: true)
class TradeItemWeightBffApi {
  TradeItemWeightBffApi({
    this.drainedWeight,
  });

  factory TradeItemWeightBffApi.fromJson(Map<String, dynamic> json) =>
      _$TradeItemWeightBffApiFromJson(json);

  @JsonKey(name: 'drainedWeight', includeIfNull: false)
  final WeightMeasurementBffApi? drainedWeight;
  static const fromJsonFactory = _$TradeItemWeightBffApiFromJson;
  static const toJsonFactory = _$TradeItemWeightBffApiToJson;
  Map<String, dynamic> toJson() => _$TradeItemWeightBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TradeItemWeightBffApi &&
            (identical(other.drainedWeight, drainedWeight) ||
                const DeepCollectionEquality()
                    .equals(other.drainedWeight, drainedWeight)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(drainedWeight) ^ runtimeType.hashCode;
}

extension $TradeItemWeightBffApiExtension on TradeItemWeightBffApi {
  TradeItemWeightBffApi copyWith({WeightMeasurementBffApi? drainedWeight}) {
    return TradeItemWeightBffApi(
        drainedWeight: drainedWeight ?? this.drainedWeight);
  }

  TradeItemWeightBffApi copyWithWrapped(
      {Wrapped<WeightMeasurementBffApi?>? drainedWeight}) {
    return TradeItemWeightBffApi(
        drainedWeight:
            (drainedWeight != null ? drainedWeight.value : this.drainedWeight));
  }
}

@JsonSerializable(explicitToJson: true)
class WeightMeasurementBffApi {
  WeightMeasurementBffApi({
    this.value,
    this.measurementUnitCode,
    this.weightInGRM,
  });

  factory WeightMeasurementBffApi.fromJson(Map<String, dynamic> json) =>
      _$WeightMeasurementBffApiFromJson(json);

  @JsonKey(name: 'value', includeIfNull: false)
  final double? value;
  @JsonKey(name: 'measurementUnitCode', includeIfNull: false)
  final CodeWithLabelBffApi? measurementUnitCode;
  @JsonKey(name: 'weightInGRM', includeIfNull: false)
  final num? weightInGRM;
  static const fromJsonFactory = _$WeightMeasurementBffApiFromJson;
  static const toJsonFactory = _$WeightMeasurementBffApiToJson;
  Map<String, dynamic> toJson() => _$WeightMeasurementBffApiToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WeightMeasurementBffApi &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)) &&
            (identical(other.measurementUnitCode, measurementUnitCode) ||
                const DeepCollectionEquality()
                    .equals(other.measurementUnitCode, measurementUnitCode)) &&
            (identical(other.weightInGRM, weightInGRM) ||
                const DeepCollectionEquality()
                    .equals(other.weightInGRM, weightInGRM)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(value) ^
      const DeepCollectionEquality().hash(measurementUnitCode) ^
      const DeepCollectionEquality().hash(weightInGRM) ^
      runtimeType.hashCode;
}

extension $WeightMeasurementBffApiExtension on WeightMeasurementBffApi {
  WeightMeasurementBffApi copyWith(
      {double? value,
      CodeWithLabelBffApi? measurementUnitCode,
      num? weightInGRM}) {
    return WeightMeasurementBffApi(
        value: value ?? this.value,
        measurementUnitCode: measurementUnitCode ?? this.measurementUnitCode,
        weightInGRM: weightInGRM ?? this.weightInGRM);
  }

  WeightMeasurementBffApi copyWithWrapped(
      {Wrapped<double?>? value,
      Wrapped<CodeWithLabelBffApi?>? measurementUnitCode,
      Wrapped<num?>? weightInGRM}) {
    return WeightMeasurementBffApi(
        value: (value != null ? value.value : this.value),
        measurementUnitCode: (measurementUnitCode != null
            ? measurementUnitCode.value
            : this.measurementUnitCode),
        weightInGRM:
            (weightInGRM != null ? weightInGRM.value : this.weightInGRM));
  }
}

String? communicationChannelTypeToJson(
    enums.CommunicationChannelType? communicationChannelType) {
  return enums.$CommunicationChannelTypeMap[communicationChannelType];
}

enums.CommunicationChannelType communicationChannelTypeFromJson(
  Object? communicationChannelType, [
  enums.CommunicationChannelType? defaultValue,
]) {
  if (communicationChannelType is String) {
    return enums.$CommunicationChannelTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                communicationChannelType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CommunicationChannelType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CommunicationChannelTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CommunicationChannelType.swaggerGeneratedUnknown;
}

List<String> communicationChannelTypeListToJson(
    List<enums.CommunicationChannelType>? communicationChannelType) {
  if (communicationChannelType == null) {
    return [];
  }

  return communicationChannelType
      .map((e) => enums.$CommunicationChannelTypeMap[e]!)
      .toList();
}

List<enums.CommunicationChannelType> communicationChannelTypeListFromJson(
  List? communicationChannelType, [
  List<enums.CommunicationChannelType>? defaultValue,
]) {
  if (communicationChannelType == null) {
    return defaultValue ?? [];
  }

  return communicationChannelType
      .map((e) => communicationChannelTypeFromJson(e.toString()))
      .toList();
}

List<enums.CommunicationChannelType>?
    communicationChannelTypeNullableListFromJson(
  List? communicationChannelType, [
  List<enums.CommunicationChannelType>? defaultValue,
]) {
  if (communicationChannelType == null) {
    return defaultValue;
  }

  return communicationChannelType
      .map((e) => communicationChannelTypeFromJson(e.toString()))
      .toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
