// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'swagger_from_issue_263.enums.swagger.dart' as enums;
export 'swagger_from_issue_263.enums.swagger.dart';

part 'swagger_from_issue_263.swagger.chopper.dart';
part 'swagger_from_issue_263.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class SwaggerFromIssue263 extends ChopperService {
  static SwaggerFromIssue263 create({
    ChopperClient? client,
    Authenticator? authenticator,
    String? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$SwaggerFromIssue263(client);
    }

    final newClient = ChopperClient(
        services: [_$SwaggerFromIssue263()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://webservices.sagebridge.org/');
    return _$SwaggerFromIssue263(newClient);
  }

  ///
  ///@param SignIn Sign in information
  Future<chopper.Response<UserSessionInfo>> v3AuthSignInPost({
    required SignIn? signIn,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(SignIn, () => SignIn.fromJsonFactory);
    generatedMapping.putIfAbsent(
        UserSessionInfo, () => UserSessionInfo.fromJsonFactory);

    return _v3AuthSignInPost(signIn: signIn, cacheControl: cacheControl);
  }

  ///
  ///@param SignIn Sign in information
  @Post(path: '/v3/auth/signIn')
  Future<chopper.Response<UserSessionInfo>> _v3AuthSignInPost({
    @Body() required SignIn? signIn,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param SignIn Information to authenticate with the server
  Future<chopper.Response<UserSessionInfo>> v3AuthReauthPost({
    required SignIn? signIn,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(SignIn, () => SignIn.fromJsonFactory);
    generatedMapping.putIfAbsent(
        UserSessionInfo, () => UserSessionInfo.fromJsonFactory);

    return _v3AuthReauthPost(signIn: signIn, cacheControl: cacheControl);
  }

  ///
  ///@param SignIn Information to authenticate with the server
  @Post(path: '/v3/auth/reauth')
  Future<chopper.Response<UserSessionInfo>> _v3AuthReauthPost({
    @Body() required SignIn? signIn,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param SignIn Email or phone information information
  Future<chopper.Response> v3AuthRequestResetPasswordPost({
    required SignIn? signIn,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(SignIn, () => SignIn.fromJsonFactory);

    return _v3AuthRequestResetPasswordPost(
        signIn: signIn, cacheControl: cacheControl);
  }

  ///
  ///@param SignIn Email or phone information information
  @Post(path: '/v3/auth/requestResetPassword')
  Future<chopper.Response> _v3AuthRequestResetPasswordPost({
    @Body() required SignIn? signIn,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param PasswordReset Password reset token
  Future<chopper.Response<Object>> v3AuthResetPasswordPost({
    required PasswordReset? passwordReset,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        PasswordReset, () => PasswordReset.fromJsonFactory);

    return _v3AuthResetPasswordPost(
        passwordReset: passwordReset, cacheControl: cacheControl);
  }

  ///
  ///@param PasswordReset Password reset token
  @Post(path: '/v3/auth/resetPassword')
  Future<chopper.Response<Object>> _v3AuthResetPasswordPost({
    @Body() required PasswordReset? passwordReset,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param SignUp Sign up information
  Future<chopper.Response<Object>> v3AuthSignUpPost({
    required SignUp? signUp,
    String? cacheControl,
  }) {
    return _v3AuthSignUpPost(signUp: signUp, cacheControl: cacheControl);
  }

  ///
  ///@param SignUp Sign up information
  @Post(path: '/v3/auth/signUp')
  Future<chopper.Response<Object>> _v3AuthSignUpPost({
    @Body() required SignUp? signUp,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param Verification verification token
  Future<chopper.Response<Object>> v3AuthVerifyEmailPost({
    required Verification? verification,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Verification, () => Verification.fromJsonFactory);

    return _v3AuthVerifyEmailPost(
        verification: verification, cacheControl: cacheControl);
  }

  ///
  ///@param Verification verification token
  @Post(path: '/v3/auth/verifyEmail')
  Future<chopper.Response<Object>> _v3AuthVerifyEmailPost({
    @Body() required Verification? verification,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param Verification verification token
  Future<chopper.Response<Object>> v3AuthVerifyPhonePost({
    required Verification? verification,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Verification, () => Verification.fromJsonFactory);

    return _v3AuthVerifyPhonePost(
        verification: verification, cacheControl: cacheControl);
  }

  ///
  ///@param Verification verification token
  @Post(path: '/v3/auth/verifyPhone')
  Future<chopper.Response<Object>> _v3AuthVerifyPhonePost({
    @Body() required Verification? verification,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param Identifier Email address of participant (phone number is ignored).
  Future<chopper.Response> v3AuthResendEmailVerificationPost({
    required Identifier? identifier,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Identifier, () => Identifier.fromJsonFactory);

    return _v3AuthResendEmailVerificationPost(
        identifier: identifier, cacheControl: cacheControl);
  }

  ///
  ///@param Identifier Email address of participant (phone number is ignored).
  @Post(path: '/v3/auth/resendEmailVerification')
  Future<chopper.Response> _v3AuthResendEmailVerificationPost({
    @Body() required Identifier? identifier,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param Identifier Phone number of participant (email address is ignored).
  Future<chopper.Response> v3AuthResendPhoneVerificationPost({
    required Identifier? identifier,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Identifier, () => Identifier.fromJsonFactory);

    return _v3AuthResendPhoneVerificationPost(
        identifier: identifier, cacheControl: cacheControl);
  }

  ///
  ///@param Identifier Phone number of participant (email address is ignored).
  @Post(path: '/v3/auth/resendPhoneVerification')
  Future<chopper.Response> _v3AuthResendPhoneVerificationPost({
    @Body() required Identifier? identifier,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param EmailSignInRequest Information to trigger an email for sign in.
  Future<chopper.Response> v3AuthEmailPost({
    required EmailSignInRequest? emailSignInRequest,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        EmailSignInRequest, () => EmailSignInRequest.fromJsonFactory);

    return _v3AuthEmailPost(
        emailSignInRequest: emailSignInRequest, cacheControl: cacheControl);
  }

  ///
  ///@param EmailSignInRequest Information to trigger an email for sign in.
  @Post(path: '/v3/auth/email')
  Future<chopper.Response> _v3AuthEmailPost({
    @Body() required EmailSignInRequest? emailSignInRequest,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param EmailSignIn Information to authenticate with the server
  Future<chopper.Response<UserSessionInfo>> v3AuthEmailSignInPost({
    required EmailSignIn? emailSignIn,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        EmailSignIn, () => EmailSignIn.fromJsonFactory);
    generatedMapping.putIfAbsent(
        UserSessionInfo, () => UserSessionInfo.fromJsonFactory);

    return _v3AuthEmailSignInPost(
        emailSignIn: emailSignIn, cacheControl: cacheControl);
  }

  ///
  ///@param EmailSignIn Information to authenticate with the server
  @Post(path: '/v3/auth/email/signIn')
  Future<chopper.Response<UserSessionInfo>> _v3AuthEmailSignInPost({
    @Body() required EmailSignIn? emailSignIn,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param PhoneSignInRequest Information to trigger an SMS message for sign in.
  Future<chopper.Response> v3AuthPhonePost({
    required PhoneSignInRequest? phoneSignInRequest,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        PhoneSignInRequest, () => PhoneSignInRequest.fromJsonFactory);

    return _v3AuthPhonePost(
        phoneSignInRequest: phoneSignInRequest, cacheControl: cacheControl);
  }

  ///
  ///@param PhoneSignInRequest Information to trigger an SMS message for sign in.
  @Post(path: '/v3/auth/phone')
  Future<chopper.Response> _v3AuthPhonePost({
    @Body() required PhoneSignInRequest? phoneSignInRequest,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param PhoneSignIn Information to authenticate with the server
  Future<chopper.Response<UserSessionInfo>> v3AuthPhoneSignInPost({
    required Object? phoneSignIn,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UserSessionInfo, () => UserSessionInfo.fromJsonFactory);

    return _v3AuthPhoneSignInPost(
        phoneSignIn: phoneSignIn, cacheControl: cacheControl);
  }

  ///
  ///@param PhoneSignIn Information to authenticate with the server
  @Post(path: '/v3/auth/phone/signIn')
  Future<chopper.Response<UserSessionInfo>> _v3AuthPhoneSignInPost({
    @Body() required Object? phoneSignIn,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param OAuthAuthorizationToken The authorization token sent from an OAuth server, used to sign in.
  Future<chopper.Response<UserSessionInfo>> v3AuthOauthSignInPost({
    required OAuthAuthorizationToken? oAuthAuthorizationToken,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        OAuthAuthorizationToken, () => OAuthAuthorizationToken.fromJsonFactory);
    generatedMapping.putIfAbsent(
        UserSessionInfo, () => UserSessionInfo.fromJsonFactory);

    return _v3AuthOauthSignInPost(
        oAuthAuthorizationToken: oAuthAuthorizationToken,
        cacheControl: cacheControl);
  }

  ///
  ///@param OAuthAuthorizationToken The authorization token sent from an OAuth server, used to sign in.
  @Post(path: '/v3/auth/oauth/signIn')
  Future<chopper.Response<UserSessionInfo>> _v3AuthOauthSignInPost({
    @Body() required OAuthAuthorizationToken? oAuthAuthorizationToken,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param SignIn Sign in information (appId only)
  Future<chopper.Response<UserSessionInfo>> v3AuthAppPost({
    required SignIn? signIn,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(SignIn, () => SignIn.fromJsonFactory);
    generatedMapping.putIfAbsent(
        UserSessionInfo, () => UserSessionInfo.fromJsonFactory);

    return _v3AuthAppPost(signIn: signIn, cacheControl: cacheControl);
  }

  ///
  ///@param SignIn Sign in information (appId only)
  @Post(path: '/v3/auth/app')
  Future<chopper.Response<UserSessionInfo>> _v3AuthAppPost({
    @Body() required SignIn? signIn,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Request an access token from a given OAuth 2.0 provider.
  ///@param
  ///@param OAuthAuthorizationToken
  Future<chopper.Response<OAuthAccessToken>> v3OauthVendorIdPost({
    required String? vendorId,
    required OAuthAuthorizationToken? oAuthAuthorizationToken,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        OAuthAuthorizationToken, () => OAuthAuthorizationToken.fromJsonFactory);
    generatedMapping.putIfAbsent(
        OAuthAccessToken, () => OAuthAccessToken.fromJsonFactory);

    return _v3OauthVendorIdPost(
        vendorId: vendorId,
        oAuthAuthorizationToken: oAuthAuthorizationToken,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Request an access token from a given OAuth 2.0 provider.
  ///@param
  ///@param OAuthAuthorizationToken
  @Post(path: '/v3/oauth/{vendorId}')
  Future<chopper.Response<OAuthAccessToken>> _v3OauthVendorIdPost({
    @Path('vendorId') required String? vendorId,
    @Body() required OAuthAuthorizationToken? oAuthAuthorizationToken,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param SignIn Sign in information
  Future<chopper.Response<UserSessionInfo>> v4AuthSignInPost({
    required SignIn? signIn,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(SignIn, () => SignIn.fromJsonFactory);
    generatedMapping.putIfAbsent(
        UserSessionInfo, () => UserSessionInfo.fromJsonFactory);

    return _v4AuthSignInPost(signIn: signIn, cacheControl: cacheControl);
  }

  ///
  ///@param SignIn Sign in information
  @Post(path: '/v4/auth/signIn')
  Future<chopper.Response<UserSessionInfo>> _v4AuthSignInPost({
    @Body() required SignIn? signIn,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  Future<chopper.Response<Object>> v4AuthSignOutPost({
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v4AuthSignOutPost(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///
  @Post(
    path: '/v4/auth/signOut',
    optionalBody: true,
  )
  Future<chopper.Response<Object>> _v4AuthSignOutPost({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param SignIn Sign in information
  Future<chopper.Response<UserSessionInfo>> v3AuthAdminSignInPost({
    required SignIn? signIn,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(SignIn, () => SignIn.fromJsonFactory);
    generatedMapping.putIfAbsent(
        UserSessionInfo, () => UserSessionInfo.fromJsonFactory);

    return _v3AuthAdminSignInPost(signIn: signIn, cacheControl: cacheControl);
  }

  ///
  ///@param SignIn Sign in information
  @Post(path: '/v3/auth/admin/signIn')
  Future<chopper.Response<UserSessionInfo>> _v3AuthAdminSignInPost({
    @Body() required SignIn? signIn,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get all apps The summary must be true if this call is made without authentication.
  ///@param summary If true, anyone can call this endpoint and return a list of truncated app objects (name and ID only). Otherwise, caller must be an admin.
  Future<chopper.Response<AppList>> v1AppsGet({
    bool? summary,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(AppList, () => AppList.fromJsonFactory);

    return _v1AppsGet(
        summary: summary,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get all apps The summary must be true if this call is made without authentication.
  ///@param summary If true, anyone can call this endpoint and return a list of truncated app objects (name and ID only). Otherwise, caller must be an admin.
  @Get(path: '/v1/apps')
  Future<chopper.Response<AppList>> _v1AppsGet({
    @Query('summary') bool? summary,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new app
  ///@param App
  Future<chopper.Response<VersionHolder>> v1AppsPost({
    required App? app,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(App, () => App.fromJsonFactory);
    generatedMapping.putIfAbsent(
        VersionHolder, () => VersionHolder.fromJsonFactory);

    return _v1AppsPost(
        app: app, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Create a new app
  ///@param App
  @Post(path: '/v1/apps')
  Future<chopper.Response<VersionHolder>> _v1AppsPost({
    @Body() required App? app,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new app with administrators and users
  ///@param AppAndUsers
  Future<chopper.Response<VersionHolder>> v1AppsInitPost({
    required AppAndUsers? appAndUsers,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AppAndUsers, () => AppAndUsers.fromJsonFactory);
    generatedMapping.putIfAbsent(
        VersionHolder, () => VersionHolder.fromJsonFactory);

    return _v1AppsInitPost(
        appAndUsers: appAndUsers,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new app with administrators and users
  ///@param AppAndUsers
  @Post(path: '/v1/apps/init')
  Future<chopper.Response<VersionHolder>> _v1AppsInitPost({
    @Body() required AppAndUsers? appAndUsers,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the list of apps that are accessible to the signed in user via a shared Synapse user ID
  Future<chopper.Response<AppList>> v1AppsMembershipsGet({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(AppList, () => AppList.fromJsonFactory);

    return _v1AppsMembershipsGet(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get the list of apps that are accessible to the signed in user via a shared Synapse user ID
  @Get(path: '/v1/apps/memberships')
  Future<chopper.Response<AppList>> _v1AppsMembershipsGet({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an app
  Future<chopper.Response<App>> v1AppsSelfGet({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(App, () => App.fromJsonFactory);

    return _v1AppsSelfGet(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get an app
  @Get(path: '/v1/apps/self')
  Future<chopper.Response<App>> _v1AppsSelfGet({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update an app
  ///@param App
  Future<chopper.Response<VersionHolder>> v1AppsSelfPost({
    required App? app,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(App, () => App.fromJsonFactory);
    generatedMapping.putIfAbsent(
        VersionHolder, () => VersionHolder.fromJsonFactory);

    return _v1AppsSelfPost(
        app: app, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Update an app
  ///@param App
  @Post(path: '/v1/apps/self')
  Future<chopper.Response<VersionHolder>> _v1AppsSelfPost({
    @Body() required App? app,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an app
  ///@param
  Future<chopper.Response<App>> v1AppsAppIdGet({
    required String? appId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(App, () => App.fromJsonFactory);

    return _v1AppsAppIdGet(
        appId: appId, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get an app
  ///@param
  @Get(path: '/v1/apps/{appId}')
  Future<chopper.Response<App>> _v1AppsAppIdGet({
    @Path('appId') required String? appId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update a app
  ///@param
  ///@param App
  Future<chopper.Response<VersionHolder>> v1AppsAppIdPost({
    required String? appId,
    required App? app,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(App, () => App.fromJsonFactory);
    generatedMapping.putIfAbsent(
        VersionHolder, () => VersionHolder.fromJsonFactory);

    return _v1AppsAppIdPost(
        appId: appId,
        app: app,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update a app
  ///@param
  ///@param App
  @Post(path: '/v1/apps/{appId}')
  Future<chopper.Response<VersionHolder>> _v1AppsAppIdPost({
    @Path('appId') required String? appId,
    @Body() required App? app,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a app
  ///@param
  ///@param
  Future<chopper.Response<Object>> v1AppsAppIdDelete({
    required String? appId,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v1AppsAppIdDelete(
        appId: appId,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a app
  ///@param
  ///@param
  @Delete(path: '/v1/apps/{appId}')
  Future<chopper.Response<Object>> _v1AppsAppIdDelete({
    @Path('appId') required String? appId,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Verifies the app's email
  ///@param
  ///@param token Email verification token
  ///@param type Type of email that should resend email verification.
  Future<chopper.Response<Object>> v1AppsAppIdEmailsVerifyPost({
    required String? appId,
    required String? token,
    required String? type,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v1AppsAppIdEmailsVerifyPost(
        appId: appId,
        token: token,
        type: type,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Verifies the app's email
  ///@param
  ///@param token Email verification token
  ///@param type Type of email that should resend email verification.
  @Post(
    path: '/v1/apps/{appId}/emails/verify',
    optionalBody: true,
  )
  Future<chopper.Response<Object>> _v1AppsAppIdEmailsVerifyPost({
    @Path('appId') required String? appId,
    @Query('token') required String? token,
    @Query('type') required String? type,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the config for the current version of the app making the request.
  ///
  ///@param
  Future<chopper.Response<AppConfig>> v1AppsAppIdAppconfigGet({
    required String? appId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(AppConfig, () => AppConfig.fromJsonFactory);

    return _v1AppsAppIdAppconfigGet(
        appId: appId, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get the config for the current version of the app making the request.
  ///
  ///@param
  @Get(path: '/v1/apps/{appId}/appconfig')
  Future<chopper.Response<AppConfig>> _v1AppsAppIdAppconfigGet({
    @Path('appId') required String? appId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get schedule plans
  ///@param
  ///@param
  Future<chopper.Response<SchedulePlanList>> v1AppsAppIdScheduleplansGet({
    required String? appId,
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SchedulePlanList, () => SchedulePlanList.fromJsonFactory);

    return _v1AppsAppIdScheduleplansGet(
        appId: appId,
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get schedule plans
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/scheduleplans')
  Future<chopper.Response<SchedulePlanList>> _v1AppsAppIdScheduleplansGet({
    @Path('appId') required String? appId,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the information on a study that is useful for displaying, selecting, and signing into the study.
  ///@param
  ///@param
  Future<chopper.Response<StudyInfo>> v1AppsAppIdStudiesStudyIdGet({
    required String? appId,
    required String? studyId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(StudyInfo, () => StudyInfo.fromJsonFactory);

    return _v1AppsAppIdStudiesStudyIdGet(
        appId: appId,
        studyId: studyId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the information on a study that is useful for displaying, selecting, and signing into the study.
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/studies/{studyId}')
  Future<chopper.Response<StudyInfo>> _v1AppsAppIdStudiesStudyIdGet({
    @Path('appId') required String? appId,
    @Path('studyId') required String? studyId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the public key CMS block for this app
  Future<chopper.Response<CmsPublicKey>> v1AppsSelfPublicKeyGet({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        CmsPublicKey, () => CmsPublicKey.fromJsonFactory);

    return _v1AppsSelfPublicKeyGet(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get the public key CMS block for this app
  @Get(path: '/v1/apps/self/publicKey')
  Future<chopper.Response<CmsPublicKey>> _v1AppsSelfPublicKeyGet({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///SES email verification status
  Future<chopper.Response<EmailVerificationStatus>> v1AppsSelfEmailStatusGet({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        EmailVerificationStatus, () => EmailVerificationStatus.fromJsonFactory);

    return _v1AppsSelfEmailStatusGet(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///SES email verification status
  @Get(path: '/v1/apps/self/emailStatus')
  Future<chopper.Response<EmailVerificationStatus>> _v1AppsSelfEmailStatusGet({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Resends the verification email for the app's email.
  ///@param type Type of email that should resend email verification.
  Future<chopper.Response<Object>> v1AppsSelfEmailsResendVerifyPost({
    required String? type,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v1AppsSelfEmailsResendVerifyPost(
        type: type, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Resends the verification email for the app's email.
  ///@param type Type of email that should resend email verification.
  @Post(
    path: '/v1/apps/self/emails/resendVerify',
    optionalBody: true,
  )
  Future<chopper.Response<Object>> _v1AppsSelfEmailsResendVerifyPost({
    @Query('type') required String? type,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Initializes configs and Synapse resources for Exporter 3.0.
  Future<chopper.Response<Exporter3Configuration>> v1AppsSelfExporter3Post({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Exporter3Configuration, () => Exporter3Configuration.fromJsonFactory);

    return _v1AppsSelfExporter3Post(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Initializes configs and Synapse resources for Exporter 3.0.
  @Post(
    path: '/v1/apps/self/exporter3',
    optionalBody: true,
  )
  Future<chopper.Response<Exporter3Configuration>> _v1AppsSelfExporter3Post({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Trigger SES email verification process
  Future<chopper.Response<EmailVerificationStatus>> v1AppsSelfVerifyEmailPost({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        EmailVerificationStatus, () => EmailVerificationStatus.fromJsonFactory);

    return _v1AppsSelfVerifyEmailPost(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Trigger SES email verification process
  @Post(
    path: '/v1/apps/self/verifyEmail',
    optionalBody: true,
  )
  Future<chopper.Response<EmailVerificationStatus>> _v1AppsSelfVerifyEmailPost({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get uploads for the app
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<UploadList>> v1AppsSelfUploadsGet({
    required String? startTime,
    required String? endTime,
    int? pageSize,
    String? offsetKey,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(UploadList, () => UploadList.fromJsonFactory);

    return _v1AppsSelfUploadsGet(
        startTime: startTime,
        endTime: endTime,
        pageSize: pageSize,
        offsetKey: offsetKey,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get uploads for the app
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/self/uploads')
  Future<chopper.Response<UploadList>> _v1AppsSelfUploadsGet({
    @Query('startTime') required String? startTime,
    @Query('endTime') required String? endTime,
    @Query('pageSize') int? pageSize,
    @Query('offsetKey') String? offsetKey,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create new Synapse project and team
  ///@param String[] A list of synapse user IDs to add as admins of the created project and access team
  Future<chopper.Response<Object>> v1AppsSelfSynapseProjectPost({
    required List<String>? $String,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v1AppsSelfSynapseProjectPost(
        $String: $String,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create new Synapse project and team
  ///@param String[] A list of synapse user IDs to add as admins of the created project and access team
  @Post(path: '/v1/apps/self/synapseProject')
  Future<chopper.Response<Object>> _v1AppsSelfSynapseProjectPost({
    @Body() required List<String>? $String,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Retrieves all records from the Exporter 3 implemention in the specified app for the given time range.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<HealthDataRecordEx3List>>
      v1AppsAppIdExporter3HealthdataGet({
    required String? appId,
    String? createdOnStart,
    String? createdOnEnd,
    int? pageSize,
    String? offsetKey,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        HealthDataRecordEx3List, () => HealthDataRecordEx3List.fromJsonFactory);

    return _v1AppsAppIdExporter3HealthdataGet(
        appId: appId,
        createdOnStart: createdOnStart,
        createdOnEnd: createdOnEnd,
        pageSize: pageSize,
        offsetKey: offsetKey,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Retrieves all records from the Exporter 3 implemention in the specified app for the given time range.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/exporter3/healthdata')
  Future<chopper.Response<HealthDataRecordEx3List>>
      _v1AppsAppIdExporter3HealthdataGet({
    @Path('appId') required String? appId,
    @Query('createdOnStart') String? createdOnStart,
    @Query('createdOnEnd') String? createdOnEnd,
    @Query('pageSize') int? pageSize,
    @Query('offsetKey') String? offsetKey,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create or update health data record using the Exporter 3 implementation. Returns the created or updated record.
  ///@param
  ///@param HealthDataRecordEx3 Health data record to be created or updated.
  Future<chopper.Response<HealthDataRecordEx3>>
      v1AppsAppIdExporter3HealthdataPost({
    required String? appId,
    required HealthDataRecordEx3? healthDataRecordEx3,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        HealthDataRecordEx3, () => HealthDataRecordEx3.fromJsonFactory);

    return _v1AppsAppIdExporter3HealthdataPost(
        appId: appId,
        healthDataRecordEx3: healthDataRecordEx3,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create or update health data record using the Exporter 3 implementation. Returns the created or updated record.
  ///@param
  ///@param HealthDataRecordEx3 Health data record to be created or updated.
  @Post(path: '/v1/apps/{appId}/exporter3/healthdata')
  Future<chopper.Response<HealthDataRecordEx3>>
      _v1AppsAppIdExporter3HealthdataPost({
    @Path('appId') required String? appId,
    @Body() required HealthDataRecordEx3? healthDataRecordEx3,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Retrieves the record for the given ID from the Exporter 3 implemention.
  ///@param
  ///@param
  Future<chopper.Response<HealthDataRecordEx3>>
      v1AppsAppIdExporter3HealthdataRecordIdGet({
    required String? appId,
    required String? recordId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        HealthDataRecordEx3, () => HealthDataRecordEx3.fromJsonFactory);

    return _v1AppsAppIdExporter3HealthdataRecordIdGet(
        appId: appId,
        recordId: recordId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Retrieves the record for the given ID from the Exporter 3 implemention.
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/exporter3/healthdata/{recordId}')
  Future<chopper.Response<HealthDataRecordEx3>>
      _v1AppsAppIdExporter3HealthdataRecordIdGet({
    @Path('appId') required String? appId,
    @Path('recordId') required String? recordId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the published surveys in an app
  ///@param
  ///@param
  Future<chopper.Response<SurveyList>> v1AppsAppIdSurveysPublishedGet({
    required String? appId,
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(SurveyList, () => SurveyList.fromJsonFactory);

    return _v1AppsAppIdSurveysPublishedGet(
        appId: appId,
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the published surveys in an app
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/surveys/published')
  Future<chopper.Response<SurveyList>> _v1AppsAppIdSurveysPublishedGet({
    @Path('appId') required String? appId,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a schema revision from an app
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<UploadSchema>>
      v1AppsAppIdUploadschemasSchemaIdRevisionsRevisionGet({
    required String? appId,
    required String? schemaId,
    required int? revision,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UploadSchema, () => UploadSchema.fromJsonFactory);

    return _v1AppsAppIdUploadschemasSchemaIdRevisionsRevisionGet(
        appId: appId,
        schemaId: schemaId,
        revision: revision,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a schema revision from an app
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/uploadschemas/{schemaId}/revisions/{revision}')
  Future<chopper.Response<UploadSchema>>
      _v1AppsAppIdUploadschemasSchemaIdRevisionsRevisionGet({
    @Path('appId') required String? appId,
    @Path('schemaId') required String? schemaId,
    @Path('revision') required int? revision,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get public study report records
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ReportDataList>> v1AppsAppIdReportsIdentifierGet({
    required String? appId,
    required String? identifier,
    required String? startDate,
    required String? endDate,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ReportDataList, () => ReportDataList.fromJsonFactory);

    return _v1AppsAppIdReportsIdentifierGet(
        appId: appId,
        identifier: identifier,
        startDate: startDate,
        endDate: endDate,
        cacheControl: cacheControl);
  }

  ///Get public study report records
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/reports/{identifier}')
  Future<chopper.Response<ReportDataList>> _v1AppsAppIdReportsIdentifierGet({
    @Path('appId') required String? appId,
    @Path('identifier') required String? identifier,
    @Query('startDate') required String? startDate,
    @Query('endDate') required String? endDate,
    @Header('Cache-Control') String? cacheControl,
  });

  ///save report for a study
  ///@param
  ///@param
  ///@param ReportData Report data
  Future<chopper.Response<Object>> v1AppsAppIdReportsIdentifierPost({
    required String? appId,
    required String? identifier,
    required ReportData? reportData,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ReportData, () => ReportData.fromJsonFactory);

    return _v1AppsAppIdReportsIdentifierPost(
        appId: appId,
        identifier: identifier,
        reportData: reportData,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///save report for a study
  ///@param
  ///@param
  ///@param ReportData Report data
  @Post(path: '/v1/apps/{appId}/reports/{identifier}')
  Future<chopper.Response<Object>> _v1AppsAppIdReportsIdentifierPost({
    @Path('appId') required String? appId,
    @Path('identifier') required String? identifier,
    @Body() required ReportData? reportData,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get uploads for a specified app
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<UploadList>> v1AppsAppIdUploadsGet({
    required String? appId,
    required String? startTime,
    required String? endTime,
    int? pageSize,
    String? offsetKey,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(UploadList, () => UploadList.fromJsonFactory);

    return _v1AppsAppIdUploadsGet(
        appId: appId,
        startTime: startTime,
        endTime: endTime,
        pageSize: pageSize,
        offsetKey: offsetKey,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get uploads for a specified app
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/uploads')
  Future<chopper.Response<UploadList>> _v1AppsAppIdUploadsGet({
    @Path('appId') required String? appId,
    @Query('startTime') required String? startTime,
    @Query('endTime') required String? endTime,
    @Query('pageSize') int? pageSize,
    @Query('offsetKey') String? offsetKey,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a paged list of study participants for an app
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<AccountSummaryList>> v1AppsAppIdParticipantsGet({
    required String? appId,
    int? offsetBy,
    int? pageSize,
    String? emailFilter,
    String? phoneFilter,
    String? startTime,
    String? endTime,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AccountSummaryList, () => AccountSummaryList.fromJsonFactory);

    return _v1AppsAppIdParticipantsGet(
        appId: appId,
        offsetBy: offsetBy,
        pageSize: pageSize,
        emailFilter: emailFilter,
        phoneFilter: phoneFilter,
        startTime: startTime,
        endTime: endTime,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a paged list of study participants for an app
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/participants')
  Future<chopper.Response<AccountSummaryList>> _v1AppsAppIdParticipantsGet({
    @Path('appId') required String? appId,
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Query('emailFilter') String? emailFilter,
    @Query('phoneFilter') String? phoneFilter,
    @Query('startTime') String? startTime,
    @Query('endTime') String? endTime,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Search for account summaries (participants)
  ///@param
  ///@param AccountSummarySearch Account summary search parameters
  Future<chopper.Response<AccountSummaryList>>
      v1AppsAppIdParticipantsSearchPost({
    required String? appId,
    required AccountSummarySearch? accountSummarySearch,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AccountSummarySearch, () => AccountSummarySearch.fromJsonFactory);
    generatedMapping.putIfAbsent(
        AccountSummaryList, () => AccountSummaryList.fromJsonFactory);

    return _v1AppsAppIdParticipantsSearchPost(
        appId: appId,
        accountSummarySearch: accountSummarySearch,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Search for account summaries (participants)
  ///@param
  ///@param AccountSummarySearch Account summary search parameters
  @Post(path: '/v1/apps/{appId}/participants/search')
  Future<chopper.Response<AccountSummaryList>>
      _v1AppsAppIdParticipantsSearchPost({
    @Path('appId') required String? appId,
    @Body() required AccountSummarySearch? accountSummarySearch,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant (user) record in an app
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<StudyParticipant>> v1AppsAppIdParticipantsUserIdGet({
    required String? appId,
    required String? userId,
    bool? consents,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyParticipant, () => StudyParticipant.fromJsonFactory);

    return _v1AppsAppIdParticipantsUserIdGet(
        appId: appId,
        userId: userId,
        consents: consents,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant (user) record in an app
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/participants/{userId}')
  Future<chopper.Response<StudyParticipant>> _v1AppsAppIdParticipantsUserIdGet({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Query('consents') bool? consents,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant (user) record in an app using the account's health code.
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<StudyParticipant>>
      v1AppsAppIdParticipantsHealthCodeHealthCodeGet({
    required String? appId,
    required String? healthCode,
    bool? consents,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyParticipant, () => StudyParticipant.fromJsonFactory);

    return _v1AppsAppIdParticipantsHealthCodeHealthCodeGet(
        appId: appId,
        healthCode: healthCode,
        consents: consents,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant (user) record in an app using the account's health code.
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/participants/healthCode:{healthCode}')
  Future<chopper.Response<StudyParticipant>>
      _v1AppsAppIdParticipantsHealthCodeHealthCodeGet({
    @Path('appId') required String? appId,
    @Path('healthCode') required String? healthCode,
    @Query('consents') bool? consents,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant (user) record in an app using the account's external ID.
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<StudyParticipant>>
      v1AppsAppIdParticipantsExternalIdExternalIdGet({
    required String? appId,
    required String? externalId,
    bool? consents,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyParticipant, () => StudyParticipant.fromJsonFactory);

    return _v1AppsAppIdParticipantsExternalIdExternalIdGet(
        appId: appId,
        externalId: externalId,
        consents: consents,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant (user) record in an app using the account's external ID.
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/participants/externalId:{externalId}')
  Future<chopper.Response<StudyParticipant>>
      _v1AppsAppIdParticipantsExternalIdExternalIdGet({
    @Path('appId') required String? appId,
    @Path('externalId') required String? externalId,
    @Query('consents') bool? consents,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant (user) record in an app using the account's Synapse user ID.
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<StudyParticipant>>
      v1AppsAppIdParticipantsSynSynapseUserIdGet({
    required String? appId,
    required String? synapseUserId,
    bool? consents,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyParticipant, () => StudyParticipant.fromJsonFactory);

    return _v1AppsAppIdParticipantsSynSynapseUserIdGet(
        appId: appId,
        synapseUserId: synapseUserId,
        consents: consents,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant (user) record in an app using the account's Synapse user ID.
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/participants/syn:{synapseUserId}')
  Future<chopper.Response<StudyParticipant>>
      _v1AppsAppIdParticipantsSynSynapseUserIdGet({
    @Path('appId') required String? appId,
    @Path('synapseUserId') required String? synapseUserId,
    @Query('consents') bool? consents,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Retrieves all records from the Exporter 3 implementation for the given user and time range.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<HealthDataRecordEx3List>>
      v1AppsAppIdParticipantsUserIdExporter3HealthdataGet({
    required String? appId,
    required String? userId,
    String? createdOnStart,
    String? createdOnEnd,
    int? pageSize,
    String? offsetKey,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        HealthDataRecordEx3List, () => HealthDataRecordEx3List.fromJsonFactory);

    return _v1AppsAppIdParticipantsUserIdExporter3HealthdataGet(
        appId: appId,
        userId: userId,
        createdOnStart: createdOnStart,
        createdOnEnd: createdOnEnd,
        pageSize: pageSize,
        offsetKey: offsetKey,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Retrieves all records from the Exporter 3 implementation for the given user and time range.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/participants/{userId}/exporter3/healthdata')
  Future<chopper.Response<HealthDataRecordEx3List>>
      _v1AppsAppIdParticipantsUserIdExporter3HealthdataGet({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Query('createdOnStart') String? createdOnStart,
    @Query('createdOnEnd') String? createdOnEnd,
    @Query('pageSize') int? pageSize,
    @Query('offsetKey') String? offsetKey,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Deletes all health data records from the Exporter 3 implementation for the given user.
  ///@param
  ///@param
  Future<chopper.Response<Object>>
      v1AppsAppIdParticipantsUserIdExporter3HealthdataDelete({
    required String? appId,
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v1AppsAppIdParticipantsUserIdExporter3HealthdataDelete(
        appId: appId,
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Deletes all health data records from the Exporter 3 implementation for the given user.
  ///@param
  ///@param
  @Delete(path: '/v1/apps/{appId}/participants/{userId}/exporter3/healthdata')
  Future<chopper.Response<Object>>
      _v1AppsAppIdParticipantsUserIdExporter3HealthdataDelete({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get participant report records by date.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ReportDataList>>
      v1AppsAppIdParticipantsUserIdReportsReportIdGet({
    required String? appId,
    required String? userId,
    required String? reportId,
    required String? startDate,
    required String? endDate,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ReportDataList, () => ReportDataList.fromJsonFactory);

    return _v1AppsAppIdParticipantsUserIdReportsReportIdGet(
        appId: appId,
        userId: userId,
        reportId: reportId,
        startDate: startDate,
        endDate: endDate,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get participant report records by date.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/participants/{userId}/reports/{reportId}')
  Future<chopper.Response<ReportDataList>>
      _v1AppsAppIdParticipantsUserIdReportsReportIdGet({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Path('reportId') required String? reportId,
    @Query('startDate') required String? startDate,
    @Query('endDate') required String? endDate,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Send an SMS message to a single participant
  ///@param
  ///@param
  ///@param SmsTemplate
  Future<chopper.Response> v1AppsAppIdParticipantsUserIdSendSmsMessagePost({
    required String? appId,
    required String? userId,
    required SmsTemplate? smsTemplate,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SmsTemplate, () => SmsTemplate.fromJsonFactory);

    return _v1AppsAppIdParticipantsUserIdSendSmsMessagePost(
        appId: appId,
        userId: userId,
        smsTemplate: smsTemplate,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Send an SMS message to a single participant
  ///@param
  ///@param
  ///@param SmsTemplate
  @Post(path: '/v1/apps/{appId}/participants/{userId}/sendSmsMessage')
  Future<chopper.Response> _v1AppsAppIdParticipantsUserIdSendSmsMessagePost({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Body() required SmsTemplate? smsTemplate,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get activity event records for participant
  ///@param
  ///@param
  Future<chopper.Response<ActivityEventList>>
      v1AppsAppIdParticipantsUserIdActivityeventsGet({
    required String? appId,
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ActivityEventList, () => ActivityEventList.fromJsonFactory);

    return _v1AppsAppIdParticipantsUserIdActivityeventsGet(
        appId: appId,
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get activity event records for participant
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/participants/{userId}/activityevents')
  Future<chopper.Response<ActivityEventList>>
      _v1AppsAppIdParticipantsUserIdActivityeventsGet({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant's history of activities
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      v1AppsAppIdParticipantsUserIdActivitiesActivityGuidGet({
    required String? appId,
    required String? userId,
    required String? activityGuid,
    String? scheduledOnStart,
    String? scheduledOnEnd,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorScheduledActivityList,
        () => ForwardCursorScheduledActivityList.fromJsonFactory);

    return _v1AppsAppIdParticipantsUserIdActivitiesActivityGuidGet(
        appId: appId,
        userId: userId,
        activityGuid: activityGuid,
        scheduledOnStart: scheduledOnStart,
        scheduledOnEnd: scheduledOnEnd,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant's history of activities
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/participants/{userId}/activities/{activityGuid}')
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      _v1AppsAppIdParticipantsUserIdActivitiesActivityGuidGet({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Path('activityGuid') required String? activityGuid,
    @Query('scheduledOnStart') String? scheduledOnStart,
    @Query('scheduledOnEnd') String? scheduledOnEnd,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant's history of a task
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      v1AppsAppIdParticipantsUserIdActivitiesTasksTaskIdGet({
    required String? appId,
    required String? userId,
    required String? taskId,
    String? scheduledOnStart,
    String? scheduledOnEnd,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorScheduledActivityList,
        () => ForwardCursorScheduledActivityList.fromJsonFactory);

    return _v1AppsAppIdParticipantsUserIdActivitiesTasksTaskIdGet(
        appId: appId,
        userId: userId,
        taskId: taskId,
        scheduledOnStart: scheduledOnStart,
        scheduledOnEnd: scheduledOnEnd,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant's history of a task
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/participants/{userId}/activities/tasks/{taskId}')
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      _v1AppsAppIdParticipantsUserIdActivitiesTasksTaskIdGet({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Path('taskId') required String? taskId,
    @Query('scheduledOnStart') String? scheduledOnStart,
    @Query('scheduledOnEnd') String? scheduledOnEnd,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant's history of a survey
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      v1AppsAppIdParticipantsUserIdActivitiesSurveysSurveyGuidGet({
    required String? appId,
    required String? userId,
    required String? surveyGuid,
    String? scheduledOnStart,
    String? scheduledOnEnd,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorScheduledActivityList,
        () => ForwardCursorScheduledActivityList.fromJsonFactory);

    return _v1AppsAppIdParticipantsUserIdActivitiesSurveysSurveyGuidGet(
        appId: appId,
        userId: userId,
        surveyGuid: surveyGuid,
        scheduledOnStart: scheduledOnStart,
        scheduledOnEnd: scheduledOnEnd,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant's history of a survey
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(
      path:
          '/v1/apps/{appId}/participants/{userId}/activities/surveys/{surveyGuid}')
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      _v1AppsAppIdParticipantsUserIdActivitiesSurveysSurveyGuidGet({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Path('surveyGuid') required String? surveyGuid,
    @Query('scheduledOnStart') String? scheduledOnStart,
    @Query('scheduledOnEnd') String? scheduledOnEnd,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant's history of a compound activity
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      v1AppsAppIdParticipantsUserIdActivitiesCompoundactivitiesTaskIdGet({
    required String? appId,
    required String? userId,
    required String? taskId,
    String? scheduledOnStart,
    String? scheduledOnEnd,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorScheduledActivityList,
        () => ForwardCursorScheduledActivityList.fromJsonFactory);

    return _v1AppsAppIdParticipantsUserIdActivitiesCompoundactivitiesTaskIdGet(
        appId: appId,
        userId: userId,
        taskId: taskId,
        scheduledOnStart: scheduledOnStart,
        scheduledOnEnd: scheduledOnEnd,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant's history of a compound activity
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(
      path:
          '/v1/apps/{appId}/participants/{userId}/activities/compoundactivities/{taskId}')
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      _v1AppsAppIdParticipantsUserIdActivitiesCompoundactivitiesTaskIdGet({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Path('taskId') required String? taskId,
    @Query('scheduledOnStart') String? scheduledOnStart,
    @Query('scheduledOnEnd') String? scheduledOnEnd,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get information about the last request made by this participant
  ///@param
  ///@param
  Future<chopper.Response<RequestInfo>>
      v1AppsAppIdParticipantsUserIdRequestInfoGet({
    required String? appId,
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        RequestInfo, () => RequestInfo.fromJsonFactory);

    return _v1AppsAppIdParticipantsUserIdRequestInfoGet(
        appId: appId,
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get information about the last request made by this participant
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/participants/{userId}/requestInfo')
  Future<chopper.Response<RequestInfo>>
      _v1AppsAppIdParticipantsUserIdRequestInfoGet({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get participant report records by date-time
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorReportDataList>>
      v2AppsAppIdParticipantsUserIdReportsReportIdGet({
    required String? appId,
    required String? userId,
    required String? reportId,
    required String? startTime,
    required String? endTime,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorReportDataList,
        () => ForwardCursorReportDataList.fromJsonFactory);

    return _v2AppsAppIdParticipantsUserIdReportsReportIdGet(
        appId: appId,
        userId: userId,
        reportId: reportId,
        startTime: startTime,
        endTime: endTime,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get participant report records by date-time
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v2/apps/{appId}/participants/{userId}/reports/{reportId}')
  Future<chopper.Response<ForwardCursorReportDataList>>
      _v2AppsAppIdParticipantsUserIdReportsReportIdGet({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Path('reportId') required String? reportId,
    @Query('startTime') required String? startTime,
    @Query('endTime') required String? endTime,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get all participant versions for health code.
  ///@param
  ///@param
  Future<chopper.Response<ParticipantVersionList>>
      v1AppsAppIdParticipantsUserIdVersionsGet({
    required String? appId,
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ParticipantVersionList, () => ParticipantVersionList.fromJsonFactory);

    return _v1AppsAppIdParticipantsUserIdVersionsGet(
        appId: appId,
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get all participant versions for health code.
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/participants/{userId}/versions')
  Future<chopper.Response<ParticipantVersionList>>
      _v1AppsAppIdParticipantsUserIdVersionsGet({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get all participant versions for health code.
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ParticipantVersion>>
      v1AppsAppIdParticipantsUserIdVersionsVersionGet({
    required String? appId,
    required String? userId,
    required int? version,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ParticipantVersion, () => ParticipantVersion.fromJsonFactory);

    return _v1AppsAppIdParticipantsUserIdVersionsVersionGet(
        appId: appId,
        userId: userId,
        version: version,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get all participant versions for health code.
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/participants/{userId}/versions/{version}')
  Future<chopper.Response<ParticipantVersion>>
      _v1AppsAppIdParticipantsUserIdVersionsVersionGet({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Path('version') required int? version,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the health codes of the accounts that have granted OAuth access through
  ///a particular vendor.
  ///
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorStringList>>
      v1AppsAppIdOauthVendorIdGet({
    required String? appId,
    required String? vendorId,
    int? pageSize,
    String? offsetKey,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ForwardCursorStringList, () => ForwardCursorStringList.fromJsonFactory);

    return _v1AppsAppIdOauthVendorIdGet(
        appId: appId,
        vendorId: vendorId,
        pageSize: pageSize,
        offsetKey: offsetKey,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the health codes of the accounts that have granted OAuth access through
  ///a particular vendor.
  ///
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/oauth/{vendorId}')
  Future<chopper.Response<ForwardCursorStringList>>
      _v1AppsAppIdOauthVendorIdGet({
    @Path('appId') required String? appId,
    @Path('vendorId') required String? vendorId,
    @Query('pageSize') int? pageSize,
    @Query('offsetKey') String? offsetKey,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the access grant for a given account as specified by a health code. If
  ///there is no grant, a 404 will be returned.
  ///
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<OAuthAccessToken>>
      v1AppsAppIdOauthVendorIdHealthCodeGet({
    required String? appId,
    required String? vendorId,
    required String? healthCode,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        OAuthAccessToken, () => OAuthAccessToken.fromJsonFactory);

    return _v1AppsAppIdOauthVendorIdHealthCodeGet(
        appId: appId,
        vendorId: vendorId,
        healthCode: healthCode,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the access grant for a given account as specified by a health code. If
  ///there is no grant, a 404 will be returned.
  ///
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/oauth/{vendorId}/{healthCode}')
  Future<chopper.Response<OAuthAccessToken>>
      _v1AppsAppIdOauthVendorIdHealthCodeGet({
    @Path('appId') required String? appId,
    @Path('vendorId') required String? vendorId,
    @Path('healthCode') required String? healthCode,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get list of identifiers for participant data
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorStringList>>
      v1AppsAppIdParticipantsUserIdDataGet({
    required String? appId,
    required String? userId,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ForwardCursorStringList, () => ForwardCursorStringList.fromJsonFactory);

    return _v1AppsAppIdParticipantsUserIdDataGet(
        appId: appId,
        userId: userId,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get list of identifiers for participant data
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/participants/{userId}/data')
  Future<chopper.Response<ForwardCursorStringList>>
      _v1AppsAppIdParticipantsUserIdDataGet({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete all participant data
  ///@param
  ///@param
  Future<chopper.Response<Message>> v1AppsAppIdParticipantsUserIdDataDelete({
    required String? appId,
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v1AppsAppIdParticipantsUserIdDataDelete(
        appId: appId,
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete all participant data
  ///@param
  ///@param
  @Delete(path: '/v1/apps/{appId}/participants/{userId}/data')
  Future<chopper.Response<Message>> _v1AppsAppIdParticipantsUserIdDataDelete({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get participant data by identifier
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ParticipantData>>
      v1AppsAppIdParticipantsUserIdDataIdentifierGet({
    required String? appId,
    required String? userId,
    required String? identifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ParticipantData, () => ParticipantData.fromJsonFactory);

    return _v1AppsAppIdParticipantsUserIdDataIdentifierGet(
        appId: appId,
        userId: userId,
        identifier: identifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get participant data by identifier
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/participants/{userId}/data/{identifier}')
  Future<chopper.Response<ParticipantData>>
      _v1AppsAppIdParticipantsUserIdDataIdentifierGet({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Path('identifier') required String? identifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Save a participant data
  ///@param
  ///@param
  ///@param
  ///@param ParticipantData
  Future<chopper.Response<Message>>
      v1AppsAppIdParticipantsUserIdDataIdentifierPost({
    required String? appId,
    required String? userId,
    required String? identifier,
    required ParticipantData? participantData,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ParticipantData, () => ParticipantData.fromJsonFactory);
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v1AppsAppIdParticipantsUserIdDataIdentifierPost(
        appId: appId,
        userId: userId,
        identifier: identifier,
        participantData: participantData,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Save a participant data
  ///@param
  ///@param
  ///@param
  ///@param ParticipantData
  @Post(path: '/v1/apps/{appId}/participants/{userId}/data/{identifier}')
  Future<chopper.Response<Message>>
      _v1AppsAppIdParticipantsUserIdDataIdentifierPost({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Path('identifier') required String? identifier,
    @Body() required ParticipantData? participantData,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a participant data
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<Message>>
      v1AppsAppIdParticipantsUserIdDataIdentifierDelete({
    required String? appId,
    required String? userId,
    required String? identifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v1AppsAppIdParticipantsUserIdDataIdentifierDelete(
        appId: appId,
        userId: userId,
        identifier: identifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a participant data
  ///@param
  ///@param
  ///@param
  @Delete(path: '/v1/apps/{appId}/participants/{userId}/data/{identifier}')
  Future<chopper.Response<Message>>
      _v1AppsAppIdParticipantsUserIdDataIdentifierDelete({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Path('identifier') required String? identifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the studies that are sponsored by the organization
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<StudyList>> v1AppsAppIdOrganizationsOrgIdStudiesGet({
    required String? appId,
    required String? orgId,
    int? offsetBy,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(StudyList, () => StudyList.fromJsonFactory);

    return _v1AppsAppIdOrganizationsOrgIdStudiesGet(
        appId: appId,
        orgId: orgId,
        offsetBy: offsetBy,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the studies that are sponsored by the organization
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/organizations/{orgId}/studies')
  Future<chopper.Response<StudyList>> _v1AppsAppIdOrganizationsOrgIdStudiesGet({
    @Path('appId') required String? appId,
    @Path('orgId') required String? orgId,
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Retrieves all records from the Exporter 3 implementation in the given app and study and time range.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<HealthDataRecordEx3List>>
      v1AppsAppIdStudiesStudyIdExporter3HealthdataGet({
    required String? appId,
    required String? studyId,
    String? createdOnStart,
    String? createdOnEnd,
    int? pageSize,
    String? offsetKey,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        HealthDataRecordEx3List, () => HealthDataRecordEx3List.fromJsonFactory);

    return _v1AppsAppIdStudiesStudyIdExporter3HealthdataGet(
        appId: appId,
        studyId: studyId,
        createdOnStart: createdOnStart,
        createdOnEnd: createdOnEnd,
        pageSize: pageSize,
        offsetKey: offsetKey,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Retrieves all records from the Exporter 3 implementation in the given app and study and time range.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/apps/{appId}/studies/{studyId}/exporter3/healthdata')
  Future<chopper.Response<HealthDataRecordEx3List>>
      _v1AppsAppIdStudiesStudyIdExporter3HealthdataGet({
    @Path('appId') required String? appId,
    @Path('studyId') required String? studyId,
    @Query('createdOnStart') String? createdOnStart,
    @Query('createdOnEnd') String? createdOnEnd,
    @Query('pageSize') int? pageSize,
    @Query('offsetKey') String? offsetKey,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get assessments in the app context.
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<AssessmentList>> v1AssessmentsGet({
    int? offsetBy,
    int? pageSize,
    List<String>? tag,
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AssessmentList, () => AssessmentList.fromJsonFactory);

    return _v1AssessmentsGet(
        offsetBy: offsetBy,
        pageSize: pageSize,
        tag: tag,
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get assessments in the app context.
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/assessments')
  Future<chopper.Response<AssessmentList>> _v1AssessmentsGet({
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Query('tag') List<String>? tag,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new assessment.
  ///@param Assessment
  Future<chopper.Response<Assessment>> v1AssessmentsPost({
    required Assessment? assessment,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Assessment, () => Assessment.fromJsonFactory);

    return _v1AssessmentsPost(
        assessment: assessment,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new assessment.
  ///@param Assessment
  @Post(path: '/v1/assessments')
  Future<chopper.Response<Assessment>> _v1AssessmentsPost({
    @Body() required Assessment? assessment,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a specific assessment revision.
  ///@param
  Future<chopper.Response<Assessment>> v1AssessmentsGuidGet({
    required String? guid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Assessment, () => Assessment.fromJsonFactory);

    return _v1AssessmentsGuidGet(
        guid: guid, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get a specific assessment revision.
  ///@param
  @Get(path: '/v1/assessments/{guid}')
  Future<chopper.Response<Assessment>> _v1AssessmentsGuidGet({
    @Path('guid') required String? guid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update an assessment revision.
  ///@param
  ///@param Assessment Updated assessment
  Future<chopper.Response<Assessment>> v1AssessmentsGuidPost({
    required String? guid,
    required Assessment? assessment,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Assessment, () => Assessment.fromJsonFactory);

    return _v1AssessmentsGuidPost(
        guid: guid,
        assessment: assessment,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update an assessment revision.
  ///@param
  ///@param Assessment Updated assessment
  @Post(path: '/v1/assessments/{guid}')
  Future<chopper.Response<Assessment>> _v1AssessmentsGuidPost({
    @Path('guid') required String? guid,
    @Body() required Assessment? assessment,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete an assessment revision.
  ///@param
  ///@param
  Future<chopper.Response<Message>> v1AssessmentsGuidDelete({
    required String? guid,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v1AssessmentsGuidDelete(
        guid: guid,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete an assessment revision.
  ///@param
  ///@param
  @Delete(path: '/v1/assessments/{guid}')
  Future<chopper.Response<Message>> _v1AssessmentsGuidDelete({
    @Path('guid') required String? guid,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the JSON config for this assessment.
  ///@param
  Future<chopper.Response<AssessmentConfig>> v1AssessmentsGuidConfigGet({
    required String? guid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AssessmentConfig, () => AssessmentConfig.fromJsonFactory);

    return _v1AssessmentsGuidConfigGet(
        guid: guid, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get the JSON config for this assessment.
  ///@param
  @Get(path: '/v1/assessments/{guid}/config')
  Future<chopper.Response<AssessmentConfig>> _v1AssessmentsGuidConfigGet({
    @Path('guid') required String? guid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update the JSON config for this assessment.
  ///@param
  ///@param AssessmentConfig
  Future<chopper.Response<AssessmentConfig>> v1AssessmentsGuidConfigPost({
    required String? guid,
    required AssessmentConfig? assessmentConfig,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AssessmentConfig, () => AssessmentConfig.fromJsonFactory);

    return _v1AssessmentsGuidConfigPost(
        guid: guid,
        assessmentConfig: assessmentConfig,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update the JSON config for this assessment.
  ///@param
  ///@param AssessmentConfig
  @Post(path: '/v1/assessments/{guid}/config')
  Future<chopper.Response<AssessmentConfig>> _v1AssessmentsGuidConfigPost({
    @Path('guid') required String? guid,
    @Body() required AssessmentConfig? assessmentConfig,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Submit updates to the config that conform to the allowed customizations for the assessment.
  ///@param
  ///@param Customization update
  Future<chopper.Response<AssessmentConfig>>
      v1AssessmentsGuidConfigCustomizePost({
    required String? guid,
    required Object? customizationUpdate,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AssessmentConfig, () => AssessmentConfig.fromJsonFactory);

    return _v1AssessmentsGuidConfigCustomizePost(
        guid: guid,
        customizationUpdate: customizationUpdate,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Submit updates to the config that conform to the allowed customizations for the assessment.
  ///@param
  ///@param Customization update
  @Post(path: '/v1/assessments/{guid}/config/customize')
  Future<chopper.Response<AssessmentConfig>>
      _v1AssessmentsGuidConfigCustomizePost({
    @Path('guid') required String? guid,
    @Body() required Object? customizationUpdate,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Publish an assessment revision in the shared library.
  ///@param
  ///@param newIdentifier Upon publishing this assessment, you can provide a new identifier for the assessment.
  Future<chopper.Response<Assessment>> v1AssessmentsGuidPublishPost({
    required String? guid,
    String? newIdentifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Assessment, () => Assessment.fromJsonFactory);

    return _v1AssessmentsGuidPublishPost(
        guid: guid,
        newIdentifier: newIdentifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Publish an assessment revision in the shared library.
  ///@param
  ///@param newIdentifier Upon publishing this assessment, you can provide a new identifier for the assessment.
  @Post(
    path: '/v1/assessments/{guid}/publish',
    optionalBody: true,
  )
  Future<chopper.Response<Assessment>> _v1AssessmentsGuidPublishPost({
    @Path('guid') required String? guid,
    @Query('newIdentifier') String? newIdentifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the revisions of an assessment with a specific identifier.
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<AssessmentList>> v1AssessmentsGuidRevisionsGet({
    required String? guid,
    int? offsetBy,
    int? pageSize,
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AssessmentList, () => AssessmentList.fromJsonFactory);

    return _v1AssessmentsGuidRevisionsGet(
        guid: guid,
        offsetBy: offsetBy,
        pageSize: pageSize,
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the revisions of an assessment with a specific identifier.
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/assessments/{guid}/revisions')
  Future<chopper.Response<AssessmentList>> _v1AssessmentsGuidRevisionsGet({
    @Path('guid') required String? guid,
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new revision of an assessment.
  ///@param
  ///@param Assessment
  Future<chopper.Response<Assessment>> v1AssessmentsGuidRevisionsPost({
    required String? guid,
    required Assessment? assessment,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Assessment, () => Assessment.fromJsonFactory);

    return _v1AssessmentsGuidRevisionsPost(
        guid: guid,
        assessment: assessment,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new revision of an assessment.
  ///@param
  ///@param Assessment
  @Post(path: '/v1/assessments/{guid}/revisions')
  Future<chopper.Response<Assessment>> _v1AssessmentsGuidRevisionsPost({
    @Path('guid') required String? guid,
    @Body() required Assessment? assessment,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the latest version of an assessment.
  ///@param
  Future<chopper.Response<Assessment>> v1AssessmentsIdentifierIdentifierGet({
    required String? identifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Assessment, () => Assessment.fromJsonFactory);

    return _v1AssessmentsIdentifierIdentifierGet(
        identifier: identifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the latest version of an assessment.
  ///@param
  @Get(path: '/v1/assessments/identifier:{identifier}')
  Future<chopper.Response<Assessment>> _v1AssessmentsIdentifierIdentifierGet({
    @Path('identifier') required String? identifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the revisions for an assessment by its identifier.
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<AssessmentList>>
      v1AssessmentsIdentifierIdentifierRevisionsGet({
    required String? identifier,
    int? offsetBy,
    int? pageSize,
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AssessmentList, () => AssessmentList.fromJsonFactory);

    return _v1AssessmentsIdentifierIdentifierRevisionsGet(
        identifier: identifier,
        offsetBy: offsetBy,
        pageSize: pageSize,
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the revisions for an assessment by its identifier.
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/assessments/identifier:{identifier}/revisions')
  Future<chopper.Response<AssessmentList>>
      _v1AssessmentsIdentifierIdentifierRevisionsGet({
    @Path('identifier') required String? identifier,
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an assessment revision by identifier and revision number.
  ///@param
  ///@param
  Future<chopper.Response<Assessment>>
      v1AssessmentsIdentifierIdentifierRevisionsRevisionGet({
    required String? identifier,
    required int? revision,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Assessment, () => Assessment.fromJsonFactory);

    return _v1AssessmentsIdentifierIdentifierRevisionsRevisionGet(
        identifier: identifier,
        revision: revision,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get an assessment revision by identifier and revision number.
  ///@param
  ///@param
  @Get(path: '/v1/assessments/identifier:{identifier}/revisions/{revision}')
  Future<chopper.Response<Assessment>>
      _v1AssessmentsIdentifierIdentifierRevisionsRevisionGet({
    @Path('identifier') required String? identifier,
    @Path('revision') required int? revision,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the external resource links documenting an assessment
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<PagedExternalResourceList>>
      v1AssessmentsIdentifierAssessmentIdResourcesGet({
    required String? assessmentId,
    int? offsetBy,
    int? pageSize,
    enums.Category? category,
    int? minRevision,
    int? maxRevision,
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(PagedExternalResourceList,
        () => PagedExternalResourceList.fromJsonFactory);

    return _v1AssessmentsIdentifierAssessmentIdResourcesGet(
        assessmentId: assessmentId,
        offsetBy: offsetBy,
        pageSize: pageSize,
        category: enums.$CategoryMap[category]?.toString(),
        minRevision: minRevision,
        maxRevision: maxRevision,
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the external resource links documenting an assessment
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/assessments/identifier:{assessmentId}/resources')
  Future<chopper.Response<PagedExternalResourceList>>
      _v1AssessmentsIdentifierAssessmentIdResourcesGet({
    @Path('assessmentId') required String? assessmentId,
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Query('category') String? category,
    @Query('minRevision') int? minRevision,
    @Query('maxRevision') int? maxRevision,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new external resource link documenting an assessment
  ///@param
  ///@param ExternalResource Assessment resource
  Future<chopper.Response<ExternalResource>>
      v1AssessmentsIdentifierAssessmentIdResourcesPost({
    required String? assessmentId,
    required ExternalResource? externalResource,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ExternalResource, () => ExternalResource.fromJsonFactory);

    return _v1AssessmentsIdentifierAssessmentIdResourcesPost(
        assessmentId: assessmentId,
        externalResource: externalResource,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new external resource link documenting an assessment
  ///@param
  ///@param ExternalResource Assessment resource
  @Post(path: '/v1/assessments/identifier:{assessmentId}/resources')
  Future<chopper.Response<ExternalResource>>
      _v1AssessmentsIdentifierAssessmentIdResourcesPost({
    @Path('assessmentId') required String? assessmentId,
    @Body() required ExternalResource? externalResource,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an assessment external resource description
  ///@param
  ///@param
  Future<chopper.Response<ExternalResource>>
      v1AssessmentsIdentifierAssessmentIdResourcesGuidGet({
    required String? assessmentId,
    required String? guid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ExternalResource, () => ExternalResource.fromJsonFactory);

    return _v1AssessmentsIdentifierAssessmentIdResourcesGuidGet(
        assessmentId: assessmentId,
        guid: guid,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get an assessment external resource description
  ///@param
  ///@param
  @Get(path: '/v1/assessments/identifier:{assessmentId}/resources/{guid}')
  Future<chopper.Response<ExternalResource>>
      _v1AssessmentsIdentifierAssessmentIdResourcesGuidGet({
    @Path('assessmentId') required String? assessmentId,
    @Path('guid') required String? guid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update an external resource link documenting an assessment
  ///@param
  ///@param
  ///@param ExternalResource Assessment resource
  Future<chopper.Response<ExternalResource>>
      v1AssessmentsIdentifierAssessmentIdResourcesGuidPost({
    required String? assessmentId,
    required String? guid,
    required ExternalResource? externalResource,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ExternalResource, () => ExternalResource.fromJsonFactory);

    return _v1AssessmentsIdentifierAssessmentIdResourcesGuidPost(
        assessmentId: assessmentId,
        guid: guid,
        externalResource: externalResource,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update an external resource link documenting an assessment
  ///@param
  ///@param
  ///@param ExternalResource Assessment resource
  @Post(path: '/v1/assessments/identifier:{assessmentId}/resources/{guid}')
  Future<chopper.Response<ExternalResource>>
      _v1AssessmentsIdentifierAssessmentIdResourcesGuidPost({
    @Path('assessmentId') required String? assessmentId,
    @Path('guid') required String? guid,
    @Body() required ExternalResource? externalResource,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete an external resource link documenting an assessment
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<Message>>
      v1AssessmentsIdentifierAssessmentIdResourcesGuidDelete({
    required String? assessmentId,
    required String? guid,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v1AssessmentsIdentifierAssessmentIdResourcesGuidDelete(
        assessmentId: assessmentId,
        guid: guid,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete an external resource link documenting an assessment
  ///@param
  ///@param
  ///@param
  @Delete(path: '/v1/assessments/identifier:{assessmentId}/resources/{guid}')
  Future<chopper.Response<Message>>
      _v1AssessmentsIdentifierAssessmentIdResourcesGuidDelete({
    @Path('assessmentId') required String? assessmentId,
    @Path('guid') required String? guid,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Copy these resources to the shared assessments library.
  ///@param
  ///@param External resource GUIDs List of external resource GUIDs
  Future<chopper.Response<ExternalResourceList>>
      v1AssessmentsIdentifierAssessmentIdResourcesPublishPost({
    required String? assessmentId,
    required List<String>? externalResourceGUIDs,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ExternalResourceList, () => ExternalResourceList.fromJsonFactory);

    return _v1AssessmentsIdentifierAssessmentIdResourcesPublishPost(
        assessmentId: assessmentId,
        externalResourceGUIDs: externalResourceGUIDs,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Copy these resources to the shared assessments library.
  ///@param
  ///@param External resource GUIDs List of external resource GUIDs
  @Post(path: '/v1/assessments/identifier:{assessmentId}/resources/publish')
  Future<chopper.Response<ExternalResourceList>>
      _v1AssessmentsIdentifierAssessmentIdResourcesPublishPost({
    @Path('assessmentId') required String? assessmentId,
    @Body() required List<String>? externalResourceGUIDs,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get assessments in the shared library.
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<AssessmentList>> v1SharedassessmentsGet({
    int? offsetBy,
    int? pageSize,
    List<String>? tag,
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AssessmentList, () => AssessmentList.fromJsonFactory);

    return _v1SharedassessmentsGet(
        offsetBy: offsetBy,
        pageSize: pageSize,
        tag: tag,
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get assessments in the shared library.
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/sharedassessments')
  Future<chopper.Response<AssessmentList>> _v1SharedassessmentsGet({
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Query('tag') List<String>? tag,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an assessment revision.
  ///@param
  Future<chopper.Response<Assessment>> v1SharedassessmentsGuidGet({
    required String? guid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Assessment, () => Assessment.fromJsonFactory);

    return _v1SharedassessmentsGuidGet(
        guid: guid, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get an assessment revision.
  ///@param
  @Get(path: '/v1/sharedassessments/{guid}')
  Future<chopper.Response<Assessment>> _v1SharedassessmentsGuidGet({
    @Path('guid') required String? guid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update an assessment revision.
  ///@param
  ///@param Assessment Updated assessment
  Future<chopper.Response<Assessment>> v1SharedassessmentsGuidPost({
    required String? guid,
    required Assessment? assessment,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Assessment, () => Assessment.fromJsonFactory);

    return _v1SharedassessmentsGuidPost(
        guid: guid,
        assessment: assessment,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update an assessment revision.
  ///@param
  ///@param Assessment Updated assessment
  @Post(path: '/v1/sharedassessments/{guid}')
  Future<chopper.Response<Assessment>> _v1SharedassessmentsGuidPost({
    @Path('guid') required String? guid,
    @Body() required Assessment? assessment,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete an assessment revision.
  ///@param
  ///@param
  Future<chopper.Response<Message>> v1SharedassessmentsGuidDelete({
    required String? guid,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v1SharedassessmentsGuidDelete(
        guid: guid,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete an assessment revision.
  ///@param
  ///@param
  @Delete(path: '/v1/sharedassessments/{guid}')
  Future<chopper.Response<Message>> _v1SharedassessmentsGuidDelete({
    @Path('guid') required String? guid,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the configuration JSON for a shared assessmentapp context.
  ///@param
  Future<chopper.Response<AssessmentConfig>> v1SharedassessmentsGuidConfigGet({
    required String? guid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AssessmentConfig, () => AssessmentConfig.fromJsonFactory);

    return _v1SharedassessmentsGuidConfigGet(
        guid: guid, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get the configuration JSON for a shared assessmentapp context.
  ///@param
  @Get(path: '/v1/sharedassessments/{guid}/config')
  Future<chopper.Response<AssessmentConfig>> _v1SharedassessmentsGuidConfigGet({
    @Path('guid') required String? guid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Import an assessment revision into the local app context.
  ///@param
  ///@param ownerId The organizational ID the assessment should be imported under as the owning organization of the assessment (only members of that organization will be able to edit the assessment, though all users in an app context can see and schedule the assessment).
  ///@param newIdentifier Upon importing this assessment, you can provide a new identifier for the assessment.
  Future<chopper.Response<Assessment>> v1SharedassessmentsGuidImportPost({
    required String? guid,
    required String? ownerId,
    String? newIdentifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Assessment, () => Assessment.fromJsonFactory);

    return _v1SharedassessmentsGuidImportPost(
        guid: guid,
        ownerId: ownerId,
        newIdentifier: newIdentifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Import an assessment revision into the local app context.
  ///@param
  ///@param ownerId The organizational ID the assessment should be imported under as the owning organization of the assessment (only members of that organization will be able to edit the assessment, though all users in an app context can see and schedule the assessment).
  ///@param newIdentifier Upon importing this assessment, you can provide a new identifier for the assessment.
  @Post(
    path: '/v1/sharedassessments/{guid}/import',
    optionalBody: true,
  )
  Future<chopper.Response<Assessment>> _v1SharedassessmentsGuidImportPost({
    @Path('guid') required String? guid,
    @Query('ownerId') required String? ownerId,
    @Query('newIdentifier') String? newIdentifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get all revisions of an assessment using the GUID of one of the revisions.
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<AssessmentList>> v1SharedassessmentsGuidRevisionsGet({
    required String? guid,
    int? offsetBy,
    int? pageSize,
    bool? includeDeleted,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AssessmentList, () => AssessmentList.fromJsonFactory);

    return _v1SharedassessmentsGuidRevisionsGet(
        guid: guid,
        offsetBy: offsetBy,
        pageSize: pageSize,
        includeDeleted: includeDeleted,
        cacheControl: cacheControl);
  }

  ///Get all revisions of an assessment using the GUID of one of the revisions.
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/sharedassessments/{guid}/revisions')
  Future<chopper.Response<AssessmentList>>
      _v1SharedassessmentsGuidRevisionsGet({
    @Path('guid') required String? guid,
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an assessment revision with the greatest revision number, using the assessment's identifier.
  ///@param
  Future<chopper.Response<Assessment>>
      v1SharedassessmentsIdentifierIdentifierGet({
    required String? identifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Assessment, () => Assessment.fromJsonFactory);

    return _v1SharedassessmentsIdentifierIdentifierGet(
        identifier: identifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get an assessment revision with the greatest revision number, using the assessment's identifier.
  ///@param
  @Get(path: '/v1/sharedassessments/identifier:{identifier}')
  Future<chopper.Response<Assessment>>
      _v1SharedassessmentsIdentifierIdentifierGet({
    @Path('identifier') required String? identifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get all revisions of an assessment with a specific identifier.
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<AssessmentList>>
      v1SharedassessmentsIdentifierIdentifierRevisionsGet({
    required String? identifier,
    int? offsetBy,
    int? pageSize,
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AssessmentList, () => AssessmentList.fromJsonFactory);

    return _v1SharedassessmentsIdentifierIdentifierRevisionsGet(
        identifier: identifier,
        offsetBy: offsetBy,
        pageSize: pageSize,
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get all revisions of an assessment with a specific identifier.
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/sharedassessments/identifier:{identifier}/revisions')
  Future<chopper.Response<AssessmentList>>
      _v1SharedassessmentsIdentifierIdentifierRevisionsGet({
    @Path('identifier') required String? identifier,
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an assessment revision by identifier and revision number.
  ///@param
  ///@param
  Future<chopper.Response<Assessment>>
      v1SharedassessmentsIdentifierIdentifierRevisionsRevisionGet({
    required String? identifier,
    required int? revision,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Assessment, () => Assessment.fromJsonFactory);

    return _v1SharedassessmentsIdentifierIdentifierRevisionsRevisionGet(
        identifier: identifier,
        revision: revision,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get an assessment revision by identifier and revision number.
  ///@param
  ///@param
  @Get(
      path:
          '/v1/sharedassessments/identifier:{identifier}/revisions/{revision}')
  Future<chopper.Response<Assessment>>
      _v1SharedassessmentsIdentifierIdentifierRevisionsRevisionGet({
    @Path('identifier') required String? identifier,
    @Path('revision') required int? revision,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the external resource links documenting an assessment
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<PagedExternalResourceList>>
      v1SharedassessmentsIdentifierAssessmentIdResourcesGet({
    required String? assessmentId,
    int? offsetBy,
    int? pageSize,
    enums.Category? category,
    int? minRevision,
    int? maxRevision,
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(PagedExternalResourceList,
        () => PagedExternalResourceList.fromJsonFactory);

    return _v1SharedassessmentsIdentifierAssessmentIdResourcesGet(
        assessmentId: assessmentId,
        offsetBy: offsetBy,
        pageSize: pageSize,
        category: enums.$CategoryMap[category]?.toString(),
        minRevision: minRevision,
        maxRevision: maxRevision,
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the external resource links documenting an assessment
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/sharedassessments/identifier:{assessmentId}/resources')
  Future<chopper.Response<PagedExternalResourceList>>
      _v1SharedassessmentsIdentifierAssessmentIdResourcesGet({
    @Path('assessmentId') required String? assessmentId,
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Query('category') String? category,
    @Query('minRevision') int? minRevision,
    @Query('maxRevision') int? maxRevision,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a external resource link documenting a shared assessment
  ///@param
  ///@param
  Future<chopper.Response<ExternalResource>>
      v1SharedassessmentsIdentifierAssessmentIdResourcesGuidGet({
    required String? assessmentId,
    required String? guid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ExternalResource, () => ExternalResource.fromJsonFactory);

    return _v1SharedassessmentsIdentifierAssessmentIdResourcesGuidGet(
        assessmentId: assessmentId,
        guid: guid,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a external resource link documenting a shared assessment
  ///@param
  ///@param
  @Get(path: '/v1/sharedassessments/identifier:{assessmentId}/resources/{guid}')
  Future<chopper.Response<ExternalResource>>
      _v1SharedassessmentsIdentifierAssessmentIdResourcesGuidGet({
    @Path('assessmentId') required String? assessmentId,
    @Path('guid') required String? guid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update an external resource link documenting a shared assessment
  ///@param
  ///@param
  ///@param ExternalResource Assessment resource
  Future<chopper.Response<ExternalResource>>
      v1SharedassessmentsIdentifierAssessmentIdResourcesGuidPost({
    required String? assessmentId,
    required String? guid,
    required ExternalResource? externalResource,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ExternalResource, () => ExternalResource.fromJsonFactory);

    return _v1SharedassessmentsIdentifierAssessmentIdResourcesGuidPost(
        assessmentId: assessmentId,
        guid: guid,
        externalResource: externalResource,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update an external resource link documenting a shared assessment
  ///@param
  ///@param
  ///@param ExternalResource Assessment resource
  @Post(
      path: '/v1/sharedassessments/identifier:{assessmentId}/resources/{guid}')
  Future<chopper.Response<ExternalResource>>
      _v1SharedassessmentsIdentifierAssessmentIdResourcesGuidPost({
    @Path('assessmentId') required String? assessmentId,
    @Path('guid') required String? guid,
    @Body() required ExternalResource? externalResource,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete an external resource link documenting a shared assessment
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<Message>>
      v1SharedassessmentsIdentifierAssessmentIdResourcesGuidDelete({
    required String? assessmentId,
    required String? guid,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v1SharedassessmentsIdentifierAssessmentIdResourcesGuidDelete(
        assessmentId: assessmentId,
        guid: guid,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete an external resource link documenting a shared assessment
  ///@param
  ///@param
  ///@param
  @Delete(
      path: '/v1/sharedassessments/identifier:{assessmentId}/resources/{guid}')
  Future<chopper.Response<Message>>
      _v1SharedassessmentsIdentifierAssessmentIdResourcesGuidDelete({
    @Path('assessmentId') required String? assessmentId,
    @Path('guid') required String? guid,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Copy these shared resources to your app context
  ///@param
  ///@param External resource GUIDs List of external resource GUIDs
  Future<chopper.Response<ExternalResourceList>>
      v1SharedassessmentsIdentifierAssessmentIdResourcesImportPost({
    required String? assessmentId,
    required List<String>? externalResourceGUIDs,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ExternalResourceList, () => ExternalResourceList.fromJsonFactory);

    return _v1SharedassessmentsIdentifierAssessmentIdResourcesImportPost(
        assessmentId: assessmentId,
        externalResourceGUIDs: externalResourceGUIDs,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Copy these shared resources to your app context
  ///@param
  ///@param External resource GUIDs List of external resource GUIDs
  @Post(
      path: '/v1/sharedassessments/identifier:{assessmentId}/resources/import')
  Future<chopper.Response<ExternalResourceList>>
      _v1SharedassessmentsIdentifierAssessmentIdResourcesImportPost({
    @Path('assessmentId') required String? assessmentId,
    @Body() required List<String>? externalResourceGUIDs,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get all tags, grouped into lists under their namespace prefixes (if a tag is created without a namespace prefix, it will be listed in the "default" group here).
  Future<chopper.Response<Object>> v1TagsGet({
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v1TagsGet(bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get all tags, grouped into lists under their namespace prefixes (if a tag is created without a namespace prefix, it will be listed in the "default" group here).
  @Get(path: '/v1/tags')
  Future<chopper.Response<Object>> _v1TagsGet({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a tag if it does not yet exist.
  ///@param Tag New tag
  Future<chopper.Response<Object>> v1TagsPost({
    required Object? tag,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v1TagsPost(
        tag: tag, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Create a tag if it does not yet exist.
  ///@param Tag New tag
  @Post(path: '/v1/tags')
  Future<chopper.Response<Object>> _v1TagsPost({
    @Body() required Object? tag,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a tag
  ///@param
  Future<chopper.Response<Message>> v1TagsTagValueDelete({
    required String? tagValue,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v1TagsTagValueDelete(
        tagValue: tagValue,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a tag
  ///@param
  @Delete(path: '/v1/tags/{tagValue}')
  Future<chopper.Response<Message>> _v1TagsTagValueDelete({
    @Path('tagValue') required String? tagValue,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a list of static files
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<FileMetadataList>> v3FilesGet({
    int? offsetBy,
    int? pageSize,
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FileMetadataList, () => FileMetadataList.fromJsonFactory);

    return _v3FilesGet(
        offsetBy: offsetBy,
        pageSize: pageSize,
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a list of static files
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/files')
  Future<chopper.Response<FileMetadataList>> _v3FilesGet({
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new file resource
  ///@param FileMetadata New file
  Future<chopper.Response<GuidVersionHolder>> v3FilesPost({
    required FileMetadata? fileMetadata,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FileMetadata, () => FileMetadata.fromJsonFactory);
    generatedMapping.putIfAbsent(
        GuidVersionHolder, () => GuidVersionHolder.fromJsonFactory);

    return _v3FilesPost(
        fileMetadata: fileMetadata,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new file resource
  ///@param FileMetadata New file
  @Post(path: '/v3/files')
  Future<chopper.Response<GuidVersionHolder>> _v3FilesPost({
    @Body() required FileMetadata? fileMetadata,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a file resource
  ///@param
  Future<chopper.Response<FileMetadata>> v3FilesGuidGet({
    required String? guid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FileMetadata, () => FileMetadata.fromJsonFactory);

    return _v3FilesGuidGet(
        guid: guid, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get a file resource
  ///@param
  @Get(path: '/v3/files/{guid}')
  Future<chopper.Response<FileMetadata>> _v3FilesGuidGet({
    @Path('guid') required String? guid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update an existing file resource
  ///@param
  ///@param File Updated file
  Future<chopper.Response<GuidVersionHolder>> v3FilesGuidPost({
    required String? guid,
    required FileMetadata? file,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FileMetadata, () => FileMetadata.fromJsonFactory);
    generatedMapping.putIfAbsent(
        GuidVersionHolder, () => GuidVersionHolder.fromJsonFactory);

    return _v3FilesGuidPost(
        guid: guid,
        file: file,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update an existing file resource
  ///@param
  ///@param File Updated file
  @Post(path: '/v3/files/{guid}')
  Future<chopper.Response<GuidVersionHolder>> _v3FilesGuidPost({
    @Path('guid') required String? guid,
    @Body() required FileMetadata? file,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete file resource (and all revisions)
  ///@param
  ///@param
  Future<chopper.Response<Message>> v3FilesGuidDelete({
    required String? guid,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v3FilesGuidDelete(
        guid: guid,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete file resource (and all revisions)
  ///@param
  ///@param
  @Delete(path: '/v3/files/{guid}')
  Future<chopper.Response<Message>> _v3FilesGuidDelete({
    @Path('guid') required String? guid,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the revision history of a file resource
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<FileRevisionList>> v3FilesGuidRevisionsGet({
    required String? guid,
    int? offsetBy,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FileRevisionList, () => FileRevisionList.fromJsonFactory);

    return _v3FilesGuidRevisionsGet(
        guid: guid,
        offsetBy: offsetBy,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the revision history of a file resource
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/files/{guid}/revisions')
  Future<chopper.Response<FileRevisionList>> _v3FilesGuidRevisionsGet({
    @Path('guid') required String? guid,
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new file resource revision.
  ///@param
  ///@param FileRevision New file revision
  Future<chopper.Response<FileRevision>> v3FilesGuidRevisionsPost({
    required String? guid,
    required FileRevision? fileRevision,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FileRevision, () => FileRevision.fromJsonFactory);

    return _v3FilesGuidRevisionsPost(
        guid: guid,
        fileRevision: fileRevision,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new file resource revision.
  ///@param
  ///@param FileRevision New file revision
  @Post(path: '/v3/files/{guid}/revisions')
  Future<chopper.Response<FileRevision>> _v3FilesGuidRevisionsPost({
    @Path('guid') required String? guid,
    @Body() required FileRevision? fileRevision,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a single file revision of a file.
  ///@param
  ///@param
  Future<chopper.Response<FileRevision>> v3FilesGuidRevisionsCreatedOnGet({
    required String? guid,
    required String? createdOn,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FileRevision, () => FileRevision.fromJsonFactory);

    return _v3FilesGuidRevisionsCreatedOnGet(
        guid: guid,
        createdOn: createdOn,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a single file revision of a file.
  ///@param
  ///@param
  @Get(path: '/v3/files/{guid}/revisions/{createdOn}')
  Future<chopper.Response<FileRevision>> _v3FilesGuidRevisionsCreatedOnGet({
    @Path('guid') required String? guid,
    @Path('createdOn') required String? createdOn,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Indicate to the server that a file revision upload has been completed.
  ///@param
  ///@param
  Future<chopper.Response<Message>> v3FilesGuidRevisionsCreatedOnPost({
    required String? guid,
    required String? createdOn,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v3FilesGuidRevisionsCreatedOnPost(
        guid: guid,
        createdOn: createdOn,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Indicate to the server that a file revision upload has been completed.
  ///@param
  ///@param
  @Post(
    path: '/v3/files/{guid}/revisions/{createdOn}',
    optionalBody: true,
  )
  Future<chopper.Response<Message>> _v3FilesGuidRevisionsCreatedOnPost({
    @Path('guid') required String? guid,
    @Path('createdOn') required String? createdOn,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create an administrative account
  ///@param Account Account record to create
  Future<chopper.Response<IdentifierHolder>> v1AccountsPost({
    required Account? account,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Account, () => Account.fromJsonFactory);
    generatedMapping.putIfAbsent(
        IdentifierHolder, () => IdentifierHolder.fromJsonFactory);

    return _v1AccountsPost(
        account: account,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create an administrative account
  ///@param Account Account record to create
  @Post(path: '/v1/accounts')
  Future<chopper.Response<IdentifierHolder>> _v1AccountsPost({
    @Body() required Account? account,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an administrative account
  ///@param
  Future<chopper.Response<Account>> v1AccountsUserIdGet({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Account, () => Account.fromJsonFactory);

    return _v1AccountsUserIdGet(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get an administrative account
  ///@param
  @Get(path: '/v1/accounts/{userId}')
  Future<chopper.Response<Account>> _v1AccountsUserIdGet({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update an administrative account
  ///@param
  ///@param Account Account record to update
  Future<chopper.Response<Message>> v1AccountsUserIdPost({
    required String? userId,
    required Account? account,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Account, () => Account.fromJsonFactory);
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v1AccountsUserIdPost(
        userId: userId,
        account: account,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update an administrative account
  ///@param
  ///@param Account Account record to update
  @Post(path: '/v1/accounts/{userId}')
  Future<chopper.Response<Message>> _v1AccountsUserIdPost({
    @Path('userId') required String? userId,
    @Body() required Account? account,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete an administrative account
  ///@param
  Future<chopper.Response<Message>> v1AccountsUserIdDelete({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v1AccountsUserIdDelete(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete an administrative account
  ///@param
  @Delete(path: '/v1/accounts/{userId}')
  Future<chopper.Response<Message>> _v1AccountsUserIdDelete({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get information about the last request made by this organization member
  ///@param
  Future<chopper.Response<RequestInfo>> v1AccountsUserIdRequestInfoGet({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        RequestInfo, () => RequestInfo.fromJsonFactory);

    return _v1AccountsUserIdRequestInfoGet(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get information about the last request made by this organization member
  ///@param
  @Get(path: '/v1/accounts/{userId}/requestInfo')
  Future<chopper.Response<RequestInfo>> _v1AccountsUserIdRequestInfoGet({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Send a password reset email or SMS message to the organization member.
  ///@param
  Future<chopper.Response> v1AccountsUserIdRequestResetPasswordPost({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v1AccountsUserIdRequestResetPasswordPost(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Send a password reset email or SMS message to the organization member.
  ///@param
  @Post(
    path: '/v1/accounts/{userId}/requestResetPassword',
    optionalBody: true,
  )
  Future<chopper.Response> _v1AccountsUserIdRequestResetPasswordPost({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Resent an email verification email to the the organization member.
  ///@param
  Future<chopper.Response> v1AccountsUserIdResendEmailVerificationPost({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v1AccountsUserIdResendEmailVerificationPost(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Resent an email verification email to the the organization member.
  ///@param
  @Post(
    path: '/v1/accounts/{userId}/resendEmailVerification',
    optionalBody: true,
  )
  Future<chopper.Response> _v1AccountsUserIdResendEmailVerificationPost({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Resent an SMS verification message to the the organization member.
  ///@param
  Future<chopper.Response> v1AccountsUserIdResendPhoneVerificationPost({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v1AccountsUserIdResendPhoneVerificationPost(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Resent an SMS verification message to the the organization member.
  ///@param
  @Post(
    path: '/v1/accounts/{userId}/resendPhoneVerification',
    optionalBody: true,
  )
  Future<chopper.Response> _v1AccountsUserIdResendPhoneVerificationPost({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Sign the account out and delete their server session
  ///@param
  ///@param deleteReauthToken Should sign out also delete any extant reauthentication tokens?
  Future<chopper.Response> v1AccountsUserIdSignOutPost({
    required String? userId,
    bool? deleteReauthToken,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v1AccountsUserIdSignOutPost(
        userId: userId,
        deleteReauthToken: deleteReauthToken,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Sign the account out and delete their server session
  ///@param
  ///@param deleteReauthToken Should sign out also delete any extant reauthentication tokens?
  @Post(
    path: '/v1/accounts/{userId}/signOut',
    optionalBody: true,
  )
  Future<chopper.Response> _v1AccountsUserIdSignOutPost({
    @Path('userId') required String? userId,
    @Query('deleteReauthToken') bool? deleteReauthToken,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param UpdateIdentifier Information to authenticate and update an account identifier
  Future<chopper.Response<UserSessionInfo>> v1AccountsSelfIdentifiersPost({
    required IdentifierUpdate? updateIdentifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        IdentifierUpdate, () => IdentifierUpdate.fromJsonFactory);
    generatedMapping.putIfAbsent(
        UserSessionInfo, () => UserSessionInfo.fromJsonFactory);

    return _v1AccountsSelfIdentifiersPost(
        updateIdentifier: updateIdentifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///
  ///@param UpdateIdentifier Information to authenticate and update an account identifier
  @Post(path: '/v1/accounts/self/identifiers')
  Future<chopper.Response<UserSessionInfo>> _v1AccountsSelfIdentifiersPost({
    @Body() required IdentifierUpdate? updateIdentifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get all of the organizations in an app
  ///@param
  ///@param
  Future<chopper.Response<OrganizationList>> v1OrganizationsGet({
    int? offsetBy,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        OrganizationList, () => OrganizationList.fromJsonFactory);

    return _v1OrganizationsGet(
        offsetBy: offsetBy,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get all of the organizations in an app
  ///@param
  ///@param
  @Get(path: '/v1/organizations')
  Future<chopper.Response<OrganizationList>> _v1OrganizationsGet({
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new organization
  ///@param Organization
  Future<chopper.Response<Organization>> v1OrganizationsPost({
    required Organization? organization,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Organization, () => Organization.fromJsonFactory);

    return _v1OrganizationsPost(
        organization: organization,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new organization
  ///@param Organization
  @Post(path: '/v1/organizations')
  Future<chopper.Response<Organization>> _v1OrganizationsPost({
    @Body() required Organization? organization,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an organization
  ///@param
  Future<chopper.Response<Organization>> v1OrganizationsOrgIdGet({
    required String? orgId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Organization, () => Organization.fromJsonFactory);

    return _v1OrganizationsOrgIdGet(
        orgId: orgId, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get an organization
  ///@param
  @Get(path: '/v1/organizations/{orgId}')
  Future<chopper.Response<Organization>> _v1OrganizationsOrgIdGet({
    @Path('orgId') required String? orgId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update an organization
  ///@param
  ///@param Organization
  Future<chopper.Response<Organization>> v1OrganizationsOrgIdPost({
    required String? orgId,
    required Organization? organization,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Organization, () => Organization.fromJsonFactory);

    return _v1OrganizationsOrgIdPost(
        orgId: orgId,
        organization: organization,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update an organization
  ///@param
  ///@param Organization
  @Post(path: '/v1/organizations/{orgId}')
  Future<chopper.Response<Organization>> _v1OrganizationsOrgIdPost({
    @Path('orgId') required String? orgId,
    @Body() required Organization? organization,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete an organization.
  ///@param
  Future<chopper.Response<Object>> v1OrganizationsOrgIdDelete({
    required String? orgId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v1OrganizationsOrgIdDelete(
        orgId: orgId, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Delete an organization.
  ///@param
  @Delete(path: '/v1/organizations/{orgId}')
  Future<chopper.Response<Object>> _v1OrganizationsOrgIdDelete({
    @Path('orgId') required String? orgId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get members of organization (using search terms). Caller must be a member of the organization.
  ///@param
  ///@param AccountSummarySearch Account summary search parameters
  Future<chopper.Response<AccountSummaryList>> v1OrganizationsOrgIdMembersPost({
    required String? orgId,
    required AccountSummarySearch? accountSummarySearch,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AccountSummarySearch, () => AccountSummarySearch.fromJsonFactory);
    generatedMapping.putIfAbsent(
        AccountSummaryList, () => AccountSummaryList.fromJsonFactory);

    return _v1OrganizationsOrgIdMembersPost(
        orgId: orgId,
        accountSummarySearch: accountSummarySearch,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get members of organization (using search terms). Caller must be a member of the organization.
  ///@param
  ///@param AccountSummarySearch Account summary search parameters
  @Post(path: '/v1/organizations/{orgId}/members')
  Future<chopper.Response<AccountSummaryList>>
      _v1OrganizationsOrgIdMembersPost({
    @Path('orgId') required String? orgId,
    @Body() required AccountSummarySearch? accountSummarySearch,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Add user as a member of the organization (this will return an error if the user is already assigned to another organization).
  ///@param
  ///@param
  Future<chopper.Response<Message>> v1OrganizationsOrgIdMembersUserIdPost({
    required String? orgId,
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v1OrganizationsOrgIdMembersUserIdPost(
        orgId: orgId,
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Add user as a member of the organization (this will return an error if the user is already assigned to another organization).
  ///@param
  ///@param
  @Post(
    path: '/v1/organizations/{orgId}/members/{userId}',
    optionalBody: true,
  )
  Future<chopper.Response<Message>> _v1OrganizationsOrgIdMembersUserIdPost({
    @Path('orgId') required String? orgId,
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Remove a member from this organization (the user will no longer belong to any organization).
  ///@param
  ///@param
  Future<chopper.Response<Message>> v1OrganizationsOrgIdMembersUserIdDelete({
    required String? orgId,
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v1OrganizationsOrgIdMembersUserIdDelete(
        orgId: orgId,
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Remove a member from this organization (the user will no longer belong to any organization).
  ///@param
  ///@param
  @Delete(path: '/v1/organizations/{orgId}/members/{userId}')
  Future<chopper.Response<Message>> _v1OrganizationsOrgIdMembersUserIdDelete({
    @Path('orgId') required String? orgId,
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the studies that are sponsored by this organization.
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<StudyList>> v1OrganizationsOrgIdStudiesGet({
    required String? orgId,
    int? offsetBy,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(StudyList, () => StudyList.fromJsonFactory);

    return _v1OrganizationsOrgIdStudiesGet(
        orgId: orgId,
        offsetBy: offsetBy,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the studies that are sponsored by this organization.
  ///@param
  ///@param
  ///@param
  @Get(path: '/v1/organizations/{orgId}/studies')
  Future<chopper.Response<StudyList>> _v1OrganizationsOrgIdStudiesGet({
    @Path('orgId') required String? orgId,
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Sponsor this study
  ///@param
  ///@param
  Future<chopper.Response<Message>> v1OrganizationsOrgIdStudiesStudyIdPost({
    required String? orgId,
    required String? studyId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v1OrganizationsOrgIdStudiesStudyIdPost(
        orgId: orgId,
        studyId: studyId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Sponsor this study
  ///@param
  ///@param
  @Post(
    path: '/v1/organizations/{orgId}/studies/{studyId}',
    optionalBody: true,
  )
  Future<chopper.Response<Message>> _v1OrganizationsOrgIdStudiesStudyIdPost({
    @Path('orgId') required String? orgId,
    @Path('studyId') required String? studyId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Stop sponsoring this study
  ///@param
  ///@param
  Future<chopper.Response<Message>> v1OrganizationsOrgIdStudiesStudyIdDelete({
    required String? orgId,
    required String? studyId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v1OrganizationsOrgIdStudiesStudyIdDelete(
        orgId: orgId,
        studyId: studyId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Stop sponsoring this study
  ///@param
  ///@param
  @Delete(path: '/v1/organizations/{orgId}/studies/{studyId}')
  Future<chopper.Response<Message>> _v1OrganizationsOrgIdStudiesStudyIdDelete({
    @Path('orgId') required String? orgId,
    @Path('studyId') required String? studyId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get paged listing of unassigned administrative accounts
  ///@param AccountSummarySearch Account summary search parameters. This method only returns administrative accounts that are not currently assigned to an organization.
  Future<chopper.Response<AccountSummaryList>> v1OrganizationsNonmembersPost({
    required AccountSummarySearch? accountSummarySearch,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AccountSummarySearch, () => AccountSummarySearch.fromJsonFactory);
    generatedMapping.putIfAbsent(
        AccountSummaryList, () => AccountSummaryList.fromJsonFactory);

    return _v1OrganizationsNonmembersPost(
        accountSummarySearch: accountSummarySearch,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get paged listing of unassigned administrative accounts
  ///@param AccountSummarySearch Account summary search parameters. This method only returns administrative accounts that are not currently assigned to an organization.
  @Post(path: '/v1/organizations/nonmembers')
  Future<chopper.Response<AccountSummaryList>> _v1OrganizationsNonmembersPost({
    @Body() required AccountSummarySearch? accountSummarySearch,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a list of the participant's scheduled activities
  ///@param offset The user's time zone offset (e.g. +07:00). Scheduled activities will be  returned in the timezone submitted at the time of the request.
  ///@param daysAhead Retrieve activities that are scheduled in the future for the indicated number  of days past today.
  ///@param minimumPerSchedule Force a look-ahead on repeating activities until at least the indicated number  of activities are scheduled (this is applied to the each schedule in the system  that applies to this user). The system will then return either the activities  for N days, or the minimum number of activities, whichever is the greatest in  number. This setting can help to expose infrequent tasks (weekly, monthly,  etc.) to users.
  Future<chopper.Response<ScheduledActivityList>> v3ActivitiesGet({
    required String? offset,
    required int? daysAhead,
    int? minimumPerSchedule,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ScheduledActivityList, () => ScheduledActivityList.fromJsonFactory);

    return _v3ActivitiesGet(
        offset: offset,
        daysAhead: daysAhead,
        minimumPerSchedule: minimumPerSchedule,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a list of the participant's scheduled activities
  ///@param offset The user's time zone offset (e.g. +07:00). Scheduled activities will be  returned in the timezone submitted at the time of the request.
  ///@param daysAhead Retrieve activities that are scheduled in the future for the indicated number  of days past today.
  ///@param minimumPerSchedule Force a look-ahead on repeating activities until at least the indicated number  of activities are scheduled (this is applied to the each schedule in the system  that applies to this user). The system will then return either the activities  for N days, or the minimum number of activities, whichever is the greatest in  number. This setting can help to expose infrequent tasks (weekly, monthly,  etc.) to users.
  @Get(path: '/v3/activities')
  Future<chopper.Response<ScheduledActivityList>> _v3ActivitiesGet({
    @Query('offset') required String? offset,
    @Query('daysAhead') required int? daysAhead,
    @Query('minimumPerSchedule') int? minimumPerSchedule,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a list of the participant's scheduled activities
  ///@param
  ///@param
  Future<chopper.Response<ScheduledActivityListV4>> v4ActivitiesGet({
    required String? startTime,
    required String? endTime,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ScheduledActivityListV4, () => ScheduledActivityListV4.fromJsonFactory);

    return _v4ActivitiesGet(
        startTime: startTime,
        endTime: endTime,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a list of the participant's scheduled activities
  ///@param
  ///@param
  @Get(path: '/v4/activities')
  Future<chopper.Response<ScheduledActivityListV4>> _v4ActivitiesGet({
    @Query('startTime') required String? startTime,
    @Query('endTime') required String? endTime,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update the status of one or more scheduled activities.
  ///@param ScheduledActivity
  Future<chopper.Response<Object>> v4ActivitiesPost({
    required List<ScheduledActivity>? scheduledActivity,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v4ActivitiesPost(
        scheduledActivity: scheduledActivity,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update the status of one or more scheduled activities.
  ///@param ScheduledActivity
  @Post(path: '/v4/activities')
  Future<chopper.Response<Object>> _v4ActivitiesPost({
    @Body() required List<ScheduledActivity>? scheduledActivity,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a history of activities
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      v3ActivitiesActivityGuidGet({
    required String? activityGuid,
    String? scheduledOnStart,
    String? scheduledOnEnd,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorScheduledActivityList,
        () => ForwardCursorScheduledActivityList.fromJsonFactory);

    return _v3ActivitiesActivityGuidGet(
        activityGuid: activityGuid,
        scheduledOnStart: scheduledOnStart,
        scheduledOnEnd: scheduledOnEnd,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a history of activities
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/activities/{activityGuid}')
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      _v3ActivitiesActivityGuidGet({
    @Path('activityGuid') required String? activityGuid,
    @Query('scheduledOnStart') String? scheduledOnStart,
    @Query('scheduledOnEnd') String? scheduledOnEnd,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a history of tasks
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      v4ActivitiesTasksTaskIdGet({
    required String? taskId,
    String? scheduledOnStart,
    String? scheduledOnEnd,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorScheduledActivityList,
        () => ForwardCursorScheduledActivityList.fromJsonFactory);

    return _v4ActivitiesTasksTaskIdGet(
        taskId: taskId,
        scheduledOnStart: scheduledOnStart,
        scheduledOnEnd: scheduledOnEnd,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a history of tasks
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v4/activities/tasks/{taskId}')
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      _v4ActivitiesTasksTaskIdGet({
    @Path('taskId') required String? taskId,
    @Query('scheduledOnStart') String? scheduledOnStart,
    @Query('scheduledOnEnd') String? scheduledOnEnd,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a history of surveys
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      v4ActivitiesSurveysSurveyGuidGet({
    required String? surveyGuid,
    String? scheduledOnStart,
    String? scheduledOnEnd,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorScheduledActivityList,
        () => ForwardCursorScheduledActivityList.fromJsonFactory);

    return _v4ActivitiesSurveysSurveyGuidGet(
        surveyGuid: surveyGuid,
        scheduledOnStart: scheduledOnStart,
        scheduledOnEnd: scheduledOnEnd,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a history of surveys
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v4/activities/surveys/{surveyGuid}')
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      _v4ActivitiesSurveysSurveyGuidGet({
    @Path('surveyGuid') required String? surveyGuid,
    @Query('scheduledOnStart') String? scheduledOnStart,
    @Query('scheduledOnEnd') String? scheduledOnEnd,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a history of compound activities
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      v4ActivitiesCompoundactivitiesTaskIdGet({
    required String? taskId,
    String? scheduledOnStart,
    String? scheduledOnEnd,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorScheduledActivityList,
        () => ForwardCursorScheduledActivityList.fromJsonFactory);

    return _v4ActivitiesCompoundactivitiesTaskIdGet(
        taskId: taskId,
        scheduledOnStart: scheduledOnStart,
        scheduledOnEnd: scheduledOnEnd,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a history of compound activities
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v4/activities/compoundactivities/{taskId}')
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      _v4ActivitiesCompoundactivitiesTaskIdGet({
    @Path('taskId') required String? taskId,
    @Query('scheduledOnStart') String? scheduledOnStart,
    @Query('scheduledOnEnd') String? scheduledOnEnd,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///List all compound activity definitions in the app
  Future<chopper.Response<CompoundActivityDefinitionList>>
      v3CompoundactivitydefinitionsGet({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CompoundActivityDefinitionList,
        () => CompoundActivityDefinitionList.fromJsonFactory);

    return _v3CompoundactivitydefinitionsGet(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///List all compound activity definitions in the app
  @Get(path: '/v3/compoundactivitydefinitions')
  Future<chopper.Response<CompoundActivityDefinitionList>>
      _v3CompoundactivitydefinitionsGet({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a compound activity definition
  ///@param CompoundActivityDefinition
  Future<chopper.Response<CompoundActivityDefinition>>
      v3CompoundactivitydefinitionsPost({
    required CompoundActivityDefinition? compoundActivityDefinition,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CompoundActivityDefinition,
        () => CompoundActivityDefinition.fromJsonFactory);

    return _v3CompoundactivitydefinitionsPost(
        compoundActivityDefinition: compoundActivityDefinition,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a compound activity definition
  ///@param CompoundActivityDefinition
  @Post(path: '/v3/compoundactivitydefinitions')
  Future<chopper.Response<CompoundActivityDefinition>>
      _v3CompoundactivitydefinitionsPost({
    @Body() required CompoundActivityDefinition? compoundActivityDefinition,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a compound activity definition by ID
  ///@param
  Future<chopper.Response<CompoundActivityDefinition>>
      v3CompoundactivitydefinitionsTaskIdGet({
    required String? taskId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CompoundActivityDefinition,
        () => CompoundActivityDefinition.fromJsonFactory);

    return _v3CompoundactivitydefinitionsTaskIdGet(
        taskId: taskId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a compound activity definition by ID
  ///@param
  @Get(path: '/v3/compoundactivitydefinitions/{taskId}')
  Future<chopper.Response<CompoundActivityDefinition>>
      _v3CompoundactivitydefinitionsTaskIdGet({
    @Path('taskId') required String? taskId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a compound activity definition
  ///@param
  Future<chopper.Response<Object>> v3CompoundactivitydefinitionsTaskIdDelete({
    required String? taskId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3CompoundactivitydefinitionsTaskIdDelete(
        taskId: taskId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a compound activity definition
  ///@param
  @Delete(path: '/v3/compoundactivitydefinitions/{taskId}')
  Future<chopper.Response<Object>> _v3CompoundactivitydefinitionsTaskIdDelete({
    @Path('taskId') required String? taskId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update a compound activity definition
  ///@param
  ///@param CompoundActivityDefinition
  Future<chopper.Response<CompoundActivityDefinition>>
      v3CompoundactivitydefinitionsTaskIdPost({
    required String? taskId,
    required CompoundActivityDefinition? compoundActivityDefinition,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CompoundActivityDefinition,
        () => CompoundActivityDefinition.fromJsonFactory);

    return _v3CompoundactivitydefinitionsTaskIdPost(
        taskId: taskId,
        compoundActivityDefinition: compoundActivityDefinition,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update a compound activity definition
  ///@param
  ///@param CompoundActivityDefinition
  @Post(path: '/v3/compoundactivitydefinitions/{taskId}')
  Future<chopper.Response<CompoundActivityDefinition>>
      _v3CompoundactivitydefinitionsTaskIdPost({
    @Path('taskId') required String? taskId,
    @Body() required CompoundActivityDefinition? compoundActivityDefinition,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a list of participant files from the user
  ///@param
  ///@param
  Future<chopper.Response<ParticipantFileList>> v3ParticipantsSelfFilesGet({
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ParticipantFileList, () => ParticipantFileList.fromJsonFactory);

    return _v3ParticipantsSelfFilesGet(
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a list of participant files from the user
  ///@param
  ///@param
  @Get(path: '/v3/participants/self/files')
  Future<chopper.Response<ParticipantFileList>> _v3ParticipantsSelfFilesGet({
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a participant file
  ///@param
  Future<chopper.Response<List<String>>> v3ParticipantsSelfFilesFileIdGet({
    required String? fileId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3ParticipantsSelfFilesFileIdGet(
        fileId: fileId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a participant file
  ///@param
  @Get(path: '/v3/participants/self/files/{fileId}')
  Future<chopper.Response<List<String>>> _v3ParticipantsSelfFilesFileIdGet({
    @Path('fileId') required String? fileId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new participant file
  ///@param
  ///@param ParticipantFile The participant file metadata
  Future<chopper.Response<ParticipantFile>> v3ParticipantsSelfFilesFileIdPost({
    required String? fileId,
    required ParticipantFile? participantFile,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ParticipantFile, () => ParticipantFile.fromJsonFactory);

    return _v3ParticipantsSelfFilesFileIdPost(
        fileId: fileId,
        participantFile: participantFile,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new participant file
  ///@param
  ///@param ParticipantFile The participant file metadata
  @Post(path: '/v3/participants/self/files/{fileId}')
  Future<chopper.Response<ParticipantFile>> _v3ParticipantsSelfFilesFileIdPost({
    @Path('fileId') required String? fileId,
    @Body() required ParticipantFile? participantFile,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a participant file
  ///@param
  Future<chopper.Response<Object>> v3ParticipantsSelfFilesFileIdDelete({
    required String? fileId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3ParticipantsSelfFilesFileIdDelete(
        fileId: fileId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a participant file
  ///@param
  @Delete(path: '/v3/participants/self/files/{fileId}')
  Future<chopper.Response<Object>> _v3ParticipantsSelfFilesFileIdDelete({
    @Path('fileId') required String? fileId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get health data records by createdOn date range.
  ///@param
  ///@param
  Future<chopper.Response<HealthDataRecordList>> v3HealthdataGet({
    String? createdOnStart,
    String? createdOnEnd,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        HealthDataRecordList, () => HealthDataRecordList.fromJsonFactory);

    return _v3HealthdataGet(
        createdOnStart: createdOnStart,
        createdOnEnd: createdOnEnd,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get health data records by createdOn date range.
  ///@param
  ///@param
  @Get(path: '/v3/healthdata')
  Future<chopper.Response<HealthDataRecordList>> _v3HealthdataGet({
    @Query('createdOnStart') String? createdOnStart,
    @Query('createdOnEnd') String? createdOnEnd,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Upload health data
  ///@param HealthDataSubmission Health data submitted by the user
  Future<chopper.Response<HealthDataRecord>> v3HealthdataPost({
    required HealthDataSubmission? healthDataSubmission,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        HealthDataSubmission, () => HealthDataSubmission.fromJsonFactory);
    generatedMapping.putIfAbsent(
        HealthDataRecord, () => HealthDataRecord.fromJsonFactory);

    return _v3HealthdataPost(
        healthDataSubmission: healthDataSubmission,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Upload health data
  ///@param HealthDataSubmission Health data submitted by the user
  @Post(path: '/v3/healthdata')
  Future<chopper.Response<HealthDataRecord>> _v3HealthdataPost({
    @Body() required HealthDataSubmission? healthDataSubmission,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create or update health data documentation.
  ///@param HealthDataDocumentation Health data documentation submitted by the user
  Future<chopper.Response<HealthDataDocumentation>>
      v3HealthdatadocumentationPost({
    required HealthDataDocumentation? healthDataDocumentation,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        HealthDataDocumentation, () => HealthDataDocumentation.fromJsonFactory);

    return _v3HealthdatadocumentationPost(
        healthDataDocumentation: healthDataDocumentation,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create or update health data documentation.
  ///@param HealthDataDocumentation Health data documentation submitted by the user
  @Post(path: '/v3/healthdatadocumentation')
  Future<chopper.Response<HealthDataDocumentation>>
      _v3HealthdatadocumentationPost({
    @Body() required HealthDataDocumentation? healthDataDocumentation,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get all health data documentation by parentId.
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<HealthDataDocumentationList>>
      v3HealthdatadocumentationGet({
    String? parentId,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(HealthDataDocumentationList,
        () => HealthDataDocumentationList.fromJsonFactory);

    return _v3HealthdatadocumentationGet(
        parentId: parentId,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get all health data documentation by parentId.
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/healthdatadocumentation')
  Future<chopper.Response<HealthDataDocumentationList>>
      _v3HealthdatadocumentationGet({
    @Query('parentId') String? parentId,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete all documentation associated with given parentId
  ///@param
  Future<chopper.Response<Object>> v3HealthdatadocumentationDelete({
    String? parentId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3HealthdatadocumentationDelete(
        parentId: parentId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete all documentation associated with given parentId
  ///@param
  @Delete(path: '/v3/healthdatadocumentation')
  Future<chopper.Response<Object>> _v3HealthdatadocumentationDelete({
    @Query('parentId') String? parentId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a health data documentation with the given identifier
  ///@param
  Future<chopper.Response<HealthDataDocumentation>>
      v3HealthdatadocumentationIdentifierGet({
    required String? identifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        HealthDataDocumentation, () => HealthDataDocumentation.fromJsonFactory);

    return _v3HealthdatadocumentationIdentifierGet(
        identifier: identifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a health data documentation with the given identifier
  ///@param
  @Get(path: '/v3/healthdatadocumentation/{identifier}')
  Future<chopper.Response<HealthDataDocumentation>>
      _v3HealthdatadocumentationIdentifierGet({
    @Path('identifier') required String? identifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a health data documentation with the given identifier.
  ///@param
  Future<chopper.Response<Object>> v3HealthdatadocumentationIdentifierDelete({
    required String? identifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3HealthdatadocumentationIdentifierDelete(
        identifier: identifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a health data documentation with the given identifier.
  ///@param
  @Delete(path: '/v3/healthdatadocumentation/{identifier}')
  Future<chopper.Response<Object>> _v3HealthdatadocumentationIdentifierDelete({
    @Path('identifier') required String? identifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Send a consent signature to Bridge before the user has signed up to the server.
  ///
  ///@param IntentToParticipate
  Future<chopper.Response> v3ItpPost({
    required IntentToParticipate? intentToParticipate,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        IntentToParticipate, () => IntentToParticipate.fromJsonFactory);

    return _v3ItpPost(
        intentToParticipate: intentToParticipate,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Send a consent signature to Bridge before the user has signed up to the server.
  ///
  ///@param IntentToParticipate
  @Post(path: '/v3/itp')
  Future<chopper.Response> _v3ItpPost({
    @Body() required IntentToParticipate? intentToParticipate,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a paged list of study participants (users)
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<AccountSummaryList>> v3ParticipantsGet({
    int? offsetBy,
    int? pageSize,
    String? emailFilter,
    String? phoneFilter,
    String? startTime,
    String? endTime,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AccountSummaryList, () => AccountSummaryList.fromJsonFactory);

    return _v3ParticipantsGet(
        offsetBy: offsetBy,
        pageSize: pageSize,
        emailFilter: emailFilter,
        phoneFilter: phoneFilter,
        startTime: startTime,
        endTime: endTime,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a paged list of study participants (users)
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/participants')
  Future<chopper.Response<AccountSummaryList>> _v3ParticipantsGet({
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Query('emailFilter') String? emailFilter,
    @Query('phoneFilter') String? phoneFilter,
    @Query('startTime') String? startTime,
    @Query('endTime') String? endTime,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new study participant (user)
  ///@param SignUp Sign up
  Future<chopper.Response<IdentifierHolder>> v3ParticipantsPost({
    required SignUp? signUp,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        IdentifierHolder, () => IdentifierHolder.fromJsonFactory);

    return _v3ParticipantsPost(
        signUp: signUp,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new study participant (user)
  ///@param SignUp Sign up
  @Post(path: '/v3/participants')
  Future<chopper.Response<IdentifierHolder>> _v3ParticipantsPost({
    @Body() required SignUp? signUp,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Search for account summaries (participants)
  ///@param AccountSummarySearch Account summary search parameters
  Future<chopper.Response<AccountSummaryList>> v3ParticipantsSearchPost({
    required AccountSummarySearch? accountSummarySearch,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AccountSummarySearch, () => AccountSummarySearch.fromJsonFactory);
    generatedMapping.putIfAbsent(
        AccountSummaryList, () => AccountSummaryList.fromJsonFactory);

    return _v3ParticipantsSearchPost(
        accountSummarySearch: accountSummarySearch,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Search for account summaries (participants)
  ///@param AccountSummarySearch Account summary search parameters
  @Post(path: '/v3/participants/search')
  Future<chopper.Response<AccountSummaryList>> _v3ParticipantsSearchPost({
    @Body() required AccountSummarySearch? accountSummarySearch,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get user's participant record
  ///@param
  Future<chopper.Response<StudyParticipant>> v3ParticipantsSelfGet({
    bool? consents,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyParticipant, () => StudyParticipant.fromJsonFactory);

    return _v3ParticipantsSelfGet(
        consents: consents,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get user's participant record
  ///@param
  @Get(path: '/v3/participants/self')
  Future<chopper.Response<StudyParticipant>> _v3ParticipantsSelfGet({
    @Query('consents') bool? consents,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update user's participant record
  ///@param StudyParticipant Study participant
  Future<chopper.Response<UserSessionInfo>> v3ParticipantsSelfPost({
    required StudyParticipant? studyParticipant,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UserSessionInfo, () => UserSessionInfo.fromJsonFactory);

    return _v3ParticipantsSelfPost(
        studyParticipant: studyParticipant,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update user's participant record
  ///@param StudyParticipant Study participant
  @Post(path: '/v3/participants/self')
  Future<chopper.Response<UserSessionInfo>> _v3ParticipantsSelfPost({
    @Body() required StudyParticipant? studyParticipant,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param UpdateIdentifier Information to authenticate and update an account identifier
  Future<chopper.Response<UserSessionInfo>> v3ParticipantsSelfIdentifiersPost({
    required IdentifierUpdate? updateIdentifier,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        IdentifierUpdate, () => IdentifierUpdate.fromJsonFactory);
    generatedMapping.putIfAbsent(
        UserSessionInfo, () => UserSessionInfo.fromJsonFactory);

    return _v3ParticipantsSelfIdentifiersPost(
        updateIdentifier: updateIdentifier, cacheControl: cacheControl);
  }

  ///
  ///@param UpdateIdentifier Information to authenticate and update an account identifier
  @Post(path: '/v3/participants/self/identifiers')
  Future<chopper.Response<UserSessionInfo>> _v3ParticipantsSelfIdentifiersPost({
    @Body() required IdentifierUpdate? updateIdentifier,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get list of report indices for participants
  Future<chopper.Response<ReportIndexList>> v3ParticipantsReportsGet({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ReportIndexList, () => ReportIndexList.fromJsonFactory);

    return _v3ParticipantsReportsGet(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get list of report indices for participants
  @Get(path: '/v3/participants/reports')
  Future<chopper.Response<ReportIndexList>> _v3ParticipantsReportsGet({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant (user) record
  ///@param
  ///@param
  Future<chopper.Response<StudyParticipant>> v3ParticipantsUserIdGet({
    required String? userId,
    bool? consents,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyParticipant, () => StudyParticipant.fromJsonFactory);

    return _v3ParticipantsUserIdGet(
        userId: userId,
        consents: consents,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant (user) record
  ///@param
  ///@param
  @Get(path: '/v3/participants/{userId}')
  Future<chopper.Response<StudyParticipant>> _v3ParticipantsUserIdGet({
    @Path('userId') required String? userId,
    @Query('consents') bool? consents,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update an existing study participant (user) record
  ///@param
  ///@param StudyParticipant Study participant
  Future<chopper.Response<Object>> v3ParticipantsUserIdPost({
    required String? userId,
    required StudyParticipant? studyParticipant,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3ParticipantsUserIdPost(
        userId: userId,
        studyParticipant: studyParticipant,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update an existing study participant (user) record
  ///@param
  ///@param StudyParticipant Study participant
  @Post(path: '/v3/participants/{userId}')
  Future<chopper.Response<Object>> _v3ParticipantsUserIdPost({
    @Path('userId') required String? userId,
    @Body() required StudyParticipant? studyParticipant,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a study participant if the record has the `test_user` data group, or the account has not been used by the participant (the participant has never signed in to Bridge using the account) and it is only enrolled in one study.
  ///@param
  Future<chopper.Response<Object>> v3ParticipantsUserIdDelete({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3ParticipantsUserIdDelete(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a study participant if the record has the `test_user` data group, or the account has not been used by the participant (the participant has never signed in to Bridge using the account) and it is only enrolled in one study.
  ///@param
  @Delete(path: '/v3/participants/{userId}')
  Future<chopper.Response<Object>> _v3ParticipantsUserIdDelete({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant (user) record using the external ID of the account
  ///@param
  ///@param
  Future<chopper.Response<StudyParticipant>>
      v3ParticipantsExternalIdExternalIdGet({
    required String? externalId,
    bool? consents,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyParticipant, () => StudyParticipant.fromJsonFactory);

    return _v3ParticipantsExternalIdExternalIdGet(
        externalId: externalId,
        consents: consents,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant (user) record using the external ID of the account
  ///@param
  ///@param
  @Get(path: '/v3/participants/externalId:{externalId}')
  Future<chopper.Response<StudyParticipant>>
      _v3ParticipantsExternalIdExternalIdGet({
    @Path('externalId') required String? externalId,
    @Query('consents') bool? consents,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant (user) record using the health code of the account
  ///@param
  ///@param
  Future<chopper.Response<StudyParticipant>>
      v3ParticipantsHealthCodeHealthCodeGet({
    required String? healthCode,
    bool? consents,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyParticipant, () => StudyParticipant.fromJsonFactory);

    return _v3ParticipantsHealthCodeHealthCodeGet(
        healthCode: healthCode,
        consents: consents,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant (user) record using the health code of the account
  ///@param
  ///@param
  @Get(path: '/v3/participants/healthCode:{healthCode}')
  Future<chopper.Response<StudyParticipant>>
      _v3ParticipantsHealthCodeHealthCodeGet({
    @Path('healthCode') required String? healthCode,
    @Query('consents') bool? consents,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant (user) record using the Synapse user ID of the account
  ///@param
  ///@param
  Future<chopper.Response<StudyParticipant>> v3ParticipantsSynSynapseUserIdGet({
    required String? synapseUserId,
    bool? consents,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyParticipant, () => StudyParticipant.fromJsonFactory);

    return _v3ParticipantsSynSynapseUserIdGet(
        synapseUserId: synapseUserId,
        consents: consents,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant (user) record using the Synapse user ID of the account
  ///@param
  ///@param
  @Get(path: '/v3/participants/syn:{synapseUserId}')
  Future<chopper.Response<StudyParticipant>>
      _v3ParticipantsSynSynapseUserIdGet({
    @Path('synapseUserId') required String? synapseUserId,
    @Query('consents') bool? consents,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get enrollment records for this user
  ///@param
  Future<chopper.Response<EnrollmentDetailList>>
      v3ParticipantsUserIdEnrollmentsGet({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        EnrollmentDetailList, () => EnrollmentDetailList.fromJsonFactory);

    return _v3ParticipantsUserIdEnrollmentsGet(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get enrollment records for this user
  ///@param
  @Get(path: '/v3/participants/{userId}/enrollments')
  Future<chopper.Response<EnrollmentDetailList>>
      _v3ParticipantsUserIdEnrollmentsGet({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Upload health data for the given user
  ///@param
  ///@param HealthDataSubmission Health data submitted on behalf of the user
  Future<chopper.Response<HealthDataRecord>>
      v3ParticipantsUserIdHealthdataPost({
    required String? userId,
    required HealthDataSubmission? healthDataSubmission,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        HealthDataSubmission, () => HealthDataSubmission.fromJsonFactory);
    generatedMapping.putIfAbsent(
        HealthDataRecord, () => HealthDataRecord.fromJsonFactory);

    return _v3ParticipantsUserIdHealthdataPost(
        userId: userId,
        healthDataSubmission: healthDataSubmission,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Upload health data for the given user
  ///@param
  ///@param HealthDataSubmission Health data submitted on behalf of the user
  @Post(path: '/v3/participants/{userId}/healthdata')
  Future<chopper.Response<HealthDataRecord>>
      _v3ParticipantsUserIdHealthdataPost({
    @Path('userId') required String? userId,
    @Body() required HealthDataSubmission? healthDataSubmission,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Returns the most recent message sent to the phone number of the given user. Used by integration tests.
  ///@param
  Future<chopper.Response<SmsMessage>> v3ParticipantsUserIdSmsRecentGet({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(SmsMessage, () => SmsMessage.fromJsonFactory);

    return _v3ParticipantsUserIdSmsRecentGet(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Returns the most recent message sent to the phone number of the given user. Used by integration tests.
  ///@param
  @Get(path: '/v3/participants/{userId}/sms/recent')
  Future<chopper.Response<SmsMessage>> _v3ParticipantsUserIdSmsRecentGet({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant's upload history
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<UploadList>> v3ParticipantsUserIdUploadsGet({
    required String? userId,
    required String? startTime,
    required String? endTime,
    int? pageSize,
    String? offsetKey,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(UploadList, () => UploadList.fromJsonFactory);

    return _v3ParticipantsUserIdUploadsGet(
        userId: userId,
        startTime: startTime,
        endTime: endTime,
        pageSize: pageSize,
        offsetKey: offsetKey,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant's upload history
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/participants/{userId}/uploads')
  Future<chopper.Response<UploadList>> _v3ParticipantsUserIdUploadsGet({
    @Path('userId') required String? userId,
    @Query('startTime') required String? startTime,
    @Query('endTime') required String? endTime,
    @Query('pageSize') int? pageSize,
    @Query('offsetKey') String? offsetKey,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete all participant versions for the given user.
  ///@param
  Future<chopper.Response<Object>> v3ParticipantsUserIdVersionsDelete({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3ParticipantsUserIdVersionsDelete(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete all participant versions for the given user.
  ///@param
  @Delete(path: '/v3/participants/{userId}/versions')
  Future<chopper.Response<Object>> _v3ParticipantsUserIdVersionsDelete({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant's push notification registrations
  ///@param
  Future<chopper.Response<NotificationRegistrationList>>
      v3ParticipantsUserIdNotificationsGet({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(NotificationRegistrationList,
        () => NotificationRegistrationList.fromJsonFactory);

    return _v3ParticipantsUserIdNotificationsGet(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant's push notification registrations
  ///@param
  @Get(path: '/v3/participants/{userId}/notifications')
  Future<chopper.Response<NotificationRegistrationList>>
      _v3ParticipantsUserIdNotificationsGet({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create an SMS notification registration for the given user.
  ///@param
  Future<chopper.Response<Object>> v3ParticipantsUserIdNotificationsSmsPost({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3ParticipantsUserIdNotificationsSmsPost(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create an SMS notification registration for the given user.
  ///@param
  @Post(
    path: '/v3/participants/{userId}/notifications/sms',
    optionalBody: true,
  )
  Future<chopper.Response<Object>> _v3ParticipantsUserIdNotificationsSmsPost({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Send a push notification to a single participant
  ///@param
  ///@param NotificationMessage
  Future<chopper.Response> v3ParticipantsUserIdSendNotificationPost({
    required String? userId,
    required NotificationMessage? notificationMessage,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        NotificationMessage, () => NotificationMessage.fromJsonFactory);

    return _v3ParticipantsUserIdSendNotificationPost(
        userId: userId,
        notificationMessage: notificationMessage,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Send a push notification to a single participant
  ///@param
  ///@param NotificationMessage
  @Post(path: '/v3/participants/{userId}/sendNotification')
  Future<chopper.Response> _v3ParticipantsUserIdSendNotificationPost({
    @Path('userId') required String? userId,
    @Body() required NotificationMessage? notificationMessage,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Send a message (SMS or email) to a participant explaining how to download and install the app
  ///@param
  Future<chopper.Response> v3ParticipantsUserIdSendInstallLinkPost({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3ParticipantsUserIdSendInstallLinkPost(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Send a message (SMS or email) to a participant explaining how to download and install the app
  ///@param
  @Post(
    path: '/v3/participants/{userId}/sendInstallLink',
    optionalBody: true,
  )
  Future<chopper.Response> _v3ParticipantsUserIdSendInstallLinkPost({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get information about the last request made by this participant
  ///@param
  Future<chopper.Response<RequestInfo>> v3ParticipantsUserIdRequestInfoGet({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        RequestInfo, () => RequestInfo.fromJsonFactory);

    return _v3ParticipantsUserIdRequestInfoGet(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get information about the last request made by this participant
  ///@param
  @Get(path: '/v3/participants/{userId}/requestInfo')
  Future<chopper.Response<RequestInfo>> _v3ParticipantsUserIdRequestInfoGet({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete all activities for a participant
  ///@param
  Future<chopper.Response<Object>> v3ParticipantsUserIdActivitiesDelete({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3ParticipantsUserIdActivitiesDelete(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete all activities for a participant
  ///@param
  @Delete(path: '/v3/participants/{userId}/activities')
  Future<chopper.Response<Object>> _v3ParticipantsUserIdActivitiesDelete({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant's history of activities
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      v3ParticipantsUserIdActivitiesActivityGuidGet({
    required String? userId,
    required String? activityGuid,
    String? scheduledOnStart,
    String? scheduledOnEnd,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorScheduledActivityList,
        () => ForwardCursorScheduledActivityList.fromJsonFactory);

    return _v3ParticipantsUserIdActivitiesActivityGuidGet(
        userId: userId,
        activityGuid: activityGuid,
        scheduledOnStart: scheduledOnStart,
        scheduledOnEnd: scheduledOnEnd,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant's history of activities
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/participants/{userId}/activities/{activityGuid}')
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      _v3ParticipantsUserIdActivitiesActivityGuidGet({
    @Path('userId') required String? userId,
    @Path('activityGuid') required String? activityGuid,
    @Query('scheduledOnStart') String? scheduledOnStart,
    @Query('scheduledOnEnd') String? scheduledOnEnd,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Sign the user out and delete their server session
  ///@param
  ///@param deleteReauthToken Should sign out also delete any extant reauthentication tokens?
  Future<chopper.Response<Object>> v3ParticipantsUserIdSignOutPost({
    required String? userId,
    bool? deleteReauthToken,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3ParticipantsUserIdSignOutPost(
        userId: userId,
        deleteReauthToken: deleteReauthToken,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Sign the user out and delete their server session
  ///@param
  ///@param deleteReauthToken Should sign out also delete any extant reauthentication tokens?
  @Post(
    path: '/v3/participants/{userId}/signOut',
    optionalBody: true,
  )
  Future<chopper.Response<Object>> _v3ParticipantsUserIdSignOutPost({
    @Path('userId') required String? userId,
    @Query('deleteReauthToken') bool? deleteReauthToken,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Trigger a request to reset password for this user
  ///@param
  Future<chopper.Response<Object>>
      v3ParticipantsUserIdRequestResetPasswordPost({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3ParticipantsUserIdRequestResetPasswordPost(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Trigger a request to reset password for this user
  ///@param
  @Post(
    path: '/v3/participants/{userId}/requestResetPassword',
    optionalBody: true,
  )
  Future<chopper.Response<Object>>
      _v3ParticipantsUserIdRequestResetPasswordPost({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Resend an email verification email to this user
  ///@param
  Future<chopper.Response<Object>>
      v3ParticipantsUserIdResendEmailVerificationPost({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3ParticipantsUserIdResendEmailVerificationPost(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Resend an email verification email to this user
  ///@param
  @Post(
    path: '/v3/participants/{userId}/resendEmailVerification',
    optionalBody: true,
  )
  Future<chopper.Response<Object>>
      _v3ParticipantsUserIdResendEmailVerificationPost({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Resend a phone verification to this user
  ///@param
  Future<chopper.Response<Object>>
      v3ParticipantsUserIdResendPhoneVerificationPost({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3ParticipantsUserIdResendPhoneVerificationPost(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Resend a phone verification to this user
  ///@param
  @Post(
    path: '/v3/participants/{userId}/resendPhoneVerification',
    optionalBody: true,
  )
  Future<chopper.Response<Object>>
      _v3ParticipantsUserIdResendPhoneVerificationPost({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Withdraw the participant from all studies in this app
  ///@param
  ///@param withdrawal
  Future<chopper.Response<Object>> v3ParticipantsUserIdConsentsWithdrawPost({
    required String? userId,
    required Withdrawal? withdrawal,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Withdrawal, () => Withdrawal.fromJsonFactory);

    return _v3ParticipantsUserIdConsentsWithdrawPost(
        userId: userId,
        withdrawal: withdrawal,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Withdraw the participant from all studies in this app
  ///@param
  ///@param withdrawal
  @Post(path: '/v3/participants/{userId}/consents/withdraw')
  Future<chopper.Response<Object>> _v3ParticipantsUserIdConsentsWithdrawPost({
    @Path('userId') required String? userId,
    @Body() required Withdrawal? withdrawal,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Re-send the consent agreement for this subpopulation
  ///@param
  ///@param
  Future<chopper.Response<Object>>
      v3ParticipantsUserIdConsentsSubpopulationGuidResendConsentPost({
    required String? userId,
    required String? subpopulationGuid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3ParticipantsUserIdConsentsSubpopulationGuidResendConsentPost(
        userId: userId,
        subpopulationGuid: subpopulationGuid,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Re-send the consent agreement for this subpopulation
  ///@param
  ///@param
  @Post(
    path:
        '/v3/participants/{userId}/consents/{subpopulationGuid}/resendConsent',
    optionalBody: true,
  )
  Future<chopper.Response<Object>>
      _v3ParticipantsUserIdConsentsSubpopulationGuidResendConsentPost({
    @Path('userId') required String? userId,
    @Path('subpopulationGuid') required String? subpopulationGuid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Withdraw the participant from the specified subpopulation
  ///@param
  ///@param
  ///@param withdrawal
  Future<chopper.Response<Object>>
      v3ParticipantsUserIdConsentsSubpopulationGuidWithdrawPost({
    required String? userId,
    required String? subpopulationGuid,
    required Withdrawal? withdrawal,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Withdrawal, () => Withdrawal.fromJsonFactory);

    return _v3ParticipantsUserIdConsentsSubpopulationGuidWithdrawPost(
        userId: userId,
        subpopulationGuid: subpopulationGuid,
        withdrawal: withdrawal,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Withdraw the participant from the specified subpopulation
  ///@param
  ///@param
  ///@param withdrawal
  @Post(path: '/v3/participants/{userId}/consents/{subpopulationGuid}/withdraw')
  Future<chopper.Response<Object>>
      _v3ParticipantsUserIdConsentsSubpopulationGuidWithdrawPost({
    @Path('userId') required String? userId,
    @Path('subpopulationGuid') required String? subpopulationGuid,
    @Body() required Withdrawal? withdrawal,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get participant report records
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ReportDataList>>
      v3ParticipantsUserIdReportsIdentifierGet({
    required String? userId,
    required String? identifier,
    required String? startDate,
    required String? endDate,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ReportDataList, () => ReportDataList.fromJsonFactory);

    return _v3ParticipantsUserIdReportsIdentifierGet(
        userId: userId,
        identifier: identifier,
        startDate: startDate,
        endDate: endDate,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get participant report records
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/participants/{userId}/reports/{identifier}')
  Future<chopper.Response<ReportDataList>>
      _v3ParticipantsUserIdReportsIdentifierGet({
    @Path('userId') required String? userId,
    @Path('identifier') required String? identifier,
    @Query('startDate') required String? startDate,
    @Query('endDate') required String? endDate,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a record for a specific day of a participant report
  ///@param
  ///@param
  ///@param date Date of records
  Future<chopper.Response<Object>>
      v3ParticipantsUserIdReportsIdentifierDateDelete({
    required String? userId,
    required String? identifier,
    required String? date,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3ParticipantsUserIdReportsIdentifierDateDelete(
        userId: userId,
        identifier: identifier,
        date: date,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a record for a specific day of a participant report
  ///@param
  ///@param
  ///@param date Date of records
  @Delete(path: '/v3/participants/{userId}/reports/{identifier}/{date}')
  Future<chopper.Response<Object>>
      _v3ParticipantsUserIdReportsIdentifierDateDelete({
    @Path('userId') required String? userId,
    @Path('identifier') required String? identifier,
    @Path('date') required String? date,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get activity events mapping for a participant
  ///@param userId
  Future<chopper.Response<ActivityEventList>>
      v3ParticipantsUserIdActivityeventsGet({
    required String? userId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ActivityEventList, () => ActivityEventList.fromJsonFactory);

    return _v3ParticipantsUserIdActivityeventsGet(
        userId: userId, cacheControl: cacheControl);
  }

  ///Get activity events mapping for a participant
  ///@param userId
  @Get(path: '/v3/participants/{userId}/activityevents')
  Future<chopper.Response<ActivityEventList>>
      _v3ParticipantsUserIdActivityeventsGet({
    @Path('userId') required String? userId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a custom event for a participant
  ///@param userId
  ///@param CustomActivityEventRequest
  Future<chopper.Response<Message>> v3ParticipantsUserIdActivityeventsPost({
    required String? userId,
    required CustomActivityEventRequest? customActivityEventRequest,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CustomActivityEventRequest,
        () => CustomActivityEventRequest.fromJsonFactory);
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v3ParticipantsUserIdActivityeventsPost(
        userId: userId,
        customActivityEventRequest: customActivityEventRequest,
        cacheControl: cacheControl);
  }

  ///Create a custom event for a participant
  ///@param userId
  ///@param CustomActivityEventRequest
  @Post(path: '/v3/participants/{userId}/activityevents')
  Future<chopper.Response<Message>> _v3ParticipantsUserIdActivityeventsPost({
    @Path('userId') required String? userId,
    @Body() required CustomActivityEventRequest? customActivityEventRequest,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Add a participant report record
  ///@param
  ///@param report data
  Future<chopper.Response<Object>> v3ParticipantsReportsIdentifierPost({
    required String? identifier,
    required ReportDataForWorker? reportData,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ReportDataForWorker, () => ReportDataForWorker.fromJsonFactory);

    return _v3ParticipantsReportsIdentifierPost(
        identifier: identifier,
        reportData: reportData,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Add a participant report record
  ///@param
  ///@param report data
  @Post(path: '/v3/participants/reports/{identifier}')
  Future<chopper.Response<Object>> _v3ParticipantsReportsIdentifierPost({
    @Path('identifier') required String? identifier,
    @Body() required ReportDataForWorker? reportData,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a participant report index
  ///@param
  Future<chopper.Response<Object>> v3ParticipantsReportsIdentifierDelete({
    required String? identifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3ParticipantsReportsIdentifierDelete(
        identifier: identifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a participant report index
  ///@param
  @Delete(path: '/v3/participants/reports/{identifier}')
  Future<chopper.Response<Object>> _v3ParticipantsReportsIdentifierDelete({
    @Path('identifier') required String? identifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a single report index for participant reports
  ///@param
  Future<chopper.Response<ReportIndex>>
      v3ParticipantsReportsIdentifierIndexGet({
    required String? identifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ReportIndex, () => ReportIndex.fromJsonFactory);

    return _v3ParticipantsReportsIdentifierIndexGet(
        identifier: identifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a single report index for participant reports
  ///@param
  @Get(path: '/v3/participants/reports/{identifier}/index')
  Future<chopper.Response<ReportIndex>>
      _v3ParticipantsReportsIdentifierIndexGet({
    @Path('identifier') required String? identifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant's history of a task
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      v3ParticipantsUserIdActivitiesTasksTaskIdGet({
    required String? userId,
    required String? taskId,
    String? scheduledOnStart,
    String? scheduledOnEnd,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorScheduledActivityList,
        () => ForwardCursorScheduledActivityList.fromJsonFactory);

    return _v3ParticipantsUserIdActivitiesTasksTaskIdGet(
        userId: userId,
        taskId: taskId,
        scheduledOnStart: scheduledOnStart,
        scheduledOnEnd: scheduledOnEnd,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant's history of a task
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/participants/{userId}/activities/tasks/{taskId}')
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      _v3ParticipantsUserIdActivitiesTasksTaskIdGet({
    @Path('userId') required String? userId,
    @Path('taskId') required String? taskId,
    @Query('scheduledOnStart') String? scheduledOnStart,
    @Query('scheduledOnEnd') String? scheduledOnEnd,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant's history of a survey
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      v3ParticipantsUserIdActivitiesSurveysSurveyGuidGet({
    required String? userId,
    required String? surveyGuid,
    String? scheduledOnStart,
    String? scheduledOnEnd,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorScheduledActivityList,
        () => ForwardCursorScheduledActivityList.fromJsonFactory);

    return _v3ParticipantsUserIdActivitiesSurveysSurveyGuidGet(
        userId: userId,
        surveyGuid: surveyGuid,
        scheduledOnStart: scheduledOnStart,
        scheduledOnEnd: scheduledOnEnd,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant's history of a survey
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/participants/{userId}/activities/surveys/{surveyGuid}')
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      _v3ParticipantsUserIdActivitiesSurveysSurveyGuidGet({
    @Path('userId') required String? userId,
    @Path('surveyGuid') required String? surveyGuid,
    @Query('scheduledOnStart') String? scheduledOnStart,
    @Query('scheduledOnEnd') String? scheduledOnEnd,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant's history of a compound activity
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      v3ParticipantsUserIdActivitiesCompoundactivitiesTaskIdGet({
    required String? userId,
    required String? taskId,
    String? scheduledOnStart,
    String? scheduledOnEnd,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorScheduledActivityList,
        () => ForwardCursorScheduledActivityList.fromJsonFactory);

    return _v3ParticipantsUserIdActivitiesCompoundactivitiesTaskIdGet(
        userId: userId,
        taskId: taskId,
        scheduledOnStart: scheduledOnStart,
        scheduledOnEnd: scheduledOnEnd,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant's history of a compound activity
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/participants/{userId}/activities/compoundactivities/{taskId}')
  Future<chopper.Response<ForwardCursorScheduledActivityList>>
      _v3ParticipantsUserIdActivitiesCompoundactivitiesTaskIdGet({
    @Path('userId') required String? userId,
    @Path('taskId') required String? taskId,
    @Query('scheduledOnStart') String? scheduledOnStart,
    @Query('scheduledOnEnd') String? scheduledOnEnd,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get participant report records
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorReportDataList>>
      v4ParticipantsUserIdReportsIdentifierGet({
    required String? userId,
    required String? identifier,
    required String? startTime,
    required String? endTime,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorReportDataList,
        () => ForwardCursorReportDataList.fromJsonFactory);

    return _v4ParticipantsUserIdReportsIdentifierGet(
        userId: userId,
        identifier: identifier,
        startTime: startTime,
        endTime: endTime,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get participant report records
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v4/participants/{userId}/reports/{identifier}')
  Future<chopper.Response<ForwardCursorReportDataList>>
      _v4ParticipantsUserIdReportsIdentifierGet({
    @Path('userId') required String? userId,
    @Path('identifier') required String? identifier,
    @Query('startTime') required String? startTime,
    @Query('endTime') required String? endTime,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Add a participant report record
  ///@param
  ///@param
  ///@param ReportData
  Future<chopper.Response<Object>> v4ParticipantsUserIdReportsIdentifierPost({
    required String? userId,
    required String? identifier,
    required ReportData? reportData,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ReportData, () => ReportData.fromJsonFactory);

    return _v4ParticipantsUserIdReportsIdentifierPost(
        userId: userId,
        identifier: identifier,
        reportData: reportData,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Add a participant report record
  ///@param
  ///@param
  ///@param ReportData
  @Post(path: '/v4/participants/{userId}/reports/{identifier}')
  Future<chopper.Response<Object>> _v4ParticipantsUserIdReportsIdentifierPost({
    @Path('userId') required String? userId,
    @Path('identifier') required String? identifier,
    @Body() required ReportData? reportData,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a participant report (all records)
  ///@param
  ///@param
  Future<chopper.Response<Object>> v4ParticipantsUserIdReportsIdentifierDelete({
    required String? userId,
    required String? identifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v4ParticipantsUserIdReportsIdentifierDelete(
        userId: userId,
        identifier: identifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a participant report (all records)
  ///@param
  ///@param
  @Delete(path: '/v4/participants/{userId}/reports/{identifier}')
  Future<chopper.Response<Object>>
      _v4ParticipantsUserIdReportsIdentifierDelete({
    @Path('userId') required String? userId,
    @Path('identifier') required String? identifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Request a roster of participants within an app, and optionally within a study if a studyId is provided.
  ///@param ParticipantRosterRequest
  Future<chopper.Response> v3ParticipantsEmailRosterPost({
    required ParticipantRosterRequest? participantRosterRequest,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ParticipantRosterRequest,
        () => ParticipantRosterRequest.fromJsonFactory);

    return _v3ParticipantsEmailRosterPost(
        participantRosterRequest: participantRosterRequest,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Request a roster of participants within an app, and optionally within a study if a studyId is provided.
  ///@param ParticipantRosterRequest
  @Post(path: '/v3/participants/emailRoster')
  Future<chopper.Response> _v3ParticipantsEmailRosterPost({
    @Body() required ParticipantRosterRequest? participantRosterRequest,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Imports the latest published version of a module into the current app.
  ///@param
  Future<chopper.Response<SharedModuleImportStatus>>
      v3SharedmodulesModuleIdImportPost({
    required String? moduleId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(SharedModuleImportStatus,
        () => SharedModuleImportStatus.fromJsonFactory);

    return _v3SharedmodulesModuleIdImportPost(
        moduleId: moduleId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Imports the latest published version of a module into the current app.
  ///@param
  @Post(
    path: '/v3/sharedmodules/{moduleId}/import',
    optionalBody: true,
  )
  Future<chopper.Response<SharedModuleImportStatus>>
      _v3SharedmodulesModuleIdImportPost({
    @Path('moduleId') required String? moduleId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Imports a specific module version into the current app.
  ///@param
  ///@param
  Future<chopper.Response<SharedModuleImportStatus>>
      v3SharedmodulesModuleIdVersionsModuleVersionImportPost({
    required String? moduleId,
    required int? moduleVersion,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(SharedModuleImportStatus,
        () => SharedModuleImportStatus.fromJsonFactory);

    return _v3SharedmodulesModuleIdVersionsModuleVersionImportPost(
        moduleId: moduleId,
        moduleVersion: moduleVersion,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Imports a specific module version into the current app.
  ///@param
  ///@param
  @Post(
    path: '/v3/sharedmodules/{moduleId}/versions/{moduleVersion}/import',
    optionalBody: true,
  )
  Future<chopper.Response<SharedModuleImportStatus>>
      _v3SharedmodulesModuleIdVersionsModuleVersionImportPost({
    @Path('moduleId') required String? moduleId,
    @Path('moduleVersion') required int? moduleVersion,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Queries module metadata using the set of given parameters.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<SharedModuleMetadataList>>
      v3SharedmodulesMetadataGet({
    bool? mostrecent,
    bool? published,
    String? name,
    String? notes,
    String? tags,
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(SharedModuleMetadataList,
        () => SharedModuleMetadataList.fromJsonFactory);

    return _v3SharedmodulesMetadataGet(
        mostrecent: mostrecent,
        published: published,
        name: name,
        notes: notes,
        tags: tags,
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Queries module metadata using the set of given parameters.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/sharedmodules/metadata')
  Future<chopper.Response<SharedModuleMetadataList>>
      _v3SharedmodulesMetadataGet({
    @Query('mostrecent') bool? mostrecent,
    @Query('published') bool? published,
    @Query('name') String? name,
    @Query('notes') String? notes,
    @Query('tags') String? tags,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Creates the specified module metadata.
  ///@param SharedModuleMetadata
  Future<chopper.Response<SharedModuleMetadata>> v3SharedmodulesMetadataPost({
    required SharedModuleMetadata? sharedModuleMetadata,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SharedModuleMetadata, () => SharedModuleMetadata.fromJsonFactory);

    return _v3SharedmodulesMetadataPost(
        sharedModuleMetadata: sharedModuleMetadata,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Creates the specified module metadata.
  ///@param SharedModuleMetadata
  @Post(path: '/v3/sharedmodules/metadata')
  Future<chopper.Response<SharedModuleMetadata>> _v3SharedmodulesMetadataPost({
    @Body() required SharedModuleMetadata? sharedModuleMetadata,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Gets metadata for the latest version of the specified module.
  ///@param
  Future<chopper.Response<SharedModuleMetadata>>
      v3SharedmodulesMetadataModuleIdGet({
    required String? moduleId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SharedModuleMetadata, () => SharedModuleMetadata.fromJsonFactory);

    return _v3SharedmodulesMetadataModuleIdGet(
        moduleId: moduleId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Gets metadata for the latest version of the specified module.
  ///@param
  @Get(path: '/v3/sharedmodules/metadata/{moduleId}')
  Future<chopper.Response<SharedModuleMetadata>>
      _v3SharedmodulesMetadataModuleIdGet({
    @Path('moduleId') required String? moduleId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Similar to queryAllMetadata, except this only queries on module versions of the specified ID.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<SharedModuleMetadataList>>
      v3SharedmodulesMetadataModuleIdVersionsGet({
    required String? moduleId,
    bool? mostrecent,
    bool? published,
    String? name,
    String? notes,
    String? tags,
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(SharedModuleMetadataList,
        () => SharedModuleMetadataList.fromJsonFactory);

    return _v3SharedmodulesMetadataModuleIdVersionsGet(
        moduleId: moduleId,
        mostrecent: mostrecent,
        published: published,
        name: name,
        notes: notes,
        tags: tags,
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Similar to queryAllMetadata, except this only queries on module versions of the specified ID.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/sharedmodules/metadata/{moduleId}/versions')
  Future<chopper.Response<SharedModuleMetadataList>>
      _v3SharedmodulesMetadataModuleIdVersionsGet({
    @Path('moduleId') required String? moduleId,
    @Query('mostrecent') bool? mostrecent,
    @Query('published') bool? published,
    @Query('name') String? name,
    @Query('notes') String? notes,
    @Query('tags') String? tags,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Deletes all metadata for module versions with the given ID.
  ///@param
  ///@param
  Future<chopper.Response<Object>>
      v3SharedmodulesMetadataModuleIdVersionsDelete({
    required String? moduleId,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3SharedmodulesMetadataModuleIdVersionsDelete(
        moduleId: moduleId,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Deletes all metadata for module versions with the given ID.
  ///@param
  ///@param
  @Delete(path: '/v3/sharedmodules/metadata/{moduleId}/versions')
  Future<chopper.Response<Object>>
      _v3SharedmodulesMetadataModuleIdVersionsDelete({
    @Path('moduleId') required String? moduleId,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Gets metadata for the specified version of the specified module.
  ///@param
  ///@param
  Future<chopper.Response<SharedModuleMetadata>>
      v3SharedmodulesMetadataModuleIdVersionsModuleVersionGet({
    required String? moduleId,
    required int? moduleVersion,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SharedModuleMetadata, () => SharedModuleMetadata.fromJsonFactory);

    return _v3SharedmodulesMetadataModuleIdVersionsModuleVersionGet(
        moduleId: moduleId,
        moduleVersion: moduleVersion,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Gets metadata for the specified version of the specified module.
  ///@param
  ///@param
  @Get(path: '/v3/sharedmodules/metadata/{moduleId}/versions/{moduleVersion}')
  Future<chopper.Response<SharedModuleMetadata>>
      _v3SharedmodulesMetadataModuleIdVersionsModuleVersionGet({
    @Path('moduleId') required String? moduleId,
    @Path('moduleVersion') required int? moduleVersion,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Updates metadata for the specified module version.
  ///@param
  ///@param
  ///@param SharedModuleMetadata
  Future<chopper.Response<SharedModuleMetadata>>
      v3SharedmodulesMetadataModuleIdVersionsModuleVersionPost({
    required String? moduleId,
    required int? moduleVersion,
    required SharedModuleMetadata? sharedModuleMetadata,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SharedModuleMetadata, () => SharedModuleMetadata.fromJsonFactory);

    return _v3SharedmodulesMetadataModuleIdVersionsModuleVersionPost(
        moduleId: moduleId,
        moduleVersion: moduleVersion,
        sharedModuleMetadata: sharedModuleMetadata,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Updates metadata for the specified module version.
  ///@param
  ///@param
  ///@param SharedModuleMetadata
  @Post(path: '/v3/sharedmodules/metadata/{moduleId}/versions/{moduleVersion}')
  Future<chopper.Response<SharedModuleMetadata>>
      _v3SharedmodulesMetadataModuleIdVersionsModuleVersionPost({
    @Path('moduleId') required String? moduleId,
    @Path('moduleVersion') required int? moduleVersion,
    @Body() required SharedModuleMetadata? sharedModuleMetadata,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Deletes metadata for the specified module ID and version.
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<Object>>
      v3SharedmodulesMetadataModuleIdVersionsModuleVersionDelete({
    required String? moduleId,
    required int? moduleVersion,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3SharedmodulesMetadataModuleIdVersionsModuleVersionDelete(
        moduleId: moduleId,
        moduleVersion: moduleVersion,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Deletes metadata for the specified module ID and version.
  ///@param
  ///@param
  ///@param
  @Delete(
      path: '/v3/sharedmodules/metadata/{moduleId}/versions/{moduleVersion}')
  Future<chopper.Response<Object>>
      _v3SharedmodulesMetadataModuleIdVersionsModuleVersionDelete({
    @Path('moduleId') required String? moduleId,
    @Path('moduleVersion') required int? moduleVersion,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get all subpopulations in this app. This is temporarily accessible to study coordinators until we build v2 of our consent system.
  ///@param
  Future<chopper.Response<SubpopulationList>> v3SubpopulationsGet({
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SubpopulationList, () => SubpopulationList.fromJsonFactory);

    return _v3SubpopulationsGet(
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get all subpopulations in this app. This is temporarily accessible to study coordinators until we build v2 of our consent system.
  ///@param
  @Get(path: '/v3/subpopulations')
  Future<chopper.Response<SubpopulationList>> _v3SubpopulationsGet({
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new subpopulation
  ///@param Subpopulation New subpopulation
  Future<chopper.Response<GuidVersionHolder>> v3SubpopulationsPost({
    required Subpopulation? subpopulation,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Subpopulation, () => Subpopulation.fromJsonFactory);
    generatedMapping.putIfAbsent(
        GuidVersionHolder, () => GuidVersionHolder.fromJsonFactory);

    return _v3SubpopulationsPost(
        subpopulation: subpopulation,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new subpopulation
  ///@param Subpopulation New subpopulation
  @Post(path: '/v3/subpopulations')
  Future<chopper.Response<GuidVersionHolder>> _v3SubpopulationsPost({
    @Body() required Subpopulation? subpopulation,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a subpopulation
  ///@param
  Future<chopper.Response<Subpopulation>> v3SubpopulationsSubpopulationGuidGet({
    required String? subpopulationGuid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Subpopulation, () => Subpopulation.fromJsonFactory);

    return _v3SubpopulationsSubpopulationGuidGet(
        subpopulationGuid: subpopulationGuid,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a subpopulation
  ///@param
  @Get(path: '/v3/subpopulations/{subpopulationGuid}')
  Future<chopper.Response<Subpopulation>>
      _v3SubpopulationsSubpopulationGuidGet({
    @Path('subpopulationGuid') required String? subpopulationGuid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update an existing subpopulation
  ///@param
  ///@param Subpopulation A subpopulation
  Future<chopper.Response<GuidVersionHolder>>
      v3SubpopulationsSubpopulationGuidPost({
    required String? subpopulationGuid,
    required Subpopulation? subpopulation,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        Subpopulation, () => Subpopulation.fromJsonFactory);
    generatedMapping.putIfAbsent(
        GuidVersionHolder, () => GuidVersionHolder.fromJsonFactory);

    return _v3SubpopulationsSubpopulationGuidPost(
        subpopulationGuid: subpopulationGuid,
        subpopulation: subpopulation,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update an existing subpopulation
  ///@param
  ///@param Subpopulation A subpopulation
  @Post(path: '/v3/subpopulations/{subpopulationGuid}')
  Future<chopper.Response<GuidVersionHolder>>
      _v3SubpopulationsSubpopulationGuidPost({
    @Path('subpopulationGuid') required String? subpopulationGuid,
    @Body() required Subpopulation? subpopulation,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a subpopulation
  ///@param
  ///@param
  Future<chopper.Response<Object>> v3SubpopulationsSubpopulationGuidDelete({
    required String? subpopulationGuid,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3SubpopulationsSubpopulationGuidDelete(
        subpopulationGuid: subpopulationGuid,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a subpopulation
  ///@param
  ///@param
  @Delete(path: '/v3/subpopulations/{subpopulationGuid}')
  Future<chopper.Response<Object>> _v3SubpopulationsSubpopulationGuidDelete({
    @Path('subpopulationGuid') required String? subpopulationGuid,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the participant's consent signature for the subpopulation
  ///@param
  Future<chopper.Response<ConsentSignature>>
      v3SubpopulationsSubpopulationGuidConsentsSignatureGet({
    required String? subpopulationGuid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ConsentSignature, () => ConsentSignature.fromJsonFactory);

    return _v3SubpopulationsSubpopulationGuidConsentsSignatureGet(
        subpopulationGuid: subpopulationGuid,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the participant's consent signature for the subpopulation
  ///@param
  @Get(path: '/v3/subpopulations/{subpopulationGuid}/consents/signature')
  Future<chopper.Response<ConsentSignature>>
      _v3SubpopulationsSubpopulationGuidConsentsSignatureGet({
    @Path('subpopulationGuid') required String? subpopulationGuid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Consent to this subpopulation by submitting a signature
  ///@param
  ///@param ConsentSignature A consent signature
  Future<chopper.Response<UserSessionInfo>>
      v3SubpopulationsSubpopulationGuidConsentsSignaturePost({
    required String? subpopulationGuid,
    required ConsentSignature? consentSignature,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ConsentSignature, () => ConsentSignature.fromJsonFactory);
    generatedMapping.putIfAbsent(
        UserSessionInfo, () => UserSessionInfo.fromJsonFactory);

    return _v3SubpopulationsSubpopulationGuidConsentsSignaturePost(
        subpopulationGuid: subpopulationGuid,
        consentSignature: consentSignature,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Consent to this subpopulation by submitting a signature
  ///@param
  ///@param ConsentSignature A consent signature
  @Post(path: '/v3/subpopulations/{subpopulationGuid}/consents/signature')
  Future<chopper.Response<UserSessionInfo>>
      _v3SubpopulationsSubpopulationGuidConsentsSignaturePost({
    @Path('subpopulationGuid') required String? subpopulationGuid,
    @Body() required ConsentSignature? consentSignature,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Withdraw participant from this subpopulation consent group
  ///@param
  ///@param withdrawal
  Future<chopper.Response<UserSessionInfo>>
      v3SubpopulationsSubpopulationGuidConsentsSignatureWithdrawPost({
    required String? subpopulationGuid,
    required Withdrawal? withdrawal,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Withdrawal, () => Withdrawal.fromJsonFactory);
    generatedMapping.putIfAbsent(
        UserSessionInfo, () => UserSessionInfo.fromJsonFactory);

    return _v3SubpopulationsSubpopulationGuidConsentsSignatureWithdrawPost(
        subpopulationGuid: subpopulationGuid,
        withdrawal: withdrawal,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Withdraw participant from this subpopulation consent group
  ///@param
  ///@param withdrawal
  @Post(
      path:
          '/v3/subpopulations/{subpopulationGuid}/consents/signature/withdraw')
  Future<chopper.Response<UserSessionInfo>>
      _v3SubpopulationsSubpopulationGuidConsentsSignatureWithdrawPost({
    @Path('subpopulationGuid') required String? subpopulationGuid,
    @Body() required Withdrawal? withdrawal,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Email or SMS the consent agreement to the participant
  ///@param
  Future<chopper.Response<Object>>
      v3SubpopulationsSubpopulationGuidConsentsSignatureResendPost({
    required String? subpopulationGuid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3SubpopulationsSubpopulationGuidConsentsSignatureResendPost(
        subpopulationGuid: subpopulationGuid,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Email or SMS the consent agreement to the participant
  ///@param
  @Post(
    path: '/v3/subpopulations/{subpopulationGuid}/consents/signature/resend',
    optionalBody: true,
  )
  Future<chopper.Response<Object>>
      _v3SubpopulationsSubpopulationGuidConsentsSignatureResendPost({
    @Path('subpopulationGuid') required String? subpopulationGuid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get all revisions of the consent in a app's default subpopulation
  Future<chopper.Response<StudyConsentList>> v3ConsentsGet({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyConsentList, () => StudyConsentList.fromJsonFactory);

    return _v3ConsentsGet(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get all revisions of the consent in a app's default subpopulation
  @Get(path: '/v3/consents')
  Future<chopper.Response<StudyConsentList>> _v3ConsentsGet({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Add new consent revision to the app's default subpopulation
  Future<chopper.Response<StudyConsent>> v3ConsentsPost({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyConsent, () => StudyConsent.fromJsonFactory);

    return _v3ConsentsPost(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Add new consent revision to the app's default subpopulation
  @Post(
    path: '/v3/consents',
    optionalBody: true,
  )
  Future<chopper.Response<StudyConsent>> _v3ConsentsPost({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get most recent revision of a app's default subpopulation
  Future<chopper.Response<StudyConsent>> v3ConsentsRecentGet({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyConsent, () => StudyConsent.fromJsonFactory);

    return _v3ConsentsRecentGet(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get most recent revision of a app's default subpopulation
  @Get(path: '/v3/consents/recent')
  Future<chopper.Response<StudyConsent>> _v3ConsentsRecentGet({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get most recently published revision of a app's default subpopulation
  Future<chopper.Response<StudyConsent>> v3ConsentsPublishedGet({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyConsent, () => StudyConsent.fromJsonFactory);

    return _v3ConsentsPublishedGet(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get most recently published revision of a app's default subpopulation
  @Get(path: '/v3/consents/published')
  Future<chopper.Response<StudyConsent>> _v3ConsentsPublishedGet({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get specific revision of a app's default subpopulation
  ///@param
  Future<chopper.Response<StudyConsent>> v3ConsentsCreatedOnGet({
    required String? createdOn,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyConsent, () => StudyConsent.fromJsonFactory);

    return _v3ConsentsCreatedOnGet(
        createdOn: createdOn,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get specific revision of a app's default subpopulation
  ///@param
  @Get(path: '/v3/consents/{createdOn}')
  Future<chopper.Response<StudyConsent>> _v3ConsentsCreatedOnGet({
    @Path('createdOn') required String? createdOn,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Withdraw user from all studies in app
  ///@param withdrawal
  Future<chopper.Response<Object>> v3ConsentsWithdrawPost({
    required Withdrawal? withdrawal,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Withdrawal, () => Withdrawal.fromJsonFactory);

    return _v3ConsentsWithdrawPost(
        withdrawal: withdrawal,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Withdraw user from all studies in app
  ///@param withdrawal
  @Post(path: '/v3/consents/withdraw')
  Future<chopper.Response<Object>> _v3ConsentsWithdrawPost({
    @Body() required Withdrawal? withdrawal,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a list of all consents for this subpopulation
  ///@param
  Future<chopper.Response<StudyConsentList>>
      v3SubpopulationsSubpopulationGuidConsentsGet({
    required String? subpopulationGuid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyConsentList, () => StudyConsentList.fromJsonFactory);

    return _v3SubpopulationsSubpopulationGuidConsentsGet(
        subpopulationGuid: subpopulationGuid,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a list of all consents for this subpopulation
  ///@param
  @Get(path: '/v3/subpopulations/{subpopulationGuid}/consents')
  Future<chopper.Response<StudyConsentList>>
      _v3SubpopulationsSubpopulationGuidConsentsGet({
    @Path('subpopulationGuid') required String? subpopulationGuid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Add a new study consent version to this subpopulation
  ///@param
  ///@param Study consent Study consent
  Future<chopper.Response<Object>>
      v3SubpopulationsSubpopulationGuidConsentsPost({
    required String? subpopulationGuid,
    required StudyConsent? studyConsent,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyConsent, () => StudyConsent.fromJsonFactory);

    return _v3SubpopulationsSubpopulationGuidConsentsPost(
        subpopulationGuid: subpopulationGuid,
        studyConsent: studyConsent,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Add a new study consent version to this subpopulation
  ///@param
  ///@param Study consent Study consent
  @Post(path: '/v3/subpopulations/{subpopulationGuid}/consents')
  Future<chopper.Response<Object>>
      _v3SubpopulationsSubpopulationGuidConsentsPost({
    @Path('subpopulationGuid') required String? subpopulationGuid,
    @Body() required StudyConsent? studyConsent,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the most recently created consent revision
  ///@param
  Future<chopper.Response<StudyConsent>>
      v3SubpopulationsSubpopulationGuidConsentsRecentGet({
    required String? subpopulationGuid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyConsent, () => StudyConsent.fromJsonFactory);

    return _v3SubpopulationsSubpopulationGuidConsentsRecentGet(
        subpopulationGuid: subpopulationGuid,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the most recently created consent revision
  ///@param
  @Get(path: '/v3/subpopulations/{subpopulationGuid}/consents/recent')
  Future<chopper.Response<StudyConsent>>
      _v3SubpopulationsSubpopulationGuidConsentsRecentGet({
    @Path('subpopulationGuid') required String? subpopulationGuid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the published consent revision
  ///@param
  Future<chopper.Response<StudyConsent>>
      v3SubpopulationsSubpopulationGuidConsentsPublishedGet({
    required String? subpopulationGuid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyConsent, () => StudyConsent.fromJsonFactory);

    return _v3SubpopulationsSubpopulationGuidConsentsPublishedGet(
        subpopulationGuid: subpopulationGuid,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the published consent revision
  ///@param
  @Get(path: '/v3/subpopulations/{subpopulationGuid}/consents/published')
  Future<chopper.Response<StudyConsent>>
      _v3SubpopulationsSubpopulationGuidConsentsPublishedGet({
    @Path('subpopulationGuid') required String? subpopulationGuid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a specific consent revision
  ///@param
  ///@param createdOn creation timestamp of the revision
  Future<chopper.Response<StudyConsent>>
      v3SubpopulationsSubpopulationGuidConsentsCreatedOnGet({
    required String? subpopulationGuid,
    required String? createdOn,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyConsent, () => StudyConsent.fromJsonFactory);

    return _v3SubpopulationsSubpopulationGuidConsentsCreatedOnGet(
        subpopulationGuid: subpopulationGuid,
        createdOn: createdOn,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a specific consent revision
  ///@param
  ///@param createdOn creation timestamp of the revision
  @Get(path: '/v3/subpopulations/{subpopulationGuid}/consents/{createdOn}')
  Future<chopper.Response<StudyConsent>>
      _v3SubpopulationsSubpopulationGuidConsentsCreatedOnGet({
    @Path('subpopulationGuid') required String? subpopulationGuid,
    @Path('createdOn') required String? createdOn,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Publish a specific consent revision
  ///@param
  ///@param createdOn creation timestamp of the revision
  Future<chopper.Response<Object>>
      v3SubpopulationsSubpopulationGuidConsentsCreatedOnPublishPost({
    required String? subpopulationGuid,
    required String? createdOn,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3SubpopulationsSubpopulationGuidConsentsCreatedOnPublishPost(
        subpopulationGuid: subpopulationGuid,
        createdOn: createdOn,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Publish a specific consent revision
  ///@param
  ///@param createdOn creation timestamp of the revision
  @Post(
    path: '/v3/subpopulations/{subpopulationGuid}/consents/{createdOn}/publish',
    optionalBody: true,
  )
  Future<chopper.Response<Object>>
      _v3SubpopulationsSubpopulationGuidConsentsCreatedOnPublishPost({
    @Path('subpopulationGuid') required String? subpopulationGuid,
    @Path('createdOn') required String? createdOn,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new user
  ///@param SignUp New user
  Future<chopper.Response<UserSessionInfo>> v3UsersPost({
    required SignUp? signUp,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UserSessionInfo, () => UserSessionInfo.fromJsonFactory);

    return _v3UsersPost(
        signUp: signUp,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new user
  ///@param SignUp New user
  @Post(path: '/v3/users')
  Future<chopper.Response<UserSessionInfo>> _v3UsersPost({
    @Body() required SignUp? signUp,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a user
  ///@param
  Future<chopper.Response<Object>> v3UsersUserIdDelete({
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3UsersUserIdDelete(
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a user
  ///@param
  @Delete(path: '/v3/users/{userId}')
  Future<chopper.Response<Object>> _v3UsersUserIdDelete({
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Change the participant's sharing scope
  ///@param SharingScope Sharing scope
  Future<chopper.Response> v3UsersSelfDataSharingPost({
    required SharingScopeForm? sharingScope,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SharingScopeForm, () => SharingScopeForm.fromJsonFactory);

    return _v3UsersSelfDataSharingPost(
        sharingScope: sharingScope,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Change the participant's sharing scope
  ///@param SharingScope Sharing scope
  @Post(path: '/v3/users/self/dataSharing')
  Future<chopper.Response> _v3UsersSelfDataSharingPost({
    @Body() required SharingScopeForm? sharingScope,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Make user's data available for download via email or an SMS message
  ///@param DateRange startDate and endDate of the request.
  Future<chopper.Response> v3UsersSelfSendDataPost({
    required DateRange? dateRange,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(DateRange, () => DateRange.fromJsonFactory);

    return _v3UsersSelfSendDataPost(
        dateRange: dateRange,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Make user's data available for download via email or an SMS message
  ///@param DateRange startDate and endDate of the request.
  @Post(path: '/v3/users/self/sendData')
  Future<chopper.Response> _v3UsersSelfSendDataPost({
    @Body() required DateRange? dateRange,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a participant report
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ReportDataList>> v3UsersSelfReportsIdentifierGet({
    required String? identifier,
    required String? startDate,
    required String? endDate,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ReportDataList, () => ReportDataList.fromJsonFactory);

    return _v3UsersSelfReportsIdentifierGet(
        identifier: identifier,
        startDate: startDate,
        endDate: endDate,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a participant report
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/users/self/reports/{identifier}')
  Future<chopper.Response<ReportDataList>> _v3UsersSelfReportsIdentifierGet({
    @Path('identifier') required String? identifier,
    @Query('startDate') required String? startDate,
    @Query('endDate') required String? endDate,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a participant report
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorReportDataList>>
      v4UsersSelfReportsIdentifierGet({
    required String? identifier,
    required String? startTime,
    required String? endTime,
    int? pageSize,
    String? offsetKey,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorReportDataList,
        () => ForwardCursorReportDataList.fromJsonFactory);

    return _v4UsersSelfReportsIdentifierGet(
        identifier: identifier,
        startTime: startTime,
        endTime: endTime,
        pageSize: pageSize,
        offsetKey: offsetKey,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a participant report
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v4/users/self/reports/{identifier}')
  Future<chopper.Response<ForwardCursorReportDataList>>
      _v4UsersSelfReportsIdentifierGet({
    @Path('identifier') required String? identifier,
    @Query('startTime') required String? startTime,
    @Query('endTime') required String? endTime,
    @Query('pageSize') int? pageSize,
    @Query('offsetKey') String? offsetKey,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Save a participant report record
  ///@param
  ///@param ReportData
  Future<chopper.Response<Message>> v4UsersSelfReportsIdentifierPost({
    required String? identifier,
    required ReportData? reportData,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ReportData, () => ReportData.fromJsonFactory);
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v4UsersSelfReportsIdentifierPost(
        identifier: identifier,
        reportData: reportData,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Save a participant report record
  ///@param
  ///@param ReportData
  @Post(path: '/v4/users/self/reports/{identifier}')
  Future<chopper.Response<Message>> _v4UsersSelfReportsIdentifierPost({
    @Path('identifier') required String? identifier,
    @Body() required ReportData? reportData,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get list of identifiers for participant data
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorStringList>> v3UsersSelfDataGet({
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ForwardCursorStringList, () => ForwardCursorStringList.fromJsonFactory);

    return _v3UsersSelfDataGet(
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get list of identifiers for participant data
  ///@param
  ///@param
  @Get(path: '/v3/users/self/data')
  Future<chopper.Response<ForwardCursorStringList>> _v3UsersSelfDataGet({
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get user's data based on the given identifier
  ///@param
  Future<chopper.Response<ParticipantData>> v3UsersSelfDataIdentifierGet({
    required String? identifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ParticipantData, () => ParticipantData.fromJsonFactory);

    return _v3UsersSelfDataIdentifierGet(
        identifier: identifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get user's data based on the given identifier
  ///@param
  @Get(path: '/v3/users/self/data/{identifier}')
  Future<chopper.Response<ParticipantData>> _v3UsersSelfDataIdentifierGet({
    @Path('identifier') required String? identifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Save a participant data record
  ///@param
  ///@param ParticipantData
  Future<chopper.Response<Message>> v3UsersSelfDataIdentifierPost({
    required String? identifier,
    required ParticipantData? participantData,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ParticipantData, () => ParticipantData.fromJsonFactory);
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v3UsersSelfDataIdentifierPost(
        identifier: identifier,
        participantData: participantData,
        cacheControl: cacheControl);
  }

  ///Save a participant data record
  ///@param
  ///@param ParticipantData
  @Post(path: '/v3/users/self/data/{identifier}')
  Future<chopper.Response<Message>> _v3UsersSelfDataIdentifierPost({
    @Path('identifier') required String? identifier,
    @Body() required ParticipantData? participantData,
    @Header('Cache-Control') String? cacheControl,
  });

  ///delete a participant data record
  ///@param
  Future<chopper.Response<Message>> v3UsersSelfDataIdentifierDelete({
    required String? identifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v3UsersSelfDataIdentifierDelete(
        identifier: identifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///delete a participant data record
  ///@param
  @Delete(path: '/v3/users/self/data/{identifier}')
  Future<chopper.Response<Message>> _v3UsersSelfDataIdentifierDelete({
    @Path('identifier') required String? identifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get list of report indices for studies
  Future<chopper.Response<ReportIndexList>> v3ReportsGet({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ReportIndexList, () => ReportIndexList.fromJsonFactory);

    return _v3ReportsGet(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get list of report indices for studies
  @Get(path: '/v3/reports')
  Future<chopper.Response<ReportIndexList>> _v3ReportsGet({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get study report records
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ReportDataList>> v3ReportsIdentifierGet({
    required String? identifier,
    required String? startDate,
    required String? endDate,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ReportDataList, () => ReportDataList.fromJsonFactory);

    return _v3ReportsIdentifierGet(
        identifier: identifier,
        startDate: startDate,
        endDate: endDate,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get study report records
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/reports/{identifier}')
  Future<chopper.Response<ReportDataList>> _v3ReportsIdentifierGet({
    @Path('identifier') required String? identifier,
    @Query('startDate') required String? startDate,
    @Query('endDate') required String? endDate,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a  report index
  ///@param
  Future<chopper.Response<ReportIndex>> v3ReportsIdentifierIndexGet({
    required String? identifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ReportIndex, () => ReportIndex.fromJsonFactory);

    return _v3ReportsIdentifierIndexGet(
        identifier: identifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a  report index
  ///@param
  @Get(path: '/v3/reports/{identifier}/index')
  Future<chopper.Response<ReportIndex>> _v3ReportsIdentifierIndexGet({
    @Path('identifier') required String? identifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update an existing study report index
  ///@param
  ///@param ReportIndex Report index
  Future<chopper.Response<Object>> v3ReportsIdentifierIndexPost({
    required String? identifier,
    required ReportIndex? reportIndex,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ReportIndex, () => ReportIndex.fromJsonFactory);

    return _v3ReportsIdentifierIndexPost(
        identifier: identifier,
        reportIndex: reportIndex,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update an existing study report index
  ///@param
  ///@param ReportIndex Report index
  @Post(path: '/v3/reports/{identifier}/index')
  Future<chopper.Response<Object>> _v3ReportsIdentifierIndexPost({
    @Path('identifier') required String? identifier,
    @Body() required ReportIndex? reportIndex,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a record for a specific day of a study report
  ///@param
  ///@param date Date of records
  Future<chopper.Response<Object>> v3ReportsIdentifierDateDelete({
    required String? identifier,
    required String? date,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3ReportsIdentifierDateDelete(
        identifier: identifier,
        date: date,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a record for a specific day of a study report
  ///@param
  ///@param date Date of records
  @Delete(path: '/v3/reports/{identifier}/{date}')
  Future<chopper.Response<Object>> _v3ReportsIdentifierDateDelete({
    @Path('identifier') required String? identifier,
    @Path('date') required String? date,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get study report records
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorReportDataList>> v4ReportsIdentifierGet({
    required String? identifier,
    required String? startTime,
    required String? endTime,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorReportDataList,
        () => ForwardCursorReportDataList.fromJsonFactory);

    return _v4ReportsIdentifierGet(
        identifier: identifier,
        startTime: startTime,
        endTime: endTime,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get study report records
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v4/reports/{identifier}')
  Future<chopper.Response<ForwardCursorReportDataList>>
      _v4ReportsIdentifierGet({
    @Path('identifier') required String? identifier,
    @Query('startTime') required String? startTime,
    @Query('endTime') required String? endTime,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Add a record to a study report
  ///@param
  ///@param ReportData Report data
  Future<chopper.Response<Object>> v4ReportsIdentifierPost({
    required String? identifier,
    required ReportData? reportData,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ReportData, () => ReportData.fromJsonFactory);

    return _v4ReportsIdentifierPost(
        identifier: identifier,
        reportData: reportData,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Add a record to a study report
  ///@param
  ///@param ReportData Report data
  @Post(path: '/v4/reports/{identifier}')
  Future<chopper.Response<Object>> _v4ReportsIdentifierPost({
    @Path('identifier') required String? identifier,
    @Body() required ReportData? reportData,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a study report (all records)
  ///@param
  Future<chopper.Response<Object>> v4ReportsIdentifierDelete({
    required String? identifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v4ReportsIdentifierDelete(
        identifier: identifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a study report (all records)
  ///@param
  @Delete(path: '/v4/reports/{identifier}')
  Future<chopper.Response<Object>> _v4ReportsIdentifierDelete({
    @Path('identifier') required String? identifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get most recent version of each survey
  ///@param
  Future<chopper.Response<SurveyList>> v3SurveysGet({
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(SurveyList, () => SurveyList.fromJsonFactory);

    return _v3SurveysGet(
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get most recent version of each survey
  ///@param
  @Get(path: '/v3/surveys')
  Future<chopper.Response<SurveyList>> _v3SurveysGet({
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new survey
  ///@param survey
  Future<chopper.Response<GuidCreatedOnVersionHolder>> v3SurveysPost({
    required Survey? survey,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Survey, () => Survey.fromJsonFactory);
    generatedMapping.putIfAbsent(GuidCreatedOnVersionHolder,
        () => GuidCreatedOnVersionHolder.fromJsonFactory);

    return _v3SurveysPost(
        survey: survey,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new survey
  ///@param survey
  @Post(path: '/v3/surveys')
  Future<chopper.Response<GuidCreatedOnVersionHolder>> _v3SurveysPost({
    @Body() required Survey? survey,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the most recently published version of each survey
  ///@param
  Future<chopper.Response<SurveyList>> v3SurveysPublishedGet({
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(SurveyList, () => SurveyList.fromJsonFactory);

    return _v3SurveysPublishedGet(
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the most recently published version of each survey
  ///@param
  @Get(path: '/v3/surveys/published')
  Future<chopper.Response<SurveyList>> _v3SurveysPublishedGet({
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get all revisions of a survey
  ///@param
  ///@param
  Future<chopper.Response<SurveyList>> v3SurveysSurveyGuidRevisionsGet({
    required String? surveyGuid,
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(SurveyList, () => SurveyList.fromJsonFactory);

    return _v3SurveysSurveyGuidRevisionsGet(
        surveyGuid: surveyGuid,
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get all revisions of a survey
  ///@param
  ///@param
  @Get(path: '/v3/surveys/{surveyGuid}/revisions')
  Future<chopper.Response<SurveyList>> _v3SurveysSurveyGuidRevisionsGet({
    @Path('surveyGuid') required String? surveyGuid,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get most recent revision of a survey
  ///@param
  Future<chopper.Response<Survey>> v3SurveysSurveyGuidRevisionsRecentGet({
    required String? surveyGuid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Survey, () => Survey.fromJsonFactory);

    return _v3SurveysSurveyGuidRevisionsRecentGet(
        surveyGuid: surveyGuid,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get most recent revision of a survey
  ///@param
  @Get(path: '/v3/surveys/{surveyGuid}/revisions/recent')
  Future<chopper.Response<Survey>> _v3SurveysSurveyGuidRevisionsRecentGet({
    @Path('surveyGuid') required String? surveyGuid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get most recently published revision of a survey
  ///@param
  Future<chopper.Response<Survey>> v3SurveysSurveyGuidRevisionsPublishedGet({
    required String? surveyGuid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Survey, () => Survey.fromJsonFactory);

    return _v3SurveysSurveyGuidRevisionsPublishedGet(
        surveyGuid: surveyGuid,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get most recently published revision of a survey
  ///@param
  @Get(path: '/v3/surveys/{surveyGuid}/revisions/published')
  Future<chopper.Response<Survey>> _v3SurveysSurveyGuidRevisionsPublishedGet({
    @Path('surveyGuid') required String? surveyGuid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a survey revision
  ///@param
  ///@param
  Future<chopper.Response<Survey>> v3SurveysSurveyGuidRevisionsCreatedOnGet({
    required String? surveyGuid,
    required String? createdOn,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Survey, () => Survey.fromJsonFactory);

    return _v3SurveysSurveyGuidRevisionsCreatedOnGet(
        surveyGuid: surveyGuid,
        createdOn: createdOn,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a survey revision
  ///@param
  ///@param
  @Get(path: '/v3/surveys/{surveyGuid}/revisions/{createdOn}')
  Future<chopper.Response<Survey>> _v3SurveysSurveyGuidRevisionsCreatedOnGet({
    @Path('surveyGuid') required String? surveyGuid,
    @Path('createdOn') required String? createdOn,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update a non-published survey revision
  ///@param
  ///@param
  ///@param Survey Updated survey
  Future<chopper.Response<GuidCreatedOnVersionHolder>>
      v3SurveysSurveyGuidRevisionsCreatedOnPost({
    required String? surveyGuid,
    required String? createdOn,
    required Survey? survey,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Survey, () => Survey.fromJsonFactory);
    generatedMapping.putIfAbsent(GuidCreatedOnVersionHolder,
        () => GuidCreatedOnVersionHolder.fromJsonFactory);

    return _v3SurveysSurveyGuidRevisionsCreatedOnPost(
        surveyGuid: surveyGuid,
        createdOn: createdOn,
        survey: survey,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update a non-published survey revision
  ///@param
  ///@param
  ///@param Survey Updated survey
  @Post(path: '/v3/surveys/{surveyGuid}/revisions/{createdOn}')
  Future<chopper.Response<GuidCreatedOnVersionHolder>>
      _v3SurveysSurveyGuidRevisionsCreatedOnPost({
    @Path('surveyGuid') required String? surveyGuid,
    @Path('createdOn') required String? createdOn,
    @Body() required Survey? survey,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a survey version
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<Object>> v3SurveysSurveyGuidRevisionsCreatedOnDelete({
    required String? surveyGuid,
    required String? createdOn,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3SurveysSurveyGuidRevisionsCreatedOnDelete(
        surveyGuid: surveyGuid,
        createdOn: createdOn,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a survey version
  ///@param
  ///@param
  ///@param
  @Delete(path: '/v3/surveys/{surveyGuid}/revisions/{createdOn}')
  Future<chopper.Response<Object>>
      _v3SurveysSurveyGuidRevisionsCreatedOnDelete({
    @Path('surveyGuid') required String? surveyGuid,
    @Path('createdOn') required String? createdOn,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Version a survey
  ///@param
  ///@param
  Future<chopper.Response<GuidCreatedOnVersionHolder>>
      v3SurveysSurveyGuidRevisionsCreatedOnVersionPost({
    required String? surveyGuid,
    required String? createdOn,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(GuidCreatedOnVersionHolder,
        () => GuidCreatedOnVersionHolder.fromJsonFactory);

    return _v3SurveysSurveyGuidRevisionsCreatedOnVersionPost(
        surveyGuid: surveyGuid,
        createdOn: createdOn,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Version a survey
  ///@param
  ///@param
  @Post(
    path: '/v3/surveys/{surveyGuid}/revisions/{createdOn}/version',
    optionalBody: true,
  )
  Future<chopper.Response<GuidCreatedOnVersionHolder>>
      _v3SurveysSurveyGuidRevisionsCreatedOnVersionPost({
    @Path('surveyGuid') required String? surveyGuid,
    @Path('createdOn') required String? createdOn,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Publish a survey
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<GuidCreatedOnVersionHolder>>
      v3SurveysSurveyGuidRevisionsCreatedOnPublishPost({
    required String? surveyGuid,
    required String? createdOn,
    bool? newSchemaRev,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(GuidCreatedOnVersionHolder,
        () => GuidCreatedOnVersionHolder.fromJsonFactory);

    return _v3SurveysSurveyGuidRevisionsCreatedOnPublishPost(
        surveyGuid: surveyGuid,
        createdOn: createdOn,
        newSchemaRev: newSchemaRev,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Publish a survey
  ///@param
  ///@param
  ///@param
  @Post(
    path: '/v3/surveys/{surveyGuid}/revisions/{createdOn}/publish',
    optionalBody: true,
  )
  Future<chopper.Response<GuidCreatedOnVersionHolder>>
      _v3SurveysSurveyGuidRevisionsCreatedOnPublishPost({
    @Path('surveyGuid') required String? surveyGuid,
    @Path('createdOn') required String? createdOn,
    @Query('newSchemaRev') bool? newSchemaRev,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get all of a user's notification registrations
  Future<chopper.Response<NotificationRegistrationList>> v3NotificationsGet({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(NotificationRegistrationList,
        () => NotificationRegistrationList.fromJsonFactory);

    return _v3NotificationsGet(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get all of a user's notification registrations
  @Get(path: '/v3/notifications')
  Future<chopper.Response<NotificationRegistrationList>> _v3NotificationsGet({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Register a client to receive push notifications
  ///@param NotificationRegistration
  Future<chopper.Response<GuidHolder>> v3NotificationsPost({
    required NotificationRegistration? notificationRegistration,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(NotificationRegistration,
        () => NotificationRegistration.fromJsonFactory);
    generatedMapping.putIfAbsent(GuidHolder, () => GuidHolder.fromJsonFactory);

    return _v3NotificationsPost(
        notificationRegistration: notificationRegistration,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Register a client to receive push notifications
  ///@param NotificationRegistration
  @Post(path: '/v3/notifications')
  Future<chopper.Response<GuidHolder>> _v3NotificationsPost({
    @Body() required NotificationRegistration? notificationRegistration,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a push notification registration
  ///@param
  Future<chopper.Response<NotificationRegistration>> v3NotificationsGuidGet({
    required String? guid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(NotificationRegistration,
        () => NotificationRegistration.fromJsonFactory);

    return _v3NotificationsGuidGet(
        guid: guid, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get a push notification registration
  ///@param
  @Get(path: '/v3/notifications/{guid}')
  Future<chopper.Response<NotificationRegistration>> _v3NotificationsGuidGet({
    @Path('guid') required String? guid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update a push notification registration
  ///@param
  ///@param NotificationRegistration
  Future<chopper.Response<GuidHolder>> v3NotificationsGuidPost({
    required String? guid,
    required NotificationRegistration? notificationRegistration,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(NotificationRegistration,
        () => NotificationRegistration.fromJsonFactory);
    generatedMapping.putIfAbsent(GuidHolder, () => GuidHolder.fromJsonFactory);

    return _v3NotificationsGuidPost(
        guid: guid,
        notificationRegistration: notificationRegistration,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update a push notification registration
  ///@param
  ///@param NotificationRegistration
  @Post(path: '/v3/notifications/{guid}')
  Future<chopper.Response<GuidHolder>> _v3NotificationsGuidPost({
    @Path('guid') required String? guid,
    @Body() required NotificationRegistration? notificationRegistration,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a push notification registration
  ///@param
  Future<chopper.Response<Object>> v3NotificationsGuidDelete({
    required String? guid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3NotificationsGuidDelete(
        guid: guid, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Delete a push notification registration
  ///@param
  @Delete(path: '/v3/notifications/{guid}')
  Future<chopper.Response<Object>> _v3NotificationsGuidDelete({
    @Path('guid') required String? guid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get subscription status for all topics using a device registration
  ///@param
  Future<chopper.Response<SubscriptionStatusList>>
      v3NotificationsGuidSubscriptionsGet({
    required String? guid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SubscriptionStatusList, () => SubscriptionStatusList.fromJsonFactory);

    return _v3NotificationsGuidSubscriptionsGet(
        guid: guid, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get subscription status for all topics using a device registration
  ///@param
  @Get(path: '/v3/notifications/{guid}/subscriptions')
  Future<chopper.Response<SubscriptionStatusList>>
      _v3NotificationsGuidSubscriptionsGet({
    @Path('guid') required String? guid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Subscribe to a set of the topics using a device registration
  ///@param
  ///@param SubscriptionRequest
  Future<chopper.Response<SubscriptionStatusList>>
      v3NotificationsGuidSubscriptionsPost({
    required String? guid,
    required SubscriptionRequest? subscriptionRequest,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SubscriptionRequest, () => SubscriptionRequest.fromJsonFactory);
    generatedMapping.putIfAbsent(
        SubscriptionStatusList, () => SubscriptionStatusList.fromJsonFactory);

    return _v3NotificationsGuidSubscriptionsPost(
        guid: guid,
        subscriptionRequest: subscriptionRequest,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Subscribe to a set of the topics using a device registration
  ///@param
  ///@param SubscriptionRequest
  @Post(path: '/v3/notifications/{guid}/subscriptions')
  Future<chopper.Response<SubscriptionStatusList>>
      _v3NotificationsGuidSubscriptionsPost({
    @Path('guid') required String? guid,
    @Body() required SubscriptionRequest? subscriptionRequest,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get all the notification topics in this app
  ///@param
  Future<chopper.Response<NotificationTopicList>> v3TopicsGet({
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        NotificationTopicList, () => NotificationTopicList.fromJsonFactory);

    return _v3TopicsGet(
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get all the notification topics in this app
  ///@param
  @Get(path: '/v3/topics')
  Future<chopper.Response<NotificationTopicList>> _v3TopicsGet({
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a notification topic
  ///@param NotificationTopic
  Future<chopper.Response<GuidHolder>> v3TopicsPost({
    required NotificationTopic? notificationTopic,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        NotificationTopic, () => NotificationTopic.fromJsonFactory);
    generatedMapping.putIfAbsent(GuidHolder, () => GuidHolder.fromJsonFactory);

    return _v3TopicsPost(
        notificationTopic: notificationTopic,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a notification topic
  ///@param NotificationTopic
  @Post(path: '/v3/topics')
  Future<chopper.Response<GuidHolder>> _v3TopicsPost({
    @Body() required NotificationTopic? notificationTopic,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a notification topic
  ///@param
  Future<chopper.Response<NotificationTopic>> v3TopicsGuidGet({
    required String? guid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        NotificationTopic, () => NotificationTopic.fromJsonFactory);

    return _v3TopicsGuidGet(
        guid: guid, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get a notification topic
  ///@param
  @Get(path: '/v3/topics/{guid}')
  Future<chopper.Response<NotificationTopic>> _v3TopicsGuidGet({
    @Path('guid') required String? guid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update a notification topic
  ///@param
  ///@param NotificationTopic
  Future<chopper.Response<GuidHolder>> v3TopicsGuidPost({
    required String? guid,
    required NotificationTopic? notificationTopic,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        NotificationTopic, () => NotificationTopic.fromJsonFactory);
    generatedMapping.putIfAbsent(GuidHolder, () => GuidHolder.fromJsonFactory);

    return _v3TopicsGuidPost(
        guid: guid,
        notificationTopic: notificationTopic,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update a notification topic
  ///@param
  ///@param NotificationTopic
  @Post(path: '/v3/topics/{guid}')
  Future<chopper.Response<GuidHolder>> _v3TopicsGuidPost({
    @Path('guid') required String? guid,
    @Body() required NotificationTopic? notificationTopic,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a notification topic
  ///@param
  ///@param
  Future<chopper.Response<Object>> v3TopicsGuidDelete({
    required String? guid,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3TopicsGuidDelete(
        guid: guid,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a notification topic
  ///@param
  ///@param
  @Delete(path: '/v3/topics/{guid}')
  Future<chopper.Response<Object>> _v3TopicsGuidDelete({
    @Path('guid') required String? guid,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Send a push notification to all topic subscribers
  ///@param
  ///@param NotificationMessage
  Future<chopper.Response> v3TopicsGuidSendNotificationPost({
    required String? guid,
    required NotificationMessage? notificationMessage,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        NotificationMessage, () => NotificationMessage.fromJsonFactory);

    return _v3TopicsGuidSendNotificationPost(
        guid: guid,
        notificationMessage: notificationMessage,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Send a push notification to all topic subscribers
  ///@param
  ///@param NotificationMessage
  @Post(path: '/v3/topics/{guid}/sendNotification')
  Future<chopper.Response> _v3TopicsGuidSendNotificationPost({
    @Path('guid') required String? guid,
    @Body() required NotificationMessage? notificationMessage,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get schedules for user
  Future<chopper.Response<ScheduleList>> v4SchedulesGet({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ScheduleList, () => ScheduleList.fromJsonFactory);

    return _v4SchedulesGet(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get schedules for user
  @Get(path: '/v4/schedules')
  Future<chopper.Response<ScheduleList>> _v4SchedulesGet({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a schedule.
  ///@param
  Future<chopper.Response<Message>> v5SchedulesGuidDelete({
    required String? guid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v5SchedulesGuidDelete(
        guid: guid, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Delete a schedule.
  ///@param
  @Delete(path: '/v5/schedules/{guid}')
  Future<chopper.Response<Message>> _v5SchedulesGuidDelete({
    @Path('guid') required String? guid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Request an upload session
  ///@param UploadRequest An upload request
  Future<chopper.Response<UploadSession>> v3UploadsPost({
    required UploadRequest? uploadRequest,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UploadRequest, () => UploadRequest.fromJsonFactory);
    generatedMapping.putIfAbsent(
        UploadSession, () => UploadSession.fromJsonFactory);

    return _v3UploadsPost(
        uploadRequest: uploadRequest,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Request an upload session
  ///@param UploadRequest An upload request
  @Post(path: '/v3/uploads')
  Future<chopper.Response<UploadSession>> _v3UploadsPost({
    @Body() required UploadRequest? uploadRequest,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Notify Bridge an upload is complete
  ///@param
  ///@param synchronous True if this API call should wait for upload validation to finish before returning.
  ///@param redrive True if this API call should allow completing uploads that are already complete. This is to allow redrives and backfills.
  Future<chopper.Response<UploadValidationStatus>>
      v3UploadsUploadIdCompletePost({
    required String? uploadId,
    bool? synchronous,
    bool? redrive,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UploadValidationStatus, () => UploadValidationStatus.fromJsonFactory);

    return _v3UploadsUploadIdCompletePost(
        uploadId: uploadId,
        synchronous: synchronous,
        redrive: redrive,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Notify Bridge an upload is complete
  ///@param
  ///@param synchronous True if this API call should wait for upload validation to finish before returning.
  ///@param redrive True if this API call should allow completing uploads that are already complete. This is to allow redrives and backfills.
  @Post(
    path: '/v3/uploads/{uploadId}/complete',
    optionalBody: true,
  )
  Future<chopper.Response<UploadValidationStatus>>
      _v3UploadsUploadIdCompletePost({
    @Path('uploadId') required String? uploadId,
    @Query('synchronous') bool? synchronous,
    @Query('redrive') bool? redrive,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get status of a single upload attempt
  ///@param
  Future<chopper.Response<UploadValidationStatus>> v3UploadstatusesUploadIdGet({
    required String? uploadId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UploadValidationStatus, () => UploadValidationStatus.fromJsonFactory);

    return _v3UploadstatusesUploadIdGet(
        uploadId: uploadId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get status of a single upload attempt
  ///@param
  @Get(path: '/v3/uploadstatuses/{uploadId}')
  Future<chopper.Response<UploadValidationStatus>>
      _v3UploadstatusesUploadIdGet({
    @Path('uploadId') required String? uploadId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an upload by ID
  ///@param
  Future<chopper.Response<Upload>> v3UploadsUploadIdGet({
    required String? uploadId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Upload, () => Upload.fromJsonFactory);

    return _v3UploadsUploadIdGet(
        uploadId: uploadId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get an upload by ID
  ///@param
  @Get(path: '/v3/uploads/{uploadId}')
  Future<chopper.Response<Upload>> _v3UploadsUploadIdGet({
    @Path('uploadId') required String? uploadId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an upload record by the health data record ID
  ///@param
  Future<chopper.Response<Upload>> v3UploadsRecordIdRecordIdGet({
    required String? recordId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Upload, () => Upload.fromJsonFactory);

    return _v3UploadsRecordIdRecordIdGet(
        recordId: recordId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get an upload record by the health data record ID
  ///@param
  @Get(path: '/v3/uploads/recordId:{recordId}')
  Future<chopper.Response<Upload>> _v3UploadsRecordIdRecordIdGet({
    @Path('recordId') required String? recordId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get most recent revision of all upload schemas
  ///@param includeDeleted Should deleted upload schemas be returned in results?
  Future<chopper.Response<UploadSchemaList>> v3UploadschemasGet({
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UploadSchemaList, () => UploadSchemaList.fromJsonFactory);

    return _v3UploadschemasGet(
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get most recent revision of all upload schemas
  ///@param includeDeleted Should deleted upload schemas be returned in results?
  @Get(path: '/v3/uploadschemas')
  Future<chopper.Response<UploadSchemaList>> _v3UploadschemasGet({
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create or update an upload schema
  ///@param UploadSchema
  Future<chopper.Response<UploadSchema>> v3UploadschemasPost({
    required UploadSchema? uploadSchema,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UploadSchema, () => UploadSchema.fromJsonFactory);

    return _v3UploadschemasPost(
        uploadSchema: uploadSchema,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create or update an upload schema
  ///@param UploadSchema
  @Post(path: '/v3/uploadschemas')
  Future<chopper.Response<UploadSchema>> _v3UploadschemasPost({
    @Body() required UploadSchema? uploadSchema,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create an upload schema
  ///@param UploadSchema
  Future<chopper.Response<UploadSchema>> v4UploadschemasPost({
    required UploadSchema? uploadSchema,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UploadSchema, () => UploadSchema.fromJsonFactory);

    return _v4UploadschemasPost(
        uploadSchema: uploadSchema,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create an upload schema
  ///@param UploadSchema
  @Post(path: '/v4/uploadschemas')
  Future<chopper.Response<UploadSchema>> _v4UploadschemasPost({
    @Body() required UploadSchema? uploadSchema,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update an upload schema
  ///@param
  ///@param
  ///@param UploadSchema
  Future<chopper.Response<UploadSchema>>
      v4UploadschemasSchemaIdRevisionsRevisionPost({
    required String? schemaId,
    required int? revision,
    required UploadSchema? uploadSchema,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UploadSchema, () => UploadSchema.fromJsonFactory);

    return _v4UploadschemasSchemaIdRevisionsRevisionPost(
        schemaId: schemaId,
        revision: revision,
        uploadSchema: uploadSchema,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update an upload schema
  ///@param
  ///@param
  ///@param UploadSchema
  @Post(path: '/v4/uploadschemas/{schemaId}/revisions/{revision}')
  Future<chopper.Response<UploadSchema>>
      _v4UploadschemasSchemaIdRevisionsRevisionPost({
    @Path('schemaId') required String? schemaId,
    @Path('revision') required int? revision,
    @Body() required UploadSchema? uploadSchema,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get all revisions of an upload schema
  ///@param
  ///@param includeDeleted Should deleted upload schemas be returned in results?
  Future<chopper.Response<UploadSchemaList>> v3UploadschemasSchemaIdGet({
    required String? schemaId,
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UploadSchemaList, () => UploadSchemaList.fromJsonFactory);

    return _v3UploadschemasSchemaIdGet(
        schemaId: schemaId,
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get all revisions of an upload schema
  ///@param
  ///@param includeDeleted Should deleted upload schemas be returned in results?
  @Get(path: '/v3/uploadschemas/{schemaId}')
  Future<chopper.Response<UploadSchemaList>> _v3UploadschemasSchemaIdGet({
    @Path('schemaId') required String? schemaId,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete all revisions of an upload schema
  ///@param
  ///@param physical Physically delete the upload schema (administrators only; this is always false for developers)
  Future<chopper.Response<Object>> v3UploadschemasSchemaIdDelete({
    required String? schemaId,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3UploadschemasSchemaIdDelete(
        schemaId: schemaId,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete all revisions of an upload schema
  ///@param
  ///@param physical Physically delete the upload schema (administrators only; this is always false for developers)
  @Delete(path: '/v3/uploadschemas/{schemaId}')
  Future<chopper.Response<Object>> _v3UploadschemasSchemaIdDelete({
    @Path('schemaId') required String? schemaId,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the most recent revision of an upload schema
  ///@param
  Future<chopper.Response<UploadSchema>> v3UploadschemasSchemaIdRecentGet({
    required String? schemaId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UploadSchema, () => UploadSchema.fromJsonFactory);

    return _v3UploadschemasSchemaIdRecentGet(
        schemaId: schemaId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the most recent revision of an upload schema
  ///@param
  @Get(path: '/v3/uploadschemas/{schemaId}/recent')
  Future<chopper.Response<UploadSchema>> _v3UploadschemasSchemaIdRecentGet({
    @Path('schemaId') required String? schemaId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the specific revision of an upload schema
  ///@param
  ///@param
  Future<chopper.Response<UploadSchema>>
      v3UploadschemasSchemaIdRevisionsRevisionGet({
    required String? schemaId,
    required int? revision,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        UploadSchema, () => UploadSchema.fromJsonFactory);

    return _v3UploadschemasSchemaIdRevisionsRevisionGet(
        schemaId: schemaId,
        revision: revision,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the specific revision of an upload schema
  ///@param
  ///@param
  @Get(path: '/v3/uploadschemas/{schemaId}/revisions/{revision}')
  Future<chopper.Response<UploadSchema>>
      _v3UploadschemasSchemaIdRevisionsRevisionGet({
    @Path('schemaId') required String? schemaId,
    @Path('revision') required int? revision,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete the specific revision of an upload schema
  ///@param
  ///@param
  ///@param physical Physically delete the upload schema (administrators only; this is always false for developers)
  Future<chopper.Response<Object>>
      v3UploadschemasSchemaIdRevisionsRevisionDelete({
    required String? schemaId,
    required int? revision,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3UploadschemasSchemaIdRevisionsRevisionDelete(
        schemaId: schemaId,
        revision: revision,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete the specific revision of an upload schema
  ///@param
  ///@param
  ///@param physical Physically delete the upload schema (administrators only; this is always false for developers)
  @Delete(path: '/v3/uploadschemas/{schemaId}/revisions/{revision}')
  Future<chopper.Response<Object>>
      _v3UploadschemasSchemaIdRevisionsRevisionDelete({
    @Path('schemaId') required String? schemaId,
    @Path('revision') required int? revision,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get schedule plans
  ///@param
  Future<chopper.Response<SchedulePlanList>> v3ScheduleplansGet({
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SchedulePlanList, () => SchedulePlanList.fromJsonFactory);

    return _v3ScheduleplansGet(
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get schedule plans
  ///@param
  @Get(path: '/v3/scheduleplans')
  Future<chopper.Response<SchedulePlanList>> _v3ScheduleplansGet({
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a schedule plan
  ///@param SchedulePlan
  Future<chopper.Response<GuidVersionHolder>> v3ScheduleplansPost({
    required SchedulePlan? schedulePlan,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SchedulePlan, () => SchedulePlan.fromJsonFactory);
    generatedMapping.putIfAbsent(
        GuidVersionHolder, () => GuidVersionHolder.fromJsonFactory);

    return _v3ScheduleplansPost(
        schedulePlan: schedulePlan,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a schedule plan
  ///@param SchedulePlan
  @Post(path: '/v3/scheduleplans')
  Future<chopper.Response<GuidVersionHolder>> _v3ScheduleplansPost({
    @Body() required SchedulePlan? schedulePlan,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a schedule plan
  ///@param
  Future<chopper.Response<SchedulePlan>> v3ScheduleplansSchedulePlanGuidGet({
    required String? schedulePlanGuid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SchedulePlan, () => SchedulePlan.fromJsonFactory);

    return _v3ScheduleplansSchedulePlanGuidGet(
        schedulePlanGuid: schedulePlanGuid,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a schedule plan
  ///@param
  @Get(path: '/v3/scheduleplans/{schedulePlanGuid}')
  Future<chopper.Response<SchedulePlan>> _v3ScheduleplansSchedulePlanGuidGet({
    @Path('schedulePlanGuid') required String? schedulePlanGuid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update a schedule plan
  ///@param
  ///@param SchedulePlan
  Future<chopper.Response<GuidVersionHolder>>
      v3ScheduleplansSchedulePlanGuidPost({
    required String? schedulePlanGuid,
    required SchedulePlan? schedulePlan,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        SchedulePlan, () => SchedulePlan.fromJsonFactory);
    generatedMapping.putIfAbsent(
        GuidVersionHolder, () => GuidVersionHolder.fromJsonFactory);

    return _v3ScheduleplansSchedulePlanGuidPost(
        schedulePlanGuid: schedulePlanGuid,
        schedulePlan: schedulePlan,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update a schedule plan
  ///@param
  ///@param SchedulePlan
  @Post(path: '/v3/scheduleplans/{schedulePlanGuid}')
  Future<chopper.Response<GuidVersionHolder>>
      _v3ScheduleplansSchedulePlanGuidPost({
    @Path('schedulePlanGuid') required String? schedulePlanGuid,
    @Body() required SchedulePlan? schedulePlan,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a schedule plan
  ///@param
  ///@param
  Future<chopper.Response<Object>> v3ScheduleplansSchedulePlanGuidDelete({
    required String? schedulePlanGuid,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3ScheduleplansSchedulePlanGuidDelete(
        schedulePlanGuid: schedulePlanGuid,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a schedule plan
  ///@param
  ///@param
  @Delete(path: '/v3/scheduleplans/{schedulePlanGuid}')
  Future<chopper.Response<Object>> _v3ScheduleplansSchedulePlanGuidDelete({
    @Path('schedulePlanGuid') required String? schedulePlanGuid,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get list of scheduler configs
  Future<chopper.Response<MasterSchedulerConfigList>> v3SchedulerconfigsGet({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(MasterSchedulerConfigList,
        () => MasterSchedulerConfigList.fromJsonFactory);

    return _v3SchedulerconfigsGet(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get list of scheduler configs
  @Get(path: '/v3/schedulerconfigs')
  Future<chopper.Response<MasterSchedulerConfigList>> _v3SchedulerconfigsGet({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a scheduler config
  ///@param MasterSchedulerConfig Master scheduler config
  Future<chopper.Response<MasterSchedulerConfig>> v3SchedulerconfigsPost({
    required MasterSchedulerConfig? masterSchedulerConfig,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        MasterSchedulerConfig, () => MasterSchedulerConfig.fromJsonFactory);

    return _v3SchedulerconfigsPost(
        masterSchedulerConfig: masterSchedulerConfig,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a scheduler config
  ///@param MasterSchedulerConfig Master scheduler config
  @Post(path: '/v3/schedulerconfigs')
  Future<chopper.Response<MasterSchedulerConfig>> _v3SchedulerconfigsPost({
    @Body() required MasterSchedulerConfig? masterSchedulerConfig,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a scheduler config
  ///@param
  Future<chopper.Response<MasterSchedulerConfig>>
      v3SchedulerconfigsScheduleIdGet({
    required String? scheduleId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        MasterSchedulerConfig, () => MasterSchedulerConfig.fromJsonFactory);

    return _v3SchedulerconfigsScheduleIdGet(
        scheduleId: scheduleId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a scheduler config
  ///@param
  @Get(path: '/v3/schedulerconfigs/{scheduleId}')
  Future<chopper.Response<MasterSchedulerConfig>>
      _v3SchedulerconfigsScheduleIdGet({
    @Path('scheduleId') required String? scheduleId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update a scheduler config
  ///@param
  ///@param MasterSchedulerConfig
  Future<chopper.Response<MasterSchedulerConfig>>
      v3SchedulerconfigsScheduleIdPost({
    required String? scheduleId,
    required MasterSchedulerConfig? masterSchedulerConfig,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        MasterSchedulerConfig, () => MasterSchedulerConfig.fromJsonFactory);

    return _v3SchedulerconfigsScheduleIdPost(
        scheduleId: scheduleId,
        masterSchedulerConfig: masterSchedulerConfig,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update a scheduler config
  ///@param
  ///@param MasterSchedulerConfig
  @Post(path: '/v3/schedulerconfigs/{scheduleId}')
  Future<chopper.Response<MasterSchedulerConfig>>
      _v3SchedulerconfigsScheduleIdPost({
    @Path('scheduleId') required String? scheduleId,
    @Body() required MasterSchedulerConfig? masterSchedulerConfig,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a scheduler config
  ///@param
  Future<chopper.Response<Object>> v3SchedulerconfigsScheduleIdDelete({
    required String? scheduleId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3SchedulerconfigsScheduleIdDelete(
        scheduleId: scheduleId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a scheduler config
  ///@param
  @Delete(path: '/v3/schedulerconfigs/{scheduleId}')
  Future<chopper.Response<Object>> _v3SchedulerconfigsScheduleIdDelete({
    @Path('scheduleId') required String? scheduleId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the last time the scheduler ran
  Future<chopper.Response<DateTimeHolder>> v3SchedulerstatusGet({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        DateTimeHolder, () => DateTimeHolder.fromJsonFactory);

    return _v3SchedulerstatusGet(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get the last time the scheduler ran
  @Get(path: '/v3/schedulerstatus')
  Future<chopper.Response<DateTimeHolder>> _v3SchedulerstatusGet({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get activity events for current user
  Future<chopper.Response<ActivityEventList>> v1ActivityeventsGet(
      {String? cacheControl}) {
    generatedMapping.putIfAbsent(
        ActivityEventList, () => ActivityEventList.fromJsonFactory);

    return _v1ActivityeventsGet(cacheControl: cacheControl);
  }

  ///Get activity events for current user
  @Get(path: '/v1/activityevents')
  Future<chopper.Response<ActivityEventList>> _v1ActivityeventsGet(
      {@Header('Cache-Control') String? cacheControl});

  ///Create an app-scoped activity event for the current user
  ///@param CustomActivityEventRequest
  Future<chopper.Response<Object>> v1ActivityeventsPost({
    required CustomActivityEventRequest? customActivityEventRequest,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(CustomActivityEventRequest,
        () => CustomActivityEventRequest.fromJsonFactory);

    return _v1ActivityeventsPost(
        customActivityEventRequest: customActivityEventRequest,
        cacheControl: cacheControl);
  }

  ///Create an app-scoped activity event for the current user
  ///@param CustomActivityEventRequest
  @Post(path: '/v1/activityevents')
  Future<chopper.Response<Object>> _v1ActivityeventsPost({
    @Body() required CustomActivityEventRequest? customActivityEventRequest,
    @Header('Cache-Control') String? cacheControl,
  });

  ///
  ///@param
  Future<chopper.Response<Object>> v1ActivityeventsEventIdDelete({
    required String? eventId,
    String? cacheControl,
  }) {
    return _v1ActivityeventsEventIdDelete(
        eventId: eventId, cacheControl: cacheControl);
  }

  ///
  ///@param
  @Delete(path: '/v1/activityevents/{eventId}')
  Future<chopper.Response<Object>> _v1ActivityeventsEventIdDelete({
    @Path('eventId') required String? eventId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete an external ID
  ///@param
  Future<chopper.Response<Object>> v4ExternalidsExternalIdDelete({
    required String? externalId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v4ExternalidsExternalIdDelete(
        externalId: externalId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete an external ID
  ///@param
  @Delete(path: '/v4/externalids/{externalId}')
  Future<chopper.Response<Object>> _v4ExternalidsExternalIdDelete({
    @Path('externalId') required String? externalId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Generate a password for a study participant's account
  ///@param
  ///@param createAccount If account has not been created for this external ID, create it
  Future<chopper.Response<GeneratedPassword>>
      v3ExternalidsExternalIdPasswordPost({
    required String? externalId,
    bool? createAccount,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        GeneratedPassword, () => GeneratedPassword.fromJsonFactory);

    return _v3ExternalidsExternalIdPasswordPost(
        externalId: externalId,
        createAccount: createAccount,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Generate a password for a study participant's account
  ///@param
  ///@param createAccount If account has not been created for this external ID, create it
  @Post(
    path: '/v3/externalids/{externalId}/password',
    optionalBody: true,
  )
  Future<chopper.Response<GeneratedPassword>>
      _v3ExternalidsExternalIdPasswordPost({
    @Path('externalId') required String? externalId,
    @Query('createAccount') bool? createAccount,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get participant report records by date
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorReportDataList>>
      v3StudiesAppIdParticipantsUserIdReportsReportIdGet({
    required String? appId,
    required String? userId,
    required String? reportId,
    required String? startDate,
    required String? endDate,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorReportDataList,
        () => ForwardCursorReportDataList.fromJsonFactory);

    return _v3StudiesAppIdParticipantsUserIdReportsReportIdGet(
        appId: appId,
        userId: userId,
        reportId: reportId,
        startDate: startDate,
        endDate: endDate,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get participant report records by date
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/studies/{appId}/participants/{userId}/reports/{reportId}')
  Future<chopper.Response<ForwardCursorReportDataList>>
      _v3StudiesAppIdParticipantsUserIdReportsReportIdGet({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Path('reportId') required String? reportId,
    @Query('startDate') required String? startDate,
    @Query('endDate') required String? endDate,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get participant report records by date
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorReportDataList>>
      v4StudiesAppIdParticipantsUserIdReportsReportIdGet({
    required String? appId,
    required String? userId,
    required String? reportId,
    required String? startTime,
    required String? endTime,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorReportDataList,
        () => ForwardCursorReportDataList.fromJsonFactory);

    return _v4StudiesAppIdParticipantsUserIdReportsReportIdGet(
        appId: appId,
        userId: userId,
        reportId: reportId,
        startTime: startTime,
        endTime: endTime,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get participant report records by date
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v4/studies/{appId}/participants/{userId}/reports/{reportId}')
  Future<chopper.Response<ForwardCursorReportDataList>>
      _v4StudiesAppIdParticipantsUserIdReportsReportIdGet({
    @Path('appId') required String? appId,
    @Path('userId') required String? userId,
    @Path('reportId') required String? reportId,
    @Query('startTime') required String? startTime,
    @Query('endTime') required String? endTime,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a list of the studies in this app
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<StudyList>> v5StudiesGet({
    int? offsetBy,
    int? pageSize,
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(StudyList, () => StudyList.fromJsonFactory);

    return _v5StudiesGet(
        offsetBy: offsetBy,
        pageSize: pageSize,
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a list of the studies in this app
  ///@param
  ///@param
  ///@param
  @Get(path: '/v5/studies')
  Future<chopper.Response<StudyList>> _v5StudiesGet({
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new study
  ///@param Study New study
  Future<chopper.Response<VersionHolder>> v5StudiesPost({
    required Study? study,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Study, () => Study.fromJsonFactory);
    generatedMapping.putIfAbsent(
        VersionHolder, () => VersionHolder.fromJsonFactory);

    return _v5StudiesPost(
        study: study, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Create a new study
  ///@param Study New study
  @Post(path: '/v5/studies')
  Future<chopper.Response<VersionHolder>> _v5StudiesPost({
    @Body() required Study? study,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study
  ///@param
  Future<chopper.Response<Study>> v5StudiesStudyIdGet({
    required String? studyId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Study, () => Study.fromJsonFactory);

    return _v5StudiesStudyIdGet(
        studyId: studyId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study
  ///@param
  @Get(path: '/v5/studies/{studyId}')
  Future<chopper.Response<Study>> _v5StudiesStudyIdGet({
    @Path('studyId') required String? studyId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update an existing study
  ///@param
  ///@param Study Updated study
  Future<chopper.Response<VersionHolder>> v5StudiesStudyIdPost({
    required String? studyId,
    required Study? study,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Study, () => Study.fromJsonFactory);
    generatedMapping.putIfAbsent(
        VersionHolder, () => VersionHolder.fromJsonFactory);

    return _v5StudiesStudyIdPost(
        studyId: studyId,
        study: study,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update an existing study
  ///@param
  ///@param Study Updated study
  @Post(path: '/v5/studies/{studyId}')
  Future<chopper.Response<VersionHolder>> _v5StudiesStudyIdPost({
    @Path('studyId') required String? studyId,
    @Body() required Study? study,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a study. Developers and study designers can logically or physically delete a study if it is in the “legacy,” “design,” “completed,” or “withdrawn” phases. Admins can logically or physically delete a study at any lifecycle phase. All study participants are unassociated with the study (not withdrawn), so this should only be done on a study that has not yet been used, or that is completed with no further need to identify study participants.
  ///@param
  ///@param
  Future<chopper.Response<Message>> v5StudiesStudyIdDelete({
    required String? studyId,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v5StudiesStudyIdDelete(
        studyId: studyId,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a study. Developers and study designers can logically or physically delete a study if it is in the “legacy,” “design,” “completed,” or “withdrawn” phases. Admins can logically or physically delete a study at any lifecycle phase. All study participants are unassociated with the study (not withdrawn), so this should only be done on a study that has not yet been used, or that is completed with no further need to identify study participants.
  ///@param
  ///@param
  @Delete(path: '/v5/studies/{studyId}')
  Future<chopper.Response<Message>> _v5StudiesStudyIdDelete({
    @Path('studyId') required String? studyId,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new study logo handle for uploading a study logo.
  ///@param
  ///@param FileRevision New file revision
  Future<chopper.Response> v5StudiesStudyIdLogoPost({
    required String? studyId,
    required FileRevision? fileRevision,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        FileRevision, () => FileRevision.fromJsonFactory);

    return _v5StudiesStudyIdLogoPost(
        studyId: studyId,
        fileRevision: fileRevision,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new study logo handle for uploading a study logo.
  ///@param
  ///@param FileRevision New file revision
  @Post(path: '/v5/studies/{studyId}/logo')
  Future<chopper.Response> _v5StudiesStudyIdLogoPost({
    @Path('studyId') required String? studyId,
    @Body() required FileRevision? fileRevision,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Confirm with the Bridge server that the logo has been uploaded to S3.
  ///@param
  ///@param
  Future<chopper.Response<Study>> v5StudiesStudyIdLogoCreatedOnPost({
    required String? studyId,
    required String? createdOn,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Study, () => Study.fromJsonFactory);

    return _v5StudiesStudyIdLogoCreatedOnPost(
        studyId: studyId,
        createdOn: createdOn,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Confirm with the Bridge server that the logo has been uploaded to S3.
  ///@param
  ///@param
  @Post(
    path: '/v5/studies/{studyId}/logo/{createdOn}',
    optionalBody: true,
  )
  Future<chopper.Response<Study>> _v5StudiesStudyIdLogoCreatedOnPost({
    @Path('studyId') required String? studyId,
    @Path('createdOn') required String? createdOn,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the sponsors of this study.
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<OrganizationList>> v5StudiesStudyIdSponsorsGet({
    required String? studyId,
    int? offsetBy,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        OrganizationList, () => OrganizationList.fromJsonFactory);

    return _v5StudiesStudyIdSponsorsGet(
        studyId: studyId,
        offsetBy: offsetBy,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the sponsors of this study.
  ///@param
  ///@param
  ///@param
  @Get(path: '/v5/studies/{studyId}/sponsors')
  Future<chopper.Response<OrganizationList>> _v5StudiesStudyIdSponsorsGet({
    @Path('studyId') required String? studyId,
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Add this organization as a sponsor
  ///@param
  ///@param
  Future<chopper.Response<Message>> v5StudiesStudyIdSponsorsOrgIdPost({
    required String? studyId,
    required String? orgId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v5StudiesStudyIdSponsorsOrgIdPost(
        studyId: studyId,
        orgId: orgId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Add this organization as a sponsor
  ///@param
  ///@param
  @Post(
    path: '/v5/studies/{studyId}/sponsors/{orgId}',
    optionalBody: true,
  )
  Future<chopper.Response<Message>> _v5StudiesStudyIdSponsorsOrgIdPost({
    @Path('studyId') required String? studyId,
    @Path('orgId') required String? orgId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Remove this organization as a sponsor
  ///@param
  ///@param
  Future<chopper.Response<Message>> v5StudiesStudyIdSponsorsOrgIdDelete({
    required String? studyId,
    required String? orgId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v5StudiesStudyIdSponsorsOrgIdDelete(
        studyId: studyId,
        orgId: orgId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Remove this organization as a sponsor
  ///@param
  ///@param
  @Delete(path: '/v5/studies/{studyId}/sponsors/{orgId}')
  Future<chopper.Response<Message>> _v5StudiesStudyIdSponsorsOrgIdDelete({
    @Path('studyId') required String? studyId,
    @Path('orgId') required String? orgId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the enrollments in this study. These include participants who have been withdrawn from the study (as we continue to document their historic participation).
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<EnrollmentDetailList>>
      v5StudiesStudyIdEnrollmentsGet({
    required String? studyId,
    String? enrollmentFilter,
    bool? includeTesters,
    int? offsetBy,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        EnrollmentDetailList, () => EnrollmentDetailList.fromJsonFactory);

    return _v5StudiesStudyIdEnrollmentsGet(
        studyId: studyId,
        enrollmentFilter: enrollmentFilter,
        includeTesters: includeTesters,
        offsetBy: offsetBy,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the enrollments in this study. These include participants who have been withdrawn from the study (as we continue to document their historic participation).
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v5/studies/{studyId}/enrollments')
  Future<chopper.Response<EnrollmentDetailList>>
      _v5StudiesStudyIdEnrollmentsGet({
    @Path('studyId') required String? studyId,
    @Query('enrollmentFilter') String? enrollmentFilter,
    @Query('includeTesters') bool? includeTesters,
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Enroll an account in a study as a participant.
  ///@param
  ///@param Enrollment Enrollment information for this user
  Future<chopper.Response<Enrollment>> v5StudiesStudyIdEnrollmentsPost({
    required String? studyId,
    required Enrollment? enrollment,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Enrollment, () => Enrollment.fromJsonFactory);

    return _v5StudiesStudyIdEnrollmentsPost(
        studyId: studyId,
        enrollment: enrollment,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Enroll an account in a study as a participant.
  ///@param
  ///@param Enrollment Enrollment information for this user
  @Post(path: '/v5/studies/{studyId}/enrollments')
  Future<chopper.Response<Enrollment>> _v5StudiesStudyIdEnrollmentsPost({
    @Path('studyId') required String? studyId,
    @Body() required Enrollment? enrollment,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update a participant's enrollment record for a study
  ///@param
  ///@param
  ///@param Enrollment Updated enrollment
  Future<chopper.Response<Message>> v5StudiesStudyIdEnrollmentsUserIdPost({
    required String? studyId,
    required String? userId,
    required Enrollment? enrollment,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Enrollment, () => Enrollment.fromJsonFactory);
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v5StudiesStudyIdEnrollmentsUserIdPost(
        studyId: studyId,
        userId: userId,
        enrollment: enrollment,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update a participant's enrollment record for a study
  ///@param
  ///@param
  ///@param Enrollment Updated enrollment
  @Post(path: '/v5/studies/{studyId}/enrollments/{userId}')
  Future<chopper.Response<Message>> _v5StudiesStudyIdEnrollmentsUserIdPost({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Body() required Enrollment? enrollment,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Withdraw a participant from the study
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<Enrollment>> v5StudiesStudyIdEnrollmentsUserIdDelete({
    required String? studyId,
    required String? userId,
    String? withdrawalNote,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Enrollment, () => Enrollment.fromJsonFactory);

    return _v5StudiesStudyIdEnrollmentsUserIdDelete(
        studyId: studyId,
        userId: userId,
        withdrawalNote: withdrawalNote,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Withdraw a participant from the study
  ///@param
  ///@param
  ///@param
  @Delete(path: '/v5/studies/{studyId}/enrollments/{userId}')
  Future<chopper.Response<Enrollment>>
      _v5StudiesStudyIdEnrollmentsUserIdDelete({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Query('withdrawalNote') String? withdrawalNote,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get external IDs for a study
  ///@param
  ///@param
  ///@param
  ///@param idFilter
  Future<chopper.Response<ExternalIdentifierList>>
      v5StudiesStudyIdExternalidsGet({
    required String? studyId,
    int? offsetBy,
    int? pageSize,
    String? idFilter,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ExternalIdentifierList, () => ExternalIdentifierList.fromJsonFactory);

    return _v5StudiesStudyIdExternalidsGet(
        studyId: studyId,
        offsetBy: offsetBy,
        pageSize: pageSize,
        idFilter: idFilter,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get external IDs for a study
  ///@param
  ///@param
  ///@param
  ///@param idFilter
  @Get(path: '/v5/studies/{studyId}/externalids')
  Future<chopper.Response<ExternalIdentifierList>>
      _v5StudiesStudyIdExternalidsGet({
    @Path('studyId') required String? studyId,
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Query('idFilter') String? idFilter,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Transition a study’s phase to “design.” This can only be done with a study that is currently in the “legacy” phase.
  ///@param
  Future<chopper.Response<Study>> v5StudiesStudyIdDesignPost({
    required String? studyId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Study, () => Study.fromJsonFactory);

    return _v5StudiesStudyIdDesignPost(
        studyId: studyId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Transition a study’s phase to “design.” This can only be done with a study that is currently in the “legacy” phase.
  ///@param
  @Post(
    path: '/v5/studies/{studyId}/design',
    optionalBody: true,
  )
  Future<chopper.Response<Study>> _v5StudiesStudyIdDesignPost({
    @Path('studyId') required String? studyId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Transition a study’s phase to “recruitment.” This can only be done with a study that is currently in the “design” phase.
  ///@param
  Future<chopper.Response<Study>> v5StudiesStudyIdRecruitPost({
    required String? studyId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Study, () => Study.fromJsonFactory);

    return _v5StudiesStudyIdRecruitPost(
        studyId: studyId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Transition a study’s phase to “recruitment.” This can only be done with a study that is currently in the “design” phase.
  ///@param
  @Post(
    path: '/v5/studies/{studyId}/recruit',
    optionalBody: true,
  )
  Future<chopper.Response<Study>> _v5StudiesStudyIdRecruitPost({
    @Path('studyId') required String? studyId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Transition a study’s phase to “in flight.” This can only be done with a study that is currently in the “recruitment” phase.
  ///@param
  Future<chopper.Response<Study>> v5StudiesStudyIdConductPost({
    required String? studyId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Study, () => Study.fromJsonFactory);

    return _v5StudiesStudyIdConductPost(
        studyId: studyId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Transition a study’s phase to “in flight.” This can only be done with a study that is currently in the “recruitment” phase.
  ///@param
  @Post(
    path: '/v5/studies/{studyId}/conduct',
    optionalBody: true,
  )
  Future<chopper.Response<Study>> _v5StudiesStudyIdConductPost({
    @Path('studyId') required String? studyId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Transition a study’s phase to “analysis.” This can only be done with a study that is currently “in flight.”
  ///@param
  Future<chopper.Response<Study>> v5StudiesStudyIdAnalyzePost({
    required String? studyId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Study, () => Study.fromJsonFactory);

    return _v5StudiesStudyIdAnalyzePost(
        studyId: studyId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Transition a study’s phase to “analysis.” This can only be done with a study that is currently “in flight.”
  ///@param
  @Post(
    path: '/v5/studies/{studyId}/analyze',
    optionalBody: true,
  )
  Future<chopper.Response<Study>> _v5StudiesStudyIdAnalyzePost({
    @Path('studyId') required String? studyId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Transition a study’s phase to “completed.” This can only be done with a study that is currently in the “analysis” phase.
  ///@param
  Future<chopper.Response<Study>> v5StudiesStudyIdCompletePost({
    required String? studyId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Study, () => Study.fromJsonFactory);

    return _v5StudiesStudyIdCompletePost(
        studyId: studyId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Transition a study’s phase to “completed.” This can only be done with a study that is currently in the “analysis” phase.
  ///@param
  @Post(
    path: '/v5/studies/{studyId}/complete',
    optionalBody: true,
  )
  Future<chopper.Response<Study>> _v5StudiesStudyIdCompletePost({
    @Path('studyId') required String? studyId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Transition a study’s phase to “withdrawn.” This can be done with a study that is currently in “design,” “recruitment,” “in flight,” or “analysis” phases.
  ///@param
  Future<chopper.Response<Study>> v5StudiesStudyIdWithdrawPost({
    required String? studyId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Study, () => Study.fromJsonFactory);

    return _v5StudiesStudyIdWithdrawPost(
        studyId: studyId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Transition a study’s phase to “withdrawn.” This can be done with a study that is currently in “design,” “recruitment,” “in flight,” or “analysis” phases.
  ///@param
  @Post(
    path: '/v5/studies/{studyId}/withdraw',
    optionalBody: true,
  )
  Future<chopper.Response<Study>> _v5StudiesStudyIdWithdrawPost({
    @Path('studyId') required String? studyId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the schedule for this study (returns 404 if a schedule has not been created for the study).
  ///@param
  Future<chopper.Response<Schedule2>> v5StudiesStudyIdScheduleGet({
    required String? studyId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Schedule2, () => Schedule2.fromJsonFactory);

    return _v5StudiesStudyIdScheduleGet(
        studyId: studyId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the schedule for this study (returns 404 if a schedule has not been created for the study).
  ///@param
  @Get(path: '/v5/studies/{studyId}/schedule')
  Future<chopper.Response<Schedule2>> _v5StudiesStudyIdScheduleGet({
    @Path('studyId') required String? studyId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create or update a schedule associated with a study. This endpoint will return a status of 200 if the call is an update, or 201 if the schedule is being created for the first time.
  ///@param
  ///@param Schedule
  Future<chopper.Response<Schedule2>> v5StudiesStudyIdSchedulePost({
    required String? studyId,
    required Schedule2? schedule,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Schedule2, () => Schedule2.fromJsonFactory);

    return _v5StudiesStudyIdSchedulePost(
        studyId: studyId,
        schedule: schedule,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create or update a schedule associated with a study. This endpoint will return a status of 200 if the call is an update, or 201 if the schedule is being created for the first time.
  ///@param
  ///@param Schedule
  @Post(path: '/v5/studies/{studyId}/schedule')
  Future<chopper.Response<Schedule2>> _v5StudiesStudyIdSchedulePost({
    @Path('studyId') required String? studyId,
    @Body() required Schedule2? schedule,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the timeline associated to this study through its schedule.
  ///@param
  Future<chopper.Response<Timeline>> v5StudiesStudyIdTimelineGet({
    required String? studyId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Timeline, () => Timeline.fromJsonFactory);

    return _v5StudiesStudyIdTimelineGet(
        studyId: studyId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the timeline associated to this study through its schedule.
  ///@param
  @Get(path: '/v5/studies/{studyId}/timeline')
  Future<chopper.Response<Timeline>> _v5StudiesStudyIdTimelineGet({
    @Path('studyId') required String? studyId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Request a roster of participants for a specific study.
  ///@param
  ///@param ParticipantRosterRequest Account summary search parameters
  Future<chopper.Response> v5StudiesStudyIdParticipantsEmailRosterPost({
    required String? studyId,
    required ParticipantRosterRequest? participantRosterRequest,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ParticipantRosterRequest,
        () => ParticipantRosterRequest.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsEmailRosterPost(
        studyId: studyId,
        participantRosterRequest: participantRosterRequest,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Request a roster of participants for a specific study.
  ///@param
  ///@param ParticipantRosterRequest Account summary search parameters
  @Post(path: '/v5/studies/{studyId}/participants/emailRoster')
  Future<chopper.Response> _v5StudiesStudyIdParticipantsEmailRosterPost({
    @Path('studyId') required String? studyId,
    @Body() required ParticipantRosterRequest? participantRosterRequest,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get enrollment records for this user. This endpoint is accessible if the caller can retrieve the participant’s record, and will only include enrollment records for studies that are visible to the caller (through their membership in a sponsoring organization). App-scoped roles (developer, researcher, admin) can see all enrollments.
  ///@param
  ///@param
  Future<chopper.Response<EnrollmentDetailList>>
      v5StudiesStudyIdParticipantsUserIdEnrollmentsGet({
    required String? studyId,
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        EnrollmentDetailList, () => EnrollmentDetailList.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdEnrollmentsGet(
        studyId: studyId,
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get enrollment records for this user. This endpoint is accessible if the caller can retrieve the participant’s record, and will only include enrollment records for studies that are visible to the caller (through their membership in a sponsoring organization). App-scoped roles (developer, researcher, admin) can see all enrollments.
  ///@param
  ///@param
  @Get(path: '/v5/studies/{studyId}/participants/{userId}/enrollments')
  Future<chopper.Response<EnrollmentDetailList>>
      _v5StudiesStudyIdParticipantsUserIdEnrollmentsGet({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Search for account summaries of study participants.
  ///@param
  ///@param AccountSummarySearch Account summary search parameters
  Future<chopper.Response<AccountSummaryList>>
      v5StudiesStudyIdParticipantsSearchPost({
    required String? studyId,
    required AccountSummarySearch? accountSummarySearch,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AccountSummarySearch, () => AccountSummarySearch.fromJsonFactory);
    generatedMapping.putIfAbsent(
        AccountSummaryList, () => AccountSummaryList.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsSearchPost(
        studyId: studyId,
        accountSummarySearch: accountSummarySearch,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Search for account summaries of study participants.
  ///@param
  ///@param AccountSummarySearch Account summary search parameters
  @Post(path: '/v5/studies/{studyId}/participants/search')
  Future<chopper.Response<AccountSummaryList>>
      _v5StudiesStudyIdParticipantsSearchPost({
    @Path('studyId') required String? studyId,
    @Body() required AccountSummarySearch? accountSummarySearch,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new study participant who will be enrolled (but not consented) in this study. If the caller is a developer or study designer account, then the participant record will automatically be created as a test user (marked with the “test_user” data group).
  ///@param
  ///@param SignUp Sign up
  Future<chopper.Response<IdentifierHolder>> v5StudiesStudyIdParticipantsPost({
    required String? studyId,
    required SignUp? signUp,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        IdentifierHolder, () => IdentifierHolder.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsPost(
        studyId: studyId,
        signUp: signUp,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new study participant who will be enrolled (but not consented) in this study. If the caller is a developer or study designer account, then the participant record will automatically be created as a test user (marked with the “test_user” data group).
  ///@param
  ///@param SignUp Sign up
  @Post(path: '/v5/studies/{studyId}/participants')
  Future<chopper.Response<IdentifierHolder>> _v5StudiesStudyIdParticipantsPost({
    @Path('studyId') required String? studyId,
    @Body() required SignUp? signUp,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant.
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<StudyParticipant>>
      v5StudiesStudyIdParticipantsUserIdGet({
    required String? studyId,
    required String? userId,
    bool? consents,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyParticipant, () => StudyParticipant.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdGet(
        studyId: studyId,
        userId: userId,
        consents: consents,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant.
  ///@param
  ///@param
  ///@param
  @Get(path: '/v5/studies/{studyId}/participants/{userId}')
  Future<chopper.Response<StudyParticipant>>
      _v5StudiesStudyIdParticipantsUserIdGet({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Query('consents') bool? consents,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update an existing study participant (user) record
  ///@param
  ///@param
  ///@param StudyParticipant Study participant
  Future<chopper.Response<Object>> v5StudiesStudyIdParticipantsUserIdPost({
    required String? studyId,
    required String? userId,
    required StudyParticipant? studyParticipant,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v5StudiesStudyIdParticipantsUserIdPost(
        studyId: studyId,
        userId: userId,
        studyParticipant: studyParticipant,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update an existing study participant (user) record
  ///@param
  ///@param
  ///@param StudyParticipant Study participant
  @Post(path: '/v5/studies/{studyId}/participants/{userId}')
  Future<chopper.Response<Object>> _v5StudiesStudyIdParticipantsUserIdPost({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Body() required StudyParticipant? studyParticipant,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a study participant if the record has the `test_user` data group, or the account has not been used by the participant (the participant has never signed in to Bridge using the account) and it is only enrolled in one study.
  ///@param
  ///@param
  Future<chopper.Response<Object>> v5StudiesStudyIdParticipantsUserIdDelete({
    required String? studyId,
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v5StudiesStudyIdParticipantsUserIdDelete(
        studyId: studyId,
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a study participant if the record has the `test_user` data group, or the account has not been used by the participant (the participant has never signed in to Bridge using the account) and it is only enrolled in one study.
  ///@param
  ///@param
  @Delete(path: '/v5/studies/{studyId}/participants/{userId}')
  Future<chopper.Response<Object>> _v5StudiesStudyIdParticipantsUserIdDelete({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get information about the last request made by this participant
  ///@param
  ///@param
  Future<chopper.Response<RequestInfo>>
      v5StudiesStudyIdParticipantsUserIdRequestInfoGet({
    required String? studyId,
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        RequestInfo, () => RequestInfo.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdRequestInfoGet(
        studyId: studyId,
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get information about the last request made by this participant
  ///@param
  ///@param
  @Get(path: '/v5/studies/{studyId}/participants/{userId}/requestInfo')
  Future<chopper.Response<RequestInfo>>
      _v5StudiesStudyIdParticipantsUserIdRequestInfoGet({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Sign the participant out and delete their server session
  ///@param
  ///@param
  ///@param deleteReauthToken Should sign out also delete any extant reauthentication tokens?
  Future<chopper.Response<Object>>
      v5StudiesStudyIdParticipantsUserIdSignOutPost({
    required String? studyId,
    required String? userId,
    bool? deleteReauthToken,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v5StudiesStudyIdParticipantsUserIdSignOutPost(
        studyId: studyId,
        userId: userId,
        deleteReauthToken: deleteReauthToken,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Sign the participant out and delete their server session
  ///@param
  ///@param
  ///@param deleteReauthToken Should sign out also delete any extant reauthentication tokens?
  @Post(
    path: '/v5/studies/{studyId}/participants/{userId}/signOut',
    optionalBody: true,
  )
  Future<chopper.Response<Object>>
      _v5StudiesStudyIdParticipantsUserIdSignOutPost({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Query('deleteReauthToken') bool? deleteReauthToken,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Trigger a request to reset password for this user
  ///@param
  ///@param
  Future<chopper.Response<Object>>
      v5StudiesStudyIdParticipantsUserIdRequestResetPasswordPost({
    required String? studyId,
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v5StudiesStudyIdParticipantsUserIdRequestResetPasswordPost(
        studyId: studyId,
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Trigger a request to reset password for this user
  ///@param
  ///@param
  @Post(
    path: '/v5/studies/{studyId}/participants/{userId}/requestResetPassword',
    optionalBody: true,
  )
  Future<chopper.Response<Object>>
      _v5StudiesStudyIdParticipantsUserIdRequestResetPasswordPost({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Resend an email verification email to this user
  ///@param
  ///@param
  Future<chopper.Response<Object>>
      v5StudiesStudyIdParticipantsUserIdResendEmailVerificationPost({
    required String? studyId,
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v5StudiesStudyIdParticipantsUserIdResendEmailVerificationPost(
        studyId: studyId,
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Resend an email verification email to this user
  ///@param
  ///@param
  @Post(
    path: '/v5/studies/{studyId}/participants/{userId}/resendEmailVerification',
    optionalBody: true,
  )
  Future<chopper.Response<Object>>
      _v5StudiesStudyIdParticipantsUserIdResendEmailVerificationPost({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Resend a phone verification to this user
  ///@param
  ///@param
  Future<chopper.Response<Object>>
      v5StudiesStudyIdParticipantsUserIdResendPhoneVerificationPost({
    required String? studyId,
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v5StudiesStudyIdParticipantsUserIdResendPhoneVerificationPost(
        studyId: studyId,
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Resend a phone verification to this user
  ///@param
  ///@param
  @Post(
    path: '/v5/studies/{studyId}/participants/{userId}/resendPhoneVerification',
    optionalBody: true,
  )
  Future<chopper.Response<Object>>
      _v5StudiesStudyIdParticipantsUserIdResendPhoneVerificationPost({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Re-send the consent agreement for this study
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<Object>>
      v5StudiesStudyIdParticipantsUserIdConsentsGuidResendConsentPost({
    required String? studyId,
    required String? userId,
    required String? guid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v5StudiesStudyIdParticipantsUserIdConsentsGuidResendConsentPost(
        studyId: studyId,
        userId: userId,
        guid: guid,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Re-send the consent agreement for this study
  ///@param
  ///@param
  ///@param
  @Post(
    path:
        '/v5/studies/{studyId}/participants/{userId}/consents/{guid}/resendConsent',
    optionalBody: true,
  )
  Future<chopper.Response<Object>>
      _v5StudiesStudyIdParticipantsUserIdConsentsGuidResendConsentPost({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Path('guid') required String? guid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant’s upload history
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<UploadList>>
      v5StudiesStudyIdParticipantsUserIdUploadsGet({
    required String? studyId,
    required String? userId,
    required String? startTime,
    required String? endTime,
    int? pageSize,
    String? offsetKey,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(UploadList, () => UploadList.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdUploadsGet(
        studyId: studyId,
        userId: userId,
        startTime: startTime,
        endTime: endTime,
        pageSize: pageSize,
        offsetKey: offsetKey,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant’s upload history
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v5/studies/{studyId}/participants/{userId}/uploads')
  Future<chopper.Response<UploadList>>
      _v5StudiesStudyIdParticipantsUserIdUploadsGet({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Query('startTime') required String? startTime,
    @Query('endTime') required String? endTime,
    @Query('pageSize') int? pageSize,
    @Query('offsetKey') String? offsetKey,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a study participant’s push notification registrations
  ///@param
  ///@param
  Future<chopper.Response<NotificationRegistrationList>>
      v5StudiesStudyIdParticipantsUserIdNotificationsGet({
    required String? studyId,
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(NotificationRegistrationList,
        () => NotificationRegistrationList.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdNotificationsGet(
        studyId: studyId,
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a study participant’s push notification registrations
  ///@param
  ///@param
  @Get(path: '/v5/studies/{studyId}/participants/{userId}/notifications')
  Future<chopper.Response<NotificationRegistrationList>>
      _v5StudiesStudyIdParticipantsUserIdNotificationsGet({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Send a push notification to a single participant
  ///@param
  ///@param
  ///@param NotificationMessage
  Future<chopper.Response>
      v5StudiesStudyIdParticipantsUserIdSendNotificationPost({
    required String? studyId,
    required String? userId,
    required NotificationMessage? notificationMessage,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        NotificationMessage, () => NotificationMessage.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdSendNotificationPost(
        studyId: studyId,
        userId: userId,
        notificationMessage: notificationMessage,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Send a push notification to a single participant
  ///@param
  ///@param
  ///@param NotificationMessage
  @Post(path: '/v5/studies/{studyId}/participants/{userId}/sendNotification')
  Future<chopper.Response>
      _v5StudiesStudyIdParticipantsUserIdSendNotificationPost({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Body() required NotificationMessage? notificationMessage,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Send a message (SMS or email) to a participant explaining how to download and install the app
  ///@param
  ///@param
  Future<chopper.Response>
      v5StudiesStudyIdParticipantsUserIdSendInstallLinkPost({
    required String? studyId,
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v5StudiesStudyIdParticipantsUserIdSendInstallLinkPost(
        studyId: studyId,
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Send a message (SMS or email) to a participant explaining how to download and install the app
  ///@param
  ///@param
  @Post(
    path: '/v5/studies/{studyId}/participants/{userId}/sendInstallLink',
    optionalBody: true,
  )
  Future<chopper.Response>
      _v5StudiesStudyIdParticipantsUserIdSendInstallLinkPost({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the timeline that is being assigned to the specific study participant. (Currently all users in a study are assigned the same timeline, but this will change with the introduction of study arms.)
  ///@param
  ///@param
  Future<chopper.Response<Timeline>>
      v5StudiesStudyIdParticipantsUserIdTimelineGet({
    required String? studyId,
    required String? userId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Timeline, () => Timeline.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdTimelineGet(
        studyId: studyId,
        userId: userId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the timeline that is being assigned to the specific study participant. (Currently all users in a study are assigned the same timeline, but this will change with the introduction of study arms.)
  ///@param
  ///@param
  @Get(path: '/v5/studies/{studyId}/participants/{userId}/timeline')
  Future<chopper.Response<Timeline>>
      _v5StudiesStudyIdParticipantsUserIdTimelineGet({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get activity events for the participants
  ///@param
  ///@param
  Future<chopper.Response<StudyActivityEventList>>
      v5StudiesStudyIdParticipantsUserIdActivityeventsGet({
    required String? studyId,
    required String? userId,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyActivityEventList, () => StudyActivityEventList.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdActivityeventsGet(
        studyId: studyId, userId: userId, cacheControl: cacheControl);
  }

  ///Get activity events for the participants
  ///@param
  ///@param
  @Get(path: '/v5/studies/{studyId}/participants/{userId}/activityevents')
  Future<chopper.Response<StudyActivityEventList>>
      _v5StudiesStudyIdParticipantsUserIdActivityeventsGet({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new activity event for a participant in this study.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param CustomActivityEventRequest
  Future<chopper.Response<Message>>
      v5StudiesStudyIdParticipantsUserIdActivityeventsPost({
    required String? studyId,
    required String? userId,
    bool? showError,
    bool? updateBursts,
    required StudyActivityEventRequest? customActivityEventRequest,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(StudyActivityEventRequest,
        () => StudyActivityEventRequest.fromJsonFactory);
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdActivityeventsPost(
        studyId: studyId,
        userId: userId,
        showError: showError,
        updateBursts: updateBursts,
        customActivityEventRequest: customActivityEventRequest,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new activity event for a participant in this study.
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param CustomActivityEventRequest
  @Post(path: '/v5/studies/{studyId}/participants/{userId}/activityevents')
  Future<chopper.Response<Message>>
      _v5StudiesStudyIdParticipantsUserIdActivityeventsPost({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Query('showError') bool? showError,
    @Query('updateBursts') bool? updateBursts,
    @Body() required StudyActivityEventRequest? customActivityEventRequest,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update one or more adherence records for a participant
  ///@param
  ///@param
  ///@param AdherenceRecordUpdates One ore more adherence records
  Future<chopper.Response<Message>>
      v5StudiesStudyIdParticipantsUserIdAdherencePost({
    required String? studyId,
    required String? userId,
    required AdherenceRecordUpdates? adherenceRecordUpdates,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AdherenceRecordUpdates, () => AdherenceRecordUpdates.fromJsonFactory);
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdAdherencePost(
        studyId: studyId,
        userId: userId,
        adherenceRecordUpdates: adherenceRecordUpdates,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update one or more adherence records for a participant
  ///@param
  ///@param
  ///@param AdherenceRecordUpdates One ore more adherence records
  @Post(path: '/v5/studies/{studyId}/participants/{userId}/adherence')
  Future<chopper.Response<Message>>
      _v5StudiesStudyIdParticipantsUserIdAdherencePost({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Body() required AdherenceRecordUpdates? adherenceRecordUpdates,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Search for adherence records.
  ///@param
  ///@param
  ///@param AdherenceRecordsSearch The search criteria.
  Future<chopper.Response<AdherenceRecordList>>
      v5StudiesStudyIdParticipantsUserIdAdherenceSearchPost({
    required String? studyId,
    required String? userId,
    required AdherenceRecordsSearch? adherenceRecordsSearch,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AdherenceRecordsSearch, () => AdherenceRecordsSearch.fromJsonFactory);
    generatedMapping.putIfAbsent(
        AdherenceRecordList, () => AdherenceRecordList.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdAdherenceSearchPost(
        studyId: studyId,
        userId: userId,
        adherenceRecordsSearch: adherenceRecordsSearch,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Search for adherence records.
  ///@param
  ///@param
  ///@param AdherenceRecordsSearch The search criteria.
  @Post(path: '/v5/studies/{studyId}/participants/{userId}/adherence/search')
  Future<chopper.Response<AdherenceRecordList>>
      _v5StudiesStudyIdParticipantsUserIdAdherenceSearchPost({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Body() required AdherenceRecordsSearch? adherenceRecordsSearch,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete an adherence record
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<Message>>
      v5StudiesStudyIdParticipantsUserIdAdherenceInstanceGuidEventTimestampStartedOnDelete({
    required String? studyId,
    required String? userId,
    required String? instanceGuid,
    required String? eventTimestamp,
    required String? startedOn,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdAdherenceInstanceGuidEventTimestampStartedOnDelete(
        studyId: studyId,
        userId: userId,
        instanceGuid: instanceGuid,
        eventTimestamp: eventTimestamp,
        startedOn: startedOn,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete an adherence record
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Delete(
      path:
          '/v5/studies/{studyId}/participants/{userId}/adherence/{instanceGuid}/{eventTimestamp}/{startedOn}')
  Future<chopper.Response<Message>>
      _v5StudiesStudyIdParticipantsUserIdAdherenceInstanceGuidEventTimestampStartedOnDelete({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Path('instanceGuid') required String? instanceGuid,
    @Path('eventTimestamp') required String? eventTimestamp,
    @Path('startedOn') required String? startedOn,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the history of past timestamps for this event (for the caller).
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<StudyActivityEventPagedList>>
      v5StudiesStudyIdParticipantsUserIdActivityeventsEventIdGet({
    required String? studyId,
    required String? userId,
    required String? eventId,
    int? offsetBy,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(StudyActivityEventPagedList,
        () => StudyActivityEventPagedList.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdActivityeventsEventIdGet(
        studyId: studyId,
        userId: userId,
        eventId: eventId,
        offsetBy: offsetBy,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the history of past timestamps for this event (for the caller).
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(
      path:
          '/v5/studies/{studyId}/participants/{userId}/activityevents/{eventId}')
  Future<chopper.Response<StudyActivityEventPagedList>>
      _v5StudiesStudyIdParticipantsUserIdActivityeventsEventIdGet({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Path('eventId') required String? eventId,
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete activity event for a study participant if it is mutable.
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<Message>>
      v5StudiesStudyIdParticipantsUserIdActivityeventsEventIdDelete({
    required String? studyId,
    required String? userId,
    required String? eventId,
    bool? showError,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdActivityeventsEventIdDelete(
        studyId: studyId,
        userId: userId,
        eventId: eventId,
        showError: showError,
        cacheControl: cacheControl);
  }

  ///Delete activity event for a study participant if it is mutable.
  ///@param
  ///@param
  ///@param
  ///@param
  @Delete(
      path:
          '/v5/studies/{studyId}/participants/{userId}/activityevents/{eventId}')
  Future<chopper.Response<Message>>
      _v5StudiesStudyIdParticipantsUserIdActivityeventsEventIdDelete({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Path('eventId') required String? eventId,
    @Query('showError') bool? showError,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the activity events for this study (for the caller).
  ///@param
  Future<chopper.Response<StudyActivityEventList>>
      v5StudiesStudyIdParticipantsSelfActivityeventsGet({
    required String? studyId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StudyActivityEventList, () => StudyActivityEventList.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsSelfActivityeventsGet(
        studyId: studyId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the activity events for this study (for the caller).
  ///@param
  @Get(path: '/v5/studies/{studyId}/participants/self/activityevents')
  Future<chopper.Response<StudyActivityEventList>>
      _v5StudiesStudyIdParticipantsSelfActivityeventsGet({
    @Path('studyId') required String? studyId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new activity event for the caller in this study.
  ///@param
  ///@param
  ///@param
  ///@param StudyActivityEventRequest
  Future<chopper.Response<Message>>
      v5StudiesStudyIdParticipantsSelfActivityeventsPost({
    required String? studyId,
    bool? showError,
    bool? updateBursts,
    required StudyActivityEventRequest? studyActivityEventRequest,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(StudyActivityEventRequest,
        () => StudyActivityEventRequest.fromJsonFactory);
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsSelfActivityeventsPost(
        studyId: studyId,
        showError: showError,
        updateBursts: updateBursts,
        studyActivityEventRequest: studyActivityEventRequest,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new activity event for the caller in this study.
  ///@param
  ///@param
  ///@param
  ///@param StudyActivityEventRequest
  @Post(path: '/v5/studies/{studyId}/participants/self/activityevents')
  Future<chopper.Response<Message>>
      _v5StudiesStudyIdParticipantsSelfActivityeventsPost({
    @Path('studyId') required String? studyId,
    @Query('showError') bool? showError,
    @Query('updateBursts') bool? updateBursts,
    @Body() required StudyActivityEventRequest? studyActivityEventRequest,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the history of past timestamps for this event (for the caller).
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<StudyActivityEventPagedList>>
      v5StudiesStudyIdParticipantsSelfActivityeventsEventIdGet({
    required String? studyId,
    required String? eventId,
    int? offsetBy,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(StudyActivityEventPagedList,
        () => StudyActivityEventPagedList.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsSelfActivityeventsEventIdGet(
        studyId: studyId,
        eventId: eventId,
        offsetBy: offsetBy,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the history of past timestamps for this event (for the caller).
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v5/studies/{studyId}/participants/self/activityevents/{eventId}')
  Future<chopper.Response<StudyActivityEventPagedList>>
      _v5StudiesStudyIdParticipantsSelfActivityeventsEventIdGet({
    @Path('studyId') required String? studyId,
    @Path('eventId') required String? eventId,
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete an activity event (for the caller) if it is mutable.
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<Message>>
      v5StudiesStudyIdParticipantsSelfActivityeventsEventIdDelete({
    required String? studyId,
    required String? eventId,
    bool? showError,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsSelfActivityeventsEventIdDelete(
        studyId: studyId,
        eventId: eventId,
        showError: showError,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete an activity event (for the caller) if it is mutable.
  ///@param
  ///@param
  ///@param
  @Delete(
      path: '/v5/studies/{studyId}/participants/self/activityevents/{eventId}')
  Future<chopper.Response<Message>>
      _v5StudiesStudyIdParticipantsSelfActivityeventsEventIdDelete({
    @Path('studyId') required String? studyId,
    @Path('eventId') required String? eventId,
    @Query('showError') bool? showError,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Search for adherence records.
  ///@param
  ///@param AdherenceRecordsSearch The search criteria.
  Future<chopper.Response<AdherenceRecordList>>
      v5StudiesStudyIdParticipantsSelfAdherenceSearchPost({
    required String? studyId,
    required AdherenceRecordsSearch? adherenceRecordsSearch,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AdherenceRecordsSearch, () => AdherenceRecordsSearch.fromJsonFactory);
    generatedMapping.putIfAbsent(
        AdherenceRecordList, () => AdherenceRecordList.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsSelfAdherenceSearchPost(
        studyId: studyId,
        adherenceRecordsSearch: adherenceRecordsSearch,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Search for adherence records.
  ///@param
  ///@param AdherenceRecordsSearch The search criteria.
  @Post(path: '/v5/studies/{studyId}/participants/self/adherence/search')
  Future<chopper.Response<AdherenceRecordList>>
      _v5StudiesStudyIdParticipantsSelfAdherenceSearchPost({
    @Path('studyId') required String? studyId,
    @Body() required AdherenceRecordsSearch? adherenceRecordsSearch,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create or update one or more adherence records.
  ///@param
  ///@param AdherenceRecordUpdates One ore more adherence records
  Future<chopper.Response<Message>>
      v5StudiesStudyIdParticipantsSelfAdherencePost({
    required String? studyId,
    required AdherenceRecordUpdates? adherenceRecordUpdates,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AdherenceRecordUpdates, () => AdherenceRecordUpdates.fromJsonFactory);
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsSelfAdherencePost(
        studyId: studyId,
        adherenceRecordUpdates: adherenceRecordUpdates,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create or update one or more adherence records.
  ///@param
  ///@param AdherenceRecordUpdates One ore more adherence records
  @Post(path: '/v5/studies/{studyId}/participants/self/adherence')
  Future<chopper.Response<Message>>
      _v5StudiesStudyIdParticipantsSelfAdherencePost({
    @Path('studyId') required String? studyId,
    @Body() required AdherenceRecordUpdates? adherenceRecordUpdates,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the caller’s timeline of scheduled assessments in this study. Timelines rarely change and can be large, though they are sent compressed by the server and usually compress well for transfer. This method supports long-term caching by accepting an optional timestamp. It will return a 304 `Not Modified` response if the schedule has not been updated after the given timestamp.
  ///@param
  ///@param If-Modified-Since ISO 8601 timestamp value
  Future<chopper.Response<Timeline>>
      v5StudiesStudyIdParticipantsSelfTimelineGet({
    required String? studyId,
    String? ifModifiedSince,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Timeline, () => Timeline.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsSelfTimelineGet(
        studyId: studyId,
        ifModifiedSince: ifModifiedSince,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the caller’s timeline of scheduled assessments in this study. Timelines rarely change and can be large, though they are sent compressed by the server and usually compress well for transfer. This method supports long-term caching by accepting an optional timestamp. It will return a 304 `Not Modified` response if the schedule has not been updated after the given timestamp.
  ///@param
  ///@param If-Modified-Since ISO 8601 timestamp value
  @Get(path: '/v5/studies/{studyId}/participants/self/timeline')
  Future<chopper.Response<Timeline>>
      _v5StudiesStudyIdParticipantsSelfTimelineGet({
    @Path('studyId') required String? studyId,
    @Header('If-Modified-Since') String? ifModifiedSince,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the indices (identifiers) of all the reports available for participants in the given study.
  ///@param
  Future<chopper.Response<ReportIndexList>>
      v5StudiesStudyIdParticipantsReportsGet({
    required String? studyId,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ReportIndexList, () => ReportIndexList.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsReportsGet(
        studyId: studyId,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the indices (identifiers) of all the reports available for participants in the given study.
  ///@param
  @Get(path: '/v5/studies/{studyId}/participants/reports')
  Future<chopper.Response<ReportIndexList>>
      _v5StudiesStudyIdParticipantsReportsGet({
    @Path('studyId') required String? studyId,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a single report index with some additional metadata about the report series.
  ///@param
  ///@param
  Future<chopper.Response<ReportIndex>>
      v5StudiesStudyIdParticipantsReportsIdentifierGet({
    required String? studyId,
    required String? identifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        ReportIndex, () => ReportIndex.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsReportsIdentifierGet(
        studyId: studyId,
        identifier: identifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a single report index with some additional metadata about the report series.
  ///@param
  ///@param
  @Get(path: '/v5/studies/{studyId}/participants/reports/{identifier}')
  Future<chopper.Response<ReportIndex>>
      _v5StudiesStudyIdParticipantsReportsIdentifierGet({
    @Path('studyId') required String? studyId,
    @Path('identifier') required String? identifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete a single report index (note that deleting an index in effect makes all report records under that identifier less accessible...the reports are not deleted, but they are not listed in the indices, either).
  ///@param
  ///@param
  Future<chopper.Response<Message>>
      v5StudiesStudyIdParticipantsReportsIdentifierDelete({
    required String? studyId,
    required String? identifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsReportsIdentifierDelete(
        studyId: studyId,
        identifier: identifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete a single report index (note that deleting an index in effect makes all report records under that identifier less accessible...the reports are not deleted, but they are not listed in the indices, either).
  ///@param
  ///@param
  @Delete(path: '/v5/studies/{studyId}/participants/reports/{identifier}')
  Future<chopper.Response<Message>>
      _v5StudiesStudyIdParticipantsReportsIdentifierDelete({
    @Path('studyId') required String? studyId,
    @Path('identifier') required String? identifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a series of report records for a specific date and time range (this API uses dates and times and not just dates; use a standard time of day portion like “T00:00:00.000Z” if a time portion is unnecessary, being sure to create and retrieve records with the same set time).
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorReportDataList>>
      v5StudiesStudyIdParticipantsUserIdReportsIdentifierGet({
    required String? studyId,
    required String? userId,
    required String? identifier,
    required String? startTime,
    required String? endTime,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorReportDataList,
        () => ForwardCursorReportDataList.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdReportsIdentifierGet(
        studyId: studyId,
        userId: userId,
        identifier: identifier,
        startTime: startTime,
        endTime: endTime,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a series of report records for a specific date and time range (this API uses dates and times and not just dates; use a standard time of day portion like “T00:00:00.000Z” if a time portion is unnecessary, being sure to create and retrieve records with the same set time).
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v5/studies/{studyId}/participants/{userId}/reports/{identifier}')
  Future<chopper.Response<ForwardCursorReportDataList>>
      _v5StudiesStudyIdParticipantsUserIdReportsIdentifierGet({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Path('identifier') required String? identifier,
    @Query('startTime') required String? startTime,
    @Query('endTime') required String? endTime,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Add a participant report for a single date and time (this API uses dates and times and not just dates; use a standard time of day portion like “T00:00:00.000Z” if a time portion is unnecessary, being sure to create and retrieve records with the same set time).
  ///@param
  ///@param
  ///@param
  ///@param ReportData
  Future<chopper.Response<Message>>
      v5StudiesStudyIdParticipantsUserIdReportsIdentifierPost({
    required String? studyId,
    required String? userId,
    required String? identifier,
    required ReportData? reportData,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ReportData, () => ReportData.fromJsonFactory);
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdReportsIdentifierPost(
        studyId: studyId,
        userId: userId,
        identifier: identifier,
        reportData: reportData,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Add a participant report for a single date and time (this API uses dates and times and not just dates; use a standard time of day portion like “T00:00:00.000Z” if a time portion is unnecessary, being sure to create and retrieve records with the same set time).
  ///@param
  ///@param
  ///@param
  ///@param ReportData
  @Post(
      path: '/v5/studies/{studyId}/participants/{userId}/reports/{identifier}')
  Future<chopper.Response<Message>>
      _v5StudiesStudyIdParticipantsUserIdReportsIdentifierPost({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Path('identifier') required String? identifier,
    @Body() required ReportData? reportData,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete all records for a report for one member of the study.
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<Message>>
      v5StudiesStudyIdParticipantsUserIdReportsIdentifierDelete({
    required String? studyId,
    required String? userId,
    required String? identifier,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdReportsIdentifierDelete(
        studyId: studyId,
        userId: userId,
        identifier: identifier,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete all records for a report for one member of the study.
  ///@param
  ///@param
  ///@param
  @Delete(
      path: '/v5/studies/{studyId}/participants/{userId}/reports/{identifier}')
  Future<chopper.Response<Message>>
      _v5StudiesStudyIdParticipantsUserIdReportsIdentifierDelete({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Path('identifier') required String? identifier,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete one record for a report for one member of the study.
  ///@param
  ///@param
  ///@param
  ///@param date The date and time of the record to delete
  Future<chopper.Response<Message>>
      v5StudiesStudyIdParticipantsUserIdReportsIdentifierDateDelete({
    required String? studyId,
    required String? userId,
    required String? identifier,
    required String? date,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdReportsIdentifierDateDelete(
        studyId: studyId,
        userId: userId,
        identifier: identifier,
        date: date,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete one record for a report for one member of the study.
  ///@param
  ///@param
  ///@param
  ///@param date The date and time of the record to delete
  @Delete(
      path:
          '/v5/studies/{studyId}/participants/{userId}/reports/{identifier}/{date}')
  Future<chopper.Response<Message>>
      _v5StudiesStudyIdParticipantsUserIdReportsIdentifierDateDelete({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Path('identifier') required String? identifier,
    @Path('date') required String? date,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a series of report records for a specific date and time range for the caller (this API uses dates and times and not just dates; use a standard time of day portion like “T00:00:00.000Z” if a time portion is unnecessary, being sure to create and retrieve records with the same set time).
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<ForwardCursorReportDataList>>
      v5StudiesStudyIdParticipantsSelfReportsIdentifierGet({
    required String? studyId,
    required String? identifier,
    required String? startTime,
    required String? endTime,
    String? offsetKey,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ForwardCursorReportDataList,
        () => ForwardCursorReportDataList.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsSelfReportsIdentifierGet(
        studyId: studyId,
        identifier: identifier,
        startTime: startTime,
        endTime: endTime,
        offsetKey: offsetKey,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a series of report records for a specific date and time range for the caller (this API uses dates and times and not just dates; use a standard time of day portion like “T00:00:00.000Z” if a time portion is unnecessary, being sure to create and retrieve records with the same set time).
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v5/studies/{studyId}/participants/self/reports/{identifier}')
  Future<chopper.Response<ForwardCursorReportDataList>>
      _v5StudiesStudyIdParticipantsSelfReportsIdentifierGet({
    @Path('studyId') required String? studyId,
    @Path('identifier') required String? identifier,
    @Query('startTime') required String? startTime,
    @Query('endTime') required String? endTime,
    @Query('offsetKey') String? offsetKey,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Add a participant report for a single date and time for the caller (this API uses dates and times and not just dates; use a standard time of day portion like “T00:00:00.000Z” if a time portion is unnecessary, being sure to create and retrieve records with the same set time).
  ///@param
  ///@param
  ///@param ReportData
  Future<chopper.Response<Message>>
      v5StudiesStudyIdParticipantsSelfReportsIdentifierPost({
    required String? studyId,
    required String? identifier,
    required ReportData? reportData,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(ReportData, () => ReportData.fromJsonFactory);
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsSelfReportsIdentifierPost(
        studyId: studyId,
        identifier: identifier,
        reportData: reportData,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Add a participant report for a single date and time for the caller (this API uses dates and times and not just dates; use a standard time of day portion like “T00:00:00.000Z” if a time portion is unnecessary, being sure to create and retrieve records with the same set time).
  ///@param
  ///@param
  ///@param ReportData
  @Post(path: '/v5/studies/{studyId}/participants/self/reports/{identifier}')
  Future<chopper.Response<Message>>
      _v5StudiesStudyIdParticipantsSelfReportsIdentifierPost({
    @Path('studyId') required String? studyId,
    @Path('identifier') required String? identifier,
    @Body() required ReportData? reportData,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a detailed report on a participant’s adherence to the entire study protocol’s schedule.
  ///@param
  ///@param
  ///@param datetime The timestamp to use as “now” for the calculation of adherence. This timestamp will be adjusted to the participant’s `clientTimeZone` value if this value has been persisted for the participant.
  ///@param activeOnly Only return records that are currently actionable by the participant
  Future<chopper.Response<EventStreamAdherenceReport>>
      v5StudiesStudyIdParticipantsUserIdAdherenceEventstreamGet({
    required String? studyId,
    required String? userId,
    String? datetime,
    bool? activeOnly,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(EventStreamAdherenceReport,
        () => EventStreamAdherenceReport.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsUserIdAdherenceEventstreamGet(
        studyId: studyId,
        userId: userId,
        datetime: datetime,
        activeOnly: activeOnly,
        cacheControl: cacheControl);
  }

  ///Get a detailed report on a participant’s adherence to the entire study protocol’s schedule.
  ///@param
  ///@param
  ///@param datetime The timestamp to use as “now” for the calculation of adherence. This timestamp will be adjusted to the participant’s `clientTimeZone` value if this value has been persisted for the participant.
  ///@param activeOnly Only return records that are currently actionable by the participant
  @Get(
      path: '/v5/studies/{studyId}/participants/{userId}/adherence/eventstream')
  Future<chopper.Response<EventStreamAdherenceReport>>
      _v5StudiesStudyIdParticipantsUserIdAdherenceEventstreamGet({
    @Path('studyId') required String? studyId,
    @Path('userId') required String? userId,
    @Query('datetime') String? datetime,
    @Query('activeOnly') bool? activeOnly,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a detailed report on the caller’s adherence to the entire study protocol’s schedule.
  ///@param
  ///@param datetime The timestamp to use as “now” for the calculation of adherence. This timestamp will be adjusted to the caller’s `clientTimeZone` value if this value has been persisted.
  ///@param activeOnly Only return records that are currently active and actionable for the participant.
  Future<chopper.Response<EventStreamAdherenceReport>>
      v5StudiesStudyIdParticipantsSelfAdherenceEventstreamGet({
    required String? studyId,
    String? datetime,
    bool? activeOnly,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(EventStreamAdherenceReport,
        () => EventStreamAdherenceReport.fromJsonFactory);

    return _v5StudiesStudyIdParticipantsSelfAdherenceEventstreamGet(
        studyId: studyId,
        datetime: datetime,
        activeOnly: activeOnly,
        cacheControl: cacheControl);
  }

  ///Get a detailed report on the caller’s adherence to the entire study protocol’s schedule.
  ///@param
  ///@param datetime The timestamp to use as “now” for the calculation of adherence. This timestamp will be adjusted to the caller’s `clientTimeZone` value if this value has been persisted.
  ///@param activeOnly Only return records that are currently active and actionable for the participant.
  @Get(path: '/v5/studies/{studyId}/participants/self/adherence/eventstream')
  Future<chopper.Response<EventStreamAdherenceReport>>
      _v5StudiesStudyIdParticipantsSelfAdherenceEventstreamGet({
    @Path('studyId') required String? studyId,
    @Query('datetime') String? datetime,
    @Query('activeOnly') bool? activeOnly,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a list of templates of a specific type
  ///@param
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<TemplateList>> v3TemplatesGet({
    String? type,
    int? offsetBy,
    int? pageSize,
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        TemplateList, () => TemplateList.fromJsonFactory);

    return _v3TemplatesGet(
        type: type,
        offsetBy: offsetBy,
        pageSize: pageSize,
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a list of templates of a specific type
  ///@param
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/templates')
  Future<chopper.Response<TemplateList>> _v3TemplatesGet({
    @Query('type') String? type,
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new template
  ///@param Template New template
  Future<chopper.Response<GuidVersionHolder>> v3TemplatesPost({
    required Template? template,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Template, () => Template.fromJsonFactory);
    generatedMapping.putIfAbsent(
        GuidVersionHolder, () => GuidVersionHolder.fromJsonFactory);

    return _v3TemplatesPost(
        template: template,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new template
  ///@param Template New template
  @Post(path: '/v3/templates')
  Future<chopper.Response<GuidVersionHolder>> _v3TemplatesPost({
    @Body() required Template? template,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a template
  ///@param
  Future<chopper.Response<Template>> v3TemplatesGuidGet({
    required String? guid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Template, () => Template.fromJsonFactory);

    return _v3TemplatesGuidGet(
        guid: guid, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get a template
  ///@param
  @Get(path: '/v3/templates/{guid}')
  Future<chopper.Response<Template>> _v3TemplatesGuidGet({
    @Path('guid') required String? guid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update an existing template
  ///@param
  ///@param Template Updated template
  Future<chopper.Response<GuidVersionHolder>> v3TemplatesGuidPost({
    required String? guid,
    required Template? template,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Template, () => Template.fromJsonFactory);
    generatedMapping.putIfAbsent(
        GuidVersionHolder, () => GuidVersionHolder.fromJsonFactory);

    return _v3TemplatesGuidPost(
        guid: guid,
        template: template,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update an existing template
  ///@param
  ///@param Template Updated template
  @Post(path: '/v3/templates/{guid}')
  Future<chopper.Response<GuidVersionHolder>> _v3TemplatesGuidPost({
    @Path('guid') required String? guid,
    @Body() required Template? template,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete template (and all revisions)
  ///@param
  ///@param
  Future<chopper.Response<Message>> v3TemplatesGuidDelete({
    required String? guid,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v3TemplatesGuidDelete(
        guid: guid,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete template (and all revisions)
  ///@param
  ///@param
  @Delete(path: '/v3/templates/{guid}')
  Future<chopper.Response<Message>> _v3TemplatesGuidDelete({
    @Path('guid') required String? guid,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get the template document revisions
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<TemplateRevisionList>> v3TemplatesGuidRevisionsGet({
    required String? guid,
    int? offsetBy,
    int? pageSize,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        TemplateRevisionList, () => TemplateRevisionList.fromJsonFactory);

    return _v3TemplatesGuidRevisionsGet(
        guid: guid,
        offsetBy: offsetBy,
        pageSize: pageSize,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get the template document revisions
  ///@param
  ///@param
  ///@param
  @Get(path: '/v3/templates/{guid}/revisions')
  Future<chopper.Response<TemplateRevisionList>> _v3TemplatesGuidRevisionsGet({
    @Path('guid') required String? guid,
    @Query('offsetBy') int? offsetBy,
    @Query('pageSize') int? pageSize,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new revision of a template
  ///@param
  ///@param TemplateRevision
  Future<chopper.Response<CreatedOnHolder>> v3TemplatesGuidRevisionsPost({
    required String? guid,
    required TemplateRevision? templateRevision,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        TemplateRevision, () => TemplateRevision.fromJsonFactory);
    generatedMapping.putIfAbsent(
        CreatedOnHolder, () => CreatedOnHolder.fromJsonFactory);

    return _v3TemplatesGuidRevisionsPost(
        guid: guid,
        templateRevision: templateRevision,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new revision of a template
  ///@param
  ///@param TemplateRevision
  @Post(path: '/v3/templates/{guid}/revisions')
  Future<chopper.Response<CreatedOnHolder>> _v3TemplatesGuidRevisionsPost({
    @Path('guid') required String? guid,
    @Body() required TemplateRevision? templateRevision,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a single template document revision
  ///@param
  ///@param
  Future<chopper.Response<TemplateRevision>>
      v3TemplatesGuidRevisionsCreatedOnGet({
    required String? guid,
    required String? createdOn,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        TemplateRevision, () => TemplateRevision.fromJsonFactory);

    return _v3TemplatesGuidRevisionsCreatedOnGet(
        guid: guid,
        createdOn: createdOn,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a single template document revision
  ///@param
  ///@param
  @Get(path: '/v3/templates/{guid}/revisions/{createdOn}')
  Future<chopper.Response<TemplateRevision>>
      _v3TemplatesGuidRevisionsCreatedOnGet({
    @Path('guid') required String? guid,
    @Path('createdOn') required String? createdOn,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Set a specific template revision as the version to use when the template is selected
  ///@param
  ///@param
  Future<chopper.Response<Message>>
      v3TemplatesGuidRevisionsCreatedOnPublishPost({
    required String? guid,
    required String? createdOn,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v3TemplatesGuidRevisionsCreatedOnPublishPost(
        guid: guid,
        createdOn: createdOn,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Set a specific template revision as the version to use when the template is selected
  ///@param
  ///@param
  @Post(
    path: '/v3/templates/{guid}/revisions/{createdOn}/publish',
    optionalBody: true,
  )
  Future<chopper.Response<Message>>
      _v3TemplatesGuidRevisionsCreatedOnPublishPost({
    @Path('guid') required String? guid,
    @Path('createdOn') required String? createdOn,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a list of the app's configurations
  ///@param
  Future<chopper.Response<AppConfigList>> v3AppconfigsGet({
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AppConfigList, () => AppConfigList.fromJsonFactory);

    return _v3AppconfigsGet(
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a list of the app's configurations
  ///@param
  @Get(path: '/v3/appconfigs')
  Future<chopper.Response<AppConfigList>> _v3AppconfigsGet({
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new app config
  ///@param AppConfig New app configuration
  Future<chopper.Response<GuidVersionHolder>> v3AppconfigsPost({
    required AppConfig? appConfig,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(AppConfig, () => AppConfig.fromJsonFactory);
    generatedMapping.putIfAbsent(
        GuidVersionHolder, () => GuidVersionHolder.fromJsonFactory);

    return _v3AppconfigsPost(
        appConfig: appConfig,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new app config
  ///@param AppConfig New app configuration
  @Post(path: '/v3/appconfigs')
  Future<chopper.Response<GuidVersionHolder>> _v3AppconfigsPost({
    @Body() required AppConfig? appConfig,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an app config
  ///@param
  Future<chopper.Response<AppConfig>> v3AppconfigsGuidGet({
    required String? guid,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(AppConfig, () => AppConfig.fromJsonFactory);

    return _v3AppconfigsGuidGet(
        guid: guid, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get an app config
  ///@param
  @Get(path: '/v3/appconfigs/{guid}')
  Future<chopper.Response<AppConfig>> _v3AppconfigsGuidGet({
    @Path('guid') required String? guid,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update an existing app config
  ///@param
  ///@param AppConfig Updated app configuration
  Future<chopper.Response<GuidVersionHolder>> v3AppconfigsGuidPost({
    required String? guid,
    required AppConfig? appConfig,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(AppConfig, () => AppConfig.fromJsonFactory);
    generatedMapping.putIfAbsent(
        GuidVersionHolder, () => GuidVersionHolder.fromJsonFactory);

    return _v3AppconfigsGuidPost(
        guid: guid,
        appConfig: appConfig,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update an existing app config
  ///@param
  ///@param AppConfig Updated app configuration
  @Post(path: '/v3/appconfigs/{guid}')
  Future<chopper.Response<GuidVersionHolder>> _v3AppconfigsGuidPost({
    @Path('guid') required String? guid,
    @Body() required AppConfig? appConfig,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete an app config
  ///@param
  ///@param
  Future<chopper.Response<Message>> v3AppconfigsGuidDelete({
    required String? guid,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v3AppconfigsGuidDelete(
        guid: guid,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete an app config
  ///@param
  ///@param
  @Delete(path: '/v3/appconfigs/{guid}')
  Future<chopper.Response<Message>> _v3AppconfigsGuidDelete({
    @Path('guid') required String? guid,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get a list of the most recent revision of each configuration element in the app
  ///@param
  Future<chopper.Response<AppConfigElementList>> v3AppconfigsElementsGet({
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AppConfigElementList, () => AppConfigElementList.fromJsonFactory);

    return _v3AppconfigsElementsGet(
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get a list of the most recent revision of each configuration element in the app
  ///@param
  @Get(path: '/v3/appconfigs/elements')
  Future<chopper.Response<AppConfigElementList>> _v3AppconfigsElementsGet({
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Create a new app config element
  ///@param AppConfigElement New app configuration element
  Future<chopper.Response<VersionHolder>> v3AppconfigsElementsPost({
    required AppConfigElement? appConfigElement,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AppConfigElement, () => AppConfigElement.fromJsonFactory);
    generatedMapping.putIfAbsent(
        VersionHolder, () => VersionHolder.fromJsonFactory);

    return _v3AppconfigsElementsPost(
        appConfigElement: appConfigElement,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Create a new app config element
  ///@param AppConfigElement New app configuration element
  @Post(path: '/v3/appconfigs/elements')
  Future<chopper.Response<VersionHolder>> _v3AppconfigsElementsPost({
    @Body() required AppConfigElement? appConfigElement,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get all revisions for an app config element
  ///@param
  ///@param
  Future<chopper.Response<AppConfigElementList>> v3AppconfigsElementsIdGet({
    required String? id,
    bool? includeDeleted,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AppConfigElementList, () => AppConfigElementList.fromJsonFactory);

    return _v3AppconfigsElementsIdGet(
        id: id,
        includeDeleted: includeDeleted,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get all revisions for an app config element
  ///@param
  ///@param
  @Get(path: '/v3/appconfigs/elements/{id}')
  Future<chopper.Response<AppConfigElementList>> _v3AppconfigsElementsIdGet({
    @Path('id') required String? id,
    @Query('includeDeleted') bool? includeDeleted,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete all revisions of an app config element
  ///@param
  ///@param
  Future<chopper.Response<Message>> v3AppconfigsElementsIdDelete({
    required String? id,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v3AppconfigsElementsIdDelete(
        id: id,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete all revisions of an app config element
  ///@param
  ///@param
  @Delete(path: '/v3/appconfigs/elements/{id}')
  Future<chopper.Response<Message>> _v3AppconfigsElementsIdDelete({
    @Path('id') required String? id,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get most recent app config element
  ///@param
  Future<chopper.Response<AppConfigElement>> v3AppconfigsElementsIdRecentGet({
    required String? id,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AppConfigElement, () => AppConfigElement.fromJsonFactory);

    return _v3AppconfigsElementsIdRecentGet(
        id: id, bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get most recent app config element
  ///@param
  @Get(path: '/v3/appconfigs/elements/{id}/recent')
  Future<chopper.Response<AppConfigElement>> _v3AppconfigsElementsIdRecentGet({
    @Path('id') required String? id,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get an app config element
  ///@param
  ///@param
  Future<chopper.Response<AppConfigElement>>
      v3AppconfigsElementsIdRevisionsRevisionGet({
    required String? id,
    required int? revision,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AppConfigElement, () => AppConfigElement.fromJsonFactory);

    return _v3AppconfigsElementsIdRevisionsRevisionGet(
        id: id,
        revision: revision,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get an app config element
  ///@param
  ///@param
  @Get(path: '/v3/appconfigs/elements/{id}/revisions/{revision}')
  Future<chopper.Response<AppConfigElement>>
      _v3AppconfigsElementsIdRevisionsRevisionGet({
    @Path('id') required String? id,
    @Path('revision') required int? revision,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Update an existing app config element
  ///@param
  ///@param
  ///@param AppConfigElement Updated app configuration element
  Future<chopper.Response<VersionHolder>>
      v3AppconfigsElementsIdRevisionsRevisionPost({
    required String? id,
    required int? revision,
    required AppConfigElement? appConfigElement,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        AppConfigElement, () => AppConfigElement.fromJsonFactory);
    generatedMapping.putIfAbsent(
        VersionHolder, () => VersionHolder.fromJsonFactory);

    return _v3AppconfigsElementsIdRevisionsRevisionPost(
        id: id,
        revision: revision,
        appConfigElement: appConfigElement,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Update an existing app config element
  ///@param
  ///@param
  ///@param AppConfigElement Updated app configuration element
  @Post(path: '/v3/appconfigs/elements/{id}/revisions/{revision}')
  Future<chopper.Response<VersionHolder>>
      _v3AppconfigsElementsIdRevisionsRevisionPost({
    @Path('id') required String? id,
    @Path('revision') required int? revision,
    @Body() required AppConfigElement? appConfigElement,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Delete an app config element
  ///@param
  ///@param
  ///@param
  Future<chopper.Response<Message>>
      v3AppconfigsElementsIdRevisionsRevisionDelete({
    required String? id,
    required int? revision,
    bool? physical,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Message, () => Message.fromJsonFactory);

    return _v3AppconfigsElementsIdRevisionsRevisionDelete(
        id: id,
        revision: revision,
        physical: physical,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Delete an app config element
  ///@param
  ///@param
  ///@param
  @Delete(path: '/v3/appconfigs/elements/{id}/revisions/{revision}')
  Future<chopper.Response<Message>>
      _v3AppconfigsElementsIdRevisionsRevisionDelete({
    @Path('id') required String? id,
    @Path('revision') required int? revision,
    @Query('physical') bool? physical,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get all the non-session Redis keys
  Future<chopper.Response<StringList>> v3CacheGet({
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(StringList, () => StringList.fromJsonFactory);

    return _v3CacheGet(
        bridgeSession: bridgeSession, cacheControl: cacheControl);
  }

  ///Get all the non-session Redis keys
  @Get(path: '/v3/cache')
  Future<chopper.Response<StringList>> _v3CacheGet({
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Get all the non-session Redis keys
  ///@param
  Future<chopper.Response<Object>> v3CacheCacheKeyDelete({
    required String? cacheKey,
    String? bridgeSession,
    String? cacheControl,
  }) {
    return _v3CacheCacheKeyDelete(
        cacheKey: cacheKey,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Get all the non-session Redis keys
  ///@param
  @Delete(path: '/v3/cache/{cacheKey}')
  Future<chopper.Response<Object>> _v3CacheCacheKeyDelete({
    @Path('cacheKey') required String? cacheKey,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });

  ///Updates the status of an export job
  ///@param RecordExportStatusRequest A record export status request
  Future<chopper.Response<Object>> v3RecordexportstatusesPost({
    required RecordExportStatusRequest? recordExportStatusRequest,
    String? bridgeSession,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(RecordExportStatusRequest,
        () => RecordExportStatusRequest.fromJsonFactory);

    return _v3RecordexportstatusesPost(
        recordExportStatusRequest: recordExportStatusRequest,
        bridgeSession: bridgeSession,
        cacheControl: cacheControl);
  }

  ///Updates the status of an export job
  ///@param RecordExportStatusRequest A record export status request
  @Post(path: '/v3/recordexportstatuses')
  Future<chopper.Response<Object>> _v3RecordexportstatusesPost({
    @Body() required RecordExportStatusRequest? recordExportStatusRequest,
    @Header('Bridge-Session') String? bridgeSession,
    @Header('Cache-Control') String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class ABTestGroup {
  ABTestGroup({
    required this.percentage,
    required this.schedule,
    this.type,
  });

  factory ABTestGroup.fromJson(Map<String, dynamic> json) =>
      _$ABTestGroupFromJson(json);

  @JsonKey(name: 'percentage', includeIfNull: false)
  final int percentage;
  @JsonKey(name: 'schedule', includeIfNull: false)
  final Schedule schedule;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ABTestGroupFromJson;
  static const toJsonFactory = _$ABTestGroupToJson;
  Map<String, dynamic> toJson() => _$ABTestGroupToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ABTestGroup &&
            (identical(other.percentage, percentage) ||
                const DeepCollectionEquality()
                    .equals(other.percentage, percentage)) &&
            (identical(other.schedule, schedule) ||
                const DeepCollectionEquality()
                    .equals(other.schedule, schedule)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(percentage) ^
      const DeepCollectionEquality().hash(schedule) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ABTestGroupExtension on ABTestGroup {
  ABTestGroup copyWith({int? percentage, Schedule? schedule, String? type}) {
    return ABTestGroup(
        percentage: percentage ?? this.percentage,
        schedule: schedule ?? this.schedule,
        type: type ?? this.type);
  }

  ABTestGroup copyWithWrapped(
      {Wrapped<int>? percentage,
      Wrapped<Schedule>? schedule,
      Wrapped<String?>? type}) {
    return ABTestGroup(
        percentage: (percentage != null ? percentage.value : this.percentage),
        schedule: (schedule != null ? schedule.value : this.schedule),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ABTestScheduleStrategy {
  ABTestScheduleStrategy({
    required this.scheduleGroups,
    this.type,
  });

  factory ABTestScheduleStrategy.fromJson(Map<String, dynamic> json) =>
      _$ABTestScheduleStrategyFromJson(json);

  @JsonKey(
      name: 'scheduleGroups',
      includeIfNull: false,
      defaultValue: <ABTestGroup>[])
  final List<ABTestGroup> scheduleGroups;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ABTestScheduleStrategyFromJson;
  static const toJsonFactory = _$ABTestScheduleStrategyToJson;
  Map<String, dynamic> toJson() => _$ABTestScheduleStrategyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ABTestScheduleStrategy &&
            (identical(other.scheduleGroups, scheduleGroups) ||
                const DeepCollectionEquality()
                    .equals(other.scheduleGroups, scheduleGroups)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(scheduleGroups) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ABTestScheduleStrategyExtension on ABTestScheduleStrategy {
  ABTestScheduleStrategy copyWith(
      {List<ABTestGroup>? scheduleGroups, String? type}) {
    return ABTestScheduleStrategy(
        scheduleGroups: scheduleGroups ?? this.scheduleGroups,
        type: type ?? this.type);
  }

  ABTestScheduleStrategy copyWithWrapped(
      {Wrapped<List<ABTestGroup>>? scheduleGroups, Wrapped<String?>? type}) {
    return ABTestScheduleStrategy(
        scheduleGroups: (scheduleGroups != null
            ? scheduleGroups.value
            : this.scheduleGroups),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AbstractStudyParticipant {
  AbstractStudyParticipant({
    this.firstName,
    this.lastName,
    this.synapseUserId,
    this.id,
    this.notifyByEmail,
    this.attributes,
    this.sharingScope,
    this.createdOn,
    this.emailVerified,
    this.phoneVerified,
    this.status,
    this.roles,
    this.dataGroups,
    this.clientData,
    this.languages,
    this.studyIds,
    this.externalIds,
    this.orgMembership,
    this.note,
    this.clientTimeZone,
  });

  factory AbstractStudyParticipant.fromJson(Map<String, dynamic> json) =>
      _$AbstractStudyParticipantFromJson(json);

  @JsonKey(name: 'firstName', includeIfNull: false, defaultValue: '')
  final String? firstName;
  @JsonKey(name: 'lastName', includeIfNull: false, defaultValue: '')
  final String? lastName;
  @JsonKey(name: 'synapseUserId', includeIfNull: false, defaultValue: '')
  final String? synapseUserId;
  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'notifyByEmail', includeIfNull: false, defaultValue: true)
  final bool? notifyByEmail;
  @JsonKey(name: 'attributes', includeIfNull: false)
  final Map<String, dynamic>? attributes;
  @JsonKey(
    name: 'sharingScope',
    includeIfNull: false,
    toJson: sharingScopeToJson,
    fromJson: sharingScopeFromJson,
  )
  final enums.SharingScope? sharingScope;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'emailVerified', includeIfNull: false)
  final bool? emailVerified;
  @JsonKey(name: 'phoneVerified', includeIfNull: false)
  final bool? phoneVerified;
  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: accountStatusToJson,
    fromJson: accountStatusFromJson,
  )
  final enums.AccountStatus? status;
  @JsonKey(
    name: 'roles',
    includeIfNull: false,
    toJson: roleListToJson,
    fromJson: roleListFromJson,
  )
  final List<enums.Role>? roles;
  @JsonKey(name: 'dataGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String>? dataGroups;
  @JsonKey(name: 'clientData', includeIfNull: false)
  final Map<String, dynamic>? clientData;
  @JsonKey(name: 'languages', includeIfNull: false, defaultValue: <String>[])
  final List<String>? languages;
  @JsonKey(name: 'studyIds', includeIfNull: false, defaultValue: <String>[])
  final List<String>? studyIds;
  @JsonKey(name: 'externalIds', includeIfNull: false)
  final Map<String, dynamic>? externalIds;
  @JsonKey(name: 'orgMembership', includeIfNull: false, defaultValue: '')
  final String? orgMembership;
  @JsonKey(name: 'note', includeIfNull: false, defaultValue: '')
  final String? note;
  @JsonKey(name: 'clientTimeZone', includeIfNull: false, defaultValue: '')
  final String? clientTimeZone;
  static const fromJsonFactory = _$AbstractStudyParticipantFromJson;
  static const toJsonFactory = _$AbstractStudyParticipantToJson;
  Map<String, dynamic> toJson() => _$AbstractStudyParticipantToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AbstractStudyParticipant &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.lastName, lastName) ||
                const DeepCollectionEquality()
                    .equals(other.lastName, lastName)) &&
            (identical(other.synapseUserId, synapseUserId) ||
                const DeepCollectionEquality()
                    .equals(other.synapseUserId, synapseUserId)) &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.notifyByEmail, notifyByEmail) ||
                const DeepCollectionEquality()
                    .equals(other.notifyByEmail, notifyByEmail)) &&
            (identical(other.attributes, attributes) ||
                const DeepCollectionEquality()
                    .equals(other.attributes, attributes)) &&
            (identical(other.sharingScope, sharingScope) ||
                const DeepCollectionEquality()
                    .equals(other.sharingScope, sharingScope)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.emailVerified, emailVerified) ||
                const DeepCollectionEquality()
                    .equals(other.emailVerified, emailVerified)) &&
            (identical(other.phoneVerified, phoneVerified) ||
                const DeepCollectionEquality()
                    .equals(other.phoneVerified, phoneVerified)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.roles, roles) ||
                const DeepCollectionEquality().equals(other.roles, roles)) &&
            (identical(other.dataGroups, dataGroups) ||
                const DeepCollectionEquality()
                    .equals(other.dataGroups, dataGroups)) &&
            (identical(other.clientData, clientData) ||
                const DeepCollectionEquality()
                    .equals(other.clientData, clientData)) &&
            (identical(other.languages, languages) ||
                const DeepCollectionEquality()
                    .equals(other.languages, languages)) &&
            (identical(other.studyIds, studyIds) ||
                const DeepCollectionEquality()
                    .equals(other.studyIds, studyIds)) &&
            (identical(other.externalIds, externalIds) ||
                const DeepCollectionEquality()
                    .equals(other.externalIds, externalIds)) &&
            (identical(other.orgMembership, orgMembership) ||
                const DeepCollectionEquality()
                    .equals(other.orgMembership, orgMembership)) &&
            (identical(other.note, note) ||
                const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.clientTimeZone, clientTimeZone) ||
                const DeepCollectionEquality()
                    .equals(other.clientTimeZone, clientTimeZone)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(firstName) ^
      const DeepCollectionEquality().hash(lastName) ^
      const DeepCollectionEquality().hash(synapseUserId) ^
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(notifyByEmail) ^
      const DeepCollectionEquality().hash(attributes) ^
      const DeepCollectionEquality().hash(sharingScope) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(emailVerified) ^
      const DeepCollectionEquality().hash(phoneVerified) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(roles) ^
      const DeepCollectionEquality().hash(dataGroups) ^
      const DeepCollectionEquality().hash(clientData) ^
      const DeepCollectionEquality().hash(languages) ^
      const DeepCollectionEquality().hash(studyIds) ^
      const DeepCollectionEquality().hash(externalIds) ^
      const DeepCollectionEquality().hash(orgMembership) ^
      const DeepCollectionEquality().hash(note) ^
      const DeepCollectionEquality().hash(clientTimeZone) ^
      runtimeType.hashCode;
}

extension $AbstractStudyParticipantExtension on AbstractStudyParticipant {
  AbstractStudyParticipant copyWith(
      {String? firstName,
      String? lastName,
      String? synapseUserId,
      String? id,
      bool? notifyByEmail,
      Map<String, dynamic>? attributes,
      enums.SharingScope? sharingScope,
      DateTime? createdOn,
      bool? emailVerified,
      bool? phoneVerified,
      enums.AccountStatus? status,
      List<enums.Role>? roles,
      List<String>? dataGroups,
      Map<String, dynamic>? clientData,
      List<String>? languages,
      List<String>? studyIds,
      Map<String, dynamic>? externalIds,
      String? orgMembership,
      String? note,
      String? clientTimeZone}) {
    return AbstractStudyParticipant(
        firstName: firstName ?? this.firstName,
        lastName: lastName ?? this.lastName,
        synapseUserId: synapseUserId ?? this.synapseUserId,
        id: id ?? this.id,
        notifyByEmail: notifyByEmail ?? this.notifyByEmail,
        attributes: attributes ?? this.attributes,
        sharingScope: sharingScope ?? this.sharingScope,
        createdOn: createdOn ?? this.createdOn,
        emailVerified: emailVerified ?? this.emailVerified,
        phoneVerified: phoneVerified ?? this.phoneVerified,
        status: status ?? this.status,
        roles: roles ?? this.roles,
        dataGroups: dataGroups ?? this.dataGroups,
        clientData: clientData ?? this.clientData,
        languages: languages ?? this.languages,
        studyIds: studyIds ?? this.studyIds,
        externalIds: externalIds ?? this.externalIds,
        orgMembership: orgMembership ?? this.orgMembership,
        note: note ?? this.note,
        clientTimeZone: clientTimeZone ?? this.clientTimeZone);
  }

  AbstractStudyParticipant copyWithWrapped(
      {Wrapped<String?>? firstName,
      Wrapped<String?>? lastName,
      Wrapped<String?>? synapseUserId,
      Wrapped<String?>? id,
      Wrapped<bool?>? notifyByEmail,
      Wrapped<Map<String, dynamic>?>? attributes,
      Wrapped<enums.SharingScope?>? sharingScope,
      Wrapped<DateTime?>? createdOn,
      Wrapped<bool?>? emailVerified,
      Wrapped<bool?>? phoneVerified,
      Wrapped<enums.AccountStatus?>? status,
      Wrapped<List<enums.Role>?>? roles,
      Wrapped<List<String>?>? dataGroups,
      Wrapped<Map<String, dynamic>?>? clientData,
      Wrapped<List<String>?>? languages,
      Wrapped<List<String>?>? studyIds,
      Wrapped<Map<String, dynamic>?>? externalIds,
      Wrapped<String?>? orgMembership,
      Wrapped<String?>? note,
      Wrapped<String?>? clientTimeZone}) {
    return AbstractStudyParticipant(
        firstName: (firstName != null ? firstName.value : this.firstName),
        lastName: (lastName != null ? lastName.value : this.lastName),
        synapseUserId:
            (synapseUserId != null ? synapseUserId.value : this.synapseUserId),
        id: (id != null ? id.value : this.id),
        notifyByEmail:
            (notifyByEmail != null ? notifyByEmail.value : this.notifyByEmail),
        attributes: (attributes != null ? attributes.value : this.attributes),
        sharingScope:
            (sharingScope != null ? sharingScope.value : this.sharingScope),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        emailVerified:
            (emailVerified != null ? emailVerified.value : this.emailVerified),
        phoneVerified:
            (phoneVerified != null ? phoneVerified.value : this.phoneVerified),
        status: (status != null ? status.value : this.status),
        roles: (roles != null ? roles.value : this.roles),
        dataGroups: (dataGroups != null ? dataGroups.value : this.dataGroups),
        clientData: (clientData != null ? clientData.value : this.clientData),
        languages: (languages != null ? languages.value : this.languages),
        studyIds: (studyIds != null ? studyIds.value : this.studyIds),
        externalIds:
            (externalIds != null ? externalIds.value : this.externalIds),
        orgMembership:
            (orgMembership != null ? orgMembership.value : this.orgMembership),
        note: (note != null ? note.value : this.note),
        clientTimeZone: (clientTimeZone != null
            ? clientTimeZone.value
            : this.clientTimeZone));
  }
}

@JsonSerializable(explicitToJson: true)
class Account {
  Account({
    this.id,
    this.firstName,
    this.lastName,
    this.synapseUserId,
    this.email,
    this.phone,
    this.password,
    this.attributes,
    this.createdOn,
    this.modifiedOn,
    this.emailVerified,
    this.phoneVerified,
    this.status,
    this.roles,
    this.dataGroups,
    this.clientData,
    this.languages,
    this.orgMembership,
    this.type,
    this.note,
    this.clientTimeZone,
  });

  factory Account.fromJson(Map<String, dynamic> json) =>
      _$AccountFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'firstName', includeIfNull: false, defaultValue: '')
  final String? firstName;
  @JsonKey(name: 'lastName', includeIfNull: false, defaultValue: '')
  final String? lastName;
  @JsonKey(name: 'synapseUserId', includeIfNull: false, defaultValue: '')
  final String? synapseUserId;
  @JsonKey(name: 'email', includeIfNull: false, defaultValue: '')
  final String? email;
  @JsonKey(name: 'phone', includeIfNull: false)
  final Phone? phone;
  @JsonKey(name: 'password', includeIfNull: false, defaultValue: '')
  final String? password;
  @JsonKey(name: 'attributes', includeIfNull: false)
  final Map<String, dynamic>? attributes;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'modifiedOn', includeIfNull: false)
  final DateTime? modifiedOn;
  @JsonKey(name: 'emailVerified', includeIfNull: false)
  final bool? emailVerified;
  @JsonKey(name: 'phoneVerified', includeIfNull: false)
  final bool? phoneVerified;
  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: accountStatusToJson,
    fromJson: accountStatusFromJson,
  )
  final enums.AccountStatus? status;
  @JsonKey(
    name: 'roles',
    includeIfNull: false,
    toJson: roleListToJson,
    fromJson: roleListFromJson,
  )
  final List<enums.Role>? roles;
  @JsonKey(name: 'dataGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String>? dataGroups;
  @JsonKey(name: 'clientData', includeIfNull: false)
  final Map<String, dynamic>? clientData;
  @JsonKey(name: 'languages', includeIfNull: false, defaultValue: <String>[])
  final List<String>? languages;
  @JsonKey(name: 'orgMembership', includeIfNull: false, defaultValue: '')
  final String? orgMembership;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  @JsonKey(name: 'note', includeIfNull: false, defaultValue: '')
  final String? note;
  @JsonKey(name: 'clientTimeZone', includeIfNull: false, defaultValue: '')
  final String? clientTimeZone;
  static const fromJsonFactory = _$AccountFromJson;
  static const toJsonFactory = _$AccountToJson;
  Map<String, dynamic> toJson() => _$AccountToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Account &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.lastName, lastName) ||
                const DeepCollectionEquality()
                    .equals(other.lastName, lastName)) &&
            (identical(other.synapseUserId, synapseUserId) ||
                const DeepCollectionEquality()
                    .equals(other.synapseUserId, synapseUserId)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.password, password) ||
                const DeepCollectionEquality()
                    .equals(other.password, password)) &&
            (identical(other.attributes, attributes) ||
                const DeepCollectionEquality()
                    .equals(other.attributes, attributes)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.modifiedOn, modifiedOn) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedOn, modifiedOn)) &&
            (identical(other.emailVerified, emailVerified) ||
                const DeepCollectionEquality()
                    .equals(other.emailVerified, emailVerified)) &&
            (identical(other.phoneVerified, phoneVerified) ||
                const DeepCollectionEquality()
                    .equals(other.phoneVerified, phoneVerified)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.roles, roles) ||
                const DeepCollectionEquality().equals(other.roles, roles)) &&
            (identical(other.dataGroups, dataGroups) ||
                const DeepCollectionEquality()
                    .equals(other.dataGroups, dataGroups)) &&
            (identical(other.clientData, clientData) ||
                const DeepCollectionEquality()
                    .equals(other.clientData, clientData)) &&
            (identical(other.languages, languages) ||
                const DeepCollectionEquality()
                    .equals(other.languages, languages)) &&
            (identical(other.orgMembership, orgMembership) ||
                const DeepCollectionEquality()
                    .equals(other.orgMembership, orgMembership)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.note, note) ||
                const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.clientTimeZone, clientTimeZone) ||
                const DeepCollectionEquality()
                    .equals(other.clientTimeZone, clientTimeZone)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(firstName) ^
      const DeepCollectionEquality().hash(lastName) ^
      const DeepCollectionEquality().hash(synapseUserId) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(phone) ^
      const DeepCollectionEquality().hash(password) ^
      const DeepCollectionEquality().hash(attributes) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(modifiedOn) ^
      const DeepCollectionEquality().hash(emailVerified) ^
      const DeepCollectionEquality().hash(phoneVerified) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(roles) ^
      const DeepCollectionEquality().hash(dataGroups) ^
      const DeepCollectionEquality().hash(clientData) ^
      const DeepCollectionEquality().hash(languages) ^
      const DeepCollectionEquality().hash(orgMembership) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(note) ^
      const DeepCollectionEquality().hash(clientTimeZone) ^
      runtimeType.hashCode;
}

extension $AccountExtension on Account {
  Account copyWith(
      {String? id,
      String? firstName,
      String? lastName,
      String? synapseUserId,
      String? email,
      Phone? phone,
      String? password,
      Map<String, dynamic>? attributes,
      DateTime? createdOn,
      DateTime? modifiedOn,
      bool? emailVerified,
      bool? phoneVerified,
      enums.AccountStatus? status,
      List<enums.Role>? roles,
      List<String>? dataGroups,
      Map<String, dynamic>? clientData,
      List<String>? languages,
      String? orgMembership,
      String? type,
      String? note,
      String? clientTimeZone}) {
    return Account(
        id: id ?? this.id,
        firstName: firstName ?? this.firstName,
        lastName: lastName ?? this.lastName,
        synapseUserId: synapseUserId ?? this.synapseUserId,
        email: email ?? this.email,
        phone: phone ?? this.phone,
        password: password ?? this.password,
        attributes: attributes ?? this.attributes,
        createdOn: createdOn ?? this.createdOn,
        modifiedOn: modifiedOn ?? this.modifiedOn,
        emailVerified: emailVerified ?? this.emailVerified,
        phoneVerified: phoneVerified ?? this.phoneVerified,
        status: status ?? this.status,
        roles: roles ?? this.roles,
        dataGroups: dataGroups ?? this.dataGroups,
        clientData: clientData ?? this.clientData,
        languages: languages ?? this.languages,
        orgMembership: orgMembership ?? this.orgMembership,
        type: type ?? this.type,
        note: note ?? this.note,
        clientTimeZone: clientTimeZone ?? this.clientTimeZone);
  }

  Account copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? firstName,
      Wrapped<String?>? lastName,
      Wrapped<String?>? synapseUserId,
      Wrapped<String?>? email,
      Wrapped<Phone?>? phone,
      Wrapped<String?>? password,
      Wrapped<Map<String, dynamic>?>? attributes,
      Wrapped<DateTime?>? createdOn,
      Wrapped<DateTime?>? modifiedOn,
      Wrapped<bool?>? emailVerified,
      Wrapped<bool?>? phoneVerified,
      Wrapped<enums.AccountStatus?>? status,
      Wrapped<List<enums.Role>?>? roles,
      Wrapped<List<String>?>? dataGroups,
      Wrapped<Map<String, dynamic>?>? clientData,
      Wrapped<List<String>?>? languages,
      Wrapped<String?>? orgMembership,
      Wrapped<String?>? type,
      Wrapped<String?>? note,
      Wrapped<String?>? clientTimeZone}) {
    return Account(
        id: (id != null ? id.value : this.id),
        firstName: (firstName != null ? firstName.value : this.firstName),
        lastName: (lastName != null ? lastName.value : this.lastName),
        synapseUserId:
            (synapseUserId != null ? synapseUserId.value : this.synapseUserId),
        email: (email != null ? email.value : this.email),
        phone: (phone != null ? phone.value : this.phone),
        password: (password != null ? password.value : this.password),
        attributes: (attributes != null ? attributes.value : this.attributes),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        modifiedOn: (modifiedOn != null ? modifiedOn.value : this.modifiedOn),
        emailVerified:
            (emailVerified != null ? emailVerified.value : this.emailVerified),
        phoneVerified:
            (phoneVerified != null ? phoneVerified.value : this.phoneVerified),
        status: (status != null ? status.value : this.status),
        roles: (roles != null ? roles.value : this.roles),
        dataGroups: (dataGroups != null ? dataGroups.value : this.dataGroups),
        clientData: (clientData != null ? clientData.value : this.clientData),
        languages: (languages != null ? languages.value : this.languages),
        orgMembership:
            (orgMembership != null ? orgMembership.value : this.orgMembership),
        type: (type != null ? type.value : this.type),
        note: (note != null ? note.value : this.note),
        clientTimeZone: (clientTimeZone != null
            ? clientTimeZone.value
            : this.clientTimeZone));
  }
}

@JsonSerializable(explicitToJson: true)
class AccountRef {
  AccountRef({
    this.firstName,
    this.lastName,
    this.synapseUserId,
    this.identifier,
    this.orgMembership,
    this.email,
    this.phone,
    this.type,
  });

  factory AccountRef.fromJson(Map<String, dynamic> json) =>
      _$AccountRefFromJson(json);

  @JsonKey(name: 'firstName', includeIfNull: false, defaultValue: '')
  final String? firstName;
  @JsonKey(name: 'lastName', includeIfNull: false, defaultValue: '')
  final String? lastName;
  @JsonKey(name: 'synapseUserId', includeIfNull: false, defaultValue: '')
  final String? synapseUserId;
  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String? identifier;
  @JsonKey(name: 'orgMembership', includeIfNull: false, defaultValue: '')
  final String? orgMembership;
  @JsonKey(name: 'email', includeIfNull: false, defaultValue: '')
  final String? email;
  @JsonKey(name: 'phone', includeIfNull: false)
  final Phone? phone;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AccountRefFromJson;
  static const toJsonFactory = _$AccountRefToJson;
  Map<String, dynamic> toJson() => _$AccountRefToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AccountRef &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.lastName, lastName) ||
                const DeepCollectionEquality()
                    .equals(other.lastName, lastName)) &&
            (identical(other.synapseUserId, synapseUserId) ||
                const DeepCollectionEquality()
                    .equals(other.synapseUserId, synapseUserId)) &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.orgMembership, orgMembership) ||
                const DeepCollectionEquality()
                    .equals(other.orgMembership, orgMembership)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(firstName) ^
      const DeepCollectionEquality().hash(lastName) ^
      const DeepCollectionEquality().hash(synapseUserId) ^
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(orgMembership) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(phone) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AccountRefExtension on AccountRef {
  AccountRef copyWith(
      {String? firstName,
      String? lastName,
      String? synapseUserId,
      String? identifier,
      String? orgMembership,
      String? email,
      Phone? phone,
      String? type}) {
    return AccountRef(
        firstName: firstName ?? this.firstName,
        lastName: lastName ?? this.lastName,
        synapseUserId: synapseUserId ?? this.synapseUserId,
        identifier: identifier ?? this.identifier,
        orgMembership: orgMembership ?? this.orgMembership,
        email: email ?? this.email,
        phone: phone ?? this.phone,
        type: type ?? this.type);
  }

  AccountRef copyWithWrapped(
      {Wrapped<String?>? firstName,
      Wrapped<String?>? lastName,
      Wrapped<String?>? synapseUserId,
      Wrapped<String?>? identifier,
      Wrapped<String?>? orgMembership,
      Wrapped<String?>? email,
      Wrapped<Phone?>? phone,
      Wrapped<String?>? type}) {
    return AccountRef(
        firstName: (firstName != null ? firstName.value : this.firstName),
        lastName: (lastName != null ? lastName.value : this.lastName),
        synapseUserId:
            (synapseUserId != null ? synapseUserId.value : this.synapseUserId),
        identifier: (identifier != null ? identifier.value : this.identifier),
        orgMembership:
            (orgMembership != null ? orgMembership.value : this.orgMembership),
        email: (email != null ? email.value : this.email),
        phone: (phone != null ? phone.value : this.phone),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AccountSummary {
  AccountSummary({
    this.appId,
    this.firstName,
    this.lastName,
    this.email,
    this.phone,
    this.id,
    this.createdOn,
    this.status,
    this.studyIds,
    this.externalIds,
    this.synapseUserId,
    this.attributes,
    this.orgMembership,
    this.roles,
    this.dataGroups,
    this.note,
    this.clientTimeZone,
    this.type,
  });

  factory AccountSummary.fromJson(Map<String, dynamic> json) =>
      _$AccountSummaryFromJson(json);

  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String? appId;
  @JsonKey(name: 'firstName', includeIfNull: false, defaultValue: '')
  final String? firstName;
  @JsonKey(name: 'lastName', includeIfNull: false, defaultValue: '')
  final String? lastName;
  @JsonKey(name: 'email', includeIfNull: false, defaultValue: '')
  final String? email;
  @JsonKey(name: 'phone', includeIfNull: false)
  final Phone? phone;
  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: accountStatusToJson,
    fromJson: accountStatusFromJson,
  )
  final enums.AccountStatus? status;
  @JsonKey(name: 'studyIds', includeIfNull: false, defaultValue: <String>[])
  final List<String>? studyIds;
  @JsonKey(name: 'externalIds', includeIfNull: false)
  final Map<String, dynamic>? externalIds;
  @JsonKey(name: 'synapseUserId', includeIfNull: false, defaultValue: '')
  final String? synapseUserId;
  @JsonKey(name: 'attributes', includeIfNull: false)
  final Map<String, dynamic>? attributes;
  @JsonKey(name: 'orgMembership', includeIfNull: false, defaultValue: '')
  final String? orgMembership;
  @JsonKey(
    name: 'roles',
    includeIfNull: false,
    toJson: roleListToJson,
    fromJson: roleListFromJson,
  )
  final List<enums.Role>? roles;
  @JsonKey(name: 'dataGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String>? dataGroups;
  @JsonKey(name: 'note', includeIfNull: false, defaultValue: '')
  final String? note;
  @JsonKey(name: 'clientTimeZone', includeIfNull: false, defaultValue: '')
  final String? clientTimeZone;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AccountSummaryFromJson;
  static const toJsonFactory = _$AccountSummaryToJson;
  Map<String, dynamic> toJson() => _$AccountSummaryToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AccountSummary &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)) &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.lastName, lastName) ||
                const DeepCollectionEquality()
                    .equals(other.lastName, lastName)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.studyIds, studyIds) ||
                const DeepCollectionEquality()
                    .equals(other.studyIds, studyIds)) &&
            (identical(other.externalIds, externalIds) ||
                const DeepCollectionEquality()
                    .equals(other.externalIds, externalIds)) &&
            (identical(other.synapseUserId, synapseUserId) ||
                const DeepCollectionEquality()
                    .equals(other.synapseUserId, synapseUserId)) &&
            (identical(other.attributes, attributes) ||
                const DeepCollectionEquality()
                    .equals(other.attributes, attributes)) &&
            (identical(other.orgMembership, orgMembership) ||
                const DeepCollectionEquality()
                    .equals(other.orgMembership, orgMembership)) &&
            (identical(other.roles, roles) ||
                const DeepCollectionEquality().equals(other.roles, roles)) &&
            (identical(other.dataGroups, dataGroups) ||
                const DeepCollectionEquality()
                    .equals(other.dataGroups, dataGroups)) &&
            (identical(other.note, note) ||
                const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.clientTimeZone, clientTimeZone) ||
                const DeepCollectionEquality()
                    .equals(other.clientTimeZone, clientTimeZone)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(appId) ^
      const DeepCollectionEquality().hash(firstName) ^
      const DeepCollectionEquality().hash(lastName) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(phone) ^
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(studyIds) ^
      const DeepCollectionEquality().hash(externalIds) ^
      const DeepCollectionEquality().hash(synapseUserId) ^
      const DeepCollectionEquality().hash(attributes) ^
      const DeepCollectionEquality().hash(orgMembership) ^
      const DeepCollectionEquality().hash(roles) ^
      const DeepCollectionEquality().hash(dataGroups) ^
      const DeepCollectionEquality().hash(note) ^
      const DeepCollectionEquality().hash(clientTimeZone) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AccountSummaryExtension on AccountSummary {
  AccountSummary copyWith(
      {String? appId,
      String? firstName,
      String? lastName,
      String? email,
      Phone? phone,
      String? id,
      DateTime? createdOn,
      enums.AccountStatus? status,
      List<String>? studyIds,
      Map<String, dynamic>? externalIds,
      String? synapseUserId,
      Map<String, dynamic>? attributes,
      String? orgMembership,
      List<enums.Role>? roles,
      List<String>? dataGroups,
      String? note,
      String? clientTimeZone,
      String? type}) {
    return AccountSummary(
        appId: appId ?? this.appId,
        firstName: firstName ?? this.firstName,
        lastName: lastName ?? this.lastName,
        email: email ?? this.email,
        phone: phone ?? this.phone,
        id: id ?? this.id,
        createdOn: createdOn ?? this.createdOn,
        status: status ?? this.status,
        studyIds: studyIds ?? this.studyIds,
        externalIds: externalIds ?? this.externalIds,
        synapseUserId: synapseUserId ?? this.synapseUserId,
        attributes: attributes ?? this.attributes,
        orgMembership: orgMembership ?? this.orgMembership,
        roles: roles ?? this.roles,
        dataGroups: dataGroups ?? this.dataGroups,
        note: note ?? this.note,
        clientTimeZone: clientTimeZone ?? this.clientTimeZone,
        type: type ?? this.type);
  }

  AccountSummary copyWithWrapped(
      {Wrapped<String?>? appId,
      Wrapped<String?>? firstName,
      Wrapped<String?>? lastName,
      Wrapped<String?>? email,
      Wrapped<Phone?>? phone,
      Wrapped<String?>? id,
      Wrapped<DateTime?>? createdOn,
      Wrapped<enums.AccountStatus?>? status,
      Wrapped<List<String>?>? studyIds,
      Wrapped<Map<String, dynamic>?>? externalIds,
      Wrapped<String?>? synapseUserId,
      Wrapped<Map<String, dynamic>?>? attributes,
      Wrapped<String?>? orgMembership,
      Wrapped<List<enums.Role>?>? roles,
      Wrapped<List<String>?>? dataGroups,
      Wrapped<String?>? note,
      Wrapped<String?>? clientTimeZone,
      Wrapped<String?>? type}) {
    return AccountSummary(
        appId: (appId != null ? appId.value : this.appId),
        firstName: (firstName != null ? firstName.value : this.firstName),
        lastName: (lastName != null ? lastName.value : this.lastName),
        email: (email != null ? email.value : this.email),
        phone: (phone != null ? phone.value : this.phone),
        id: (id != null ? id.value : this.id),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        status: (status != null ? status.value : this.status),
        studyIds: (studyIds != null ? studyIds.value : this.studyIds),
        externalIds:
            (externalIds != null ? externalIds.value : this.externalIds),
        synapseUserId:
            (synapseUserId != null ? synapseUserId.value : this.synapseUserId),
        attributes: (attributes != null ? attributes.value : this.attributes),
        orgMembership:
            (orgMembership != null ? orgMembership.value : this.orgMembership),
        roles: (roles != null ? roles.value : this.roles),
        dataGroups: (dataGroups != null ? dataGroups.value : this.dataGroups),
        note: (note != null ? note.value : this.note),
        clientTimeZone: (clientTimeZone != null
            ? clientTimeZone.value
            : this.clientTimeZone),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AccountSummarySearch {
  AccountSummarySearch({
    this.pageSize,
    this.offsetBy,
    this.emailFilter,
    this.phoneFilter,
    this.allOfGroups,
    this.noneOfGroups,
    this.language,
    this.startTime,
    this.endTime,
    this.orgMembership,
    this.adminOnly,
    this.enrolledInStudyId,
    this.externalIdFilter,
    this.status,
    this.enrollment,
    this.attributeKey,
    this.attributeValueFilter,
    this.predicate,
    this.stringSearchPosition,
    this.type,
  });

  factory AccountSummarySearch.fromJson(Map<String, dynamic> json) =>
      _$AccountSummarySearchFromJson(json);

  @JsonKey(name: 'pageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'offsetBy', includeIfNull: false)
  final int? offsetBy;
  @JsonKey(name: 'emailFilter', includeIfNull: false, defaultValue: '')
  final String? emailFilter;
  @JsonKey(name: 'phoneFilter', includeIfNull: false, defaultValue: '')
  final String? phoneFilter;
  @JsonKey(name: 'allOfGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String>? allOfGroups;
  @JsonKey(name: 'noneOfGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String>? noneOfGroups;
  @JsonKey(name: 'language', includeIfNull: false, defaultValue: '')
  final String? language;
  @JsonKey(name: 'startTime', includeIfNull: false)
  final DateTime? startTime;
  @JsonKey(name: 'endTime', includeIfNull: false)
  final DateTime? endTime;
  @JsonKey(name: 'orgMembership', includeIfNull: false, defaultValue: '')
  final String? orgMembership;
  @JsonKey(name: 'adminOnly', includeIfNull: false)
  final bool? adminOnly;
  @JsonKey(name: 'enrolledInStudyId', includeIfNull: false, defaultValue: '')
  final String? enrolledInStudyId;
  @JsonKey(name: 'externalIdFilter', includeIfNull: false, defaultValue: '')
  final String? externalIdFilter;
  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: accountStatusToJson,
    fromJson: accountStatusFromJson,
  )
  final enums.AccountStatus? status;
  @JsonKey(
    name: 'enrollment',
    includeIfNull: false,
    toJson: enrollmentFilterToJson,
    fromJson: enrollmentFilterFromJson,
  )
  final enums.EnrollmentFilter? enrollment;
  @JsonKey(name: 'attributeKey', includeIfNull: false, defaultValue: '')
  final String? attributeKey;
  @JsonKey(name: 'attributeValueFilter', includeIfNull: false, defaultValue: '')
  final String? attributeValueFilter;
  @JsonKey(
    name: 'predicate',
    includeIfNull: false,
    toJson: searchTermPredicateToJson,
    fromJson: searchTermPredicatePredicateFromJson,
  )
  final enums.SearchTermPredicate? predicate;
  static enums.SearchTermPredicate searchTermPredicatePredicateFromJson(
          Object? value) =>
      searchTermPredicateFromJson(value, enums.SearchTermPredicate.and);

  @JsonKey(
    name: 'stringSearchPosition',
    includeIfNull: false,
    toJson: stringSearchPositionToJson,
    fromJson: stringSearchPositionStringSearchPositionFromJson,
  )
  final enums.StringSearchPosition? stringSearchPosition;
  static enums.StringSearchPosition
      stringSearchPositionStringSearchPositionFromJson(Object? value) =>
          stringSearchPositionFromJson(value, enums.StringSearchPosition.infix);

  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AccountSummarySearchFromJson;
  static const toJsonFactory = _$AccountSummarySearchToJson;
  Map<String, dynamic> toJson() => _$AccountSummarySearchToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AccountSummarySearch &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.offsetBy, offsetBy) ||
                const DeepCollectionEquality()
                    .equals(other.offsetBy, offsetBy)) &&
            (identical(other.emailFilter, emailFilter) ||
                const DeepCollectionEquality()
                    .equals(other.emailFilter, emailFilter)) &&
            (identical(other.phoneFilter, phoneFilter) ||
                const DeepCollectionEquality()
                    .equals(other.phoneFilter, phoneFilter)) &&
            (identical(other.allOfGroups, allOfGroups) ||
                const DeepCollectionEquality()
                    .equals(other.allOfGroups, allOfGroups)) &&
            (identical(other.noneOfGroups, noneOfGroups) ||
                const DeepCollectionEquality()
                    .equals(other.noneOfGroups, noneOfGroups)) &&
            (identical(other.language, language) ||
                const DeepCollectionEquality()
                    .equals(other.language, language)) &&
            (identical(other.startTime, startTime) ||
                const DeepCollectionEquality()
                    .equals(other.startTime, startTime)) &&
            (identical(other.endTime, endTime) ||
                const DeepCollectionEquality()
                    .equals(other.endTime, endTime)) &&
            (identical(other.orgMembership, orgMembership) ||
                const DeepCollectionEquality()
                    .equals(other.orgMembership, orgMembership)) &&
            (identical(other.adminOnly, adminOnly) ||
                const DeepCollectionEquality()
                    .equals(other.adminOnly, adminOnly)) &&
            (identical(other.enrolledInStudyId, enrolledInStudyId) ||
                const DeepCollectionEquality()
                    .equals(other.enrolledInStudyId, enrolledInStudyId)) &&
            (identical(other.externalIdFilter, externalIdFilter) ||
                const DeepCollectionEquality()
                    .equals(other.externalIdFilter, externalIdFilter)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.enrollment, enrollment) ||
                const DeepCollectionEquality()
                    .equals(other.enrollment, enrollment)) &&
            (identical(other.attributeKey, attributeKey) ||
                const DeepCollectionEquality()
                    .equals(other.attributeKey, attributeKey)) &&
            (identical(other.attributeValueFilter, attributeValueFilter) ||
                const DeepCollectionEquality().equals(
                    other.attributeValueFilter, attributeValueFilter)) &&
            (identical(other.predicate, predicate) ||
                const DeepCollectionEquality()
                    .equals(other.predicate, predicate)) &&
            (identical(other.stringSearchPosition, stringSearchPosition) ||
                const DeepCollectionEquality().equals(
                    other.stringSearchPosition, stringSearchPosition)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(offsetBy) ^
      const DeepCollectionEquality().hash(emailFilter) ^
      const DeepCollectionEquality().hash(phoneFilter) ^
      const DeepCollectionEquality().hash(allOfGroups) ^
      const DeepCollectionEquality().hash(noneOfGroups) ^
      const DeepCollectionEquality().hash(language) ^
      const DeepCollectionEquality().hash(startTime) ^
      const DeepCollectionEquality().hash(endTime) ^
      const DeepCollectionEquality().hash(orgMembership) ^
      const DeepCollectionEquality().hash(adminOnly) ^
      const DeepCollectionEquality().hash(enrolledInStudyId) ^
      const DeepCollectionEquality().hash(externalIdFilter) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(enrollment) ^
      const DeepCollectionEquality().hash(attributeKey) ^
      const DeepCollectionEquality().hash(attributeValueFilter) ^
      const DeepCollectionEquality().hash(predicate) ^
      const DeepCollectionEquality().hash(stringSearchPosition) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AccountSummarySearchExtension on AccountSummarySearch {
  AccountSummarySearch copyWith(
      {int? pageSize,
      int? offsetBy,
      String? emailFilter,
      String? phoneFilter,
      List<String>? allOfGroups,
      List<String>? noneOfGroups,
      String? language,
      DateTime? startTime,
      DateTime? endTime,
      String? orgMembership,
      bool? adminOnly,
      String? enrolledInStudyId,
      String? externalIdFilter,
      enums.AccountStatus? status,
      enums.EnrollmentFilter? enrollment,
      String? attributeKey,
      String? attributeValueFilter,
      enums.SearchTermPredicate? predicate,
      enums.StringSearchPosition? stringSearchPosition,
      String? type}) {
    return AccountSummarySearch(
        pageSize: pageSize ?? this.pageSize,
        offsetBy: offsetBy ?? this.offsetBy,
        emailFilter: emailFilter ?? this.emailFilter,
        phoneFilter: phoneFilter ?? this.phoneFilter,
        allOfGroups: allOfGroups ?? this.allOfGroups,
        noneOfGroups: noneOfGroups ?? this.noneOfGroups,
        language: language ?? this.language,
        startTime: startTime ?? this.startTime,
        endTime: endTime ?? this.endTime,
        orgMembership: orgMembership ?? this.orgMembership,
        adminOnly: adminOnly ?? this.adminOnly,
        enrolledInStudyId: enrolledInStudyId ?? this.enrolledInStudyId,
        externalIdFilter: externalIdFilter ?? this.externalIdFilter,
        status: status ?? this.status,
        enrollment: enrollment ?? this.enrollment,
        attributeKey: attributeKey ?? this.attributeKey,
        attributeValueFilter: attributeValueFilter ?? this.attributeValueFilter,
        predicate: predicate ?? this.predicate,
        stringSearchPosition: stringSearchPosition ?? this.stringSearchPosition,
        type: type ?? this.type);
  }

  AccountSummarySearch copyWithWrapped(
      {Wrapped<int?>? pageSize,
      Wrapped<int?>? offsetBy,
      Wrapped<String?>? emailFilter,
      Wrapped<String?>? phoneFilter,
      Wrapped<List<String>?>? allOfGroups,
      Wrapped<List<String>?>? noneOfGroups,
      Wrapped<String?>? language,
      Wrapped<DateTime?>? startTime,
      Wrapped<DateTime?>? endTime,
      Wrapped<String?>? orgMembership,
      Wrapped<bool?>? adminOnly,
      Wrapped<String?>? enrolledInStudyId,
      Wrapped<String?>? externalIdFilter,
      Wrapped<enums.AccountStatus?>? status,
      Wrapped<enums.EnrollmentFilter?>? enrollment,
      Wrapped<String?>? attributeKey,
      Wrapped<String?>? attributeValueFilter,
      Wrapped<enums.SearchTermPredicate?>? predicate,
      Wrapped<enums.StringSearchPosition?>? stringSearchPosition,
      Wrapped<String?>? type}) {
    return AccountSummarySearch(
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        offsetBy: (offsetBy != null ? offsetBy.value : this.offsetBy),
        emailFilter:
            (emailFilter != null ? emailFilter.value : this.emailFilter),
        phoneFilter:
            (phoneFilter != null ? phoneFilter.value : this.phoneFilter),
        allOfGroups:
            (allOfGroups != null ? allOfGroups.value : this.allOfGroups),
        noneOfGroups:
            (noneOfGroups != null ? noneOfGroups.value : this.noneOfGroups),
        language: (language != null ? language.value : this.language),
        startTime: (startTime != null ? startTime.value : this.startTime),
        endTime: (endTime != null ? endTime.value : this.endTime),
        orgMembership:
            (orgMembership != null ? orgMembership.value : this.orgMembership),
        adminOnly: (adminOnly != null ? adminOnly.value : this.adminOnly),
        enrolledInStudyId: (enrolledInStudyId != null
            ? enrolledInStudyId.value
            : this.enrolledInStudyId),
        externalIdFilter: (externalIdFilter != null
            ? externalIdFilter.value
            : this.externalIdFilter),
        status: (status != null ? status.value : this.status),
        enrollment: (enrollment != null ? enrollment.value : this.enrollment),
        attributeKey:
            (attributeKey != null ? attributeKey.value : this.attributeKey),
        attributeValueFilter: (attributeValueFilter != null
            ? attributeValueFilter.value
            : this.attributeValueFilter),
        predicate: (predicate != null ? predicate.value : this.predicate),
        stringSearchPosition: (stringSearchPosition != null
            ? stringSearchPosition.value
            : this.stringSearchPosition),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Activity {
  Activity({
    required this.label,
    this.labelDetail,
    required this.guid,
    this.compoundActivity,
    this.task,
    this.survey,
    required this.activityType,
    this.type,
  });

  factory Activity.fromJson(Map<String, dynamic> json) =>
      _$ActivityFromJson(json);

  @JsonKey(name: 'label', includeIfNull: false, defaultValue: '')
  final String label;
  @JsonKey(name: 'labelDetail', includeIfNull: false, defaultValue: '')
  final String? labelDetail;
  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String guid;
  @JsonKey(name: 'compoundActivity', includeIfNull: false)
  final CompoundActivity? compoundActivity;
  @JsonKey(name: 'task', includeIfNull: false)
  final TaskReference? task;
  @JsonKey(name: 'survey', includeIfNull: false)
  final SurveyReference? survey;
  @JsonKey(
    name: 'activityType',
    includeIfNull: false,
    toJson: activityTypeToJson,
    fromJson: activityTypeFromJson,
  )
  final enums.ActivityType activityType;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ActivityFromJson;
  static const toJsonFactory = _$ActivityToJson;
  Map<String, dynamic> toJson() => _$ActivityToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Activity &&
            (identical(other.label, label) ||
                const DeepCollectionEquality().equals(other.label, label)) &&
            (identical(other.labelDetail, labelDetail) ||
                const DeepCollectionEquality()
                    .equals(other.labelDetail, labelDetail)) &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.compoundActivity, compoundActivity) ||
                const DeepCollectionEquality()
                    .equals(other.compoundActivity, compoundActivity)) &&
            (identical(other.task, task) ||
                const DeepCollectionEquality().equals(other.task, task)) &&
            (identical(other.survey, survey) ||
                const DeepCollectionEquality().equals(other.survey, survey)) &&
            (identical(other.activityType, activityType) ||
                const DeepCollectionEquality()
                    .equals(other.activityType, activityType)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(label) ^
      const DeepCollectionEquality().hash(labelDetail) ^
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(compoundActivity) ^
      const DeepCollectionEquality().hash(task) ^
      const DeepCollectionEquality().hash(survey) ^
      const DeepCollectionEquality().hash(activityType) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ActivityExtension on Activity {
  Activity copyWith(
      {String? label,
      String? labelDetail,
      String? guid,
      CompoundActivity? compoundActivity,
      TaskReference? task,
      SurveyReference? survey,
      enums.ActivityType? activityType,
      String? type}) {
    return Activity(
        label: label ?? this.label,
        labelDetail: labelDetail ?? this.labelDetail,
        guid: guid ?? this.guid,
        compoundActivity: compoundActivity ?? this.compoundActivity,
        task: task ?? this.task,
        survey: survey ?? this.survey,
        activityType: activityType ?? this.activityType,
        type: type ?? this.type);
  }

  Activity copyWithWrapped(
      {Wrapped<String>? label,
      Wrapped<String?>? labelDetail,
      Wrapped<String>? guid,
      Wrapped<CompoundActivity?>? compoundActivity,
      Wrapped<TaskReference?>? task,
      Wrapped<SurveyReference?>? survey,
      Wrapped<enums.ActivityType>? activityType,
      Wrapped<String?>? type}) {
    return Activity(
        label: (label != null ? label.value : this.label),
        labelDetail:
            (labelDetail != null ? labelDetail.value : this.labelDetail),
        guid: (guid != null ? guid.value : this.guid),
        compoundActivity: (compoundActivity != null
            ? compoundActivity.value
            : this.compoundActivity),
        task: (task != null ? task.value : this.task),
        survey: (survey != null ? survey.value : this.survey),
        activityType:
            (activityType != null ? activityType.value : this.activityType),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ActivityEvent {
  ActivityEvent({
    required this.eventId,
    this.studyId,
    this.answerValue,
    required this.timestamp,
    this.type,
  });

  factory ActivityEvent.fromJson(Map<String, dynamic> json) =>
      _$ActivityEventFromJson(json);

  @JsonKey(name: 'eventId', includeIfNull: false, defaultValue: '')
  final String eventId;
  @JsonKey(name: 'studyId', includeIfNull: false, defaultValue: '')
  final String? studyId;
  @JsonKey(name: 'answerValue', includeIfNull: false, defaultValue: '')
  final String? answerValue;
  @JsonKey(name: 'timestamp', includeIfNull: false)
  final DateTime timestamp;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ActivityEventFromJson;
  static const toJsonFactory = _$ActivityEventToJson;
  Map<String, dynamic> toJson() => _$ActivityEventToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ActivityEvent &&
            (identical(other.eventId, eventId) ||
                const DeepCollectionEquality()
                    .equals(other.eventId, eventId)) &&
            (identical(other.studyId, studyId) ||
                const DeepCollectionEquality()
                    .equals(other.studyId, studyId)) &&
            (identical(other.answerValue, answerValue) ||
                const DeepCollectionEquality()
                    .equals(other.answerValue, answerValue)) &&
            (identical(other.timestamp, timestamp) ||
                const DeepCollectionEquality()
                    .equals(other.timestamp, timestamp)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(eventId) ^
      const DeepCollectionEquality().hash(studyId) ^
      const DeepCollectionEquality().hash(answerValue) ^
      const DeepCollectionEquality().hash(timestamp) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ActivityEventExtension on ActivityEvent {
  ActivityEvent copyWith(
      {String? eventId,
      String? studyId,
      String? answerValue,
      DateTime? timestamp,
      String? type}) {
    return ActivityEvent(
        eventId: eventId ?? this.eventId,
        studyId: studyId ?? this.studyId,
        answerValue: answerValue ?? this.answerValue,
        timestamp: timestamp ?? this.timestamp,
        type: type ?? this.type);
  }

  ActivityEvent copyWithWrapped(
      {Wrapped<String>? eventId,
      Wrapped<String?>? studyId,
      Wrapped<String?>? answerValue,
      Wrapped<DateTime>? timestamp,
      Wrapped<String?>? type}) {
    return ActivityEvent(
        eventId: (eventId != null ? eventId.value : this.eventId),
        studyId: (studyId != null ? studyId.value : this.studyId),
        answerValue:
            (answerValue != null ? answerValue.value : this.answerValue),
        timestamp: (timestamp != null ? timestamp.value : this.timestamp),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Address {
  Address({
    this.placeName,
    this.street,
    this.mailRouting,
    this.city,
    this.division,
    this.postalCode,
    this.country,
    this.type,
  });

  factory Address.fromJson(Map<String, dynamic> json) =>
      _$AddressFromJson(json);

  @JsonKey(name: 'placeName', includeIfNull: false, defaultValue: '')
  final String? placeName;
  @JsonKey(name: 'street', includeIfNull: false, defaultValue: '')
  final String? street;
  @JsonKey(name: 'mailRouting', includeIfNull: false, defaultValue: '')
  final String? mailRouting;
  @JsonKey(name: 'city', includeIfNull: false, defaultValue: '')
  final String? city;
  @JsonKey(name: 'division', includeIfNull: false, defaultValue: '')
  final String? division;
  @JsonKey(name: 'postalCode', includeIfNull: false, defaultValue: '')
  final String? postalCode;
  @JsonKey(name: 'country', includeIfNull: false, defaultValue: '')
  final String? country;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AddressFromJson;
  static const toJsonFactory = _$AddressToJson;
  Map<String, dynamic> toJson() => _$AddressToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Address &&
            (identical(other.placeName, placeName) ||
                const DeepCollectionEquality()
                    .equals(other.placeName, placeName)) &&
            (identical(other.street, street) ||
                const DeepCollectionEquality().equals(other.street, street)) &&
            (identical(other.mailRouting, mailRouting) ||
                const DeepCollectionEquality()
                    .equals(other.mailRouting, mailRouting)) &&
            (identical(other.city, city) ||
                const DeepCollectionEquality().equals(other.city, city)) &&
            (identical(other.division, division) ||
                const DeepCollectionEquality()
                    .equals(other.division, division)) &&
            (identical(other.postalCode, postalCode) ||
                const DeepCollectionEquality()
                    .equals(other.postalCode, postalCode)) &&
            (identical(other.country, country) ||
                const DeepCollectionEquality()
                    .equals(other.country, country)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(placeName) ^
      const DeepCollectionEquality().hash(street) ^
      const DeepCollectionEquality().hash(mailRouting) ^
      const DeepCollectionEquality().hash(city) ^
      const DeepCollectionEquality().hash(division) ^
      const DeepCollectionEquality().hash(postalCode) ^
      const DeepCollectionEquality().hash(country) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AddressExtension on Address {
  Address copyWith(
      {String? placeName,
      String? street,
      String? mailRouting,
      String? city,
      String? division,
      String? postalCode,
      String? country,
      String? type}) {
    return Address(
        placeName: placeName ?? this.placeName,
        street: street ?? this.street,
        mailRouting: mailRouting ?? this.mailRouting,
        city: city ?? this.city,
        division: division ?? this.division,
        postalCode: postalCode ?? this.postalCode,
        country: country ?? this.country,
        type: type ?? this.type);
  }

  Address copyWithWrapped(
      {Wrapped<String?>? placeName,
      Wrapped<String?>? street,
      Wrapped<String?>? mailRouting,
      Wrapped<String?>? city,
      Wrapped<String?>? division,
      Wrapped<String?>? postalCode,
      Wrapped<String?>? country,
      Wrapped<String?>? type}) {
    return Address(
        placeName: (placeName != null ? placeName.value : this.placeName),
        street: (street != null ? street.value : this.street),
        mailRouting:
            (mailRouting != null ? mailRouting.value : this.mailRouting),
        city: (city != null ? city.value : this.city),
        division: (division != null ? division.value : this.division),
        postalCode: (postalCode != null ? postalCode.value : this.postalCode),
        country: (country != null ? country.value : this.country),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AdherenceRecord {
  AdherenceRecord({
    required this.instanceGuid,
    this.startedOn,
    this.finishedOn,
    required this.eventTimestamp,
    this.clientTimeZone,
    this.uploadedOn,
    this.declined,
    this.clientData,
    this.type,
  });

  factory AdherenceRecord.fromJson(Map<String, dynamic> json) =>
      _$AdherenceRecordFromJson(json);

  @JsonKey(name: 'instanceGuid', includeIfNull: false, defaultValue: '')
  final String instanceGuid;
  @JsonKey(name: 'startedOn', includeIfNull: false)
  final DateTime? startedOn;
  @JsonKey(name: 'finishedOn', includeIfNull: false)
  final DateTime? finishedOn;
  @JsonKey(name: 'eventTimestamp', includeIfNull: false)
  final DateTime eventTimestamp;
  @JsonKey(name: 'clientTimeZone', includeIfNull: false, defaultValue: '')
  final String? clientTimeZone;
  @JsonKey(name: 'uploadedOn', includeIfNull: false)
  final DateTime? uploadedOn;
  @JsonKey(name: 'declined', includeIfNull: false)
  final bool? declined;
  @JsonKey(name: 'clientData', includeIfNull: false)
  final Object? clientData;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AdherenceRecordFromJson;
  static const toJsonFactory = _$AdherenceRecordToJson;
  Map<String, dynamic> toJson() => _$AdherenceRecordToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AdherenceRecord &&
            (identical(other.instanceGuid, instanceGuid) ||
                const DeepCollectionEquality()
                    .equals(other.instanceGuid, instanceGuid)) &&
            (identical(other.startedOn, startedOn) ||
                const DeepCollectionEquality()
                    .equals(other.startedOn, startedOn)) &&
            (identical(other.finishedOn, finishedOn) ||
                const DeepCollectionEquality()
                    .equals(other.finishedOn, finishedOn)) &&
            (identical(other.eventTimestamp, eventTimestamp) ||
                const DeepCollectionEquality()
                    .equals(other.eventTimestamp, eventTimestamp)) &&
            (identical(other.clientTimeZone, clientTimeZone) ||
                const DeepCollectionEquality()
                    .equals(other.clientTimeZone, clientTimeZone)) &&
            (identical(other.uploadedOn, uploadedOn) ||
                const DeepCollectionEquality()
                    .equals(other.uploadedOn, uploadedOn)) &&
            (identical(other.declined, declined) ||
                const DeepCollectionEquality()
                    .equals(other.declined, declined)) &&
            (identical(other.clientData, clientData) ||
                const DeepCollectionEquality()
                    .equals(other.clientData, clientData)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(instanceGuid) ^
      const DeepCollectionEquality().hash(startedOn) ^
      const DeepCollectionEquality().hash(finishedOn) ^
      const DeepCollectionEquality().hash(eventTimestamp) ^
      const DeepCollectionEquality().hash(clientTimeZone) ^
      const DeepCollectionEquality().hash(uploadedOn) ^
      const DeepCollectionEquality().hash(declined) ^
      const DeepCollectionEquality().hash(clientData) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AdherenceRecordExtension on AdherenceRecord {
  AdherenceRecord copyWith(
      {String? instanceGuid,
      DateTime? startedOn,
      DateTime? finishedOn,
      DateTime? eventTimestamp,
      String? clientTimeZone,
      DateTime? uploadedOn,
      bool? declined,
      Object? clientData,
      String? type}) {
    return AdherenceRecord(
        instanceGuid: instanceGuid ?? this.instanceGuid,
        startedOn: startedOn ?? this.startedOn,
        finishedOn: finishedOn ?? this.finishedOn,
        eventTimestamp: eventTimestamp ?? this.eventTimestamp,
        clientTimeZone: clientTimeZone ?? this.clientTimeZone,
        uploadedOn: uploadedOn ?? this.uploadedOn,
        declined: declined ?? this.declined,
        clientData: clientData ?? this.clientData,
        type: type ?? this.type);
  }

  AdherenceRecord copyWithWrapped(
      {Wrapped<String>? instanceGuid,
      Wrapped<DateTime?>? startedOn,
      Wrapped<DateTime?>? finishedOn,
      Wrapped<DateTime>? eventTimestamp,
      Wrapped<String?>? clientTimeZone,
      Wrapped<DateTime?>? uploadedOn,
      Wrapped<bool?>? declined,
      Wrapped<Object?>? clientData,
      Wrapped<String?>? type}) {
    return AdherenceRecord(
        instanceGuid:
            (instanceGuid != null ? instanceGuid.value : this.instanceGuid),
        startedOn: (startedOn != null ? startedOn.value : this.startedOn),
        finishedOn: (finishedOn != null ? finishedOn.value : this.finishedOn),
        eventTimestamp: (eventTimestamp != null
            ? eventTimestamp.value
            : this.eventTimestamp),
        clientTimeZone: (clientTimeZone != null
            ? clientTimeZone.value
            : this.clientTimeZone),
        uploadedOn: (uploadedOn != null ? uploadedOn.value : this.uploadedOn),
        declined: (declined != null ? declined.value : this.declined),
        clientData: (clientData != null ? clientData.value : this.clientData),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AdherenceRecordUpdates {
  AdherenceRecordUpdates({
    required this.records,
    this.type,
  });

  factory AdherenceRecordUpdates.fromJson(Map<String, dynamic> json) =>
      _$AdherenceRecordUpdatesFromJson(json);

  @JsonKey(
      name: 'records', includeIfNull: false, defaultValue: <AdherenceRecord>[])
  final List<AdherenceRecord> records;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AdherenceRecordUpdatesFromJson;
  static const toJsonFactory = _$AdherenceRecordUpdatesToJson;
  Map<String, dynamic> toJson() => _$AdherenceRecordUpdatesToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AdherenceRecordUpdates &&
            (identical(other.records, records) ||
                const DeepCollectionEquality()
                    .equals(other.records, records)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(records) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AdherenceRecordUpdatesExtension on AdherenceRecordUpdates {
  AdherenceRecordUpdates copyWith(
      {List<AdherenceRecord>? records, String? type}) {
    return AdherenceRecordUpdates(
        records: records ?? this.records, type: type ?? this.type);
  }

  AdherenceRecordUpdates copyWithWrapped(
      {Wrapped<List<AdherenceRecord>>? records, Wrapped<String?>? type}) {
    return AdherenceRecordUpdates(
        records: (records != null ? records.value : this.records),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AdherenceRecordsSearch {
  AdherenceRecordsSearch({
    this.instanceGuids,
    this.assessmentIds,
    this.sessionGuids,
    this.timeWindowGuids,
    this.adherenceRecordType,
    this.includeRepeats,
    this.currentTimestampsOnly,
    this.eventTimestamps,
    this.startTime,
    this.endTime,
    this.pageSize,
    this.offsetBy,
    this.sortOrder,
    this.predicate,
    this.stringSearchPosition,
    this.type,
  });

  factory AdherenceRecordsSearch.fromJson(Map<String, dynamic> json) =>
      _$AdherenceRecordsSearchFromJson(json);

  @JsonKey(
      name: 'instanceGuids', includeIfNull: false, defaultValue: <String>[])
  final List<String>? instanceGuids;
  @JsonKey(
      name: 'assessmentIds', includeIfNull: false, defaultValue: <String>[])
  final List<String>? assessmentIds;
  @JsonKey(name: 'sessionGuids', includeIfNull: false, defaultValue: <String>[])
  final List<String>? sessionGuids;
  @JsonKey(
      name: 'timeWindowGuids', includeIfNull: false, defaultValue: <String>[])
  final List<String>? timeWindowGuids;
  @JsonKey(
    name: 'adherenceRecordType',
    includeIfNull: false,
    toJson: adherenceRecordTypeToJson,
    fromJson: adherenceRecordTypeFromJson,
  )
  final enums.AdherenceRecordType? adherenceRecordType;
  @JsonKey(name: 'includeRepeats', includeIfNull: false)
  final bool? includeRepeats;
  @JsonKey(name: 'currentTimestampsOnly', includeIfNull: false)
  final bool? currentTimestampsOnly;
  @JsonKey(name: 'eventTimestamps', includeIfNull: false)
  final Map<String, dynamic>? eventTimestamps;
  @JsonKey(name: 'startTime', includeIfNull: false)
  final DateTime? startTime;
  @JsonKey(name: 'endTime', includeIfNull: false)
  final DateTime? endTime;
  @JsonKey(name: 'pageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'offsetBy', includeIfNull: false)
  final int? offsetBy;
  @JsonKey(
    name: 'sortOrder',
    includeIfNull: false,
    toJson: sortOrderToJson,
    fromJson: sortOrderFromJson,
  )
  final enums.SortOrder? sortOrder;
  @JsonKey(
    name: 'predicate',
    includeIfNull: false,
    toJson: searchTermPredicateToJson,
    fromJson: searchTermPredicateFromJson,
  )
  final enums.SearchTermPredicate? predicate;
  @JsonKey(
    name: 'stringSearchPosition',
    includeIfNull: false,
    toJson: stringSearchPositionToJson,
    fromJson: stringSearchPositionFromJson,
  )
  final enums.StringSearchPosition? stringSearchPosition;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AdherenceRecordsSearchFromJson;
  static const toJsonFactory = _$AdherenceRecordsSearchToJson;
  Map<String, dynamic> toJson() => _$AdherenceRecordsSearchToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AdherenceRecordsSearch &&
            (identical(other.instanceGuids, instanceGuids) ||
                const DeepCollectionEquality()
                    .equals(other.instanceGuids, instanceGuids)) &&
            (identical(other.assessmentIds, assessmentIds) ||
                const DeepCollectionEquality()
                    .equals(other.assessmentIds, assessmentIds)) &&
            (identical(other.sessionGuids, sessionGuids) ||
                const DeepCollectionEquality()
                    .equals(other.sessionGuids, sessionGuids)) &&
            (identical(other.timeWindowGuids, timeWindowGuids) ||
                const DeepCollectionEquality()
                    .equals(other.timeWindowGuids, timeWindowGuids)) &&
            (identical(other.adherenceRecordType, adherenceRecordType) ||
                const DeepCollectionEquality()
                    .equals(other.adherenceRecordType, adherenceRecordType)) &&
            (identical(other.includeRepeats, includeRepeats) ||
                const DeepCollectionEquality()
                    .equals(other.includeRepeats, includeRepeats)) &&
            (identical(other.currentTimestampsOnly, currentTimestampsOnly) ||
                const DeepCollectionEquality().equals(
                    other.currentTimestampsOnly, currentTimestampsOnly)) &&
            (identical(other.eventTimestamps, eventTimestamps) ||
                const DeepCollectionEquality()
                    .equals(other.eventTimestamps, eventTimestamps)) &&
            (identical(other.startTime, startTime) ||
                const DeepCollectionEquality()
                    .equals(other.startTime, startTime)) &&
            (identical(other.endTime, endTime) ||
                const DeepCollectionEquality()
                    .equals(other.endTime, endTime)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.offsetBy, offsetBy) ||
                const DeepCollectionEquality()
                    .equals(other.offsetBy, offsetBy)) &&
            (identical(other.sortOrder, sortOrder) ||
                const DeepCollectionEquality()
                    .equals(other.sortOrder, sortOrder)) &&
            (identical(other.predicate, predicate) ||
                const DeepCollectionEquality()
                    .equals(other.predicate, predicate)) &&
            (identical(other.stringSearchPosition, stringSearchPosition) ||
                const DeepCollectionEquality().equals(
                    other.stringSearchPosition, stringSearchPosition)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(instanceGuids) ^
      const DeepCollectionEquality().hash(assessmentIds) ^
      const DeepCollectionEquality().hash(sessionGuids) ^
      const DeepCollectionEquality().hash(timeWindowGuids) ^
      const DeepCollectionEquality().hash(adherenceRecordType) ^
      const DeepCollectionEquality().hash(includeRepeats) ^
      const DeepCollectionEquality().hash(currentTimestampsOnly) ^
      const DeepCollectionEquality().hash(eventTimestamps) ^
      const DeepCollectionEquality().hash(startTime) ^
      const DeepCollectionEquality().hash(endTime) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(offsetBy) ^
      const DeepCollectionEquality().hash(sortOrder) ^
      const DeepCollectionEquality().hash(predicate) ^
      const DeepCollectionEquality().hash(stringSearchPosition) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AdherenceRecordsSearchExtension on AdherenceRecordsSearch {
  AdherenceRecordsSearch copyWith(
      {List<String>? instanceGuids,
      List<String>? assessmentIds,
      List<String>? sessionGuids,
      List<String>? timeWindowGuids,
      enums.AdherenceRecordType? adherenceRecordType,
      bool? includeRepeats,
      bool? currentTimestampsOnly,
      Map<String, dynamic>? eventTimestamps,
      DateTime? startTime,
      DateTime? endTime,
      int? pageSize,
      int? offsetBy,
      enums.SortOrder? sortOrder,
      enums.SearchTermPredicate? predicate,
      enums.StringSearchPosition? stringSearchPosition,
      String? type}) {
    return AdherenceRecordsSearch(
        instanceGuids: instanceGuids ?? this.instanceGuids,
        assessmentIds: assessmentIds ?? this.assessmentIds,
        sessionGuids: sessionGuids ?? this.sessionGuids,
        timeWindowGuids: timeWindowGuids ?? this.timeWindowGuids,
        adherenceRecordType: adherenceRecordType ?? this.adherenceRecordType,
        includeRepeats: includeRepeats ?? this.includeRepeats,
        currentTimestampsOnly:
            currentTimestampsOnly ?? this.currentTimestampsOnly,
        eventTimestamps: eventTimestamps ?? this.eventTimestamps,
        startTime: startTime ?? this.startTime,
        endTime: endTime ?? this.endTime,
        pageSize: pageSize ?? this.pageSize,
        offsetBy: offsetBy ?? this.offsetBy,
        sortOrder: sortOrder ?? this.sortOrder,
        predicate: predicate ?? this.predicate,
        stringSearchPosition: stringSearchPosition ?? this.stringSearchPosition,
        type: type ?? this.type);
  }

  AdherenceRecordsSearch copyWithWrapped(
      {Wrapped<List<String>?>? instanceGuids,
      Wrapped<List<String>?>? assessmentIds,
      Wrapped<List<String>?>? sessionGuids,
      Wrapped<List<String>?>? timeWindowGuids,
      Wrapped<enums.AdherenceRecordType?>? adherenceRecordType,
      Wrapped<bool?>? includeRepeats,
      Wrapped<bool?>? currentTimestampsOnly,
      Wrapped<Map<String, dynamic>?>? eventTimestamps,
      Wrapped<DateTime?>? startTime,
      Wrapped<DateTime?>? endTime,
      Wrapped<int?>? pageSize,
      Wrapped<int?>? offsetBy,
      Wrapped<enums.SortOrder?>? sortOrder,
      Wrapped<enums.SearchTermPredicate?>? predicate,
      Wrapped<enums.StringSearchPosition?>? stringSearchPosition,
      Wrapped<String?>? type}) {
    return AdherenceRecordsSearch(
        instanceGuids:
            (instanceGuids != null ? instanceGuids.value : this.instanceGuids),
        assessmentIds:
            (assessmentIds != null ? assessmentIds.value : this.assessmentIds),
        sessionGuids:
            (sessionGuids != null ? sessionGuids.value : this.sessionGuids),
        timeWindowGuids: (timeWindowGuids != null
            ? timeWindowGuids.value
            : this.timeWindowGuids),
        adherenceRecordType: (adherenceRecordType != null
            ? adherenceRecordType.value
            : this.adherenceRecordType),
        includeRepeats: (includeRepeats != null
            ? includeRepeats.value
            : this.includeRepeats),
        currentTimestampsOnly: (currentTimestampsOnly != null
            ? currentTimestampsOnly.value
            : this.currentTimestampsOnly),
        eventTimestamps: (eventTimestamps != null
            ? eventTimestamps.value
            : this.eventTimestamps),
        startTime: (startTime != null ? startTime.value : this.startTime),
        endTime: (endTime != null ? endTime.value : this.endTime),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        offsetBy: (offsetBy != null ? offsetBy.value : this.offsetBy),
        sortOrder: (sortOrder != null ? sortOrder.value : this.sortOrder),
        predicate: (predicate != null ? predicate.value : this.predicate),
        stringSearchPosition: (stringSearchPosition != null
            ? stringSearchPosition.value
            : this.stringSearchPosition),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AndroidAppLink {
  AndroidAppLink({
    required this.namespace,
    required this.packageName,
    required this.sha256CertFingerprints,
    this.type,
  });

  factory AndroidAppLink.fromJson(Map<String, dynamic> json) =>
      _$AndroidAppLinkFromJson(json);

  @JsonKey(name: 'namespace', includeIfNull: false, defaultValue: '')
  final String namespace;
  @JsonKey(name: 'package_name', includeIfNull: false, defaultValue: '')
  final String packageName;
  @JsonKey(
      name: 'sha256_cert_fingerprints',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String> sha256CertFingerprints;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AndroidAppLinkFromJson;
  static const toJsonFactory = _$AndroidAppLinkToJson;
  Map<String, dynamic> toJson() => _$AndroidAppLinkToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AndroidAppLink &&
            (identical(other.namespace, namespace) ||
                const DeepCollectionEquality()
                    .equals(other.namespace, namespace)) &&
            (identical(other.packageName, packageName) ||
                const DeepCollectionEquality()
                    .equals(other.packageName, packageName)) &&
            (identical(other.sha256CertFingerprints, sha256CertFingerprints) ||
                const DeepCollectionEquality().equals(
                    other.sha256CertFingerprints, sha256CertFingerprints)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(namespace) ^
      const DeepCollectionEquality().hash(packageName) ^
      const DeepCollectionEquality().hash(sha256CertFingerprints) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AndroidAppLinkExtension on AndroidAppLink {
  AndroidAppLink copyWith(
      {String? namespace,
      String? packageName,
      List<String>? sha256CertFingerprints,
      String? type}) {
    return AndroidAppLink(
        namespace: namespace ?? this.namespace,
        packageName: packageName ?? this.packageName,
        sha256CertFingerprints:
            sha256CertFingerprints ?? this.sha256CertFingerprints,
        type: type ?? this.type);
  }

  AndroidAppLink copyWithWrapped(
      {Wrapped<String>? namespace,
      Wrapped<String>? packageName,
      Wrapped<List<String>>? sha256CertFingerprints,
      Wrapped<String?>? type}) {
    return AndroidAppLink(
        namespace: (namespace != null ? namespace.value : this.namespace),
        packageName:
            (packageName != null ? packageName.value : this.packageName),
        sha256CertFingerprints: (sha256CertFingerprints != null
            ? sha256CertFingerprints.value
            : this.sha256CertFingerprints),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class App {
  App({
    required this.name,
    required this.shortName,
    this.customEvents,
    this.automaticCustomEvents,
    this.autoVerificationEmailSuppressed,
    this.consentNotificationEmailVerified,
    this.exporter3Configuration,
    this.exporter3Enabled,
    this.fitBitScopes,
    this.installLinks,
    this.participantIpLockingEnabled,
    required this.sponsorName,
    required this.supportEmail,
    this.technicalEmail,
    this.uploadMetadataFieldDefinitions,
    this.uploadValidationStrictness,
    this.consentNotificationEmail,
    required this.identifier,
    required this.version,
    this.minAgeOfConsent,
    this.appIdExcludedInExport,
    this.synapseDataAccessTeamId,
    this.synapseProjectId,
    this.usesCustomExportSchedule,
    this.userProfileAttributes,
    this.taskIdentifiers,
    this.dataGroups,
    this.passwordPolicy,
    this.active,
    this.strictUploadValidationEnabled,
    this.healthCodeExportEnabled,
    this.emailVerificationEnabled,
    this.autoVerificationPhoneSuppressed,
    this.emailSignInEnabled,
    this.phoneSignInEnabled,
    this.reauthenticationEnabled,
    this.externalIdRequiredOnSignup,
    this.verifyChannelOnSignInEnabled,
    this.accountLimit,
    this.disableExport,
    this.minSupportedAppVersions,
    this.oAuthProviders,
    this.pushNotificationARNs,
    this.appleAppLinks,
    this.androidAppLinks,
    this.defaultTemplates,
    this.type,
  });

  factory App.fromJson(Map<String, dynamic> json) => _$AppFromJson(json);

  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'shortName', includeIfNull: false, defaultValue: '')
  final String shortName;
  @JsonKey(name: 'customEvents', includeIfNull: false)
  final Map<String, dynamic>? customEvents;
  @JsonKey(name: 'automaticCustomEvents', includeIfNull: false)
  final Map<String, dynamic>? automaticCustomEvents;
  @JsonKey(name: 'autoVerificationEmailSuppressed', includeIfNull: false)
  final bool? autoVerificationEmailSuppressed;
  @JsonKey(name: 'consentNotificationEmailVerified', includeIfNull: false)
  final bool? consentNotificationEmailVerified;
  @JsonKey(name: 'exporter3Configuration', includeIfNull: false)
  final Exporter3Configuration? exporter3Configuration;
  @JsonKey(name: 'exporter3Enabled', includeIfNull: false)
  final bool? exporter3Enabled;
  @JsonKey(name: 'fitBitScopes', includeIfNull: false, defaultValue: <String>[])
  final List<String>? fitBitScopes;
  @JsonKey(name: 'installLinks', includeIfNull: false)
  final Map<String, dynamic>? installLinks;
  @JsonKey(name: 'participantIpLockingEnabled', includeIfNull: false)
  final bool? participantIpLockingEnabled;
  @JsonKey(name: 'sponsorName', includeIfNull: false, defaultValue: '')
  final String sponsorName;
  @JsonKey(name: 'supportEmail', includeIfNull: false, defaultValue: '')
  final String supportEmail;
  @JsonKey(name: 'technicalEmail', includeIfNull: false, defaultValue: '')
  final String? technicalEmail;
  @JsonKey(
      name: 'uploadMetadataFieldDefinitions',
      includeIfNull: false,
      defaultValue: <UploadFieldDefinition>[])
  final List<UploadFieldDefinition>? uploadMetadataFieldDefinitions;
  @JsonKey(
    name: 'uploadValidationStrictness',
    includeIfNull: false,
    toJson: uploadValidationStrictnessToJson,
    fromJson: uploadValidationStrictnessFromJson,
  )
  final enums.UploadValidationStrictness? uploadValidationStrictness;
  @JsonKey(
      name: 'consentNotificationEmail', includeIfNull: false, defaultValue: '')
  final String? consentNotificationEmail;
  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String identifier;
  @JsonKey(name: 'version', includeIfNull: false)
  final num version;
  @JsonKey(name: 'minAgeOfConsent', includeIfNull: false)
  final int? minAgeOfConsent;
  @JsonKey(name: 'appIdExcludedInExport', includeIfNull: false)
  final bool? appIdExcludedInExport;
  @JsonKey(name: 'synapseDataAccessTeamId', includeIfNull: false)
  final num? synapseDataAccessTeamId;
  @JsonKey(name: 'synapseProjectId', includeIfNull: false, defaultValue: '')
  final String? synapseProjectId;
  @JsonKey(name: 'usesCustomExportSchedule', includeIfNull: false)
  final bool? usesCustomExportSchedule;
  @JsonKey(
      name: 'userProfileAttributes',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? userProfileAttributes;
  @JsonKey(
      name: 'taskIdentifiers', includeIfNull: false, defaultValue: <String>[])
  final List<String>? taskIdentifiers;
  @JsonKey(name: 'dataGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String>? dataGroups;
  @JsonKey(name: 'passwordPolicy', includeIfNull: false)
  final PasswordPolicy? passwordPolicy;
  @JsonKey(name: 'active', includeIfNull: false)
  final bool? active;
  @JsonKey(name: 'strictUploadValidationEnabled', includeIfNull: false)
  final bool? strictUploadValidationEnabled;
  @JsonKey(name: 'healthCodeExportEnabled', includeIfNull: false)
  final bool? healthCodeExportEnabled;
  @JsonKey(name: 'emailVerificationEnabled', includeIfNull: false)
  final bool? emailVerificationEnabled;
  @JsonKey(name: 'autoVerificationPhoneSuppressed', includeIfNull: false)
  final bool? autoVerificationPhoneSuppressed;
  @JsonKey(
      name: 'emailSignInEnabled', includeIfNull: false, defaultValue: false)
  final bool? emailSignInEnabled;
  @JsonKey(
      name: 'phoneSignInEnabled', includeIfNull: false, defaultValue: false)
  final bool? phoneSignInEnabled;
  @JsonKey(
      name: 'reauthenticationEnabled', includeIfNull: false, defaultValue: true)
  final bool? reauthenticationEnabled;
  @JsonKey(
      name: 'externalIdRequiredOnSignup',
      includeIfNull: false,
      defaultValue: false)
  final bool? externalIdRequiredOnSignup;
  @JsonKey(
      name: 'verifyChannelOnSignInEnabled',
      includeIfNull: false,
      defaultValue: true)
  final bool? verifyChannelOnSignInEnabled;
  @JsonKey(name: 'accountLimit', includeIfNull: false)
  final int? accountLimit;
  @JsonKey(name: 'disableExport', includeIfNull: false, defaultValue: false)
  final bool? disableExport;
  @JsonKey(name: 'minSupportedAppVersions', includeIfNull: false)
  final Map<String, dynamic>? minSupportedAppVersions;
  @JsonKey(name: 'oAuthProviders', includeIfNull: false)
  final Map<String, dynamic>? oAuthProviders;
  @JsonKey(name: 'pushNotificationARNs', includeIfNull: false)
  final Map<String, dynamic>? pushNotificationARNs;
  @JsonKey(
      name: 'appleAppLinks',
      includeIfNull: false,
      defaultValue: <AppleAppLink>[])
  final List<AppleAppLink>? appleAppLinks;
  @JsonKey(
      name: 'androidAppLinks',
      includeIfNull: false,
      defaultValue: <AndroidAppLink>[])
  final List<AndroidAppLink>? androidAppLinks;
  @JsonKey(name: 'defaultTemplates', includeIfNull: false)
  final Map<String, dynamic>? defaultTemplates;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AppFromJson;
  static const toJsonFactory = _$AppToJson;
  Map<String, dynamic> toJson() => _$AppToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is App &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.shortName, shortName) ||
                const DeepCollectionEquality()
                    .equals(other.shortName, shortName)) &&
            (identical(other.customEvents, customEvents) ||
                const DeepCollectionEquality()
                    .equals(other.customEvents, customEvents)) &&
            (identical(other.automaticCustomEvents, automaticCustomEvents) ||
                const DeepCollectionEquality().equals(
                    other.automaticCustomEvents, automaticCustomEvents)) &&
            (identical(other.autoVerificationEmailSuppressed, autoVerificationEmailSuppressed) ||
                const DeepCollectionEquality().equals(
                    other.autoVerificationEmailSuppressed,
                    autoVerificationEmailSuppressed)) &&
            (identical(other.consentNotificationEmailVerified, consentNotificationEmailVerified) ||
                const DeepCollectionEquality().equals(
                    other.consentNotificationEmailVerified,
                    consentNotificationEmailVerified)) &&
            (identical(other.exporter3Configuration, exporter3Configuration) ||
                const DeepCollectionEquality().equals(
                    other.exporter3Configuration, exporter3Configuration)) &&
            (identical(other.exporter3Enabled, exporter3Enabled) ||
                const DeepCollectionEquality()
                    .equals(other.exporter3Enabled, exporter3Enabled)) &&
            (identical(other.fitBitScopes, fitBitScopes) ||
                const DeepCollectionEquality()
                    .equals(other.fitBitScopes, fitBitScopes)) &&
            (identical(other.installLinks, installLinks) ||
                const DeepCollectionEquality()
                    .equals(other.installLinks, installLinks)) &&
            (identical(other.participantIpLockingEnabled, participantIpLockingEnabled) ||
                const DeepCollectionEquality().equals(
                    other.participantIpLockingEnabled,
                    participantIpLockingEnabled)) &&
            (identical(other.sponsorName, sponsorName) ||
                const DeepCollectionEquality()
                    .equals(other.sponsorName, sponsorName)) &&
            (identical(other.supportEmail, supportEmail) ||
                const DeepCollectionEquality()
                    .equals(other.supportEmail, supportEmail)) &&
            (identical(other.technicalEmail, technicalEmail) ||
                const DeepCollectionEquality().equals(other.technicalEmail, technicalEmail)) &&
            (identical(other.uploadMetadataFieldDefinitions, uploadMetadataFieldDefinitions) || const DeepCollectionEquality().equals(other.uploadMetadataFieldDefinitions, uploadMetadataFieldDefinitions)) &&
            (identical(other.uploadValidationStrictness, uploadValidationStrictness) || const DeepCollectionEquality().equals(other.uploadValidationStrictness, uploadValidationStrictness)) &&
            (identical(other.consentNotificationEmail, consentNotificationEmail) || const DeepCollectionEquality().equals(other.consentNotificationEmail, consentNotificationEmail)) &&
            (identical(other.identifier, identifier) || const DeepCollectionEquality().equals(other.identifier, identifier)) &&
            (identical(other.version, version) || const DeepCollectionEquality().equals(other.version, version)) &&
            (identical(other.minAgeOfConsent, minAgeOfConsent) || const DeepCollectionEquality().equals(other.minAgeOfConsent, minAgeOfConsent)) &&
            (identical(other.appIdExcludedInExport, appIdExcludedInExport) || const DeepCollectionEquality().equals(other.appIdExcludedInExport, appIdExcludedInExport)) &&
            (identical(other.synapseDataAccessTeamId, synapseDataAccessTeamId) || const DeepCollectionEquality().equals(other.synapseDataAccessTeamId, synapseDataAccessTeamId)) &&
            (identical(other.synapseProjectId, synapseProjectId) || const DeepCollectionEquality().equals(other.synapseProjectId, synapseProjectId)) &&
            (identical(other.usesCustomExportSchedule, usesCustomExportSchedule) || const DeepCollectionEquality().equals(other.usesCustomExportSchedule, usesCustomExportSchedule)) &&
            (identical(other.userProfileAttributes, userProfileAttributes) || const DeepCollectionEquality().equals(other.userProfileAttributes, userProfileAttributes)) &&
            (identical(other.taskIdentifiers, taskIdentifiers) || const DeepCollectionEquality().equals(other.taskIdentifiers, taskIdentifiers)) &&
            (identical(other.dataGroups, dataGroups) || const DeepCollectionEquality().equals(other.dataGroups, dataGroups)) &&
            (identical(other.passwordPolicy, passwordPolicy) || const DeepCollectionEquality().equals(other.passwordPolicy, passwordPolicy)) &&
            (identical(other.active, active) || const DeepCollectionEquality().equals(other.active, active)) &&
            (identical(other.strictUploadValidationEnabled, strictUploadValidationEnabled) || const DeepCollectionEquality().equals(other.strictUploadValidationEnabled, strictUploadValidationEnabled)) &&
            (identical(other.healthCodeExportEnabled, healthCodeExportEnabled) || const DeepCollectionEquality().equals(other.healthCodeExportEnabled, healthCodeExportEnabled)) &&
            (identical(other.emailVerificationEnabled, emailVerificationEnabled) || const DeepCollectionEquality().equals(other.emailVerificationEnabled, emailVerificationEnabled)) &&
            (identical(other.autoVerificationPhoneSuppressed, autoVerificationPhoneSuppressed) || const DeepCollectionEquality().equals(other.autoVerificationPhoneSuppressed, autoVerificationPhoneSuppressed)) &&
            (identical(other.emailSignInEnabled, emailSignInEnabled) || const DeepCollectionEquality().equals(other.emailSignInEnabled, emailSignInEnabled)) &&
            (identical(other.phoneSignInEnabled, phoneSignInEnabled) || const DeepCollectionEquality().equals(other.phoneSignInEnabled, phoneSignInEnabled)) &&
            (identical(other.reauthenticationEnabled, reauthenticationEnabled) || const DeepCollectionEquality().equals(other.reauthenticationEnabled, reauthenticationEnabled)) &&
            (identical(other.externalIdRequiredOnSignup, externalIdRequiredOnSignup) || const DeepCollectionEquality().equals(other.externalIdRequiredOnSignup, externalIdRequiredOnSignup)) &&
            (identical(other.verifyChannelOnSignInEnabled, verifyChannelOnSignInEnabled) || const DeepCollectionEquality().equals(other.verifyChannelOnSignInEnabled, verifyChannelOnSignInEnabled)) &&
            (identical(other.accountLimit, accountLimit) || const DeepCollectionEquality().equals(other.accountLimit, accountLimit)) &&
            (identical(other.disableExport, disableExport) || const DeepCollectionEquality().equals(other.disableExport, disableExport)) &&
            (identical(other.minSupportedAppVersions, minSupportedAppVersions) || const DeepCollectionEquality().equals(other.minSupportedAppVersions, minSupportedAppVersions)) &&
            (identical(other.oAuthProviders, oAuthProviders) || const DeepCollectionEquality().equals(other.oAuthProviders, oAuthProviders)) &&
            (identical(other.pushNotificationARNs, pushNotificationARNs) || const DeepCollectionEquality().equals(other.pushNotificationARNs, pushNotificationARNs)) &&
            (identical(other.appleAppLinks, appleAppLinks) || const DeepCollectionEquality().equals(other.appleAppLinks, appleAppLinks)) &&
            (identical(other.androidAppLinks, androidAppLinks) || const DeepCollectionEquality().equals(other.androidAppLinks, androidAppLinks)) &&
            (identical(other.defaultTemplates, defaultTemplates) || const DeepCollectionEquality().equals(other.defaultTemplates, defaultTemplates)) &&
            (identical(other.type, type) || const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(shortName) ^
      const DeepCollectionEquality().hash(customEvents) ^
      const DeepCollectionEquality().hash(automaticCustomEvents) ^
      const DeepCollectionEquality().hash(autoVerificationEmailSuppressed) ^
      const DeepCollectionEquality().hash(consentNotificationEmailVerified) ^
      const DeepCollectionEquality().hash(exporter3Configuration) ^
      const DeepCollectionEquality().hash(exporter3Enabled) ^
      const DeepCollectionEquality().hash(fitBitScopes) ^
      const DeepCollectionEquality().hash(installLinks) ^
      const DeepCollectionEquality().hash(participantIpLockingEnabled) ^
      const DeepCollectionEquality().hash(sponsorName) ^
      const DeepCollectionEquality().hash(supportEmail) ^
      const DeepCollectionEquality().hash(technicalEmail) ^
      const DeepCollectionEquality().hash(uploadMetadataFieldDefinitions) ^
      const DeepCollectionEquality().hash(uploadValidationStrictness) ^
      const DeepCollectionEquality().hash(consentNotificationEmail) ^
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(minAgeOfConsent) ^
      const DeepCollectionEquality().hash(appIdExcludedInExport) ^
      const DeepCollectionEquality().hash(synapseDataAccessTeamId) ^
      const DeepCollectionEquality().hash(synapseProjectId) ^
      const DeepCollectionEquality().hash(usesCustomExportSchedule) ^
      const DeepCollectionEquality().hash(userProfileAttributes) ^
      const DeepCollectionEquality().hash(taskIdentifiers) ^
      const DeepCollectionEquality().hash(dataGroups) ^
      const DeepCollectionEquality().hash(passwordPolicy) ^
      const DeepCollectionEquality().hash(active) ^
      const DeepCollectionEquality().hash(strictUploadValidationEnabled) ^
      const DeepCollectionEquality().hash(healthCodeExportEnabled) ^
      const DeepCollectionEquality().hash(emailVerificationEnabled) ^
      const DeepCollectionEquality().hash(autoVerificationPhoneSuppressed) ^
      const DeepCollectionEquality().hash(emailSignInEnabled) ^
      const DeepCollectionEquality().hash(phoneSignInEnabled) ^
      const DeepCollectionEquality().hash(reauthenticationEnabled) ^
      const DeepCollectionEquality().hash(externalIdRequiredOnSignup) ^
      const DeepCollectionEquality().hash(verifyChannelOnSignInEnabled) ^
      const DeepCollectionEquality().hash(accountLimit) ^
      const DeepCollectionEquality().hash(disableExport) ^
      const DeepCollectionEquality().hash(minSupportedAppVersions) ^
      const DeepCollectionEquality().hash(oAuthProviders) ^
      const DeepCollectionEquality().hash(pushNotificationARNs) ^
      const DeepCollectionEquality().hash(appleAppLinks) ^
      const DeepCollectionEquality().hash(androidAppLinks) ^
      const DeepCollectionEquality().hash(defaultTemplates) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AppExtension on App {
  App copyWith(
      {String? name,
      String? shortName,
      Map<String, dynamic>? customEvents,
      Map<String, dynamic>? automaticCustomEvents,
      bool? autoVerificationEmailSuppressed,
      bool? consentNotificationEmailVerified,
      Exporter3Configuration? exporter3Configuration,
      bool? exporter3Enabled,
      List<String>? fitBitScopes,
      Map<String, dynamic>? installLinks,
      bool? participantIpLockingEnabled,
      String? sponsorName,
      String? supportEmail,
      String? technicalEmail,
      List<UploadFieldDefinition>? uploadMetadataFieldDefinitions,
      enums.UploadValidationStrictness? uploadValidationStrictness,
      String? consentNotificationEmail,
      String? identifier,
      num? version,
      int? minAgeOfConsent,
      bool? appIdExcludedInExport,
      num? synapseDataAccessTeamId,
      String? synapseProjectId,
      bool? usesCustomExportSchedule,
      List<String>? userProfileAttributes,
      List<String>? taskIdentifiers,
      List<String>? dataGroups,
      PasswordPolicy? passwordPolicy,
      bool? active,
      bool? strictUploadValidationEnabled,
      bool? healthCodeExportEnabled,
      bool? emailVerificationEnabled,
      bool? autoVerificationPhoneSuppressed,
      bool? emailSignInEnabled,
      bool? phoneSignInEnabled,
      bool? reauthenticationEnabled,
      bool? externalIdRequiredOnSignup,
      bool? verifyChannelOnSignInEnabled,
      int? accountLimit,
      bool? disableExport,
      Map<String, dynamic>? minSupportedAppVersions,
      Map<String, dynamic>? oAuthProviders,
      Map<String, dynamic>? pushNotificationARNs,
      List<AppleAppLink>? appleAppLinks,
      List<AndroidAppLink>? androidAppLinks,
      Map<String, dynamic>? defaultTemplates,
      String? type}) {
    return App(
        name: name ?? this.name,
        shortName: shortName ?? this.shortName,
        customEvents: customEvents ?? this.customEvents,
        automaticCustomEvents:
            automaticCustomEvents ?? this.automaticCustomEvents,
        autoVerificationEmailSuppressed: autoVerificationEmailSuppressed ??
            this.autoVerificationEmailSuppressed,
        consentNotificationEmailVerified: consentNotificationEmailVerified ??
            this.consentNotificationEmailVerified,
        exporter3Configuration:
            exporter3Configuration ?? this.exporter3Configuration,
        exporter3Enabled: exporter3Enabled ?? this.exporter3Enabled,
        fitBitScopes: fitBitScopes ?? this.fitBitScopes,
        installLinks: installLinks ?? this.installLinks,
        participantIpLockingEnabled:
            participantIpLockingEnabled ?? this.participantIpLockingEnabled,
        sponsorName: sponsorName ?? this.sponsorName,
        supportEmail: supportEmail ?? this.supportEmail,
        technicalEmail: technicalEmail ?? this.technicalEmail,
        uploadMetadataFieldDefinitions: uploadMetadataFieldDefinitions ??
            this.uploadMetadataFieldDefinitions,
        uploadValidationStrictness:
            uploadValidationStrictness ?? this.uploadValidationStrictness,
        consentNotificationEmail:
            consentNotificationEmail ?? this.consentNotificationEmail,
        identifier: identifier ?? this.identifier,
        version: version ?? this.version,
        minAgeOfConsent: minAgeOfConsent ?? this.minAgeOfConsent,
        appIdExcludedInExport:
            appIdExcludedInExport ?? this.appIdExcludedInExport,
        synapseDataAccessTeamId:
            synapseDataAccessTeamId ?? this.synapseDataAccessTeamId,
        synapseProjectId: synapseProjectId ?? this.synapseProjectId,
        usesCustomExportSchedule:
            usesCustomExportSchedule ?? this.usesCustomExportSchedule,
        userProfileAttributes:
            userProfileAttributes ?? this.userProfileAttributes,
        taskIdentifiers: taskIdentifiers ?? this.taskIdentifiers,
        dataGroups: dataGroups ?? this.dataGroups,
        passwordPolicy: passwordPolicy ?? this.passwordPolicy,
        active: active ?? this.active,
        strictUploadValidationEnabled:
            strictUploadValidationEnabled ?? this.strictUploadValidationEnabled,
        healthCodeExportEnabled:
            healthCodeExportEnabled ?? this.healthCodeExportEnabled,
        emailVerificationEnabled:
            emailVerificationEnabled ?? this.emailVerificationEnabled,
        autoVerificationPhoneSuppressed: autoVerificationPhoneSuppressed ??
            this.autoVerificationPhoneSuppressed,
        emailSignInEnabled: emailSignInEnabled ?? this.emailSignInEnabled,
        phoneSignInEnabled: phoneSignInEnabled ?? this.phoneSignInEnabled,
        reauthenticationEnabled:
            reauthenticationEnabled ?? this.reauthenticationEnabled,
        externalIdRequiredOnSignup:
            externalIdRequiredOnSignup ?? this.externalIdRequiredOnSignup,
        verifyChannelOnSignInEnabled:
            verifyChannelOnSignInEnabled ?? this.verifyChannelOnSignInEnabled,
        accountLimit: accountLimit ?? this.accountLimit,
        disableExport: disableExport ?? this.disableExport,
        minSupportedAppVersions:
            minSupportedAppVersions ?? this.minSupportedAppVersions,
        oAuthProviders: oAuthProviders ?? this.oAuthProviders,
        pushNotificationARNs: pushNotificationARNs ?? this.pushNotificationARNs,
        appleAppLinks: appleAppLinks ?? this.appleAppLinks,
        androidAppLinks: androidAppLinks ?? this.androidAppLinks,
        defaultTemplates: defaultTemplates ?? this.defaultTemplates,
        type: type ?? this.type);
  }

  App copyWithWrapped(
      {Wrapped<String>? name,
      Wrapped<String>? shortName,
      Wrapped<Map<String, dynamic>?>? customEvents,
      Wrapped<Map<String, dynamic>?>? automaticCustomEvents,
      Wrapped<bool?>? autoVerificationEmailSuppressed,
      Wrapped<bool?>? consentNotificationEmailVerified,
      Wrapped<Exporter3Configuration?>? exporter3Configuration,
      Wrapped<bool?>? exporter3Enabled,
      Wrapped<List<String>?>? fitBitScopes,
      Wrapped<Map<String, dynamic>?>? installLinks,
      Wrapped<bool?>? participantIpLockingEnabled,
      Wrapped<String>? sponsorName,
      Wrapped<String>? supportEmail,
      Wrapped<String?>? technicalEmail,
      Wrapped<List<UploadFieldDefinition>?>? uploadMetadataFieldDefinitions,
      Wrapped<enums.UploadValidationStrictness?>? uploadValidationStrictness,
      Wrapped<String?>? consentNotificationEmail,
      Wrapped<String>? identifier,
      Wrapped<num>? version,
      Wrapped<int?>? minAgeOfConsent,
      Wrapped<bool?>? appIdExcludedInExport,
      Wrapped<num?>? synapseDataAccessTeamId,
      Wrapped<String?>? synapseProjectId,
      Wrapped<bool?>? usesCustomExportSchedule,
      Wrapped<List<String>?>? userProfileAttributes,
      Wrapped<List<String>?>? taskIdentifiers,
      Wrapped<List<String>?>? dataGroups,
      Wrapped<PasswordPolicy?>? passwordPolicy,
      Wrapped<bool?>? active,
      Wrapped<bool?>? strictUploadValidationEnabled,
      Wrapped<bool?>? healthCodeExportEnabled,
      Wrapped<bool?>? emailVerificationEnabled,
      Wrapped<bool?>? autoVerificationPhoneSuppressed,
      Wrapped<bool?>? emailSignInEnabled,
      Wrapped<bool?>? phoneSignInEnabled,
      Wrapped<bool?>? reauthenticationEnabled,
      Wrapped<bool?>? externalIdRequiredOnSignup,
      Wrapped<bool?>? verifyChannelOnSignInEnabled,
      Wrapped<int?>? accountLimit,
      Wrapped<bool?>? disableExport,
      Wrapped<Map<String, dynamic>?>? minSupportedAppVersions,
      Wrapped<Map<String, dynamic>?>? oAuthProviders,
      Wrapped<Map<String, dynamic>?>? pushNotificationARNs,
      Wrapped<List<AppleAppLink>?>? appleAppLinks,
      Wrapped<List<AndroidAppLink>?>? androidAppLinks,
      Wrapped<Map<String, dynamic>?>? defaultTemplates,
      Wrapped<String?>? type}) {
    return App(
        name: (name != null ? name.value : this.name),
        shortName: (shortName != null ? shortName.value : this.shortName),
        customEvents:
            (customEvents != null ? customEvents.value : this.customEvents),
        automaticCustomEvents: (automaticCustomEvents != null
            ? automaticCustomEvents.value
            : this.automaticCustomEvents),
        autoVerificationEmailSuppressed: (autoVerificationEmailSuppressed != null
            ? autoVerificationEmailSuppressed.value
            : this.autoVerificationEmailSuppressed),
        consentNotificationEmailVerified:
            (consentNotificationEmailVerified != null
                ? consentNotificationEmailVerified.value
                : this.consentNotificationEmailVerified),
        exporter3Configuration: (exporter3Configuration != null
            ? exporter3Configuration.value
            : this.exporter3Configuration),
        exporter3Enabled: (exporter3Enabled != null
            ? exporter3Enabled.value
            : this.exporter3Enabled),
        fitBitScopes:
            (fitBitScopes != null ? fitBitScopes.value : this.fitBitScopes),
        installLinks:
            (installLinks != null ? installLinks.value : this.installLinks),
        participantIpLockingEnabled: (participantIpLockingEnabled != null
            ? participantIpLockingEnabled.value
            : this.participantIpLockingEnabled),
        sponsorName:
            (sponsorName != null ? sponsorName.value : this.sponsorName),
        supportEmail:
            (supportEmail != null ? supportEmail.value : this.supportEmail),
        technicalEmail: (technicalEmail != null
            ? technicalEmail.value
            : this.technicalEmail),
        uploadMetadataFieldDefinitions: (uploadMetadataFieldDefinitions != null
            ? uploadMetadataFieldDefinitions.value
            : this.uploadMetadataFieldDefinitions),
        uploadValidationStrictness: (uploadValidationStrictness != null
            ? uploadValidationStrictness.value
            : this.uploadValidationStrictness),
        consentNotificationEmail: (consentNotificationEmail != null
            ? consentNotificationEmail.value
            : this.consentNotificationEmail),
        identifier: (identifier != null ? identifier.value : this.identifier),
        version: (version != null ? version.value : this.version),
        minAgeOfConsent: (minAgeOfConsent != null
            ? minAgeOfConsent.value
            : this.minAgeOfConsent),
        appIdExcludedInExport: (appIdExcludedInExport != null
            ? appIdExcludedInExport.value
            : this.appIdExcludedInExport),
        synapseDataAccessTeamId: (synapseDataAccessTeamId != null
            ? synapseDataAccessTeamId.value
            : this.synapseDataAccessTeamId),
        synapseProjectId: (synapseProjectId != null
            ? synapseProjectId.value
            : this.synapseProjectId),
        usesCustomExportSchedule: (usesCustomExportSchedule != null
            ? usesCustomExportSchedule.value
            : this.usesCustomExportSchedule),
        userProfileAttributes: (userProfileAttributes != null
            ? userProfileAttributes.value
            : this.userProfileAttributes),
        taskIdentifiers: (taskIdentifiers != null
            ? taskIdentifiers.value
            : this.taskIdentifiers),
        dataGroups: (dataGroups != null ? dataGroups.value : this.dataGroups),
        passwordPolicy: (passwordPolicy != null
            ? passwordPolicy.value
            : this.passwordPolicy),
        active: (active != null ? active.value : this.active),
        strictUploadValidationEnabled: (strictUploadValidationEnabled != null
            ? strictUploadValidationEnabled.value
            : this.strictUploadValidationEnabled),
        healthCodeExportEnabled: (healthCodeExportEnabled != null
            ? healthCodeExportEnabled.value
            : this.healthCodeExportEnabled),
        emailVerificationEnabled: (emailVerificationEnabled != null
            ? emailVerificationEnabled.value
            : this.emailVerificationEnabled),
        autoVerificationPhoneSuppressed: (autoVerificationPhoneSuppressed != null
            ? autoVerificationPhoneSuppressed.value
            : this.autoVerificationPhoneSuppressed),
        emailSignInEnabled: (emailSignInEnabled != null
            ? emailSignInEnabled.value
            : this.emailSignInEnabled),
        phoneSignInEnabled: (phoneSignInEnabled != null
            ? phoneSignInEnabled.value
            : this.phoneSignInEnabled),
        reauthenticationEnabled: (reauthenticationEnabled != null
            ? reauthenticationEnabled.value
            : this.reauthenticationEnabled),
        externalIdRequiredOnSignup: (externalIdRequiredOnSignup != null ? externalIdRequiredOnSignup.value : this.externalIdRequiredOnSignup),
        verifyChannelOnSignInEnabled: (verifyChannelOnSignInEnabled != null ? verifyChannelOnSignInEnabled.value : this.verifyChannelOnSignInEnabled),
        accountLimit: (accountLimit != null ? accountLimit.value : this.accountLimit),
        disableExport: (disableExport != null ? disableExport.value : this.disableExport),
        minSupportedAppVersions: (minSupportedAppVersions != null ? minSupportedAppVersions.value : this.minSupportedAppVersions),
        oAuthProviders: (oAuthProviders != null ? oAuthProviders.value : this.oAuthProviders),
        pushNotificationARNs: (pushNotificationARNs != null ? pushNotificationARNs.value : this.pushNotificationARNs),
        appleAppLinks: (appleAppLinks != null ? appleAppLinks.value : this.appleAppLinks),
        androidAppLinks: (androidAppLinks != null ? androidAppLinks.value : this.androidAppLinks),
        defaultTemplates: (defaultTemplates != null ? defaultTemplates.value : this.defaultTemplates),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AppAndUsers {
  AppAndUsers({
    required this.adminIds,
    required this.app,
    required this.users,
    this.type,
  });

  factory AppAndUsers.fromJson(Map<String, dynamic> json) =>
      _$AppAndUsersFromJson(json);

  @JsonKey(name: 'adminIds', includeIfNull: false, defaultValue: <String>[])
  final List<String> adminIds;
  @JsonKey(name: 'app', includeIfNull: false)
  final App app;
  @JsonKey(
      name: 'users', includeIfNull: false, defaultValue: <StudyParticipant>[])
  final List<StudyParticipant> users;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AppAndUsersFromJson;
  static const toJsonFactory = _$AppAndUsersToJson;
  Map<String, dynamic> toJson() => _$AppAndUsersToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AppAndUsers &&
            (identical(other.adminIds, adminIds) ||
                const DeepCollectionEquality()
                    .equals(other.adminIds, adminIds)) &&
            (identical(other.app, app) ||
                const DeepCollectionEquality().equals(other.app, app)) &&
            (identical(other.users, users) ||
                const DeepCollectionEquality().equals(other.users, users)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(adminIds) ^
      const DeepCollectionEquality().hash(app) ^
      const DeepCollectionEquality().hash(users) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AppAndUsersExtension on AppAndUsers {
  AppAndUsers copyWith(
      {List<String>? adminIds,
      App? app,
      List<StudyParticipant>? users,
      String? type}) {
    return AppAndUsers(
        adminIds: adminIds ?? this.adminIds,
        app: app ?? this.app,
        users: users ?? this.users,
        type: type ?? this.type);
  }

  AppAndUsers copyWithWrapped(
      {Wrapped<List<String>>? adminIds,
      Wrapped<App>? app,
      Wrapped<List<StudyParticipant>>? users,
      Wrapped<String?>? type}) {
    return AppAndUsers(
        adminIds: (adminIds != null ? adminIds.value : this.adminIds),
        app: (app != null ? app.value : this.app),
        users: (users != null ? users.value : this.users),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AppConfig {
  AppConfig({
    required this.label,
    this.createdOn,
    this.modifiedOn,
    this.guid,
    this.deleted,
    this.criteria,
    this.clientData,
    this.surveyReferences,
    this.schemaReferences,
    this.configReferences,
    this.fileReferences,
    this.assessmentReferences,
    this.configElements,
    this.version,
    this.type,
  });

  factory AppConfig.fromJson(Map<String, dynamic> json) =>
      _$AppConfigFromJson(json);

  @JsonKey(name: 'label', includeIfNull: false, defaultValue: '')
  final String label;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'modifiedOn', includeIfNull: false)
  final DateTime? modifiedOn;
  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String? guid;
  @JsonKey(name: 'deleted', includeIfNull: false)
  final bool? deleted;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final Criteria? criteria;
  @JsonKey(name: 'clientData', includeIfNull: false)
  final Object? clientData;
  @JsonKey(
      name: 'surveyReferences',
      includeIfNull: false,
      defaultValue: <SurveyReference>[])
  final List<SurveyReference>? surveyReferences;
  @JsonKey(
      name: 'schemaReferences',
      includeIfNull: false,
      defaultValue: <SchemaReference>[])
  final List<SchemaReference>? schemaReferences;
  @JsonKey(
      name: 'configReferences',
      includeIfNull: false,
      defaultValue: <ConfigReference>[])
  final List<ConfigReference>? configReferences;
  @JsonKey(
      name: 'fileReferences',
      includeIfNull: false,
      defaultValue: <FileReference>[])
  final List<FileReference>? fileReferences;
  @JsonKey(
      name: 'assessmentReferences',
      includeIfNull: false,
      defaultValue: <AssessmentReference>[])
  final List<AssessmentReference>? assessmentReferences;
  @JsonKey(name: 'configElements', includeIfNull: false)
  final Map<String, dynamic>? configElements;
  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AppConfigFromJson;
  static const toJsonFactory = _$AppConfigToJson;
  Map<String, dynamic> toJson() => _$AppConfigToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AppConfig &&
            (identical(other.label, label) ||
                const DeepCollectionEquality().equals(other.label, label)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.modifiedOn, modifiedOn) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedOn, modifiedOn)) &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.deleted, deleted) ||
                const DeepCollectionEquality()
                    .equals(other.deleted, deleted)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.clientData, clientData) ||
                const DeepCollectionEquality()
                    .equals(other.clientData, clientData)) &&
            (identical(other.surveyReferences, surveyReferences) ||
                const DeepCollectionEquality()
                    .equals(other.surveyReferences, surveyReferences)) &&
            (identical(other.schemaReferences, schemaReferences) ||
                const DeepCollectionEquality()
                    .equals(other.schemaReferences, schemaReferences)) &&
            (identical(other.configReferences, configReferences) ||
                const DeepCollectionEquality()
                    .equals(other.configReferences, configReferences)) &&
            (identical(other.fileReferences, fileReferences) ||
                const DeepCollectionEquality()
                    .equals(other.fileReferences, fileReferences)) &&
            (identical(other.assessmentReferences, assessmentReferences) ||
                const DeepCollectionEquality().equals(
                    other.assessmentReferences, assessmentReferences)) &&
            (identical(other.configElements, configElements) ||
                const DeepCollectionEquality()
                    .equals(other.configElements, configElements)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(label) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(modifiedOn) ^
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(deleted) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(clientData) ^
      const DeepCollectionEquality().hash(surveyReferences) ^
      const DeepCollectionEquality().hash(schemaReferences) ^
      const DeepCollectionEquality().hash(configReferences) ^
      const DeepCollectionEquality().hash(fileReferences) ^
      const DeepCollectionEquality().hash(assessmentReferences) ^
      const DeepCollectionEquality().hash(configElements) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AppConfigExtension on AppConfig {
  AppConfig copyWith(
      {String? label,
      DateTime? createdOn,
      DateTime? modifiedOn,
      String? guid,
      bool? deleted,
      Criteria? criteria,
      Object? clientData,
      List<SurveyReference>? surveyReferences,
      List<SchemaReference>? schemaReferences,
      List<ConfigReference>? configReferences,
      List<FileReference>? fileReferences,
      List<AssessmentReference>? assessmentReferences,
      Map<String, dynamic>? configElements,
      num? version,
      String? type}) {
    return AppConfig(
        label: label ?? this.label,
        createdOn: createdOn ?? this.createdOn,
        modifiedOn: modifiedOn ?? this.modifiedOn,
        guid: guid ?? this.guid,
        deleted: deleted ?? this.deleted,
        criteria: criteria ?? this.criteria,
        clientData: clientData ?? this.clientData,
        surveyReferences: surveyReferences ?? this.surveyReferences,
        schemaReferences: schemaReferences ?? this.schemaReferences,
        configReferences: configReferences ?? this.configReferences,
        fileReferences: fileReferences ?? this.fileReferences,
        assessmentReferences: assessmentReferences ?? this.assessmentReferences,
        configElements: configElements ?? this.configElements,
        version: version ?? this.version,
        type: type ?? this.type);
  }

  AppConfig copyWithWrapped(
      {Wrapped<String>? label,
      Wrapped<DateTime?>? createdOn,
      Wrapped<DateTime?>? modifiedOn,
      Wrapped<String?>? guid,
      Wrapped<bool?>? deleted,
      Wrapped<Criteria?>? criteria,
      Wrapped<Object?>? clientData,
      Wrapped<List<SurveyReference>?>? surveyReferences,
      Wrapped<List<SchemaReference>?>? schemaReferences,
      Wrapped<List<ConfigReference>?>? configReferences,
      Wrapped<List<FileReference>?>? fileReferences,
      Wrapped<List<AssessmentReference>?>? assessmentReferences,
      Wrapped<Map<String, dynamic>?>? configElements,
      Wrapped<num?>? version,
      Wrapped<String?>? type}) {
    return AppConfig(
        label: (label != null ? label.value : this.label),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        modifiedOn: (modifiedOn != null ? modifiedOn.value : this.modifiedOn),
        guid: (guid != null ? guid.value : this.guid),
        deleted: (deleted != null ? deleted.value : this.deleted),
        criteria: (criteria != null ? criteria.value : this.criteria),
        clientData: (clientData != null ? clientData.value : this.clientData),
        surveyReferences: (surveyReferences != null
            ? surveyReferences.value
            : this.surveyReferences),
        schemaReferences: (schemaReferences != null
            ? schemaReferences.value
            : this.schemaReferences),
        configReferences: (configReferences != null
            ? configReferences.value
            : this.configReferences),
        fileReferences: (fileReferences != null
            ? fileReferences.value
            : this.fileReferences),
        assessmentReferences: (assessmentReferences != null
            ? assessmentReferences.value
            : this.assessmentReferences),
        configElements: (configElements != null
            ? configElements.value
            : this.configElements),
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AppConfigElement {
  AppConfigElement({
    required this.id,
    required this.revision,
    this.deleted,
    required this.data,
    this.createdOn,
    this.modifiedOn,
    this.version,
    this.type,
  });

  factory AppConfigElement.fromJson(Map<String, dynamic> json) =>
      _$AppConfigElementFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'revision', includeIfNull: false)
  final num revision;
  @JsonKey(name: 'deleted', includeIfNull: false)
  final bool? deleted;
  @JsonKey(name: 'data', includeIfNull: false)
  final Object data;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'modifiedOn', includeIfNull: false)
  final DateTime? modifiedOn;
  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AppConfigElementFromJson;
  static const toJsonFactory = _$AppConfigElementToJson;
  Map<String, dynamic> toJson() => _$AppConfigElementToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AppConfigElement &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.revision, revision) ||
                const DeepCollectionEquality()
                    .equals(other.revision, revision)) &&
            (identical(other.deleted, deleted) ||
                const DeepCollectionEquality()
                    .equals(other.deleted, deleted)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.modifiedOn, modifiedOn) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedOn, modifiedOn)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(revision) ^
      const DeepCollectionEquality().hash(deleted) ^
      const DeepCollectionEquality().hash(data) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(modifiedOn) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AppConfigElementExtension on AppConfigElement {
  AppConfigElement copyWith(
      {String? id,
      num? revision,
      bool? deleted,
      Object? data,
      DateTime? createdOn,
      DateTime? modifiedOn,
      num? version,
      String? type}) {
    return AppConfigElement(
        id: id ?? this.id,
        revision: revision ?? this.revision,
        deleted: deleted ?? this.deleted,
        data: data ?? this.data,
        createdOn: createdOn ?? this.createdOn,
        modifiedOn: modifiedOn ?? this.modifiedOn,
        version: version ?? this.version,
        type: type ?? this.type);
  }

  AppConfigElement copyWithWrapped(
      {Wrapped<String>? id,
      Wrapped<num>? revision,
      Wrapped<bool?>? deleted,
      Wrapped<Object>? data,
      Wrapped<DateTime?>? createdOn,
      Wrapped<DateTime?>? modifiedOn,
      Wrapped<num?>? version,
      Wrapped<String?>? type}) {
    return AppConfigElement(
        id: (id != null ? id.value : this.id),
        revision: (revision != null ? revision.value : this.revision),
        deleted: (deleted != null ? deleted.value : this.deleted),
        data: (data != null ? data.value : this.data),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        modifiedOn: (modifiedOn != null ? modifiedOn.value : this.modifiedOn),
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AppleAppLink {
  AppleAppLink({
    required this.appID,
    required this.paths,
    this.type,
  });

  factory AppleAppLink.fromJson(Map<String, dynamic> json) =>
      _$AppleAppLinkFromJson(json);

  @JsonKey(name: 'appID', includeIfNull: false, defaultValue: '')
  final String appID;
  @JsonKey(name: 'paths', includeIfNull: false, defaultValue: <String>[])
  final List<String> paths;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AppleAppLinkFromJson;
  static const toJsonFactory = _$AppleAppLinkToJson;
  Map<String, dynamic> toJson() => _$AppleAppLinkToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AppleAppLink &&
            (identical(other.appID, appID) ||
                const DeepCollectionEquality().equals(other.appID, appID)) &&
            (identical(other.paths, paths) ||
                const DeepCollectionEquality().equals(other.paths, paths)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(appID) ^
      const DeepCollectionEquality().hash(paths) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AppleAppLinkExtension on AppleAppLink {
  AppleAppLink copyWith({String? appID, List<String>? paths, String? type}) {
    return AppleAppLink(
        appID: appID ?? this.appID,
        paths: paths ?? this.paths,
        type: type ?? this.type);
  }

  AppleAppLink copyWithWrapped(
      {Wrapped<String>? appID,
      Wrapped<List<String>>? paths,
      Wrapped<String?>? type}) {
    return AppleAppLink(
        appID: (appID != null ? appID.value : this.appID),
        paths: (paths != null ? paths.value : this.paths),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Assessment {
  Assessment({
    this.guid,
    required this.identifier,
    required this.revision,
    required this.ownerId,
    required this.title,
    this.labels,
    this.colorScheme,
    this.summary,
    required this.osName,
    this.originGuid,
    this.validationStatus,
    this.normingStatus,
    this.minutesToComplete,
    this.tags,
    this.customizationFields,
    this.createdOn,
    this.modifiedOn,
    this.deleted,
    this.version,
    this.type,
  });

  factory Assessment.fromJson(Map<String, dynamic> json) =>
      _$AssessmentFromJson(json);

  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String? guid;
  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String identifier;
  @JsonKey(name: 'revision', includeIfNull: false)
  final num revision;
  @JsonKey(name: 'ownerId', includeIfNull: false, defaultValue: '')
  final String ownerId;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  @JsonKey(name: 'labels', includeIfNull: false, defaultValue: <Label>[])
  final List<Label>? labels;
  @JsonKey(name: 'colorScheme', includeIfNull: false)
  final ColorScheme? colorScheme;
  @JsonKey(name: 'summary', includeIfNull: false, defaultValue: '')
  final String? summary;
  @JsonKey(name: 'osName', includeIfNull: false, defaultValue: '')
  final String osName;
  @JsonKey(name: 'originGuid', includeIfNull: false, defaultValue: '')
  final String? originGuid;
  @JsonKey(name: 'validationStatus', includeIfNull: false, defaultValue: '')
  final String? validationStatus;
  @JsonKey(name: 'normingStatus', includeIfNull: false, defaultValue: '')
  final String? normingStatus;
  @JsonKey(name: 'minutesToComplete', includeIfNull: false)
  final int? minutesToComplete;
  @JsonKey(name: 'tags', includeIfNull: false, defaultValue: <String>[])
  final List<String>? tags;
  @JsonKey(name: 'customizationFields', includeIfNull: false)
  final Map<String, dynamic>? customizationFields;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'modifiedOn', includeIfNull: false)
  final DateTime? modifiedOn;
  @JsonKey(name: 'deleted', includeIfNull: false)
  final bool? deleted;
  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AssessmentFromJson;
  static const toJsonFactory = _$AssessmentToJson;
  Map<String, dynamic> toJson() => _$AssessmentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Assessment &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.revision, revision) ||
                const DeepCollectionEquality()
                    .equals(other.revision, revision)) &&
            (identical(other.ownerId, ownerId) ||
                const DeepCollectionEquality()
                    .equals(other.ownerId, ownerId)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.labels, labels) ||
                const DeepCollectionEquality().equals(other.labels, labels)) &&
            (identical(other.colorScheme, colorScheme) ||
                const DeepCollectionEquality()
                    .equals(other.colorScheme, colorScheme)) &&
            (identical(other.summary, summary) ||
                const DeepCollectionEquality()
                    .equals(other.summary, summary)) &&
            (identical(other.osName, osName) ||
                const DeepCollectionEquality().equals(other.osName, osName)) &&
            (identical(other.originGuid, originGuid) ||
                const DeepCollectionEquality()
                    .equals(other.originGuid, originGuid)) &&
            (identical(other.validationStatus, validationStatus) ||
                const DeepCollectionEquality()
                    .equals(other.validationStatus, validationStatus)) &&
            (identical(other.normingStatus, normingStatus) ||
                const DeepCollectionEquality()
                    .equals(other.normingStatus, normingStatus)) &&
            (identical(other.minutesToComplete, minutesToComplete) ||
                const DeepCollectionEquality()
                    .equals(other.minutesToComplete, minutesToComplete)) &&
            (identical(other.tags, tags) ||
                const DeepCollectionEquality().equals(other.tags, tags)) &&
            (identical(other.customizationFields, customizationFields) ||
                const DeepCollectionEquality()
                    .equals(other.customizationFields, customizationFields)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.modifiedOn, modifiedOn) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedOn, modifiedOn)) &&
            (identical(other.deleted, deleted) ||
                const DeepCollectionEquality()
                    .equals(other.deleted, deleted)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(revision) ^
      const DeepCollectionEquality().hash(ownerId) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(labels) ^
      const DeepCollectionEquality().hash(colorScheme) ^
      const DeepCollectionEquality().hash(summary) ^
      const DeepCollectionEquality().hash(osName) ^
      const DeepCollectionEquality().hash(originGuid) ^
      const DeepCollectionEquality().hash(validationStatus) ^
      const DeepCollectionEquality().hash(normingStatus) ^
      const DeepCollectionEquality().hash(minutesToComplete) ^
      const DeepCollectionEquality().hash(tags) ^
      const DeepCollectionEquality().hash(customizationFields) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(modifiedOn) ^
      const DeepCollectionEquality().hash(deleted) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AssessmentExtension on Assessment {
  Assessment copyWith(
      {String? guid,
      String? identifier,
      num? revision,
      String? ownerId,
      String? title,
      List<Label>? labels,
      ColorScheme? colorScheme,
      String? summary,
      String? osName,
      String? originGuid,
      String? validationStatus,
      String? normingStatus,
      int? minutesToComplete,
      List<String>? tags,
      Map<String, dynamic>? customizationFields,
      DateTime? createdOn,
      DateTime? modifiedOn,
      bool? deleted,
      num? version,
      String? type}) {
    return Assessment(
        guid: guid ?? this.guid,
        identifier: identifier ?? this.identifier,
        revision: revision ?? this.revision,
        ownerId: ownerId ?? this.ownerId,
        title: title ?? this.title,
        labels: labels ?? this.labels,
        colorScheme: colorScheme ?? this.colorScheme,
        summary: summary ?? this.summary,
        osName: osName ?? this.osName,
        originGuid: originGuid ?? this.originGuid,
        validationStatus: validationStatus ?? this.validationStatus,
        normingStatus: normingStatus ?? this.normingStatus,
        minutesToComplete: minutesToComplete ?? this.minutesToComplete,
        tags: tags ?? this.tags,
        customizationFields: customizationFields ?? this.customizationFields,
        createdOn: createdOn ?? this.createdOn,
        modifiedOn: modifiedOn ?? this.modifiedOn,
        deleted: deleted ?? this.deleted,
        version: version ?? this.version,
        type: type ?? this.type);
  }

  Assessment copyWithWrapped(
      {Wrapped<String?>? guid,
      Wrapped<String>? identifier,
      Wrapped<num>? revision,
      Wrapped<String>? ownerId,
      Wrapped<String>? title,
      Wrapped<List<Label>?>? labels,
      Wrapped<ColorScheme?>? colorScheme,
      Wrapped<String?>? summary,
      Wrapped<String>? osName,
      Wrapped<String?>? originGuid,
      Wrapped<String?>? validationStatus,
      Wrapped<String?>? normingStatus,
      Wrapped<int?>? minutesToComplete,
      Wrapped<List<String>?>? tags,
      Wrapped<Map<String, dynamic>?>? customizationFields,
      Wrapped<DateTime?>? createdOn,
      Wrapped<DateTime?>? modifiedOn,
      Wrapped<bool?>? deleted,
      Wrapped<num?>? version,
      Wrapped<String?>? type}) {
    return Assessment(
        guid: (guid != null ? guid.value : this.guid),
        identifier: (identifier != null ? identifier.value : this.identifier),
        revision: (revision != null ? revision.value : this.revision),
        ownerId: (ownerId != null ? ownerId.value : this.ownerId),
        title: (title != null ? title.value : this.title),
        labels: (labels != null ? labels.value : this.labels),
        colorScheme:
            (colorScheme != null ? colorScheme.value : this.colorScheme),
        summary: (summary != null ? summary.value : this.summary),
        osName: (osName != null ? osName.value : this.osName),
        originGuid: (originGuid != null ? originGuid.value : this.originGuid),
        validationStatus: (validationStatus != null
            ? validationStatus.value
            : this.validationStatus),
        normingStatus:
            (normingStatus != null ? normingStatus.value : this.normingStatus),
        minutesToComplete: (minutesToComplete != null
            ? minutesToComplete.value
            : this.minutesToComplete),
        tags: (tags != null ? tags.value : this.tags),
        customizationFields: (customizationFields != null
            ? customizationFields.value
            : this.customizationFields),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        modifiedOn: (modifiedOn != null ? modifiedOn.value : this.modifiedOn),
        deleted: (deleted != null ? deleted.value : this.deleted),
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AssessmentConfig {
  AssessmentConfig({
    required this.config,
    this.createdOn,
    this.modifiedOn,
    this.version,
    this.type,
  });

  factory AssessmentConfig.fromJson(Map<String, dynamic> json) =>
      _$AssessmentConfigFromJson(json);

  @JsonKey(name: 'config', includeIfNull: false)
  final Object config;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'modifiedOn', includeIfNull: false)
  final DateTime? modifiedOn;
  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AssessmentConfigFromJson;
  static const toJsonFactory = _$AssessmentConfigToJson;
  Map<String, dynamic> toJson() => _$AssessmentConfigToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AssessmentConfig &&
            (identical(other.config, config) ||
                const DeepCollectionEquality().equals(other.config, config)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.modifiedOn, modifiedOn) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedOn, modifiedOn)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(config) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(modifiedOn) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AssessmentConfigExtension on AssessmentConfig {
  AssessmentConfig copyWith(
      {Object? config,
      DateTime? createdOn,
      DateTime? modifiedOn,
      num? version,
      String? type}) {
    return AssessmentConfig(
        config: config ?? this.config,
        createdOn: createdOn ?? this.createdOn,
        modifiedOn: modifiedOn ?? this.modifiedOn,
        version: version ?? this.version,
        type: type ?? this.type);
  }

  AssessmentConfig copyWithWrapped(
      {Wrapped<Object>? config,
      Wrapped<DateTime?>? createdOn,
      Wrapped<DateTime?>? modifiedOn,
      Wrapped<num?>? version,
      Wrapped<String?>? type}) {
    return AssessmentConfig(
        config: (config != null ? config.value : this.config),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        modifiedOn: (modifiedOn != null ? modifiedOn.value : this.modifiedOn),
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AssessmentInfo {
  AssessmentInfo({
    this.key,
    this.guid,
    this.appId,
    this.identifier,
    this.revision,
    this.label,
    this.minutesToComplete,
    this.colorScheme,
    this.configUrl,
    this.type,
  });

  factory AssessmentInfo.fromJson(Map<String, dynamic> json) =>
      _$AssessmentInfoFromJson(json);

  @JsonKey(name: 'key', includeIfNull: false, defaultValue: '')
  final String? key;
  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String? guid;
  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String? appId;
  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String? identifier;
  @JsonKey(name: 'revision', includeIfNull: false)
  final int? revision;
  @JsonKey(name: 'label', includeIfNull: false, defaultValue: '')
  final String? label;
  @JsonKey(name: 'minutesToComplete', includeIfNull: false)
  final int? minutesToComplete;
  @JsonKey(name: 'colorScheme', includeIfNull: false)
  final ColorScheme? colorScheme;
  @JsonKey(name: 'configUrl', includeIfNull: false, defaultValue: '')
  final String? configUrl;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AssessmentInfoFromJson;
  static const toJsonFactory = _$AssessmentInfoToJson;
  Map<String, dynamic> toJson() => _$AssessmentInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AssessmentInfo &&
            (identical(other.key, key) ||
                const DeepCollectionEquality().equals(other.key, key)) &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)) &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.revision, revision) ||
                const DeepCollectionEquality()
                    .equals(other.revision, revision)) &&
            (identical(other.label, label) ||
                const DeepCollectionEquality().equals(other.label, label)) &&
            (identical(other.minutesToComplete, minutesToComplete) ||
                const DeepCollectionEquality()
                    .equals(other.minutesToComplete, minutesToComplete)) &&
            (identical(other.colorScheme, colorScheme) ||
                const DeepCollectionEquality()
                    .equals(other.colorScheme, colorScheme)) &&
            (identical(other.configUrl, configUrl) ||
                const DeepCollectionEquality()
                    .equals(other.configUrl, configUrl)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(key) ^
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(appId) ^
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(revision) ^
      const DeepCollectionEquality().hash(label) ^
      const DeepCollectionEquality().hash(minutesToComplete) ^
      const DeepCollectionEquality().hash(colorScheme) ^
      const DeepCollectionEquality().hash(configUrl) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AssessmentInfoExtension on AssessmentInfo {
  AssessmentInfo copyWith(
      {String? key,
      String? guid,
      String? appId,
      String? identifier,
      int? revision,
      String? label,
      int? minutesToComplete,
      ColorScheme? colorScheme,
      String? configUrl,
      String? type}) {
    return AssessmentInfo(
        key: key ?? this.key,
        guid: guid ?? this.guid,
        appId: appId ?? this.appId,
        identifier: identifier ?? this.identifier,
        revision: revision ?? this.revision,
        label: label ?? this.label,
        minutesToComplete: minutesToComplete ?? this.minutesToComplete,
        colorScheme: colorScheme ?? this.colorScheme,
        configUrl: configUrl ?? this.configUrl,
        type: type ?? this.type);
  }

  AssessmentInfo copyWithWrapped(
      {Wrapped<String?>? key,
      Wrapped<String?>? guid,
      Wrapped<String?>? appId,
      Wrapped<String?>? identifier,
      Wrapped<int?>? revision,
      Wrapped<String?>? label,
      Wrapped<int?>? minutesToComplete,
      Wrapped<ColorScheme?>? colorScheme,
      Wrapped<String?>? configUrl,
      Wrapped<String?>? type}) {
    return AssessmentInfo(
        key: (key != null ? key.value : this.key),
        guid: (guid != null ? guid.value : this.guid),
        appId: (appId != null ? appId.value : this.appId),
        identifier: (identifier != null ? identifier.value : this.identifier),
        revision: (revision != null ? revision.value : this.revision),
        label: (label != null ? label.value : this.label),
        minutesToComplete: (minutesToComplete != null
            ? minutesToComplete.value
            : this.minutesToComplete),
        colorScheme:
            (colorScheme != null ? colorScheme.value : this.colorScheme),
        configUrl: (configUrl != null ? configUrl.value : this.configUrl),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AssessmentReference {
  AssessmentReference({
    this.appId,
    required this.guid,
    this.id,
    this.originSharedId,
    this.configHref,
    this.type,
  });

  factory AssessmentReference.fromJson(Map<String, dynamic> json) =>
      _$AssessmentReferenceFromJson(json);

  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String? appId;
  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String guid;
  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'originSharedId', includeIfNull: false, defaultValue: '')
  final String? originSharedId;
  @JsonKey(name: 'configHref', includeIfNull: false, defaultValue: '')
  final String? configHref;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AssessmentReferenceFromJson;
  static const toJsonFactory = _$AssessmentReferenceToJson;
  Map<String, dynamic> toJson() => _$AssessmentReferenceToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AssessmentReference &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)) &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.originSharedId, originSharedId) ||
                const DeepCollectionEquality()
                    .equals(other.originSharedId, originSharedId)) &&
            (identical(other.configHref, configHref) ||
                const DeepCollectionEquality()
                    .equals(other.configHref, configHref)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(appId) ^
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(originSharedId) ^
      const DeepCollectionEquality().hash(configHref) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AssessmentReferenceExtension on AssessmentReference {
  AssessmentReference copyWith(
      {String? appId,
      String? guid,
      String? id,
      String? originSharedId,
      String? configHref,
      String? type}) {
    return AssessmentReference(
        appId: appId ?? this.appId,
        guid: guid ?? this.guid,
        id: id ?? this.id,
        originSharedId: originSharedId ?? this.originSharedId,
        configHref: configHref ?? this.configHref,
        type: type ?? this.type);
  }

  AssessmentReference copyWithWrapped(
      {Wrapped<String?>? appId,
      Wrapped<String>? guid,
      Wrapped<String?>? id,
      Wrapped<String?>? originSharedId,
      Wrapped<String?>? configHref,
      Wrapped<String?>? type}) {
    return AssessmentReference(
        appId: (appId != null ? appId.value : this.appId),
        guid: (guid != null ? guid.value : this.guid),
        id: (id != null ? id.value : this.id),
        originSharedId: (originSharedId != null
            ? originSharedId.value
            : this.originSharedId),
        configHref: (configHref != null ? configHref.value : this.configHref),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AssessmentReference2 {
  AssessmentReference2({
    required this.appId,
    required this.guid,
    this.title,
    this.identifier,
    this.revision,
    this.minutesToComplete,
    this.labels,
    this.colorScheme,
    this.type,
  });

  factory AssessmentReference2.fromJson(Map<String, dynamic> json) =>
      _$AssessmentReference2FromJson(json);

  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String appId;
  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String guid;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String? identifier;
  @JsonKey(name: 'revision', includeIfNull: false)
  final int? revision;
  @JsonKey(name: 'minutesToComplete', includeIfNull: false)
  final int? minutesToComplete;
  @JsonKey(name: 'labels', includeIfNull: false, defaultValue: <Label>[])
  final List<Label>? labels;
  @JsonKey(name: 'colorScheme', includeIfNull: false)
  final ColorScheme? colorScheme;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AssessmentReference2FromJson;
  static const toJsonFactory = _$AssessmentReference2ToJson;
  Map<String, dynamic> toJson() => _$AssessmentReference2ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AssessmentReference2 &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)) &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.revision, revision) ||
                const DeepCollectionEquality()
                    .equals(other.revision, revision)) &&
            (identical(other.minutesToComplete, minutesToComplete) ||
                const DeepCollectionEquality()
                    .equals(other.minutesToComplete, minutesToComplete)) &&
            (identical(other.labels, labels) ||
                const DeepCollectionEquality().equals(other.labels, labels)) &&
            (identical(other.colorScheme, colorScheme) ||
                const DeepCollectionEquality()
                    .equals(other.colorScheme, colorScheme)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(appId) ^
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(revision) ^
      const DeepCollectionEquality().hash(minutesToComplete) ^
      const DeepCollectionEquality().hash(labels) ^
      const DeepCollectionEquality().hash(colorScheme) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AssessmentReference2Extension on AssessmentReference2 {
  AssessmentReference2 copyWith(
      {String? appId,
      String? guid,
      String? title,
      String? identifier,
      int? revision,
      int? minutesToComplete,
      List<Label>? labels,
      ColorScheme? colorScheme,
      String? type}) {
    return AssessmentReference2(
        appId: appId ?? this.appId,
        guid: guid ?? this.guid,
        title: title ?? this.title,
        identifier: identifier ?? this.identifier,
        revision: revision ?? this.revision,
        minutesToComplete: minutesToComplete ?? this.minutesToComplete,
        labels: labels ?? this.labels,
        colorScheme: colorScheme ?? this.colorScheme,
        type: type ?? this.type);
  }

  AssessmentReference2 copyWithWrapped(
      {Wrapped<String>? appId,
      Wrapped<String>? guid,
      Wrapped<String?>? title,
      Wrapped<String?>? identifier,
      Wrapped<int?>? revision,
      Wrapped<int?>? minutesToComplete,
      Wrapped<List<Label>?>? labels,
      Wrapped<ColorScheme?>? colorScheme,
      Wrapped<String?>? type}) {
    return AssessmentReference2(
        appId: (appId != null ? appId.value : this.appId),
        guid: (guid != null ? guid.value : this.guid),
        title: (title != null ? title.value : this.title),
        identifier: (identifier != null ? identifier.value : this.identifier),
        revision: (revision != null ? revision.value : this.revision),
        minutesToComplete: (minutesToComplete != null
            ? minutesToComplete.value
            : this.minutesToComplete),
        labels: (labels != null ? labels.value : this.labels),
        colorScheme:
            (colorScheme != null ? colorScheme.value : this.colorScheme),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ClientInfo {
  ClientInfo({
    this.appName,
    this.appVersion,
    this.deviceName,
    this.osName,
    this.osVersion,
    this.sdkName,
    this.sdkVersion,
    this.type,
  });

  factory ClientInfo.fromJson(Map<String, dynamic> json) =>
      _$ClientInfoFromJson(json);

  @JsonKey(name: 'appName', includeIfNull: false, defaultValue: '')
  final String? appName;
  @JsonKey(name: 'appVersion', includeIfNull: false)
  final int? appVersion;
  @JsonKey(name: 'deviceName', includeIfNull: false, defaultValue: '')
  final String? deviceName;
  @JsonKey(name: 'osName', includeIfNull: false, defaultValue: '')
  final String? osName;
  @JsonKey(name: 'osVersion', includeIfNull: false, defaultValue: '')
  final String? osVersion;
  @JsonKey(name: 'sdkName', includeIfNull: false, defaultValue: '')
  final String? sdkName;
  @JsonKey(name: 'sdkVersion', includeIfNull: false)
  final int? sdkVersion;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ClientInfoFromJson;
  static const toJsonFactory = _$ClientInfoToJson;
  Map<String, dynamic> toJson() => _$ClientInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ClientInfo &&
            (identical(other.appName, appName) ||
                const DeepCollectionEquality()
                    .equals(other.appName, appName)) &&
            (identical(other.appVersion, appVersion) ||
                const DeepCollectionEquality()
                    .equals(other.appVersion, appVersion)) &&
            (identical(other.deviceName, deviceName) ||
                const DeepCollectionEquality()
                    .equals(other.deviceName, deviceName)) &&
            (identical(other.osName, osName) ||
                const DeepCollectionEquality().equals(other.osName, osName)) &&
            (identical(other.osVersion, osVersion) ||
                const DeepCollectionEquality()
                    .equals(other.osVersion, osVersion)) &&
            (identical(other.sdkName, sdkName) ||
                const DeepCollectionEquality()
                    .equals(other.sdkName, sdkName)) &&
            (identical(other.sdkVersion, sdkVersion) ||
                const DeepCollectionEquality()
                    .equals(other.sdkVersion, sdkVersion)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(appName) ^
      const DeepCollectionEquality().hash(appVersion) ^
      const DeepCollectionEquality().hash(deviceName) ^
      const DeepCollectionEquality().hash(osName) ^
      const DeepCollectionEquality().hash(osVersion) ^
      const DeepCollectionEquality().hash(sdkName) ^
      const DeepCollectionEquality().hash(sdkVersion) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ClientInfoExtension on ClientInfo {
  ClientInfo copyWith(
      {String? appName,
      int? appVersion,
      String? deviceName,
      String? osName,
      String? osVersion,
      String? sdkName,
      int? sdkVersion,
      String? type}) {
    return ClientInfo(
        appName: appName ?? this.appName,
        appVersion: appVersion ?? this.appVersion,
        deviceName: deviceName ?? this.deviceName,
        osName: osName ?? this.osName,
        osVersion: osVersion ?? this.osVersion,
        sdkName: sdkName ?? this.sdkName,
        sdkVersion: sdkVersion ?? this.sdkVersion,
        type: type ?? this.type);
  }

  ClientInfo copyWithWrapped(
      {Wrapped<String?>? appName,
      Wrapped<int?>? appVersion,
      Wrapped<String?>? deviceName,
      Wrapped<String?>? osName,
      Wrapped<String?>? osVersion,
      Wrapped<String?>? sdkName,
      Wrapped<int?>? sdkVersion,
      Wrapped<String?>? type}) {
    return ClientInfo(
        appName: (appName != null ? appName.value : this.appName),
        appVersion: (appVersion != null ? appVersion.value : this.appVersion),
        deviceName: (deviceName != null ? deviceName.value : this.deviceName),
        osName: (osName != null ? osName.value : this.osName),
        osVersion: (osVersion != null ? osVersion.value : this.osVersion),
        sdkName: (sdkName != null ? sdkName.value : this.sdkName),
        sdkVersion: (sdkVersion != null ? sdkVersion.value : this.sdkVersion),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class CmsPublicKey {
  CmsPublicKey({
    this.publicKey,
    this.type,
  });

  factory CmsPublicKey.fromJson(Map<String, dynamic> json) =>
      _$CmsPublicKeyFromJson(json);

  @JsonKey(name: 'publicKey', includeIfNull: false, defaultValue: '')
  final String? publicKey;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$CmsPublicKeyFromJson;
  static const toJsonFactory = _$CmsPublicKeyToJson;
  Map<String, dynamic> toJson() => _$CmsPublicKeyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CmsPublicKey &&
            (identical(other.publicKey, publicKey) ||
                const DeepCollectionEquality()
                    .equals(other.publicKey, publicKey)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(publicKey) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $CmsPublicKeyExtension on CmsPublicKey {
  CmsPublicKey copyWith({String? publicKey, String? type}) {
    return CmsPublicKey(
        publicKey: publicKey ?? this.publicKey, type: type ?? this.type);
  }

  CmsPublicKey copyWithWrapped(
      {Wrapped<String?>? publicKey, Wrapped<String?>? type}) {
    return CmsPublicKey(
        publicKey: (publicKey != null ? publicKey.value : this.publicKey),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ColorScheme {
  ColorScheme({
    this.foreground,
    this.background,
    this.activated,
    this.inactivated,
    this.type,
  });

  factory ColorScheme.fromJson(Map<String, dynamic> json) =>
      _$ColorSchemeFromJson(json);

  @JsonKey(name: 'foreground', includeIfNull: false, defaultValue: '')
  final String? foreground;
  @JsonKey(name: 'background', includeIfNull: false, defaultValue: '')
  final String? background;
  @JsonKey(name: 'activated', includeIfNull: false, defaultValue: '')
  final String? activated;
  @JsonKey(name: 'inactivated', includeIfNull: false, defaultValue: '')
  final String? inactivated;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ColorSchemeFromJson;
  static const toJsonFactory = _$ColorSchemeToJson;
  Map<String, dynamic> toJson() => _$ColorSchemeToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ColorScheme &&
            (identical(other.foreground, foreground) ||
                const DeepCollectionEquality()
                    .equals(other.foreground, foreground)) &&
            (identical(other.background, background) ||
                const DeepCollectionEquality()
                    .equals(other.background, background)) &&
            (identical(other.activated, activated) ||
                const DeepCollectionEquality()
                    .equals(other.activated, activated)) &&
            (identical(other.inactivated, inactivated) ||
                const DeepCollectionEquality()
                    .equals(other.inactivated, inactivated)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(foreground) ^
      const DeepCollectionEquality().hash(background) ^
      const DeepCollectionEquality().hash(activated) ^
      const DeepCollectionEquality().hash(inactivated) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ColorSchemeExtension on ColorScheme {
  ColorScheme copyWith(
      {String? foreground,
      String? background,
      String? activated,
      String? inactivated,
      String? type}) {
    return ColorScheme(
        foreground: foreground ?? this.foreground,
        background: background ?? this.background,
        activated: activated ?? this.activated,
        inactivated: inactivated ?? this.inactivated,
        type: type ?? this.type);
  }

  ColorScheme copyWithWrapped(
      {Wrapped<String?>? foreground,
      Wrapped<String?>? background,
      Wrapped<String?>? activated,
      Wrapped<String?>? inactivated,
      Wrapped<String?>? type}) {
    return ColorScheme(
        foreground: (foreground != null ? foreground.value : this.foreground),
        background: (background != null ? background.value : this.background),
        activated: (activated != null ? activated.value : this.activated),
        inactivated:
            (inactivated != null ? inactivated.value : this.inactivated),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class CompoundActivity {
  CompoundActivity({
    required this.schemaList,
    required this.surveyList,
    required this.taskIdentifier,
    this.type,
  });

  factory CompoundActivity.fromJson(Map<String, dynamic> json) =>
      _$CompoundActivityFromJson(json);

  @JsonKey(
      name: 'schemaList',
      includeIfNull: false,
      defaultValue: <SchemaReference>[])
  final List<SchemaReference> schemaList;
  @JsonKey(
      name: 'surveyList',
      includeIfNull: false,
      defaultValue: <SurveyReference>[])
  final List<SurveyReference> surveyList;
  @JsonKey(name: 'taskIdentifier', includeIfNull: false, defaultValue: '')
  final String taskIdentifier;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$CompoundActivityFromJson;
  static const toJsonFactory = _$CompoundActivityToJson;
  Map<String, dynamic> toJson() => _$CompoundActivityToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CompoundActivity &&
            (identical(other.schemaList, schemaList) ||
                const DeepCollectionEquality()
                    .equals(other.schemaList, schemaList)) &&
            (identical(other.surveyList, surveyList) ||
                const DeepCollectionEquality()
                    .equals(other.surveyList, surveyList)) &&
            (identical(other.taskIdentifier, taskIdentifier) ||
                const DeepCollectionEquality()
                    .equals(other.taskIdentifier, taskIdentifier)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(schemaList) ^
      const DeepCollectionEquality().hash(surveyList) ^
      const DeepCollectionEquality().hash(taskIdentifier) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $CompoundActivityExtension on CompoundActivity {
  CompoundActivity copyWith(
      {List<SchemaReference>? schemaList,
      List<SurveyReference>? surveyList,
      String? taskIdentifier,
      String? type}) {
    return CompoundActivity(
        schemaList: schemaList ?? this.schemaList,
        surveyList: surveyList ?? this.surveyList,
        taskIdentifier: taskIdentifier ?? this.taskIdentifier,
        type: type ?? this.type);
  }

  CompoundActivity copyWithWrapped(
      {Wrapped<List<SchemaReference>>? schemaList,
      Wrapped<List<SurveyReference>>? surveyList,
      Wrapped<String>? taskIdentifier,
      Wrapped<String?>? type}) {
    return CompoundActivity(
        schemaList: (schemaList != null ? schemaList.value : this.schemaList),
        surveyList: (surveyList != null ? surveyList.value : this.surveyList),
        taskIdentifier: (taskIdentifier != null
            ? taskIdentifier.value
            : this.taskIdentifier),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class CompoundActivityDefinition {
  CompoundActivityDefinition({
    required this.schemaList,
    required this.surveyList,
    required this.taskId,
    this.version,
    this.type,
  });

  factory CompoundActivityDefinition.fromJson(Map<String, dynamic> json) =>
      _$CompoundActivityDefinitionFromJson(json);

  @JsonKey(
      name: 'schemaList',
      includeIfNull: false,
      defaultValue: <SchemaReference>[])
  final List<SchemaReference> schemaList;
  @JsonKey(
      name: 'surveyList',
      includeIfNull: false,
      defaultValue: <SurveyReference>[])
  final List<SurveyReference> surveyList;
  @JsonKey(name: 'taskId', includeIfNull: false, defaultValue: '')
  final String taskId;
  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$CompoundActivityDefinitionFromJson;
  static const toJsonFactory = _$CompoundActivityDefinitionToJson;
  Map<String, dynamic> toJson() => _$CompoundActivityDefinitionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CompoundActivityDefinition &&
            (identical(other.schemaList, schemaList) ||
                const DeepCollectionEquality()
                    .equals(other.schemaList, schemaList)) &&
            (identical(other.surveyList, surveyList) ||
                const DeepCollectionEquality()
                    .equals(other.surveyList, surveyList)) &&
            (identical(other.taskId, taskId) ||
                const DeepCollectionEquality().equals(other.taskId, taskId)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(schemaList) ^
      const DeepCollectionEquality().hash(surveyList) ^
      const DeepCollectionEquality().hash(taskId) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $CompoundActivityDefinitionExtension on CompoundActivityDefinition {
  CompoundActivityDefinition copyWith(
      {List<SchemaReference>? schemaList,
      List<SurveyReference>? surveyList,
      String? taskId,
      num? version,
      String? type}) {
    return CompoundActivityDefinition(
        schemaList: schemaList ?? this.schemaList,
        surveyList: surveyList ?? this.surveyList,
        taskId: taskId ?? this.taskId,
        version: version ?? this.version,
        type: type ?? this.type);
  }

  CompoundActivityDefinition copyWithWrapped(
      {Wrapped<List<SchemaReference>>? schemaList,
      Wrapped<List<SurveyReference>>? surveyList,
      Wrapped<String>? taskId,
      Wrapped<num?>? version,
      Wrapped<String?>? type}) {
    return CompoundActivityDefinition(
        schemaList: (schemaList != null ? schemaList.value : this.schemaList),
        surveyList: (surveyList != null ? surveyList.value : this.surveyList),
        taskId: (taskId != null ? taskId.value : this.taskId),
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ConfigReference {
  ConfigReference({
    required this.id,
    required this.revision,
    this.type,
  });

  factory ConfigReference.fromJson(Map<String, dynamic> json) =>
      _$ConfigReferenceFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'revision', includeIfNull: false)
  final num revision;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ConfigReferenceFromJson;
  static const toJsonFactory = _$ConfigReferenceToJson;
  Map<String, dynamic> toJson() => _$ConfigReferenceToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ConfigReference &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.revision, revision) ||
                const DeepCollectionEquality()
                    .equals(other.revision, revision)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(revision) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ConfigReferenceExtension on ConfigReference {
  ConfigReference copyWith({String? id, num? revision, String? type}) {
    return ConfigReference(
        id: id ?? this.id,
        revision: revision ?? this.revision,
        type: type ?? this.type);
  }

  ConfigReference copyWithWrapped(
      {Wrapped<String>? id, Wrapped<num>? revision, Wrapped<String?>? type}) {
    return ConfigReference(
        id: (id != null ? id.value : this.id),
        revision: (revision != null ? revision.value : this.revision),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ConsentSignature {
  ConsentSignature({
    required this.name,
    this.birthdate,
    this.imageData,
    this.imageMimeType,
    this.signedOn,
    this.withdrewOn,
    required this.scope,
    this.type,
  });

  factory ConsentSignature.fromJson(Map<String, dynamic> json) =>
      _$ConsentSignatureFromJson(json);

  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'birthdate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? birthdate;
  @JsonKey(name: 'imageData', includeIfNull: false, defaultValue: '')
  final String? imageData;
  @JsonKey(name: 'imageMimeType', includeIfNull: false, defaultValue: '')
  final String? imageMimeType;
  @JsonKey(name: 'signedOn', includeIfNull: false)
  final DateTime? signedOn;
  @JsonKey(name: 'withdrewOn', includeIfNull: false)
  final DateTime? withdrewOn;
  @JsonKey(
    name: 'scope',
    includeIfNull: false,
    toJson: sharingScopeToJson,
    fromJson: sharingScopeFromJson,
  )
  final enums.SharingScope scope;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ConsentSignatureFromJson;
  static const toJsonFactory = _$ConsentSignatureToJson;
  Map<String, dynamic> toJson() => _$ConsentSignatureToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ConsentSignature &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.birthdate, birthdate) ||
                const DeepCollectionEquality()
                    .equals(other.birthdate, birthdate)) &&
            (identical(other.imageData, imageData) ||
                const DeepCollectionEquality()
                    .equals(other.imageData, imageData)) &&
            (identical(other.imageMimeType, imageMimeType) ||
                const DeepCollectionEquality()
                    .equals(other.imageMimeType, imageMimeType)) &&
            (identical(other.signedOn, signedOn) ||
                const DeepCollectionEquality()
                    .equals(other.signedOn, signedOn)) &&
            (identical(other.withdrewOn, withdrewOn) ||
                const DeepCollectionEquality()
                    .equals(other.withdrewOn, withdrewOn)) &&
            (identical(other.scope, scope) ||
                const DeepCollectionEquality().equals(other.scope, scope)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(birthdate) ^
      const DeepCollectionEquality().hash(imageData) ^
      const DeepCollectionEquality().hash(imageMimeType) ^
      const DeepCollectionEquality().hash(signedOn) ^
      const DeepCollectionEquality().hash(withdrewOn) ^
      const DeepCollectionEquality().hash(scope) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ConsentSignatureExtension on ConsentSignature {
  ConsentSignature copyWith(
      {String? name,
      DateTime? birthdate,
      String? imageData,
      String? imageMimeType,
      DateTime? signedOn,
      DateTime? withdrewOn,
      enums.SharingScope? scope,
      String? type}) {
    return ConsentSignature(
        name: name ?? this.name,
        birthdate: birthdate ?? this.birthdate,
        imageData: imageData ?? this.imageData,
        imageMimeType: imageMimeType ?? this.imageMimeType,
        signedOn: signedOn ?? this.signedOn,
        withdrewOn: withdrewOn ?? this.withdrewOn,
        scope: scope ?? this.scope,
        type: type ?? this.type);
  }

  ConsentSignature copyWithWrapped(
      {Wrapped<String>? name,
      Wrapped<DateTime?>? birthdate,
      Wrapped<String?>? imageData,
      Wrapped<String?>? imageMimeType,
      Wrapped<DateTime?>? signedOn,
      Wrapped<DateTime?>? withdrewOn,
      Wrapped<enums.SharingScope>? scope,
      Wrapped<String?>? type}) {
    return ConsentSignature(
        name: (name != null ? name.value : this.name),
        birthdate: (birthdate != null ? birthdate.value : this.birthdate),
        imageData: (imageData != null ? imageData.value : this.imageData),
        imageMimeType:
            (imageMimeType != null ? imageMimeType.value : this.imageMimeType),
        signedOn: (signedOn != null ? signedOn.value : this.signedOn),
        withdrewOn: (withdrewOn != null ? withdrewOn.value : this.withdrewOn),
        scope: (scope != null ? scope.value : this.scope),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ConsentStatus {
  ConsentStatus({
    this.name,
    this.subpopulationGuid,
    this.required,
    this.signedOn,
    this.consented,
    this.signedMostRecentConsent,
    this.type,
  });

  factory ConsentStatus.fromJson(Map<String, dynamic> json) =>
      _$ConsentStatusFromJson(json);

  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'subpopulationGuid', includeIfNull: false, defaultValue: '')
  final String? subpopulationGuid;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool? required;
  @JsonKey(name: 'signedOn', includeIfNull: false)
  final DateTime? signedOn;
  @JsonKey(name: 'consented', includeIfNull: false)
  final bool? consented;
  @JsonKey(name: 'signedMostRecentConsent', includeIfNull: false)
  final bool? signedMostRecentConsent;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ConsentStatusFromJson;
  static const toJsonFactory = _$ConsentStatusToJson;
  Map<String, dynamic> toJson() => _$ConsentStatusToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ConsentStatus &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.subpopulationGuid, subpopulationGuid) ||
                const DeepCollectionEquality()
                    .equals(other.subpopulationGuid, subpopulationGuid)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.signedOn, signedOn) ||
                const DeepCollectionEquality()
                    .equals(other.signedOn, signedOn)) &&
            (identical(other.consented, consented) ||
                const DeepCollectionEquality()
                    .equals(other.consented, consented)) &&
            (identical(
                    other.signedMostRecentConsent, signedMostRecentConsent) ||
                const DeepCollectionEquality().equals(
                    other.signedMostRecentConsent, signedMostRecentConsent)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(subpopulationGuid) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(signedOn) ^
      const DeepCollectionEquality().hash(consented) ^
      const DeepCollectionEquality().hash(signedMostRecentConsent) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ConsentStatusExtension on ConsentStatus {
  ConsentStatus copyWith(
      {String? name,
      String? subpopulationGuid,
      bool? required,
      DateTime? signedOn,
      bool? consented,
      bool? signedMostRecentConsent,
      String? type}) {
    return ConsentStatus(
        name: name ?? this.name,
        subpopulationGuid: subpopulationGuid ?? this.subpopulationGuid,
        required: required ?? this.required,
        signedOn: signedOn ?? this.signedOn,
        consented: consented ?? this.consented,
        signedMostRecentConsent:
            signedMostRecentConsent ?? this.signedMostRecentConsent,
        type: type ?? this.type);
  }

  ConsentStatus copyWithWrapped(
      {Wrapped<String?>? name,
      Wrapped<String?>? subpopulationGuid,
      Wrapped<bool?>? required,
      Wrapped<DateTime?>? signedOn,
      Wrapped<bool?>? consented,
      Wrapped<bool?>? signedMostRecentConsent,
      Wrapped<String?>? type}) {
    return ConsentStatus(
        name: (name != null ? name.value : this.name),
        subpopulationGuid: (subpopulationGuid != null
            ? subpopulationGuid.value
            : this.subpopulationGuid),
        required: (required != null ? required.value : this.required),
        signedOn: (signedOn != null ? signedOn.value : this.signedOn),
        consented: (consented != null ? consented.value : this.consented),
        signedMostRecentConsent: (signedMostRecentConsent != null
            ? signedMostRecentConsent.value
            : this.signedMostRecentConsent),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Contact {
  Contact({
    required this.role,
    required this.name,
    this.position,
    this.affiliation,
    this.address,
    this.email,
    this.phone,
    this.jurisdiction,
    this.type,
  });

  factory Contact.fromJson(Map<String, dynamic> json) =>
      _$ContactFromJson(json);

  @JsonKey(
    name: 'role',
    includeIfNull: false,
    toJson: contactRoleToJson,
    fromJson: contactRoleFromJson,
  )
  final enums.ContactRole role;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'position', includeIfNull: false, defaultValue: '')
  final String? position;
  @JsonKey(name: 'affiliation', includeIfNull: false, defaultValue: '')
  final String? affiliation;
  @JsonKey(name: 'address', includeIfNull: false)
  final Address? address;
  @JsonKey(name: 'email', includeIfNull: false, defaultValue: '')
  final String? email;
  @JsonKey(name: 'phone', includeIfNull: false)
  final Phone? phone;
  @JsonKey(name: 'jurisdiction', includeIfNull: false, defaultValue: '')
  final String? jurisdiction;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ContactFromJson;
  static const toJsonFactory = _$ContactToJson;
  Map<String, dynamic> toJson() => _$ContactToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Contact &&
            (identical(other.role, role) ||
                const DeepCollectionEquality().equals(other.role, role)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.position, position) ||
                const DeepCollectionEquality()
                    .equals(other.position, position)) &&
            (identical(other.affiliation, affiliation) ||
                const DeepCollectionEquality()
                    .equals(other.affiliation, affiliation)) &&
            (identical(other.address, address) ||
                const DeepCollectionEquality()
                    .equals(other.address, address)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.jurisdiction, jurisdiction) ||
                const DeepCollectionEquality()
                    .equals(other.jurisdiction, jurisdiction)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(role) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(position) ^
      const DeepCollectionEquality().hash(affiliation) ^
      const DeepCollectionEquality().hash(address) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(phone) ^
      const DeepCollectionEquality().hash(jurisdiction) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ContactExtension on Contact {
  Contact copyWith(
      {enums.ContactRole? role,
      String? name,
      String? position,
      String? affiliation,
      Address? address,
      String? email,
      Phone? phone,
      String? jurisdiction,
      String? type}) {
    return Contact(
        role: role ?? this.role,
        name: name ?? this.name,
        position: position ?? this.position,
        affiliation: affiliation ?? this.affiliation,
        address: address ?? this.address,
        email: email ?? this.email,
        phone: phone ?? this.phone,
        jurisdiction: jurisdiction ?? this.jurisdiction,
        type: type ?? this.type);
  }

  Contact copyWithWrapped(
      {Wrapped<enums.ContactRole>? role,
      Wrapped<String>? name,
      Wrapped<String?>? position,
      Wrapped<String?>? affiliation,
      Wrapped<Address?>? address,
      Wrapped<String?>? email,
      Wrapped<Phone?>? phone,
      Wrapped<String?>? jurisdiction,
      Wrapped<String?>? type}) {
    return Contact(
        role: (role != null ? role.value : this.role),
        name: (name != null ? name.value : this.name),
        position: (position != null ? position.value : this.position),
        affiliation:
            (affiliation != null ? affiliation.value : this.affiliation),
        address: (address != null ? address.value : this.address),
        email: (email != null ? email.value : this.email),
        phone: (phone != null ? phone.value : this.phone),
        jurisdiction:
            (jurisdiction != null ? jurisdiction.value : this.jurisdiction),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class CreatedOnHolder {
  CreatedOnHolder({
    this.createdOn,
    this.type,
  });

  factory CreatedOnHolder.fromJson(Map<String, dynamic> json) =>
      _$CreatedOnHolderFromJson(json);

  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$CreatedOnHolderFromJson;
  static const toJsonFactory = _$CreatedOnHolderToJson;
  Map<String, dynamic> toJson() => _$CreatedOnHolderToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CreatedOnHolder &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $CreatedOnHolderExtension on CreatedOnHolder {
  CreatedOnHolder copyWith({DateTime? createdOn, String? type}) {
    return CreatedOnHolder(
        createdOn: createdOn ?? this.createdOn, type: type ?? this.type);
  }

  CreatedOnHolder copyWithWrapped(
      {Wrapped<DateTime?>? createdOn, Wrapped<String?>? type}) {
    return CreatedOnHolder(
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Criteria {
  Criteria({
    this.language,
    this.allOfGroups,
    this.noneOfGroups,
    this.allOfStudyIds,
    this.noneOfStudyIds,
    this.minAppVersions,
    this.maxAppVersions,
    this.type,
  });

  factory Criteria.fromJson(Map<String, dynamic> json) =>
      _$CriteriaFromJson(json);

  @JsonKey(name: 'language', includeIfNull: false, defaultValue: '')
  final String? language;
  @JsonKey(name: 'allOfGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String>? allOfGroups;
  @JsonKey(name: 'noneOfGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String>? noneOfGroups;
  @JsonKey(
      name: 'allOfStudyIds', includeIfNull: false, defaultValue: <String>[])
  final List<String>? allOfStudyIds;
  @JsonKey(
      name: 'noneOfStudyIds', includeIfNull: false, defaultValue: <String>[])
  final List<String>? noneOfStudyIds;
  @JsonKey(name: 'minAppVersions', includeIfNull: false)
  final Map<String, dynamic>? minAppVersions;
  @JsonKey(name: 'maxAppVersions', includeIfNull: false)
  final Map<String, dynamic>? maxAppVersions;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$CriteriaFromJson;
  static const toJsonFactory = _$CriteriaToJson;
  Map<String, dynamic> toJson() => _$CriteriaToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Criteria &&
            (identical(other.language, language) ||
                const DeepCollectionEquality()
                    .equals(other.language, language)) &&
            (identical(other.allOfGroups, allOfGroups) ||
                const DeepCollectionEquality()
                    .equals(other.allOfGroups, allOfGroups)) &&
            (identical(other.noneOfGroups, noneOfGroups) ||
                const DeepCollectionEquality()
                    .equals(other.noneOfGroups, noneOfGroups)) &&
            (identical(other.allOfStudyIds, allOfStudyIds) ||
                const DeepCollectionEquality()
                    .equals(other.allOfStudyIds, allOfStudyIds)) &&
            (identical(other.noneOfStudyIds, noneOfStudyIds) ||
                const DeepCollectionEquality()
                    .equals(other.noneOfStudyIds, noneOfStudyIds)) &&
            (identical(other.minAppVersions, minAppVersions) ||
                const DeepCollectionEquality()
                    .equals(other.minAppVersions, minAppVersions)) &&
            (identical(other.maxAppVersions, maxAppVersions) ||
                const DeepCollectionEquality()
                    .equals(other.maxAppVersions, maxAppVersions)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(language) ^
      const DeepCollectionEquality().hash(allOfGroups) ^
      const DeepCollectionEquality().hash(noneOfGroups) ^
      const DeepCollectionEquality().hash(allOfStudyIds) ^
      const DeepCollectionEquality().hash(noneOfStudyIds) ^
      const DeepCollectionEquality().hash(minAppVersions) ^
      const DeepCollectionEquality().hash(maxAppVersions) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $CriteriaExtension on Criteria {
  Criteria copyWith(
      {String? language,
      List<String>? allOfGroups,
      List<String>? noneOfGroups,
      List<String>? allOfStudyIds,
      List<String>? noneOfStudyIds,
      Map<String, dynamic>? minAppVersions,
      Map<String, dynamic>? maxAppVersions,
      String? type}) {
    return Criteria(
        language: language ?? this.language,
        allOfGroups: allOfGroups ?? this.allOfGroups,
        noneOfGroups: noneOfGroups ?? this.noneOfGroups,
        allOfStudyIds: allOfStudyIds ?? this.allOfStudyIds,
        noneOfStudyIds: noneOfStudyIds ?? this.noneOfStudyIds,
        minAppVersions: minAppVersions ?? this.minAppVersions,
        maxAppVersions: maxAppVersions ?? this.maxAppVersions,
        type: type ?? this.type);
  }

  Criteria copyWithWrapped(
      {Wrapped<String?>? language,
      Wrapped<List<String>?>? allOfGroups,
      Wrapped<List<String>?>? noneOfGroups,
      Wrapped<List<String>?>? allOfStudyIds,
      Wrapped<List<String>?>? noneOfStudyIds,
      Wrapped<Map<String, dynamic>?>? minAppVersions,
      Wrapped<Map<String, dynamic>?>? maxAppVersions,
      Wrapped<String?>? type}) {
    return Criteria(
        language: (language != null ? language.value : this.language),
        allOfGroups:
            (allOfGroups != null ? allOfGroups.value : this.allOfGroups),
        noneOfGroups:
            (noneOfGroups != null ? noneOfGroups.value : this.noneOfGroups),
        allOfStudyIds:
            (allOfStudyIds != null ? allOfStudyIds.value : this.allOfStudyIds),
        noneOfStudyIds: (noneOfStudyIds != null
            ? noneOfStudyIds.value
            : this.noneOfStudyIds),
        minAppVersions: (minAppVersions != null
            ? minAppVersions.value
            : this.minAppVersions),
        maxAppVersions: (maxAppVersions != null
            ? maxAppVersions.value
            : this.maxAppVersions),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class CriteriaScheduleStrategy {
  CriteriaScheduleStrategy({
    required this.scheduleCriteria,
    this.type,
  });

  factory CriteriaScheduleStrategy.fromJson(Map<String, dynamic> json) =>
      _$CriteriaScheduleStrategyFromJson(json);

  @JsonKey(
      name: 'scheduleCriteria',
      includeIfNull: false,
      defaultValue: <ScheduleCriteria>[])
  final List<ScheduleCriteria> scheduleCriteria;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$CriteriaScheduleStrategyFromJson;
  static const toJsonFactory = _$CriteriaScheduleStrategyToJson;
  Map<String, dynamic> toJson() => _$CriteriaScheduleStrategyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CriteriaScheduleStrategy &&
            (identical(other.scheduleCriteria, scheduleCriteria) ||
                const DeepCollectionEquality()
                    .equals(other.scheduleCriteria, scheduleCriteria)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(scheduleCriteria) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $CriteriaScheduleStrategyExtension on CriteriaScheduleStrategy {
  CriteriaScheduleStrategy copyWith(
      {List<ScheduleCriteria>? scheduleCriteria, String? type}) {
    return CriteriaScheduleStrategy(
        scheduleCriteria: scheduleCriteria ?? this.scheduleCriteria,
        type: type ?? this.type);
  }

  CriteriaScheduleStrategy copyWithWrapped(
      {Wrapped<List<ScheduleCriteria>>? scheduleCriteria,
      Wrapped<String?>? type}) {
    return CriteriaScheduleStrategy(
        scheduleCriteria: (scheduleCriteria != null
            ? scheduleCriteria.value
            : this.scheduleCriteria),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class CustomActivityEventRequest {
  CustomActivityEventRequest({
    required this.eventId,
    required this.timestamp,
    this.type,
  });

  factory CustomActivityEventRequest.fromJson(Map<String, dynamic> json) =>
      _$CustomActivityEventRequestFromJson(json);

  @JsonKey(name: 'eventId', includeIfNull: false, defaultValue: '')
  final String eventId;
  @JsonKey(name: 'timestamp', includeIfNull: false)
  final DateTime timestamp;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$CustomActivityEventRequestFromJson;
  static const toJsonFactory = _$CustomActivityEventRequestToJson;
  Map<String, dynamic> toJson() => _$CustomActivityEventRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CustomActivityEventRequest &&
            (identical(other.eventId, eventId) ||
                const DeepCollectionEquality()
                    .equals(other.eventId, eventId)) &&
            (identical(other.timestamp, timestamp) ||
                const DeepCollectionEquality()
                    .equals(other.timestamp, timestamp)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(eventId) ^
      const DeepCollectionEquality().hash(timestamp) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $CustomActivityEventRequestExtension on CustomActivityEventRequest {
  CustomActivityEventRequest copyWith(
      {String? eventId, DateTime? timestamp, String? type}) {
    return CustomActivityEventRequest(
        eventId: eventId ?? this.eventId,
        timestamp: timestamp ?? this.timestamp,
        type: type ?? this.type);
  }

  CustomActivityEventRequest copyWithWrapped(
      {Wrapped<String>? eventId,
      Wrapped<DateTime>? timestamp,
      Wrapped<String?>? type}) {
    return CustomActivityEventRequest(
        eventId: (eventId != null ? eventId.value : this.eventId),
        timestamp: (timestamp != null ? timestamp.value : this.timestamp),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class CustomEvent {
  CustomEvent({
    required this.eventId,
    required this.updateType,
    this.type,
  });

  factory CustomEvent.fromJson(Map<String, dynamic> json) =>
      _$CustomEventFromJson(json);

  @JsonKey(name: 'eventId', includeIfNull: false, defaultValue: '')
  final String eventId;
  @JsonKey(
    name: 'updateType',
    includeIfNull: false,
    toJson: activityEventUpdateTypeToJson,
    fromJson: activityEventUpdateTypeFromJson,
  )
  final enums.ActivityEventUpdateType updateType;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$CustomEventFromJson;
  static const toJsonFactory = _$CustomEventToJson;
  Map<String, dynamic> toJson() => _$CustomEventToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CustomEvent &&
            (identical(other.eventId, eventId) ||
                const DeepCollectionEquality()
                    .equals(other.eventId, eventId)) &&
            (identical(other.updateType, updateType) ||
                const DeepCollectionEquality()
                    .equals(other.updateType, updateType)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(eventId) ^
      const DeepCollectionEquality().hash(updateType) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $CustomEventExtension on CustomEvent {
  CustomEvent copyWith(
      {String? eventId,
      enums.ActivityEventUpdateType? updateType,
      String? type}) {
    return CustomEvent(
        eventId: eventId ?? this.eventId,
        updateType: updateType ?? this.updateType,
        type: type ?? this.type);
  }

  CustomEvent copyWithWrapped(
      {Wrapped<String>? eventId,
      Wrapped<enums.ActivityEventUpdateType>? updateType,
      Wrapped<String?>? type}) {
    return CustomEvent(
        eventId: (eventId != null ? eventId.value : this.eventId),
        updateType: (updateType != null ? updateType.value : this.updateType),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class DataGroups {
  DataGroups({
    required this.dataGroups,
    this.type,
  });

  factory DataGroups.fromJson(Map<String, dynamic> json) =>
      _$DataGroupsFromJson(json);

  @JsonKey(name: 'dataGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String> dataGroups;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$DataGroupsFromJson;
  static const toJsonFactory = _$DataGroupsToJson;
  Map<String, dynamic> toJson() => _$DataGroupsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DataGroups &&
            (identical(other.dataGroups, dataGroups) ||
                const DeepCollectionEquality()
                    .equals(other.dataGroups, dataGroups)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(dataGroups) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $DataGroupsExtension on DataGroups {
  DataGroups copyWith({List<String>? dataGroups, String? type}) {
    return DataGroups(
        dataGroups: dataGroups ?? this.dataGroups, type: type ?? this.type);
  }

  DataGroups copyWithWrapped(
      {Wrapped<List<String>>? dataGroups, Wrapped<String?>? type}) {
    return DataGroups(
        dataGroups: (dataGroups != null ? dataGroups.value : this.dataGroups),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class DateRange {
  DateRange({
    this.startDate,
    this.endDate,
  });

  factory DateRange.fromJson(Map<String, dynamic> json) =>
      _$DateRangeFromJson(json);

  @JsonKey(name: 'startDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? startDate;
  @JsonKey(name: 'endDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? endDate;
  static const fromJsonFactory = _$DateRangeFromJson;
  static const toJsonFactory = _$DateRangeToJson;
  Map<String, dynamic> toJson() => _$DateRangeToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DateRange &&
            (identical(other.startDate, startDate) ||
                const DeepCollectionEquality()
                    .equals(other.startDate, startDate)) &&
            (identical(other.endDate, endDate) ||
                const DeepCollectionEquality().equals(other.endDate, endDate)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(startDate) ^
      const DeepCollectionEquality().hash(endDate) ^
      runtimeType.hashCode;
}

extension $DateRangeExtension on DateRange {
  DateRange copyWith({DateTime? startDate, DateTime? endDate}) {
    return DateRange(
        startDate: startDate ?? this.startDate,
        endDate: endDate ?? this.endDate);
  }

  DateRange copyWithWrapped(
      {Wrapped<DateTime?>? startDate, Wrapped<DateTime?>? endDate}) {
    return DateRange(
        startDate: (startDate != null ? startDate.value : this.startDate),
        endDate: (endDate != null ? endDate.value : this.endDate));
  }
}

@JsonSerializable(explicitToJson: true)
class DayRange {
  DayRange({
    this.min,
    this.max,
    this.type,
  });

  factory DayRange.fromJson(Map<String, dynamic> json) =>
      _$DayRangeFromJson(json);

  @JsonKey(name: 'min', includeIfNull: false)
  final int? min;
  @JsonKey(name: 'max', includeIfNull: false)
  final int? max;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$DayRangeFromJson;
  static const toJsonFactory = _$DayRangeToJson;
  Map<String, dynamic> toJson() => _$DayRangeToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DayRange &&
            (identical(other.min, min) ||
                const DeepCollectionEquality().equals(other.min, min)) &&
            (identical(other.max, max) ||
                const DeepCollectionEquality().equals(other.max, max)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(min) ^
      const DeepCollectionEquality().hash(max) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $DayRangeExtension on DayRange {
  DayRange copyWith({int? min, int? max, String? type}) {
    return DayRange(
        min: min ?? this.min, max: max ?? this.max, type: type ?? this.type);
  }

  DayRange copyWithWrapped(
      {Wrapped<int?>? min, Wrapped<int?>? max, Wrapped<String?>? type}) {
    return DayRange(
        min: (min != null ? min.value : this.min),
        max: (max != null ? max.value : this.max),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class EmailSignIn {
  EmailSignIn({
    required this.appId,
    required this.email,
    required this.token,
    this.type,
  });

  factory EmailSignIn.fromJson(Map<String, dynamic> json) =>
      _$EmailSignInFromJson(json);

  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String appId;
  @JsonKey(name: 'email', includeIfNull: false, defaultValue: '')
  final String email;
  @JsonKey(name: 'token', includeIfNull: false, defaultValue: '')
  final String token;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$EmailSignInFromJson;
  static const toJsonFactory = _$EmailSignInToJson;
  Map<String, dynamic> toJson() => _$EmailSignInToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EmailSignIn &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.token, token) ||
                const DeepCollectionEquality().equals(other.token, token)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(appId) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(token) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $EmailSignInExtension on EmailSignIn {
  EmailSignIn copyWith(
      {String? appId, String? email, String? token, String? type}) {
    return EmailSignIn(
        appId: appId ?? this.appId,
        email: email ?? this.email,
        token: token ?? this.token,
        type: type ?? this.type);
  }

  EmailSignIn copyWithWrapped(
      {Wrapped<String>? appId,
      Wrapped<String>? email,
      Wrapped<String>? token,
      Wrapped<String?>? type}) {
    return EmailSignIn(
        appId: (appId != null ? appId.value : this.appId),
        email: (email != null ? email.value : this.email),
        token: (token != null ? token.value : this.token),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class EmailSignInRequest {
  EmailSignInRequest({
    required this.appId,
    required this.email,
    this.type,
  });

  factory EmailSignInRequest.fromJson(Map<String, dynamic> json) =>
      _$EmailSignInRequestFromJson(json);

  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String appId;
  @JsonKey(name: 'email', includeIfNull: false, defaultValue: '')
  final String email;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$EmailSignInRequestFromJson;
  static const toJsonFactory = _$EmailSignInRequestToJson;
  Map<String, dynamic> toJson() => _$EmailSignInRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EmailSignInRequest &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(appId) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $EmailSignInRequestExtension on EmailSignInRequest {
  EmailSignInRequest copyWith({String? appId, String? email, String? type}) {
    return EmailSignInRequest(
        appId: appId ?? this.appId,
        email: email ?? this.email,
        type: type ?? this.type);
  }

  EmailSignInRequest copyWithWrapped(
      {Wrapped<String>? appId,
      Wrapped<String>? email,
      Wrapped<String?>? type}) {
    return EmailSignInRequest(
        appId: (appId != null ? appId.value : this.appId),
        email: (email != null ? email.value : this.email),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class EmailVerificationStatus {
  EmailVerificationStatus({
    this.status,
    this.type,
  });

  factory EmailVerificationStatus.fromJson(Map<String, dynamic> json) =>
      _$EmailVerificationStatusFromJson(json);

  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: accountStatusToJson,
    fromJson: accountStatusFromJson,
  )
  final enums.AccountStatus? status;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$EmailVerificationStatusFromJson;
  static const toJsonFactory = _$EmailVerificationStatusToJson;
  Map<String, dynamic> toJson() => _$EmailVerificationStatusToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EmailVerificationStatus &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $EmailVerificationStatusExtension on EmailVerificationStatus {
  EmailVerificationStatus copyWith(
      {enums.AccountStatus? status, String? type}) {
    return EmailVerificationStatus(
        status: status ?? this.status, type: type ?? this.type);
  }

  EmailVerificationStatus copyWithWrapped(
      {Wrapped<enums.AccountStatus?>? status, Wrapped<String?>? type}) {
    return EmailVerificationStatus(
        status: (status != null ? status.value : this.status),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Enrollment {
  Enrollment({
    this.externalId,
    required this.userId,
    this.consentRequired,
    this.enrolledOn,
    this.enrolledBy,
    this.withdrawnOn,
    this.withdrawnBy,
    this.withdrawalNote,
    this.note,
    this.type,
  });

  factory Enrollment.fromJson(Map<String, dynamic> json) =>
      _$EnrollmentFromJson(json);

  @JsonKey(name: 'externalId', includeIfNull: false, defaultValue: '')
  final String? externalId;
  @JsonKey(name: 'userId', includeIfNull: false, defaultValue: '')
  final String userId;
  @JsonKey(name: 'consentRequired', includeIfNull: false, defaultValue: false)
  final bool? consentRequired;
  @JsonKey(name: 'enrolledOn', includeIfNull: false)
  final DateTime? enrolledOn;
  @JsonKey(name: 'enrolledBy', includeIfNull: false, defaultValue: '')
  final String? enrolledBy;
  @JsonKey(name: 'withdrawnOn', includeIfNull: false)
  final DateTime? withdrawnOn;
  @JsonKey(name: 'withdrawnBy', includeIfNull: false, defaultValue: '')
  final String? withdrawnBy;
  @JsonKey(name: 'withdrawalNote', includeIfNull: false, defaultValue: '')
  final String? withdrawalNote;
  @JsonKey(name: 'note', includeIfNull: false, defaultValue: '')
  final String? note;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$EnrollmentFromJson;
  static const toJsonFactory = _$EnrollmentToJson;
  Map<String, dynamic> toJson() => _$EnrollmentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Enrollment &&
            (identical(other.externalId, externalId) ||
                const DeepCollectionEquality()
                    .equals(other.externalId, externalId)) &&
            (identical(other.userId, userId) ||
                const DeepCollectionEquality().equals(other.userId, userId)) &&
            (identical(other.consentRequired, consentRequired) ||
                const DeepCollectionEquality()
                    .equals(other.consentRequired, consentRequired)) &&
            (identical(other.enrolledOn, enrolledOn) ||
                const DeepCollectionEquality()
                    .equals(other.enrolledOn, enrolledOn)) &&
            (identical(other.enrolledBy, enrolledBy) ||
                const DeepCollectionEquality()
                    .equals(other.enrolledBy, enrolledBy)) &&
            (identical(other.withdrawnOn, withdrawnOn) ||
                const DeepCollectionEquality()
                    .equals(other.withdrawnOn, withdrawnOn)) &&
            (identical(other.withdrawnBy, withdrawnBy) ||
                const DeepCollectionEquality()
                    .equals(other.withdrawnBy, withdrawnBy)) &&
            (identical(other.withdrawalNote, withdrawalNote) ||
                const DeepCollectionEquality()
                    .equals(other.withdrawalNote, withdrawalNote)) &&
            (identical(other.note, note) ||
                const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(externalId) ^
      const DeepCollectionEquality().hash(userId) ^
      const DeepCollectionEquality().hash(consentRequired) ^
      const DeepCollectionEquality().hash(enrolledOn) ^
      const DeepCollectionEquality().hash(enrolledBy) ^
      const DeepCollectionEquality().hash(withdrawnOn) ^
      const DeepCollectionEquality().hash(withdrawnBy) ^
      const DeepCollectionEquality().hash(withdrawalNote) ^
      const DeepCollectionEquality().hash(note) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $EnrollmentExtension on Enrollment {
  Enrollment copyWith(
      {String? externalId,
      String? userId,
      bool? consentRequired,
      DateTime? enrolledOn,
      String? enrolledBy,
      DateTime? withdrawnOn,
      String? withdrawnBy,
      String? withdrawalNote,
      String? note,
      String? type}) {
    return Enrollment(
        externalId: externalId ?? this.externalId,
        userId: userId ?? this.userId,
        consentRequired: consentRequired ?? this.consentRequired,
        enrolledOn: enrolledOn ?? this.enrolledOn,
        enrolledBy: enrolledBy ?? this.enrolledBy,
        withdrawnOn: withdrawnOn ?? this.withdrawnOn,
        withdrawnBy: withdrawnBy ?? this.withdrawnBy,
        withdrawalNote: withdrawalNote ?? this.withdrawalNote,
        note: note ?? this.note,
        type: type ?? this.type);
  }

  Enrollment copyWithWrapped(
      {Wrapped<String?>? externalId,
      Wrapped<String>? userId,
      Wrapped<bool?>? consentRequired,
      Wrapped<DateTime?>? enrolledOn,
      Wrapped<String?>? enrolledBy,
      Wrapped<DateTime?>? withdrawnOn,
      Wrapped<String?>? withdrawnBy,
      Wrapped<String?>? withdrawalNote,
      Wrapped<String?>? note,
      Wrapped<String?>? type}) {
    return Enrollment(
        externalId: (externalId != null ? externalId.value : this.externalId),
        userId: (userId != null ? userId.value : this.userId),
        consentRequired: (consentRequired != null
            ? consentRequired.value
            : this.consentRequired),
        enrolledOn: (enrolledOn != null ? enrolledOn.value : this.enrolledOn),
        enrolledBy: (enrolledBy != null ? enrolledBy.value : this.enrolledBy),
        withdrawnOn:
            (withdrawnOn != null ? withdrawnOn.value : this.withdrawnOn),
        withdrawnBy:
            (withdrawnBy != null ? withdrawnBy.value : this.withdrawnBy),
        withdrawalNote: (withdrawalNote != null
            ? withdrawalNote.value
            : this.withdrawalNote),
        note: (note != null ? note.value : this.note),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class EnrollmentDetail {
  EnrollmentDetail({
    required this.studyId,
    this.externalId,
    required this.participant,
    required this.consentRequired,
    required this.enrolledOn,
    required this.enrolledBy,
    this.withdrawnOn,
    this.withdrawnBy,
    this.withdrawalNote,
    this.note,
    this.type,
  });

  factory EnrollmentDetail.fromJson(Map<String, dynamic> json) =>
      _$EnrollmentDetailFromJson(json);

  @JsonKey(name: 'studyId', includeIfNull: false, defaultValue: '')
  final String studyId;
  @JsonKey(name: 'externalId', includeIfNull: false, defaultValue: '')
  final String? externalId;
  @JsonKey(name: 'participant', includeIfNull: false)
  final AccountRef participant;
  @JsonKey(name: 'consentRequired', includeIfNull: false)
  final bool consentRequired;
  @JsonKey(name: 'enrolledOn', includeIfNull: false)
  final DateTime enrolledOn;
  @JsonKey(name: 'enrolledBy', includeIfNull: false)
  final AccountRef enrolledBy;
  @JsonKey(name: 'withdrawnOn', includeIfNull: false)
  final DateTime? withdrawnOn;
  @JsonKey(name: 'withdrawnBy', includeIfNull: false)
  final AccountRef? withdrawnBy;
  @JsonKey(name: 'withdrawalNote', includeIfNull: false, defaultValue: '')
  final String? withdrawalNote;
  @JsonKey(name: 'note', includeIfNull: false, defaultValue: '')
  final String? note;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$EnrollmentDetailFromJson;
  static const toJsonFactory = _$EnrollmentDetailToJson;
  Map<String, dynamic> toJson() => _$EnrollmentDetailToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EnrollmentDetail &&
            (identical(other.studyId, studyId) ||
                const DeepCollectionEquality()
                    .equals(other.studyId, studyId)) &&
            (identical(other.externalId, externalId) ||
                const DeepCollectionEquality()
                    .equals(other.externalId, externalId)) &&
            (identical(other.participant, participant) ||
                const DeepCollectionEquality()
                    .equals(other.participant, participant)) &&
            (identical(other.consentRequired, consentRequired) ||
                const DeepCollectionEquality()
                    .equals(other.consentRequired, consentRequired)) &&
            (identical(other.enrolledOn, enrolledOn) ||
                const DeepCollectionEquality()
                    .equals(other.enrolledOn, enrolledOn)) &&
            (identical(other.enrolledBy, enrolledBy) ||
                const DeepCollectionEquality()
                    .equals(other.enrolledBy, enrolledBy)) &&
            (identical(other.withdrawnOn, withdrawnOn) ||
                const DeepCollectionEquality()
                    .equals(other.withdrawnOn, withdrawnOn)) &&
            (identical(other.withdrawnBy, withdrawnBy) ||
                const DeepCollectionEquality()
                    .equals(other.withdrawnBy, withdrawnBy)) &&
            (identical(other.withdrawalNote, withdrawalNote) ||
                const DeepCollectionEquality()
                    .equals(other.withdrawalNote, withdrawalNote)) &&
            (identical(other.note, note) ||
                const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(studyId) ^
      const DeepCollectionEquality().hash(externalId) ^
      const DeepCollectionEquality().hash(participant) ^
      const DeepCollectionEquality().hash(consentRequired) ^
      const DeepCollectionEquality().hash(enrolledOn) ^
      const DeepCollectionEquality().hash(enrolledBy) ^
      const DeepCollectionEquality().hash(withdrawnOn) ^
      const DeepCollectionEquality().hash(withdrawnBy) ^
      const DeepCollectionEquality().hash(withdrawalNote) ^
      const DeepCollectionEquality().hash(note) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $EnrollmentDetailExtension on EnrollmentDetail {
  EnrollmentDetail copyWith(
      {String? studyId,
      String? externalId,
      AccountRef? participant,
      bool? consentRequired,
      DateTime? enrolledOn,
      AccountRef? enrolledBy,
      DateTime? withdrawnOn,
      AccountRef? withdrawnBy,
      String? withdrawalNote,
      String? note,
      String? type}) {
    return EnrollmentDetail(
        studyId: studyId ?? this.studyId,
        externalId: externalId ?? this.externalId,
        participant: participant ?? this.participant,
        consentRequired: consentRequired ?? this.consentRequired,
        enrolledOn: enrolledOn ?? this.enrolledOn,
        enrolledBy: enrolledBy ?? this.enrolledBy,
        withdrawnOn: withdrawnOn ?? this.withdrawnOn,
        withdrawnBy: withdrawnBy ?? this.withdrawnBy,
        withdrawalNote: withdrawalNote ?? this.withdrawalNote,
        note: note ?? this.note,
        type: type ?? this.type);
  }

  EnrollmentDetail copyWithWrapped(
      {Wrapped<String>? studyId,
      Wrapped<String?>? externalId,
      Wrapped<AccountRef>? participant,
      Wrapped<bool>? consentRequired,
      Wrapped<DateTime>? enrolledOn,
      Wrapped<AccountRef>? enrolledBy,
      Wrapped<DateTime?>? withdrawnOn,
      Wrapped<AccountRef?>? withdrawnBy,
      Wrapped<String?>? withdrawalNote,
      Wrapped<String?>? note,
      Wrapped<String?>? type}) {
    return EnrollmentDetail(
        studyId: (studyId != null ? studyId.value : this.studyId),
        externalId: (externalId != null ? externalId.value : this.externalId),
        participant:
            (participant != null ? participant.value : this.participant),
        consentRequired: (consentRequired != null
            ? consentRequired.value
            : this.consentRequired),
        enrolledOn: (enrolledOn != null ? enrolledOn.value : this.enrolledOn),
        enrolledBy: (enrolledBy != null ? enrolledBy.value : this.enrolledBy),
        withdrawnOn:
            (withdrawnOn != null ? withdrawnOn.value : this.withdrawnOn),
        withdrawnBy:
            (withdrawnBy != null ? withdrawnBy.value : this.withdrawnBy),
        withdrawalNote: (withdrawalNote != null
            ? withdrawalNote.value
            : this.withdrawalNote),
        note: (note != null ? note.value : this.note),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class EnrollmentInfo {
  EnrollmentInfo({
    this.externalId,
    this.consentRequired,
    this.enrolledOn,
    this.withdrawnOn,
    this.enrolledBySelf,
    this.withdrawnBySelf,
    this.type,
  });

  factory EnrollmentInfo.fromJson(Map<String, dynamic> json) =>
      _$EnrollmentInfoFromJson(json);

  @JsonKey(name: 'externalId', includeIfNull: false, defaultValue: '')
  final String? externalId;
  @JsonKey(name: 'consentRequired', includeIfNull: false)
  final bool? consentRequired;
  @JsonKey(name: 'enrolledOn', includeIfNull: false)
  final DateTime? enrolledOn;
  @JsonKey(name: 'withdrawnOn', includeIfNull: false)
  final DateTime? withdrawnOn;
  @JsonKey(name: 'enrolledBySelf', includeIfNull: false)
  final bool? enrolledBySelf;
  @JsonKey(name: 'withdrawnBySelf', includeIfNull: false)
  final bool? withdrawnBySelf;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$EnrollmentInfoFromJson;
  static const toJsonFactory = _$EnrollmentInfoToJson;
  Map<String, dynamic> toJson() => _$EnrollmentInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EnrollmentInfo &&
            (identical(other.externalId, externalId) ||
                const DeepCollectionEquality()
                    .equals(other.externalId, externalId)) &&
            (identical(other.consentRequired, consentRequired) ||
                const DeepCollectionEquality()
                    .equals(other.consentRequired, consentRequired)) &&
            (identical(other.enrolledOn, enrolledOn) ||
                const DeepCollectionEquality()
                    .equals(other.enrolledOn, enrolledOn)) &&
            (identical(other.withdrawnOn, withdrawnOn) ||
                const DeepCollectionEquality()
                    .equals(other.withdrawnOn, withdrawnOn)) &&
            (identical(other.enrolledBySelf, enrolledBySelf) ||
                const DeepCollectionEquality()
                    .equals(other.enrolledBySelf, enrolledBySelf)) &&
            (identical(other.withdrawnBySelf, withdrawnBySelf) ||
                const DeepCollectionEquality()
                    .equals(other.withdrawnBySelf, withdrawnBySelf)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(externalId) ^
      const DeepCollectionEquality().hash(consentRequired) ^
      const DeepCollectionEquality().hash(enrolledOn) ^
      const DeepCollectionEquality().hash(withdrawnOn) ^
      const DeepCollectionEquality().hash(enrolledBySelf) ^
      const DeepCollectionEquality().hash(withdrawnBySelf) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $EnrollmentInfoExtension on EnrollmentInfo {
  EnrollmentInfo copyWith(
      {String? externalId,
      bool? consentRequired,
      DateTime? enrolledOn,
      DateTime? withdrawnOn,
      bool? enrolledBySelf,
      bool? withdrawnBySelf,
      String? type}) {
    return EnrollmentInfo(
        externalId: externalId ?? this.externalId,
        consentRequired: consentRequired ?? this.consentRequired,
        enrolledOn: enrolledOn ?? this.enrolledOn,
        withdrawnOn: withdrawnOn ?? this.withdrawnOn,
        enrolledBySelf: enrolledBySelf ?? this.enrolledBySelf,
        withdrawnBySelf: withdrawnBySelf ?? this.withdrawnBySelf,
        type: type ?? this.type);
  }

  EnrollmentInfo copyWithWrapped(
      {Wrapped<String?>? externalId,
      Wrapped<bool?>? consentRequired,
      Wrapped<DateTime?>? enrolledOn,
      Wrapped<DateTime?>? withdrawnOn,
      Wrapped<bool?>? enrolledBySelf,
      Wrapped<bool?>? withdrawnBySelf,
      Wrapped<String?>? type}) {
    return EnrollmentInfo(
        externalId: (externalId != null ? externalId.value : this.externalId),
        consentRequired: (consentRequired != null
            ? consentRequired.value
            : this.consentRequired),
        enrolledOn: (enrolledOn != null ? enrolledOn.value : this.enrolledOn),
        withdrawnOn:
            (withdrawnOn != null ? withdrawnOn.value : this.withdrawnOn),
        enrolledBySelf: (enrolledBySelf != null
            ? enrolledBySelf.value
            : this.enrolledBySelf),
        withdrawnBySelf: (withdrawnBySelf != null
            ? withdrawnBySelf.value
            : this.withdrawnBySelf),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class EventStream {
  EventStream({
    this.startEventId,
    this.sessionGuids,
    this.eventTimestamp,
    this.daysSinceEvent,
    this.studyBurstId,
    this.studyBurstNum,
    this.byDayEntries,
    this.type,
  });

  factory EventStream.fromJson(Map<String, dynamic> json) =>
      _$EventStreamFromJson(json);

  @JsonKey(name: 'startEventId', includeIfNull: false, defaultValue: '')
  final String? startEventId;
  @JsonKey(name: 'sessionGuids', includeIfNull: false, defaultValue: <String>[])
  final List<String>? sessionGuids;
  @JsonKey(name: 'eventTimestamp', includeIfNull: false)
  final DateTime? eventTimestamp;
  @JsonKey(name: 'daysSinceEvent', includeIfNull: false)
  final int? daysSinceEvent;
  @JsonKey(name: 'studyBurstId', includeIfNull: false, defaultValue: '')
  final String? studyBurstId;
  @JsonKey(name: 'studyBurstNum', includeIfNull: false)
  final int? studyBurstNum;
  @JsonKey(name: 'byDayEntries', includeIfNull: false)
  final Map<String, dynamic>? byDayEntries;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$EventStreamFromJson;
  static const toJsonFactory = _$EventStreamToJson;
  Map<String, dynamic> toJson() => _$EventStreamToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EventStream &&
            (identical(other.startEventId, startEventId) ||
                const DeepCollectionEquality()
                    .equals(other.startEventId, startEventId)) &&
            (identical(other.sessionGuids, sessionGuids) ||
                const DeepCollectionEquality()
                    .equals(other.sessionGuids, sessionGuids)) &&
            (identical(other.eventTimestamp, eventTimestamp) ||
                const DeepCollectionEquality()
                    .equals(other.eventTimestamp, eventTimestamp)) &&
            (identical(other.daysSinceEvent, daysSinceEvent) ||
                const DeepCollectionEquality()
                    .equals(other.daysSinceEvent, daysSinceEvent)) &&
            (identical(other.studyBurstId, studyBurstId) ||
                const DeepCollectionEquality()
                    .equals(other.studyBurstId, studyBurstId)) &&
            (identical(other.studyBurstNum, studyBurstNum) ||
                const DeepCollectionEquality()
                    .equals(other.studyBurstNum, studyBurstNum)) &&
            (identical(other.byDayEntries, byDayEntries) ||
                const DeepCollectionEquality()
                    .equals(other.byDayEntries, byDayEntries)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(startEventId) ^
      const DeepCollectionEquality().hash(sessionGuids) ^
      const DeepCollectionEquality().hash(eventTimestamp) ^
      const DeepCollectionEquality().hash(daysSinceEvent) ^
      const DeepCollectionEquality().hash(studyBurstId) ^
      const DeepCollectionEquality().hash(studyBurstNum) ^
      const DeepCollectionEquality().hash(byDayEntries) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $EventStreamExtension on EventStream {
  EventStream copyWith(
      {String? startEventId,
      List<String>? sessionGuids,
      DateTime? eventTimestamp,
      int? daysSinceEvent,
      String? studyBurstId,
      int? studyBurstNum,
      Map<String, dynamic>? byDayEntries,
      String? type}) {
    return EventStream(
        startEventId: startEventId ?? this.startEventId,
        sessionGuids: sessionGuids ?? this.sessionGuids,
        eventTimestamp: eventTimestamp ?? this.eventTimestamp,
        daysSinceEvent: daysSinceEvent ?? this.daysSinceEvent,
        studyBurstId: studyBurstId ?? this.studyBurstId,
        studyBurstNum: studyBurstNum ?? this.studyBurstNum,
        byDayEntries: byDayEntries ?? this.byDayEntries,
        type: type ?? this.type);
  }

  EventStream copyWithWrapped(
      {Wrapped<String?>? startEventId,
      Wrapped<List<String>?>? sessionGuids,
      Wrapped<DateTime?>? eventTimestamp,
      Wrapped<int?>? daysSinceEvent,
      Wrapped<String?>? studyBurstId,
      Wrapped<int?>? studyBurstNum,
      Wrapped<Map<String, dynamic>?>? byDayEntries,
      Wrapped<String?>? type}) {
    return EventStream(
        startEventId:
            (startEventId != null ? startEventId.value : this.startEventId),
        sessionGuids:
            (sessionGuids != null ? sessionGuids.value : this.sessionGuids),
        eventTimestamp: (eventTimestamp != null
            ? eventTimestamp.value
            : this.eventTimestamp),
        daysSinceEvent: (daysSinceEvent != null
            ? daysSinceEvent.value
            : this.daysSinceEvent),
        studyBurstId:
            (studyBurstId != null ? studyBurstId.value : this.studyBurstId),
        studyBurstNum:
            (studyBurstNum != null ? studyBurstNum.value : this.studyBurstNum),
        byDayEntries:
            (byDayEntries != null ? byDayEntries.value : this.byDayEntries),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class EventStreamAdherenceReport {
  EventStreamAdherenceReport({
    this.activeOnly,
    this.timestamp,
    this.clientTimeZone,
    this.adherencePercent,
    this.dayRangeOfAllStreams,
    this.streams,
    this.type,
  });

  factory EventStreamAdherenceReport.fromJson(Map<String, dynamic> json) =>
      _$EventStreamAdherenceReportFromJson(json);

  @JsonKey(name: 'activeOnly', includeIfNull: false)
  final bool? activeOnly;
  @JsonKey(name: 'timestamp', includeIfNull: false)
  final DateTime? timestamp;
  @JsonKey(name: 'clientTimeZone', includeIfNull: false, defaultValue: '')
  final String? clientTimeZone;
  @JsonKey(name: 'adherencePercent', includeIfNull: false)
  final int? adherencePercent;
  @JsonKey(name: 'dayRangeOfAllStreams', includeIfNull: false)
  final DayRange? dayRangeOfAllStreams;
  @JsonKey(name: 'streams', includeIfNull: false, defaultValue: <EventStream>[])
  final List<EventStream>? streams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$EventStreamAdherenceReportFromJson;
  static const toJsonFactory = _$EventStreamAdherenceReportToJson;
  Map<String, dynamic> toJson() => _$EventStreamAdherenceReportToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EventStreamAdherenceReport &&
            (identical(other.activeOnly, activeOnly) ||
                const DeepCollectionEquality()
                    .equals(other.activeOnly, activeOnly)) &&
            (identical(other.timestamp, timestamp) ||
                const DeepCollectionEquality()
                    .equals(other.timestamp, timestamp)) &&
            (identical(other.clientTimeZone, clientTimeZone) ||
                const DeepCollectionEquality()
                    .equals(other.clientTimeZone, clientTimeZone)) &&
            (identical(other.adherencePercent, adherencePercent) ||
                const DeepCollectionEquality()
                    .equals(other.adherencePercent, adherencePercent)) &&
            (identical(other.dayRangeOfAllStreams, dayRangeOfAllStreams) ||
                const DeepCollectionEquality().equals(
                    other.dayRangeOfAllStreams, dayRangeOfAllStreams)) &&
            (identical(other.streams, streams) ||
                const DeepCollectionEquality()
                    .equals(other.streams, streams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(activeOnly) ^
      const DeepCollectionEquality().hash(timestamp) ^
      const DeepCollectionEquality().hash(clientTimeZone) ^
      const DeepCollectionEquality().hash(adherencePercent) ^
      const DeepCollectionEquality().hash(dayRangeOfAllStreams) ^
      const DeepCollectionEquality().hash(streams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $EventStreamAdherenceReportExtension on EventStreamAdherenceReport {
  EventStreamAdherenceReport copyWith(
      {bool? activeOnly,
      DateTime? timestamp,
      String? clientTimeZone,
      int? adherencePercent,
      DayRange? dayRangeOfAllStreams,
      List<EventStream>? streams,
      String? type}) {
    return EventStreamAdherenceReport(
        activeOnly: activeOnly ?? this.activeOnly,
        timestamp: timestamp ?? this.timestamp,
        clientTimeZone: clientTimeZone ?? this.clientTimeZone,
        adherencePercent: adherencePercent ?? this.adherencePercent,
        dayRangeOfAllStreams: dayRangeOfAllStreams ?? this.dayRangeOfAllStreams,
        streams: streams ?? this.streams,
        type: type ?? this.type);
  }

  EventStreamAdherenceReport copyWithWrapped(
      {Wrapped<bool?>? activeOnly,
      Wrapped<DateTime?>? timestamp,
      Wrapped<String?>? clientTimeZone,
      Wrapped<int?>? adherencePercent,
      Wrapped<DayRange?>? dayRangeOfAllStreams,
      Wrapped<List<EventStream>?>? streams,
      Wrapped<String?>? type}) {
    return EventStreamAdherenceReport(
        activeOnly: (activeOnly != null ? activeOnly.value : this.activeOnly),
        timestamp: (timestamp != null ? timestamp.value : this.timestamp),
        clientTimeZone: (clientTimeZone != null
            ? clientTimeZone.value
            : this.clientTimeZone),
        adherencePercent: (adherencePercent != null
            ? adherencePercent.value
            : this.adherencePercent),
        dayRangeOfAllStreams: (dayRangeOfAllStreams != null
            ? dayRangeOfAllStreams.value
            : this.dayRangeOfAllStreams),
        streams: (streams != null ? streams.value : this.streams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class EventStreamDay {
  EventStreamDay({
    this.sessionGuid,
    this.sessionName,
    this.sessionSymbol,
    this.week,
    this.studyBurstId,
    this.studyBurstNum,
    this.startDay,
    this.startDate,
    this.timeWindows,
    this.type,
  });

  factory EventStreamDay.fromJson(Map<String, dynamic> json) =>
      _$EventStreamDayFromJson(json);

  @JsonKey(name: 'sessionGuid', includeIfNull: false, defaultValue: '')
  final String? sessionGuid;
  @JsonKey(name: 'sessionName', includeIfNull: false, defaultValue: '')
  final String? sessionName;
  @JsonKey(name: 'sessionSymbol', includeIfNull: false, defaultValue: '')
  final String? sessionSymbol;
  @JsonKey(name: 'week', includeIfNull: false)
  final int? week;
  @JsonKey(name: 'studyBurstId', includeIfNull: false, defaultValue: '')
  final String? studyBurstId;
  @JsonKey(name: 'studyBurstNum', includeIfNull: false)
  final int? studyBurstNum;
  @JsonKey(name: 'startDay', includeIfNull: false)
  final int? startDay;
  @JsonKey(name: 'startDate', includeIfNull: false)
  final dynamic startDate;
  @JsonKey(
      name: 'timeWindows',
      includeIfNull: false,
      defaultValue: <EventStreamWindow>[])
  final List<EventStreamWindow>? timeWindows;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$EventStreamDayFromJson;
  static const toJsonFactory = _$EventStreamDayToJson;
  Map<String, dynamic> toJson() => _$EventStreamDayToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EventStreamDay &&
            (identical(other.sessionGuid, sessionGuid) ||
                const DeepCollectionEquality()
                    .equals(other.sessionGuid, sessionGuid)) &&
            (identical(other.sessionName, sessionName) ||
                const DeepCollectionEquality()
                    .equals(other.sessionName, sessionName)) &&
            (identical(other.sessionSymbol, sessionSymbol) ||
                const DeepCollectionEquality()
                    .equals(other.sessionSymbol, sessionSymbol)) &&
            (identical(other.week, week) ||
                const DeepCollectionEquality().equals(other.week, week)) &&
            (identical(other.studyBurstId, studyBurstId) ||
                const DeepCollectionEquality()
                    .equals(other.studyBurstId, studyBurstId)) &&
            (identical(other.studyBurstNum, studyBurstNum) ||
                const DeepCollectionEquality()
                    .equals(other.studyBurstNum, studyBurstNum)) &&
            (identical(other.startDay, startDay) ||
                const DeepCollectionEquality()
                    .equals(other.startDay, startDay)) &&
            (identical(other.startDate, startDate) ||
                const DeepCollectionEquality()
                    .equals(other.startDate, startDate)) &&
            (identical(other.timeWindows, timeWindows) ||
                const DeepCollectionEquality()
                    .equals(other.timeWindows, timeWindows)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(sessionGuid) ^
      const DeepCollectionEquality().hash(sessionName) ^
      const DeepCollectionEquality().hash(sessionSymbol) ^
      const DeepCollectionEquality().hash(week) ^
      const DeepCollectionEquality().hash(studyBurstId) ^
      const DeepCollectionEquality().hash(studyBurstNum) ^
      const DeepCollectionEquality().hash(startDay) ^
      const DeepCollectionEquality().hash(startDate) ^
      const DeepCollectionEquality().hash(timeWindows) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $EventStreamDayExtension on EventStreamDay {
  EventStreamDay copyWith(
      {String? sessionGuid,
      String? sessionName,
      String? sessionSymbol,
      int? week,
      String? studyBurstId,
      int? studyBurstNum,
      int? startDay,
      dynamic startDate,
      List<EventStreamWindow>? timeWindows,
      String? type}) {
    return EventStreamDay(
        sessionGuid: sessionGuid ?? this.sessionGuid,
        sessionName: sessionName ?? this.sessionName,
        sessionSymbol: sessionSymbol ?? this.sessionSymbol,
        week: week ?? this.week,
        studyBurstId: studyBurstId ?? this.studyBurstId,
        studyBurstNum: studyBurstNum ?? this.studyBurstNum,
        startDay: startDay ?? this.startDay,
        startDate: startDate ?? this.startDate,
        timeWindows: timeWindows ?? this.timeWindows,
        type: type ?? this.type);
  }

  EventStreamDay copyWithWrapped(
      {Wrapped<String?>? sessionGuid,
      Wrapped<String?>? sessionName,
      Wrapped<String?>? sessionSymbol,
      Wrapped<int?>? week,
      Wrapped<String?>? studyBurstId,
      Wrapped<int?>? studyBurstNum,
      Wrapped<int?>? startDay,
      Wrapped<dynamic>? startDate,
      Wrapped<List<EventStreamWindow>?>? timeWindows,
      Wrapped<String?>? type}) {
    return EventStreamDay(
        sessionGuid:
            (sessionGuid != null ? sessionGuid.value : this.sessionGuid),
        sessionName:
            (sessionName != null ? sessionName.value : this.sessionName),
        sessionSymbol:
            (sessionSymbol != null ? sessionSymbol.value : this.sessionSymbol),
        week: (week != null ? week.value : this.week),
        studyBurstId:
            (studyBurstId != null ? studyBurstId.value : this.studyBurstId),
        studyBurstNum:
            (studyBurstNum != null ? studyBurstNum.value : this.studyBurstNum),
        startDay: (startDay != null ? startDay.value : this.startDay),
        startDate: (startDate != null ? startDate.value : this.startDate),
        timeWindows:
            (timeWindows != null ? timeWindows.value : this.timeWindows),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class EventStreamWindow {
  EventStreamWindow({
    this.sessionInstanceGuid,
    this.timeWindowGuid,
    this.state,
    this.endDay,
    this.endDate,
    this.type,
  });

  factory EventStreamWindow.fromJson(Map<String, dynamic> json) =>
      _$EventStreamWindowFromJson(json);

  @JsonKey(name: 'sessionInstanceGuid', includeIfNull: false, defaultValue: '')
  final String? sessionInstanceGuid;
  @JsonKey(name: 'timeWindowGuid', includeIfNull: false, defaultValue: '')
  final String? timeWindowGuid;
  @JsonKey(
    name: 'state',
    includeIfNull: false,
    toJson: sessionCompletionStateToJson,
    fromJson: sessionCompletionStateFromJson,
  )
  final enums.SessionCompletionState? state;
  @JsonKey(name: 'endDay', includeIfNull: false)
  final int? endDay;
  @JsonKey(name: 'endDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? endDate;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$EventStreamWindowFromJson;
  static const toJsonFactory = _$EventStreamWindowToJson;
  Map<String, dynamic> toJson() => _$EventStreamWindowToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EventStreamWindow &&
            (identical(other.sessionInstanceGuid, sessionInstanceGuid) ||
                const DeepCollectionEquality()
                    .equals(other.sessionInstanceGuid, sessionInstanceGuid)) &&
            (identical(other.timeWindowGuid, timeWindowGuid) ||
                const DeepCollectionEquality()
                    .equals(other.timeWindowGuid, timeWindowGuid)) &&
            (identical(other.state, state) ||
                const DeepCollectionEquality().equals(other.state, state)) &&
            (identical(other.endDay, endDay) ||
                const DeepCollectionEquality().equals(other.endDay, endDay)) &&
            (identical(other.endDate, endDate) ||
                const DeepCollectionEquality()
                    .equals(other.endDate, endDate)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(sessionInstanceGuid) ^
      const DeepCollectionEquality().hash(timeWindowGuid) ^
      const DeepCollectionEquality().hash(state) ^
      const DeepCollectionEquality().hash(endDay) ^
      const DeepCollectionEquality().hash(endDate) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $EventStreamWindowExtension on EventStreamWindow {
  EventStreamWindow copyWith(
      {String? sessionInstanceGuid,
      String? timeWindowGuid,
      enums.SessionCompletionState? state,
      int? endDay,
      DateTime? endDate,
      String? type}) {
    return EventStreamWindow(
        sessionInstanceGuid: sessionInstanceGuid ?? this.sessionInstanceGuid,
        timeWindowGuid: timeWindowGuid ?? this.timeWindowGuid,
        state: state ?? this.state,
        endDay: endDay ?? this.endDay,
        endDate: endDate ?? this.endDate,
        type: type ?? this.type);
  }

  EventStreamWindow copyWithWrapped(
      {Wrapped<String?>? sessionInstanceGuid,
      Wrapped<String?>? timeWindowGuid,
      Wrapped<enums.SessionCompletionState?>? state,
      Wrapped<int?>? endDay,
      Wrapped<DateTime?>? endDate,
      Wrapped<String?>? type}) {
    return EventStreamWindow(
        sessionInstanceGuid: (sessionInstanceGuid != null
            ? sessionInstanceGuid.value
            : this.sessionInstanceGuid),
        timeWindowGuid: (timeWindowGuid != null
            ? timeWindowGuid.value
            : this.timeWindowGuid),
        state: (state != null ? state.value : this.state),
        endDay: (endDay != null ? endDay.value : this.endDay),
        endDate: (endDate != null ? endDate.value : this.endDate),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Exporter3Configuration {
  Exporter3Configuration({
    this.configured,
    this.dataAccessTeamId,
    this.projectId,
    this.rawDataFolderId,
    this.storageLocationId,
    this.type,
  });

  factory Exporter3Configuration.fromJson(Map<String, dynamic> json) =>
      _$Exporter3ConfigurationFromJson(json);

  @JsonKey(name: 'configured', includeIfNull: false)
  final bool? configured;
  @JsonKey(name: 'dataAccessTeamId', includeIfNull: false)
  final num? dataAccessTeamId;
  @JsonKey(name: 'projectId', includeIfNull: false, defaultValue: '')
  final String? projectId;
  @JsonKey(name: 'rawDataFolderId', includeIfNull: false, defaultValue: '')
  final String? rawDataFolderId;
  @JsonKey(name: 'storageLocationId', includeIfNull: false)
  final num? storageLocationId;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$Exporter3ConfigurationFromJson;
  static const toJsonFactory = _$Exporter3ConfigurationToJson;
  Map<String, dynamic> toJson() => _$Exporter3ConfigurationToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Exporter3Configuration &&
            (identical(other.configured, configured) ||
                const DeepCollectionEquality()
                    .equals(other.configured, configured)) &&
            (identical(other.dataAccessTeamId, dataAccessTeamId) ||
                const DeepCollectionEquality()
                    .equals(other.dataAccessTeamId, dataAccessTeamId)) &&
            (identical(other.projectId, projectId) ||
                const DeepCollectionEquality()
                    .equals(other.projectId, projectId)) &&
            (identical(other.rawDataFolderId, rawDataFolderId) ||
                const DeepCollectionEquality()
                    .equals(other.rawDataFolderId, rawDataFolderId)) &&
            (identical(other.storageLocationId, storageLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.storageLocationId, storageLocationId)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(configured) ^
      const DeepCollectionEquality().hash(dataAccessTeamId) ^
      const DeepCollectionEquality().hash(projectId) ^
      const DeepCollectionEquality().hash(rawDataFolderId) ^
      const DeepCollectionEquality().hash(storageLocationId) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $Exporter3ConfigurationExtension on Exporter3Configuration {
  Exporter3Configuration copyWith(
      {bool? configured,
      num? dataAccessTeamId,
      String? projectId,
      String? rawDataFolderId,
      num? storageLocationId,
      String? type}) {
    return Exporter3Configuration(
        configured: configured ?? this.configured,
        dataAccessTeamId: dataAccessTeamId ?? this.dataAccessTeamId,
        projectId: projectId ?? this.projectId,
        rawDataFolderId: rawDataFolderId ?? this.rawDataFolderId,
        storageLocationId: storageLocationId ?? this.storageLocationId,
        type: type ?? this.type);
  }

  Exporter3Configuration copyWithWrapped(
      {Wrapped<bool?>? configured,
      Wrapped<num?>? dataAccessTeamId,
      Wrapped<String?>? projectId,
      Wrapped<String?>? rawDataFolderId,
      Wrapped<num?>? storageLocationId,
      Wrapped<String?>? type}) {
    return Exporter3Configuration(
        configured: (configured != null ? configured.value : this.configured),
        dataAccessTeamId: (dataAccessTeamId != null
            ? dataAccessTeamId.value
            : this.dataAccessTeamId),
        projectId: (projectId != null ? projectId.value : this.projectId),
        rawDataFolderId: (rawDataFolderId != null
            ? rawDataFolderId.value
            : this.rawDataFolderId),
        storageLocationId: (storageLocationId != null
            ? storageLocationId.value
            : this.storageLocationId),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ExternalIdentifier {
  ExternalIdentifier({
    required this.studyId,
    required this.identifier,
    this.assigned,
    this.type,
  });

  factory ExternalIdentifier.fromJson(Map<String, dynamic> json) =>
      _$ExternalIdentifierFromJson(json);

  @JsonKey(name: 'studyId', includeIfNull: false, defaultValue: '')
  final String studyId;
  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String identifier;
  @JsonKey(name: 'assigned', includeIfNull: false)
  final bool? assigned;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ExternalIdentifierFromJson;
  static const toJsonFactory = _$ExternalIdentifierToJson;
  Map<String, dynamic> toJson() => _$ExternalIdentifierToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ExternalIdentifier &&
            (identical(other.studyId, studyId) ||
                const DeepCollectionEquality()
                    .equals(other.studyId, studyId)) &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.assigned, assigned) ||
                const DeepCollectionEquality()
                    .equals(other.assigned, assigned)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(studyId) ^
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(assigned) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ExternalIdentifierExtension on ExternalIdentifier {
  ExternalIdentifier copyWith(
      {String? studyId, String? identifier, bool? assigned, String? type}) {
    return ExternalIdentifier(
        studyId: studyId ?? this.studyId,
        identifier: identifier ?? this.identifier,
        assigned: assigned ?? this.assigned,
        type: type ?? this.type);
  }

  ExternalIdentifier copyWithWrapped(
      {Wrapped<String>? studyId,
      Wrapped<String>? identifier,
      Wrapped<bool?>? assigned,
      Wrapped<String?>? type}) {
    return ExternalIdentifier(
        studyId: (studyId != null ? studyId.value : this.studyId),
        identifier: (identifier != null ? identifier.value : this.identifier),
        assigned: (assigned != null ? assigned.value : this.assigned),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ExternalResource {
  ExternalResource({
    this.guid,
    required this.title,
    required this.category,
    required this.url,
    this.format,
    this.date,
    this.description,
    this.contributors,
    this.creators,
    this.publishers,
    this.language,
    this.minRevision,
    this.maxRevision,
    this.createdAtRevision,
    this.createdOn,
    this.modifiedOn,
    this.deleted,
    this.version,
    this.upToDate,
    this.type,
  });

  factory ExternalResource.fromJson(Map<String, dynamic> json) =>
      _$ExternalResourceFromJson(json);

  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String? guid;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  @JsonKey(
    name: 'category',
    includeIfNull: false,
    toJson: resourceCategoryToJson,
    fromJson: resourceCategoryFromJson,
  )
  final enums.ResourceCategory category;
  @JsonKey(name: 'url', includeIfNull: false, defaultValue: '')
  final String url;
  @JsonKey(name: 'format', includeIfNull: false, defaultValue: '')
  final String? format;
  @JsonKey(name: 'date', includeIfNull: false, defaultValue: '')
  final String? date;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'contributors', includeIfNull: false, defaultValue: <String>[])
  final List<String>? contributors;
  @JsonKey(name: 'creators', includeIfNull: false, defaultValue: <String>[])
  final List<String>? creators;
  @JsonKey(name: 'publishers', includeIfNull: false, defaultValue: <String>[])
  final List<String>? publishers;
  @JsonKey(name: 'language', includeIfNull: false, defaultValue: '')
  final String? language;
  @JsonKey(name: 'minRevision', includeIfNull: false)
  final int? minRevision;
  @JsonKey(name: 'maxRevision', includeIfNull: false)
  final int? maxRevision;
  @JsonKey(name: 'createdAtRevision', includeIfNull: false)
  final int? createdAtRevision;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'modifiedOn', includeIfNull: false)
  final DateTime? modifiedOn;
  @JsonKey(name: 'deleted', includeIfNull: false)
  final bool? deleted;
  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(name: 'upToDate', includeIfNull: false)
  final bool? upToDate;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ExternalResourceFromJson;
  static const toJsonFactory = _$ExternalResourceToJson;
  Map<String, dynamic> toJson() => _$ExternalResourceToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ExternalResource &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.category, category) ||
                const DeepCollectionEquality()
                    .equals(other.category, category)) &&
            (identical(other.url, url) ||
                const DeepCollectionEquality().equals(other.url, url)) &&
            (identical(other.format, format) ||
                const DeepCollectionEquality().equals(other.format, format)) &&
            (identical(other.date, date) ||
                const DeepCollectionEquality().equals(other.date, date)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.contributors, contributors) ||
                const DeepCollectionEquality()
                    .equals(other.contributors, contributors)) &&
            (identical(other.creators, creators) ||
                const DeepCollectionEquality()
                    .equals(other.creators, creators)) &&
            (identical(other.publishers, publishers) ||
                const DeepCollectionEquality()
                    .equals(other.publishers, publishers)) &&
            (identical(other.language, language) ||
                const DeepCollectionEquality()
                    .equals(other.language, language)) &&
            (identical(other.minRevision, minRevision) ||
                const DeepCollectionEquality()
                    .equals(other.minRevision, minRevision)) &&
            (identical(other.maxRevision, maxRevision) ||
                const DeepCollectionEquality()
                    .equals(other.maxRevision, maxRevision)) &&
            (identical(other.createdAtRevision, createdAtRevision) ||
                const DeepCollectionEquality()
                    .equals(other.createdAtRevision, createdAtRevision)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.modifiedOn, modifiedOn) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedOn, modifiedOn)) &&
            (identical(other.deleted, deleted) ||
                const DeepCollectionEquality()
                    .equals(other.deleted, deleted)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.upToDate, upToDate) ||
                const DeepCollectionEquality()
                    .equals(other.upToDate, upToDate)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(category) ^
      const DeepCollectionEquality().hash(url) ^
      const DeepCollectionEquality().hash(format) ^
      const DeepCollectionEquality().hash(date) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(contributors) ^
      const DeepCollectionEquality().hash(creators) ^
      const DeepCollectionEquality().hash(publishers) ^
      const DeepCollectionEquality().hash(language) ^
      const DeepCollectionEquality().hash(minRevision) ^
      const DeepCollectionEquality().hash(maxRevision) ^
      const DeepCollectionEquality().hash(createdAtRevision) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(modifiedOn) ^
      const DeepCollectionEquality().hash(deleted) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(upToDate) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ExternalResourceExtension on ExternalResource {
  ExternalResource copyWith(
      {String? guid,
      String? title,
      enums.ResourceCategory? category,
      String? url,
      String? format,
      String? date,
      String? description,
      List<String>? contributors,
      List<String>? creators,
      List<String>? publishers,
      String? language,
      int? minRevision,
      int? maxRevision,
      int? createdAtRevision,
      DateTime? createdOn,
      DateTime? modifiedOn,
      bool? deleted,
      num? version,
      bool? upToDate,
      String? type}) {
    return ExternalResource(
        guid: guid ?? this.guid,
        title: title ?? this.title,
        category: category ?? this.category,
        url: url ?? this.url,
        format: format ?? this.format,
        date: date ?? this.date,
        description: description ?? this.description,
        contributors: contributors ?? this.contributors,
        creators: creators ?? this.creators,
        publishers: publishers ?? this.publishers,
        language: language ?? this.language,
        minRevision: minRevision ?? this.minRevision,
        maxRevision: maxRevision ?? this.maxRevision,
        createdAtRevision: createdAtRevision ?? this.createdAtRevision,
        createdOn: createdOn ?? this.createdOn,
        modifiedOn: modifiedOn ?? this.modifiedOn,
        deleted: deleted ?? this.deleted,
        version: version ?? this.version,
        upToDate: upToDate ?? this.upToDate,
        type: type ?? this.type);
  }

  ExternalResource copyWithWrapped(
      {Wrapped<String?>? guid,
      Wrapped<String>? title,
      Wrapped<enums.ResourceCategory>? category,
      Wrapped<String>? url,
      Wrapped<String?>? format,
      Wrapped<String?>? date,
      Wrapped<String?>? description,
      Wrapped<List<String>?>? contributors,
      Wrapped<List<String>?>? creators,
      Wrapped<List<String>?>? publishers,
      Wrapped<String?>? language,
      Wrapped<int?>? minRevision,
      Wrapped<int?>? maxRevision,
      Wrapped<int?>? createdAtRevision,
      Wrapped<DateTime?>? createdOn,
      Wrapped<DateTime?>? modifiedOn,
      Wrapped<bool?>? deleted,
      Wrapped<num?>? version,
      Wrapped<bool?>? upToDate,
      Wrapped<String?>? type}) {
    return ExternalResource(
        guid: (guid != null ? guid.value : this.guid),
        title: (title != null ? title.value : this.title),
        category: (category != null ? category.value : this.category),
        url: (url != null ? url.value : this.url),
        format: (format != null ? format.value : this.format),
        date: (date != null ? date.value : this.date),
        description:
            (description != null ? description.value : this.description),
        contributors:
            (contributors != null ? contributors.value : this.contributors),
        creators: (creators != null ? creators.value : this.creators),
        publishers: (publishers != null ? publishers.value : this.publishers),
        language: (language != null ? language.value : this.language),
        minRevision:
            (minRevision != null ? minRevision.value : this.minRevision),
        maxRevision:
            (maxRevision != null ? maxRevision.value : this.maxRevision),
        createdAtRevision: (createdAtRevision != null
            ? createdAtRevision.value
            : this.createdAtRevision),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        modifiedOn: (modifiedOn != null ? modifiedOn.value : this.modifiedOn),
        deleted: (deleted != null ? deleted.value : this.deleted),
        version: (version != null ? version.value : this.version),
        upToDate: (upToDate != null ? upToDate.value : this.upToDate),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class FileReference {
  FileReference({
    required this.guid,
    required this.createdOn,
    this.href,
    this.type,
  });

  factory FileReference.fromJson(Map<String, dynamic> json) =>
      _$FileReferenceFromJson(json);

  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String guid;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime createdOn;
  @JsonKey(name: 'href', includeIfNull: false, defaultValue: '')
  final String? href;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$FileReferenceFromJson;
  static const toJsonFactory = _$FileReferenceToJson;
  Map<String, dynamic> toJson() => _$FileReferenceToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FileReference &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.href, href) ||
                const DeepCollectionEquality().equals(other.href, href)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(href) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $FileReferenceExtension on FileReference {
  FileReference copyWith(
      {String? guid, DateTime? createdOn, String? href, String? type}) {
    return FileReference(
        guid: guid ?? this.guid,
        createdOn: createdOn ?? this.createdOn,
        href: href ?? this.href,
        type: type ?? this.type);
  }

  FileReference copyWithWrapped(
      {Wrapped<String>? guid,
      Wrapped<DateTime>? createdOn,
      Wrapped<String?>? href,
      Wrapped<String?>? type}) {
    return FileReference(
        guid: (guid != null ? guid.value : this.guid),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        href: (href != null ? href.value : this.href),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class GeneratedPassword {
  GeneratedPassword({
    this.externalId,
    this.userId,
    this.password,
    this.type,
  });

  factory GeneratedPassword.fromJson(Map<String, dynamic> json) =>
      _$GeneratedPasswordFromJson(json);

  @JsonKey(name: 'externalId', includeIfNull: false, defaultValue: '')
  final String? externalId;
  @JsonKey(name: 'userId', includeIfNull: false, defaultValue: '')
  final String? userId;
  @JsonKey(name: 'password', includeIfNull: false, defaultValue: '')
  final String? password;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$GeneratedPasswordFromJson;
  static const toJsonFactory = _$GeneratedPasswordToJson;
  Map<String, dynamic> toJson() => _$GeneratedPasswordToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is GeneratedPassword &&
            (identical(other.externalId, externalId) ||
                const DeepCollectionEquality()
                    .equals(other.externalId, externalId)) &&
            (identical(other.userId, userId) ||
                const DeepCollectionEquality().equals(other.userId, userId)) &&
            (identical(other.password, password) ||
                const DeepCollectionEquality()
                    .equals(other.password, password)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(externalId) ^
      const DeepCollectionEquality().hash(userId) ^
      const DeepCollectionEquality().hash(password) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $GeneratedPasswordExtension on GeneratedPassword {
  GeneratedPassword copyWith(
      {String? externalId, String? userId, String? password, String? type}) {
    return GeneratedPassword(
        externalId: externalId ?? this.externalId,
        userId: userId ?? this.userId,
        password: password ?? this.password,
        type: type ?? this.type);
  }

  GeneratedPassword copyWithWrapped(
      {Wrapped<String?>? externalId,
      Wrapped<String?>? userId,
      Wrapped<String?>? password,
      Wrapped<String?>? type}) {
    return GeneratedPassword(
        externalId: (externalId != null ? externalId.value : this.externalId),
        userId: (userId != null ? userId.value : this.userId),
        password: (password != null ? password.value : this.password),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class GuidCreatedOnVersionHolder {
  GuidCreatedOnVersionHolder({
    this.guid,
    this.createdOn,
    this.version,
    this.type,
  });

  factory GuidCreatedOnVersionHolder.fromJson(Map<String, dynamic> json) =>
      _$GuidCreatedOnVersionHolderFromJson(json);

  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String? guid;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$GuidCreatedOnVersionHolderFromJson;
  static const toJsonFactory = _$GuidCreatedOnVersionHolderToJson;
  Map<String, dynamic> toJson() => _$GuidCreatedOnVersionHolderToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is GuidCreatedOnVersionHolder &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $GuidCreatedOnVersionHolderExtension on GuidCreatedOnVersionHolder {
  GuidCreatedOnVersionHolder copyWith(
      {String? guid, DateTime? createdOn, num? version, String? type}) {
    return GuidCreatedOnVersionHolder(
        guid: guid ?? this.guid,
        createdOn: createdOn ?? this.createdOn,
        version: version ?? this.version,
        type: type ?? this.type);
  }

  GuidCreatedOnVersionHolder copyWithWrapped(
      {Wrapped<String?>? guid,
      Wrapped<DateTime?>? createdOn,
      Wrapped<num?>? version,
      Wrapped<String?>? type}) {
    return GuidCreatedOnVersionHolder(
        guid: (guid != null ? guid.value : this.guid),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class GuidHolder {
  GuidHolder({
    this.guid,
    this.type,
  });

  factory GuidHolder.fromJson(Map<String, dynamic> json) =>
      _$GuidHolderFromJson(json);

  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String? guid;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$GuidHolderFromJson;
  static const toJsonFactory = _$GuidHolderToJson;
  Map<String, dynamic> toJson() => _$GuidHolderToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is GuidHolder &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $GuidHolderExtension on GuidHolder {
  GuidHolder copyWith({String? guid, String? type}) {
    return GuidHolder(guid: guid ?? this.guid, type: type ?? this.type);
  }

  GuidHolder copyWithWrapped({Wrapped<String?>? guid, Wrapped<String?>? type}) {
    return GuidHolder(
        guid: (guid != null ? guid.value : this.guid),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class GuidVersionHolder {
  GuidVersionHolder({
    this.guid,
    this.version,
    this.type,
  });

  factory GuidVersionHolder.fromJson(Map<String, dynamic> json) =>
      _$GuidVersionHolderFromJson(json);

  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String? guid;
  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$GuidVersionHolderFromJson;
  static const toJsonFactory = _$GuidVersionHolderToJson;
  Map<String, dynamic> toJson() => _$GuidVersionHolderToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is GuidVersionHolder &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $GuidVersionHolderExtension on GuidVersionHolder {
  GuidVersionHolder copyWith({String? guid, num? version, String? type}) {
    return GuidVersionHolder(
        guid: guid ?? this.guid,
        version: version ?? this.version,
        type: type ?? this.type);
  }

  GuidVersionHolder copyWithWrapped(
      {Wrapped<String?>? guid,
      Wrapped<num?>? version,
      Wrapped<String?>? type}) {
    return GuidVersionHolder(
        guid: (guid != null ? guid.value : this.guid),
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class HealthDataDocumentation {
  HealthDataDocumentation({
    this.title,
    this.parentId,
    this.identifier,
    this.version,
    required this.documentation,
    this.createdBy,
    this.createdOn,
    this.modifiedBy,
    this.modifiedOn,
    this.type,
  });

  factory HealthDataDocumentation.fromJson(Map<String, dynamic> json) =>
      _$HealthDataDocumentationFromJson(json);

  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'parentId', includeIfNull: false, defaultValue: '')
  final String? parentId;
  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String? identifier;
  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(name: 'documentation', includeIfNull: false, defaultValue: '')
  final String documentation;
  @JsonKey(name: 'createdBy', includeIfNull: false, defaultValue: '')
  final String? createdBy;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final Object? createdOn;
  @JsonKey(name: 'modifiedBy', includeIfNull: false, defaultValue: '')
  final String? modifiedBy;
  @JsonKey(name: 'modifiedOn', includeIfNull: false)
  final Object? modifiedOn;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$HealthDataDocumentationFromJson;
  static const toJsonFactory = _$HealthDataDocumentationToJson;
  Map<String, dynamic> toJson() => _$HealthDataDocumentationToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is HealthDataDocumentation &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.parentId, parentId) ||
                const DeepCollectionEquality()
                    .equals(other.parentId, parentId)) &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.documentation, documentation) ||
                const DeepCollectionEquality()
                    .equals(other.documentation, documentation)) &&
            (identical(other.createdBy, createdBy) ||
                const DeepCollectionEquality()
                    .equals(other.createdBy, createdBy)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.modifiedBy, modifiedBy) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedBy, modifiedBy)) &&
            (identical(other.modifiedOn, modifiedOn) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedOn, modifiedOn)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(parentId) ^
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(documentation) ^
      const DeepCollectionEquality().hash(createdBy) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(modifiedBy) ^
      const DeepCollectionEquality().hash(modifiedOn) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $HealthDataDocumentationExtension on HealthDataDocumentation {
  HealthDataDocumentation copyWith(
      {String? title,
      String? parentId,
      String? identifier,
      num? version,
      String? documentation,
      String? createdBy,
      Object? createdOn,
      String? modifiedBy,
      Object? modifiedOn,
      String? type}) {
    return HealthDataDocumentation(
        title: title ?? this.title,
        parentId: parentId ?? this.parentId,
        identifier: identifier ?? this.identifier,
        version: version ?? this.version,
        documentation: documentation ?? this.documentation,
        createdBy: createdBy ?? this.createdBy,
        createdOn: createdOn ?? this.createdOn,
        modifiedBy: modifiedBy ?? this.modifiedBy,
        modifiedOn: modifiedOn ?? this.modifiedOn,
        type: type ?? this.type);
  }

  HealthDataDocumentation copyWithWrapped(
      {Wrapped<String?>? title,
      Wrapped<String?>? parentId,
      Wrapped<String?>? identifier,
      Wrapped<num?>? version,
      Wrapped<String>? documentation,
      Wrapped<String?>? createdBy,
      Wrapped<Object?>? createdOn,
      Wrapped<String?>? modifiedBy,
      Wrapped<Object?>? modifiedOn,
      Wrapped<String?>? type}) {
    return HealthDataDocumentation(
        title: (title != null ? title.value : this.title),
        parentId: (parentId != null ? parentId.value : this.parentId),
        identifier: (identifier != null ? identifier.value : this.identifier),
        version: (version != null ? version.value : this.version),
        documentation:
            (documentation != null ? documentation.value : this.documentation),
        createdBy: (createdBy != null ? createdBy.value : this.createdBy),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        modifiedBy: (modifiedBy != null ? modifiedBy.value : this.modifiedBy),
        modifiedOn: (modifiedOn != null ? modifiedOn.value : this.modifiedOn),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class HealthDataRecord {
  HealthDataRecord({
    this.appVersion,
    this.createdOn,
    this.createdOnTimeZone,
    this.data,
    this.dayInStudy,
    this.id,
    this.metadata,
    this.phoneInfo,
    this.rawDataAttachmentId,
    this.schemaId,
    this.schemaRevision,
    this.appId,
    this.uploadDate,
    this.uploadId,
    this.uploadedOn,
    this.userMetadata,
    this.userSharingScope,
    this.userExternalId,
    required this.userDataGroups,
    this.userStudyMemberships,
    this.validationErrors,
    this.version,
    this.synapseExporterStatus,
    this.type,
  });

  factory HealthDataRecord.fromJson(Map<String, dynamic> json) =>
      _$HealthDataRecordFromJson(json);

  @JsonKey(name: 'appVersion', includeIfNull: false, defaultValue: '')
  final String? appVersion;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'createdOnTimeZone', includeIfNull: false, defaultValue: '')
  final String? createdOnTimeZone;
  @JsonKey(name: 'data', includeIfNull: false)
  final Object? data;
  @JsonKey(name: 'dayInStudy', includeIfNull: false)
  final int? dayInStudy;
  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'metadata', includeIfNull: false)
  final Object? metadata;
  @JsonKey(name: 'phoneInfo', includeIfNull: false, defaultValue: '')
  final String? phoneInfo;
  @JsonKey(name: 'rawDataAttachmentId', includeIfNull: false, defaultValue: '')
  final String? rawDataAttachmentId;
  @JsonKey(name: 'schemaId', includeIfNull: false, defaultValue: '')
  final String? schemaId;
  @JsonKey(name: 'schemaRevision', includeIfNull: false)
  final num? schemaRevision;
  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String? appId;
  @JsonKey(name: 'uploadDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? uploadDate;
  @JsonKey(name: 'uploadId', includeIfNull: false, defaultValue: '')
  final String? uploadId;
  @JsonKey(name: 'uploadedOn', includeIfNull: false)
  final DateTime? uploadedOn;
  @JsonKey(name: 'userMetadata', includeIfNull: false)
  final Object? userMetadata;
  @JsonKey(
    name: 'userSharingScope',
    includeIfNull: false,
    toJson: sharingScopeToJson,
    fromJson: sharingScopeFromJson,
  )
  final enums.SharingScope? userSharingScope;
  @JsonKey(name: 'userExternalId', includeIfNull: false, defaultValue: '')
  final String? userExternalId;
  @JsonKey(
      name: 'userDataGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String> userDataGroups;
  @JsonKey(name: 'userStudyMemberships', includeIfNull: false)
  final Map<String, dynamic>? userStudyMemberships;
  @JsonKey(name: 'validationErrors', includeIfNull: false, defaultValue: '')
  final String? validationErrors;
  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(
    name: 'synapseExporterStatus',
    includeIfNull: false,
    toJson: synapseExporterStatusToJson,
    fromJson: synapseExporterStatusFromJson,
  )
  final enums.SynapseExporterStatus? synapseExporterStatus;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$HealthDataRecordFromJson;
  static const toJsonFactory = _$HealthDataRecordToJson;
  Map<String, dynamic> toJson() => _$HealthDataRecordToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is HealthDataRecord &&
            (identical(other.appVersion, appVersion) ||
                const DeepCollectionEquality()
                    .equals(other.appVersion, appVersion)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.createdOnTimeZone, createdOnTimeZone) ||
                const DeepCollectionEquality()
                    .equals(other.createdOnTimeZone, createdOnTimeZone)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)) &&
            (identical(other.dayInStudy, dayInStudy) ||
                const DeepCollectionEquality()
                    .equals(other.dayInStudy, dayInStudy)) &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.metadata, metadata) ||
                const DeepCollectionEquality()
                    .equals(other.metadata, metadata)) &&
            (identical(other.phoneInfo, phoneInfo) ||
                const DeepCollectionEquality()
                    .equals(other.phoneInfo, phoneInfo)) &&
            (identical(other.rawDataAttachmentId, rawDataAttachmentId) ||
                const DeepCollectionEquality()
                    .equals(other.rawDataAttachmentId, rawDataAttachmentId)) &&
            (identical(other.schemaId, schemaId) ||
                const DeepCollectionEquality()
                    .equals(other.schemaId, schemaId)) &&
            (identical(other.schemaRevision, schemaRevision) ||
                const DeepCollectionEquality()
                    .equals(other.schemaRevision, schemaRevision)) &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)) &&
            (identical(other.uploadDate, uploadDate) ||
                const DeepCollectionEquality()
                    .equals(other.uploadDate, uploadDate)) &&
            (identical(other.uploadId, uploadId) ||
                const DeepCollectionEquality()
                    .equals(other.uploadId, uploadId)) &&
            (identical(other.uploadedOn, uploadedOn) ||
                const DeepCollectionEquality()
                    .equals(other.uploadedOn, uploadedOn)) &&
            (identical(other.userMetadata, userMetadata) ||
                const DeepCollectionEquality()
                    .equals(other.userMetadata, userMetadata)) &&
            (identical(other.userSharingScope, userSharingScope) ||
                const DeepCollectionEquality()
                    .equals(other.userSharingScope, userSharingScope)) &&
            (identical(other.userExternalId, userExternalId) ||
                const DeepCollectionEquality()
                    .equals(other.userExternalId, userExternalId)) &&
            (identical(other.userDataGroups, userDataGroups) ||
                const DeepCollectionEquality()
                    .equals(other.userDataGroups, userDataGroups)) &&
            (identical(other.userStudyMemberships, userStudyMemberships) ||
                const DeepCollectionEquality().equals(
                    other.userStudyMemberships, userStudyMemberships)) &&
            (identical(other.validationErrors, validationErrors) ||
                const DeepCollectionEquality()
                    .equals(other.validationErrors, validationErrors)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.synapseExporterStatus, synapseExporterStatus) ||
                const DeepCollectionEquality()
                    .equals(other.synapseExporterStatus, synapseExporterStatus)) &&
            (identical(other.type, type) || const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(appVersion) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(createdOnTimeZone) ^
      const DeepCollectionEquality().hash(data) ^
      const DeepCollectionEquality().hash(dayInStudy) ^
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(metadata) ^
      const DeepCollectionEquality().hash(phoneInfo) ^
      const DeepCollectionEquality().hash(rawDataAttachmentId) ^
      const DeepCollectionEquality().hash(schemaId) ^
      const DeepCollectionEquality().hash(schemaRevision) ^
      const DeepCollectionEquality().hash(appId) ^
      const DeepCollectionEquality().hash(uploadDate) ^
      const DeepCollectionEquality().hash(uploadId) ^
      const DeepCollectionEquality().hash(uploadedOn) ^
      const DeepCollectionEquality().hash(userMetadata) ^
      const DeepCollectionEquality().hash(userSharingScope) ^
      const DeepCollectionEquality().hash(userExternalId) ^
      const DeepCollectionEquality().hash(userDataGroups) ^
      const DeepCollectionEquality().hash(userStudyMemberships) ^
      const DeepCollectionEquality().hash(validationErrors) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(synapseExporterStatus) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $HealthDataRecordExtension on HealthDataRecord {
  HealthDataRecord copyWith(
      {String? appVersion,
      DateTime? createdOn,
      String? createdOnTimeZone,
      Object? data,
      int? dayInStudy,
      String? id,
      Object? metadata,
      String? phoneInfo,
      String? rawDataAttachmentId,
      String? schemaId,
      num? schemaRevision,
      String? appId,
      DateTime? uploadDate,
      String? uploadId,
      DateTime? uploadedOn,
      Object? userMetadata,
      enums.SharingScope? userSharingScope,
      String? userExternalId,
      List<String>? userDataGroups,
      Map<String, dynamic>? userStudyMemberships,
      String? validationErrors,
      num? version,
      enums.SynapseExporterStatus? synapseExporterStatus,
      String? type}) {
    return HealthDataRecord(
        appVersion: appVersion ?? this.appVersion,
        createdOn: createdOn ?? this.createdOn,
        createdOnTimeZone: createdOnTimeZone ?? this.createdOnTimeZone,
        data: data ?? this.data,
        dayInStudy: dayInStudy ?? this.dayInStudy,
        id: id ?? this.id,
        metadata: metadata ?? this.metadata,
        phoneInfo: phoneInfo ?? this.phoneInfo,
        rawDataAttachmentId: rawDataAttachmentId ?? this.rawDataAttachmentId,
        schemaId: schemaId ?? this.schemaId,
        schemaRevision: schemaRevision ?? this.schemaRevision,
        appId: appId ?? this.appId,
        uploadDate: uploadDate ?? this.uploadDate,
        uploadId: uploadId ?? this.uploadId,
        uploadedOn: uploadedOn ?? this.uploadedOn,
        userMetadata: userMetadata ?? this.userMetadata,
        userSharingScope: userSharingScope ?? this.userSharingScope,
        userExternalId: userExternalId ?? this.userExternalId,
        userDataGroups: userDataGroups ?? this.userDataGroups,
        userStudyMemberships: userStudyMemberships ?? this.userStudyMemberships,
        validationErrors: validationErrors ?? this.validationErrors,
        version: version ?? this.version,
        synapseExporterStatus:
            synapseExporterStatus ?? this.synapseExporterStatus,
        type: type ?? this.type);
  }

  HealthDataRecord copyWithWrapped(
      {Wrapped<String?>? appVersion,
      Wrapped<DateTime?>? createdOn,
      Wrapped<String?>? createdOnTimeZone,
      Wrapped<Object?>? data,
      Wrapped<int?>? dayInStudy,
      Wrapped<String?>? id,
      Wrapped<Object?>? metadata,
      Wrapped<String?>? phoneInfo,
      Wrapped<String?>? rawDataAttachmentId,
      Wrapped<String?>? schemaId,
      Wrapped<num?>? schemaRevision,
      Wrapped<String?>? appId,
      Wrapped<DateTime?>? uploadDate,
      Wrapped<String?>? uploadId,
      Wrapped<DateTime?>? uploadedOn,
      Wrapped<Object?>? userMetadata,
      Wrapped<enums.SharingScope?>? userSharingScope,
      Wrapped<String?>? userExternalId,
      Wrapped<List<String>>? userDataGroups,
      Wrapped<Map<String, dynamic>?>? userStudyMemberships,
      Wrapped<String?>? validationErrors,
      Wrapped<num?>? version,
      Wrapped<enums.SynapseExporterStatus?>? synapseExporterStatus,
      Wrapped<String?>? type}) {
    return HealthDataRecord(
        appVersion: (appVersion != null ? appVersion.value : this.appVersion),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        createdOnTimeZone: (createdOnTimeZone != null
            ? createdOnTimeZone.value
            : this.createdOnTimeZone),
        data: (data != null ? data.value : this.data),
        dayInStudy: (dayInStudy != null ? dayInStudy.value : this.dayInStudy),
        id: (id != null ? id.value : this.id),
        metadata: (metadata != null ? metadata.value : this.metadata),
        phoneInfo: (phoneInfo != null ? phoneInfo.value : this.phoneInfo),
        rawDataAttachmentId: (rawDataAttachmentId != null
            ? rawDataAttachmentId.value
            : this.rawDataAttachmentId),
        schemaId: (schemaId != null ? schemaId.value : this.schemaId),
        schemaRevision: (schemaRevision != null
            ? schemaRevision.value
            : this.schemaRevision),
        appId: (appId != null ? appId.value : this.appId),
        uploadDate: (uploadDate != null ? uploadDate.value : this.uploadDate),
        uploadId: (uploadId != null ? uploadId.value : this.uploadId),
        uploadedOn: (uploadedOn != null ? uploadedOn.value : this.uploadedOn),
        userMetadata:
            (userMetadata != null ? userMetadata.value : this.userMetadata),
        userSharingScope: (userSharingScope != null
            ? userSharingScope.value
            : this.userSharingScope),
        userExternalId: (userExternalId != null
            ? userExternalId.value
            : this.userExternalId),
        userDataGroups: (userDataGroups != null
            ? userDataGroups.value
            : this.userDataGroups),
        userStudyMemberships: (userStudyMemberships != null
            ? userStudyMemberships.value
            : this.userStudyMemberships),
        validationErrors: (validationErrors != null
            ? validationErrors.value
            : this.validationErrors),
        version: (version != null ? version.value : this.version),
        synapseExporterStatus: (synapseExporterStatus != null
            ? synapseExporterStatus.value
            : this.synapseExporterStatus),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class HealthDataRecordEx3 {
  HealthDataRecordEx3({
    this.id,
    required this.appId,
    this.studyId,
    required this.healthCode,
    required this.createdOn,
    this.clientInfo,
    this.exported,
    this.exportedOn,
    this.metadata,
    this.sharingScope,
    this.version,
    this.type,
  });

  factory HealthDataRecordEx3.fromJson(Map<String, dynamic> json) =>
      _$HealthDataRecordEx3FromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String appId;
  @JsonKey(name: 'studyId', includeIfNull: false, defaultValue: '')
  final String? studyId;
  @JsonKey(name: 'healthCode', includeIfNull: false, defaultValue: '')
  final String healthCode;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime createdOn;
  @JsonKey(name: 'clientInfo', includeIfNull: false, defaultValue: '')
  final String? clientInfo;
  @JsonKey(name: 'exported', includeIfNull: false, defaultValue: false)
  final bool? exported;
  @JsonKey(name: 'exportedOn', includeIfNull: false)
  final DateTime? exportedOn;
  @JsonKey(name: 'metadata', includeIfNull: false)
  final Map<String, dynamic>? metadata;
  @JsonKey(
    name: 'sharingScope',
    includeIfNull: false,
    toJson: sharingScopeToJson,
    fromJson: sharingScopeFromJson,
  )
  final enums.SharingScope? sharingScope;
  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$HealthDataRecordEx3FromJson;
  static const toJsonFactory = _$HealthDataRecordEx3ToJson;
  Map<String, dynamic> toJson() => _$HealthDataRecordEx3ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is HealthDataRecordEx3 &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)) &&
            (identical(other.studyId, studyId) ||
                const DeepCollectionEquality()
                    .equals(other.studyId, studyId)) &&
            (identical(other.healthCode, healthCode) ||
                const DeepCollectionEquality()
                    .equals(other.healthCode, healthCode)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.clientInfo, clientInfo) ||
                const DeepCollectionEquality()
                    .equals(other.clientInfo, clientInfo)) &&
            (identical(other.exported, exported) ||
                const DeepCollectionEquality()
                    .equals(other.exported, exported)) &&
            (identical(other.exportedOn, exportedOn) ||
                const DeepCollectionEquality()
                    .equals(other.exportedOn, exportedOn)) &&
            (identical(other.metadata, metadata) ||
                const DeepCollectionEquality()
                    .equals(other.metadata, metadata)) &&
            (identical(other.sharingScope, sharingScope) ||
                const DeepCollectionEquality()
                    .equals(other.sharingScope, sharingScope)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(appId) ^
      const DeepCollectionEquality().hash(studyId) ^
      const DeepCollectionEquality().hash(healthCode) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(clientInfo) ^
      const DeepCollectionEquality().hash(exported) ^
      const DeepCollectionEquality().hash(exportedOn) ^
      const DeepCollectionEquality().hash(metadata) ^
      const DeepCollectionEquality().hash(sharingScope) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $HealthDataRecordEx3Extension on HealthDataRecordEx3 {
  HealthDataRecordEx3 copyWith(
      {String? id,
      String? appId,
      String? studyId,
      String? healthCode,
      DateTime? createdOn,
      String? clientInfo,
      bool? exported,
      DateTime? exportedOn,
      Map<String, dynamic>? metadata,
      enums.SharingScope? sharingScope,
      num? version,
      String? type}) {
    return HealthDataRecordEx3(
        id: id ?? this.id,
        appId: appId ?? this.appId,
        studyId: studyId ?? this.studyId,
        healthCode: healthCode ?? this.healthCode,
        createdOn: createdOn ?? this.createdOn,
        clientInfo: clientInfo ?? this.clientInfo,
        exported: exported ?? this.exported,
        exportedOn: exportedOn ?? this.exportedOn,
        metadata: metadata ?? this.metadata,
        sharingScope: sharingScope ?? this.sharingScope,
        version: version ?? this.version,
        type: type ?? this.type);
  }

  HealthDataRecordEx3 copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String>? appId,
      Wrapped<String?>? studyId,
      Wrapped<String>? healthCode,
      Wrapped<DateTime>? createdOn,
      Wrapped<String?>? clientInfo,
      Wrapped<bool?>? exported,
      Wrapped<DateTime?>? exportedOn,
      Wrapped<Map<String, dynamic>?>? metadata,
      Wrapped<enums.SharingScope?>? sharingScope,
      Wrapped<num?>? version,
      Wrapped<String?>? type}) {
    return HealthDataRecordEx3(
        id: (id != null ? id.value : this.id),
        appId: (appId != null ? appId.value : this.appId),
        studyId: (studyId != null ? studyId.value : this.studyId),
        healthCode: (healthCode != null ? healthCode.value : this.healthCode),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        clientInfo: (clientInfo != null ? clientInfo.value : this.clientInfo),
        exported: (exported != null ? exported.value : this.exported),
        exportedOn: (exportedOn != null ? exportedOn.value : this.exportedOn),
        metadata: (metadata != null ? metadata.value : this.metadata),
        sharingScope:
            (sharingScope != null ? sharingScope.value : this.sharingScope),
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class HealthDataSubmission {
  HealthDataSubmission({
    required this.appVersion,
    this.createdOn,
    required this.data,
    this.metadata,
    required this.phoneInfo,
    this.schemaId,
    this.schemaRevision,
    this.surveyCreatedOn,
    this.surveyGuid,
    this.type,
  });

  factory HealthDataSubmission.fromJson(Map<String, dynamic> json) =>
      _$HealthDataSubmissionFromJson(json);

  @JsonKey(name: 'appVersion', includeIfNull: false, defaultValue: '')
  final String appVersion;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'data', includeIfNull: false)
  final Object data;
  @JsonKey(name: 'metadata', includeIfNull: false)
  final Object? metadata;
  @JsonKey(name: 'phoneInfo', includeIfNull: false, defaultValue: '')
  final String phoneInfo;
  @JsonKey(name: 'schemaId', includeIfNull: false, defaultValue: '')
  final String? schemaId;
  @JsonKey(name: 'schemaRevision', includeIfNull: false)
  final num? schemaRevision;
  @JsonKey(name: 'surveyCreatedOn', includeIfNull: false)
  final DateTime? surveyCreatedOn;
  @JsonKey(name: 'surveyGuid', includeIfNull: false, defaultValue: '')
  final String? surveyGuid;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$HealthDataSubmissionFromJson;
  static const toJsonFactory = _$HealthDataSubmissionToJson;
  Map<String, dynamic> toJson() => _$HealthDataSubmissionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is HealthDataSubmission &&
            (identical(other.appVersion, appVersion) ||
                const DeepCollectionEquality()
                    .equals(other.appVersion, appVersion)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)) &&
            (identical(other.metadata, metadata) ||
                const DeepCollectionEquality()
                    .equals(other.metadata, metadata)) &&
            (identical(other.phoneInfo, phoneInfo) ||
                const DeepCollectionEquality()
                    .equals(other.phoneInfo, phoneInfo)) &&
            (identical(other.schemaId, schemaId) ||
                const DeepCollectionEquality()
                    .equals(other.schemaId, schemaId)) &&
            (identical(other.schemaRevision, schemaRevision) ||
                const DeepCollectionEquality()
                    .equals(other.schemaRevision, schemaRevision)) &&
            (identical(other.surveyCreatedOn, surveyCreatedOn) ||
                const DeepCollectionEquality()
                    .equals(other.surveyCreatedOn, surveyCreatedOn)) &&
            (identical(other.surveyGuid, surveyGuid) ||
                const DeepCollectionEquality()
                    .equals(other.surveyGuid, surveyGuid)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(appVersion) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(data) ^
      const DeepCollectionEquality().hash(metadata) ^
      const DeepCollectionEquality().hash(phoneInfo) ^
      const DeepCollectionEquality().hash(schemaId) ^
      const DeepCollectionEquality().hash(schemaRevision) ^
      const DeepCollectionEquality().hash(surveyCreatedOn) ^
      const DeepCollectionEquality().hash(surveyGuid) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $HealthDataSubmissionExtension on HealthDataSubmission {
  HealthDataSubmission copyWith(
      {String? appVersion,
      DateTime? createdOn,
      Object? data,
      Object? metadata,
      String? phoneInfo,
      String? schemaId,
      num? schemaRevision,
      DateTime? surveyCreatedOn,
      String? surveyGuid,
      String? type}) {
    return HealthDataSubmission(
        appVersion: appVersion ?? this.appVersion,
        createdOn: createdOn ?? this.createdOn,
        data: data ?? this.data,
        metadata: metadata ?? this.metadata,
        phoneInfo: phoneInfo ?? this.phoneInfo,
        schemaId: schemaId ?? this.schemaId,
        schemaRevision: schemaRevision ?? this.schemaRevision,
        surveyCreatedOn: surveyCreatedOn ?? this.surveyCreatedOn,
        surveyGuid: surveyGuid ?? this.surveyGuid,
        type: type ?? this.type);
  }

  HealthDataSubmission copyWithWrapped(
      {Wrapped<String>? appVersion,
      Wrapped<DateTime?>? createdOn,
      Wrapped<Object>? data,
      Wrapped<Object?>? metadata,
      Wrapped<String>? phoneInfo,
      Wrapped<String?>? schemaId,
      Wrapped<num?>? schemaRevision,
      Wrapped<DateTime?>? surveyCreatedOn,
      Wrapped<String?>? surveyGuid,
      Wrapped<String?>? type}) {
    return HealthDataSubmission(
        appVersion: (appVersion != null ? appVersion.value : this.appVersion),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        data: (data != null ? data.value : this.data),
        metadata: (metadata != null ? metadata.value : this.metadata),
        phoneInfo: (phoneInfo != null ? phoneInfo.value : this.phoneInfo),
        schemaId: (schemaId != null ? schemaId.value : this.schemaId),
        schemaRevision: (schemaRevision != null
            ? schemaRevision.value
            : this.schemaRevision),
        surveyCreatedOn: (surveyCreatedOn != null
            ? surveyCreatedOn.value
            : this.surveyCreatedOn),
        surveyGuid: (surveyGuid != null ? surveyGuid.value : this.surveyGuid),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class FileMetadata {
  FileMetadata({
    required this.name,
    this.guid,
    this.description,
    this.disposition,
    this.createdOn,
    this.modifiedOn,
    this.deleted,
    this.version,
    this.type,
  });

  factory FileMetadata.fromJson(Map<String, dynamic> json) =>
      _$FileMetadataFromJson(json);

  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String? guid;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(
    name: 'disposition',
    includeIfNull: false,
    toJson: fileDispositionToJson,
    fromJson: fileDispositionDispositionFromJson,
  )
  final enums.FileDisposition? disposition;
  static enums.FileDisposition fileDispositionDispositionFromJson(
          Object? value) =>
      fileDispositionFromJson(value, enums.FileDisposition.attachment);

  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'modifiedOn', includeIfNull: false)
  final DateTime? modifiedOn;
  @JsonKey(name: 'deleted', includeIfNull: false)
  final bool? deleted;
  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$FileMetadataFromJson;
  static const toJsonFactory = _$FileMetadataToJson;
  Map<String, dynamic> toJson() => _$FileMetadataToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FileMetadata &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.disposition, disposition) ||
                const DeepCollectionEquality()
                    .equals(other.disposition, disposition)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.modifiedOn, modifiedOn) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedOn, modifiedOn)) &&
            (identical(other.deleted, deleted) ||
                const DeepCollectionEquality()
                    .equals(other.deleted, deleted)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(disposition) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(modifiedOn) ^
      const DeepCollectionEquality().hash(deleted) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $FileMetadataExtension on FileMetadata {
  FileMetadata copyWith(
      {String? name,
      String? guid,
      String? description,
      enums.FileDisposition? disposition,
      DateTime? createdOn,
      DateTime? modifiedOn,
      bool? deleted,
      num? version,
      String? type}) {
    return FileMetadata(
        name: name ?? this.name,
        guid: guid ?? this.guid,
        description: description ?? this.description,
        disposition: disposition ?? this.disposition,
        createdOn: createdOn ?? this.createdOn,
        modifiedOn: modifiedOn ?? this.modifiedOn,
        deleted: deleted ?? this.deleted,
        version: version ?? this.version,
        type: type ?? this.type);
  }

  FileMetadata copyWithWrapped(
      {Wrapped<String>? name,
      Wrapped<String?>? guid,
      Wrapped<String?>? description,
      Wrapped<enums.FileDisposition?>? disposition,
      Wrapped<DateTime?>? createdOn,
      Wrapped<DateTime?>? modifiedOn,
      Wrapped<bool?>? deleted,
      Wrapped<num?>? version,
      Wrapped<String?>? type}) {
    return FileMetadata(
        name: (name != null ? name.value : this.name),
        guid: (guid != null ? guid.value : this.guid),
        description:
            (description != null ? description.value : this.description),
        disposition:
            (disposition != null ? disposition.value : this.disposition),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        modifiedOn: (modifiedOn != null ? modifiedOn.value : this.modifiedOn),
        deleted: (deleted != null ? deleted.value : this.deleted),
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class FileRevision {
  FileRevision({
    required this.name,
    this.fileGuid,
    this.description,
    required this.mimeType,
    this.createdOn,
    required this.size,
    this.uploadURL,
    this.downloadURL,
    this.status,
    this.type,
  });

  factory FileRevision.fromJson(Map<String, dynamic> json) =>
      _$FileRevisionFromJson(json);

  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'fileGuid', includeIfNull: false, defaultValue: '')
  final String? fileGuid;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'mimeType', includeIfNull: false, defaultValue: '')
  final String mimeType;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'size', includeIfNull: false)
  final num size;
  @JsonKey(name: 'uploadURL', includeIfNull: false, defaultValue: '')
  final String? uploadURL;
  @JsonKey(name: 'downloadURL', includeIfNull: false, defaultValue: '')
  final String? downloadURL;
  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: fileRevisionStatusToJson,
    fromJson: fileRevisionStatusFromJson,
  )
  final enums.FileRevisionStatus? status;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$FileRevisionFromJson;
  static const toJsonFactory = _$FileRevisionToJson;
  Map<String, dynamic> toJson() => _$FileRevisionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FileRevision &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.fileGuid, fileGuid) ||
                const DeepCollectionEquality()
                    .equals(other.fileGuid, fileGuid)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.mimeType, mimeType) ||
                const DeepCollectionEquality()
                    .equals(other.mimeType, mimeType)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.size, size) ||
                const DeepCollectionEquality().equals(other.size, size)) &&
            (identical(other.uploadURL, uploadURL) ||
                const DeepCollectionEquality()
                    .equals(other.uploadURL, uploadURL)) &&
            (identical(other.downloadURL, downloadURL) ||
                const DeepCollectionEquality()
                    .equals(other.downloadURL, downloadURL)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(fileGuid) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(mimeType) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(size) ^
      const DeepCollectionEquality().hash(uploadURL) ^
      const DeepCollectionEquality().hash(downloadURL) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $FileRevisionExtension on FileRevision {
  FileRevision copyWith(
      {String? name,
      String? fileGuid,
      String? description,
      String? mimeType,
      DateTime? createdOn,
      num? size,
      String? uploadURL,
      String? downloadURL,
      enums.FileRevisionStatus? status,
      String? type}) {
    return FileRevision(
        name: name ?? this.name,
        fileGuid: fileGuid ?? this.fileGuid,
        description: description ?? this.description,
        mimeType: mimeType ?? this.mimeType,
        createdOn: createdOn ?? this.createdOn,
        size: size ?? this.size,
        uploadURL: uploadURL ?? this.uploadURL,
        downloadURL: downloadURL ?? this.downloadURL,
        status: status ?? this.status,
        type: type ?? this.type);
  }

  FileRevision copyWithWrapped(
      {Wrapped<String>? name,
      Wrapped<String?>? fileGuid,
      Wrapped<String?>? description,
      Wrapped<String>? mimeType,
      Wrapped<DateTime?>? createdOn,
      Wrapped<num>? size,
      Wrapped<String?>? uploadURL,
      Wrapped<String?>? downloadURL,
      Wrapped<enums.FileRevisionStatus?>? status,
      Wrapped<String?>? type}) {
    return FileRevision(
        name: (name != null ? name.value : this.name),
        fileGuid: (fileGuid != null ? fileGuid.value : this.fileGuid),
        description:
            (description != null ? description.value : this.description),
        mimeType: (mimeType != null ? mimeType.value : this.mimeType),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        size: (size != null ? size.value : this.size),
        uploadURL: (uploadURL != null ? uploadURL.value : this.uploadURL),
        downloadURL:
            (downloadURL != null ? downloadURL.value : this.downloadURL),
        status: (status != null ? status.value : this.status),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Identifier {
  Identifier({
    this.email,
    this.phone,
    required this.appId,
    this.type,
  });

  factory Identifier.fromJson(Map<String, dynamic> json) =>
      _$IdentifierFromJson(json);

  @JsonKey(name: 'email', includeIfNull: false, defaultValue: '')
  final String? email;
  @JsonKey(name: 'phone', includeIfNull: false)
  final Phone? phone;
  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String appId;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$IdentifierFromJson;
  static const toJsonFactory = _$IdentifierToJson;
  Map<String, dynamic> toJson() => _$IdentifierToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Identifier &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(phone) ^
      const DeepCollectionEquality().hash(appId) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $IdentifierExtension on Identifier {
  Identifier copyWith(
      {String? email, Phone? phone, String? appId, String? type}) {
    return Identifier(
        email: email ?? this.email,
        phone: phone ?? this.phone,
        appId: appId ?? this.appId,
        type: type ?? this.type);
  }

  Identifier copyWithWrapped(
      {Wrapped<String?>? email,
      Wrapped<Phone?>? phone,
      Wrapped<String>? appId,
      Wrapped<String?>? type}) {
    return Identifier(
        email: (email != null ? email.value : this.email),
        phone: (phone != null ? phone.value : this.phone),
        appId: (appId != null ? appId.value : this.appId),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class IdentifierHolder {
  IdentifierHolder({
    this.identifier,
    this.type,
  });

  factory IdentifierHolder.fromJson(Map<String, dynamic> json) =>
      _$IdentifierHolderFromJson(json);

  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String? identifier;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$IdentifierHolderFromJson;
  static const toJsonFactory = _$IdentifierHolderToJson;
  Map<String, dynamic> toJson() => _$IdentifierHolderToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is IdentifierHolder &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $IdentifierHolderExtension on IdentifierHolder {
  IdentifierHolder copyWith({String? identifier, String? type}) {
    return IdentifierHolder(
        identifier: identifier ?? this.identifier, type: type ?? this.type);
  }

  IdentifierHolder copyWithWrapped(
      {Wrapped<String?>? identifier, Wrapped<String?>? type}) {
    return IdentifierHolder(
        identifier: (identifier != null ? identifier.value : this.identifier),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class IdentifierUpdate {
  IdentifierUpdate({
    required this.signIn,
    this.emailUpdate,
    this.phoneUpdate,
    this.synapseUserIdUpdate,
    this.type,
  });

  factory IdentifierUpdate.fromJson(Map<String, dynamic> json) =>
      _$IdentifierUpdateFromJson(json);

  @JsonKey(name: 'signIn', includeIfNull: false)
  final SignIn signIn;
  @JsonKey(name: 'emailUpdate', includeIfNull: false, defaultValue: '')
  final String? emailUpdate;
  @JsonKey(name: 'phoneUpdate', includeIfNull: false)
  final Phone? phoneUpdate;
  @JsonKey(name: 'synapseUserIdUpdate', includeIfNull: false, defaultValue: '')
  final String? synapseUserIdUpdate;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$IdentifierUpdateFromJson;
  static const toJsonFactory = _$IdentifierUpdateToJson;
  Map<String, dynamic> toJson() => _$IdentifierUpdateToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is IdentifierUpdate &&
            (identical(other.signIn, signIn) ||
                const DeepCollectionEquality().equals(other.signIn, signIn)) &&
            (identical(other.emailUpdate, emailUpdate) ||
                const DeepCollectionEquality()
                    .equals(other.emailUpdate, emailUpdate)) &&
            (identical(other.phoneUpdate, phoneUpdate) ||
                const DeepCollectionEquality()
                    .equals(other.phoneUpdate, phoneUpdate)) &&
            (identical(other.synapseUserIdUpdate, synapseUserIdUpdate) ||
                const DeepCollectionEquality()
                    .equals(other.synapseUserIdUpdate, synapseUserIdUpdate)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(signIn) ^
      const DeepCollectionEquality().hash(emailUpdate) ^
      const DeepCollectionEquality().hash(phoneUpdate) ^
      const DeepCollectionEquality().hash(synapseUserIdUpdate) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $IdentifierUpdateExtension on IdentifierUpdate {
  IdentifierUpdate copyWith(
      {SignIn? signIn,
      String? emailUpdate,
      Phone? phoneUpdate,
      String? synapseUserIdUpdate,
      String? type}) {
    return IdentifierUpdate(
        signIn: signIn ?? this.signIn,
        emailUpdate: emailUpdate ?? this.emailUpdate,
        phoneUpdate: phoneUpdate ?? this.phoneUpdate,
        synapseUserIdUpdate: synapseUserIdUpdate ?? this.synapseUserIdUpdate,
        type: type ?? this.type);
  }

  IdentifierUpdate copyWithWrapped(
      {Wrapped<SignIn>? signIn,
      Wrapped<String?>? emailUpdate,
      Wrapped<Phone?>? phoneUpdate,
      Wrapped<String?>? synapseUserIdUpdate,
      Wrapped<String?>? type}) {
    return IdentifierUpdate(
        signIn: (signIn != null ? signIn.value : this.signIn),
        emailUpdate:
            (emailUpdate != null ? emailUpdate.value : this.emailUpdate),
        phoneUpdate:
            (phoneUpdate != null ? phoneUpdate.value : this.phoneUpdate),
        synapseUserIdUpdate: (synapseUserIdUpdate != null
            ? synapseUserIdUpdate.value
            : this.synapseUserIdUpdate),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Image {
  Image({
    required this.source,
    this.width,
    this.height,
    this.type,
  });

  factory Image.fromJson(Map<String, dynamic> json) => _$ImageFromJson(json);

  @JsonKey(name: 'source', includeIfNull: false, defaultValue: '')
  final String source;
  @JsonKey(name: 'width', includeIfNull: false)
  final int? width;
  @JsonKey(name: 'height', includeIfNull: false)
  final int? height;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ImageFromJson;
  static const toJsonFactory = _$ImageToJson;
  Map<String, dynamic> toJson() => _$ImageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Image &&
            (identical(other.source, source) ||
                const DeepCollectionEquality().equals(other.source, source)) &&
            (identical(other.width, width) ||
                const DeepCollectionEquality().equals(other.width, width)) &&
            (identical(other.height, height) ||
                const DeepCollectionEquality().equals(other.height, height)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(source) ^
      const DeepCollectionEquality().hash(width) ^
      const DeepCollectionEquality().hash(height) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ImageExtension on Image {
  Image copyWith({String? source, int? width, int? height, String? type}) {
    return Image(
        source: source ?? this.source,
        width: width ?? this.width,
        height: height ?? this.height,
        type: type ?? this.type);
  }

  Image copyWithWrapped(
      {Wrapped<String>? source,
      Wrapped<int?>? width,
      Wrapped<int?>? height,
      Wrapped<String?>? type}) {
    return Image(
        source: (source != null ? source.value : this.source),
        width: (width != null ? width.value : this.width),
        height: (height != null ? height.value : this.height),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class IntentToParticipate {
  IntentToParticipate({
    this.appId,
    required this.subpopGuid,
    this.osName,
    this.phone,
    this.email,
    required this.consentSignature,
    required this.scope,
    this.type,
  });

  factory IntentToParticipate.fromJson(Map<String, dynamic> json) =>
      _$IntentToParticipateFromJson(json);

  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String? appId;
  @JsonKey(name: 'subpopGuid', includeIfNull: false, defaultValue: '')
  final String subpopGuid;
  @JsonKey(name: 'osName', includeIfNull: false, defaultValue: '')
  final String? osName;
  @JsonKey(name: 'phone', includeIfNull: false)
  final Phone? phone;
  @JsonKey(name: 'email', includeIfNull: false, defaultValue: '')
  final String? email;
  @JsonKey(name: 'consentSignature', includeIfNull: false)
  final ConsentSignature consentSignature;
  @JsonKey(
    name: 'scope',
    includeIfNull: false,
    toJson: sharingScopeToJson,
    fromJson: sharingScopeFromJson,
  )
  final enums.SharingScope scope;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$IntentToParticipateFromJson;
  static const toJsonFactory = _$IntentToParticipateToJson;
  Map<String, dynamic> toJson() => _$IntentToParticipateToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is IntentToParticipate &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)) &&
            (identical(other.subpopGuid, subpopGuid) ||
                const DeepCollectionEquality()
                    .equals(other.subpopGuid, subpopGuid)) &&
            (identical(other.osName, osName) ||
                const DeepCollectionEquality().equals(other.osName, osName)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.consentSignature, consentSignature) ||
                const DeepCollectionEquality()
                    .equals(other.consentSignature, consentSignature)) &&
            (identical(other.scope, scope) ||
                const DeepCollectionEquality().equals(other.scope, scope)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(appId) ^
      const DeepCollectionEquality().hash(subpopGuid) ^
      const DeepCollectionEquality().hash(osName) ^
      const DeepCollectionEquality().hash(phone) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(consentSignature) ^
      const DeepCollectionEquality().hash(scope) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $IntentToParticipateExtension on IntentToParticipate {
  IntentToParticipate copyWith(
      {String? appId,
      String? subpopGuid,
      String? osName,
      Phone? phone,
      String? email,
      ConsentSignature? consentSignature,
      enums.SharingScope? scope,
      String? type}) {
    return IntentToParticipate(
        appId: appId ?? this.appId,
        subpopGuid: subpopGuid ?? this.subpopGuid,
        osName: osName ?? this.osName,
        phone: phone ?? this.phone,
        email: email ?? this.email,
        consentSignature: consentSignature ?? this.consentSignature,
        scope: scope ?? this.scope,
        type: type ?? this.type);
  }

  IntentToParticipate copyWithWrapped(
      {Wrapped<String?>? appId,
      Wrapped<String>? subpopGuid,
      Wrapped<String?>? osName,
      Wrapped<Phone?>? phone,
      Wrapped<String?>? email,
      Wrapped<ConsentSignature>? consentSignature,
      Wrapped<enums.SharingScope>? scope,
      Wrapped<String?>? type}) {
    return IntentToParticipate(
        appId: (appId != null ? appId.value : this.appId),
        subpopGuid: (subpopGuid != null ? subpopGuid.value : this.subpopGuid),
        osName: (osName != null ? osName.value : this.osName),
        phone: (phone != null ? phone.value : this.phone),
        email: (email != null ? email.value : this.email),
        consentSignature: (consentSignature != null
            ? consentSignature.value
            : this.consentSignature),
        scope: (scope != null ? scope.value : this.scope),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class InvalidEntity {
  InvalidEntity({
    this.message,
    this.errors,
  });

  factory InvalidEntity.fromJson(Map<String, dynamic> json) =>
      _$InvalidEntityFromJson(json);

  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'errors', includeIfNull: false)
  final Map<String, dynamic>? errors;
  static const fromJsonFactory = _$InvalidEntityFromJson;
  static const toJsonFactory = _$InvalidEntityToJson;
  Map<String, dynamic> toJson() => _$InvalidEntityToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is InvalidEntity &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.errors, errors) ||
                const DeepCollectionEquality().equals(other.errors, errors)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(errors) ^
      runtimeType.hashCode;
}

extension $InvalidEntityExtension on InvalidEntity {
  InvalidEntity copyWith({String? message, Map<String, dynamic>? errors}) {
    return InvalidEntity(
        message: message ?? this.message, errors: errors ?? this.errors);
  }

  InvalidEntity copyWithWrapped(
      {Wrapped<String?>? message, Wrapped<Map<String, dynamic>?>? errors}) {
    return InvalidEntity(
        message: (message != null ? message.value : this.message),
        errors: (errors != null ? errors.value : this.errors));
  }
}

@JsonSerializable(explicitToJson: true)
class Label {
  Label({
    this.lang,
    this.value,
    this.type,
  });

  factory Label.fromJson(Map<String, dynamic> json) => _$LabelFromJson(json);

  @JsonKey(name: 'lang', includeIfNull: false, defaultValue: '')
  final String? lang;
  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String? value;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$LabelFromJson;
  static const toJsonFactory = _$LabelToJson;
  Map<String, dynamic> toJson() => _$LabelToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Label &&
            (identical(other.lang, lang) ||
                const DeepCollectionEquality().equals(other.lang, lang)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(lang) ^
      const DeepCollectionEquality().hash(value) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $LabelExtension on Label {
  Label copyWith({String? lang, String? value, String? type}) {
    return Label(
        lang: lang ?? this.lang,
        value: value ?? this.value,
        type: type ?? this.type);
  }

  Label copyWithWrapped(
      {Wrapped<String?>? lang,
      Wrapped<String?>? value,
      Wrapped<String?>? type}) {
    return Label(
        lang: (lang != null ? lang.value : this.lang),
        value: (value != null ? value.value : this.value),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class MasterSchedulerConfig {
  MasterSchedulerConfig({
    required this.scheduleId,
    this.cronSchedule,
    this.requestTemplate,
    this.sqsQueueUrl,
    this.version,
    this.type,
  });

  factory MasterSchedulerConfig.fromJson(Map<String, dynamic> json) =>
      _$MasterSchedulerConfigFromJson(json);

  @JsonKey(name: 'scheduleId', includeIfNull: false, defaultValue: '')
  final String scheduleId;
  @JsonKey(name: 'cronSchedule', includeIfNull: false, defaultValue: '')
  final String? cronSchedule;
  @JsonKey(name: 'requestTemplate', includeIfNull: false)
  final Object? requestTemplate;
  @JsonKey(name: 'sqsQueueUrl', includeIfNull: false, defaultValue: '')
  final String? sqsQueueUrl;
  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$MasterSchedulerConfigFromJson;
  static const toJsonFactory = _$MasterSchedulerConfigToJson;
  Map<String, dynamic> toJson() => _$MasterSchedulerConfigToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MasterSchedulerConfig &&
            (identical(other.scheduleId, scheduleId) ||
                const DeepCollectionEquality()
                    .equals(other.scheduleId, scheduleId)) &&
            (identical(other.cronSchedule, cronSchedule) ||
                const DeepCollectionEquality()
                    .equals(other.cronSchedule, cronSchedule)) &&
            (identical(other.requestTemplate, requestTemplate) ||
                const DeepCollectionEquality()
                    .equals(other.requestTemplate, requestTemplate)) &&
            (identical(other.sqsQueueUrl, sqsQueueUrl) ||
                const DeepCollectionEquality()
                    .equals(other.sqsQueueUrl, sqsQueueUrl)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(scheduleId) ^
      const DeepCollectionEquality().hash(cronSchedule) ^
      const DeepCollectionEquality().hash(requestTemplate) ^
      const DeepCollectionEquality().hash(sqsQueueUrl) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $MasterSchedulerConfigExtension on MasterSchedulerConfig {
  MasterSchedulerConfig copyWith(
      {String? scheduleId,
      String? cronSchedule,
      Object? requestTemplate,
      String? sqsQueueUrl,
      num? version,
      String? type}) {
    return MasterSchedulerConfig(
        scheduleId: scheduleId ?? this.scheduleId,
        cronSchedule: cronSchedule ?? this.cronSchedule,
        requestTemplate: requestTemplate ?? this.requestTemplate,
        sqsQueueUrl: sqsQueueUrl ?? this.sqsQueueUrl,
        version: version ?? this.version,
        type: type ?? this.type);
  }

  MasterSchedulerConfig copyWithWrapped(
      {Wrapped<String>? scheduleId,
      Wrapped<String?>? cronSchedule,
      Wrapped<Object?>? requestTemplate,
      Wrapped<String?>? sqsQueueUrl,
      Wrapped<num?>? version,
      Wrapped<String?>? type}) {
    return MasterSchedulerConfig(
        scheduleId: (scheduleId != null ? scheduleId.value : this.scheduleId),
        cronSchedule:
            (cronSchedule != null ? cronSchedule.value : this.cronSchedule),
        requestTemplate: (requestTemplate != null
            ? requestTemplate.value
            : this.requestTemplate),
        sqsQueueUrl:
            (sqsQueueUrl != null ? sqsQueueUrl.value : this.sqsQueueUrl),
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Message {
  Message({
    this.message,
    this.type,
  });

  factory Message.fromJson(Map<String, dynamic> json) =>
      _$MessageFromJson(json);

  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$MessageFromJson;
  static const toJsonFactory = _$MessageToJson;
  Map<String, dynamic> toJson() => _$MessageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Message &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $MessageExtension on Message {
  Message copyWith({String? message, String? type}) {
    return Message(message: message ?? this.message, type: type ?? this.type);
  }

  Message copyWithWrapped({Wrapped<String?>? message, Wrapped<String?>? type}) {
    return Message(
        message: (message != null ? message.value : this.message),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Notification {
  Notification({
    required this.notifyAt,
    required this.offset,
    this.interval,
    this.allowSnooze,
    this.messages,
    this.type,
  });

  factory Notification.fromJson(Map<String, dynamic> json) =>
      _$NotificationFromJson(json);

  @JsonKey(
    name: 'notifyAt',
    includeIfNull: false,
    toJson: notificationTypeToJson,
    fromJson: notificationTypeFromJson,
  )
  final enums.NotificationType notifyAt;
  @JsonKey(name: 'offset', includeIfNull: false, defaultValue: '')
  final String offset;
  @JsonKey(name: 'interval', includeIfNull: false, defaultValue: '')
  final String? interval;
  @JsonKey(name: 'allowSnooze', includeIfNull: false, defaultValue: false)
  final bool? allowSnooze;
  @JsonKey(
      name: 'messages',
      includeIfNull: false,
      defaultValue: <NotificationMessage>[])
  final List<NotificationMessage>? messages;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$NotificationFromJson;
  static const toJsonFactory = _$NotificationToJson;
  Map<String, dynamic> toJson() => _$NotificationToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Notification &&
            (identical(other.notifyAt, notifyAt) ||
                const DeepCollectionEquality()
                    .equals(other.notifyAt, notifyAt)) &&
            (identical(other.offset, offset) ||
                const DeepCollectionEquality().equals(other.offset, offset)) &&
            (identical(other.interval, interval) ||
                const DeepCollectionEquality()
                    .equals(other.interval, interval)) &&
            (identical(other.allowSnooze, allowSnooze) ||
                const DeepCollectionEquality()
                    .equals(other.allowSnooze, allowSnooze)) &&
            (identical(other.messages, messages) ||
                const DeepCollectionEquality()
                    .equals(other.messages, messages)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(notifyAt) ^
      const DeepCollectionEquality().hash(offset) ^
      const DeepCollectionEquality().hash(interval) ^
      const DeepCollectionEquality().hash(allowSnooze) ^
      const DeepCollectionEquality().hash(messages) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $NotificationExtension on Notification {
  Notification copyWith(
      {enums.NotificationType? notifyAt,
      String? offset,
      String? interval,
      bool? allowSnooze,
      List<NotificationMessage>? messages,
      String? type}) {
    return Notification(
        notifyAt: notifyAt ?? this.notifyAt,
        offset: offset ?? this.offset,
        interval: interval ?? this.interval,
        allowSnooze: allowSnooze ?? this.allowSnooze,
        messages: messages ?? this.messages,
        type: type ?? this.type);
  }

  Notification copyWithWrapped(
      {Wrapped<enums.NotificationType>? notifyAt,
      Wrapped<String>? offset,
      Wrapped<String?>? interval,
      Wrapped<bool?>? allowSnooze,
      Wrapped<List<NotificationMessage>?>? messages,
      Wrapped<String?>? type}) {
    return Notification(
        notifyAt: (notifyAt != null ? notifyAt.value : this.notifyAt),
        offset: (offset != null ? offset.value : this.offset),
        interval: (interval != null ? interval.value : this.interval),
        allowSnooze:
            (allowSnooze != null ? allowSnooze.value : this.allowSnooze),
        messages: (messages != null ? messages.value : this.messages),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class NotificationInfo {
  NotificationInfo({
    required this.notifyAt,
    required this.offset,
    this.interval,
    this.allowSnooze,
    this.message,
    this.type,
  });

  factory NotificationInfo.fromJson(Map<String, dynamic> json) =>
      _$NotificationInfoFromJson(json);

  @JsonKey(
    name: 'notifyAt',
    includeIfNull: false,
    toJson: notificationTypeToJson,
    fromJson: notificationTypeFromJson,
  )
  final enums.NotificationType notifyAt;
  @JsonKey(name: 'offset', includeIfNull: false, defaultValue: '')
  final String offset;
  @JsonKey(name: 'interval', includeIfNull: false, defaultValue: '')
  final String? interval;
  @JsonKey(name: 'allowSnooze', includeIfNull: false, defaultValue: false)
  final bool? allowSnooze;
  @JsonKey(name: 'message', includeIfNull: false)
  final NotificationMessage? message;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$NotificationInfoFromJson;
  static const toJsonFactory = _$NotificationInfoToJson;
  Map<String, dynamic> toJson() => _$NotificationInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NotificationInfo &&
            (identical(other.notifyAt, notifyAt) ||
                const DeepCollectionEquality()
                    .equals(other.notifyAt, notifyAt)) &&
            (identical(other.offset, offset) ||
                const DeepCollectionEquality().equals(other.offset, offset)) &&
            (identical(other.interval, interval) ||
                const DeepCollectionEquality()
                    .equals(other.interval, interval)) &&
            (identical(other.allowSnooze, allowSnooze) ||
                const DeepCollectionEquality()
                    .equals(other.allowSnooze, allowSnooze)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(notifyAt) ^
      const DeepCollectionEquality().hash(offset) ^
      const DeepCollectionEquality().hash(interval) ^
      const DeepCollectionEquality().hash(allowSnooze) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $NotificationInfoExtension on NotificationInfo {
  NotificationInfo copyWith(
      {enums.NotificationType? notifyAt,
      String? offset,
      String? interval,
      bool? allowSnooze,
      NotificationMessage? message,
      String? type}) {
    return NotificationInfo(
        notifyAt: notifyAt ?? this.notifyAt,
        offset: offset ?? this.offset,
        interval: interval ?? this.interval,
        allowSnooze: allowSnooze ?? this.allowSnooze,
        message: message ?? this.message,
        type: type ?? this.type);
  }

  NotificationInfo copyWithWrapped(
      {Wrapped<enums.NotificationType>? notifyAt,
      Wrapped<String>? offset,
      Wrapped<String?>? interval,
      Wrapped<bool?>? allowSnooze,
      Wrapped<NotificationMessage?>? message,
      Wrapped<String?>? type}) {
    return NotificationInfo(
        notifyAt: (notifyAt != null ? notifyAt.value : this.notifyAt),
        offset: (offset != null ? offset.value : this.offset),
        interval: (interval != null ? interval.value : this.interval),
        allowSnooze:
            (allowSnooze != null ? allowSnooze.value : this.allowSnooze),
        message: (message != null ? message.value : this.message),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class NotificationMessage {
  NotificationMessage({
    this.lang,
    required this.subject,
    required this.message,
    this.type,
  });

  factory NotificationMessage.fromJson(Map<String, dynamic> json) =>
      _$NotificationMessageFromJson(json);

  @JsonKey(name: 'lang', includeIfNull: false, defaultValue: '')
  final String? lang;
  @JsonKey(name: 'subject', includeIfNull: false, defaultValue: '')
  final String subject;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String message;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$NotificationMessageFromJson;
  static const toJsonFactory = _$NotificationMessageToJson;
  Map<String, dynamic> toJson() => _$NotificationMessageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NotificationMessage &&
            (identical(other.lang, lang) ||
                const DeepCollectionEquality().equals(other.lang, lang)) &&
            (identical(other.subject, subject) ||
                const DeepCollectionEquality()
                    .equals(other.subject, subject)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(lang) ^
      const DeepCollectionEquality().hash(subject) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $NotificationMessageExtension on NotificationMessage {
  NotificationMessage copyWith(
      {String? lang, String? subject, String? message, String? type}) {
    return NotificationMessage(
        lang: lang ?? this.lang,
        subject: subject ?? this.subject,
        message: message ?? this.message,
        type: type ?? this.type);
  }

  NotificationMessage copyWithWrapped(
      {Wrapped<String?>? lang,
      Wrapped<String>? subject,
      Wrapped<String>? message,
      Wrapped<String?>? type}) {
    return NotificationMessage(
        lang: (lang != null ? lang.value : this.lang),
        subject: (subject != null ? subject.value : this.subject),
        message: (message != null ? message.value : this.message),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class NotificationRegistration {
  NotificationRegistration({
    this.guid,
    required this.protocol,
    this.endpoint,
    required this.deviceId,
    required this.osName,
    this.createdOn,
    this.modifiedOn,
    this.type,
  });

  factory NotificationRegistration.fromJson(Map<String, dynamic> json) =>
      _$NotificationRegistrationFromJson(json);

  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String? guid;
  @JsonKey(
    name: 'protocol',
    includeIfNull: false,
    toJson: notificationProtocolToJson,
    fromJson: notificationProtocolFromJson,
  )
  final enums.NotificationProtocol protocol;
  @JsonKey(name: 'endpoint', includeIfNull: false, defaultValue: '')
  final String? endpoint;
  @JsonKey(name: 'deviceId', includeIfNull: false, defaultValue: '')
  final String deviceId;
  @JsonKey(name: 'osName', includeIfNull: false, defaultValue: '')
  final String osName;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'modifiedOn', includeIfNull: false)
  final DateTime? modifiedOn;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$NotificationRegistrationFromJson;
  static const toJsonFactory = _$NotificationRegistrationToJson;
  Map<String, dynamic> toJson() => _$NotificationRegistrationToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NotificationRegistration &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.protocol, protocol) ||
                const DeepCollectionEquality()
                    .equals(other.protocol, protocol)) &&
            (identical(other.endpoint, endpoint) ||
                const DeepCollectionEquality()
                    .equals(other.endpoint, endpoint)) &&
            (identical(other.deviceId, deviceId) ||
                const DeepCollectionEquality()
                    .equals(other.deviceId, deviceId)) &&
            (identical(other.osName, osName) ||
                const DeepCollectionEquality().equals(other.osName, osName)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.modifiedOn, modifiedOn) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedOn, modifiedOn)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(protocol) ^
      const DeepCollectionEquality().hash(endpoint) ^
      const DeepCollectionEquality().hash(deviceId) ^
      const DeepCollectionEquality().hash(osName) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(modifiedOn) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $NotificationRegistrationExtension on NotificationRegistration {
  NotificationRegistration copyWith(
      {String? guid,
      enums.NotificationProtocol? protocol,
      String? endpoint,
      String? deviceId,
      String? osName,
      DateTime? createdOn,
      DateTime? modifiedOn,
      String? type}) {
    return NotificationRegistration(
        guid: guid ?? this.guid,
        protocol: protocol ?? this.protocol,
        endpoint: endpoint ?? this.endpoint,
        deviceId: deviceId ?? this.deviceId,
        osName: osName ?? this.osName,
        createdOn: createdOn ?? this.createdOn,
        modifiedOn: modifiedOn ?? this.modifiedOn,
        type: type ?? this.type);
  }

  NotificationRegistration copyWithWrapped(
      {Wrapped<String?>? guid,
      Wrapped<enums.NotificationProtocol>? protocol,
      Wrapped<String?>? endpoint,
      Wrapped<String>? deviceId,
      Wrapped<String>? osName,
      Wrapped<DateTime?>? createdOn,
      Wrapped<DateTime?>? modifiedOn,
      Wrapped<String?>? type}) {
    return NotificationRegistration(
        guid: (guid != null ? guid.value : this.guid),
        protocol: (protocol != null ? protocol.value : this.protocol),
        endpoint: (endpoint != null ? endpoint.value : this.endpoint),
        deviceId: (deviceId != null ? deviceId.value : this.deviceId),
        osName: (osName != null ? osName.value : this.osName),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        modifiedOn: (modifiedOn != null ? modifiedOn.value : this.modifiedOn),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class NotificationTopic {
  NotificationTopic({
    this.guid,
    required this.name,
    required this.shortName,
    this.description,
    this.createdOn,
    this.modifiedOn,
    this.deleted,
    this.criteria,
    this.type,
  });

  factory NotificationTopic.fromJson(Map<String, dynamic> json) =>
      _$NotificationTopicFromJson(json);

  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String? guid;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'shortName', includeIfNull: false, defaultValue: '')
  final String shortName;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'modifiedOn', includeIfNull: false)
  final DateTime? modifiedOn;
  @JsonKey(name: 'deleted', includeIfNull: false)
  final bool? deleted;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final Criteria? criteria;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$NotificationTopicFromJson;
  static const toJsonFactory = _$NotificationTopicToJson;
  Map<String, dynamic> toJson() => _$NotificationTopicToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NotificationTopic &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.shortName, shortName) ||
                const DeepCollectionEquality()
                    .equals(other.shortName, shortName)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.modifiedOn, modifiedOn) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedOn, modifiedOn)) &&
            (identical(other.deleted, deleted) ||
                const DeepCollectionEquality()
                    .equals(other.deleted, deleted)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(shortName) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(modifiedOn) ^
      const DeepCollectionEquality().hash(deleted) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $NotificationTopicExtension on NotificationTopic {
  NotificationTopic copyWith(
      {String? guid,
      String? name,
      String? shortName,
      String? description,
      DateTime? createdOn,
      DateTime? modifiedOn,
      bool? deleted,
      Criteria? criteria,
      String? type}) {
    return NotificationTopic(
        guid: guid ?? this.guid,
        name: name ?? this.name,
        shortName: shortName ?? this.shortName,
        description: description ?? this.description,
        createdOn: createdOn ?? this.createdOn,
        modifiedOn: modifiedOn ?? this.modifiedOn,
        deleted: deleted ?? this.deleted,
        criteria: criteria ?? this.criteria,
        type: type ?? this.type);
  }

  NotificationTopic copyWithWrapped(
      {Wrapped<String?>? guid,
      Wrapped<String>? name,
      Wrapped<String>? shortName,
      Wrapped<String?>? description,
      Wrapped<DateTime?>? createdOn,
      Wrapped<DateTime?>? modifiedOn,
      Wrapped<bool?>? deleted,
      Wrapped<Criteria?>? criteria,
      Wrapped<String?>? type}) {
    return NotificationTopic(
        guid: (guid != null ? guid.value : this.guid),
        name: (name != null ? name.value : this.name),
        shortName: (shortName != null ? shortName.value : this.shortName),
        description:
            (description != null ? description.value : this.description),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        modifiedOn: (modifiedOn != null ? modifiedOn.value : this.modifiedOn),
        deleted: (deleted != null ? deleted.value : this.deleted),
        criteria: (criteria != null ? criteria.value : this.criteria),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class OAuthAccessToken {
  OAuthAccessToken({
    this.vendorId,
    this.accessToken,
    this.expiresOn,
    this.providerUserId,
    this.scopes,
    this.type,
  });

  factory OAuthAccessToken.fromJson(Map<String, dynamic> json) =>
      _$OAuthAccessTokenFromJson(json);

  @JsonKey(name: 'vendorId', includeIfNull: false, defaultValue: '')
  final String? vendorId;
  @JsonKey(name: 'accessToken', includeIfNull: false, defaultValue: '')
  final String? accessToken;
  @JsonKey(name: 'expiresOn', includeIfNull: false)
  final DateTime? expiresOn;
  @JsonKey(name: 'providerUserId', includeIfNull: false, defaultValue: '')
  final String? providerUserId;
  @JsonKey(name: 'scopes', includeIfNull: false, defaultValue: <String>[])
  final List<String>? scopes;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$OAuthAccessTokenFromJson;
  static const toJsonFactory = _$OAuthAccessTokenToJson;
  Map<String, dynamic> toJson() => _$OAuthAccessTokenToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OAuthAccessToken &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.accessToken, accessToken) ||
                const DeepCollectionEquality()
                    .equals(other.accessToken, accessToken)) &&
            (identical(other.expiresOn, expiresOn) ||
                const DeepCollectionEquality()
                    .equals(other.expiresOn, expiresOn)) &&
            (identical(other.providerUserId, providerUserId) ||
                const DeepCollectionEquality()
                    .equals(other.providerUserId, providerUserId)) &&
            (identical(other.scopes, scopes) ||
                const DeepCollectionEquality().equals(other.scopes, scopes)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(vendorId) ^
      const DeepCollectionEquality().hash(accessToken) ^
      const DeepCollectionEquality().hash(expiresOn) ^
      const DeepCollectionEquality().hash(providerUserId) ^
      const DeepCollectionEquality().hash(scopes) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $OAuthAccessTokenExtension on OAuthAccessToken {
  OAuthAccessToken copyWith(
      {String? vendorId,
      String? accessToken,
      DateTime? expiresOn,
      String? providerUserId,
      List<String>? scopes,
      String? type}) {
    return OAuthAccessToken(
        vendorId: vendorId ?? this.vendorId,
        accessToken: accessToken ?? this.accessToken,
        expiresOn: expiresOn ?? this.expiresOn,
        providerUserId: providerUserId ?? this.providerUserId,
        scopes: scopes ?? this.scopes,
        type: type ?? this.type);
  }

  OAuthAccessToken copyWithWrapped(
      {Wrapped<String?>? vendorId,
      Wrapped<String?>? accessToken,
      Wrapped<DateTime?>? expiresOn,
      Wrapped<String?>? providerUserId,
      Wrapped<List<String>?>? scopes,
      Wrapped<String?>? type}) {
    return OAuthAccessToken(
        vendorId: (vendorId != null ? vendorId.value : this.vendorId),
        accessToken:
            (accessToken != null ? accessToken.value : this.accessToken),
        expiresOn: (expiresOn != null ? expiresOn.value : this.expiresOn),
        providerUserId: (providerUserId != null
            ? providerUserId.value
            : this.providerUserId),
        scopes: (scopes != null ? scopes.value : this.scopes),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class OAuthAuthorizationToken {
  OAuthAuthorizationToken({
    this.appId,
    this.vendorId,
    required this.authToken,
    this.callbackUrl,
    this.type,
  });

  factory OAuthAuthorizationToken.fromJson(Map<String, dynamic> json) =>
      _$OAuthAuthorizationTokenFromJson(json);

  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String? appId;
  @JsonKey(name: 'vendorId', includeIfNull: false, defaultValue: '')
  final String? vendorId;
  @JsonKey(name: 'authToken', includeIfNull: false, defaultValue: '')
  final String authToken;
  @JsonKey(name: 'callbackUrl', includeIfNull: false, defaultValue: '')
  final String? callbackUrl;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$OAuthAuthorizationTokenFromJson;
  static const toJsonFactory = _$OAuthAuthorizationTokenToJson;
  Map<String, dynamic> toJson() => _$OAuthAuthorizationTokenToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OAuthAuthorizationToken &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.authToken, authToken) ||
                const DeepCollectionEquality()
                    .equals(other.authToken, authToken)) &&
            (identical(other.callbackUrl, callbackUrl) ||
                const DeepCollectionEquality()
                    .equals(other.callbackUrl, callbackUrl)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(appId) ^
      const DeepCollectionEquality().hash(vendorId) ^
      const DeepCollectionEquality().hash(authToken) ^
      const DeepCollectionEquality().hash(callbackUrl) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $OAuthAuthorizationTokenExtension on OAuthAuthorizationToken {
  OAuthAuthorizationToken copyWith(
      {String? appId,
      String? vendorId,
      String? authToken,
      String? callbackUrl,
      String? type}) {
    return OAuthAuthorizationToken(
        appId: appId ?? this.appId,
        vendorId: vendorId ?? this.vendorId,
        authToken: authToken ?? this.authToken,
        callbackUrl: callbackUrl ?? this.callbackUrl,
        type: type ?? this.type);
  }

  OAuthAuthorizationToken copyWithWrapped(
      {Wrapped<String?>? appId,
      Wrapped<String?>? vendorId,
      Wrapped<String>? authToken,
      Wrapped<String?>? callbackUrl,
      Wrapped<String?>? type}) {
    return OAuthAuthorizationToken(
        appId: (appId != null ? appId.value : this.appId),
        vendorId: (vendorId != null ? vendorId.value : this.vendorId),
        authToken: (authToken != null ? authToken.value : this.authToken),
        callbackUrl:
            (callbackUrl != null ? callbackUrl.value : this.callbackUrl),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class OAuthProvider {
  OAuthProvider({
    required this.clientId,
    required this.secret,
    required this.endpoint,
    required this.callbackUrl,
    this.introspectEndpoint,
    this.type,
  });

  factory OAuthProvider.fromJson(Map<String, dynamic> json) =>
      _$OAuthProviderFromJson(json);

  @JsonKey(name: 'clientId', includeIfNull: false, defaultValue: '')
  final String clientId;
  @JsonKey(name: 'secret', includeIfNull: false, defaultValue: '')
  final String secret;
  @JsonKey(name: 'endpoint', includeIfNull: false, defaultValue: '')
  final String endpoint;
  @JsonKey(name: 'callbackUrl', includeIfNull: false, defaultValue: '')
  final String callbackUrl;
  @JsonKey(name: 'introspectEndpoint', includeIfNull: false, defaultValue: '')
  final String? introspectEndpoint;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$OAuthProviderFromJson;
  static const toJsonFactory = _$OAuthProviderToJson;
  Map<String, dynamic> toJson() => _$OAuthProviderToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OAuthProvider &&
            (identical(other.clientId, clientId) ||
                const DeepCollectionEquality()
                    .equals(other.clientId, clientId)) &&
            (identical(other.secret, secret) ||
                const DeepCollectionEquality().equals(other.secret, secret)) &&
            (identical(other.endpoint, endpoint) ||
                const DeepCollectionEquality()
                    .equals(other.endpoint, endpoint)) &&
            (identical(other.callbackUrl, callbackUrl) ||
                const DeepCollectionEquality()
                    .equals(other.callbackUrl, callbackUrl)) &&
            (identical(other.introspectEndpoint, introspectEndpoint) ||
                const DeepCollectionEquality()
                    .equals(other.introspectEndpoint, introspectEndpoint)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(clientId) ^
      const DeepCollectionEquality().hash(secret) ^
      const DeepCollectionEquality().hash(endpoint) ^
      const DeepCollectionEquality().hash(callbackUrl) ^
      const DeepCollectionEquality().hash(introspectEndpoint) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $OAuthProviderExtension on OAuthProvider {
  OAuthProvider copyWith(
      {String? clientId,
      String? secret,
      String? endpoint,
      String? callbackUrl,
      String? introspectEndpoint,
      String? type}) {
    return OAuthProvider(
        clientId: clientId ?? this.clientId,
        secret: secret ?? this.secret,
        endpoint: endpoint ?? this.endpoint,
        callbackUrl: callbackUrl ?? this.callbackUrl,
        introspectEndpoint: introspectEndpoint ?? this.introspectEndpoint,
        type: type ?? this.type);
  }

  OAuthProvider copyWithWrapped(
      {Wrapped<String>? clientId,
      Wrapped<String>? secret,
      Wrapped<String>? endpoint,
      Wrapped<String>? callbackUrl,
      Wrapped<String?>? introspectEndpoint,
      Wrapped<String?>? type}) {
    return OAuthProvider(
        clientId: (clientId != null ? clientId.value : this.clientId),
        secret: (secret != null ? secret.value : this.secret),
        endpoint: (endpoint != null ? endpoint.value : this.endpoint),
        callbackUrl:
            (callbackUrl != null ? callbackUrl.value : this.callbackUrl),
        introspectEndpoint: (introspectEndpoint != null
            ? introspectEndpoint.value
            : this.introspectEndpoint),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Organization {
  Organization({
    required this.name,
    required this.identifier,
    this.description,
    this.createdOn,
    this.modifiedOn,
    this.version,
    this.type,
  });

  factory Organization.fromJson(Map<String, dynamic> json) =>
      _$OrganizationFromJson(json);

  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String identifier;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'modifiedOn', includeIfNull: false)
  final DateTime? modifiedOn;
  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$OrganizationFromJson;
  static const toJsonFactory = _$OrganizationToJson;
  Map<String, dynamic> toJson() => _$OrganizationToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Organization &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.modifiedOn, modifiedOn) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedOn, modifiedOn)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(modifiedOn) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $OrganizationExtension on Organization {
  Organization copyWith(
      {String? name,
      String? identifier,
      String? description,
      DateTime? createdOn,
      DateTime? modifiedOn,
      num? version,
      String? type}) {
    return Organization(
        name: name ?? this.name,
        identifier: identifier ?? this.identifier,
        description: description ?? this.description,
        createdOn: createdOn ?? this.createdOn,
        modifiedOn: modifiedOn ?? this.modifiedOn,
        version: version ?? this.version,
        type: type ?? this.type);
  }

  Organization copyWithWrapped(
      {Wrapped<String>? name,
      Wrapped<String>? identifier,
      Wrapped<String?>? description,
      Wrapped<DateTime?>? createdOn,
      Wrapped<DateTime?>? modifiedOn,
      Wrapped<num?>? version,
      Wrapped<String?>? type}) {
    return Organization(
        name: (name != null ? name.value : this.name),
        identifier: (identifier != null ? identifier.value : this.identifier),
        description:
            (description != null ? description.value : this.description),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        modifiedOn: (modifiedOn != null ? modifiedOn.value : this.modifiedOn),
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ParticipantData {
  ParticipantData({
    this.identifier,
    required this.data,
    this.type,
  });

  factory ParticipantData.fromJson(Map<String, dynamic> json) =>
      _$ParticipantDataFromJson(json);

  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String? identifier;
  @JsonKey(name: 'data', includeIfNull: false)
  final Object data;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ParticipantDataFromJson;
  static const toJsonFactory = _$ParticipantDataToJson;
  Map<String, dynamic> toJson() => _$ParticipantDataToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ParticipantData &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(data) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ParticipantDataExtension on ParticipantData {
  ParticipantData copyWith({String? identifier, Object? data, String? type}) {
    return ParticipantData(
        identifier: identifier ?? this.identifier,
        data: data ?? this.data,
        type: type ?? this.type);
  }

  ParticipantData copyWithWrapped(
      {Wrapped<String?>? identifier,
      Wrapped<Object>? data,
      Wrapped<String?>? type}) {
    return ParticipantData(
        identifier: (identifier != null ? identifier.value : this.identifier),
        data: (data != null ? data.value : this.data),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ParticipantFile {
  ParticipantFile({
    this.fileId,
    this.mimeType,
    this.createdOn,
    this.downloadUrl,
    this.uploadUrl,
    this.type,
    this.expiresOn,
  });

  factory ParticipantFile.fromJson(Map<String, dynamic> json) =>
      _$ParticipantFileFromJson(json);

  @JsonKey(name: 'fileId', includeIfNull: false, defaultValue: '')
  final String? fileId;
  @JsonKey(name: 'mimeType', includeIfNull: false, defaultValue: '')
  final String? mimeType;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'downloadUrl', includeIfNull: false, defaultValue: '')
  final String? downloadUrl;
  @JsonKey(name: 'uploadUrl', includeIfNull: false, defaultValue: '')
  final String? uploadUrl;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  @JsonKey(name: 'expiresOn', includeIfNull: false)
  final DateTime? expiresOn;
  static const fromJsonFactory = _$ParticipantFileFromJson;
  static const toJsonFactory = _$ParticipantFileToJson;
  Map<String, dynamic> toJson() => _$ParticipantFileToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ParticipantFile &&
            (identical(other.fileId, fileId) ||
                const DeepCollectionEquality().equals(other.fileId, fileId)) &&
            (identical(other.mimeType, mimeType) ||
                const DeepCollectionEquality()
                    .equals(other.mimeType, mimeType)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.downloadUrl, downloadUrl) ||
                const DeepCollectionEquality()
                    .equals(other.downloadUrl, downloadUrl)) &&
            (identical(other.uploadUrl, uploadUrl) ||
                const DeepCollectionEquality()
                    .equals(other.uploadUrl, uploadUrl)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.expiresOn, expiresOn) ||
                const DeepCollectionEquality()
                    .equals(other.expiresOn, expiresOn)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(fileId) ^
      const DeepCollectionEquality().hash(mimeType) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(downloadUrl) ^
      const DeepCollectionEquality().hash(uploadUrl) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(expiresOn) ^
      runtimeType.hashCode;
}

extension $ParticipantFileExtension on ParticipantFile {
  ParticipantFile copyWith(
      {String? fileId,
      String? mimeType,
      DateTime? createdOn,
      String? downloadUrl,
      String? uploadUrl,
      String? type,
      DateTime? expiresOn}) {
    return ParticipantFile(
        fileId: fileId ?? this.fileId,
        mimeType: mimeType ?? this.mimeType,
        createdOn: createdOn ?? this.createdOn,
        downloadUrl: downloadUrl ?? this.downloadUrl,
        uploadUrl: uploadUrl ?? this.uploadUrl,
        type: type ?? this.type,
        expiresOn: expiresOn ?? this.expiresOn);
  }

  ParticipantFile copyWithWrapped(
      {Wrapped<String?>? fileId,
      Wrapped<String?>? mimeType,
      Wrapped<DateTime?>? createdOn,
      Wrapped<String?>? downloadUrl,
      Wrapped<String?>? uploadUrl,
      Wrapped<String?>? type,
      Wrapped<DateTime?>? expiresOn}) {
    return ParticipantFile(
        fileId: (fileId != null ? fileId.value : this.fileId),
        mimeType: (mimeType != null ? mimeType.value : this.mimeType),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        downloadUrl:
            (downloadUrl != null ? downloadUrl.value : this.downloadUrl),
        uploadUrl: (uploadUrl != null ? uploadUrl.value : this.uploadUrl),
        type: (type != null ? type.value : this.type),
        expiresOn: (expiresOn != null ? expiresOn.value : this.expiresOn));
  }
}

@JsonSerializable(explicitToJson: true)
class ParticipantRosterRequest {
  ParticipantRosterRequest({
    required this.password,
    this.studyId,
    this.type,
  });

  factory ParticipantRosterRequest.fromJson(Map<String, dynamic> json) =>
      _$ParticipantRosterRequestFromJson(json);

  @JsonKey(name: 'password', includeIfNull: false, defaultValue: '')
  final String password;
  @JsonKey(name: 'studyId', includeIfNull: false, defaultValue: '')
  final String? studyId;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ParticipantRosterRequestFromJson;
  static const toJsonFactory = _$ParticipantRosterRequestToJson;
  Map<String, dynamic> toJson() => _$ParticipantRosterRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ParticipantRosterRequest &&
            (identical(other.password, password) ||
                const DeepCollectionEquality()
                    .equals(other.password, password)) &&
            (identical(other.studyId, studyId) ||
                const DeepCollectionEquality()
                    .equals(other.studyId, studyId)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(password) ^
      const DeepCollectionEquality().hash(studyId) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ParticipantRosterRequestExtension on ParticipantRosterRequest {
  ParticipantRosterRequest copyWith(
      {String? password, String? studyId, String? type}) {
    return ParticipantRosterRequest(
        password: password ?? this.password,
        studyId: studyId ?? this.studyId,
        type: type ?? this.type);
  }

  ParticipantRosterRequest copyWithWrapped(
      {Wrapped<String>? password,
      Wrapped<String?>? studyId,
      Wrapped<String?>? type}) {
    return ParticipantRosterRequest(
        password: (password != null ? password.value : this.password),
        studyId: (studyId != null ? studyId.value : this.studyId),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ParticipantVersion {
  ParticipantVersion({
    required this.appId,
    required this.healthCode,
    required this.participantVersion,
    this.createdOn,
    this.modifiedOn,
    this.dataGroups,
    this.languages,
    this.sharingScope,
    this.studyMemberships,
    this.timeZone,
    this.type,
  });

  factory ParticipantVersion.fromJson(Map<String, dynamic> json) =>
      _$ParticipantVersionFromJson(json);

  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String appId;
  @JsonKey(name: 'healthCode', includeIfNull: false, defaultValue: '')
  final String healthCode;
  @JsonKey(name: 'participantVersion', includeIfNull: false)
  final int participantVersion;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'modifiedOn', includeIfNull: false)
  final DateTime? modifiedOn;
  @JsonKey(name: 'dataGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String>? dataGroups;
  @JsonKey(name: 'languages', includeIfNull: false, defaultValue: <String>[])
  final List<String>? languages;
  @JsonKey(
    name: 'sharingScope',
    includeIfNull: false,
    toJson: sharingScopeToJson,
    fromJson: sharingScopeFromJson,
  )
  final enums.SharingScope? sharingScope;
  @JsonKey(name: 'studyMemberships', includeIfNull: false)
  final Map<String, dynamic>? studyMemberships;
  @JsonKey(name: 'timeZone', includeIfNull: false, defaultValue: '')
  final String? timeZone;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ParticipantVersionFromJson;
  static const toJsonFactory = _$ParticipantVersionToJson;
  Map<String, dynamic> toJson() => _$ParticipantVersionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ParticipantVersion &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)) &&
            (identical(other.healthCode, healthCode) ||
                const DeepCollectionEquality()
                    .equals(other.healthCode, healthCode)) &&
            (identical(other.participantVersion, participantVersion) ||
                const DeepCollectionEquality()
                    .equals(other.participantVersion, participantVersion)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.modifiedOn, modifiedOn) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedOn, modifiedOn)) &&
            (identical(other.dataGroups, dataGroups) ||
                const DeepCollectionEquality()
                    .equals(other.dataGroups, dataGroups)) &&
            (identical(other.languages, languages) ||
                const DeepCollectionEquality()
                    .equals(other.languages, languages)) &&
            (identical(other.sharingScope, sharingScope) ||
                const DeepCollectionEquality()
                    .equals(other.sharingScope, sharingScope)) &&
            (identical(other.studyMemberships, studyMemberships) ||
                const DeepCollectionEquality()
                    .equals(other.studyMemberships, studyMemberships)) &&
            (identical(other.timeZone, timeZone) ||
                const DeepCollectionEquality()
                    .equals(other.timeZone, timeZone)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(appId) ^
      const DeepCollectionEquality().hash(healthCode) ^
      const DeepCollectionEquality().hash(participantVersion) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(modifiedOn) ^
      const DeepCollectionEquality().hash(dataGroups) ^
      const DeepCollectionEquality().hash(languages) ^
      const DeepCollectionEquality().hash(sharingScope) ^
      const DeepCollectionEquality().hash(studyMemberships) ^
      const DeepCollectionEquality().hash(timeZone) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ParticipantVersionExtension on ParticipantVersion {
  ParticipantVersion copyWith(
      {String? appId,
      String? healthCode,
      int? participantVersion,
      DateTime? createdOn,
      DateTime? modifiedOn,
      List<String>? dataGroups,
      List<String>? languages,
      enums.SharingScope? sharingScope,
      Map<String, dynamic>? studyMemberships,
      String? timeZone,
      String? type}) {
    return ParticipantVersion(
        appId: appId ?? this.appId,
        healthCode: healthCode ?? this.healthCode,
        participantVersion: participantVersion ?? this.participantVersion,
        createdOn: createdOn ?? this.createdOn,
        modifiedOn: modifiedOn ?? this.modifiedOn,
        dataGroups: dataGroups ?? this.dataGroups,
        languages: languages ?? this.languages,
        sharingScope: sharingScope ?? this.sharingScope,
        studyMemberships: studyMemberships ?? this.studyMemberships,
        timeZone: timeZone ?? this.timeZone,
        type: type ?? this.type);
  }

  ParticipantVersion copyWithWrapped(
      {Wrapped<String>? appId,
      Wrapped<String>? healthCode,
      Wrapped<int>? participantVersion,
      Wrapped<DateTime?>? createdOn,
      Wrapped<DateTime?>? modifiedOn,
      Wrapped<List<String>?>? dataGroups,
      Wrapped<List<String>?>? languages,
      Wrapped<enums.SharingScope?>? sharingScope,
      Wrapped<Map<String, dynamic>?>? studyMemberships,
      Wrapped<String?>? timeZone,
      Wrapped<String?>? type}) {
    return ParticipantVersion(
        appId: (appId != null ? appId.value : this.appId),
        healthCode: (healthCode != null ? healthCode.value : this.healthCode),
        participantVersion: (participantVersion != null
            ? participantVersion.value
            : this.participantVersion),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        modifiedOn: (modifiedOn != null ? modifiedOn.value : this.modifiedOn),
        dataGroups: (dataGroups != null ? dataGroups.value : this.dataGroups),
        languages: (languages != null ? languages.value : this.languages),
        sharingScope:
            (sharingScope != null ? sharingScope.value : this.sharingScope),
        studyMemberships: (studyMemberships != null
            ? studyMemberships.value
            : this.studyMemberships),
        timeZone: (timeZone != null ? timeZone.value : this.timeZone),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class PasswordPolicy {
  PasswordPolicy({
    this.minLength,
    this.numericRequired,
    this.symbolRequired,
    this.lowerCaseRequired,
    this.upperCaseRequired,
    this.type,
  });

  factory PasswordPolicy.fromJson(Map<String, dynamic> json) =>
      _$PasswordPolicyFromJson(json);

  @JsonKey(name: 'minLength', includeIfNull: false)
  final int? minLength;
  @JsonKey(name: 'numericRequired', includeIfNull: false, defaultValue: true)
  final bool? numericRequired;
  @JsonKey(name: 'symbolRequired', includeIfNull: false, defaultValue: true)
  final bool? symbolRequired;
  @JsonKey(name: 'lowerCaseRequired', includeIfNull: false, defaultValue: true)
  final bool? lowerCaseRequired;
  @JsonKey(name: 'upperCaseRequired', includeIfNull: false, defaultValue: true)
  final bool? upperCaseRequired;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$PasswordPolicyFromJson;
  static const toJsonFactory = _$PasswordPolicyToJson;
  Map<String, dynamic> toJson() => _$PasswordPolicyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PasswordPolicy &&
            (identical(other.minLength, minLength) ||
                const DeepCollectionEquality()
                    .equals(other.minLength, minLength)) &&
            (identical(other.numericRequired, numericRequired) ||
                const DeepCollectionEquality()
                    .equals(other.numericRequired, numericRequired)) &&
            (identical(other.symbolRequired, symbolRequired) ||
                const DeepCollectionEquality()
                    .equals(other.symbolRequired, symbolRequired)) &&
            (identical(other.lowerCaseRequired, lowerCaseRequired) ||
                const DeepCollectionEquality()
                    .equals(other.lowerCaseRequired, lowerCaseRequired)) &&
            (identical(other.upperCaseRequired, upperCaseRequired) ||
                const DeepCollectionEquality()
                    .equals(other.upperCaseRequired, upperCaseRequired)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(minLength) ^
      const DeepCollectionEquality().hash(numericRequired) ^
      const DeepCollectionEquality().hash(symbolRequired) ^
      const DeepCollectionEquality().hash(lowerCaseRequired) ^
      const DeepCollectionEquality().hash(upperCaseRequired) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $PasswordPolicyExtension on PasswordPolicy {
  PasswordPolicy copyWith(
      {int? minLength,
      bool? numericRequired,
      bool? symbolRequired,
      bool? lowerCaseRequired,
      bool? upperCaseRequired,
      String? type}) {
    return PasswordPolicy(
        minLength: minLength ?? this.minLength,
        numericRequired: numericRequired ?? this.numericRequired,
        symbolRequired: symbolRequired ?? this.symbolRequired,
        lowerCaseRequired: lowerCaseRequired ?? this.lowerCaseRequired,
        upperCaseRequired: upperCaseRequired ?? this.upperCaseRequired,
        type: type ?? this.type);
  }

  PasswordPolicy copyWithWrapped(
      {Wrapped<int?>? minLength,
      Wrapped<bool?>? numericRequired,
      Wrapped<bool?>? symbolRequired,
      Wrapped<bool?>? lowerCaseRequired,
      Wrapped<bool?>? upperCaseRequired,
      Wrapped<String?>? type}) {
    return PasswordPolicy(
        minLength: (minLength != null ? minLength.value : this.minLength),
        numericRequired: (numericRequired != null
            ? numericRequired.value
            : this.numericRequired),
        symbolRequired: (symbolRequired != null
            ? symbolRequired.value
            : this.symbolRequired),
        lowerCaseRequired: (lowerCaseRequired != null
            ? lowerCaseRequired.value
            : this.lowerCaseRequired),
        upperCaseRequired: (upperCaseRequired != null
            ? upperCaseRequired.value
            : this.upperCaseRequired),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class PasswordReset {
  PasswordReset({
    required this.password,
    required this.sptoken,
    this.type,
  });

  factory PasswordReset.fromJson(Map<String, dynamic> json) =>
      _$PasswordResetFromJson(json);

  @JsonKey(name: 'password', includeIfNull: false, defaultValue: '')
  final String password;
  @JsonKey(name: 'sptoken', includeIfNull: false, defaultValue: '')
  final String sptoken;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$PasswordResetFromJson;
  static const toJsonFactory = _$PasswordResetToJson;
  Map<String, dynamic> toJson() => _$PasswordResetToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PasswordReset &&
            (identical(other.password, password) ||
                const DeepCollectionEquality()
                    .equals(other.password, password)) &&
            (identical(other.sptoken, sptoken) ||
                const DeepCollectionEquality()
                    .equals(other.sptoken, sptoken)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(password) ^
      const DeepCollectionEquality().hash(sptoken) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $PasswordResetExtension on PasswordReset {
  PasswordReset copyWith({String? password, String? sptoken, String? type}) {
    return PasswordReset(
        password: password ?? this.password,
        sptoken: sptoken ?? this.sptoken,
        type: type ?? this.type);
  }

  PasswordReset copyWithWrapped(
      {Wrapped<String>? password,
      Wrapped<String>? sptoken,
      Wrapped<String?>? type}) {
    return PasswordReset(
        password: (password != null ? password.value : this.password),
        sptoken: (sptoken != null ? sptoken.value : this.sptoken),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Phone {
  Phone({
    required this.number,
    required this.regionCode,
    this.nationalFormat,
    this.type,
  });

  factory Phone.fromJson(Map<String, dynamic> json) => _$PhoneFromJson(json);

  @JsonKey(name: 'number', includeIfNull: false, defaultValue: '')
  final String number;
  @JsonKey(name: 'regionCode', includeIfNull: false, defaultValue: '')
  final String regionCode;
  @JsonKey(name: 'nationalFormat', includeIfNull: false, defaultValue: '')
  final String? nationalFormat;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$PhoneFromJson;
  static const toJsonFactory = _$PhoneToJson;
  Map<String, dynamic> toJson() => _$PhoneToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Phone &&
            (identical(other.number, number) ||
                const DeepCollectionEquality().equals(other.number, number)) &&
            (identical(other.regionCode, regionCode) ||
                const DeepCollectionEquality()
                    .equals(other.regionCode, regionCode)) &&
            (identical(other.nationalFormat, nationalFormat) ||
                const DeepCollectionEquality()
                    .equals(other.nationalFormat, nationalFormat)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(number) ^
      const DeepCollectionEquality().hash(regionCode) ^
      const DeepCollectionEquality().hash(nationalFormat) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $PhoneExtension on Phone {
  Phone copyWith(
      {String? number,
      String? regionCode,
      String? nationalFormat,
      String? type}) {
    return Phone(
        number: number ?? this.number,
        regionCode: regionCode ?? this.regionCode,
        nationalFormat: nationalFormat ?? this.nationalFormat,
        type: type ?? this.type);
  }

  Phone copyWithWrapped(
      {Wrapped<String>? number,
      Wrapped<String>? regionCode,
      Wrapped<String?>? nationalFormat,
      Wrapped<String?>? type}) {
    return Phone(
        number: (number != null ? number.value : this.number),
        regionCode: (regionCode != null ? regionCode.value : this.regionCode),
        nationalFormat: (nationalFormat != null
            ? nationalFormat.value
            : this.nationalFormat),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class PhoneSignInRequest {
  PhoneSignInRequest({
    required this.appId,
    required this.phone,
    this.type,
  });

  factory PhoneSignInRequest.fromJson(Map<String, dynamic> json) =>
      _$PhoneSignInRequestFromJson(json);

  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String appId;
  @JsonKey(name: 'phone', includeIfNull: false)
  final Phone phone;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$PhoneSignInRequestFromJson;
  static const toJsonFactory = _$PhoneSignInRequestToJson;
  Map<String, dynamic> toJson() => _$PhoneSignInRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PhoneSignInRequest &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(appId) ^
      const DeepCollectionEquality().hash(phone) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $PhoneSignInRequestExtension on PhoneSignInRequest {
  PhoneSignInRequest copyWith({String? appId, Phone? phone, String? type}) {
    return PhoneSignInRequest(
        appId: appId ?? this.appId,
        phone: phone ?? this.phone,
        type: type ?? this.type);
  }

  PhoneSignInRequest copyWithWrapped(
      {Wrapped<String>? appId, Wrapped<Phone>? phone, Wrapped<String?>? type}) {
    return PhoneSignInRequest(
        appId: (appId != null ? appId.value : this.appId),
        phone: (phone != null ? phone.value : this.phone),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class PropertyInfo {
  PropertyInfo({
    required this.propName,
    required this.label,
    this.description,
    this.propType,
    this.type,
  });

  factory PropertyInfo.fromJson(Map<String, dynamic> json) =>
      _$PropertyInfoFromJson(json);

  @JsonKey(name: 'propName', includeIfNull: false, defaultValue: '')
  final String propName;
  @JsonKey(name: 'label', includeIfNull: false, defaultValue: '')
  final String label;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'propType', includeIfNull: false, defaultValue: '')
  final String? propType;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$PropertyInfoFromJson;
  static const toJsonFactory = _$PropertyInfoToJson;
  Map<String, dynamic> toJson() => _$PropertyInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PropertyInfo &&
            (identical(other.propName, propName) ||
                const DeepCollectionEquality()
                    .equals(other.propName, propName)) &&
            (identical(other.label, label) ||
                const DeepCollectionEquality().equals(other.label, label)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.propType, propType) ||
                const DeepCollectionEquality()
                    .equals(other.propType, propType)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(propName) ^
      const DeepCollectionEquality().hash(label) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(propType) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $PropertyInfoExtension on PropertyInfo {
  PropertyInfo copyWith(
      {String? propName,
      String? label,
      String? description,
      String? propType,
      String? type}) {
    return PropertyInfo(
        propName: propName ?? this.propName,
        label: label ?? this.label,
        description: description ?? this.description,
        propType: propType ?? this.propType,
        type: type ?? this.type);
  }

  PropertyInfo copyWithWrapped(
      {Wrapped<String>? propName,
      Wrapped<String>? label,
      Wrapped<String?>? description,
      Wrapped<String?>? propType,
      Wrapped<String?>? type}) {
    return PropertyInfo(
        propName: (propName != null ? propName.value : this.propName),
        label: (label != null ? label.value : this.label),
        description:
            (description != null ? description.value : this.description),
        propType: (propType != null ? propType.value : this.propType),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class RecordExportStatusRequest {
  RecordExportStatusRequest({
    required this.recordIds,
    required this.synapseExporterStatus,
    this.type,
  });

  factory RecordExportStatusRequest.fromJson(Map<String, dynamic> json) =>
      _$RecordExportStatusRequestFromJson(json);

  @JsonKey(name: 'recordIds', includeIfNull: false, defaultValue: <String>[])
  final List<String> recordIds;
  @JsonKey(
    name: 'synapseExporterStatus',
    includeIfNull: false,
    toJson: synapseExporterStatusToJson,
    fromJson: synapseExporterStatusFromJson,
  )
  final enums.SynapseExporterStatus synapseExporterStatus;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$RecordExportStatusRequestFromJson;
  static const toJsonFactory = _$RecordExportStatusRequestToJson;
  Map<String, dynamic> toJson() => _$RecordExportStatusRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is RecordExportStatusRequest &&
            (identical(other.recordIds, recordIds) ||
                const DeepCollectionEquality()
                    .equals(other.recordIds, recordIds)) &&
            (identical(other.synapseExporterStatus, synapseExporterStatus) ||
                const DeepCollectionEquality().equals(
                    other.synapseExporterStatus, synapseExporterStatus)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(recordIds) ^
      const DeepCollectionEquality().hash(synapseExporterStatus) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $RecordExportStatusRequestExtension on RecordExportStatusRequest {
  RecordExportStatusRequest copyWith(
      {List<String>? recordIds,
      enums.SynapseExporterStatus? synapseExporterStatus,
      String? type}) {
    return RecordExportStatusRequest(
        recordIds: recordIds ?? this.recordIds,
        synapseExporterStatus:
            synapseExporterStatus ?? this.synapseExporterStatus,
        type: type ?? this.type);
  }

  RecordExportStatusRequest copyWithWrapped(
      {Wrapped<List<String>>? recordIds,
      Wrapped<enums.SynapseExporterStatus>? synapseExporterStatus,
      Wrapped<String?>? type}) {
    return RecordExportStatusRequest(
        recordIds: (recordIds != null ? recordIds.value : this.recordIds),
        synapseExporterStatus: (synapseExporterStatus != null
            ? synapseExporterStatus.value
            : this.synapseExporterStatus),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ReportData {
  ReportData({
    this.date,
    this.localDate,
    this.dateTime,
    required this.data,
    this.studyIds,
    this.type,
  });

  factory ReportData.fromJson(Map<String, dynamic> json) =>
      _$ReportDataFromJson(json);

  @JsonKey(name: 'date', includeIfNull: false, defaultValue: '')
  final String? date;
  @JsonKey(name: 'localDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? localDate;
  @JsonKey(name: 'dateTime', includeIfNull: false)
  final DateTime? dateTime;
  @JsonKey(name: 'data', includeIfNull: false)
  final Object data;
  @JsonKey(name: 'studyIds', includeIfNull: false, defaultValue: <String>[])
  final List<String>? studyIds;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ReportDataFromJson;
  static const toJsonFactory = _$ReportDataToJson;
  Map<String, dynamic> toJson() => _$ReportDataToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ReportData &&
            (identical(other.date, date) ||
                const DeepCollectionEquality().equals(other.date, date)) &&
            (identical(other.localDate, localDate) ||
                const DeepCollectionEquality()
                    .equals(other.localDate, localDate)) &&
            (identical(other.dateTime, dateTime) ||
                const DeepCollectionEquality()
                    .equals(other.dateTime, dateTime)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)) &&
            (identical(other.studyIds, studyIds) ||
                const DeepCollectionEquality()
                    .equals(other.studyIds, studyIds)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(date) ^
      const DeepCollectionEquality().hash(localDate) ^
      const DeepCollectionEquality().hash(dateTime) ^
      const DeepCollectionEquality().hash(data) ^
      const DeepCollectionEquality().hash(studyIds) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ReportDataExtension on ReportData {
  ReportData copyWith(
      {String? date,
      DateTime? localDate,
      DateTime? dateTime,
      Object? data,
      List<String>? studyIds,
      String? type}) {
    return ReportData(
        date: date ?? this.date,
        localDate: localDate ?? this.localDate,
        dateTime: dateTime ?? this.dateTime,
        data: data ?? this.data,
        studyIds: studyIds ?? this.studyIds,
        type: type ?? this.type);
  }

  ReportData copyWithWrapped(
      {Wrapped<String?>? date,
      Wrapped<DateTime?>? localDate,
      Wrapped<DateTime?>? dateTime,
      Wrapped<Object>? data,
      Wrapped<List<String>?>? studyIds,
      Wrapped<String?>? type}) {
    return ReportData(
        date: (date != null ? date.value : this.date),
        localDate: (localDate != null ? localDate.value : this.localDate),
        dateTime: (dateTime != null ? dateTime.value : this.dateTime),
        data: (data != null ? data.value : this.data),
        studyIds: (studyIds != null ? studyIds.value : this.studyIds),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ReportDataForWorker {
  ReportDataForWorker({
    this.healthCode,
    this.date,
    this.dateTime,
    required this.data,
    this.studyIds,
    this.type,
  });

  factory ReportDataForWorker.fromJson(Map<String, dynamic> json) =>
      _$ReportDataForWorkerFromJson(json);

  @JsonKey(name: 'healthCode', includeIfNull: false, defaultValue: '')
  final String? healthCode;
  @JsonKey(name: 'date', includeIfNull: false, toJson: _dateToJson)
  final DateTime? date;
  @JsonKey(name: 'dateTime', includeIfNull: false)
  final DateTime? dateTime;
  @JsonKey(name: 'data', includeIfNull: false)
  final Object data;
  @JsonKey(name: 'studyIds', includeIfNull: false, defaultValue: <String>[])
  final List<String>? studyIds;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ReportDataForWorkerFromJson;
  static const toJsonFactory = _$ReportDataForWorkerToJson;
  Map<String, dynamic> toJson() => _$ReportDataForWorkerToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ReportDataForWorker &&
            (identical(other.healthCode, healthCode) ||
                const DeepCollectionEquality()
                    .equals(other.healthCode, healthCode)) &&
            (identical(other.date, date) ||
                const DeepCollectionEquality().equals(other.date, date)) &&
            (identical(other.dateTime, dateTime) ||
                const DeepCollectionEquality()
                    .equals(other.dateTime, dateTime)) &&
            (identical(other.data, data) ||
                const DeepCollectionEquality().equals(other.data, data)) &&
            (identical(other.studyIds, studyIds) ||
                const DeepCollectionEquality()
                    .equals(other.studyIds, studyIds)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(healthCode) ^
      const DeepCollectionEquality().hash(date) ^
      const DeepCollectionEquality().hash(dateTime) ^
      const DeepCollectionEquality().hash(data) ^
      const DeepCollectionEquality().hash(studyIds) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ReportDataForWorkerExtension on ReportDataForWorker {
  ReportDataForWorker copyWith(
      {String? healthCode,
      DateTime? date,
      DateTime? dateTime,
      Object? data,
      List<String>? studyIds,
      String? type}) {
    return ReportDataForWorker(
        healthCode: healthCode ?? this.healthCode,
        date: date ?? this.date,
        dateTime: dateTime ?? this.dateTime,
        data: data ?? this.data,
        studyIds: studyIds ?? this.studyIds,
        type: type ?? this.type);
  }

  ReportDataForWorker copyWithWrapped(
      {Wrapped<String?>? healthCode,
      Wrapped<DateTime?>? date,
      Wrapped<DateTime?>? dateTime,
      Wrapped<Object>? data,
      Wrapped<List<String>?>? studyIds,
      Wrapped<String?>? type}) {
    return ReportDataForWorker(
        healthCode: (healthCode != null ? healthCode.value : this.healthCode),
        date: (date != null ? date.value : this.date),
        dateTime: (dateTime != null ? dateTime.value : this.dateTime),
        data: (data != null ? data.value : this.data),
        studyIds: (studyIds != null ? studyIds.value : this.studyIds),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ReportIndex {
  ReportIndex({
    required this.identifier,
    this.studyIds,
    this.public,
    this.type,
  });

  factory ReportIndex.fromJson(Map<String, dynamic> json) =>
      _$ReportIndexFromJson(json);

  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String identifier;
  @JsonKey(name: 'studyIds', includeIfNull: false, defaultValue: <String>[])
  final List<String>? studyIds;
  @JsonKey(name: 'public', includeIfNull: false)
  final bool? public;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ReportIndexFromJson;
  static const toJsonFactory = _$ReportIndexToJson;
  Map<String, dynamic> toJson() => _$ReportIndexToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ReportIndex &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.studyIds, studyIds) ||
                const DeepCollectionEquality()
                    .equals(other.studyIds, studyIds)) &&
            (identical(other.public, public) ||
                const DeepCollectionEquality().equals(other.public, public)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(studyIds) ^
      const DeepCollectionEquality().hash(public) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ReportIndexExtension on ReportIndex {
  ReportIndex copyWith(
      {String? identifier,
      List<String>? studyIds,
      bool? public,
      String? type}) {
    return ReportIndex(
        identifier: identifier ?? this.identifier,
        studyIds: studyIds ?? this.studyIds,
        public: public ?? this.public,
        type: type ?? this.type);
  }

  ReportIndex copyWithWrapped(
      {Wrapped<String>? identifier,
      Wrapped<List<String>?>? studyIds,
      Wrapped<bool?>? public,
      Wrapped<String?>? type}) {
    return ReportIndex(
        identifier: (identifier != null ? identifier.value : this.identifier),
        studyIds: (studyIds != null ? studyIds.value : this.studyIds),
        public: (public != null ? public.value : this.public),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class RequestInfo {
  RequestInfo({
    this.userId,
    this.clientInfo,
    this.userAgent,
    this.languages,
    this.userDataGroups,
    this.activitiesAccessedOn,
    this.timelineAccessedOn,
    this.signedInOn,
    this.uploadedOn,
    this.timeZone,
    this.type,
  });

  factory RequestInfo.fromJson(Map<String, dynamic> json) =>
      _$RequestInfoFromJson(json);

  @JsonKey(name: 'userId', includeIfNull: false, defaultValue: '')
  final String? userId;
  @JsonKey(name: 'clientInfo', includeIfNull: false)
  final ClientInfo? clientInfo;
  @JsonKey(name: 'userAgent', includeIfNull: false, defaultValue: '')
  final String? userAgent;
  @JsonKey(name: 'languages', includeIfNull: false, defaultValue: <String>[])
  final List<String>? languages;
  @JsonKey(
      name: 'userDataGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String>? userDataGroups;
  @JsonKey(name: 'activitiesAccessedOn', includeIfNull: false)
  final DateTime? activitiesAccessedOn;
  @JsonKey(name: 'timelineAccessedOn', includeIfNull: false)
  final DateTime? timelineAccessedOn;
  @JsonKey(name: 'signedInOn', includeIfNull: false)
  final DateTime? signedInOn;
  @JsonKey(name: 'uploadedOn', includeIfNull: false)
  final DateTime? uploadedOn;
  @JsonKey(name: 'timeZone', includeIfNull: false, defaultValue: '')
  final String? timeZone;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$RequestInfoFromJson;
  static const toJsonFactory = _$RequestInfoToJson;
  Map<String, dynamic> toJson() => _$RequestInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is RequestInfo &&
            (identical(other.userId, userId) ||
                const DeepCollectionEquality().equals(other.userId, userId)) &&
            (identical(other.clientInfo, clientInfo) ||
                const DeepCollectionEquality()
                    .equals(other.clientInfo, clientInfo)) &&
            (identical(other.userAgent, userAgent) ||
                const DeepCollectionEquality()
                    .equals(other.userAgent, userAgent)) &&
            (identical(other.languages, languages) ||
                const DeepCollectionEquality()
                    .equals(other.languages, languages)) &&
            (identical(other.userDataGroups, userDataGroups) ||
                const DeepCollectionEquality()
                    .equals(other.userDataGroups, userDataGroups)) &&
            (identical(other.activitiesAccessedOn, activitiesAccessedOn) ||
                const DeepCollectionEquality().equals(
                    other.activitiesAccessedOn, activitiesAccessedOn)) &&
            (identical(other.timelineAccessedOn, timelineAccessedOn) ||
                const DeepCollectionEquality()
                    .equals(other.timelineAccessedOn, timelineAccessedOn)) &&
            (identical(other.signedInOn, signedInOn) ||
                const DeepCollectionEquality()
                    .equals(other.signedInOn, signedInOn)) &&
            (identical(other.uploadedOn, uploadedOn) ||
                const DeepCollectionEquality()
                    .equals(other.uploadedOn, uploadedOn)) &&
            (identical(other.timeZone, timeZone) ||
                const DeepCollectionEquality()
                    .equals(other.timeZone, timeZone)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(userId) ^
      const DeepCollectionEquality().hash(clientInfo) ^
      const DeepCollectionEquality().hash(userAgent) ^
      const DeepCollectionEquality().hash(languages) ^
      const DeepCollectionEquality().hash(userDataGroups) ^
      const DeepCollectionEquality().hash(activitiesAccessedOn) ^
      const DeepCollectionEquality().hash(timelineAccessedOn) ^
      const DeepCollectionEquality().hash(signedInOn) ^
      const DeepCollectionEquality().hash(uploadedOn) ^
      const DeepCollectionEquality().hash(timeZone) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $RequestInfoExtension on RequestInfo {
  RequestInfo copyWith(
      {String? userId,
      ClientInfo? clientInfo,
      String? userAgent,
      List<String>? languages,
      List<String>? userDataGroups,
      DateTime? activitiesAccessedOn,
      DateTime? timelineAccessedOn,
      DateTime? signedInOn,
      DateTime? uploadedOn,
      String? timeZone,
      String? type}) {
    return RequestInfo(
        userId: userId ?? this.userId,
        clientInfo: clientInfo ?? this.clientInfo,
        userAgent: userAgent ?? this.userAgent,
        languages: languages ?? this.languages,
        userDataGroups: userDataGroups ?? this.userDataGroups,
        activitiesAccessedOn: activitiesAccessedOn ?? this.activitiesAccessedOn,
        timelineAccessedOn: timelineAccessedOn ?? this.timelineAccessedOn,
        signedInOn: signedInOn ?? this.signedInOn,
        uploadedOn: uploadedOn ?? this.uploadedOn,
        timeZone: timeZone ?? this.timeZone,
        type: type ?? this.type);
  }

  RequestInfo copyWithWrapped(
      {Wrapped<String?>? userId,
      Wrapped<ClientInfo?>? clientInfo,
      Wrapped<String?>? userAgent,
      Wrapped<List<String>?>? languages,
      Wrapped<List<String>?>? userDataGroups,
      Wrapped<DateTime?>? activitiesAccessedOn,
      Wrapped<DateTime?>? timelineAccessedOn,
      Wrapped<DateTime?>? signedInOn,
      Wrapped<DateTime?>? uploadedOn,
      Wrapped<String?>? timeZone,
      Wrapped<String?>? type}) {
    return RequestInfo(
        userId: (userId != null ? userId.value : this.userId),
        clientInfo: (clientInfo != null ? clientInfo.value : this.clientInfo),
        userAgent: (userAgent != null ? userAgent.value : this.userAgent),
        languages: (languages != null ? languages.value : this.languages),
        userDataGroups: (userDataGroups != null
            ? userDataGroups.value
            : this.userDataGroups),
        activitiesAccessedOn: (activitiesAccessedOn != null
            ? activitiesAccessedOn.value
            : this.activitiesAccessedOn),
        timelineAccessedOn: (timelineAccessedOn != null
            ? timelineAccessedOn.value
            : this.timelineAccessedOn),
        signedInOn: (signedInOn != null ? signedInOn.value : this.signedInOn),
        uploadedOn: (uploadedOn != null ? uploadedOn.value : this.uploadedOn),
        timeZone: (timeZone != null ? timeZone.value : this.timeZone),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class RequestParams {
  RequestParams({
    this.allOfGroups,
    this.assessmentIds,
    this.assignmentFilter,
    this.currentTimestampsOnly,
    this.emailFilter,
    this.endDate,
    this.endTime,
    this.eventTimestamps,
    this.idFilter,
    this.includeDeleted,
    this.includeRepeats,
    this.instanceGuids,
    this.language,
    this.noneOfGroups,
    this.offsetBy,
    this.offsetKey,
    this.pageSize,
    this.phoneFilter,
    this.recordType,
    this.reportType,
    this.scheduledOnStart,
    this.scheduledOnEnd,
    this.sessionGuids,
    this.sortOrder,
    this.startDate,
    this.startTime,
    this.studyId,
    this.timeWindowGuids,
    this.total,
    this.summary,
    this.tags,
    this.categories,
    this.minRevision,
    this.maxRevision,
    this.adminOnly,
    this.orgMembership,
    this.externalIdFilter,
    this.status,
    this.enrollment,
    this.attributeKey,
    this.attributeValueFilter,
    this.predicate,
    this.stringSearchPosition,
    this.type,
  });

  factory RequestParams.fromJson(Map<String, dynamic> json) =>
      _$RequestParamsFromJson(json);

  @JsonKey(name: 'allOfGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String>? allOfGroups;
  @JsonKey(
      name: 'assessmentIds', includeIfNull: false, defaultValue: <String>[])
  final List<String>? assessmentIds;
  @JsonKey(name: 'assignmentFilter', includeIfNull: false)
  final bool? assignmentFilter;
  @JsonKey(name: 'currentTimestampsOnly', includeIfNull: false)
  final bool? currentTimestampsOnly;
  @JsonKey(name: 'emailFilter', includeIfNull: false, defaultValue: '')
  final String? emailFilter;
  @JsonKey(name: 'endDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? endDate;
  @JsonKey(name: 'endTime', includeIfNull: false)
  final DateTime? endTime;
  @JsonKey(name: 'eventTimestamps', includeIfNull: false)
  final Map<String, dynamic>? eventTimestamps;
  @JsonKey(name: 'idFilter', includeIfNull: false, defaultValue: '')
  final String? idFilter;
  @JsonKey(name: 'includeDeleted', includeIfNull: false)
  final bool? includeDeleted;
  @JsonKey(name: 'includeRepeats', includeIfNull: false)
  final bool? includeRepeats;
  @JsonKey(
      name: 'instanceGuids', includeIfNull: false, defaultValue: <String>[])
  final List<String>? instanceGuids;
  @JsonKey(name: 'language', includeIfNull: false, defaultValue: '')
  final String? language;
  @JsonKey(name: 'noneOfGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String>? noneOfGroups;
  @JsonKey(name: 'offsetBy', includeIfNull: false)
  final int? offsetBy;
  @JsonKey(name: 'offsetKey', includeIfNull: false, defaultValue: '')
  final String? offsetKey;
  @JsonKey(name: 'pageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'phoneFilter', includeIfNull: false, defaultValue: '')
  final String? phoneFilter;
  @JsonKey(
    name: 'recordType',
    includeIfNull: false,
    toJson: adherenceRecordTypeToJson,
    fromJson: adherenceRecordTypeFromJson,
  )
  final enums.AdherenceRecordType? recordType;
  @JsonKey(
    name: 'reportType',
    includeIfNull: false,
    toJson: reportTypeToJson,
    fromJson: reportTypeFromJson,
  )
  final enums.ReportType? reportType;
  @JsonKey(name: 'scheduledOnStart', includeIfNull: false)
  final DateTime? scheduledOnStart;
  @JsonKey(name: 'scheduledOnEnd', includeIfNull: false)
  final DateTime? scheduledOnEnd;
  @JsonKey(name: 'sessionGuids', includeIfNull: false, defaultValue: <String>[])
  final List<String>? sessionGuids;
  @JsonKey(
    name: 'sortOrder',
    includeIfNull: false,
    toJson: sortOrderToJson,
    fromJson: sortOrderFromJson,
  )
  final enums.SortOrder? sortOrder;
  @JsonKey(name: 'startDate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? startDate;
  @JsonKey(name: 'startTime', includeIfNull: false)
  final DateTime? startTime;
  @JsonKey(name: 'studyId', includeIfNull: false, defaultValue: '')
  final String? studyId;
  @JsonKey(
      name: 'timeWindowGuids', includeIfNull: false, defaultValue: <String>[])
  final List<String>? timeWindowGuids;
  @JsonKey(name: 'total', includeIfNull: false)
  final int? total;
  @JsonKey(name: 'summary', includeIfNull: false)
  final bool? summary;
  @JsonKey(name: 'tags', includeIfNull: false, defaultValue: <String>[])
  final List<String>? tags;
  @JsonKey(
    name: 'categories',
    includeIfNull: false,
    toJson: resourceCategoryListToJson,
    fromJson: resourceCategoryListFromJson,
  )
  final List<enums.ResourceCategory>? categories;
  @JsonKey(name: 'minRevision', includeIfNull: false)
  final int? minRevision;
  @JsonKey(name: 'maxRevision', includeIfNull: false)
  final int? maxRevision;
  @JsonKey(name: 'adminOnly', includeIfNull: false)
  final bool? adminOnly;
  @JsonKey(name: 'orgMembership', includeIfNull: false, defaultValue: '')
  final String? orgMembership;
  @JsonKey(name: 'externalIdFilter', includeIfNull: false, defaultValue: '')
  final String? externalIdFilter;
  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: accountStatusToJson,
    fromJson: accountStatusFromJson,
  )
  final enums.AccountStatus? status;
  @JsonKey(
    name: 'enrollment',
    includeIfNull: false,
    toJson: enrollmentFilterToJson,
    fromJson: enrollmentFilterFromJson,
  )
  final enums.EnrollmentFilter? enrollment;
  @JsonKey(name: 'attributeKey', includeIfNull: false, defaultValue: '')
  final String? attributeKey;
  @JsonKey(name: 'attributeValueFilter', includeIfNull: false, defaultValue: '')
  final String? attributeValueFilter;
  @JsonKey(
    name: 'predicate',
    includeIfNull: false,
    toJson: searchTermPredicateToJson,
    fromJson: searchTermPredicateFromJson,
  )
  final enums.SearchTermPredicate? predicate;
  @JsonKey(
    name: 'stringSearchPosition',
    includeIfNull: false,
    toJson: stringSearchPositionToJson,
    fromJson: stringSearchPositionFromJson,
  )
  final enums.StringSearchPosition? stringSearchPosition;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$RequestParamsFromJson;
  static const toJsonFactory = _$RequestParamsToJson;
  Map<String, dynamic> toJson() => _$RequestParamsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is RequestParams &&
            (identical(other.allOfGroups, allOfGroups) ||
                const DeepCollectionEquality()
                    .equals(other.allOfGroups, allOfGroups)) &&
            (identical(other.assessmentIds, assessmentIds) ||
                const DeepCollectionEquality()
                    .equals(other.assessmentIds, assessmentIds)) &&
            (identical(other.assignmentFilter, assignmentFilter) ||
                const DeepCollectionEquality()
                    .equals(other.assignmentFilter, assignmentFilter)) &&
            (identical(other.currentTimestampsOnly, currentTimestampsOnly) ||
                const DeepCollectionEquality().equals(
                    other.currentTimestampsOnly, currentTimestampsOnly)) &&
            (identical(other.emailFilter, emailFilter) ||
                const DeepCollectionEquality()
                    .equals(other.emailFilter, emailFilter)) &&
            (identical(other.endDate, endDate) ||
                const DeepCollectionEquality()
                    .equals(other.endDate, endDate)) &&
            (identical(other.endTime, endTime) ||
                const DeepCollectionEquality()
                    .equals(other.endTime, endTime)) &&
            (identical(other.eventTimestamps, eventTimestamps) ||
                const DeepCollectionEquality()
                    .equals(other.eventTimestamps, eventTimestamps)) &&
            (identical(other.idFilter, idFilter) ||
                const DeepCollectionEquality()
                    .equals(other.idFilter, idFilter)) &&
            (identical(other.includeDeleted, includeDeleted) ||
                const DeepCollectionEquality()
                    .equals(other.includeDeleted, includeDeleted)) &&
            (identical(other.includeRepeats, includeRepeats) ||
                const DeepCollectionEquality()
                    .equals(other.includeRepeats, includeRepeats)) &&
            (identical(other.instanceGuids, instanceGuids) ||
                const DeepCollectionEquality()
                    .equals(other.instanceGuids, instanceGuids)) &&
            (identical(other.language, language) ||
                const DeepCollectionEquality()
                    .equals(other.language, language)) &&
            (identical(other.noneOfGroups, noneOfGroups) ||
                const DeepCollectionEquality()
                    .equals(other.noneOfGroups, noneOfGroups)) &&
            (identical(other.offsetBy, offsetBy) ||
                const DeepCollectionEquality()
                    .equals(other.offsetBy, offsetBy)) &&
            (identical(other.offsetKey, offsetKey) ||
                const DeepCollectionEquality()
                    .equals(other.offsetKey, offsetKey)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.phoneFilter, phoneFilter) ||
                const DeepCollectionEquality()
                    .equals(other.phoneFilter, phoneFilter)) &&
            (identical(other.recordType, recordType) ||
                const DeepCollectionEquality()
                    .equals(other.recordType, recordType)) &&
            (identical(other.reportType, reportType) ||
                const DeepCollectionEquality()
                    .equals(other.reportType, reportType)) &&
            (identical(other.scheduledOnStart, scheduledOnStart) ||
                const DeepCollectionEquality()
                    .equals(other.scheduledOnStart, scheduledOnStart)) &&
            (identical(other.scheduledOnEnd, scheduledOnEnd) ||
                const DeepCollectionEquality().equals(other.scheduledOnEnd, scheduledOnEnd)) &&
            (identical(other.sessionGuids, sessionGuids) || const DeepCollectionEquality().equals(other.sessionGuids, sessionGuids)) &&
            (identical(other.sortOrder, sortOrder) || const DeepCollectionEquality().equals(other.sortOrder, sortOrder)) &&
            (identical(other.startDate, startDate) || const DeepCollectionEquality().equals(other.startDate, startDate)) &&
            (identical(other.startTime, startTime) || const DeepCollectionEquality().equals(other.startTime, startTime)) &&
            (identical(other.studyId, studyId) || const DeepCollectionEquality().equals(other.studyId, studyId)) &&
            (identical(other.timeWindowGuids, timeWindowGuids) || const DeepCollectionEquality().equals(other.timeWindowGuids, timeWindowGuids)) &&
            (identical(other.total, total) || const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.summary, summary) || const DeepCollectionEquality().equals(other.summary, summary)) &&
            (identical(other.tags, tags) || const DeepCollectionEquality().equals(other.tags, tags)) &&
            (identical(other.categories, categories) || const DeepCollectionEquality().equals(other.categories, categories)) &&
            (identical(other.minRevision, minRevision) || const DeepCollectionEquality().equals(other.minRevision, minRevision)) &&
            (identical(other.maxRevision, maxRevision) || const DeepCollectionEquality().equals(other.maxRevision, maxRevision)) &&
            (identical(other.adminOnly, adminOnly) || const DeepCollectionEquality().equals(other.adminOnly, adminOnly)) &&
            (identical(other.orgMembership, orgMembership) || const DeepCollectionEquality().equals(other.orgMembership, orgMembership)) &&
            (identical(other.externalIdFilter, externalIdFilter) || const DeepCollectionEquality().equals(other.externalIdFilter, externalIdFilter)) &&
            (identical(other.status, status) || const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.enrollment, enrollment) || const DeepCollectionEquality().equals(other.enrollment, enrollment)) &&
            (identical(other.attributeKey, attributeKey) || const DeepCollectionEquality().equals(other.attributeKey, attributeKey)) &&
            (identical(other.attributeValueFilter, attributeValueFilter) || const DeepCollectionEquality().equals(other.attributeValueFilter, attributeValueFilter)) &&
            (identical(other.predicate, predicate) || const DeepCollectionEquality().equals(other.predicate, predicate)) &&
            (identical(other.stringSearchPosition, stringSearchPosition) || const DeepCollectionEquality().equals(other.stringSearchPosition, stringSearchPosition)) &&
            (identical(other.type, type) || const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(allOfGroups) ^
      const DeepCollectionEquality().hash(assessmentIds) ^
      const DeepCollectionEquality().hash(assignmentFilter) ^
      const DeepCollectionEquality().hash(currentTimestampsOnly) ^
      const DeepCollectionEquality().hash(emailFilter) ^
      const DeepCollectionEquality().hash(endDate) ^
      const DeepCollectionEquality().hash(endTime) ^
      const DeepCollectionEquality().hash(eventTimestamps) ^
      const DeepCollectionEquality().hash(idFilter) ^
      const DeepCollectionEquality().hash(includeDeleted) ^
      const DeepCollectionEquality().hash(includeRepeats) ^
      const DeepCollectionEquality().hash(instanceGuids) ^
      const DeepCollectionEquality().hash(language) ^
      const DeepCollectionEquality().hash(noneOfGroups) ^
      const DeepCollectionEquality().hash(offsetBy) ^
      const DeepCollectionEquality().hash(offsetKey) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(phoneFilter) ^
      const DeepCollectionEquality().hash(recordType) ^
      const DeepCollectionEquality().hash(reportType) ^
      const DeepCollectionEquality().hash(scheduledOnStart) ^
      const DeepCollectionEquality().hash(scheduledOnEnd) ^
      const DeepCollectionEquality().hash(sessionGuids) ^
      const DeepCollectionEquality().hash(sortOrder) ^
      const DeepCollectionEquality().hash(startDate) ^
      const DeepCollectionEquality().hash(startTime) ^
      const DeepCollectionEquality().hash(studyId) ^
      const DeepCollectionEquality().hash(timeWindowGuids) ^
      const DeepCollectionEquality().hash(total) ^
      const DeepCollectionEquality().hash(summary) ^
      const DeepCollectionEquality().hash(tags) ^
      const DeepCollectionEquality().hash(categories) ^
      const DeepCollectionEquality().hash(minRevision) ^
      const DeepCollectionEquality().hash(maxRevision) ^
      const DeepCollectionEquality().hash(adminOnly) ^
      const DeepCollectionEquality().hash(orgMembership) ^
      const DeepCollectionEquality().hash(externalIdFilter) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(enrollment) ^
      const DeepCollectionEquality().hash(attributeKey) ^
      const DeepCollectionEquality().hash(attributeValueFilter) ^
      const DeepCollectionEquality().hash(predicate) ^
      const DeepCollectionEquality().hash(stringSearchPosition) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $RequestParamsExtension on RequestParams {
  RequestParams copyWith(
      {List<String>? allOfGroups,
      List<String>? assessmentIds,
      bool? assignmentFilter,
      bool? currentTimestampsOnly,
      String? emailFilter,
      DateTime? endDate,
      DateTime? endTime,
      Map<String, dynamic>? eventTimestamps,
      String? idFilter,
      bool? includeDeleted,
      bool? includeRepeats,
      List<String>? instanceGuids,
      String? language,
      List<String>? noneOfGroups,
      int? offsetBy,
      String? offsetKey,
      int? pageSize,
      String? phoneFilter,
      enums.AdherenceRecordType? recordType,
      enums.ReportType? reportType,
      DateTime? scheduledOnStart,
      DateTime? scheduledOnEnd,
      List<String>? sessionGuids,
      enums.SortOrder? sortOrder,
      DateTime? startDate,
      DateTime? startTime,
      String? studyId,
      List<String>? timeWindowGuids,
      int? total,
      bool? summary,
      List<String>? tags,
      List<enums.ResourceCategory>? categories,
      int? minRevision,
      int? maxRevision,
      bool? adminOnly,
      String? orgMembership,
      String? externalIdFilter,
      enums.AccountStatus? status,
      enums.EnrollmentFilter? enrollment,
      String? attributeKey,
      String? attributeValueFilter,
      enums.SearchTermPredicate? predicate,
      enums.StringSearchPosition? stringSearchPosition,
      String? type}) {
    return RequestParams(
        allOfGroups: allOfGroups ?? this.allOfGroups,
        assessmentIds: assessmentIds ?? this.assessmentIds,
        assignmentFilter: assignmentFilter ?? this.assignmentFilter,
        currentTimestampsOnly:
            currentTimestampsOnly ?? this.currentTimestampsOnly,
        emailFilter: emailFilter ?? this.emailFilter,
        endDate: endDate ?? this.endDate,
        endTime: endTime ?? this.endTime,
        eventTimestamps: eventTimestamps ?? this.eventTimestamps,
        idFilter: idFilter ?? this.idFilter,
        includeDeleted: includeDeleted ?? this.includeDeleted,
        includeRepeats: includeRepeats ?? this.includeRepeats,
        instanceGuids: instanceGuids ?? this.instanceGuids,
        language: language ?? this.language,
        noneOfGroups: noneOfGroups ?? this.noneOfGroups,
        offsetBy: offsetBy ?? this.offsetBy,
        offsetKey: offsetKey ?? this.offsetKey,
        pageSize: pageSize ?? this.pageSize,
        phoneFilter: phoneFilter ?? this.phoneFilter,
        recordType: recordType ?? this.recordType,
        reportType: reportType ?? this.reportType,
        scheduledOnStart: scheduledOnStart ?? this.scheduledOnStart,
        scheduledOnEnd: scheduledOnEnd ?? this.scheduledOnEnd,
        sessionGuids: sessionGuids ?? this.sessionGuids,
        sortOrder: sortOrder ?? this.sortOrder,
        startDate: startDate ?? this.startDate,
        startTime: startTime ?? this.startTime,
        studyId: studyId ?? this.studyId,
        timeWindowGuids: timeWindowGuids ?? this.timeWindowGuids,
        total: total ?? this.total,
        summary: summary ?? this.summary,
        tags: tags ?? this.tags,
        categories: categories ?? this.categories,
        minRevision: minRevision ?? this.minRevision,
        maxRevision: maxRevision ?? this.maxRevision,
        adminOnly: adminOnly ?? this.adminOnly,
        orgMembership: orgMembership ?? this.orgMembership,
        externalIdFilter: externalIdFilter ?? this.externalIdFilter,
        status: status ?? this.status,
        enrollment: enrollment ?? this.enrollment,
        attributeKey: attributeKey ?? this.attributeKey,
        attributeValueFilter: attributeValueFilter ?? this.attributeValueFilter,
        predicate: predicate ?? this.predicate,
        stringSearchPosition: stringSearchPosition ?? this.stringSearchPosition,
        type: type ?? this.type);
  }

  RequestParams copyWithWrapped(
      {Wrapped<List<String>?>? allOfGroups,
      Wrapped<List<String>?>? assessmentIds,
      Wrapped<bool?>? assignmentFilter,
      Wrapped<bool?>? currentTimestampsOnly,
      Wrapped<String?>? emailFilter,
      Wrapped<DateTime?>? endDate,
      Wrapped<DateTime?>? endTime,
      Wrapped<Map<String, dynamic>?>? eventTimestamps,
      Wrapped<String?>? idFilter,
      Wrapped<bool?>? includeDeleted,
      Wrapped<bool?>? includeRepeats,
      Wrapped<List<String>?>? instanceGuids,
      Wrapped<String?>? language,
      Wrapped<List<String>?>? noneOfGroups,
      Wrapped<int?>? offsetBy,
      Wrapped<String?>? offsetKey,
      Wrapped<int?>? pageSize,
      Wrapped<String?>? phoneFilter,
      Wrapped<enums.AdherenceRecordType?>? recordType,
      Wrapped<enums.ReportType?>? reportType,
      Wrapped<DateTime?>? scheduledOnStart,
      Wrapped<DateTime?>? scheduledOnEnd,
      Wrapped<List<String>?>? sessionGuids,
      Wrapped<enums.SortOrder?>? sortOrder,
      Wrapped<DateTime?>? startDate,
      Wrapped<DateTime?>? startTime,
      Wrapped<String?>? studyId,
      Wrapped<List<String>?>? timeWindowGuids,
      Wrapped<int?>? total,
      Wrapped<bool?>? summary,
      Wrapped<List<String>?>? tags,
      Wrapped<List<enums.ResourceCategory>?>? categories,
      Wrapped<int?>? minRevision,
      Wrapped<int?>? maxRevision,
      Wrapped<bool?>? adminOnly,
      Wrapped<String?>? orgMembership,
      Wrapped<String?>? externalIdFilter,
      Wrapped<enums.AccountStatus?>? status,
      Wrapped<enums.EnrollmentFilter?>? enrollment,
      Wrapped<String?>? attributeKey,
      Wrapped<String?>? attributeValueFilter,
      Wrapped<enums.SearchTermPredicate?>? predicate,
      Wrapped<enums.StringSearchPosition?>? stringSearchPosition,
      Wrapped<String?>? type}) {
    return RequestParams(
        allOfGroups:
            (allOfGroups != null ? allOfGroups.value : this.allOfGroups),
        assessmentIds:
            (assessmentIds != null ? assessmentIds.value : this.assessmentIds),
        assignmentFilter: (assignmentFilter != null
            ? assignmentFilter.value
            : this.assignmentFilter),
        currentTimestampsOnly: (currentTimestampsOnly != null
            ? currentTimestampsOnly.value
            : this.currentTimestampsOnly),
        emailFilter:
            (emailFilter != null ? emailFilter.value : this.emailFilter),
        endDate: (endDate != null ? endDate.value : this.endDate),
        endTime: (endTime != null ? endTime.value : this.endTime),
        eventTimestamps: (eventTimestamps != null
            ? eventTimestamps.value
            : this.eventTimestamps),
        idFilter: (idFilter != null ? idFilter.value : this.idFilter),
        includeDeleted: (includeDeleted != null
            ? includeDeleted.value
            : this.includeDeleted),
        includeRepeats: (includeRepeats != null
            ? includeRepeats.value
            : this.includeRepeats),
        instanceGuids:
            (instanceGuids != null ? instanceGuids.value : this.instanceGuids),
        language: (language != null ? language.value : this.language),
        noneOfGroups:
            (noneOfGroups != null ? noneOfGroups.value : this.noneOfGroups),
        offsetBy: (offsetBy != null ? offsetBy.value : this.offsetBy),
        offsetKey: (offsetKey != null ? offsetKey.value : this.offsetKey),
        pageSize: (pageSize != null ? pageSize.value : this.pageSize),
        phoneFilter:
            (phoneFilter != null ? phoneFilter.value : this.phoneFilter),
        recordType: (recordType != null ? recordType.value : this.recordType),
        reportType: (reportType != null ? reportType.value : this.reportType),
        scheduledOnStart: (scheduledOnStart != null
            ? scheduledOnStart.value
            : this.scheduledOnStart),
        scheduledOnEnd: (scheduledOnEnd != null
            ? scheduledOnEnd.value
            : this.scheduledOnEnd),
        sessionGuids:
            (sessionGuids != null ? sessionGuids.value : this.sessionGuids),
        sortOrder: (sortOrder != null ? sortOrder.value : this.sortOrder),
        startDate: (startDate != null ? startDate.value : this.startDate),
        startTime: (startTime != null ? startTime.value : this.startTime),
        studyId: (studyId != null ? studyId.value : this.studyId),
        timeWindowGuids: (timeWindowGuids != null
            ? timeWindowGuids.value
            : this.timeWindowGuids),
        total: (total != null ? total.value : this.total),
        summary: (summary != null ? summary.value : this.summary),
        tags: (tags != null ? tags.value : this.tags),
        categories: (categories != null ? categories.value : this.categories),
        minRevision:
            (minRevision != null ? minRevision.value : this.minRevision),
        maxRevision:
            (maxRevision != null ? maxRevision.value : this.maxRevision),
        adminOnly: (adminOnly != null ? adminOnly.value : this.adminOnly),
        orgMembership:
            (orgMembership != null ? orgMembership.value : this.orgMembership),
        externalIdFilter: (externalIdFilter != null
            ? externalIdFilter.value
            : this.externalIdFilter),
        status: (status != null ? status.value : this.status),
        enrollment: (enrollment != null ? enrollment.value : this.enrollment),
        attributeKey:
            (attributeKey != null ? attributeKey.value : this.attributeKey),
        attributeValueFilter: (attributeValueFilter != null
            ? attributeValueFilter.value
            : this.attributeValueFilter),
        predicate: (predicate != null ? predicate.value : this.predicate),
        stringSearchPosition: (stringSearchPosition != null
            ? stringSearchPosition.value
            : this.stringSearchPosition),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Schedule {
  Schedule({
    required this.label,
    required this.scheduleType,
    this.eventId,
    this.delay,
    this.interval,
    this.sequencePeriod,
    this.expires,
    this.cronTrigger,
    this.startsOn,
    this.endsOn,
    required this.times,
    required this.persistent,
    required this.activities,
    this.type,
  });

  factory Schedule.fromJson(Map<String, dynamic> json) =>
      _$ScheduleFromJson(json);

  @JsonKey(name: 'label', includeIfNull: false, defaultValue: '')
  final String label;
  @JsonKey(
    name: 'scheduleType',
    includeIfNull: false,
    toJson: scheduleTypeToJson,
    fromJson: scheduleTypeFromJson,
  )
  final enums.ScheduleType scheduleType;
  @JsonKey(name: 'eventId', includeIfNull: false, defaultValue: '')
  final String? eventId;
  @JsonKey(name: 'delay', includeIfNull: false, defaultValue: '')
  final String? delay;
  @JsonKey(name: 'interval', includeIfNull: false, defaultValue: '')
  final String? interval;
  @JsonKey(name: 'sequencePeriod', includeIfNull: false, defaultValue: '')
  final String? sequencePeriod;
  @JsonKey(name: 'expires', includeIfNull: false, defaultValue: '')
  final String? expires;
  @JsonKey(name: 'cronTrigger', includeIfNull: false, defaultValue: '')
  final String? cronTrigger;
  @JsonKey(name: 'startsOn', includeIfNull: false)
  final DateTime? startsOn;
  @JsonKey(name: 'endsOn', includeIfNull: false)
  final DateTime? endsOn;
  @JsonKey(name: 'times', includeIfNull: false, defaultValue: <String>[])
  final List<String> times;
  @JsonKey(name: 'persistent', includeIfNull: false)
  final bool persistent;
  @JsonKey(name: 'activities', includeIfNull: false, defaultValue: <Activity>[])
  final List<Activity> activities;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ScheduleFromJson;
  static const toJsonFactory = _$ScheduleToJson;
  Map<String, dynamic> toJson() => _$ScheduleToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Schedule &&
            (identical(other.label, label) ||
                const DeepCollectionEquality().equals(other.label, label)) &&
            (identical(other.scheduleType, scheduleType) ||
                const DeepCollectionEquality()
                    .equals(other.scheduleType, scheduleType)) &&
            (identical(other.eventId, eventId) ||
                const DeepCollectionEquality()
                    .equals(other.eventId, eventId)) &&
            (identical(other.delay, delay) ||
                const DeepCollectionEquality().equals(other.delay, delay)) &&
            (identical(other.interval, interval) ||
                const DeepCollectionEquality()
                    .equals(other.interval, interval)) &&
            (identical(other.sequencePeriod, sequencePeriod) ||
                const DeepCollectionEquality()
                    .equals(other.sequencePeriod, sequencePeriod)) &&
            (identical(other.expires, expires) ||
                const DeepCollectionEquality()
                    .equals(other.expires, expires)) &&
            (identical(other.cronTrigger, cronTrigger) ||
                const DeepCollectionEquality()
                    .equals(other.cronTrigger, cronTrigger)) &&
            (identical(other.startsOn, startsOn) ||
                const DeepCollectionEquality()
                    .equals(other.startsOn, startsOn)) &&
            (identical(other.endsOn, endsOn) ||
                const DeepCollectionEquality().equals(other.endsOn, endsOn)) &&
            (identical(other.times, times) ||
                const DeepCollectionEquality().equals(other.times, times)) &&
            (identical(other.persistent, persistent) ||
                const DeepCollectionEquality()
                    .equals(other.persistent, persistent)) &&
            (identical(other.activities, activities) ||
                const DeepCollectionEquality()
                    .equals(other.activities, activities)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(label) ^
      const DeepCollectionEquality().hash(scheduleType) ^
      const DeepCollectionEquality().hash(eventId) ^
      const DeepCollectionEquality().hash(delay) ^
      const DeepCollectionEquality().hash(interval) ^
      const DeepCollectionEquality().hash(sequencePeriod) ^
      const DeepCollectionEquality().hash(expires) ^
      const DeepCollectionEquality().hash(cronTrigger) ^
      const DeepCollectionEquality().hash(startsOn) ^
      const DeepCollectionEquality().hash(endsOn) ^
      const DeepCollectionEquality().hash(times) ^
      const DeepCollectionEquality().hash(persistent) ^
      const DeepCollectionEquality().hash(activities) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ScheduleExtension on Schedule {
  Schedule copyWith(
      {String? label,
      enums.ScheduleType? scheduleType,
      String? eventId,
      String? delay,
      String? interval,
      String? sequencePeriod,
      String? expires,
      String? cronTrigger,
      DateTime? startsOn,
      DateTime? endsOn,
      List<String>? times,
      bool? persistent,
      List<Activity>? activities,
      String? type}) {
    return Schedule(
        label: label ?? this.label,
        scheduleType: scheduleType ?? this.scheduleType,
        eventId: eventId ?? this.eventId,
        delay: delay ?? this.delay,
        interval: interval ?? this.interval,
        sequencePeriod: sequencePeriod ?? this.sequencePeriod,
        expires: expires ?? this.expires,
        cronTrigger: cronTrigger ?? this.cronTrigger,
        startsOn: startsOn ?? this.startsOn,
        endsOn: endsOn ?? this.endsOn,
        times: times ?? this.times,
        persistent: persistent ?? this.persistent,
        activities: activities ?? this.activities,
        type: type ?? this.type);
  }

  Schedule copyWithWrapped(
      {Wrapped<String>? label,
      Wrapped<enums.ScheduleType>? scheduleType,
      Wrapped<String?>? eventId,
      Wrapped<String?>? delay,
      Wrapped<String?>? interval,
      Wrapped<String?>? sequencePeriod,
      Wrapped<String?>? expires,
      Wrapped<String?>? cronTrigger,
      Wrapped<DateTime?>? startsOn,
      Wrapped<DateTime?>? endsOn,
      Wrapped<List<String>>? times,
      Wrapped<bool>? persistent,
      Wrapped<List<Activity>>? activities,
      Wrapped<String?>? type}) {
    return Schedule(
        label: (label != null ? label.value : this.label),
        scheduleType:
            (scheduleType != null ? scheduleType.value : this.scheduleType),
        eventId: (eventId != null ? eventId.value : this.eventId),
        delay: (delay != null ? delay.value : this.delay),
        interval: (interval != null ? interval.value : this.interval),
        sequencePeriod: (sequencePeriod != null
            ? sequencePeriod.value
            : this.sequencePeriod),
        expires: (expires != null ? expires.value : this.expires),
        cronTrigger:
            (cronTrigger != null ? cronTrigger.value : this.cronTrigger),
        startsOn: (startsOn != null ? startsOn.value : this.startsOn),
        endsOn: (endsOn != null ? endsOn.value : this.endsOn),
        times: (times != null ? times.value : this.times),
        persistent: (persistent != null ? persistent.value : this.persistent),
        activities: (activities != null ? activities.value : this.activities),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Schedule2 {
  Schedule2({
    this.ownerId,
    required this.name,
    this.guid,
    required this.duration,
    this.published,
    this.deleted,
    this.clientData,
    this.studyBursts,
    this.sessions,
    this.createdOn,
    this.modifiedOn,
    this.version,
    this.type,
  });

  factory Schedule2.fromJson(Map<String, dynamic> json) =>
      _$Schedule2FromJson(json);

  @JsonKey(name: 'ownerId', includeIfNull: false, defaultValue: '')
  final String? ownerId;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String? guid;
  @JsonKey(name: 'duration', includeIfNull: false, defaultValue: '')
  final String duration;
  @JsonKey(name: 'published', includeIfNull: false)
  final bool? published;
  @JsonKey(name: 'deleted', includeIfNull: false)
  final bool? deleted;
  @JsonKey(name: 'clientData', includeIfNull: false)
  final Map<String, dynamic>? clientData;
  @JsonKey(
      name: 'studyBursts', includeIfNull: false, defaultValue: <StudyBurst>[])
  final List<StudyBurst>? studyBursts;
  @JsonKey(name: 'sessions', includeIfNull: false, defaultValue: <Session>[])
  final List<Session>? sessions;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'modifiedOn', includeIfNull: false)
  final DateTime? modifiedOn;
  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$Schedule2FromJson;
  static const toJsonFactory = _$Schedule2ToJson;
  Map<String, dynamic> toJson() => _$Schedule2ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Schedule2 &&
            (identical(other.ownerId, ownerId) ||
                const DeepCollectionEquality()
                    .equals(other.ownerId, ownerId)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.duration, duration) ||
                const DeepCollectionEquality()
                    .equals(other.duration, duration)) &&
            (identical(other.published, published) ||
                const DeepCollectionEquality()
                    .equals(other.published, published)) &&
            (identical(other.deleted, deleted) ||
                const DeepCollectionEquality()
                    .equals(other.deleted, deleted)) &&
            (identical(other.clientData, clientData) ||
                const DeepCollectionEquality()
                    .equals(other.clientData, clientData)) &&
            (identical(other.studyBursts, studyBursts) ||
                const DeepCollectionEquality()
                    .equals(other.studyBursts, studyBursts)) &&
            (identical(other.sessions, sessions) ||
                const DeepCollectionEquality()
                    .equals(other.sessions, sessions)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.modifiedOn, modifiedOn) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedOn, modifiedOn)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(ownerId) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(duration) ^
      const DeepCollectionEquality().hash(published) ^
      const DeepCollectionEquality().hash(deleted) ^
      const DeepCollectionEquality().hash(clientData) ^
      const DeepCollectionEquality().hash(studyBursts) ^
      const DeepCollectionEquality().hash(sessions) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(modifiedOn) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $Schedule2Extension on Schedule2 {
  Schedule2 copyWith(
      {String? ownerId,
      String? name,
      String? guid,
      String? duration,
      bool? published,
      bool? deleted,
      Map<String, dynamic>? clientData,
      List<StudyBurst>? studyBursts,
      List<Session>? sessions,
      DateTime? createdOn,
      DateTime? modifiedOn,
      num? version,
      String? type}) {
    return Schedule2(
        ownerId: ownerId ?? this.ownerId,
        name: name ?? this.name,
        guid: guid ?? this.guid,
        duration: duration ?? this.duration,
        published: published ?? this.published,
        deleted: deleted ?? this.deleted,
        clientData: clientData ?? this.clientData,
        studyBursts: studyBursts ?? this.studyBursts,
        sessions: sessions ?? this.sessions,
        createdOn: createdOn ?? this.createdOn,
        modifiedOn: modifiedOn ?? this.modifiedOn,
        version: version ?? this.version,
        type: type ?? this.type);
  }

  Schedule2 copyWithWrapped(
      {Wrapped<String?>? ownerId,
      Wrapped<String>? name,
      Wrapped<String?>? guid,
      Wrapped<String>? duration,
      Wrapped<bool?>? published,
      Wrapped<bool?>? deleted,
      Wrapped<Map<String, dynamic>?>? clientData,
      Wrapped<List<StudyBurst>?>? studyBursts,
      Wrapped<List<Session>?>? sessions,
      Wrapped<DateTime?>? createdOn,
      Wrapped<DateTime?>? modifiedOn,
      Wrapped<num?>? version,
      Wrapped<String?>? type}) {
    return Schedule2(
        ownerId: (ownerId != null ? ownerId.value : this.ownerId),
        name: (name != null ? name.value : this.name),
        guid: (guid != null ? guid.value : this.guid),
        duration: (duration != null ? duration.value : this.duration),
        published: (published != null ? published.value : this.published),
        deleted: (deleted != null ? deleted.value : this.deleted),
        clientData: (clientData != null ? clientData.value : this.clientData),
        studyBursts:
            (studyBursts != null ? studyBursts.value : this.studyBursts),
        sessions: (sessions != null ? sessions.value : this.sessions),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        modifiedOn: (modifiedOn != null ? modifiedOn.value : this.modifiedOn),
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ScheduleCriteria {
  ScheduleCriteria({
    required this.criteria,
    required this.schedule,
    this.type,
  });

  factory ScheduleCriteria.fromJson(Map<String, dynamic> json) =>
      _$ScheduleCriteriaFromJson(json);

  @JsonKey(name: 'criteria', includeIfNull: false)
  final Criteria criteria;
  @JsonKey(name: 'schedule', includeIfNull: false)
  final Schedule schedule;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ScheduleCriteriaFromJson;
  static const toJsonFactory = _$ScheduleCriteriaToJson;
  Map<String, dynamic> toJson() => _$ScheduleCriteriaToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ScheduleCriteria &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.schedule, schedule) ||
                const DeepCollectionEquality()
                    .equals(other.schedule, schedule)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(schedule) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ScheduleCriteriaExtension on ScheduleCriteria {
  ScheduleCriteria copyWith(
      {Criteria? criteria, Schedule? schedule, String? type}) {
    return ScheduleCriteria(
        criteria: criteria ?? this.criteria,
        schedule: schedule ?? this.schedule,
        type: type ?? this.type);
  }

  ScheduleCriteria copyWithWrapped(
      {Wrapped<Criteria>? criteria,
      Wrapped<Schedule>? schedule,
      Wrapped<String?>? type}) {
    return ScheduleCriteria(
        criteria: (criteria != null ? criteria.value : this.criteria),
        schedule: (schedule != null ? schedule.value : this.schedule),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ScheduledAssessment {
  ScheduledAssessment({
    this.refKey,
    this.instanceGuid,
    this.type,
  });

  factory ScheduledAssessment.fromJson(Map<String, dynamic> json) =>
      _$ScheduledAssessmentFromJson(json);

  @JsonKey(name: 'refKey', includeIfNull: false, defaultValue: '')
  final String? refKey;
  @JsonKey(name: 'instanceGuid', includeIfNull: false, defaultValue: '')
  final String? instanceGuid;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ScheduledAssessmentFromJson;
  static const toJsonFactory = _$ScheduledAssessmentToJson;
  Map<String, dynamic> toJson() => _$ScheduledAssessmentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ScheduledAssessment &&
            (identical(other.refKey, refKey) ||
                const DeepCollectionEquality().equals(other.refKey, refKey)) &&
            (identical(other.instanceGuid, instanceGuid) ||
                const DeepCollectionEquality()
                    .equals(other.instanceGuid, instanceGuid)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(refKey) ^
      const DeepCollectionEquality().hash(instanceGuid) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ScheduledAssessmentExtension on ScheduledAssessment {
  ScheduledAssessment copyWith(
      {String? refKey, String? instanceGuid, String? type}) {
    return ScheduledAssessment(
        refKey: refKey ?? this.refKey,
        instanceGuid: instanceGuid ?? this.instanceGuid,
        type: type ?? this.type);
  }

  ScheduledAssessment copyWithWrapped(
      {Wrapped<String?>? refKey,
      Wrapped<String?>? instanceGuid,
      Wrapped<String?>? type}) {
    return ScheduledAssessment(
        refKey: (refKey != null ? refKey.value : this.refKey),
        instanceGuid:
            (instanceGuid != null ? instanceGuid.value : this.instanceGuid),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ScheduledSession {
  ScheduledSession({
    this.refGuid,
    this.instanceGuid,
    this.startEventId,
    this.startDay,
    this.endDay,
    this.startTime,
    this.delayTime,
    this.expiration,
    this.persistent,
    this.studyBurstId,
    this.studyBurstNum,
    this.timeWindowGuid,
    this.assessments,
    this.type,
  });

  factory ScheduledSession.fromJson(Map<String, dynamic> json) =>
      _$ScheduledSessionFromJson(json);

  @JsonKey(name: 'refGuid', includeIfNull: false, defaultValue: '')
  final String? refGuid;
  @JsonKey(name: 'instanceGuid', includeIfNull: false, defaultValue: '')
  final String? instanceGuid;
  @JsonKey(name: 'startEventId', includeIfNull: false, defaultValue: '')
  final String? startEventId;
  @JsonKey(name: 'startDay', includeIfNull: false)
  final int? startDay;
  @JsonKey(name: 'endDay', includeIfNull: false)
  final int? endDay;
  @JsonKey(name: 'startTime', includeIfNull: false, defaultValue: '')
  final String? startTime;
  @JsonKey(name: 'delayTime', includeIfNull: false, defaultValue: '')
  final String? delayTime;
  @JsonKey(name: 'expiration', includeIfNull: false, defaultValue: '')
  final String? expiration;
  @JsonKey(name: 'persistent', includeIfNull: false)
  final bool? persistent;
  @JsonKey(name: 'studyBurstId', includeIfNull: false, defaultValue: '')
  final String? studyBurstId;
  @JsonKey(name: 'studyBurstNum', includeIfNull: false)
  final int? studyBurstNum;
  @JsonKey(name: 'timeWindowGuid', includeIfNull: false, defaultValue: '')
  final String? timeWindowGuid;
  @JsonKey(
      name: 'assessments',
      includeIfNull: false,
      defaultValue: <ScheduledAssessment>[])
  final List<ScheduledAssessment>? assessments;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ScheduledSessionFromJson;
  static const toJsonFactory = _$ScheduledSessionToJson;
  Map<String, dynamic> toJson() => _$ScheduledSessionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ScheduledSession &&
            (identical(other.refGuid, refGuid) ||
                const DeepCollectionEquality()
                    .equals(other.refGuid, refGuid)) &&
            (identical(other.instanceGuid, instanceGuid) ||
                const DeepCollectionEquality()
                    .equals(other.instanceGuid, instanceGuid)) &&
            (identical(other.startEventId, startEventId) ||
                const DeepCollectionEquality()
                    .equals(other.startEventId, startEventId)) &&
            (identical(other.startDay, startDay) ||
                const DeepCollectionEquality()
                    .equals(other.startDay, startDay)) &&
            (identical(other.endDay, endDay) ||
                const DeepCollectionEquality().equals(other.endDay, endDay)) &&
            (identical(other.startTime, startTime) ||
                const DeepCollectionEquality()
                    .equals(other.startTime, startTime)) &&
            (identical(other.delayTime, delayTime) ||
                const DeepCollectionEquality()
                    .equals(other.delayTime, delayTime)) &&
            (identical(other.expiration, expiration) ||
                const DeepCollectionEquality()
                    .equals(other.expiration, expiration)) &&
            (identical(other.persistent, persistent) ||
                const DeepCollectionEquality()
                    .equals(other.persistent, persistent)) &&
            (identical(other.studyBurstId, studyBurstId) ||
                const DeepCollectionEquality()
                    .equals(other.studyBurstId, studyBurstId)) &&
            (identical(other.studyBurstNum, studyBurstNum) ||
                const DeepCollectionEquality()
                    .equals(other.studyBurstNum, studyBurstNum)) &&
            (identical(other.timeWindowGuid, timeWindowGuid) ||
                const DeepCollectionEquality()
                    .equals(other.timeWindowGuid, timeWindowGuid)) &&
            (identical(other.assessments, assessments) ||
                const DeepCollectionEquality()
                    .equals(other.assessments, assessments)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(refGuid) ^
      const DeepCollectionEquality().hash(instanceGuid) ^
      const DeepCollectionEquality().hash(startEventId) ^
      const DeepCollectionEquality().hash(startDay) ^
      const DeepCollectionEquality().hash(endDay) ^
      const DeepCollectionEquality().hash(startTime) ^
      const DeepCollectionEquality().hash(delayTime) ^
      const DeepCollectionEquality().hash(expiration) ^
      const DeepCollectionEquality().hash(persistent) ^
      const DeepCollectionEquality().hash(studyBurstId) ^
      const DeepCollectionEquality().hash(studyBurstNum) ^
      const DeepCollectionEquality().hash(timeWindowGuid) ^
      const DeepCollectionEquality().hash(assessments) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ScheduledSessionExtension on ScheduledSession {
  ScheduledSession copyWith(
      {String? refGuid,
      String? instanceGuid,
      String? startEventId,
      int? startDay,
      int? endDay,
      String? startTime,
      String? delayTime,
      String? expiration,
      bool? persistent,
      String? studyBurstId,
      int? studyBurstNum,
      String? timeWindowGuid,
      List<ScheduledAssessment>? assessments,
      String? type}) {
    return ScheduledSession(
        refGuid: refGuid ?? this.refGuid,
        instanceGuid: instanceGuid ?? this.instanceGuid,
        startEventId: startEventId ?? this.startEventId,
        startDay: startDay ?? this.startDay,
        endDay: endDay ?? this.endDay,
        startTime: startTime ?? this.startTime,
        delayTime: delayTime ?? this.delayTime,
        expiration: expiration ?? this.expiration,
        persistent: persistent ?? this.persistent,
        studyBurstId: studyBurstId ?? this.studyBurstId,
        studyBurstNum: studyBurstNum ?? this.studyBurstNum,
        timeWindowGuid: timeWindowGuid ?? this.timeWindowGuid,
        assessments: assessments ?? this.assessments,
        type: type ?? this.type);
  }

  ScheduledSession copyWithWrapped(
      {Wrapped<String?>? refGuid,
      Wrapped<String?>? instanceGuid,
      Wrapped<String?>? startEventId,
      Wrapped<int?>? startDay,
      Wrapped<int?>? endDay,
      Wrapped<String?>? startTime,
      Wrapped<String?>? delayTime,
      Wrapped<String?>? expiration,
      Wrapped<bool?>? persistent,
      Wrapped<String?>? studyBurstId,
      Wrapped<int?>? studyBurstNum,
      Wrapped<String?>? timeWindowGuid,
      Wrapped<List<ScheduledAssessment>?>? assessments,
      Wrapped<String?>? type}) {
    return ScheduledSession(
        refGuid: (refGuid != null ? refGuid.value : this.refGuid),
        instanceGuid:
            (instanceGuid != null ? instanceGuid.value : this.instanceGuid),
        startEventId:
            (startEventId != null ? startEventId.value : this.startEventId),
        startDay: (startDay != null ? startDay.value : this.startDay),
        endDay: (endDay != null ? endDay.value : this.endDay),
        startTime: (startTime != null ? startTime.value : this.startTime),
        delayTime: (delayTime != null ? delayTime.value : this.delayTime),
        expiration: (expiration != null ? expiration.value : this.expiration),
        persistent: (persistent != null ? persistent.value : this.persistent),
        studyBurstId:
            (studyBurstId != null ? studyBurstId.value : this.studyBurstId),
        studyBurstNum:
            (studyBurstNum != null ? studyBurstNum.value : this.studyBurstNum),
        timeWindowGuid: (timeWindowGuid != null
            ? timeWindowGuid.value
            : this.timeWindowGuid),
        assessments:
            (assessments != null ? assessments.value : this.assessments),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SchedulePlan {
  SchedulePlan({
    this.guid,
    required this.label,
    this.modifiedOn,
    this.deleted,
    required this.strategy,
    this.version,
    this.type,
  });

  factory SchedulePlan.fromJson(Map<String, dynamic> json) =>
      _$SchedulePlanFromJson(json);

  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String? guid;
  @JsonKey(name: 'label', includeIfNull: false, defaultValue: '')
  final String label;
  @JsonKey(name: 'modifiedOn', includeIfNull: false)
  final DateTime? modifiedOn;
  @JsonKey(name: 'deleted', includeIfNull: false)
  final bool? deleted;
  @JsonKey(name: 'strategy', includeIfNull: false)
  final ScheduleStrategy strategy;
  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SchedulePlanFromJson;
  static const toJsonFactory = _$SchedulePlanToJson;
  Map<String, dynamic> toJson() => _$SchedulePlanToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SchedulePlan &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.label, label) ||
                const DeepCollectionEquality().equals(other.label, label)) &&
            (identical(other.modifiedOn, modifiedOn) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedOn, modifiedOn)) &&
            (identical(other.deleted, deleted) ||
                const DeepCollectionEquality()
                    .equals(other.deleted, deleted)) &&
            (identical(other.strategy, strategy) ||
                const DeepCollectionEquality()
                    .equals(other.strategy, strategy)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(label) ^
      const DeepCollectionEquality().hash(modifiedOn) ^
      const DeepCollectionEquality().hash(deleted) ^
      const DeepCollectionEquality().hash(strategy) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SchedulePlanExtension on SchedulePlan {
  SchedulePlan copyWith(
      {String? guid,
      String? label,
      DateTime? modifiedOn,
      bool? deleted,
      ScheduleStrategy? strategy,
      num? version,
      String? type}) {
    return SchedulePlan(
        guid: guid ?? this.guid,
        label: label ?? this.label,
        modifiedOn: modifiedOn ?? this.modifiedOn,
        deleted: deleted ?? this.deleted,
        strategy: strategy ?? this.strategy,
        version: version ?? this.version,
        type: type ?? this.type);
  }

  SchedulePlan copyWithWrapped(
      {Wrapped<String?>? guid,
      Wrapped<String>? label,
      Wrapped<DateTime?>? modifiedOn,
      Wrapped<bool?>? deleted,
      Wrapped<ScheduleStrategy>? strategy,
      Wrapped<num?>? version,
      Wrapped<String?>? type}) {
    return SchedulePlan(
        guid: (guid != null ? guid.value : this.guid),
        label: (label != null ? label.value : this.label),
        modifiedOn: (modifiedOn != null ? modifiedOn.value : this.modifiedOn),
        deleted: (deleted != null ? deleted.value : this.deleted),
        strategy: (strategy != null ? strategy.value : this.strategy),
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ScheduleStrategy {
  ScheduleStrategy({
    this.type,
  });

  factory ScheduleStrategy.fromJson(Map<String, dynamic> json) =>
      _$ScheduleStrategyFromJson(json);

  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ScheduleStrategyFromJson;
  static const toJsonFactory = _$ScheduleStrategyToJson;
  Map<String, dynamic> toJson() => _$ScheduleStrategyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ScheduleStrategy &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(type) ^ runtimeType.hashCode;
}

extension $ScheduleStrategyExtension on ScheduleStrategy {
  ScheduleStrategy copyWith({String? type}) {
    return ScheduleStrategy(type: type ?? this.type);
  }

  ScheduleStrategy copyWithWrapped({Wrapped<String?>? type}) {
    return ScheduleStrategy(type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ScheduledActivity {
  ScheduledActivity({
    this.guid,
    this.schedulePlanGuid,
    this.startedOn,
    this.finishedOn,
    this.scheduledOn,
    this.expiresOn,
    this.activity,
    this.persistent,
    this.clientData,
    this.status,
    this.type,
  });

  factory ScheduledActivity.fromJson(Map<String, dynamic> json) =>
      _$ScheduledActivityFromJson(json);

  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String? guid;
  @JsonKey(name: 'schedulePlanGuid', includeIfNull: false, defaultValue: '')
  final String? schedulePlanGuid;
  @JsonKey(name: 'startedOn', includeIfNull: false)
  final DateTime? startedOn;
  @JsonKey(name: 'finishedOn', includeIfNull: false)
  final DateTime? finishedOn;
  @JsonKey(name: 'scheduledOn', includeIfNull: false)
  final DateTime? scheduledOn;
  @JsonKey(name: 'expiresOn', includeIfNull: false)
  final DateTime? expiresOn;
  @JsonKey(name: 'activity', includeIfNull: false)
  final Activity? activity;
  @JsonKey(name: 'persistent', includeIfNull: false)
  final bool? persistent;
  @JsonKey(name: 'clientData', includeIfNull: false)
  final Object? clientData;
  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: scheduleStatusToJson,
    fromJson: scheduleStatusFromJson,
  )
  final enums.ScheduleStatus? status;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ScheduledActivityFromJson;
  static const toJsonFactory = _$ScheduledActivityToJson;
  Map<String, dynamic> toJson() => _$ScheduledActivityToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ScheduledActivity &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.schedulePlanGuid, schedulePlanGuid) ||
                const DeepCollectionEquality()
                    .equals(other.schedulePlanGuid, schedulePlanGuid)) &&
            (identical(other.startedOn, startedOn) ||
                const DeepCollectionEquality()
                    .equals(other.startedOn, startedOn)) &&
            (identical(other.finishedOn, finishedOn) ||
                const DeepCollectionEquality()
                    .equals(other.finishedOn, finishedOn)) &&
            (identical(other.scheduledOn, scheduledOn) ||
                const DeepCollectionEquality()
                    .equals(other.scheduledOn, scheduledOn)) &&
            (identical(other.expiresOn, expiresOn) ||
                const DeepCollectionEquality()
                    .equals(other.expiresOn, expiresOn)) &&
            (identical(other.activity, activity) ||
                const DeepCollectionEquality()
                    .equals(other.activity, activity)) &&
            (identical(other.persistent, persistent) ||
                const DeepCollectionEquality()
                    .equals(other.persistent, persistent)) &&
            (identical(other.clientData, clientData) ||
                const DeepCollectionEquality()
                    .equals(other.clientData, clientData)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(schedulePlanGuid) ^
      const DeepCollectionEquality().hash(startedOn) ^
      const DeepCollectionEquality().hash(finishedOn) ^
      const DeepCollectionEquality().hash(scheduledOn) ^
      const DeepCollectionEquality().hash(expiresOn) ^
      const DeepCollectionEquality().hash(activity) ^
      const DeepCollectionEquality().hash(persistent) ^
      const DeepCollectionEquality().hash(clientData) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ScheduledActivityExtension on ScheduledActivity {
  ScheduledActivity copyWith(
      {String? guid,
      String? schedulePlanGuid,
      DateTime? startedOn,
      DateTime? finishedOn,
      DateTime? scheduledOn,
      DateTime? expiresOn,
      Activity? activity,
      bool? persistent,
      Object? clientData,
      enums.ScheduleStatus? status,
      String? type}) {
    return ScheduledActivity(
        guid: guid ?? this.guid,
        schedulePlanGuid: schedulePlanGuid ?? this.schedulePlanGuid,
        startedOn: startedOn ?? this.startedOn,
        finishedOn: finishedOn ?? this.finishedOn,
        scheduledOn: scheduledOn ?? this.scheduledOn,
        expiresOn: expiresOn ?? this.expiresOn,
        activity: activity ?? this.activity,
        persistent: persistent ?? this.persistent,
        clientData: clientData ?? this.clientData,
        status: status ?? this.status,
        type: type ?? this.type);
  }

  ScheduledActivity copyWithWrapped(
      {Wrapped<String?>? guid,
      Wrapped<String?>? schedulePlanGuid,
      Wrapped<DateTime?>? startedOn,
      Wrapped<DateTime?>? finishedOn,
      Wrapped<DateTime?>? scheduledOn,
      Wrapped<DateTime?>? expiresOn,
      Wrapped<Activity?>? activity,
      Wrapped<bool?>? persistent,
      Wrapped<Object?>? clientData,
      Wrapped<enums.ScheduleStatus?>? status,
      Wrapped<String?>? type}) {
    return ScheduledActivity(
        guid: (guid != null ? guid.value : this.guid),
        schedulePlanGuid: (schedulePlanGuid != null
            ? schedulePlanGuid.value
            : this.schedulePlanGuid),
        startedOn: (startedOn != null ? startedOn.value : this.startedOn),
        finishedOn: (finishedOn != null ? finishedOn.value : this.finishedOn),
        scheduledOn:
            (scheduledOn != null ? scheduledOn.value : this.scheduledOn),
        expiresOn: (expiresOn != null ? expiresOn.value : this.expiresOn),
        activity: (activity != null ? activity.value : this.activity),
        persistent: (persistent != null ? persistent.value : this.persistent),
        clientData: (clientData != null ? clientData.value : this.clientData),
        status: (status != null ? status.value : this.status),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SchemaReference {
  SchemaReference({
    required this.id,
    this.revision,
    this.type,
  });

  factory SchemaReference.fromJson(Map<String, dynamic> json) =>
      _$SchemaReferenceFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'revision', includeIfNull: false)
  final num? revision;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SchemaReferenceFromJson;
  static const toJsonFactory = _$SchemaReferenceToJson;
  Map<String, dynamic> toJson() => _$SchemaReferenceToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SchemaReference &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.revision, revision) ||
                const DeepCollectionEquality()
                    .equals(other.revision, revision)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(revision) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SchemaReferenceExtension on SchemaReference {
  SchemaReference copyWith({String? id, num? revision, String? type}) {
    return SchemaReference(
        id: id ?? this.id,
        revision: revision ?? this.revision,
        type: type ?? this.type);
  }

  SchemaReference copyWithWrapped(
      {Wrapped<String>? id, Wrapped<num?>? revision, Wrapped<String?>? type}) {
    return SchemaReference(
        id: (id != null ? id.value : this.id),
        revision: (revision != null ? revision.value : this.revision),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Session {
  Session({
    this.guid,
    required this.name,
    this.symbol,
    this.labels,
    this.startEventIds,
    this.studyBurstIds,
    this.delay,
    this.interval,
    this.occurrences,
    required this.performanceOrder,
    this.timeWindows,
    this.assessments,
    this.notifications,
    this.type,
  });

  factory Session.fromJson(Map<String, dynamic> json) =>
      _$SessionFromJson(json);

  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String? guid;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'symbol', includeIfNull: false, defaultValue: '')
  final String? symbol;
  @JsonKey(name: 'labels', includeIfNull: false, defaultValue: <Label>[])
  final List<Label>? labels;
  @JsonKey(
      name: 'startEventIds', includeIfNull: false, defaultValue: <String>[])
  final List<String>? startEventIds;
  @JsonKey(
      name: 'studyBurstIds', includeIfNull: false, defaultValue: <String>[])
  final List<String>? studyBurstIds;
  @JsonKey(name: 'delay', includeIfNull: false, defaultValue: '')
  final String? delay;
  @JsonKey(name: 'interval', includeIfNull: false, defaultValue: '')
  final String? interval;
  @JsonKey(name: 'occurrences', includeIfNull: false)
  final int? occurrences;
  @JsonKey(
    name: 'performanceOrder',
    includeIfNull: false,
    toJson: performanceOrderToJson,
    fromJson: performanceOrderFromJson,
  )
  final enums.PerformanceOrder performanceOrder;
  @JsonKey(
      name: 'timeWindows', includeIfNull: false, defaultValue: <TimeWindow>[])
  final List<TimeWindow>? timeWindows;
  @JsonKey(
      name: 'assessments',
      includeIfNull: false,
      defaultValue: <AssessmentReference2>[])
  final List<AssessmentReference2>? assessments;
  @JsonKey(
      name: 'notifications',
      includeIfNull: false,
      defaultValue: <Notification>[])
  final List<Notification>? notifications;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SessionFromJson;
  static const toJsonFactory = _$SessionToJson;
  Map<String, dynamic> toJson() => _$SessionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Session &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.symbol, symbol) ||
                const DeepCollectionEquality().equals(other.symbol, symbol)) &&
            (identical(other.labels, labels) ||
                const DeepCollectionEquality().equals(other.labels, labels)) &&
            (identical(other.startEventIds, startEventIds) ||
                const DeepCollectionEquality()
                    .equals(other.startEventIds, startEventIds)) &&
            (identical(other.studyBurstIds, studyBurstIds) ||
                const DeepCollectionEquality()
                    .equals(other.studyBurstIds, studyBurstIds)) &&
            (identical(other.delay, delay) ||
                const DeepCollectionEquality().equals(other.delay, delay)) &&
            (identical(other.interval, interval) ||
                const DeepCollectionEquality()
                    .equals(other.interval, interval)) &&
            (identical(other.occurrences, occurrences) ||
                const DeepCollectionEquality()
                    .equals(other.occurrences, occurrences)) &&
            (identical(other.performanceOrder, performanceOrder) ||
                const DeepCollectionEquality()
                    .equals(other.performanceOrder, performanceOrder)) &&
            (identical(other.timeWindows, timeWindows) ||
                const DeepCollectionEquality()
                    .equals(other.timeWindows, timeWindows)) &&
            (identical(other.assessments, assessments) ||
                const DeepCollectionEquality()
                    .equals(other.assessments, assessments)) &&
            (identical(other.notifications, notifications) ||
                const DeepCollectionEquality()
                    .equals(other.notifications, notifications)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(symbol) ^
      const DeepCollectionEquality().hash(labels) ^
      const DeepCollectionEquality().hash(startEventIds) ^
      const DeepCollectionEquality().hash(studyBurstIds) ^
      const DeepCollectionEquality().hash(delay) ^
      const DeepCollectionEquality().hash(interval) ^
      const DeepCollectionEquality().hash(occurrences) ^
      const DeepCollectionEquality().hash(performanceOrder) ^
      const DeepCollectionEquality().hash(timeWindows) ^
      const DeepCollectionEquality().hash(assessments) ^
      const DeepCollectionEquality().hash(notifications) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SessionExtension on Session {
  Session copyWith(
      {String? guid,
      String? name,
      String? symbol,
      List<Label>? labels,
      List<String>? startEventIds,
      List<String>? studyBurstIds,
      String? delay,
      String? interval,
      int? occurrences,
      enums.PerformanceOrder? performanceOrder,
      List<TimeWindow>? timeWindows,
      List<AssessmentReference2>? assessments,
      List<Notification>? notifications,
      String? type}) {
    return Session(
        guid: guid ?? this.guid,
        name: name ?? this.name,
        symbol: symbol ?? this.symbol,
        labels: labels ?? this.labels,
        startEventIds: startEventIds ?? this.startEventIds,
        studyBurstIds: studyBurstIds ?? this.studyBurstIds,
        delay: delay ?? this.delay,
        interval: interval ?? this.interval,
        occurrences: occurrences ?? this.occurrences,
        performanceOrder: performanceOrder ?? this.performanceOrder,
        timeWindows: timeWindows ?? this.timeWindows,
        assessments: assessments ?? this.assessments,
        notifications: notifications ?? this.notifications,
        type: type ?? this.type);
  }

  Session copyWithWrapped(
      {Wrapped<String?>? guid,
      Wrapped<String>? name,
      Wrapped<String?>? symbol,
      Wrapped<List<Label>?>? labels,
      Wrapped<List<String>?>? startEventIds,
      Wrapped<List<String>?>? studyBurstIds,
      Wrapped<String?>? delay,
      Wrapped<String?>? interval,
      Wrapped<int?>? occurrences,
      Wrapped<enums.PerformanceOrder>? performanceOrder,
      Wrapped<List<TimeWindow>?>? timeWindows,
      Wrapped<List<AssessmentReference2>?>? assessments,
      Wrapped<List<Notification>?>? notifications,
      Wrapped<String?>? type}) {
    return Session(
        guid: (guid != null ? guid.value : this.guid),
        name: (name != null ? name.value : this.name),
        symbol: (symbol != null ? symbol.value : this.symbol),
        labels: (labels != null ? labels.value : this.labels),
        startEventIds:
            (startEventIds != null ? startEventIds.value : this.startEventIds),
        studyBurstIds:
            (studyBurstIds != null ? studyBurstIds.value : this.studyBurstIds),
        delay: (delay != null ? delay.value : this.delay),
        interval: (interval != null ? interval.value : this.interval),
        occurrences:
            (occurrences != null ? occurrences.value : this.occurrences),
        performanceOrder: (performanceOrder != null
            ? performanceOrder.value
            : this.performanceOrder),
        timeWindows:
            (timeWindows != null ? timeWindows.value : this.timeWindows),
        assessments:
            (assessments != null ? assessments.value : this.assessments),
        notifications:
            (notifications != null ? notifications.value : this.notifications),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SessionInfo {
  SessionInfo({
    this.guid,
    this.label,
    this.symbol,
    this.performanceOrder,
    this.timeWindowGuids,
    this.minutesToComplete,
    this.notifications,
    this.type,
  });

  factory SessionInfo.fromJson(Map<String, dynamic> json) =>
      _$SessionInfoFromJson(json);

  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String? guid;
  @JsonKey(name: 'label', includeIfNull: false, defaultValue: '')
  final String? label;
  @JsonKey(name: 'symbol', includeIfNull: false, defaultValue: '')
  final String? symbol;
  @JsonKey(
    name: 'performanceOrder',
    includeIfNull: false,
    toJson: performanceOrderToJson,
    fromJson: performanceOrderFromJson,
  )
  final enums.PerformanceOrder? performanceOrder;
  @JsonKey(
      name: 'timeWindowGuids', includeIfNull: false, defaultValue: <String>[])
  final List<String>? timeWindowGuids;
  @JsonKey(name: 'minutesToComplete', includeIfNull: false)
  final int? minutesToComplete;
  @JsonKey(
      name: 'notifications',
      includeIfNull: false,
      defaultValue: <NotificationInfo>[])
  final List<NotificationInfo>? notifications;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SessionInfoFromJson;
  static const toJsonFactory = _$SessionInfoToJson;
  Map<String, dynamic> toJson() => _$SessionInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SessionInfo &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.label, label) ||
                const DeepCollectionEquality().equals(other.label, label)) &&
            (identical(other.symbol, symbol) ||
                const DeepCollectionEquality().equals(other.symbol, symbol)) &&
            (identical(other.performanceOrder, performanceOrder) ||
                const DeepCollectionEquality()
                    .equals(other.performanceOrder, performanceOrder)) &&
            (identical(other.timeWindowGuids, timeWindowGuids) ||
                const DeepCollectionEquality()
                    .equals(other.timeWindowGuids, timeWindowGuids)) &&
            (identical(other.minutesToComplete, minutesToComplete) ||
                const DeepCollectionEquality()
                    .equals(other.minutesToComplete, minutesToComplete)) &&
            (identical(other.notifications, notifications) ||
                const DeepCollectionEquality()
                    .equals(other.notifications, notifications)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(label) ^
      const DeepCollectionEquality().hash(symbol) ^
      const DeepCollectionEquality().hash(performanceOrder) ^
      const DeepCollectionEquality().hash(timeWindowGuids) ^
      const DeepCollectionEquality().hash(minutesToComplete) ^
      const DeepCollectionEquality().hash(notifications) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SessionInfoExtension on SessionInfo {
  SessionInfo copyWith(
      {String? guid,
      String? label,
      String? symbol,
      enums.PerformanceOrder? performanceOrder,
      List<String>? timeWindowGuids,
      int? minutesToComplete,
      List<NotificationInfo>? notifications,
      String? type}) {
    return SessionInfo(
        guid: guid ?? this.guid,
        label: label ?? this.label,
        symbol: symbol ?? this.symbol,
        performanceOrder: performanceOrder ?? this.performanceOrder,
        timeWindowGuids: timeWindowGuids ?? this.timeWindowGuids,
        minutesToComplete: minutesToComplete ?? this.minutesToComplete,
        notifications: notifications ?? this.notifications,
        type: type ?? this.type);
  }

  SessionInfo copyWithWrapped(
      {Wrapped<String?>? guid,
      Wrapped<String?>? label,
      Wrapped<String?>? symbol,
      Wrapped<enums.PerformanceOrder?>? performanceOrder,
      Wrapped<List<String>?>? timeWindowGuids,
      Wrapped<int?>? minutesToComplete,
      Wrapped<List<NotificationInfo>?>? notifications,
      Wrapped<String?>? type}) {
    return SessionInfo(
        guid: (guid != null ? guid.value : this.guid),
        label: (label != null ? label.value : this.label),
        symbol: (symbol != null ? symbol.value : this.symbol),
        performanceOrder: (performanceOrder != null
            ? performanceOrder.value
            : this.performanceOrder),
        timeWindowGuids: (timeWindowGuids != null
            ? timeWindowGuids.value
            : this.timeWindowGuids),
        minutesToComplete: (minutesToComplete != null
            ? minutesToComplete.value
            : this.minutesToComplete),
        notifications:
            (notifications != null ? notifications.value : this.notifications),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SharedModuleImportStatus {
  SharedModuleImportStatus({
    this.moduleType,
    this.schemaId,
    this.schemaRevision,
    this.surveyCreatedOn,
    this.surveyGuid,
    this.type,
  });

  factory SharedModuleImportStatus.fromJson(Map<String, dynamic> json) =>
      _$SharedModuleImportStatusFromJson(json);

  @JsonKey(
    name: 'moduleType',
    includeIfNull: false,
    toJson: sharedModuleTypeToJson,
    fromJson: sharedModuleTypeFromJson,
  )
  final enums.SharedModuleType? moduleType;
  @JsonKey(name: 'schemaId', includeIfNull: false, defaultValue: '')
  final String? schemaId;
  @JsonKey(name: 'schemaRevision', includeIfNull: false)
  final int? schemaRevision;
  @JsonKey(name: 'surveyCreatedOn', includeIfNull: false, defaultValue: '')
  final String? surveyCreatedOn;
  @JsonKey(name: 'surveyGuid', includeIfNull: false, defaultValue: '')
  final String? surveyGuid;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SharedModuleImportStatusFromJson;
  static const toJsonFactory = _$SharedModuleImportStatusToJson;
  Map<String, dynamic> toJson() => _$SharedModuleImportStatusToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SharedModuleImportStatus &&
            (identical(other.moduleType, moduleType) ||
                const DeepCollectionEquality()
                    .equals(other.moduleType, moduleType)) &&
            (identical(other.schemaId, schemaId) ||
                const DeepCollectionEquality()
                    .equals(other.schemaId, schemaId)) &&
            (identical(other.schemaRevision, schemaRevision) ||
                const DeepCollectionEquality()
                    .equals(other.schemaRevision, schemaRevision)) &&
            (identical(other.surveyCreatedOn, surveyCreatedOn) ||
                const DeepCollectionEquality()
                    .equals(other.surveyCreatedOn, surveyCreatedOn)) &&
            (identical(other.surveyGuid, surveyGuid) ||
                const DeepCollectionEquality()
                    .equals(other.surveyGuid, surveyGuid)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(moduleType) ^
      const DeepCollectionEquality().hash(schemaId) ^
      const DeepCollectionEquality().hash(schemaRevision) ^
      const DeepCollectionEquality().hash(surveyCreatedOn) ^
      const DeepCollectionEquality().hash(surveyGuid) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SharedModuleImportStatusExtension on SharedModuleImportStatus {
  SharedModuleImportStatus copyWith(
      {enums.SharedModuleType? moduleType,
      String? schemaId,
      int? schemaRevision,
      String? surveyCreatedOn,
      String? surveyGuid,
      String? type}) {
    return SharedModuleImportStatus(
        moduleType: moduleType ?? this.moduleType,
        schemaId: schemaId ?? this.schemaId,
        schemaRevision: schemaRevision ?? this.schemaRevision,
        surveyCreatedOn: surveyCreatedOn ?? this.surveyCreatedOn,
        surveyGuid: surveyGuid ?? this.surveyGuid,
        type: type ?? this.type);
  }

  SharedModuleImportStatus copyWithWrapped(
      {Wrapped<enums.SharedModuleType?>? moduleType,
      Wrapped<String?>? schemaId,
      Wrapped<int?>? schemaRevision,
      Wrapped<String?>? surveyCreatedOn,
      Wrapped<String?>? surveyGuid,
      Wrapped<String?>? type}) {
    return SharedModuleImportStatus(
        moduleType: (moduleType != null ? moduleType.value : this.moduleType),
        schemaId: (schemaId != null ? schemaId.value : this.schemaId),
        schemaRevision: (schemaRevision != null
            ? schemaRevision.value
            : this.schemaRevision),
        surveyCreatedOn: (surveyCreatedOn != null
            ? surveyCreatedOn.value
            : this.surveyCreatedOn),
        surveyGuid: (surveyGuid != null ? surveyGuid.value : this.surveyGuid),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SharedModuleMetadata {
  SharedModuleMetadata({
    required this.id,
    this.licenseRestricted,
    this.moduleType,
    required this.name,
    this.notes,
    this.os,
    this.published,
    this.schemaId,
    this.schemaRevision,
    this.surveyCreatedOn,
    this.surveyGuid,
    required this.tags,
    this.deleted,
    required this.version,
    this.type,
  });

  factory SharedModuleMetadata.fromJson(Map<String, dynamic> json) =>
      _$SharedModuleMetadataFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'licenseRestricted', includeIfNull: false)
  final bool? licenseRestricted;
  @JsonKey(
    name: 'moduleType',
    includeIfNull: false,
    toJson: sharedModuleTypeToJson,
    fromJson: sharedModuleTypeFromJson,
  )
  final enums.SharedModuleType? moduleType;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'os', includeIfNull: false, defaultValue: '')
  final String? os;
  @JsonKey(name: 'published', includeIfNull: false)
  final bool? published;
  @JsonKey(name: 'schemaId', includeIfNull: false, defaultValue: '')
  final String? schemaId;
  @JsonKey(name: 'schemaRevision', includeIfNull: false)
  final int? schemaRevision;
  @JsonKey(name: 'surveyCreatedOn', includeIfNull: false, defaultValue: '')
  final String? surveyCreatedOn;
  @JsonKey(name: 'surveyGuid', includeIfNull: false, defaultValue: '')
  final String? surveyGuid;
  @JsonKey(name: 'tags', includeIfNull: false, defaultValue: <String>[])
  final List<String> tags;
  @JsonKey(name: 'deleted', includeIfNull: false)
  final bool? deleted;
  @JsonKey(name: 'version', includeIfNull: false)
  final int version;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SharedModuleMetadataFromJson;
  static const toJsonFactory = _$SharedModuleMetadataToJson;
  Map<String, dynamic> toJson() => _$SharedModuleMetadataToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SharedModuleMetadata &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.licenseRestricted, licenseRestricted) ||
                const DeepCollectionEquality()
                    .equals(other.licenseRestricted, licenseRestricted)) &&
            (identical(other.moduleType, moduleType) ||
                const DeepCollectionEquality()
                    .equals(other.moduleType, moduleType)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.os, os) ||
                const DeepCollectionEquality().equals(other.os, os)) &&
            (identical(other.published, published) ||
                const DeepCollectionEquality()
                    .equals(other.published, published)) &&
            (identical(other.schemaId, schemaId) ||
                const DeepCollectionEquality()
                    .equals(other.schemaId, schemaId)) &&
            (identical(other.schemaRevision, schemaRevision) ||
                const DeepCollectionEquality()
                    .equals(other.schemaRevision, schemaRevision)) &&
            (identical(other.surveyCreatedOn, surveyCreatedOn) ||
                const DeepCollectionEquality()
                    .equals(other.surveyCreatedOn, surveyCreatedOn)) &&
            (identical(other.surveyGuid, surveyGuid) ||
                const DeepCollectionEquality()
                    .equals(other.surveyGuid, surveyGuid)) &&
            (identical(other.tags, tags) ||
                const DeepCollectionEquality().equals(other.tags, tags)) &&
            (identical(other.deleted, deleted) ||
                const DeepCollectionEquality()
                    .equals(other.deleted, deleted)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(licenseRestricted) ^
      const DeepCollectionEquality().hash(moduleType) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(os) ^
      const DeepCollectionEquality().hash(published) ^
      const DeepCollectionEquality().hash(schemaId) ^
      const DeepCollectionEquality().hash(schemaRevision) ^
      const DeepCollectionEquality().hash(surveyCreatedOn) ^
      const DeepCollectionEquality().hash(surveyGuid) ^
      const DeepCollectionEquality().hash(tags) ^
      const DeepCollectionEquality().hash(deleted) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SharedModuleMetadataExtension on SharedModuleMetadata {
  SharedModuleMetadata copyWith(
      {String? id,
      bool? licenseRestricted,
      enums.SharedModuleType? moduleType,
      String? name,
      String? notes,
      String? os,
      bool? published,
      String? schemaId,
      int? schemaRevision,
      String? surveyCreatedOn,
      String? surveyGuid,
      List<String>? tags,
      bool? deleted,
      int? version,
      String? type}) {
    return SharedModuleMetadata(
        id: id ?? this.id,
        licenseRestricted: licenseRestricted ?? this.licenseRestricted,
        moduleType: moduleType ?? this.moduleType,
        name: name ?? this.name,
        notes: notes ?? this.notes,
        os: os ?? this.os,
        published: published ?? this.published,
        schemaId: schemaId ?? this.schemaId,
        schemaRevision: schemaRevision ?? this.schemaRevision,
        surveyCreatedOn: surveyCreatedOn ?? this.surveyCreatedOn,
        surveyGuid: surveyGuid ?? this.surveyGuid,
        tags: tags ?? this.tags,
        deleted: deleted ?? this.deleted,
        version: version ?? this.version,
        type: type ?? this.type);
  }

  SharedModuleMetadata copyWithWrapped(
      {Wrapped<String>? id,
      Wrapped<bool?>? licenseRestricted,
      Wrapped<enums.SharedModuleType?>? moduleType,
      Wrapped<String>? name,
      Wrapped<String?>? notes,
      Wrapped<String?>? os,
      Wrapped<bool?>? published,
      Wrapped<String?>? schemaId,
      Wrapped<int?>? schemaRevision,
      Wrapped<String?>? surveyCreatedOn,
      Wrapped<String?>? surveyGuid,
      Wrapped<List<String>>? tags,
      Wrapped<bool?>? deleted,
      Wrapped<int>? version,
      Wrapped<String?>? type}) {
    return SharedModuleMetadata(
        id: (id != null ? id.value : this.id),
        licenseRestricted: (licenseRestricted != null
            ? licenseRestricted.value
            : this.licenseRestricted),
        moduleType: (moduleType != null ? moduleType.value : this.moduleType),
        name: (name != null ? name.value : this.name),
        notes: (notes != null ? notes.value : this.notes),
        os: (os != null ? os.value : this.os),
        published: (published != null ? published.value : this.published),
        schemaId: (schemaId != null ? schemaId.value : this.schemaId),
        schemaRevision: (schemaRevision != null
            ? schemaRevision.value
            : this.schemaRevision),
        surveyCreatedOn: (surveyCreatedOn != null
            ? surveyCreatedOn.value
            : this.surveyCreatedOn),
        surveyGuid: (surveyGuid != null ? surveyGuid.value : this.surveyGuid),
        tags: (tags != null ? tags.value : this.tags),
        deleted: (deleted != null ? deleted.value : this.deleted),
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SharingScopeForm {
  SharingScopeForm({
    required this.scope,
    this.type,
  });

  factory SharingScopeForm.fromJson(Map<String, dynamic> json) =>
      _$SharingScopeFormFromJson(json);

  @JsonKey(
    name: 'scope',
    includeIfNull: false,
    toJson: sharingScopeToJson,
    fromJson: sharingScopeFromJson,
  )
  final enums.SharingScope scope;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SharingScopeFormFromJson;
  static const toJsonFactory = _$SharingScopeFormToJson;
  Map<String, dynamic> toJson() => _$SharingScopeFormToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SharingScopeForm &&
            (identical(other.scope, scope) ||
                const DeepCollectionEquality().equals(other.scope, scope)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(scope) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SharingScopeFormExtension on SharingScopeForm {
  SharingScopeForm copyWith({enums.SharingScope? scope, String? type}) {
    return SharingScopeForm(
        scope: scope ?? this.scope, type: type ?? this.type);
  }

  SharingScopeForm copyWithWrapped(
      {Wrapped<enums.SharingScope>? scope, Wrapped<String?>? type}) {
    return SharingScopeForm(
        scope: (scope != null ? scope.value : this.scope),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SignIn {
  SignIn({
    required this.appId,
    this.email,
    this.phone,
    this.externalId,
    this.password,
    this.reauthToken,
    this.type,
  });

  factory SignIn.fromJson(Map<String, dynamic> json) => _$SignInFromJson(json);

  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String appId;
  @JsonKey(name: 'email', includeIfNull: false, defaultValue: '')
  final String? email;
  @JsonKey(name: 'phone', includeIfNull: false)
  final Phone? phone;
  @JsonKey(name: 'externalId', includeIfNull: false, defaultValue: '')
  final String? externalId;
  @JsonKey(name: 'password', includeIfNull: false, defaultValue: '')
  final String? password;
  @JsonKey(name: 'reauthToken', includeIfNull: false, defaultValue: '')
  final String? reauthToken;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SignInFromJson;
  static const toJsonFactory = _$SignInToJson;
  Map<String, dynamic> toJson() => _$SignInToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SignIn &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.externalId, externalId) ||
                const DeepCollectionEquality()
                    .equals(other.externalId, externalId)) &&
            (identical(other.password, password) ||
                const DeepCollectionEquality()
                    .equals(other.password, password)) &&
            (identical(other.reauthToken, reauthToken) ||
                const DeepCollectionEquality()
                    .equals(other.reauthToken, reauthToken)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(appId) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(phone) ^
      const DeepCollectionEquality().hash(externalId) ^
      const DeepCollectionEquality().hash(password) ^
      const DeepCollectionEquality().hash(reauthToken) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SignInExtension on SignIn {
  SignIn copyWith(
      {String? appId,
      String? email,
      Phone? phone,
      String? externalId,
      String? password,
      String? reauthToken,
      String? type}) {
    return SignIn(
        appId: appId ?? this.appId,
        email: email ?? this.email,
        phone: phone ?? this.phone,
        externalId: externalId ?? this.externalId,
        password: password ?? this.password,
        reauthToken: reauthToken ?? this.reauthToken,
        type: type ?? this.type);
  }

  SignIn copyWithWrapped(
      {Wrapped<String>? appId,
      Wrapped<String?>? email,
      Wrapped<Phone?>? phone,
      Wrapped<String?>? externalId,
      Wrapped<String?>? password,
      Wrapped<String?>? reauthToken,
      Wrapped<String?>? type}) {
    return SignIn(
        appId: (appId != null ? appId.value : this.appId),
        email: (email != null ? email.value : this.email),
        phone: (phone != null ? phone.value : this.phone),
        externalId: (externalId != null ? externalId.value : this.externalId),
        password: (password != null ? password.value : this.password),
        reauthToken:
            (reauthToken != null ? reauthToken.value : this.reauthToken),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SignUp {
  SignUp({
    required this.appId,
    this.email,
    this.phone,
    this.externalId,
    this.password,
    this.consent,
    this.type,
    this.firstName,
    this.lastName,
    this.synapseUserId,
    this.id,
    this.notifyByEmail,
    this.attributes,
    this.sharingScope,
    this.createdOn,
    this.emailVerified,
    this.phoneVerified,
    this.status,
    this.roles,
    this.dataGroups,
    this.clientData,
    this.languages,
    this.studyIds,
    this.externalIds,
    this.orgMembership,
    this.note,
    this.clientTimeZone,
  });

  factory SignUp.fromJson(Map<String, dynamic> json) => _$SignUpFromJson(json);

  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String appId;
  @JsonKey(name: 'email', includeIfNull: false, defaultValue: '')
  final String? email;
  @JsonKey(name: 'phone', includeIfNull: false)
  final Phone? phone;
  @JsonKey(name: 'externalId', includeIfNull: false, defaultValue: '')
  final String? externalId;
  @JsonKey(name: 'password', includeIfNull: false, defaultValue: '')
  final String? password;
  @JsonKey(name: 'consent', includeIfNull: false)
  final bool? consent;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  @JsonKey(name: 'firstName', includeIfNull: false, defaultValue: '')
  final String? firstName;
  @JsonKey(name: 'lastName', includeIfNull: false, defaultValue: '')
  final String? lastName;
  @JsonKey(name: 'synapseUserId', includeIfNull: false, defaultValue: '')
  final String? synapseUserId;
  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'notifyByEmail', includeIfNull: false, defaultValue: true)
  final bool? notifyByEmail;
  @JsonKey(name: 'attributes', includeIfNull: false)
  final Map<String, dynamic>? attributes;
  @JsonKey(
    name: 'sharingScope',
    includeIfNull: false,
    toJson: sharingScopeToJson,
    fromJson: sharingScopeFromJson,
  )
  final enums.SharingScope? sharingScope;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'emailVerified', includeIfNull: false)
  final bool? emailVerified;
  @JsonKey(name: 'phoneVerified', includeIfNull: false)
  final bool? phoneVerified;
  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: accountStatusToJson,
    fromJson: accountStatusFromJson,
  )
  final enums.AccountStatus? status;
  @JsonKey(
    name: 'roles',
    includeIfNull: false,
    toJson: roleListToJson,
    fromJson: roleListFromJson,
  )
  final List<enums.Role>? roles;
  @JsonKey(name: 'dataGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String>? dataGroups;
  @JsonKey(name: 'clientData', includeIfNull: false)
  final Map<String, dynamic>? clientData;
  @JsonKey(name: 'languages', includeIfNull: false, defaultValue: <String>[])
  final List<String>? languages;
  @JsonKey(name: 'studyIds', includeIfNull: false, defaultValue: <String>[])
  final List<String>? studyIds;
  @JsonKey(name: 'externalIds', includeIfNull: false)
  final Map<String, dynamic>? externalIds;
  @JsonKey(name: 'orgMembership', includeIfNull: false, defaultValue: '')
  final String? orgMembership;
  @JsonKey(name: 'note', includeIfNull: false, defaultValue: '')
  final String? note;
  @JsonKey(name: 'clientTimeZone', includeIfNull: false, defaultValue: '')
  final String? clientTimeZone;
  static const fromJsonFactory = _$SignUpFromJson;
  static const toJsonFactory = _$SignUpToJson;
  Map<String, dynamic> toJson() => _$SignUpToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SignUp &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.externalId, externalId) ||
                const DeepCollectionEquality()
                    .equals(other.externalId, externalId)) &&
            (identical(other.password, password) ||
                const DeepCollectionEquality()
                    .equals(other.password, password)) &&
            (identical(other.consent, consent) ||
                const DeepCollectionEquality()
                    .equals(other.consent, consent)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.lastName, lastName) ||
                const DeepCollectionEquality()
                    .equals(other.lastName, lastName)) &&
            (identical(other.synapseUserId, synapseUserId) ||
                const DeepCollectionEquality()
                    .equals(other.synapseUserId, synapseUserId)) &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.notifyByEmail, notifyByEmail) ||
                const DeepCollectionEquality()
                    .equals(other.notifyByEmail, notifyByEmail)) &&
            (identical(other.attributes, attributes) ||
                const DeepCollectionEquality()
                    .equals(other.attributes, attributes)) &&
            (identical(other.sharingScope, sharingScope) ||
                const DeepCollectionEquality()
                    .equals(other.sharingScope, sharingScope)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.emailVerified, emailVerified) ||
                const DeepCollectionEquality()
                    .equals(other.emailVerified, emailVerified)) &&
            (identical(other.phoneVerified, phoneVerified) ||
                const DeepCollectionEquality()
                    .equals(other.phoneVerified, phoneVerified)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.roles, roles) ||
                const DeepCollectionEquality().equals(other.roles, roles)) &&
            (identical(other.dataGroups, dataGroups) ||
                const DeepCollectionEquality()
                    .equals(other.dataGroups, dataGroups)) &&
            (identical(other.clientData, clientData) ||
                const DeepCollectionEquality()
                    .equals(other.clientData, clientData)) &&
            (identical(other.languages, languages) ||
                const DeepCollectionEquality()
                    .equals(other.languages, languages)) &&
            (identical(other.studyIds, studyIds) ||
                const DeepCollectionEquality()
                    .equals(other.studyIds, studyIds)) &&
            (identical(other.externalIds, externalIds) ||
                const DeepCollectionEquality()
                    .equals(other.externalIds, externalIds)) &&
            (identical(other.orgMembership, orgMembership) ||
                const DeepCollectionEquality()
                    .equals(other.orgMembership, orgMembership)) &&
            (identical(other.note, note) || const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.clientTimeZone, clientTimeZone) || const DeepCollectionEquality().equals(other.clientTimeZone, clientTimeZone)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(appId) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(phone) ^
      const DeepCollectionEquality().hash(externalId) ^
      const DeepCollectionEquality().hash(password) ^
      const DeepCollectionEquality().hash(consent) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(firstName) ^
      const DeepCollectionEquality().hash(lastName) ^
      const DeepCollectionEquality().hash(synapseUserId) ^
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(notifyByEmail) ^
      const DeepCollectionEquality().hash(attributes) ^
      const DeepCollectionEquality().hash(sharingScope) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(emailVerified) ^
      const DeepCollectionEquality().hash(phoneVerified) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(roles) ^
      const DeepCollectionEquality().hash(dataGroups) ^
      const DeepCollectionEquality().hash(clientData) ^
      const DeepCollectionEquality().hash(languages) ^
      const DeepCollectionEquality().hash(studyIds) ^
      const DeepCollectionEquality().hash(externalIds) ^
      const DeepCollectionEquality().hash(orgMembership) ^
      const DeepCollectionEquality().hash(note) ^
      const DeepCollectionEquality().hash(clientTimeZone) ^
      runtimeType.hashCode;
}

extension $SignUpExtension on SignUp {
  SignUp copyWith(
      {String? appId,
      String? email,
      Phone? phone,
      String? externalId,
      String? password,
      bool? consent,
      String? type,
      String? firstName,
      String? lastName,
      String? synapseUserId,
      String? id,
      bool? notifyByEmail,
      Map<String, dynamic>? attributes,
      enums.SharingScope? sharingScope,
      DateTime? createdOn,
      bool? emailVerified,
      bool? phoneVerified,
      enums.AccountStatus? status,
      List<enums.Role>? roles,
      List<String>? dataGroups,
      Map<String, dynamic>? clientData,
      List<String>? languages,
      List<String>? studyIds,
      Map<String, dynamic>? externalIds,
      String? orgMembership,
      String? note,
      String? clientTimeZone}) {
    return SignUp(
        appId: appId ?? this.appId,
        email: email ?? this.email,
        phone: phone ?? this.phone,
        externalId: externalId ?? this.externalId,
        password: password ?? this.password,
        consent: consent ?? this.consent,
        type: type ?? this.type,
        firstName: firstName ?? this.firstName,
        lastName: lastName ?? this.lastName,
        synapseUserId: synapseUserId ?? this.synapseUserId,
        id: id ?? this.id,
        notifyByEmail: notifyByEmail ?? this.notifyByEmail,
        attributes: attributes ?? this.attributes,
        sharingScope: sharingScope ?? this.sharingScope,
        createdOn: createdOn ?? this.createdOn,
        emailVerified: emailVerified ?? this.emailVerified,
        phoneVerified: phoneVerified ?? this.phoneVerified,
        status: status ?? this.status,
        roles: roles ?? this.roles,
        dataGroups: dataGroups ?? this.dataGroups,
        clientData: clientData ?? this.clientData,
        languages: languages ?? this.languages,
        studyIds: studyIds ?? this.studyIds,
        externalIds: externalIds ?? this.externalIds,
        orgMembership: orgMembership ?? this.orgMembership,
        note: note ?? this.note,
        clientTimeZone: clientTimeZone ?? this.clientTimeZone);
  }

  SignUp copyWithWrapped(
      {Wrapped<String>? appId,
      Wrapped<String?>? email,
      Wrapped<Phone?>? phone,
      Wrapped<String?>? externalId,
      Wrapped<String?>? password,
      Wrapped<bool?>? consent,
      Wrapped<String?>? type,
      Wrapped<String?>? firstName,
      Wrapped<String?>? lastName,
      Wrapped<String?>? synapseUserId,
      Wrapped<String?>? id,
      Wrapped<bool?>? notifyByEmail,
      Wrapped<Map<String, dynamic>?>? attributes,
      Wrapped<enums.SharingScope?>? sharingScope,
      Wrapped<DateTime?>? createdOn,
      Wrapped<bool?>? emailVerified,
      Wrapped<bool?>? phoneVerified,
      Wrapped<enums.AccountStatus?>? status,
      Wrapped<List<enums.Role>?>? roles,
      Wrapped<List<String>?>? dataGroups,
      Wrapped<Map<String, dynamic>?>? clientData,
      Wrapped<List<String>?>? languages,
      Wrapped<List<String>?>? studyIds,
      Wrapped<Map<String, dynamic>?>? externalIds,
      Wrapped<String?>? orgMembership,
      Wrapped<String?>? note,
      Wrapped<String?>? clientTimeZone}) {
    return SignUp(
        appId: (appId != null ? appId.value : this.appId),
        email: (email != null ? email.value : this.email),
        phone: (phone != null ? phone.value : this.phone),
        externalId: (externalId != null ? externalId.value : this.externalId),
        password: (password != null ? password.value : this.password),
        consent: (consent != null ? consent.value : this.consent),
        type: (type != null ? type.value : this.type),
        firstName: (firstName != null ? firstName.value : this.firstName),
        lastName: (lastName != null ? lastName.value : this.lastName),
        synapseUserId:
            (synapseUserId != null ? synapseUserId.value : this.synapseUserId),
        id: (id != null ? id.value : this.id),
        notifyByEmail:
            (notifyByEmail != null ? notifyByEmail.value : this.notifyByEmail),
        attributes: (attributes != null ? attributes.value : this.attributes),
        sharingScope:
            (sharingScope != null ? sharingScope.value : this.sharingScope),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        emailVerified:
            (emailVerified != null ? emailVerified.value : this.emailVerified),
        phoneVerified:
            (phoneVerified != null ? phoneVerified.value : this.phoneVerified),
        status: (status != null ? status.value : this.status),
        roles: (roles != null ? roles.value : this.roles),
        dataGroups: (dataGroups != null ? dataGroups.value : this.dataGroups),
        clientData: (clientData != null ? clientData.value : this.clientData),
        languages: (languages != null ? languages.value : this.languages),
        studyIds: (studyIds != null ? studyIds.value : this.studyIds),
        externalIds:
            (externalIds != null ? externalIds.value : this.externalIds),
        orgMembership:
            (orgMembership != null ? orgMembership.value : this.orgMembership),
        note: (note != null ? note.value : this.note),
        clientTimeZone: (clientTimeZone != null
            ? clientTimeZone.value
            : this.clientTimeZone));
  }
}

@JsonSerializable(explicitToJson: true)
class SimpleScheduleStrategy {
  SimpleScheduleStrategy({
    required this.schedule,
    this.type,
  });

  factory SimpleScheduleStrategy.fromJson(Map<String, dynamic> json) =>
      _$SimpleScheduleStrategyFromJson(json);

  @JsonKey(name: 'schedule', includeIfNull: false)
  final Schedule schedule;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SimpleScheduleStrategyFromJson;
  static const toJsonFactory = _$SimpleScheduleStrategyToJson;
  Map<String, dynamic> toJson() => _$SimpleScheduleStrategyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SimpleScheduleStrategy &&
            (identical(other.schedule, schedule) ||
                const DeepCollectionEquality()
                    .equals(other.schedule, schedule)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(schedule) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SimpleScheduleStrategyExtension on SimpleScheduleStrategy {
  SimpleScheduleStrategy copyWith({Schedule? schedule, String? type}) {
    return SimpleScheduleStrategy(
        schedule: schedule ?? this.schedule, type: type ?? this.type);
  }

  SimpleScheduleStrategy copyWithWrapped(
      {Wrapped<Schedule>? schedule, Wrapped<String?>? type}) {
    return SimpleScheduleStrategy(
        schedule: (schedule != null ? schedule.value : this.schedule),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SmsMessage {
  SmsMessage({
    this.phoneNumber,
    this.sentOn,
    this.healthCode,
    this.messageBody,
    this.messageId,
    this.smsType,
    this.appId,
    this.type,
  });

  factory SmsMessage.fromJson(Map<String, dynamic> json) =>
      _$SmsMessageFromJson(json);

  @JsonKey(name: 'phoneNumber', includeIfNull: false, defaultValue: '')
  final String? phoneNumber;
  @JsonKey(name: 'sentOn', includeIfNull: false)
  final DateTime? sentOn;
  @JsonKey(name: 'healthCode', includeIfNull: false, defaultValue: '')
  final String? healthCode;
  @JsonKey(name: 'messageBody', includeIfNull: false, defaultValue: '')
  final String? messageBody;
  @JsonKey(name: 'messageId', includeIfNull: false, defaultValue: '')
  final String? messageId;
  @JsonKey(
    name: 'smsType',
    includeIfNull: false,
    toJson: smsTypeToJson,
    fromJson: smsTypeFromJson,
  )
  final enums.SmsType? smsType;
  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String? appId;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SmsMessageFromJson;
  static const toJsonFactory = _$SmsMessageToJson;
  Map<String, dynamic> toJson() => _$SmsMessageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SmsMessage &&
            (identical(other.phoneNumber, phoneNumber) ||
                const DeepCollectionEquality()
                    .equals(other.phoneNumber, phoneNumber)) &&
            (identical(other.sentOn, sentOn) ||
                const DeepCollectionEquality().equals(other.sentOn, sentOn)) &&
            (identical(other.healthCode, healthCode) ||
                const DeepCollectionEquality()
                    .equals(other.healthCode, healthCode)) &&
            (identical(other.messageBody, messageBody) ||
                const DeepCollectionEquality()
                    .equals(other.messageBody, messageBody)) &&
            (identical(other.messageId, messageId) ||
                const DeepCollectionEquality()
                    .equals(other.messageId, messageId)) &&
            (identical(other.smsType, smsType) ||
                const DeepCollectionEquality()
                    .equals(other.smsType, smsType)) &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(phoneNumber) ^
      const DeepCollectionEquality().hash(sentOn) ^
      const DeepCollectionEquality().hash(healthCode) ^
      const DeepCollectionEquality().hash(messageBody) ^
      const DeepCollectionEquality().hash(messageId) ^
      const DeepCollectionEquality().hash(smsType) ^
      const DeepCollectionEquality().hash(appId) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SmsMessageExtension on SmsMessage {
  SmsMessage copyWith(
      {String? phoneNumber,
      DateTime? sentOn,
      String? healthCode,
      String? messageBody,
      String? messageId,
      enums.SmsType? smsType,
      String? appId,
      String? type}) {
    return SmsMessage(
        phoneNumber: phoneNumber ?? this.phoneNumber,
        sentOn: sentOn ?? this.sentOn,
        healthCode: healthCode ?? this.healthCode,
        messageBody: messageBody ?? this.messageBody,
        messageId: messageId ?? this.messageId,
        smsType: smsType ?? this.smsType,
        appId: appId ?? this.appId,
        type: type ?? this.type);
  }

  SmsMessage copyWithWrapped(
      {Wrapped<String?>? phoneNumber,
      Wrapped<DateTime?>? sentOn,
      Wrapped<String?>? healthCode,
      Wrapped<String?>? messageBody,
      Wrapped<String?>? messageId,
      Wrapped<enums.SmsType?>? smsType,
      Wrapped<String?>? appId,
      Wrapped<String?>? type}) {
    return SmsMessage(
        phoneNumber:
            (phoneNumber != null ? phoneNumber.value : this.phoneNumber),
        sentOn: (sentOn != null ? sentOn.value : this.sentOn),
        healthCode: (healthCode != null ? healthCode.value : this.healthCode),
        messageBody:
            (messageBody != null ? messageBody.value : this.messageBody),
        messageId: (messageId != null ? messageId.value : this.messageId),
        smsType: (smsType != null ? smsType.value : this.smsType),
        appId: (appId != null ? appId.value : this.appId),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SmsTemplate {
  SmsTemplate({
    required this.message,
    this.type,
  });

  factory SmsTemplate.fromJson(Map<String, dynamic> json) =>
      _$SmsTemplateFromJson(json);

  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String message;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SmsTemplateFromJson;
  static const toJsonFactory = _$SmsTemplateToJson;
  Map<String, dynamic> toJson() => _$SmsTemplateToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SmsTemplate &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SmsTemplateExtension on SmsTemplate {
  SmsTemplate copyWith({String? message, String? type}) {
    return SmsTemplate(
        message: message ?? this.message, type: type ?? this.type);
  }

  SmsTemplate copyWithWrapped(
      {Wrapped<String>? message, Wrapped<String?>? type}) {
    return SmsTemplate(
        message: (message != null ? message.value : this.message),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class StudyActivityEventRequest {
  StudyActivityEventRequest({
    required this.eventId,
    required this.timestamp,
    this.answerValue,
    this.clientTimeZone,
    this.type,
  });

  factory StudyActivityEventRequest.fromJson(Map<String, dynamic> json) =>
      _$StudyActivityEventRequestFromJson(json);

  @JsonKey(name: 'eventId', includeIfNull: false, defaultValue: '')
  final String eventId;
  @JsonKey(name: 'timestamp', includeIfNull: false)
  final DateTime timestamp;
  @JsonKey(name: 'answerValue', includeIfNull: false, defaultValue: '')
  final String? answerValue;
  @JsonKey(name: 'clientTimeZone', includeIfNull: false, defaultValue: '')
  final String? clientTimeZone;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$StudyActivityEventRequestFromJson;
  static const toJsonFactory = _$StudyActivityEventRequestToJson;
  Map<String, dynamic> toJson() => _$StudyActivityEventRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StudyActivityEventRequest &&
            (identical(other.eventId, eventId) ||
                const DeepCollectionEquality()
                    .equals(other.eventId, eventId)) &&
            (identical(other.timestamp, timestamp) ||
                const DeepCollectionEquality()
                    .equals(other.timestamp, timestamp)) &&
            (identical(other.answerValue, answerValue) ||
                const DeepCollectionEquality()
                    .equals(other.answerValue, answerValue)) &&
            (identical(other.clientTimeZone, clientTimeZone) ||
                const DeepCollectionEquality()
                    .equals(other.clientTimeZone, clientTimeZone)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(eventId) ^
      const DeepCollectionEquality().hash(timestamp) ^
      const DeepCollectionEquality().hash(answerValue) ^
      const DeepCollectionEquality().hash(clientTimeZone) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $StudyActivityEventRequestExtension on StudyActivityEventRequest {
  StudyActivityEventRequest copyWith(
      {String? eventId,
      DateTime? timestamp,
      String? answerValue,
      String? clientTimeZone,
      String? type}) {
    return StudyActivityEventRequest(
        eventId: eventId ?? this.eventId,
        timestamp: timestamp ?? this.timestamp,
        answerValue: answerValue ?? this.answerValue,
        clientTimeZone: clientTimeZone ?? this.clientTimeZone,
        type: type ?? this.type);
  }

  StudyActivityEventRequest copyWithWrapped(
      {Wrapped<String>? eventId,
      Wrapped<DateTime>? timestamp,
      Wrapped<String?>? answerValue,
      Wrapped<String?>? clientTimeZone,
      Wrapped<String?>? type}) {
    return StudyActivityEventRequest(
        eventId: (eventId != null ? eventId.value : this.eventId),
        timestamp: (timestamp != null ? timestamp.value : this.timestamp),
        answerValue:
            (answerValue != null ? answerValue.value : this.answerValue),
        clientTimeZone: (clientTimeZone != null
            ? clientTimeZone.value
            : this.clientTimeZone),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class StudyBurst {
  StudyBurst({
    required this.identifier,
    required this.originEventId,
    this.delay,
    required this.interval,
    required this.occurrences,
    required this.updateType,
    this.type,
  });

  factory StudyBurst.fromJson(Map<String, dynamic> json) =>
      _$StudyBurstFromJson(json);

  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String identifier;
  @JsonKey(name: 'originEventId', includeIfNull: false, defaultValue: '')
  final String originEventId;
  @JsonKey(name: 'delay', includeIfNull: false, defaultValue: '')
  final String? delay;
  @JsonKey(name: 'interval', includeIfNull: false, defaultValue: '')
  final String interval;
  @JsonKey(name: 'occurrences', includeIfNull: false)
  final int occurrences;
  @JsonKey(
    name: 'updateType',
    includeIfNull: false,
    toJson: activityEventUpdateTypeToJson,
    fromJson: activityEventUpdateTypeFromJson,
  )
  final enums.ActivityEventUpdateType updateType;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$StudyBurstFromJson;
  static const toJsonFactory = _$StudyBurstToJson;
  Map<String, dynamic> toJson() => _$StudyBurstToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StudyBurst &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.originEventId, originEventId) ||
                const DeepCollectionEquality()
                    .equals(other.originEventId, originEventId)) &&
            (identical(other.delay, delay) ||
                const DeepCollectionEquality().equals(other.delay, delay)) &&
            (identical(other.interval, interval) ||
                const DeepCollectionEquality()
                    .equals(other.interval, interval)) &&
            (identical(other.occurrences, occurrences) ||
                const DeepCollectionEquality()
                    .equals(other.occurrences, occurrences)) &&
            (identical(other.updateType, updateType) ||
                const DeepCollectionEquality()
                    .equals(other.updateType, updateType)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(originEventId) ^
      const DeepCollectionEquality().hash(delay) ^
      const DeepCollectionEquality().hash(interval) ^
      const DeepCollectionEquality().hash(occurrences) ^
      const DeepCollectionEquality().hash(updateType) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $StudyBurstExtension on StudyBurst {
  StudyBurst copyWith(
      {String? identifier,
      String? originEventId,
      String? delay,
      String? interval,
      int? occurrences,
      enums.ActivityEventUpdateType? updateType,
      String? type}) {
    return StudyBurst(
        identifier: identifier ?? this.identifier,
        originEventId: originEventId ?? this.originEventId,
        delay: delay ?? this.delay,
        interval: interval ?? this.interval,
        occurrences: occurrences ?? this.occurrences,
        updateType: updateType ?? this.updateType,
        type: type ?? this.type);
  }

  StudyBurst copyWithWrapped(
      {Wrapped<String>? identifier,
      Wrapped<String>? originEventId,
      Wrapped<String?>? delay,
      Wrapped<String>? interval,
      Wrapped<int>? occurrences,
      Wrapped<enums.ActivityEventUpdateType>? updateType,
      Wrapped<String?>? type}) {
    return StudyBurst(
        identifier: (identifier != null ? identifier.value : this.identifier),
        originEventId:
            (originEventId != null ? originEventId.value : this.originEventId),
        delay: (delay != null ? delay.value : this.delay),
        interval: (interval != null ? interval.value : this.interval),
        occurrences:
            (occurrences != null ? occurrences.value : this.occurrences),
        updateType: (updateType != null ? updateType.value : this.updateType),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class StudyBurstInfo {
  StudyBurstInfo({
    this.identifier,
    this.originEventId,
    this.delay,
    this.interval,
    this.occurrences,
    this.type,
  });

  factory StudyBurstInfo.fromJson(Map<String, dynamic> json) =>
      _$StudyBurstInfoFromJson(json);

  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String? identifier;
  @JsonKey(name: 'originEventId', includeIfNull: false, defaultValue: '')
  final String? originEventId;
  @JsonKey(name: 'delay', includeIfNull: false, defaultValue: '')
  final String? delay;
  @JsonKey(name: 'interval', includeIfNull: false, defaultValue: '')
  final String? interval;
  @JsonKey(name: 'occurrences', includeIfNull: false)
  final int? occurrences;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$StudyBurstInfoFromJson;
  static const toJsonFactory = _$StudyBurstInfoToJson;
  Map<String, dynamic> toJson() => _$StudyBurstInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StudyBurstInfo &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.originEventId, originEventId) ||
                const DeepCollectionEquality()
                    .equals(other.originEventId, originEventId)) &&
            (identical(other.delay, delay) ||
                const DeepCollectionEquality().equals(other.delay, delay)) &&
            (identical(other.interval, interval) ||
                const DeepCollectionEquality()
                    .equals(other.interval, interval)) &&
            (identical(other.occurrences, occurrences) ||
                const DeepCollectionEquality()
                    .equals(other.occurrences, occurrences)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(originEventId) ^
      const DeepCollectionEquality().hash(delay) ^
      const DeepCollectionEquality().hash(interval) ^
      const DeepCollectionEquality().hash(occurrences) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $StudyBurstInfoExtension on StudyBurstInfo {
  StudyBurstInfo copyWith(
      {String? identifier,
      String? originEventId,
      String? delay,
      String? interval,
      int? occurrences,
      String? type}) {
    return StudyBurstInfo(
        identifier: identifier ?? this.identifier,
        originEventId: originEventId ?? this.originEventId,
        delay: delay ?? this.delay,
        interval: interval ?? this.interval,
        occurrences: occurrences ?? this.occurrences,
        type: type ?? this.type);
  }

  StudyBurstInfo copyWithWrapped(
      {Wrapped<String?>? identifier,
      Wrapped<String?>? originEventId,
      Wrapped<String?>? delay,
      Wrapped<String?>? interval,
      Wrapped<int?>? occurrences,
      Wrapped<String?>? type}) {
    return StudyBurstInfo(
        identifier: (identifier != null ? identifier.value : this.identifier),
        originEventId:
            (originEventId != null ? originEventId.value : this.originEventId),
        delay: (delay != null ? delay.value : this.delay),
        interval: (interval != null ? interval.value : this.interval),
        occurrences:
            (occurrences != null ? occurrences.value : this.occurrences),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class StudyConsent {
  StudyConsent({
    required this.subpopulationGuid,
    this.createdOn,
    required this.documentContent,
    this.type,
  });

  factory StudyConsent.fromJson(Map<String, dynamic> json) =>
      _$StudyConsentFromJson(json);

  @JsonKey(name: 'subpopulationGuid', includeIfNull: false, defaultValue: '')
  final String subpopulationGuid;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'documentContent', includeIfNull: false, defaultValue: '')
  final String documentContent;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$StudyConsentFromJson;
  static const toJsonFactory = _$StudyConsentToJson;
  Map<String, dynamic> toJson() => _$StudyConsentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StudyConsent &&
            (identical(other.subpopulationGuid, subpopulationGuid) ||
                const DeepCollectionEquality()
                    .equals(other.subpopulationGuid, subpopulationGuid)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.documentContent, documentContent) ||
                const DeepCollectionEquality()
                    .equals(other.documentContent, documentContent)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(subpopulationGuid) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(documentContent) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $StudyConsentExtension on StudyConsent {
  StudyConsent copyWith(
      {String? subpopulationGuid,
      DateTime? createdOn,
      String? documentContent,
      String? type}) {
    return StudyConsent(
        subpopulationGuid: subpopulationGuid ?? this.subpopulationGuid,
        createdOn: createdOn ?? this.createdOn,
        documentContent: documentContent ?? this.documentContent,
        type: type ?? this.type);
  }

  StudyConsent copyWithWrapped(
      {Wrapped<String>? subpopulationGuid,
      Wrapped<DateTime?>? createdOn,
      Wrapped<String>? documentContent,
      Wrapped<String?>? type}) {
    return StudyConsent(
        subpopulationGuid: (subpopulationGuid != null
            ? subpopulationGuid.value
            : this.subpopulationGuid),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        documentContent: (documentContent != null
            ? documentContent.value
            : this.documentContent),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class StudyParticipant {
  StudyParticipant({
    this.healthCode,
    this.email,
    this.phone,
    this.consentHistories,
    this.enrollments,
    this.consented,
    this.timeZone,
    this.type,
    this.firstName,
    this.lastName,
    this.synapseUserId,
    this.id,
    this.notifyByEmail,
    this.attributes,
    this.sharingScope,
    this.createdOn,
    this.emailVerified,
    this.phoneVerified,
    this.status,
    this.roles,
    this.dataGroups,
    this.clientData,
    this.languages,
    this.studyIds,
    this.externalIds,
    this.orgMembership,
    this.note,
    this.clientTimeZone,
  });

  factory StudyParticipant.fromJson(Map<String, dynamic> json) =>
      _$StudyParticipantFromJson(json);

  @JsonKey(name: 'healthCode', includeIfNull: false, defaultValue: '')
  final String? healthCode;
  @JsonKey(name: 'email', includeIfNull: false, defaultValue: '')
  final String? email;
  @JsonKey(name: 'phone', includeIfNull: false)
  final Phone? phone;
  @JsonKey(name: 'consentHistories', includeIfNull: false)
  final Map<String, dynamic>? consentHistories;
  @JsonKey(name: 'enrollments', includeIfNull: false)
  final Map<String, dynamic>? enrollments;
  @JsonKey(name: 'consented', includeIfNull: false)
  final bool? consented;
  @JsonKey(name: 'timeZone', includeIfNull: false, defaultValue: '')
  final String? timeZone;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  @JsonKey(name: 'firstName', includeIfNull: false, defaultValue: '')
  final String? firstName;
  @JsonKey(name: 'lastName', includeIfNull: false, defaultValue: '')
  final String? lastName;
  @JsonKey(name: 'synapseUserId', includeIfNull: false, defaultValue: '')
  final String? synapseUserId;
  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'notifyByEmail', includeIfNull: false, defaultValue: true)
  final bool? notifyByEmail;
  @JsonKey(name: 'attributes', includeIfNull: false)
  final Map<String, dynamic>? attributes;
  @JsonKey(
    name: 'sharingScope',
    includeIfNull: false,
    toJson: sharingScopeToJson,
    fromJson: sharingScopeFromJson,
  )
  final enums.SharingScope? sharingScope;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'emailVerified', includeIfNull: false)
  final bool? emailVerified;
  @JsonKey(name: 'phoneVerified', includeIfNull: false)
  final bool? phoneVerified;
  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: accountStatusToJson,
    fromJson: accountStatusFromJson,
  )
  final enums.AccountStatus? status;
  @JsonKey(
    name: 'roles',
    includeIfNull: false,
    toJson: roleListToJson,
    fromJson: roleListFromJson,
  )
  final List<enums.Role>? roles;
  @JsonKey(name: 'dataGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String>? dataGroups;
  @JsonKey(name: 'clientData', includeIfNull: false)
  final Map<String, dynamic>? clientData;
  @JsonKey(name: 'languages', includeIfNull: false, defaultValue: <String>[])
  final List<String>? languages;
  @JsonKey(name: 'studyIds', includeIfNull: false, defaultValue: <String>[])
  final List<String>? studyIds;
  @JsonKey(name: 'externalIds', includeIfNull: false)
  final Map<String, dynamic>? externalIds;
  @JsonKey(name: 'orgMembership', includeIfNull: false, defaultValue: '')
  final String? orgMembership;
  @JsonKey(name: 'note', includeIfNull: false, defaultValue: '')
  final String? note;
  @JsonKey(name: 'clientTimeZone', includeIfNull: false, defaultValue: '')
  final String? clientTimeZone;
  static const fromJsonFactory = _$StudyParticipantFromJson;
  static const toJsonFactory = _$StudyParticipantToJson;
  Map<String, dynamic> toJson() => _$StudyParticipantToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StudyParticipant &&
            (identical(other.healthCode, healthCode) ||
                const DeepCollectionEquality()
                    .equals(other.healthCode, healthCode)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.consentHistories, consentHistories) ||
                const DeepCollectionEquality()
                    .equals(other.consentHistories, consentHistories)) &&
            (identical(other.enrollments, enrollments) ||
                const DeepCollectionEquality()
                    .equals(other.enrollments, enrollments)) &&
            (identical(other.consented, consented) ||
                const DeepCollectionEquality()
                    .equals(other.consented, consented)) &&
            (identical(other.timeZone, timeZone) ||
                const DeepCollectionEquality()
                    .equals(other.timeZone, timeZone)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.lastName, lastName) ||
                const DeepCollectionEquality()
                    .equals(other.lastName, lastName)) &&
            (identical(other.synapseUserId, synapseUserId) ||
                const DeepCollectionEquality()
                    .equals(other.synapseUserId, synapseUserId)) &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.notifyByEmail, notifyByEmail) ||
                const DeepCollectionEquality()
                    .equals(other.notifyByEmail, notifyByEmail)) &&
            (identical(other.attributes, attributes) ||
                const DeepCollectionEquality()
                    .equals(other.attributes, attributes)) &&
            (identical(other.sharingScope, sharingScope) ||
                const DeepCollectionEquality()
                    .equals(other.sharingScope, sharingScope)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.emailVerified, emailVerified) ||
                const DeepCollectionEquality()
                    .equals(other.emailVerified, emailVerified)) &&
            (identical(other.phoneVerified, phoneVerified) ||
                const DeepCollectionEquality()
                    .equals(other.phoneVerified, phoneVerified)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.roles, roles) ||
                const DeepCollectionEquality().equals(other.roles, roles)) &&
            (identical(other.dataGroups, dataGroups) ||
                const DeepCollectionEquality()
                    .equals(other.dataGroups, dataGroups)) &&
            (identical(other.clientData, clientData) ||
                const DeepCollectionEquality()
                    .equals(other.clientData, clientData)) &&
            (identical(other.languages, languages) ||
                const DeepCollectionEquality()
                    .equals(other.languages, languages)) &&
            (identical(other.studyIds, studyIds) ||
                const DeepCollectionEquality()
                    .equals(other.studyIds, studyIds)) &&
            (identical(other.externalIds, externalIds) ||
                const DeepCollectionEquality().equals(other.externalIds, externalIds)) &&
            (identical(other.orgMembership, orgMembership) || const DeepCollectionEquality().equals(other.orgMembership, orgMembership)) &&
            (identical(other.note, note) || const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.clientTimeZone, clientTimeZone) || const DeepCollectionEquality().equals(other.clientTimeZone, clientTimeZone)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(healthCode) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(phone) ^
      const DeepCollectionEquality().hash(consentHistories) ^
      const DeepCollectionEquality().hash(enrollments) ^
      const DeepCollectionEquality().hash(consented) ^
      const DeepCollectionEquality().hash(timeZone) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(firstName) ^
      const DeepCollectionEquality().hash(lastName) ^
      const DeepCollectionEquality().hash(synapseUserId) ^
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(notifyByEmail) ^
      const DeepCollectionEquality().hash(attributes) ^
      const DeepCollectionEquality().hash(sharingScope) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(emailVerified) ^
      const DeepCollectionEquality().hash(phoneVerified) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(roles) ^
      const DeepCollectionEquality().hash(dataGroups) ^
      const DeepCollectionEquality().hash(clientData) ^
      const DeepCollectionEquality().hash(languages) ^
      const DeepCollectionEquality().hash(studyIds) ^
      const DeepCollectionEquality().hash(externalIds) ^
      const DeepCollectionEquality().hash(orgMembership) ^
      const DeepCollectionEquality().hash(note) ^
      const DeepCollectionEquality().hash(clientTimeZone) ^
      runtimeType.hashCode;
}

extension $StudyParticipantExtension on StudyParticipant {
  StudyParticipant copyWith(
      {String? healthCode,
      String? email,
      Phone? phone,
      Map<String, dynamic>? consentHistories,
      Map<String, dynamic>? enrollments,
      bool? consented,
      String? timeZone,
      String? type,
      String? firstName,
      String? lastName,
      String? synapseUserId,
      String? id,
      bool? notifyByEmail,
      Map<String, dynamic>? attributes,
      enums.SharingScope? sharingScope,
      DateTime? createdOn,
      bool? emailVerified,
      bool? phoneVerified,
      enums.AccountStatus? status,
      List<enums.Role>? roles,
      List<String>? dataGroups,
      Map<String, dynamic>? clientData,
      List<String>? languages,
      List<String>? studyIds,
      Map<String, dynamic>? externalIds,
      String? orgMembership,
      String? note,
      String? clientTimeZone}) {
    return StudyParticipant(
        healthCode: healthCode ?? this.healthCode,
        email: email ?? this.email,
        phone: phone ?? this.phone,
        consentHistories: consentHistories ?? this.consentHistories,
        enrollments: enrollments ?? this.enrollments,
        consented: consented ?? this.consented,
        timeZone: timeZone ?? this.timeZone,
        type: type ?? this.type,
        firstName: firstName ?? this.firstName,
        lastName: lastName ?? this.lastName,
        synapseUserId: synapseUserId ?? this.synapseUserId,
        id: id ?? this.id,
        notifyByEmail: notifyByEmail ?? this.notifyByEmail,
        attributes: attributes ?? this.attributes,
        sharingScope: sharingScope ?? this.sharingScope,
        createdOn: createdOn ?? this.createdOn,
        emailVerified: emailVerified ?? this.emailVerified,
        phoneVerified: phoneVerified ?? this.phoneVerified,
        status: status ?? this.status,
        roles: roles ?? this.roles,
        dataGroups: dataGroups ?? this.dataGroups,
        clientData: clientData ?? this.clientData,
        languages: languages ?? this.languages,
        studyIds: studyIds ?? this.studyIds,
        externalIds: externalIds ?? this.externalIds,
        orgMembership: orgMembership ?? this.orgMembership,
        note: note ?? this.note,
        clientTimeZone: clientTimeZone ?? this.clientTimeZone);
  }

  StudyParticipant copyWithWrapped(
      {Wrapped<String?>? healthCode,
      Wrapped<String?>? email,
      Wrapped<Phone?>? phone,
      Wrapped<Map<String, dynamic>?>? consentHistories,
      Wrapped<Map<String, dynamic>?>? enrollments,
      Wrapped<bool?>? consented,
      Wrapped<String?>? timeZone,
      Wrapped<String?>? type,
      Wrapped<String?>? firstName,
      Wrapped<String?>? lastName,
      Wrapped<String?>? synapseUserId,
      Wrapped<String?>? id,
      Wrapped<bool?>? notifyByEmail,
      Wrapped<Map<String, dynamic>?>? attributes,
      Wrapped<enums.SharingScope?>? sharingScope,
      Wrapped<DateTime?>? createdOn,
      Wrapped<bool?>? emailVerified,
      Wrapped<bool?>? phoneVerified,
      Wrapped<enums.AccountStatus?>? status,
      Wrapped<List<enums.Role>?>? roles,
      Wrapped<List<String>?>? dataGroups,
      Wrapped<Map<String, dynamic>?>? clientData,
      Wrapped<List<String>?>? languages,
      Wrapped<List<String>?>? studyIds,
      Wrapped<Map<String, dynamic>?>? externalIds,
      Wrapped<String?>? orgMembership,
      Wrapped<String?>? note,
      Wrapped<String?>? clientTimeZone}) {
    return StudyParticipant(
        healthCode: (healthCode != null ? healthCode.value : this.healthCode),
        email: (email != null ? email.value : this.email),
        phone: (phone != null ? phone.value : this.phone),
        consentHistories: (consentHistories != null
            ? consentHistories.value
            : this.consentHistories),
        enrollments:
            (enrollments != null ? enrollments.value : this.enrollments),
        consented: (consented != null ? consented.value : this.consented),
        timeZone: (timeZone != null ? timeZone.value : this.timeZone),
        type: (type != null ? type.value : this.type),
        firstName: (firstName != null ? firstName.value : this.firstName),
        lastName: (lastName != null ? lastName.value : this.lastName),
        synapseUserId:
            (synapseUserId != null ? synapseUserId.value : this.synapseUserId),
        id: (id != null ? id.value : this.id),
        notifyByEmail:
            (notifyByEmail != null ? notifyByEmail.value : this.notifyByEmail),
        attributes: (attributes != null ? attributes.value : this.attributes),
        sharingScope:
            (sharingScope != null ? sharingScope.value : this.sharingScope),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        emailVerified:
            (emailVerified != null ? emailVerified.value : this.emailVerified),
        phoneVerified:
            (phoneVerified != null ? phoneVerified.value : this.phoneVerified),
        status: (status != null ? status.value : this.status),
        roles: (roles != null ? roles.value : this.roles),
        dataGroups: (dataGroups != null ? dataGroups.value : this.dataGroups),
        clientData: (clientData != null ? clientData.value : this.clientData),
        languages: (languages != null ? languages.value : this.languages),
        studyIds: (studyIds != null ? studyIds.value : this.studyIds),
        externalIds:
            (externalIds != null ? externalIds.value : this.externalIds),
        orgMembership:
            (orgMembership != null ? orgMembership.value : this.orgMembership),
        note: (note != null ? note.value : this.note),
        clientTimeZone: (clientTimeZone != null
            ? clientTimeZone.value
            : this.clientTimeZone));
  }
}

@JsonSerializable(explicitToJson: true)
class Subpopulation {
  Subpopulation({
    required this.guid,
    required this.name,
    this.description,
    required this.criteria,
    this.autoSendConsentSuppressed,
    required this.required,
    required this.defaultGroup,
    this.publishedConsentCreatedOn,
    this.dataGroupsAssignedWhileConsented,
    this.studyIdsAssignedOnConsent,
    required this.version,
    this.consentHTML,
    this.consentPDF,
    this.type,
  });

  factory Subpopulation.fromJson(Map<String, dynamic> json) =>
      _$SubpopulationFromJson(json);

  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String guid;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final Criteria criteria;
  @JsonKey(
      name: 'autoSendConsentSuppressed',
      includeIfNull: false,
      defaultValue: false)
  final bool? autoSendConsentSuppressed;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool required;
  @JsonKey(name: 'defaultGroup', includeIfNull: false)
  final bool defaultGroup;
  @JsonKey(name: 'publishedConsentCreatedOn', includeIfNull: false)
  final DateTime? publishedConsentCreatedOn;
  @JsonKey(
      name: 'dataGroupsAssignedWhileConsented',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? dataGroupsAssignedWhileConsented;
  @JsonKey(
      name: 'studyIdsAssignedOnConsent',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? studyIdsAssignedOnConsent;
  @JsonKey(name: 'version', includeIfNull: false)
  final num version;
  @JsonKey(name: 'consentHTML', includeIfNull: false, defaultValue: '')
  final String? consentHTML;
  @JsonKey(name: 'consentPDF', includeIfNull: false, defaultValue: '')
  final String? consentPDF;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SubpopulationFromJson;
  static const toJsonFactory = _$SubpopulationToJson;
  Map<String, dynamic> toJson() => _$SubpopulationToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Subpopulation &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.autoSendConsentSuppressed, autoSendConsentSuppressed) ||
                const DeepCollectionEquality().equals(
                    other.autoSendConsentSuppressed,
                    autoSendConsentSuppressed)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.defaultGroup, defaultGroup) ||
                const DeepCollectionEquality()
                    .equals(other.defaultGroup, defaultGroup)) &&
            (identical(other.publishedConsentCreatedOn, publishedConsentCreatedOn) ||
                const DeepCollectionEquality().equals(
                    other.publishedConsentCreatedOn,
                    publishedConsentCreatedOn)) &&
            (identical(other.dataGroupsAssignedWhileConsented, dataGroupsAssignedWhileConsented) ||
                const DeepCollectionEquality().equals(
                    other.dataGroupsAssignedWhileConsented,
                    dataGroupsAssignedWhileConsented)) &&
            (identical(other.studyIdsAssignedOnConsent, studyIdsAssignedOnConsent) ||
                const DeepCollectionEquality().equals(
                    other.studyIdsAssignedOnConsent,
                    studyIdsAssignedOnConsent)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.consentHTML, consentHTML) ||
                const DeepCollectionEquality()
                    .equals(other.consentHTML, consentHTML)) &&
            (identical(other.consentPDF, consentPDF) ||
                const DeepCollectionEquality()
                    .equals(other.consentPDF, consentPDF)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(autoSendConsentSuppressed) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(defaultGroup) ^
      const DeepCollectionEquality().hash(publishedConsentCreatedOn) ^
      const DeepCollectionEquality().hash(dataGroupsAssignedWhileConsented) ^
      const DeepCollectionEquality().hash(studyIdsAssignedOnConsent) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(consentHTML) ^
      const DeepCollectionEquality().hash(consentPDF) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SubpopulationExtension on Subpopulation {
  Subpopulation copyWith(
      {String? guid,
      String? name,
      String? description,
      Criteria? criteria,
      bool? autoSendConsentSuppressed,
      bool? required,
      bool? defaultGroup,
      DateTime? publishedConsentCreatedOn,
      List<String>? dataGroupsAssignedWhileConsented,
      List<String>? studyIdsAssignedOnConsent,
      num? version,
      String? consentHTML,
      String? consentPDF,
      String? type}) {
    return Subpopulation(
        guid: guid ?? this.guid,
        name: name ?? this.name,
        description: description ?? this.description,
        criteria: criteria ?? this.criteria,
        autoSendConsentSuppressed:
            autoSendConsentSuppressed ?? this.autoSendConsentSuppressed,
        required: required ?? this.required,
        defaultGroup: defaultGroup ?? this.defaultGroup,
        publishedConsentCreatedOn:
            publishedConsentCreatedOn ?? this.publishedConsentCreatedOn,
        dataGroupsAssignedWhileConsented: dataGroupsAssignedWhileConsented ??
            this.dataGroupsAssignedWhileConsented,
        studyIdsAssignedOnConsent:
            studyIdsAssignedOnConsent ?? this.studyIdsAssignedOnConsent,
        version: version ?? this.version,
        consentHTML: consentHTML ?? this.consentHTML,
        consentPDF: consentPDF ?? this.consentPDF,
        type: type ?? this.type);
  }

  Subpopulation copyWithWrapped(
      {Wrapped<String>? guid,
      Wrapped<String>? name,
      Wrapped<String?>? description,
      Wrapped<Criteria>? criteria,
      Wrapped<bool?>? autoSendConsentSuppressed,
      Wrapped<bool>? required,
      Wrapped<bool>? defaultGroup,
      Wrapped<DateTime?>? publishedConsentCreatedOn,
      Wrapped<List<String>?>? dataGroupsAssignedWhileConsented,
      Wrapped<List<String>?>? studyIdsAssignedOnConsent,
      Wrapped<num>? version,
      Wrapped<String?>? consentHTML,
      Wrapped<String?>? consentPDF,
      Wrapped<String?>? type}) {
    return Subpopulation(
        guid: (guid != null ? guid.value : this.guid),
        name: (name != null ? name.value : this.name),
        description:
            (description != null ? description.value : this.description),
        criteria: (criteria != null ? criteria.value : this.criteria),
        autoSendConsentSuppressed: (autoSendConsentSuppressed != null
            ? autoSendConsentSuppressed.value
            : this.autoSendConsentSuppressed),
        required: (required != null ? required.value : this.required),
        defaultGroup:
            (defaultGroup != null ? defaultGroup.value : this.defaultGroup),
        publishedConsentCreatedOn: (publishedConsentCreatedOn != null
            ? publishedConsentCreatedOn.value
            : this.publishedConsentCreatedOn),
        dataGroupsAssignedWhileConsented:
            (dataGroupsAssignedWhileConsented != null
                ? dataGroupsAssignedWhileConsented.value
                : this.dataGroupsAssignedWhileConsented),
        studyIdsAssignedOnConsent: (studyIdsAssignedOnConsent != null
            ? studyIdsAssignedOnConsent.value
            : this.studyIdsAssignedOnConsent),
        version: (version != null ? version.value : this.version),
        consentHTML:
            (consentHTML != null ? consentHTML.value : this.consentHTML),
        consentPDF: (consentPDF != null ? consentPDF.value : this.consentPDF),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SubscriptionRequest {
  SubscriptionRequest({
    required this.topicGuids,
    this.type,
  });

  factory SubscriptionRequest.fromJson(Map<String, dynamic> json) =>
      _$SubscriptionRequestFromJson(json);

  @JsonKey(name: 'topicGuids', includeIfNull: false, defaultValue: <String>[])
  final List<String> topicGuids;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SubscriptionRequestFromJson;
  static const toJsonFactory = _$SubscriptionRequestToJson;
  Map<String, dynamic> toJson() => _$SubscriptionRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SubscriptionRequest &&
            (identical(other.topicGuids, topicGuids) ||
                const DeepCollectionEquality()
                    .equals(other.topicGuids, topicGuids)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(topicGuids) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SubscriptionRequestExtension on SubscriptionRequest {
  SubscriptionRequest copyWith({List<String>? topicGuids, String? type}) {
    return SubscriptionRequest(
        topicGuids: topicGuids ?? this.topicGuids, type: type ?? this.type);
  }

  SubscriptionRequest copyWithWrapped(
      {Wrapped<List<String>>? topicGuids, Wrapped<String?>? type}) {
    return SubscriptionRequest(
        topicGuids: (topicGuids != null ? topicGuids.value : this.topicGuids),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SubscriptionStatus {
  SubscriptionStatus({
    this.topicGuid,
    this.topicName,
    this.subscribed,
    this.type,
  });

  factory SubscriptionStatus.fromJson(Map<String, dynamic> json) =>
      _$SubscriptionStatusFromJson(json);

  @JsonKey(name: 'topicGuid', includeIfNull: false, defaultValue: '')
  final String? topicGuid;
  @JsonKey(name: 'topicName', includeIfNull: false, defaultValue: '')
  final String? topicName;
  @JsonKey(name: 'subscribed', includeIfNull: false)
  final bool? subscribed;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SubscriptionStatusFromJson;
  static const toJsonFactory = _$SubscriptionStatusToJson;
  Map<String, dynamic> toJson() => _$SubscriptionStatusToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SubscriptionStatus &&
            (identical(other.topicGuid, topicGuid) ||
                const DeepCollectionEquality()
                    .equals(other.topicGuid, topicGuid)) &&
            (identical(other.topicName, topicName) ||
                const DeepCollectionEquality()
                    .equals(other.topicName, topicName)) &&
            (identical(other.subscribed, subscribed) ||
                const DeepCollectionEquality()
                    .equals(other.subscribed, subscribed)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(topicGuid) ^
      const DeepCollectionEquality().hash(topicName) ^
      const DeepCollectionEquality().hash(subscribed) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SubscriptionStatusExtension on SubscriptionStatus {
  SubscriptionStatus copyWith(
      {String? topicGuid, String? topicName, bool? subscribed, String? type}) {
    return SubscriptionStatus(
        topicGuid: topicGuid ?? this.topicGuid,
        topicName: topicName ?? this.topicName,
        subscribed: subscribed ?? this.subscribed,
        type: type ?? this.type);
  }

  SubscriptionStatus copyWithWrapped(
      {Wrapped<String?>? topicGuid,
      Wrapped<String?>? topicName,
      Wrapped<bool?>? subscribed,
      Wrapped<String?>? type}) {
    return SubscriptionStatus(
        topicGuid: (topicGuid != null ? topicGuid.value : this.topicGuid),
        topicName: (topicName != null ? topicName.value : this.topicName),
        subscribed: (subscribed != null ? subscribed.value : this.subscribed),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Study {
  Study({
    required this.identifier,
    required this.name,
    this.details,
    required this.phase,
    this.clientData,
    this.studyTimeZone,
    this.adherenceThresholdPercentage,
    this.irbName,
    this.irbDecisionOn,
    this.irbExpiresOn,
    this.irbDecisionType,
    this.irbProtocolName,
    this.irbProtocolId,
    this.studyLogoUrl,
    this.colorScheme,
    this.institutionId,
    this.scheduleGuid,
    this.keywords,
    this.diseases,
    this.studyDesignTypes,
    this.signInTypes,
    this.contacts,
    this.customEvents,
    this.deleted,
    this.createdOn,
    this.modifiedOn,
    required this.version,
    this.type,
  });

  factory Study.fromJson(Map<String, dynamic> json) => _$StudyFromJson(json);

  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String identifier;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'details', includeIfNull: false, defaultValue: '')
  final String? details;
  @JsonKey(
    name: 'phase',
    includeIfNull: false,
    toJson: studyPhaseToJson,
    fromJson: studyPhaseFromJson,
  )
  final enums.StudyPhase phase;
  @JsonKey(name: 'clientData', includeIfNull: false)
  final Map<String, dynamic>? clientData;
  @JsonKey(name: 'studyTimeZone', includeIfNull: false, defaultValue: '')
  final String? studyTimeZone;
  @JsonKey(name: 'adherenceThresholdPercentage', includeIfNull: false)
  final int? adherenceThresholdPercentage;
  @JsonKey(name: 'irbName', includeIfNull: false, defaultValue: '')
  final String? irbName;
  @JsonKey(name: 'irbDecisionOn', includeIfNull: false, toJson: _dateToJson)
  final DateTime? irbDecisionOn;
  @JsonKey(name: 'irbExpiresOn', includeIfNull: false, toJson: _dateToJson)
  final DateTime? irbExpiresOn;
  @JsonKey(
    name: 'irbDecisionType',
    includeIfNull: false,
    toJson: irbDecisionTypeToJson,
    fromJson: irbDecisionTypeFromJson,
  )
  final enums.IrbDecisionType? irbDecisionType;
  @JsonKey(name: 'irbProtocolName', includeIfNull: false, defaultValue: '')
  final String? irbProtocolName;
  @JsonKey(name: 'irbProtocolId', includeIfNull: false, defaultValue: '')
  final String? irbProtocolId;
  @JsonKey(name: 'studyLogoUrl', includeIfNull: false, defaultValue: '')
  final String? studyLogoUrl;
  @JsonKey(name: 'colorScheme', includeIfNull: false)
  final ColorScheme? colorScheme;
  @JsonKey(name: 'institutionId', includeIfNull: false, defaultValue: '')
  final String? institutionId;
  @JsonKey(name: 'scheduleGuid', includeIfNull: false, defaultValue: '')
  final String? scheduleGuid;
  @JsonKey(name: 'keywords', includeIfNull: false, defaultValue: '')
  final String? keywords;
  @JsonKey(name: 'diseases', includeIfNull: false, defaultValue: <String>[])
  final List<String>? diseases;
  @JsonKey(
      name: 'studyDesignTypes', includeIfNull: false, defaultValue: <String>[])
  final List<String>? studyDesignTypes;
  @JsonKey(
    name: 'signInTypes',
    includeIfNull: false,
    toJson: signInTypeListToJson,
    fromJson: signInTypeListFromJson,
  )
  final List<enums.SignInType>? signInTypes;
  @JsonKey(name: 'contacts', includeIfNull: false, defaultValue: <Contact>[])
  final List<Contact>? contacts;
  @JsonKey(
      name: 'customEvents', includeIfNull: false, defaultValue: <CustomEvent>[])
  final List<CustomEvent>? customEvents;
  @JsonKey(name: 'deleted', includeIfNull: false)
  final bool? deleted;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'modifiedOn', includeIfNull: false)
  final DateTime? modifiedOn;
  @JsonKey(name: 'version', includeIfNull: false)
  final num version;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$StudyFromJson;
  static const toJsonFactory = _$StudyToJson;
  Map<String, dynamic> toJson() => _$StudyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Study &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.details, details) ||
                const DeepCollectionEquality()
                    .equals(other.details, details)) &&
            (identical(other.phase, phase) ||
                const DeepCollectionEquality().equals(other.phase, phase)) &&
            (identical(other.clientData, clientData) ||
                const DeepCollectionEquality()
                    .equals(other.clientData, clientData)) &&
            (identical(other.studyTimeZone, studyTimeZone) ||
                const DeepCollectionEquality()
                    .equals(other.studyTimeZone, studyTimeZone)) &&
            (identical(other.adherenceThresholdPercentage, adherenceThresholdPercentage) ||
                const DeepCollectionEquality().equals(
                    other.adherenceThresholdPercentage,
                    adherenceThresholdPercentage)) &&
            (identical(other.irbName, irbName) ||
                const DeepCollectionEquality()
                    .equals(other.irbName, irbName)) &&
            (identical(other.irbDecisionOn, irbDecisionOn) ||
                const DeepCollectionEquality()
                    .equals(other.irbDecisionOn, irbDecisionOn)) &&
            (identical(other.irbExpiresOn, irbExpiresOn) ||
                const DeepCollectionEquality()
                    .equals(other.irbExpiresOn, irbExpiresOn)) &&
            (identical(other.irbDecisionType, irbDecisionType) ||
                const DeepCollectionEquality()
                    .equals(other.irbDecisionType, irbDecisionType)) &&
            (identical(other.irbProtocolName, irbProtocolName) ||
                const DeepCollectionEquality()
                    .equals(other.irbProtocolName, irbProtocolName)) &&
            (identical(other.irbProtocolId, irbProtocolId) ||
                const DeepCollectionEquality()
                    .equals(other.irbProtocolId, irbProtocolId)) &&
            (identical(other.studyLogoUrl, studyLogoUrl) ||
                const DeepCollectionEquality()
                    .equals(other.studyLogoUrl, studyLogoUrl)) &&
            (identical(other.colorScheme, colorScheme) ||
                const DeepCollectionEquality()
                    .equals(other.colorScheme, colorScheme)) &&
            (identical(other.institutionId, institutionId) ||
                const DeepCollectionEquality()
                    .equals(other.institutionId, institutionId)) &&
            (identical(other.scheduleGuid, scheduleGuid) ||
                const DeepCollectionEquality()
                    .equals(other.scheduleGuid, scheduleGuid)) &&
            (identical(other.keywords, keywords) ||
                const DeepCollectionEquality()
                    .equals(other.keywords, keywords)) &&
            (identical(other.diseases, diseases) ||
                const DeepCollectionEquality().equals(other.diseases, diseases)) &&
            (identical(other.studyDesignTypes, studyDesignTypes) || const DeepCollectionEquality().equals(other.studyDesignTypes, studyDesignTypes)) &&
            (identical(other.signInTypes, signInTypes) || const DeepCollectionEquality().equals(other.signInTypes, signInTypes)) &&
            (identical(other.contacts, contacts) || const DeepCollectionEquality().equals(other.contacts, contacts)) &&
            (identical(other.customEvents, customEvents) || const DeepCollectionEquality().equals(other.customEvents, customEvents)) &&
            (identical(other.deleted, deleted) || const DeepCollectionEquality().equals(other.deleted, deleted)) &&
            (identical(other.createdOn, createdOn) || const DeepCollectionEquality().equals(other.createdOn, createdOn)) &&
            (identical(other.modifiedOn, modifiedOn) || const DeepCollectionEquality().equals(other.modifiedOn, modifiedOn)) &&
            (identical(other.version, version) || const DeepCollectionEquality().equals(other.version, version)) &&
            (identical(other.type, type) || const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(details) ^
      const DeepCollectionEquality().hash(phase) ^
      const DeepCollectionEquality().hash(clientData) ^
      const DeepCollectionEquality().hash(studyTimeZone) ^
      const DeepCollectionEquality().hash(adherenceThresholdPercentage) ^
      const DeepCollectionEquality().hash(irbName) ^
      const DeepCollectionEquality().hash(irbDecisionOn) ^
      const DeepCollectionEquality().hash(irbExpiresOn) ^
      const DeepCollectionEquality().hash(irbDecisionType) ^
      const DeepCollectionEquality().hash(irbProtocolName) ^
      const DeepCollectionEquality().hash(irbProtocolId) ^
      const DeepCollectionEquality().hash(studyLogoUrl) ^
      const DeepCollectionEquality().hash(colorScheme) ^
      const DeepCollectionEquality().hash(institutionId) ^
      const DeepCollectionEquality().hash(scheduleGuid) ^
      const DeepCollectionEquality().hash(keywords) ^
      const DeepCollectionEquality().hash(diseases) ^
      const DeepCollectionEquality().hash(studyDesignTypes) ^
      const DeepCollectionEquality().hash(signInTypes) ^
      const DeepCollectionEquality().hash(contacts) ^
      const DeepCollectionEquality().hash(customEvents) ^
      const DeepCollectionEquality().hash(deleted) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(modifiedOn) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $StudyExtension on Study {
  Study copyWith(
      {String? identifier,
      String? name,
      String? details,
      enums.StudyPhase? phase,
      Map<String, dynamic>? clientData,
      String? studyTimeZone,
      int? adherenceThresholdPercentage,
      String? irbName,
      DateTime? irbDecisionOn,
      DateTime? irbExpiresOn,
      enums.IrbDecisionType? irbDecisionType,
      String? irbProtocolName,
      String? irbProtocolId,
      String? studyLogoUrl,
      ColorScheme? colorScheme,
      String? institutionId,
      String? scheduleGuid,
      String? keywords,
      List<String>? diseases,
      List<String>? studyDesignTypes,
      List<enums.SignInType>? signInTypes,
      List<Contact>? contacts,
      List<CustomEvent>? customEvents,
      bool? deleted,
      DateTime? createdOn,
      DateTime? modifiedOn,
      num? version,
      String? type}) {
    return Study(
        identifier: identifier ?? this.identifier,
        name: name ?? this.name,
        details: details ?? this.details,
        phase: phase ?? this.phase,
        clientData: clientData ?? this.clientData,
        studyTimeZone: studyTimeZone ?? this.studyTimeZone,
        adherenceThresholdPercentage:
            adherenceThresholdPercentage ?? this.adherenceThresholdPercentage,
        irbName: irbName ?? this.irbName,
        irbDecisionOn: irbDecisionOn ?? this.irbDecisionOn,
        irbExpiresOn: irbExpiresOn ?? this.irbExpiresOn,
        irbDecisionType: irbDecisionType ?? this.irbDecisionType,
        irbProtocolName: irbProtocolName ?? this.irbProtocolName,
        irbProtocolId: irbProtocolId ?? this.irbProtocolId,
        studyLogoUrl: studyLogoUrl ?? this.studyLogoUrl,
        colorScheme: colorScheme ?? this.colorScheme,
        institutionId: institutionId ?? this.institutionId,
        scheduleGuid: scheduleGuid ?? this.scheduleGuid,
        keywords: keywords ?? this.keywords,
        diseases: diseases ?? this.diseases,
        studyDesignTypes: studyDesignTypes ?? this.studyDesignTypes,
        signInTypes: signInTypes ?? this.signInTypes,
        contacts: contacts ?? this.contacts,
        customEvents: customEvents ?? this.customEvents,
        deleted: deleted ?? this.deleted,
        createdOn: createdOn ?? this.createdOn,
        modifiedOn: modifiedOn ?? this.modifiedOn,
        version: version ?? this.version,
        type: type ?? this.type);
  }

  Study copyWithWrapped(
      {Wrapped<String>? identifier,
      Wrapped<String>? name,
      Wrapped<String?>? details,
      Wrapped<enums.StudyPhase>? phase,
      Wrapped<Map<String, dynamic>?>? clientData,
      Wrapped<String?>? studyTimeZone,
      Wrapped<int?>? adherenceThresholdPercentage,
      Wrapped<String?>? irbName,
      Wrapped<DateTime?>? irbDecisionOn,
      Wrapped<DateTime?>? irbExpiresOn,
      Wrapped<enums.IrbDecisionType?>? irbDecisionType,
      Wrapped<String?>? irbProtocolName,
      Wrapped<String?>? irbProtocolId,
      Wrapped<String?>? studyLogoUrl,
      Wrapped<ColorScheme?>? colorScheme,
      Wrapped<String?>? institutionId,
      Wrapped<String?>? scheduleGuid,
      Wrapped<String?>? keywords,
      Wrapped<List<String>?>? diseases,
      Wrapped<List<String>?>? studyDesignTypes,
      Wrapped<List<enums.SignInType>?>? signInTypes,
      Wrapped<List<Contact>?>? contacts,
      Wrapped<List<CustomEvent>?>? customEvents,
      Wrapped<bool?>? deleted,
      Wrapped<DateTime?>? createdOn,
      Wrapped<DateTime?>? modifiedOn,
      Wrapped<num>? version,
      Wrapped<String?>? type}) {
    return Study(
        identifier: (identifier != null ? identifier.value : this.identifier),
        name: (name != null ? name.value : this.name),
        details: (details != null ? details.value : this.details),
        phase: (phase != null ? phase.value : this.phase),
        clientData: (clientData != null ? clientData.value : this.clientData),
        studyTimeZone:
            (studyTimeZone != null ? studyTimeZone.value : this.studyTimeZone),
        adherenceThresholdPercentage: (adherenceThresholdPercentage != null
            ? adherenceThresholdPercentage.value
            : this.adherenceThresholdPercentage),
        irbName: (irbName != null ? irbName.value : this.irbName),
        irbDecisionOn:
            (irbDecisionOn != null ? irbDecisionOn.value : this.irbDecisionOn),
        irbExpiresOn:
            (irbExpiresOn != null ? irbExpiresOn.value : this.irbExpiresOn),
        irbDecisionType: (irbDecisionType != null
            ? irbDecisionType.value
            : this.irbDecisionType),
        irbProtocolName: (irbProtocolName != null
            ? irbProtocolName.value
            : this.irbProtocolName),
        irbProtocolId:
            (irbProtocolId != null ? irbProtocolId.value : this.irbProtocolId),
        studyLogoUrl:
            (studyLogoUrl != null ? studyLogoUrl.value : this.studyLogoUrl),
        colorScheme:
            (colorScheme != null ? colorScheme.value : this.colorScheme),
        institutionId:
            (institutionId != null ? institutionId.value : this.institutionId),
        scheduleGuid:
            (scheduleGuid != null ? scheduleGuid.value : this.scheduleGuid),
        keywords: (keywords != null ? keywords.value : this.keywords),
        diseases: (diseases != null ? diseases.value : this.diseases),
        studyDesignTypes: (studyDesignTypes != null
            ? studyDesignTypes.value
            : this.studyDesignTypes),
        signInTypes:
            (signInTypes != null ? signInTypes.value : this.signInTypes),
        contacts: (contacts != null ? contacts.value : this.contacts),
        customEvents:
            (customEvents != null ? customEvents.value : this.customEvents),
        deleted: (deleted != null ? deleted.value : this.deleted),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        modifiedOn: (modifiedOn != null ? modifiedOn.value : this.modifiedOn),
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class StudyActivityEvent {
  StudyActivityEvent({
    required this.eventId,
    this.answerValue,
    required this.timestamp,
    this.updateType,
    this.clientTimeZone,
    this.originEventId,
    this.studyBurstId,
    this.periodFromOrigin,
    this.recordCount,
    this.createdOn,
    this.type,
  });

  factory StudyActivityEvent.fromJson(Map<String, dynamic> json) =>
      _$StudyActivityEventFromJson(json);

  @JsonKey(name: 'eventId', includeIfNull: false, defaultValue: '')
  final String eventId;
  @JsonKey(name: 'answerValue', includeIfNull: false, defaultValue: '')
  final String? answerValue;
  @JsonKey(name: 'timestamp', includeIfNull: false)
  final DateTime timestamp;
  @JsonKey(
    name: 'updateType',
    includeIfNull: false,
    toJson: activityEventUpdateTypeToJson,
    fromJson: activityEventUpdateTypeFromJson,
  )
  final enums.ActivityEventUpdateType? updateType;
  @JsonKey(name: 'clientTimeZone', includeIfNull: false, defaultValue: '')
  final String? clientTimeZone;
  @JsonKey(name: 'originEventId', includeIfNull: false, defaultValue: '')
  final String? originEventId;
  @JsonKey(name: 'studyBurstId', includeIfNull: false, defaultValue: '')
  final String? studyBurstId;
  @JsonKey(name: 'periodFromOrigin', includeIfNull: false, defaultValue: '')
  final String? periodFromOrigin;
  @JsonKey(name: 'recordCount', includeIfNull: false)
  final int? recordCount;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$StudyActivityEventFromJson;
  static const toJsonFactory = _$StudyActivityEventToJson;
  Map<String, dynamic> toJson() => _$StudyActivityEventToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StudyActivityEvent &&
            (identical(other.eventId, eventId) ||
                const DeepCollectionEquality()
                    .equals(other.eventId, eventId)) &&
            (identical(other.answerValue, answerValue) ||
                const DeepCollectionEquality()
                    .equals(other.answerValue, answerValue)) &&
            (identical(other.timestamp, timestamp) ||
                const DeepCollectionEquality()
                    .equals(other.timestamp, timestamp)) &&
            (identical(other.updateType, updateType) ||
                const DeepCollectionEquality()
                    .equals(other.updateType, updateType)) &&
            (identical(other.clientTimeZone, clientTimeZone) ||
                const DeepCollectionEquality()
                    .equals(other.clientTimeZone, clientTimeZone)) &&
            (identical(other.originEventId, originEventId) ||
                const DeepCollectionEquality()
                    .equals(other.originEventId, originEventId)) &&
            (identical(other.studyBurstId, studyBurstId) ||
                const DeepCollectionEquality()
                    .equals(other.studyBurstId, studyBurstId)) &&
            (identical(other.periodFromOrigin, periodFromOrigin) ||
                const DeepCollectionEquality()
                    .equals(other.periodFromOrigin, periodFromOrigin)) &&
            (identical(other.recordCount, recordCount) ||
                const DeepCollectionEquality()
                    .equals(other.recordCount, recordCount)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(eventId) ^
      const DeepCollectionEquality().hash(answerValue) ^
      const DeepCollectionEquality().hash(timestamp) ^
      const DeepCollectionEquality().hash(updateType) ^
      const DeepCollectionEquality().hash(clientTimeZone) ^
      const DeepCollectionEquality().hash(originEventId) ^
      const DeepCollectionEquality().hash(studyBurstId) ^
      const DeepCollectionEquality().hash(periodFromOrigin) ^
      const DeepCollectionEquality().hash(recordCount) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $StudyActivityEventExtension on StudyActivityEvent {
  StudyActivityEvent copyWith(
      {String? eventId,
      String? answerValue,
      DateTime? timestamp,
      enums.ActivityEventUpdateType? updateType,
      String? clientTimeZone,
      String? originEventId,
      String? studyBurstId,
      String? periodFromOrigin,
      int? recordCount,
      DateTime? createdOn,
      String? type}) {
    return StudyActivityEvent(
        eventId: eventId ?? this.eventId,
        answerValue: answerValue ?? this.answerValue,
        timestamp: timestamp ?? this.timestamp,
        updateType: updateType ?? this.updateType,
        clientTimeZone: clientTimeZone ?? this.clientTimeZone,
        originEventId: originEventId ?? this.originEventId,
        studyBurstId: studyBurstId ?? this.studyBurstId,
        periodFromOrigin: periodFromOrigin ?? this.periodFromOrigin,
        recordCount: recordCount ?? this.recordCount,
        createdOn: createdOn ?? this.createdOn,
        type: type ?? this.type);
  }

  StudyActivityEvent copyWithWrapped(
      {Wrapped<String>? eventId,
      Wrapped<String?>? answerValue,
      Wrapped<DateTime>? timestamp,
      Wrapped<enums.ActivityEventUpdateType?>? updateType,
      Wrapped<String?>? clientTimeZone,
      Wrapped<String?>? originEventId,
      Wrapped<String?>? studyBurstId,
      Wrapped<String?>? periodFromOrigin,
      Wrapped<int?>? recordCount,
      Wrapped<DateTime?>? createdOn,
      Wrapped<String?>? type}) {
    return StudyActivityEvent(
        eventId: (eventId != null ? eventId.value : this.eventId),
        answerValue:
            (answerValue != null ? answerValue.value : this.answerValue),
        timestamp: (timestamp != null ? timestamp.value : this.timestamp),
        updateType: (updateType != null ? updateType.value : this.updateType),
        clientTimeZone: (clientTimeZone != null
            ? clientTimeZone.value
            : this.clientTimeZone),
        originEventId:
            (originEventId != null ? originEventId.value : this.originEventId),
        studyBurstId:
            (studyBurstId != null ? studyBurstId.value : this.studyBurstId),
        periodFromOrigin: (periodFromOrigin != null
            ? periodFromOrigin.value
            : this.periodFromOrigin),
        recordCount:
            (recordCount != null ? recordCount.value : this.recordCount),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class StudyInfo {
  StudyInfo({
    this.identifier,
    this.name,
    this.details,
    this.phase,
    this.studyLogoUrl,
    this.colorScheme,
    this.signInTypes,
    this.type,
  });

  factory StudyInfo.fromJson(Map<String, dynamic> json) =>
      _$StudyInfoFromJson(json);

  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String? identifier;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'details', includeIfNull: false, defaultValue: '')
  final String? details;
  @JsonKey(
    name: 'phase',
    includeIfNull: false,
    toJson: studyPhaseToJson,
    fromJson: studyPhaseFromJson,
  )
  final enums.StudyPhase? phase;
  @JsonKey(name: 'studyLogoUrl', includeIfNull: false, defaultValue: '')
  final String? studyLogoUrl;
  @JsonKey(name: 'colorScheme', includeIfNull: false)
  final ColorScheme? colorScheme;
  @JsonKey(
    name: 'signInTypes',
    includeIfNull: false,
    toJson: signInTypeListToJson,
    fromJson: signInTypeListFromJson,
  )
  final List<enums.SignInType>? signInTypes;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$StudyInfoFromJson;
  static const toJsonFactory = _$StudyInfoToJson;
  Map<String, dynamic> toJson() => _$StudyInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StudyInfo &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.details, details) ||
                const DeepCollectionEquality()
                    .equals(other.details, details)) &&
            (identical(other.phase, phase) ||
                const DeepCollectionEquality().equals(other.phase, phase)) &&
            (identical(other.studyLogoUrl, studyLogoUrl) ||
                const DeepCollectionEquality()
                    .equals(other.studyLogoUrl, studyLogoUrl)) &&
            (identical(other.colorScheme, colorScheme) ||
                const DeepCollectionEquality()
                    .equals(other.colorScheme, colorScheme)) &&
            (identical(other.signInTypes, signInTypes) ||
                const DeepCollectionEquality()
                    .equals(other.signInTypes, signInTypes)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(details) ^
      const DeepCollectionEquality().hash(phase) ^
      const DeepCollectionEquality().hash(studyLogoUrl) ^
      const DeepCollectionEquality().hash(colorScheme) ^
      const DeepCollectionEquality().hash(signInTypes) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $StudyInfoExtension on StudyInfo {
  StudyInfo copyWith(
      {String? identifier,
      String? name,
      String? details,
      enums.StudyPhase? phase,
      String? studyLogoUrl,
      ColorScheme? colorScheme,
      List<enums.SignInType>? signInTypes,
      String? type}) {
    return StudyInfo(
        identifier: identifier ?? this.identifier,
        name: name ?? this.name,
        details: details ?? this.details,
        phase: phase ?? this.phase,
        studyLogoUrl: studyLogoUrl ?? this.studyLogoUrl,
        colorScheme: colorScheme ?? this.colorScheme,
        signInTypes: signInTypes ?? this.signInTypes,
        type: type ?? this.type);
  }

  StudyInfo copyWithWrapped(
      {Wrapped<String?>? identifier,
      Wrapped<String?>? name,
      Wrapped<String?>? details,
      Wrapped<enums.StudyPhase?>? phase,
      Wrapped<String?>? studyLogoUrl,
      Wrapped<ColorScheme?>? colorScheme,
      Wrapped<List<enums.SignInType>?>? signInTypes,
      Wrapped<String?>? type}) {
    return StudyInfo(
        identifier: (identifier != null ? identifier.value : this.identifier),
        name: (name != null ? name.value : this.name),
        details: (details != null ? details.value : this.details),
        phase: (phase != null ? phase.value : this.phase),
        studyLogoUrl:
            (studyLogoUrl != null ? studyLogoUrl.value : this.studyLogoUrl),
        colorScheme:
            (colorScheme != null ? colorScheme.value : this.colorScheme),
        signInTypes:
            (signInTypes != null ? signInTypes.value : this.signInTypes),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Survey {
  Survey({
    required this.guid,
    this.moduleId,
    this.moduleVersion,
    required this.name,
    required this.identifier,
    this.published,
    this.schemaRevision,
    this.createdOn,
    this.modifiedOn,
    this.copyrightNotice,
    this.deleted,
    required this.version,
    required this.elements,
    this.type,
  });

  factory Survey.fromJson(Map<String, dynamic> json) => _$SurveyFromJson(json);

  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String guid;
  @JsonKey(name: 'moduleId', includeIfNull: false, defaultValue: '')
  final String? moduleId;
  @JsonKey(name: 'moduleVersion', includeIfNull: false)
  final int? moduleVersion;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String identifier;
  @JsonKey(name: 'published', includeIfNull: false)
  final bool? published;
  @JsonKey(name: 'schemaRevision', includeIfNull: false)
  final num? schemaRevision;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'modifiedOn', includeIfNull: false)
  final DateTime? modifiedOn;
  @JsonKey(name: 'copyrightNotice', includeIfNull: false, defaultValue: '')
  final String? copyrightNotice;
  @JsonKey(name: 'deleted', includeIfNull: false)
  final bool? deleted;
  @JsonKey(name: 'version', includeIfNull: false)
  final num version;
  @JsonKey(
      name: 'elements', includeIfNull: false, defaultValue: <SurveyElement>[])
  final List<SurveyElement> elements;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SurveyFromJson;
  static const toJsonFactory = _$SurveyToJson;
  Map<String, dynamic> toJson() => _$SurveyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Survey &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.moduleId, moduleId) ||
                const DeepCollectionEquality()
                    .equals(other.moduleId, moduleId)) &&
            (identical(other.moduleVersion, moduleVersion) ||
                const DeepCollectionEquality()
                    .equals(other.moduleVersion, moduleVersion)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.published, published) ||
                const DeepCollectionEquality()
                    .equals(other.published, published)) &&
            (identical(other.schemaRevision, schemaRevision) ||
                const DeepCollectionEquality()
                    .equals(other.schemaRevision, schemaRevision)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.modifiedOn, modifiedOn) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedOn, modifiedOn)) &&
            (identical(other.copyrightNotice, copyrightNotice) ||
                const DeepCollectionEquality()
                    .equals(other.copyrightNotice, copyrightNotice)) &&
            (identical(other.deleted, deleted) ||
                const DeepCollectionEquality()
                    .equals(other.deleted, deleted)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.elements, elements) ||
                const DeepCollectionEquality()
                    .equals(other.elements, elements)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(moduleId) ^
      const DeepCollectionEquality().hash(moduleVersion) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(published) ^
      const DeepCollectionEquality().hash(schemaRevision) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(modifiedOn) ^
      const DeepCollectionEquality().hash(copyrightNotice) ^
      const DeepCollectionEquality().hash(deleted) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(elements) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SurveyExtension on Survey {
  Survey copyWith(
      {String? guid,
      String? moduleId,
      int? moduleVersion,
      String? name,
      String? identifier,
      bool? published,
      num? schemaRevision,
      DateTime? createdOn,
      DateTime? modifiedOn,
      String? copyrightNotice,
      bool? deleted,
      num? version,
      List<SurveyElement>? elements,
      String? type}) {
    return Survey(
        guid: guid ?? this.guid,
        moduleId: moduleId ?? this.moduleId,
        moduleVersion: moduleVersion ?? this.moduleVersion,
        name: name ?? this.name,
        identifier: identifier ?? this.identifier,
        published: published ?? this.published,
        schemaRevision: schemaRevision ?? this.schemaRevision,
        createdOn: createdOn ?? this.createdOn,
        modifiedOn: modifiedOn ?? this.modifiedOn,
        copyrightNotice: copyrightNotice ?? this.copyrightNotice,
        deleted: deleted ?? this.deleted,
        version: version ?? this.version,
        elements: elements ?? this.elements,
        type: type ?? this.type);
  }

  Survey copyWithWrapped(
      {Wrapped<String>? guid,
      Wrapped<String?>? moduleId,
      Wrapped<int?>? moduleVersion,
      Wrapped<String>? name,
      Wrapped<String>? identifier,
      Wrapped<bool?>? published,
      Wrapped<num?>? schemaRevision,
      Wrapped<DateTime?>? createdOn,
      Wrapped<DateTime?>? modifiedOn,
      Wrapped<String?>? copyrightNotice,
      Wrapped<bool?>? deleted,
      Wrapped<num>? version,
      Wrapped<List<SurveyElement>>? elements,
      Wrapped<String?>? type}) {
    return Survey(
        guid: (guid != null ? guid.value : this.guid),
        moduleId: (moduleId != null ? moduleId.value : this.moduleId),
        moduleVersion:
            (moduleVersion != null ? moduleVersion.value : this.moduleVersion),
        name: (name != null ? name.value : this.name),
        identifier: (identifier != null ? identifier.value : this.identifier),
        published: (published != null ? published.value : this.published),
        schemaRevision: (schemaRevision != null
            ? schemaRevision.value
            : this.schemaRevision),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        modifiedOn: (modifiedOn != null ? modifiedOn.value : this.modifiedOn),
        copyrightNotice: (copyrightNotice != null
            ? copyrightNotice.value
            : this.copyrightNotice),
        deleted: (deleted != null ? deleted.value : this.deleted),
        version: (version != null ? version.value : this.version),
        elements: (elements != null ? elements.value : this.elements),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SurveyElement {
  SurveyElement({
    required this.guid,
    this.beforeRules,
    this.afterRules,
    required this.identifier,
    this.type,
  });

  factory SurveyElement.fromJson(Map<String, dynamic> json) =>
      _$SurveyElementFromJson(json);

  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String guid;
  @JsonKey(
      name: 'beforeRules', includeIfNull: false, defaultValue: <SurveyRule>[])
  final List<SurveyRule>? beforeRules;
  @JsonKey(
      name: 'afterRules', includeIfNull: false, defaultValue: <SurveyRule>[])
  final List<SurveyRule>? afterRules;
  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String identifier;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SurveyElementFromJson;
  static const toJsonFactory = _$SurveyElementToJson;
  Map<String, dynamic> toJson() => _$SurveyElementToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SurveyElement &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.beforeRules, beforeRules) ||
                const DeepCollectionEquality()
                    .equals(other.beforeRules, beforeRules)) &&
            (identical(other.afterRules, afterRules) ||
                const DeepCollectionEquality()
                    .equals(other.afterRules, afterRules)) &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(beforeRules) ^
      const DeepCollectionEquality().hash(afterRules) ^
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SurveyElementExtension on SurveyElement {
  SurveyElement copyWith(
      {String? guid,
      List<SurveyRule>? beforeRules,
      List<SurveyRule>? afterRules,
      String? identifier,
      String? type}) {
    return SurveyElement(
        guid: guid ?? this.guid,
        beforeRules: beforeRules ?? this.beforeRules,
        afterRules: afterRules ?? this.afterRules,
        identifier: identifier ?? this.identifier,
        type: type ?? this.type);
  }

  SurveyElement copyWithWrapped(
      {Wrapped<String>? guid,
      Wrapped<List<SurveyRule>?>? beforeRules,
      Wrapped<List<SurveyRule>?>? afterRules,
      Wrapped<String>? identifier,
      Wrapped<String?>? type}) {
    return SurveyElement(
        guid: (guid != null ? guid.value : this.guid),
        beforeRules:
            (beforeRules != null ? beforeRules.value : this.beforeRules),
        afterRules: (afterRules != null ? afterRules.value : this.afterRules),
        identifier: (identifier != null ? identifier.value : this.identifier),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SurveyInfoScreen {
  SurveyInfoScreen({
    required this.title,
    required this.prompt,
    this.promptDetail,
    this.image,
    required this.guid,
    this.beforeRules,
    this.afterRules,
    required this.identifier,
    this.type,
  });

  factory SurveyInfoScreen.fromJson(Map<String, dynamic> json) =>
      _$SurveyInfoScreenFromJson(json);

  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  @JsonKey(name: 'prompt', includeIfNull: false, defaultValue: '')
  final String prompt;
  @JsonKey(name: 'promptDetail', includeIfNull: false, defaultValue: '')
  final String? promptDetail;
  @JsonKey(name: 'image', includeIfNull: false)
  final Image? image;
  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String guid;
  @JsonKey(
      name: 'beforeRules', includeIfNull: false, defaultValue: <SurveyRule>[])
  final List<SurveyRule>? beforeRules;
  @JsonKey(
      name: 'afterRules', includeIfNull: false, defaultValue: <SurveyRule>[])
  final List<SurveyRule>? afterRules;
  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String identifier;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SurveyInfoScreenFromJson;
  static const toJsonFactory = _$SurveyInfoScreenToJson;
  Map<String, dynamic> toJson() => _$SurveyInfoScreenToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SurveyInfoScreen &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.prompt, prompt) ||
                const DeepCollectionEquality().equals(other.prompt, prompt)) &&
            (identical(other.promptDetail, promptDetail) ||
                const DeepCollectionEquality()
                    .equals(other.promptDetail, promptDetail)) &&
            (identical(other.image, image) ||
                const DeepCollectionEquality().equals(other.image, image)) &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.beforeRules, beforeRules) ||
                const DeepCollectionEquality()
                    .equals(other.beforeRules, beforeRules)) &&
            (identical(other.afterRules, afterRules) ||
                const DeepCollectionEquality()
                    .equals(other.afterRules, afterRules)) &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(prompt) ^
      const DeepCollectionEquality().hash(promptDetail) ^
      const DeepCollectionEquality().hash(image) ^
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(beforeRules) ^
      const DeepCollectionEquality().hash(afterRules) ^
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SurveyInfoScreenExtension on SurveyInfoScreen {
  SurveyInfoScreen copyWith(
      {String? title,
      String? prompt,
      String? promptDetail,
      Image? image,
      String? guid,
      List<SurveyRule>? beforeRules,
      List<SurveyRule>? afterRules,
      String? identifier,
      String? type}) {
    return SurveyInfoScreen(
        title: title ?? this.title,
        prompt: prompt ?? this.prompt,
        promptDetail: promptDetail ?? this.promptDetail,
        image: image ?? this.image,
        guid: guid ?? this.guid,
        beforeRules: beforeRules ?? this.beforeRules,
        afterRules: afterRules ?? this.afterRules,
        identifier: identifier ?? this.identifier,
        type: type ?? this.type);
  }

  SurveyInfoScreen copyWithWrapped(
      {Wrapped<String>? title,
      Wrapped<String>? prompt,
      Wrapped<String?>? promptDetail,
      Wrapped<Image?>? image,
      Wrapped<String>? guid,
      Wrapped<List<SurveyRule>?>? beforeRules,
      Wrapped<List<SurveyRule>?>? afterRules,
      Wrapped<String>? identifier,
      Wrapped<String?>? type}) {
    return SurveyInfoScreen(
        title: (title != null ? title.value : this.title),
        prompt: (prompt != null ? prompt.value : this.prompt),
        promptDetail:
            (promptDetail != null ? promptDetail.value : this.promptDetail),
        image: (image != null ? image.value : this.image),
        guid: (guid != null ? guid.value : this.guid),
        beforeRules:
            (beforeRules != null ? beforeRules.value : this.beforeRules),
        afterRules: (afterRules != null ? afterRules.value : this.afterRules),
        identifier: (identifier != null ? identifier.value : this.identifier),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SurveyQuestion {
  SurveyQuestion({
    required this.title,
    required this.prompt,
    this.promptDetail,
    required this.uiHint,
    required this.constraints,
    required this.guid,
    this.beforeRules,
    this.afterRules,
    required this.identifier,
    this.type,
  });

  factory SurveyQuestion.fromJson(Map<String, dynamic> json) =>
      _$SurveyQuestionFromJson(json);

  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  @JsonKey(name: 'prompt', includeIfNull: false, defaultValue: '')
  final String prompt;
  @JsonKey(name: 'promptDetail', includeIfNull: false, defaultValue: '')
  final String? promptDetail;
  @JsonKey(
    name: 'uiHint',
    includeIfNull: false,
    toJson: uIHintToJson,
    fromJson: uIHintFromJson,
  )
  final enums.UIHint uiHint;
  @JsonKey(name: 'constraints', includeIfNull: false)
  final Constraints constraints;
  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String guid;
  @JsonKey(
      name: 'beforeRules', includeIfNull: false, defaultValue: <SurveyRule>[])
  final List<SurveyRule>? beforeRules;
  @JsonKey(
      name: 'afterRules', includeIfNull: false, defaultValue: <SurveyRule>[])
  final List<SurveyRule>? afterRules;
  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String identifier;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SurveyQuestionFromJson;
  static const toJsonFactory = _$SurveyQuestionToJson;
  Map<String, dynamic> toJson() => _$SurveyQuestionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SurveyQuestion &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.prompt, prompt) ||
                const DeepCollectionEquality().equals(other.prompt, prompt)) &&
            (identical(other.promptDetail, promptDetail) ||
                const DeepCollectionEquality()
                    .equals(other.promptDetail, promptDetail)) &&
            (identical(other.uiHint, uiHint) ||
                const DeepCollectionEquality().equals(other.uiHint, uiHint)) &&
            (identical(other.constraints, constraints) ||
                const DeepCollectionEquality()
                    .equals(other.constraints, constraints)) &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.beforeRules, beforeRules) ||
                const DeepCollectionEquality()
                    .equals(other.beforeRules, beforeRules)) &&
            (identical(other.afterRules, afterRules) ||
                const DeepCollectionEquality()
                    .equals(other.afterRules, afterRules)) &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(prompt) ^
      const DeepCollectionEquality().hash(promptDetail) ^
      const DeepCollectionEquality().hash(uiHint) ^
      const DeepCollectionEquality().hash(constraints) ^
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(beforeRules) ^
      const DeepCollectionEquality().hash(afterRules) ^
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SurveyQuestionExtension on SurveyQuestion {
  SurveyQuestion copyWith(
      {String? title,
      String? prompt,
      String? promptDetail,
      enums.UIHint? uiHint,
      Constraints? constraints,
      String? guid,
      List<SurveyRule>? beforeRules,
      List<SurveyRule>? afterRules,
      String? identifier,
      String? type}) {
    return SurveyQuestion(
        title: title ?? this.title,
        prompt: prompt ?? this.prompt,
        promptDetail: promptDetail ?? this.promptDetail,
        uiHint: uiHint ?? this.uiHint,
        constraints: constraints ?? this.constraints,
        guid: guid ?? this.guid,
        beforeRules: beforeRules ?? this.beforeRules,
        afterRules: afterRules ?? this.afterRules,
        identifier: identifier ?? this.identifier,
        type: type ?? this.type);
  }

  SurveyQuestion copyWithWrapped(
      {Wrapped<String>? title,
      Wrapped<String>? prompt,
      Wrapped<String?>? promptDetail,
      Wrapped<enums.UIHint>? uiHint,
      Wrapped<Constraints>? constraints,
      Wrapped<String>? guid,
      Wrapped<List<SurveyRule>?>? beforeRules,
      Wrapped<List<SurveyRule>?>? afterRules,
      Wrapped<String>? identifier,
      Wrapped<String?>? type}) {
    return SurveyQuestion(
        title: (title != null ? title.value : this.title),
        prompt: (prompt != null ? prompt.value : this.prompt),
        promptDetail:
            (promptDetail != null ? promptDetail.value : this.promptDetail),
        uiHint: (uiHint != null ? uiHint.value : this.uiHint),
        constraints:
            (constraints != null ? constraints.value : this.constraints),
        guid: (guid != null ? guid.value : this.guid),
        beforeRules:
            (beforeRules != null ? beforeRules.value : this.beforeRules),
        afterRules: (afterRules != null ? afterRules.value : this.afterRules),
        identifier: (identifier != null ? identifier.value : this.identifier),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SurveyQuestionOption {
  SurveyQuestionOption({
    required this.label,
    this.detail,
    this.value,
    this.image,
    this.exclusive,
    this.type,
  });

  factory SurveyQuestionOption.fromJson(Map<String, dynamic> json) =>
      _$SurveyQuestionOptionFromJson(json);

  @JsonKey(name: 'label', includeIfNull: false, defaultValue: '')
  final String label;
  @JsonKey(name: 'detail', includeIfNull: false, defaultValue: '')
  final String? detail;
  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String? value;
  @JsonKey(name: 'image', includeIfNull: false)
  final Image? image;
  @JsonKey(name: 'exclusive', includeIfNull: false)
  final bool? exclusive;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SurveyQuestionOptionFromJson;
  static const toJsonFactory = _$SurveyQuestionOptionToJson;
  Map<String, dynamic> toJson() => _$SurveyQuestionOptionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SurveyQuestionOption &&
            (identical(other.label, label) ||
                const DeepCollectionEquality().equals(other.label, label)) &&
            (identical(other.detail, detail) ||
                const DeepCollectionEquality().equals(other.detail, detail)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)) &&
            (identical(other.image, image) ||
                const DeepCollectionEquality().equals(other.image, image)) &&
            (identical(other.exclusive, exclusive) ||
                const DeepCollectionEquality()
                    .equals(other.exclusive, exclusive)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(label) ^
      const DeepCollectionEquality().hash(detail) ^
      const DeepCollectionEquality().hash(value) ^
      const DeepCollectionEquality().hash(image) ^
      const DeepCollectionEquality().hash(exclusive) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SurveyQuestionOptionExtension on SurveyQuestionOption {
  SurveyQuestionOption copyWith(
      {String? label,
      String? detail,
      String? value,
      Image? image,
      bool? exclusive,
      String? type}) {
    return SurveyQuestionOption(
        label: label ?? this.label,
        detail: detail ?? this.detail,
        value: value ?? this.value,
        image: image ?? this.image,
        exclusive: exclusive ?? this.exclusive,
        type: type ?? this.type);
  }

  SurveyQuestionOption copyWithWrapped(
      {Wrapped<String>? label,
      Wrapped<String?>? detail,
      Wrapped<String?>? value,
      Wrapped<Image?>? image,
      Wrapped<bool?>? exclusive,
      Wrapped<String?>? type}) {
    return SurveyQuestionOption(
        label: (label != null ? label.value : this.label),
        detail: (detail != null ? detail.value : this.detail),
        value: (value != null ? value.value : this.value),
        image: (image != null ? image.value : this.image),
        exclusive: (exclusive != null ? exclusive.value : this.exclusive),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SurveyReference {
  SurveyReference({
    this.identifier,
    required this.guid,
    this.createdOn,
    this.href,
    this.type,
  });

  factory SurveyReference.fromJson(Map<String, dynamic> json) =>
      _$SurveyReferenceFromJson(json);

  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String? identifier;
  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String guid;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'href', includeIfNull: false, defaultValue: '')
  final String? href;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SurveyReferenceFromJson;
  static const toJsonFactory = _$SurveyReferenceToJson;
  Map<String, dynamic> toJson() => _$SurveyReferenceToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SurveyReference &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.href, href) ||
                const DeepCollectionEquality().equals(other.href, href)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(href) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SurveyReferenceExtension on SurveyReference {
  SurveyReference copyWith(
      {String? identifier,
      String? guid,
      DateTime? createdOn,
      String? href,
      String? type}) {
    return SurveyReference(
        identifier: identifier ?? this.identifier,
        guid: guid ?? this.guid,
        createdOn: createdOn ?? this.createdOn,
        href: href ?? this.href,
        type: type ?? this.type);
  }

  SurveyReference copyWithWrapped(
      {Wrapped<String?>? identifier,
      Wrapped<String>? guid,
      Wrapped<DateTime?>? createdOn,
      Wrapped<String?>? href,
      Wrapped<String?>? type}) {
    return SurveyReference(
        identifier: (identifier != null ? identifier.value : this.identifier),
        guid: (guid != null ? guid.value : this.guid),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        href: (href != null ? href.value : this.href),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SurveyRule {
  SurveyRule({
    required this.$operator,
    this.value,
    this.dataGroups,
    this.skipTo,
    this.endSurvey,
    this.displayIf,
    this.displayUnless,
    this.assignDataGroup,
    this.type,
  });

  factory SurveyRule.fromJson(Map<String, dynamic> json) =>
      _$SurveyRuleFromJson(json);

  @JsonKey(
    name: 'operator',
    includeIfNull: false,
    toJson: operatorToJson,
    fromJson: operatorFromJson,
  )
  final enums.Operator $operator;
  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String? value;
  @JsonKey(name: 'dataGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String>? dataGroups;
  @JsonKey(name: 'skipTo', includeIfNull: false, defaultValue: '')
  final String? skipTo;
  @JsonKey(name: 'endSurvey', includeIfNull: false)
  final bool? endSurvey;
  @JsonKey(name: 'displayIf', includeIfNull: false)
  final bool? displayIf;
  @JsonKey(name: 'displayUnless', includeIfNull: false)
  final bool? displayUnless;
  @JsonKey(name: 'assignDataGroup', includeIfNull: false, defaultValue: '')
  final String? assignDataGroup;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SurveyRuleFromJson;
  static const toJsonFactory = _$SurveyRuleToJson;
  Map<String, dynamic> toJson() => _$SurveyRuleToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SurveyRule &&
            (identical(other.$operator, $operator) ||
                const DeepCollectionEquality()
                    .equals(other.$operator, $operator)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)) &&
            (identical(other.dataGroups, dataGroups) ||
                const DeepCollectionEquality()
                    .equals(other.dataGroups, dataGroups)) &&
            (identical(other.skipTo, skipTo) ||
                const DeepCollectionEquality().equals(other.skipTo, skipTo)) &&
            (identical(other.endSurvey, endSurvey) ||
                const DeepCollectionEquality()
                    .equals(other.endSurvey, endSurvey)) &&
            (identical(other.displayIf, displayIf) ||
                const DeepCollectionEquality()
                    .equals(other.displayIf, displayIf)) &&
            (identical(other.displayUnless, displayUnless) ||
                const DeepCollectionEquality()
                    .equals(other.displayUnless, displayUnless)) &&
            (identical(other.assignDataGroup, assignDataGroup) ||
                const DeepCollectionEquality()
                    .equals(other.assignDataGroup, assignDataGroup)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash($operator) ^
      const DeepCollectionEquality().hash(value) ^
      const DeepCollectionEquality().hash(dataGroups) ^
      const DeepCollectionEquality().hash(skipTo) ^
      const DeepCollectionEquality().hash(endSurvey) ^
      const DeepCollectionEquality().hash(displayIf) ^
      const DeepCollectionEquality().hash(displayUnless) ^
      const DeepCollectionEquality().hash(assignDataGroup) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SurveyRuleExtension on SurveyRule {
  SurveyRule copyWith(
      {enums.Operator? $operator,
      String? value,
      List<String>? dataGroups,
      String? skipTo,
      bool? endSurvey,
      bool? displayIf,
      bool? displayUnless,
      String? assignDataGroup,
      String? type}) {
    return SurveyRule(
        $operator: $operator ?? this.$operator,
        value: value ?? this.value,
        dataGroups: dataGroups ?? this.dataGroups,
        skipTo: skipTo ?? this.skipTo,
        endSurvey: endSurvey ?? this.endSurvey,
        displayIf: displayIf ?? this.displayIf,
        displayUnless: displayUnless ?? this.displayUnless,
        assignDataGroup: assignDataGroup ?? this.assignDataGroup,
        type: type ?? this.type);
  }

  SurveyRule copyWithWrapped(
      {Wrapped<enums.Operator>? $operator,
      Wrapped<String?>? value,
      Wrapped<List<String>?>? dataGroups,
      Wrapped<String?>? skipTo,
      Wrapped<bool?>? endSurvey,
      Wrapped<bool?>? displayIf,
      Wrapped<bool?>? displayUnless,
      Wrapped<String?>? assignDataGroup,
      Wrapped<String?>? type}) {
    return SurveyRule(
        $operator: ($operator != null ? $operator.value : this.$operator),
        value: (value != null ? value.value : this.value),
        dataGroups: (dataGroups != null ? dataGroups.value : this.dataGroups),
        skipTo: (skipTo != null ? skipTo.value : this.skipTo),
        endSurvey: (endSurvey != null ? endSurvey.value : this.endSurvey),
        displayIf: (displayIf != null ? displayIf.value : this.displayIf),
        displayUnless:
            (displayUnless != null ? displayUnless.value : this.displayUnless),
        assignDataGroup: (assignDataGroup != null
            ? assignDataGroup.value
            : this.assignDataGroup),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class TaskReference {
  TaskReference({
    required this.identifier,
    this.schema,
    this.type,
  });

  factory TaskReference.fromJson(Map<String, dynamic> json) =>
      _$TaskReferenceFromJson(json);

  @JsonKey(name: 'identifier', includeIfNull: false, defaultValue: '')
  final String identifier;
  @JsonKey(name: 'schema', includeIfNull: false)
  final SchemaReference? schema;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$TaskReferenceFromJson;
  static const toJsonFactory = _$TaskReferenceToJson;
  Map<String, dynamic> toJson() => _$TaskReferenceToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TaskReference &&
            (identical(other.identifier, identifier) ||
                const DeepCollectionEquality()
                    .equals(other.identifier, identifier)) &&
            (identical(other.schema, schema) ||
                const DeepCollectionEquality().equals(other.schema, schema)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(identifier) ^
      const DeepCollectionEquality().hash(schema) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $TaskReferenceExtension on TaskReference {
  TaskReference copyWith(
      {String? identifier, SchemaReference? schema, String? type}) {
    return TaskReference(
        identifier: identifier ?? this.identifier,
        schema: schema ?? this.schema,
        type: type ?? this.type);
  }

  TaskReference copyWithWrapped(
      {Wrapped<String>? identifier,
      Wrapped<SchemaReference?>? schema,
      Wrapped<String?>? type}) {
    return TaskReference(
        identifier: (identifier != null ? identifier.value : this.identifier),
        schema: (schema != null ? schema.value : this.schema),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Template {
  Template({
    this.guid,
    required this.templateType,
    required this.name,
    this.description,
    this.criteria,
    this.createdOn,
    this.modifiedOn,
    this.publishedCreatedOn,
    this.deleted,
    this.version,
    this.type,
  });

  factory Template.fromJson(Map<String, dynamic> json) =>
      _$TemplateFromJson(json);

  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String? guid;
  @JsonKey(
    name: 'templateType',
    includeIfNull: false,
    toJson: templateTypeToJson,
    fromJson: templateTypeFromJson,
  )
  final enums.TemplateType templateType;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String? description;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final Criteria? criteria;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'modifiedOn', includeIfNull: false)
  final DateTime? modifiedOn;
  @JsonKey(name: 'publishedCreatedOn', includeIfNull: false)
  final DateTime? publishedCreatedOn;
  @JsonKey(name: 'deleted', includeIfNull: false)
  final bool? deleted;
  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$TemplateFromJson;
  static const toJsonFactory = _$TemplateToJson;
  Map<String, dynamic> toJson() => _$TemplateToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Template &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.templateType, templateType) ||
                const DeepCollectionEquality()
                    .equals(other.templateType, templateType)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.modifiedOn, modifiedOn) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedOn, modifiedOn)) &&
            (identical(other.publishedCreatedOn, publishedCreatedOn) ||
                const DeepCollectionEquality()
                    .equals(other.publishedCreatedOn, publishedCreatedOn)) &&
            (identical(other.deleted, deleted) ||
                const DeepCollectionEquality()
                    .equals(other.deleted, deleted)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(templateType) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(modifiedOn) ^
      const DeepCollectionEquality().hash(publishedCreatedOn) ^
      const DeepCollectionEquality().hash(deleted) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $TemplateExtension on Template {
  Template copyWith(
      {String? guid,
      enums.TemplateType? templateType,
      String? name,
      String? description,
      Criteria? criteria,
      DateTime? createdOn,
      DateTime? modifiedOn,
      DateTime? publishedCreatedOn,
      bool? deleted,
      num? version,
      String? type}) {
    return Template(
        guid: guid ?? this.guid,
        templateType: templateType ?? this.templateType,
        name: name ?? this.name,
        description: description ?? this.description,
        criteria: criteria ?? this.criteria,
        createdOn: createdOn ?? this.createdOn,
        modifiedOn: modifiedOn ?? this.modifiedOn,
        publishedCreatedOn: publishedCreatedOn ?? this.publishedCreatedOn,
        deleted: deleted ?? this.deleted,
        version: version ?? this.version,
        type: type ?? this.type);
  }

  Template copyWithWrapped(
      {Wrapped<String?>? guid,
      Wrapped<enums.TemplateType>? templateType,
      Wrapped<String>? name,
      Wrapped<String?>? description,
      Wrapped<Criteria?>? criteria,
      Wrapped<DateTime?>? createdOn,
      Wrapped<DateTime?>? modifiedOn,
      Wrapped<DateTime?>? publishedCreatedOn,
      Wrapped<bool?>? deleted,
      Wrapped<num?>? version,
      Wrapped<String?>? type}) {
    return Template(
        guid: (guid != null ? guid.value : this.guid),
        templateType:
            (templateType != null ? templateType.value : this.templateType),
        name: (name != null ? name.value : this.name),
        description:
            (description != null ? description.value : this.description),
        criteria: (criteria != null ? criteria.value : this.criteria),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        modifiedOn: (modifiedOn != null ? modifiedOn.value : this.modifiedOn),
        publishedCreatedOn: (publishedCreatedOn != null
            ? publishedCreatedOn.value
            : this.publishedCreatedOn),
        deleted: (deleted != null ? deleted.value : this.deleted),
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class TemplateRevision {
  TemplateRevision({
    this.createdOn,
    this.createdBy,
    this.documentContent,
    this.subject,
    required this.mimeType,
    this.type,
  });

  factory TemplateRevision.fromJson(Map<String, dynamic> json) =>
      _$TemplateRevisionFromJson(json);

  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'createdBy', includeIfNull: false, defaultValue: '')
  final String? createdBy;
  @JsonKey(name: 'documentContent', includeIfNull: false, defaultValue: '')
  final String? documentContent;
  @JsonKey(name: 'subject', includeIfNull: false, defaultValue: '')
  final String? subject;
  @JsonKey(
    name: 'mimeType',
    includeIfNull: false,
    toJson: mimeTypeToJson,
    fromJson: mimeTypeFromJson,
  )
  final enums.MimeType mimeType;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$TemplateRevisionFromJson;
  static const toJsonFactory = _$TemplateRevisionToJson;
  Map<String, dynamic> toJson() => _$TemplateRevisionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TemplateRevision &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.createdBy, createdBy) ||
                const DeepCollectionEquality()
                    .equals(other.createdBy, createdBy)) &&
            (identical(other.documentContent, documentContent) ||
                const DeepCollectionEquality()
                    .equals(other.documentContent, documentContent)) &&
            (identical(other.subject, subject) ||
                const DeepCollectionEquality()
                    .equals(other.subject, subject)) &&
            (identical(other.mimeType, mimeType) ||
                const DeepCollectionEquality()
                    .equals(other.mimeType, mimeType)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(createdBy) ^
      const DeepCollectionEquality().hash(documentContent) ^
      const DeepCollectionEquality().hash(subject) ^
      const DeepCollectionEquality().hash(mimeType) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $TemplateRevisionExtension on TemplateRevision {
  TemplateRevision copyWith(
      {DateTime? createdOn,
      String? createdBy,
      String? documentContent,
      String? subject,
      enums.MimeType? mimeType,
      String? type}) {
    return TemplateRevision(
        createdOn: createdOn ?? this.createdOn,
        createdBy: createdBy ?? this.createdBy,
        documentContent: documentContent ?? this.documentContent,
        subject: subject ?? this.subject,
        mimeType: mimeType ?? this.mimeType,
        type: type ?? this.type);
  }

  TemplateRevision copyWithWrapped(
      {Wrapped<DateTime?>? createdOn,
      Wrapped<String?>? createdBy,
      Wrapped<String?>? documentContent,
      Wrapped<String?>? subject,
      Wrapped<enums.MimeType>? mimeType,
      Wrapped<String?>? type}) {
    return TemplateRevision(
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        createdBy: (createdBy != null ? createdBy.value : this.createdBy),
        documentContent: (documentContent != null
            ? documentContent.value
            : this.documentContent),
        subject: (subject != null ? subject.value : this.subject),
        mimeType: (mimeType != null ? mimeType.value : this.mimeType),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Timeline {
  Timeline({
    this.duration,
    this.schedule,
    this.assessments,
    this.sessions,
    this.studyBursts,
    this.totalMinutes,
    this.totalNotifications,
    this.type,
  });

  factory Timeline.fromJson(Map<String, dynamic> json) =>
      _$TimelineFromJson(json);

  @JsonKey(name: 'duration', includeIfNull: false, defaultValue: '')
  final String? duration;
  @JsonKey(
      name: 'schedule',
      includeIfNull: false,
      defaultValue: <ScheduledSession>[])
  final List<ScheduledSession>? schedule;
  @JsonKey(
      name: 'assessments',
      includeIfNull: false,
      defaultValue: <AssessmentInfo>[])
  final List<AssessmentInfo>? assessments;
  @JsonKey(
      name: 'sessions', includeIfNull: false, defaultValue: <SessionInfo>[])
  final List<SessionInfo>? sessions;
  @JsonKey(
      name: 'studyBursts',
      includeIfNull: false,
      defaultValue: <StudyBurstInfo>[])
  final List<StudyBurstInfo>? studyBursts;
  @JsonKey(name: 'totalMinutes', includeIfNull: false)
  final int? totalMinutes;
  @JsonKey(name: 'totalNotifications', includeIfNull: false)
  final int? totalNotifications;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$TimelineFromJson;
  static const toJsonFactory = _$TimelineToJson;
  Map<String, dynamic> toJson() => _$TimelineToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Timeline &&
            (identical(other.duration, duration) ||
                const DeepCollectionEquality()
                    .equals(other.duration, duration)) &&
            (identical(other.schedule, schedule) ||
                const DeepCollectionEquality()
                    .equals(other.schedule, schedule)) &&
            (identical(other.assessments, assessments) ||
                const DeepCollectionEquality()
                    .equals(other.assessments, assessments)) &&
            (identical(other.sessions, sessions) ||
                const DeepCollectionEquality()
                    .equals(other.sessions, sessions)) &&
            (identical(other.studyBursts, studyBursts) ||
                const DeepCollectionEquality()
                    .equals(other.studyBursts, studyBursts)) &&
            (identical(other.totalMinutes, totalMinutes) ||
                const DeepCollectionEquality()
                    .equals(other.totalMinutes, totalMinutes)) &&
            (identical(other.totalNotifications, totalNotifications) ||
                const DeepCollectionEquality()
                    .equals(other.totalNotifications, totalNotifications)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(duration) ^
      const DeepCollectionEquality().hash(schedule) ^
      const DeepCollectionEquality().hash(assessments) ^
      const DeepCollectionEquality().hash(sessions) ^
      const DeepCollectionEquality().hash(studyBursts) ^
      const DeepCollectionEquality().hash(totalMinutes) ^
      const DeepCollectionEquality().hash(totalNotifications) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $TimelineExtension on Timeline {
  Timeline copyWith(
      {String? duration,
      List<ScheduledSession>? schedule,
      List<AssessmentInfo>? assessments,
      List<SessionInfo>? sessions,
      List<StudyBurstInfo>? studyBursts,
      int? totalMinutes,
      int? totalNotifications,
      String? type}) {
    return Timeline(
        duration: duration ?? this.duration,
        schedule: schedule ?? this.schedule,
        assessments: assessments ?? this.assessments,
        sessions: sessions ?? this.sessions,
        studyBursts: studyBursts ?? this.studyBursts,
        totalMinutes: totalMinutes ?? this.totalMinutes,
        totalNotifications: totalNotifications ?? this.totalNotifications,
        type: type ?? this.type);
  }

  Timeline copyWithWrapped(
      {Wrapped<String?>? duration,
      Wrapped<List<ScheduledSession>?>? schedule,
      Wrapped<List<AssessmentInfo>?>? assessments,
      Wrapped<List<SessionInfo>?>? sessions,
      Wrapped<List<StudyBurstInfo>?>? studyBursts,
      Wrapped<int?>? totalMinutes,
      Wrapped<int?>? totalNotifications,
      Wrapped<String?>? type}) {
    return Timeline(
        duration: (duration != null ? duration.value : this.duration),
        schedule: (schedule != null ? schedule.value : this.schedule),
        assessments:
            (assessments != null ? assessments.value : this.assessments),
        sessions: (sessions != null ? sessions.value : this.sessions),
        studyBursts:
            (studyBursts != null ? studyBursts.value : this.studyBursts),
        totalMinutes:
            (totalMinutes != null ? totalMinutes.value : this.totalMinutes),
        totalNotifications: (totalNotifications != null
            ? totalNotifications.value
            : this.totalNotifications),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class TimeWindow {
  TimeWindow({
    this.guid,
    required this.startTime,
    this.expiration,
    this.persistent,
    this.type,
  });

  factory TimeWindow.fromJson(Map<String, dynamic> json) =>
      _$TimeWindowFromJson(json);

  @JsonKey(name: 'guid', includeIfNull: false, defaultValue: '')
  final String? guid;
  @JsonKey(name: 'startTime', includeIfNull: false, defaultValue: '')
  final String startTime;
  @JsonKey(name: 'expiration', includeIfNull: false, defaultValue: '')
  final String? expiration;
  @JsonKey(name: 'persistent', includeIfNull: false)
  final bool? persistent;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$TimeWindowFromJson;
  static const toJsonFactory = _$TimeWindowToJson;
  Map<String, dynamic> toJson() => _$TimeWindowToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TimeWindow &&
            (identical(other.guid, guid) ||
                const DeepCollectionEquality().equals(other.guid, guid)) &&
            (identical(other.startTime, startTime) ||
                const DeepCollectionEquality()
                    .equals(other.startTime, startTime)) &&
            (identical(other.expiration, expiration) ||
                const DeepCollectionEquality()
                    .equals(other.expiration, expiration)) &&
            (identical(other.persistent, persistent) ||
                const DeepCollectionEquality()
                    .equals(other.persistent, persistent)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(guid) ^
      const DeepCollectionEquality().hash(startTime) ^
      const DeepCollectionEquality().hash(expiration) ^
      const DeepCollectionEquality().hash(persistent) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $TimeWindowExtension on TimeWindow {
  TimeWindow copyWith(
      {String? guid,
      String? startTime,
      String? expiration,
      bool? persistent,
      String? type}) {
    return TimeWindow(
        guid: guid ?? this.guid,
        startTime: startTime ?? this.startTime,
        expiration: expiration ?? this.expiration,
        persistent: persistent ?? this.persistent,
        type: type ?? this.type);
  }

  TimeWindow copyWithWrapped(
      {Wrapped<String?>? guid,
      Wrapped<String>? startTime,
      Wrapped<String?>? expiration,
      Wrapped<bool?>? persistent,
      Wrapped<String?>? type}) {
    return TimeWindow(
        guid: (guid != null ? guid.value : this.guid),
        startTime: (startTime != null ? startTime.value : this.startTime),
        expiration: (expiration != null ? expiration.value : this.expiration),
        persistent: (persistent != null ? persistent.value : this.persistent),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class DateTimeHolder {
  DateTimeHolder({
    this.dateTime,
    this.type,
  });

  factory DateTimeHolder.fromJson(Map<String, dynamic> json) =>
      _$DateTimeHolderFromJson(json);

  @JsonKey(name: 'dateTime', includeIfNull: false)
  final DateTime? dateTime;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$DateTimeHolderFromJson;
  static const toJsonFactory = _$DateTimeHolderToJson;
  Map<String, dynamic> toJson() => _$DateTimeHolderToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DateTimeHolder &&
            (identical(other.dateTime, dateTime) ||
                const DeepCollectionEquality()
                    .equals(other.dateTime, dateTime)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(dateTime) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $DateTimeHolderExtension on DateTimeHolder {
  DateTimeHolder copyWith({DateTime? dateTime, String? type}) {
    return DateTimeHolder(
        dateTime: dateTime ?? this.dateTime, type: type ?? this.type);
  }

  DateTimeHolder copyWithWrapped(
      {Wrapped<DateTime?>? dateTime, Wrapped<String?>? type}) {
    return DateTimeHolder(
        dateTime: (dateTime != null ? dateTime.value : this.dateTime),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Upload {
  Upload({
    required this.uploadId,
    this.encrypted,
    required this.schemaId,
    required this.schemaRevision,
    this.recordId,
    this.healthData,
    this.contentLength,
    this.contentMd5,
    this.contentType,
    this.filename,
    required this.status,
    required this.requestedOn,
    this.completedOn,
    this.completedBy,
    required this.validationMessageList,
    this.healthRecordExporterStatus,
    this.zipped,
    this.type,
  });

  factory Upload.fromJson(Map<String, dynamic> json) => _$UploadFromJson(json);

  @JsonKey(name: 'uploadId', includeIfNull: false, defaultValue: '')
  final String uploadId;
  @JsonKey(name: 'encrypted', includeIfNull: false)
  final bool? encrypted;
  @JsonKey(name: 'schemaId', includeIfNull: false, defaultValue: '')
  final String schemaId;
  @JsonKey(name: 'schemaRevision', includeIfNull: false)
  final num schemaRevision;
  @JsonKey(name: 'recordId', includeIfNull: false, defaultValue: '')
  final String? recordId;
  @JsonKey(name: 'healthData', includeIfNull: false)
  final HealthDataRecord? healthData;
  @JsonKey(name: 'contentLength', includeIfNull: false)
  final num? contentLength;
  @JsonKey(name: 'contentMd5', includeIfNull: false, defaultValue: '')
  final String? contentMd5;
  @JsonKey(name: 'contentType', includeIfNull: false, defaultValue: '')
  final String? contentType;
  @JsonKey(name: 'filename', includeIfNull: false, defaultValue: '')
  final String? filename;
  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: uploadStatusToJson,
    fromJson: uploadStatusFromJson,
  )
  final enums.UploadStatus status;
  @JsonKey(name: 'requestedOn', includeIfNull: false)
  final DateTime requestedOn;
  @JsonKey(name: 'completedOn', includeIfNull: false)
  final DateTime? completedOn;
  @JsonKey(
    name: 'completedBy',
    includeIfNull: false,
    toJson: uploadCompletedByToJson,
    fromJson: uploadCompletedByFromJson,
  )
  final enums.UploadCompletedBy? completedBy;
  @JsonKey(
      name: 'validationMessageList',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String> validationMessageList;
  @JsonKey(
    name: 'healthRecordExporterStatus',
    includeIfNull: false,
    toJson: synapseExporterStatusToJson,
    fromJson: synapseExporterStatusFromJson,
  )
  final enums.SynapseExporterStatus? healthRecordExporterStatus;
  @JsonKey(name: 'zipped', includeIfNull: false)
  final bool? zipped;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$UploadFromJson;
  static const toJsonFactory = _$UploadToJson;
  Map<String, dynamic> toJson() => _$UploadToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Upload &&
            (identical(other.uploadId, uploadId) ||
                const DeepCollectionEquality()
                    .equals(other.uploadId, uploadId)) &&
            (identical(other.encrypted, encrypted) ||
                const DeepCollectionEquality()
                    .equals(other.encrypted, encrypted)) &&
            (identical(other.schemaId, schemaId) ||
                const DeepCollectionEquality()
                    .equals(other.schemaId, schemaId)) &&
            (identical(other.schemaRevision, schemaRevision) ||
                const DeepCollectionEquality()
                    .equals(other.schemaRevision, schemaRevision)) &&
            (identical(other.recordId, recordId) ||
                const DeepCollectionEquality()
                    .equals(other.recordId, recordId)) &&
            (identical(other.healthData, healthData) ||
                const DeepCollectionEquality()
                    .equals(other.healthData, healthData)) &&
            (identical(other.contentLength, contentLength) ||
                const DeepCollectionEquality()
                    .equals(other.contentLength, contentLength)) &&
            (identical(other.contentMd5, contentMd5) ||
                const DeepCollectionEquality()
                    .equals(other.contentMd5, contentMd5)) &&
            (identical(other.contentType, contentType) ||
                const DeepCollectionEquality()
                    .equals(other.contentType, contentType)) &&
            (identical(other.filename, filename) ||
                const DeepCollectionEquality()
                    .equals(other.filename, filename)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.requestedOn, requestedOn) ||
                const DeepCollectionEquality()
                    .equals(other.requestedOn, requestedOn)) &&
            (identical(other.completedOn, completedOn) ||
                const DeepCollectionEquality()
                    .equals(other.completedOn, completedOn)) &&
            (identical(other.completedBy, completedBy) ||
                const DeepCollectionEquality()
                    .equals(other.completedBy, completedBy)) &&
            (identical(other.validationMessageList, validationMessageList) ||
                const DeepCollectionEquality().equals(
                    other.validationMessageList, validationMessageList)) &&
            (identical(other.healthRecordExporterStatus,
                    healthRecordExporterStatus) ||
                const DeepCollectionEquality().equals(
                    other.healthRecordExporterStatus,
                    healthRecordExporterStatus)) &&
            (identical(other.zipped, zipped) ||
                const DeepCollectionEquality().equals(other.zipped, zipped)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(uploadId) ^
      const DeepCollectionEquality().hash(encrypted) ^
      const DeepCollectionEquality().hash(schemaId) ^
      const DeepCollectionEquality().hash(schemaRevision) ^
      const DeepCollectionEquality().hash(recordId) ^
      const DeepCollectionEquality().hash(healthData) ^
      const DeepCollectionEquality().hash(contentLength) ^
      const DeepCollectionEquality().hash(contentMd5) ^
      const DeepCollectionEquality().hash(contentType) ^
      const DeepCollectionEquality().hash(filename) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(requestedOn) ^
      const DeepCollectionEquality().hash(completedOn) ^
      const DeepCollectionEquality().hash(completedBy) ^
      const DeepCollectionEquality().hash(validationMessageList) ^
      const DeepCollectionEquality().hash(healthRecordExporterStatus) ^
      const DeepCollectionEquality().hash(zipped) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $UploadExtension on Upload {
  Upload copyWith(
      {String? uploadId,
      bool? encrypted,
      String? schemaId,
      num? schemaRevision,
      String? recordId,
      HealthDataRecord? healthData,
      num? contentLength,
      String? contentMd5,
      String? contentType,
      String? filename,
      enums.UploadStatus? status,
      DateTime? requestedOn,
      DateTime? completedOn,
      enums.UploadCompletedBy? completedBy,
      List<String>? validationMessageList,
      enums.SynapseExporterStatus? healthRecordExporterStatus,
      bool? zipped,
      String? type}) {
    return Upload(
        uploadId: uploadId ?? this.uploadId,
        encrypted: encrypted ?? this.encrypted,
        schemaId: schemaId ?? this.schemaId,
        schemaRevision: schemaRevision ?? this.schemaRevision,
        recordId: recordId ?? this.recordId,
        healthData: healthData ?? this.healthData,
        contentLength: contentLength ?? this.contentLength,
        contentMd5: contentMd5 ?? this.contentMd5,
        contentType: contentType ?? this.contentType,
        filename: filename ?? this.filename,
        status: status ?? this.status,
        requestedOn: requestedOn ?? this.requestedOn,
        completedOn: completedOn ?? this.completedOn,
        completedBy: completedBy ?? this.completedBy,
        validationMessageList:
            validationMessageList ?? this.validationMessageList,
        healthRecordExporterStatus:
            healthRecordExporterStatus ?? this.healthRecordExporterStatus,
        zipped: zipped ?? this.zipped,
        type: type ?? this.type);
  }

  Upload copyWithWrapped(
      {Wrapped<String>? uploadId,
      Wrapped<bool?>? encrypted,
      Wrapped<String>? schemaId,
      Wrapped<num>? schemaRevision,
      Wrapped<String?>? recordId,
      Wrapped<HealthDataRecord?>? healthData,
      Wrapped<num?>? contentLength,
      Wrapped<String?>? contentMd5,
      Wrapped<String?>? contentType,
      Wrapped<String?>? filename,
      Wrapped<enums.UploadStatus>? status,
      Wrapped<DateTime>? requestedOn,
      Wrapped<DateTime?>? completedOn,
      Wrapped<enums.UploadCompletedBy?>? completedBy,
      Wrapped<List<String>>? validationMessageList,
      Wrapped<enums.SynapseExporterStatus?>? healthRecordExporterStatus,
      Wrapped<bool?>? zipped,
      Wrapped<String?>? type}) {
    return Upload(
        uploadId: (uploadId != null ? uploadId.value : this.uploadId),
        encrypted: (encrypted != null ? encrypted.value : this.encrypted),
        schemaId: (schemaId != null ? schemaId.value : this.schemaId),
        schemaRevision: (schemaRevision != null
            ? schemaRevision.value
            : this.schemaRevision),
        recordId: (recordId != null ? recordId.value : this.recordId),
        healthData: (healthData != null ? healthData.value : this.healthData),
        contentLength:
            (contentLength != null ? contentLength.value : this.contentLength),
        contentMd5: (contentMd5 != null ? contentMd5.value : this.contentMd5),
        contentType:
            (contentType != null ? contentType.value : this.contentType),
        filename: (filename != null ? filename.value : this.filename),
        status: (status != null ? status.value : this.status),
        requestedOn:
            (requestedOn != null ? requestedOn.value : this.requestedOn),
        completedOn:
            (completedOn != null ? completedOn.value : this.completedOn),
        completedBy:
            (completedBy != null ? completedBy.value : this.completedBy),
        validationMessageList: (validationMessageList != null
            ? validationMessageList.value
            : this.validationMessageList),
        healthRecordExporterStatus: (healthRecordExporterStatus != null
            ? healthRecordExporterStatus.value
            : this.healthRecordExporterStatus),
        zipped: (zipped != null ? zipped.value : this.zipped),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class UploadFieldDefinition {
  UploadFieldDefinition({
    required this.name,
    this.required,
    required this.type,
    this.allowOtherChoices,
    this.fileExtension,
    this.mimeType,
    this.maxLength,
    required this.multiChoiceAnswerList,
    this.unboundedText,
  });

  factory UploadFieldDefinition.fromJson(Map<String, dynamic> json) =>
      _$UploadFieldDefinitionFromJson(json);

  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'required', includeIfNull: false, defaultValue: true)
  final bool? required;
  @JsonKey(
    name: 'type',
    includeIfNull: false,
    toJson: uploadFieldTypeToJson,
    fromJson: uploadFieldTypeFromJson,
  )
  final enums.UploadFieldType type;
  @JsonKey(name: 'allowOtherChoices', includeIfNull: false)
  final bool? allowOtherChoices;
  @JsonKey(name: 'fileExtension', includeIfNull: false, defaultValue: '')
  final String? fileExtension;
  @JsonKey(name: 'mimeType', includeIfNull: false, defaultValue: '')
  final String? mimeType;
  @JsonKey(name: 'maxLength', includeIfNull: false)
  final int? maxLength;
  @JsonKey(
      name: 'multiChoiceAnswerList',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String> multiChoiceAnswerList;
  @JsonKey(name: 'unboundedText', includeIfNull: false)
  final bool? unboundedText;
  static const fromJsonFactory = _$UploadFieldDefinitionFromJson;
  static const toJsonFactory = _$UploadFieldDefinitionToJson;
  Map<String, dynamic> toJson() => _$UploadFieldDefinitionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UploadFieldDefinition &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.allowOtherChoices, allowOtherChoices) ||
                const DeepCollectionEquality()
                    .equals(other.allowOtherChoices, allowOtherChoices)) &&
            (identical(other.fileExtension, fileExtension) ||
                const DeepCollectionEquality()
                    .equals(other.fileExtension, fileExtension)) &&
            (identical(other.mimeType, mimeType) ||
                const DeepCollectionEquality()
                    .equals(other.mimeType, mimeType)) &&
            (identical(other.maxLength, maxLength) ||
                const DeepCollectionEquality()
                    .equals(other.maxLength, maxLength)) &&
            (identical(other.multiChoiceAnswerList, multiChoiceAnswerList) ||
                const DeepCollectionEquality().equals(
                    other.multiChoiceAnswerList, multiChoiceAnswerList)) &&
            (identical(other.unboundedText, unboundedText) ||
                const DeepCollectionEquality()
                    .equals(other.unboundedText, unboundedText)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(allowOtherChoices) ^
      const DeepCollectionEquality().hash(fileExtension) ^
      const DeepCollectionEquality().hash(mimeType) ^
      const DeepCollectionEquality().hash(maxLength) ^
      const DeepCollectionEquality().hash(multiChoiceAnswerList) ^
      const DeepCollectionEquality().hash(unboundedText) ^
      runtimeType.hashCode;
}

extension $UploadFieldDefinitionExtension on UploadFieldDefinition {
  UploadFieldDefinition copyWith(
      {String? name,
      bool? required,
      enums.UploadFieldType? type,
      bool? allowOtherChoices,
      String? fileExtension,
      String? mimeType,
      int? maxLength,
      List<String>? multiChoiceAnswerList,
      bool? unboundedText}) {
    return UploadFieldDefinition(
        name: name ?? this.name,
        required: required ?? this.required,
        type: type ?? this.type,
        allowOtherChoices: allowOtherChoices ?? this.allowOtherChoices,
        fileExtension: fileExtension ?? this.fileExtension,
        mimeType: mimeType ?? this.mimeType,
        maxLength: maxLength ?? this.maxLength,
        multiChoiceAnswerList:
            multiChoiceAnswerList ?? this.multiChoiceAnswerList,
        unboundedText: unboundedText ?? this.unboundedText);
  }

  UploadFieldDefinition copyWithWrapped(
      {Wrapped<String>? name,
      Wrapped<bool?>? required,
      Wrapped<enums.UploadFieldType>? type,
      Wrapped<bool?>? allowOtherChoices,
      Wrapped<String?>? fileExtension,
      Wrapped<String?>? mimeType,
      Wrapped<int?>? maxLength,
      Wrapped<List<String>>? multiChoiceAnswerList,
      Wrapped<bool?>? unboundedText}) {
    return UploadFieldDefinition(
        name: (name != null ? name.value : this.name),
        required: (required != null ? required.value : this.required),
        type: (type != null ? type.value : this.type),
        allowOtherChoices: (allowOtherChoices != null
            ? allowOtherChoices.value
            : this.allowOtherChoices),
        fileExtension:
            (fileExtension != null ? fileExtension.value : this.fileExtension),
        mimeType: (mimeType != null ? mimeType.value : this.mimeType),
        maxLength: (maxLength != null ? maxLength.value : this.maxLength),
        multiChoiceAnswerList: (multiChoiceAnswerList != null
            ? multiChoiceAnswerList.value
            : this.multiChoiceAnswerList),
        unboundedText:
            (unboundedText != null ? unboundedText.value : this.unboundedText));
  }
}

@JsonSerializable(explicitToJson: true)
class UploadRequest {
  UploadRequest({
    required this.name,
    required this.contentLength,
    required this.contentMd5,
    required this.contentType,
    this.encrypted,
    this.metadata,
    this.zipped,
    this.type,
  });

  factory UploadRequest.fromJson(Map<String, dynamic> json) =>
      _$UploadRequestFromJson(json);

  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'contentLength', includeIfNull: false)
  final num contentLength;
  @JsonKey(name: 'contentMd5', includeIfNull: false, defaultValue: '')
  final String contentMd5;
  @JsonKey(name: 'contentType', includeIfNull: false, defaultValue: '')
  final String contentType;
  @JsonKey(name: 'encrypted', includeIfNull: false, defaultValue: true)
  final bool? encrypted;
  @JsonKey(name: 'metadata', includeIfNull: false)
  final Map<String, dynamic>? metadata;
  @JsonKey(name: 'zipped', includeIfNull: false, defaultValue: true)
  final bool? zipped;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$UploadRequestFromJson;
  static const toJsonFactory = _$UploadRequestToJson;
  Map<String, dynamic> toJson() => _$UploadRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UploadRequest &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.contentLength, contentLength) ||
                const DeepCollectionEquality()
                    .equals(other.contentLength, contentLength)) &&
            (identical(other.contentMd5, contentMd5) ||
                const DeepCollectionEquality()
                    .equals(other.contentMd5, contentMd5)) &&
            (identical(other.contentType, contentType) ||
                const DeepCollectionEquality()
                    .equals(other.contentType, contentType)) &&
            (identical(other.encrypted, encrypted) ||
                const DeepCollectionEquality()
                    .equals(other.encrypted, encrypted)) &&
            (identical(other.metadata, metadata) ||
                const DeepCollectionEquality()
                    .equals(other.metadata, metadata)) &&
            (identical(other.zipped, zipped) ||
                const DeepCollectionEquality().equals(other.zipped, zipped)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(contentLength) ^
      const DeepCollectionEquality().hash(contentMd5) ^
      const DeepCollectionEquality().hash(contentType) ^
      const DeepCollectionEquality().hash(encrypted) ^
      const DeepCollectionEquality().hash(metadata) ^
      const DeepCollectionEquality().hash(zipped) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $UploadRequestExtension on UploadRequest {
  UploadRequest copyWith(
      {String? name,
      num? contentLength,
      String? contentMd5,
      String? contentType,
      bool? encrypted,
      Map<String, dynamic>? metadata,
      bool? zipped,
      String? type}) {
    return UploadRequest(
        name: name ?? this.name,
        contentLength: contentLength ?? this.contentLength,
        contentMd5: contentMd5 ?? this.contentMd5,
        contentType: contentType ?? this.contentType,
        encrypted: encrypted ?? this.encrypted,
        metadata: metadata ?? this.metadata,
        zipped: zipped ?? this.zipped,
        type: type ?? this.type);
  }

  UploadRequest copyWithWrapped(
      {Wrapped<String>? name,
      Wrapped<num>? contentLength,
      Wrapped<String>? contentMd5,
      Wrapped<String>? contentType,
      Wrapped<bool?>? encrypted,
      Wrapped<Map<String, dynamic>?>? metadata,
      Wrapped<bool?>? zipped,
      Wrapped<String?>? type}) {
    return UploadRequest(
        name: (name != null ? name.value : this.name),
        contentLength:
            (contentLength != null ? contentLength.value : this.contentLength),
        contentMd5: (contentMd5 != null ? contentMd5.value : this.contentMd5),
        contentType:
            (contentType != null ? contentType.value : this.contentType),
        encrypted: (encrypted != null ? encrypted.value : this.encrypted),
        metadata: (metadata != null ? metadata.value : this.metadata),
        zipped: (zipped != null ? zipped.value : this.zipped),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class UploadSchema {
  UploadSchema({
    this.maxAppVersions,
    this.minAppVersions,
    this.moduleId,
    this.moduleVersion,
    required this.name,
    required this.revision,
    required this.schemaId,
    this.surveyGuid,
    this.appId,
    this.surveyCreatedOn,
    this.schemaType,
    this.deleted,
    required this.version,
    required this.fieldDefinitions,
    this.type,
  });

  factory UploadSchema.fromJson(Map<String, dynamic> json) =>
      _$UploadSchemaFromJson(json);

  @JsonKey(name: 'maxAppVersions', includeIfNull: false)
  final Map<String, dynamic>? maxAppVersions;
  @JsonKey(name: 'minAppVersions', includeIfNull: false)
  final Map<String, dynamic>? minAppVersions;
  @JsonKey(name: 'moduleId', includeIfNull: false, defaultValue: '')
  final String? moduleId;
  @JsonKey(name: 'moduleVersion', includeIfNull: false)
  final int? moduleVersion;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String name;
  @JsonKey(name: 'revision', includeIfNull: false)
  final num revision;
  @JsonKey(name: 'schemaId', includeIfNull: false, defaultValue: '')
  final String schemaId;
  @JsonKey(name: 'surveyGuid', includeIfNull: false, defaultValue: '')
  final String? surveyGuid;
  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String? appId;
  @JsonKey(name: 'surveyCreatedOn', includeIfNull: false)
  final DateTime? surveyCreatedOn;
  @JsonKey(
    name: 'schemaType',
    includeIfNull: false,
    toJson: uploadSchemaTypeToJson,
    fromJson: uploadSchemaTypeFromJson,
  )
  final enums.UploadSchemaType? schemaType;
  @JsonKey(name: 'deleted', includeIfNull: false)
  final bool? deleted;
  @JsonKey(name: 'version', includeIfNull: false)
  final num version;
  @JsonKey(
      name: 'fieldDefinitions',
      includeIfNull: false,
      defaultValue: <UploadFieldDefinition>[])
  final List<UploadFieldDefinition> fieldDefinitions;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$UploadSchemaFromJson;
  static const toJsonFactory = _$UploadSchemaToJson;
  Map<String, dynamic> toJson() => _$UploadSchemaToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UploadSchema &&
            (identical(other.maxAppVersions, maxAppVersions) ||
                const DeepCollectionEquality()
                    .equals(other.maxAppVersions, maxAppVersions)) &&
            (identical(other.minAppVersions, minAppVersions) ||
                const DeepCollectionEquality()
                    .equals(other.minAppVersions, minAppVersions)) &&
            (identical(other.moduleId, moduleId) ||
                const DeepCollectionEquality()
                    .equals(other.moduleId, moduleId)) &&
            (identical(other.moduleVersion, moduleVersion) ||
                const DeepCollectionEquality()
                    .equals(other.moduleVersion, moduleVersion)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.revision, revision) ||
                const DeepCollectionEquality()
                    .equals(other.revision, revision)) &&
            (identical(other.schemaId, schemaId) ||
                const DeepCollectionEquality()
                    .equals(other.schemaId, schemaId)) &&
            (identical(other.surveyGuid, surveyGuid) ||
                const DeepCollectionEquality()
                    .equals(other.surveyGuid, surveyGuid)) &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)) &&
            (identical(other.surveyCreatedOn, surveyCreatedOn) ||
                const DeepCollectionEquality()
                    .equals(other.surveyCreatedOn, surveyCreatedOn)) &&
            (identical(other.schemaType, schemaType) ||
                const DeepCollectionEquality()
                    .equals(other.schemaType, schemaType)) &&
            (identical(other.deleted, deleted) ||
                const DeepCollectionEquality()
                    .equals(other.deleted, deleted)) &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.fieldDefinitions, fieldDefinitions) ||
                const DeepCollectionEquality()
                    .equals(other.fieldDefinitions, fieldDefinitions)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(maxAppVersions) ^
      const DeepCollectionEquality().hash(minAppVersions) ^
      const DeepCollectionEquality().hash(moduleId) ^
      const DeepCollectionEquality().hash(moduleVersion) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(revision) ^
      const DeepCollectionEquality().hash(schemaId) ^
      const DeepCollectionEquality().hash(surveyGuid) ^
      const DeepCollectionEquality().hash(appId) ^
      const DeepCollectionEquality().hash(surveyCreatedOn) ^
      const DeepCollectionEquality().hash(schemaType) ^
      const DeepCollectionEquality().hash(deleted) ^
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(fieldDefinitions) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $UploadSchemaExtension on UploadSchema {
  UploadSchema copyWith(
      {Map<String, dynamic>? maxAppVersions,
      Map<String, dynamic>? minAppVersions,
      String? moduleId,
      int? moduleVersion,
      String? name,
      num? revision,
      String? schemaId,
      String? surveyGuid,
      String? appId,
      DateTime? surveyCreatedOn,
      enums.UploadSchemaType? schemaType,
      bool? deleted,
      num? version,
      List<UploadFieldDefinition>? fieldDefinitions,
      String? type}) {
    return UploadSchema(
        maxAppVersions: maxAppVersions ?? this.maxAppVersions,
        minAppVersions: minAppVersions ?? this.minAppVersions,
        moduleId: moduleId ?? this.moduleId,
        moduleVersion: moduleVersion ?? this.moduleVersion,
        name: name ?? this.name,
        revision: revision ?? this.revision,
        schemaId: schemaId ?? this.schemaId,
        surveyGuid: surveyGuid ?? this.surveyGuid,
        appId: appId ?? this.appId,
        surveyCreatedOn: surveyCreatedOn ?? this.surveyCreatedOn,
        schemaType: schemaType ?? this.schemaType,
        deleted: deleted ?? this.deleted,
        version: version ?? this.version,
        fieldDefinitions: fieldDefinitions ?? this.fieldDefinitions,
        type: type ?? this.type);
  }

  UploadSchema copyWithWrapped(
      {Wrapped<Map<String, dynamic>?>? maxAppVersions,
      Wrapped<Map<String, dynamic>?>? minAppVersions,
      Wrapped<String?>? moduleId,
      Wrapped<int?>? moduleVersion,
      Wrapped<String>? name,
      Wrapped<num>? revision,
      Wrapped<String>? schemaId,
      Wrapped<String?>? surveyGuid,
      Wrapped<String?>? appId,
      Wrapped<DateTime?>? surveyCreatedOn,
      Wrapped<enums.UploadSchemaType?>? schemaType,
      Wrapped<bool?>? deleted,
      Wrapped<num>? version,
      Wrapped<List<UploadFieldDefinition>>? fieldDefinitions,
      Wrapped<String?>? type}) {
    return UploadSchema(
        maxAppVersions: (maxAppVersions != null
            ? maxAppVersions.value
            : this.maxAppVersions),
        minAppVersions: (minAppVersions != null
            ? minAppVersions.value
            : this.minAppVersions),
        moduleId: (moduleId != null ? moduleId.value : this.moduleId),
        moduleVersion:
            (moduleVersion != null ? moduleVersion.value : this.moduleVersion),
        name: (name != null ? name.value : this.name),
        revision: (revision != null ? revision.value : this.revision),
        schemaId: (schemaId != null ? schemaId.value : this.schemaId),
        surveyGuid: (surveyGuid != null ? surveyGuid.value : this.surveyGuid),
        appId: (appId != null ? appId.value : this.appId),
        surveyCreatedOn: (surveyCreatedOn != null
            ? surveyCreatedOn.value
            : this.surveyCreatedOn),
        schemaType: (schemaType != null ? schemaType.value : this.schemaType),
        deleted: (deleted != null ? deleted.value : this.deleted),
        version: (version != null ? version.value : this.version),
        fieldDefinitions: (fieldDefinitions != null
            ? fieldDefinitions.value
            : this.fieldDefinitions),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class UploadSession {
  UploadSession({
    this.id,
    this.url,
    this.expires,
    this.type,
  });

  factory UploadSession.fromJson(Map<String, dynamic> json) =>
      _$UploadSessionFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'url', includeIfNull: false, defaultValue: '')
  final String? url;
  @JsonKey(name: 'expires', includeIfNull: false)
  final DateTime? expires;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$UploadSessionFromJson;
  static const toJsonFactory = _$UploadSessionToJson;
  Map<String, dynamic> toJson() => _$UploadSessionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UploadSession &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.url, url) ||
                const DeepCollectionEquality().equals(other.url, url)) &&
            (identical(other.expires, expires) ||
                const DeepCollectionEquality()
                    .equals(other.expires, expires)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(url) ^
      const DeepCollectionEquality().hash(expires) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $UploadSessionExtension on UploadSession {
  UploadSession copyWith(
      {String? id, String? url, DateTime? expires, String? type}) {
    return UploadSession(
        id: id ?? this.id,
        url: url ?? this.url,
        expires: expires ?? this.expires,
        type: type ?? this.type);
  }

  UploadSession copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? url,
      Wrapped<DateTime?>? expires,
      Wrapped<String?>? type}) {
    return UploadSession(
        id: (id != null ? id.value : this.id),
        url: (url != null ? url.value : this.url),
        expires: (expires != null ? expires.value : this.expires),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class UploadValidationStatus {
  UploadValidationStatus({
    this.id,
    this.messageList,
    this.status,
    this.record,
    this.type,
  });

  factory UploadValidationStatus.fromJson(Map<String, dynamic> json) =>
      _$UploadValidationStatusFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'messageList', includeIfNull: false, defaultValue: <String>[])
  final List<String>? messageList;
  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: uploadStatusToJson,
    fromJson: uploadStatusFromJson,
  )
  final enums.UploadStatus? status;
  @JsonKey(name: 'record', includeIfNull: false)
  final HealthDataRecord? record;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$UploadValidationStatusFromJson;
  static const toJsonFactory = _$UploadValidationStatusToJson;
  Map<String, dynamic> toJson() => _$UploadValidationStatusToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UploadValidationStatus &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.messageList, messageList) ||
                const DeepCollectionEquality()
                    .equals(other.messageList, messageList)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.record, record) ||
                const DeepCollectionEquality().equals(other.record, record)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(messageList) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(record) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $UploadValidationStatusExtension on UploadValidationStatus {
  UploadValidationStatus copyWith(
      {String? id,
      List<String>? messageList,
      enums.UploadStatus? status,
      HealthDataRecord? record,
      String? type}) {
    return UploadValidationStatus(
        id: id ?? this.id,
        messageList: messageList ?? this.messageList,
        status: status ?? this.status,
        record: record ?? this.record,
        type: type ?? this.type);
  }

  UploadValidationStatus copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<List<String>?>? messageList,
      Wrapped<enums.UploadStatus?>? status,
      Wrapped<HealthDataRecord?>? record,
      Wrapped<String?>? type}) {
    return UploadValidationStatus(
        id: (id != null ? id.value : this.id),
        messageList:
            (messageList != null ? messageList.value : this.messageList),
        status: (status != null ? status.value : this.status),
        record: (record != null ? record.value : this.record),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class UserConsentHistory {
  UserConsentHistory({
    this.subpopulationGuid,
    this.consentCreatedOn,
    this.name,
    this.birthdate,
    this.imageData,
    this.imageMimeType,
    this.signedOn,
    this.withdrewOn,
    this.hasSignedActiveConsent,
    this.type,
  });

  factory UserConsentHistory.fromJson(Map<String, dynamic> json) =>
      _$UserConsentHistoryFromJson(json);

  @JsonKey(name: 'subpopulationGuid', includeIfNull: false, defaultValue: '')
  final String? subpopulationGuid;
  @JsonKey(name: 'consentCreatedOn', includeIfNull: false)
  final DateTime? consentCreatedOn;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'birthdate', includeIfNull: false, toJson: _dateToJson)
  final DateTime? birthdate;
  @JsonKey(name: 'imageData', includeIfNull: false, defaultValue: '')
  final String? imageData;
  @JsonKey(name: 'imageMimeType', includeIfNull: false, defaultValue: '')
  final String? imageMimeType;
  @JsonKey(name: 'signedOn', includeIfNull: false)
  final DateTime? signedOn;
  @JsonKey(name: 'withdrewOn', includeIfNull: false)
  final DateTime? withdrewOn;
  @JsonKey(name: 'hasSignedActiveConsent', includeIfNull: false)
  final bool? hasSignedActiveConsent;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$UserConsentHistoryFromJson;
  static const toJsonFactory = _$UserConsentHistoryToJson;
  Map<String, dynamic> toJson() => _$UserConsentHistoryToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserConsentHistory &&
            (identical(other.subpopulationGuid, subpopulationGuid) ||
                const DeepCollectionEquality()
                    .equals(other.subpopulationGuid, subpopulationGuid)) &&
            (identical(other.consentCreatedOn, consentCreatedOn) ||
                const DeepCollectionEquality()
                    .equals(other.consentCreatedOn, consentCreatedOn)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.birthdate, birthdate) ||
                const DeepCollectionEquality()
                    .equals(other.birthdate, birthdate)) &&
            (identical(other.imageData, imageData) ||
                const DeepCollectionEquality()
                    .equals(other.imageData, imageData)) &&
            (identical(other.imageMimeType, imageMimeType) ||
                const DeepCollectionEquality()
                    .equals(other.imageMimeType, imageMimeType)) &&
            (identical(other.signedOn, signedOn) ||
                const DeepCollectionEquality()
                    .equals(other.signedOn, signedOn)) &&
            (identical(other.withdrewOn, withdrewOn) ||
                const DeepCollectionEquality()
                    .equals(other.withdrewOn, withdrewOn)) &&
            (identical(other.hasSignedActiveConsent, hasSignedActiveConsent) ||
                const DeepCollectionEquality().equals(
                    other.hasSignedActiveConsent, hasSignedActiveConsent)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(subpopulationGuid) ^
      const DeepCollectionEquality().hash(consentCreatedOn) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(birthdate) ^
      const DeepCollectionEquality().hash(imageData) ^
      const DeepCollectionEquality().hash(imageMimeType) ^
      const DeepCollectionEquality().hash(signedOn) ^
      const DeepCollectionEquality().hash(withdrewOn) ^
      const DeepCollectionEquality().hash(hasSignedActiveConsent) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $UserConsentHistoryExtension on UserConsentHistory {
  UserConsentHistory copyWith(
      {String? subpopulationGuid,
      DateTime? consentCreatedOn,
      String? name,
      DateTime? birthdate,
      String? imageData,
      String? imageMimeType,
      DateTime? signedOn,
      DateTime? withdrewOn,
      bool? hasSignedActiveConsent,
      String? type}) {
    return UserConsentHistory(
        subpopulationGuid: subpopulationGuid ?? this.subpopulationGuid,
        consentCreatedOn: consentCreatedOn ?? this.consentCreatedOn,
        name: name ?? this.name,
        birthdate: birthdate ?? this.birthdate,
        imageData: imageData ?? this.imageData,
        imageMimeType: imageMimeType ?? this.imageMimeType,
        signedOn: signedOn ?? this.signedOn,
        withdrewOn: withdrewOn ?? this.withdrewOn,
        hasSignedActiveConsent:
            hasSignedActiveConsent ?? this.hasSignedActiveConsent,
        type: type ?? this.type);
  }

  UserConsentHistory copyWithWrapped(
      {Wrapped<String?>? subpopulationGuid,
      Wrapped<DateTime?>? consentCreatedOn,
      Wrapped<String?>? name,
      Wrapped<DateTime?>? birthdate,
      Wrapped<String?>? imageData,
      Wrapped<String?>? imageMimeType,
      Wrapped<DateTime?>? signedOn,
      Wrapped<DateTime?>? withdrewOn,
      Wrapped<bool?>? hasSignedActiveConsent,
      Wrapped<String?>? type}) {
    return UserConsentHistory(
        subpopulationGuid: (subpopulationGuid != null
            ? subpopulationGuid.value
            : this.subpopulationGuid),
        consentCreatedOn: (consentCreatedOn != null
            ? consentCreatedOn.value
            : this.consentCreatedOn),
        name: (name != null ? name.value : this.name),
        birthdate: (birthdate != null ? birthdate.value : this.birthdate),
        imageData: (imageData != null ? imageData.value : this.imageData),
        imageMimeType:
            (imageMimeType != null ? imageMimeType.value : this.imageMimeType),
        signedOn: (signedOn != null ? signedOn.value : this.signedOn),
        withdrewOn: (withdrewOn != null ? withdrewOn.value : this.withdrewOn),
        hasSignedActiveConsent: (hasSignedActiveConsent != null
            ? hasSignedActiveConsent.value
            : this.hasSignedActiveConsent),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class UserSessionInfo {
  UserSessionInfo({
    this.firstName,
    this.lastName,
    this.externalId,
    this.id,
    this.notifyByEmail,
    this.attributes,
    this.sharingScope,
    this.createdOn,
    this.emailVerified,
    this.phoneVerified,
    this.status,
    this.roles,
    this.dataGroups,
    this.clientData,
    this.languages,
    this.studyIds,
    this.externalIds,
    this.authenticated,
    this.sessionToken,
    this.reauthToken,
    this.environment,
    this.email,
    this.phone,
    this.dataSharing,
    this.signedMostRecentConsent,
    this.synapseUserId,
    this.consented,
    this.consentStatuses,
    this.enrollments,
    this.orgMembership,
    this.type,
  });

  factory UserSessionInfo.fromJson(Map<String, dynamic> json) =>
      _$UserSessionInfoFromJson(json);

  @JsonKey(name: 'firstName', includeIfNull: false, defaultValue: '')
  final String? firstName;
  @JsonKey(name: 'lastName', includeIfNull: false, defaultValue: '')
  final String? lastName;
  @JsonKey(name: 'externalId', includeIfNull: false, defaultValue: '')
  final String? externalId;
  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'notifyByEmail', includeIfNull: false, defaultValue: true)
  final bool? notifyByEmail;
  @JsonKey(name: 'attributes', includeIfNull: false)
  final Map<String, dynamic>? attributes;
  @JsonKey(
    name: 'sharingScope',
    includeIfNull: false,
    toJson: sharingScopeToJson,
    fromJson: sharingScopeFromJson,
  )
  final enums.SharingScope? sharingScope;
  @JsonKey(name: 'createdOn', includeIfNull: false)
  final DateTime? createdOn;
  @JsonKey(name: 'emailVerified', includeIfNull: false)
  final bool? emailVerified;
  @JsonKey(name: 'phoneVerified', includeIfNull: false)
  final bool? phoneVerified;
  @JsonKey(
    name: 'status',
    includeIfNull: false,
    toJson: accountStatusToJson,
    fromJson: accountStatusFromJson,
  )
  final enums.AccountStatus? status;
  @JsonKey(
    name: 'roles',
    includeIfNull: false,
    toJson: roleListToJson,
    fromJson: roleListFromJson,
  )
  final List<enums.Role>? roles;
  @JsonKey(name: 'dataGroups', includeIfNull: false, defaultValue: <String>[])
  final List<String>? dataGroups;
  @JsonKey(name: 'clientData', includeIfNull: false)
  final Map<String, dynamic>? clientData;
  @JsonKey(name: 'languages', includeIfNull: false, defaultValue: <String>[])
  final List<String>? languages;
  @JsonKey(name: 'studyIds', includeIfNull: false, defaultValue: <String>[])
  final List<String>? studyIds;
  @JsonKey(name: 'externalIds', includeIfNull: false)
  final Map<String, dynamic>? externalIds;
  @JsonKey(name: 'authenticated', includeIfNull: false)
  final bool? authenticated;
  @JsonKey(name: 'sessionToken', includeIfNull: false, defaultValue: '')
  final String? sessionToken;
  @JsonKey(name: 'reauthToken', includeIfNull: false, defaultValue: '')
  final String? reauthToken;
  @JsonKey(
    name: 'environment',
    includeIfNull: false,
    toJson: environmentToJson,
    fromJson: environmentFromJson,
  )
  final enums.Environment? environment;
  @JsonKey(name: 'email', includeIfNull: false, defaultValue: '')
  final String? email;
  @JsonKey(name: 'phone', includeIfNull: false)
  final Phone? phone;
  @JsonKey(name: 'dataSharing', includeIfNull: false)
  final bool? dataSharing;
  @JsonKey(name: 'signedMostRecentConsent', includeIfNull: false)
  final bool? signedMostRecentConsent;
  @JsonKey(name: 'synapseUserId', includeIfNull: false, defaultValue: '')
  final String? synapseUserId;
  @JsonKey(name: 'consented', includeIfNull: false)
  final bool? consented;
  @JsonKey(name: 'consentStatuses', includeIfNull: false)
  final Map<String, dynamic>? consentStatuses;
  @JsonKey(name: 'enrollments', includeIfNull: false)
  final Map<String, dynamic>? enrollments;
  @JsonKey(name: 'orgMembership', includeIfNull: false, defaultValue: '')
  final String? orgMembership;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$UserSessionInfoFromJson;
  static const toJsonFactory = _$UserSessionInfoToJson;
  Map<String, dynamic> toJson() => _$UserSessionInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UserSessionInfo &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.lastName, lastName) ||
                const DeepCollectionEquality()
                    .equals(other.lastName, lastName)) &&
            (identical(other.externalId, externalId) ||
                const DeepCollectionEquality()
                    .equals(other.externalId, externalId)) &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.notifyByEmail, notifyByEmail) ||
                const DeepCollectionEquality()
                    .equals(other.notifyByEmail, notifyByEmail)) &&
            (identical(other.attributes, attributes) ||
                const DeepCollectionEquality()
                    .equals(other.attributes, attributes)) &&
            (identical(other.sharingScope, sharingScope) ||
                const DeepCollectionEquality()
                    .equals(other.sharingScope, sharingScope)) &&
            (identical(other.createdOn, createdOn) ||
                const DeepCollectionEquality()
                    .equals(other.createdOn, createdOn)) &&
            (identical(other.emailVerified, emailVerified) ||
                const DeepCollectionEquality()
                    .equals(other.emailVerified, emailVerified)) &&
            (identical(other.phoneVerified, phoneVerified) ||
                const DeepCollectionEquality()
                    .equals(other.phoneVerified, phoneVerified)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.roles, roles) ||
                const DeepCollectionEquality().equals(other.roles, roles)) &&
            (identical(other.dataGroups, dataGroups) ||
                const DeepCollectionEquality()
                    .equals(other.dataGroups, dataGroups)) &&
            (identical(other.clientData, clientData) ||
                const DeepCollectionEquality()
                    .equals(other.clientData, clientData)) &&
            (identical(other.languages, languages) ||
                const DeepCollectionEquality()
                    .equals(other.languages, languages)) &&
            (identical(other.studyIds, studyIds) ||
                const DeepCollectionEquality()
                    .equals(other.studyIds, studyIds)) &&
            (identical(other.externalIds, externalIds) ||
                const DeepCollectionEquality()
                    .equals(other.externalIds, externalIds)) &&
            (identical(other.authenticated, authenticated) ||
                const DeepCollectionEquality()
                    .equals(other.authenticated, authenticated)) &&
            (identical(other.sessionToken, sessionToken) ||
                const DeepCollectionEquality()
                    .equals(other.sessionToken, sessionToken)) &&
            (identical(other.reauthToken, reauthToken) ||
                const DeepCollectionEquality()
                    .equals(other.reauthToken, reauthToken)) &&
            (identical(other.environment, environment) ||
                const DeepCollectionEquality()
                    .equals(other.environment, environment)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.dataSharing, dataSharing) ||
                const DeepCollectionEquality()
                    .equals(other.dataSharing, dataSharing)) &&
            (identical(other.signedMostRecentConsent, signedMostRecentConsent) || const DeepCollectionEquality().equals(other.signedMostRecentConsent, signedMostRecentConsent)) &&
            (identical(other.synapseUserId, synapseUserId) || const DeepCollectionEquality().equals(other.synapseUserId, synapseUserId)) &&
            (identical(other.consented, consented) || const DeepCollectionEquality().equals(other.consented, consented)) &&
            (identical(other.consentStatuses, consentStatuses) || const DeepCollectionEquality().equals(other.consentStatuses, consentStatuses)) &&
            (identical(other.enrollments, enrollments) || const DeepCollectionEquality().equals(other.enrollments, enrollments)) &&
            (identical(other.orgMembership, orgMembership) || const DeepCollectionEquality().equals(other.orgMembership, orgMembership)) &&
            (identical(other.type, type) || const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(firstName) ^
      const DeepCollectionEquality().hash(lastName) ^
      const DeepCollectionEquality().hash(externalId) ^
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(notifyByEmail) ^
      const DeepCollectionEquality().hash(attributes) ^
      const DeepCollectionEquality().hash(sharingScope) ^
      const DeepCollectionEquality().hash(createdOn) ^
      const DeepCollectionEquality().hash(emailVerified) ^
      const DeepCollectionEquality().hash(phoneVerified) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(roles) ^
      const DeepCollectionEquality().hash(dataGroups) ^
      const DeepCollectionEquality().hash(clientData) ^
      const DeepCollectionEquality().hash(languages) ^
      const DeepCollectionEquality().hash(studyIds) ^
      const DeepCollectionEquality().hash(externalIds) ^
      const DeepCollectionEquality().hash(authenticated) ^
      const DeepCollectionEquality().hash(sessionToken) ^
      const DeepCollectionEquality().hash(reauthToken) ^
      const DeepCollectionEquality().hash(environment) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(phone) ^
      const DeepCollectionEquality().hash(dataSharing) ^
      const DeepCollectionEquality().hash(signedMostRecentConsent) ^
      const DeepCollectionEquality().hash(synapseUserId) ^
      const DeepCollectionEquality().hash(consented) ^
      const DeepCollectionEquality().hash(consentStatuses) ^
      const DeepCollectionEquality().hash(enrollments) ^
      const DeepCollectionEquality().hash(orgMembership) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $UserSessionInfoExtension on UserSessionInfo {
  UserSessionInfo copyWith(
      {String? firstName,
      String? lastName,
      String? externalId,
      String? id,
      bool? notifyByEmail,
      Map<String, dynamic>? attributes,
      enums.SharingScope? sharingScope,
      DateTime? createdOn,
      bool? emailVerified,
      bool? phoneVerified,
      enums.AccountStatus? status,
      List<enums.Role>? roles,
      List<String>? dataGroups,
      Map<String, dynamic>? clientData,
      List<String>? languages,
      List<String>? studyIds,
      Map<String, dynamic>? externalIds,
      bool? authenticated,
      String? sessionToken,
      String? reauthToken,
      enums.Environment? environment,
      String? email,
      Phone? phone,
      bool? dataSharing,
      bool? signedMostRecentConsent,
      String? synapseUserId,
      bool? consented,
      Map<String, dynamic>? consentStatuses,
      Map<String, dynamic>? enrollments,
      String? orgMembership,
      String? type}) {
    return UserSessionInfo(
        firstName: firstName ?? this.firstName,
        lastName: lastName ?? this.lastName,
        externalId: externalId ?? this.externalId,
        id: id ?? this.id,
        notifyByEmail: notifyByEmail ?? this.notifyByEmail,
        attributes: attributes ?? this.attributes,
        sharingScope: sharingScope ?? this.sharingScope,
        createdOn: createdOn ?? this.createdOn,
        emailVerified: emailVerified ?? this.emailVerified,
        phoneVerified: phoneVerified ?? this.phoneVerified,
        status: status ?? this.status,
        roles: roles ?? this.roles,
        dataGroups: dataGroups ?? this.dataGroups,
        clientData: clientData ?? this.clientData,
        languages: languages ?? this.languages,
        studyIds: studyIds ?? this.studyIds,
        externalIds: externalIds ?? this.externalIds,
        authenticated: authenticated ?? this.authenticated,
        sessionToken: sessionToken ?? this.sessionToken,
        reauthToken: reauthToken ?? this.reauthToken,
        environment: environment ?? this.environment,
        email: email ?? this.email,
        phone: phone ?? this.phone,
        dataSharing: dataSharing ?? this.dataSharing,
        signedMostRecentConsent:
            signedMostRecentConsent ?? this.signedMostRecentConsent,
        synapseUserId: synapseUserId ?? this.synapseUserId,
        consented: consented ?? this.consented,
        consentStatuses: consentStatuses ?? this.consentStatuses,
        enrollments: enrollments ?? this.enrollments,
        orgMembership: orgMembership ?? this.orgMembership,
        type: type ?? this.type);
  }

  UserSessionInfo copyWithWrapped(
      {Wrapped<String?>? firstName,
      Wrapped<String?>? lastName,
      Wrapped<String?>? externalId,
      Wrapped<String?>? id,
      Wrapped<bool?>? notifyByEmail,
      Wrapped<Map<String, dynamic>?>? attributes,
      Wrapped<enums.SharingScope?>? sharingScope,
      Wrapped<DateTime?>? createdOn,
      Wrapped<bool?>? emailVerified,
      Wrapped<bool?>? phoneVerified,
      Wrapped<enums.AccountStatus?>? status,
      Wrapped<List<enums.Role>?>? roles,
      Wrapped<List<String>?>? dataGroups,
      Wrapped<Map<String, dynamic>?>? clientData,
      Wrapped<List<String>?>? languages,
      Wrapped<List<String>?>? studyIds,
      Wrapped<Map<String, dynamic>?>? externalIds,
      Wrapped<bool?>? authenticated,
      Wrapped<String?>? sessionToken,
      Wrapped<String?>? reauthToken,
      Wrapped<enums.Environment?>? environment,
      Wrapped<String?>? email,
      Wrapped<Phone?>? phone,
      Wrapped<bool?>? dataSharing,
      Wrapped<bool?>? signedMostRecentConsent,
      Wrapped<String?>? synapseUserId,
      Wrapped<bool?>? consented,
      Wrapped<Map<String, dynamic>?>? consentStatuses,
      Wrapped<Map<String, dynamic>?>? enrollments,
      Wrapped<String?>? orgMembership,
      Wrapped<String?>? type}) {
    return UserSessionInfo(
        firstName: (firstName != null ? firstName.value : this.firstName),
        lastName: (lastName != null ? lastName.value : this.lastName),
        externalId: (externalId != null ? externalId.value : this.externalId),
        id: (id != null ? id.value : this.id),
        notifyByEmail:
            (notifyByEmail != null ? notifyByEmail.value : this.notifyByEmail),
        attributes: (attributes != null ? attributes.value : this.attributes),
        sharingScope:
            (sharingScope != null ? sharingScope.value : this.sharingScope),
        createdOn: (createdOn != null ? createdOn.value : this.createdOn),
        emailVerified:
            (emailVerified != null ? emailVerified.value : this.emailVerified),
        phoneVerified:
            (phoneVerified != null ? phoneVerified.value : this.phoneVerified),
        status: (status != null ? status.value : this.status),
        roles: (roles != null ? roles.value : this.roles),
        dataGroups: (dataGroups != null ? dataGroups.value : this.dataGroups),
        clientData: (clientData != null ? clientData.value : this.clientData),
        languages: (languages != null ? languages.value : this.languages),
        studyIds: (studyIds != null ? studyIds.value : this.studyIds),
        externalIds:
            (externalIds != null ? externalIds.value : this.externalIds),
        authenticated:
            (authenticated != null ? authenticated.value : this.authenticated),
        sessionToken:
            (sessionToken != null ? sessionToken.value : this.sessionToken),
        reauthToken:
            (reauthToken != null ? reauthToken.value : this.reauthToken),
        environment:
            (environment != null ? environment.value : this.environment),
        email: (email != null ? email.value : this.email),
        phone: (phone != null ? phone.value : this.phone),
        dataSharing:
            (dataSharing != null ? dataSharing.value : this.dataSharing),
        signedMostRecentConsent: (signedMostRecentConsent != null
            ? signedMostRecentConsent.value
            : this.signedMostRecentConsent),
        synapseUserId:
            (synapseUserId != null ? synapseUserId.value : this.synapseUserId),
        consented: (consented != null ? consented.value : this.consented),
        consentStatuses: (consentStatuses != null
            ? consentStatuses.value
            : this.consentStatuses),
        enrollments:
            (enrollments != null ? enrollments.value : this.enrollments),
        orgMembership:
            (orgMembership != null ? orgMembership.value : this.orgMembership),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Verification {
  Verification({
    required this.sptoken,
    this.type,
  });

  factory Verification.fromJson(Map<String, dynamic> json) =>
      _$VerificationFromJson(json);

  @JsonKey(name: 'sptoken', includeIfNull: false, defaultValue: '')
  final String sptoken;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$VerificationFromJson;
  static const toJsonFactory = _$VerificationToJson;
  Map<String, dynamic> toJson() => _$VerificationToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Verification &&
            (identical(other.sptoken, sptoken) ||
                const DeepCollectionEquality()
                    .equals(other.sptoken, sptoken)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(sptoken) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $VerificationExtension on Verification {
  Verification copyWith({String? sptoken, String? type}) {
    return Verification(
        sptoken: sptoken ?? this.sptoken, type: type ?? this.type);
  }

  Verification copyWithWrapped(
      {Wrapped<String>? sptoken, Wrapped<String?>? type}) {
    return Verification(
        sptoken: (sptoken != null ? sptoken.value : this.sptoken),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class VersionHolder {
  VersionHolder({
    this.version,
    this.type,
  });

  factory VersionHolder.fromJson(Map<String, dynamic> json) =>
      _$VersionHolderFromJson(json);

  @JsonKey(name: 'version', includeIfNull: false)
  final num? version;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$VersionHolderFromJson;
  static const toJsonFactory = _$VersionHolderToJson;
  Map<String, dynamic> toJson() => _$VersionHolderToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is VersionHolder &&
            (identical(other.version, version) ||
                const DeepCollectionEquality()
                    .equals(other.version, version)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(version) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $VersionHolderExtension on VersionHolder {
  VersionHolder copyWith({num? version, String? type}) {
    return VersionHolder(
        version: version ?? this.version, type: type ?? this.type);
  }

  VersionHolder copyWithWrapped(
      {Wrapped<num?>? version, Wrapped<String?>? type}) {
    return VersionHolder(
        version: (version != null ? version.value : this.version),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Withdrawal {
  Withdrawal({
    this.reason,
    this.type,
  });

  factory Withdrawal.fromJson(Map<String, dynamic> json) =>
      _$WithdrawalFromJson(json);

  @JsonKey(name: 'reason', includeIfNull: false, defaultValue: '')
  final String? reason;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$WithdrawalFromJson;
  static const toJsonFactory = _$WithdrawalToJson;
  Map<String, dynamic> toJson() => _$WithdrawalToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Withdrawal &&
            (identical(other.reason, reason) ||
                const DeepCollectionEquality().equals(other.reason, reason)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(reason) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $WithdrawalExtension on Withdrawal {
  Withdrawal copyWith({String? reason, String? type}) {
    return Withdrawal(reason: reason ?? this.reason, type: type ?? this.type);
  }

  Withdrawal copyWithWrapped(
      {Wrapped<String?>? reason, Wrapped<String?>? type}) {
    return Withdrawal(
        reason: (reason != null ? reason.value : this.reason),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ResourceList {
  ResourceList({
    this.requestParams,
    this.type,
  });

  factory ResourceList.fromJson(Map<String, dynamic> json) =>
      _$ResourceListFromJson(json);

  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ResourceListFromJson;
  static const toJsonFactory = _$ResourceListToJson;
  Map<String, dynamic> toJson() => _$ResourceListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ResourceList &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ResourceListExtension on ResourceList {
  ResourceList copyWith({RequestParams? requestParams, String? type}) {
    return ResourceList(
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  ResourceList copyWithWrapped(
      {Wrapped<RequestParams?>? requestParams, Wrapped<String?>? type}) {
    return ResourceList(
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class PagedResourceList {
  PagedResourceList({
    this.total,
    this.requestParams,
    this.type,
  });

  factory PagedResourceList.fromJson(Map<String, dynamic> json) =>
      _$PagedResourceListFromJson(json);

  @JsonKey(name: 'total', includeIfNull: false)
  final int? total;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$PagedResourceListFromJson;
  static const toJsonFactory = _$PagedResourceListToJson;
  Map<String, dynamic> toJson() => _$PagedResourceListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PagedResourceList &&
            (identical(other.total, total) ||
                const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(total) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $PagedResourceListExtension on PagedResourceList {
  PagedResourceList copyWith(
      {int? total, RequestParams? requestParams, String? type}) {
    return PagedResourceList(
        total: total ?? this.total,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  PagedResourceList copyWithWrapped(
      {Wrapped<int?>? total,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return PagedResourceList(
        total: (total != null ? total.value : this.total),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ForwardCursorPagedResourceList {
  ForwardCursorPagedResourceList({
    this.nextPageOffsetKey,
    this.hasNext,
    this.requestParams,
    this.type,
  });

  factory ForwardCursorPagedResourceList.fromJson(Map<String, dynamic> json) =>
      _$ForwardCursorPagedResourceListFromJson(json);

  @JsonKey(name: 'nextPageOffsetKey', includeIfNull: false, defaultValue: '')
  final String? nextPageOffsetKey;
  @JsonKey(name: 'hasNext', includeIfNull: false)
  final bool? hasNext;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ForwardCursorPagedResourceListFromJson;
  static const toJsonFactory = _$ForwardCursorPagedResourceListToJson;
  Map<String, dynamic> toJson() => _$ForwardCursorPagedResourceListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ForwardCursorPagedResourceList &&
            (identical(other.nextPageOffsetKey, nextPageOffsetKey) ||
                const DeepCollectionEquality()
                    .equals(other.nextPageOffsetKey, nextPageOffsetKey)) &&
            (identical(other.hasNext, hasNext) ||
                const DeepCollectionEquality()
                    .equals(other.hasNext, hasNext)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(nextPageOffsetKey) ^
      const DeepCollectionEquality().hash(hasNext) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ForwardCursorPagedResourceListExtension
    on ForwardCursorPagedResourceList {
  ForwardCursorPagedResourceList copyWith(
      {String? nextPageOffsetKey,
      bool? hasNext,
      RequestParams? requestParams,
      String? type}) {
    return ForwardCursorPagedResourceList(
        nextPageOffsetKey: nextPageOffsetKey ?? this.nextPageOffsetKey,
        hasNext: hasNext ?? this.hasNext,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  ForwardCursorPagedResourceList copyWithWrapped(
      {Wrapped<String?>? nextPageOffsetKey,
      Wrapped<bool?>? hasNext,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return ForwardCursorPagedResourceList(
        nextPageOffsetKey: (nextPageOffsetKey != null
            ? nextPageOffsetKey.value
            : this.nextPageOffsetKey),
        hasNext: (hasNext != null ? hasNext.value : this.hasNext),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AccountSummaryList {
  AccountSummaryList({
    this.items,
  });

  factory AccountSummaryList.fromJson(Map<String, dynamic> json) =>
      _$AccountSummaryListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <AccountSummary>[])
  final List<AccountSummary>? items;
  static const fromJsonFactory = _$AccountSummaryListFromJson;
  static const toJsonFactory = _$AccountSummaryListToJson;
  Map<String, dynamic> toJson() => _$AccountSummaryListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AccountSummaryList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $AccountSummaryListExtension on AccountSummaryList {
  AccountSummaryList copyWith({List<AccountSummary>? items}) {
    return AccountSummaryList(items: items ?? this.items);
  }

  AccountSummaryList copyWithWrapped({Wrapped<List<AccountSummary>?>? items}) {
    return AccountSummaryList(
        items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class ActivityList {
  ActivityList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory ActivityList.fromJson(Map<String, dynamic> json) =>
      _$ActivityListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <ScheduledActivity>[])
  final List<ScheduledActivity>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ActivityListFromJson;
  static const toJsonFactory = _$ActivityListToJson;
  Map<String, dynamic> toJson() => _$ActivityListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ActivityList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ActivityListExtension on ActivityList {
  ActivityList copyWith(
      {List<ScheduledActivity>? items,
      RequestParams? requestParams,
      String? type}) {
    return ActivityList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  ActivityList copyWithWrapped(
      {Wrapped<List<ScheduledActivity>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return ActivityList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ActivityEventList {
  ActivityEventList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory ActivityEventList.fromJson(Map<String, dynamic> json) =>
      _$ActivityEventListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <ActivityEvent>[])
  final List<ActivityEvent>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ActivityEventListFromJson;
  static const toJsonFactory = _$ActivityEventListToJson;
  Map<String, dynamic> toJson() => _$ActivityEventListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ActivityEventList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ActivityEventListExtension on ActivityEventList {
  ActivityEventList copyWith(
      {List<ActivityEvent>? items,
      RequestParams? requestParams,
      String? type}) {
    return ActivityEventList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  ActivityEventList copyWithWrapped(
      {Wrapped<List<ActivityEvent>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return ActivityEventList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AdherenceRecordList {
  AdherenceRecordList({
    this.items,
  });

  factory AdherenceRecordList.fromJson(Map<String, dynamic> json) =>
      _$AdherenceRecordListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <AdherenceRecord>[])
  final List<AdherenceRecord>? items;
  static const fromJsonFactory = _$AdherenceRecordListFromJson;
  static const toJsonFactory = _$AdherenceRecordListToJson;
  Map<String, dynamic> toJson() => _$AdherenceRecordListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AdherenceRecordList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $AdherenceRecordListExtension on AdherenceRecordList {
  AdherenceRecordList copyWith({List<AdherenceRecord>? items}) {
    return AdherenceRecordList(items: items ?? this.items);
  }

  AdherenceRecordList copyWithWrapped(
      {Wrapped<List<AdherenceRecord>?>? items}) {
    return AdherenceRecordList(
        items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class AppConfigList {
  AppConfigList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory AppConfigList.fromJson(Map<String, dynamic> json) =>
      _$AppConfigListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <AppConfig>[])
  final List<AppConfig>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AppConfigListFromJson;
  static const toJsonFactory = _$AppConfigListToJson;
  Map<String, dynamic> toJson() => _$AppConfigListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AppConfigList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AppConfigListExtension on AppConfigList {
  AppConfigList copyWith(
      {List<AppConfig>? items, RequestParams? requestParams, String? type}) {
    return AppConfigList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  AppConfigList copyWithWrapped(
      {Wrapped<List<AppConfig>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return AppConfigList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AppConfigElementList {
  AppConfigElementList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory AppConfigElementList.fromJson(Map<String, dynamic> json) =>
      _$AppConfigElementListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <AppConfigElement>[])
  final List<AppConfigElement>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AppConfigElementListFromJson;
  static const toJsonFactory = _$AppConfigElementListToJson;
  Map<String, dynamic> toJson() => _$AppConfigElementListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AppConfigElementList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AppConfigElementListExtension on AppConfigElementList {
  AppConfigElementList copyWith(
      {List<AppConfigElement>? items,
      RequestParams? requestParams,
      String? type}) {
    return AppConfigElementList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  AppConfigElementList copyWithWrapped(
      {Wrapped<List<AppConfigElement>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return AppConfigElementList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AppList {
  AppList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory AppList.fromJson(Map<String, dynamic> json) =>
      _$AppListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <App>[])
  final List<App>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$AppListFromJson;
  static const toJsonFactory = _$AppListToJson;
  Map<String, dynamic> toJson() => _$AppListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AppList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $AppListExtension on AppList {
  AppList copyWith(
      {List<App>? items, RequestParams? requestParams, String? type}) {
    return AppList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  AppList copyWithWrapped(
      {Wrapped<List<App>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return AppList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class AssessmentList {
  AssessmentList({
    this.items,
  });

  factory AssessmentList.fromJson(Map<String, dynamic> json) =>
      _$AssessmentListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <Assessment>[])
  final List<Assessment>? items;
  static const fromJsonFactory = _$AssessmentListFromJson;
  static const toJsonFactory = _$AssessmentListToJson;
  Map<String, dynamic> toJson() => _$AssessmentListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is AssessmentList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $AssessmentListExtension on AssessmentList {
  AssessmentList copyWith({List<Assessment>? items}) {
    return AssessmentList(items: items ?? this.items);
  }

  AssessmentList copyWithWrapped({Wrapped<List<Assessment>?>? items}) {
    return AssessmentList(items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class CompoundActivityDefinitionList {
  CompoundActivityDefinitionList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory CompoundActivityDefinitionList.fromJson(Map<String, dynamic> json) =>
      _$CompoundActivityDefinitionListFromJson(json);

  @JsonKey(
      name: 'items',
      includeIfNull: false,
      defaultValue: <CompoundActivityDefinition>[])
  final List<CompoundActivityDefinition>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$CompoundActivityDefinitionListFromJson;
  static const toJsonFactory = _$CompoundActivityDefinitionListToJson;
  Map<String, dynamic> toJson() => _$CompoundActivityDefinitionListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CompoundActivityDefinitionList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $CompoundActivityDefinitionListExtension
    on CompoundActivityDefinitionList {
  CompoundActivityDefinitionList copyWith(
      {List<CompoundActivityDefinition>? items,
      RequestParams? requestParams,
      String? type}) {
    return CompoundActivityDefinitionList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  CompoundActivityDefinitionList copyWithWrapped(
      {Wrapped<List<CompoundActivityDefinition>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return CompoundActivityDefinitionList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class EnrollmentDetailList {
  EnrollmentDetailList({
    this.items,
  });

  factory EnrollmentDetailList.fromJson(Map<String, dynamic> json) =>
      _$EnrollmentDetailListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <EnrollmentDetail>[])
  final List<EnrollmentDetail>? items;
  static const fromJsonFactory = _$EnrollmentDetailListFromJson;
  static const toJsonFactory = _$EnrollmentDetailListToJson;
  Map<String, dynamic> toJson() => _$EnrollmentDetailListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is EnrollmentDetailList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $EnrollmentDetailListExtension on EnrollmentDetailList {
  EnrollmentDetailList copyWith({List<EnrollmentDetail>? items}) {
    return EnrollmentDetailList(items: items ?? this.items);
  }

  EnrollmentDetailList copyWithWrapped(
      {Wrapped<List<EnrollmentDetail>?>? items}) {
    return EnrollmentDetailList(
        items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class ExternalIdentifierList {
  ExternalIdentifierList({
    this.items,
  });

  factory ExternalIdentifierList.fromJson(Map<String, dynamic> json) =>
      _$ExternalIdentifierListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <ExternalIdentifier>[])
  final List<ExternalIdentifier>? items;
  static const fromJsonFactory = _$ExternalIdentifierListFromJson;
  static const toJsonFactory = _$ExternalIdentifierListToJson;
  Map<String, dynamic> toJson() => _$ExternalIdentifierListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ExternalIdentifierList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $ExternalIdentifierListExtension on ExternalIdentifierList {
  ExternalIdentifierList copyWith({List<ExternalIdentifier>? items}) {
    return ExternalIdentifierList(items: items ?? this.items);
  }

  ExternalIdentifierList copyWithWrapped(
      {Wrapped<List<ExternalIdentifier>?>? items}) {
    return ExternalIdentifierList(
        items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class ExternalResourceList {
  ExternalResourceList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory ExternalResourceList.fromJson(Map<String, dynamic> json) =>
      _$ExternalResourceListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <ExternalResource>[])
  final List<ExternalResource>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ExternalResourceListFromJson;
  static const toJsonFactory = _$ExternalResourceListToJson;
  Map<String, dynamic> toJson() => _$ExternalResourceListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ExternalResourceList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ExternalResourceListExtension on ExternalResourceList {
  ExternalResourceList copyWith(
      {List<ExternalResource>? items,
      RequestParams? requestParams,
      String? type}) {
    return ExternalResourceList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  ExternalResourceList copyWithWrapped(
      {Wrapped<List<ExternalResource>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return ExternalResourceList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class FileMetadataList {
  FileMetadataList({
    this.items,
  });

  factory FileMetadataList.fromJson(Map<String, dynamic> json) =>
      _$FileMetadataListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <FileMetadata>[])
  final List<FileMetadata>? items;
  static const fromJsonFactory = _$FileMetadataListFromJson;
  static const toJsonFactory = _$FileMetadataListToJson;
  Map<String, dynamic> toJson() => _$FileMetadataListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FileMetadataList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $FileMetadataListExtension on FileMetadataList {
  FileMetadataList copyWith({List<FileMetadata>? items}) {
    return FileMetadataList(items: items ?? this.items);
  }

  FileMetadataList copyWithWrapped({Wrapped<List<FileMetadata>?>? items}) {
    return FileMetadataList(items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class FileRevisionList {
  FileRevisionList({
    this.items,
  });

  factory FileRevisionList.fromJson(Map<String, dynamic> json) =>
      _$FileRevisionListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <FileRevision>[])
  final List<FileRevision>? items;
  static const fromJsonFactory = _$FileRevisionListFromJson;
  static const toJsonFactory = _$FileRevisionListToJson;
  Map<String, dynamic> toJson() => _$FileRevisionListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FileRevisionList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $FileRevisionListExtension on FileRevisionList {
  FileRevisionList copyWith({List<FileRevision>? items}) {
    return FileRevisionList(items: items ?? this.items);
  }

  FileRevisionList copyWithWrapped({Wrapped<List<FileRevision>?>? items}) {
    return FileRevisionList(items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class HealthDataDocumentationList {
  HealthDataDocumentationList({
    this.items,
  });

  factory HealthDataDocumentationList.fromJson(Map<String, dynamic> json) =>
      _$HealthDataDocumentationListFromJson(json);

  @JsonKey(
      name: 'items',
      includeIfNull: false,
      defaultValue: <HealthDataDocumentation>[])
  final List<HealthDataDocumentation>? items;
  static const fromJsonFactory = _$HealthDataDocumentationListFromJson;
  static const toJsonFactory = _$HealthDataDocumentationListToJson;
  Map<String, dynamic> toJson() => _$HealthDataDocumentationListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is HealthDataDocumentationList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $HealthDataDocumentationListExtension on HealthDataDocumentationList {
  HealthDataDocumentationList copyWith({List<HealthDataDocumentation>? items}) {
    return HealthDataDocumentationList(items: items ?? this.items);
  }

  HealthDataDocumentationList copyWithWrapped(
      {Wrapped<List<HealthDataDocumentation>?>? items}) {
    return HealthDataDocumentationList(
        items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class HealthDataRecordList {
  HealthDataRecordList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory HealthDataRecordList.fromJson(Map<String, dynamic> json) =>
      _$HealthDataRecordListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <HealthDataRecord>[])
  final List<HealthDataRecord>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$HealthDataRecordListFromJson;
  static const toJsonFactory = _$HealthDataRecordListToJson;
  Map<String, dynamic> toJson() => _$HealthDataRecordListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is HealthDataRecordList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $HealthDataRecordListExtension on HealthDataRecordList {
  HealthDataRecordList copyWith(
      {List<HealthDataRecord>? items,
      RequestParams? requestParams,
      String? type}) {
    return HealthDataRecordList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  HealthDataRecordList copyWithWrapped(
      {Wrapped<List<HealthDataRecord>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return HealthDataRecordList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class HealthDataRecordEx3List {
  HealthDataRecordEx3List({
    this.items,
  });

  factory HealthDataRecordEx3List.fromJson(Map<String, dynamic> json) =>
      _$HealthDataRecordEx3ListFromJson(json);

  @JsonKey(
      name: 'items',
      includeIfNull: false,
      defaultValue: <HealthDataRecordEx3>[])
  final List<HealthDataRecordEx3>? items;
  static const fromJsonFactory = _$HealthDataRecordEx3ListFromJson;
  static const toJsonFactory = _$HealthDataRecordEx3ListToJson;
  Map<String, dynamic> toJson() => _$HealthDataRecordEx3ListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is HealthDataRecordEx3List &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $HealthDataRecordEx3ListExtension on HealthDataRecordEx3List {
  HealthDataRecordEx3List copyWith({List<HealthDataRecordEx3>? items}) {
    return HealthDataRecordEx3List(items: items ?? this.items);
  }

  HealthDataRecordEx3List copyWithWrapped(
      {Wrapped<List<HealthDataRecordEx3>?>? items}) {
    return HealthDataRecordEx3List(
        items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class NotificationRegistrationList {
  NotificationRegistrationList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory NotificationRegistrationList.fromJson(Map<String, dynamic> json) =>
      _$NotificationRegistrationListFromJson(json);

  @JsonKey(
      name: 'items',
      includeIfNull: false,
      defaultValue: <NotificationRegistration>[])
  final List<NotificationRegistration>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$NotificationRegistrationListFromJson;
  static const toJsonFactory = _$NotificationRegistrationListToJson;
  Map<String, dynamic> toJson() => _$NotificationRegistrationListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NotificationRegistrationList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $NotificationRegistrationListExtension
    on NotificationRegistrationList {
  NotificationRegistrationList copyWith(
      {List<NotificationRegistration>? items,
      RequestParams? requestParams,
      String? type}) {
    return NotificationRegistrationList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  NotificationRegistrationList copyWithWrapped(
      {Wrapped<List<NotificationRegistration>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return NotificationRegistrationList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class NotificationTopicList {
  NotificationTopicList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory NotificationTopicList.fromJson(Map<String, dynamic> json) =>
      _$NotificationTopicListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <NotificationTopic>[])
  final List<NotificationTopic>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$NotificationTopicListFromJson;
  static const toJsonFactory = _$NotificationTopicListToJson;
  Map<String, dynamic> toJson() => _$NotificationTopicListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is NotificationTopicList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $NotificationTopicListExtension on NotificationTopicList {
  NotificationTopicList copyWith(
      {List<NotificationTopic>? items,
      RequestParams? requestParams,
      String? type}) {
    return NotificationTopicList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  NotificationTopicList copyWithWrapped(
      {Wrapped<List<NotificationTopic>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return NotificationTopicList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class MasterSchedulerConfigList {
  MasterSchedulerConfigList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory MasterSchedulerConfigList.fromJson(Map<String, dynamic> json) =>
      _$MasterSchedulerConfigListFromJson(json);

  @JsonKey(
      name: 'items',
      includeIfNull: false,
      defaultValue: <MasterSchedulerConfig>[])
  final List<MasterSchedulerConfig>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$MasterSchedulerConfigListFromJson;
  static const toJsonFactory = _$MasterSchedulerConfigListToJson;
  Map<String, dynamic> toJson() => _$MasterSchedulerConfigListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MasterSchedulerConfigList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $MasterSchedulerConfigListExtension on MasterSchedulerConfigList {
  MasterSchedulerConfigList copyWith(
      {List<MasterSchedulerConfig>? items,
      RequestParams? requestParams,
      String? type}) {
    return MasterSchedulerConfigList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  MasterSchedulerConfigList copyWithWrapped(
      {Wrapped<List<MasterSchedulerConfig>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return MasterSchedulerConfigList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class PagedExternalResourceList {
  PagedExternalResourceList({
    this.items,
  });

  factory PagedExternalResourceList.fromJson(Map<String, dynamic> json) =>
      _$PagedExternalResourceListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <ExternalResource>[])
  final List<ExternalResource>? items;
  static const fromJsonFactory = _$PagedExternalResourceListFromJson;
  static const toJsonFactory = _$PagedExternalResourceListToJson;
  Map<String, dynamic> toJson() => _$PagedExternalResourceListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PagedExternalResourceList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $PagedExternalResourceListExtension on PagedExternalResourceList {
  PagedExternalResourceList copyWith({List<ExternalResource>? items}) {
    return PagedExternalResourceList(items: items ?? this.items);
  }

  PagedExternalResourceList copyWithWrapped(
      {Wrapped<List<ExternalResource>?>? items}) {
    return PagedExternalResourceList(
        items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class ReportDataList {
  ReportDataList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory ReportDataList.fromJson(Map<String, dynamic> json) =>
      _$ReportDataListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <ReportData>[])
  final List<ReportData>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ReportDataListFromJson;
  static const toJsonFactory = _$ReportDataListToJson;
  Map<String, dynamic> toJson() => _$ReportDataListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ReportDataList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ReportDataListExtension on ReportDataList {
  ReportDataList copyWith(
      {List<ReportData>? items, RequestParams? requestParams, String? type}) {
    return ReportDataList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  ReportDataList copyWithWrapped(
      {Wrapped<List<ReportData>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return ReportDataList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ForwardCursorReportDataList {
  ForwardCursorReportDataList({
    this.items,
  });

  factory ForwardCursorReportDataList.fromJson(Map<String, dynamic> json) =>
      _$ForwardCursorReportDataListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <ReportData>[])
  final List<ReportData>? items;
  static const fromJsonFactory = _$ForwardCursorReportDataListFromJson;
  static const toJsonFactory = _$ForwardCursorReportDataListToJson;
  Map<String, dynamic> toJson() => _$ForwardCursorReportDataListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ForwardCursorReportDataList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $ForwardCursorReportDataListExtension on ForwardCursorReportDataList {
  ForwardCursorReportDataList copyWith({List<ReportData>? items}) {
    return ForwardCursorReportDataList(items: items ?? this.items);
  }

  ForwardCursorReportDataList copyWithWrapped(
      {Wrapped<List<ReportData>?>? items}) {
    return ForwardCursorReportDataList(
        items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class OrganizationList {
  OrganizationList({
    this.items,
  });

  factory OrganizationList.fromJson(Map<String, dynamic> json) =>
      _$OrganizationListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <Organization>[])
  final List<Organization>? items;
  static const fromJsonFactory = _$OrganizationListFromJson;
  static const toJsonFactory = _$OrganizationListToJson;
  Map<String, dynamic> toJson() => _$OrganizationListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is OrganizationList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $OrganizationListExtension on OrganizationList {
  OrganizationList copyWith({List<Organization>? items}) {
    return OrganizationList(items: items ?? this.items);
  }

  OrganizationList copyWithWrapped({Wrapped<List<Organization>?>? items}) {
    return OrganizationList(items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class ParticipantDataList {
  ParticipantDataList({
    this.items,
  });

  factory ParticipantDataList.fromJson(Map<String, dynamic> json) =>
      _$ParticipantDataListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <ParticipantData>[])
  final List<ParticipantData>? items;
  static const fromJsonFactory = _$ParticipantDataListFromJson;
  static const toJsonFactory = _$ParticipantDataListToJson;
  Map<String, dynamic> toJson() => _$ParticipantDataListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ParticipantDataList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $ParticipantDataListExtension on ParticipantDataList {
  ParticipantDataList copyWith({List<ParticipantData>? items}) {
    return ParticipantDataList(items: items ?? this.items);
  }

  ParticipantDataList copyWithWrapped(
      {Wrapped<List<ParticipantData>?>? items}) {
    return ParticipantDataList(
        items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class ParticipantFileList {
  ParticipantFileList({
    this.items,
  });

  factory ParticipantFileList.fromJson(Map<String, dynamic> json) =>
      _$ParticipantFileListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <ParticipantFile>[])
  final List<ParticipantFile>? items;
  static const fromJsonFactory = _$ParticipantFileListFromJson;
  static const toJsonFactory = _$ParticipantFileListToJson;
  Map<String, dynamic> toJson() => _$ParticipantFileListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ParticipantFileList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $ParticipantFileListExtension on ParticipantFileList {
  ParticipantFileList copyWith({List<ParticipantFile>? items}) {
    return ParticipantFileList(items: items ?? this.items);
  }

  ParticipantFileList copyWithWrapped(
      {Wrapped<List<ParticipantFile>?>? items}) {
    return ParticipantFileList(
        items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class ParticipantVersionList {
  ParticipantVersionList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory ParticipantVersionList.fromJson(Map<String, dynamic> json) =>
      _$ParticipantVersionListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <ParticipantVersion>[])
  final List<ParticipantVersion>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ParticipantVersionListFromJson;
  static const toJsonFactory = _$ParticipantVersionListToJson;
  Map<String, dynamic> toJson() => _$ParticipantVersionListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ParticipantVersionList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ParticipantVersionListExtension on ParticipantVersionList {
  ParticipantVersionList copyWith(
      {List<ParticipantVersion>? items,
      RequestParams? requestParams,
      String? type}) {
    return ParticipantVersionList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  ParticipantVersionList copyWithWrapped(
      {Wrapped<List<ParticipantVersion>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return ParticipantVersionList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ReportIndexList {
  ReportIndexList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory ReportIndexList.fromJson(Map<String, dynamic> json) =>
      _$ReportIndexListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <ReportIndex>[])
  final List<ReportIndex>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ReportIndexListFromJson;
  static const toJsonFactory = _$ReportIndexListToJson;
  Map<String, dynamic> toJson() => _$ReportIndexListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ReportIndexList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ReportIndexListExtension on ReportIndexList {
  ReportIndexList copyWith(
      {List<ReportIndex>? items, RequestParams? requestParams, String? type}) {
    return ReportIndexList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  ReportIndexList copyWithWrapped(
      {Wrapped<List<ReportIndex>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return ReportIndexList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ScheduleList {
  ScheduleList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory ScheduleList.fromJson(Map<String, dynamic> json) =>
      _$ScheduleListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <Schedule>[])
  final List<Schedule>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ScheduleListFromJson;
  static const toJsonFactory = _$ScheduleListToJson;
  Map<String, dynamic> toJson() => _$ScheduleListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ScheduleList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ScheduleListExtension on ScheduleList {
  ScheduleList copyWith(
      {List<Schedule>? items, RequestParams? requestParams, String? type}) {
    return ScheduleList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  ScheduleList copyWithWrapped(
      {Wrapped<List<Schedule>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return ScheduleList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ScheduledActivityList {
  ScheduledActivityList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory ScheduledActivityList.fromJson(Map<String, dynamic> json) =>
      _$ScheduledActivityListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <ScheduledActivity>[])
  final List<ScheduledActivity>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ScheduledActivityListFromJson;
  static const toJsonFactory = _$ScheduledActivityListToJson;
  Map<String, dynamic> toJson() => _$ScheduledActivityListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ScheduledActivityList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ScheduledActivityListExtension on ScheduledActivityList {
  ScheduledActivityList copyWith(
      {List<ScheduledActivity>? items,
      RequestParams? requestParams,
      String? type}) {
    return ScheduledActivityList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  ScheduledActivityList copyWithWrapped(
      {Wrapped<List<ScheduledActivity>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return ScheduledActivityList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ScheduledActivityListV4 {
  ScheduledActivityListV4({
    this.items,
    this.requestParams,
    this.type,
  });

  factory ScheduledActivityListV4.fromJson(Map<String, dynamic> json) =>
      _$ScheduledActivityListV4FromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <ScheduledActivity>[])
  final List<ScheduledActivity>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ScheduledActivityListV4FromJson;
  static const toJsonFactory = _$ScheduledActivityListV4ToJson;
  Map<String, dynamic> toJson() => _$ScheduledActivityListV4ToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ScheduledActivityListV4 &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ScheduledActivityListV4Extension on ScheduledActivityListV4 {
  ScheduledActivityListV4 copyWith(
      {List<ScheduledActivity>? items,
      RequestParams? requestParams,
      String? type}) {
    return ScheduledActivityListV4(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  ScheduledActivityListV4 copyWithWrapped(
      {Wrapped<List<ScheduledActivity>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return ScheduledActivityListV4(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class ForwardCursorScheduledActivityList {
  ForwardCursorScheduledActivityList({
    this.items,
  });

  factory ForwardCursorScheduledActivityList.fromJson(
          Map<String, dynamic> json) =>
      _$ForwardCursorScheduledActivityListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <ScheduledActivity>[])
  final List<ScheduledActivity>? items;
  static const fromJsonFactory = _$ForwardCursorScheduledActivityListFromJson;
  static const toJsonFactory = _$ForwardCursorScheduledActivityListToJson;
  Map<String, dynamic> toJson() =>
      _$ForwardCursorScheduledActivityListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ForwardCursorScheduledActivityList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $ForwardCursorScheduledActivityListExtension
    on ForwardCursorScheduledActivityList {
  ForwardCursorScheduledActivityList copyWith(
      {List<ScheduledActivity>? items}) {
    return ForwardCursorScheduledActivityList(items: items ?? this.items);
  }

  ForwardCursorScheduledActivityList copyWithWrapped(
      {Wrapped<List<ScheduledActivity>?>? items}) {
    return ForwardCursorScheduledActivityList(
        items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class ForwardCursorStringList {
  ForwardCursorStringList({
    this.items,
  });

  factory ForwardCursorStringList.fromJson(Map<String, dynamic> json) =>
      _$ForwardCursorStringListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <String>[])
  final List<String>? items;
  static const fromJsonFactory = _$ForwardCursorStringListFromJson;
  static const toJsonFactory = _$ForwardCursorStringListToJson;
  Map<String, dynamic> toJson() => _$ForwardCursorStringListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ForwardCursorStringList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $ForwardCursorStringListExtension on ForwardCursorStringList {
  ForwardCursorStringList copyWith({List<String>? items}) {
    return ForwardCursorStringList(items: items ?? this.items);
  }

  ForwardCursorStringList copyWithWrapped({Wrapped<List<String>?>? items}) {
    return ForwardCursorStringList(
        items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class SchedulePlanList {
  SchedulePlanList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory SchedulePlanList.fromJson(Map<String, dynamic> json) =>
      _$SchedulePlanListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <SchedulePlan>[])
  final List<SchedulePlan>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SchedulePlanListFromJson;
  static const toJsonFactory = _$SchedulePlanListToJson;
  Map<String, dynamic> toJson() => _$SchedulePlanListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SchedulePlanList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SchedulePlanListExtension on SchedulePlanList {
  SchedulePlanList copyWith(
      {List<SchedulePlan>? items, RequestParams? requestParams, String? type}) {
    return SchedulePlanList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  SchedulePlanList copyWithWrapped(
      {Wrapped<List<SchedulePlan>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return SchedulePlanList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SharedModuleMetadataList {
  SharedModuleMetadataList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory SharedModuleMetadataList.fromJson(Map<String, dynamic> json) =>
      _$SharedModuleMetadataListFromJson(json);

  @JsonKey(
      name: 'items',
      includeIfNull: false,
      defaultValue: <SharedModuleMetadata>[])
  final List<SharedModuleMetadata>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SharedModuleMetadataListFromJson;
  static const toJsonFactory = _$SharedModuleMetadataListToJson;
  Map<String, dynamic> toJson() => _$SharedModuleMetadataListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SharedModuleMetadataList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SharedModuleMetadataListExtension on SharedModuleMetadataList {
  SharedModuleMetadataList copyWith(
      {List<SharedModuleMetadata>? items,
      RequestParams? requestParams,
      String? type}) {
    return SharedModuleMetadataList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  SharedModuleMetadataList copyWithWrapped(
      {Wrapped<List<SharedModuleMetadata>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return SharedModuleMetadataList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class StringList {
  StringList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory StringList.fromJson(Map<String, dynamic> json) =>
      _$StringListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <String>[])
  final List<String>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$StringListFromJson;
  static const toJsonFactory = _$StringListToJson;
  Map<String, dynamic> toJson() => _$StringListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StringList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $StringListExtension on StringList {
  StringList copyWith(
      {List<String>? items, RequestParams? requestParams, String? type}) {
    return StringList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  StringList copyWithWrapped(
      {Wrapped<List<String>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return StringList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class StudyActivityEventList {
  StudyActivityEventList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory StudyActivityEventList.fromJson(Map<String, dynamic> json) =>
      _$StudyActivityEventListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <StudyActivityEvent>[])
  final List<StudyActivityEvent>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$StudyActivityEventListFromJson;
  static const toJsonFactory = _$StudyActivityEventListToJson;
  Map<String, dynamic> toJson() => _$StudyActivityEventListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StudyActivityEventList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $StudyActivityEventListExtension on StudyActivityEventList {
  StudyActivityEventList copyWith(
      {List<StudyActivityEvent>? items,
      RequestParams? requestParams,
      String? type}) {
    return StudyActivityEventList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  StudyActivityEventList copyWithWrapped(
      {Wrapped<List<StudyActivityEvent>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return StudyActivityEventList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class StudyActivityEventPagedList {
  StudyActivityEventPagedList({
    this.items,
  });

  factory StudyActivityEventPagedList.fromJson(Map<String, dynamic> json) =>
      _$StudyActivityEventPagedListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <StudyActivityEvent>[])
  final List<StudyActivityEvent>? items;
  static const fromJsonFactory = _$StudyActivityEventPagedListFromJson;
  static const toJsonFactory = _$StudyActivityEventPagedListToJson;
  Map<String, dynamic> toJson() => _$StudyActivityEventPagedListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StudyActivityEventPagedList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $StudyActivityEventPagedListExtension on StudyActivityEventPagedList {
  StudyActivityEventPagedList copyWith({List<StudyActivityEvent>? items}) {
    return StudyActivityEventPagedList(items: items ?? this.items);
  }

  StudyActivityEventPagedList copyWithWrapped(
      {Wrapped<List<StudyActivityEvent>?>? items}) {
    return StudyActivityEventPagedList(
        items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class StudyConsentList {
  StudyConsentList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory StudyConsentList.fromJson(Map<String, dynamic> json) =>
      _$StudyConsentListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <StudyConsent>[])
  final List<StudyConsent>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$StudyConsentListFromJson;
  static const toJsonFactory = _$StudyConsentListToJson;
  Map<String, dynamic> toJson() => _$StudyConsentListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StudyConsentList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $StudyConsentListExtension on StudyConsentList {
  StudyConsentList copyWith(
      {List<StudyConsent>? items, RequestParams? requestParams, String? type}) {
    return StudyConsentList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  StudyConsentList copyWithWrapped(
      {Wrapped<List<StudyConsent>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return StudyConsentList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class StudyList {
  StudyList({
    this.items,
  });

  factory StudyList.fromJson(Map<String, dynamic> json) =>
      _$StudyListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <Study>[])
  final List<Study>? items;
  static const fromJsonFactory = _$StudyListFromJson;
  static const toJsonFactory = _$StudyListToJson;
  Map<String, dynamic> toJson() => _$StudyListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StudyList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $StudyListExtension on StudyList {
  StudyList copyWith({List<Study>? items}) {
    return StudyList(items: items ?? this.items);
  }

  StudyList copyWithWrapped({Wrapped<List<Study>?>? items}) {
    return StudyList(items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class SubpopulationList {
  SubpopulationList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory SubpopulationList.fromJson(Map<String, dynamic> json) =>
      _$SubpopulationListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <Subpopulation>[])
  final List<Subpopulation>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SubpopulationListFromJson;
  static const toJsonFactory = _$SubpopulationListToJson;
  Map<String, dynamic> toJson() => _$SubpopulationListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SubpopulationList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SubpopulationListExtension on SubpopulationList {
  SubpopulationList copyWith(
      {List<Subpopulation>? items,
      RequestParams? requestParams,
      String? type}) {
    return SubpopulationList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  SubpopulationList copyWithWrapped(
      {Wrapped<List<Subpopulation>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return SubpopulationList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SubscriptionStatusList {
  SubscriptionStatusList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory SubscriptionStatusList.fromJson(Map<String, dynamic> json) =>
      _$SubscriptionStatusListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <SubscriptionStatus>[])
  final List<SubscriptionStatus>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SubscriptionStatusListFromJson;
  static const toJsonFactory = _$SubscriptionStatusListToJson;
  Map<String, dynamic> toJson() => _$SubscriptionStatusListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SubscriptionStatusList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SubscriptionStatusListExtension on SubscriptionStatusList {
  SubscriptionStatusList copyWith(
      {List<SubscriptionStatus>? items,
      RequestParams? requestParams,
      String? type}) {
    return SubscriptionStatusList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  SubscriptionStatusList copyWithWrapped(
      {Wrapped<List<SubscriptionStatus>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return SubscriptionStatusList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class SurveyList {
  SurveyList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory SurveyList.fromJson(Map<String, dynamic> json) =>
      _$SurveyListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <Survey>[])
  final List<Survey>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$SurveyListFromJson;
  static const toJsonFactory = _$SurveyListToJson;
  Map<String, dynamic> toJson() => _$SurveyListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SurveyList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $SurveyListExtension on SurveyList {
  SurveyList copyWith(
      {List<Survey>? items, RequestParams? requestParams, String? type}) {
    return SurveyList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  SurveyList copyWithWrapped(
      {Wrapped<List<Survey>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return SurveyList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class TemplateList {
  TemplateList({
    this.items,
  });

  factory TemplateList.fromJson(Map<String, dynamic> json) =>
      _$TemplateListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <Template>[])
  final List<Template>? items;
  static const fromJsonFactory = _$TemplateListFromJson;
  static const toJsonFactory = _$TemplateListToJson;
  Map<String, dynamic> toJson() => _$TemplateListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TemplateList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $TemplateListExtension on TemplateList {
  TemplateList copyWith({List<Template>? items}) {
    return TemplateList(items: items ?? this.items);
  }

  TemplateList copyWithWrapped({Wrapped<List<Template>?>? items}) {
    return TemplateList(items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class TemplateRevisionList {
  TemplateRevisionList({
    this.items,
  });

  factory TemplateRevisionList.fromJson(Map<String, dynamic> json) =>
      _$TemplateRevisionListFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <TemplateRevision>[])
  final List<TemplateRevision>? items;
  static const fromJsonFactory = _$TemplateRevisionListFromJson;
  static const toJsonFactory = _$TemplateRevisionListToJson;
  Map<String, dynamic> toJson() => _$TemplateRevisionListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TemplateRevisionList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $TemplateRevisionListExtension on TemplateRevisionList {
  TemplateRevisionList copyWith({List<TemplateRevision>? items}) {
    return TemplateRevisionList(items: items ?? this.items);
  }

  TemplateRevisionList copyWithWrapped(
      {Wrapped<List<TemplateRevision>?>? items}) {
    return TemplateRevisionList(
        items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class UploadList {
  UploadList({
    this.items,
  });

  factory UploadList.fromJson(Map<String, dynamic> json) =>
      _$UploadListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <Upload>[])
  final List<Upload>? items;
  static const fromJsonFactory = _$UploadListFromJson;
  static const toJsonFactory = _$UploadListToJson;
  Map<String, dynamic> toJson() => _$UploadListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UploadList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^ runtimeType.hashCode;
}

extension $UploadListExtension on UploadList {
  UploadList copyWith({List<Upload>? items}) {
    return UploadList(items: items ?? this.items);
  }

  UploadList copyWithWrapped({Wrapped<List<Upload>?>? items}) {
    return UploadList(items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class UploadSchemaList {
  UploadSchemaList({
    this.items,
    this.requestParams,
    this.type,
  });

  factory UploadSchemaList.fromJson(Map<String, dynamic> json) =>
      _$UploadSchemaListFromJson(json);

  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <UploadSchema>[])
  final List<UploadSchema>? items;
  @JsonKey(name: 'requestParams', includeIfNull: false)
  final RequestParams? requestParams;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$UploadSchemaListFromJson;
  static const toJsonFactory = _$UploadSchemaListToJson;
  Map<String, dynamic> toJson() => _$UploadSchemaListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is UploadSchemaList &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.requestParams, requestParams) ||
                const DeepCollectionEquality()
                    .equals(other.requestParams, requestParams)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(requestParams) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $UploadSchemaListExtension on UploadSchemaList {
  UploadSchemaList copyWith(
      {List<UploadSchema>? items, RequestParams? requestParams, String? type}) {
    return UploadSchemaList(
        items: items ?? this.items,
        requestParams: requestParams ?? this.requestParams,
        type: type ?? this.type);
  }

  UploadSchemaList copyWithWrapped(
      {Wrapped<List<UploadSchema>?>? items,
      Wrapped<RequestParams?>? requestParams,
      Wrapped<String?>? type}) {
    return UploadSchemaList(
        items: (items != null ? items.value : this.items),
        requestParams:
            (requestParams != null ? requestParams.value : this.requestParams),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class Constraints {
  Constraints({
    required this.dataType,
    this.required,
    this.type,
  });

  factory Constraints.fromJson(Map<String, dynamic> json) =>
      _$ConstraintsFromJson(json);

  @JsonKey(
    name: 'dataType',
    includeIfNull: false,
    toJson: dataTypeToJson,
    fromJson: dataTypeFromJson,
  )
  final enums.DataType dataType;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool? required;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$ConstraintsFromJson;
  static const toJsonFactory = _$ConstraintsToJson;
  Map<String, dynamic> toJson() => _$ConstraintsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Constraints &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ConstraintsExtension on Constraints {
  Constraints copyWith(
      {enums.DataType? dataType, bool? required, String? type}) {
    return Constraints(
        dataType: dataType ?? this.dataType,
        required: required ?? this.required,
        type: type ?? this.type);
  }

  Constraints copyWithWrapped(
      {Wrapped<enums.DataType>? dataType,
      Wrapped<bool?>? required,
      Wrapped<String?>? type}) {
    return Constraints(
        dataType: (dataType != null ? dataType.value : this.dataType),
        required: (required != null ? required.value : this.required),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class MultiValueConstraints {
  MultiValueConstraints({
    this.allowOther,
    this.allowMultiple,
    required this.enumeration,
    required this.dataType,
    this.required,
    this.type,
  });

  factory MultiValueConstraints.fromJson(Map<String, dynamic> json) =>
      _$MultiValueConstraintsFromJson(json);

  @JsonKey(name: 'allowOther', includeIfNull: false)
  final bool? allowOther;
  @JsonKey(name: 'allowMultiple', includeIfNull: false)
  final bool? allowMultiple;
  @JsonKey(
      name: 'enumeration',
      includeIfNull: false,
      defaultValue: <SurveyQuestionOption>[])
  final List<SurveyQuestionOption> enumeration;
  @JsonKey(
    name: 'dataType',
    includeIfNull: false,
    toJson: dataTypeToJson,
    fromJson: dataTypeFromJson,
  )
  final enums.DataType dataType;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool? required;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$MultiValueConstraintsFromJson;
  static const toJsonFactory = _$MultiValueConstraintsToJson;
  Map<String, dynamic> toJson() => _$MultiValueConstraintsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MultiValueConstraints &&
            (identical(other.allowOther, allowOther) ||
                const DeepCollectionEquality()
                    .equals(other.allowOther, allowOther)) &&
            (identical(other.allowMultiple, allowMultiple) ||
                const DeepCollectionEquality()
                    .equals(other.allowMultiple, allowMultiple)) &&
            (identical(other.enumeration, enumeration) ||
                const DeepCollectionEquality()
                    .equals(other.enumeration, enumeration)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(allowOther) ^
      const DeepCollectionEquality().hash(allowMultiple) ^
      const DeepCollectionEquality().hash(enumeration) ^
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $MultiValueConstraintsExtension on MultiValueConstraints {
  MultiValueConstraints copyWith(
      {bool? allowOther,
      bool? allowMultiple,
      List<SurveyQuestionOption>? enumeration,
      enums.DataType? dataType,
      bool? required,
      String? type}) {
    return MultiValueConstraints(
        allowOther: allowOther ?? this.allowOther,
        allowMultiple: allowMultiple ?? this.allowMultiple,
        enumeration: enumeration ?? this.enumeration,
        dataType: dataType ?? this.dataType,
        required: required ?? this.required,
        type: type ?? this.type);
  }

  MultiValueConstraints copyWithWrapped(
      {Wrapped<bool?>? allowOther,
      Wrapped<bool?>? allowMultiple,
      Wrapped<List<SurveyQuestionOption>>? enumeration,
      Wrapped<enums.DataType>? dataType,
      Wrapped<bool?>? required,
      Wrapped<String?>? type}) {
    return MultiValueConstraints(
        allowOther: (allowOther != null ? allowOther.value : this.allowOther),
        allowMultiple:
            (allowMultiple != null ? allowMultiple.value : this.allowMultiple),
        enumeration:
            (enumeration != null ? enumeration.value : this.enumeration),
        dataType: (dataType != null ? dataType.value : this.dataType),
        required: (required != null ? required.value : this.required),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class BooleanConstraints {
  BooleanConstraints({
    required this.dataType,
    this.required,
    this.type,
  });

  factory BooleanConstraints.fromJson(Map<String, dynamic> json) =>
      _$BooleanConstraintsFromJson(json);

  @JsonKey(
    name: 'dataType',
    includeIfNull: false,
    toJson: dataTypeToJson,
    fromJson: dataTypeFromJson,
  )
  final enums.DataType dataType;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool? required;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$BooleanConstraintsFromJson;
  static const toJsonFactory = _$BooleanConstraintsToJson;
  Map<String, dynamic> toJson() => _$BooleanConstraintsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is BooleanConstraints &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $BooleanConstraintsExtension on BooleanConstraints {
  BooleanConstraints copyWith(
      {enums.DataType? dataType, bool? required, String? type}) {
    return BooleanConstraints(
        dataType: dataType ?? this.dataType,
        required: required ?? this.required,
        type: type ?? this.type);
  }

  BooleanConstraints copyWithWrapped(
      {Wrapped<enums.DataType>? dataType,
      Wrapped<bool?>? required,
      Wrapped<String?>? type}) {
    return BooleanConstraints(
        dataType: (dataType != null ? dataType.value : this.dataType),
        required: (required != null ? required.value : this.required),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class IntegerConstraints {
  IntegerConstraints({
    this.unit,
    this.minValue,
    this.maxValue,
    this.step,
    required this.dataType,
    this.required,
    this.type,
  });

  factory IntegerConstraints.fromJson(Map<String, dynamic> json) =>
      _$IntegerConstraintsFromJson(json);

  @JsonKey(
    name: 'unit',
    includeIfNull: false,
    toJson: unitToJson,
    fromJson: unitFromJson,
  )
  final enums.Unit? unit;
  @JsonKey(name: 'minValue', includeIfNull: false)
  final int? minValue;
  @JsonKey(name: 'maxValue', includeIfNull: false)
  final int? maxValue;
  @JsonKey(name: 'step', includeIfNull: false)
  final int? step;
  @JsonKey(
    name: 'dataType',
    includeIfNull: false,
    toJson: dataTypeToJson,
    fromJson: dataTypeFromJson,
  )
  final enums.DataType dataType;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool? required;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$IntegerConstraintsFromJson;
  static const toJsonFactory = _$IntegerConstraintsToJson;
  Map<String, dynamic> toJson() => _$IntegerConstraintsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is IntegerConstraints &&
            (identical(other.unit, unit) ||
                const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.minValue, minValue) ||
                const DeepCollectionEquality()
                    .equals(other.minValue, minValue)) &&
            (identical(other.maxValue, maxValue) ||
                const DeepCollectionEquality()
                    .equals(other.maxValue, maxValue)) &&
            (identical(other.step, step) ||
                const DeepCollectionEquality().equals(other.step, step)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(unit) ^
      const DeepCollectionEquality().hash(minValue) ^
      const DeepCollectionEquality().hash(maxValue) ^
      const DeepCollectionEquality().hash(step) ^
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $IntegerConstraintsExtension on IntegerConstraints {
  IntegerConstraints copyWith(
      {enums.Unit? unit,
      int? minValue,
      int? maxValue,
      int? step,
      enums.DataType? dataType,
      bool? required,
      String? type}) {
    return IntegerConstraints(
        unit: unit ?? this.unit,
        minValue: minValue ?? this.minValue,
        maxValue: maxValue ?? this.maxValue,
        step: step ?? this.step,
        dataType: dataType ?? this.dataType,
        required: required ?? this.required,
        type: type ?? this.type);
  }

  IntegerConstraints copyWithWrapped(
      {Wrapped<enums.Unit?>? unit,
      Wrapped<int?>? minValue,
      Wrapped<int?>? maxValue,
      Wrapped<int?>? step,
      Wrapped<enums.DataType>? dataType,
      Wrapped<bool?>? required,
      Wrapped<String?>? type}) {
    return IntegerConstraints(
        unit: (unit != null ? unit.value : this.unit),
        minValue: (minValue != null ? minValue.value : this.minValue),
        maxValue: (maxValue != null ? maxValue.value : this.maxValue),
        step: (step != null ? step.value : this.step),
        dataType: (dataType != null ? dataType.value : this.dataType),
        required: (required != null ? required.value : this.required),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class DecimalConstraints {
  DecimalConstraints({
    this.unit,
    this.minValue,
    this.maxValue,
    this.step,
    required this.dataType,
    this.required,
    this.type,
  });

  factory DecimalConstraints.fromJson(Map<String, dynamic> json) =>
      _$DecimalConstraintsFromJson(json);

  @JsonKey(
    name: 'unit',
    includeIfNull: false,
    toJson: unitToJson,
    fromJson: unitFromJson,
  )
  final enums.Unit? unit;
  @JsonKey(name: 'minValue', includeIfNull: false)
  final double? minValue;
  @JsonKey(name: 'maxValue', includeIfNull: false)
  final double? maxValue;
  @JsonKey(name: 'step', includeIfNull: false)
  final double? step;
  @JsonKey(
    name: 'dataType',
    includeIfNull: false,
    toJson: dataTypeToJson,
    fromJson: dataTypeFromJson,
  )
  final enums.DataType dataType;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool? required;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$DecimalConstraintsFromJson;
  static const toJsonFactory = _$DecimalConstraintsToJson;
  Map<String, dynamic> toJson() => _$DecimalConstraintsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DecimalConstraints &&
            (identical(other.unit, unit) ||
                const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.minValue, minValue) ||
                const DeepCollectionEquality()
                    .equals(other.minValue, minValue)) &&
            (identical(other.maxValue, maxValue) ||
                const DeepCollectionEquality()
                    .equals(other.maxValue, maxValue)) &&
            (identical(other.step, step) ||
                const DeepCollectionEquality().equals(other.step, step)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(unit) ^
      const DeepCollectionEquality().hash(minValue) ^
      const DeepCollectionEquality().hash(maxValue) ^
      const DeepCollectionEquality().hash(step) ^
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $DecimalConstraintsExtension on DecimalConstraints {
  DecimalConstraints copyWith(
      {enums.Unit? unit,
      double? minValue,
      double? maxValue,
      double? step,
      enums.DataType? dataType,
      bool? required,
      String? type}) {
    return DecimalConstraints(
        unit: unit ?? this.unit,
        minValue: minValue ?? this.minValue,
        maxValue: maxValue ?? this.maxValue,
        step: step ?? this.step,
        dataType: dataType ?? this.dataType,
        required: required ?? this.required,
        type: type ?? this.type);
  }

  DecimalConstraints copyWithWrapped(
      {Wrapped<enums.Unit?>? unit,
      Wrapped<double?>? minValue,
      Wrapped<double?>? maxValue,
      Wrapped<double?>? step,
      Wrapped<enums.DataType>? dataType,
      Wrapped<bool?>? required,
      Wrapped<String?>? type}) {
    return DecimalConstraints(
        unit: (unit != null ? unit.value : this.unit),
        minValue: (minValue != null ? minValue.value : this.minValue),
        maxValue: (maxValue != null ? maxValue.value : this.maxValue),
        step: (step != null ? step.value : this.step),
        dataType: (dataType != null ? dataType.value : this.dataType),
        required: (required != null ? required.value : this.required),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class StringConstraints {
  StringConstraints({
    this.minLength,
    this.maxLength,
    this.pattern,
    this.patternErrorMessage,
    this.patternPlaceholder,
    required this.dataType,
    this.required,
    this.type,
  });

  factory StringConstraints.fromJson(Map<String, dynamic> json) =>
      _$StringConstraintsFromJson(json);

  @JsonKey(name: 'minLength', includeIfNull: false)
  final int? minLength;
  @JsonKey(name: 'maxLength', includeIfNull: false)
  final int? maxLength;
  @JsonKey(name: 'pattern', includeIfNull: false, defaultValue: '')
  final String? pattern;
  @JsonKey(name: 'patternErrorMessage', includeIfNull: false, defaultValue: '')
  final String? patternErrorMessage;
  @JsonKey(name: 'patternPlaceholder', includeIfNull: false, defaultValue: '')
  final String? patternPlaceholder;
  @JsonKey(
    name: 'dataType',
    includeIfNull: false,
    toJson: dataTypeToJson,
    fromJson: dataTypeFromJson,
  )
  final enums.DataType dataType;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool? required;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$StringConstraintsFromJson;
  static const toJsonFactory = _$StringConstraintsToJson;
  Map<String, dynamic> toJson() => _$StringConstraintsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StringConstraints &&
            (identical(other.minLength, minLength) ||
                const DeepCollectionEquality()
                    .equals(other.minLength, minLength)) &&
            (identical(other.maxLength, maxLength) ||
                const DeepCollectionEquality()
                    .equals(other.maxLength, maxLength)) &&
            (identical(other.pattern, pattern) ||
                const DeepCollectionEquality()
                    .equals(other.pattern, pattern)) &&
            (identical(other.patternErrorMessage, patternErrorMessage) ||
                const DeepCollectionEquality()
                    .equals(other.patternErrorMessage, patternErrorMessage)) &&
            (identical(other.patternPlaceholder, patternPlaceholder) ||
                const DeepCollectionEquality()
                    .equals(other.patternPlaceholder, patternPlaceholder)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(minLength) ^
      const DeepCollectionEquality().hash(maxLength) ^
      const DeepCollectionEquality().hash(pattern) ^
      const DeepCollectionEquality().hash(patternErrorMessage) ^
      const DeepCollectionEquality().hash(patternPlaceholder) ^
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $StringConstraintsExtension on StringConstraints {
  StringConstraints copyWith(
      {int? minLength,
      int? maxLength,
      String? pattern,
      String? patternErrorMessage,
      String? patternPlaceholder,
      enums.DataType? dataType,
      bool? required,
      String? type}) {
    return StringConstraints(
        minLength: minLength ?? this.minLength,
        maxLength: maxLength ?? this.maxLength,
        pattern: pattern ?? this.pattern,
        patternErrorMessage: patternErrorMessage ?? this.patternErrorMessage,
        patternPlaceholder: patternPlaceholder ?? this.patternPlaceholder,
        dataType: dataType ?? this.dataType,
        required: required ?? this.required,
        type: type ?? this.type);
  }

  StringConstraints copyWithWrapped(
      {Wrapped<int?>? minLength,
      Wrapped<int?>? maxLength,
      Wrapped<String?>? pattern,
      Wrapped<String?>? patternErrorMessage,
      Wrapped<String?>? patternPlaceholder,
      Wrapped<enums.DataType>? dataType,
      Wrapped<bool?>? required,
      Wrapped<String?>? type}) {
    return StringConstraints(
        minLength: (minLength != null ? minLength.value : this.minLength),
        maxLength: (maxLength != null ? maxLength.value : this.maxLength),
        pattern: (pattern != null ? pattern.value : this.pattern),
        patternErrorMessage: (patternErrorMessage != null
            ? patternErrorMessage.value
            : this.patternErrorMessage),
        patternPlaceholder: (patternPlaceholder != null
            ? patternPlaceholder.value
            : this.patternPlaceholder),
        dataType: (dataType != null ? dataType.value : this.dataType),
        required: (required != null ? required.value : this.required),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class DateTimeConstraints {
  DateTimeConstraints({
    this.allowFuture,
    this.allowPast,
    this.earliestValue,
    this.latestValue,
    required this.dataType,
    this.required,
    this.type,
  });

  factory DateTimeConstraints.fromJson(Map<String, dynamic> json) =>
      _$DateTimeConstraintsFromJson(json);

  @JsonKey(name: 'allowFuture', includeIfNull: false, defaultValue: false)
  final bool? allowFuture;
  @JsonKey(name: 'allowPast', includeIfNull: false, defaultValue: true)
  final bool? allowPast;
  @JsonKey(name: 'earliestValue', includeIfNull: false)
  final DateTime? earliestValue;
  @JsonKey(name: 'latestValue', includeIfNull: false)
  final DateTime? latestValue;
  @JsonKey(
    name: 'dataType',
    includeIfNull: false,
    toJson: dataTypeToJson,
    fromJson: dataTypeFromJson,
  )
  final enums.DataType dataType;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool? required;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$DateTimeConstraintsFromJson;
  static const toJsonFactory = _$DateTimeConstraintsToJson;
  Map<String, dynamic> toJson() => _$DateTimeConstraintsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DateTimeConstraints &&
            (identical(other.allowFuture, allowFuture) ||
                const DeepCollectionEquality()
                    .equals(other.allowFuture, allowFuture)) &&
            (identical(other.allowPast, allowPast) ||
                const DeepCollectionEquality()
                    .equals(other.allowPast, allowPast)) &&
            (identical(other.earliestValue, earliestValue) ||
                const DeepCollectionEquality()
                    .equals(other.earliestValue, earliestValue)) &&
            (identical(other.latestValue, latestValue) ||
                const DeepCollectionEquality()
                    .equals(other.latestValue, latestValue)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(allowFuture) ^
      const DeepCollectionEquality().hash(allowPast) ^
      const DeepCollectionEquality().hash(earliestValue) ^
      const DeepCollectionEquality().hash(latestValue) ^
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $DateTimeConstraintsExtension on DateTimeConstraints {
  DateTimeConstraints copyWith(
      {bool? allowFuture,
      bool? allowPast,
      DateTime? earliestValue,
      DateTime? latestValue,
      enums.DataType? dataType,
      bool? required,
      String? type}) {
    return DateTimeConstraints(
        allowFuture: allowFuture ?? this.allowFuture,
        allowPast: allowPast ?? this.allowPast,
        earliestValue: earliestValue ?? this.earliestValue,
        latestValue: latestValue ?? this.latestValue,
        dataType: dataType ?? this.dataType,
        required: required ?? this.required,
        type: type ?? this.type);
  }

  DateTimeConstraints copyWithWrapped(
      {Wrapped<bool?>? allowFuture,
      Wrapped<bool?>? allowPast,
      Wrapped<DateTime?>? earliestValue,
      Wrapped<DateTime?>? latestValue,
      Wrapped<enums.DataType>? dataType,
      Wrapped<bool?>? required,
      Wrapped<String?>? type}) {
    return DateTimeConstraints(
        allowFuture:
            (allowFuture != null ? allowFuture.value : this.allowFuture),
        allowPast: (allowPast != null ? allowPast.value : this.allowPast),
        earliestValue:
            (earliestValue != null ? earliestValue.value : this.earliestValue),
        latestValue:
            (latestValue != null ? latestValue.value : this.latestValue),
        dataType: (dataType != null ? dataType.value : this.dataType),
        required: (required != null ? required.value : this.required),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class DateConstraints {
  DateConstraints({
    this.allowFuture,
    this.allowPast,
    this.earliestValue,
    this.latestValue,
    required this.dataType,
    this.required,
    this.type,
  });

  factory DateConstraints.fromJson(Map<String, dynamic> json) =>
      _$DateConstraintsFromJson(json);

  @JsonKey(name: 'allowFuture', includeIfNull: false, defaultValue: false)
  final bool? allowFuture;
  @JsonKey(name: 'allowPast', includeIfNull: false, defaultValue: true)
  final bool? allowPast;
  @JsonKey(name: 'earliestValue', includeIfNull: false, toJson: _dateToJson)
  final DateTime? earliestValue;
  @JsonKey(name: 'latestValue', includeIfNull: false, toJson: _dateToJson)
  final DateTime? latestValue;
  @JsonKey(
    name: 'dataType',
    includeIfNull: false,
    toJson: dataTypeToJson,
    fromJson: dataTypeFromJson,
  )
  final enums.DataType dataType;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool? required;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$DateConstraintsFromJson;
  static const toJsonFactory = _$DateConstraintsToJson;
  Map<String, dynamic> toJson() => _$DateConstraintsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DateConstraints &&
            (identical(other.allowFuture, allowFuture) ||
                const DeepCollectionEquality()
                    .equals(other.allowFuture, allowFuture)) &&
            (identical(other.allowPast, allowPast) ||
                const DeepCollectionEquality()
                    .equals(other.allowPast, allowPast)) &&
            (identical(other.earliestValue, earliestValue) ||
                const DeepCollectionEquality()
                    .equals(other.earliestValue, earliestValue)) &&
            (identical(other.latestValue, latestValue) ||
                const DeepCollectionEquality()
                    .equals(other.latestValue, latestValue)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(allowFuture) ^
      const DeepCollectionEquality().hash(allowPast) ^
      const DeepCollectionEquality().hash(earliestValue) ^
      const DeepCollectionEquality().hash(latestValue) ^
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $DateConstraintsExtension on DateConstraints {
  DateConstraints copyWith(
      {bool? allowFuture,
      bool? allowPast,
      DateTime? earliestValue,
      DateTime? latestValue,
      enums.DataType? dataType,
      bool? required,
      String? type}) {
    return DateConstraints(
        allowFuture: allowFuture ?? this.allowFuture,
        allowPast: allowPast ?? this.allowPast,
        earliestValue: earliestValue ?? this.earliestValue,
        latestValue: latestValue ?? this.latestValue,
        dataType: dataType ?? this.dataType,
        required: required ?? this.required,
        type: type ?? this.type);
  }

  DateConstraints copyWithWrapped(
      {Wrapped<bool?>? allowFuture,
      Wrapped<bool?>? allowPast,
      Wrapped<DateTime?>? earliestValue,
      Wrapped<DateTime?>? latestValue,
      Wrapped<enums.DataType>? dataType,
      Wrapped<bool?>? required,
      Wrapped<String?>? type}) {
    return DateConstraints(
        allowFuture:
            (allowFuture != null ? allowFuture.value : this.allowFuture),
        allowPast: (allowPast != null ? allowPast.value : this.allowPast),
        earliestValue:
            (earliestValue != null ? earliestValue.value : this.earliestValue),
        latestValue:
            (latestValue != null ? latestValue.value : this.latestValue),
        dataType: (dataType != null ? dataType.value : this.dataType),
        required: (required != null ? required.value : this.required),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class PostalCodeConstraints {
  PostalCodeConstraints({
    required this.countryCode,
    this.sparseZipCodePrefixes,
    required this.dataType,
    this.required,
    this.type,
  });

  factory PostalCodeConstraints.fromJson(Map<String, dynamic> json) =>
      _$PostalCodeConstraintsFromJson(json);

  @JsonKey(
    name: 'countryCode',
    includeIfNull: false,
    toJson: countryCodeToJson,
    fromJson: countryCodeFromJson,
  )
  final enums.CountryCode countryCode;
  @JsonKey(
      name: 'sparseZipCodePrefixes',
      includeIfNull: false,
      defaultValue: <String>[])
  final List<String>? sparseZipCodePrefixes;
  @JsonKey(
    name: 'dataType',
    includeIfNull: false,
    toJson: dataTypeToJson,
    fromJson: dataTypeFromJson,
  )
  final enums.DataType dataType;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool? required;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$PostalCodeConstraintsFromJson;
  static const toJsonFactory = _$PostalCodeConstraintsToJson;
  Map<String, dynamic> toJson() => _$PostalCodeConstraintsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is PostalCodeConstraints &&
            (identical(other.countryCode, countryCode) ||
                const DeepCollectionEquality()
                    .equals(other.countryCode, countryCode)) &&
            (identical(other.sparseZipCodePrefixes, sparseZipCodePrefixes) ||
                const DeepCollectionEquality().equals(
                    other.sparseZipCodePrefixes, sparseZipCodePrefixes)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(countryCode) ^
      const DeepCollectionEquality().hash(sparseZipCodePrefixes) ^
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $PostalCodeConstraintsExtension on PostalCodeConstraints {
  PostalCodeConstraints copyWith(
      {enums.CountryCode? countryCode,
      List<String>? sparseZipCodePrefixes,
      enums.DataType? dataType,
      bool? required,
      String? type}) {
    return PostalCodeConstraints(
        countryCode: countryCode ?? this.countryCode,
        sparseZipCodePrefixes:
            sparseZipCodePrefixes ?? this.sparseZipCodePrefixes,
        dataType: dataType ?? this.dataType,
        required: required ?? this.required,
        type: type ?? this.type);
  }

  PostalCodeConstraints copyWithWrapped(
      {Wrapped<enums.CountryCode>? countryCode,
      Wrapped<List<String>?>? sparseZipCodePrefixes,
      Wrapped<enums.DataType>? dataType,
      Wrapped<bool?>? required,
      Wrapped<String?>? type}) {
    return PostalCodeConstraints(
        countryCode:
            (countryCode != null ? countryCode.value : this.countryCode),
        sparseZipCodePrefixes: (sparseZipCodePrefixes != null
            ? sparseZipCodePrefixes.value
            : this.sparseZipCodePrefixes),
        dataType: (dataType != null ? dataType.value : this.dataType),
        required: (required != null ? required.value : this.required),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class YearMonthConstraints {
  YearMonthConstraints({
    this.allowFuture,
    this.allowPast,
    this.earliestValue,
    this.latestValue,
    required this.dataType,
    this.required,
    this.type,
  });

  factory YearMonthConstraints.fromJson(Map<String, dynamic> json) =>
      _$YearMonthConstraintsFromJson(json);

  @JsonKey(name: 'allowFuture', includeIfNull: false, defaultValue: false)
  final bool? allowFuture;
  @JsonKey(name: 'allowPast', includeIfNull: false, defaultValue: true)
  final bool? allowPast;
  @JsonKey(name: 'earliestValue', includeIfNull: false, defaultValue: '')
  final String? earliestValue;
  @JsonKey(name: 'latestValue', includeIfNull: false, defaultValue: '')
  final String? latestValue;
  @JsonKey(
    name: 'dataType',
    includeIfNull: false,
    toJson: dataTypeToJson,
    fromJson: dataTypeFromJson,
  )
  final enums.DataType dataType;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool? required;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$YearMonthConstraintsFromJson;
  static const toJsonFactory = _$YearMonthConstraintsToJson;
  Map<String, dynamic> toJson() => _$YearMonthConstraintsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is YearMonthConstraints &&
            (identical(other.allowFuture, allowFuture) ||
                const DeepCollectionEquality()
                    .equals(other.allowFuture, allowFuture)) &&
            (identical(other.allowPast, allowPast) ||
                const DeepCollectionEquality()
                    .equals(other.allowPast, allowPast)) &&
            (identical(other.earliestValue, earliestValue) ||
                const DeepCollectionEquality()
                    .equals(other.earliestValue, earliestValue)) &&
            (identical(other.latestValue, latestValue) ||
                const DeepCollectionEquality()
                    .equals(other.latestValue, latestValue)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(allowFuture) ^
      const DeepCollectionEquality().hash(allowPast) ^
      const DeepCollectionEquality().hash(earliestValue) ^
      const DeepCollectionEquality().hash(latestValue) ^
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $YearMonthConstraintsExtension on YearMonthConstraints {
  YearMonthConstraints copyWith(
      {bool? allowFuture,
      bool? allowPast,
      String? earliestValue,
      String? latestValue,
      enums.DataType? dataType,
      bool? required,
      String? type}) {
    return YearMonthConstraints(
        allowFuture: allowFuture ?? this.allowFuture,
        allowPast: allowPast ?? this.allowPast,
        earliestValue: earliestValue ?? this.earliestValue,
        latestValue: latestValue ?? this.latestValue,
        dataType: dataType ?? this.dataType,
        required: required ?? this.required,
        type: type ?? this.type);
  }

  YearMonthConstraints copyWithWrapped(
      {Wrapped<bool?>? allowFuture,
      Wrapped<bool?>? allowPast,
      Wrapped<String?>? earliestValue,
      Wrapped<String?>? latestValue,
      Wrapped<enums.DataType>? dataType,
      Wrapped<bool?>? required,
      Wrapped<String?>? type}) {
    return YearMonthConstraints(
        allowFuture:
            (allowFuture != null ? allowFuture.value : this.allowFuture),
        allowPast: (allowPast != null ? allowPast.value : this.allowPast),
        earliestValue:
            (earliestValue != null ? earliestValue.value : this.earliestValue),
        latestValue:
            (latestValue != null ? latestValue.value : this.latestValue),
        dataType: (dataType != null ? dataType.value : this.dataType),
        required: (required != null ? required.value : this.required),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class YearConstraints {
  YearConstraints({
    this.allowFuture,
    this.allowPast,
    this.earliestValue,
    this.latestValue,
    required this.dataType,
    this.required,
    this.type,
  });

  factory YearConstraints.fromJson(Map<String, dynamic> json) =>
      _$YearConstraintsFromJson(json);

  @JsonKey(name: 'allowFuture', includeIfNull: false, defaultValue: false)
  final bool? allowFuture;
  @JsonKey(name: 'allowPast', includeIfNull: false, defaultValue: true)
  final bool? allowPast;
  @JsonKey(name: 'earliestValue', includeIfNull: false, defaultValue: '')
  final String? earliestValue;
  @JsonKey(name: 'latestValue', includeIfNull: false, defaultValue: '')
  final String? latestValue;
  @JsonKey(
    name: 'dataType',
    includeIfNull: false,
    toJson: dataTypeToJson,
    fromJson: dataTypeFromJson,
  )
  final enums.DataType dataType;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool? required;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$YearConstraintsFromJson;
  static const toJsonFactory = _$YearConstraintsToJson;
  Map<String, dynamic> toJson() => _$YearConstraintsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is YearConstraints &&
            (identical(other.allowFuture, allowFuture) ||
                const DeepCollectionEquality()
                    .equals(other.allowFuture, allowFuture)) &&
            (identical(other.allowPast, allowPast) ||
                const DeepCollectionEquality()
                    .equals(other.allowPast, allowPast)) &&
            (identical(other.earliestValue, earliestValue) ||
                const DeepCollectionEquality()
                    .equals(other.earliestValue, earliestValue)) &&
            (identical(other.latestValue, latestValue) ||
                const DeepCollectionEquality()
                    .equals(other.latestValue, latestValue)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(allowFuture) ^
      const DeepCollectionEquality().hash(allowPast) ^
      const DeepCollectionEquality().hash(earliestValue) ^
      const DeepCollectionEquality().hash(latestValue) ^
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $YearConstraintsExtension on YearConstraints {
  YearConstraints copyWith(
      {bool? allowFuture,
      bool? allowPast,
      String? earliestValue,
      String? latestValue,
      enums.DataType? dataType,
      bool? required,
      String? type}) {
    return YearConstraints(
        allowFuture: allowFuture ?? this.allowFuture,
        allowPast: allowPast ?? this.allowPast,
        earliestValue: earliestValue ?? this.earliestValue,
        latestValue: latestValue ?? this.latestValue,
        dataType: dataType ?? this.dataType,
        required: required ?? this.required,
        type: type ?? this.type);
  }

  YearConstraints copyWithWrapped(
      {Wrapped<bool?>? allowFuture,
      Wrapped<bool?>? allowPast,
      Wrapped<String?>? earliestValue,
      Wrapped<String?>? latestValue,
      Wrapped<enums.DataType>? dataType,
      Wrapped<bool?>? required,
      Wrapped<String?>? type}) {
    return YearConstraints(
        allowFuture:
            (allowFuture != null ? allowFuture.value : this.allowFuture),
        allowPast: (allowPast != null ? allowPast.value : this.allowPast),
        earliestValue:
            (earliestValue != null ? earliestValue.value : this.earliestValue),
        latestValue:
            (latestValue != null ? latestValue.value : this.latestValue),
        dataType: (dataType != null ? dataType.value : this.dataType),
        required: (required != null ? required.value : this.required),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class TimeConstraints {
  TimeConstraints({
    required this.dataType,
    this.required,
    this.type,
  });

  factory TimeConstraints.fromJson(Map<String, dynamic> json) =>
      _$TimeConstraintsFromJson(json);

  @JsonKey(
    name: 'dataType',
    includeIfNull: false,
    toJson: dataTypeToJson,
    fromJson: dataTypeFromJson,
  )
  final enums.DataType dataType;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool? required;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$TimeConstraintsFromJson;
  static const toJsonFactory = _$TimeConstraintsToJson;
  Map<String, dynamic> toJson() => _$TimeConstraintsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TimeConstraints &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $TimeConstraintsExtension on TimeConstraints {
  TimeConstraints copyWith(
      {enums.DataType? dataType, bool? required, String? type}) {
    return TimeConstraints(
        dataType: dataType ?? this.dataType,
        required: required ?? this.required,
        type: type ?? this.type);
  }

  TimeConstraints copyWithWrapped(
      {Wrapped<enums.DataType>? dataType,
      Wrapped<bool?>? required,
      Wrapped<String?>? type}) {
    return TimeConstraints(
        dataType: (dataType != null ? dataType.value : this.dataType),
        required: (required != null ? required.value : this.required),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class DurationConstraints {
  DurationConstraints({
    required this.unit,
    this.minValue,
    this.maxValue,
    this.step,
    required this.dataType,
    this.required,
    this.type,
  });

  factory DurationConstraints.fromJson(Map<String, dynamic> json) =>
      _$DurationConstraintsFromJson(json);

  @JsonKey(
    name: 'unit',
    includeIfNull: false,
    toJson: unitToJson,
    fromJson: unitFromJson,
  )
  final enums.Unit unit;
  @JsonKey(name: 'minValue', includeIfNull: false)
  final int? minValue;
  @JsonKey(name: 'maxValue', includeIfNull: false)
  final int? maxValue;
  @JsonKey(name: 'step', includeIfNull: false)
  final int? step;
  @JsonKey(
    name: 'dataType',
    includeIfNull: false,
    toJson: dataTypeToJson,
    fromJson: dataTypeFromJson,
  )
  final enums.DataType dataType;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool? required;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$DurationConstraintsFromJson;
  static const toJsonFactory = _$DurationConstraintsToJson;
  Map<String, dynamic> toJson() => _$DurationConstraintsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is DurationConstraints &&
            (identical(other.unit, unit) ||
                const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.minValue, minValue) ||
                const DeepCollectionEquality()
                    .equals(other.minValue, minValue)) &&
            (identical(other.maxValue, maxValue) ||
                const DeepCollectionEquality()
                    .equals(other.maxValue, maxValue)) &&
            (identical(other.step, step) ||
                const DeepCollectionEquality().equals(other.step, step)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(unit) ^
      const DeepCollectionEquality().hash(minValue) ^
      const DeepCollectionEquality().hash(maxValue) ^
      const DeepCollectionEquality().hash(step) ^
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $DurationConstraintsExtension on DurationConstraints {
  DurationConstraints copyWith(
      {enums.Unit? unit,
      int? minValue,
      int? maxValue,
      int? step,
      enums.DataType? dataType,
      bool? required,
      String? type}) {
    return DurationConstraints(
        unit: unit ?? this.unit,
        minValue: minValue ?? this.minValue,
        maxValue: maxValue ?? this.maxValue,
        step: step ?? this.step,
        dataType: dataType ?? this.dataType,
        required: required ?? this.required,
        type: type ?? this.type);
  }

  DurationConstraints copyWithWrapped(
      {Wrapped<enums.Unit>? unit,
      Wrapped<int?>? minValue,
      Wrapped<int?>? maxValue,
      Wrapped<int?>? step,
      Wrapped<enums.DataType>? dataType,
      Wrapped<bool?>? required,
      Wrapped<String?>? type}) {
    return DurationConstraints(
        unit: (unit != null ? unit.value : this.unit),
        minValue: (minValue != null ? minValue.value : this.minValue),
        maxValue: (maxValue != null ? maxValue.value : this.maxValue),
        step: (step != null ? step.value : this.step),
        dataType: (dataType != null ? dataType.value : this.dataType),
        required: (required != null ? required.value : this.required),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class BloodPressureConstraints {
  BloodPressureConstraints({
    this.unit,
    required this.dataType,
    this.required,
    this.type,
  });

  factory BloodPressureConstraints.fromJson(Map<String, dynamic> json) =>
      _$BloodPressureConstraintsFromJson(json);

  @JsonKey(
    name: 'unit',
    includeIfNull: false,
    toJson: unitToJson,
    fromJson: unitFromJson,
  )
  final enums.Unit? unit;
  @JsonKey(
    name: 'dataType',
    includeIfNull: false,
    toJson: dataTypeToJson,
    fromJson: dataTypeFromJson,
  )
  final enums.DataType dataType;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool? required;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$BloodPressureConstraintsFromJson;
  static const toJsonFactory = _$BloodPressureConstraintsToJson;
  Map<String, dynamic> toJson() => _$BloodPressureConstraintsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is BloodPressureConstraints &&
            (identical(other.unit, unit) ||
                const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(unit) ^
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $BloodPressureConstraintsExtension on BloodPressureConstraints {
  BloodPressureConstraints copyWith(
      {enums.Unit? unit,
      enums.DataType? dataType,
      bool? required,
      String? type}) {
    return BloodPressureConstraints(
        unit: unit ?? this.unit,
        dataType: dataType ?? this.dataType,
        required: required ?? this.required,
        type: type ?? this.type);
  }

  BloodPressureConstraints copyWithWrapped(
      {Wrapped<enums.Unit?>? unit,
      Wrapped<enums.DataType>? dataType,
      Wrapped<bool?>? required,
      Wrapped<String?>? type}) {
    return BloodPressureConstraints(
        unit: (unit != null ? unit.value : this.unit),
        dataType: (dataType != null ? dataType.value : this.dataType),
        required: (required != null ? required.value : this.required),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class HeightConstraints {
  HeightConstraints({
    this.unit,
    this.forInfant,
    required this.dataType,
    this.required,
    this.type,
  });

  factory HeightConstraints.fromJson(Map<String, dynamic> json) =>
      _$HeightConstraintsFromJson(json);

  @JsonKey(
    name: 'unit',
    includeIfNull: false,
    toJson: unitToJson,
    fromJson: unitFromJson,
  )
  final enums.Unit? unit;
  @JsonKey(name: 'forInfant', includeIfNull: false)
  final bool? forInfant;
  @JsonKey(
    name: 'dataType',
    includeIfNull: false,
    toJson: dataTypeToJson,
    fromJson: dataTypeFromJson,
  )
  final enums.DataType dataType;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool? required;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$HeightConstraintsFromJson;
  static const toJsonFactory = _$HeightConstraintsToJson;
  Map<String, dynamic> toJson() => _$HeightConstraintsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is HeightConstraints &&
            (identical(other.unit, unit) ||
                const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.forInfant, forInfant) ||
                const DeepCollectionEquality()
                    .equals(other.forInfant, forInfant)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(unit) ^
      const DeepCollectionEquality().hash(forInfant) ^
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $HeightConstraintsExtension on HeightConstraints {
  HeightConstraints copyWith(
      {enums.Unit? unit,
      bool? forInfant,
      enums.DataType? dataType,
      bool? required,
      String? type}) {
    return HeightConstraints(
        unit: unit ?? this.unit,
        forInfant: forInfant ?? this.forInfant,
        dataType: dataType ?? this.dataType,
        required: required ?? this.required,
        type: type ?? this.type);
  }

  HeightConstraints copyWithWrapped(
      {Wrapped<enums.Unit?>? unit,
      Wrapped<bool?>? forInfant,
      Wrapped<enums.DataType>? dataType,
      Wrapped<bool?>? required,
      Wrapped<String?>? type}) {
    return HeightConstraints(
        unit: (unit != null ? unit.value : this.unit),
        forInfant: (forInfant != null ? forInfant.value : this.forInfant),
        dataType: (dataType != null ? dataType.value : this.dataType),
        required: (required != null ? required.value : this.required),
        type: (type != null ? type.value : this.type));
  }
}

@JsonSerializable(explicitToJson: true)
class WeightConstraints {
  WeightConstraints({
    this.unit,
    this.forInfant,
    required this.dataType,
    this.required,
    this.type,
  });

  factory WeightConstraints.fromJson(Map<String, dynamic> json) =>
      _$WeightConstraintsFromJson(json);

  @JsonKey(
    name: 'unit',
    includeIfNull: false,
    toJson: unitToJson,
    fromJson: unitFromJson,
  )
  final enums.Unit? unit;
  @JsonKey(name: 'forInfant', includeIfNull: false)
  final bool? forInfant;
  @JsonKey(
    name: 'dataType',
    includeIfNull: false,
    toJson: dataTypeToJson,
    fromJson: dataTypeFromJson,
  )
  final enums.DataType dataType;
  @JsonKey(name: 'required', includeIfNull: false)
  final bool? required;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  static const fromJsonFactory = _$WeightConstraintsFromJson;
  static const toJsonFactory = _$WeightConstraintsToJson;
  Map<String, dynamic> toJson() => _$WeightConstraintsToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WeightConstraints &&
            (identical(other.unit, unit) ||
                const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.forInfant, forInfant) ||
                const DeepCollectionEquality()
                    .equals(other.forInfant, forInfant)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.required, required) ||
                const DeepCollectionEquality()
                    .equals(other.required, required)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(unit) ^
      const DeepCollectionEquality().hash(forInfant) ^
      const DeepCollectionEquality().hash(dataType) ^
      const DeepCollectionEquality().hash(required) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $WeightConstraintsExtension on WeightConstraints {
  WeightConstraints copyWith(
      {enums.Unit? unit,
      bool? forInfant,
      enums.DataType? dataType,
      bool? required,
      String? type}) {
    return WeightConstraints(
        unit: unit ?? this.unit,
        forInfant: forInfant ?? this.forInfant,
        dataType: dataType ?? this.dataType,
        required: required ?? this.required,
        type: type ?? this.type);
  }

  WeightConstraints copyWithWrapped(
      {Wrapped<enums.Unit?>? unit,
      Wrapped<bool?>? forInfant,
      Wrapped<enums.DataType>? dataType,
      Wrapped<bool?>? required,
      Wrapped<String?>? type}) {
    return WeightConstraints(
        unit: (unit != null ? unit.value : this.unit),
        forInfant: (forInfant != null ? forInfant.value : this.forInfant),
        dataType: (dataType != null ? dataType.value : this.dataType),
        required: (required != null ? required.value : this.required),
        type: (type != null ? type.value : this.type));
  }
}

String? sharingScopeToJson(enums.SharingScope? sharingScope) {
  return enums.$SharingScopeMap[sharingScope];
}

enums.SharingScope sharingScopeFromJson(
  Object? sharingScope, [
  enums.SharingScope? defaultValue,
]) {
  if (sharingScope is String) {
    return enums.$SharingScopeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == sharingScope.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.SharingScope.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SharingScopeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SharingScope.swaggerGeneratedUnknown;
}

List<String> sharingScopeListToJson(List<enums.SharingScope>? sharingScope) {
  if (sharingScope == null) {
    return [];
  }

  return sharingScope.map((e) => enums.$SharingScopeMap[e]!).toList();
}

List<enums.SharingScope> sharingScopeListFromJson(
  List? sharingScope, [
  List<enums.SharingScope>? defaultValue,
]) {
  if (sharingScope == null) {
    return defaultValue ?? [];
  }

  return sharingScope.map((e) => sharingScopeFromJson(e.toString())).toList();
}

List<enums.SharingScope>? sharingScopeNullableListFromJson(
  List? sharingScope, [
  List<enums.SharingScope>? defaultValue,
]) {
  if (sharingScope == null) {
    return defaultValue;
  }

  return sharingScope.map((e) => sharingScopeFromJson(e.toString())).toList();
}

String? accountStatusToJson(enums.AccountStatus? accountStatus) {
  return enums.$AccountStatusMap[accountStatus];
}

enums.AccountStatus accountStatusFromJson(
  Object? accountStatus, [
  enums.AccountStatus? defaultValue,
]) {
  if (accountStatus is String) {
    return enums.$AccountStatusMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == accountStatus.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.AccountStatus.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$AccountStatusMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.AccountStatus.swaggerGeneratedUnknown;
}

List<String> accountStatusListToJson(List<enums.AccountStatus>? accountStatus) {
  if (accountStatus == null) {
    return [];
  }

  return accountStatus.map((e) => enums.$AccountStatusMap[e]!).toList();
}

List<enums.AccountStatus> accountStatusListFromJson(
  List? accountStatus, [
  List<enums.AccountStatus>? defaultValue,
]) {
  if (accountStatus == null) {
    return defaultValue ?? [];
  }

  return accountStatus.map((e) => accountStatusFromJson(e.toString())).toList();
}

List<enums.AccountStatus>? accountStatusNullableListFromJson(
  List? accountStatus, [
  List<enums.AccountStatus>? defaultValue,
]) {
  if (accountStatus == null) {
    return defaultValue;
  }

  return accountStatus.map((e) => accountStatusFromJson(e.toString())).toList();
}

String? activityEventUpdateTypeToJson(
    enums.ActivityEventUpdateType? activityEventUpdateType) {
  return enums.$ActivityEventUpdateTypeMap[activityEventUpdateType];
}

enums.ActivityEventUpdateType activityEventUpdateTypeFromJson(
  Object? activityEventUpdateType, [
  enums.ActivityEventUpdateType? defaultValue,
]) {
  if (activityEventUpdateType is String) {
    return enums.$ActivityEventUpdateTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                activityEventUpdateType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ActivityEventUpdateType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ActivityEventUpdateTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ActivityEventUpdateType.swaggerGeneratedUnknown;
}

List<String> activityEventUpdateTypeListToJson(
    List<enums.ActivityEventUpdateType>? activityEventUpdateType) {
  if (activityEventUpdateType == null) {
    return [];
  }

  return activityEventUpdateType
      .map((e) => enums.$ActivityEventUpdateTypeMap[e]!)
      .toList();
}

List<enums.ActivityEventUpdateType> activityEventUpdateTypeListFromJson(
  List? activityEventUpdateType, [
  List<enums.ActivityEventUpdateType>? defaultValue,
]) {
  if (activityEventUpdateType == null) {
    return defaultValue ?? [];
  }

  return activityEventUpdateType
      .map((e) => activityEventUpdateTypeFromJson(e.toString()))
      .toList();
}

List<enums.ActivityEventUpdateType>?
    activityEventUpdateTypeNullableListFromJson(
  List? activityEventUpdateType, [
  List<enums.ActivityEventUpdateType>? defaultValue,
]) {
  if (activityEventUpdateType == null) {
    return defaultValue;
  }

  return activityEventUpdateType
      .map((e) => activityEventUpdateTypeFromJson(e.toString()))
      .toList();
}

String? contactRoleToJson(enums.ContactRole? contactRole) {
  return enums.$ContactRoleMap[contactRole];
}

enums.ContactRole contactRoleFromJson(
  Object? contactRole, [
  enums.ContactRole? defaultValue,
]) {
  if (contactRole is String) {
    return enums.$ContactRoleMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == contactRole.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.ContactRole.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ContactRoleMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ContactRole.swaggerGeneratedUnknown;
}

List<String> contactRoleListToJson(List<enums.ContactRole>? contactRole) {
  if (contactRole == null) {
    return [];
  }

  return contactRole.map((e) => enums.$ContactRoleMap[e]!).toList();
}

List<enums.ContactRole> contactRoleListFromJson(
  List? contactRole, [
  List<enums.ContactRole>? defaultValue,
]) {
  if (contactRole == null) {
    return defaultValue ?? [];
  }

  return contactRole.map((e) => contactRoleFromJson(e.toString())).toList();
}

List<enums.ContactRole>? contactRoleNullableListFromJson(
  List? contactRole, [
  List<enums.ContactRole>? defaultValue,
]) {
  if (contactRole == null) {
    return defaultValue;
  }

  return contactRole.map((e) => contactRoleFromJson(e.toString())).toList();
}

String? countryCodeToJson(enums.CountryCode? countryCode) {
  return enums.$CountryCodeMap[countryCode];
}

enums.CountryCode countryCodeFromJson(
  Object? countryCode, [
  enums.CountryCode? defaultValue,
]) {
  if (countryCode is String) {
    return enums.$CountryCodeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == countryCode.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.CountryCode.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CountryCodeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CountryCode.swaggerGeneratedUnknown;
}

List<String> countryCodeListToJson(List<enums.CountryCode>? countryCode) {
  if (countryCode == null) {
    return [];
  }

  return countryCode.map((e) => enums.$CountryCodeMap[e]!).toList();
}

List<enums.CountryCode> countryCodeListFromJson(
  List? countryCode, [
  List<enums.CountryCode>? defaultValue,
]) {
  if (countryCode == null) {
    return defaultValue ?? [];
  }

  return countryCode.map((e) => countryCodeFromJson(e.toString())).toList();
}

List<enums.CountryCode>? countryCodeNullableListFromJson(
  List? countryCode, [
  List<enums.CountryCode>? defaultValue,
]) {
  if (countryCode == null) {
    return defaultValue;
  }

  return countryCode.map((e) => countryCodeFromJson(e.toString())).toList();
}

String? dataTypeToJson(enums.DataType? dataType) {
  return enums.$DataTypeMap[dataType];
}

enums.DataType dataTypeFromJson(
  Object? dataType, [
  enums.DataType? defaultValue,
]) {
  if (dataType is String) {
    return enums.$DataTypeMap.entries
        .firstWhere(
            (element) => element.value.toLowerCase() == dataType.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.DataType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$DataTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ?? defaultValue ?? enums.DataType.swaggerGeneratedUnknown;
}

List<String> dataTypeListToJson(List<enums.DataType>? dataType) {
  if (dataType == null) {
    return [];
  }

  return dataType.map((e) => enums.$DataTypeMap[e]!).toList();
}

List<enums.DataType> dataTypeListFromJson(
  List? dataType, [
  List<enums.DataType>? defaultValue,
]) {
  if (dataType == null) {
    return defaultValue ?? [];
  }

  return dataType.map((e) => dataTypeFromJson(e.toString())).toList();
}

List<enums.DataType>? dataTypeNullableListFromJson(
  List? dataType, [
  List<enums.DataType>? defaultValue,
]) {
  if (dataType == null) {
    return defaultValue;
  }

  return dataType.map((e) => dataTypeFromJson(e.toString())).toList();
}

String? enrollmentFilterToJson(enums.EnrollmentFilter? enrollmentFilter) {
  return enums.$EnrollmentFilterMap[enrollmentFilter];
}

enums.EnrollmentFilter enrollmentFilterFromJson(
  Object? enrollmentFilter, [
  enums.EnrollmentFilter? defaultValue,
]) {
  if (enrollmentFilter is String) {
    return enums.$EnrollmentFilterMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == enrollmentFilter.toLowerCase(),
            orElse: () => const MapEntry(
                enums.EnrollmentFilter.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$EnrollmentFilterMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.EnrollmentFilter.swaggerGeneratedUnknown;
}

List<String> enrollmentFilterListToJson(
    List<enums.EnrollmentFilter>? enrollmentFilter) {
  if (enrollmentFilter == null) {
    return [];
  }

  return enrollmentFilter.map((e) => enums.$EnrollmentFilterMap[e]!).toList();
}

List<enums.EnrollmentFilter> enrollmentFilterListFromJson(
  List? enrollmentFilter, [
  List<enums.EnrollmentFilter>? defaultValue,
]) {
  if (enrollmentFilter == null) {
    return defaultValue ?? [];
  }

  return enrollmentFilter
      .map((e) => enrollmentFilterFromJson(e.toString()))
      .toList();
}

List<enums.EnrollmentFilter>? enrollmentFilterNullableListFromJson(
  List? enrollmentFilter, [
  List<enums.EnrollmentFilter>? defaultValue,
]) {
  if (enrollmentFilter == null) {
    return defaultValue;
  }

  return enrollmentFilter
      .map((e) => enrollmentFilterFromJson(e.toString()))
      .toList();
}

String? environmentToJson(enums.Environment? environment) {
  return enums.$EnvironmentMap[environment];
}

enums.Environment environmentFromJson(
  Object? environment, [
  enums.Environment? defaultValue,
]) {
  if (environment is String) {
    return enums.$EnvironmentMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == environment.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.Environment.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$EnvironmentMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.Environment.swaggerGeneratedUnknown;
}

List<String> environmentListToJson(List<enums.Environment>? environment) {
  if (environment == null) {
    return [];
  }

  return environment.map((e) => enums.$EnvironmentMap[e]!).toList();
}

List<enums.Environment> environmentListFromJson(
  List? environment, [
  List<enums.Environment>? defaultValue,
]) {
  if (environment == null) {
    return defaultValue ?? [];
  }

  return environment.map((e) => environmentFromJson(e.toString())).toList();
}

List<enums.Environment>? environmentNullableListFromJson(
  List? environment, [
  List<enums.Environment>? defaultValue,
]) {
  if (environment == null) {
    return defaultValue;
  }

  return environment.map((e) => environmentFromJson(e.toString())).toList();
}

String? fileDispositionToJson(enums.FileDisposition? fileDisposition) {
  return enums.$FileDispositionMap[fileDisposition];
}

enums.FileDisposition fileDispositionFromJson(
  Object? fileDisposition, [
  enums.FileDisposition? defaultValue,
]) {
  if (fileDisposition is String) {
    return enums.$FileDispositionMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == fileDisposition.toLowerCase(),
            orElse: () => const MapEntry(
                enums.FileDisposition.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$FileDispositionMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.FileDisposition.swaggerGeneratedUnknown;
}

List<String> fileDispositionListToJson(
    List<enums.FileDisposition>? fileDisposition) {
  if (fileDisposition == null) {
    return [];
  }

  return fileDisposition.map((e) => enums.$FileDispositionMap[e]!).toList();
}

List<enums.FileDisposition> fileDispositionListFromJson(
  List? fileDisposition, [
  List<enums.FileDisposition>? defaultValue,
]) {
  if (fileDisposition == null) {
    return defaultValue ?? [];
  }

  return fileDisposition
      .map((e) => fileDispositionFromJson(e.toString()))
      .toList();
}

List<enums.FileDisposition>? fileDispositionNullableListFromJson(
  List? fileDisposition, [
  List<enums.FileDisposition>? defaultValue,
]) {
  if (fileDisposition == null) {
    return defaultValue;
  }

  return fileDisposition
      .map((e) => fileDispositionFromJson(e.toString()))
      .toList();
}

String? fileRevisionStatusToJson(enums.FileRevisionStatus? fileRevisionStatus) {
  return enums.$FileRevisionStatusMap[fileRevisionStatus];
}

enums.FileRevisionStatus fileRevisionStatusFromJson(
  Object? fileRevisionStatus, [
  enums.FileRevisionStatus? defaultValue,
]) {
  if (fileRevisionStatus is String) {
    return enums.$FileRevisionStatusMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == fileRevisionStatus.toLowerCase(),
            orElse: () => const MapEntry(
                enums.FileRevisionStatus.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$FileRevisionStatusMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.FileRevisionStatus.swaggerGeneratedUnknown;
}

List<String> fileRevisionStatusListToJson(
    List<enums.FileRevisionStatus>? fileRevisionStatus) {
  if (fileRevisionStatus == null) {
    return [];
  }

  return fileRevisionStatus
      .map((e) => enums.$FileRevisionStatusMap[e]!)
      .toList();
}

List<enums.FileRevisionStatus> fileRevisionStatusListFromJson(
  List? fileRevisionStatus, [
  List<enums.FileRevisionStatus>? defaultValue,
]) {
  if (fileRevisionStatus == null) {
    return defaultValue ?? [];
  }

  return fileRevisionStatus
      .map((e) => fileRevisionStatusFromJson(e.toString()))
      .toList();
}

List<enums.FileRevisionStatus>? fileRevisionStatusNullableListFromJson(
  List? fileRevisionStatus, [
  List<enums.FileRevisionStatus>? defaultValue,
]) {
  if (fileRevisionStatus == null) {
    return defaultValue;
  }

  return fileRevisionStatus
      .map((e) => fileRevisionStatusFromJson(e.toString()))
      .toList();
}

String? irbDecisionTypeToJson(enums.IrbDecisionType? irbDecisionType) {
  return enums.$IrbDecisionTypeMap[irbDecisionType];
}

enums.IrbDecisionType irbDecisionTypeFromJson(
  Object? irbDecisionType, [
  enums.IrbDecisionType? defaultValue,
]) {
  if (irbDecisionType is String) {
    return enums.$IrbDecisionTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == irbDecisionType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.IrbDecisionType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$IrbDecisionTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.IrbDecisionType.swaggerGeneratedUnknown;
}

List<String> irbDecisionTypeListToJson(
    List<enums.IrbDecisionType>? irbDecisionType) {
  if (irbDecisionType == null) {
    return [];
  }

  return irbDecisionType.map((e) => enums.$IrbDecisionTypeMap[e]!).toList();
}

List<enums.IrbDecisionType> irbDecisionTypeListFromJson(
  List? irbDecisionType, [
  List<enums.IrbDecisionType>? defaultValue,
]) {
  if (irbDecisionType == null) {
    return defaultValue ?? [];
  }

  return irbDecisionType
      .map((e) => irbDecisionTypeFromJson(e.toString()))
      .toList();
}

List<enums.IrbDecisionType>? irbDecisionTypeNullableListFromJson(
  List? irbDecisionType, [
  List<enums.IrbDecisionType>? defaultValue,
]) {
  if (irbDecisionType == null) {
    return defaultValue;
  }

  return irbDecisionType
      .map((e) => irbDecisionTypeFromJson(e.toString()))
      .toList();
}

String? notificationProtocolToJson(
    enums.NotificationProtocol? notificationProtocol) {
  return enums.$NotificationProtocolMap[notificationProtocol];
}

enums.NotificationProtocol notificationProtocolFromJson(
  Object? notificationProtocol, [
  enums.NotificationProtocol? defaultValue,
]) {
  if (notificationProtocol is String) {
    return enums.$NotificationProtocolMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                notificationProtocol.toLowerCase(),
            orElse: () => const MapEntry(
                enums.NotificationProtocol.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$NotificationProtocolMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.NotificationProtocol.swaggerGeneratedUnknown;
}

List<String> notificationProtocolListToJson(
    List<enums.NotificationProtocol>? notificationProtocol) {
  if (notificationProtocol == null) {
    return [];
  }

  return notificationProtocol
      .map((e) => enums.$NotificationProtocolMap[e]!)
      .toList();
}

List<enums.NotificationProtocol> notificationProtocolListFromJson(
  List? notificationProtocol, [
  List<enums.NotificationProtocol>? defaultValue,
]) {
  if (notificationProtocol == null) {
    return defaultValue ?? [];
  }

  return notificationProtocol
      .map((e) => notificationProtocolFromJson(e.toString()))
      .toList();
}

List<enums.NotificationProtocol>? notificationProtocolNullableListFromJson(
  List? notificationProtocol, [
  List<enums.NotificationProtocol>? defaultValue,
]) {
  if (notificationProtocol == null) {
    return defaultValue;
  }

  return notificationProtocol
      .map((e) => notificationProtocolFromJson(e.toString()))
      .toList();
}

String? notificationTypeToJson(enums.NotificationType? notificationType) {
  return enums.$NotificationTypeMap[notificationType];
}

enums.NotificationType notificationTypeFromJson(
  Object? notificationType, [
  enums.NotificationType? defaultValue,
]) {
  if (notificationType is String) {
    return enums.$NotificationTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == notificationType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.NotificationType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$NotificationTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.NotificationType.swaggerGeneratedUnknown;
}

List<String> notificationTypeListToJson(
    List<enums.NotificationType>? notificationType) {
  if (notificationType == null) {
    return [];
  }

  return notificationType.map((e) => enums.$NotificationTypeMap[e]!).toList();
}

List<enums.NotificationType> notificationTypeListFromJson(
  List? notificationType, [
  List<enums.NotificationType>? defaultValue,
]) {
  if (notificationType == null) {
    return defaultValue ?? [];
  }

  return notificationType
      .map((e) => notificationTypeFromJson(e.toString()))
      .toList();
}

List<enums.NotificationType>? notificationTypeNullableListFromJson(
  List? notificationType, [
  List<enums.NotificationType>? defaultValue,
]) {
  if (notificationType == null) {
    return defaultValue;
  }

  return notificationType
      .map((e) => notificationTypeFromJson(e.toString()))
      .toList();
}

String? performanceOrderToJson(enums.PerformanceOrder? performanceOrder) {
  return enums.$PerformanceOrderMap[performanceOrder];
}

enums.PerformanceOrder performanceOrderFromJson(
  Object? performanceOrder, [
  enums.PerformanceOrder? defaultValue,
]) {
  if (performanceOrder is String) {
    return enums.$PerformanceOrderMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == performanceOrder.toLowerCase(),
            orElse: () => const MapEntry(
                enums.PerformanceOrder.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$PerformanceOrderMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.PerformanceOrder.swaggerGeneratedUnknown;
}

List<String> performanceOrderListToJson(
    List<enums.PerformanceOrder>? performanceOrder) {
  if (performanceOrder == null) {
    return [];
  }

  return performanceOrder.map((e) => enums.$PerformanceOrderMap[e]!).toList();
}

List<enums.PerformanceOrder> performanceOrderListFromJson(
  List? performanceOrder, [
  List<enums.PerformanceOrder>? defaultValue,
]) {
  if (performanceOrder == null) {
    return defaultValue ?? [];
  }

  return performanceOrder
      .map((e) => performanceOrderFromJson(e.toString()))
      .toList();
}

List<enums.PerformanceOrder>? performanceOrderNullableListFromJson(
  List? performanceOrder, [
  List<enums.PerformanceOrder>? defaultValue,
]) {
  if (performanceOrder == null) {
    return defaultValue;
  }

  return performanceOrder
      .map((e) => performanceOrderFromJson(e.toString()))
      .toList();
}

String? adherenceRecordTypeToJson(
    enums.AdherenceRecordType? adherenceRecordType) {
  return enums.$AdherenceRecordTypeMap[adherenceRecordType];
}

enums.AdherenceRecordType adherenceRecordTypeFromJson(
  Object? adherenceRecordType, [
  enums.AdherenceRecordType? defaultValue,
]) {
  if (adherenceRecordType is String) {
    return enums.$AdherenceRecordTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                adherenceRecordType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.AdherenceRecordType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$AdherenceRecordTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.AdherenceRecordType.swaggerGeneratedUnknown;
}

List<String> adherenceRecordTypeListToJson(
    List<enums.AdherenceRecordType>? adherenceRecordType) {
  if (adherenceRecordType == null) {
    return [];
  }

  return adherenceRecordType
      .map((e) => enums.$AdherenceRecordTypeMap[e]!)
      .toList();
}

List<enums.AdherenceRecordType> adherenceRecordTypeListFromJson(
  List? adherenceRecordType, [
  List<enums.AdherenceRecordType>? defaultValue,
]) {
  if (adherenceRecordType == null) {
    return defaultValue ?? [];
  }

  return adherenceRecordType
      .map((e) => adherenceRecordTypeFromJson(e.toString()))
      .toList();
}

List<enums.AdherenceRecordType>? adherenceRecordTypeNullableListFromJson(
  List? adherenceRecordType, [
  List<enums.AdherenceRecordType>? defaultValue,
]) {
  if (adherenceRecordType == null) {
    return defaultValue;
  }

  return adherenceRecordType
      .map((e) => adherenceRecordTypeFromJson(e.toString()))
      .toList();
}

String? scheduleTypeToJson(enums.ScheduleType? scheduleType) {
  return enums.$ScheduleTypeMap[scheduleType];
}

enums.ScheduleType scheduleTypeFromJson(
  Object? scheduleType, [
  enums.ScheduleType? defaultValue,
]) {
  if (scheduleType is String) {
    return enums.$ScheduleTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == scheduleType.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.ScheduleType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ScheduleTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ScheduleType.swaggerGeneratedUnknown;
}

List<String> scheduleTypeListToJson(List<enums.ScheduleType>? scheduleType) {
  if (scheduleType == null) {
    return [];
  }

  return scheduleType.map((e) => enums.$ScheduleTypeMap[e]!).toList();
}

List<enums.ScheduleType> scheduleTypeListFromJson(
  List? scheduleType, [
  List<enums.ScheduleType>? defaultValue,
]) {
  if (scheduleType == null) {
    return defaultValue ?? [];
  }

  return scheduleType.map((e) => scheduleTypeFromJson(e.toString())).toList();
}

List<enums.ScheduleType>? scheduleTypeNullableListFromJson(
  List? scheduleType, [
  List<enums.ScheduleType>? defaultValue,
]) {
  if (scheduleType == null) {
    return defaultValue;
  }

  return scheduleType.map((e) => scheduleTypeFromJson(e.toString())).toList();
}

String? sessionCompletionStateToJson(
    enums.SessionCompletionState? sessionCompletionState) {
  return enums.$SessionCompletionStateMap[sessionCompletionState];
}

enums.SessionCompletionState sessionCompletionStateFromJson(
  Object? sessionCompletionState, [
  enums.SessionCompletionState? defaultValue,
]) {
  if (sessionCompletionState is String) {
    return enums.$SessionCompletionStateMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                sessionCompletionState.toLowerCase(),
            orElse: () => const MapEntry(
                enums.SessionCompletionState.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SessionCompletionStateMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SessionCompletionState.swaggerGeneratedUnknown;
}

List<String> sessionCompletionStateListToJson(
    List<enums.SessionCompletionState>? sessionCompletionState) {
  if (sessionCompletionState == null) {
    return [];
  }

  return sessionCompletionState
      .map((e) => enums.$SessionCompletionStateMap[e]!)
      .toList();
}

List<enums.SessionCompletionState> sessionCompletionStateListFromJson(
  List? sessionCompletionState, [
  List<enums.SessionCompletionState>? defaultValue,
]) {
  if (sessionCompletionState == null) {
    return defaultValue ?? [];
  }

  return sessionCompletionState
      .map((e) => sessionCompletionStateFromJson(e.toString()))
      .toList();
}

List<enums.SessionCompletionState>? sessionCompletionStateNullableListFromJson(
  List? sessionCompletionState, [
  List<enums.SessionCompletionState>? defaultValue,
]) {
  if (sessionCompletionState == null) {
    return defaultValue;
  }

  return sessionCompletionState
      .map((e) => sessionCompletionStateFromJson(e.toString()))
      .toList();
}

String? signInTypeToJson(enums.SignInType? signInType) {
  return enums.$SignInTypeMap[signInType];
}

enums.SignInType signInTypeFromJson(
  Object? signInType, [
  enums.SignInType? defaultValue,
]) {
  if (signInType is String) {
    return enums.$SignInTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == signInType.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.SignInType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SignInTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SignInType.swaggerGeneratedUnknown;
}

List<String> signInTypeListToJson(List<enums.SignInType>? signInType) {
  if (signInType == null) {
    return [];
  }

  return signInType.map((e) => enums.$SignInTypeMap[e]!).toList();
}

List<enums.SignInType> signInTypeListFromJson(
  List? signInType, [
  List<enums.SignInType>? defaultValue,
]) {
  if (signInType == null) {
    return defaultValue ?? [];
  }

  return signInType.map((e) => signInTypeFromJson(e.toString())).toList();
}

List<enums.SignInType>? signInTypeNullableListFromJson(
  List? signInType, [
  List<enums.SignInType>? defaultValue,
]) {
  if (signInType == null) {
    return defaultValue;
  }

  return signInType.map((e) => signInTypeFromJson(e.toString())).toList();
}

String? smsTypeToJson(enums.SmsType? smsType) {
  return enums.$SmsTypeMap[smsType];
}

enums.SmsType smsTypeFromJson(
  Object? smsType, [
  enums.SmsType? defaultValue,
]) {
  if (smsType is String) {
    return enums.$SmsTypeMap.entries
        .firstWhere(
            (element) => element.value.toLowerCase() == smsType.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.SmsType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SmsTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ?? defaultValue ?? enums.SmsType.swaggerGeneratedUnknown;
}

List<String> smsTypeListToJson(List<enums.SmsType>? smsType) {
  if (smsType == null) {
    return [];
  }

  return smsType.map((e) => enums.$SmsTypeMap[e]!).toList();
}

List<enums.SmsType> smsTypeListFromJson(
  List? smsType, [
  List<enums.SmsType>? defaultValue,
]) {
  if (smsType == null) {
    return defaultValue ?? [];
  }

  return smsType.map((e) => smsTypeFromJson(e.toString())).toList();
}

List<enums.SmsType>? smsTypeNullableListFromJson(
  List? smsType, [
  List<enums.SmsType>? defaultValue,
]) {
  if (smsType == null) {
    return defaultValue;
  }

  return smsType.map((e) => smsTypeFromJson(e.toString())).toList();
}

String? sortOrderToJson(enums.SortOrder? sortOrder) {
  return enums.$SortOrderMap[sortOrder];
}

enums.SortOrder sortOrderFromJson(
  Object? sortOrder, [
  enums.SortOrder? defaultValue,
]) {
  if (sortOrder is String) {
    return enums.$SortOrderMap.entries
        .firstWhere(
            (element) => element.value.toLowerCase() == sortOrder.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.SortOrder.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SortOrderMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SortOrder.swaggerGeneratedUnknown;
}

List<String> sortOrderListToJson(List<enums.SortOrder>? sortOrder) {
  if (sortOrder == null) {
    return [];
  }

  return sortOrder.map((e) => enums.$SortOrderMap[e]!).toList();
}

List<enums.SortOrder> sortOrderListFromJson(
  List? sortOrder, [
  List<enums.SortOrder>? defaultValue,
]) {
  if (sortOrder == null) {
    return defaultValue ?? [];
  }

  return sortOrder.map((e) => sortOrderFromJson(e.toString())).toList();
}

List<enums.SortOrder>? sortOrderNullableListFromJson(
  List? sortOrder, [
  List<enums.SortOrder>? defaultValue,
]) {
  if (sortOrder == null) {
    return defaultValue;
  }

  return sortOrder.map((e) => sortOrderFromJson(e.toString())).toList();
}

String? studyPhaseToJson(enums.StudyPhase? studyPhase) {
  return enums.$StudyPhaseMap[studyPhase];
}

enums.StudyPhase studyPhaseFromJson(
  Object? studyPhase, [
  enums.StudyPhase? defaultValue,
]) {
  if (studyPhase is String) {
    return enums.$StudyPhaseMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == studyPhase.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.StudyPhase.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$StudyPhaseMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.StudyPhase.swaggerGeneratedUnknown;
}

List<String> studyPhaseListToJson(List<enums.StudyPhase>? studyPhase) {
  if (studyPhase == null) {
    return [];
  }

  return studyPhase.map((e) => enums.$StudyPhaseMap[e]!).toList();
}

List<enums.StudyPhase> studyPhaseListFromJson(
  List? studyPhase, [
  List<enums.StudyPhase>? defaultValue,
]) {
  if (studyPhase == null) {
    return defaultValue ?? [];
  }

  return studyPhase.map((e) => studyPhaseFromJson(e.toString())).toList();
}

List<enums.StudyPhase>? studyPhaseNullableListFromJson(
  List? studyPhase, [
  List<enums.StudyPhase>? defaultValue,
]) {
  if (studyPhase == null) {
    return defaultValue;
  }

  return studyPhase.map((e) => studyPhaseFromJson(e.toString())).toList();
}

String? roleToJson(enums.Role? role) {
  return enums.$RoleMap[role];
}

enums.Role roleFromJson(
  Object? role, [
  enums.Role? defaultValue,
]) {
  if (role is String) {
    return enums.$RoleMap.entries
        .firstWhere(
            (element) => element.value.toLowerCase() == role.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.Role.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$RoleMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ?? defaultValue ?? enums.Role.swaggerGeneratedUnknown;
}

List<String> roleListToJson(List<enums.Role>? role) {
  if (role == null) {
    return [];
  }

  return role.map((e) => enums.$RoleMap[e]!).toList();
}

List<enums.Role> roleListFromJson(
  List? role, [
  List<enums.Role>? defaultValue,
]) {
  if (role == null) {
    return defaultValue ?? [];
  }

  return role.map((e) => roleFromJson(e.toString())).toList();
}

List<enums.Role>? roleNullableListFromJson(
  List? role, [
  List<enums.Role>? defaultValue,
]) {
  if (role == null) {
    return defaultValue;
  }

  return role.map((e) => roleFromJson(e.toString())).toList();
}

String? activityTypeToJson(enums.ActivityType? activityType) {
  return enums.$ActivityTypeMap[activityType];
}

enums.ActivityType activityTypeFromJson(
  Object? activityType, [
  enums.ActivityType? defaultValue,
]) {
  if (activityType is String) {
    return enums.$ActivityTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == activityType.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.ActivityType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ActivityTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ActivityType.swaggerGeneratedUnknown;
}

List<String> activityTypeListToJson(List<enums.ActivityType>? activityType) {
  if (activityType == null) {
    return [];
  }

  return activityType.map((e) => enums.$ActivityTypeMap[e]!).toList();
}

List<enums.ActivityType> activityTypeListFromJson(
  List? activityType, [
  List<enums.ActivityType>? defaultValue,
]) {
  if (activityType == null) {
    return defaultValue ?? [];
  }

  return activityType.map((e) => activityTypeFromJson(e.toString())).toList();
}

List<enums.ActivityType>? activityTypeNullableListFromJson(
  List? activityType, [
  List<enums.ActivityType>? defaultValue,
]) {
  if (activityType == null) {
    return defaultValue;
  }

  return activityType.map((e) => activityTypeFromJson(e.toString())).toList();
}

String? unitToJson(enums.Unit? unit) {
  return enums.$UnitMap[unit];
}

enums.Unit unitFromJson(
  Object? unit, [
  enums.Unit? defaultValue,
]) {
  if (unit is String) {
    return enums.$UnitMap.entries
        .firstWhere(
            (element) => element.value.toLowerCase() == unit.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.Unit.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$UnitMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ?? defaultValue ?? enums.Unit.swaggerGeneratedUnknown;
}

List<String> unitListToJson(List<enums.Unit>? unit) {
  if (unit == null) {
    return [];
  }

  return unit.map((e) => enums.$UnitMap[e]!).toList();
}

List<enums.Unit> unitListFromJson(
  List? unit, [
  List<enums.Unit>? defaultValue,
]) {
  if (unit == null) {
    return defaultValue ?? [];
  }

  return unit.map((e) => unitFromJson(e.toString())).toList();
}

List<enums.Unit>? unitNullableListFromJson(
  List? unit, [
  List<enums.Unit>? defaultValue,
]) {
  if (unit == null) {
    return defaultValue;
  }

  return unit.map((e) => unitFromJson(e.toString())).toList();
}

String? mimeTypeToJson(enums.MimeType? mimeType) {
  return enums.$MimeTypeMap[mimeType];
}

enums.MimeType mimeTypeFromJson(
  Object? mimeType, [
  enums.MimeType? defaultValue,
]) {
  if (mimeType is String) {
    return enums.$MimeTypeMap.entries
        .firstWhere(
            (element) => element.value.toLowerCase() == mimeType.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.MimeType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$MimeTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ?? defaultValue ?? enums.MimeType.swaggerGeneratedUnknown;
}

List<String> mimeTypeListToJson(List<enums.MimeType>? mimeType) {
  if (mimeType == null) {
    return [];
  }

  return mimeType.map((e) => enums.$MimeTypeMap[e]!).toList();
}

List<enums.MimeType> mimeTypeListFromJson(
  List? mimeType, [
  List<enums.MimeType>? defaultValue,
]) {
  if (mimeType == null) {
    return defaultValue ?? [];
  }

  return mimeType.map((e) => mimeTypeFromJson(e.toString())).toList();
}

List<enums.MimeType>? mimeTypeNullableListFromJson(
  List? mimeType, [
  List<enums.MimeType>? defaultValue,
]) {
  if (mimeType == null) {
    return defaultValue;
  }

  return mimeType.map((e) => mimeTypeFromJson(e.toString())).toList();
}

String? uIHintToJson(enums.UIHint? uIHint) {
  return enums.$UIHintMap[uIHint];
}

enums.UIHint uIHintFromJson(
  Object? uIHint, [
  enums.UIHint? defaultValue,
]) {
  if (uIHint is String) {
    return enums.$UIHintMap.entries
        .firstWhere(
            (element) => element.value.toLowerCase() == uIHint.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.UIHint.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$UIHintMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ?? defaultValue ?? enums.UIHint.swaggerGeneratedUnknown;
}

List<String> uIHintListToJson(List<enums.UIHint>? uIHint) {
  if (uIHint == null) {
    return [];
  }

  return uIHint.map((e) => enums.$UIHintMap[e]!).toList();
}

List<enums.UIHint> uIHintListFromJson(
  List? uIHint, [
  List<enums.UIHint>? defaultValue,
]) {
  if (uIHint == null) {
    return defaultValue ?? [];
  }

  return uIHint.map((e) => uIHintFromJson(e.toString())).toList();
}

List<enums.UIHint>? uIHintNullableListFromJson(
  List? uIHint, [
  List<enums.UIHint>? defaultValue,
]) {
  if (uIHint == null) {
    return defaultValue;
  }

  return uIHint.map((e) => uIHintFromJson(e.toString())).toList();
}

String? operatorToJson(enums.Operator? operator) {
  return enums.$OperatorMap[operator];
}

enums.Operator operatorFromJson(
  Object? operator, [
  enums.Operator? defaultValue,
]) {
  if (operator is String) {
    return enums.$OperatorMap.entries
        .firstWhere(
            (element) => element.value.toLowerCase() == operator.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.Operator.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$OperatorMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ?? defaultValue ?? enums.Operator.swaggerGeneratedUnknown;
}

List<String> operatorListToJson(List<enums.Operator>? operator) {
  if (operator == null) {
    return [];
  }

  return operator.map((e) => enums.$OperatorMap[e]!).toList();
}

List<enums.Operator> operatorListFromJson(
  List? operator, [
  List<enums.Operator>? defaultValue,
]) {
  if (operator == null) {
    return defaultValue ?? [];
  }

  return operator.map((e) => operatorFromJson(e.toString())).toList();
}

List<enums.Operator>? operatorNullableListFromJson(
  List? operator, [
  List<enums.Operator>? defaultValue,
]) {
  if (operator == null) {
    return defaultValue;
  }

  return operator.map((e) => operatorFromJson(e.toString())).toList();
}

String? reportTypeToJson(enums.ReportType? reportType) {
  return enums.$ReportTypeMap[reportType];
}

enums.ReportType reportTypeFromJson(
  Object? reportType, [
  enums.ReportType? defaultValue,
]) {
  if (reportType is String) {
    return enums.$ReportTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == reportType.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.ReportType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ReportTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ReportType.swaggerGeneratedUnknown;
}

List<String> reportTypeListToJson(List<enums.ReportType>? reportType) {
  if (reportType == null) {
    return [];
  }

  return reportType.map((e) => enums.$ReportTypeMap[e]!).toList();
}

List<enums.ReportType> reportTypeListFromJson(
  List? reportType, [
  List<enums.ReportType>? defaultValue,
]) {
  if (reportType == null) {
    return defaultValue ?? [];
  }

  return reportType.map((e) => reportTypeFromJson(e.toString())).toList();
}

List<enums.ReportType>? reportTypeNullableListFromJson(
  List? reportType, [
  List<enums.ReportType>? defaultValue,
]) {
  if (reportType == null) {
    return defaultValue;
  }

  return reportType.map((e) => reportTypeFromJson(e.toString())).toList();
}

String? searchTermPredicateToJson(
    enums.SearchTermPredicate? searchTermPredicate) {
  return enums.$SearchTermPredicateMap[searchTermPredicate];
}

enums.SearchTermPredicate searchTermPredicateFromJson(
  Object? searchTermPredicate, [
  enums.SearchTermPredicate? defaultValue,
]) {
  if (searchTermPredicate is String) {
    return enums.$SearchTermPredicateMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                searchTermPredicate.toLowerCase(),
            orElse: () => const MapEntry(
                enums.SearchTermPredicate.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SearchTermPredicateMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SearchTermPredicate.swaggerGeneratedUnknown;
}

List<String> searchTermPredicateListToJson(
    List<enums.SearchTermPredicate>? searchTermPredicate) {
  if (searchTermPredicate == null) {
    return [];
  }

  return searchTermPredicate
      .map((e) => enums.$SearchTermPredicateMap[e]!)
      .toList();
}

List<enums.SearchTermPredicate> searchTermPredicateListFromJson(
  List? searchTermPredicate, [
  List<enums.SearchTermPredicate>? defaultValue,
]) {
  if (searchTermPredicate == null) {
    return defaultValue ?? [];
  }

  return searchTermPredicate
      .map((e) => searchTermPredicateFromJson(e.toString()))
      .toList();
}

List<enums.SearchTermPredicate>? searchTermPredicateNullableListFromJson(
  List? searchTermPredicate, [
  List<enums.SearchTermPredicate>? defaultValue,
]) {
  if (searchTermPredicate == null) {
    return defaultValue;
  }

  return searchTermPredicate
      .map((e) => searchTermPredicateFromJson(e.toString()))
      .toList();
}

String? stringSearchPositionToJson(
    enums.StringSearchPosition? stringSearchPosition) {
  return enums.$StringSearchPositionMap[stringSearchPosition];
}

enums.StringSearchPosition stringSearchPositionFromJson(
  Object? stringSearchPosition, [
  enums.StringSearchPosition? defaultValue,
]) {
  if (stringSearchPosition is String) {
    return enums.$StringSearchPositionMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                stringSearchPosition.toLowerCase(),
            orElse: () => const MapEntry(
                enums.StringSearchPosition.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$StringSearchPositionMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.StringSearchPosition.swaggerGeneratedUnknown;
}

List<String> stringSearchPositionListToJson(
    List<enums.StringSearchPosition>? stringSearchPosition) {
  if (stringSearchPosition == null) {
    return [];
  }

  return stringSearchPosition
      .map((e) => enums.$StringSearchPositionMap[e]!)
      .toList();
}

List<enums.StringSearchPosition> stringSearchPositionListFromJson(
  List? stringSearchPosition, [
  List<enums.StringSearchPosition>? defaultValue,
]) {
  if (stringSearchPosition == null) {
    return defaultValue ?? [];
  }

  return stringSearchPosition
      .map((e) => stringSearchPositionFromJson(e.toString()))
      .toList();
}

List<enums.StringSearchPosition>? stringSearchPositionNullableListFromJson(
  List? stringSearchPosition, [
  List<enums.StringSearchPosition>? defaultValue,
]) {
  if (stringSearchPosition == null) {
    return defaultValue;
  }

  return stringSearchPosition
      .map((e) => stringSearchPositionFromJson(e.toString()))
      .toList();
}

String? sharedModuleTypeToJson(enums.SharedModuleType? sharedModuleType) {
  return enums.$SharedModuleTypeMap[sharedModuleType];
}

enums.SharedModuleType sharedModuleTypeFromJson(
  Object? sharedModuleType, [
  enums.SharedModuleType? defaultValue,
]) {
  if (sharedModuleType is String) {
    return enums.$SharedModuleTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == sharedModuleType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.SharedModuleType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SharedModuleTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SharedModuleType.swaggerGeneratedUnknown;
}

List<String> sharedModuleTypeListToJson(
    List<enums.SharedModuleType>? sharedModuleType) {
  if (sharedModuleType == null) {
    return [];
  }

  return sharedModuleType.map((e) => enums.$SharedModuleTypeMap[e]!).toList();
}

List<enums.SharedModuleType> sharedModuleTypeListFromJson(
  List? sharedModuleType, [
  List<enums.SharedModuleType>? defaultValue,
]) {
  if (sharedModuleType == null) {
    return defaultValue ?? [];
  }

  return sharedModuleType
      .map((e) => sharedModuleTypeFromJson(e.toString()))
      .toList();
}

List<enums.SharedModuleType>? sharedModuleTypeNullableListFromJson(
  List? sharedModuleType, [
  List<enums.SharedModuleType>? defaultValue,
]) {
  if (sharedModuleType == null) {
    return defaultValue;
  }

  return sharedModuleType
      .map((e) => sharedModuleTypeFromJson(e.toString()))
      .toList();
}

String? templateTypeToJson(enums.TemplateType? templateType) {
  return enums.$TemplateTypeMap[templateType];
}

enums.TemplateType templateTypeFromJson(
  Object? templateType, [
  enums.TemplateType? defaultValue,
]) {
  if (templateType is String) {
    return enums.$TemplateTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == templateType.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.TemplateType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$TemplateTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.TemplateType.swaggerGeneratedUnknown;
}

List<String> templateTypeListToJson(List<enums.TemplateType>? templateType) {
  if (templateType == null) {
    return [];
  }

  return templateType.map((e) => enums.$TemplateTypeMap[e]!).toList();
}

List<enums.TemplateType> templateTypeListFromJson(
  List? templateType, [
  List<enums.TemplateType>? defaultValue,
]) {
  if (templateType == null) {
    return defaultValue ?? [];
  }

  return templateType.map((e) => templateTypeFromJson(e.toString())).toList();
}

List<enums.TemplateType>? templateTypeNullableListFromJson(
  List? templateType, [
  List<enums.TemplateType>? defaultValue,
]) {
  if (templateType == null) {
    return defaultValue;
  }

  return templateType.map((e) => templateTypeFromJson(e.toString())).toList();
}

String? uploadStatusToJson(enums.UploadStatus? uploadStatus) {
  return enums.$UploadStatusMap[uploadStatus];
}

enums.UploadStatus uploadStatusFromJson(
  Object? uploadStatus, [
  enums.UploadStatus? defaultValue,
]) {
  if (uploadStatus is String) {
    return enums.$UploadStatusMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == uploadStatus.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.UploadStatus.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$UploadStatusMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.UploadStatus.swaggerGeneratedUnknown;
}

List<String> uploadStatusListToJson(List<enums.UploadStatus>? uploadStatus) {
  if (uploadStatus == null) {
    return [];
  }

  return uploadStatus.map((e) => enums.$UploadStatusMap[e]!).toList();
}

List<enums.UploadStatus> uploadStatusListFromJson(
  List? uploadStatus, [
  List<enums.UploadStatus>? defaultValue,
]) {
  if (uploadStatus == null) {
    return defaultValue ?? [];
  }

  return uploadStatus.map((e) => uploadStatusFromJson(e.toString())).toList();
}

List<enums.UploadStatus>? uploadStatusNullableListFromJson(
  List? uploadStatus, [
  List<enums.UploadStatus>? defaultValue,
]) {
  if (uploadStatus == null) {
    return defaultValue;
  }

  return uploadStatus.map((e) => uploadStatusFromJson(e.toString())).toList();
}

String? uploadSchemaTypeToJson(enums.UploadSchemaType? uploadSchemaType) {
  return enums.$UploadSchemaTypeMap[uploadSchemaType];
}

enums.UploadSchemaType uploadSchemaTypeFromJson(
  Object? uploadSchemaType, [
  enums.UploadSchemaType? defaultValue,
]) {
  if (uploadSchemaType is String) {
    return enums.$UploadSchemaTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == uploadSchemaType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.UploadSchemaType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$UploadSchemaTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.UploadSchemaType.swaggerGeneratedUnknown;
}

List<String> uploadSchemaTypeListToJson(
    List<enums.UploadSchemaType>? uploadSchemaType) {
  if (uploadSchemaType == null) {
    return [];
  }

  return uploadSchemaType.map((e) => enums.$UploadSchemaTypeMap[e]!).toList();
}

List<enums.UploadSchemaType> uploadSchemaTypeListFromJson(
  List? uploadSchemaType, [
  List<enums.UploadSchemaType>? defaultValue,
]) {
  if (uploadSchemaType == null) {
    return defaultValue ?? [];
  }

  return uploadSchemaType
      .map((e) => uploadSchemaTypeFromJson(e.toString()))
      .toList();
}

List<enums.UploadSchemaType>? uploadSchemaTypeNullableListFromJson(
  List? uploadSchemaType, [
  List<enums.UploadSchemaType>? defaultValue,
]) {
  if (uploadSchemaType == null) {
    return defaultValue;
  }

  return uploadSchemaType
      .map((e) => uploadSchemaTypeFromJson(e.toString()))
      .toList();
}

String? uploadValidationStrictnessToJson(
    enums.UploadValidationStrictness? uploadValidationStrictness) {
  return enums.$UploadValidationStrictnessMap[uploadValidationStrictness];
}

enums.UploadValidationStrictness uploadValidationStrictnessFromJson(
  Object? uploadValidationStrictness, [
  enums.UploadValidationStrictness? defaultValue,
]) {
  if (uploadValidationStrictness is String) {
    return enums.$UploadValidationStrictnessMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                uploadValidationStrictness.toLowerCase(),
            orElse: () => const MapEntry(
                enums.UploadValidationStrictness.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$UploadValidationStrictnessMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.UploadValidationStrictness.swaggerGeneratedUnknown;
}

List<String> uploadValidationStrictnessListToJson(
    List<enums.UploadValidationStrictness>? uploadValidationStrictness) {
  if (uploadValidationStrictness == null) {
    return [];
  }

  return uploadValidationStrictness
      .map((e) => enums.$UploadValidationStrictnessMap[e]!)
      .toList();
}

List<enums.UploadValidationStrictness> uploadValidationStrictnessListFromJson(
  List? uploadValidationStrictness, [
  List<enums.UploadValidationStrictness>? defaultValue,
]) {
  if (uploadValidationStrictness == null) {
    return defaultValue ?? [];
  }

  return uploadValidationStrictness
      .map((e) => uploadValidationStrictnessFromJson(e.toString()))
      .toList();
}

List<enums.UploadValidationStrictness>?
    uploadValidationStrictnessNullableListFromJson(
  List? uploadValidationStrictness, [
  List<enums.UploadValidationStrictness>? defaultValue,
]) {
  if (uploadValidationStrictness == null) {
    return defaultValue;
  }

  return uploadValidationStrictness
      .map((e) => uploadValidationStrictnessFromJson(e.toString()))
      .toList();
}

String? synapseExporterStatusToJson(
    enums.SynapseExporterStatus? synapseExporterStatus) {
  return enums.$SynapseExporterStatusMap[synapseExporterStatus];
}

enums.SynapseExporterStatus synapseExporterStatusFromJson(
  Object? synapseExporterStatus, [
  enums.SynapseExporterStatus? defaultValue,
]) {
  if (synapseExporterStatus is String) {
    return enums.$SynapseExporterStatusMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                synapseExporterStatus.toLowerCase(),
            orElse: () => const MapEntry(
                enums.SynapseExporterStatus.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SynapseExporterStatusMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SynapseExporterStatus.swaggerGeneratedUnknown;
}

List<String> synapseExporterStatusListToJson(
    List<enums.SynapseExporterStatus>? synapseExporterStatus) {
  if (synapseExporterStatus == null) {
    return [];
  }

  return synapseExporterStatus
      .map((e) => enums.$SynapseExporterStatusMap[e]!)
      .toList();
}

List<enums.SynapseExporterStatus> synapseExporterStatusListFromJson(
  List? synapseExporterStatus, [
  List<enums.SynapseExporterStatus>? defaultValue,
]) {
  if (synapseExporterStatus == null) {
    return defaultValue ?? [];
  }

  return synapseExporterStatus
      .map((e) => synapseExporterStatusFromJson(e.toString()))
      .toList();
}

List<enums.SynapseExporterStatus>? synapseExporterStatusNullableListFromJson(
  List? synapseExporterStatus, [
  List<enums.SynapseExporterStatus>? defaultValue,
]) {
  if (synapseExporterStatus == null) {
    return defaultValue;
  }

  return synapseExporterStatus
      .map((e) => synapseExporterStatusFromJson(e.toString()))
      .toList();
}

String? scheduleStatusToJson(enums.ScheduleStatus? scheduleStatus) {
  return enums.$ScheduleStatusMap[scheduleStatus];
}

enums.ScheduleStatus scheduleStatusFromJson(
  Object? scheduleStatus, [
  enums.ScheduleStatus? defaultValue,
]) {
  if (scheduleStatus is String) {
    return enums.$ScheduleStatusMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == scheduleStatus.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ScheduleStatus.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ScheduleStatusMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ScheduleStatus.swaggerGeneratedUnknown;
}

List<String> scheduleStatusListToJson(
    List<enums.ScheduleStatus>? scheduleStatus) {
  if (scheduleStatus == null) {
    return [];
  }

  return scheduleStatus.map((e) => enums.$ScheduleStatusMap[e]!).toList();
}

List<enums.ScheduleStatus> scheduleStatusListFromJson(
  List? scheduleStatus, [
  List<enums.ScheduleStatus>? defaultValue,
]) {
  if (scheduleStatus == null) {
    return defaultValue ?? [];
  }

  return scheduleStatus
      .map((e) => scheduleStatusFromJson(e.toString()))
      .toList();
}

List<enums.ScheduleStatus>? scheduleStatusNullableListFromJson(
  List? scheduleStatus, [
  List<enums.ScheduleStatus>? defaultValue,
]) {
  if (scheduleStatus == null) {
    return defaultValue;
  }

  return scheduleStatus
      .map((e) => scheduleStatusFromJson(e.toString()))
      .toList();
}

String? uploadFieldTypeToJson(enums.UploadFieldType? uploadFieldType) {
  return enums.$UploadFieldTypeMap[uploadFieldType];
}

enums.UploadFieldType uploadFieldTypeFromJson(
  Object? uploadFieldType, [
  enums.UploadFieldType? defaultValue,
]) {
  if (uploadFieldType is String) {
    return enums.$UploadFieldTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == uploadFieldType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.UploadFieldType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$UploadFieldTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.UploadFieldType.swaggerGeneratedUnknown;
}

List<String> uploadFieldTypeListToJson(
    List<enums.UploadFieldType>? uploadFieldType) {
  if (uploadFieldType == null) {
    return [];
  }

  return uploadFieldType.map((e) => enums.$UploadFieldTypeMap[e]!).toList();
}

List<enums.UploadFieldType> uploadFieldTypeListFromJson(
  List? uploadFieldType, [
  List<enums.UploadFieldType>? defaultValue,
]) {
  if (uploadFieldType == null) {
    return defaultValue ?? [];
  }

  return uploadFieldType
      .map((e) => uploadFieldTypeFromJson(e.toString()))
      .toList();
}

List<enums.UploadFieldType>? uploadFieldTypeNullableListFromJson(
  List? uploadFieldType, [
  List<enums.UploadFieldType>? defaultValue,
]) {
  if (uploadFieldType == null) {
    return defaultValue;
  }

  return uploadFieldType
      .map((e) => uploadFieldTypeFromJson(e.toString()))
      .toList();
}

String? resourceCategoryToJson(enums.ResourceCategory? resourceCategory) {
  return enums.$ResourceCategoryMap[resourceCategory];
}

enums.ResourceCategory resourceCategoryFromJson(
  Object? resourceCategory, [
  enums.ResourceCategory? defaultValue,
]) {
  if (resourceCategory is String) {
    return enums.$ResourceCategoryMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == resourceCategory.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ResourceCategory.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ResourceCategoryMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ResourceCategory.swaggerGeneratedUnknown;
}

List<String> resourceCategoryListToJson(
    List<enums.ResourceCategory>? resourceCategory) {
  if (resourceCategory == null) {
    return [];
  }

  return resourceCategory.map((e) => enums.$ResourceCategoryMap[e]!).toList();
}

List<enums.ResourceCategory> resourceCategoryListFromJson(
  List? resourceCategory, [
  List<enums.ResourceCategory>? defaultValue,
]) {
  if (resourceCategory == null) {
    return defaultValue ?? [];
  }

  return resourceCategory
      .map((e) => resourceCategoryFromJson(e.toString()))
      .toList();
}

List<enums.ResourceCategory>? resourceCategoryNullableListFromJson(
  List? resourceCategory, [
  List<enums.ResourceCategory>? defaultValue,
]) {
  if (resourceCategory == null) {
    return defaultValue;
  }

  return resourceCategory
      .map((e) => resourceCategoryFromJson(e.toString()))
      .toList();
}

String? uploadCompletedByToJson(enums.UploadCompletedBy? uploadCompletedBy) {
  return enums.$UploadCompletedByMap[uploadCompletedBy];
}

enums.UploadCompletedBy uploadCompletedByFromJson(
  Object? uploadCompletedBy, [
  enums.UploadCompletedBy? defaultValue,
]) {
  if (uploadCompletedBy is String) {
    return enums.$UploadCompletedByMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == uploadCompletedBy.toLowerCase(),
            orElse: () => const MapEntry(
                enums.UploadCompletedBy.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$UploadCompletedByMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.UploadCompletedBy.swaggerGeneratedUnknown;
}

List<String> uploadCompletedByListToJson(
    List<enums.UploadCompletedBy>? uploadCompletedBy) {
  if (uploadCompletedBy == null) {
    return [];
  }

  return uploadCompletedBy.map((e) => enums.$UploadCompletedByMap[e]!).toList();
}

List<enums.UploadCompletedBy> uploadCompletedByListFromJson(
  List? uploadCompletedBy, [
  List<enums.UploadCompletedBy>? defaultValue,
]) {
  if (uploadCompletedBy == null) {
    return defaultValue ?? [];
  }

  return uploadCompletedBy
      .map((e) => uploadCompletedByFromJson(e.toString()))
      .toList();
}

List<enums.UploadCompletedBy>? uploadCompletedByNullableListFromJson(
  List? uploadCompletedBy, [
  List<enums.UploadCompletedBy>? defaultValue,
]) {
  if (uploadCompletedBy == null) {
    return defaultValue;
  }

  return uploadCompletedBy
      .map((e) => uploadCompletedByFromJson(e.toString()))
      .toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
